/*
 * File: LowPass_Filter.c
 *
 * Code generated for Simulink model 'TRPC_Lat_CG'.
 *
 * Model version                  : 1.9
 * Simulink Coder version         : 9.9 (R2023a) 19-Nov-2022
 * C/C++ source code generated on : Tue Jan 23 08:30:57 2024
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: Intel->x86-64 (Windows64)
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "LowPass_Filter.h"
#include "rtwtypes.h"

/* System initialize for atomic system: '<S675>/LowPass_Filter' */
void TRPC_Lat_CG_LowPass_Filter_Init(DW_LowPass_Filter_TRPC_Lat_CG_T *localDW)
{
  /* InitializeConditions for Delay: '<S681>/Resettable Delay2' */
  localDW->icLoad = true;

  /* InitializeConditions for Delay: '<S681>/Resettable Delay1' */
  localDW->icLoad_n = true;
}

/* Output and update for atomic system: '<S675>/LowPass_Filter' */
real32_T TRPC_Lat_CG_LowPass_Filter(real32_T rtu_Signal_Input, real32_T
  rtp_LPF_CrossoverPoint_Hz, real32_T rtp_LPF_SampFrequency_Num,
  DW_LowPass_Filter_TRPC_Lat_CG_T *localDW)
{
  real32_T rty_Signal_Output_0;
  real32_T rtb_Divide_gw_tmp_tmp;
  real32_T rtb_Product2_f_tmp;
  real32_T rty_Signal_Output_tmp;

  /* Gain: '<S682>/pi' incorporates:
   *  Constant: '<S682>/fc'
   *  Gain: '<S683>/pi'
   *  Gain: '<S684>/pi1'
   */
  rty_Signal_Output_tmp = 3.14159274F * rtp_LPF_CrossoverPoint_Hz;

  /* Sum: '<S682>/Add' incorporates:
   *  Constant: '<S682>/fs'
   *  Gain: '<S682>/pi'
   *  Sum: '<S684>/Add2'
   */
  rtb_Divide_gw_tmp_tmp = rty_Signal_Output_tmp + rtp_LPF_SampFrequency_Num;

  /* Product: '<S681>/Product2' incorporates:
   *  Gain: '<S682>/pi'
   *  Product: '<S681>/Product'
   *  Product: '<S682>/Divide'
   *  Sum: '<S682>/Add'
   */
  rtb_Product2_f_tmp = rty_Signal_Output_tmp / rtb_Divide_gw_tmp_tmp *
    rtu_Signal_Input;

  /* Delay: '<S681>/Resettable Delay2' incorporates:
   *  Product: '<S681>/Product2'
   */
  if (localDW->icLoad) {
    localDW->ResettableDelay2_DSTATE = rtb_Product2_f_tmp;
  }

  /* Delay: '<S681>/Resettable Delay1' */
  if (localDW->icLoad_n) {
    localDW->ResettableDelay1_DSTATE = rtu_Signal_Input;
  }

  /* Sum: '<S681>/Sum1' incorporates:
   *  Constant: '<S684>/fs'
   *  Delay: '<S681>/Resettable Delay1'
   *  Delay: '<S681>/Resettable Delay2'
   *  Product: '<S681>/Product1'
   *  Product: '<S684>/Divide1'
   *  Sum: '<S681>/Sum2'
   *  Sum: '<S684>/Add1'
   */
  rty_Signal_Output_0 = (rtb_Product2_f_tmp + localDW->ResettableDelay2_DSTATE)
    - (rty_Signal_Output_tmp - rtp_LPF_SampFrequency_Num) /
    rtb_Divide_gw_tmp_tmp * localDW->ResettableDelay1_DSTATE;

  /* Update for Delay: '<S681>/Resettable Delay2' incorporates:
   *  Product: '<S681>/Product2'
   */
  localDW->icLoad = false;
  localDW->ResettableDelay2_DSTATE = rtb_Product2_f_tmp;

  /* Update for Delay: '<S681>/Resettable Delay1' */
  localDW->icLoad_n = false;
  localDW->ResettableDelay1_DSTATE = rty_Signal_Output_0;
  return rty_Signal_Output_0;
}

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
