/*
 * TRPCLongSubDataWrapper.h
 *
 *  Created on: Feb 14, 2024
 *      Author: yasmine
 */

#ifndef TRPCLONGSubDataWrapper_WRAPPER_HEADER_H
#define TRPCLONGSubDataWrapper_WRAPPER_HEADER_H

#include "dpc_trpc_long/executable.h"
#include "sub/SubDataWrapper.h"


/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename DataType>
class VED2TRPCLong_SubDataWrapper :  public SubDataWrapper<DataType>
{
    private:
        dpc::VED4DPC* _ved_to_trpclong = nullptr;
    public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _ved_to_trpclong = (dpc::VED4DPC*) ptr->Get();
        }
        void GetData(dpc::VED4DPC &data)
        {
            if(_ved_to_trpclong)
                data = *(_ved_to_trpclong);
        }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename DataType>
class DM2TRPCLong_SubDataWrapper :  public SubDataWrapper<DataType>
{
    private:
        dpc::Decision4Long* _dm_to_trpclong = nullptr;
    public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _dm_to_trpclong = (dpc::Decision4Long*)ptr->Get();
        }
        void GetData(dpc::Decision4Long &data)
        {
            if(_dm_to_trpclong)
                data = *(_dm_to_trpclong);
        }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename DataType>
class EM2TRPCLongTargetsInfo_SubDataWrapper :  public SubDataWrapper<DataType>
{
    private:
        dpc::TargetsInfo* _em_targetsinfo_to_trpclong = nullptr;
    public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _em_targetsinfo_to_trpclong = (dpc::TargetsInfo*) ptr->Get();
        }
        void GetData(dpc::TargetsInfo &data)
        {
            if(_em_targetsinfo_to_trpclong)
                data = *(_em_targetsinfo_to_trpclong);
        }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename DataType>
class EM2TRPCLongTargetInfo_SubDataWrapper :  public SubDataWrapper<DataType>
{
    private:
        dpc::TargetInfo* _em_targetinfo_to_trpclong = nullptr;
    public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _em_targetinfo_to_trpclong = (dpc::TargetInfo*)ptr->Get();
        }
        void GetData(dpc::TargetInfo &data)
        {
            if(_em_targetinfo_to_trpclong)
                data = *(_em_targetinfo_to_trpclong);
        }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename DataType>
class EM2TRPCLongRoadEdgeInfo_SubDataWrapper :  public SubDataWrapper<DataType>
{
    private: 
        dpc::RoadEdgeInfo* _em_roadedgeinfo_to_trpclong = nullptr;
    public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _em_roadedgeinfo_to_trpclong = (dpc::RoadEdgeInfo*)ptr->Get();
        }
        void GetData(dpc::RoadEdgeInfo &data)
        {
            if(_em_roadedgeinfo_to_trpclong)
                data = *(_em_roadedgeinfo_to_trpclong);
        }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename DataType>
class EM2TRPCLongLaneMarkerInfo_SubDataWrapper :  public SubDataWrapper<DataType>
{
    private: 
        dpc::LaneMarkerInfo* _em_lanemarkerinfo_to_trpclong = nullptr;
    public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _em_lanemarkerinfo_to_trpclong = (dpc::LaneMarkerInfo*)ptr->Get();
        }
        void GetData(dpc::LaneMarkerInfo &data)
        {
            if(_em_lanemarkerinfo_to_trpclong)
                data = *(_em_lanemarkerinfo_to_trpclong);
        }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename DataType>
class CAN2Long_SubDataWrapper :  public SubDataWrapper<DataType>
{
    private:
        CAN2SWC* _canData_4_trpcLong = nullptr;
    public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _canData_4_trpcLong = (CAN2SWC*)ptr->Get();
        }
        void GetData(CAN2SWC &data)
        {
            if(_canData_4_trpcLong)
                data = *(_canData_4_trpcLong);
        }
};

#endif /* TRPCLONGSubDataWrapper_WRAPPER_HEADER_H */
