/***********************************************************************************************************************
 *  COPYRIGHT
 *  --------------------------------------------------------------------------------------------------------------------
 *  \verbatim
 *  Copyright (c) 2022 by Vector Informatik GmbH.                                              All rights reserved.
 *
 *                This software is copyright protected and proprietary to Vector Informatik GmbH.
 *                Vector Informatik GmbH grants to you only those rights as set out in the license conditions.
 *                All other rights remain with Vector Informatik GmbH.
 *  \endverbatim
 *  --------------------------------------------------------------------------------------------------------------------
 *  FILE DESCRIPTION
 *  ------------------------------------------------------------------------------------------------------------------*/
/**
 *  \ingroup     Os_Kernel
 *  \defgroup    Os_MemMap MemMap
 *
 * \{
 *
 * \file
 * \brief       MemMap file.
 * \details     Includes the generated file Os_MemMapInt.h if no static code analysis is done.
 *
 *
 **********************************************************************************************************************/
/***********************************************************************************************************************
 *  REVISION HISTORY
 *  --------------------------------------------------------------------------------------------------------------------
 *  Refer to Os.h.
 **********************************************************************************************************************/
                                                                                                                        /* PRQA S 0388  EOF */ /* MD_MSR_Dir1.1 */

/***********************************************************************************************************************
 *  INCLUDES
 **********************************************************************************************************************/

# ifdef OS_STATIC_CODE_ANALYSIS                                                                                         /* COV_OS_STATICCODEANALYSIS */
#  ifdef MEMMAP_ERROR                                                                                                   /* COV_OS_MEMMAPERROR */
#   undef MEMMAP_ERROR                                                                                                  /* PRQA S 0841 */ /* MD_MSR_Undef */ /* SBSW_OS_MEMAP_UNDEF */
#  endif
# else
#  include "Os_MemMapInt.h"
# endif


/*!
 * \}
 */
/***********************************************************************************************************************
 *  END OF FILE: Os_MemMap_OsCode.h
 **********************************************************************************************************************/
