//
// Created by sbn on 2/4/24.
//

#ifndef VEDPubDataWrapper_WRAPPER_HEADER_H
#define VEDPubDataWrapper_WRAPPER_HEADER_H

#include "pub/PubDataWrapper.h"
#include "dpc_ved/executable.h"

template<typename EventType>
class VED2DPC_PubDataWrapper: public PubDataWrapper<EventType> {

private:
    dpc::VED4DPC _ved_data;

public:

    void GetData(ara::com::SampleAllocateePtr<EventType> &data) override{
        data->MotionState = _ved_data.MotionState;
        data->LongitudinalVelocity = _ved_data.LongitudinalVelocity;
        data->LongitudinalAcceleration = _ved_data.LongitudinalAcceleration;
        data->LateralVelocity = _ved_data.LateralVelocity;
        data->LateralAcceleration = _ved_data.LateralAcceleration;
        data->Yawrate = _ved_data.Yawrate;
    }

    void SetData(dpc::VED4DPC &data){
        _ved_data = data;
    }

};
/*---------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class VED2FusionEgoMotion_PubDataWrapper: public PubDataWrapper<EventType> {

private:
    dpc::VED4FusionEgoMotion _ved_data_4_fusion;

public:

    void GetData(ara::com::SampleAllocateePtr<EventType> &data) override{
        data->SigStatus = _ved_data_4_fusion.SigStatus;  // Set as true
        data->LongAcc = _ved_data_4_fusion.LongAcc;
        data->TimeStamp = _ved_data_4_fusion.TimeStamp;
        data->LongVel = _ved_data_4_fusion.LongVel;
        data->LatYawRate = _ved_data_4_fusion.LatYawRate;
    }

    void SetData(dpc::VED4FusionEgoMotion &data) {
        _ved_data_4_fusion = data;
    }

};
#endif //VEDPubDataWrapper_WRAPPER_HEADER_H
