#ifndef VEDSubDataWrapper_WRAPPER_HEADER_H
#define VEDSubDataWrapper_WRAPPER_HEADER_H


#include "sub/SubDataWrapper.h"
#include "dpc_ved/executable.h"


template <typename DataType>
class CAN2VED_SubDataWrapper : public SubDataWrapper<DataType>
{
private:
    CAN2SWC* _can_to_dpc = nullptr;
public:
    void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
        _can_to_dpc = (CAN2SWC*)ptr->Get();
    }

    void GetData(CAN2SWC &data){
        if(_can_to_dpc)
            data = *(_can_to_dpc);
    }
};

#endif
