#pragma once

#include <iostream>
#include <vector>
#include "rm_road_info.h"
#include "dpc/impl_type_passage.h"

namespace DM
{

    struct HVInfoVec
    {
        std::vector<float> m_distance_along_s;
        std::vector<float> m_velocity;
        std::vector<uint8_t> m_lane_location;
    };

    struct BehaviorNodeGlobal
    {
        // BehaviorNodeGlobal definition
        rm_interface::Index m_node_id;
        float m_total_cost;
        float m_process_cost;
        float m_ba_calc_cost;
        std::vector<float> m_duration_time_arr;
        std::vector<uint8_t> m_action_typ_arr;
        std::vector<uint32_t> m_corridor_id_arr;
        std::vector<uint32_t> m_target_obj_id_arr;
        HVInfoVec m_hv_info_global;
        uint32_t m_first_corridor_id;
        bool m_is_node_terminated;
        float m_total_duration_time;
        rm_interface::Index m_first_passage_id;
    };

    struct Passageob
    {
        rm_interface::Index passage_id;
        uint32_t corridor_id;
        rm_interface::LongitudinalInfo longt_info;
        uint8_t action_type;
        float duration_time;
        std::vector<uint32_t> interest_obj_id_list;
        float alcdis_egolane;
        float realcdis_egolane;
        float alcdis_tarlane_frt;
        float realcdis_tarlane_frt;
        float alcdis_tarlane_bck;
        float realcdis_tarlane_bck;
        float lc_tar_frt_obj_dist_nrst;
        float lc_tar_bck_obj_dist_nrst;
        bool lc_passagegenflg;
        bool lc_lne_chg_res0;
        bool lc_lne_chg_res1;
        bool lc_lne_chg_res2;
        bool lc_lne_chg_res3;
        bool lc_ego_frt_obj_exist_flg;
        uint8_t lc_cls;
        uint32_t lc_ego_frt_obj_id;
        float lc_ego_frt_obj_dist;
        float lc_ego_frt_obj_spd;
        float lc_ego_frt_obj_len;
        uint32_t lc_ego_frt_obj_cls;
        bool lc_tar_frt_obj_exist_flg;
        uint32_t lc_tar_frt_obj_id;
        float lc_tar_frt_obj_dist;
        float lc_tar_frt_obj_spd;
        float lc_tar_frt_obj_len;
        uint32_t lc_tar_frt_obj_cls;
        bool lc_tar_bck_obj_exist_flg;
        uint32_t lc_tar_bck_obj_id;
        float lc_tar_bck_obj_dist;
        float lc_tar_bck_obj_spd;
        float lc_tar_bck_obj_len;
        uint32_t lc_tar_bck_obj_cls;
        bool lcp_frt_passagegenflg;
        bool lcp_bck_passagegenflg;
        bool lcp_ego_frt_obj_exist_flg;
        float frt_lcp_dis_tarlane_egofrt_raw;
        float frt_lcp_dis_tarlane_egobck_raw;
        float bck_lcp_dis_tarlane_egofrt_raw;
        float bck_lcp_dis_tarlane_egobck_raw;
        float frt_lcp_dis_tarlane_egofrt;
        float frt_lcp_dis_tarlane_egobck;
        float bck_lcp_dis_tarlane_egofrt;
        float bck_lcp_dis_tarlane_egobck;
        uint8_t lcp_cls_frt;
        uint8_t lcp_cls_bck;
        float lcp_frt_mov_dist;
        float lcp_frt_ego_lne_space;
        float lcp_frt_est_space;
        float lcp_frt_nd_space;
        float lcp_bck_mov_dist;
        float lcp_bck_ego_lne_space;
        float lcp_bck_est_space;
        float lcp_bck_nd_space;
        float lcp_frt_ego_arv_est_tm;
        float lcp_frt_ego_region_dist;
        float lcp_bck_ego_arv_est_tm;
        float lcp_bck_ego_region_dist;
        bool lcp_frt_lne_chg_pr_res1;
        bool lcp_frt_lne_chg_pr_res2;
        bool lcp_frt_lne_chg_pr_res3;
        bool lcp_frt_lne_chg_pr_res4;
        bool lcp_bck_lne_chg_pr_res1;
        bool lcp_bck_lne_chg_pr_res2;
        bool lcp_bck_lne_chg_pr_res3;
        bool lcp_bck_lne_chg_pr_res4;
        uint32_t lcp_ego_frt_obj_id;
        float lcp_ego_frt_obj_dist;
        float lcp_ego_frt_obj_spd;
        float lcp_ego_frt_obj_len;
        uint32_t lcp_ego_frt_obj_cls;
        bool lcp_ego_bck_obj_exist_flg;
        uint32_t lcp_ego_bck_obj_id;
        float lcp_ego_bck_obj_dist;
        float lcp_ego_bck_obj_spd;
        float lcp_ego_bck_obj_len;
        uint32_t lcp_ego_bck_obj_cls;
        bool lcp_nr_obj_exist_flg;
        uint32_t lcp_nr_obj_id;
        float lcp_nr_obj_dist;
        float lcp_nr_obj_spd;
        float lcp_nr_obj_len;
        uint32_t lcp_nr_obj_cls;
        bool lcp_nr_frt_obj_exist_flg;
        uint32_t lcp_nr_frt_obj_id;
        float lcp_nr_frt_obj_dist;
        float lcp_nr_frt_obj_spd;
        float lcp_nr_frt_obj_len;
        uint32_t lcp_nr_frt_obj_cls;
        bool lcp_nr_bck_obj_exist_flg;
        uint32_t lcp_nr_bck_obj_id;
        float lcp_nr_bck_obj_dist;
        float lcp_nr_bck_obj_spd;
        float lcp_nr_bck_obj_len;
        uint32_t lcp_nr_bck_obj_cls;
    };

    struct MsgBA2Obs
    {
        // BA measurement variable
        std::vector<BehaviorNodeGlobal> m_ba_behavior_node_global_vector;
        std::vector<BehaviorNodeGlobal> m_ba_terminated_behavior_nodes_vector;
        std::vector<uint8_t> m_ba_lat_avlbl_behavior;
        int m_ba_step_num;
        uint32_t m_ba_optimal_corridor_id;
        uint32_t m_ba_optimal_target_obj_id;
        uint8_t m_ba_optimal_action;
        bool m_ba_behavior_node_update_done;
        std::vector<Passageob> m_ba_passage_ob_lst;
        bool m_ba_passage_genflg_lc;
        std::vector<uint32_t> m_ba_interest_obj_id_list;
        std::vector<dpc::Passage> m_ba_passage_list_ob;
        bool m_ba_lc_ego_frt_obj_exist_flg;
        uint32_t m_ba_lc_ego_frt_obj_id;
        bool m_ba_lc_tar_frt_obj_exist_flg;
        uint32_t m_ba_lc_tar_frt_obj_id;
        bool m_ba_lc_tar_bck_obj_exist_flg;
        uint32_t m_ba_lc_tar_bck_obj_id;
        bool m_ba_lcp_frt_passagegenflg;
        bool m_ba_lcp_bck_passagegenflg;
        bool m_ba_lcp_ego_frt_obj_exist_flg;
        uint32_t m_ba_lcp_ego_frt_obj_id;
        bool m_ba_lcp_ego_bck_obj_exist_flg;
        uint32_t m_ba_lcp_ego_bck_obj_id;
        bool m_ba_lcp_nr_obj_exist_flg;
        uint32_t m_ba_lcp_nr_obj_id;
        bool m_ba_lcp_nr_frt_obj_exist_flg;
        uint32_t m_ba_lcp_nr_frt_obj_id;
        bool m_ba_lcp_nr_bck_obj_exist_flg;
        uint32_t m_ba_lcp_nr_bck_obj_id;
    };

    struct LateralBlueCorridor
    {
        // lateral blue corridor definition
        dpc::LineGeometry m_reference_line;
        float m_width;
    };

    struct LateralBorder
    {
        // lateral border definition
        rm_interface::SLPoint m_left_border[20];
        rm_interface::SLPoint m_right_border[20];
    };

    struct LongitudinalCorridor
    {
        // longitudinal corridor definition
        float m_corridor_distance; // distance to vehicle;
        float m_corridor_speed;    // desired speed;
    }; 
    
    struct SpeedLimit
    {
        // longitudinal speed limit definition
        float m_target_speed;
        float m_related_distance;
    };

    struct DirectionIndicatorDuration
    {
        // Direction indicator duration definition
        float m_left_direction_indicator_duration;
        float m_right_direction_indicator_duration;
    };
}
