/*
 * @Author: your name
 * @Date: 2021-09-23 18:50:38
 * @LastEditTime: 2022-03-09 18:23:15
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Editd
 * @FilePath: //media/xnm/xnm/ros/RM/roadmodel/modules/common/road/local_view.h
 */

#pragma once

#include <memory>

// #include "mpc_drv_msgs/msg/vehicle_state_output.hpp"
// #include "mpc_drv_msgs/msg/control_waypoints.hpp"
// #include "mpc_drv_msgs/msg/msg_sm2_ba.hpp"
// #include "mpc_drv_msgs/msg/road_info.hpp"
// #include "interface/rm_road_info.h"
// #include "interface/slam_decision.h"
// #include "interface/ved_dpc_interface.h"
// #include "interface/sm_dm_interface.h"
#include "dpc/impl_type_roadinfo.h"
#include "dpc/impl_type_controlwaypoints.h"
#include "dpc/impl_type_ved4dpc.h"
#include "dpc/impl_type_sm4decision.h"

namespace BA {

/**
 * @struct local_view
 * @brief LocalView contains all necessary data as rm input
 */
struct LocalView {
  std::shared_ptr<RoadInfo> road_model;
  std::shared_ptr<dpc::VED4DPC> vehicle_state;
  std::shared_ptr<SM4Decision> system_management;
  std::shared_ptr<ControlWaypoints> control_waypoints;
  LocalView(){
    road_model = std::make_shared<RoadInfo>();
    vehicle_state = std::make_shared<dpc::VED4DPC>();
    system_management = std::make_shared<SM4Decision>();
    control_waypoints = std::make_shared<ControlWaypoints>();
  }
};

} // namespace BA
