

/**
 * @brief  PD_BehaviorNodeLocal.cpp
 * @param
 * @author lzc
 * @date 2021-11-22
 * @version 1.0
 * @property
 * */

#include "PD_BehaviorNodeLocal.h"

using namespace ADC::PD_BehvNodeLocal;

BehaviorNodeLocal::BehaviorNodeLocal(const PD_Corridor::UpdateCorridor &nodeinfo,
                                     const PD_Comfort::Comfort &comfort,
                                     const PD_DynmcObjRsk::DynamicObjRisk &dynmcobjrsk,
                                     const PD_TrffcEffcy::TrffcEffcy &trffceffcy,
                                     const PD_LegalPnsh::LegalPunishment &punishment,
                                     const PD_StnObstcRsk::StnObstcRisk &stnobstcrsk,
                                     const std::vector<PD_NodeUpdate::PD_NodeHVInfo> &hvdurainfo,
                                     const PD::PD_Input &pd_input,
                                     const bool &nodeclsn,
                                     const bool &rminvalidflg,
                                     const PD_LgtSpdLmt::LgtSpdLmt &lgtspdlmt)

{
    // if(!dynmcobjrsk.m_DynObjRsk_list.empty())

    // node info
    // PD::BehaviorNodeLocal Corridor_nodeinfo;
    behaviornodellocalvector.m_node_id.x = nodeinfo.pd_UpdateCorridor_Next_NodeID.x;
    behaviornodellocalvector.m_node_id.y = nodeinfo.pd_UpdateCorridor_Next_NodeID.y;
    behaviornodellocalvector.m_parent_node_id.x = nodeinfo.pd_UpdateCorridor_Parent_NodeID.x;
    behaviornodellocalvector.m_parent_node_id.y = nodeinfo.pd_UpdateCorridor_Parent_NodeID.y;

    // comfort index
    //  mpc_drv_msgs::BehaviorNodeLocal Dynamic_riskinfo;
    PD::Comfort Dynamic_comfort;
    PD::RiskEvaluation Dynamic_riskevaluation;
    Dynamic_comfort.m_cft_lat_jerk_max = comfort.m_CftLatAccJerkMax;
    Dynamic_comfort.m_cft_lat_acc_max = comfort.m_CftLatAccMax;
    Dynamic_comfort.m_cft_long_jerk_max = comfort.m_CftLongAccJerkMax;
    Dynamic_comfort.m_cft_long_acc_max = comfort.m_CftLongAccMax;
    // Dynamic_comfort = comfort.m_CftLatAccJerkMax;
    Dynamic_riskevaluation.m_comfort_list.emplace_back(Dynamic_comfort);

    // DLOG(INFO) << "CftLatAccMax: " << Dynamic_comfort.m_cft_lat_acc_max << std::endl;

    // dynamic risk index
    std::vector<PD::DynamicObjRisk> Dynamic_objrsk;
    // Dynamic_objrsk.m_ObjID = dynmcobjrsk.m_DynObjRsk_list.
    PD::DynamicObjRisk badynamic_objrsk;
    for (int i = 0; i < dynmcobjrsk.m_DynObjRsk_list.size(); i++)
    {
        badynamic_objrsk.m_obj_id = dynmcobjrsk.m_DynObjRsk_list[i].ObjID;
        badynamic_objrsk.m_obj_lat_crs_saftzn_itg = dynmcobjrsk.m_DynObjRsk_list[i].m_ObjLatCrsSfZnItg;
        badynamic_objrsk.m_obj_lat_min_distance = dynmcobjrsk.m_DynObjRsk_list[i].m_ObjLatMinDis;
        badynamic_objrsk.m_obj_lat_ovlp_deg = dynmcobjrsk.m_DynObjRsk_list[i].m_ObjLatOvlpDeg;
        badynamic_objrsk.m_obj_long_crs_saftzn_itg = dynmcobjrsk.m_DynObjRsk_list[i].m_ObjLongCrsSfZnItg;
        badynamic_objrsk.m_obj_long_min_distance = dynmcobjrsk.m_DynObjRsk_list[i].m_ObjLongMinDis;
        badynamic_objrsk.m_obj_long_ovlp_deg = dynmcobjrsk.m_DynObjRsk_list[i].m_ObjLongOvlpDeg;
        badynamic_objrsk.m_obj_long_clsn_td = dynmcobjrsk.m_DynObjRsk_list[i].m_ObjLongPreClsnTD;
        badynamic_objrsk.m_obj_long_clsn_ttc = dynmcobjrsk.m_DynObjRsk_list[i].m_ObjLongPreClsnTTC;

        // Dynamic_riskevaluation.m_DynamicObjRisk_list.emplace_back(Dynamic_objrsk);

        Dynamic_objrsk.emplace_back(badynamic_objrsk);
    }
    

    Dynamic_riskevaluation.m_dynamicobj_risk_list = Dynamic_objrsk;
    // traffic rule

    #ifdef GLOG
    // analysis data
    //  for (auto it = Dynamic_riskevaluation.m_dynamicobj_risk_list.begin(); it != Dynamic_riskevaluation.m_dynamicobj_risk_list.end();)
    // {

    //     DLOG(INFO) << "id: " << int(it->m_obj_id)
    //                << "\taction: " << int(pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type);
    //     int datasz = std::min(it->m_obj_long_clsn_td.size(), it->m_obj_long_clsn_ttc.size());
    //     for (int i = 0; i < datasz; i++)
    //     {
    //         DLOG(INFO) << "ttc: " << it->m_obj_long_clsn_ttc[i]
    //                    << "\ttd: " << it->m_obj_long_clsn_td[i];
    //     }

    //     DLOG(INFO) << std::endl;
    //     it++;
    // }
    #endif
    PD::TrffcEffcy Dynamic_trffceffcy;
    Dynamic_trffceffcy.m_effcy_avgspd = trffceffcy.m_EffAvgSpd;
    Dynamic_trffceffcy.m_effcy_endspd = trffceffcy.m_EffEndSpd;
    Dynamic_trffceffcy.m_effcy_longdrv_distance = trffceffcy.m_EffLongDrvDis;
    // Dynamic_riskevaluation.m_TrffcEffcy_list.emplace_back(Dynamic_trffceffcy);
    Dynamic_riskevaluation.m_trffc_effcy_list.emplace_back(Dynamic_trffceffcy);

    // Legal punishment
    PD::LegalPunishment Dynamic_legalpunishment;

    Dynamic_legalpunishment.m_pnshmnt = punishment.m_PnshSldnene;

    Dynamic_riskevaluation.m_legal_pnshmt_list.emplace_back(Dynamic_legalpunishment);

    // behaviornodellocalvector.m_RiskEvaluation.

    // Stationary obstacle risk index
    PD::StnObstcRisk Dynamic_stnobstcrsk;
    Dynamic_stnobstcrsk.m_bdrlat_crs_saftzn_itg = stnobstcrsk.m_BdrLatCrsSfZnItg;
    Dynamic_stnobstcrsk.m_bdrlat_min_distance = stnobstcrsk.m_BdrLatMinDis;
    Dynamic_riskevaluation.m_stnobstc_risk_list.emplace_back(Dynamic_stnobstcrsk);

    // push RiskEvaluation
    behaviornodellocalvector.m_risk_evaluation = Dynamic_riskevaluation;

    // Host Vehicle infomation
    std::vector<PD::HVInfo> bahvinfo;
    PD::HVInfo egodurainfo;

    for (int i = 0; i < hvdurainfo.size(); i++)
    {
        egodurainfo.m_distance_alongs = hvdurainfo.at(i).relat_s;
        egodurainfo.m_lane_location = hvdurainfo.at(i).locationID;
        egodurainfo.m_velocity = hvdurainfo.at(i).vx;
        bahvinfo.emplace_back(egodurainfo);
    }

    behaviornodellocalvector.m_hvinfo = bahvinfo;

    // std::ostream

    // response duration time

    if (!pd_input.rm_roadmodel.empty())
    {
        if (!pd_input.rm_roadmodel.at(rm_Num).passage_list.empty())

            behaviornodellocalvector.m_duration_time = pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).duration_time;
    }

    // response Node collision state
    // rminvalidflg indicate the environment is invalid
    behaviornodellocalvector.m_node_clsn_sts = (nodeclsn || rminvalidflg);

    // output lgt speed limt info
    behaviornodellocalvector.desired_spd_limit_val = lgtspdlmt.LgtSpdLmt_SpdVal;
    behaviornodellocalvector.desired_spd_limt_dist = lgtspdlmt.LgtSpdLmt_DistVal;
    behaviornodellocalvector.spd_limit_flg = lgtspdlmt.LgtSpdLmt_SpdLmtFlg;
    behaviornodellocalvector.spd_limit_type = lgtspdlmt.LgtSpdLmt_type;

    DLOG(INFO) << "ba_ndClsn: " << behaviornodellocalvector.m_node_clsn_sts
               << "\tnodeclsn: " << nodeclsn
               << "\trmInvld: " << rminvalidflg << std::endl;
}
// #endif

// print local behaviornode collision status

#if LocalClsn_WRITE_FLAG != 0
std::ofstream ofs2;

ofs2.open("./src/mpc_drv_ctAp_ba/core/source/PD_module/PD_LOG/LBN_ClsnSts.txt");

// if (pd_input.rm_roadmodel.at(rm_Num).road_id.x == static_cast<uint8_t>(0))
// {
ofs2 << "Action: " << int(pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type) << "\tClsn: "
     << int(behaviornodellocalvector.m_NodeClsnSts) << std::endl;
// }
ofs2.close();

#endif
