/**
 * @file
 * @brief lzc add 20211119
 *        usage: to calculate ego vehicle temporal position
 *
 */

#include "PD_EgoVehStsArb.h"
#include "PD_LatTrajectory.h"
#include "PD_LgtTrajectory.h"
#include <vector>
#include <algorithm>

using namespace ADC::PD_EgoVehTrj;

// PD_EgoVehTrj::EgoVeh_TrjPnt egoveh_trjpnt;
// extern int rm_Num;
// extern int psg_Num;

void EgoVehTrj::EgoVehLgtTrjPntProc(const PD_LgtSpdLmt::LgtSpdLmt &lgtspdlmt,
                                    const ADC::PD_LgtTrj::LgtTrajectory &lgttrj_st)

{

    // choose lgt speed limit trajectory result
    // DLOG(INFO) << "Egoveh_SpdLmtFlg: " << lgtspdlmt.LgtSpdLmt_SpdLmtFlg
    //            << "\tSpdLmt_s_pntsize: " << lgtspdlmt.pd_lgtspdlmt_st_trace.pd_lgttrj_st_trace.size()
    //            << "\tSpdLmt_tm: " << lgtspdlmt.pd_lgtspdlmt_st_trace.lgttrj_st_coe.tm << std::endl;
    if (!lgtspdlmt.pd_lgtspdlmt_st_trace.pd_lgttrj_st_trace.empty() && lgtspdlmt.LgtSpdLmt_SpdLmtFlg == true)
    {

        lgt_egoveh_tpinfo.egoveh_lgttrjpnt = lgtspdlmt.pd_lgtspdlmt_st_trace.pd_lgttrj_st_trace;
        lgt_egoveh_tpinfo.plan_tm = lgtspdlmt.pd_lgtspdlmt_st_trace.lgttrj_st_coe.tm;
        // std::cout << "***" << std::endl;
    }

    else
    {
        // choose  follow/distance lgt trajectory result
        lgt_egoveh_tpinfo.egoveh_lgttrjpnt = lgttrj_st.pd_lgttrj_stinfo.pd_lgttrj_st_trace;
        lgt_egoveh_tpinfo.plan_tm = lgttrj_st.pd_lgttrj_stinfo.lgttrj_st_coe.tm;

        // DLOG(INFO) << "lgt_s_pntsize: " << lgttrj_st.pd_lgttrj_stinfo.pd_lgttrj_st_trace.size() << std::endl;
        // DLOG(INFO) << "lgt_tm: " << lgt_egoveh_tpinfo.plan_tm << std::endl;
    }
}

void EgoVehTrj::EgoVehTrjArbProc(const PD_LgtSpdLmt::LgtSpdLmt &lgtspdlmt,
                                 const ADC::PD_LgtTrj::LgtTrajectory &lgttrj_st,
                                 const ADC::PD_LatTrj::LatTrajectory &LatTrj_LS_trace,
                                 const PD::PD_Input &pd_input)
{
    // EgoVehLgtTrjPntProc(lgtspdlmt, lgttrj_st);

    PD_EgoVehTrj::EgoVeh_TrjPnt egoveh_trjpnt;

    // if (!(LatTrj_LS_trace.pd_LatTrj_LS_trace.empty() || LgtTrj_ST_trace.pd_LgtTrj_ST_trace.empty()))

    if (!(LatTrj_LS_trace.pd_LatTrj_LS_trace.empty()) && !(lgt_egoveh_tpinfo.egoveh_lgttrjpnt.empty()))
    {
        float DurationTM = pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).duration_time;
        float LatPlanTm = LatTrj_LS_trace.pd_LatTrj_LS_trace.back().t;

        float LgtPlanTm = lgt_egoveh_tpinfo.plan_tm;
        int indx = static_cast<int>(DurationTM / 0.1);

        if (LatPlanTm >= LgtPlanTm)
        {
            pd_vehtrajPlanTm = LgtPlanTm;
        }
        else
        {
            pd_vehtrajPlanTm = LatPlanTm;
        }

        // DLOG(INFO) << "LatPlanTm: " << LatPlanTm
        //            << "\tDurationTM: " << DurationTM
        //            << "\tl_pntsize: " << LatTrj_LS_trace.pd_LatTrj_LS_trace.size()
        //            << "\ts_size: " << lgt_egoveh_tpinfo.egoveh_lgttrjpnt.size() << std::endl;
        // DLOG(INFO) << "vehplantm: " << pd_vehtrajPlanTm << std::endl;

        // std::cout << "LatPlanTm: " << LatPlanTm
        //           << "\tDurationTM: " << DurationTM
        //           << "\tl_pntsize: " << LatTrj_LS_trace.pd_LatTrj_LS_trace.size()
        //           << "\ts_size: " << lgt_egoveh_tpinfo.egoveh_lgttrjpnt.size() << std::endl;
        // std::cout << "vehplantm: " << pd_vehtrajPlanTm << std::endl;

        // std::cout << "plan less Dutm" << std::endl;
        if (pd_vehtrajPlanTm <= DurationTM)
        {

            int lgtpntsize = lgt_egoveh_tpinfo.egoveh_lgttrjpnt.size();
            int latpntsize = LatTrj_LS_trace.pd_LatTrj_LS_trace.size();
            int egopntsize = std::min(lgtpntsize, latpntsize);
            // std::cout << "egopntsize: " << egopntsize
            //           << "\tlgtpntsize: " << lgtpntsize << std::endl;
            for (int i = 0; i < egopntsize; i++)
            {
                // std::cout << "i: " << i << std::endl;
                float tm = i * 0.1;
                egoveh_trjpnt.t = i * 0.1;
                // std::cout << "00" << std::endl;
                egoveh_trjpnt.s = lgt_egoveh_tpinfo.egoveh_lgttrjpnt.at(i).s;

                egoveh_trjpnt.l = LatTrj_LS_trace.pd_LatTrj_LS_trace.at(i).l;
                // egoveh_trjpnt.l = 0.0;

                egoveh_trjpnt.vx = lgt_egoveh_tpinfo.egoveh_lgttrjpnt.at(i).vx;

                egoveh_trjpnt.vy = LatTrj_LS_trace.pd_LatTrj_Lt_coefficient_d[1] +
                                   2 * LatTrj_LS_trace.pd_LatTrj_Lt_coefficient_d[2] * tm +
                                   3 * LatTrj_LS_trace.pd_LatTrj_Lt_coefficient_d[3] * tm * tm +
                                   4 * LatTrj_LS_trace.pd_LatTrj_Lt_coefficient_d[4] * tm * tm * tm +
                                   5 * LatTrj_LS_trace.pd_LatTrj_Lt_coefficient_d[5] * tm * tm * tm * tm;

                // egoveh_trjpnt.vy = 0.0f;
                egoveh_trjpnt.ax = lgt_egoveh_tpinfo.egoveh_lgttrjpnt.at(i).ax;
                egoveh_trjpnt.jkx = lgt_egoveh_tpinfo.egoveh_lgttrjpnt.at(i).jkx;

                egoveh_tp.emplace_back(egoveh_trjpnt);
            }

            // splice durationTM gap data
            float _EgoVehStepTime = 0.1;
            float starttm = egopntsize * _EgoVehStepTime;

            // std::cout << "test01"
            //           << "\tstarttime: " << starttm
            //           << "\tDu tm: " << DurationTM << std::endl;

            // std::cout << "last s: " << egoveh_tp.back().s
            //           << "\ts size: " << egoveh_tp.size() << std::endl;

            for (float i = starttm; i < DurationTM + 0.001; i = i + 0.1)
            {

                egoveh_trjpnt.t = i;

                egoveh_trjpnt.s = egoveh_tp.back().s + egoveh_tp.back().vx * _EgoVehStepTime;

                // if (LatPlanTm >= DurationTM)
                
                if (LatPlanTm >= starttm && (ceil(i * 10) < LatTrj_LS_trace.pd_LatTrj_LS_trace.size()))
                {
                    // int _tempindx = i * 10;

                    egoveh_trjpnt.l = LatTrj_LS_trace.pd_LatTrj_LS_trace.at(ceil(i * 10)).l;

                    egoveh_trjpnt.vy = LatTrj_LS_trace.pd_LatTrj_Lt_coefficient_d[1] +
                                       2 * LatTrj_LS_trace.pd_LatTrj_Lt_coefficient_d[2] * i +
                                       3 * LatTrj_LS_trace.pd_LatTrj_Lt_coefficient_d[3] * i * i +
                                       4 * LatTrj_LS_trace.pd_LatTrj_Lt_coefficient_d[4] * i * i * i +
                                       5 * LatTrj_LS_trace.pd_LatTrj_Lt_coefficient_d[5] * i * i * i * i;
                }

                else
                {
                    egoveh_trjpnt.l = egoveh_tp.back().l;
                    egoveh_trjpnt.vy = egoveh_tp.back().vy;
                }

                egoveh_trjpnt.vx = egoveh_tp.back().vx;

                

                // egoveh_trjpnt.ax = egoveh_tp.back().ax;
                // egoveh_trjpnt.jkx = egoveh_tp.back().jkx;

                egoveh_trjpnt.ax = 0.0f;
                egoveh_trjpnt.jkx = 0.0f;

                egoveh_tp.emplace_back(egoveh_trjpnt);
            }
            // std::cout << "EgoCore" << std::endl;
            // // // std::cout <<
            // std::cout << "egoveh tp size: " << egoveh_tp.size() << std::endl;

            
        }
        else // duration time  < pd_vehtrajPlanTm
        {
            // std::cout << "DurationTM: " << DurationTM << std::endl;
            // std::cout << "pd_vehtrajPlanTm: " << pd_vehtrajPlanTm << std::endl;
            // std::cout << "LatPlanTm: " << LatPlanTm << std::endl;
            // std::cout << "LgtPlanTm: " << LgtPlanTm << std::endl;
            // std::cout << "l_pntsize: " << LatTrj_LS_trace.pd_LatTrj_LS_trace.size() << std::endl;
            // std::cout << "s_pntsize: " << lgt_egoveh_tpinfo.egoveh_lgttrjpnt.size() << std::endl;
            // std::cout << "**indx: " << indx << std::endl;
            // std::cout << std::endl;
            if ((lgt_egoveh_tpinfo.egoveh_lgttrjpnt.size() >= indx) && (LatTrj_LS_trace.pd_LatTrj_LS_trace.size() >= indx)) // lattrj size and lgttrj size are enough
            {
                {

                    // std::cout << "l_pntsize: " << LatTrj_LS_trace.pd_LatTrj_LS_trace.size() << std::endl;
                    // std::cout << "s_pntsize: " << lgt_egoveh_tpinfo.egoveh_lgttrjpnt.size() << std::endl;

                    // for (int ii = 0; ii < LatTrj_LS_trace.pd_LatTrj_LS_trace.size(); ii++)
                    // {
                    //     std::cout << ii << "\tl_pnt: " << LatTrj_LS_trace.pd_LatTrj_LS_trace.at(ii).l << std::endl;
                    // }
                    // for (int j = 0; j < lgt_egoveh_tpinfo.egoveh_lgttrjpnt.size(); j++)
                    // {
                    //     std::cout << j << "\ts_pnt: " << lgt_egoveh_tpinfo.egoveh_lgttrjpnt.at(j).s << std::endl;
                    // }

                    // std::cout << "lgt s_size: " << lgt_egoveh_tpinfo.egoveh_lgttrjpnt.size() << "\tlat l_size: " << LatTrj_LS_trace.pd_LatTrj_LS_trace.size() << std::endl;
                    for (int i = 0; i < indx; i++)
                    {
                        float tm = i * 0.1;
                        egoveh_trjpnt.t = i * 0.1;
                        egoveh_trjpnt.s = lgt_egoveh_tpinfo.egoveh_lgttrjpnt.at(i).s;
                        // egoveh_trjpnt.s = lgt_egoveh_tpinfo.egoveh_lgttrjpnt[i].s;

                        egoveh_trjpnt.l = LatTrj_LS_trace.pd_LatTrj_LS_trace.at(i).l;

                        egoveh_trjpnt.vx = lgt_egoveh_tpinfo.egoveh_lgttrjpnt.at(i).vx;

                        egoveh_trjpnt.vy = LatTrj_LS_trace.pd_LatTrj_Lt_coefficient_d[1] +
                                           2 * LatTrj_LS_trace.pd_LatTrj_Lt_coefficient_d[2] * tm +
                                           3 * LatTrj_LS_trace.pd_LatTrj_Lt_coefficient_d[3] * tm * tm +
                                           4 * LatTrj_LS_trace.pd_LatTrj_Lt_coefficient_d[4] * tm * tm * tm +
                                           5 * LatTrj_LS_trace.pd_LatTrj_Lt_coefficient_d[5] * tm * tm * tm * tm;

                        egoveh_trjpnt.ax = lgt_egoveh_tpinfo.egoveh_lgttrjpnt.at(i).ax;
                        egoveh_trjpnt.jkx = lgt_egoveh_tpinfo.egoveh_lgttrjpnt.at(i).jkx;

                        egoveh_tp.emplace_back(egoveh_trjpnt);
                    }
                }
            }
            else // size not enough
            {
                // std::cout << "size not enough" << std::endl;
                // std::cout << "lgt size: " << lgt_egoveh_tpinfo.egoveh_lgttrjpnt.size() << std::endl;
                // std::cout << "lat size: " << LatTrj_LS_trace.pd_LatTrj_LS_trace.size() << std::endl;
                // std::cout << "****indx: " << indx << std::endl;
                // std::cout <<
                if (lgt_egoveh_tpinfo.egoveh_lgttrjpnt.size() < indx && (!lgt_egoveh_tpinfo.egoveh_lgttrjpnt.empty())) // get exit lgttrjpnt
                {

                    for (int i = 0; i < lgt_egoveh_tpinfo.egoveh_lgttrjpnt.size(); i++)
                    {
                        // std::cout << "ss" << std::endl;
                        float tm = i * 0.1;
                        egoveh_trjpnt.t = lgt_egoveh_tpinfo.egoveh_lgttrjpnt.at(i).t;
                        egoveh_trjpnt.s = lgt_egoveh_tpinfo.egoveh_lgttrjpnt.at(i).s;

                        egoveh_trjpnt.l = LatTrj_LS_trace.pd_LatTrj_LS_trace.at(i).l; //
                        // egoveh_trjpnt.l = 0;

                        egoveh_trjpnt.vx = lgt_egoveh_tpinfo.egoveh_lgttrjpnt.at(i).vx;
                        // std::cout << "vx" << std::endl;
                        egoveh_trjpnt.vy = LatTrj_LS_trace.pd_LatTrj_Lt_coefficient_d[1] +
                                           2 * LatTrj_LS_trace.pd_LatTrj_Lt_coefficient_d[2] * tm +
                                           3 * LatTrj_LS_trace.pd_LatTrj_Lt_coefficient_d[3] * tm * tm +
                                           4 * LatTrj_LS_trace.pd_LatTrj_Lt_coefficient_d[4] * tm * tm * tm +
                                           5 * LatTrj_LS_trace.pd_LatTrj_Lt_coefficient_d[5] * tm * tm * tm * tm;
                        // std::cout << "vy" << std::endl;
                        egoveh_trjpnt.ax = lgt_egoveh_tpinfo.egoveh_lgttrjpnt.at(i).ax;
                        // std::cout << "ax" << std::endl;
                        egoveh_trjpnt.jkx = lgt_egoveh_tpinfo.egoveh_lgttrjpnt.at(i).jkx;

                        egoveh_tp.emplace_back(egoveh_trjpnt);
                    }
                    // std::cout << "No_comp t: " << egoveh_tp.back().t << std::endl;
                    // compensation lgttrjpnt

                    DLOG(INFO) << "before comp egoveh size: " << egoveh_tp.size();
                    LgtTrjPntCompProc(lgttrj_st, LatTrj_LS_trace, pd_input);
                }
            }
        }
    }
#ifdef GLOG
    // analysis data
    // DLOG(INFO) << "Output"
    //            << "\trm_id:(" << int(pd_input.rm_roadmodel.at(rm_Num).road_id.x)
    //            << "," << int(pd_input.rm_roadmodel.at(rm_Num).road_id.y) << ")" << std::endl;
    // for (int i = 0; i < egoveh_tp.size(); i++)
    // {
    //     DLOG(INFO) << i << "\ts_pnt: " << egoveh_tp.at(i).s << "\tl_pnt: " << egoveh_tp.at(i).l
    //                << "\tt_pnt: " << egoveh_tp.at(i).t << "\tvx_pnt: " << egoveh_tp.at(i).vx
    //                << "\tvy_pnt: " << egoveh_tp.at(i).vy << "\tax: " << egoveh_tp.at(i).ax << std::endl;
    // }

    // DLOG(INFO) << "real lat pnt"
    //            << "\tl size: " << LatTrj_LS_trace.pd_LatTrj_LS_trace.size() << std::endl;
    // // for (auto ele : LatTrj_LS_trace.pd_LatTrj_LS_trace)
    // // {
    // //     DLOG(INFO) << "real l: " << ele.l << std::endl;
    // // }
    // DLOG(INFO) << "Output_End" << std::endl;

#endif
}

void EgoVehTrj::LgtTrjPntCompProc(const ADC::PD_LgtTrj::LgtTrajectory &lgttrj_st,
                                  const ADC::PD_LatTrj::LatTrajectory &LatTrj_LS_trace,
                                  const PD::PD_Input &pd_input)
{
    // int CompNum = 0;
    // CompNum = indx - lgt_egoveh_tpinfo.egoveh_lgttrjpnt.size();
    // float temp_s = lgt_egoveh_tpinfo.egoveh_lgttrjpnt.back().s;
    // float temp_v = lgt_egoveh_tpinfo.egoveh_lgttrjpnt.back().vx;
    // float CompTime = CompNum / 10;
    float Comp_timestop = 0.1f;
    float Comp_StartTimt = lgt_egoveh_tpinfo.egoveh_lgttrjpnt.size() * Comp_timestop;
    float Comp_durationtm = pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).duration_time;

    PD_EgoVehTrj::EgoVeh_TrjPnt Comp_egoveh_trjpnt;
    int Comp_indx = static_cast<int>(Comp_durationtm / 0.1);

    for (float i = Comp_StartTimt; i <= Comp_durationtm + 0.001; i = i + 0.1)
    {
        Comp_egoveh_trjpnt.t = i;
        Comp_egoveh_trjpnt.s = egoveh_tp.back().s + egoveh_tp.back().vx * Comp_timestop;

        if (LatTrj_LS_trace.pd_LatTrj_LS_trace.size() >= Comp_indx)

        {
            Comp_egoveh_trjpnt.l = LatTrj_LS_trace.pd_LatTrj_LS_trace.at(10 * i).l;
        }
        else
        {
            Comp_egoveh_trjpnt.l = egoveh_tp.back().l + egoveh_tp.back().vy * Comp_timestop;
        }

        Comp_egoveh_trjpnt.vx = egoveh_tp.back().vx;
        Comp_egoveh_trjpnt.vy = egoveh_tp.back().vy;
        Comp_egoveh_trjpnt.ax = 0.0f;
        Comp_egoveh_trjpnt.jkx = 0.0f;
        egoveh_tp.emplace_back(Comp_egoveh_trjpnt);
        // std::cout << "tm: " << i << std::endl;
    }
    // std::cout << "Comp_StartTimt: " << Comp_StartTimt << std::endl;
    // std::cout << "Comp_durationtm: " << Comp_durationtm << std::endl;
    // std::cout << "Comp_indx: " << Comp_indx << std::endl;
}