// /**
//  * @brief  PD_ObjAttention.h
//  * @param
//  * @author lzc
//  * @date 2022-06-15
//  * @version 1.0
//  * @property  to process risk object and output attention
//  * */
#pragma once

#include "PD_NodeUpdate.h"
// #include "mpc_drv_msgs/msg/obj_attention.hpp"
// #include "install/mpc_drv_msgs/include/mpc_drv_msgs/msg/obj_attention.hpp"
#include "PD_DynamicObjRisk.h"
#include <math.h>
#include <algorithm>
#include "../../../../include/CtApBehaviorAnalysis_/BA_Enum_List.h"
#include "../../../../include/CtApBehaviorAnalysis_/interface/pd_interface.h"

namespace ADC
{
    namespace PD_ObjAttention
    {

        struct PD_AttentionSVObj
        {
            uint32_t m_ObjID = 0;
            std::vector<float> vec_l;
            std::vector<float> vec_relat_s;
            std::vector<float> vec_DistTm; // time distance in time sequence
            std::vector<float> vec_ttc;
        };

        struct PD_AttObjInfo
        {
            uint32_t m_ObjID = 0; 
            float MinTTC = 999.0f;
            float MinTD = 25.0f;
            float MinLgtDist = 999.0f;
            bool Risksts = false;
        };

        class RiskObjAttention
        {
        public:
            void ObjAttentionProc(const PD_SVEstmd::SVEstmd &svtrajpnt,
                                  const PD::PD_Input &pd_input,
                                  const PD_EgoVehTrj::EgoVehTrj &egovehtrj,
                                  const PD_DynmcObjRsk::DynamicObjRisk &dynmcobjrsk);
            void UpdateObjAttentionProc(const PD_SVEstmd::SVEstmd &svtrajpnt,
                                  const PD::PD_Input &pd_input,
                                  const PD_EgoVehTrj::EgoVehTrj &egovehtrj,
                                  const PD_DynmcObjRsk::DynamicObjRisk &dynmcobjrsk);

            PD::Attention attention;
            std::vector<PD::Attention> objattention;

            std::vector<PD_AttentionSVObj> PD_AttentionObjList;

            bool AttentionVehSpdEnblProc(const uint32_t targetobjid,
                                         const PD::PD_Input &pd_input);
            bool Attention_VehSpdEnbl = false;
            bool AttentionObjTrgEnbl = false;

            bool AttentionBahvirEnblProc(const PD::PD_Input &pd_input);

            void Process(const PD_SVEstmd::SVEstmd &svtrajpnt,
                         const PD::PD_Input &pd_input,
                         const PD_EgoVehTrj::EgoVehTrj &egovehtrj,
                         const PD_DynmcObjRsk::DynamicObjRisk &dynmcobjrsk);
            bool AttObjRiskStsProc(float &ttc,float &td,float &lgtdist);

            private:
                std::vector<PD_AttObjInfo> pd_attobjinfo_vec;
                
        };

    } // namespace PD_ObjAttention
} // namespace ADC