/**
 * @file
 * @brief  add 20211122
 */
#ifndef __PD_ROADMODELVECTOR_PDTOBA_H__
#define __PD_ROADMODELVECTOR_PDTOBA_H__

#include "PD_Input.h"
#include "PD_RoadModel_RoadID_PDtoBA.h"
#include "PD_RoadModel_CarPosition_PDtoBA.h"
#include "PD_RoadModel_LaneList_PDtoBA.h"
#include "PD_RoadModel_LaneMarkerList_PDtoBA.h"
#include "PD_RoadModel_ObjectList_PDtoBA.h"
#include "PD_RoadModel_RoadEdge_PDtoBA.h"
#include "PD_EgoVehStsArb.h"
#include "PD_NodeUpdate.h"
#include "../../source/PD_commonfunc.h"
#include "../../../commonfunc.h"    // ADC::common::k_BA_TotalDurationTimeThreshold
#include "PD_LatTrajectory.h"
#include <thread>


#define FLAG_PDRM_HEAP 0    /***************** switch 0 ******************/
#define FLAG_PDRM_THREAD 0    /***************** switch 0 ******************/


#if FLAG_PDFP_SAVECSV != 0
#include <chrono>
#if USING_ROS2 == 0
#include <rosgraph_msgs/Clock.h>
void getRosbagTimeCallback(const rosgraph_msgs::Clock::ConstPtr& msg);
#endif  // USING_ROS2
#if USING_ROS2 != 0
#include <rosgraph_msgs/msg/clock.hpp>
void getRosbagTimeCallback(const rosgraph_msgs::msg::Clock& timemsg);
#endif  // USING_ROS2
#endif


namespace ADC
{
namespace PD_RoadModelVector_PDtoBA
{

class RoadModelVector_PDtoBA
{
public:
    RoadModelVector_PDtoBA(const PD::PD_Input &m_pd_input,
                            const dpc::Index &m_pd_updatecorridor_next_NodeID, 
                            const std::vector<ADC::PD_EgoVehTrj::EgoVeh_TrjPnt> &m_egoveh_tp,
                            const std::vector<ADC::PD_NodeUpdate::PD_NodeHVInfo> &m_nodeHVinfo);
    ~RoadModelVector_PDtoBA()=default;

private:
    bool init(const PD::PD_Input &m_pd_input,
                            const dpc::Index &m_pd_updatecorridor_next_NodeID, 
                            const std::vector<ADC::PD_EgoVehTrj::EgoVeh_TrjPnt> &m_egoveh_tp,
                            const std::vector<ADC::PD_NodeUpdate::PD_NodeHVInfo> &m_nodeHVinfo);
    bool initFlag=true;
    PD::PD_Input _pd_input_last;
    // std::vector<ADCmsgs::RoadInfo> _pd_last_RoadModelVector;
    dpc::Index _pd_UpdateCorridor_index;
    float _EV_end_s=0.0;
    float _EV_end_l=0.0;
    float _EV_delta_l=0.0;
    float _EV_end_vs=0.0;
    float _EV_end_vl=0.0;
    uint8_t _EV_end_laneID=0;

public:
    void process();
    RoadInfo pd_RoadModel_output;      //output
    bool pd_RoadModelOutput_invalid = false;    //output
};



}   //namespace PD_RoadModelVector_PDtoBA
}   //namespace ADC


#endif  //__PD_ROADMODELVECTOR_PDTOBA_H__
