/**
 * @file
 * @brief  add 20211123
 */

#ifndef __PD_ROADMODEL_CARPOSITION_PDTOBA_H__
#define __PD_ROADMODEL_CARPOSITION_PDTOBA_H__

#include "PD_Input.h"
#include "../../source/PD_commonfunc.h"
#include "PD_LatTrajectory.h"

#define FlagCalculateCarPos 0

namespace ADC
{
namespace PD_RoadModel_CarPosition_PDtoBA
{

class RoadModel_CarPosition_PDtoBA
{
public:
    RoadModel_CarPosition_PDtoBA(const PD::PD_Input &m_pd_input, float m_EV_end_s, float m_EV_end_l, uint8_t m_EV_end_laneID);
    ~RoadModel_CarPosition_PDtoBA()=default;

private:
    bool init(const PD::PD_Input &m_pd_input, float m_EV_end_s, float m_EV_end_l, uint8_t m_EV_end_laneID);
    bool initFlag=true;
    RoadInfo _m_last_RoadInfo;
    float _EV_EndPositionToReferenceLine_s = 0.0;
    float _EV_EndPositionToReferenceLine_l = 0.0;
    uint8_t _EV_end_laneID = 0;


private:
    void calcu_CarPosition_based_DurationTime();
    float _leftLine_LastPositionToEV_l = 0.0;
    float _rightLine_LastPositionToEV_l = 0.0;
    float _EV_LastPositionToReferenceLine_l = 0.0;
    float _leftLine_EndPositionToEV_l = 0.0;       // Lateral distance
    float _rightLine_EndPositionToEV_l = 0.0;      // Lateral distance
    float _LaneWidth_egoVehicle = 0.0;

public:
    void process();                                         // working
    CarPosition PD_RoadModel_CarPosition_output;   // output
};

}   //namespace PD_RoadModel_CarPosition_PDtoBA
}   //namespace ADC

#endif  //__PD_ROADMODEL_CARPOSITION_PDTOBA_H__

