/**
 * @file
 * @brief  add 20211129
 */

#ifndef __PD_ROADMODEL_OBJECTLIST_PDTOBA_H__
#define __PD_ROADMODEL_OBJECTLIST_PDTOBA_H__

#include "PD_Input.h"
#include "PD_RoadModel_LaneList_PDtoBA.h"
#include "PD_LatTrajectory.h"
#include "../../source/PD_commonfunc.h"

namespace ADC
{
namespace PD_RoadModel_ObjectList_PDtoBA
{

typedef ADC::PD_RoadModel_LaneList_PDtoBA::Position_Frenet Position_Frenet;
// {
//     float s_Frenet = 0.0;
//     float l_Frenet = 0.0;
// };
typedef ADC::PD_RoadModel_LaneList_PDtoBA::Position_Cartesian Position_Cartesian;
// {
//     float x_Cartesian = 0.0;
//     float y_Cartesian = 0.0;
// };


class RoadModel_ObjectList_PDtoBA:public ADC::PD_RoadModel_LaneList_PDtoBA::RoadModel_base
{
public:
    RoadModel_ObjectList_PDtoBA(const PD::PD_Input &m_pd_input, float m_EV_end_s, float m_EV_end_l, float m_EV_end_vs, float m_EV_end_vl);
    ~RoadModel_ObjectList_PDtoBA()=default;

private:
    // bool init(const PD::PD_Input &pd_input, float m_EV_end_s, float m_EV_end_l, float *m_LatTrj_Lt_coeff,
    //                                 const std::vector<float> &m_LgtTrajCoeffnt);
    // bool initFlag=true;


private:
    void calcu_ObjectList_based_DurationTime();


public:
    void process();
    std::vector<Object> pd_RoadModel_ObjectList_output;    //output
};


}   //namespace PD_RoadModel_ObjectList_PDtoBA
}   //namespace ADC

#endif  //__PD_ROADMODEL_OBJECTLIST_PDTOBA_H__

