/**
 * @file
 * @brief  add 2021-11-29
 *        usage: include the head file in prediction.h;
 *               in prediction.cpp function process():  
 */

#include "PD_RoadModel_RoadEdge_PDtoBA.h"
using namespace ADC::PD_RoadModel_RoadEdge_PDtoBA;

/**
 * @brief
 * @param
 */
RoadModel_RoadEdge_PDtoBA::RoadModel_RoadEdge_PDtoBA(const PD::PD_Input &m_pd_input, float m_EV_end_s, float m_EV_end_l, float m_EV_end_vs, float m_EV_end_vl):
                        ADC::PD_RoadModel_LaneList_PDtoBA::RoadModel_base(m_pd_input,m_EV_end_s,m_EV_end_l,m_EV_end_vs,m_EV_end_vl){
    if(init(m_pd_input,m_EV_end_s,m_EV_end_l,m_EV_end_vs,m_EV_end_vl) == false)
    return;
}


/**
 * @brief
 * @param
 */
void RoadModel_RoadEdge_PDtoBA::calcu_RoadEdge_based_DurationTime(){

    pd_RoadModel_RoadEdge_output.clear();
    pd_RoadModel_RoadEdge_output.reserve(8);
    calcu_referenceLineList_Cartesian();
    calcu_transforFactor_BaseOnEVMove();

    for(auto& element : _m_last_RoadInfo.road_edge_list){

        // continue use input information
        RoadEdge m_next_RoadEdge = element;

        // only update geometry information
        for(decltype(m_next_RoadEdge.road_edge_segment_list.size()) i_edge = 0; i_edge < m_next_RoadEdge.road_edge_segment_list.size(); i_edge++){
            float edge_start_range_y =  m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.c0 + 
                                        m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.c1 * m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.start_range +
                                        m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.c2 * m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.start_range * 
                                        m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.start_range +
                                        m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.c3 * m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.start_range * 
                                        m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.start_range * m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.start_range;
            float edge_end_range_y =    m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.c0 + 
                                        m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.c1 * m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.end_range +
                                        m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.c2 * m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.end_range * 
                                        m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.end_range +
                                        m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.c3 * m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.end_range * 
                                        m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.end_range * m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.end_range;
            float x_range = m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.end_range - m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.start_range;
            if(fabs(x_range)<0.005)         {x_range = std::max(x_range,0.01f);}
            Position_Cartesian selectNewPointFit;
            std::vector<Position_Cartesian> selectNewPointFitList;
            selectNewPointFitList.reserve(sizeof(const_interpolation)/sizeof(float));
            for(decltype(sizeof(const_interpolation)/sizeof(float)) i=0;i<sizeof(const_interpolation)/sizeof(float);i++){
                float last_x =  m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.start_range + const_interpolation[i] * x_range;
                float last_y =  m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.c0 + 
                                m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.c1 * last_x +
                                m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.c2 * last_x * last_x +
                                m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.c3 * last_x * last_x * last_x;
                selectNewPointFit = calcu_EndCartesianPoint_BaseOnEVMove(last_x,last_y);
                selectNewPointFitList.emplace_back(selectNewPointFit);
            }
            std::unique_ptr<float[]> newReferenceLineCoeff(new float[4]);
            int num_fit=0;
            while(PolynomialFitting(selectNewPointFitList,3,newReferenceLineCoeff)>const_fittingErrorThreshold){
                num_fit++;
                if(num_fit>3){
                    newReferenceLineCoeff[1]=(fabs(selectNewPointFitList.back().x_Cartesian-selectNewPointFitList.front().x_Cartesian)<0.001) ? 0.0 : \
                                                (selectNewPointFitList.back().y_Cartesian-selectNewPointFitList.front().y_Cartesian) / \
                                                (selectNewPointFitList.back().x_Cartesian-selectNewPointFitList.front().x_Cartesian);
                    newReferenceLineCoeff[0]=selectNewPointFitList.front().y_Cartesian - \
                                                newReferenceLineCoeff[1] * selectNewPointFitList.front().x_Cartesian;
                    newReferenceLineCoeff[2]=0.0;
                    newReferenceLineCoeff[3]=0.0;
                    break;
                }
            }
            m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.c0 = newReferenceLineCoeff[0];
            m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.c1 = newReferenceLineCoeff[1];
            m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.c2 = newReferenceLineCoeff[2];
            m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.c3 = newReferenceLineCoeff[3];
            m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.start_range = calcu_EndCartesianPoint_BaseOnEVMove(m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.start_range,edge_start_range_y).x_Cartesian;
            m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.end_range = calcu_EndCartesianPoint_BaseOnEVMove(m_next_RoadEdge.road_edge_segment_list.at(i_edge).line_geometry.end_range,edge_end_range_y).x_Cartesian;
        }

        pd_RoadModel_RoadEdge_output.emplace_back(m_next_RoadEdge);
    }

    std::vector<RoadEdge>(pd_RoadModel_RoadEdge_output).swap(pd_RoadModel_RoadEdge_output); //capacity()

}


/**
 * @brief
 * @param
 */
void RoadModel_RoadEdge_PDtoBA::process(){

    if(initFlag != 1){
        // std::cout<< "ATTENTION: Data reading of RoadMode_RoadEdge_PDtoBA error" <<std::endl;
        return;
    }

    calcu_RoadEdge_based_DurationTime();
}
