/**
 * @file
 * @brief  add 2021-11-11
 *        instruction manual: include the head file in prediction.h;
 *               in prediction.cpp function process():  
 */

#include "PD_UpdateCorridor.h"
using namespace ADC::PD_Corridor;
#if FLAG_PD_ROADID_SAVECSV != 0
extern std::string timeStampBag;
int roadmodel_size=0;
int passage_size=0;
#endif

/**
 * @brief
 * @param
 */
UpdateCorridor::UpdateCorridor(const PD::PD_Input &m_pd_input){
    if(init(m_pd_input)==false)
    return;
}


/**
 * @brief 
 * @param
 * @return
 */
bool UpdateCorridor::init(const PD::PD_Input &m_pd_input){
    bool Flag=true;
    Flag = Flag && (static_cast<decltype(m_pd_input.rm_roadmodel.size())>(rm_Num)<m_pd_input.rm_roadmodel.size());                                 //chech rm_roadmodel
    if(Flag){
        Flag = Flag && (static_cast<decltype(m_pd_input.rm_roadmodel.at(rm_Num).passage_list.size())>(psg_Num)<m_pd_input.rm_roadmodel.at(rm_Num).passage_list.size());    //chech passage_list
    }
    /*Flag = Flag && !(m_pd_input.rm_roadmodel.empty());                //chech rm_roadmodel
    for(auto& element : m_pd_input.rm_roadmodel){
        Flag = Flag && !(element.passage_list.empty());             //check passage_list
    }*/

    if(Flag==false){
        initFlag=false;
    }
    else{

        initFlag=true;

        #if FLAG_PD_ROADID_SAVECSV != 0
        roadmodel_size=m_pd_input.rm_roadmodel.size();
        passage_size=m_pd_input.rm_roadmodel.at(rm_Num).passage_list.size();
        #endif


        //input
        _pd_UpdateCorridor_Last_RoadModelID.x = m_pd_input.rm_roadmodel.at(rm_Num).road_id.x;
        _pd_UpdateCorridor_Last_RoadModelID.y = m_pd_input.rm_roadmodel.at(rm_Num).road_id.y;
        _pd_UpdateCorridor_Last_PassageID.x   = m_pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).passage_id.x;
        _pd_UpdateCorridor_Last_PassageID.y   = m_pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).passage_id.y;
        _pd_UpdateCorridor_Last_CorridorID    = m_pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).corridor_id;
        _BA_duration_time_input               = m_pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).duration_time;
        _egoVehicle_vs                        = m_pd_input.VSE_LgtVehSpd;
        if(m_pd_input.rm_roadmodel.at(rm_Num).road_id.x != static_cast<uint8_t>(0)){
            Index_map temp_index(m_pd_input.rm_roadmodel.at(rm_Num).road_id);
            _egoVehicle_vs = PD_LatTrj_LastSts_LastCycle_list[temp_index].vx;
        }
    }
    return initFlag;
}


/**
 * @brief
 * @param
 */
void UpdateCorridor::calcu_Next_Node(){
    pd_UpdateCorridor_Next_NodeID.x   = _pd_UpdateCorridor_Last_PassageID.x;
    pd_UpdateCorridor_Next_NodeID.y   = _pd_UpdateCorridor_Last_PassageID.y;
    pd_UpdateCorridor_Parent_NodeID.x = _pd_UpdateCorridor_Last_RoadModelID.x;
    pd_UpdateCorridor_Parent_NodeID.y = _pd_UpdateCorridor_Last_RoadModelID.y;



}


/**
 * @brief
 * @param
 */
void UpdateCorridor::getLatCoefficient(float *pd_LatTrj_LS_Coeff, float pd_LatTrj_plnTime){
    for(int i=0;i<6;i++){
        _pd_LatTrj_LS_Coeff[i] = pd_LatTrj_LS_Coeff[i];
    }
    _pd_LatTrj_plnTime = pd_LatTrj_plnTime;
}


/**
 * @brief
 * @param
 */
void UpdateCorridor::calcu_Next_ReferenceLineCoefficient(){

    float l_s = 0.0;
    float dl_s = 0.0;
    float ddl_s = 0.0;

    float s_duration_time = 0.0;

    if(_BA_duration_time_input<=_pd_LatTrj_plnTime){
        s_duration_time = _egoVehicle_vs * _BA_duration_time_input;
        l_s =   _pd_LatTrj_LS_Coeff[0] + 
                _pd_LatTrj_LS_Coeff[1] * s_duration_time +
                _pd_LatTrj_LS_Coeff[2] * s_duration_time * s_duration_time +
                _pd_LatTrj_LS_Coeff[3] * s_duration_time * s_duration_time * s_duration_time +
                _pd_LatTrj_LS_Coeff[4] * s_duration_time * s_duration_time * s_duration_time * s_duration_time +
                _pd_LatTrj_LS_Coeff[5] * s_duration_time * s_duration_time * s_duration_time * s_duration_time * s_duration_time;
        //first derivative
        dl_s =  _pd_LatTrj_LS_Coeff[1] + 
                _pd_LatTrj_LS_Coeff[2] * s_duration_time * 2.0 + 
                _pd_LatTrj_LS_Coeff[3] * s_duration_time * s_duration_time * 3.0 + 
                _pd_LatTrj_LS_Coeff[4] * s_duration_time * s_duration_time * s_duration_time * 4.0 + 
                _pd_LatTrj_LS_Coeff[5] * s_duration_time * s_duration_time * s_duration_time * s_duration_time * 5.0; 
        //second derivative
        ddl_s = _pd_LatTrj_LS_Coeff[2] * 2.0 + 
                _pd_LatTrj_LS_Coeff[3] * s_duration_time * 6.0 + 
                _pd_LatTrj_LS_Coeff[4] * s_duration_time * s_duration_time * 12.0 + 
                _pd_LatTrj_LS_Coeff[5] * s_duration_time * s_duration_time * s_duration_time * 20.0;
    }
    else{
        s_duration_time = _egoVehicle_vs * _pd_LatTrj_plnTime;
        l_s =   _pd_LatTrj_LS_Coeff[0] + 
                _pd_LatTrj_LS_Coeff[1] * s_duration_time +
                _pd_LatTrj_LS_Coeff[2] * s_duration_time * s_duration_time +
                _pd_LatTrj_LS_Coeff[3] * s_duration_time * s_duration_time * s_duration_time +
                _pd_LatTrj_LS_Coeff[4] * s_duration_time * s_duration_time * s_duration_time * s_duration_time +
                _pd_LatTrj_LS_Coeff[5] * s_duration_time * s_duration_time * s_duration_time * s_duration_time * s_duration_time;
        dl_s  = 0.0;
        ddl_s = 0.0;
    }

    pd_UpdateCorridor_Next_ReferenceLineCoefficient[0] =  -1.0*l_s;                                 //offset
    pd_UpdateCorridor_Next_ReferenceLineCoefficient[1] =  -1.0*dl_s;                                //heading
    pd_UpdateCorridor_Next_ReferenceLineCoefficient[2] =  -1.0*ddl_s/(pow((1.0+dl_s*dl_s),1.5));    //curvature

}



/**
 * @brief
 * @param
 */
void UpdateCorridor::process(){
    if(initFlag != true){
        // std::cout<< "ATTENTION: Data reading of PD_UpdateCorridor error" <<std::endl;
        return;
    }

    calcu_Next_Node();
    calcu_Next_ReferenceLineCoefficient();

    #if FLAG_PD_ROADID_SAVECSV != 0
    std::ofstream outfile_PDcorr;
    outfile_PDcorr.open("./pd_roadid_file.csv", std::ios::app);
    outfile_PDcorr << "timestamp," << timeStampBag << \
                    ",roadmodel_size," << roadmodel_size << \
                    ",passage_size," << passage_size << \
                    ",last_roadID_x," << int(_pd_UpdateCorridor_Last_RoadModelID.x) << \
                    ",last_roadID_y," << int(_pd_UpdateCorridor_Last_RoadModelID.y) << \
                    ",last_passageID_x," << int(_pd_UpdateCorridor_Last_PassageID.x) << \
                    ",last_passageID_y," <<int( _pd_UpdateCorridor_Last_PassageID.y) << \
                    ",next_roadID_x," << int(pd_UpdateCorridor_Next_NodeID.x) << \
                    ",next_roadID_y," << int(pd_UpdateCorridor_Next_NodeID.y) << \
                    ",next_parentID_x," << int(pd_UpdateCorridor_Parent_NodeID.x) << \
                    ",next_parentID_y," <<int( pd_UpdateCorridor_Parent_NodeID.y);




    // outfile_PDcorr<<std::endl;
    outfile_PDcorr.close();




    #endif




}
