/**
 * @file
 * @brief  add 20211110
 */
#ifndef __PD_UPDATECORRIDOR_H__
#define __PD_UPDATECORRIDOR_H__

#include "PD_Input.h"
#include "../../source/PD_commonfunc.h"
#include "PD_LatTrajectory.h"



extern std::map<Index_map, ADC::PD_LatTrj::PD_LatTrj_EgoVeh_Lat_Sts> PD_LatTrj_LastSts_LastCycle_list;

namespace ADC
{
namespace PD_Corridor
{

class UpdateCorridor
{
public:
    UpdateCorridor(const PD::PD_Input &m_pd_input);
    ~UpdateCorridor()=default;

private:
    bool init(const PD::PD_Input &m_pd_input);
    bool initFlag=true;

private:
    void calcu_Next_Node();
    dpc::Index _pd_UpdateCorridor_Last_RoadModelID;
    dpc::Index _pd_UpdateCorridor_Last_PassageID;
    uint32_t _pd_UpdateCorridor_Last_CorridorID=0;
public:
    dpc::Index pd_UpdateCorridor_Next_RoadModelID;                 // 
    dpc::Index pd_UpdateCorridor_Next_NodeID;                      // output
    dpc::Index pd_UpdateCorridor_Parent_NodeID;                    // output
    std::vector<dpc::Index> pd_UpdateCorridor_Next_PassageID;      // 
    std::vector<uint8_t> pd_UpdateCorridor_Next_CorridorID;            // 

private:
    void calcu_Next_ReferenceLineCoefficient();
    float _BA_duration_time_input=0.0;
    float _egoVehicle_vs=0.0;
    float _pd_LatTrj_LS_Coeff[6]={0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
    float _pd_LatTrj_plnTime=0.0;
public:
    float pd_UpdateCorridor_Next_ReferenceLineCoefficient[3]={0.0, 0.0, 0.0}; // output

public:
    void process();
    void getLatCoefficient(float *pd_LatTrj_LS_Coeff, float pd_LatTrj_plnTime);


};



}   //namespace PD_Corridor
}   //namespace ADC
#endif  //__PD_UPDATECORRIDOR_H__
