#pragma once
#include "../include/CtApPrediction/PD_Input.h"
#include "../include/CtApPrediction/PD_DynamicObjRisk.h"
#include "../include/CtApPrediction/PD_EgoVehStsArb.h"
#include "../include/CtApPrediction/PD_LgtSpdLmt.h"
#include "../include/CtApPrediction/PD_NodeUpdate.h"
#include "../include/CtApPrediction/PD_ObjAttention.h"
#include "../include/CtApPrediction/PD_LgtTrajectory.h"
#include <vector>
#include "PD_commonfunc.h"
// #include "mpc_drv_msgs/msg/pd_debug.hpp"
#include "../../../../include/CtApBehaviorAnalysis_/interface/pd_interface.h"

namespace ADC
{
    namespace PD_DebugProc
    {

        // struct InterestObj
        // {
        //     uint32_t objid = 0;
        //     float LonX = 0.0f;
        //     float LatY = 0.0f;
        //     float LonVx = 0.0f;
        //     float Lon_ttc = 0.0f;
        //     float Lon_td = 0.0f;

        // };

        class PD_AnalysisData
        {
        public:
            PD_AnalysisData(const PD::PD_Input &pd_input,
                            const PD_DynmcObjRsk::DynamicObjRisk &dynmcobjrsk,
                            const PD_EgoVehTrj::EgoVehTrj &egovehtrj,
                            const PD_LgtSpdLmt::LgtSpdLmt &lgtspdlmt,
                            const PD_NodeUpdate::NodeUpdate &nodeinfo,
                            const PD_ObjAttention::RiskObjAttention &attobjinfo,
                            const PD_LgtTrj::LgtTrajectory &lgttrjinfo);

            PD::PDDebug pddebuginfo;

        private:
            std::vector<PD::PDClsnInfo> pdclsninfo;
            std::vector<PD::PDAsmtVar> pdasmtinfo;
            PD::PDObsVar pdobsvar;
            PD::PDClsnInfo out_clsninfo;

            // void ClsnObjInfoProc(const PD::PD_Input &pd_input);

            // void GetClsnObjDynamicInfo(const PD_DynmcObjRsk::DynamicObjRisk &dynmcobjrsk);
            // InterestObj clsnobj;
            // std::vector<InterestObj> Intstclsnobjinfo;
        };
    } // namespace PD_DebugProc
} // namespace ADC