#include "PD_SubFunc.h"

using namespace ADC::PD_SubFunc;
// using namespace boost;

PD_FuncRun::PD_FuncRun(const predict::Prediction &prediction)
{
    // prediction.process
    if (init(prediction.res) == false)
        return;
}

bool PD_FuncRun::init(const PD::PDMdOut &res)
{
    bool Flag = true;
    Flag = Flag && !(res.pd_behavior_nodelocal_vector.empty()); // check PD_BehaviorNodeLocalVector
    for (auto &ele : res.pd_roadrodel_vector)
    {
        Flag = Flag && !(ele.lane_list.empty());    // check lane_list
        Flag = Flag && !(ele.passage_list.empty()); // check passage_list
    }

    if (Flag == false)
    {
        initFlag = false;
    }
    else
    {
        std::cout << "PD_FuncRun Running!" << std::endl;
    }

    return initFlag;
}

void PD_FuncRun::PD_FuncCall(PD::PDInputBa &REQ,
                             const PD::PDVSE &vseinfo,
                             bool &last_cyc_spdlmt_flg,
                             uint8_t &last_cyc_spdlmt_id,
                             uint8_t &last_cyc_spdlmt_type)
                            
{
    _prediction.UpdateVSEBaseInfo(vseinfo);

    // _prediction.lastcyc_spdlmtinfo.LastCyc_SpdLmtDist = last_cyc_spdlmtdist;
    // _prediction.lastcyc_spdlmtinfo.LastCyc_SpdLmtFlg = last_cyc_spdlmtflg;
    // _prediction.lastcyc_spdlmtinfo.LastCyc_SpdLmtVal = last_cyc_spdlmtval;
    _prediction.UpdateSpdLmtInfo(last_cyc_spdlmt_flg, last_cyc_spdlmt_type,last_cyc_spdlmt_id);
    
    _prediction.PDCallback(REQ);
    

    // std::cout << "PDCallback finished" << std::endl;
}
