#pragma once
/************ros 相关头文件*******/
// #include "ros/ros.h"
// #include "std_msgs/Float64MultiArray.h"
// #include <nav_msgs/Path.h> //示例：rviz的path显示头文件
// #include <ros/callback_queue.h>

/************使用的库*******/
#include <sstream>
#include <iostream>
#include <chrono>
#include <vector>
// #include <Eigen/Core>
// #include <Eigen/LU>
// #include <boost/thread/thread.hpp>

/************自定义的头文件*******/
// #include <can_recorder/Can.h>         //示例：CEM_MSG_INPUT
// #include <LatCtrl32/control_Input.h>  //示例：
// #include <LatCtrl32/control_Output.h> //示例：
// #include <mpc_drv_msgs/msg/road_info.hpp>
// #include <CtApPredictionDemo/RoadInfo.h>

extern int rm_Num;
extern int psg_Num;
extern int lm_Num;

namespace ADC
{
    namespace common
    {
        using namespace std;

        // #define TIMERSTART(tag) auto tag##_start = std::chrono::steady_clock::now(), tag##_end = tag##_start
        // #define TIMEREND(tag) tag##_end = std::chrono::steady_clock::now()

        // #define DURATION_s(tag) std::chrono::duration_cast<std::chrono::seconds>(tag##_end - tag##_start).count()
        // #define DURATION_ms(tag) std::chrono::duration_cast<std::chrono::milliseconds>(tag##_end - tag##_start).count()
        // #define DURATION_us(tag) std::chrono::duration_cast<std::chrono::nanoseconds>(tag##_end - tag##_start).count()
        // #define DURATION_ns(tag) std::chrono::duration_cast<std::chrono::nanoseconds>(tag##_end - tag##_start).count()

#define PLANNERCYCLE 100 //示例：周期，单位：毫秒
#define CONTROLCYCLE 20  //示例：周期，单位：毫秒
#define MAXSAMPLETIME 10 //纵向规划最大采样时间
#define SampleStartTM 4  // longitudinal trajectory sample start time

        // typedef boost::shared_lock<boost::shared_mutex> read_lock;
        // typedef boost::unique_lock<boost::shared_mutex> write_lock;

    } // namespace common

    // const float Kt = 0.5; // sample time weight coefficient 0.5 better
    // const float Kj = 0.08;  // 0.1 better

    const float Kt = 0.06; // sample time weight coefficient 0.5 better
    const float Kj = 0.04;        // 0.1 better

    // const float ReplanTimeSize = 0.3;

    extern float PD_NodeLgtClsnRltvDist; // unit:m
    extern float PD_Nodelat2reflindist;  // lateral threshold of longitudinal collision,unit:m

   
                                 //  lgtspdlmt para
    const float Kt_spdlmt = 2;
    const float Kj_spdlmt = 0.08;
    const float Ka_spdlmt = 10;
    const float LgtSpdLmtThrsVal = 1.39f; // longitudinal speed limit low threshold value:5km/h
    const float LgtSpdLmtDistVal = 0.0f;

    extern float PD_lgttrj_inacclmt; // longitudinal acceleration limit threshold value(speed up case)
    extern float PD_lgttrj_deacclmt; // longitudinal acceleration limit threshold value(slow down case)
    extern float PD_lgttrj_inaccthrs;
    extern float PD_lgttrj_deaccthrs;

    // Node para
    extern float PD_NodeCrslineValC0; // 
    extern float PD_VehBckLaneC0LmtVal; // pull vehicle back during lane change status c0 value
    extern float PD_RdEndClsnTimeVal;  // time distance threshold in road end collision  
    extern float PD_LgtAccThrsVal; // longitudianl acceleration threshold value
    extern int PD_LgtCrsLneIndx; // longitudinal cross line index
    extern int PD_ChkClsn_timesize; // ego vehicle trajectory point size limit

    // Cost para
    extern float PD_CostCrossLine;          // 1.85---2.95(+1.1/1.2)
    extern float PD_CostLatThrDltaVminSame1; // 1.4---1.6-  // The cost lateral threshold related to the min relative velocity(5.56) before cross line
    extern float PD_CostLatThrDltaVmaxSame1; // 1.4---1.6
    extern float PD_CostLatThrDltaVminSame2; // 1.3---1.4 // The cost lateral threshold related to the min relative velocity  after cross line
    extern float PD_CostLatThrDltaVmaxSame2; // 1.3---1.4
    extern float PD_CostLatThrDltaVminLCP; //the different side objects lateral threshold value during LCP
    extern float PD_CostLatThrDltaVmaxLCP;
    extern float PD_CostLatThrDltaVminOther; // the different side objects lateral threshold value during LC
    extern float PD_CostLatThrDltaVmaxOther; 

    // no use
    extern float PD_CostDltaVmin;
    extern float PD_CostDltaVmax;
    extern float PD_CostLatThrRelVmin;
    extern float PD_CostLatThrRelVmax;

    extern float PD_CostInterstObjLatDis; 
    extern float PD_CostEgoBackLatOffSetL; //left/right neighbor lane object lgt calculation lat threshold value
    extern float PD_CostEgoBackLatOffSetR; // 1.85---1.95
    extern float PD_CostEgoBackLatOffSetLF;
    extern float PD_CostLatOffSetObjInLaneLL;
    extern float PD_CostLatOffSetObjInLaneRR; // right right neighbor lane object lgt calculation lat threshold value
    extern float PD_CostLatAbsDisOther; // left left/right right neighbor lane object behavior lateral threshold value
    extern int PD_CostSizeObjInEgoLaneList; // ego lane object size
    extern int PD_CostSizeObjInEgoLaneListL; // left neighbor lane object size
    extern int PD_CostSizeObjInEgoLaneListLL; // left left neighbor lane object size
    extern int PD_CostSizeObjOtherLaneList;
    extern int PD_CostSizeObjLCP; // LCP behavior size
    extern std::vector<float> PD_CostRelativeVelocity;     // Add 0818
    extern std::vector<float> PD_CostGainTrgtFrtDist; // 1, 1/0.9, 1/0.8, 1/0.78 // for target lane front object gain para with speed 
    extern std::vector<float> PD_CostGainTrgtFrtTD;   // 1, 1/0.9, 1/0.8, 1/0.78
    // const std::vector<float> PD_CostRelativeVelocityEgoBck = {3.0, 2.0, 0, -2.0, -3.0};       // Add 0818
    // const std::vector<float> PD_CostGainEgoBckTD = {1.0, 1.25, 1.33, 1.43, 1.54};     // 1, 1/0.8, 1/0.75, 1/0.7, 1/0.65
    extern float PD_CostBckDist2R; // opposite side rear object lgt distance
    extern float PD_CostFrtDist2R; // opposite side front object lgt distance
    extern float PD_CostNearLatOffSet2R; // opposite side object lgt distance from -6 to 8
    extern float PD_CostBckDist3L;
    extern float PD_CostFrtDist3L;
    extern float PD_CostNearLatOffSet3L;
    const float PD_CostEgoBckFrtLatVl3LL = -0.4;
    const float PD_CostBckDist3LL = -6;
    const float PD_CostFrtDist3LL = 8;
    const float PD_CostEgoBckFrtLatVl2RR = 0.4;
    const float PD_CostBckDist2RR = -6;
    const float PD_CostFrtDist2RR = 8;

#define VELOCITYMAX 41.67
#define TTCTDTHRESHOLDMAXPLUS 25
#define TTCTDTHRESHOLDMAXNGT -25
#define PDCOSTDEFAULTMAXPLUS 999.0f
#define PDCOSTDEFAULTMAXNGT -999.0f
#define PDCOSTDEFAULTMINPLUS 0.1f
#define PDCOSTDEFAULTMINNGT -0.1f
#define PDCOSTCALCULATEMINPLUS 0.01f
#define PDCOSTCALCULATEMINNGT -0.01f

#define SAMPLEPNTNUM 10          // spd limit lgttrajectory sample number
#define SignSpdLimt_minacc -0.5f // vehicel min acceleration during speed limit scenario,unit:m/s2
#define SignSpdLmt_maxacc -2.0f  // vehicel max acceleration during speed limit scenario,unit:m/s2
#define HOLDVAL 0.001

#define EgoVheSizeWidth 1.925 // Vehicle width 1925 mm
#define SVInitalFrnt_L 2.6    // surrounding vehicle initial frenet L threshold value

} // namespace ADC
