
#include "prediction.h"
#include "glog/logging.h"

int rm_Num = 0;
int psg_Num = 0;
namespace ADC
{
    namespace predict
    {

        void Prediction::UpdateVSEBaseInfo(const PD::PDVSE &vseinfo)

        {

            this->PD_input.VSE_LgtVehSpd = vseinfo.m_vse_lgt_vehspd;

            this->PD_input.VSE_LatAcc = vseinfo.m_vse_lat_acc;

            this->PD_input.VSE_LgtAcc = vseinfo.m_vse_lgt_acc;

            this->PD_input.VSE_YawRate = vseinfo.m_vse_yawrate;

            this->PD_input.VSE_HeadingAng = vseinfo.m_vse_heading_ang;
        }

        void Prediction::getPDinput(PD::PDInputBa &req)
        {
            for (auto it = req.ba_roadmodel_vector.begin(); it != req.ba_roadmodel_vector.end();)
            {

                if (it->passage_list.empty())
                {
                    // RealPassageFlag = true;
                    req.ba_roadmodel_vector.erase(it);
                    continue;
                }
                it++;
            }

            this->PD_input.rm_roadmodel = req.ba_roadmodel_vector;

            // DLOG(INFO) << "InSpdLmtFlg: " << req.ba_roadmodel_vector.
            // for (int i = 0; i < req.ba_roadmodel_vector.size(); i++)
            // {
            //     DLOG(INFO) << "InSpdLmtFlg: " << req.ba_roadmodel_vector.at(i).m_lastnode_spdlimt_flag
            //                << "\tInSpdLmtDist: " << req.ba_roadmodel_vector.at(i).m_lastnode_spdlimt_dist
            //                << "\tInSpdLmtVal: " << req.ba_roadmodel_vector.at(i).m_lastnode_spdlimt_val << std::endl;

            //     DLOG(INFO) << std::endl;

            //     DLOG(INFO) << "InLon_S: " << req.ba_roadmodel_vector.at(i).m_lastnode_s << std::endl;
            // }
        }

        void Prediction::UpdateSpdLmtInfo(bool &last_cyc_spdlmtflg,
                                          uint8_t &last_cyc_spdlmttype,
                                          uint8_t &last_cyc_spdlmtid)
        {
            pd_lastcyc_spdlmtinfo.LastCyc_SpdLmtFlg = last_cyc_spdlmtflg;
            pd_lastcyc_spdlmtinfo.LastCyc_SpdLmtId = last_cyc_spdlmtid;
            pd_lastcyc_spdlmtinfo.LastCyc_SpdLmtType = last_cyc_spdlmttype;
        }

        void Prediction::CombinatClsn2Attention(const std::vector<PD_NodeUpdate::ClsnObjInfo> &clsnobjinfo,
                                                std::vector<PD::Attention> &attention,
                                                const PD::PD_Input &pd_input)
        {
            // find related obj id
            if (pd_input.rm_roadmodel.at(rm_Num).road_id.x == static_cast<uint8_t>(0) /*&&
                !clsnobjinfo.empty()*/)
            {
                PD::Attention temp_attention;
                for (int i = 0; i < clsnobjinfo.size(); i++)
                {
                    if (!attention.empty())
                    {
                        for (int j = 0; j < attention.size(); j++)
                        {
                            if (clsnobjinfo[i].ClsnObjID == attention[j].obj_id)
                            {
                                attention[j].obj_attention_flg = clsnobjinfo[i].ClsnFlag;
                                attention[j].obj_attention_grade = static_cast<uint8_t>(1);
                            }
                            else
                            {
                                // attention[attention.size()+1].obj_attention_flg = clsnobjinfo[i].ClsnFlag;
                                // attention[attention.size()+1].obj_id
                                temp_attention.obj_attention_flg = clsnobjinfo[i].ClsnFlag;
                                temp_attention.obj_attention_grade = static_cast<uint8_t>(1);
                                temp_attention.obj_id = clsnobjinfo[i].ClsnObjID;
                            }
                        }
                        attention.emplace_back(temp_attention);
                    }
                }

                // this->pd_objattention = attention;
                // pd_att.m_obj_attention = attention;
                this->pd_objattention.m_obj_attention = attention;

                // analysis data
                # ifdef GLOG
                // for (int i = 0; i < this->pd_objattention.m_obj_attention.size(); i++)
                // {
                //     DLOG(INFO) << "att_id: " << pd_objattention.m_obj_attention[i].obj_id
                //                << "\tatt_flg: " << pd_objattention.m_obj_attention[i].obj_attention_flg << std::endl;
                // }

                # endif
            }
        }

        void Prediction::WrapUpNodeVehInfo(RoadInfo &roadinfo,
                                           const PD_EgoVehTrj::EgoVehTrj &egovehtrj,
                                           const PD::BehaviorNodeLocal &behaviornodelocalinfo)

        {
            // std::cout << std::endl;
            // std::cout << "pd_egotpsize: "<< egovehtrj.egoveh_tp.size() << std::endl;
            if (!egovehtrj.egoveh_tp.empty() && (!behaviornodelocalinfo.m_hvinfo.empty()))
            {
                // roadinfo.m_lastnode_s = egovehtrj.egoveh_tp.back().s;

                // roadinfo.m_lastnode_s = behaviornodelocalinfo.at(rm_Num).m_HVInfo.back().m_DistanceAlongS;

                // roadinfo.m_lastnode_s = behaviornodelocalinfo.m_HVInfo.back().m_DistanceAlongS;
                roadinfo.m_lastnode_s = behaviornodelocalinfo.m_hvinfo.back().m_distance_alongs;
                roadinfo.m_lastnode_vx = egovehtrj.egoveh_tp.back().vx;
                roadinfo.m_lastnode_vy = egovehtrj.egoveh_tp.back().vy;
                roadinfo.m_lastnode_ax = egovehtrj.egoveh_tp.back().ax;
                roadinfo.m_lastnode_ay = 0;
                roadinfo.m_lastnode_jkx = egovehtrj.egoveh_tp.back().jkx;
                // roadinfo.m_lastnode_spdlimt_dist = behaviornodelocalinfo.desired_spd_limt_dist;
                // roadinfo.m_lastnode_spdlimt_flag = behaviornodelocalinfo.spd_limit_flg;
                // roadinfo.m_lastnode_spdlimt_val = behaviornodelocalinfo.desired_spd_limit_val;
            }
        }

        void Prediction::PDoutput(const std::vector<PD::BehaviorNodeLocal> &behaviornodelocalinfo,
                                  const std::vector<RoadInfo> &pd_roadmodelinfo)
        {

            res.pd_behavior_nodelocal_vector.clear();
            res.pd_roadrodel_vector.clear();

            res.pd_roadrodel_vector = pd_roadmodelinfo;
            res.pd_behavior_nodelocal_vector = behaviornodelocalinfo;
            if (!pd_roadmodelinfo.empty())

            {
                // DLOG(INFO) << "outSpdLmtFlg: " << pd_roadmodelinfo.at(rm_Num).m_lastnode_spdlimt_flag
                //            << "outSpdLmtDist: " << pd_roadmodelinfo.at(rm_Num).m_lastnode_spdlimt_dist
                //            << "\toutSpdLmtVal: " << pd_roadmodelinfo.at(rm_Num).m_lastnode_spdlimt_val << std::endl;

                // for (int i = 0; i < pd_roadmodelinfo.size(); i++)
                // {
                //     DLOG(INFO) << "1stSpdLmtFlg: " << pd_roadmodelinfo.at(i).m_lastnode_spdlimt_flag
                //                << "\t1stSpdLmtdist: " << pd_roadmodelinfo.at(i).m_lastnode_spdlimt_dist
                //                << "\t1stSpdLmtVal: " << pd_roadmodelinfo.at(i).m_lastnode_spdlimt_val << std::endl;
                //     DLOG(INFO) << std::endl;

                //     DLOG(INFO) << "1stLon_S: " << pd_roadmodelinfo.at(i).m_lastnode_s << std::endl;
                // }

                // DLOG(INFO) << std::endl;
                // DLOG(INFO) << "1stSpdLmtFlg: " << pd_roadmodelinfo.front().m_lastnode_spdlimt_flag
                //            << "\t1stSpdLmtdist: " << pd_roadmodelinfo.front().m_lastnode_spdlimt_dist
                //            << "\t1stSpdLmtVal: " << pd_roadmodelinfo.front().m_lastnode_spdlimt_val << std::endl;
            }
        }

        bool Prediction::PDCallback(PD::PDInputBa &req)

        {

            // get request Data from BA
            // PD::BehaviorNodeLocal res_behaviornodelocal();
            // ADC::PD_RoadModelVector_PDtoBA::RoadModelVector_PDtoBA res_roadmodelvector;

            if (req.ba_roadmodel_vector.empty())
            {
                // std::cout << "BUG: PD_Call.BA_RoadModelVector is empty" << std::endl;
                return false;
            }

            // mpc_drv_msgs::msg::PD_Call::Request

            getPDinput(req);
            // std::cout << "enter successfully" << std::endl;

            process();
            return true;
        }

        // void Prediction::process(mpc_drv_msgs::msg::PD_MdOut &res)
        void Prediction::process()
        // void Prediction::process(mpc_drv_msgs::msg::PD_Call::Response &res)
        {
            std::vector<RoadInfo> Roadmodel_totalOutput;
            std::vector<PD::BehaviorNodeLocal> BehaviorNodeLocal_totalOutput;

            
            for (rm_Num = 0; rm_Num < PD_input.rm_roadmodel.size(); rm_Num++)
            {

                for (psg_Num = 0; psg_Num < PD_input.rm_roadmodel.at(rm_Num).passage_list.size(); psg_Num++)
                {

                    ADC::PD_LgtTrj::LgtTrajectory _lgtTrajectory(PD_input); // lzc 2021-11-19

                    _lgtTrajectory.process(PD_input); // lzc 2021-11-19

                    ADC::PD_LatTrj::LatTrajectory _latTrajectory(PD_input); // zym mod 2021-11-10
                    _latTrajectory.process();                               // zym mod 2021-11-10


                    ADC::PD_Corridor::UpdateCorridor _updateCorridor(PD_input);                                                      // zym mod 2021-11-19
                    _updateCorridor.getLatCoefficient(_latTrajectory.pd_LatTrj_LS_coefficient_d, _latTrajectory.pd_LatTrj_time_pln); // zym mod 2021-11-19
                    _updateCorridor.process();

                    // ADC::PD_EgoVehTrj::EgoVehTrj _egovehtrj(_latTrajectory, _lgtTrajectory, PD_input); // lzc 2021-11-21

                    ADC::PD_LgtSpdLmt::LgtSpdLmt _lgtspdlmt(PD_input, pd_lastcyc_spdlmtinfo);
                    // _lgtspdlmt(pd_lastcyc_spdlmtinfo);
                    _lgtspdlmt.process(PD_input);

                    ADC::PD_EgoVehTrj::EgoVehTrj _egovehtrj;

                    _egovehtrj.EgoVehLgtTrjPntProc(_lgtspdlmt,
                                                   _lgtTrajectory);
                    _egovehtrj.EgoVehTrjArbProc(_lgtspdlmt,
                                                _lgtTrajectory,
                                                _latTrajectory,
                                                PD_input);

                    ADC::PD_SVEstmd::SVEstmd _svEstmd(PD_input);
                    _svEstmd.getLgtTrajectoryPoint(_egovehtrj.egoveh_tp);
                    _svEstmd.process();

                    // _egovehtrj.EgoVehTrjArbProc()
                    ADC::PD_DynmcObjRsk::DynamicObjRisk _DynamicObjRisk(PD_input,
                                                                        _egovehtrj.egoveh_tp,
                                                                        _svEstmd.SV_Trajectory_list);

                    _DynamicObjRisk.process();

                    // Calculate LegalPunishment
                    ADC::PD_LegalPnsh::LegalPunishment _legalPunishment(PD_input,
                                                                        _latTrajectory.pd_LatTrj_EV_ActionType,
                                                                        _egovehtrj.egoveh_tp);
                    _legalPunishment.process();

                    // Calculate StnObstcRisk
                    ADC::PD_StnObstcRsk::StnObstcRisk _stnObstcRisk(PD_input,
                                                                    _latTrajectory.pd_LatTrj_EV_ActionType,
                                                                    _egovehtrj.egoveh_tp);
                    _stnObstcRisk.process();

                    // CalculateComfort
                    ADC::PD_Comfort::Comfort _comfort(_latTrajectory.pd_LatTrj_Lt_coefficient_d,
                                                      _egovehtrj.egoveh_tp);
                    _comfort.process();

                    // CalculateTrffcEffcy
                    ADC::PD_TrffcEffcy::TrffcEffcy _trffcEffcy(_egovehtrj.egoveh_tp);
                    _trffcEffcy.process();

                    // // after the lgt prediction

                    _latTrajectory.saveLastPredictData(_egovehtrj.egoveh_tp.empty() ? 0.0 : _egovehtrj.egoveh_tp.back().vx,
                                                       _egovehtrj.egoveh_tp.empty() ? 0.0 : _egovehtrj.egoveh_tp.back().vy); // zym mod 2021-12-06
                    // BehaviorNodelocal Package

                    // _lgtTrajectory.saveLastHvInfo(_egovehtrj.egoveh_tp.empty() ? 0.0f : _egovehtrj.egoveh_tp.back().s,
                    //                               _egovehtrj.egoveh_tp.empty() ? 0.0f : _egovehtrj.egoveh_tp.back().vx,
                    //                               _egovehtrj.egoveh_tp.empty() ? 0.0f : _egovehtrj.egoveh_tp.back().ax);

                    ADC::PD_NodeUpdate::NodeUpdate _nodeupdate;

                    _nodeupdate.ResDurationHVInfo(_egovehtrj,
                                                  PD_input);

                    _nodeupdate.NodeClsnStsCalu(_svEstmd,
                                                PD_input,
                                                _egovehtrj);

                    ADC::PD_ObjAttention::RiskObjAttention _riskobjattention;
                    _riskobjattention.Process(_svEstmd, PD_input, _egovehtrj, _DynamicObjRisk);

                    CombinatClsn2Attention(_nodeupdate.clsnobjinfo, _riskobjattention.objattention, PD_input);

                    ADC::PD_DebugProc::PD_AnalysisData _pd_analysisdata(PD_input,
                                                                        _DynamicObjRisk,
                                                                        _egovehtrj,
                                                                        _lgtspdlmt,
                                                                        _nodeupdate,
                                                                        _riskobjattention,
                                                                        _lgtTrajectory);

                    PD_DebugInfo.emplace_back(_pd_analysisdata.pddebuginfo);

                    ADC::PD_RoadModelVector_PDtoBA::RoadModelVector_PDtoBA _roadModelVector_PDtoBA(PD_input,
                                                                                                   _updateCorridor.pd_UpdateCorridor_Next_NodeID,
                                                                                                   _egovehtrj.egoveh_tp,
                                                                                                   _nodeupdate.nodehvinfo);
                    _roadModelVector_PDtoBA.process();
                    ADC::PD_BehvNodeLocal::BehaviorNodeLocal _behaviornodelocal(_updateCorridor,
                                                                                _comfort,
                                                                                _DynamicObjRisk,
                                                                                _trffcEffcy,
                                                                                _legalPunishment,
                                                                                _stnObstcRisk,
                                                                                _nodeupdate.nodehvinfo,
                                                                                PD_input,
                                                                                _nodeupdate.NodeClsnFlag,
                                                                                _roadModelVector_PDtoBA.pd_RoadModelOutput_invalid,
                                                                                _lgtspdlmt);

                    WrapUpNodeVehInfo(_roadModelVector_PDtoBA.pd_RoadModel_output, _egovehtrj, _behaviornodelocal.behaviornodellocalvector);
                    // DLOG(INFO) << "lastnd_flg: " << pd_input.rm_roadmodel.at(rm_Num).m_lastnode_spdlimt_flag
                    //            << "\tlastnd_spdval: " << pd_input.rm_roadmodel.at(rm_Num).m_lastnode_spdlimt_val
                    //            << "\tlastnd_distval: " << pd_input.rm_roadmodel.at(rm_Num).m_lastnode_spdlimt_dist << std::endl;

                    Roadmodel_totalOutput.emplace_back(_roadModelVector_PDtoBA.pd_RoadModel_output);
                    // behaviornodelocal_totaloutput
                    BehaviorNodeLocal_totalOutput.emplace_back(_behaviornodelocal.behaviornodellocalvector);

                } // passage number;
            }     // roadmodel num

            PDoutput(BehaviorNodeLocal_totalOutput, Roadmodel_totalOutput);

        } // process

    }

} // namespace ADC
