#pragma once
#include "PD_commonfunc.h" //示例：使用的库及msg头文件
// #include "mpc_drv_msgs/msg/road_info.hpp"
// #include "mpc_drv_msgs/PD_Call.h"
// #include "mpc_drv_msgs/msg/vehicle_state_output.hpp"
// #include "PD_DataProcess.h"
#include "../include/CtApPrediction/PD_Input.h"
#include "../include/CtApPrediction/PD_EgoVehStsArb.h"
#include "../include/CtApPrediction/PD_LatTrajectory.h"  //zym mod 2021-11-10
#include "../include/CtApPrediction/PD_SVEstmd.h"        //zym mod 2021-11-11
#include "../include/CtApPrediction/PD_UpdateCorridor.h" //zym mod 2021-11-11

#include "../include/CtApPrediction/PD_DynamicObjRisk.h"  //wzy mod 2021-11-12
#include "../include/CtApPrediction/PD_LegalPunishment.h" //wzy mod 2021-11-15
#include "../include/CtApPrediction/PD_StnObstcRisk.h"    //wzy mod 2021-11-18
#include "../include/CtApPrediction/PD_Comfort.h"         //wzy mod 2021-11-19
#include "../include/CtApPrediction/PD_TrffcEffcy.h"      //wzy mod 2021-11-19
#include "../include/CtApPrediction/PD_RoadModelVector_PDtoBA.h"
#include "../include/CtApPrediction/PD_BehaviorNodeLocal.h"
#include "../include/CtApPrediction/PD_LgtTrajectory.h"
#include "../include/CtApPrediction/PD_NodeUpdate.h"
// #include "mpc_drv_msgs/msg/pd_md_out.hpp"
// #include "mpc_drv_msgs/msg/pd_input_ba.hpp"
// #include "mpc_drv_msgs/msg/pdvse.hpp"
#include <algorithm>
#include <vector>
#include "../include/CtApPrediction/PD_LgtSpdLmt.h"
#include "../include/CtApPrediction/PD_ObjAttention.h"
#include "PD_Debug_Process.h"
// #include "../../../include/CtApBehaviorAnalysis_/interface/rm_road_info.h"
#include "../../../include/CtApBehaviorAnalysis_/interface/dm_internal_interface.h"
#include "../../../include/CtApBehaviorAnalysis_/interface/pd_interface.h"
#include "../../../include/CtApBehaviorAnalysis_/interface/ved_dpc_interface.h"
#include "dpc/impl_type_roadinfo.h"

#define SHOWres_WRITE_FLAG 1 // 1:cout out

namespace ADC
{
    namespace predict
    {
        using namespace ADC::common;

        struct RMAddNodeInfo
        {

            PD::PDMdOut res;
            float LastCyc_s;
            float LastCyc_vx;
            float LastCyc_vy;
            float LastCyc_ax;
            // float LastCyc_ay;
            float LastCyc_jk;
        };

        // struct LastCyc_SpdLmtInfo
        // {
        //     uint8_t LastCyc_SpdLmtId = 0;
        //     uint8_t LastCyc_SpdLmtType= 0;
        //     bool LastCyc_SpdLmtFlg = 0;
        //     // uint8_t LastCyc_SpdLmtId = 0;

        // };

        class Prediction
        {
        public:
            Prediction() = default;

            bool PDCallback(PD::PDInputBa &req);

            void getPDinput(PD::PDInputBa &req);

            void PDoutput(const std::vector<PD::BehaviorNodeLocal> &behaviornodelocalinfo,
                          const std::vector<RoadInfo> &pd_roadmodelinfo);

            PD::PD_Input PD_input;
            PD::PDMdOut res;
            // LastCyc_SpdLmtInfo lastcyc_spdlmtinfo;
            ADC::PD_LgtSpdLmt::LastCyc_SpdLmtInfo pd_lastcyc_spdlmtinfo;

            PD::ObjAttention pd_objattention;
            
            std::vector<PD::PDDebug> PD_DebugInfo;

            

            

            std::vector<float> PD_LatTrj_LS;

            // private:
            void process(); // PD main function

            void UpdateVSEBaseInfo(const PD::PDVSE &vseinfo);

            void GetNodeRelatS(std::vector<PD::BehaviorNodeLocal> &vecnodehvinfo, const PD::PD_Input &pd_input);

            void WrapUpNodeVehInfo(RoadInfo &roadinfo,
                                   const PD_EgoVehTrj::EgoVehTrj &egovehtrj,
                                   const PD::BehaviorNodeLocal &behaviornodelocalinfo);

            void UpdateSpdLmtInfo(bool &last_cyc_spdlmtflg,
                                  uint8_t &last_cyc_spdlmttype,
                                  uint8_t &last_cyc_spdlmtid);

            void CombinatClsn2Attention(const std::vector<PD_NodeUpdate::ClsnObjInfo> &clsnobjinfo,
                                        std::vector<PD::Attention> &attention,
                                        const PD::PD_Input &pd_input);

            // private:
            //     PD::PD_MdOut Node_res;
        };

    } // namespace predict
} // namespace ADC
