#pragma once
#include "commonfunc.h"
#include "../include/CtApBehaviorAnalysis_/input_BA.h"
#include "../include/CtApBehaviorAnalysis_/behaviorNodeGlobal.h"
#include "../include/CtApBehaviorAnalysis_/request_BA.h"
#include "../include/CtApBehaviorAnalysis_/response_BA.h"
#include "../include/CtApBehaviorAnalysis_/local_view.h"
// #include "mpc_drv_msgs/msg/direction_indicator_duration.hpp"
// #include "mpc_drv_msgs/msg/msg_ba2_sm.hpp"
// #include "mpc_drv_msgs/msg/msg_ba2_trp_lat.hpp"
// #include "mpc_drv_msgs/msg/msg_ba2_trp_longt.hpp"
// #include "mpc_drv_msgs/msg/msg_ba2_obs.hpp"
// #include "mpc_drv_msgs/msg/pd_debug.hpp"
// #include "mpc_drv_msgs/msg/vehicle_state_output.hpp"
// #include "mpc_drv_msgs/msg/msg_sm2_ba.hpp"
#include "modules/corridor_generation.h"
#include "../include/CtApBehaviorAnalysis_/BA_Enum_List.h"
// #include "mpc_drv_msgs/msg/lateral_border.hpp"
#include "modules/BA_CurrentBehaviorJudgement.h"
#include "modules/BehaviorNodesAdd.h"
#include "modules/RoadModelUpdate.h"
#include "modules/BA_BaseInfoProcess.h"
#include "PD_module/source/PD_SubFunc.h"
#include "PD_module/source/prediction.h"
#include "modules/global_info_process.h"
#include "modules/global_cost_calculation.h"
// #include "rclcpp/rclcpp.hpp"
// #include "mpc_drv_msgs/msg/passageob.hpp"
#include "../include/CtApBehaviorAnalysis_/common_BA.h"
#include <algorithm>
#include <mutex>
#include "../include/CtApBehaviorAnalysis_/interface/dm_sm_interface.h"
#include "../include/CtApBehaviorAnalysis_/interface/dm_trplat_interface.h"
#include "../include/CtApBehaviorAnalysis_/interface/dm_trplon_interface.h"
#include "../include/CtApBehaviorAnalysis_/interface/rm_road_info.h"
#include "../include/CtApBehaviorAnalysis_/interface/sm_dm_interface.h"
#include "../include/CtApBehaviorAnalysis_/interface/dm_internal_interface.h"
#include "../include/CtApBehaviorAnalysis_/interface/pd_interface.h"
// #include "../include/CtApBehaviorAnalysis_/interface/slam_decision.h"
#include "../include/CtApBehaviorAnalysis_/interface/ved_dpc_interface.h"
#include "dpc/impl_type_decision4sm.h"
#include "dpc/impl_type_decision4lat.h"
#include "dpc/impl_type_decision4long.h"
#include "dpc/impl_type_roadinfo.h"
#include "dpc/impl_type_sm4decision.h"
#include "dpc/impl_type_controlwaypoints.h"
#include "dpc/impl_type_ved4dpc.h"
#include "wrappers/DM_GeneralWrapper.h"
#include "ara/log/logger.h"

namespace ADC
{
    namespace planning
    {
        using namespace ADC::common;

        class BehaviorAnalysis
        {
        public:
            BehaviorAnalysis() : BA_StepNum(-1)
            {
                BA_BehaviorNodeGlobalVector = std::unique_ptr<std::vector<BA::behaviorNodeGlobal>>(new std::vector<BA::behaviorNodeGlobal>());
                BA_RoadModelVector = std::unique_ptr<std::vector<RoadInfo>>(new std::vector<RoadInfo>());
                BA_TerminatedBehaviorNodesVector = std::unique_ptr<std::vector<BA::behaviorNodeGlobal>>(new std::vector<BA::behaviorNodeGlobal>());
                BA_FirstPassageList = std::unique_ptr<std::vector<Passage>>(new std::vector<Passage>());

            }
            // void Callback4RMInfo(const RoadInfo::SharedPtr rm_msg);
            // void Callback4VSEInfo(const VED4DPC::SharedPtr vse_msg);
            // void Callback4SMInfo(const MsgSM2BA::SharedPtr sm_msg);
            // void Callback4EHRInfo(const ControlWaypoints::SharedPtr ehr_msg);
            void BehaviorAnalyzerStartRun(LocalView &local_view);
            uint32_t CalcRollCounter();
            uint64_t GetFusionTimeStamp();
            uint8_t CalcCycleCounter2SM();
            // uint8_t CalcCycleCounter2SM_InclOthrNodes();

        public:
            // DM2SMInterface msg_BA2SM; // internal struct
            Decision4SM msg_BA2SM;
            // DM2TRPLATInterface msg_BA2TRPLat; // internal struct
            Decision4Lat msg_BA2TRPLat;
            // DM2TRPLONInterface msg_BA2TRPLongt; // internal struct
            Decision4Long msg_BA2TRPLongt;
            ObjectTrim objTrim;
            DM::MsgBA2Obs msg_BA2Obs;
            PD::PDDebug msg_BA2PDDebug;
            BA::GlobalInfoContainer globalInfo;
            BA::DircnIndReqSts BA_DircnIndReq;
            BA::DircnIndReqSts BA_DircnIndReq_Deb;
            BA::Input_BA input_BA;       // inputs to BA, used inside BA

            // input internal struct
            // VED4DPC vehicle_state_recv;
            // RoadInfo road_info;
            // // RMHeader rm_header;
            // // Index ;
            // CarPosition carPos;
            // Lane lane;
            // LaneMarker laneMarker;
            // Object object;
            // RoadEdge pubs_road_edge;
            // // NeighborLane ;
            // // Corridor ;
            // SamplingPoint pubs_sampling_point;
            // LineColor line_color;
            // LineType line_type;
            // // ObjectLocation ;
            // // SLPoint ;
            // LaneControl lane_control;
            // // LaneBoundary ;
            // LineGeometry line_geometry;
            // RoadEdgeSegment pubs_road_edge_seg;
            // // AdjacentExtendLaneStruct ;
            // // SMAStruct ;
            // // WPExtendLaneStruct ;
            // // RemindWayPointStruct ;
            // // ControlWayPointStruct ;
            // // TransitLaneStruct ;
            // ControlWaypoints ehr_recv;


        private:
            void testWrapper();
            void RunOnce(); // BA main pipeline

            void UpdateRMBaseInfo(const RoadInfo &rm_msg);             // update road model related members of input_BA
            void UpdateSMBaseInfo(const dpc::SM4Decision &sm_msg);          // update system management related members of input_BA
            void UpdateVSEBaseInfo(const dpc::VED4DPC &vse_msg);            // update vehicle estimation related members of input_BA
            void UpdateEHRBaseInfo(const ControlWaypoints &ehr_msg);   // update electronic horizon receiver related members of input_BA
            void UpdateBaseInfo();                                     // update last cycle behavior analysis output
            void UpdateRespInfo(PD::PDMdOut &PDMdOut);

            void ExpandBehaviorSequence(std::vector<BA::BA_ActionTyp> &latAvlblBhvr); // to be expanded to more functions
            void DetermineOptimalCorridor(bool BA_IsBehaviorAvlbl,
                                          uint32_t &BA_OptCorridorID,
                                          BA::BA_ActionTyp &BA_OptAction,
                                          uint32_t &BA_OptTargetObjID,
                                          BA::Index &BA_OptPassageID,
                                          uint8_t &BA_TrgtLaneStID,
                                          uint8_t &BA_TrgtLaneEndID);
            bool UpdateBehaviorNodeGlobalVector();                                     // delete old behaviorNodeGlobal
            bool GetRoadModelIDToPD(std::vector<dpc::Index> &roadModelID2PD); // output road model ID to be evaluated to PD
            bool FindTgtObj(const RoadInfo &roadModel,
                            const uint8_t &objID,
                            Object &tgtObj); // to find target object according to object ID
            bool WrapUpMsgOutput(const DM::LongitudinalCorridor &BA_LgtBlueCrrdr,
                                 const DM::LongitudinalCorridor &BA_LgtYllwBrdr,
                                 const DM::LongitudinalCorridor &BA_LgtRedBrdr,
                                 const DM::SpeedLimit &BA_LgtSpdLmt,
                                 const DM::LateralBlueCorridor &latBlueCrrdr,
                                 const DM::LateralBorder &latYllwBrdr,
                                 const DM::LateralBorder &latRedBrdr,
                                 const uint8_t &spdLmtActVal,
								 const float &spdLmtNxtDst,
                                 const BA::BA_ActionTyp &BA_Action4TRP,
                                 const uint32_t &BA_Corridor4TRP,
                                 GlobalInfoProcess &globalInfoProc);
            bool WrapUpMsgToSM(GlobalInfoProcess &globalInfoProc);
            bool WrapUpMsgToTRPLat(const DM::LateralBlueCorridor &latBlueCrrdr,
                                   const DM::LateralBorder &latYllwBrdr,
                                   const DM::LateralBorder &latRedBrdr,
                                   const BA::BA_ActionTyp &BA_Action4TRPLat,
                                   const uint32_t &BA_Corridor4TRPLat);
            bool WrapUpMsgToTRPLongt(const DM::LongitudinalCorridor &BA_LgtBlueCrrdr,
                                     const DM::LongitudinalCorridor &BA_LgtYllwBrdr,
                                     const DM::LongitudinalCorridor &BA_LgtRedBrdr,
                                     const DM::SpeedLimit &BA_LgtSpdLmt,
                                     const DM::LateralBlueCorridor &latBlueCrrdr,
                                     const uint8_t &spdLmtActVal,
								     const float &spdLmtNxtDst,
                                     const BA::BA_ActionTyp &BA_Action4TRPLgt,
                                     const uint32_t &BA_Corridor4TRPLgt);
            bool WrapUpMsgToSelf();
            void SwitchBhvrNodeGlobalVec(std::vector<DM::BehaviorNodeGlobal> &newBhvrNodeGlobalVec);
            void SwitchLatAvlblBhvrVec(std::vector<uint8_t> &newLatAvlblBhvrVec);

            bool JudgeBehaviorSeqTermination(); //
            bool JudgeAllGlobalNodeExp();       // determine whether all nodes in behaviorNodeGlobal have expired or not
            bool LabelOvertimeBehaviorNode();
            void JudgeBehaviorNodeTermination();
            void UpdateOrgLaneInfo(); // update original lane info, start lane id and end lane id, when necessary
            float GetTimeGapInfo(const uint8_t &slctDistLvl);
            bool GetTrgtObjInfo(uint32_t &objID, float &objRelDist, float &objVel, Corridor &objBlgCrrd, bool &lineFllwCrrdrFound); // get target object id, distance and velocity when no available behavior is received, the object is closest one in ego lane corridor
            bool JudgeNoLineNoCarCase();                                                                               // judge whether there is no lane lines and cars
            bool GetILCDrct(BA::ILCDirection &drctOfILC);                                                              // judge direction of ILC for sm
            bool UpdateGlobalCost(const bool &toUpdtGlbCost, GlobalInfoProcess &globalInfoProc, const bool &allwLCAntiDrctCond);      // update global costs
            static bool Sort_by_distX(const ObjectLocation &objLoc1, const ObjectLocation &objLoc2);  // sort tmpObjLocList by relative center_x
            bool GetFrtObjToSM(std::vector<ObjectTrim> &objLstTrim, const bool &trgtObjFound, const bool &lineFllwCrrdrFound, const uint32_t &trgtObjID);       // extract forward six objects info for SM
            bool LoadObjTrim(const uint32_t &objID, ObjectTrim &objTrim);                           // assign values to trimmed object by object id
            bool UpdateGlobalInfo(const bool &toUpdtGlbInfo, GlobalInfoProcess &globalInfoProc);                       // update global info
            bool CalcIntrSpprAction(GlobalInfoProcess &globalInfoProc, const bool &spdCond4AutoLC, const BA::TargetRoadTyp &lastTrgtRdTyp, bool &allwLCAntiDrctCond);        // calculate suppressed actions based on internal rules
            static bool Sort_by_actionTyp(BA::behaviorNodeGlobal &bng01, BA::behaviorNodeGlobal &bng02);               //sort terminateBehaviorNodeGlobal by action type
            void CalcLnVehFlowSpd(const uint8_t &laneID,
                                  const RoadInfo &roadModel,
                                  const float &setSpd,
                                  float &lnVehFlowSpd,
                                  uint32_t &frtNrstObjID,
								  float &frtNrstObjDst); // calculate lane vehicle flow speed
            void CalcLnVehFlowSpd_alpha(const uint8_t &laneID,
                                        const RoadInfo &roadModel,
                                        const float &setSpd,
                                        float &lnVehFlowSpd,
                                        uint32_t &frtNrstObjID,
								        float &frtNrstObjDst); // calculate lane vehicle flow speed alpha version
            void IsLCIntGnrt(const float &vehSpd,
                             const float &setSpd,
                             const CarPosition &carPos,
                             const bool &isLCIntReset,
                             bool &isEffcLCIntGnrt,
                             const BA::DriveMd &drvStyle); // judge whether lane change intention is generated
            bool DebounceOptRes(); // do debounce process for optimal results
            bool ManageDircnIndReq(GlobalInfoProcess &globalInfoProc, const bool &drcnTurnOff, const BA::TargetRoadTyp &lastTrtRdTyp); // manage direction indicator request command
            void FilterSpdLmt(const GlobalInfoProcess &globalInfoProc); // filter speed limit info in some cases
            static bool Cmp_by_stRng(const NeighborLane &nLn01, const NeighborLane &nLn02);
            void DynChgLCInterval(const GlobalInfoProcess &globalInfoProc, const BA::TargetRoadTyp &lastTrtRdTyp); // change lane change interval in specific cases
            bool DebounceTOR(); // do debounce process for TOR to SM
            bool GetOptLaneID(); // get optimal lane ID
            bool JudgeDrcnIndTurnOff(); // get whether direction indicator is turned off
            bool JudgeAutoLCSpdCond(); // get whether speed condition for auto lane change is satisfied
            void ShineHighlght(uint8_t &toShineHghlght, const uint32_t &ILCTrgtID); // determine flag whether to shine the highlight or not
            void AdjSetSpd(const GlobalInfoProcess &globalInfoProc); // determine whether to adjust set speed
            int CalcVehFlowDense(const uint8_t &laneID); // calculate vehicle number in spec lane within certain range
            float CalcAvgVehFlowDense(const GlobalInfoProcess &globalInfoProc); // calculate average vehicle flow dense
            bool CalcSmplPntTimeStamp();
            void UpdatePDDbgInfo(const PD::PDDebug &pd_Debug);
            bool CalcDstToRLnBndry(float &dstToRghtLnBndry, const uint8_t &laneID);
            bool CalcDstToLLnBndry(float &dstToLftLnBndry, const uint8_t &laneID);
            bool DebounceDrcnIndReq(); // do debounce process for direction indicator request
            bool GetLineTyp(const uint32_t &laneMrkID, uint8_t &lineTyp);
            bool DebounceFlowDense(); // do debounce process for average vehicle flow dense
            bool DebounceSpdCond_L(const bool &input, bool &output, bool &laneChgFlg);
            bool DebounceSpdCond_R(const bool &input, bool &output, bool &laneChgFlg);
            bool ProcessLnVehFlowSpdCond(uint8_t &lftNbghLnID, 
                                         uint8_t &rghtNbghLnID, 
                                         const bool &chgSpdThrFlg,
                                         const GlobalInfoProcess &globalInfoProc); // determine LF/LLC/RLC lane vehicle flow speed condition
            bool MonitorRMCycleCounter(); // check whether rm cycle counter is normal or not
            bool JudgeAutoLCCrvCond(); // get whether curve condition for auto lane change is satisfied
            void AdjTrpLatSts(const GlobalInfoProcess &globalInfoProc, const bool &toUpdtGlbInfo); // determine whether to adjust trp lat sts
            bool DebounceTRPLatSts(); // do debounce process for TRPLatSts
            void UpdateLftNghrDesLCPnt(const bool &chgSpdThrFlg, GlobalInfoProcess &globalInfoProc); // update left neighbor lane desired lane change point in spec case

            BA::Request_BA request_BA;   // request to PD
            BA::Response_BA response_BA; // response from PD
            unique_ptr<std::vector<BA::behaviorNodeGlobal>> BA_BehaviorNodeGlobalVector;
            unique_ptr<std::vector<RoadInfo>> BA_RoadModelVector;
            unique_ptr<std::vector<BA::behaviorNodeGlobal>> BA_TerminatedBehaviorNodesVector;   
            bool BA_BehaviorNodeUpdateDone = false;
            std::vector<BA::BA_ActionTyp> BA_LatAvlblBehavior;
            BA::LongtAvlblBhvr BA_LongtAvlblBehavior;
            bool BA_VehInLnCenter = false;
            bool BA_VehClsToLnCntr = false;
            bool BA_LaneChangeAbolitionAvlbl = false;
            int BA_StepNum;
            uint32_t BA_OptimalCorridorID = uint32_t(0);
            BA::BA_ActionTyp BA_OptimalAction = BA::BA_ActionTyp_None;
            uint32_t BA_OptimalTargetObjID = uint32_t(0);
            BA::Index BA_OptimalPassageID{0, 0};
            unique_ptr<std::vector<Passage>> BA_FirstPassageList; // relevant to RM_RoadModel
            std::vector<Passage> BA_PassageListObs; // variable for internal observation
            bool BA_IsLCAbltAvlbl;                                              // from CurrentBehaviorJudgement
            DM::DirectionIndicatorDuration BA_DirectionIndicatorInfo;
            std::vector<BIP::HistoryBehavior> BA_BehaviorStackVector;
            uint8_t BA_TgtLaneStID;
            uint8_t BA_TgtLaneEndID;
            uint8_t BA_OrgLaneStID;                  // only when optimal action turns to LeftLaneChange or RightLaneChange, update original lane start ID
            uint8_t BA_OrgLaneEndID;                 // only when optimal action turns to LeftLaneChange or RightLaneChange, update original lane end ID
            vector<BA::BA_ActionTyp> BA_SupprActLst; // store actions being suppressed based on ba internal rules
            vector<DM::Passageob> BA_PassageObLst; // store passages in last cycle
            // optimal results after debounce process
            uint32_t BA_OptCorridorID_Deb = uint32_t(0);
            BA::BA_ActionTyp BA_OptAction_Deb = BA::BA_ActionTyp_None;
            uint32_t BA_OptTargetObjID_Deb = uint32_t(0);
            BA::Index BA_OptPassageID_Deb{0, 0};
            uint8_t BA_OptLaneID_Deb = uint8_t(0);
            BA::BA_ActionTyp BA_LastActTyp2SM = BA::BA_ActionTyp_None;
            BA::SpdLmtTyp BA_OptimalSpdLmtTyp = BA::SpdLmtTyp_NotAvlbl;
            float BA_OptimalSpdLmtDst = 1000.0f;
            float BA_OptimalSpdLmtVal = 130.0f;
            uint8_t BA_OptimalSpdLmtID = uint8_t(0);
            bool BA_OptimalSpdLmtFlg = false;
            bool BA_SpdLmtInfoFltred = false;
            uint8_t BA_DynChgLCintervalLvl = uint8_t(0);
            uint8_t BA_TORTyp = uint8_t(0);
            uint8_t BA_TORTyp_Deb = uint8_t(0);
            bool BA_ISLCLnIDnotChg = true;
            float BA_FuncOnDurTm = 0.0f;
            uint8_t BA_ShineHighlightFlg = uint8_t(0);
            bool BA_LaneChgAblFlg4TRPLat = false;
            bool BA_AvgFlowDenseHigh = false;
            bool BA_AvgFlowDenseHigh_Deb = false;
            bool BA_LeftLnSpdCond = false;
            bool BA_LeftLnSpdCond_Deb = false;
            bool BA_RightLnSpdCond = false;
            bool BA_RightLnSpdCond_Deb = false;
            BA::TargetRoadTyp BA_TmpTrgtRdTypMem = BA::TargetRoadTyp_NotAvlbl;
            BA::DriveMd BA_TmpDriveMd = BA::DriveMd_Normal;
            uint8_t BA_TRPLatSts = BA::TRPLatSts_Comfort;
            uint8_t BA_TRPLatSts_Deb = BA::TRPLatSts_Comfort;
            float BA_Wait4LCDurTm = 0.0f;
            BA::ScenarioTyp BA_CrrtScenarioTyp = BA::ScenarioTyp_Normal;
            // SM Msg;
            std::mutex data_mutex_sm;
            // RM Msg;
            std::mutex data_mutex_rm;
            // VSE Msg;
            std::mutex data_mutex_vse;
            // EHR Msg;
            std::mutex data_mutex_ehr;
        };

    } // namespace planning
} // namespace ADC
