#pragma once

#include <memory>
#include <vector>
#include <array>

#include "../include/CtApBehaviorAnalysis_/input_BA.h"
// #include "mpc_drv_msgs/msg/road_info.hpp"
#include "../include/CtApBehaviorAnalysis_/behaviorNodeGlobal.h"
#include "../include/CtApBehaviorAnalysis_/BA_Enum_List.h"
// #include "mpc_drv_msgs/msg/behavior_node_local.hpp"
#include "../../third_party/linear_interpolation.h"
#include "../source/commonfunc.h"
// #include "../include/CtApBehaviorAnalysis_/interface/rm_road_info.h"
#include "../include/CtApBehaviorAnalysis_/interface/pd_interface.h"
#include "../include/CtApBehaviorAnalysis_/interface/dm_internal_interface.h"
#include "dpc/impl_type_roadinfo.h"

using namespace std;
using namespace MathFcn;
using namespace BA;
// using namespace mpc_drv_msgs;
using namespace ADC;
using namespace common;

class BehaviorNodesAdd
{
public:
    void Init(vector<BA::behaviorNodeGlobal> *BA_BehaviorNodeGlobalVector,
              vector<PD::BehaviorNodeLocal> &PD_BehaviorNodeLocalVector_,
              vector<RoadInfo> *RoadModel_,
              int &BA_StepNum,
              BA_ActionTyp BA_OptAction_LastCycle,
              uint32_t BA_OptCorridorID_LastCycle,
              uint32_t BA_OptTargetObjID_LastCycle,
              BA::Input_BA Input_BA,
              vector<BA::BA_ActionTyp> BA_LatAvlblBehavior);
    void Process(vector<BA::behaviorNodeGlobal> *BA_BehaviorNodeGlobalVector_,
                 vector<PD::BehaviorNodeLocal> &PD_BehaviorNodeLocalVector_,
                 vector<RoadInfo> *RoadModel_,
                 int &BA_StepNum,
                 BA::Input_BA Input_BA,
                 vector<BA::BA_ActionTyp> BA_LatAvlblBehavior);

    bool BNGNode_Unusual;
    bool GPP_RunNormal;
    bool GPN_RunNormal;
    bool GPR_RunNormal;

private:
//public:     // for gtest 
    BA_ActionTyp BA_OptAction_LastCycle_;
    uint32_t BA_OptCorridorID_LastCycle_;
    uint32_t BA_OptTargetObjID_LastCycle_;
    vector<BA::behaviorNodeGlobal> BA_BehaviorNodeGlobalVector_;
    uint8_t BA_OptLCPCls_LastCycle_;
    uint8_t BA_OptLCCls_LastCycle_;    
    int BA_StepNum_;

    float Gain_share_;
    float Gain_decay_;
    bool BAChgWork_S2_ = false;
    bool BAChgWork_S3_ = false;
    bool BAChgWork_S4_ = false;
    bool BAS2_S4Allfail_;

    float BAPDCost_;
    float BAChgCost_;
    float BAALCCourageCost_;
    float LayerCost_;       //layer cost influence by Gain
    float BADelimitCost_; 
    vector<float> PDNormalPartArr_;
    float PDNormalCost_ = 0;  
//    float BA_GlobeWeight_;
    vector<uint32_t> ReminderObjLst_;
    uint32_t ReminderObjID_;

    void CycleCounter(int &BA_StepNum); //  run once in each BNA, StepNum+1

    void FatherNodeGen(vector<BA::behaviorNodeGlobal> *BA_BehaviorNodeGlobalVector_); // Do Father node work, record last BA cycle info,initialize ohter info in FatherNode
    bool FatherNodeJudge();                                                           // judge Father node or not

    bool CycleNodeJudge();             // judge PD Cycle or not
    void CycleNodeGen(vector<BA::behaviorNodeGlobal> *BA_BehaviorNodeGlobalVector_,
                      vector<PD::BehaviorNodeLocal> &PD_BehaviorNodeLocalVector_,
                      vector<RoadInfo> *RoadModel_,
                      BA::Input_BA Input_BA,
                      vector<BA::BA_ActionTyp> BA_LatAvlblBehavior);                     // Do Cycle Node work, update&push
    
    void FirstEstNodeChk(vector<BA::behaviorNodeGlobal> *BA_BehaviorNodeGlobalVector_,
                         vector<BA::BA_ActionTyp> BA_LatAvlblBehavior);  // chk first_node safety,return monitor signal for BA.h

    bool CollideTerminalNodeJudge(PD::BehaviorNodeLocal PD_BehaviorNodeLocal);            // judge terinal node, stop updating node

    void CostProcess(BA::behaviorNodeGlobal ParentNode_,
                     Passage ParentPassage_,
                     BA::behaviorNodeGlobal &NewNode_,
                     PD::BehaviorNodeLocal BehaviorNodeLocal,
                     BA::Input_BA Input_BA,
                     vector<BA::BA_ActionTyp> BA_LatAvlblBehavior
                     );         // Cost Work mian Function, do PDCostCalc BAChgCost Calc , do Decay&layer cost calc, node cost update
    void CostGainCalc(BA::behaviorNodeGlobal &NewNode_, PD::BehaviorNodeLocal BehaviorNodeLocal);       //get gain for PDstepCost & BAChgCost
    void PDStepCostEstimate(PD::BehaviorNodeLocal BehaviorNodeLocal,
                            Passage ParentPassage); // API for PD Cost Section
    void BAChgCostEstimate(BA::behaviorNodeGlobal ParentNode_,
                           Passage ParentPassage_,
                           BA::Input_BA Input_BA,
                           vector<BA::BA_ActionTyp> BA_LatAvlblBehavior,
                           BA::behaviorNodeGlobal &NewNode_);  // calc new node Behavior Chg Cost   need globe info
    void LayerCostGen();    // Update new node m_TotalCost

    RoadInfo GetParentRMInfo(vector<RoadInfo> *RoadModel_, PD::BehaviorNodeLocal localnode_);
    BA::behaviorNodeGlobal GetParentNode(vector<BA::behaviorNodeGlobal> *BA_behaviornodeglobalvector_, PD::BehaviorNodeLocal localnode_);
    Passage GetParentPassage(RoadInfo RoadModelInfo_, PD::BehaviorNodeLocal localnode_); // use localnode locate ref passage
    BA::behaviorNodeGlobal UpdateNewNode(BA::behaviorNodeGlobal ParentNode_,
                                         Passage ParentPassage_,
                                         PD::BehaviorNodeLocal BehaviorNodeLocal,
                                         uint8_t NodeIndex,
                                         BA::Input_BA Input_BA,
                                         vector<BA::BA_ActionTyp> BA_LatAvlblBehavior);

    // BA::HV_Info HVInfoTransf(PD::HVInfo BehaviorNodeLocalHVInfo);
    void HVInfoAdd(PD::HVInfo BehaviorNodeLocalHVInfo,
                   BA::behaviorNodeGlobal &NewNode);                                     // transf BANodeLocal->HVInfo toBANodeGlobe->HVinfo
    // void BANodeGlobalHVpushFcn(BA::behaviorNodeGlobal &NewNode_, PD::BehaviorNodeLocal &BehaviorNodeLocal); // push each BANdLocal Vector<m_Hvinfo> member to BANdGlobal Vector<HVInfo>
    void BANodeGlobalHVpushFcn(BA::behaviorNodeGlobal &NewNode_, 
                               PD::BehaviorNodeLocal &BehaviorNodeLocal);

    void BehaviorChgCost_S1(BA::behaviorNodeGlobal ParentNode_,
                            Passage ParentPassage_);                         // for common behavior chg cost 

    void BehaviorChgCost_S2(BA::behaviorNodeGlobal ParentNode_,
                            Passage ParentPassage_);

    void BehaviorChgCost_S3(BA::behaviorNodeGlobal ParentNode_,
                            Passage ParentPassage_,
                            BA::Input_BA Input_BA,
                            vector<BA::BA_ActionTyp> BA_LatAvlblBehavior);    //for encourage Maner for ALC/iALC

    void BehaviorChgCost_S4(BA::behaviorNodeGlobal ParentNode_,
                            Passage ParentPassage_,
                            BA::Input_BA Input_BA,                            
                            vector<BA::BA_ActionTyp> BA_LatAvlblBehavior);    //for encourage Maner for ALC when lastcycle is lanechgprepare                            
    void BehaviorChgCostS2_S4ALLFail();

    void BehaviorChgGuideCost(BA::behaviorNodeGlobal ParentNode_,
                              Passage ParentPassage_,
                              BA::Input_BA Input_BA,
                              BA::behaviorNodeGlobal &NewNode_);
    bool LCPFrtBckChk(uint8_t LCPCls);  // frt is true  back is false
    
    void BehaviorChgCourageCost(BA::behaviorNodeGlobal ParentNode_,
                                Passage ParentPassage_,
                                BA::Input_BA Input_BA);
    bool TargetBehaviorChk(BA::BA_ActionTyp Goal, vector<BA::BA_ActionTyp> BA_LatAvlblBehavior);
 
    // PD_Cost Ref
    void PDRuleDelimit(PD::BehaviorNodeLocal BehaviorNodeLocal);
    void PDNormalization(PD::BehaviorNodeLocal BehaviorNodeLocal, Passage ParentPassage);
    float PDLabelObjTTC(PD::BehaviorNodeLocal BehaviorNodeLocal, uint32_t InterestObjID);
    float PDLabelObjLgtMinDist(PD::BehaviorNodeLocal BehaviorNodeLocal, uint32_t InterestObjID);
    float PDLabelObjTD(PD::BehaviorNodeLocal BehaviorNodeLocal,
                                      uint32_t InterestObjID);   // ad TD Para for PDNormalizationCost RiskPart 0616

};



                            
