
#include "longitudinal_corridor_generate.h"
#include "glog/logging.h"
#include <math.h>
namespace LgtFcn
{
    using namespace std;
    using namespace ADC::common;
    // Main Fcn  API
    void LgtCrdorGen::LgtCrdorGenProcess(float duration,
                                         BA::BA_ActionTyp action,
                                         Corridor cr,
                                         const float drvrSetSpd,
                                         int &index_,
                                         RoadInfo &roadModel,
                                         int BA_StepNum,
                                         float longtVelocity,
                                         const bool m_BA_LaneChangeAbolitionAvlbl,
                                         std::vector<BA::behaviorNodeGlobal>::iterator BNGItr,
                                         std::vector<Corridor> Corridors2LonSub,
                                         vector<DM::Passageob> &passageObLst,
                                         const BA::SeldDistLvl &drvrSetDstLvl,
                                         const BA::SignSpeedLimit &signSpdLmtInfo01,
                                         const BA::SignSpeedLimit &signSpdLmtInfo02,
                                         const bool &lastCycleSpdLmtFlg,
                                         const BA::SpdLmtTyp &lastCycleSpdLmtTyp,
                                         const uint8_t &lastCycleSpdLmtID,
                                         BA::DriveMd &driveMode,
                                         BA::ScenarioTyp &ScenarioType) // serivce of RoadModelUpdate
    {
        Init(duration, action, cr, drvrSetSpd, BA_StepNum, longtVelocity, m_BA_LaneChangeAbolitionAvlbl, Corridors2LonSub, drvrSetDstLvl,
             signSpdLmtInfo01, signSpdLmtInfo02, lastCycleSpdLmtFlg, lastCycleSpdLmtTyp, lastCycleSpdLmtID, driveMode, ScenarioType);
        // VSEInfoUpdate();
        EachCridorObjJudge(index_, roadModel, BA_StepNum, BNGItr, passageObLst);
    }

    // PART I : Initial Factor
    void LgtCrdorGen::Init(const float DurationTm,
                           const BA::BA_ActionTyp ActionType,
                           const Corridor CorridorInfo,
                           const float DrvrSetSpd,
                           const int BA_StepNum,
                           const float longtVelocity,
                           const bool m_BA_LaneChangeAbolitionAvlbl,
                           const vector<Corridor> Corridors2LonSub,
                           const BA::SeldDistLvl &drvrSetDstLvl,
                           const BA::SignSpeedLimit &signSpdLmtInfo01,
                           const BA::SignSpeedLimit &signSpdLmtInfo02,
                           const bool &lastCycleSpdLmtFlg,
                           const BA::SpdLmtTyp &lastCycleSpdLmtTyp,
                           const uint8_t &lastCycleSpdLmtID,
                           BA::DriveMd &driveMode,
                           BA::ScenarioTyp &ScenarioType) // get durationTm&Action&Corridor for each corridor cycle
    {
        this->L_ActionTm = DurationTm;
        this->L_ActionType = ActionType;
        this->L_Corridor = CorridorInfo;
        this->L_DrvrSetSpd = DrvrSetSpd;
        this->L_BA_StepNum = BA_StepNum;
        this->L_VEgo = longtVelocity;                       // get vehicle speed here
        this->L_EgoOvrLne = !m_BA_LaneChangeAbolitionAvlbl; // ovrlane but do not arrive center is ture ,eles is false
        this->L_SpdLimit = 0;
        if (!Corridors2LonSub.empty())
        {
            this->L_CorridorSub = Corridors2LonSub.at(0);
        }
        L_InterestObjIDList.clear();
        L_ReminderObjIDList.clear();
        this->L_DrvrDistLvl = drvrSetDstLvl;

        this->L_SignSpdLmtInfo01 = signSpdLmtInfo01;
        this->L_SignSpdLmtInfo02 = signSpdLmtInfo02;
        this->L_LastCycleSpdLmtFlg = lastCycleSpdLmtFlg;
        this->L_LastCycleSpdLmtTyp = lastCycleSpdLmtTyp;
        this->L_LastCycleSpdLmtID = lastCycleSpdLmtID;
        this->L_DriveMode = driveMode;
        this->L_Red = 5; // Use for ArvTm Est 0808
        // calc LCP Start distance & debounce
        // iAlcDis_TarLane_ = 1.2 * AlcDis_TarLane_;
        // reiAlcDis_TarLane_ = AlcDis_TarLane_;

        // merge DriverSetDistLevel to AutoLaneChgSetReq FOR TEST Only !! //0720  || merge softbutton 0730 version ADD Trigger FOR TEST

        this->L_ScnrTyp = ScenarioType;

        if (k_BA_LCGDrveMdTestOn)
        {
            if (L_DrvrDistLvl == BA::SeldDistLvl_DistLvl1)
            {
                this->L_ALCSR = eALCSR_Level3; // Aggressive
            }
            else if (L_DrvrDistLvl == BA::SeldDistLvl_DistLvl2)
            {
                this->L_ALCSR = eALCSR_Level1; // Conservative
            }
            else
            {
                this->L_ALCSR = eALCSR_Level2; // Default Normal
            }
        }
        else
        {
            if (L_DriveMode == BA::DriveMd_Sport)
            {
                this->L_ALCSR = eALCSR_Level3; // Aggressive
            }
            else if (L_DriveMode == BA::DriveMd_Comfortable)
            {
                this->L_ALCSR = eALCSR_Level1; // Conservative
            }
            else
            {
                this->L_ALCSR = eALCSR_Level2; // Default Normal
            }
        }

        // Init Iner para
        this->LC_PassageGenFlg_ = false;
        this->LCP_Frt_PassageGenFlg_ = false;
        this->LCP_Bck_PassageGenFlg_ = false;

        this->LC_EgoFrtObjExstFlg_ = false;
        this->LC_EgoFrtObjID_ = 0;
        this->LC_EgoFrtObjDist_ = 0;
        this->LC_EgoFrtObjSpd_ = 0;
        this->LC_EgoFrtObjLen_ = 0;
        this->LC_EgoFrtObjCls_ = 0;
        this->LC_EgoFrtObjAcc_ = 0;

        this->LC_EgoBckObjExstFlg_ = false; // 0714 use for ego bck obj Label for Unexpect cls 1 obj chk
        this->LC_EgoBckObjID_ = 0;

        this->LC_TarFrtObjExstFlg_ = false;
        this->LC_TarFrtObjID_ = 0;
        this->LC_TarFrtObjDist_ = 0;
        this->LC_TarFrtObjSpd_ = 0;
        this->LC_TarFrtObjLen_ = 0;
        this->LC_TarFrtObjCls_ = 0;
        this->LC_TarFrtObjAcc_ = 0;

        this->LC_TarBckObjExstFlg_ = false;
        this->LC_TarBckObjID_ = 0;
        this->LC_TarBckObjDist_ = 0;
        this->LC_TarBckObjSpd_ = 0;
        this->LC_TarBckObjLen_ = 0;
        this->LC_TarBckObjCls_ = 0;
        this->LC_TarBckObjAcc_ = 0;

        // FOR LCP
        this->LCP_EgoFrtObjExstFlg_ = false;
        this->LCP_EgoFrtObjID_ = 0;
        this->LCP_EgoFrtObjDist_ = 0;
        this->LCP_EgoFrtObjSpd_ = 0;
        this->LCP_EgoFrtObjLen_ = 0;
        this->LCP_EgoFrtObjCls_ = 0;
        this->LCP_EgoFrtObjACC_ = 0;

        this->LCP_EgoBckObjExstFlg_ = false;
        this->LCP_EgoBckObjID_ = 0;
        this->LCP_EgoBckObjDist_ = 0;
        this->LCP_EgoBckObjSpd_ = 0;
        this->LCP_EgoBckObjLen_ = 0;
        this->LCP_EgoBckObjCls_ = 0;
        this->LCP_EgoBckObjAcc_ = 0;

        this->LCP_NrObjExstFlg_ = false;
        this->LCP_NrObjID_ = 0;
        this->LCP_NrObjDist_ = 0;
        this->LCP_NrObjSpd_ = 0;
        this->LCP_NrObjLen_ = 0;
        this->LCP_NrObjCls_ = 0;
        this->LCP_NrObjAcc_ = 0;

        this->LCP_NrFrtObjExstFlg_ = false;
        this->LCP_NrFrtObjID_ = 0;
        this->LCP_NrFrtObjDist_ = 0;
        this->LCP_NrFrtObjSpd_ = 0;
        this->LCP_NrFrtObjLen_ = 0;
        this->LCP_NrFrtObjCls_ = 0;
        this->LCP_NrFrtObjAcc_ = 0;

        this->LCP_NrBckObjExstFlg_ = false;
        this->LCP_NrBckObjID_ = 0;
        this->LCP_NrBckObjDist_ = 0;
        this->LCP_NrBckObjSpd_ = 0;
        this->LCP_NrBckObjLen_ = 0;
        this->LCP_NrBckObjCls_ = 0;
        this->LCP_NrBckObjAcc_ = 0;

        // For LabelFcn
        this->FrtObjExstFlg_ = false;
        this->BckObjExstFlg_ = false;
        this->NrObjExstFlg_ = false;
        this->NrFrtObjExstFlg_ = false;
        this->NrBckObjExstFlg_ = false;
        // observe LC space not satisfy flag
        this->LneChgRes0_ = false;
        this->LneChgRes1_ = false;
        this->LneChgRes2_ = false;
        this->LneChgRes3_ = false;
        this->PassageGenFlg_ = false;
    }

    // PART II : Obj & Space Judge base on Maner&Corridor
    void LgtCrdorGen::EachCridorObjJudge(int &index_,
                                         RoadInfo &roadModel,
                                         int BA_StepNum,
                                         std::vector<BA::behaviorNodeGlobal>::iterator BNGItr,
                                         vector<DM::Passageob> &passageObLst) // just for TJA Now
    {
        // int TotalNum = L_Corridor.size(); // no use for one corridor one object
        // L_InterestObjIDList.clear();
        if (L_ActionType == BA::BA_ActionTyp_LaneFollow || L_ActionType == BA::BA_ActionTyp_LeftLaneChangeAbolition || L_ActionType == BA::BA_ActionTyp_RightLaneChangeAbolition || (L_ActionType == BA::BA_ActionTyp_LeftLaneChange && L_EgoOvrLne) || (L_ActionType == BA::BA_ActionTyp_RightLaneChange && L_EgoOvrLne))
        {
            // init LgtOutput
            L_TempObjID = 0;
            L_TempObjDist = 1000;
            L_TempObjSpd = 100;
            DoubleObjLabel(L_Corridor);
            //			DLOG(INFO) << "L_Corridor ID is: = " << int(L_Corridor.corridor_id) << "*************" << std::endl;
            if (FrtObjExstFlg_)
            {
                L_TempObjID = PrtFrt_->object_id;
                L_TempObjDist = PrtFrt_->relative_center_x;
                L_TempObjSpd = PrtFrt_->reference_point2corridor_frenet.ds;
                L_InterestObjIDList.push_back(L_TempObjID);
            }
            else
            {
                L_TempObjID = 0;
                L_TempObjDist = 1000; // protect for TRP
                L_TempObjSpd = 100;
                L_InterestObjIDList.push_back(uint32_t(0));
            }
            //			DLOG(INFO) << "L_TempObjID is : = " << int(L_TempObjID) <<"*************" << std::endl;
            DLOG(INFO) << "LF_InterestObjIDList Size = " << int(L_InterestObjIDList.size()) << std::endl;
            PassageGenPush(index_, BA_StepNum, roadModel);
            PassageOBGenPush(index_, BA_StepNum, roadModel, passageObLst); // chk lf obj 0627
            // clear some info

            L_InterestObjIDList.clear();
        }
        // for LaneChange Can be Abolition
        else if ((L_ActionType == BA::BA_ActionTyp_LeftLaneChange && !L_EgoOvrLne) || (L_ActionType == BA::BA_ActionTyp_RightLaneChange && !L_EgoOvrLne))
        {
            //            DLOG(INFO) << "LC_TgtCorridor Width = " << L_Corridor.drivable_width << std::endl;
            // init LgtOutput
            L_TempObjID = 0;
            L_TempObjDist = 1000;
            L_TempObjSpd = 100;
            LC_PassageGenFlg_ = false; // true->false 0524
            // get nearest EgoLne Obj
            DoubleObjLabel(L_CorridorSub);
            if (FrtObjExstFlg_)
            {
                LC_EgoFrtObjExstFlg_ = true;
                LC_EgoFrtObjID_ = PrtFrt_->object_id;
                LC_EgoFrtObjDist_ = PrtFrt_->relative_center_x;
                LC_EgoFrtObjSpd_ = PrtFrt_->reference_point2corridor_frenet.ds;
                LC_EgoFrtObjLen_ = PrtFrt_->size_length;
                LC_EgoFrtObjCls_ = PrtFrt_->classification;
                LC_EgoFrtObjAcc_ = PrtFrt_->reference_point2corridor_frenet.dds;
            }
            else
            {
                LC_EgoFrtObjExstFlg_ = false;
                LC_EgoFrtObjID_ = 0;
                LC_EgoFrtObjDist_ = 0;
                LC_EgoFrtObjSpd_ = 0;
                LC_EgoFrtObjLen_ = 0;
                LC_EgoFrtObjCls_ = 0;
                LC_EgoFrtObjAcc_ = 0;
            }
            float LC_EgoFrtObjDistNrst = max(LC_EgoFrtObjDist_ - 0.5 * k_BA_LCGEgoLenth - 0.5 * LC_EgoFrtObjLen_, 0.0);

            // ADD EgoBckObj Label 0714
            if (BckObjExstFlg_)
            {
                LC_EgoBckObjExstFlg_ = true;
                LC_EgoBckObjID_ = PrtBck_->object_id;
            }
            else
            {
                LC_EgoBckObjExstFlg_ = false;
                LC_EgoBckObjID_ = 0;
            } //

            if (!L_Corridor.object_in_corridor_list.empty())
            {
                // get TarLne Frt&Bck Obj
                DoubleObjLabel(L_Corridor);
                if (FrtObjExstFlg_)
                {
                    LC_TarFrtObjExstFlg_ = true;
                    LC_TarFrtObjID_ = PrtFrt_->object_id;
                    LC_TarFrtObjDist_ = PrtFrt_->relative_center_x;
                    LC_TarFrtObjSpd_ = PrtFrt_->reference_point2corridor_frenet.ds;
                    LC_TarFrtObjLen_ = PrtFrt_->size_length;
                    LC_TarFrtObjCls_ = PrtFrt_->classification;
                    LC_TarFrtObjAcc_ = PrtFrt_->reference_point2corridor_frenet.dds;
                    //                    DLOG(INFO) << "LCFindFrtObjOriID = " << int(LC_TarFrtObjID_) << std::endl;
                }
                else
                {
                    LC_TarFrtObjExstFlg_ = false;
                    LC_TarFrtObjID_ = 0;
                    LC_TarFrtObjDist_ = 0;
                    LC_TarFrtObjSpd_ = 0;
                    LC_TarFrtObjLen_ = 0;
                    LC_TarFrtObjCls_ = 0;
                    LC_TarFrtObjAcc_ = 0;
                }
                if (BckObjExstFlg_)
                {
                    LC_TarBckObjExstFlg_ = true;
                    LC_TarBckObjID_ = PrtBck_->object_id;
                    LC_TarBckObjDist_ = PrtBck_->relative_center_x;
                    LC_TarBckObjSpd_ = PrtBck_->reference_point2corridor_frenet.ds;
                    LC_TarBckObjLen_ = PrtBck_->size_length;
                    LC_TarFrtObjCls_ = PrtBck_->classification;
                    LC_TarBckObjAcc_ = PrtBck_->reference_point2corridor_frenet.dds;
                    //                    DLOG(INFO) << "LCFindBckObjOriID is  " << LC_TarBckObjID_ << std::endl;
                }
                else
                {
                    LC_TarBckObjExstFlg_ = false;
                    LC_TarBckObjID_ = 0;
                    LC_TarBckObjDist_ = 0;
                    LC_TarBckObjSpd_ = 0;
                    LC_TarBckObjLen_ = 0;
                    LC_TarBckObjCls_ = 0;
                    LC_TarBckObjAcc_ = 0;
                }
                // logic judge dist calc
                float lc_tar_frt_obj_dist_nrst = max(float(LC_TarFrtObjDist_ - 0.5 * k_BA_LCGEgoLenth - 0.5 * LC_TarFrtObjLen_), float(0.0));
                float lc_tar_bck_obj_dist_nrst = max(float(abs(LC_TarBckObjDist_) - 0.5 * k_BA_LCGEgoLenth - 0.5 * LC_TarBckObjLen_), float(0.0));
                // JUST for Ob
                LC_TarFrtObjDistNrst_ = lc_tar_frt_obj_dist_nrst;
                LC_TarBckObjDistNrst_ = lc_tar_bck_obj_dist_nrst;
                // LC Interest Obj Label&Push
                if (LC_EgoFrtObjExstFlg_)
                {
                    L_InterestObjIDList.push_back(LC_EgoFrtObjID_);
                }
                else
                {
                    L_InterestObjIDList.push_back(uint32_t(0));
                }
                if (LC_TarFrtObjExstFlg_)
                {
                    L_InterestObjIDList.push_back(LC_TarFrtObjID_);
                }
                else
                {
                    L_InterestObjIDList.push_back(uint32_t(0));
                }
                if (LC_TarBckObjExstFlg_)
                {
                    L_InterestObjIDList.push_back(LC_TarBckObjID_);
                }
                else
                {
                    L_InterestObjIDList.push_back(uint32_t(0));
                }
                if (LC_EgoBckObjExstFlg_)
                {
                    L_InterestObjIDList.push_back(LC_EgoBckObjID_);
                }
                else
                {
                    L_InterestObjIDList.push_back(uint32_t(0));
                } // ADD BckObjLabel

                //  calc  distance & debounce
                // ReAlc TorGain Calc
                float ReAlcTorGain = LCAbltTolrGain(roadModel);
                DLOG(INFO) << "ReAlcTorGain is = " << float(ReAlcTorGain) << std::endl;
                if (k_BA_LCGAlcAbltTorOff)
                {
                    ReAlcTorGain = 1.0;
                }

                // 0712 ADD Dyna TgtBckReGain Calc
                MathFcn::LinearIntrPltn<float> TgtBckReGainPltn;
                float AlcTarReGain = min(TgtBckReGainPltn.InterPolation(k_BA_LCGAlcTarBckReGainSpd, k_BA_LCGAlcTarBckReGainTb, L_VEgo), k_BA_LCGAlcEgoReGain); // mark tolerance  work in tar_bck
                float AlcLCPEnrgGain = 1.0;
                if (BNGItr->m_ActionTypArr.back() == BA::BA_ActionTyp_LeftLaneChangePrepare || BNGItr->m_ActionTypArr.back() == BA::BA_ActionTyp_RightLaneChangePrepare)
                {
                    AlcLCPEnrgGain = k_BA_LCGLCPEnrgGain;
                }
                DLOG(INFO) << "AlcTarReGain = " << float(AlcTarReGain) << std::endl;
                DLOG(INFO) << "Vego = " << float(L_VEgo) << std::endl;

                AlcDis_EgoLane_ = EstDistCalc(L_VEgo, FrtEst_) * k_BA_LCGLCLCPFlowGain * k_BA_BNAEgoLneFctr; //  unlock when ego lane obj be considered;
                reAlcDis_EgoLane_ = AlcDis_EgoLane_ * k_BA_LCGAlcEgoReGain * ReAlcTorGain;

                AlcDis_EgoLane_ = max(AlcDis_EgoLane_, k_BA_LCGDeftTgtDist);
                reAlcDis_EgoLane_ = max(reAlcDis_EgoLane_, k_BA_LCGDeftTgtDist);

                //  calc Tarlane EgoFrt distance & debounce
                AlcDis_TarLane_frt_ = EstDistCalc(L_VEgo, FrtEst_) * k_BA_LCGLCLCPFlowGain * k_BA_BNATarLneFctr; // ALCDisDecrease use to creat radical LC Maner 0311
                reAlcDis_TarLane_frt_ = AlcDis_TarLane_frt_ * k_BA_LCGAlcEgoReGain * ReAlcTorGain;

                AlcDis_TarLane_frt_ = max(AlcDis_TarLane_frt_, k_BA_LCGDeftTgtDist);
                reAlcDis_TarLane_frt_ = max(reAlcDis_TarLane_frt_, k_BA_LCGDeftTgtDist);

                //  calc Tarlane EgoFBck distance & debounce
                if (LC_TarBckObjExstFlg_)
                {
                    AlcDis_TarLane_bck_ = EstDistCalc(LC_TarBckObjSpd_, BckEst_) * k_BA_LCGLCLCPFlowGain * k_BA_BNATarLneFctr * AlcLCPEnrgGain;
                    reAlcDis_TarLane_bck_ = AlcDis_TarLane_bck_ * AlcTarReGain * ReAlcTorGain;
                }
                else
                {
                    AlcDis_TarLane_bck_ = EstDistCalc(L_VEgo, BckEst_) * k_BA_LCGLCLCPFlowGain * k_BA_BNATarLneFctr * AlcLCPEnrgGain;
                    reAlcDis_TarLane_bck_ = AlcDis_TarLane_bck_ * AlcTarReGain * ReAlcTorGain;
                }

                AlcDis_TarLane_bck_ = max(AlcDis_TarLane_frt_, k_BA_LCGDeftTgtDist);
                reAlcDis_TarLane_bck_ = max(reAlcDis_TarLane_frt_, k_BA_LCGDeftTgtDist);

                // add Compress Logic 0701
                if (LC_TarFrtObjExstFlg_)
                {
                    DLOG(INFO) << "AlcDis_TarLane_frt_ori = " << float(AlcDis_TarLane_frt_) << std::endl;
                    DLOG(INFO) << "reAlcDis_TarLane_frt__ori = " << float(reAlcDis_TarLane_frt_) << std::endl;
                    DLOG(INFO) << "AlcDis_TarFrtObj_ID_ = " << int(LC_TarFrtObjID_) << std::endl;

                    float CmprsGain = DistCmPresGainCalc(L_VEgo, LC_TarFrtObjSpd_, BNGItr, FrtEst_);
                    CmprsGain_lc_tar_frt_ = CmprsGain;

                    AlcDis_TarLane_frt_ = AlcDis_TarLane_frt_ * CmprsGain;
                    reAlcDis_TarLane_frt_ = reAlcDis_TarLane_frt_ * CmprsGain;

                    DLOG(INFO) << "AlcDis_TarLane_frt_ = " << float(AlcDis_TarLane_frt_) << std::endl;
                    DLOG(INFO) << "reAlcDis_TarLane_frt_ = " << float(reAlcDis_TarLane_frt_) << std::endl;
                    DLOG(INFO) << "AlcDis_TarLane_frt_CmprsGain = " << float(CmprsGain) << std::endl;
                }
                if (LC_TarBckObjExstFlg_)
                {
                    DLOG(INFO) << "AlcDis_TarLane_bck_ori = " << float(AlcDis_TarLane_bck_) << std::endl;
                    DLOG(INFO) << "reAlcDis_TarLane_bck_ori = " << float(reAlcDis_TarLane_bck_) << std::endl;
                    DLOG(INFO) << "AlcDis_TarBckObj_ID_ = " << int(LC_TarBckObjID_) << std::endl;

                    float CmprsGain = DistCmPresGainCalc(L_VEgo, LC_TarBckObjSpd_, BNGItr, BckEst_);
                    CmprsGain_lc_tar_bck_ = CmprsGain;

                    AlcDis_TarLane_bck_ = AlcDis_TarLane_bck_ * CmprsGain;
                    reAlcDis_TarLane_bck_ = reAlcDis_TarLane_bck_ * CmprsGain;
                    DLOG(INFO) << "AlcDis_TarLane_bck_ = " << float(AlcDis_TarLane_bck_) << std::endl;
                    DLOG(INFO) << "reAlcDis_TarLane_bck_ = " << float(reAlcDis_TarLane_bck_) << std::endl;
                    DLOG(INFO) << "AlcDis_TarLane_bck_CmprsGain = " << float(CmprsGain) << std::endl;
                }
                if (LC_EgoFrtObjExstFlg_)
                {
                    DLOG(INFO) << "AlcDis_EgoLane_ori = " << float(AlcDis_EgoLane_) << std::endl;
                    DLOG(INFO) << "reAlcDis_EgoLane_ori = " << float(reAlcDis_EgoLane_) << std::endl;
                    DLOG(INFO) << "AlcDis_EgoFrtObj_ID_ = " << int(LC_EgoFrtObjID_) << std::endl;

                    float CmprsGain = DistCmPresGainCalc(L_VEgo, LC_EgoFrtObjSpd_, BNGItr, FrtEst_);
                    AlcDis_EgoLane_ = AlcDis_EgoLane_ * CmprsGain;
                    reAlcDis_EgoLane_ = reAlcDis_EgoLane_ * CmprsGain;
                    DLOG(INFO) << "AlcDis_EgoLane_ = " << float(AlcDis_EgoLane_) << std::endl;
                    DLOG(INFO) << "reAlcDis_EgoLane_ = " << float(reAlcDis_EgoLane_) << std::endl;
                    DLOG(INFO) << "AlcDis_EgoLane_CmprsGain = " << float(CmprsGain) << std::endl;
                }

                // Do Obj Judge & Passage Push work
                // initial judge flag
                LneChgRes0_ = false;
                LneChgRes1_ = false;
                LneChgRes2_ = false;
                LneChgRes3_ = false;
                if (LC_TarFrtObjExstFlg_ == true && LC_TarBckObjExstFlg_ == false)
                {
                    LC_Cls_ = 1;
                    if (BNGItr->m_ActionTypArr.back() != L_ActionType)
                    {
                        LneChgRes1_ = lc_tar_frt_obj_dist_nrst < AlcDis_TarLane_frt_;
                        LneChgRes2_ = ((L_VEgo > LC_TarFrtObjSpd_) && ((lc_tar_frt_obj_dist_nrst / (max(float(0.1), (L_VEgo - LC_TarFrtObjSpd_)))) < k_BA_LCGLCFrtTTC)) || (L_VEgo - LC_TarFrtObjSpd_ > k_BA_LCGLCSpdErrSftyThr_frt);
                        if (LC_EgoFrtObjExstFlg_ == true)
                        {
                            LneChgRes0_ = (LC_EgoFrtObjDistNrst < AlcDis_EgoLane_) || ((L_VEgo > LC_EgoFrtObjSpd_) && ((LC_EgoFrtObjDistNrst / (max(float(0.1), (L_VEgo - LC_EgoFrtObjSpd_)))) < 5));
                        }
                    }
                    else
                    {
                        LneChgRes1_ = lc_tar_frt_obj_dist_nrst < reAlcDis_TarLane_frt_;
                        LneChgRes2_ = (L_VEgo > LC_TarFrtObjSpd_) && ((lc_tar_frt_obj_dist_nrst / (max(float(0.1), (L_VEgo - LC_TarFrtObjSpd_)))) < k_BA_LCGLCFrtReTTC);
                        if (LC_EgoFrtObjExstFlg_ == true)
                        {
                            LneChgRes0_ = (LC_EgoFrtObjDistNrst < reAlcDis_EgoLane_) || ((L_VEgo > LC_EgoFrtObjSpd_) && ((LC_EgoFrtObjDistNrst / (max(float(0.1), (L_VEgo - LC_EgoFrtObjSpd_)))) < 2));
                        }
                    }
                    // Passage Gen Judge&Main Obj get
                    if (LneChgRes1_ || LneChgRes2_ || LneChgRes0_ || CommonResChk(BNGItr, roadModel))
                    {
                        bool chk = CommonResChk(BNGItr, roadModel);
                        DLOG(INFO) << "Com COND  = " << int(chk) << std::endl;
                        LC_PassageGenFlg_ = false;
                        L_TempObjID = 0;
                        L_TempObjDist = 1000;
                        L_TempObjSpd = 100;

                        // Remind Obj Find
                        if (LneChgRes1_ || LneChgRes2_)
                        {
                            L_ReminderObjIDList.push_back(LC_TarFrtObjID_);
                        }

                        if (LneChgRes0_)
                        {
                            L_ReminderObjIDList.push_back(LC_EgoFrtObjID_);
                        }
                        // if (CommonResChk(BNGItr, roadModel))
                        // {
                        //     L_ReminderObjIDList.push_back(CommonObjID_);
                        // }
                    }
                    else
                    {
                        LC_PassageGenFlg_ = true;
                        L_TempObjID = LC_TarFrtObjID_;
                        L_TempObjDist = LC_TarFrtObjDist_;
                        L_TempObjSpd = LC_TarFrtObjSpd_;
                    }
                }

                else if (LC_TarFrtObjExstFlg_ == false && LC_TarBckObjExstFlg_ == true)
                {
                    LC_Cls_ = 2;
                    if (BNGItr->m_ActionTypArr.back() != L_ActionType)
                    {
                        LneChgRes1_ = abs(lc_tar_bck_obj_dist_nrst) < AlcDis_TarLane_bck_;
                        LneChgRes2_ = ((L_VEgo < LC_TarBckObjSpd_) && ((lc_tar_bck_obj_dist_nrst / (max(float(0.1), (abs(L_VEgo - LC_TarBckObjSpd_))))) < k_BA_LCGLCBckTTC)) || (LC_TarBckObjSpd_ - L_VEgo > k_BA_LCGLCSpdErrSftyThr_bck);
                        if (LC_EgoFrtObjExstFlg_ == true)
                        {
                            LneChgRes0_ = (LC_EgoFrtObjDistNrst < AlcDis_EgoLane_) || ((L_VEgo > LC_EgoFrtObjSpd_) && ((LC_EgoFrtObjDistNrst / (max(float(0.1), (L_VEgo - LC_EgoFrtObjSpd_)))) < 5));
                        }
                    }
                    else
                    {
                        LneChgRes1_ = abs(lc_tar_bck_obj_dist_nrst) < reAlcDis_TarLane_bck_;
                        LneChgRes2_ = (L_VEgo < LC_TarBckObjSpd_) && ((lc_tar_bck_obj_dist_nrst / (max(float(0.1), (abs(L_VEgo - LC_TarBckObjSpd_))))) < k_BA_LCGLCBckReTTC);
                        if (LC_EgoFrtObjExstFlg_ == true)
                        {
                            LneChgRes0_ = (LC_EgoFrtObjDistNrst < reAlcDis_EgoLane_) || ((L_VEgo > LC_EgoFrtObjSpd_) && ((LC_EgoFrtObjDistNrst / (max(float(0.1), (L_VEgo - LC_EgoFrtObjSpd_)))) < 2));
                        }
                    }
                    // Passage Gen Judge&Main Obj get
                    if (LneChgRes1_ || LneChgRes2_ || LneChgRes0_ || CommonResChk(BNGItr, roadModel))
                    {
                        LC_PassageGenFlg_ = false;
                        L_TempObjID = 0;
                        L_TempObjDist = 1000;
                        L_TempObjSpd = 100;

                        // Remind Obj Find
                        if (LneChgRes1_ || LneChgRes2_)
                        {
                            L_ReminderObjIDList.push_back(LC_TarBckObjID_);
                        }

                        if (LneChgRes0_)
                        {
                            L_ReminderObjIDList.push_back(LC_EgoFrtObjID_);
                        }
                        // if (CommonResChk(BNGItr, roadModel))
                        // {
                        //     L_ReminderObjIDList.push_back(CommonObjID_);
                        // }
                    }
                    else
                    {
                        LC_PassageGenFlg_ = true;
                        L_TempObjID = 0;
                        L_TempObjDist = 1000;
                        L_TempObjSpd = 100;
                    }
                }
                else if (LC_TarFrtObjExstFlg_ == true && LC_TarBckObjExstFlg_ == true)
                {
                    LC_Cls_ = 3;
                    if (BNGItr->m_ActionTypArr.back() != L_ActionType)
                    {
                        LneChgRes1_ = ((abs(lc_tar_frt_obj_dist_nrst) < AlcDis_TarLane_frt_) || (abs(lc_tar_bck_obj_dist_nrst) < AlcDis_TarLane_bck_));
                        LneChgRes2_ = ((L_VEgo > LC_TarFrtObjSpd_) && ((lc_tar_frt_obj_dist_nrst / (max(float(0.1), (abs(L_VEgo - LC_TarFrtObjSpd_))))) < k_BA_LCGLCFrtTTC)) || (L_VEgo - LC_TarFrtObjSpd_ > k_BA_LCGLCSpdErrSftyThr_frt);
                        LneChgRes3_ = (((L_VEgo < LC_TarBckObjSpd_) && ((abs(lc_tar_bck_obj_dist_nrst) / (max(float(0.1), (abs(L_VEgo - LC_TarBckObjSpd_))))) < k_BA_LCGLCBckTTC))) || (LC_TarBckObjSpd_ - L_VEgo > k_BA_LCGLCSpdErrSftyThr_bck);
                        //  DLOG(INFO) << "lc_tar_frt_obj_dist_nrst = " << float(lc_tar_frt_obj_dist_nrst) << std::endl;
                        //  DLOG(INFO) << "AlcDis_TarLane_frt_ = " << float(AlcDis_TarLane_frt_) << std::endl;
                        //  DLOG(INFO) << "lc_tar_bck_obj_dist_nrst = " << float(lc_tar_bck_obj_dist_nrst) << std::endl;
                        //  DLOG(INFO) << "AlcDis_TarLane_bck_ = " << float(AlcDis_TarLane_bck_) << std::endl;
                        // DLOG(INFO) << "Vego = " << float(L_VEgo) << std::endl;
                        if (LC_EgoFrtObjExstFlg_ == true)
                        {
                            LneChgRes0_ = (LC_EgoFrtObjDistNrst < AlcDis_EgoLane_) || ((L_VEgo > LC_EgoFrtObjSpd_) && ((LC_EgoFrtObjDistNrst / (max(float(0.1), (L_VEgo - LC_EgoFrtObjSpd_)))) < 5));
                        }
                    }
                    else
                    {
                        LneChgRes1_ = ((abs(lc_tar_frt_obj_dist_nrst) < reAlcDis_TarLane_frt_) || (abs(lc_tar_bck_obj_dist_nrst) < reAlcDis_TarLane_bck_));
                        LneChgRes2_ = (L_VEgo > LC_TarFrtObjSpd_) && ((lc_tar_frt_obj_dist_nrst / (max(float(0.1), (abs(L_VEgo - LC_TarFrtObjSpd_))))) < k_BA_LCGLCFrtReTTC);
                        LneChgRes3_ = (L_VEgo < LC_TarBckObjSpd_) && ((abs(lc_tar_bck_obj_dist_nrst) / (max(float(0.1), (abs(L_VEgo - LC_TarBckObjSpd_))))) < k_BA_LCGLCBckReTTC);
                        // DLOG(INFO) << "lc_tar_bck_obj_dist_nrst = " << float(lc_tar_bck_obj_dist_nrst) << std::endl;
                        // DLOG(INFO) << "AlcDis_TarLane_bck_ = " << float(AlcDis_TarLane_bck_) << std::endl;
                        // DLOG(INFO) << "Vego = " << float(L_VEgo) << std::endl;
                        if (LC_EgoFrtObjExstFlg_ == true)
                        {
                            LneChgRes0_ = (LC_EgoFrtObjDistNrst < reAlcDis_EgoLane_) || ((L_VEgo > LC_EgoFrtObjSpd_) && ((LC_EgoFrtObjDistNrst / (max(float(0.1), (L_VEgo - LC_EgoFrtObjSpd_)))) < 2));
                        }
                    }
                    // Passage Gen Judge&Main Obj get
                    if (LneChgRes1_ || LneChgRes2_ || LneChgRes3_ || LneChgRes0_ || CommonResChk(BNGItr, roadModel))
                    {
                        LC_PassageGenFlg_ = false;
                        L_TempObjID = 0;
                        L_TempObjDist = 1000;
                        L_TempObjSpd = 100;

                        // Remind Obj Find
                        if (BNGItr->m_ActionTypArr.back() != L_ActionType)
                        {
                            if ((LneChgRes1_ && (abs(lc_tar_frt_obj_dist_nrst) < AlcDis_TarLane_frt_)) || LneChgRes2_)
                            {
                                L_ReminderObjIDList.push_back(LC_TarFrtObjID_);
                            }
                            if ((LneChgRes1_ && (abs(lc_tar_bck_obj_dist_nrst) < AlcDis_TarLane_bck_)) || LneChgRes3_)
                            {
                                L_ReminderObjIDList.push_back(LC_TarBckObjID_);
                            }
                        }
                        else
                        {
                            if ((LneChgRes1_ && (abs(lc_tar_frt_obj_dist_nrst) < reAlcDis_TarLane_frt_)) || LneChgRes2_)
                            {
                                L_ReminderObjIDList.push_back(LC_TarFrtObjID_);
                            }
                            if ((LneChgRes1_ && (abs(lc_tar_bck_obj_dist_nrst) < reAlcDis_TarLane_bck_)) || LneChgRes3_)
                            {
                                L_ReminderObjIDList.push_back(LC_TarBckObjID_);
                            }
                        }

                        if (LneChgRes0_)
                        {
                            L_ReminderObjIDList.push_back(LC_EgoFrtObjID_);
                        }
                        // if (CommonResChk(BNGItr, roadModel))
                        // {
                        //     L_ReminderObjIDList.push_back(CommonObjID_);
                        // }
                    }
                    else
                    {
                        LC_PassageGenFlg_ = true;
                        L_TempObjID = LC_TarFrtObjID_;
                        L_TempObjDist = LC_TarFrtObjDist_;
                        L_TempObjSpd = LC_TarFrtObjSpd_;
                    }
                }
                else // both 0 , no obj protect
                {
                    LC_Cls_ = 4;
                    if (LC_EgoFrtObjExstFlg_ == true)
                    {
                        if (BNGItr->m_ActionTypArr.back() != L_ActionType)
                        {
                            if ((LC_EgoFrtObjDistNrst < AlcDis_EgoLane_) || ((L_VEgo > LC_EgoFrtObjSpd_) && ((LC_EgoFrtObjDistNrst / (max(float(0.1), (L_VEgo - LC_EgoFrtObjSpd_)))) < 5)))
                            {
                                // bool CLS4_COND_11 = (LC_EgoFrtObjDistNrst < AlcDis_EgoLane_);
                                // bool CLS4_COND_22 = ((L_VEgo > LC_EgoFrtObjSpd_) && ((LC_EgoFrtObjDistNrst / (max(float(0.1), (L_VEgo - LC_EgoFrtObjSpd_)))) < 5));
                                // DLOG(INFO) << "CLS4 COND 11 = " << int(CLS4_COND_11) << std::endl;
                                // DLOG(INFO) << "CLS4 COND 22 = " << int(CLS4_COND_22) << std::endl;
                                LC_PassageGenFlg_ = false;
                                L_ReminderObjIDList.push_back(LC_EgoFrtObjID_);
                            }
                            else if (CommonResChk(BNGItr, roadModel))
                            {
                                LC_PassageGenFlg_ = false;
                                // L_ReminderObjIDList.push_back(CommonObjID_);
                            }
                            else
                            {
                                LC_PassageGenFlg_ = true;
                                L_TempObjID = 0;
                                L_TempObjDist = 1000;
                                L_TempObjSpd = 100;
                            }
                        }
                        else if ((LC_EgoFrtObjDistNrst < reAlcDis_EgoLane_) || ((L_VEgo > LC_EgoFrtObjSpd_) && ((LC_EgoFrtObjDistNrst / (max(float(0.1), (L_VEgo - LC_EgoFrtObjSpd_)))) < 2)))
                        {
                            // bool RECLS4_COND_11 = (LC_EgoFrtObjDistNrst < AlcDis_EgoLane_);
                            // bool RECLS4_COND_22 = ((L_VEgo > LC_EgoFrtObjSpd_) && ((LC_EgoFrtObjDistNrst / (max(float(0.1), (L_VEgo - LC_EgoFrtObjSpd_)))) < 2));
                            // DLOG(INFO) << "LC_EgoFrtObjDistNrst = " << int(LC_EgoFrtObjDistNrst) << std::endl;
                            // DLOG(INFO) << "AlcDis_EgoLane_ = " << int(AlcDis_EgoLane_) << std::endl;
                            // DLOG(INFO) << "RECLS4 COND 11 = " << int(RECLS4_COND_11) << std::endl;
                            // DLOG(INFO) << "RECLS4 COND 22 = " << int(RECLS4_COND_22) << std::endl;
                            LC_PassageGenFlg_ = false;
                            L_ReminderObjIDList.push_back(LC_EgoFrtObjID_);
                        }
                        else
                        {
                            LC_PassageGenFlg_ = true;
                            L_TempObjID = 0;
                            L_TempObjDist = 1000;
                            L_TempObjSpd = 100;
                        }
                    }
                    else
                    {
                        LC_PassageGenFlg_ = true;
                        L_TempObjID = 0;
                        L_TempObjDist = 1000;
                        L_TempObjSpd = 100;
                    }
                }
            }
            else // target lne no obj
            {
                LC_Cls_ = 4;
                if (LC_EgoFrtObjExstFlg_ == true)
                {
                    if (BNGItr->m_ActionTypArr.back() != L_ActionType)
                    {
                        if ((LC_EgoFrtObjDistNrst < AlcDis_EgoLane_) || ((L_VEgo > LC_EgoFrtObjSpd_) && ((LC_EgoFrtObjDistNrst / (max(float(0.1), (L_VEgo - LC_EgoFrtObjSpd_)))) < 5)))
                        {
                            // bool CLS4_COND_11 = (LC_EgoFrtObjDistNrst < AlcDis_EgoLane_);
                            // bool CLS4_COND_22 = ((L_VEgo > LC_EgoFrtObjSpd_) && ((LC_EgoFrtObjDistNrst / (max(float(0.1), (L_VEgo - LC_EgoFrtObjSpd_)))) < 5));
                            // DLOG(INFO) << "CLS4 COND 11 = " << int(CLS4_COND_11) << std::endl;
                            // DLOG(INFO) << "CLS4 COND 22 = " << int(CLS4_COND_22) << std::endl;
                            LC_PassageGenFlg_ = false;
                            L_ReminderObjIDList.push_back(LC_EgoFrtObjID_);
                        }
                        else if (CommonResChk(BNGItr, roadModel))
                        {
                            LC_PassageGenFlg_ = false;
                            // L_ReminderObjIDList.push_back(CommonObjID_);
                        }
                        else
                        {
                            LC_PassageGenFlg_ = true;
                            L_TempObjID = 0;
                            L_TempObjDist = 1000;
                            L_TempObjSpd = 100;
                        }
                    }
                    else if ((LC_EgoFrtObjDistNrst < reAlcDis_EgoLane_) || ((L_VEgo > LC_EgoFrtObjSpd_) && ((LC_EgoFrtObjDistNrst / (max(float(0.1), (L_VEgo - LC_EgoFrtObjSpd_)))) < 2)))
                    {
                        // bool RECLS4_COND_11 = (LC_EgoFrtObjDistNrst < AlcDis_EgoLane_);
                        // bool RECLS4_COND_22 = ((L_VEgo > LC_EgoFrtObjSpd_) && ((LC_EgoFrtObjDistNrst / (max(float(0.1), (L_VEgo - LC_EgoFrtObjSpd_)))) < 2));
                        // DLOG(INFO) << "LC_EgoFrtObjDistNrst = " << int(LC_EgoFrtObjDistNrst) << std::endl;
                        // DLOG(INFO) << "AlcDis_EgoLane_ = " << int(AlcDis_EgoLane_) << std::endl;
                        // DLOG(INFO) << "RECLS4 COND 11 = " << int(RECLS4_COND_11) << std::endl;
                        // DLOG(INFO) << "RECLS4 COND 22 = " << int(RECLS4_COND_22) << std::endl;
                        LC_PassageGenFlg_ = false;
                        L_ReminderObjIDList.push_back(LC_EgoFrtObjID_);
                    }
                    else
                    {
                        LC_PassageGenFlg_ = true;
                        L_TempObjID = 0;
                        L_TempObjDist = 1000;
                        L_TempObjSpd = 100;
                    }
                }
                else
                {
                    LC_PassageGenFlg_ = true;
                    L_TempObjID = 0;
                    L_TempObjDist = 1000;
                    L_TempObjSpd = 100;
                }

                // Push Zero to InterestObjIDList in case of no obj in TgtCorridor list 0712
                if (LC_EgoFrtObjExstFlg_)
                {
                    L_InterestObjIDList.push_back(LC_EgoFrtObjID_);
                }
                else
                {
                    L_InterestObjIDList.push_back(uint32_t(0));
                }                                           // EgoFrt
                L_InterestObjIDList.push_back(uint32_t(0)); // TarFrt
                L_InterestObjIDList.push_back(uint32_t(0)); // TarBck
                if (LC_EgoBckObjExstFlg_)
                {
                    L_InterestObjIDList.push_back(LC_EgoBckObjID_);
                }
                else
                {
                    L_InterestObjIDList.push_back(uint32_t(0));
                } // EgoBck
            }

            DLOG(INFO) << "LC_EgoBckObjID = " << int(L_InterestObjIDList[3]) << std::endl;
            DLOG(INFO) << "LC_Cls_  = " << int(LC_Cls_) << std::endl;
            // DLOG(INFO) << "LCP_Bck_MovDist_  = " << float(LCP_Bck_MovDist_) << std::endl;
            // DLOG(INFO) << "LCP_Bck_EgoLneSpace_  = " << float(LCP_Bck_EgoLneSpace_) << std::endl;
            // DLOG(INFO) << "LCP_Bck_EstSpace_  = " << float(LCP_Bck_EstSpace_) << std::endl;
            // DLOG(INFO) << "LCP_Bck_NdSpace_  = " << float(LCP_Bck_NdSpace_) << std::endl;
            // DLOG(INFO) << "LCP_Bck_EgoRegionDist_  = " << float(LCP_Bck_EgoRegionDist_) << std::endl;
            // DLOG(INFO) << "LCP_Bck_EgoArvEstTm_  = " << float(LCP_Bck_EgoArvEstTm_) << std::endl;

            DLOG(INFO) << "LC_PassageGenFlg_  = " << int(LC_PassageGenFlg_) << std::endl;
            DLOG(INFO) << "LneChgRes0_  = " << int(LneChgRes0_) << std::endl;
            DLOG(INFO) << "LneChgRes1_  = " << int(LneChgRes1_) << std::endl;
            DLOG(INFO) << "LneChgRes2_  = " << int(LneChgRes2_) << std::endl;
            DLOG(INFO) << "LneChgRes3_  = " << int(LneChgRes3_) << std::endl;
            DLOG(INFO) << "CommonChk  = " << int(CommonResChk(BNGItr, roadModel)) << std::endl;

            // Push Reminder Obj into InterestObjIDList 0927
            if (LC_PassageGenFlg_ == false)
            {
                if (!L_ReminderObjIDList.empty())
                {
                    if (L_ReminderObjIDList.size() == 1)
                    {
                        L_InterestObjIDList.push_back(L_ReminderObjIDList[0]);
                    }
                    else
                    {
                        if (LC_TarFrtObjExstFlg_)
                        {
                            uint32_t TargetID = LC_TarFrtObjID_;
                            auto it_frtobj = find_if(L_ReminderObjIDList.begin(), L_ReminderObjIDList.end(),
                                                     [TargetID](uint32_t ChkObjLstID)
                                                     {
                                                         return (TargetID == ChkObjLstID);
                                                     });
                            if (it_frtobj != L_ReminderObjIDList.end())
                            {
                                L_InterestObjIDList.push_back(*it_frtobj);
                            }
                        }
                        else if (LC_EgoFrtObjExstFlg_)
                        {
                            uint32_t TargetID = LC_EgoFrtObjID_;
                            auto it_frtobj = find_if(L_ReminderObjIDList.begin(), L_ReminderObjIDList.end(),
                                                     [TargetID](uint32_t ChkObjLstID)
                                                     {
                                                         return (TargetID == ChkObjLstID);
                                                     });
                            if (it_frtobj != L_ReminderObjIDList.end())
                            {
                                L_InterestObjIDList.push_back(*it_frtobj);
                            }
                        }
                        else
                        {
                            L_InterestObjIDList.push_back(L_ReminderObjIDList.front());
                        }
                    }
                }
            }

            // Passage Gen
            PassageOBGenPush(index_, BA_StepNum, roadModel, passageObLst);
            //  Control
            if (LC_PassageGenFlg_)
            {
                PassageGenPush(index_, BA_StepNum, roadModel);
            }

            // clear some info
            L_InterestObjIDList.clear();
        }

        // for LaneChangePrepare
        else if (L_ActionType == BA::BA_ActionTyp_LeftLaneChangePrepare || L_ActionType == BA::BA_ActionTyp_RightLaneChangePrepare)
        {
            // init LgtOutput
            L_TempObjID = 0;
            L_TempObjDist = 1000;
            L_TempObjSpd = 100;

            LCP_Frt_PassageGenFlg_ = false;
            LCP_Bck_PassageGenFlg_ = false;

            // Get Enviorment Obj
            //  EgoLne
            DoubleObjLabel(L_Corridor);
            if (FrtObjExstFlg_)
            {
                LCP_EgoFrtObjExstFlg_ = true;
                LCP_EgoFrtObjID_ = PrtFrt_->object_id;
                LCP_EgoFrtObjDist_ = PrtFrt_->relative_center_x;
                LCP_EgoFrtObjSpd_ = PrtFrt_->reference_point2corridor_frenet.ds;
                LCP_EgoFrtObjLen_ = PrtFrt_->size_length;
                LCP_EgoFrtObjCls_ = PrtFrt_->classification;
                LCP_EgoFrtObjACC_ = PrtFrt_->reference_point2corridor_frenet.dds;
            }
            else
            {
                LCP_EgoFrtObjExstFlg_ = false;
                LCP_EgoFrtObjID_ = 0;
                LCP_EgoFrtObjDist_ = 0;
                LCP_EgoFrtObjSpd_ = 0;
                LCP_EgoFrtObjLen_ = 0;
                LCP_EgoFrtObjCls_ = 0;
                LCP_EgoFrtObjACC_ = 0;
            }
            if (BckObjExstFlg_)
            {
                LCP_EgoBckObjExstFlg_ = true;
                LCP_EgoBckObjID_ = PrtBck_->object_id;
                LCP_EgoBckObjDist_ = PrtBck_->relative_center_x;
                LCP_EgoBckObjSpd_ = PrtBck_->reference_point2corridor_frenet.ds;
                LCP_EgoBckObjLen_ = PrtBck_->size_length;
                LCP_EgoBckObjCls_ = PrtBck_->classification;
                LCP_EgoBckObjAcc_ = PrtBck_->reference_point2corridor_frenet.dds;
            }
            else
            {
                LCP_EgoBckObjExstFlg_ = false;
                LCP_EgoBckObjID_ = 0;
                LCP_EgoBckObjDist_ = 0;
                LCP_EgoBckObjSpd_ = 0;
                LCP_EgoBckObjLen_ = 0;
                LCP_EgoBckObjCls_ = 0;
                LCP_EgoBckObjAcc_ = 0;
            }
            // TarLne
            TripleCrdObjLabel(L_CorridorSub);
            if (NrObjExstFlg_)
            {
                LCP_NrObjExstFlg_ = true;
                LCP_NrObjID_ = PrtNr_->object_id;
                LCP_NrObjDist_ = PrtNr_->relative_center_x;
                LCP_NrObjSpd_ = PrtNr_->reference_point2corridor_frenet.ds;
                LCP_NrObjLen_ = PrtNr_->size_length;
                LCP_NrObjCls_ = PrtNr_->classification;
                LCP_NrObjAcc_ = PrtNr_->reference_point2corridor_frenet.dds;
                if (NrFrtObjExstFlg_)
                {
                    LCP_NrFrtObjExstFlg_ = true;
                    LCP_NrFrtObjID_ = PrtNrFrt_->object_id;
                    LCP_NrFrtObjDist_ = PrtNrFrt_->relative_center_x;
                    LCP_NrFrtObjSpd_ = PrtNrFrt_->reference_point2corridor_frenet.ds;
                    LCP_NrFrtObjLen_ = PrtNrFrt_->size_length;
                    LCP_NrFrtObjCls_ = PrtNrFrt_->classification;
                    LCP_NrFrtObjAcc_ = PrtNrFrt_->reference_point2corridor_frenet.dds;
                }
                else
                {
                    LCP_NrFrtObjExstFlg_ = false;
                    LCP_NrFrtObjID_ = 0;
                    LCP_NrFrtObjDist_ = 0;
                    LCP_NrFrtObjSpd_ = 0;
                    LCP_NrFrtObjLen_ = 0;
                    LCP_NrFrtObjCls_ = 0;
                    LCP_NrFrtObjAcc_ = 0;
                }
                if (NrBckObjExstFlg_)
                {
                    LCP_NrBckObjExstFlg_ = true;
                    LCP_NrBckObjID_ = PrtNrBck_->object_id;
                    LCP_NrBckObjDist_ = PrtNrBck_->relative_center_x;
                    LCP_NrBckObjSpd_ = PrtNrBck_->reference_point2corridor_frenet.ds;
                    LCP_NrBckObjLen_ = PrtNrBck_->size_length;
                    LCP_NrBckObjCls_ = PrtNrBck_->classification;
                    LCP_NrBckObjAcc_ = PrtNrBck_->reference_point2corridor_frenet.dds;
                }
                else
                {
                    LCP_NrBckObjExstFlg_ = false;
                    LCP_NrBckObjID_ = 0;
                    LCP_NrBckObjDist_ = 0;
                    LCP_NrBckObjSpd_ = 0;
                    LCP_NrBckObjLen_ = 0;
                    LCP_NrBckObjCls_ = 0;
                    LCP_NrBckObjAcc_ = 0;
                }
            }
            else
            {
                LCP_NrObjExstFlg_ = false;
                LCP_NrObjID_ = 0;
                LCP_NrObjDist_ = 0;
                LCP_NrObjSpd_ = 0;
                LCP_NrObjLen_ = 0;
                LCP_NrObjCls_ = 0;
                LCP_NrObjAcc_ = 0;

                LCP_NrFrtObjExstFlg_ = false;
                LCP_NrFrtObjID_ = 0;
                LCP_NrFrtObjDist_ = 0;
                LCP_NrFrtObjSpd_ = 0;
                LCP_NrFrtObjLen_ = 0;
                LCP_NrFrtObjCls_ = 0;
                LCP_NrFrtObjAcc_ = 0;

                LCP_NrBckObjExstFlg_ = false;
                LCP_NrBckObjID_ = 0;
                LCP_NrBckObjDist_ = 0;
                LCP_NrBckObjSpd_ = 0;
                LCP_NrBckObjLen_ = 0;
                LCP_NrBckObjCls_ = 0;
                LCP_NrBckObjAcc_ = 0;
            }
            // EgoSpaceCalc 0323

            // link with trp lgt
            // Frt_LCP_BckDist & Bck_LCP_FrtDist need be compress by Ego&Nr Spd Err 0701  link with LC lowspdTar_Bck &&
            // Frt_LCP
            if (LCP_NrFrtObjExstFlg_)
            {
                float EstSpd = L_VEgo; // consider accel scnario abolish,using small spd to estimate dist 0701

                float CmprsGain = DistCmPresGainCalc(L_VEgo, LCP_NrFrtObjSpd_, BNGItr, FrtEst_);
                CmprsGain_lcp_frt_frt_ = CmprsGain; // use for ob

                FrtLcpDis_TarLane_EgoFrt_Raw_ = EstDistCalc(EstSpd, FrtEst_) * k_BA_BNATarLneFctr * CmprsGain;
            }
            else
            {
                // PROTECT
                FrtLcpDis_TarLane_EgoFrt_Raw_ = EstDistCalc(L_VEgo, FrtEst_) * k_BA_BNATarLneFctr;
            }
            // Frt_LCP_BckDist
            if (LCP_NrObjExstFlg_)
            {
                FrtLcpDis_TarLane_EgoBck_Raw_ = EstDistCalc(LCP_NrObjSpd_, BckEst_) * k_BA_BNATarLneFctr;

                float CmprsGain = DistCmPresGainCalc(L_VEgo, LCP_NrObjSpd_, BNGItr, BckEst_);
                CmprsGain_lcp_frt_bck_ = CmprsGain; // use for ob

                FrtLcpDis_TarLane_EgoBck_Raw_ = FrtLcpDis_TarLane_EgoBck_Raw_ * CmprsGain;
            }
            else
            {
                // PROTECT
                FrtLcpDis_TarLane_EgoBck_Raw_ = EstDistCalc(L_VEgo, BckEst_) * k_BA_BNATarLneFctr;
            }

            // Bck_LCP
            // Bck_LCP_FrtDist
            if (LCP_NrObjExstFlg_)
            {
                BckLcpDis_TarLane_EgoFrt_Raw_ = EstDistCalc(L_VEgo, FrtEst_) * k_BA_BNATarLneFctr;

                float CmprsGain = DistCmPresGainCalc(L_VEgo, LCP_NrObjSpd_, BNGItr, FrtEst_);
                CmprsGain_lcp_bck_frt_ = CmprsGain; // use for ob

                BckLcpDis_TarLane_EgoFrt_Raw_ = BckLcpDis_TarLane_EgoFrt_Raw_ * CmprsGain;
            }
            else
            {
                // PROTECT
                BckLcpDis_TarLane_EgoFrt_Raw_ = EstDistCalc(L_VEgo, FrtEst_);
            }

            if (LCP_NrBckObjExstFlg_)
            {
                BckLcpDis_TarLane_EgoBck_Raw_ = EstDistCalc(LCP_NrBckObjSpd_, BckEst_) * k_BA_BNATarLneFctr;

                float CmprsGain = DistCmPresGainCalc(L_VEgo, LCP_NrBckObjSpd_, BNGItr, BckEst_);
                CmprsGain_lcp_bck_bck_ = CmprsGain; // use for ob

                BckLcpDis_TarLane_EgoBck_Raw_ = BckLcpDis_TarLane_EgoBck_Raw_ * CmprsGain;
            }
            else
            {
                // PROTECT
                FrtLcpDis_TarLane_EgoBck_Raw_ = EstDistCalc(L_VEgo, BckEst_) * k_BA_BNATarLneFctr;
            }

            //      debounce work && value gen for logic & ob
            if (BNGItr->m_ActionTypArr.back() != L_ActionType)
            {
                FrtLcpDis_TarLane_EgoFrt_ = k_BA_LCGLCPDisDbSrtGain * FrtLcpDis_TarLane_EgoFrt_Raw_;
                FrtLcpDis_TarLane_EgoBck_ = k_BA_LCGLCPDisDbSrtGain * FrtLcpDis_TarLane_EgoBck_Raw_;
                BckLcpDis_TarLane_EgoFrt_ = k_BA_LCGLCPDisDbSrtGain * BckLcpDis_TarLane_EgoFrt_Raw_;
                BckLcpDis_TarLane_EgoBck_ = k_BA_LCGLCPDisDbSrtGain * BckLcpDis_TarLane_EgoBck_Raw_;
            }
            else
            {
                FrtLcpDis_TarLane_EgoFrt_ = k_BA_LCGLCPDisDbWrkInGain * FrtLcpDis_TarLane_EgoFrt_Raw_;
                FrtLcpDis_TarLane_EgoBck_ = k_BA_LCGLCPDisDbWrkInGain * FrtLcpDis_TarLane_EgoBck_Raw_;
                BckLcpDis_TarLane_EgoFrt_ = k_BA_LCGLCPDisDbWrkInGain * BckLcpDis_TarLane_EgoFrt_Raw_;
                BckLcpDis_TarLane_EgoBck_ = k_BA_LCGLCPDisDbWrkInGain * BckLcpDis_TarLane_EgoBck_Raw_;
            }

            // InterestObjLabel
            if (LCP_EgoFrtObjExstFlg_)
            {
                L_InterestObjIDList.push_back(LCP_EgoFrtObjID_);
            }
            else
            {
                L_InterestObjIDList.push_back(uint32_t(0));
            }
            if (LCP_EgoBckObjExstFlg_)
            {
                L_InterestObjIDList.push_back(LCP_EgoBckObjID_);
            }
            else
            {
                L_InterestObjIDList.push_back(uint32_t(0));
            }
            if (LCP_NrObjExstFlg_)
            {
                L_InterestObjIDList.push_back(LCP_NrObjID_);
            }
            else
            {
                L_InterestObjIDList.push_back(uint32_t(0));
            }
            if (LCP_NrFrtObjExstFlg_)
            {
                L_InterestObjIDList.push_back(LCP_NrFrtObjID_);
            }
            else
            {
                L_InterestObjIDList.push_back(uint32_t(0));
            }
            if (LCP_NrBckObjExstFlg_)
            {
                L_InterestObjIDList.push_back(LCP_NrBckObjID_);
            }
            else
            {
                L_InterestObjIDList.push_back(uint32_t(0));
            }
            // Senario Judge
            float Frt_MovDist = 0;
            float Frt_EgoLneSpace = 0;
            float Frt_EstSpace = 0;
            float Frt_NdSpace = 0;
            float Bck_MovDist = 0;
            float Bck_EgoLneSpace = 0;
            float Bck_EstSpace = 0;
            float Bck_NdSpace = 0;

            float EgoRegionDist = 0;
            float EgoArvEstTm = 0;
            float MovEstSpd_Frt = 0.1;
            float MovEstSpd_Bck = 0.1;
            float LCP_DrvrSetSpd = L_DrvrSetSpd;
            // data process
            if (k_BA_LCGLCPDyaSfDis)
            {
                // spilit frt&bck dist gain in 1117
                if (L_ScnrTyp != BA::ScenarioTyp_MergeIN)
                {
                    LcpEgoLaneSftyDist_frt = k_BA_LCGLCPSftyDist + EstDistCalc(L_VEgo, FrtEst_) * k_BA_BNALcpEgoLneFctr_frt;
                }
                else
                {
                    LcpEgoLaneSftyDist_frt = k_BA_LCGLCPSftyDist + EstDistCalc(L_VEgo, FrtEst_) * k_BA_BNALcpEgoLneFctr_bck;
                }

                LcpEgoLaneSftyDist_bck = k_BA_LCGLCPSftyDist + EstDistCalc(L_VEgo, FrtEst_) * k_BA_BNALcpEgoLneFctr_bck; // need link with LC EgoLneDist Condition
            }
            //  FrtSenario Judge (1,2,5,6)  For Frt Region
            //   Senario 1

            // just for ob
            LCP_Frt_EgoArvEstTmDynThr_ = k_BA_LCGLCPAccelTmThr;
            // judge logic
            if (LCP_NrFrtObjExstFlg_ == false && LCP_NrObjDist_ < 0)
            {
                // Initial
                LCP_Cls_frt_ = 1;
                // Evaluation Parameters Clac
                Frt_MovDist = max(float(FrtLcpDis_TarLane_EgoBck_ + 0.5 * k_BA_LCGEgoLenth + 0.5 * LCP_NrObjLen_ - abs(LCP_NrObjDist_)), k_BA_LCGArvDistPrtctVal);
                if (LCP_EgoFrtObjExstFlg_)
                {
                    Frt_EgoLneSpace = (LCP_EgoFrtObjDist_ - LcpEgoLaneSftyDist_frt) - 0.5 * LCP_EgoFrtObjLen_ - 0.5 * k_BA_LCGEgoLenth;
                }
                else
                {
                    Frt_EgoLneSpace = 1000;
                }
                Frt_EstSpace = 1000;
                Frt_NdSpace = FrtLcpDis_TarLane_EgoBck_;
                EgoRegionDist = abs(LCP_NrObjDist_) - 0.5 * k_BA_LCGEgoLenth - 0.5 * LCP_NrObjLen_;
                if (k_BA_LCGLCPSetLmtOn)
                {
                    MovEstSpd_Frt = min((L_VEgo + k_BA_LCGLCPArvEstEgoAccelSpd), (LCP_DrvrSetSpd / 3.78f));
                }
                else
                {
                    MovEstSpd_Frt = L_VEgo + k_BA_LCGLCPArvEstEgoAccelSpd;
                }
                EgoArvEstTm = abs(Frt_MovDist) / max((MovEstSpd_Frt - LCP_NrObjSpd_), 0.1f);
                L_Red = EgoArvEstTm;
                // JUST for Ob
                LCP_Frt_MovDist_ = Frt_MovDist;
                LCP_Frt_EgoLneSpace_ = Frt_EgoLneSpace;
                LCP_Frt_EstSpace_ = Frt_EstSpace;
                LCP_Frt_NdSpace_ = Frt_NdSpace;
                LCP_Frt_EgoRegionDist_ = EgoRegionDist;
                LCP_Frt_EgoArvEstTm_ = EgoArvEstTm;
                // Region Evaluate Logic
                //  Ego Lne Mov Abty
                if (Frt_MovDist > Frt_EgoLneSpace)
                {
                    Frt_LneChgPrRes1_ = true;
                }
                //  Tar Lne Mov Abty
                if (Frt_NdSpace > Frt_EstSpace)
                {
                    Frt_LneChgPrRes2_ = true;
                }
                //  LC Satsfy
                if (EgoRegionDist > FrtLcpDis_TarLane_EgoBck_Raw_ && (L_VEgo - LCP_NrObjSpd_ > 0.5)) // can not use debounce
                {
                    Frt_LneChgPrRes3_ = true;
                }
                //  Accel Abty
                if (EgoArvEstTm > k_BA_LCGLCPAccelTmThr || EgoArvEstTm < 0)
                {
                    Frt_LneChgPrRes4_ = true;
                }
                // Ego & NrObj Spd Err Protect
                if (L_VEgo < LCP_NrObjSpd_ && abs(LCP_NrObjSpd_ - L_VEgo) > k_BA_LCGLCPFrtSpdErrCdThr)
                {
                    Frt_LneChgPrRes5_ = true;
                }
                // PassageGen
                if (Frt_LneChgPrRes1_ || Frt_LneChgPrRes2_ || Frt_LneChgPrRes3_ || Frt_LneChgPrRes4_ || Frt_LneChgPrRes5_ || CommonResChk(BNGItr, roadModel))
                {
                    LCP_Frt_PassageGenFlg_ = false;
                }
                else
                {
                    LCP_Frt_PassageGenFlg_ = true;
                }
            }
            //   Senario 2
            else if (LCP_NrFrtObjExstFlg_ == false && LCP_NrObjDist_ > 0)
            {
                LCP_Cls_frt_ = 2;
                Frt_MovDist = max(float(FrtLcpDis_TarLane_EgoBck_ + 0.5 * k_BA_LCGEgoLenth + 0.5 * LCP_NrObjLen_ + abs(LCP_NrObjDist_)), k_BA_LCGArvDistPrtctVal);
                if (LCP_EgoFrtObjExstFlg_)
                {
                    Frt_EgoLneSpace = (LCP_EgoFrtObjDist_ - LcpEgoLaneSftyDist_frt) - 0.5 * LCP_EgoFrtObjLen_ - 0.5 * k_BA_LCGEgoLenth;
                }
                else
                {
                    Frt_EgoLneSpace = 1000;
                }
                Frt_EstSpace = 1000;
                Frt_NdSpace = FrtLcpDis_TarLane_EgoBck_;
                EgoRegionDist = abs(LCP_NrObjDist_) - 0.5 * k_BA_LCGEgoLenth - 0.5 * LCP_NrObjLen_;
                if (ADC::common::k_BA_LCGLCPSetLmtOn)
                {
                    MovEstSpd_Frt = min((L_VEgo + k_BA_LCGLCPArvEstEgoAccelSpd), (LCP_DrvrSetSpd / 3.78f));
                }
                else
                {
                    MovEstSpd_Frt = L_VEgo + k_BA_LCGLCPArvEstEgoAccelSpd;
                }
                EgoArvEstTm = abs(Frt_MovDist) / max((MovEstSpd_Frt - LCP_NrObjSpd_), 0.1f);
                L_Red = EgoArvEstTm;
                // JUST for Ob
                LCP_Frt_MovDist_ = Frt_MovDist;
                LCP_Frt_EgoLneSpace_ = Frt_EgoLneSpace;
                LCP_Frt_EstSpace_ = Frt_EstSpace;
                LCP_Frt_NdSpace_ = Frt_NdSpace;
                LCP_Frt_EgoRegionDist_ = EgoRegionDist;
                LCP_Frt_EgoArvEstTm_ = EgoArvEstTm;
                // Region Evaluate Logic
                //  Ego Lne Mov Abty
                if (Frt_MovDist > Frt_EgoLneSpace)
                {
                    Frt_LneChgPrRes1_ = true;
                }
                //  Tar Lne Mov Abty
                if (Frt_NdSpace > Frt_EstSpace)
                {
                    Frt_LneChgPrRes2_ = true;
                }
                //  LC Satsfy
                if (EgoRegionDist > FrtLcpDis_TarLane_EgoBck_Raw_ && (L_VEgo - LCP_NrObjSpd_ > 0.5)) // can not use debounce
                {
                    Frt_LneChgPrRes3_ = true;
                }
                //  Accel Abty
                if (EgoArvEstTm > k_BA_LCGLCPAccelTmThr || EgoArvEstTm < 0)
                {
                    Frt_LneChgPrRes4_ = true;
                }
                // Ego & NrObj Spd Err Protect
                if (L_VEgo < LCP_NrObjSpd_ && abs(LCP_NrObjSpd_ - L_VEgo) > k_BA_LCGLCPFrtSpdErrCdThr)
                {
                    Frt_LneChgPrRes5_ = true;
                }
                // PassageGen
                if (Frt_LneChgPrRes1_ || Frt_LneChgPrRes2_ || Frt_LneChgPrRes3_ || Frt_LneChgPrRes4_ || Frt_LneChgPrRes5_ || CommonResChk(BNGItr, roadModel))
                {
                    LCP_Frt_PassageGenFlg_ = false;
                }
                else
                {
                    LCP_Frt_PassageGenFlg_ = true;
                }
            }
            //   Senario 5
            else if (LCP_NrFrtObjExstFlg_ == true && LCP_NrObjDist_ > 0)
            {
                LCP_Cls_frt_ = 5;
                Frt_MovDist = max(float(FrtLcpDis_TarLane_EgoBck_ + 0.5 * k_BA_LCGEgoLenth + 0.5 * LCP_NrObjLen_ + abs(LCP_NrObjDist_)), k_BA_LCGArvDistPrtctVal);
                if (LCP_EgoFrtObjExstFlg_)
                {
                    Frt_EgoLneSpace = (LCP_EgoFrtObjDist_ - LcpEgoLaneSftyDist_frt) - 0.5 * LCP_EgoFrtObjLen_ - 0.5 * k_BA_LCGEgoLenth;
                }
                else
                {
                    Frt_EgoLneSpace = 1000;
                }
                Frt_EstSpace = LCP_NrFrtObjDist_ - abs(LCP_NrObjDist_) - 0.5 * LCP_NrFrtObjLen_ - 0.5 * LCP_NrObjLen_;
                Frt_NdSpace = FrtLcpDis_TarLane_EgoBck_ + FrtLcpDis_TarLane_EgoFrt_ + k_BA_LCGEgoLenth;
                EgoRegionDist = abs(LCP_NrObjDist_) - 0.5 * k_BA_LCGEgoLenth - 0.5 * LCP_NrObjLen_;
                if (k_BA_LCGLCPSetLmtOn)
                {
                    MovEstSpd_Frt = min((L_VEgo + k_BA_LCGLCPArvEstEgoAccelSpd), (LCP_DrvrSetSpd / 3.78f));
                }
                else
                {
                    MovEstSpd_Frt = L_VEgo + k_BA_LCGLCPArvEstEgoAccelSpd;
                }
                EgoArvEstTm = abs(Frt_MovDist) / max((MovEstSpd_Frt - LCP_NrObjSpd_), 0.1f);
                L_Red = EgoArvEstTm;
                // JUST for Ob
                LCP_Frt_MovDist_ = Frt_MovDist;
                LCP_Frt_EgoLneSpace_ = Frt_EgoLneSpace;
                LCP_Frt_EstSpace_ = Frt_EstSpace;
                LCP_Frt_NdSpace_ = Frt_NdSpace;
                LCP_Frt_EgoRegionDist_ = EgoRegionDist;
                LCP_Frt_EgoArvEstTm_ = EgoArvEstTm;
                // Region Evaluate Logic
                //  Ego Lne Mov Abty
                if (Frt_MovDist > Frt_EgoLneSpace)
                {
                    Frt_LneChgPrRes1_ = true;
                }
                //  Tar Lne Mov Abty
                if (Frt_NdSpace > Frt_EstSpace)
                {
                    Frt_LneChgPrRes2_ = true;
                }
                //  LC Satsfy
                if (EgoRegionDist > BckLcpDis_TarLane_EgoFrt_Raw_ && (L_VEgo < LCP_NrObjSpd_ - 0.5)) // can not use debounce
                {
                    Frt_LneChgPrRes3_ = true;
                }
                //  Accel Abty
                if (EgoArvEstTm > k_BA_LCGLCPAccelTmThr || EgoArvEstTm < 0)
                {
                    Frt_LneChgPrRes4_ = true;
                }
                // Ego & NrObj Spd Err Protect
                if (L_VEgo < LCP_NrObjSpd_ && abs(LCP_NrObjSpd_ - L_VEgo) > k_BA_LCGLCPFrtSpdErrCdThr)
                {
                    Frt_LneChgPrRes5_ = true;
                }
                // PassageGen
                if (Frt_LneChgPrRes1_ || Frt_LneChgPrRes2_ || Frt_LneChgPrRes3_ || Frt_LneChgPrRes4_ || Frt_LneChgPrRes5_ || CommonResChk(BNGItr, roadModel))
                {
                    LCP_Frt_PassageGenFlg_ = false;
                }
                else
                {
                    LCP_Frt_PassageGenFlg_ = true;
                }

                // work to long Action
                if (LCP_Frt_PassageGenFlg_ && LCPActionLongTm(BNGItr))
                {
                }
            }
            //   Senario 6
            else if (LCP_NrFrtObjExstFlg_ == true && LCP_NrObjDist_ < 0)
            {
                LCP_Cls_frt_ = 6;
                Frt_MovDist = max(float(FrtLcpDis_TarLane_EgoBck_ + 0.5 * k_BA_LCGEgoLenth + 0.5 * LCP_NrObjLen_ - abs(LCP_NrObjDist_)), k_BA_LCGArvDistPrtctVal);
                if (LCP_EgoFrtObjExstFlg_)
                {
                    Frt_EgoLneSpace = (LCP_EgoFrtObjDist_ - LcpEgoLaneSftyDist_frt) - 0.5 * LCP_EgoFrtObjLen_ - 0.5 * k_BA_LCGEgoLenth;
                }
                else
                {
                    Frt_EgoLneSpace = 1000;
                }
                Frt_EstSpace = LCP_NrFrtObjDist_ + abs(LCP_NrObjDist_) - 0.5 * LCP_NrFrtObjLen_ - 0.5 * LCP_NrObjLen_;
                Frt_NdSpace = FrtLcpDis_TarLane_EgoBck_ + FrtLcpDis_TarLane_EgoFrt_ + k_BA_LCGEgoLenth;
                EgoRegionDist = abs(LCP_NrObjDist_) - 0.5 * k_BA_LCGEgoLenth - 0.5 * LCP_NrObjLen_;
                if (k_BA_LCGLCPSetLmtOn)
                {
                    MovEstSpd_Frt = min((L_VEgo + k_BA_LCGLCPArvEstEgoAccelSpd), (LCP_DrvrSetSpd / 3.78f));
                }
                else
                {
                    MovEstSpd_Frt = L_VEgo + k_BA_LCGLCPArvEstEgoAccelSpd;
                }
                EgoArvEstTm = abs(Frt_MovDist) / max((MovEstSpd_Frt - LCP_NrObjSpd_), 0.1f);
                L_Red = EgoArvEstTm;
                // JUST for Ob
                LCP_Frt_MovDist_ = Frt_MovDist;
                LCP_Frt_EgoLneSpace_ = Frt_EgoLneSpace;
                LCP_Frt_EstSpace_ = Frt_EstSpace;
                LCP_Frt_NdSpace_ = Frt_NdSpace;
                LCP_Frt_EgoRegionDist_ = EgoRegionDist;
                LCP_Frt_EgoArvEstTm_ = EgoArvEstTm;
                // Region Evaluate Logic
                //  Ego Lne Mov Abty
                if (Frt_MovDist > Frt_EgoLneSpace)
                {
                    Frt_LneChgPrRes1_ = true;
                }
                //  Tar Lne Mov Abty
                if (Frt_NdSpace > Frt_EstSpace)
                {
                    Frt_LneChgPrRes2_ = true;
                }
                //  LC Satsfy
                if (EgoRegionDist > FrtLcpDis_TarLane_EgoBck_Raw_ && (L_VEgo - LCP_NrObjSpd_ > 0.5)) // can not use debounce
                {
                    Frt_LneChgPrRes3_ = true;
                }
                //  Accel Abty
                if (EgoArvEstTm > k_BA_LCGLCPAccelTmThr || EgoArvEstTm < 0)
                {
                    Frt_LneChgPrRes4_ = true;
                }
                // Ego & NrObj Spd Err Protect
                if (L_VEgo < LCP_NrObjSpd_ && abs(LCP_NrObjSpd_ - L_VEgo) > k_BA_LCGLCPFrtSpdErrCdThr)
                {
                    Frt_LneChgPrRes5_ = true;
                }
                // PassageGen
                if (Frt_LneChgPrRes1_ || Frt_LneChgPrRes2_ || Frt_LneChgPrRes3_ || Frt_LneChgPrRes4_ || Frt_LneChgPrRes5_ || CommonResChk(BNGItr, roadModel))
                {
                    LCP_Frt_PassageGenFlg_ = false;
                }
                else
                {
                    LCP_Frt_PassageGenFlg_ = true;
                }
            }
            else // PROTECT
            {
                LCP_Frt_PassageGenFlg_ = false;
            }

            float Frt_EgoArvEstTm = EgoArvEstTm;
            //  BckSenario Judge (3,4,7,8)      For Bck Region
            // data process
            //  add dyn thr logic   0611
            float LCP_Bck_EstArvTmThr = 5; // default
            if (k_BA_LCGLCPBckDynArvEstTmOn)
            {
                MathFcn::LinearIntrPltn<float> BckEstArvTmPltn;
                LCP_Bck_EstArvTmThr = BckEstArvTmPltn.InterPolation(ADC::common::k_BA_LCGLCPBckArvEstTmThrSpdFctr, ADC::common::k_BA_LCGLCPBckDynArvTm, L_VEgo);
                DLOG(INFO) << "LCP_Bck_EstArvTmThr  = " << float(LCP_Bck_EstArvTmThr) << std::endl;
            }
            else
            {
                LCP_Bck_EstArvTmThr = k_BA_LCGLCPDeAccelTmThr;
            }
            // just for ob
            LCP_Bck_EgoArvEstTmDynThr_ = LCP_Bck_EstArvTmThr;
            //   Senario 3

            if (LCP_NrBckObjExstFlg_ == false && LCP_NrObjDist_ > 0)
            {
                LCP_Cls_bck_ = 3;
                Bck_MovDist = max(float(BckLcpDis_TarLane_EgoFrt_ + 0.5 * k_BA_LCGEgoLenth + 0.5 * LCP_NrObjLen_ - abs(LCP_NrObjDist_)), k_BA_LCGArvDistPrtctVal);
                if (LCP_EgoBckObjExstFlg_)
                {
                    Bck_EgoLneSpace = (abs(LCP_EgoBckObjDist_) - LcpEgoLaneSftyDist_bck) - 0.5 * LCP_EgoBckObjLen_ - 0.5 * k_BA_LCGEgoLenth;
                    if (L_ALCSR == eALCSR_Level3 && BNGItr->m_ActionTypArr.back() == L_ActionType)
                    {
                        Bck_EgoLneSpace = Bck_EgoLneSpace * k_BA_LCGLCPEgoLneSpcDbnc;
                        // 0802 reduce egoLneSpace Condition abolition
                    }
                }
                else
                {
                    Bck_EgoLneSpace = 1000;
                }
                Bck_EstSpace = 1000;
                Bck_NdSpace = BckLcpDis_TarLane_EgoFrt_;
                EgoRegionDist = abs(LCP_NrObjDist_) - 0.5 * k_BA_LCGEgoLenth - 0.5 * LCP_NrObjLen_;
                MovEstSpd_Bck = max((L_VEgo - k_BA_LCGLCPArvEstEgoDeAccelSpd), 0.1f);
                EgoArvEstTm = abs(Bck_MovDist) / max((LCP_NrObjSpd_ - MovEstSpd_Bck), 0.1f);
                L_Red = EgoArvEstTm;

                // JUST for Ob
                LCP_Bck_MovDist_ = Bck_MovDist;
                LCP_Bck_EgoLneSpace_ = Bck_EgoLneSpace;
                LCP_Bck_EstSpace_ = Bck_EstSpace;
                LCP_Bck_NdSpace_ = Bck_NdSpace;
                LCP_Bck_EgoRegionDist_ = EgoRegionDist;
                LCP_Bck_EgoArvEstTm_ = EgoArvEstTm;

                // Region Evaluate Logic
                //  Ego Lne Mov Abty
                if (Bck_MovDist > Bck_EgoLneSpace)
                {
                    Bck_LneChgPrRes1_ = true;
                }
                //  Tar Lne Mov Abty
                if (Bck_NdSpace > Bck_EstSpace)
                {
                    Bck_LneChgPrRes2_ = true;
                }
                //  LC Satsfy
                if (EgoRegionDist > BckLcpDis_TarLane_EgoFrt_Raw_ && (L_VEgo < LCP_NrObjSpd_ - 0.5)) // can not use debounce
                {
                    Bck_LneChgPrRes3_ = true;
                }
                //  Accel Abty
                if (EgoArvEstTm > LCP_Bck_EstArvTmThr || EgoArvEstTm < 0)
                {
                    Bck_LneChgPrRes4_ = true;
                }
                // Nr Obj Cond
                if (((LCP_NrObjSpd_ < k_BA_LCGLCPBckScNrObjSpdThr) || (L_VEgo - LCP_NrObjSpd_) > k_BA_LCGLCPBckScNrObjSpdErrThr) && LCP_NrObjExstFlg_)
                {
                    Bck_LneChgPrRes5_ = true;
                }
                // PassageGen
                if (Bck_LneChgPrRes1_ || Bck_LneChgPrRes2_ || Bck_LneChgPrRes3_ || Bck_LneChgPrRes4_ || Bck_LneChgPrRes5_ || CommonResChk(BNGItr, roadModel))
                {
                    LCP_Bck_PassageGenFlg_ = false;
                }
                else
                {
                    LCP_Bck_PassageGenFlg_ = true;
                }
            }
            //      Senario 4
            else if (LCP_NrBckObjExstFlg_ == false && LCP_NrObjDist_ < 0)
            {
                LCP_Cls_bck_ = 4;
                Bck_MovDist = max(float(BckLcpDis_TarLane_EgoFrt_ + 0.5 * k_BA_LCGEgoLenth + 0.5 * LCP_NrObjLen_ + abs(LCP_NrObjDist_)), k_BA_LCGArvDistPrtctVal);
                if (LCP_EgoBckObjExstFlg_)
                {
                    Bck_EgoLneSpace = (abs(LCP_EgoBckObjDist_) - LcpEgoLaneSftyDist_bck) - 0.5 * LCP_EgoBckObjLen_ - 0.5 * k_BA_LCGEgoLenth;
                    if (L_ALCSR == eALCSR_Level3 && BNGItr->m_ActionTypArr.back() == L_ActionType)
                    {
                        Bck_EgoLneSpace = Bck_EgoLneSpace * k_BA_LCGLCPEgoLneSpcDbnc;
                        // 0802 reduce egoLneSpace Condition abolition
                    }
                }
                else
                {
                    Bck_EgoLneSpace = 1000;
                }
                Bck_EstSpace = 1000;
                Bck_NdSpace = BckLcpDis_TarLane_EgoFrt_;
                EgoRegionDist = abs(LCP_NrObjDist_) - 0.5 * k_BA_LCGEgoLenth - 0.5 * LCP_NrObjLen_;
                MovEstSpd_Bck = max((L_VEgo - k_BA_LCGLCPArvEstEgoDeAccelSpd), 0.1f);
                EgoArvEstTm = abs(Bck_MovDist) / max((LCP_NrObjSpd_ - MovEstSpd_Bck), 0.1f);
                L_Red = EgoArvEstTm;
                // JUST for Ob
                LCP_Bck_MovDist_ = Bck_MovDist;
                LCP_Bck_EgoLneSpace_ = Bck_EgoLneSpace;
                LCP_Bck_EstSpace_ = Bck_EstSpace;
                LCP_Bck_NdSpace_ = Bck_NdSpace;
                LCP_Bck_EgoRegionDist_ = EgoRegionDist;
                LCP_Bck_EgoArvEstTm_ = EgoArvEstTm;
                // Region Evaluate Logic
                //  Ego Lne Mov Abty
                if (Bck_MovDist > Bck_EgoLneSpace)
                {
                    Bck_LneChgPrRes1_ = true;
                }
                //  Tar Lne Mov Abty
                if (Bck_NdSpace > Bck_EstSpace)
                {
                    Bck_LneChgPrRes2_ = true;
                }
                //  LC Satsfy
                if (EgoRegionDist > FrtLcpDis_TarLane_EgoBck_Raw_ && (L_VEgo - 0.5 > LCP_NrObjSpd_)) // can not use debounce
                {
                    Bck_LneChgPrRes3_ = true;
                }
                //  Accel Abty
                if (EgoArvEstTm > LCP_Bck_EstArvTmThr || EgoArvEstTm < 0)
                {
                    Bck_LneChgPrRes4_ = true;
                }
                // Nr Obj Cond
                if (((LCP_NrObjSpd_ < k_BA_LCGLCPBckScNrObjSpdThr) || (L_VEgo - LCP_NrObjSpd_) > k_BA_LCGLCPBckScNrObjSpdErrThr) && LCP_NrObjExstFlg_)
                {
                    Bck_LneChgPrRes5_ = true;
                }
                // PassageGen
                if (Bck_LneChgPrRes1_ || Bck_LneChgPrRes2_ || Bck_LneChgPrRes3_ || Bck_LneChgPrRes4_ || Bck_LneChgPrRes5_ || CommonResChk(BNGItr, roadModel))
                {
                    LCP_Bck_PassageGenFlg_ = false;
                }
                else
                {
                    LCP_Bck_PassageGenFlg_ = true;
                }
            }
            //      Senario 7
            else if (LCP_NrBckObjExstFlg_ == true && LCP_NrObjDist_ > 0)
            {
                LCP_Cls_bck_ = 7;
                Bck_MovDist = max(float(BckLcpDis_TarLane_EgoFrt_ + 0.5 * k_BA_LCGEgoLenth + 0.5 * LCP_NrObjLen_ - abs(LCP_NrObjDist_)), k_BA_LCGArvDistPrtctVal);
                if (LCP_EgoBckObjExstFlg_)
                {
                    Bck_EgoLneSpace = (abs(LCP_EgoBckObjDist_) - LcpEgoLaneSftyDist_bck) - 0.5 * LCP_EgoBckObjLen_ - 0.5 * k_BA_LCGEgoLenth;
                    if (L_ALCSR == eALCSR_Level3 && BNGItr->m_ActionTypArr.back() == L_ActionType)
                    {
                        Bck_EgoLneSpace = Bck_EgoLneSpace * k_BA_LCGLCPEgoLneSpcDbnc;
                        // 0802 reduce egoLneSpace Condition abolition
                    }
                }
                else
                {
                    Bck_EgoLneSpace = 1000;
                }
                Bck_EstSpace = abs(LCP_NrBckObjDist_) + abs(LCP_NrObjDist_) - 0.5 * LCP_NrObjLen_ - 0.5 * LCP_NrBckObjLen_;
                Bck_NdSpace = BckLcpDis_TarLane_EgoFrt_ + BckLcpDis_TarLane_EgoBck_ + k_BA_LCGEgoLenth;
                EgoRegionDist = abs(LCP_NrObjDist_) - 0.5 * k_BA_LCGEgoLenth - 0.5 * LCP_NrObjLen_;
                MovEstSpd_Bck = max((L_VEgo - k_BA_LCGLCPArvEstEgoDeAccelSpd), 0.1f);
                EgoArvEstTm = abs(Bck_MovDist) / max((LCP_NrObjSpd_ - MovEstSpd_Bck), 0.1f);
                // JUST for Ob
                LCP_Bck_MovDist_ = Bck_MovDist;
                LCP_Bck_EgoLneSpace_ = Bck_EgoLneSpace;
                LCP_Bck_EstSpace_ = Bck_EstSpace;
                LCP_Bck_NdSpace_ = Bck_NdSpace;
                LCP_Bck_EgoRegionDist_ = EgoRegionDist;
                LCP_Bck_EgoArvEstTm_ = EgoArvEstTm;
                L_Red = EgoArvEstTm;

                // Region Evaluate Logic
                //  Ego Lne Mov Abty
                if (Bck_MovDist > Bck_EgoLneSpace)
                {
                    Bck_LneChgPrRes1_ = true;
                }
                //  Tar Lne Mov Abty
                if (Bck_NdSpace > Bck_EstSpace)
                {
                    Bck_LneChgPrRes2_ = true;
                }
                //  LC Satsfy
                if (EgoRegionDist > BckLcpDis_TarLane_EgoFrt_Raw_ && (L_VEgo < LCP_NrObjSpd_ - 0.5)) // can not use debounce
                {
                    Bck_LneChgPrRes3_ = true;
                }
                //  Accel Abty
                if (EgoArvEstTm > LCP_Bck_EstArvTmThr || EgoArvEstTm < 0)
                {
                    Bck_LneChgPrRes4_ = true;
                }
                // Nr Obj Cond
                if (((LCP_NrObjSpd_ < k_BA_LCGLCPBckScNrObjSpdThr) || (L_VEgo - LCP_NrObjSpd_) > k_BA_LCGLCPBckScNrObjSpdErrThr) && LCP_NrObjExstFlg_)
                {
                    Bck_LneChgPrRes5_ = true;
                }
                // PassageGen
                if (Bck_LneChgPrRes1_ || Bck_LneChgPrRes2_ || Bck_LneChgPrRes3_ || Bck_LneChgPrRes4_ || Bck_LneChgPrRes5_ || CommonResChk(BNGItr, roadModel))
                {
                    LCP_Bck_PassageGenFlg_ = false;
                }
                else
                {
                    LCP_Bck_PassageGenFlg_ = true;
                }
            }
            //      Senario 8
            else if (LCP_NrBckObjExstFlg_ == true && LCP_NrObjDist_ < 0)
            {
                LCP_Cls_bck_ = 8;
                Bck_MovDist = max(float(BckLcpDis_TarLane_EgoFrt_ + 0.5 * k_BA_LCGEgoLenth + 0.5 * LCP_NrObjLen_ + abs(LCP_NrObjDist_)), k_BA_LCGArvDistPrtctVal);
                if (LCP_EgoBckObjExstFlg_)
                {
                    Bck_EgoLneSpace = (abs(LCP_EgoBckObjDist_) - LcpEgoLaneSftyDist_bck) - 0.5 * LCP_EgoBckObjLen_ - 0.5 * k_BA_LCGEgoLenth;
                    if (L_ALCSR == eALCSR_Level3 && BNGItr->m_ActionTypArr.back() == L_ActionType)
                    {
                        Bck_EgoLneSpace = Bck_EgoLneSpace * k_BA_LCGLCPEgoLneSpcDbnc;
                        // 0802 reduce egoLneSpace Condition abolition
                    }
                }
                else
                {
                    Bck_EgoLneSpace = 1000;
                }
                Bck_EstSpace = abs(LCP_NrBckObjDist_) - abs(LCP_NrObjDist_) - 0.5 * LCP_NrObjLen_ - 0.5 * LCP_NrBckObjLen_;
                Bck_NdSpace = BckLcpDis_TarLane_EgoFrt_ + BckLcpDis_TarLane_EgoBck_ + k_BA_LCGEgoLenth;
                EgoRegionDist = abs(LCP_NrObjDist_) - 0.5 * k_BA_LCGEgoLenth - 0.5 * LCP_NrObjLen_;
                MovEstSpd_Bck = max((L_VEgo - k_BA_LCGLCPArvEstEgoDeAccelSpd), 0.1f);
                EgoArvEstTm = abs(Bck_MovDist) / max((LCP_NrObjSpd_ - MovEstSpd_Bck), 0.1f);
                L_Red = EgoArvEstTm;

                // JUST for Ob
                LCP_Bck_MovDist_ = Bck_MovDist;
                LCP_Bck_EgoLneSpace_ = Bck_EgoLneSpace;
                LCP_Bck_EstSpace_ = Bck_EstSpace;
                LCP_Bck_NdSpace_ = Bck_NdSpace;
                LCP_Bck_EgoRegionDist_ = EgoRegionDist;
                LCP_Bck_EgoArvEstTm_ = EgoArvEstTm;
                // Region Evaluate Logic
                //  Ego Lne Mov Abty
                if (Bck_MovDist > Bck_EgoLneSpace)
                {
                    Bck_LneChgPrRes1_ = true;
                }
                //  Tar Lne Mov Abty
                if (Bck_NdSpace > Bck_EstSpace)
                {
                    Bck_LneChgPrRes2_ = true;
                }
                //  LC Satsfy
                if (EgoRegionDist > FrtLcpDis_TarLane_EgoBck_Raw_ && (L_VEgo - 0.5 > LCP_NrObjSpd_)) // can not use debounce
                {
                    Bck_LneChgPrRes3_ = true;
                }
                //  Accel Abty
                if (EgoArvEstTm > LCP_Bck_EstArvTmThr || EgoArvEstTm < 0)
                {
                    Bck_LneChgPrRes4_ = true;
                }
                // Nr Obj Cond
                if (((LCP_NrObjSpd_ < k_BA_LCGLCPBckScNrObjSpdThr) || (L_VEgo - LCP_NrObjSpd_) > k_BA_LCGLCPBckScNrObjSpdErrThr) && LCP_NrObjExstFlg_)
                {
                    Bck_LneChgPrRes5_ = true;
                }
                // PassageGen
                if (Bck_LneChgPrRes1_ || Bck_LneChgPrRes2_ || Bck_LneChgPrRes3_ || Bck_LneChgPrRes4_ || Bck_LneChgPrRes5_ || CommonResChk(BNGItr, roadModel))
                {
                    LCP_Bck_PassageGenFlg_ = false;
                }
                else
                {
                    LCP_Bck_PassageGenFlg_ = true;
                }
            }
            else
            {
                LCP_Bck_PassageGenFlg_ = false;
            }

            float Bck_EgoArvEstTm = EgoArvEstTm;

            DLOG(INFO) << "LCP_Cls_bck_  = " << int(LCP_Cls_bck_) << std::endl;
            DLOG(INFO) << "LCP_Bck_MovDist_  = " << float(LCP_Bck_MovDist_) << std::endl;
            DLOG(INFO) << "LCP_Bck_EgoLneSpace_  = " << float(LCP_Bck_EgoLneSpace_) << std::endl;
            DLOG(INFO) << "LCP_Bck_EstSpace_  = " << float(LCP_Bck_EstSpace_) << std::endl;
            DLOG(INFO) << "LCP_Bck_NdSpace_  = " << float(LCP_Bck_NdSpace_) << std::endl;
            DLOG(INFO) << "LCP_Bck_EgoRegionDist_  = " << float(LCP_Bck_EgoRegionDist_) << std::endl;
            DLOG(INFO) << "LCP_Bck_EgoArvEstTm_  = " << float(LCP_Bck_EgoArvEstTm_) << std::endl;

            DLOG(INFO) << "Bck_LneChgPrRes1_  = " << int(Bck_LneChgPrRes1_) << std::endl;
            DLOG(INFO) << "Bck_LneChgPrRes2_  = " << int(Bck_LneChgPrRes2_) << std::endl;
            DLOG(INFO) << "Bck_LneChgPrRes3_  = " << int(Bck_LneChgPrRes3_) << std::endl;
            DLOG(INFO) << "Bck_LneChgPrRes4_  = " << int(Bck_LneChgPrRes4_) << std::endl;
            DLOG(INFO) << "Bck_LneChgPrRes5_  = " << int(Bck_LneChgPrRes5_) << std::endl;

            // PassageGen Process

            // Duringtime chk & action 1110

            // chk during time
            enum BA::LCPSts Frt_LCPState = BA::LCPSts_Normal;
            enum BA::LCPSts Bck_LCPState = BA::LCPSts_Normal;
            float NeedMovDist = 0;

            if (LCP_Frt_PassageGenFlg_)
            {
                if (LCPActionLongTm(BNGItr))
                {
                    if (Frt_LCPState == BA::LCPSts_Normal || Frt_LCPState == BA::LCPSts_Hold)
                    {
                        if (L_VEgo - LCP_NrObjSpd_ < 1.38 || Frt_EgoArvEstTm > 3 || LCP_Frt_MovDist_ > 6)
                        {
                            Frt_LCPState = BA::LCPSts_OverLock;
                            NeedMovDist = Frt_MovDist;
                            DLOG(INFO) << "Frt_LCPOverLock  = " << std::endl;
                        }
                    }
                    else if (Frt_LCPState == BA::LCPSts_OverLock)
                    {
                        if (L_VEgo - LCP_NrObjSpd_ > 2.5 || Frt_EgoArvEstTm < 1.5 || LCP_Frt_MovDist_ < 1.5)
                        {
                            Frt_LCPState = BA::LCPSts_Normal;
                            NeedMovDist = Frt_MovDist;
                            DLOG(INFO) << "Frt_LCPOverUnlock  = " << std::endl;
                        }
                    }
                }
                else
                {
                    if (Frt_LCPState == BA::LCPSts_Normal)
                    {
                        if (L_VEgo - LCP_NrObjSpd_ > 2.77 && Frt_EgoArvEstTm < 3 && LCP_Frt_MovDist_ < 12)
                        {
                            Frt_LCPState = BA::LCPSts_Hold;
                            NeedMovDist = Frt_MovDist;
                        }
                    }
                    else if (Frt_LCPState == BA::LCPSts_Hold)
                    {
                        if (L_VEgo - LCP_NrObjSpd_ < 1.35 || Frt_EgoArvEstTm > 5 || LCP_Frt_MovDist_ > 15)
                        {
                            Frt_LCPState = BA::LCPSts_Normal;
                            NeedMovDist = Frt_MovDist;
                        }
                    }
                }
            }

            if (LCP_Bck_PassageGenFlg_)
            {
                if (LCPActionLongTm(BNGItr))
                {
                    if (Bck_LCPState == BA::LCPSts_Normal || Bck_LCPState == BA::LCPSts_Hold)
                    {
                        if (LCP_NrObjSpd_ - L_VEgo < 1.38 || Bck_EgoArvEstTm > 3 || LCP_Bck_MovDist_ > 6)
                        {
                            Bck_LCPState = BA::LCPSts_AvoidLock;
                            NeedMovDist = Bck_MovDist;
                            DLOG(INFO) << "Bck_LCPOverLock  = " << std::endl;
                        }
                    }
                    else if (Bck_LCPState == BA::LCPSts_AvoidLock)
                    {
                        if (LCP_NrObjSpd_ - L_VEgo > 2.5 || Bck_EgoArvEstTm < 1.5 || LCP_Bck_MovDist_ < 1.5)
                        {
                            Bck_LCPState = BA::LCPSts_Normal;
                            NeedMovDist = Bck_MovDist;
                            DLOG(INFO) << "Bck_LCPOverUnlock= " << std::endl;
                        }
                    }
                }
                else
                {
                    if (Bck_LCPState == BA::LCPSts_Normal)
                    {
                        if (LCP_NrObjSpd_ - L_VEgo > 2.77 && Bck_EgoArvEstTm < 3 && LCP_Bck_MovDist_ < 12)
                        {
                            Frt_LCPState = BA::LCPSts_Hold;
                            NeedMovDist = Bck_MovDist;
                        }
                    }
                    else if (Bck_LCPState == BA::LCPSts_Hold)
                    {
                        if (LCP_NrObjSpd_ - L_VEgo < 1.38 || Bck_EgoArvEstTm > 5 && LCP_Bck_MovDist_ > 15)
                        {
                            Frt_LCPState = BA::LCPSts_Normal;
                            NeedMovDist = Bck_MovDist;
                        }
                    }
                }
            }

            // record for OB
            Frt_LCPState_ = Frt_LCPState;
            Bck_LCPState_ = Bck_LCPState;

            //  Frt Region
            // init LCP_Frt Obj Gen
            L_TempObjID = 0;
            L_TempObjDist = 1000;
            L_TempObjSpd = 100;
            if (LCP_Frt_PassageGenFlg_)
            {
                if (LCP_NrFrtObjExstFlg_)
                {
                    L_TempObjID = LCP_NrFrtObjID_;
                    L_TempObjDist = LCP_NrFrtObjDist_;
                    L_TempObjSpd = LCP_NrFrtObjSpd_;
                }
                else
                {
                    L_TempObjID = 0;
                    L_TempObjDist = 1000;
                    L_TempObjSpd = 100;
                }
                // Passage Push
                // L_DrvrSetSpd = LCP_DrvrSetSpd + k_BA_LCGLCPSpdUpTest; // only for lcp test
                PassageGenPush(index_, BA_StepNum, roadModel);
                PassageOBGenPush(index_, BA_StepNum, roadModel, passageObLst);
            }
            else
            {
                L_TempObjID = 0;
                L_TempObjDist = 1000;
                L_TempObjSpd = 100;
                L_DrvrSetSpd = LCP_DrvrSetSpd + k_BA_LCGLCPSpdUpTest; // only for lcp test
                PassageOBGenPush(index_, BA_StepNum, roadModel, passageObLst);
            }
            //  Bck Region
            // init LCP_Bck Obj Gen
            L_TempObjID = 0;
            L_TempObjDist = 1000;
            L_TempObjSpd = 100;
            if (LCP_Bck_PassageGenFlg_)
            {
                L_TempObjID = LCP_NrObjID_;
                L_TempObjDist = LCP_NrObjDist_;
                L_TempObjSpd = LCP_NrObjSpd_;
                // Passage Push
                DLOG(INFO) << "LCP_InterestObjIDList Size = " << int(L_InterestObjIDList.size()) << std::endl;
                L_DrvrSetSpd = LCP_DrvrSetSpd - k_BA_LCGLCPSpdDnTest; // only for lcp test
                PassageGenPush(index_, BA_StepNum, roadModel);
                PassageOBGenPush(index_, BA_StepNum, roadModel, passageObLst);
            }
            else
            {
                L_TempObjID = 0;
                L_TempObjDist = 1000;
                L_TempObjSpd = 100;
                PassageOBGenPush(index_, BA_StepNum, roadModel, passageObLst);
            }
        }
        // PROTECT
        else
        {
            L_TempObjID = 0;
            L_TempObjDist = 1000; // Protect For No LCP Action useful
            L_TempObjSpd = 100;
        }

        // reset some info
        L_InterestObjIDList.clear();
    }

    // SubFcn FOR Passage Info & Gen & Push   Sevice for PART II

    void LgtCrdorGen::PassageGenPush(int &index_, int BA_StepNum, RoadInfo &roadModel)
    {
        // index cout
        index_++;

        // LgtInfoGenWork
        LgtInfoCalc();

        // Passage Gen&push
        Passage L_Passage_;
        UpdatePassageInfo(index_, BA_StepNum, L_Passage_);
        roadModel.passage_list.push_back(L_Passage_);

        // Chk&Push First Step Passage for Control
        if (L_BA_StepNum == 0) // chg 20211202
        {
            L_PassageFirstStep.push_back(L_Passage_);
        }
    }

    void LgtCrdorGen::PassageOBGenPush(int &index_, int BA_StepNum, RoadInfo &roadModel, vector<DM::Passageob> &passageObLst)
    {
        // index cout
        // index_++;    index can not use for ob
        if (L_BA_StepNum == 0) // chg 20211202
        {
            LgtInfoCalc();

            // Passage Gen&push
            DM::Passageob L_PassageOb;
            UpdatePassageObInfo(index_, BA_StepNum, L_PassageOb);
            passageObLst.push_back(L_PassageOb);
        }
    }

    void LgtCrdorGen::LgtInfoCalc()
    {
        // RefGainCalc
        //  TJA Test use Lv1
        MathFcn::LinearIntrPltn<float> Tau;
        // MathFcn::LinearIntrPltn<float> D0;
        this->L_EgoLaneTau = Tau.InterPolation(ADC::common::k_BA_LCGDsrdDistLv1Spd, ADC::common::k_BA_LCGDsrdDistLv1, L_VEgo);

        this->L_EgoLaneD0 = k_BA_LCGEgoLaneD0;
        this->L_SideLaneTau = k_BA_LCGSideLaneTau;
        this->L_SideLaneD0 = k_BA_LCGSideLaneD0;

        float DesirDistGain = 1; // 0624 add   for compress follow distance
        if (L_ActionType == BA::BA_ActionTyp_LeftLaneChange || L_ActionType == BA::BA_ActionTyp_RightLaneChange)
        {
            DesirDistGain = k_BA_BNATarLneFctr;
        }
        else if (L_ActionType == BA::BA_ActionTyp_LeftLaneChangePrepare || L_ActionType == BA::BA_ActionTyp_RightLaneChangePrepare)
        {
            DesirDistGain = k_BA_BNAEgoLneFctr;
        }
        else
        {
            DesirDistGain = 1;
        }

        // DsrdSVCalc
        if (L_TempObjID != int(0))
        {
            // this->L_DesireDist = L_VEgo * L_EgoLaneTau + L_EgoLaneD0;
            this->L_DesireDist = EstDistCalc(L_VEgo, FrtEst_) * DesirDistGain; // merge to lgt table distance  0624
                                                                               // DLOG(INFO) << "L_DesireDist = " << float(L_DesireDist) << std::endl;
            // if(L_DesireDist < 0 )
            // {
            // DLOG(INFO) << "SB  " << std::endl;
            // }
            this->L_Blue = L_TempObjDist - L_DesireDist;
        }
        else
        {
            this->L_DesireDist = 1000;
            this->L_Blue = 1000;
        }

        // RefBordersCalc
        if (L_TempObjID != int(0))
        {
            this->L_Yellow = L_TempObjDist - L_VEgo * L_EgoLaneTau * k_BA_LCGYellowGain - L_EgoLaneD0;
            //            this->L_Red = L_TempObjDist - L_EgoLaneD0;
        }
        else
        {
            this->L_Yellow = 1000;
            //            this->L_Red = 1000;
        }

        // SetSpd
        L_SpdLimit = L_DrvrSetSpd;

        // DsrdSpd
        if (L_TempObjID != int(0))
        {
            this->L_DesireSpd = L_TempObjSpd;
        }
        else
        {
            this->L_DesireSpd = L_DrvrSetSpd;
        }
    }

    void LgtCrdorGen::UpdatePassageInfo(int &index_, int BA_StepNum, Passage &L_Passage)
    {
        L_Passage.corridor_id = L_Corridor.corridor_id;
        L_Passage.passage_id.x = BA_StepNum + 1; // add plus one
        L_Passage.passage_id.y = index_;
        L_Passage.action_type = L_ActionType;
        L_Passage.duration_time = L_ActionTm;
        L_Passage.longt_info.desired_distance = L_Blue;
        L_Passage.longt_info.desired_speed = L_DesireSpd;
        L_Passage.longt_info.set_speed = L_SpdLimit;
        L_Passage.longt_info.set_distance = 0; // temp set to 0
        L_Passage.longt_info.yellow_border_distance = L_Yellow;
        L_Passage.longt_info.red_border_distance = L_Red;
        L_Passage.longt_info.target_object_id = L_TempObjID;
        L_Passage.v_ego = L_VEgo;

        // use for passage feature tag  0512
        L_Passage.feature_label = int(L_Corridor.feature_tag);

        // use for Senario find $Cost Calc     0314 add
        L_Passage.lc_cls = LC_Cls_;
        if (LCP_Cls_frt_ != int(0))
        {
            L_Passage.lcp_cls = LCP_Cls_frt_;
        }
        else
        {
            L_Passage.lcp_cls = LCP_Cls_bck_;
        }

        // use for Spd Limit
        L_Passage.longt_info.curv_spd_limit_dist = 0;
        L_Passage.longt_info.curv_spd_limit_val = 0;

        L_Passage.longt_info.sign_spd_limit_id_01 = L_SignSpdLmtInfo01.m_SignSpdLmtID;
        L_Passage.longt_info.sign_spd_limit_dist_01 = L_SignSpdLmtInfo01.m_SignSpdLmtDist;
        L_Passage.longt_info.sign_spd_limit_val_01 = L_SignSpdLmtInfo01.m_SignSpdLmtVal;
        L_Passage.longt_info.sign_spd_limit_id_02 = L_SignSpdLmtInfo02.m_SignSpdLmtID;
        L_Passage.longt_info.sign_spd_limit_dist_02 = L_SignSpdLmtInfo02.m_SignSpdLmtDist;
        L_Passage.longt_info.sign_spd_limit_val_02 = L_SignSpdLmtInfo02.m_SignSpdLmtVal;
        L_Passage.longt_info.spd_limit_id_last_cycle = L_LastCycleSpdLmtID;
        L_Passage.longt_info.spd_limit_type_last_cycle = L_LastCycleSpdLmtTyp;
        L_Passage.longt_info.spd_limit_flg_last_cycle = L_LastCycleSpdLmtFlg;

        //  Inteset OBJ push , for PD Cost
        if (!L_InterestObjIDList.empty())
        {
            int Num = L_InterestObjIDList.size();
            for (int i = 0; i < Num; i++)
            {
                L_Passage.interest_obj_id_list.push_back(L_InterestObjIDList[i]);
            }
            DLOG(INFO) << "InterestObjIDList Size = " << int(L_InterestObjIDList.size()) << std::endl;
        }
        else
        {
            DLOG(INFO) << "InterestObjIDList is Empty!!! = " << std::endl;
        }
    }
    void LgtCrdorGen::UpdatePassageObInfo(int &index_, int BA_StepNum, DM::Passageob &PassageOb)
    {
        PassageOb.corridor_id = L_Corridor.corridor_id;
        PassageOb.passage_id.x = BA_StepNum + 1; // add plus one
        PassageOb.passage_id.y = index_;
        PassageOb.action_type = L_ActionType;
        PassageOb.duration_time = L_ActionTm;
        PassageOb.longt_info.desired_distance = L_Blue;
        PassageOb.longt_info.desired_speed = L_DesireSpd;
        PassageOb.longt_info.set_speed = L_SpdLimit;
        PassageOb.longt_info.set_distance = 0; // temp set to 0
        PassageOb.longt_info.yellow_border_distance = L_Yellow;
        PassageOb.longt_info.red_border_distance = L_Red;
        PassageOb.longt_info.target_object_id = L_TempObjID;

        // use for Cmprs Gain Ob
        // CmprsGain_lc_tar_frt_ = round(CmprsGain_lc_tar_frt_ * 10) / (float(10.0));
        // CmprsGain_lc_tar_bck_ = round(CmprsGain_lc_tar_bck_ * 10) / (float(10.0));
        // CmprsGain_lcp_frt_frt_ = round(CmprsGain_lcp_frt_frt_ * 10) / (float(10.0));
        // CmprsGain_lcp_frt_bck_ = round(CmprsGain_lcp_frt_bck_ * 10) / (float(10.0));
        // CmprsGain_lcp_bck_frt_ = round(CmprsGain_lcp_bck_frt_ * 10) / (float(10.0));
        // CmprsGain_lcp_bck_bck_ = round(CmprsGain_lcp_bck_bck_ * 10) / (float(10.0));

        CmprsGain_lc_tar_frt_ = CmprsGain_lc_tar_frt_;
        CmprsGain_lc_tar_bck_ = CmprsGain_lc_tar_bck_;
        CmprsGain_lcp_frt_frt_ = CmprsGain_lcp_frt_frt_;
        CmprsGain_lcp_frt_bck_ = CmprsGain_lcp_frt_bck_;
        CmprsGain_lcp_bck_frt_ = CmprsGain_lcp_bck_frt_;
        CmprsGain_lcp_bck_bck_ = CmprsGain_lcp_bck_bck_;

        PassageOb.longt_info.sign_spd_limit_dist_01 = CmprsGain_lcp_frt_frt_;
        PassageOb.longt_info.sign_spd_limit_dist_02 = CmprsGain_lcp_frt_bck_;
        PassageOb.longt_info.sign_spd_limit_val_01 = CmprsGain_lcp_bck_frt_;
        PassageOb.longt_info.sign_spd_limit_val_02 = CmprsGain_lcp_bck_bck_;
        PassageOb.longt_info.curv_spd_limit_dist = CmprsGain_lc_tar_frt_;
        PassageOb.longt_info.curv_spd_limit_val = CmprsGain_lc_tar_bck_;
        PassageOb.longt_info.set_distance = int(Frt_LCPState_);
        PassageOb.longt_info.set_speed = int(Bck_LCPState_);

        // for lc obj info ob
        PassageOb.lc_ego_frt_obj_exist_flg = LC_EgoFrtObjExstFlg_;
        PassageOb.lc_ego_frt_obj_id = LC_EgoFrtObjID_;
        PassageOb.lc_ego_frt_obj_dist = LC_EgoFrtObjDist_;
        PassageOb.lc_ego_frt_obj_spd = LC_EgoFrtObjSpd_;
        PassageOb.lc_ego_frt_obj_len = LC_EgoFrtObjLen_;
        PassageOb.lc_ego_frt_obj_cls = LC_EgoFrtObjCls_;

        PassageOb.lc_tar_frt_obj_exist_flg = LC_TarFrtObjExstFlg_;
        PassageOb.lc_tar_frt_obj_id = LC_TarFrtObjID_;
        PassageOb.lc_tar_frt_obj_dist = LC_TarFrtObjDist_;
        PassageOb.lc_tar_frt_obj_spd = LC_TarFrtObjSpd_;
        PassageOb.lc_tar_frt_obj_len = LC_TarFrtObjLen_;
        PassageOb.lc_tar_frt_obj_cls = LC_TarFrtObjCls_;

        PassageOb.lc_tar_bck_obj_exist_flg = LC_TarBckObjExstFlg_;
        PassageOb.lc_tar_bck_obj_id = LC_TarBckObjID_;
        PassageOb.lc_tar_bck_obj_dist = LC_TarBckObjDist_;
        PassageOb.lc_tar_bck_obj_spd = LC_TarBckObjSpd_;
        PassageOb.lc_tar_bck_obj_len = LC_TarBckObjLen_;
        PassageOb.lc_tar_bck_obj_cls = LC_TarBckObjCls_;

        // for Lc Obj Space&Trigger OB
        PassageOb.lc_passagegenflg = LC_PassageGenFlg_;
        PassageOb.alcdis_egolane = AlcDis_EgoLane_;
        PassageOb.realcdis_egolane = reAlcDis_EgoLane_;
        PassageOb.alcdis_tarlane_frt = AlcDis_TarLane_frt_;
        PassageOb.realcdis_tarlane_frt = reAlcDis_TarLane_frt_;
        PassageOb.alcdis_tarlane_bck = AlcDis_TarLane_bck_;
        PassageOb.realcdis_tarlane_bck = reAlcDis_TarLane_bck_;
        PassageOb.lc_tar_frt_obj_dist_nrst = LC_TarFrtObjDistNrst_;
        PassageOb.lc_tar_bck_obj_dist_nrst = LC_TarBckObjDistNrst_;
        PassageOb.lc_lne_chg_res0 = LneChgRes0_;
        PassageOb.lc_lne_chg_res1 = LneChgRes1_;
        PassageOb.lc_lne_chg_res2 = LneChgRes2_;
        PassageOb.lc_lne_chg_res3 = LneChgRes3_;
        PassageOb.lc_cls = LC_Cls_;
        // for inteset OBJ ob
        if (!L_InterestObjIDList.empty())
        {
            int Num = L_InterestObjIDList.size();
            for (int i = 0; i < Num; i++)
            {
                PassageOb.interest_obj_id_list.push_back(L_InterestObjIDList[i]);
            }
        }

        // for LCP Obj Info OB
        PassageOb.lcp_ego_frt_obj_exist_flg = LCP_EgoFrtObjExstFlg_;
        PassageOb.lcp_ego_frt_obj_id = LCP_EgoFrtObjID_;
        PassageOb.lcp_ego_frt_obj_dist = LCP_EgoFrtObjDist_;
        PassageOb.lcp_ego_frt_obj_spd = LCP_EgoFrtObjSpd_;
        PassageOb.lcp_ego_frt_obj_len = LCP_EgoFrtObjLen_;
        PassageOb.lcp_ego_frt_obj_cls = LCP_EgoFrtObjCls_;

        PassageOb.lcp_ego_bck_obj_exist_flg = LCP_EgoBckObjExstFlg_;
        PassageOb.lcp_ego_bck_obj_id = LCP_EgoBckObjID_;
        PassageOb.lcp_ego_bck_obj_dist = LCP_EgoBckObjDist_;
        PassageOb.lcp_ego_bck_obj_spd = LCP_EgoBckObjSpd_;
        PassageOb.lcp_ego_bck_obj_len = LCP_EgoBckObjLen_;
        PassageOb.lcp_ego_bck_obj_cls = LCP_EgoBckObjCls_;

        PassageOb.lcp_nr_obj_exist_flg = LCP_NrObjExstFlg_;
        PassageOb.lcp_nr_obj_id = LCP_NrObjID_;
        PassageOb.lcp_nr_obj_dist = LCP_NrObjDist_;
        PassageOb.lcp_nr_obj_spd = LCP_NrObjSpd_;
        PassageOb.lcp_nr_obj_len = LCP_NrObjLen_;
        PassageOb.lcp_nr_obj_cls = LCP_NrObjCls_;

        PassageOb.lcp_nr_frt_obj_exist_flg = LCP_NrFrtObjExstFlg_;
        PassageOb.lcp_nr_frt_obj_id = LCP_NrFrtObjID_;
        PassageOb.lcp_nr_frt_obj_dist = LCP_NrFrtObjDist_;
        PassageOb.lcp_nr_frt_obj_spd = LCP_NrFrtObjSpd_;
        PassageOb.lcp_nr_frt_obj_len = LCP_NrFrtObjLen_;
        PassageOb.lcp_nr_frt_obj_cls = LCP_NrFrtObjCls_;

        PassageOb.lcp_nr_bck_obj_exist_flg = LCP_NrBckObjExstFlg_;
        PassageOb.lcp_nr_bck_obj_id = LCP_NrBckObjID_;
        PassageOb.lcp_nr_bck_obj_dist = LCP_NrBckObjDist_;
        PassageOb.lcp_nr_bck_obj_spd = LCP_NrBckObjSpd_;
        PassageOb.lcp_nr_bck_obj_len = LCP_NrBckObjLen_;
        PassageOb.lcp_nr_bck_obj_cls = LCP_NrBckObjCls_;

        // For LCP Obj Space&Trigger OB
        PassageOb.lcp_frt_passagegenflg = LCP_Frt_PassageGenFlg_;
        PassageOb.lcp_bck_passagegenflg = LCP_Bck_PassageGenFlg_;
        PassageOb.frt_lcp_dis_tarlane_egofrt_raw = FrtLcpDis_TarLane_EgoFrt_Raw_;
        PassageOb.frt_lcp_dis_tarlane_egobck_raw = FrtLcpDis_TarLane_EgoBck_Raw_;
        PassageOb.bck_lcp_dis_tarlane_egofrt_raw = BckLcpDis_TarLane_EgoFrt_Raw_;
        PassageOb.bck_lcp_dis_tarlane_egobck_raw = BckLcpDis_TarLane_EgoBck_Raw_;
        PassageOb.frt_lcp_dis_tarlane_egofrt = FrtLcpDis_TarLane_EgoFrt_;
        PassageOb.frt_lcp_dis_tarlane_egobck = FrtLcpDis_TarLane_EgoBck_;
        PassageOb.bck_lcp_dis_tarlane_egofrt = BckLcpDis_TarLane_EgoFrt_;
        PassageOb.bck_lcp_dis_tarlane_egobck = BckLcpDis_TarLane_EgoBck_;
        PassageOb.lcp_cls_frt = LCP_Cls_frt_;
        PassageOb.lcp_cls_bck = LCP_Cls_bck_;
        PassageOb.lcp_frt_lne_chg_pr_res1 = Frt_LneChgPrRes1_;
        PassageOb.lcp_frt_lne_chg_pr_res2 = Frt_LneChgPrRes2_;
        PassageOb.lcp_frt_lne_chg_pr_res3 = Frt_LneChgPrRes3_;
        PassageOb.lcp_frt_lne_chg_pr_res4 = Frt_LneChgPrRes4_;
        PassageOb.lcp_bck_lne_chg_pr_res1 = Bck_LneChgPrRes1_;
        PassageOb.lcp_bck_lne_chg_pr_res2 = Bck_LneChgPrRes2_;
        PassageOb.lcp_bck_lne_chg_pr_res3 = Bck_LneChgPrRes3_;
        PassageOb.lcp_bck_lne_chg_pr_res4 = Bck_LneChgPrRes4_;
        PassageOb.lcp_frt_mov_dist = LCP_Frt_MovDist_;
        PassageOb.lcp_frt_ego_lne_space = LCP_Frt_EgoLneSpace_;
        PassageOb.lcp_frt_est_space = LCP_Frt_EstSpace_;
        PassageOb.lcp_frt_nd_space = LCP_Frt_NdSpace_;
        PassageOb.lcp_bck_mov_dist = LCP_Bck_MovDist_;
        PassageOb.lcp_bck_ego_lne_space = LCP_Bck_EgoLneSpace_;
        PassageOb.lcp_bck_est_space = LCP_Bck_EstSpace_;
        PassageOb.lcp_bck_nd_space = LCP_Bck_NdSpace_;
        // merge est time & dynamic thr into one data  0614
        float LCP_Frt_EgoArvEstTmRealPart = round((min(LCP_Frt_EgoArvEstTm_, float(30.0))) * 10) / float(10.0);
        float LCP_Frt_EgoArvEstTmThrPart = round(min(LCP_Frt_EgoArvEstTmDynThr_, float(30.0)) * 10) / float(10.0);
        PassageOb.lcp_frt_ego_arv_est_tm = LCP_Frt_EgoArvEstTmRealPart * 10 + LCP_Frt_EgoArvEstTmThrPart * 10000;
        // PassageOb.lcp_bck_ego_arv_est_tm = min(LCP_Bck_EgoArvEstTm_ , 30);
        float LCP_Bck_EgoArvEstTmRealPart = round((min(LCP_Bck_EgoArvEstTm_, float(30.0))) * 10) / float(10.0);
        float LCP_Bck_EgoArvEstTmThrPart = round(min(LCP_Bck_EgoArvEstTmDynThr_, float(30.0)) * 10) / float(10.0);
        PassageOb.lcp_bck_ego_arv_est_tm = LCP_Bck_EgoArvEstTmRealPart * 10 + LCP_Bck_EgoArvEstTmThrPart * 10000;

        PassageOb.lcp_frt_ego_region_dist = LCP_Frt_EgoRegionDist_;
        PassageOb.lcp_bck_ego_region_dist = LCP_Bck_EgoRegionDist_;

        // for LCP Res Ref Chk //0611
        // Passage.lcp_bck_ego_arv_est_tm_thr = LCP_Bck_EgoArvEstTmDynThr_;
        // //JUST FOR OB
        // if(PassageOb.passage_id.x == 1)
        // {
        //     std::cout<< "PassageOb_Action:"<< int(PassageOb.action_type)<< std::endl;
        //     std::cout<< "PassageOb_LCGen:"<< int(PassageOb.lc_passagegenflg)<< std::endl;
        //     std::cout<< "PassageOb_LCPFGen:"<< int(PassageOb.lcp_frt_passagegenflg)<< std::endl;
        //     std::cout<< "PassageOb_LCPBGen:"<< int(PassageOb.lcp_bck_passagegenflg)<< std::endl;
        // }
    }

    void LgtCrdorGen::DoubleObjLabel(Corridor &Corridor)
    {
        PrtFrt_ = Corridor.object_in_corridor_list.end();
        PrtBck_ = Corridor.object_in_corridor_list.end();
        FrtObjExstFlg_ = false;
        BckObjExstFlg_ = false;

        if (!Corridor.object_in_corridor_list.empty())
        {
            // FrtObj
            auto it_frt = find_if(Corridor.object_in_corridor_list.begin(), Corridor.object_in_corridor_list.end(),
                                  [](ObjectLocation &ObjectLocation)
                                  {
                                      float dist = ObjectLocation.relative_center_x;
                                      if (dist > 0 && dist < 130)
                                      {
                                          return true;
                                      }
                                      else
                                      {
                                          return false;
                                      }
                                  });
            if (it_frt != Corridor.object_in_corridor_list.end())
            {
                FrtObjExstFlg_ = true;
                PrtFrt_ = it_frt;
                for (auto prt = it_frt; prt != Corridor.object_in_corridor_list.end(); prt++)
                {
                    if (prt->relative_center_x > 0 && prt->relative_center_x < 130 && prt->relative_center_x < PrtFrt_->relative_center_x)
                    {
                        PrtFrt_ = prt;
                    }
                }
            }

            // BckObj
            auto it_bck = find_if(Corridor.object_in_corridor_list.begin(), Corridor.object_in_corridor_list.end(),
                                  [](ObjectLocation &ObjectLocation)
                                  {
                                      float dist = ObjectLocation.relative_center_x;
                                      if (dist < 0 && dist > -130)
                                      {
                                          return true;
                                      }
                                      else
                                      {
                                          return false;
                                      }
                                  });
            if (it_bck != Corridor.object_in_corridor_list.end())
            {
                BckObjExstFlg_ = true;
                PrtBck_ = it_bck;
                for (auto prt = it_bck; prt != Corridor.object_in_corridor_list.end(); prt++)
                {
                    if (prt->relative_center_x < 0 && prt->relative_center_x > -130 && prt->relative_center_x > PrtBck_->relative_center_x)
                    {
                        PrtBck_ = prt;
                    }
                }
            }
        }
    }

    void LgtCrdorGen::TripleCrdObjLabel(Corridor &Corridor)
    {
        PrtNr_ = Corridor.object_in_corridor_list.end();
        PrtNrFrt_ = Corridor.object_in_corridor_list.end();
        PrtNrBck_ = Corridor.object_in_corridor_list.end();
        NrObjExstFlg_ = false;
        NrFrtObjExstFlg_ = false;
        NrBckObjExstFlg_ = false;

        if (!Corridor.object_in_corridor_list.empty())
        {
            // NrObj
            auto it_nr = find_if(Corridor.object_in_corridor_list.begin(), Corridor.object_in_corridor_list.end(),
                                 [](ObjectLocation &ObjectLocation)
                                 {
                                     float dist = abs(ObjectLocation.relative_center_x);
                                     if (dist > 0 && dist < 130)
                                     {
                                         return true;
                                     }
                                     else
                                     {
                                         return false;
                                     };
                                 });
            if (it_nr != Corridor.object_in_corridor_list.end())
            {
                NrObjExstFlg_ = true;
                PrtNr_ = it_nr;
                for (auto prt = it_nr; prt != Corridor.object_in_corridor_list.end(); prt++)
                {
                    if (abs(prt->relative_center_x) > 0 && abs(prt->relative_center_x) < abs(PrtNr_->relative_center_x))
                    {
                        PrtNr_ = prt;
                    }
                }
            }

            // NrFrtObj && NrBckObj
            if (NrObjExstFlg_)
            {
                // NrFrtObj
                auto it_nrfrt = find_if(Corridor.object_in_corridor_list.begin(), Corridor.object_in_corridor_list.end(),
                                        [=](ObjectLocation &ObjectLocation)
                                        {
                                            float dist = ObjectLocation.relative_center_x;
                                            if (dist > PrtNr_->relative_center_x && dist < 130)
                                            {
                                                return true;
                                            }
                                            else
                                            {
                                                return false;
                                            };
                                        });
                if (it_nrfrt != Corridor.object_in_corridor_list.end())
                {
                    NrFrtObjExstFlg_ = true;
                    PrtNrFrt_ = it_nrfrt;
                    for (auto prt = it_nrfrt; prt != Corridor.object_in_corridor_list.end(); prt++)
                    {
                        if (prt->relative_center_x > PrtNr_->relative_center_x && prt->relative_center_x < PrtNrFrt_->relative_center_x)
                        {
                            PrtNrFrt_ = prt;
                        }
                    }
                }

                // NrBckObj
                auto it_nrbck = find_if(Corridor.object_in_corridor_list.begin(), Corridor.object_in_corridor_list.end(),
                                        [=](ObjectLocation &ObjectLocation)
                                        {
                                            float dist = ObjectLocation.relative_center_x;
                                            if (dist < PrtNr_->relative_center_x && dist > -130)
                                            {
                                                return true;
                                            }
                                            else
                                            {
                                                return false;
                                            };
                                        });
                if (it_nrbck != Corridor.object_in_corridor_list.end())
                {
                    NrBckObjExstFlg_ = true;
                    PrtNrBck_ = it_nrbck;
                    for (auto prt = it_nrbck; prt != Corridor.object_in_corridor_list.end(); prt++)
                    {
                        if (prt->relative_center_x < PrtNr_->relative_center_x && prt->relative_center_x > PrtNrBck_->relative_center_x)
                        {
                            PrtNrBck_ = prt;
                        }
                    }
                }
            }
        }
    }

    float LgtCrdorGen::EstDistCalc(float EstSpd, bool FrtEst)
    {
        MathFcn::LinearIntrPltn<float> EstDistPltn;
        float EstDist = 1000;
        // ADD Drivring Style
        //  DLOG(INFO) << "### DrvrSetTmDist is : " << float(L_DrvrDistLvl) << std::endl;

        //  Add driving style Gain  //0720
        float ALCSRGain_Basic = 1.0;
        if (L_ALCSR == eALCSR_Level1)
        {
            ALCSRGain_Basic = k_BA_LCGALCSRLv1Gain_Bsic;
        }
        else if (L_ALCSR == eALCSR_Level3)
        {
            ALCSRGain_Basic = k_BA_LCGALCSRLv3Gain_Bsic;
        }
        else
        {
            ALCSRGain_Basic = k_BA_LCGALCSRLv2Gain_Bsic; // Default
        }

        if (FrtEst)
        {
            // if (L_DrvrDistLvl == BA::SeldDistLvl_DistLvl0)
            // {
            //     EstDist = EstDistPltn.InterPolation(ADC::common::k_BA_LCGEstDistSpd, ADC::common::k_BA_LCGEstDistLv0, EstSpd);
            // }
            // else if (L_DrvrDistLvl == BA::SeldDistLvl_DistLvl1)
            // {
            //     EstDist = EstDistPltn.InterPolation(ADC::common::k_BA_LCGEstDistSpd, ADC::common::k_BA_LCGEstDistLv1, EstSpd);
            // }
            // else if (L_DrvrDistLvl == BA::SeldDistLvl_DistLvl2)
            // {
            //     EstDist = EstDistPltn.InterPolation(ADC::common::k_BA_LCGEstDistSpd, ADC::common::k_BA_LCGEstDistLv2, EstSpd);
            // }
            // else if (L_DrvrDistLvl == BA::SeldDistLvl_DistLvl3)
            // {
            //     EstDist = EstDistPltn.InterPolation(ADC::common::k_BA_LCGEstDistSpd, ADC::common::k_BA_LCGEstDistLv3, EstSpd);
            // }
            // 0720 seperate driving style with timedistance, default Lv3
            if (L_DrvrDistLvl == BA::SeldDistLvl_DistLvl3 || L_DrvrDistLvl == BA::SeldDistLvl_DistLvl1 || L_DrvrDistLvl == BA::SeldDistLvl_DistLvl2 || L_DrvrDistLvl == BA::SeldDistLvl_DistLvl0)
            {
                EstDist = EstDistPltn.InterPolation(ADC::common::k_BA_LCGEstDistSpd, ADC::common::k_BA_LCGEstDistLv3, EstSpd);
                if (k_BA_LCGALCSRIn)
                {
                    EstDist = EstDist * ALCSRGain_Basic;
                }
            }
            else
            {
                EstDist = 1000;
            }
        }
        else
        {
            // if (L_DrvrDistLvl == BA::SeldDistLvl_DistLvl0)
            // {
            //     EstDist = EstDistPltn.InterPolation(ADC::common::k_BA_LCGEstDistSpd, ADC::common::k_BA_LCGEstDistLv0_bck, EstSpd);
            // }
            // else if (L_DrvrDistLvl == BA::SeldDistLvl_DistLvl1)
            // {
            //     EstDist = EstDistPltn.InterPolation(ADC::common::k_BA_LCGEstDistSpd, ADC::common::k_BA_LCGEstDistLv1_bck, EstSpd);
            // }
            // else if (L_DrvrDistLvl == BA::SeldDistLvl_DistLvl2)
            // {
            //     EstDist = EstDistPltn.InterPolation(ADC::common::k_BA_LCGEstDistSpd, ADC::common::k_BA_LCGEstDistLv2_bck, EstSpd);
            // }
            // else if (L_DrvrDistLvl == BA::SeldDistLvl_DistLvl3)
            // {
            //     EstDist = EstDistPltn.InterPolation(ADC::common::k_BA_LCGEstDistSpd, ADC::common::k_BA_LCGEstDistLv3_bck, EstSpd);
            // }

            // 0720 seperate driving style with timedistance, default Lv3
            if (L_DrvrDistLvl == BA::SeldDistLvl_DistLvl3 || L_DrvrDistLvl == BA::SeldDistLvl_DistLvl1 || L_DrvrDistLvl == BA::SeldDistLvl_DistLvl2 || L_DrvrDistLvl == BA::SeldDistLvl_DistLvl0)
            {
                EstDist = EstDistPltn.InterPolation(ADC::common::k_BA_LCGEstDistSpd, ADC::common::k_BA_LCGEstDistLv3_bck, EstSpd);
                if (k_BA_LCGALCSRIn)
                {
                    EstDist = EstDist * ALCSRGain_Basic;
                }
            }
            else
            {
                EstDist = 1000;
            }
        }

        return EstDist;
    }

    bool LgtCrdorGen::ObjConFlictChk(std::vector<BA::behaviorNodeGlobal>::iterator BNGItr, RoadInfo &roadModel)
    {
        // Find EgoLne Info
        // CommonObjID_ = 0;
        uint8_t EgoLneID = roadModel.car_position.ego_lane_id;
        bool EgoLaneFind = false;
        float EgoLaneEndDist = 400;
        bool EgoLaneEndFlg = true;
        auto it_egolne = find_if(roadModel.lane_list.begin(), roadModel.lane_list.end(),
                                 [EgoLneID](const Lane &lane_)
                                 {
                                     return (EgoLneID == lane_.start_id);
                                 });
        if (it_egolne != roadModel.lane_list.end())
        {
            EgoLaneFind = true;
            EgoLaneEndFlg = it_egolne->is_end_out_of_range;
            EgoLaneEndDist = it_egolne->end_range;

            // DLOG(INFO) << "EgoLaneFind = " << int(EgoLaneFind) << std::endl;
            // DLOG(INFO) << "EgoLaneEndDist  = " << float(EgoLaneEndDist) << std::endl;
            // DLOG(INFO) << "EgoLaneEndFlg = " << int(EgoLaneEndFlg) << std::endl;
        }
        // Judge
        if (L_InterestObjIDList.empty())
        {
            return false;
        }
        else
        {
            if (EgoLaneFind && EgoLaneEndFlg == false && EgoLaneEndDist < k_BA_LCGEgoLneEndDistThr)
            {
                return false;
            }
            else if (BNGItr->m_ActionTypArr.back() != L_ActionType)
            {
                // Extract Nozero Element
                std::vector<uint32_t> Chk_InterestObjIDList;
                int Num = L_InterestObjIDList.size();
                for (int i = 0; i < Num; i++)
                {
                    if (L_InterestObjIDList[i] != uint32_t(0))
                    {
                        Chk_InterestObjIDList.push_back(L_InterestObjIDList[i]);
                    }
                }
                // DLOG(INFO) << "InterestObjIDList Size = " << int(Chk_InterestObjIDList.size()) << std::endl;
                // for (int j = 0; j < Chk_InterestObjIDList.size(); j++)
                // {
                //     DLOG(INFO) << "InterestObjIDList Member = " << int(Chk_InterestObjIDList[j]) << std::endl;
                // }

                // Chk Unique
                // int OriObjNum = Chk_InterestObjIDList.size();
                if (!Chk_InterestObjIDList.empty())
                {
                    sort(Chk_InterestObjIDList.begin(), Chk_InterestObjIDList.end());
                    auto UniqueObjLb = unique(Chk_InterestObjIDList.begin(), Chk_InterestObjIDList.end());
                    if (UniqueObjLb == Chk_InterestObjIDList.end())
                    {
                        return false;
                    }
                    else
                    {
                        return true;
                        //    CommonObjID_ = *UniqueObjLb;
                    }
                }
                else
                {
                    return false;
                }
            }
            else
            {
                return false;
            }
        }
    }

    bool LgtCrdorGen::BckObjSpdErrChk()
    {
        if (L_ActionType == BA::BA_ActionTyp_LeftLaneChange || L_ActionType == BA::BA_ActionTyp_RightLaneChange)
        {
            if ((LC_Cls_ == 2 || LC_Cls_ == 3) && LC_TarBckObjExstFlg_ && ((LC_TarBckObjSpd_ - L_VEgo) > k_BA_LCGBckObjSpdErrSftyThr))
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        else if (L_ActionType == BA::BA_ActionTyp_LeftLaneChangePrepare || L_ActionType == BA::BA_ActionTyp_RightLaneChangePrepare)
        {
            if ((LCP_Cls_bck_ == 7 || LCP_Cls_bck_ == 8) && LCP_NrBckObjExstFlg_ && ((LCP_NrBckObjExstFlg_ - L_VEgo) > k_BA_LCGBckObjSpdErrSftyThr))
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        else
        {
            return false;
        }
    }

    bool LgtCrdorGen::BckLCPNrObjChk()
    {
        if (L_ActionType == BA::BA_ActionTyp_LeftLaneChangePrepare || L_ActionType == BA::BA_ActionTyp_RightLaneChangePrepare)
        {
            if (LCP_Cls_bck_ == 3 || LCP_Cls_bck_ == 7)
            {
                // Bck_LCP in chk
                if (this->LCP_NrObjSpd_ < k_BA_LCGLCPBckNrObjSpdThr || this->LCP_NrObjAcc_ < k_BA_LCGLCPBckNrObjAccThr2)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
            else if (LCP_Cls_bck_ == 4 || LCP_Cls_bck_ == 8)
            {
                // Bck_LCP in chk
                if (this->LCP_NrObjSpd_ < k_BA_LCGLCPBckNrObjSpdThr || this->LCP_NrObjAcc_ < k_BA_LCGLCPBckNrObjAccThr1)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
            else
            {
                return false;
            }
        }
        else
        {
            return false;
        }
    }

    bool LgtCrdorGen::CommonResChk(std::vector<BA::behaviorNodeGlobal>::iterator BNGItr, RoadInfo &roadModel)
    {
        bool CommonRes1 = ObjConFlictChk(BNGItr, roadModel);
        bool CommonRes2 = BckObjSpdErrChk();
        bool CommonRes3 = BckLCPNrObjChk();

        // if (CommonRes1 || CommonRes2)
        if (CommonRes1 || CommonRes3) // 0713
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    float LgtCrdorGen::DistCmPresGainCalc(float EgoSpd, float ReferObjSpd, std::vector<BA::behaviorNodeGlobal>::iterator BNGItr, bool FrtEst)
    {
        float gain = 1.0;
        MathFcn::LinearIntrPltn<float> EstGainPltn;
        float spderr = abs(EgoSpd - ReferObjSpd);
        if (FrtEst)
        {
            if (EgoSpd - ReferObjSpd > 0.01)
            {
                // Enlarge
                if (k_BA_LCGALCSRIn)
                {
                    if (L_ALCSR == eALCSR_Level1)
                    {
                        gain = max(EstGainPltn.InterPolation(ADC::common::k_BA_LCGDistCmprsSpdErrFctr, ADC::common::k_BA_LCGDistReCmprsGain_Cnsrv, spderr), 1.0f);
                    }
                    else if (L_ALCSR == eALCSR_Level3)
                    {
                        gain = max(EstGainPltn.InterPolation(ADC::common::k_BA_LCGDistCmprsSpdErrFctr, ADC::common::k_BA_LCGDistReCmprsGain_Agrsv, spderr), 1.0f);
                    }
                    else
                    {
                        gain = max(EstGainPltn.InterPolation(ADC::common::k_BA_LCGDistCmprsSpdErrFctr, ADC::common::k_BA_LCGDistReCmprsGain, spderr), 1.0f);
                    }
                }
                else
                {
                    gain = max(EstGainPltn.InterPolation(ADC::common::k_BA_LCGDistCmprsSpdErrFctr, ADC::common::k_BA_LCGDistReCmprsGain, spderr), 1.0f);
                }
            }
            else if (ReferObjSpd - EgoSpd > 0.01)
            {
                // Reduce
                if (k_BA_LCGALCSRIn)
                {
                    if (L_ALCSR == eALCSR_Level1)
                    {
                        if (((BNGItr->m_ActionTypArr.back() == BA::BA_ActionTyp_LeftLaneChangePrepare || BNGItr->m_ActionTypArr.back() == BA::BA_ActionTyp_RightLaneChangePrepare) && (L_ActionType == BA::BA_ActionTyp_LeftLaneChange || L_ActionType == BA::BA_ActionTyp_RightLaneChange)) || (BNGItr->m_ActionTypArr.back() == L_ActionType && (L_ActionType == BA::BA_ActionTyp_LeftLaneChange || L_ActionType == BA::BA_ActionTyp_RightLaneChange)))
                        {
                            // DLOG(INFO) << "WORK!! = " << std::endl;
                            gain = min(EstGainPltn.InterPolation(ADC::common::k_BA_LCGDistCmprsSpdErrFctr, ADC::common::k_BA_LCGDistCmprsGain, spderr), 1.0f);
                        }
                        else
                        {
                            gain = min(EstGainPltn.InterPolation(ADC::common::k_BA_LCGDistCmprsSpdErrFctr, ADC::common::k_BA_LCGDistCmprsGain_Cnsrv, spderr), 1.0f);
                        }
                    }
                    else if (L_ALCSR == eALCSR_Level3)
                    {
                        gain = min(EstGainPltn.InterPolation(ADC::common::k_BA_LCGDistCmprsSpdErrFctr, ADC::common::k_BA_LCGDistCmprsGain_Agrsv, spderr), 1.0f);
                    }
                    else
                    {
                        gain = min(EstGainPltn.InterPolation(ADC::common::k_BA_LCGDistCmprsSpdErrFctr, ADC::common::k_BA_LCGDistCmprsGain, spderr), 1.0f);
                    }
                }
                else
                {
                    gain = min(EstGainPltn.InterPolation(ADC::common::k_BA_LCGDistCmprsSpdErrFctr, ADC::common::k_BA_LCGDistCmprsGain, spderr), 1.0f);
                }
            }
            else
            {
                gain = 1.0f;
            }
        }
        else
        {
            if (k_BA_LCGBckCmprs2DOn)
            {
                float spderr2D = EgoSpd - ReferObjSpd;
                gain = EstGainPltn.InterPolation(k_BA_LCGBckCmprsSpdErr, k_BA_LCGBckCmprsEgoSpd, k_BA_LCGBckCmprsTb, spderr2D, EgoSpd);
                return gain;
            }
            else
            {
                if (EgoSpd - ReferObjSpd > 0.1)
                {
                    gain = min(EstGainPltn.InterPolation(ADC::common::k_BA_LCGDistCmprsSpdErrFctr, ADC::common::k_BA_LCGDistCmprsGain, spderr), 1.0f);
                }
                else if (ReferObjSpd - EgoSpd > 0.1)
                {
                    gain = max(EstGainPltn.InterPolation(ADC::common::k_BA_LCGDistCmprsSpdErrFctr, ADC::common::k_BA_LCGDistReCmprsGain, spderr), 1.0f);
                }
                else
                {
                    gain = 1.0f;
                }
            }
        }

        float MrgInSpdErrGain = LCPMergeInGain(EgoSpd, ReferObjSpd, BNGItr, FrtEst);

        gain = gain * MrgInSpdErrGain;
        return gain;
    }

    bool LgtCrdorGen::GetRefLneMrk(RoadInfo &RoadModel, float &TgtC0)
    {
        TgtC0 = 0;
        // get Egolne in LneList by Egolne ID
        uint8_t EgoLneID = RoadModel.car_position.ego_lane_id;
        auto it_egolne = find_if(RoadModel.lane_list.begin(), RoadModel.lane_list.end(),
                                 [EgoLneID](const Lane &lane_)
                                 {
                                     return (EgoLneID == lane_.start_id);
                                 });
        if (it_egolne != RoadModel.lane_list.end())
        {
            uint32_t TgtRgtLneMrkID = uint32_t(0);
            uint32_t TgtLftLneMrkID = uint32_t(0);
            if (L_ActionType == BA::BA_ActionTyp_LeftLaneChange)
            {
                if (!(it_egolne->left_lane_marker_id_list.empty()))
                {
                    // get Egolne's LftMrk in Left lane mrk list by EgoLne's LftLneMrk ID
                    TgtLftLneMrkID = it_egolne->left_lane_marker_id_list.front(); // only one
                    auto it_LftLneMrk = find_if(RoadModel.lane_marker_list.begin(), RoadModel.lane_marker_list.end(),
                                                [TgtLftLneMrkID](LaneMarker &lane_mark_)
                                                {
                                                    return (TgtLftLneMrkID == lane_mark_.id);
                                                });
                    if (it_LftLneMrk != RoadModel.lane_marker_list.end())
                    {
                        // get nearest Egolne LftMrk's Bndry in LftLneMrk's front boundry list

                        if (!it_LftLneMrk->front_lane_boundary_list.empty())
                        {
                            // auto TgtLftLneBndryPrt = it_LftLneMrk -> front_lane_boundary_list.begin();
                            // for(auto prt = it_LftLneMrk ->front_lane_boundary_list.begin() + 1;prt != it_LftLneMrk -> front_lane_boundary_list.end(); prt++)
                            // {
                            //     float StartRg = prt -> line_geometry.start_range;
                            //     if(StartRg >= 0 && StartRg <= TgtLftLneBndryPrt -> line_geometry.start_range)
                            //     {
                            //         TgtLftLneBndryPrt = prt;
                            //     }
                            // }
                            // TgtC0 = TgtLftLneBndryPrt -> line_geometry.c0;

                            LaneBoundary TgtLftLneBndry;
                            TgtLftLneBndry = it_LftLneMrk->front_lane_boundary_list.front();
                            TgtC0 = TgtLftLneBndry.line_geometry.c0;

                            return true;
                        }
                        else
                        {
                            return false;
                        }
                    }
                    else
                    {
                        return false;
                    }
                }
                else
                {
                    return false;
                }
            }
            else if (L_ActionType == BA::BA_ActionTyp_RightLaneChange)
            {
                if (!(it_egolne->right_lane_marker_id_list.empty()))
                {
                    // get Egolne's Mrk in Right lane mrk list by EgoLne's RhtLneMrk ID
                    TgtRgtLneMrkID = it_egolne->right_lane_marker_id_list.front(); // only one
                    auto it_RgtLneMrk = find_if(RoadModel.lane_marker_list.begin(), RoadModel.lane_marker_list.end(),
                                                [TgtRgtLneMrkID](LaneMarker &lane_mark_)
                                                {
                                                    return (TgtRgtLneMrkID == lane_mark_.id);
                                                });
                    if (it_RgtLneMrk != RoadModel.lane_marker_list.end())
                    {
                        // get nearest Egolne LftMrk's Bndry in LftLneMrk's front boundry list
                        if (!it_RgtLneMrk->front_lane_boundary_list.empty())
                        {
                            // auto TgtRgtLneBndryPrt = it_RgtLneMrk -> front_lane_boundary_list.begin();
                            // for(auto prt = it_RgtLneMrk ->front_lane_boundary_list.begin() + 1;prt != it_RgtLneMrk -> front_lane_boundary_list.end(); prt++)
                            // {
                            //     float StartRg = prt -> line_geometry.start_range;
                            //     if(StartRg >= 0 && StartRg <= TgtRgtLneBndryPrt -> line_geometry.start_range)
                            //     {
                            //         TgtRgtLneBndryPrt = prt;
                            //     }
                            // }
                            // TgtC0 = TgtRgtLneBndryPrt -> line_geometry.c0;

                            LaneBoundary TgtRgtLneBndry;
                            TgtRgtLneBndry = it_RgtLneMrk->front_lane_boundary_list.front();
                            TgtC0 = TgtRgtLneBndry.line_geometry.c0;

                            return true;
                        }
                        else
                        {
                            return false;
                        }
                    }
                    else
                    {
                        return false;
                    }
                }
                else
                {
                    return false;
                }
            }
            else
            {
                return false;
            }
        }
        else
        {
            return false;
        }
    }

    float LgtCrdorGen::LCAbltTolrGain(RoadInfo &RoadModel)
    {
        float TgtC0 = 2.0; // sfy
        float AbltTolGain = 1.0;
        if (GetRefLneMrk(RoadModel, TgtC0))
        {
            DLOG(INFO) << "TgtC01 is = " << float(TgtC0) << std::endl;
            TgtC0 = abs(TgtC0);
            MathFcn::LinearIntrPltn<float> TolGainCalc;
            AbltTolGain = max(min(TolGainCalc.InterPolation(k_BA_LCGAlcAbltTorC0, k_BA_LCGAlcAbltTorGainTb, TgtC0), float(k_BA_LCGAlcAbltTorGainHi)), float(k_BA_LCGAlcAbltTorGainLo));
            return AbltTolGain;
        }
        else
        {
            return AbltTolGain;
        }
    }

    bool LgtCrdorGen::LCPActionLongTm(std::vector<BA::behaviorNodeGlobal>::iterator BNGItr)
    {
        static float LCPDurTmCt = 0;
        if (L_ActionType == BA::BA_ActionTyp_LeftLaneChangePrepare || L_ActionType == BA::BA_ActionTyp_RightLaneChangePrepare)
        {
            if (BNGItr->m_ActionTypArr.back() == L_ActionType)
            {
                LCPDurTmCt++;
            }
            else
            {
                LCPDurTmCt = 0;
            }
            DLOG(INFO) << "LCP_Ct is : = " << int(LCPDurTmCt) << std::endl;
        }

        LCPDurTmCt = min(LCPDurTmCt, float(600.0));
        if (LCPDurTmCt * (BEHAVIORANALYZERCYCLE / 1000.0) > k_BA_LCGLCPActLonThr)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    float LgtCrdorGen::LCPMergeInGain(float EgoSpd, float ReferObjSpd, std::vector<BA::behaviorNodeGlobal>::iterator BNGItr, bool FrtEst)
    {
        enum TGTSPDCONDFLG
        {
            eTSCFS_Unsatisfied = 0,
            eTSCFS_Satisfied = 1
        };
        static TGTSPDCONDFLG FrtObj = eTSCFS_Unsatisfied;
        static TGTSPDCONDFLG BckObj = eTSCFS_Unsatisfied;
        float Local_Gain = 1.0;
        MathFcn::LinearIntrPltn<float> MrgSpdErrGain;
        if (FrtEst)
        {
            switch (FrtObj)
            {
            case eTSCFS_Unsatisfied:

                if (ReferObjSpd - EgoSpd > 1.5)
                {
                    FrtObj = eTSCFS_Satisfied;
                }
                break;

            case eTSCFS_Satisfied:
                if (ReferObjSpd - EgoSpd < 0.1)
                {
                    FrtObj = eTSCFS_Unsatisfied;
                }
                break;
            }
            if (L_ScnrTyp == BA::ScenarioTyp_MergeIN && FrtObj == eTSCFS_Satisfied)
            {
                float spderr_abs = ReferObjSpd - EgoSpd;
                Local_Gain = MrgSpdErrGain.InterPolation(k_BA_LCGMrgSpdErr, k_BA_LCGMrgSpdErrFctr_frt, spderr_abs);
            }
        }
        else
        {
            switch (BckObj)
            {
            case eTSCFS_Unsatisfied:
                if (EgoSpd - ReferObjSpd > 1.5)
                {
                    BckObj = eTSCFS_Satisfied;
                }
                break;

            case eTSCFS_Satisfied:
                if (EgoSpd - ReferObjSpd < 0.1)
                {
                    BckObj = eTSCFS_Unsatisfied;
                }
            }
            if (L_ScnrTyp == BA::ScenarioTyp_MergeIN && BckObj == eTSCFS_Satisfied)
            {
                float spderr_abs = EgoSpd - ReferObjSpd;
                Local_Gain = MrgSpdErrGain.InterPolation(k_BA_LCGMrgSpdErr, k_BA_LCGMrgSpdErrFctr_bck, spderr_abs);
            }
        }

        return Local_Gain;
    }
}
