#ifndef DM_GENERAL_WRAPPER_HEADER_H
#define DM_GENERAL_WRAPPER_HEADER_H
#include "pub/PubWrapperHelper.h"
#include "pub/PubDataWrapper.h"
#include "sub/SubWrapperHelper.h"
#include "dpc_dm/executable.h"
#include "DM_PubDataWrapper.h"
#include "DM_SubDataWrapper.h"


using namespace jac::ap::dmservice::skeleton;
using namespace jac::ap::emservice::proxy;
using namespace jac::ap::slamservice::proxy;
using namespace jac::ap::vedservice::proxy;
using namespace jac::ap::smservice::proxy;
using namespace jac::ap::canservice::proxy;

GENERATE_PUB_WRAPPER(DM2TRPCLong_Provide, DM2TRPCLong_PubDataWrapper, DMServiceSkeleton, dpc::Decision4Long, Decision4LongEvent);
GENERATE_PUB_WRAPPER(DM2TRPCLat_Provide, DM2TRPCLat_PubDataWrapper, DMServiceSkeleton, dpc::Decision4Lat, Decision4LatEvent);
GENERATE_PUB_WRAPPER(DM2SM_Provide, DM2SM_PubDataWrapper, DMServiceSkeleton, dpc::Decision4SM, Decision4SMEvent);
GENERATE_PUB_WRAPPER(DM2SMObjectTrim_Provide, DM2SMObjectTrim_PubDataWrapper, DMServiceSkeleton, dpc::ObjectTrim, ObjectTrimEvent);

GENERATE_SUB_WRAPPER(VED2DM_Required, VED2DM_SubDataWrapper, VEDServiceProxy, dpc::VED4DPC, VED4DPCEvent, "11", 10);
GENERATE_SUB_WRAPPER(EM2DMRoadInfo_Required, EM2DMRoadInfo_SubDataWrapper, EMServiceProxy, dpc::RoadInfo, RoadInfoEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2DMRMHeader_Required, EM2DMRMHeader_SubDataWrapper, EMServiceProxy, dpc::RMHeader, RMHeaderEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2DMIndex_Required, EM2DMIndex_SubDataWrapper, EMServiceProxy, dpc::Index, IndexEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2DMCarPosition_Required, EM2DMCarPosition_SubDataWrapper, EMServiceProxy, dpc::CarPosition, CarPositionEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2DMLane_Required, EM2DMLane_SubDataWrapper, EMServiceProxy, dpc::Lane, LaneEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2DMLaneMarker_Required, EM2DMLaneMarker_SubDataWrapper, EMServiceProxy, dpc::LaneMarker, LaneMarkerEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2DMObject_Required, EM2DMObject_SubDataWrapper, EMServiceProxy, dpc::Object, ObjectEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2DMRoadEdge_Required, EM2DMRoadEdge_SubDataWrapper, EMServiceProxy, dpc::RoadEdge, RoadEdgeEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2DMNeighborLane_Required, EM2DMNeighborLane_SubDataWrapper, EMServiceProxy, dpc::NeighborLane, NeighborLaneEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2DMCorridor_Required, EM2DMCorridor_SubDataWrapper, EMServiceProxy, dpc::Corridor, CorridorEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2DMSamplingPoint_Required, EM2DMSamplingPoint_SubDataWrapper, EMServiceProxy, dpc::SamplingPoint, SamplingPointEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2DMLineColor_Required, EM2DMLineColor_SubDataWrapper, EMServiceProxy, dpc::LineColor, LineColorEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2DMLineType_Required, EM2DMLineType_SubDataWrapper, EMServiceProxy, dpc::LineType, LineTypeEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2DMObjectLocation_Required, EM2DMObjectLocation_SubDataWrapper, EMServiceProxy, dpc::ObjectLocation, ObjectLocationEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2DMSLPoint_Required, EM2DMSLPoint_SubDataWrapper, EMServiceProxy, dpc::SLPoint, SLPointEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2DMLaneControl_Required, EM2DMLaneControl_SubDataWrapper, EMServiceProxy, dpc::LaneControl, LaneControlEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2DMLaneBoundary_Required, EM2DMLaneBoundary_SubDataWrapper, EMServiceProxy, dpc::LaneBoundary, LaneBoundryEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2DMLineGeometry_Required, EM2DMLineGeometry_SubDataWrapper, EMServiceProxy, dpc::LineGeometry, LineGeometryEvent, "6", 10);
GENERATE_SUB_WRAPPER(EM2DMRoadEdgeSegment_Required, EM2DMRoadEdgeSegment_SubDataWrapper, EMServiceProxy, dpc::RoadEdgeSegment, RoadEdgeSegmentEvent, "6", 10);
GENERATE_SUB_WRAPPER(SLAM2DMAdjacentExtendLaneStruct_Required, SLAM2DMAdjacentExtendLaneStruct_SubDataWrapper, SLAMServiceProxy, dpc::AdjacentExtendLaneStruct, AdjacentExtendLaneStructEvent, "8", 10);
GENERATE_SUB_WRAPPER(SLAM2DMSMAStruct_Required, SLAM2DMSMAStruct_SubDataWrapper, SLAMServiceProxy, dpc::SMAStruct, SMAStructEvent, "8", 10);
GENERATE_SUB_WRAPPER(SLAM2DMWPExtendLaneStruct_Required, SLAM2DMWPExtendLaneStruct_SubDataWrapper, SLAMServiceProxy, dpc::WPExtendLaneStruct, WPExtendLaneStructEvent, "8", 10);
GENERATE_SUB_WRAPPER(SLAM2DMRemindWayPointStruct_Required, SLAM2DMRemindWayPointStruct_SubDataWrapper, SLAMServiceProxy, dpc::RemindWayPointStruct, RemindWayPointStructEvent, "8", 10);
GENERATE_SUB_WRAPPER(SLAM2DMControlWayPointStruct_Required, SLAM2DMControlWayPointStruct_SubDataWrapper, SLAMServiceProxy, dpc::ControlWayPointStruct, ControlWayPointStructEvent, "8", 10);
GENERATE_SUB_WRAPPER(SLAM2DMMsgHeader_Required, SLAM2DMMsgHeader_SubDataWrapper, SLAMServiceProxy, dpc::MsgHeader, MsgHeaderEvent, "8", 10);
GENERATE_SUB_WRAPPER(SLAM2DMTransitLaneStruct_Required, SLAM2DMTransitLaneStruct_SubDataWrapper, SLAMServiceProxy, dpc::TransitLaneStruct, TransitLaneStructEvent, "8", 10);
GENERATE_SUB_WRAPPER(SLAM2DMControlWayPoints_Required, SLAM2DMControlWayPoints_SubDataWrapper, SLAMServiceProxy, dpc::ControlWaypoints, ControlWayPointsEvent, "8", 10);
GENERATE_SUB_WRAPPER(SM2Decision_Required, SM2Decision_SubDataWrapper, SMServiceProxy, dpc::SM4Decision, SM4DecisionEvent, "9", 10);
GENERATE_SUB_WRAPPER(CAN2DM_Required, CAN2DM_SubDataWrapper, CANServiceProxy, CAN2SWC, CAN2SWCEvent, "3", 10);


class GeneralWrapper {
public:
    DM2TRPCLong_Provide _DM2TRPCLong_Provide;
    DM2TRPCLat_Provide _DM2TRPCLat_Provide;
    DM2SM_Provide _DM2SM_Provide;
    DM2SMObjectTrim_Provide _DM2SMObjectTrim_Provide;

    VED2DM_Required  _VED2DM_Required;
    EM2DMRoadInfo_Required  _EM2DMRoadInfo_Required;
    EM2DMRMHeader_Required  _EM2DMRMHeader_Required;
    EM2DMIndex_Required  _EM2DMIndex_Required;
    EM2DMCarPosition_Required  _EM2DMCarPosition_Required;
    EM2DMLane_Required  _EM2DMLane_Required;
    EM2DMLaneMarker_Required  _EM2DMLaneMarker_Required;
    EM2DMObject_Required  _EM2DMObject_Required;
    EM2DMRoadEdge_Required  _EM2DMRoadEdge_Required;
    EM2DMNeighborLane_Required  _EM2DMNeighborLane_Required;
    EM2DMCorridor_Required  _EM2DMCorridor_Required;
    EM2DMSamplingPoint_Required  _EM2DMSamplingPoint_Required;
    EM2DMLineColor_Required  _EM2DMLineColor_Required;
    EM2DMLineType_Required  _EM2DMLineType_Required;
    EM2DMObjectLocation_Required  _EM2DMObjectLocation_Required;
    EM2DMSLPoint_Required  _EM2DMSLPoint_Required;
    EM2DMLaneControl_Required  _EM2DMLaneControl_Required;
    EM2DMLaneBoundary_Required  _EM2DMLaneBoundary_Required;
    EM2DMLineGeometry_Required  _EM2DMLineGeometry_Required;
    EM2DMRoadEdgeSegment_Required  _EM2DMRoadEdgeSegment_Required;
    SLAM2DMAdjacentExtendLaneStruct_Required  _SLAM2DMAdjacentExtendLaneStruct_Required;
    SLAM2DMSMAStruct_Required  _SLAM2DMSMAStruct_Required;
    SLAM2DMWPExtendLaneStruct_Required  _SLAM2DMWPExtendLaneStruct_Required;
    SLAM2DMRemindWayPointStruct_Required  _SLAM2DMRemindWayPointStruct_Required;
    SLAM2DMControlWayPointStruct_Required  _SLAM2DMControlWayPointStruct_Required;
    SLAM2DMMsgHeader_Required  _SLAM2DMMsgHeader_Required;
    SLAM2DMTransitLaneStruct_Required  _SLAM2DMTransitLaneStruct_Required;
    SLAM2DMControlWayPoints_Required  _SLAM2DMControlWayPoints_Required;
    SM2Decision_Required _SM2Decision_Required;
    CAN2DM_Required _CAN2DM_Required;

    
    GeneralWrapper(ara::log::Logger& mainLog);
    ~GeneralWrapper();
    void Start();
};

#endif
