
#ifndef DMPubDataWrapper_WRAPPER_HEADER_H
#define DMPubDataWrapper_WRAPPER_HEADER_H

#include "pub/PubDataWrapper.h"
#include "dpc_dm/executable.h"

/*-------------------------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class DM2TRPCLong_PubDataWrapper: public PubDataWrapper<EventType>

{
private:
	dpc::Decision4Long _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::Decision4Long>(std::move(_data));
    }

    void SetData(dpc::Decision4Long& data)
    {
        _data = std::move(data);
    }
};


/*-------------------------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class DM2TRPCLat_PubDataWrapper: public PubDataWrapper<EventType>

{
private:
	dpc::Decision4Lat _data;
public:
	void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
	{
        data = std::make_unique<dpc::Decision4Lat>(std::move(_data));
    }

    void SetData(dpc::Decision4Lat& data)
    {
        _data = std::move(data);
    }
};


/*-------------------------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class DM2SM_PubDataWrapper: public PubDataWrapper<EventType>

{
private:
	dpc::Decision4SM _data;
public:
	void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
	{
        data = std::make_unique<dpc::Decision4SM>(std::move(_data));
    }

    void SetData(dpc::Decision4SM& data)
    {
        _data = std::move(data);
    }
};


/*-------------------------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class DM2SMObjectTrim_PubDataWrapper: public PubDataWrapper<EventType>

{
private:
	dpc::ObjectTrim _data;
public:
	void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
	{
        data = std::make_unique<dpc::ObjectTrim>(std::move(_data));
    }

    void SetData(dpc::ObjectTrim& data)
    {
        _data = std::move(data);
    }
};


#endif /* DMPubDataWrapper_WRAPPER_HEADER_H */
