#ifndef ACC_TARGET_SELECTION_C0CALCULATOR_H
#define ACC_TARGET_SELECTION_C0CALCULATOR_H

#include "basetype.h"
#include "param.h"

namespace ACC_Target_Selection {
class C0Calculator {
public:

    explicit C0Calculator(const Param_C0Calculator &param_conf);

    C0Calculator(const C0Calculator& r);

    ~C0Calculator();

    const Param_C0Calculator &param_conf_;

    void lp1r();

    void calculatec0(const basetype::float32_t &spd, const basetype::float32_t &steeringangle, const basetype::float32_t &yawrate);

    basetype::float32_t get_C0();

    void enablereset();
private:

    basetype::float32_t curvaturecog_;
    basetype::float32_t radiuscog_;
    basetype::float32_t slip_;
    basetype::float32_t curvaturerr_;
    basetype::float32_t curvaturerrraw_;
    basetype::float32_t c0_;
    basetype::float32_t c0basedkinematics_;
    basetype::float32_t c0baseddynamics_;
    basetype::boolean_t reset_;

    void blend(const basetype::float32_t &spd);

    void calculatec0basedkinematics(const basetype::float32_t &spd,
                                    const basetype::float32_t &yawrate);

    void calculatec0baseddynamics(const basetype::float32_t &spd,
                                  const basetype::float32_t &steeringangle,
                                  const basetype::float32_t &yawrate);

    void calulatecurvaturecog(const basetype::float32_t &steering,
                              const basetype::float32_t &spd);

    void calculateslip(const basetype::float32_t &spd);

    void calculatecurvaturerear(const basetype::float32_t &spd, const basetype::float32_t &yawrate, const basetype::float32_t &steeringangle);

    void calculatedeadzone(const basetype::float32_t &spd, const basetype::float32_t &yawrate, const basetype::float32_t &steeringangle);
};
}

#endif