#ifndef ACC_TARGET_SELECTION_OBJECTRESULTHANDLER_H
#define ACC_TARGET_SELECTION_OBJECTRESULTHANDLER_H

#include "logger.h"
#include "mpc_drv_msgs/msg/road_info.hpp"
// #include "mpc_drv_msgs/msg/targets_info.hpp"
#include "impl_type_targetsinfo.h"
#include "param.h"

namespace ACC_Target_Selection {
class ObjectResultHandler {
public:
  ObjectResultHandler();

  ObjectResultHandler(const ObjectResultHandler &r);

  ~ObjectResultHandler();

  void setlogger(Logger *logger);

  void assignresult(mpc_drv_msgs::msg::TargetsInfo &ats_targetsinfo);

  void assignresult(mpc_drv_msgs::msg::Corridor &ats_corridor);

  void assignresult(uint32_t &pedestrain_id, mpc_drv_msgs::msg::TargetsInfo &ats_targetsinfo);

  basetype::float32_t dis2frontbump_;

  basetype::float32_t dis2rearbump_;

  mpc_drv_msgs::msg::TargetInfo default_iv_;

  mpc_drv_msgs::msg::TargetInfo default_riv_;
private:
  Logger *logger_;

  void assigniv(mpc_drv_msgs::msg::TargetsInfo &ats_targetsinfo);

  void assigniiv(mpc_drv_msgs::msg::TargetsInfo &ats_targetsinfo);

  void assignflniv(mpc_drv_msgs::msg::TargetsInfo &ats_targetsinfo);

  void assignflniiv(mpc_drv_msgs::msg::TargetsInfo &ats_targetsinfo);

  void assignslniv(mpc_drv_msgs::msg::TargetsInfo &ats_targetsinfo);

  void assignslniiv(mpc_drv_msgs::msg::TargetsInfo &ats_targetsinfo);

  void assignriv(mpc_drv_msgs::msg::TargetsInfo &ats_targetsinfo);

  void assignflnriv(mpc_drv_msgs::msg::TargetsInfo &ats_targetsinfo);

  void assignslnriv(mpc_drv_msgs::msg::TargetsInfo &ats_targetsinfo);
};

} // namespace ACC_Target_Selection

#endif