/**
 * @file egovehicleinformation.h
 * @author your name (you@domain.com)
 * @brief 
 * @version 0.1
 * @date 2022-01-21
 * 
 * @copyright Copyright (c) 2022
 * 
 */

#ifndef ACC_TARGET_SELECTION_EGOVEHICLEINFORMATION_H
#define ACC_TARGET_SELECTION_EGOVEHICLEINFORMATION_H

#include "basetype.h"
#include "simpleconstant.h"
#include "indicatorstatus.h"

namespace ACC_Target_Selection {
const basetype::float32_t EgoVehicleInformation_SpdLgt_Default{zero_float32_t};
const basetype::float32_t EgoVehicleInformation_SpdLat_Default{zero_float32_t};
const basetype::float32_t EgoVehicleInformation_SpdLgtCompFac_Default{one_float32_t};
const basetype::float32_t EgoVehicleInformation_AccelLgt_Default{zero_float32_t};
const basetype::float32_t EgoVehicleInformation_AccelLgtRaw_Default{zero_float32_t};
const basetype::float32_t EgoVehicleInformation_AccelLatRaw_Default{zero_float32_t};
const basetype::float32_t EgoVehicleInformation_YawRate_Default{zero_float32_t};
const basetype::float32_t EgoVehicleInformation_YawRateRaw_Default{zero_float32_t};
const IndicatorStatus EgoVehicleInformation_Indicator_Default{IndicatorStatus::None};
const basetype::float32_t EgoVehicleInformation_SteeringAngle_Default{zero_float32_t};
struct EgoVehicleInformation {
    basetype::float32_t SpdLgt;
    basetype::float32_t SpdLat;
    basetype::float32_t SpdLgtCompFac;
    basetype::float32_t AccelLgt;
    basetype::float32_t AccelLgtRaw;
    basetype::float32_t AccelLatRaw;
    basetype::float32_t YawRate;
    basetype::float32_t YawRateRaw;
    IndicatorStatus Indicator;
    basetype::float32_t SteeringAngle;

    explicit EgoVehicleInformation() :
            SpdLgt(EgoVehicleInformation_SpdLgt_Default),
            SpdLat(EgoVehicleInformation_SpdLat_Default),
            SpdLgtCompFac(EgoVehicleInformation_SpdLgtCompFac_Default),
            AccelLgt(EgoVehicleInformation_AccelLgt_Default),
            AccelLgtRaw(EgoVehicleInformation_AccelLgtRaw_Default),
            AccelLatRaw(EgoVehicleInformation_AccelLatRaw_Default),
            YawRate(EgoVehicleInformation_YawRate_Default),
            YawRateRaw(EgoVehicleInformation_YawRateRaw_Default),
            Indicator(EgoVehicleInformation_Indicator_Default),
            SteeringAngle(EgoVehicleInformation_SteeringAngle_Default) {
    }

    EgoVehicleInformation(const EgoVehicleInformation &r):
            SpdLgt(r.SpdLgt),
            SpdLat(r.SpdLat),
            SpdLgtCompFac(r.SpdLgtCompFac),
            AccelLgt(r.AccelLgt),
            AccelLgtRaw(r.AccelLgtRaw),
            AccelLatRaw(r.AccelLatRaw),
            YawRate(r.YawRate),
            YawRateRaw(r.YawRateRaw),
            Indicator(r.Indicator),
            SteeringAngle(r.SteeringAngle) {
    }

    explicit EgoVehicleInformation(const basetype::float32_t &SpdLgt_,
                                   const basetype::float32_t &SpdLat_,
                                   const basetype::float32_t &SpdLgtCompFac_,
                                   const basetype::float32_t &AccelLgt_,
                                   const basetype::float32_t &AccelLgtRaw_,
                                   const basetype::float32_t &AccelLatRaw_,
                                   const basetype::float32_t &YawRate_,
                                   const basetype::float32_t &YawRateRaw_,
                                   const IndicatorStatus &Indicator_,
                                   const basetype::float32_t &SteeringAngle_):
            SpdLgt(SpdLgt_),
            SpdLat(SpdLat_),
            SpdLgtCompFac(SpdLgtCompFac_),
            AccelLgt(AccelLgt_),
            AccelLgtRaw(AccelLgtRaw_),
            AccelLatRaw(AccelLatRaw_),
            YawRate(YawRate_),
            YawRateRaw(YawRateRaw_),
            Indicator(Indicator_),
            SteeringAngle(SteeringAngle_) {
    }

    EgoVehicleInformation& operator=(const EgoVehicleInformation& rhs) {
        SpdLgt = rhs.SpdLgt;
        SpdLat = rhs.SpdLat;
        SpdLgtCompFac = rhs.SpdLgtCompFac;
        AccelLgt = rhs.AccelLgt;
        AccelLgtRaw = rhs.AccelLgtRaw;
        AccelLatRaw = rhs.AccelLatRaw;
        YawRate = rhs.YawRate;
        YawRateRaw = rhs.YawRateRaw;
        Indicator = rhs.Indicator;
        SteeringAngle = rhs.SteeringAngle;
        return *this;
    }
};

const EgoVehicleInformation EgoVehicleInformation_Default{EgoVehicleInformation_SpdLgt_Default,
                                                          EgoVehicleInformation_SpdLat_Default,
                                                          EgoVehicleInformation_SpdLgtCompFac_Default,
                                                          EgoVehicleInformation_AccelLgt_Default,
                                                          EgoVehicleInformation_AccelLgtRaw_Default,
                                                          EgoVehicleInformation_AccelLatRaw_Default,
                                                          EgoVehicleInformation_YawRate_Default,
                                                          EgoVehicleInformation_YawRateRaw_Default,
                                                          EgoVehicleInformation_Indicator_Default,
                                                          EgoVehicleInformation_SteeringAngle_Default};
    
}

#endif