/**
 * @file objectestimation.h
 * @author your name (you@domain.com)
 * @brief 
 * @version 0.1
 * @date 2022-01-21
 * 
 * @copyright Copyright (c) 2022
 * 
 */

#ifndef ACC_TARGET_SELECTION_OBJECTESTIMATION_H
#define ACC_TARGET_SELECTION_OBJECTESTIMATION_H

#include "basetype.h"
#include "simpleconstant.h"

namespace ACC_Target_Selection{
const basetype::float32_t ObjectEstimation_DisLgt_Default{zero_float32_t};
const basetype::float32_t ObjectEstimation_DisLat_Default{zero_float32_t};
const basetype::float32_t ObjectEstimation_Spd_Default{zero_float32_t};
const basetype::float32_t ObjectEstimation_SpdLgt_Default{zero_float32_t};
const basetype::float32_t ObjectEstimation_SpdLat_Default{zero_float32_t};
const basetype::float32_t ObjectEstimation_Accel_Default{zero_float32_t};
const basetype::float32_t ObjectEstimation_AccelLgt_Default{zero_float32_t};
const basetype::float32_t ObjectEstimation_AccelLat_Default{zero_float32_t};
const basetype::float32_t ObjectEstimation_HeadingAngle_Default{zero_float32_t};
const basetype::float32_t ObjectEstimation_Curvature_Default{zero_float32_t};
struct ObjectEstimation{
    basetype::float32_t DisLgt;
    basetype::float32_t DisLat;
    basetype::float32_t Spd;
    basetype::float32_t SpdLgt;
    basetype::float32_t SpdLat;
    basetype::float32_t Accel;
    basetype::float32_t AccelLgt;
    basetype::float32_t AccelLat;
    basetype::float32_t HeadingAngle;
    basetype::float32_t Curvature;
    
    explicit ObjectEstimation() :
            DisLgt(ObjectEstimation_DisLgt_Default),
            DisLat(ObjectEstimation_DisLat_Default),
            Spd(ObjectEstimation_Spd_Default),
            SpdLgt(ObjectEstimation_SpdLgt_Default),
            SpdLat(ObjectEstimation_SpdLat_Default),
            Accel(ObjectEstimation_Accel_Default),
            AccelLgt(ObjectEstimation_AccelLgt_Default),
            AccelLat(ObjectEstimation_AccelLat_Default),
            HeadingAngle(ObjectEstimation_HeadingAngle_Default),
            Curvature(ObjectEstimation_Curvature_Default) {
    }

    ObjectEstimation(const ObjectEstimation &r):
            DisLgt(r.DisLgt),
            DisLat(r.DisLat),
            Spd(r.Spd),
            SpdLgt(r.SpdLgt),
            SpdLat(r.SpdLat),
            Accel(r.Accel),
            AccelLgt(r.AccelLgt),
            AccelLat(r.AccelLat),
            HeadingAngle(r.HeadingAngle),
            Curvature(r.Curvature) {
    }

    explicit ObjectEstimation(const basetype::float32_t &DisLgt_,
                              const basetype::float32_t &DisLat_,
                              const basetype::float32_t &Spd_,
                              const basetype::float32_t &SpdLgt_,
                              const basetype::float32_t &SpdLat_,
                              const basetype::float32_t &Accel_,
                              const basetype::float32_t &AccelLgt_,
                              const basetype::float32_t &AccelLat_,
                              const basetype::float32_t &HeadingAngle_,
                              const basetype::float32_t &Curvature_):
            DisLgt(DisLgt_),
            DisLat(DisLat_),
            Spd(Spd_),
            SpdLgt(SpdLgt_),
            SpdLat(SpdLat_),
            Accel(Accel_),
            AccelLgt(AccelLgt_),
            AccelLat(AccelLat_),
            HeadingAngle(HeadingAngle_),
            Curvature(Curvature_) {
    }

    ObjectEstimation& operator=(const ObjectEstimation& rhs) {
        DisLgt = rhs.DisLgt;
        DisLat = rhs.DisLat;
        Spd = rhs.Spd;
        SpdLgt = rhs.SpdLgt;
        SpdLat = rhs.SpdLat;
        Accel = rhs.Accel;
        AccelLgt = rhs.AccelLgt;
        AccelLat = rhs.AccelLat;
        HeadingAngle = rhs.HeadingAngle;
        Curvature = rhs.Curvature;
        return *this;
    }
};

const ObjectEstimation ObjectEstimation_Default{ObjectEstimation_DisLgt_Default,
                                                ObjectEstimation_DisLat_Default,
                                                ObjectEstimation_Spd_Default,
                                                ObjectEstimation_SpdLgt_Default,
                                                ObjectEstimation_SpdLat_Default,
                                                ObjectEstimation_Accel_Default,
                                                ObjectEstimation_AccelLgt_Default,
                                                ObjectEstimation_AccelLat_Default,
                                                ObjectEstimation_HeadingAngle_Default,
                                                ObjectEstimation_Curvature_Default};
}

#endif