/**
 * @file objectinformation.h
 * @author your name (you@domain.com)
 * @brief 
 * @version 0.1
 * @date 2022-01-21
 * 
 * @copyright Copyright (c) 2022
 * 
 */

#ifndef ACC_TARGET_SELECTION_OBJECTINFORMATION_H
#define ACC_TARGET_SELECTION_OBJECTINFORMATION_H

#include "basetype.h"
#include "simpleconstant.h"
#include "objecttype.h"
#include "objectmotiontype.h"
#include "objectmotionhistorytype.h"

namespace ACC_Target_Selection{
const ObjectType ObjectInformation_Type_Default{ObjectType::Unknown};
const basetype::uint8_t ObjectInformation_Type_raw_Default{zero_uint8_t};
const basetype::float32_t ObjectInformation_Width_Default{zero_float32_t};
const basetype::float32_t ObjectInformation_Height_Default{zero_float32_t};
const basetype::float32_t ObjectInformation_Length_Default{zero_float32_t};
const ObjectMotionType ObjectInformation_MotionType_Default{ObjectMotionType::Unknown};
const ObjectMotionHistoryType ObjectInformation_MotionHistoryType_Default{ObjectMotionHistoryType::Unknown};
const basetype::float32_t ObjectInformation_DisLatFromLaneCenter_Default{zero_float32_t};
struct ObjectInformation{
    ObjectType Type;
    basetype::uint8_t Type_raw;
    basetype::float32_t Width;
    basetype::float32_t Height;
    basetype::float32_t Length;
    ObjectMotionType MotionType;
    ObjectMotionHistoryType MotionHistoryType;
    basetype::float32_t DisLatFromLaneCenter;

    explicit ObjectInformation() :
            Type(ObjectInformation_Type_Default),
            Type_raw(ObjectInformation_Type_raw_Default),
            Width(ObjectInformation_Width_Default),
            Height(ObjectInformation_Height_Default),
            Length(ObjectInformation_Length_Default),
            MotionType(ObjectInformation_MotionType_Default),
            MotionHistoryType(ObjectInformation_MotionHistoryType_Default),
            DisLatFromLaneCenter(ObjectInformation_DisLatFromLaneCenter_Default) {
    }

    ObjectInformation(const ObjectInformation &r):
            Type(r.Type),
            Type_raw(r.Type_raw),
            Width(r.Width),
            Height(r.Height),
            Length(r.Length),
            MotionType(r.MotionType),
            MotionHistoryType(r.MotionHistoryType),
            DisLatFromLaneCenter(r.DisLatFromLaneCenter) {
    }

    ObjectInformation(const ObjectType &Type_,
                      const basetype::uint8_t &Type_raw_,
                      const basetype::float32_t &Width_,
                      const basetype::float32_t &Height_,
                      const basetype::float32_t &Length_,
                      const ObjectMotionType &MotionType_,
                      const ObjectMotionHistoryType &MotionHistoryType_,
                      const basetype::float32_t &DisLatFromLaneCenter_):
            Type(Type_),
            Type_raw(Type_raw_),
            Width(Width_),
            Height(Height_),
            Length(Length_),
            MotionType(MotionType_),
            MotionHistoryType(MotionHistoryType_),
            DisLatFromLaneCenter(DisLatFromLaneCenter_) {
    }

    ObjectInformation& operator=(const ObjectInformation& rhs) {
        Type = rhs.Type;
        Type_raw = rhs.Type_raw;
        Width = rhs.Width;
        Height = rhs.Height;
        Length = rhs.Length;
        MotionType = rhs.MotionType; 
        MotionHistoryType = rhs.MotionHistoryType;
        DisLatFromLaneCenter = rhs.DisLatFromLaneCenter;
        return *this;
    }
};

const ObjectInformation ObjectInformation_Default{ObjectInformation_Type_Default,
                                                  ObjectInformation_Type_raw_Default,
                                                  ObjectInformation_Width_Default,
                                                  ObjectInformation_Height_Default,
                                                  ObjectInformation_Length_Default,
                                                  ObjectInformation_MotionType_Default,
                                                  ObjectInformation_MotionHistoryType_Default,
                                                  ObjectInformation_DisLatFromLaneCenter_Default};
}

#endif