/**
 * @file objectproperty.h
 * @author your name (you@domain.com)
 * @brief 
 * @version 0.1
 * @date 2022-01-21
 * 
 * @copyright Copyright (c) 2022
 * 
 */

#ifndef ACC_TARGET_SELECTION_OBJECTPROPERTY_H
#define ACC_TARGET_SELECTION_OBJECTPROPERTY_H

#include "basetype.h"
#include "simpleconstant.h"
#include "objecttrackstatus.h"
#include "objectdislatfromlanecenterqf.h"
#include "objectfusionsource.h"

namespace ACC_Target_Selection{
const basetype::objectid_t ObjectProperty_Id_Default{zero_objectid_t};
const basetype::uint32_t ObjectProperty_CameraId_Default{zero_uint32_t};
const basetype::uint32_t ObjectProperty_RadarId_Default{zero_uint32_t};
const ObjectTrackStatus ObjectProperty_TrackStatus_Default{ObjectTrackStatus::Invalid};
const ObjectDisLatFromLaneCenterQf ObjectProperty_DisLatFromLaneCenterQf_Default{ObjectDisLatFromLaneCenterQf::UnReliable};
const basetype::float32_t ObjectProperty_DisLgtStdDev_Default{zero_float32_t};
const basetype::float32_t ObjectProperty_DisLatStdDev_Default{zero_float32_t};
const basetype::float32_t ObjectProperty_HeadingAngleStdDev_Default{zero_float32_t};
const basetype::float32_t ObjectProperty_SpdStdDev_Default{zero_float32_t};
const basetype::float32_t ObjectProperty_AccelStdDev_Default{zero_float32_t};
const ObjectFusionSource ObjectProperty_FusionSource_Default{ObjectFusionSource::None};
struct ObjectProperty{
    basetype::objectid_t Id;
    basetype::uint32_t CameraId;
    basetype::uint32_t RadarId;
    ObjectTrackStatus TrackStatus;
    ObjectDisLatFromLaneCenterQf DisLatFromLaneCenterQf;
    basetype::float32_t DisLgtStdDev;
    basetype::float32_t DisLatStdDev;
    basetype::float32_t HeadingAngleStdDev;
    basetype::float32_t SpdStdDev;
    basetype::float32_t AccelStdDev;
    ObjectFusionSource FusionSource;
    
    explicit ObjectProperty() :
            Id(ObjectProperty_Id_Default),
            CameraId(ObjectProperty_CameraId_Default),
            RadarId(ObjectProperty_RadarId_Default),
            TrackStatus(ObjectProperty_TrackStatus_Default),
            DisLatFromLaneCenterQf(ObjectProperty_DisLatFromLaneCenterQf_Default),
            DisLgtStdDev(ObjectProperty_DisLgtStdDev_Default),
            DisLatStdDev(ObjectProperty_DisLatStdDev_Default),
            HeadingAngleStdDev(ObjectProperty_HeadingAngleStdDev_Default),
            SpdStdDev(ObjectProperty_SpdStdDev_Default),
            AccelStdDev(ObjectProperty_AccelStdDev_Default),
            FusionSource(ObjectProperty_FusionSource_Default) {
    }

    ObjectProperty(const ObjectProperty &r):
            Id(r.Id),
            CameraId(r.CameraId),
            RadarId(r.RadarId),
            TrackStatus(r.TrackStatus),
            DisLatFromLaneCenterQf(r.DisLatFromLaneCenterQf),
            DisLgtStdDev(r.DisLgtStdDev),
            DisLatStdDev(r.DisLatStdDev),
            HeadingAngleStdDev(r.HeadingAngleStdDev),
            SpdStdDev(r.SpdStdDev),
            AccelStdDev(r.AccelStdDev),
            FusionSource(r.FusionSource) {
    }

    explicit ObjectProperty(const basetype::objectid_t &Id_,
                            const basetype::uint32_t &CameraId_,
                            const basetype::uint32_t &RadarId_,
                            const ObjectTrackStatus &TrackStatus_,
                            const ObjectDisLatFromLaneCenterQf &DisLatFromLaneCenterQf_,
                            const basetype::float32_t &DisLgtStdDev_,
                            const basetype::float32_t &DisLatStdDev_,
                            const basetype::float32_t &HeadingAngleStdDev_,
                            const basetype::float32_t &SpdStdDev_,
                            const basetype::float32_t &AccelStdDev_,
                            const ObjectFusionSource &FusionSource_):
            Id(Id_),
            CameraId(CameraId_),
            RadarId(RadarId_),
            TrackStatus(TrackStatus_),
            DisLatFromLaneCenterQf(DisLatFromLaneCenterQf_),
            DisLgtStdDev(DisLgtStdDev_),
            DisLatStdDev(DisLatStdDev_),
            HeadingAngleStdDev(HeadingAngleStdDev_),
            SpdStdDev(SpdStdDev_),
            AccelStdDev(AccelStdDev_),
            FusionSource(FusionSource_) {
    }

    ObjectProperty& operator=(const ObjectProperty& rhs) {
        Id = rhs.Id;
        CameraId = rhs.CameraId;
        RadarId = rhs.RadarId;
        TrackStatus = rhs.TrackStatus;
        DisLatFromLaneCenterQf = rhs.DisLatFromLaneCenterQf;
        DisLgtStdDev = rhs.DisLgtStdDev;
        DisLatStdDev = rhs.DisLatStdDev;
        HeadingAngleStdDev = rhs.HeadingAngleStdDev;
        SpdStdDev = rhs.SpdStdDev;
        AccelStdDev = rhs.AccelStdDev;
        FusionSource = rhs.FusionSource;
        return *this;
    }
};

const ObjectProperty ObjectProperty_Default{ObjectProperty_Id_Default,
                                            ObjectProperty_CameraId_Default,
                                            ObjectProperty_RadarId_Default,
                                            ObjectProperty_TrackStatus_Default,
                                            ObjectProperty_DisLatFromLaneCenterQf_Default,
                                            ObjectProperty_DisLgtStdDev_Default,
                                            ObjectProperty_DisLatStdDev_Default,
                                            ObjectProperty_HeadingAngleStdDev_Default,
                                            ObjectProperty_SpdStdDev_Default,
                                            ObjectProperty_AccelStdDev_Default,
                                            ObjectProperty_FusionSource_Default};
}

#endif