/**
 * @file objects.h
 * @author your name (you@domain.com)
 * @brief 
 * @version 0.1
 * @date 2022-01-21
 * 
 * @copyright Copyright (c) 2s022
 * 
 */

#ifndef ACC_TARGET_SELECTION_OBJECTS_H
#define ACC_TARGET_SELECTION_OBJECTS_H

#include "object.h"
#include "param.h"

#include <array>
#include <initializer_list>

namespace ACC_Target_Selection {

struct Objects : std::array<Object, c_ObjectSize> {
    explicit Objects() {
        basetype::objectid_t idn{zero_objectid_t};
        for (auto &elem : *this) {
            elem = Object_Default;
            elem.Ppty.Id = ++idn;
        }
    }

    Objects(const Objects &r) {
        for (std::size_t ii = 0; ii < r.size(); ii++) {
            this->at(ii) = r.at(ii);
        }   
    }

    explicit Objects(std::initializer_list<Object> list) {
        std::size_t count{0};
        for (auto &elem : list) {
            this->at(count) = elem;
            this->at(count).Ppty.Id = static_cast<basetype::objectid_t>(++count);
        }
        if (list.size() < c_ObjectSize) {
            for (std::size_t ii = list.size(); ii < c_ObjectSize; ii++) {
                this->at(ii) = Object_Default;
                this->at(count).Ppty.Id = static_cast<basetype::objectid_t>(++count);
            }
        }
    }
    
    Objects& operator=(const Objects& rhs) {
        for (std::size_t ii = 0; ii < rhs.size(); ii++) {
            this->at(ii) = rhs.at(ii);
        }
        return *this;
    }
};
}

#endif