/**
 * @file roadproperty.h
 * @author your name (you@domain.com)
 * @brief 
 * @version 0.1
 * @date 2022-01-21
 * 
 * @copyright Copyright (c) 2022
 * 
 */

#ifndef ACC_TARGET_SELECTION_ROADPROPERTY_H
#define ACC_TARGET_SELECTION_ROADPROPERTY_H

#include "basetype.h"
#include "simpleconstant.h"

namespace ACC_Target_Selection {
const basetype::float32_t RoadProperty_LaneWidth_Default{3.6f};
const basetype::float32_t RoadProperty_LateralOffset_Default{zero_float32_t};
const basetype::boolean_t RoadProperty_Valid_Default{boolean_t_false};
struct RoadProperty {
    basetype::float32_t LaneWidth;
    basetype::float32_t LateralOffset;
    basetype::boolean_t Valid;

    explicit RoadProperty() :
            LaneWidth(RoadProperty_LaneWidth_Default),
            LateralOffset(RoadProperty_LateralOffset_Default),
            Valid(RoadProperty_Valid_Default) {
    }

    RoadProperty(const RoadProperty &r):
            LaneWidth(r.LaneWidth),
            LateralOffset(r.LateralOffset),
            Valid(r.Valid) {
    }

    explicit RoadProperty(const basetype::uint32_t &LaneWidth_,
                          const basetype::uint32_t &LateralOffset_,
                          const basetype::uint32_t &Valid_) :
            LaneWidth(LaneWidth_),
            LateralOffset(LateralOffset_),
            Valid(Valid_) {
    }

    RoadProperty& operator=(const RoadProperty& rhs) {
        LaneWidth = rhs.LaneWidth;
        LateralOffset = rhs.LateralOffset;
        Valid = rhs.Valid;
        return *this;
    }
};

const RoadProperty RoadProperty_Default{RoadProperty_LaneWidth_Default,
                                        RoadProperty_LateralOffset_Default,
                                        RoadProperty_Valid_Default};
    
}

#endif