#ifndef ACC_TARGET_SELECTION_PARAM_H
#define ACC_TARGET_SELECTION_PARAM_H

#include "basetype.h"
#include "simpleconstant.h"

#include <vector>

namespace ACC_Target_Selection {

    const basetype::objectid_t c_ObjectSize{255u};
    const basetype::objectid_t c_ObjectIndexMin{1u};
    const basetype::objectid_t c_ObjectIndexMax{255u};
    const basetype::float32_t c_SampleTime{0.025f};
    const basetype::float32_t pi{3.14159f};

    const basetype::boolean_t usecomcheck{boolean_t_true};
    const basetype::float32_t Param_Validator_maxcoastingtime_Default{0.25f};
    const basetype::uint8_t Param_Validator_minjumpthreshold_Default{5u};
    const basetype::float32_t Param_Validator_maxposjumpthreshold_Default{3.5f};
    const basetype::uint8_t Param_Validator_maxmaturitythreshold_Default{50u};
    const std::vector<basetype::float32_t> Param_Validator_stddevthresholdbps_Default{0.0f,25.0f,50.0f,75.0f,100.0f,125.0f,150.0f,175.0f,200.0f};
    const std::vector<basetype::uint8_t> Param_Validator_minmaturitythreshold_Default{2u,2u,2u,2u,2u,2u,2u,2u,2u};
    const std::vector<basetype::uint8_t> Param_Validator_minmaturitythreshold2_Default{2u,2u,2u,2u,2u,2u,2u,2u,2u};
    const basetype::boolean_t Param_Validator_disableposnqly_Default{boolean_t_false};
    const basetype::float32_t Param_Validator_mintargetdistance_Default{3.7f};
    const basetype::float32_t Param_Validator_lgtdistancedevthreshold_Default{300.0f};
    const basetype::float32_t Param_Validator_latdistancedevthreshold_Default{99.0f};
    const basetype::float32_t Param_Validator_acceldevthreshold_Default{50.0f};
    const basetype::float32_t Param_Validator_headingangledevthreshold_Default{5.0f};
    const basetype::float32_t Param_Validator_maxegospdforstationaryobject_Default{20.0f};
    const basetype::float32_t Param_Validator_useallobjectsmaxobjectdistance_Default{8.0f};
    const basetype::float32_t Param_Validator_useallobjectsmaxegospd_Default{0.0f};
    const basetype::boolean_t Param_Validator_usefixforoncomingwithnegativespeed_Default{boolean_t_true};
    const basetype::float32_t Param_Validator_minspdforignoringunknownobject_Default{4.0f};
    const basetype::float32_t Param_Validator_maxdifferentspdunknownobject2ego_Default{3.0f};
    const basetype::float32_t Param_Validator_minspeedofunknown_Default{3.0f};
    const basetype::float32_t Param_Validator_egospdforignoringunknownobject_Default{15.0f};
    const basetype::float32_t Param_Validator_mindistanceforstationaryormoving_Default{0.1f};
    const basetype::float32_t Param_Validator_maxdistanceforcameraonlymotor_Default{35.0f};
    const basetype::float32_t Param_Validator_mindistanceforcameraonlymotor_Default{0.1f};
    const basetype::float32_t Param_Validator_maxdistanceforcameraonlycar_Default{65.0f};
    const basetype::float32_t Param_Validator_mindistanceforcameraonlycar_Default{0.1f};
    const basetype::float32_t Param_Validator_maxegospdforcameraonlycar_Default{27.0f};
    const basetype::float32_t Param_Validator_maxselectionrange_Default{150.0f};
    const std::vector<basetype::float32_t> Param_Validator_maxdynamicselectionrangespeedbp_Default{8.33f, 13.88f, 19.44f, 22.22f, 27.77f, 33.33f};
    const std::vector<basetype::float32_t> Param_Validator_maxdynamicselectionrange_Default{50.0f, 70.0f, 100.0f, 110.0f, 130.0f, 150.0f};
    const basetype::float32_t Param_Validator_maxtargetreardistance_Default{-70.0f};
    const basetype::float32_t Param_Validator_maxreardistanceforcameraonlymotor_Default{-1.0f};
    const basetype::float32_t Param_Validator_minreardistanceforcameraonlymotor_Default{-40.0f};
    const basetype::float32_t Param_Validator_maxreardistanceforcameraonlycar_Default{-1.0f};
    const basetype::float32_t Param_Validator_minreardistanceforcameraonlycar_Default{-60.0f};
    const basetype::float32_t Param_Validator_maxreardistanceforstationaryormoving_Default{-150.0f};
    const basetype::float32_t Param_Validator_speedthresholdforheading_Default{0.5f};
    struct Param_Validator {
        basetype::float32_t maxcoastingtime;
        basetype::uint8_t minjumpthreshold;
        basetype::float32_t maxposjumpthreshold;
        basetype::uint8_t maxmaturitythreshold;
        std::vector<basetype::float32_t> stddevthresholdbps;
        std::vector<basetype::uint8_t> minmaturitythreshold;
        std::vector<basetype::uint8_t> minmaturitythreshold2;
        basetype::boolean_t disableposnqly;
        basetype::float32_t mintargetdistance;
        basetype::float32_t lgtdistancedevthreshold;
        basetype::float32_t latdistancedevthreshold;
        basetype::float32_t acceldevthreshold ;
        basetype::float32_t headingangledevthreshold;
        basetype::float32_t maxegospdforstationaryobject;
        basetype::float32_t useallobjectsmaxobjectdistance;
        basetype::float32_t useallobjectsmaxegospd;
        basetype::boolean_t usefixforoncomingwithnegativespeed;
        basetype::float32_t minspdforignoringunknownobject ;
        basetype::float32_t maxdifferentspdunknownobject2ego;
        basetype::float32_t minspeedofunknown;
        basetype::float32_t egospdforignoringunknownobject ;
        basetype::float32_t mindistanceforstationaryormoving;
        basetype::float32_t maxdistanceforcameraonlymotor;
        basetype::float32_t mindistanceforcameraonlymotor;
        basetype::float32_t maxdistanceforcameraonlycar;
        basetype::float32_t mindistanceforcameraonlycar;
        basetype::float32_t maxegospdforcameraonlycar;
        basetype::float32_t maxselectionrange;
        std::vector<basetype::float32_t> maxdynamicselectionrangespeedbp;
        std::vector<basetype::float32_t> maxdynamicselectionrange;
        basetype::float32_t maxtargetreardistance;
        basetype::float32_t maxreardistanceforcameraonlymotor;
        basetype::float32_t minreardistanceforcameraonlymotor;
        basetype::float32_t maxreardistanceforcameraonlycar;
        basetype::float32_t minreardistanceforcameraonlycar;
        basetype::float32_t maxreardistanceforstationaryormoving;
        basetype::float32_t speedthresholdforheading;
        explicit Param_Validator() :
            maxcoastingtime(Param_Validator_maxcoastingtime_Default),
            minjumpthreshold (Param_Validator_minjumpthreshold_Default),
            maxposjumpthreshold(Param_Validator_maxposjumpthreshold_Default),
            maxmaturitythreshold(Param_Validator_maxmaturitythreshold_Default),
            stddevthresholdbps(Param_Validator_stddevthresholdbps_Default),
            minmaturitythreshold(Param_Validator_minmaturitythreshold_Default),
            minmaturitythreshold2(Param_Validator_minmaturitythreshold2_Default),
            disableposnqly(Param_Validator_disableposnqly_Default),
            mintargetdistance(Param_Validator_mintargetdistance_Default),
            lgtdistancedevthreshold(Param_Validator_lgtdistancedevthreshold_Default),
            latdistancedevthreshold(Param_Validator_latdistancedevthreshold_Default),
            acceldevthreshold(Param_Validator_acceldevthreshold_Default),
            headingangledevthreshold(Param_Validator_headingangledevthreshold_Default),
            maxegospdforstationaryobject(Param_Validator_maxegospdforstationaryobject_Default),
            useallobjectsmaxobjectdistance(Param_Validator_useallobjectsmaxobjectdistance_Default),
            useallobjectsmaxegospd(Param_Validator_useallobjectsmaxegospd_Default),
            usefixforoncomingwithnegativespeed(Param_Validator_usefixforoncomingwithnegativespeed_Default),
            minspdforignoringunknownobject(Param_Validator_minspdforignoringunknownobject_Default),
            maxdifferentspdunknownobject2ego(Param_Validator_maxdifferentspdunknownobject2ego_Default),
            minspeedofunknown(Param_Validator_minspeedofunknown_Default),
            egospdforignoringunknownobject(Param_Validator_egospdforignoringunknownobject_Default),
            mindistanceforstationaryormoving(Param_Validator_mindistanceforstationaryormoving_Default),
            maxdistanceforcameraonlymotor(Param_Validator_maxdistanceforcameraonlymotor_Default),
            mindistanceforcameraonlymotor(Param_Validator_mindistanceforcameraonlymotor_Default),
            maxdistanceforcameraonlycar(Param_Validator_maxdistanceforcameraonlycar_Default),
            mindistanceforcameraonlycar(Param_Validator_mindistanceforcameraonlycar_Default),
            maxegospdforcameraonlycar(Param_Validator_maxegospdforcameraonlycar_Default),
            maxselectionrange(Param_Validator_maxselectionrange_Default),
            maxdynamicselectionrangespeedbp(Param_Validator_maxdynamicselectionrangespeedbp_Default),
            maxdynamicselectionrange(Param_Validator_maxdynamicselectionrange_Default),
            maxtargetreardistance(Param_Validator_maxtargetreardistance_Default),
            maxreardistanceforcameraonlymotor(Param_Validator_maxreardistanceforcameraonlymotor_Default),
            minreardistanceforcameraonlymotor(Param_Validator_minreardistanceforcameraonlymotor_Default),
            maxreardistanceforcameraonlycar(Param_Validator_maxreardistanceforcameraonlycar_Default),
            minreardistanceforcameraonlycar(Param_Validator_minreardistanceforcameraonlycar_Default),
            maxreardistanceforstationaryormoving(Param_Validator_maxreardistanceforstationaryormoving_Default),
            speedthresholdforheading(Param_Validator_speedthresholdforheading_Default) {
        }
        
        Param_Validator(const Param_Validator &r):
            maxcoastingtime(r.maxcoastingtime),
            minjumpthreshold(r.minjumpthreshold),
            maxposjumpthreshold(r.maxposjumpthreshold),
            maxmaturitythreshold(r.maxmaturitythreshold),
            stddevthresholdbps(r.stddevthresholdbps),
            minmaturitythreshold(r.minmaturitythreshold),
            minmaturitythreshold2(r.minmaturitythreshold2),
            disableposnqly(r.disableposnqly),
            mintargetdistance(r.mintargetdistance),
            lgtdistancedevthreshold(r.lgtdistancedevthreshold),
            latdistancedevthreshold(r.latdistancedevthreshold),
            acceldevthreshold (r.acceldevthreshold),
            headingangledevthreshold(r.headingangledevthreshold),
            maxegospdforstationaryobject(r.maxegospdforstationaryobject),
            useallobjectsmaxobjectdistance(r.useallobjectsmaxobjectdistance),
            useallobjectsmaxegospd(r.useallobjectsmaxegospd),
            usefixforoncomingwithnegativespeed(r.usefixforoncomingwithnegativespeed),
            minspdforignoringunknownobject (r.minspdforignoringunknownobject),
            maxdifferentspdunknownobject2ego(r.maxdifferentspdunknownobject2ego),
            minspeedofunknown(r.minspeedofunknown),
            egospdforignoringunknownobject (r.egospdforignoringunknownobject),
            mindistanceforstationaryormoving(r.mindistanceforstationaryormoving),
            maxdistanceforcameraonlymotor(r.maxdistanceforcameraonlymotor),
            mindistanceforcameraonlymotor(r.mindistanceforcameraonlymotor),
            maxdistanceforcameraonlycar(r.maxdistanceforcameraonlycar),
            mindistanceforcameraonlycar(r.mindistanceforcameraonlycar),
            maxegospdforcameraonlycar(r.maxegospdforcameraonlycar),
            maxselectionrange(r.maxselectionrange),
            maxdynamicselectionrangespeedbp(r.maxdynamicselectionrangespeedbp),
            maxdynamicselectionrange(r.maxdynamicselectionrange),
            maxtargetreardistance(r.maxtargetreardistance),
            maxreardistanceforcameraonlymotor(r.maxreardistanceforcameraonlymotor),
            minreardistanceforcameraonlymotor(r.minreardistanceforcameraonlymotor),
            maxreardistanceforcameraonlycar(r.maxreardistanceforcameraonlycar),
            minreardistanceforcameraonlycar(r.minreardistanceforcameraonlycar),
            maxreardistanceforstationaryormoving(r.maxreardistanceforstationaryormoving),
            speedthresholdforheading(r.speedthresholdforheading) {
        }
        /**
        Param_Validator(const std::shared_ptr<Param_Validator> &r):
                maxcoastingtime(r->maxcoastingtime),
                minjumpthreshold(r->minjumpthreshold),
                maxposjumpthreshold(r->maxposjumpthreshold),
                maxmaturitythreshold(r->maxmaturitythreshold),
                stddevthresholdbps(r->stddevthresholdbps),
                minmaturitythreshold(r->minmaturitythreshold),
                minmaturitythreshold2(r->minmaturitythreshold2),
                disableposnqly(r->disableposnqly),
                mintargetdistance(r->mintargetdistance),
                lgtdistancedevthreshold(r->lgtdistancedevthreshold),
                latdistancedevthreshold(r->latdistancedevthreshold),
                acceldevthreshold (r->acceldevthreshold),
                headingangledevthreshold(r->headingangledevthreshold),
                maxegospdforstationaryobject(r->maxegospdforstationaryobject),
                useallobjectsmaxobjectdistance(r->useallobjectsmaxobjectdistance),
                useallobjectsmaxegospd(r->useallobjectsmaxegospd),
                usefixforoncomingwithnegativespeed(r->usefixforoncomingwithnegativespeed),
                minspdforignoringunknownobject (r->minspdforignoringunknownobject),
                maxdifferentspdunknownobject2ego(r->maxdifferentspdunknownobject2ego),
                minspeedofunknown(r->minspeedofunknown),
                egospdforignoringunknownobject (r->egospdforignoringunknownobject),
                mindistanceforstationaryormoving(r->mindistanceforstationaryormoving),
                maxdistanceforcameraonlymotor(r->maxdistanceforcameraonlymotor),
                mindistanceforcameraonlymotor(r->mindistanceforcameraonlymotor),
                maxdistanceforcameraonlycar(r->maxdistanceforcameraonlycar),
                mindistanceforcameraonlycar(r->mindistanceforcameraonlycar),
                maxegospdforcameraonlycar(r->maxegospdforcameraonlycar),
                maxselectionrange(r->maxselectionrange),
                maxdynamicselectionrangespeedbp(r->maxdynamicselectionrangespeedbp),
                maxdynamicselectionrange(r->maxdynamicselectionrange),
                maxtargetreardistance(r->maxtargetreardistance),
                maxreardistanceforcameraonlymotor(r->maxreardistanceforcameraonlymotor),
                minreardistanceforcameraonlymotor(r->minreardistanceforcameraonlymotor),
                maxreardistanceforcameraonlycar(r->maxreardistanceforcameraonlycar),
                minreardistanceforcameraonlycar(r->minreardistanceforcameraonlycar),
                maxreardistanceforstationaryormoving(r->maxreardistanceforstationaryormoving),
                speedthresholdforheading(r->speedthresholdforheading) {
        }**/
        explicit Param_Validator(const basetype::float32_t &maxcoastingtime_,
                                 const basetype::uint8_t &minjumpthreshold_,
                                 const basetype::float32_t &maxposjumpthreshold_,
                                 const basetype::uint8_t &maxmaturitythreshold_,
                                 const std::vector<basetype::float32_t> &stddevthresholdbps_,
                                 const std::vector<basetype::uint8_t> &minmaturitythreshold_,
                                 const std::vector<basetype::uint8_t> &minmaturitythreshold2_,
                                 const basetype::boolean_t &disableposnqly_,
                                 const basetype::float32_t &mintargetdistance_,
                                 const basetype::float32_t &lgtdistancedevthreshold_,
                                 const basetype::float32_t &latdistancedevthreshold_,
                                 const basetype::float32_t &acceldevthreshold_,
                                 const basetype::float32_t &headingangledevthreshold_,
                                 const basetype::float32_t &maxegospdforstationaryobject_,
                                 const basetype::float32_t &useallobjectsmaxobjectdistance_,
                                 const basetype::float32_t &useallobjectsmaxegospd_,
                                 const basetype::boolean_t &usefixforoncomingwithnegativespeed_,
                                 const basetype::float32_t &minspdforignoringunknownobject_,
                                 const basetype::float32_t &maxdifferentspdunknownobject2ego_,
                                 const basetype::float32_t &minspeedofunknown_,
                                 const basetype::float32_t &egospdforignoringunknownobject_,
                                 const basetype::float32_t &mindistanceforstationaryormoving_,
                                 const basetype::float32_t &maxdistanceforcameraonlymotor_,
                                 const basetype::float32_t &mindistanceforcameraonlymotor_,
                                 const basetype::float32_t &maxdistanceforcameraonlycar_,
                                 const basetype::float32_t &mindistanceforcameraonlycar_,
                                 const basetype::float32_t &maxegospdforcameraonlycar_,
                                 const basetype::float32_t &maxselectionrange_,
                                 const std::vector<basetype::float32_t> &maxdynamicselectionrangespeedbp_,
                                 const std::vector<basetype::float32_t> &maxdynamicselectionrange_,
                                 const basetype::float32_t &maxtargetreardistance_,
                                 const basetype::float32_t &maxreardistanceforcameraonlymotor_,
                                 const basetype::float32_t &minreardistanceforcameraonlymotor_,
                                 const basetype::float32_t &maxreardistanceforcameraonlycar_,
                                 const basetype::float32_t &minreardistanceforcameraonlycar_,
                                 const basetype::float32_t &maxreardistanceforstationaryormoving_,
                                 const basetype::float32_t &speedthresholdforheading_):
                maxcoastingtime(maxcoastingtime_),
                minjumpthreshold(minjumpthreshold_),
                maxposjumpthreshold(maxposjumpthreshold_),
                maxmaturitythreshold(maxmaturitythreshold_),
                stddevthresholdbps(stddevthresholdbps_),
                minmaturitythreshold(minmaturitythreshold_),
                minmaturitythreshold2(minmaturitythreshold2_),
                disableposnqly(disableposnqly_),
                mintargetdistance(mintargetdistance_),
                lgtdistancedevthreshold(lgtdistancedevthreshold_),
                latdistancedevthreshold(latdistancedevthreshold_),
                acceldevthreshold(acceldevthreshold_),
                headingangledevthreshold(headingangledevthreshold_),
                maxegospdforstationaryobject(maxegospdforstationaryobject_),
                useallobjectsmaxobjectdistance(useallobjectsmaxobjectdistance_),
                useallobjectsmaxegospd(useallobjectsmaxegospd_),
                usefixforoncomingwithnegativespeed(usefixforoncomingwithnegativespeed_),
                minspdforignoringunknownobject (minspdforignoringunknownobject_),
                maxdifferentspdunknownobject2ego(maxdifferentspdunknownobject2ego_),
                minspeedofunknown(minspeedofunknown_),
                egospdforignoringunknownobject (egospdforignoringunknownobject_),
                mindistanceforstationaryormoving(mindistanceforstationaryormoving_),
                maxdistanceforcameraonlymotor(maxdistanceforcameraonlymotor_),
                mindistanceforcameraonlymotor(mindistanceforcameraonlymotor_),
                maxdistanceforcameraonlycar(maxdistanceforcameraonlycar_),
                mindistanceforcameraonlycar(mindistanceforcameraonlycar_),
                maxegospdforcameraonlycar(maxegospdforcameraonlycar_),
                maxselectionrange(maxselectionrange_),
                maxdynamicselectionrangespeedbp(maxdynamicselectionrangespeedbp_),
                maxdynamicselectionrange(maxdynamicselectionrange_),
                maxtargetreardistance(maxtargetreardistance_),
                maxreardistanceforcameraonlymotor(maxreardistanceforcameraonlymotor_),
                minreardistanceforcameraonlymotor(minreardistanceforcameraonlymotor_),
                maxreardistanceforcameraonlycar(maxreardistanceforcameraonlycar_),
                minreardistanceforcameraonlycar(minreardistanceforcameraonlycar_),
                maxreardistanceforstationaryormoving(maxreardistanceforstationaryormoving_),
                speedthresholdforheading(speedthresholdforheading_) {
        }

        Param_Validator& operator=(const Param_Validator& rhs) {
            maxcoastingtime = rhs.maxcoastingtime;
            minjumpthreshold = rhs.minjumpthreshold;
            maxposjumpthreshold = rhs.maxposjumpthreshold;
            maxmaturitythreshold = rhs.maxmaturitythreshold;
            stddevthresholdbps = rhs.stddevthresholdbps;
            minmaturitythreshold = rhs.minmaturitythreshold;
            minmaturitythreshold2 = rhs.minmaturitythreshold2;
            disableposnqly = rhs.disableposnqly;
            mintargetdistance = rhs.mintargetdistance;
            lgtdistancedevthreshold = rhs.lgtdistancedevthreshold;
            latdistancedevthreshold = rhs.latdistancedevthreshold;
            acceldevthreshold  = rhs.acceldevthreshold;
            headingangledevthreshold = rhs.headingangledevthreshold;
            maxegospdforstationaryobject = rhs.maxegospdforstationaryobject;
            useallobjectsmaxobjectdistance = rhs.useallobjectsmaxobjectdistance;
            useallobjectsmaxegospd = rhs.useallobjectsmaxegospd;
            usefixforoncomingwithnegativespeed = rhs.usefixforoncomingwithnegativespeed;
            minspdforignoringunknownobject  = rhs.minspdforignoringunknownobject;
            maxdifferentspdunknownobject2ego = rhs.maxdifferentspdunknownobject2ego;
            minspeedofunknown = rhs.minspeedofunknown;
            egospdforignoringunknownobject  = rhs.egospdforignoringunknownobject;
            mindistanceforstationaryormoving = rhs.mindistanceforstationaryormoving;
            maxdistanceforcameraonlymotor = rhs.maxdistanceforcameraonlymotor;
            mindistanceforcameraonlymotor = rhs.mindistanceforcameraonlymotor;
            maxdistanceforcameraonlycar = rhs.maxdistanceforcameraonlycar;
            mindistanceforcameraonlycar = rhs.mindistanceforcameraonlycar;
            maxegospdforcameraonlycar = rhs.maxegospdforcameraonlycar;
            maxselectionrange = rhs.maxselectionrange;
            maxdynamicselectionrangespeedbp = rhs.maxdynamicselectionrangespeedbp;
            maxdynamicselectionrange = rhs.maxdynamicselectionrange;
            maxtargetreardistance = rhs.maxtargetreardistance;
            maxreardistanceforcameraonlymotor = rhs.maxreardistanceforcameraonlymotor;
            minreardistanceforcameraonlymotor = rhs.minreardistanceforcameraonlymotor;
            maxreardistanceforcameraonlycar = rhs.maxreardistanceforcameraonlycar;
            minreardistanceforcameraonlycar = rhs.minreardistanceforcameraonlycar;
            maxreardistanceforstationaryormoving = rhs.maxreardistanceforstationaryormoving;
            speedthresholdforheading = rhs.speedthresholdforheading;
            return *this;
        }
    };

    const std::vector<basetype::float32_t> Param_Funnel_funneloffsetspeed_Default{0.0f,2.0f,5.0f,10.0f,20.0f,30.0f,40.0f,55.0f};
    const std::vector<basetype::float32_t> Param_Funnel_funneloffsetnormal_Default{0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f};
    const std::vector<basetype::float32_t> Param_Funnel_funneloffsetovertaking_Default{0.4f,0.4f,0.5f,1.2f,1.5f,1.5f,1.5f,1.5f};
    const std::vector<basetype::float32_t> Param_Funnel_funneloffsetopposite_Default{-0.4f,-0.4f,-0.4f,-0.4f,-0.4f,-0.4f,-0.4f,-0.4f};
    const std::vector<basetype::float32_t> Param_Funnel_innerfunneloffsetovertaking_Default{0.2f,0.2f,0.25f,0.6f,0.75f,0.75f,0.75f,0.75f};
    const std::vector<basetype::float32_t> Param_Funnel_innerfunneloffsetopposite_Default{-0.2f,-0.2f,-0.2f,-0.2f,-0.2f,-0.2f,-0.2f,-0.2f};
    const basetype::float32_t Param_Funnel_unnelgrowthrate_Default{0.8f};
    const basetype::float32_t Param_Funnel_funnelshrinkrate_Default{-0.25f};
    const basetype::float32_t Param_Funnel_innerfunnelgrowthrate_Default{0.5f};
    const basetype::float32_t Param_Funnel_innerfunnelshrinkrate_Default{-0.15f};
    const std::vector<basetype::float32_t> Param_Funnel_funnelbreakpoints_Default{0.0f,1.0f,4.0f,12.0f,20.0f,40.0f,60.0f,80.0f,100.0f,150.0f,200.0f};
    const basetype::float32_t Param_Funnel_maxrangehighquality_Default{200.0f};
    const std::vector<basetype::float32_t> Param_Funnel_innerfunnelwidth_Default{0.20f,0.20f,0.62f,0.75f,0.75f,0.75f,0.75f,0.75f,0.65f,0.63f,0.66f};
    const std::vector<basetype::float32_t> Param_Funnel_outerfunnelwidth_Default{0.60f,0.60f,0.80f,0.88f,0.90f,0.85f,0.85f,0.85f,0.85f,0.85f,0.85f};
    const basetype::float32_t Param_Funnel_adjacentlanemultifactorinner_Default{3.0f};
    const basetype::float32_t Param_Funnel_adjacentlanemultifactorouter_Default{1.08f};
    const basetype::float32_t Param_Funnel_rightinnerlowconfscaling_Default{0.5f};
    const basetype::float32_t Param_Funnel_rightouterlowconfscaling_Default{1.0f};
    const basetype::float32_t Param_Funnel_minrangehighquality_Default{-100.0f};
    const std::vector<basetype::float32_t> Param_Funnel_funnelrearbreakpoints_Default{-200.0f,-150.0f,-100.0f,-80.0f,-60.0f,-40.0f,-20.0f,-12.0f,-4.0f,-1.0f,0.0f};
    const std::vector<basetype::float32_t> Param_Funnel_innerrearfunnelwidth_Default{0.66f,0.63f,0.65f,0.75f,0.75f,0.75f,0.81f,0.81f,0.62f,0.20f,0.20f};
    const std::vector<basetype::float32_t> Param_Funnel_outerrearfunnelwidth_Default{1.20f,1.20f,1.10f,0.94f,0.94f,0.94f,0.95f,0.95f,0.80f,0.60f,0.60f};

    struct Param_Funnel {
        std::vector<basetype::float32_t> funneloffsetspeed;
        std::vector<basetype::float32_t> funneloffsetnormal;
        std::vector<basetype::float32_t> funneloffsetovertaking;
        std::vector<basetype::float32_t> funneloffsetopposite;
        std::vector<basetype::float32_t> innerfunneloffsetovertaking;
        std::vector<basetype::float32_t> innerfunneloffsetopposite;
        basetype::float32_t funnelgrowthrate;
        basetype::float32_t funnelshrinkrate;
        basetype::float32_t innerfunnelgrowthrate;
        basetype::float32_t innerfunnelshrinkrate;
        std::vector<basetype::float32_t> funnelbreakpoints;
        basetype::float32_t maxrangehighquality;
        std::vector<basetype::float32_t> innerfunnelwidth;
        std::vector<basetype::float32_t> outerfunnelwidth;
        basetype::float32_t adjacentlanemultifactorinner;
        basetype::float32_t adjacentlanemultifactorouter;
        basetype::float32_t rightinnerlowconfscaling;
        basetype::float32_t rightouterlowconfscaling;
        basetype::float32_t minrangehighquality;
        std::vector<basetype::float32_t> funnelrearbreakpoints;
        std::vector<basetype::float32_t> innerrearfunnelwidth;
        std::vector<basetype::float32_t> outerrearfunnelwidth;
        explicit Param_Funnel() :
            funneloffsetspeed(Param_Funnel_funneloffsetspeed_Default),
            funneloffsetnormal(Param_Funnel_funneloffsetnormal_Default),
            funneloffsetovertaking(Param_Funnel_funneloffsetovertaking_Default),
            funneloffsetopposite(Param_Funnel_funneloffsetopposite_Default),
            innerfunneloffsetovertaking(Param_Funnel_innerfunneloffsetovertaking_Default),
            innerfunneloffsetopposite(Param_Funnel_innerfunneloffsetopposite_Default),
            funnelgrowthrate(Param_Funnel_unnelgrowthrate_Default),
            funnelshrinkrate(Param_Funnel_funnelshrinkrate_Default),
            innerfunnelgrowthrate(Param_Funnel_innerfunnelgrowthrate_Default),
            innerfunnelshrinkrate(Param_Funnel_innerfunnelshrinkrate_Default),
            funnelbreakpoints(Param_Funnel_funnelbreakpoints_Default),
            maxrangehighquality(Param_Funnel_maxrangehighquality_Default),
            innerfunnelwidth(Param_Funnel_innerfunnelwidth_Default),
            outerfunnelwidth(Param_Funnel_outerfunnelwidth_Default),
            adjacentlanemultifactorinner(Param_Funnel_adjacentlanemultifactorinner_Default),
            adjacentlanemultifactorouter(Param_Funnel_adjacentlanemultifactorouter_Default),
            rightinnerlowconfscaling(Param_Funnel_rightinnerlowconfscaling_Default),
            rightouterlowconfscaling(Param_Funnel_rightouterlowconfscaling_Default),
            minrangehighquality(Param_Funnel_minrangehighquality_Default),
            funnelrearbreakpoints(Param_Funnel_funnelrearbreakpoints_Default),
            innerrearfunnelwidth(Param_Funnel_innerrearfunnelwidth_Default),
            outerrearfunnelwidth(Param_Funnel_outerrearfunnelwidth_Default) {
        }
        Param_Funnel(const Param_Funnel &r) :
                funneloffsetspeed(r.funneloffsetspeed),
                funneloffsetnormal(r.funneloffsetnormal),
                funneloffsetovertaking(r.funneloffsetovertaking),
                funneloffsetopposite(r.funneloffsetopposite),
                innerfunneloffsetovertaking(r.innerfunneloffsetovertaking),
                innerfunneloffsetopposite(r.innerfunneloffsetopposite),
                funnelgrowthrate(r.funnelgrowthrate),
                funnelshrinkrate(r.funnelshrinkrate),
                innerfunnelgrowthrate(r.innerfunnelgrowthrate),
                innerfunnelshrinkrate(r.innerfunnelshrinkrate),
                funnelbreakpoints(r.funnelbreakpoints),
                maxrangehighquality(r.maxrangehighquality),
                innerfunnelwidth(r.innerfunnelwidth),
                outerfunnelwidth(r.outerfunnelwidth),
                adjacentlanemultifactorinner(r.adjacentlanemultifactorinner),
                adjacentlanemultifactorouter(r.adjacentlanemultifactorouter),
                rightinnerlowconfscaling(r.rightinnerlowconfscaling),
                rightouterlowconfscaling(r.rightouterlowconfscaling),
                minrangehighquality(r.minrangehighquality),
                funnelrearbreakpoints(r.funnelrearbreakpoints),
                innerrearfunnelwidth(r.innerrearfunnelwidth),
                outerrearfunnelwidth(r.outerrearfunnelwidth) {
        }
        /**
        explicit Param_Funnel(const std::shared_ptr<Param_Funnel> &r) :
                funneloffsetspeed(r->funneloffsetspeed),
                funneloffsetnormal(r->funneloffsetnormal),
                funneloffsetovertaking(r->funneloffsetovertaking),
                funneloffsetopposite(r->funneloffsetopposite),
                innerfunneloffsetovertaking(r->innerfunneloffsetovertaking),
                innerfunneloffsetopposite(r->innerfunneloffsetopposite),
                funnelgrowthrate(r->funnelgrowthrate),
                funnelshrinkrate(r->funnelshrinkrate),
                innerfunnelgrowthrate(r->innerfunnelgrowthrate),
                innerfunnelshrinkrate(r->innerfunnelshrinkrate),
                funnelbreakpoints(r->funnelbreakpoints),
                maxrangehighquality(r->maxrangehighquality),
                innerfunnelwidth(r->innerfunnelwidth),
                outerfunnelwidth(r->outerfunnelwidth),
                adjacentlanemultifactorinner(r->adjacentlanemultifactorinner),
                adjacentlanemultifactorouter(r->adjacentlanemultifactorouter),
                rightinnerlowconfscaling(r->rightinnerlowconfscaling),
                rightouterlowconfscaling(r->rightouterlowconfscaling),
                minrangehighquality(r->minrangehighquality),
                funnelrearbreakpoints(r->funnelrearbreakpoints),
                innerrearfunnelwidth(r->innerrearfunnelwidth),
                outerrearfunnelwidth(r->outerrearfunnelwidth) {
        }*/
        explicit Param_Funnel(const std::vector<basetype::float32_t> &funneloffsetspeed_,
                              const std::vector<basetype::float32_t> &funneloffsetnormal_,
                              const std::vector<basetype::float32_t> &funneloffsetovertaking_,
                              const std::vector<basetype::float32_t> &funneloffsetopposite_,
                              const std::vector<basetype::float32_t> &innerfunneloffsetovertaking_,
                              const std::vector<basetype::float32_t> &innerfunneloffsetopposite_,
                              const basetype::float32_t &funnelgrowthrate_,
                              const basetype::float32_t &funnelshrinkrate_,
                              const basetype::float32_t &innerfunnelgrowthrate_,
                              const basetype::float32_t &innerfunnelshrinkrate_,
                              const std::vector<basetype::float32_t> &funnelbreakpoints_,
                              const basetype::float32_t &maxrangehighquality_,
                              const std::vector<basetype::float32_t> &innerfunnelwidth_,
                              const std::vector<basetype::float32_t> &outerfunnelwidth_,
                              const basetype::float32_t &adjacentlanemultifactorinner_,
                              const basetype::float32_t &adjacentlanemultifactorouter_,
                              const basetype::float32_t &rightinnerlowconfscaling_,
                              const basetype::float32_t &rightouterlowconfscaling_,
                              const basetype::float32_t &minrangehighquality_,
                              const std::vector<basetype::float32_t> &funnelrearbreakpoints_,
                              const std::vector<basetype::float32_t> &innerrearfunnelwidth_,
                              const std::vector<basetype::float32_t> &outerrearfunnelwidth_) :
                funneloffsetspeed(funneloffsetspeed_),
                funneloffsetnormal(funneloffsetnormal_),
                funneloffsetovertaking(funneloffsetovertaking_),
                funneloffsetopposite(funneloffsetopposite_),
                innerfunneloffsetovertaking(innerfunneloffsetovertaking_),
                innerfunneloffsetopposite(innerfunneloffsetopposite_),
                funnelgrowthrate(funnelgrowthrate_),
                funnelshrinkrate(funnelshrinkrate_),
                innerfunnelgrowthrate(innerfunnelgrowthrate_),
                innerfunnelshrinkrate(innerfunnelshrinkrate_),
                funnelbreakpoints(funnelbreakpoints_),
                maxrangehighquality(maxrangehighquality_),
                innerfunnelwidth(innerfunnelwidth_),
                outerfunnelwidth(outerfunnelwidth_),
                adjacentlanemultifactorinner(adjacentlanemultifactorinner_),
                adjacentlanemultifactorouter(adjacentlanemultifactorouter_),
                rightinnerlowconfscaling(rightinnerlowconfscaling_),
                rightouterlowconfscaling(rightouterlowconfscaling_),
                minrangehighquality(minrangehighquality_),
                funnelrearbreakpoints(funnelrearbreakpoints_),
                innerrearfunnelwidth(innerrearfunnelwidth_),
                outerrearfunnelwidth(outerrearfunnelwidth_) {

        }
        Param_Funnel& operator=(const Param_Funnel& rhs) {
            funneloffsetspeed = rhs.funneloffsetspeed;
            funneloffsetnormal = rhs.funneloffsetnormal;
            funneloffsetovertaking = rhs.funneloffsetovertaking;
            funneloffsetopposite = rhs.funneloffsetopposite;
            innerfunneloffsetovertaking = rhs.innerfunneloffsetovertaking;
            innerfunneloffsetopposite = rhs.innerfunneloffsetopposite;
            funnelgrowthrate = rhs.funnelgrowthrate;
            funnelshrinkrate = rhs.funnelshrinkrate;
            innerfunnelgrowthrate = rhs.innerfunnelgrowthrate;
            innerfunnelshrinkrate = rhs.innerfunnelshrinkrate;
            funnelbreakpoints = rhs.funnelbreakpoints;
            maxrangehighquality = rhs.maxrangehighquality;
            innerfunnelwidth = rhs.innerfunnelwidth;
            outerfunnelwidth = rhs.outerfunnelwidth;
            adjacentlanemultifactorinner = rhs.adjacentlanemultifactorinner;
            adjacentlanemultifactorouter = rhs.adjacentlanemultifactorouter;
            rightinnerlowconfscaling = rhs.rightinnerlowconfscaling;
            rightouterlowconfscaling = rhs.rightouterlowconfscaling;
            minrangehighquality = rhs.minrangehighquality;
            funnelrearbreakpoints = rhs.funnelrearbreakpoints;
            innerrearfunnelwidth = rhs.innerrearfunnelwidth;
            outerrearfunnelwidth = rhs.outerrearfunnelwidth;
            return *this;
        }
    };
    
    const basetype::float32_t Param_Road_maxdistancefromlanecenter_Default{0.6f};
    const basetype::boolean_t Param_Road_useadjustfunnelwithposinlane_Default{boolean_t_true};
    const basetype::boolean_t Param_Road_uselanewidthforfunnel_Default{boolean_t_true};
    const basetype::float32_t Param_Road_mindistanceforusinglanewidth_Default{12.0f};
    const basetype::float32_t Param_Road_defaultlanewidth_Default{3.6f};
    const basetype::float32_t Param_Road_minspeedforusingdistancefromlanecenter_Default{6.0f};
    struct Param_Road {
        basetype::float32_t maxdistancefromlanecenter;
        basetype::boolean_t useadjustfunnelwithposinlane;
        basetype::boolean_t uselanewidthforfunnel;
        basetype::float32_t mindistanceforusinglanewidth;
        basetype::float32_t defaultlanewidth;
        basetype::float32_t minspeedforusingdistancefromlanecenter;
        Param_Road() :
            maxdistancefromlanecenter(Param_Road_maxdistancefromlanecenter_Default),
            useadjustfunnelwithposinlane(Param_Road_useadjustfunnelwithposinlane_Default),
            uselanewidthforfunnel(Param_Road_uselanewidthforfunnel_Default),
            mindistanceforusinglanewidth(Param_Road_mindistanceforusinglanewidth_Default),
            defaultlanewidth(Param_Road_defaultlanewidth_Default),
            minspeedforusingdistancefromlanecenter(Param_Road_minspeedforusingdistancefromlanecenter_Default) {
        }
        Param_Road(const Param_Road &r) :
                maxdistancefromlanecenter(r.maxdistancefromlanecenter),
                useadjustfunnelwithposinlane(r.useadjustfunnelwithposinlane),
                uselanewidthforfunnel(r.uselanewidthforfunnel),
                mindistanceforusinglanewidth(r.mindistanceforusinglanewidth),
                defaultlanewidth(r.defaultlanewidth),
                minspeedforusingdistancefromlanecenter(r.minspeedforusingdistancefromlanecenter) {
        }
        /**
        explicit Param_Road(const std::shared_ptr<Param_Road> &r) :
                maxdistancefromlanecenter(r->maxdistancefromlanecenter),
                useadjustfunnelwithposinlane(r->useadjustfunnelwithposinlane),
                uselanewidthforfunnel(r->uselanewidthforfunnel),
                mindistanceforusinglanewidth(r->mindistanceforusinglanewidth),
                defaultlanewidth(r->defaultlanewidth),
                minspeedforusingdistancefromlanecenter(r->minspeedforusingdistancefromlanecenter) {
        }**/
        Param_Road(const basetype::float32_t &maxdistancefromlanecenter_,
                   const basetype::boolean_t &useadjustfunnelwithposinlane_,
                   const basetype::boolean_t &uselanewidthforfunnel_,
                   const basetype::float32_t &mindistanceforusinglanewidth_,
                   const basetype::float32_t &defaultlanewidth_,
                   const basetype::float32_t &minspeedforusingdistancefromlanecenter_):
                maxdistancefromlanecenter(maxdistancefromlanecenter_),
                useadjustfunnelwithposinlane(useadjustfunnelwithposinlane_),
                uselanewidthforfunnel(uselanewidthforfunnel_),
                mindistanceforusinglanewidth(mindistanceforusinglanewidth_),
                defaultlanewidth(defaultlanewidth_),
                minspeedforusingdistancefromlanecenter(minspeedforusingdistancefromlanecenter_) {
        }
        Param_Road& operator=(const Param_Road& rhs) {
            maxdistancefromlanecenter = rhs.maxdistancefromlanecenter;
            useadjustfunnelwithposinlane = rhs.useadjustfunnelwithposinlane;
            uselanewidthforfunnel = rhs.uselanewidthforfunnel;
            mindistanceforusinglanewidth = rhs.mindistanceforusinglanewidth;
            defaultlanewidth = rhs.defaultlanewidth;
            minspeedforusingdistancefromlanecenter = rhs.minspeedforusingdistancefromlanecenter;
            return *this;
        }
    };

    const basetype::boolean_t Param_OffsetCalculator_enableuseoffsetfromlanecenter_Default{boolean_t_true};
    const basetype::float32_t Param_OffsetCalculator_mintimegapforusingdistancefromlanecenter_Default{1.1f};
    const basetype::uint8_t Param_OffsetCalculator_objectminmaturity_Default{10u};
    const basetype::float32_t Param_OffsetCalculator_maxheadingangleforyawplus_Default{0.7854f};
    const basetype::float32_t Param_OffsetCalculator_minheadingangleforyawplus_Default{-0.7854f};
    const std::vector<basetype::float32_t> Param_OffsetCalculator_headinganglefactor_Default{1.0f,1.0f,1.0f,1.0f,1.0f,0.0f,0.0f,0.0f};
    const std::vector<basetype::float32_t> Param_OffsetCalculator_headinganglefactorbreakpoints_Default{0.0f,15.0f,16.0f,80.0f,90.0f,110.0f,120.0f,150.0f};
    const std::vector<basetype::float32_t> Param_OffsetCalculator_cutofffreqyawplus_Default{6.7f,6.7f,6.7f,3.3f,1.5f,1.0f,0.5f,0.2f};
    const std::vector<basetype::float32_t> Param_OffsetCalculator_cutofffreqyawplusbreakpoints_Default{0.0f,30.0f,40.0f,75.0f,100.0f,120.0f,150.0f,250.0f};
    const basetype::float32_t Param_OffsetCalculator_maxoffsetderiv_Default{1.0f};
    const basetype::float32_t Param_OffsetCalculator_minoffsetderiv_Default{-1.0f};
    const basetype::float32_t Param_OffsetCalculator_filtercontantoffsetderiv_Default{0.03f};
    const basetype::boolean_t Param_OffsetCalculator_useobjectwidth_Default{boolean_t_true};
    const std::vector<basetype::float32_t> Param_OffsetCalculator_objectwidth_Default{0.0f,0.0f,1.0f,1.0f,0.0f,0.0f};
    const std::vector<basetype::float32_t> Param_OffsetCalculator_objectwidthbreakpoints_Default{0.0f,15.0f,16.0f,125.0f,130.0f,250.0f};
    const std::vector<basetype::float32_t> Param_OffsetCalculator_objectwidthfactor_Default{0.1f,0.2f,0.2f,0.3f,0.3f,0.3f};
    const std::vector<basetype::float32_t> Param_OffsetCalculator_assumedmaxhostyaw_Default{25.0f,25.0f,14.0f,10.0f,5.0f,1.5f,1.0f};
    const std::vector<basetype::float32_t> Param_OffsetCalculator_assumedmaxhostyawbreakpoints_Default{0.0f,7.0f,11.0f,14.0f,28.0f,42.0f,56.0f};
    const std::vector<basetype::float32_t> Param_OffsetCalculator_timefactor_Default{1.0f,1.0f,0.0f,0.0f};
    const std::vector<basetype::float32_t> Param_OffsetCalculator_timefactorbreakpoints_Default{0.0f,1.0f,1.1f,100.0f};
    const std::vector<basetype::float32_t> Param_OffsetCalculator_speedfactor_Default{0.0f,1.0f,1.0f,1.0f};
    const std::vector<basetype::float32_t> Param_OffsetCalculator_speedfactorbreakpoints_Default{0.0f,9.0f,10.0f,100.0f};
    const std::vector<basetype::float32_t> Param_OffsetCalculator_mintimegap_Default{0.0f,0.5f,1.0f,1.0f};
    const std::vector<basetype::float32_t> Param_OffsetCalculator_mintimegapbreakpoints_Default{0.0f,1.4f,1.6f,20.0f};
    const std::vector<basetype::float32_t> Param_OffsetCalculator_mintatrdis_Default{0.0f,0.0f,1.0f,1.0f,0.0f,0.0f};
    const std::vector<basetype::float32_t> Param_OffsetCalculator_mintatrdisbreakpoints_Default{0.0f,29.0f,31.0f,145.0f,150.0f,250.0f};
    const std::vector<basetype::float32_t> Param_OffsetCalculator_mintatrspd_Default{0.0f,1.0f,1.0f,1.0f};
    const std::vector<basetype::float32_t> Param_OffsetCalculator_mintatrspdbreakpoints_Default{0.0f,12.0f,13.0f,50.0f};
    const std::vector<basetype::float32_t> Param_OffsetCalculator_mintatranglestd_Default{1.0f,1.0f,0.0f,0.0f};
    const std::vector<basetype::float32_t> Param_OffsetCalculator_mintatranglestdbreakpoints_Default{0.0f,0.18f,0.2f,10.0f};
    struct Param_OffsetCalculator {
        basetype::boolean_t enableuseoffsetfromlanecenter;
        basetype::float32_t mintimegapforusingdistancefromlanecenter;
        basetype::uint8_t objectminmaturity;
        basetype::float32_t maxheadingangleforyawplus;
        basetype::float32_t minheadingangleforyawplus;
        std::vector<basetype::float32_t> headinganglefactor;
        std::vector<basetype::float32_t> headinganglefactorbreakpoints;
        std::vector<basetype::float32_t> cutofffreqyawplus;
        std::vector<basetype::float32_t> cutofffreqyawplusbreakpoints;
        basetype::float32_t maxoffsetderiv;
        basetype::float32_t minoffsetderiv;
        basetype::float32_t filtercontantoffsetderiv;
        basetype::boolean_t useobjectwidth;
        std::vector<basetype::float32_t> objectwidth;
        std::vector<basetype::float32_t> objectwidthbreakpoints;
        std::vector<basetype::float32_t> objectwidthfactor;
        std::vector<basetype::float32_t> assumedmaxhostyaw;
        std::vector<basetype::float32_t> assumedmaxhostyawbreakpoints;
        std::vector<basetype::float32_t> timefactor;
        std::vector<basetype::float32_t> timefactorbreakpoints;
        std::vector<basetype::float32_t> speedfactor;
        std::vector<basetype::float32_t> speedfactorbreakpoints;
        std::vector<basetype::float32_t> mintimegap;
        std::vector<basetype::float32_t> mintimegapbreakpoints;
        std::vector<basetype::float32_t> mintatrdis;
        std::vector<basetype::float32_t> mintatrdisbreakpoints;
        std::vector<basetype::float32_t> mintatrspd;
        std::vector<basetype::float32_t> mintatrspdbreakpoints;
        std::vector<basetype::float32_t> mintatranglestd;
        std::vector<basetype::float32_t> mintatranglestdbreakpoints;
        explicit Param_OffsetCalculator() :
            enableuseoffsetfromlanecenter(Param_OffsetCalculator_enableuseoffsetfromlanecenter_Default),
            mintimegapforusingdistancefromlanecenter(Param_OffsetCalculator_mintimegapforusingdistancefromlanecenter_Default),
            objectminmaturity(Param_OffsetCalculator_objectminmaturity_Default),
            maxheadingangleforyawplus(Param_OffsetCalculator_maxheadingangleforyawplus_Default),
            minheadingangleforyawplus(Param_OffsetCalculator_minheadingangleforyawplus_Default),
            headinganglefactor(Param_OffsetCalculator_headinganglefactor_Default),
            headinganglefactorbreakpoints(Param_OffsetCalculator_headinganglefactorbreakpoints_Default),
            cutofffreqyawplus(Param_OffsetCalculator_cutofffreqyawplus_Default),
            cutofffreqyawplusbreakpoints(Param_OffsetCalculator_cutofffreqyawplusbreakpoints_Default),
            maxoffsetderiv(Param_OffsetCalculator_maxoffsetderiv_Default),
            minoffsetderiv(Param_OffsetCalculator_minoffsetderiv_Default),
            filtercontantoffsetderiv(Param_OffsetCalculator_filtercontantoffsetderiv_Default),
            useobjectwidth(Param_OffsetCalculator_useobjectwidth_Default),
            objectwidth(Param_OffsetCalculator_objectwidth_Default),
            objectwidthbreakpoints(Param_OffsetCalculator_objectwidthbreakpoints_Default),
            objectwidthfactor(Param_OffsetCalculator_objectwidthfactor_Default),
            assumedmaxhostyaw(Param_OffsetCalculator_assumedmaxhostyaw_Default),
            assumedmaxhostyawbreakpoints(Param_OffsetCalculator_assumedmaxhostyawbreakpoints_Default),
            timefactor(Param_OffsetCalculator_timefactor_Default),
            timefactorbreakpoints(Param_OffsetCalculator_timefactorbreakpoints_Default),
            speedfactor(Param_OffsetCalculator_speedfactor_Default),
            speedfactorbreakpoints(Param_OffsetCalculator_speedfactorbreakpoints_Default),
            mintimegap(Param_OffsetCalculator_mintimegap_Default),
            mintimegapbreakpoints(Param_OffsetCalculator_mintimegapbreakpoints_Default),
            mintatrdis(Param_OffsetCalculator_mintatrdis_Default),
            mintatrdisbreakpoints(Param_OffsetCalculator_mintatrdisbreakpoints_Default),
            mintatrspd(Param_OffsetCalculator_mintatrspd_Default),
            mintatrspdbreakpoints(Param_OffsetCalculator_mintatrspdbreakpoints_Default),
            mintatranglestd(Param_OffsetCalculator_mintatranglestd_Default),
            mintatranglestdbreakpoints(Param_OffsetCalculator_mintatranglestdbreakpoints_Default) {
        }
        Param_OffsetCalculator(const Param_OffsetCalculator &r) :
                enableuseoffsetfromlanecenter(r.enableuseoffsetfromlanecenter),
                mintimegapforusingdistancefromlanecenter(r.mintimegapforusingdistancefromlanecenter),
                objectminmaturity(r.objectminmaturity),
                maxheadingangleforyawplus(r.maxheadingangleforyawplus),
                minheadingangleforyawplus(r.minheadingangleforyawplus),
                headinganglefactor(r.headinganglefactor),
                headinganglefactorbreakpoints(r.headinganglefactorbreakpoints),
                cutofffreqyawplus(r.cutofffreqyawplus),
                cutofffreqyawplusbreakpoints(r.cutofffreqyawplusbreakpoints),
                maxoffsetderiv(r.maxoffsetderiv),
                minoffsetderiv(r.minoffsetderiv),
                filtercontantoffsetderiv(r.filtercontantoffsetderiv),
                useobjectwidth(r.useobjectwidth),
                objectwidth (r.objectwidth),
                objectwidthbreakpoints(r.objectwidthbreakpoints),
                objectwidthfactor(r.objectwidthfactor),
                assumedmaxhostyaw(r.assumedmaxhostyaw),
                assumedmaxhostyawbreakpoints(r.assumedmaxhostyawbreakpoints),
                timefactor(r.timefactor),
                timefactorbreakpoints(r.timefactorbreakpoints),
                speedfactor(r.speedfactor),
                speedfactorbreakpoints(r.speedfactorbreakpoints),
                mintimegap(r.mintimegap),
                mintimegapbreakpoints(r.mintimegapbreakpoints),
                mintatrdis(r.mintatrdis),
                mintatrdisbreakpoints(r.mintatrdisbreakpoints),
                mintatrspd(r.mintatrspd),
                mintatrspdbreakpoints(r.mintatrspdbreakpoints),
                mintatranglestd(r.mintatranglestd),
                mintatranglestdbreakpoints(r.mintatranglestdbreakpoints) {
        }
        /*
        Param_OffsetCalculator(const std::shared_ptr<Param_OffsetCalculator> &r) :
                enableuseoffsetfromlanecenter(r->enableuseoffsetfromlanecenter),
                mintimegapforusingdistancefromlanecenter(r->mintimegapforusingdistancefromlanecenter),
                objectminmaturity(r->objectminmaturity),
                maxheadingangleforyawplus(r->maxheadingangleforyawplus),
                minheadingangleforyawplus(r->minheadingangleforyawplus),
                headinganglefactor(r->headinganglefactor),
                headinganglefactorbreakpoints(r->headinganglefactorbreakpoints),
                cutofffreqyawplus(r->cutofffreqyawplus),
                cutofffreqyawplusbreakpoints(r->cutofffreqyawplusbreakpoints),
                maxoffsetderiv(r->maxoffsetderiv),
                minoffsetderiv(r->minoffsetderiv),
                filtercontantoffsetderiv(r->filtercontantoffsetderiv),
                useobjectwidth(r->useobjectwidth),
                objectwidth (r->objectwidth),
                objectwidthbreakpoints(r->objectwidthbreakpoints),
                objectwidthfactor(r->objectwidthfactor),
                assumedmaxhostyaw(r->assumedmaxhostyaw),
                assumedmaxhostyawbreakpoints(r->assumedmaxhostyawbreakpoints),
                timefactor(r->timefactor),
                timefactorbreakpoints(r->timefactorbreakpoints),
                speedfactor(r->speedfactor),
                speedfactorbreakpoints(r->speedfactorbreakpoints),
                mintimegap(r->mintimegap),
                mintimegapbreakpoints(r->mintimegapbreakpoints),
                mintatrdis(r->mintatrdis),
                mintatrdisbreakpoints(r->mintatrdisbreakpoints),
                mintatrspd(r->mintatrspd),
                mintatrspdbreakpoints(r->mintatrspdbreakpoints),
                mintatranglestd(r->mintatranglestd),
                mintatranglestdbreakpoints(r->mintatranglestdbreakpoints) {
        }*/
        explicit Param_OffsetCalculator(const basetype::boolean_t &enableuseoffsetfromlanecenter_,
                                        const basetype::float32_t &mintimegapforusingdistancefromlanecenter_,
                                        const basetype::uint8_t &objectminmaturity_,
                                        const basetype::float32_t &maxheadingangleforyawplus_,
                                        const basetype::float32_t &minheadingangleforyawplus_,
                                        const std::vector<basetype::float32_t> &headinganglefactor_,
                                        const std::vector<basetype::float32_t> &headinganglefactorbreakpoints_,
                                        const std::vector<basetype::float32_t> &cutofffreqyawplus_,
                                        const std::vector<basetype::float32_t> &cutofffreqyawplusbreakpoints_,
                                        const basetype::float32_t &maxoffsetderiv_,
                                        const basetype::float32_t &minoffsetderiv_,
                                        const basetype::float32_t &filtercontantoffsetderiv_,
                                        const basetype::boolean_t &useobjectwidth_,
                                        const std::vector<basetype::float32_t> &objectwidth_,
                                        const std::vector<basetype::float32_t> &objectwidthbreakpoints_,
                                        const std::vector<basetype::float32_t> &objectwidthfactor_,
                                        const std::vector<basetype::float32_t> &assumedmaxhostyaw_,
                                        const std::vector<basetype::float32_t> &assumedmaxhostyawbreakpoints_,
                                        const std::vector<basetype::float32_t> &timefactor_,
                                        const std::vector<basetype::float32_t> &timefactorbreakpoints_,
                                        const std::vector<basetype::float32_t> &speedfactor_,
                                        const std::vector<basetype::float32_t> &speedfactorbreakpoints_,
                                        const std::vector<basetype::float32_t> &mintimegap_,
                                        const std::vector<basetype::float32_t> &mintimegapbreakpoints_,
                                        const std::vector<basetype::float32_t> &mintatrdis_,
                                        const std::vector<basetype::float32_t> &mintatrdisbreakpoints_,
                                        const std::vector<basetype::float32_t> &mintatrspd_,
                                        const std::vector<basetype::float32_t> &mintatrspdbreakpoints_,
                                        const std::vector<basetype::float32_t> &mintatranglestd_,
                                        const std::vector<basetype::float32_t> &mintatranglestdbreakpoints_):
                enableuseoffsetfromlanecenter(enableuseoffsetfromlanecenter_),
                mintimegapforusingdistancefromlanecenter(mintimegapforusingdistancefromlanecenter_),
                objectminmaturity(objectminmaturity_),
                maxheadingangleforyawplus(maxheadingangleforyawplus_),
                minheadingangleforyawplus(minheadingangleforyawplus_),
                headinganglefactor(headinganglefactor_),
                headinganglefactorbreakpoints(headinganglefactorbreakpoints_),
                cutofffreqyawplus(cutofffreqyawplus_),
                cutofffreqyawplusbreakpoints(cutofffreqyawplusbreakpoints_),
                maxoffsetderiv(maxoffsetderiv_),
                minoffsetderiv(minoffsetderiv_),
                filtercontantoffsetderiv(filtercontantoffsetderiv_),
                useobjectwidth(useobjectwidth_),
                objectwidth (objectwidth_),
                objectwidthbreakpoints(objectwidthbreakpoints_),
                objectwidthfactor(objectwidthfactor_),
                assumedmaxhostyaw(assumedmaxhostyaw_),
                assumedmaxhostyawbreakpoints(assumedmaxhostyawbreakpoints_),
                timefactor(timefactor_),
                timefactorbreakpoints(timefactorbreakpoints_),
                speedfactor(speedfactor_),
                speedfactorbreakpoints(speedfactorbreakpoints_),
                mintimegap(mintimegap_),
                mintimegapbreakpoints(mintimegapbreakpoints_),
                mintatrdis(mintatrdis_),
                mintatrdisbreakpoints(mintatrdisbreakpoints_),
                mintatrspd(mintatrspd_),
                mintatrspdbreakpoints(mintatrspdbreakpoints_),
                mintatranglestd(mintatranglestd_),
                mintatranglestdbreakpoints(mintatranglestdbreakpoints_) {
        }
        Param_OffsetCalculator& operator=(const Param_OffsetCalculator& rhs) {
            enableuseoffsetfromlanecenter = rhs.enableuseoffsetfromlanecenter;
            mintimegapforusingdistancefromlanecenter = rhs.mintimegapforusingdistancefromlanecenter;
            objectminmaturity = rhs.objectminmaturity;
            maxheadingangleforyawplus = rhs.maxheadingangleforyawplus;
            minheadingangleforyawplus = rhs.minheadingangleforyawplus;
            headinganglefactor = rhs.headinganglefactor;
            headinganglefactorbreakpoints = rhs.headinganglefactorbreakpoints;
            cutofffreqyawplus = rhs.cutofffreqyawplus;
            cutofffreqyawplusbreakpoints = rhs.cutofffreqyawplusbreakpoints;
            maxoffsetderiv = rhs.maxoffsetderiv;
            minoffsetderiv = rhs.minoffsetderiv;
            filtercontantoffsetderiv = rhs.filtercontantoffsetderiv;
            useobjectwidth = rhs.useobjectwidth;
            objectwidth  = rhs.objectwidth;
            objectwidthbreakpoints = rhs.objectwidthbreakpoints;
            objectwidthfactor = rhs.objectwidthfactor;
            assumedmaxhostyaw = rhs.assumedmaxhostyaw;
            assumedmaxhostyawbreakpoints = rhs.assumedmaxhostyawbreakpoints;
            timefactor = rhs.timefactor;
            timefactorbreakpoints = rhs.timefactorbreakpoints;
            speedfactor = rhs.speedfactor;
            speedfactorbreakpoints = rhs.speedfactorbreakpoints;
            mintimegap = rhs.mintimegap;
            mintimegapbreakpoints = rhs.mintimegapbreakpoints;
            mintatrdis = rhs.mintatrdis;
            mintatrdisbreakpoints = rhs.mintatrdisbreakpoints;
            mintatrspd = rhs.mintatrspd;
            mintatrspdbreakpoints = rhs.mintatrspdbreakpoints;
            mintatranglestd = rhs.mintatranglestd;
            mintatranglestdbreakpoints = rhs.mintatranglestdbreakpoints;
            return *this;
        }
    };
    
    const basetype::float32_t Param_Selector_mindistanceforprediction_Default{5.0f};
    const basetype::float32_t Param_Selector_minspeedforprediction_Default{2.5f};
    const basetype::uint8_t Param_Selector_maxinpathcounter_Default{4u};
    const basetype::float32_t Param_Selector_funnelhysteresis_Default{0.2f};
    const basetype::float32_t Param_Selector_maxholdforyawplus_Default{2.0f};
    const basetype::float32_t Param_Selector_holdyawpluslanechange_Default{8.0f};
    const basetype::float32_t Param_Selector_maxoverlapforcameraonlycar_Default{4.5f};
    const basetype::float32_t Param_Selector_maxrelativeoverlapforcameraonlycar_Default{0.14f};
    const basetype::float32_t Param_Selector_cutinpredictiontime_Default{1.0f};
    const basetype::float32_t Param_Selector_cutinmaxdistance_Default{100.0f};
    const basetype::float32_t Param_Selector_cutinivdistanceoffset_Default{6.0f};
    const std::vector<basetype::float32_t> Param_Selector_cutouttimegapfactor_Default{1.0f,1.0f,0.0f,0.0f};
    const std::vector<basetype::float32_t> Param_Selector_cutouttimegapfactorbreakpoints_Default{0.0f,1.8f,2.1f,20.0f};
    const basetype::float32_t Param_Selector_cutouttimethreshold_Default{1.0f};
    const basetype::float32_t Param_Selector_mintargetdistance_Default{3.7f};
    const basetype::float32_t Param_Selector_mintargetlatdistance_Default{2.8f};
    const basetype::float32_t Param_Selector_minreartargetdistance_Default{-1.6f};

    struct Param_Selector {
        basetype::float32_t mindistanceforprediction;
        basetype::float32_t minspeedforprediction;
        basetype::uint8_t maxinpathcounter;
        basetype::float32_t funnelhysteresis;
        basetype::float32_t maxholdforyawplus;
        basetype::float32_t holdyawpluslanechange;
        basetype::float32_t maxoverlapforcameraonlycar;
        basetype::float32_t maxrelativeoverlapforcameraonlycar;
        basetype::float32_t cutinpredictiontime;
        basetype::float32_t cutinmaxdistance;
        basetype::float32_t cutinivdistanceoffset;
        std::vector<basetype::float32_t> cutouttimegapfactor;
        std::vector<basetype::float32_t> cutouttimegapfactorbreakpoints;
        basetype::float32_t cutouttimethreshold;
        basetype::float32_t mintargetdistance;
        basetype::float32_t mintargetlatdistance;
        basetype::float32_t minreartargetdistance;
        explicit Param_Selector() :
            mindistanceforprediction(Param_Selector_mindistanceforprediction_Default),
            minspeedforprediction(Param_Selector_minspeedforprediction_Default),
            maxinpathcounter(Param_Selector_maxinpathcounter_Default),
            funnelhysteresis(Param_Selector_funnelhysteresis_Default),
            maxholdforyawplus(Param_Selector_maxholdforyawplus_Default),
            holdyawpluslanechange(Param_Selector_holdyawpluslanechange_Default),
            maxoverlapforcameraonlycar(Param_Selector_maxoverlapforcameraonlycar_Default),
            maxrelativeoverlapforcameraonlycar(Param_Selector_maxrelativeoverlapforcameraonlycar_Default),
            cutinpredictiontime(Param_Selector_cutinpredictiontime_Default),
            cutinmaxdistance(Param_Selector_cutinmaxdistance_Default),
            cutinivdistanceoffset(Param_Selector_cutinivdistanceoffset_Default),
            cutouttimegapfactor(Param_Selector_cutouttimegapfactor_Default),
            cutouttimegapfactorbreakpoints(Param_Selector_cutouttimegapfactorbreakpoints_Default),
            cutouttimethreshold(Param_Selector_cutouttimethreshold_Default),
            mintargetdistance(Param_Selector_mintargetdistance_Default),
            mintargetlatdistance(Param_Selector_mintargetlatdistance_Default),
            minreartargetdistance(Param_Selector_minreartargetdistance_Default) {
        }
        Param_Selector(const Param_Selector &r) :
                mindistanceforprediction(r.mindistanceforprediction),
                minspeedforprediction(r.minspeedforprediction),
                maxinpathcounter(r.maxinpathcounter),
                funnelhysteresis(r.funnelhysteresis),
                maxholdforyawplus(r.maxholdforyawplus),
                holdyawpluslanechange(r.holdyawpluslanechange),
                maxoverlapforcameraonlycar(r.maxoverlapforcameraonlycar),
                maxrelativeoverlapforcameraonlycar(r.maxrelativeoverlapforcameraonlycar),
                cutinpredictiontime(r.cutinpredictiontime),
                cutinmaxdistance(r.cutinmaxdistance),
                cutinivdistanceoffset(r.cutinivdistanceoffset),
                cutouttimegapfactor(r.cutouttimegapfactor),
                cutouttimegapfactorbreakpoints(r.cutouttimegapfactorbreakpoints),
                cutouttimethreshold(r.cutouttimethreshold),
                mintargetdistance(r.mintargetdistance),
                mintargetlatdistance(r.mintargetlatdistance),
                minreartargetdistance(r.minreartargetdistance) {
        }
        /*
        Param_Selector(const std::shared_ptr<Param_Selector> &r) :
                mindistanceforprediction(r->mindistanceforprediction),
                minspeedforprediction(r->minspeedforprediction),
                maxinpathcounter(r->maxinpathcounter),
                funnelhysteresis(r->funnelhysteresis),
                maxholdforyawplus(r->maxholdforyawplus),
                holdyawpluslanechange(r->holdyawpluslanechange),
                maxoverlapforcameraonlycar(r->maxoverlapforcameraonlycar),
                maxrelativeoverlapforcameraonlycar(r->maxrelativeoverlapforcameraonlycar),
                cutinpredictiontime(r->cutinpredictiontime),
                cutinmaxdistance(r->cutinmaxdistance),
                cutinivdistanceoffset(r->cutinivdistanceoffset),
                cutouttimegapfactor(r->cutouttimegapfactor),
                cutouttimegapfactorbreakpoints(r->cutouttimegapfactorbreakpoints),
                cutouttimethreshold(r->cutouttimethreshold),
                mintargetdistance(r->mintargetdistance),
                mintargetlatdistance(r->mintargetlatdistance),
                minreartargetdistance(r->minreartargetdistance) {
        }*/
        explicit Param_Selector(const basetype::float32_t &mindistanceforprediction_,
                                const basetype::float32_t &minspeedforprediction_,
                                const basetype::uint8_t &maxinpathcounter_,
                                const basetype::float32_t &funnelhysteresis_,
                                const basetype::float32_t &maxholdforyawplus_,
                                const basetype::float32_t &holdyawpluslanechange_,
                                const basetype::float32_t &maxoverlapforcameraonlycar_,
                                const basetype::float32_t &maxrelativeoverlapforcameraonlycar_,
                                const basetype::float32_t &cutinpredictiontime_,
                                const basetype::float32_t &cutinmaxdistance_,
                                const basetype::float32_t &cutinivdistanceoffset_,
                                const std::vector<basetype::float32_t> &cutouttimegapfactor_,
                                const std::vector<basetype::float32_t> &cutouttimegapfactorbreakpoints_,
                                const basetype::float32_t &cutouttimethreshold_,
                                const basetype::float32_t &mintargetdistance_,
                                const basetype::float32_t &mintargetlatdistance_,
                                const basetype::float32_t &minreartargetdistance_) :
                mindistanceforprediction(mindistanceforprediction_),
                minspeedforprediction(minspeedforprediction_),
                maxinpathcounter(maxinpathcounter_),
                funnelhysteresis(funnelhysteresis_),
                maxholdforyawplus(maxholdforyawplus_),
                holdyawpluslanechange(holdyawpluslanechange_),
                maxoverlapforcameraonlycar(maxoverlapforcameraonlycar_),
                maxrelativeoverlapforcameraonlycar(maxrelativeoverlapforcameraonlycar_),
                cutinpredictiontime(cutinpredictiontime_),
                cutinmaxdistance(cutinmaxdistance_),
                cutinivdistanceoffset(cutinivdistanceoffset_),
                cutouttimegapfactor(cutouttimegapfactor_),
                cutouttimegapfactorbreakpoints(cutouttimegapfactorbreakpoints_),
                cutouttimethreshold(cutouttimethreshold_),
                mintargetdistance(mintargetdistance_),
                mintargetlatdistance(mintargetlatdistance_),
                minreartargetdistance(minreartargetdistance_) {
        }
        Param_Selector& operator=(const Param_Selector& rhs) {
            mindistanceforprediction = rhs.mindistanceforprediction;
            minspeedforprediction = rhs.minspeedforprediction;
            maxinpathcounter = rhs.maxinpathcounter;
            funnelhysteresis = rhs.funnelhysteresis;
            maxholdforyawplus = rhs.maxholdforyawplus;
            holdyawpluslanechange = rhs.holdyawpluslanechange;
            maxoverlapforcameraonlycar = rhs.maxoverlapforcameraonlycar;
            maxrelativeoverlapforcameraonlycar = rhs.maxrelativeoverlapforcameraonlycar;
            cutinpredictiontime = rhs.cutinpredictiontime;
            cutinmaxdistance = rhs.cutinmaxdistance;
            cutinivdistanceoffset = rhs.cutinivdistanceoffset;
            cutouttimegapfactor = rhs.cutouttimegapfactor;
            cutouttimegapfactorbreakpoints = rhs.cutouttimegapfactorbreakpoints;
            cutouttimethreshold = rhs.cutouttimethreshold;
            mintargetdistance = rhs.mintargetdistance;
            mintargetlatdistance = rhs.mintargetlatdistance;
            minreartargetdistance = rhs.minreartargetdistance;
            return *this;
        }
    };
    
    const basetype::float32_t Param_C0Calculator_radiuscog_Default{5000.0f};
    const std::vector<basetype::float32_t> Param_C0Calculator_c0blendfactor_Default{0.0f,1.0f};
    const std::vector<basetype::float32_t> Param_C0Calculator_c0blendfactorbreakpoints_Default{2.0f,3.0f};
    const std::vector<basetype::float32_t> Param_C0Calculator_c0kinematicsyawratemax_Default{0.001f,0.001f,0.001f,0.001f,0.001f,0.01f,1.0f};
    const std::vector<basetype::float32_t> Param_C0Calculator_c0c0kinematicsyawratemaxbreakpoints_Default{0.0f,0.2f,0.5f,0.8f,1.0,1.5f,2.0f};
    const basetype::float32_t Param_C0Calculator_steeringrateforbicyclemodel_Default{16.14f};
    const basetype::float32_t Param_C0Calculator_vehiclemassforbicyclemodel_Default{1488.0f};
    const basetype::float32_t Param_C0Calculator_cornrgstfnfrntforbicyclemodel_Default{95410.0f};
    const basetype::float32_t Param_C0Calculator_cornrgstfnreforbicyclemodel_Default{125000.0f};
    const basetype::float32_t Param_C0Calculator_whleelbaseforbicyclemodel_Default{2.58f};
    const basetype::float32_t Param_C0Calculator_frontdistanceforbicyclemodel_Default{1.0f};
    const basetype::float32_t Param_C0Calculator_upperlimitcurvaturerear_Default{0.5f};
    const basetype::float32_t Param_C0Calculator_lowerlimitcurvaturerear_Default{-0.5f};
    const basetype::float32_t Param_C0Calculator_c0biasfactorbasedynamics_Default{0.3f};
    const basetype::float32_t Param_C0Calculator_c0cutofffrequencybasedynamics_Default{0.8f};
    const basetype::float32_t Param_C0Calculator_maxcurvature_Default{0.5f};
    struct Param_C0Calculator {
        basetype::float32_t radiuscog;
        std::vector<basetype::float32_t> c0blendfactor;
        std::vector<basetype::float32_t> c0blendfactorbreakpoints;
        std::vector<basetype::float32_t> c0kinematicsyawratemax;
        std::vector<basetype::float32_t> c0c0kinematicsyawratemaxbreakpoints;
        basetype::float32_t steeringrateforbicyclemodel;
        basetype::float32_t vehiclemassforbicyclemodel;
        basetype::float32_t cornrgstfnfrntforbicyclemodel;
        basetype::float32_t cornrgstfnreforbicyclemodel;
        basetype::float32_t whleelbaseforbicyclemodel;
        basetype::float32_t frontdistanceforbicyclemodel;
        basetype::float32_t upperlimitcurvaturerear;
        basetype::float32_t lowerlimitcurvaturerear;
        basetype::float32_t c0biasfactorbasedynamics;
        basetype::float32_t c0cutofffrequencybasedynamics;
        basetype::float32_t maxcurvature;
        explicit Param_C0Calculator() :
            radiuscog(Param_C0Calculator_radiuscog_Default),
            c0blendfactor(Param_C0Calculator_c0blendfactor_Default),
            c0blendfactorbreakpoints(Param_C0Calculator_c0blendfactorbreakpoints_Default),
            c0kinematicsyawratemax(Param_C0Calculator_c0kinematicsyawratemax_Default),
            c0c0kinematicsyawratemaxbreakpoints(Param_C0Calculator_c0c0kinematicsyawratemaxbreakpoints_Default),
            steeringrateforbicyclemodel(Param_C0Calculator_steeringrateforbicyclemodel_Default),
            vehiclemassforbicyclemodel(Param_C0Calculator_vehiclemassforbicyclemodel_Default),
            cornrgstfnfrntforbicyclemodel(Param_C0Calculator_cornrgstfnfrntforbicyclemodel_Default),
            cornrgstfnreforbicyclemodel(Param_C0Calculator_cornrgstfnreforbicyclemodel_Default),
            whleelbaseforbicyclemodel(Param_C0Calculator_whleelbaseforbicyclemodel_Default),
            frontdistanceforbicyclemodel(Param_C0Calculator_frontdistanceforbicyclemodel_Default),
            upperlimitcurvaturerear(Param_C0Calculator_upperlimitcurvaturerear_Default),
            lowerlimitcurvaturerear(Param_C0Calculator_lowerlimitcurvaturerear_Default),
            c0biasfactorbasedynamics(Param_C0Calculator_c0biasfactorbasedynamics_Default),
            c0cutofffrequencybasedynamics(Param_C0Calculator_c0cutofffrequencybasedynamics_Default),
            maxcurvature(Param_C0Calculator_maxcurvature_Default) {
        }
        Param_C0Calculator(const Param_C0Calculator &r) :
                radiuscog(r.radiuscog),
                c0blendfactor(r.c0blendfactor),
                c0blendfactorbreakpoints(r.c0blendfactorbreakpoints),
                c0kinematicsyawratemax(r.c0kinematicsyawratemax),
                c0c0kinematicsyawratemaxbreakpoints(r.c0c0kinematicsyawratemaxbreakpoints),
                steeringrateforbicyclemodel(r.steeringrateforbicyclemodel),
                vehiclemassforbicyclemodel(r.vehiclemassforbicyclemodel),
                cornrgstfnfrntforbicyclemodel(r.cornrgstfnfrntforbicyclemodel),
                cornrgstfnreforbicyclemodel(r.cornrgstfnreforbicyclemodel),
                whleelbaseforbicyclemodel(r.whleelbaseforbicyclemodel),
                frontdistanceforbicyclemodel(r.frontdistanceforbicyclemodel),
                upperlimitcurvaturerear(r.upperlimitcurvaturerear),
                lowerlimitcurvaturerear(r.lowerlimitcurvaturerear),
                c0biasfactorbasedynamics(r.c0biasfactorbasedynamics),
                c0cutofffrequencybasedynamics(r.c0cutofffrequencybasedynamics),
                maxcurvature(r.maxcurvature) {
        }
        /*
        Param_C0Calculator(const std::shared_ptr<Param_C0Calculator> &r) :
                radiuscog(r->radiuscog),
                c0blendfactor(r->c0blendfactor),
                c0blendfactorbreakpoints(r->c0blendfactorbreakpoints),
                c0kinematicsyawratemax(r->c0kinematicsyawratemax),
                c0c0kinematicsyawratemaxbreakpoints(r->c0c0kinematicsyawratemaxbreakpoints),
                steeringrateforbicyclemodel(r->steeringrateforbicyclemodel),
                vehiclemassforbicyclemodel(r->vehiclemassforbicyclemodel),
                cornrgstfnfrntforbicyclemodel(r->cornrgstfnfrntforbicyclemodel),
                cornrgstfnreforbicyclemodel(r->cornrgstfnreforbicyclemodel),
                whleelbaseforbicyclemodel(r->whleelbaseforbicyclemodel),
                frontdistanceforbicyclemodel(r->frontdistanceforbicyclemodel),
                upperlimitcurvaturerear(r->upperlimitcurvaturerear),
                lowerlimitcurvaturerear(r->lowerlimitcurvaturerear),
                c0biasfactorbasedynamics(r->c0biasfactorbasedynamics),
                c0cutofffrequencybasedynamics(r->c0cutofffrequencybasedynamics),
                maxcurvature(r->maxcurvature) {
        }*/
        explicit Param_C0Calculator(const basetype::float32_t &radiuscog_,
                                    const std::vector<basetype::float32_t> &c0blendfactor_,
                                    const std::vector<basetype::float32_t> &c0blendfactorbreakpoints_,
                                    const std::vector<basetype::float32_t> &c0kinematicsyawratemax_,
                                    const std::vector<basetype::float32_t> &c0c0kinematicsyawratemaxbreakpoints_,
                                    const basetype::float32_t &steeringrateforbicyclemodel_,
                                    const basetype::float32_t &vehiclemassforbicyclemodel_,
                                    const basetype::float32_t &cornrgstfnfrntforbicyclemodel_,
                                    const basetype::float32_t &cornrgstfnreforbicyclemodel_,
                                    const basetype::float32_t &whleelbaseforbicyclemodel_,
                                    const basetype::float32_t &frontdistanceforbicyclemodel_,
                                    const basetype::float32_t &upperlimitcurvaturerear_,
                                    const basetype::float32_t &lowerlimitcurvaturerear_,
                                    const basetype::float32_t &c0biasfactorbasedynamics_,
                                    const basetype::float32_t &c0cutofffrequencybasedynamics_,
                                    const basetype::float32_t &maxcurvature_) :
                radiuscog(radiuscog_),
                c0blendfactor(c0blendfactor_),
                c0blendfactorbreakpoints(c0blendfactorbreakpoints_),
                c0kinematicsyawratemax(c0kinematicsyawratemax_),
                c0c0kinematicsyawratemaxbreakpoints(c0c0kinematicsyawratemaxbreakpoints_),
                steeringrateforbicyclemodel(steeringrateforbicyclemodel_),
                vehiclemassforbicyclemodel(vehiclemassforbicyclemodel_),
                cornrgstfnfrntforbicyclemodel(cornrgstfnfrntforbicyclemodel_),
                cornrgstfnreforbicyclemodel(cornrgstfnreforbicyclemodel_),
                whleelbaseforbicyclemodel(whleelbaseforbicyclemodel_),
                frontdistanceforbicyclemodel(frontdistanceforbicyclemodel_),
                upperlimitcurvaturerear(upperlimitcurvaturerear_),
                lowerlimitcurvaturerear(lowerlimitcurvaturerear_),
                c0biasfactorbasedynamics(c0biasfactorbasedynamics_),
                c0cutofffrequencybasedynamics(c0cutofffrequencybasedynamics_),
                maxcurvature(maxcurvature_) {
        }
        Param_C0Calculator& operator=(const Param_C0Calculator& rhs) {
            radiuscog = rhs.radiuscog;
            c0blendfactor = rhs.c0blendfactor;
            c0blendfactorbreakpoints = rhs.c0blendfactorbreakpoints;
            c0kinematicsyawratemax = rhs.c0kinematicsyawratemax;
            c0c0kinematicsyawratemaxbreakpoints = rhs.c0c0kinematicsyawratemaxbreakpoints;
            steeringrateforbicyclemodel = rhs.steeringrateforbicyclemodel;
            vehiclemassforbicyclemodel = rhs.vehiclemassforbicyclemodel;
            cornrgstfnfrntforbicyclemodel = rhs.cornrgstfnfrntforbicyclemodel;
            cornrgstfnreforbicyclemodel = rhs.cornrgstfnreforbicyclemodel;
            whleelbaseforbicyclemodel = rhs.whleelbaseforbicyclemodel;
            frontdistanceforbicyclemodel = rhs.frontdistanceforbicyclemodel;
            upperlimitcurvaturerear = rhs.upperlimitcurvaturerear;
            lowerlimitcurvaturerear = rhs.lowerlimitcurvaturerear;
            c0biasfactorbasedynamics = rhs.c0biasfactorbasedynamics;
            c0cutofffrequencybasedynamics = rhs.c0cutofffrequencybasedynamics;
            maxcurvature = rhs.maxcurvature;
            return *this;
        }
    };
    
    struct Param_Selection {
        Param_C0Calculator c0calculator;
        Param_Validator validator;
        Param_Funnel funnel;
        Param_Road road;
        Param_OffsetCalculator offsetcalculator;
        Param_Selector selector;
        explicit Param_Selection(): 
            c0calculator(),
            validator (),
            funnel(),
            road(),
            offsetcalculator(),
            selector() {
        }
        Param_Selection(const Param_Selection &r) :
                c0calculator(r.c0calculator),
                validator(r.validator),
                funnel(r.funnel),
                road(r.road),
                offsetcalculator(r.offsetcalculator),
                selector(r.selector) {
        }
        explicit Param_Selection(const Param_C0Calculator &c0calculator_,
                                 const Param_Validator &validator_,
                                 const Param_Funnel &funnel_,
                                 const Param_Road &road_,
                                 const Param_OffsetCalculator &offsetcalculator_,
                                 const Param_Selector &selector_) :
                c0calculator(c0calculator_),
                validator(validator_),
                funnel(funnel_),
                road(road_),
                offsetcalculator(offsetcalculator_),
                selector(selector_) {
        }
    };

    class Param{
    public:
        Param();
        ~Param();

        Param_Selection selection_;
    };
    
} // namespace ACC_Target_Selection

#endif