#ifndef ACC_TARGET_SELECTION_ROAD_H
#define ACC_TARGET_SELECTION_ROAD_H

#include <array>
#include <memory>

#include "basetype.h"
#include "param.h"

#include "logger.h"
#include "egovehicleinformation.h"
#include "roadproperty.h"

namespace ACC_Target_Selection {
    class Road {
    public:
        const Param_Road &param_conf_;
        const Logger &logger_;

        explicit Road(const Param_Road &param_conf, const Logger  &logger);
        Road(const Road& r);
        ~Road();

        basetype::float32_t getlaneoffset();

        basetype::float32_t getoffset();

        basetype::float32_t getlanewidth(const basetype::float32_t &lgtdis);

        basetype::boolean_t getisoffsetfromlanecenterusable();

        basetype::boolean_t getisoffsetfromlanecentervalid();

        void set(const RoadProperty &roadproperty,const EgoVehicleInformation &egovehinfo);
    private:
        basetype::float32_t offset_;
        basetype::float32_t landwidth_;
        basetype::boolean_t isoffsetfromlanecenterusable_;
        basetype::boolean_t isoffsetfromlanecentervalid_;

        basetype::boolean_t checkoffsetlat();
    };

} // namespace ACC_Target_Selection

#endif