#include "runner.h"

#include "egovehicleinformation.h"
#include "object.h"
#include "roadproperty.h"

#include <iostream>

namespace ACC_Target_Selection {
    Runner::Runner() :
            logger_(),
            param_(),
            selector_(param_.selection_, logger_) {
    }
    
    Runner::~Runner() {
    }

    void Runner::init() {
        EgoVehicleInformation initegovehinfo{EgoVehicleInformation_Default};
        //Object initobjects[c_ObjectSize];
        std::array<Object, c_ObjectSize> initobjects(Objecs_Default);
        RoadProperty initroadperty{RoadProperty_Default};
        initegovehinfo.SpdLgt = 0.0f;
        initroadperty.LaneWidth = 3.6f;
        initroadperty.LateralOffset =0.0f;
        initroadperty.Valid = boolean_t_false;
        for (basetype::objectid_t i = 0u; i < c_ObjectSize; i++) {
            initobjects.at(i).Ppty.Id = i + one_objectid_t;
            /**
            if (initobjects[i].Ppty.Id == (one_objectid_t + one_objectid_t)) {
                initobjects[i].Est.DisLgt = 0.0f;
                initobjects[i].Est.DisLat = 0.0f;
                initobjects[i].Est.Spd = 0.0f;
                initobjects[i].Est.SpdLgt = 0.0f;
                initobjects[i].Info.DisLatFromLaneCenter = 0.0;
                initobjects[i].Info.MotionHistoryType = ObjectMotionHistoryType::Unknown;
                initobjects[i].Info.MotionType = ObjectMotionType::Unknown;
                initobjects[i].Info.Type = ObjectType::Unknown;
                initobjects[i].Info.Width = 0.0f;
                initobjects[i].Ppty.FusionSource = ObjectFusionSource::None;
                initobjects[i].Ppty.TrackStatus = ObjectTrackStatus::Invalid;
                initobjects[i].Ppty.DisLatFromLaneCenterQf = ObjectDisLatFromLaneCenterQf::UnReliable;
            }
            **/
        }
        
        logger_.logegovehinfo(initegovehinfo);
        logger_.logobjects(initobjects);
        logger_.logroadperty(initroadperty);


    }

    void Runner::step(const EgoVehicleInformation &egovehinfo, const std::array<Object, c_ObjectSize> &objects, const RoadProperty &roadperty) {

        logger_.logegovehinfo(egovehinfo);
        logger_.logobjects(objects);
        logger_.logroadperty(roadperty);

        selector_.update(logger_.Getinfoprovider().objects,
                         logger_.Getinfoprovider().egovehinfo,
                         logger_.Getinfoprovider().roadperty,
                         ((logger_.Getinfoprovider().egovehinfo.Indicator==IndicatorStatus::Left)? boolean_t_true : boolean_t_false),
                         ((logger_.Getinfoprovider().egovehinfo.Indicator==IndicatorStatus::Right)? boolean_t_true : boolean_t_false),
                         LaneChangeType::None);
        //InfoProvider INFOPROVIDER{selector_.logger_.Getinfoprovider()};
        //InfoCreator INFOCREATOR{INFOCREATOR = selector_.logger_.Getinfocreator()};
        //std::cout<< "SpdLgt: "<<(INFOPROVIDER.egovehinfo.SpdLgt)<<std::endl;
        //std::cout<< "SteeringAngle: "<<(INFOPROVIDER.egovehinfo.SteeringAngle)<<std::endl;
        //std::cout<< "Indicator: "<<int(INFOPROVIDER.egovehinfo.Indicator)<<std::endl;
        //std::cout<< "YawRate: "<<(INFOPROVIDER.egovehinfo.YawRate)<<std::endl;
        //std::cout<< "YawRateRaw: "<<(INFOPROVIDER.egovehinfo.YawRateRaw)<<std::endl;
        //std::cout<< "pedestrain: "<<int(INFOCREATOR.element.pedestrain)<<std::endl;
        //std::cout<< "iv: "<<int(INFOCREATOR.element.iv)<<std::endl;
        //std::cout<< "iiv: "<<int(INFOCREATOR.element.iiv)<<std::endl;
        //std::cout<< "cutin: "<<int(INFOCREATOR.element.cutin)<<std::endl;
        //std::cout<< "fliv: "<<int(INFOCREATOR.element.fliv)<<std::endl;
        //std::cout<< "sliv: "<<int(INFOCREATOR.element.sliv)<<std::endl;
        //std::cout<< "fliiv: "<<int(INFOCREATOR.element.fliiv)<<std::endl;
        //std::cout<< "sliiv: "<<int(INFOCREATOR.element.sliiv)<<std::endl;
        //std::cout<< "------------------------------------------"<<std::endl;
        //std::cout<< "riv: "<<int(INFOCREATOR.element.riv)<<std::endl;
        //std::cout<< "riiv: "<<int(INFOCREATOR.element.riiv)<<std::endl;
        //std::cout<< "rcutin: "<<int(INFOCREATOR.element.rcutin)<<std::endl;
        //std::cout<< "rfliv: "<<int(INFOCREATOR.element.rfliv)<<std::endl;
        //std::cout<< "rsliv: "<<int(INFOCREATOR.element.rsliv)<<std::endl;
        //std::cout<< "rfliiv: "<<int(INFOCREATOR.element.rfliiv)<<std::endl;
        //std::cout<< "rsliiv: "<<int(INFOCREATOR.element.rsliiv)<<std::endl;
        //std::cout<< "valid: "<<int(INFOCREATOR.array.valid[173])<<std::endl;
        //std::cout<< "jumpcounter: "<<int(INFOCREATOR.array.jumpcounter[173])<<std::endl;
        //std::cout<< "coastedcounter: "<<int(INFOCREATOR.array.coastedcounter[173])<<std::endl;
        //std::cout<< "maturitycounter: "<<int(INFOCREATOR.array.maturitycounter[173])<<std::endl;
        //std::cout<< "laneoffset: "<<(INFOCREATOR.element.laneoffset)<<std::endl;
        //std::cout<< "offset: "<<(INFOCREATOR.array.offset[173])<<std::endl;
        //std::cout<< "offsetraw: "<<(INFOCREATOR.array.offsetraw[173])<<std::endl;
        //std::cout<< "lanewidth: "<<(INFOCREATOR.array.lanewidth[173])<<std::endl;
        //std::cout<< "innerleftfunnel: "<<(INFOCREATOR.array.innerleftfunnel[173])<<std::endl;
        //std::cout<< "innerrightfunnel: "<<(INFOCREATOR.array.innerrightfunnel[173])<<std::endl;
        //std::cout<< "outerleftfunnel: "<<(INFOCREATOR.array.outerleftfunnel[173])<<std::endl;
        //std::cout<< "outerrightfunnel: "<<(INFOCREATOR.array.outerrightfunnel[173])<<std::endl;
        //std::cout<< "DisLgt: "<<(INFOPROVIDER.objects[173].Est.DisLgt)<<std::endl;
        //std::cout<< "DisLat: "<<(INFOPROVIDER.objects[173].Est.DisLat)<<std::endl;
        //std::cout<< "HeadingAngle: "<<(INFOPROVIDER.objects[173].Est.HeadingAngle)<<std::endl;
        //std::cout<< "DisLatFromLaneCenter: "<<(INFOPROVIDER.objects[173].Info.DisLatFromLaneCenter)<<std::endl;
        //std::cout<< "c1: "<<(INFOCREATOR.array.c1[173])<<std::endl;
        //std::cout<< "c0: "<<(INFOCREATOR.element.c0)<<std::endl;
        //std::cout<< "******************************************"<<std::endl;
        
    }

    void Runner::step() {
        Runner::selector_.update(Runner::logger_.Getinfoprovider().objects,
                                 Runner::logger_.Getinfoprovider().egovehinfo,
                                 Runner::logger_.Getinfoprovider().roadperty,
                                 ((Runner::logger_.Getinfoprovider().egovehinfo.Indicator==IndicatorStatus::Left)? boolean_t_true : boolean_t_false),
                                 ((Runner::logger_.Getinfoprovider().egovehinfo.Indicator==IndicatorStatus::Right)? boolean_t_true : boolean_t_false),
                                 LaneChangeType::None);
        //InfoProvider INFOPROVIDER{selector_.logger_.Getinfoprovider()};
        //InfoCreator INFOCREATOR{INFOCREATOR = selector_.logger_.Getinfocreator()};
        //std::cout<< "cip: "<<int(INFOCREATOR.element.cip)<<std::endl;
        //std::cout<< "valid: "<<int(INFOCREATOR.array.valid[0])<<"|"<<int(INFOCREATOR.array.valid[1])<<std::endl;
    }
} // namespace ACC_Target_Selection