#pragma once

#include "adapter_output.h"
#include "delay.h"
#include "frame.h"
#include "intersection_virtual_lane_generator.h"
#include "macros.h"
// #include "mpc_drv_msgs/msg/corridor.hpp"
#include "dpc/impl_type_corridor.h"
// #include "mpc_drv_msgs/msg/rmsm_message.hpp"
#include "dpc/impl_type_rmsmmessage.h"
// #include "mpc_drv_msgs/msg/road_info.hpp"
#include "dpc/impl_type_roadinfo.h"
// #include "mpc_drv_msgs/msg/targets_info.hpp"
#include "dpc/impl_type_targetsinfo.h"
#include "road/road_info_provider.h"

namespace rm {
class ATSOutputSwitch {
public:
  void RunAtsOutputSwitch(dpc::RoadInfo &rm_road_info,
                          dpc::RMSMMessage &rm_sm_msg,
                          dpc::TargetsInfo &rm_targets_info,
                          dpc::Corridor &ats_corridor,
                          dpc::TargetsInfo &ats_targetsinfo,
                          dpc::TargetsInfo &targets_info,
                          rm::Frame *frame, uint32_t ats_pedestrian_iv);
  bool EvaluateTargetNew(uint32_t &id_pre, uint32_t &id_new);

private:
  rm::Delay<bool> ego_lane_miss_delay_{0.0, 1.0, false};
  rm::Delay<bool> ego_corridor_list_empty_delay_{0.0, 1.0, false};
  dpc::TargetsInfo targetsinfo_pre_;
  void SetRMTSResWithATSRes(rm::Frame *frame,
                            dpc::TargetsInfo &ats_targetsinfo);

  DECLARE_SINGLETON(ATSOutputSwitch);
};
} // namespace rm
