/*
 * @Author: your name
 * @Date: 2021-12-16 08:18:41
 * @LastEditTime: 2022-03-21 19:21:36
 * @LastEditors: Please set LastEditors
 * @Description: 打开koroFileHeader查看配置 进行设置:
 * https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 * @FilePath:
 * /EHR/home/igs/roadmodel/src/core/source/common/base/adapter_output.h
 */

//用于外部message 与内部接口转换
#pragma once
#include <algorithm>

#include "boundary.h"
#include "control_way_points.h"
#include "corridor.h"
#include "discrete_point_curvature_calculator.h"
#include "enum_list.h"
#include "global_parameters.h"
#include "lane.h"
#include "lane_info.h"
#include "lane_marker.h"
#include "macros.h"
// #include "mpc_drv_msgs/msg/corridor.hpp"
#include "dpc/impl_type_corridor.h"
// #include "mpc_drv_msgs/msg/lane.hpp"
#include "dpc/impl_type_lane.h"
// #include "mpc_drv_msgs/msg/lane_boundary.hpp"
#include "dpc/impl_type_laneboundary.h"
// #include "mpc_drv_msgs/msg/lane_control.hpp"
#include "dpc/impl_type_lanecontrol.h"
// #include "mpc_drv_msgs/msg/lane_marker.hpp"
#include "dpc/impl_type_lanemarker.h"
// #include "mpc_drv_msgs/msg/line_geometry.hpp"
#include "dpc/impl_type_linegeometry.h"
// #include "mpc_drv_msgs/msg/object.hpp"
#include "dpc/impl_type_object.h"
// #include "mpc_drv_msgs/msg/rmsm_message.hpp"
#include "dpc/impl_type_rmsmmessage.h"
// #include "mpc_drv_msgs/msg/road_edge.hpp"
#include "dpc/impl_type_roadedge.h"
// #include "mpc_drv_msgs/msg/sampling_point.hpp"
#include "dpc/impl_type_samplingpoint.h"
// #include "mpc_drv_msgs/msg/target_info.hpp"
#include "dpc/impl_type_targetinfo.h"
#include "obstacle.h"
#include "polynom_line.h"
#include "road_edge.h"
#include "sampling_point.h"
#include "stdint.h"
#include "vehicle_state_provider.h"
#include "rm_config.h"
namespace rm {
namespace output {
void PolynomLine2LineGeometry(const PolynomLine &polynomLine,
                              dpc::LineGeometry &line_geometry);

void LaneMarkerSegment2LaneBoundary(
    const LaneMarkerSegment &lane_marker_segment,
    dpc::LaneBoundary &lane_boundary);

// TODO(ningmeng):need update
void LaneMarker2LaneMarker(const LaneMarker &lane_marker,
                           dpc::LaneMarker &pubs_lane_marker);

void SamplingPoint2SamplingPoint(
    const SamplingPoint &sample_point,
    dpc::SamplingPoint &pubs_sampling_point);

void SamplingPoint2TrpLonSamplingPoint(
    const SamplingPoint &sample_point,
    dpc::SamplingPoint &pubs_sampling_point);

void ObjLocation2ObjLocation(const ObjectLocation object_location,
                             dpc::ObjectLocation &ret);

void Corridor2Corridor(const Corridor &corridor,
                       dpc::Corridor &cor);

void DefaultCorridor2Corridor(dpc::Corridor &cor);

void Obstacle2Object(const Obstacle &obstacle,
                     dpc::Object &object);

void FrontObstacle2Target(const Obstacle &obstacle,
                          dpc::TargetInfo &target);

void RearObstacle2Target(const Obstacle &obstacle,
                         dpc::TargetInfo &target);

void DefaultFrontTarget(dpc::TargetInfo &target);

void DefaultRearTarget(dpc::TargetInfo &target);

void EHRSpeedLimit2SMSpeedLimit(dpc::RMSMMessage *ptr_rm_sm_msg,
                                const rm::ControlWayPoints *control_waypoints,
                                const rm::Lane *lane);

void Lane2LaneInfo(rm::LaneInfo *lane_info_ptr,
                   dpc::LaneInfo &lane_info);

void ILCTargetList2RMILCTarget(dpc::RMSMMessage *ptr_rm_sm_msg,
                               const std::vector<uint32_t> &ilc_target_list);

void RoadEdge2RoadEdge(const RoadEdge &road_edge,
                       dpc::RoadEdge &pubs_road_edge);

void RoadEdgeSeg2RoadEdgeSeg(
    const RoadEdgeSegment &road_edge_seg,
    dpc::RoadEdgeSegment &pubs_road_edge_seg);

uint8_t RoadEdgeType2TRPRoadEdgeType(RoadEdgeType road_edge_type);

void CorridorInfo2SMCorridorInfo(uint8_t &idx,
                                 dpc::RMSMMessage &rm_sm_msg,
                                 uint32_t id, rm::CorridorFeatureTag tag);

void ObstacleReferencePointAdapter(double &dx, double &dy,
                                   const Obstacle &object);

void ODDInfoAdapter(dpc::LaneInfo &sm_lane_info,
                    rm::WPExtendLane *extend_lane);

void ReferenceLineGeometeryAdapter(dpc::LaneInfo &sm_lane_info,
                                   rm::LaneInfo *lane_info);

void MaxSpeedLimitAdapter(dpc::Lane &lane,
                          const rm::Lane &rm_lane);

void SampingPointTrpLongAdapter(
    std::array<dpc::SamplingPoint, 25> &sampling_points_output,
    std::vector<LaneMarkerSegment> *lane_marker_segs, uint8_t desired_lane_id,
    const Lane &special_ego_lane);

void PolynomLine2SamplingPoint(
    const PolynomLine &line,
    dpc::SamplingPoint &pubs_sampling_point, double x);

rm::MeasurementState
MeasurementStateRemap(rm::MeasurementState original_meas_state,
                      rm::LineType current_ln_type);

} // namespace output
} // namespace rm
