#ifndef LH1_EP21_P_CAN2_V12_H
#define LH1_EP21_P_CAN2_V12_H

#ifdef __cplusplus
extern "C" {
#endif

#include <stdint.h>
#include <stdbool.h>
#include <stddef.h>

#ifndef EINVAL
#    define EINVAL 22
#endif

struct lh1_ep21_p_can2_v12_sas_hsc2_fr_p00_t {
    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t strg_whl_ang_vhsc2;

    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t strg_whl_ang_snsr_cal_sts_hsc2;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t strg_whl_ang_snsr_inid_hsc2;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t strg_whl_ang_snsr_mult_capb_hsc2;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t strg_whl_ang_snsr_flt_hsc2;

    /**
     * Range: 0..65534.08 (-2048..2047.88 degree)
     * Scale: 0.0625
     * Offset: -2048
     */
    uint16_t strg_whl_ang_hsc2;

    /**
     * Range: 0..15 (0..15 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t strg_whl_ang_alv_rchsc2;

    /**
     * Range: 0..4094 (-2048..2046 degree/s)
     * Scale: 1
     * Offset: -2048
     */
    uint16_t strg_whl_ang_grd_hsc2;

    /**
     * Range: 0..65535 (0..65535 -)
     * Scale: 1
     * Offset: 0
     */
    uint16_t strg_whl_ang_extd_pvhsc2;

    /**
     * Range: 0..255 (0..255 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t strg_whl_ang_snsr_chksm_hsc2;
};

struct lh1_ep21_p_can2_v12_scs_hsc2_fr_p05_t {
    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t virtual_mstr_cylnd_prs_sts_hsc2;

    /**
     * Range: 0..1000 (0..250 bar)
     * Scale: 0.25
     * Offset: 0
     */
    uint16_t virtual_mstr_cylnd_prs_hsc2;

    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t brk_sys_tr_gear_req_typ_hsc2;

    /**
     * Range: 0..15 (0..15 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t brk_sys_tr_gear_req_gear_hsc2;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t absahsc2;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t absfhsc2;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t tcsahsc2;

    /**
     * Traction Control System Enabled
     *
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t tcs_enbd_hsc2;

    /**
     * Engine Drag Torque Reduction Active
     *
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t en_drag_toq_rducn_ahsc2;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t vse_sys_ahsc2;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t veh_dyn_yaw_rate_vhsc2;

    /**
     * Range: -2048..2047.008 (-128..127.938 deg/s)
     * Scale: 0.0625
     * Offset: 0
     */
    int16_t veh_dyn_yaw_rate_hsc2;

    /**
     * Range: 0..15 (0..15 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t absarchsc2;

    /**
     * Range: 0..255 (0..255 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t absa_chksm_hsc2;
};

struct lh1_ep21_p_can2_v12_scs_hsc2_fr_p24_t {
    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t veh_sdsl_sts_hsc2;

    /**
     * 2017.05.25
     * ChACCAEBAccReqResp name changed to ChACCAccReqResp
     *
     * Range: 0..7 (0..7 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ch_acc_acc_req_resp_hsc2;

    /**
     * 2017.05.25:
     * ChACCAEBHydBrkAstReqResp name changed to ChAEBHydBrkAstReqResp
     *
     * Range: 0..7 (0..7 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ch_aeb_hyd_brk_ast_req_resp_hsc2;

    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ch_acc_req_flr_sts_hsc2;

    /**
     * 2017.05.25:
     * ChACCAEBPrflReqResp name changed to ChAEBPrflReqResp
     * 
     * ,and encode updated
     * 
     * ChAEBPrflReqResp
     * 
     *
     * Range: 0..7 (0..7 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ch_aeb_prfl_req_resp_hsc2;

    /**
     * Range: 0..7 (0..7 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ch_accaeb_brk_jerk_req_resp_hsc2;

    /**
     * 2017.05.25
     * ChACCAEBDclReqResp_Radar name changed to ChAEBDclReqResp
     *
     * Range: 0..7 (0..7 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ch_aeb_dcl_req_resp_hsc2;

    /**
     * Range: 0..15 (0..15 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ch_accaeb_alv_rlng_ctr_radar_hsc2;

    /**
     * Range: 0..255 (-7..5.75 -)
     * Scale: 0.05
     * Offset: -7
     */
    uint8_t veh_trgt_longt_acc_hsc2;

    /**
     * Range: 0..255 (0..255 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ch_accaeb_chksm_radar_hsc2;
};

struct lh1_ep21_p_can2_v12_scs_hsc2_fr_p19_t {
    /**
     * Range: 0..65535 (0..65535 -)
     * Scale: 1
     * Offset: 0
     */
    uint16_t veh_spd_avg_pvhsc2;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t veh_spd_avg_vhsc2;

    /**
     * Range: 0..32766.976 (0..511.984 km/h)
     * Scale: 0.015625
     * Offset: 0
     */
    uint16_t veh_spd_avg_hsc2;

    /**
     * Range: 0..15 (0..15 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t veh_spd_avg_alv_rchsc2;

    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t veh_spd_avg_sts_hsc2;

    /**
     * Range: 0..250 (0..250 bar)
     * Scale: 1
     * Offset: 0
     */
    uint8_t max_estd_whl_prs_hsc2;

    /**
     * Range: 0..255 (0..255 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t veh_spd_avg_chksm_hsc2;
};

struct lh1_ep21_p_can2_v12_gw_hsc2_bcm_fr_p04_t {
    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ldspc_open_sts_hsc2;

    /**
     * Rear Right Door Open Status
     *
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t rr_door_open_sts_hsc2;

    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t dircn_ind_lamp_sw_sts_hsc2;

    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t drvr_door_open_sts_hsc2;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t main_beam_lght_on_hsc2;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t frt_fog_lght_on_hsc2;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t dipd_beam_lght_on_hsc2;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t l_dircn_iohsc2;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t l_dircn_ind_lght_fhsc2;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t r_dircn_iohsc2;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t rr_fog_lght_on_hsc2;

    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t bnt_open_sts_hsc2;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t dsp_meas_sys_hsc2;

    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t frt_psng_door_open_sts_hsc2;

    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t rl_door_open_sts_hsc2;

    /**
     * Front Washer Pump Active
     *
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t frt_wshr_pump_ahsc2;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t trlr_hitch_sw_ahsc2;

    /**
     * Front Wiper Park Position Active
     * Wiper Park Position for the Front wiper
     *
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t frt_wiper_park_pos_ahsc2;

    /**
     * Range: 0..7 (0..7 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t key_det_indx_hsc2;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t r_dircn_ind_lght_fhsc2;

    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t main_beam_sw_pos_sts_hsc2;

    /**
     * Ambient Light Level
     * Indicate the Request from Auto Light Sensor
     *
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ambt_lght_lvl_hsc2;

    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t veh_side_lght_sts_hsc2;
};

struct lh1_ep21_p_can2_v12_scs_hsc2_fr_p08_t {
    /**
     * Range: -32768.00196608503317768493487..32767.01892356844433521749816 (-3.99999..3.99987 g)
     * Scale: 0.00012207
     * Offset: 0
     */
    int16_t longd_acc_snsr_val_hsc2;

    /**
     * Latitude  Acceleration Sensor Value
     *
     * Range: -32768.03278688524590163934426..32766.96721311475409836065574 (-3.9977..3.99757 g)
     * Scale: 0.000122
     * Offset: 0
     */
    int16_t latd_acc_snsr_val_hsc2;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t longd_acc_snsr_val_vhsc2;

    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t longd_latd_acc_snsr_val_archsc2;

    /**
     * LongdLatdAccSnsrChksm = (Byte[0]+Byte[1]+Byte[2]+Byte[3]+Byte[4]+Byte[5]+((Byte[6]&0xF8)>>3)+(CAN_ID/8))
     *
     * Range: 0..2047 (0..2047 -)
     * Scale: 1
     * Offset: 0
     */
    uint16_t longd_latd_acc_snsr_chksm_hsc2;
};

/**
 * Unpack message SAS_HSC2_FrP00.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int lh1_ep21_p_can2_v12_sas_hsc2_fr_p00_unpack(
    struct lh1_ep21_p_can2_v12_sas_hsc2_fr_p00_t *dst_p,
    const uint8_t *src_p,
    size_t size);

int lh1_ep21_p_can2_v12_scs_hsc2_fr_p05_unpack(
    struct lh1_ep21_p_can2_v12_scs_hsc2_fr_p05_t *dst_p,
    const uint8_t *src_p,
    size_t size);

int lh1_ep21_p_can2_v12_scs_hsc2_fr_p24_unpack(
    struct lh1_ep21_p_can2_v12_scs_hsc2_fr_p24_t *dst_p,
    const uint8_t *src_p,
    size_t size);

int lh1_ep21_p_can2_v12_scs_hsc2_fr_p19_unpack(
    struct lh1_ep21_p_can2_v12_scs_hsc2_fr_p19_t *dst_p,
    const uint8_t *src_p,
    size_t size);

int lh1_ep21_p_can2_v12_gw_hsc2_bcm_fr_p04_unpack(
    struct lh1_ep21_p_can2_v12_gw_hsc2_bcm_fr_p04_t *dst_p,
    const uint8_t *src_p,
    size_t size);

int lh1_ep21_p_can2_v12_scs_hsc2_fr_p08_unpack(
    struct lh1_ep21_p_can2_v12_scs_hsc2_fr_p08_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double lh1_ep21_p_can2_v12_sas_hsc2_fr_p00_strg_whl_ang_hsc2_decode(uint16_t value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double lh1_ep21_p_can2_v12_scs_hsc2_fr_p05_veh_dyn_yaw_rate_hsc2_decode(int16_t value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double lh1_ep21_p_can2_v12_scs_hsc2_fr_p08_latd_acc_snsr_val_hsc2_decode(int16_t value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double lh1_ep21_p_can2_v12_scs_hsc2_fr_p08_longd_acc_snsr_val_hsc2_decode(int16_t value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double lh1_ep21_p_can2_v12_scs_hsc2_fr_p19_veh_spd_avg_hsc2_decode(uint16_t value);

#ifdef __cplusplus
}
#endif

#endif