/*
 * @Author: your name
 * @Date: 2021-12-16 08:18:41
 * @LastEditTime: 2021-12-16 11:13:53
 * @LastEditors: Please set LastEditors
 * @Description: 打开koroFileHeader查看配置 进行设置:
 * https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 * @FilePath:
 * /EHR/home/igs/roadmodel/src/core/source/common/math/extend_kalman_filter_object.h
 */
#include "Eigen/Dense"
#include "enum_list.h"
#include "observer.h"
#include "vec2d.h"
#include <cmath>
#include <iostream>
#include <vector>

namespace rm {
namespace common {
namespace math {

class ExtendKalmanFilterObject {
public:
  ExtendKalmanFilterObject();
  ~ExtendKalmanFilterObject();
  void Init(const std::vector<double> &meas);
  static void Set_CoordinateTransformMat(const double dx, const double dangle);
  void CorrdinateTransform();
  void Predict();
  bool Correct(const std::vector<double> &meas);
  void GetState(std::array<double, 6> &filtered_state); // TODO 传递原始数据类型
  rm::FilterStatus filter_status() const {return filter_status_;};
  // void UpdateParam(const std::shared_ptr<Observer>& observer);

private:
  Eigen::Matrix<double, 6, 6> process_cov_, meas_cov_, state_cov_,
      jacob_process_, kalman_gain_;
  Eigen::Matrix<double, 6, 1> state_vec_; // state_vec_ = (x y v a phi phi_dot)
  static Eigen::Matrix<double, 6, 6> coord_transf_;
  static Eigen::Matrix<double, 6, 1> coord_offset_;
  static const double t_; // sample time
  rm::FilterStatus filter_status_;
  // std::shared_ptr<Observer> observer_;
};

} // namespace math
} // namespace common
} // namespace rm