#pragma once
#include <stdint.h>

namespace rm {
namespace common {
class FlipFlop {
public:
  FlipFlop() : prv_status_(false), prv_not_status_(true){};
  ~FlipFlop() {};
  void Run(bool set, bool reset) {
    prv_status_ = set || (!reset && prv_status_);
    prv_not_status_ = !prv_status_;
  };
  void Reset() {
    prv_status_ = false;
    prv_not_status_ = true;
  }
  bool get_status() const { return prv_status_; };

private:
  bool prv_status_;
  bool prv_not_status_;
};
} // namespace common

} // namespace rm
