/*
 * @Author: your name
 * @Date: 2021-12-07 09:23:38
 * @LastEditTime: 2021-12-10 09:41:54
 * @LastEditors: Please set LastEditors
 * @Description: 打开koroFileHeader查看配置 进行设置: https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 * @FilePath: /EHR/home/igs/roadmodel/src/CtApRoadModel/source/common/math/lookup_table.cpp
 */
#include "lookup_table.h"
#include <iostream>
using namespace std;
namespace rm{
//参考网址 https://www.cnblogs.com/linkr/p/3630902.html
double TwoDimLookupTable::Evaluate(double row,double col) const
{
        int it_row = std::lower_bound(row_.begin(), row_.end(), row) - row_.begin();//计算row_中首次出现比row大的数值所在的位置  位置从0开始计算
        int it_col = std::lower_bound(col_.begin(), col_.end(), col) - col_.begin();
        
        it_row = min(max(1,it_row),(int)row_.size()-1);
        it_col = min(max(1,it_col),(int)col_.size()-1);

        double y1 = row_.at(it_row-1);
        double y2 = row_.at(it_row);
        double x1 = col_.at(it_col-1);
        double x2 = col_.at(it_col);

        double x = col;
        double y = row;
        
        double Q11 = value_.at((it_row-1)+(it_col-1)*(row_.size()));
        double Q12 = value_.at((it_row)+(it_col-1)*(row_.size()));
        double Q21 = value_.at((it_row-1)+(it_col)*(row_.size()));
        double Q22 = value_.at((it_row)+(it_col)*(row_.size()));

        double denominator = (x2-x1)*(y2-y1);
        double molecule = Q11*(x2-x)*(y2-y)+
                          Q21*(x-x1)*(y2-y)+
                          Q12*(x2-x)*(y-y1)+
                          Q22*(x-x1)*(y-y1);
        return molecule/denominator;
}
// 参考网址 https://baike.baidu.com/item/%E7%BA%BF%E6%80%A7%E6%8F%92%E5%80%BC/19113392?fr=aladdin
double OneDimLookupTable::Evaluate(double col) const
{
        if(col <= col_.front()) return value_.front();
        if(col >= col_.back())  return value_.back();
        
        int it_col = std::lower_bound(col_.begin(), col_.end(), col) - col_.begin();
        
        it_col = min(max(1,it_col),(int)col_.size()-1);
        // cout<<it_col<<endl;
        double x1 = col_.at(it_col-1);
        double x2 = col_.at(it_col);
        double x = col;

        double Q1 = value_.at((it_col-1));
        double Q2 = value_.at((it_col));
        
        return ((x-x2)*Q1 -(x-x1)*Q2)/(x1-x2);
}
}