/*
 * @Author: your name
 * @Date: 2021-09-15 13:20:28
 * @LastEditTime: 2021-12-28 13:58:54
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath: /NOP_EHR/media/igs/xnm/ros/RM/roadmodel/modules/common/math/polynom_line_test.cc
 */

#ifdef GTEST
/**
 * @file
 **/

#include "polynom_line.h"
// #include "matplotlibcpp.h"
// namespace plt = matplotlibcpp;
#include "gtest/gtest.h"

namespace rm {

TEST(PolynomLineTest, Evaluate) {
  {
    double x0 = 0.0;
    double dx0 = 0.0;
    double ddx0 = 0.0;
    double x1 = 10.0;
    double param = 8.0;

    // PolynomLine curve(x0, dx0, ddx0, x1, param);
    // EXPECT_NEAR(x1, curve.Evaluate(0, param), 1e-8);
    // EXPECT_NEAR(0, curve.Evaluate(0, 0.0), 1e-8);
    // EXPECT_NEAR(0, curve.Evaluate(1, 0.0), 1e-8);
    // EXPECT_NEAR(0, curve.Evaluate(2, 0.0), 1e-8);
  }
  {
    double x0 = 0.0;
    double dx0 = 0.0;
    double ddx0 = 0.0;
    double x1 = 5.0;
    double param = 3.0;

    // PolynomLine curve(x0, dx0, ddx0, x1, param);
    // EXPECT_NEAR(x1, curve.Evaluate(0, param), 1e-8);
    // EXPECT_NEAR(0, curve.Evaluate(0, 0.0), 1e-8);
    // EXPECT_NEAR(0, curve.Evaluate(1, 0.0), 1e-8);
    // EXPECT_NEAR(0, curve.Evaluate(2, 0.0), 1e-8);
  }

  {
    double x0 = 1.0;
    double dx0 = 2.0;
    double ddx0 = 3.0;
    double x1 = 5.0;
    double param = 3.0;
    // PolynomLine curve(x0, dx0, ddx0, x1, param);
    // EXPECT_NEAR(x1, curve.Evaluate(0, param), 1e-8);
    // EXPECT_NEAR(x0, curve.Evaluate(0, 0.0), 1e-8);
    // EXPECT_NEAR(dx0, curve.Evaluate(1, 0.0), 1e-8);
    // EXPECT_NEAR(ddx0, curve.Evaluate(2, 0.0), 1e-8);
  }
}
TEST(PolynomLineTest, translation){
  std::array<double,4>coef = {0,0,-0.01/2.0,0.0006/6.0};
  PolynomLine curve(coef,0,60);
  std::vector<common::math::ReferencePoint> points = curve.DiscreteCurved( 0.5);
  std::vector<double> x;
  std::vector<double> y;
  for(int i=0;i<points.size();i++){
    x.push_back(points[i].x());
    y.push_back(points[i].y());
  }
  // plt::named_plot("origin",x,y);
  std::array<double,4>coef1 = {-5,0,-0.01/2.0,0.0006/6.0};
  PolynomLine curve1(coef1,0,60);
  std::vector<common::math::ReferencePoint> points1 = curve1.DiscreteCurved( 0.5);
  std::vector<double> x1;
  std::vector<double> y1;
  for(int i=0;i<points.size();i++){
    x1.push_back(points1[i].x());
    y1.push_back(points1[i].y());
  }
  // plt::named_plot("a",x1,y1);
  curve.MoveCurved(-5);
  PolynomLine curve_new = curve;
  EXPECT_NEAR(curve_new.EndCondition(),62.4 , 1e-7);
  EXPECT_NEAR(curve_new.Coef(0),curve.Coef(0)-5 , 1e-7);
  EXPECT_NEAR(curve_new.Coef(1),curve.Coef(1) , 1e-7);
  EXPECT_NEAR(curve_new.Coef(2),(-0.01052632+0.00145104)/2.0 , 1e-7);
  EXPECT_NEAR(curve_new.Evaluate(2,curve_new.EndCondition()),(0.02300885+0.00145104) , 1e-7);
  std::vector<common::math::ReferencePoint> point = curve_new.DiscreteCurved( 0.5);
  
  std::vector<double> xx;
  std::vector<double> yy;
  for(int i=0;i<point.size();i++){
    xx.push_back(point[i].x());
    yy.push_back(point[i].y());
  }
  // plt::named_plot("opt",xx,yy);
  // plt::legend();
  // plt::axis("equal");
  // plt::show(); //TODO(ningmeng):需要修复plt在gtest中无法正常调用的问题
}

}  // namespace rm
#endif