#include "safe_divide.h"

namespace rm {

namespace math {

double SafeDivide(double nominator, double denominator) {
  double abs_denominator = std::abs(denominator);
  double threshold = pow(10, -10);
  if (abs_denominator > threshold) {
    return nominator / denominator;
  } else if (abs_denominator <= threshold) {
    return (denominator >= 0.0) ? nominator / threshold
                                : -1.0 * nominator / threshold;
  } else {
    // do nothing
  }
}

} // namespace math
} // namespace rm
