#include "slope_limiter.h"

namespace rm {
namespace math {
float SlopeLimiter::Run(float value) {
  float delta_value = value - prv_output_;
  if (delta_value > 0) {
    prv_output_ = (delta_value > slope_limitation_ * rm::ROADMODELCYCLEINS)
                      ? prv_output_ + slope_limitation_ * rm::ROADMODELCYCLEINS
                      : value;
  } else {
    prv_output_ =
        (delta_value < -1.0 * slope_limitation_ * rm::ROADMODELCYCLEINS)
            ? prv_output_ - slope_limitation_ * rm::ROADMODELCYCLEINS
            : value;
  }
}
} // namespace math
} // namespace rm