#include "state_machine/state.h"
namespace rm {
namespace state_machine {

State::State(const int &id)
    : id_(id), transitions_(std::make_shared<TransitionMap>()) {}

const StatePtr State::ChangeState(const int &change_flag) {
  auto it = transitions_->find(change_flag);
  if (it != transitions_->end()) {
    return it->second;
  } else {
    return nullptr;
  }
}

void State::AddTransition(const int &change_flag, const StatePtr &to_state) {
  transitions_->insert(make_pair(change_flag, to_state));
}

}  // namespace state_machine
}  // namespace rm
