#pragma once
#include <iostream>
#include <map>
#include <string>

#include "state_machine/state_machine_type.h"

namespace rm {
namespace state_machine {

class State {
 public:
  State(const int &id);

  bool operator==(const State &other) const { return id_ == other.id_; }

  bool operator!=(const State &other) const { return id_ != other.id_; }
  int Id() { return id_; }
  const StatePtr ChangeState(const int &change_flag);

  void AddTransition(const int &change_flag, const StatePtr &to_state);

 private:
  int id_;
  TransitionMapPtr transitions_;
};

}  // namespace state_machine
}  // namespace rm
