#pragma once
#include <fstream>
#include <mutex>
#include <vector>

#include "state_machine/state.h"
#include "state_machine/state_machine_type.h"
namespace rm {
namespace state_machine {

class StateMachine {
 public:
  StateMachine();
  void SetInitializeState(const int state_id);

  bool ChangeState(const int &change_flag);
  void SetChangeFlag(const int &msg) { change_flag_ = msg; }
  int GetChangeFlag() const { return change_flag_; }
  int GetCurrentState() const { return current_state_->Id(); }
  void LoadStateMachine(const std::vector<std::array<int, 3>> &transition);

 private:
  StatePtr current_state_ = nullptr;
  StateMapPtr states_ = std::make_shared<StateMap>();
  int change_flag_ = 0;
  // mutex lock for updating state machine
  std::mutex state_mtx_;
};

using StateMachineShrPtr = std::shared_ptr<StateMachine>;

}  // namespace state_machine
}  // namespace rm
