/*
 * @Author: your name
 * @Date: 2021-12-14 08:47:33
 * @LastEditTime: 2022-02-09 14:24:27
 * @LastEditors: Please set LastEditors
 * @Description: 打开koroFileHeader查看配置 进行设置: https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 * @FilePath: /EHR/home/igs/roadmodel/src/core/source/common/base/config.h
 */
#pragma once
#include <string>
using namespace std;

namespace rm{

struct BoundaryBuilderConfig{
    // int int_param;
    // double double_param;

};
struct CorridorBuilderConfig{
    // string str_param;
    // bool bool_param;

};
struct ObjectAssignmentBuilderConfig{

};
struct RoadInfoProviderConfig{
//   int int_param;
  
//   double proc_x_cov;
//   double proc_y_cov;
//   double proc_v_cov;
//   double proc_a_cov;
//   double proc_yaw_cov;
//   double proc_yawrate_cov;
//   double meas_x_cov;
//   double meas_y_cov;
//   double meas_v_cov;
//   double meas_a_cov;
//   double meas_yaw_cov;
//   double meas_yawrate_cov;

};

struct ILCCorridorBuilderConfig {

};

struct DynamicConfig {

  enum ConfigType {
    BOUNDARY_BUILDER,
    CORRIDOR_BUILDER,
    OBJECT_ASSIGNMENT_BUILDER,
    ROAD_INFO_PROVIDER,
    ILC_CORRIDOR_BUILDER
  };

  string ConfigTypeName(){
    switch (config_type_)
      {
      case BOUNDARY_BUILDER:
        return "BOUNDARY_BUILDER";
      case CORRIDOR_BUILDER:
        return "CORRIDOR_BUILDER";
      case OBJECT_ASSIGNMENT_BUILDER:
        return "OBJECT_ASSIGNMENT_BUILDER";
      case ROAD_INFO_PROVIDER:
        return "ROAD_INFO_PROVIDER";
      case ILC_CORRIDOR_BUILDER:
        return "ILC_CORRIDOR_BUILDER";
      default:
        return "";
      }
  }

  DynamicConfig(ConfigType config_type){
      config_type_ = config_type;
      switch (config_type_)
      {
      case BOUNDARY_BUILDER:
        boundary_builder_config = new BoundaryBuilderConfig();
        break;
      case CORRIDOR_BUILDER:
        corridor_builder_config = new CorridorBuilderConfig();
        break;
      case OBJECT_ASSIGNMENT_BUILDER:
        object_assignment_builder_config = new ObjectAssignmentBuilderConfig();
        break;
      case ROAD_INFO_PROVIDER:
        road_info_provider_config = new RoadInfoProviderConfig();
        break;
      case ILC_CORRIDOR_BUILDER:
        ilc_corridor_builder_config = new ILCCorridorBuilderConfig();
      default:
        break;
      }
      
  }
  
  ~DynamicConfig(){
      switch (config_type_)
      {
      case BOUNDARY_BUILDER:
        delete boundary_builder_config ;
        break;
      case CORRIDOR_BUILDER:
        delete corridor_builder_config ;
        break;
      case OBJECT_ASSIGNMENT_BUILDER:
        delete object_assignment_builder_config ;
        break;
      case ROAD_INFO_PROVIDER:
        delete road_info_provider_config;
        break;
      case ILC_CORRIDOR_BUILDER:
        delete ilc_corridor_builder_config;
        break;
      default:
        break;
      }
  }
  ConfigType config_type() const{return config_type_;}
  ConfigType config_type_ ;
  union {
    BoundaryBuilderConfig* boundary_builder_config ;
    CorridorBuilderConfig* corridor_builder_config ;
    ObjectAssignmentBuilderConfig* object_assignment_builder_config;
    RoadInfoProviderConfig*  road_info_provider_config;
    ILCCorridorBuilderConfig* ilc_corridor_builder_config;
  };
};

}