/*
 * @Author: your name
 * @Date: 2022-03-19 01:39:29
 * @LastEditTime: 2022-03-21 19:31:29
 * @LastEditors: Please set LastEditors
 * @Description: 打开koroFileHeader查看配置 进行设置:
 * https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 * @FilePath: /roadmodel/mpc_drv_ctap_rm/core/config/global_parameters.cpp
 */
#include "global_parameters.h"
#include <cmath>
namespace rm {
extern const uint32_t SOFTWAREVERSION = Hex2Dec("68a7a08d");
extern const double PI = 3.14159265;
extern const double ROADMODELCYCLEINS = 0.04; // s
extern const double ROADMODELCYCLEINMS = 40;  // ms
extern const double DEG2RAD = 0.01745329;
extern const double RAD2DEG = 57.29577951;
extern const double KPH2MPS = 0.27777778;
extern const double MPS2KPH = 3.6;
extern const double UNLADENWEIGHT = 2205;                  // kg
extern const double WEIGHT = 2205 + 2 * 80 + 100;          // 2 person plus load
extern const double WHEELBASE = 2.947;                     // m
extern const double DISFRONTAXEL2COG = 1.5278;             // m
extern const double DISREARAXEL2COG = 1.4192;              // m
extern const double FRONTCONERSTIFFNESS = 84900 * 2 * 0.9; // N/rad
extern const double REARCONERSTIFFNESS = 84900 * 2;        // N/rad
extern const double WIDTH = 1.926;                         // m
extern const double LENGTH = 4.895;                        // m
extern const double DISREARAXEL2FRONT = 3.921;             // m   TBD
extern const double DISREARAXEL2BACK = 0.974;              // m   TBD
extern const double MOMENTOFINERTIA =
    0.1269 * WEIGHT * WHEELBASE * LENGTH; // kg m^2
extern const double STEERWHL2WHlRATIO = 1 / 14.2;
extern const float MINCORRIDORRANGE =
    8.0F; // minimum range for corridor generation
extern const uint16_t CORRIDORSTACKEDPOINTMAXSIZE = 200U;
extern const uint16_t CORRIDORSTACKEDPOINTMINSIZE = 10U;

uint32_t CRC32(const std::string &in_str) {
    std::bitset<32> Crc(4294967295); //"FFFFFFFF"
    for (auto &ele : in_str) {
        std::bitset<32> byte(ele);
        size_t lookup_idx(((Crc ^ byte) & CRC_HALF_BYTE_MASK).to_ulong());
        Crc = (Crc >> CRC_HALF_BYTE_SHIFT);
        Crc = (Crc) ^ (lookup.at(lookup_idx));
        lookup_idx = (Crc ^ (byte >> CRC_HALF_BYTE_SHIFT)).to_ulong();
        lookup_idx = (lookup_idx & (CRC_HALF_BYTE_MASK.to_ulong()));
        Crc = (Crc >> CRC_HALF_BYTE_SHIFT) ^ (lookup.at(lookup_idx));
    }
    Crc = (Crc ^ CRC_CRC32_XOR_VAL);
    return static_cast<uint32_t>(Crc.to_ulong());
}
uint32_t Hex2Dec(const std::string &in_str) {
    uint32_t res(0);
    for (size_t ii = 0; ii < in_str.size(); ii++) {
        int number = 0;
        if (in_str.at(ii) >= '0' && in_str.at(ii) <= '9') {
            number = in_str.at(ii) - '0';
        } else if (in_str.at(ii) >= 'a' && in_str.at(ii) <= 'f') {
            number = in_str.at(ii) - 'a' + 10;
        } else if (in_str.at(ii) >= 'A' && in_str.at(ii) <= 'F') {
            number = in_str.at(ii) - 'A' + 10;
        }
        res += static_cast<uint32_t>(number * std::pow(16, (in_str.size() - ii - 1)));
    }
    return res;
    
}
} // namespace rm
