/*
 * @Author: your name
 * @Date: 2022-03-19 01:31:10
 * @LastEditTime: 2022-03-21 19:34:49
 * @LastEditors: Please set LastEditors
 * @Description: 打开koroFileHeader查看配置 进行设置:
 * https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 * @FilePath: /roadmodel/mpc_drv_ctap_rm/core/config/parameter.h
 */
#pragma once

#include <stdint.h>
#include <array>
#include <bitset>
namespace rm {

extern const uint32_t SOFTWAREVERSION;
extern const double PI;
extern const double ROADMODELCYCLEINS;
extern const double ROADMODELCYCLEINMS;
extern const double DEG2RAD;
extern const double RAD2DEG;
extern const double KPH2MPS;
extern const double MPS2KPH;
extern const double UNLADENWEIGHT;
extern const double WEIGHT;
extern const double WHEELBASE;
extern const double DISFRONTAXEL2COG;
extern const double DISREARAXEL2COG;
extern const double FRONTCONERSTIFFNESS;
extern const double REARCONERSTIFFNESS;
extern const double MOMENTOFINERTIA;
extern const double WIDTH;
extern const double LENGTH;
extern const double DISREARAXEL2FRONT;
extern const double DISREARAXEL2BACK;
extern const double STEERRATIO;
extern const float MINCORRIDORRANGE;
extern const uint16_t CORRIDORSTACKEDPOINTMAXSIZE;
extern const uint16_t CORRIDORSTACKEDPOINTMINSIZE;

const std::bitset<32> CRC_CRC32_XOR_VAL(4294967295); //"FFFFFFFF"
const std::bitset<32> CRC_HALF_BYTE_MASK(15); //"F"
const size_t CRC_HALF_BYTE_SHIFT(4);
const std::array<std::bitset<32>, 16> lookup({
    //'00000000 ', '1DB71064 ', '3B6E20C8 ', '26D930AC ',
    0, 498536548, 997073096, 651767980,
    // '76DC4190 ', '6B6B51F4 ', '4DB26158 ', '5005713C ',
    1994146192, 1802195444, 1303535960, 1342533948,
    // 'EDB88320 ', 'F00F9344 ', 'D6D6A3E8 ', 'CB61B38C ',
    3988292384, 4027552580, 4027552580, 3412177804,
    // '9B64C2B0 ', '86D3D2D4 ', 'A00AE278 ', 'BDBDF21C '
    2607071920, 2262029012, 2685067896, 3183342108});
uint32_t CRC32(const std::string &in_str);
uint32_t Hex2Dec(const std::string &in_str);
} // namespace rm
