/*
 * @Author: your name
 * @Date: 2022-03-08 17:48:26
 * @LastEditTime: 2022-03-21 19:32:50
 * @LastEditors: Please set LastEditors
 * @Description: 打开koroFileHeader查看配置 进行设置:
 * https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 * @FilePath:
 * /dev_roadmodel_ros2/src/mpc_drv_ctAp_rm/src/mpc_drv_ctAp_rm_node.cpp
 */
#include <chrono>
#include <climits>
#include <cstdio>
#include <iostream>
#include <memory>
#include <string>

#ifdef RVIZ
#include "rm_rviz_display.h"
#endif

#include "adapter_output.h"
// #include "ats_node.h"
#include "ats_output_switch.h"
// #include "cem_interfaces/msg/map_scene.hpp"
// #include "cem_interfaces/msg/traffic_participant_struct.hpp"
#include "dpc/impl_type_trafficparticipantstruct.h"
// #include "cem_interfaces/msg/traffic_road_edge_struct.hpp"
// #include "cem_interfaces/msg/traffic_road_struct.hpp"
#include "dpc/impl_type_slam_road_model.h"
#include "counter_calculator.h"
#include "dependency_injector.h"
#include "gflags.h"
#include "global_parameters.h"
// #include "loc_msgs/msg/odometry.hpp"
#include "dpc/impl_type_slam_odometry.h"
#include "local_view.h"
#include "logging.h"
// #include "mpc_drv_msgs/msg/msg_sm2_trpc.hpp"
// #include "mpc_drv_msgs/msg/rmsm_message.hpp"
#include "dpc/impl_type_rmsmmessage.h"
// #include "mpc_drv_msgs/msg/road_info.hpp"
#include "dpc/impl_type_roadinfo.h"
// #include "mpc_drv_msgs/msg/sm_waypoints.hpp"
// #include "mpc_drv_msgs/msg/targets_info.hpp"
#include "dpc/impl_type_targetsinfo.h"
// #include "mpc_drv_msgs/msg/vehicle_state_output.hpp"
#include "dpc/impl_type_ved4dpc.h"
// #include "nav_msgs/msg/occupancy_grid.hpp"
#include "polynom_line.h"
// #include "rclcpp/rclcpp.hpp"
#include "road_model.h"
#include "road_model_gflags.h"
#include "ros2_dynamic_config.h"
#include "ros_recv.h"
#include "update_local_view.h"
#include "int_test.h"
#include "../wrappers/EM_GeneralWrapper.h"
#include "ara/log/logging.h"

// #include "vehicle_msgs/msg/ap_ibs20ms_pdu15.hpp"
// #include "vehicle_msgs/msg/ap_sas10ms_pdu00.hpp"
// #include "vehicle_msgs/msg/can_copy_cp2_ap10ms_struct.hpp"
// #include "vehicle_msgs/msg/can_copy_cp2_ap20ms_struct.hpp"
// #include "vehicle_msgs/msg/can_copy_cp2_ap50ms_struct.hpp"

#define TIMERSTART(tag) \
    auto tag##_start = std::chrono::steady_clock::now(), tag##_end = tag##_start
#define TIMEREND(tag) tag##_end = std::chrono::steady_clock::now()
#define DURATION_ms(tag)                                               \
    std::chrono::duration_cast<std::chrono::milliseconds>(tag##_end -  \
                                                          tag##_start) \
        .count()

// #define ROADMODELCYCLE 40

using namespace rm;

int main(int argc, char **argv)
{
    //	setup_test();
    /*******************glog初始化*******************/
    ara::log::InitLogging("DPC", "EM_TEST", ara::log::LogLevel::kVerbose, (ara::log::LogMode::kConsole | ara::log::LogMode::kRemote));
    ara::log::Logger &mainLog{ara::log::CreateLogger("main", "EM context", ara::log::LogLevel::kVerbose)};
    mainLog.LogInfo() << "EM data...";
    GeneralWrapper gw(mainLog);

    google::InitGoogleLogging(argv[0]); // google的日志库

    FLAGS_logtostderr = false;     // true: 设置日志消息转到标准输出 而不是日志文件
    FLAGS_colorlogtostderr = true; // true: log为彩色
    //   FLAGS_max_log_size = 100; // true: 设置最大日志文件大小（以MB为单位）
    const char *dir = FLAGS_selflog_dir.c_str();
    if (access(dir, 0) == -1)
        mkdir(dir, 00700);             // 判断文件夹是否存在 若不存在则创建
    FLAGS_log_dir = FLAGS_selflog_dir; // 有此句才可以输出日志文件
    FLAGS_v = 4;                       // 设置clog的输出级别 ADEBUG的级别是4 FLAGS_v小于4时不打印ADEBUG
    // 设置特定严重级别的日志的输出目录和前缀。第一个参数为日志级别，第二个参数表示输出目录及日志文件名前缀
    google::SetLogDestination(google::GLOG_INFO,
                              (FLAGS_selflog_dir + "INFO_").c_str());
    google::SetLogDestination(google::GLOG_WARNING,
                              (FLAGS_selflog_dir + "WARNING_").c_str());
    google::SetLogDestination(google::GLOG_ERROR,
                              (FLAGS_selflog_dir + "ERROR_").c_str());
    google::SetLogDestination(google::GLOG_FATAL,
                              (FLAGS_selflog_dir + "FATAL_").c_str());
    google::SetLogFilenameExtension(".log");
    /*******************ros初始化*******************/
    //   rclcpp::init(argc, argv);
    //   rclcpp::executors::MultiThreadedExecutor executor(rclcpp::ExecutorOptions(),
    //                                                     5);

    //   auto road_model_node = std::make_shared<rclcpp::Node>("mpc_drv_ctAp_rm");

    //   std::shared_ptr<Ros2DynamicConfig> rm_config_ptr =
    //       std::make_shared<Ros2DynamicConfig>(road_model_node);

    RosRecv<dpc::VED4DPC> vehicle_state_recv(
        "mpc_interface_drv_vse_p0010ms_vseinfo");
    RosRecv<dpc::slam_road_model> traffic_road_recv(
        "cem/fusion/traffic_road");
    RosRecv<dpc::RoadEdge> traffic_road_edge_recv(
        "cem/fusion/edge");
//    RosRecv<dpc::TrafficParticipantStruct>
//        traffic_participant_recv("cem/fusion/objects");
    RosRecv<dpc::Object>
            traffic_participant_recv("cem/fusion/objects");

    // RosRecv<nav_msgs::msg::OccupancyGrid> freespace_recv("cem/fusion/freespace");
    RosRecv<dpc::slam_odometry> odometry_recv("/cem/loc/odom_dr");
    // RosRecv<mpc_drv_msgs::msg::SMWaypoints> sm_waypoints_recv(
    //     "mpc_interface_drv_ehr_p0050ms_ehr2rm");
    // RosRecv<cem_interfaces::msg::MapScene> ehr_mapscene_recv("cem/ehr/map_scene");
    // RosRecv<vehicle_msgs::msg::CanCopyCp2Ap50msStruct> cp2ap50ms_recv(
    //     "mpc_cp2ap_50ms_CanCopyCp2Ap50msStruct");
    // RosRecv<vehicle_msgs::msg::CanCopyCp2Ap20msStruct> cp2ap20ms_recv(
    //     "mpc_cp2ap_20ms_CanCopyCp2Ap20msStruct");
    // RosRecv<vehicle_msgs::msg::CanCopyCp2Ap10msStruct> cp2ap10ms_recv(
    //     "mpc_cp2ap_10ms_CanCopyCp2Ap10msStruct");
    // RosRecv<vehicle_msgs::msg::ApIbs20msPdu15> apibs20mspdu15_recv(
    //     "mpc_cp2ap_ApIbs20msPdu15");
    // RosRecv<vehicle_msgs::msg::ApSas10msPdu00> apsas10mspdu00_recv(
    //     "mpc_cp2ap_ApSas10msPdu00");
    // RosRecv<mpc_drv_msgs::msg::MsgSM2TRPC> sm_info_recv(
    //     "mpc_interface_drv_sm_p0010ms_sminfo");

    //   auto subopt = rclcpp::SubscriptionOptions();
    //   subopt.callback_group = road_model_node->create_callback_group(
    //       rclcpp::CallbackGroupType::Reentrant);
    // TODO sub/pub method on new platform
    //   auto vehiclestateoutput_sub =
    //       road_model_node
    //           ->create_subscription<mpc_drv_msgs::msg::VehicleStateOutput>(
    //               vehicle_state_recv.topic_, rclcpp::QoS(2),
    //               std::bind(
    //                   &RosRecv<mpc_drv_msgs::msg::VehicleStateOutput>::Callback,
    //                   &vehicle_state_recv, std::placeholders::_1),
    //               subopt);
    //   auto trafficroadstruct_sub =
    //       road_model_node
    //           ->create_subscription<cem_interfaces::msg::TrafficRoadStruct>(
    //               traffic_road_recv.topic_, rclcpp::QoS(2),
    //               std::bind(
    //                   &RosRecv<cem_interfaces::msg::TrafficRoadStruct>::Callback,
    //                   &traffic_road_recv, std::placeholders::_1),
    //               subopt);
    //   auto trafficroadedgestruct_sub = road_model_node->create_subscription<
    //       cem_interfaces::msg::TrafficRoadEdgeStruct>(
    //       traffic_road_edge_recv.topic_, rclcpp::QoS(2),
    //       std::bind(&RosRecv<cem_interfaces::msg::TrafficRoadEdgeStruct>::Callback,
    //                 &traffic_road_edge_recv, std::placeholders::_1),
    //       subopt);
    //   auto trafficparticipantstruct_sub = road_model_node->create_subscription<
    //       cem_interfaces::msg::TrafficParticipantStruct>(
    //       traffic_participant_recv.topic_, rclcpp::QoS(2),
    //       std::bind(
    //           &RosRecv<cem_interfaces::msg::TrafficParticipantStruct>::Callback,
    //           &traffic_participant_recv, std::placeholders::_1),
    //       subopt);
    //   auto freespace_sub =
    //       road_model_node->create_subscription<nav_msgs::msg::OccupancyGrid>(
    //           freespace_recv.topic_, rclcpp::QoS(2),
    //           std::bind(&RosRecv<nav_msgs::msg::OccupancyGrid>::Callback,
    //                     &freespace_recv, std::placeholders::_1),
    //           subopt);
    //   auto odometry_sub =
    //       road_model_node->create_subscription<loc_msgs::msg::Odometry>(
    //           odometry_recv.topic_, rclcpp::QoS(2),
    //           std::bind(&RosRecv<loc_msgs::msg::Odometry>::Callback, &odometry_recv,
    //                     std::placeholders::_1),
    //           subopt);
    //   auto ehrmapscene_sub =
    //       road_model_node->create_subscription<cem_interfaces::msg::MapScene>(
    //           ehr_mapscene_recv.topic_, rclcpp::QoS(2),
    //           std::bind(&RosRecv<cem_interfaces::msg::MapScene>::Callback,
    //                     &ehr_mapscene_recv, std::placeholders::_1),
    //           subopt);
    //   auto smwaypoints_sub =
    //       road_model_node->create_subscription<mpc_drv_msgs::msg::SMWaypoints>(
    //           sm_waypoints_recv.topic_, rclcpp::QoS(2),
    //           std::bind(&RosRecv<mpc_drv_msgs::msg::SMWaypoints>::Callback,
    //                     &sm_waypoints_recv, std::placeholders::_1),
    //           subopt);
    //   auto cp2ap50m_sub =
    //       road_model_node
    //           ->create_subscription<vehicle_msgs::msg::CanCopyCp2Ap50msStruct>(
    //               cp2ap50ms_recv.topic_, rclcpp::QoS(2),
    //               std::bind(
    //                   &RosRecv<vehicle_msgs::msg::CanCopyCp2Ap50msStruct>::Callback,
    //                   &cp2ap50ms_recv, std::placeholders::_1),
    //               subopt);
    //   auto cp2ap20ms_sub =
    //       road_model_node
    //           ->create_subscription<vehicle_msgs::msg::CanCopyCp2Ap20msStruct>(
    //               cp2ap20ms_recv.topic_, rclcpp::QoS(2),
    //               std::bind(
    //                   &RosRecv<vehicle_msgs::msg::CanCopyCp2Ap20msStruct>::Callback,
    //                   &cp2ap20ms_recv, std::placeholders::_1),
    //               subopt);
    //   auto cp2ap10ms_sub =
    //       road_model_node
    //           ->create_subscription<vehicle_msgs::msg::CanCopyCp2Ap10msStruct>(
    //               cp2ap10ms_recv.topic_, rclcpp::QoS(2),
    //               std::bind(
    //                   &RosRecv<vehicle_msgs::msg::CanCopyCp2Ap10msStruct>::Callback,
    //                   &cp2ap10ms_recv, std::placeholders::_1),
    //               subopt);
    //   auto apibs20mspdu15_sub =
    //       road_model_node->create_subscription<vehicle_msgs::msg::ApIbs20msPdu15>(
    //           apibs20mspdu15_recv.topic_, rclcpp::QoS(2),
    //           std::bind(&RosRecv<vehicle_msgs::msg::ApIbs20msPdu15>::Callback,
    //                     &apibs20mspdu15_recv, std::placeholders::_1),
    //           subopt);
    //   auto apsas10mspdu00_sub =
    //       road_model_node->create_subscription<vehicle_msgs::msg::ApSas10msPdu00>(
    //           apsas10mspdu00_recv.topic_, rclcpp::QoS(2),
    //           std::bind(&RosRecv<vehicle_msgs::msg::ApSas10msPdu00>::Callback,
    //                     &apsas10mspdu00_recv, std::placeholders::_1),
    //           subopt);
    //   auto sminfo_sub =
    //       road_model_node->create_subscription<mpc_drv_msgs::msg::MsgSM2TRPC>(
    //           sm_info_recv.topic_, rclcpp::QoS(2),
    //           std::bind(&RosRecv<mpc_drv_msgs::msg::MsgSM2TRPC>::Callback,
    //                     &sm_info_recv, std::placeholders::_1),
    //           subopt);
    //   auto slaminfo_sub =
    //       road_model_node->create_subscription<rm_interface::slam_road_model>(
    //           slaminfo_sub.topic_, rclcpp::QoS(2),
    //           std::bind(&RosRecv<rm_interface::slam_road_model>::Callback,
    //                     &slaminfo_sub, std::placeholders::_1),
    //           subopt);
    //   auto rmsmmessage_pub =
    //       road_model_node->create_publisher<mpc_drv_msgs::msg::RMSMMessage>(
    //           rm_config_ptr->Get_rm2sm_topic(), rclcpp::QoS(1));
    //   auto roadinfo_pub =
    //       road_model_node->create_publisher<mpc_drv_msgs::msg::RoadInfo>(
    //           rm_config_ptr->Get_rm2ba_topic(), rclcpp::QoS(1));
    //   auto targetsinfo_pub =
    //       road_model_node->create_publisher<mpc_drv_msgs::msg::TargetsInfo>(
    //           rm_config_ptr->Get_rm2trplon_topic(), rclcpp::QoS(1));
    // #ifdef RVIZ
    //   auto marker_pub =
    //       road_model_node->create_publisher<visualization_msgs::msg::Marker>(
    //           "viz/mpc_drv_ctap_rm/rm_corridor", rclcpp::QoS(100));
    //   auto marker_arr_pub =
    //       road_model_node->create_publisher<visualization_msgs::msg::MarkerArray>(
    //           "viz/mpc_drv_ctap_rm/rm_boundary", rclcpp::QoS(100));
    //   auto debug_string_pub =
    //       road_model_node->create_publisher<visualization_msgs::msg::Marker>(
    //           "viz/mpc_drv_ctap_rm/rm_debug", rclcpp::QoS(100));
    // #endif

    //   executor.add_node(road_model_node);

    //   auto spin_thread = std::thread([&executor]() { executor.spin(); });
    std::shared_ptr<DependencyInjector> injector =
        std::make_shared<DependencyInjector>(); // TODO（ningmeng) :依赖注入
                                                // 存历史数据
    RoadModel road_model(injector);             // 最大的信息处理类
    LocalView local_view;                       // 获取输入信息
    common::CounterCalculator counter_calculator{};

    //  CHECK(road_model.Init().ok()) << "Failed to init rm module"; //初始化
    road_model.Init();
    // ACC_Target_Selection::Node ats_adaptor(/*road_model_node*/);
    uint32_t ats_pedestrain_id(0);
    dpc::Corridor ats_corridor;
    dpc::TargetsInfo ats_targetsinfo;

    dpc::RoadInfo road_info;
    dpc::RMSMMessage rm_sm_msg;
    dpc::TargetsInfo targets_info;
    dpc::TargetsInfo rm_targets_info;

    // required
    dpc::position position;
    dpc::attribute attribute;
    dpc::line_point linePoint;
    dpc::line line;
    dpc::speed_limit speedLimit;
    dpc::traffic_object trafficObject;
    dpc::Lane lane;

    // provided
    dpc::TargetsInfo targetsInfo;
    dpc::TargetInfo targetInfo;
    dpc::RoadEdgeInfo roadEdgeInfo;
    dpc::LaneMarkerInfo laneMarkerInfo;
    dpc::RMHeader rmHeader;
    dpc::Index index;
    dpc::CarPosition carPosition;
    dpc::Lane lane_provide;
    dpc::LaneMarker laneMarker;
    dpc::Object object;
    dpc::RoadEdge roadEdge;
    dpc::NeighborLane neighborLane;
    dpc::SamplingPoint samplingPoint;
    dpc::LineColor lineColor;
    dpc::LineType lineType;
    dpc::ObjectLocation objectLocation;
    dpc::SLPoint slPoint;
    dpc::LaneControl laneControl;
    dpc::LaneBoundary laneBoundary;
    dpc::LineGeometry lineGeometry;
    dpc::RoadEdgeSegment roadEdgeSegment;
    dpc::LaneInfo laneInfo;
    dpc::LeftLine leftLine;
    dpc::RightLine rightLine;
    dpc::RightRoadEdge rightRoadEdge;
    dpc::LeftRoadEdge leftRoadEdge;
    dpc::ODDInfo oddInfo;
    dpc::RMEgoLftLnegeometry rmEgoLftLineGeometry;
    dpc::RMEgoRgtLnegeometry rmEgoRgtLineGeometry;
    dpc::RMRdEdgeLftgeometry rmrdEdgeLftGeometry;
    dpc::RMRdEdgeRgtgeometry rmrdEdgeRgtGeometry;


    while (/*rclcpp::ok()*/ true)
    {
        TIMERSTART(rm);

        //    //Requireds
        gw._SLAM2EMposition_Required.s.GetData(position);
        gw._SLAM2EMattribute_Required.s.GetData(attribute);
        gw._SLAM2EMline_point_Required.s.GetData(linePoint);
        gw._SLAM2EMline_Required.s.GetData(line);
        gw._SLAM2EMspeed_limit_Required.s.GetData(speedLimit);
        gw._SLAM2EMtraffic_object_Required.s.GetData(trafficObject);
        gw._SLAM2EMlane_Required.s.GetData(lane);
        gw._SLAM2EMroad_edge_Required.s.GetData(traffic_road_edge_recv.data_);
        gw._SLAM2EMslam_road_model_Required.s.GetData(traffic_road_recv.data_);
        gw._FusionObjects_Required.s.GetData(traffic_participant_recv.data_);

        //    UpdateLocalView(local_view, traffic_road_recv, /*traffic_road_edge_recv,*/
        //                    traffic_participant_recv, vehicle_state_recv,
        //                    /*sm_waypoints_recv, freespace_recv,*/ odometry_recv/*,
        //                    cp2ap50ms_recv, cp2ap20ms_recv, cp2ap10ms_recv,
        //                    apibs20mspdu15_recv, apsas10mspdu00_recv, sm_info_recv,
        //                    ehr_mapscene_recv*/);

        // std::cout << "I am running" << std::endl;
        // printf("%s, %d\n", __FUNCTION__, __LINE__);
        //     road_model.RunOnce(local_view, &road_info, &rm_sm_msg, &rm_targets_info);
        // printf("%s, %d\n", __FUNCTION__, __LINE__);
        // FIXME get the real timestamp
        // ats_adaptor.Run(/*road_model_node->get_clock()->now().nanoseconds()*/ 0,
        //                 local_view, road_info, ats_corridor, ats_targetsinfo,
        //                 ats_pedestrain_id);

        // ATSOutputSwitch::Instance()->RunAtsOutputSwitch(
        //     road_info, rm_sm_msg, rm_targets_info, ats_corridor, ats_targetsinfo,
        //     targets_info, road_model.mutable_frame(), ats_pedestrain_id);
        uint16_t rm_cyclecounter = counter_calculator.RunCounterCalculator();
        road_info.rm_header.cyclecounter = rm_cyclecounter;
        rm_sm_msg.rm_header.cyclecounter = rm_cyclecounter;
        targets_info.cyclecounter = rm_cyclecounter;
        road_info.rm_header.software_version = rm::SOFTWAREVERSION;
        // TODO using the real timestamp
        targets_info.timestamp = 0;
        road_info.rm_header.timestamp = 0;
        rm_sm_msg.rm_header.timestamp = 0;
        // targets_info.set__timestamp(
        //     road_model_node->get_clock()->now().nanoseconds());
        // road_info.rm_header.set__timestamp(
        //     road_model_node->get_clock()->now().nanoseconds());
        // rm_sm_msg.rm_header.set__timestamp(
        //     road_model_node->get_clock()->now().nanoseconds());

        // rm_sm_msg.float_reserve.at(6) =
        //     VehicleStateProvider::Instance()->driving_curvature();
        // rm_sm_msg.float_reserve.at(7) = ats_targetsinfo.iv.indx_tgtid;
        // rm_sm_msg.float_reserve.at(8) =
        //     VehicleStateProvider::Instance()->driving_curvature() -
        //     2.0 * road_info.lane_list.at(0).corridor_list.at(0).reference_line.c2;
        // rm_sm_msg.float_reserve.at(9) =
        //     road_model.mutable_frame()->ats_switch_state();

        // roadinfo_pub->publish(road_info);
        // rmsmmessage_pub->publish(rm_sm_msg);
        // targetsinfo_pub->publish(targets_info);
        //
        DLOG(INFO) << PRINT(targets_info.iv.indx_tgtid);

        // #ifdef RVIZ
        //     rm_rviz_display(road_info, targets_info, road_model_node, road_model,
        //                     marker_pub, marker_arr_pub, debug_string_pub);
        // #endif

        TIMEREND(rm);
        if (DURATION_ms(rm) > rm::ROADMODELCYCLEINMS)
        {
            std::cout << "------------the program is running in low "
                         "frequency-----------,    delta_time = "
                      << DURATION_ms(rm) << std::endl;
        }
        else
        {
            sleep((ROADMODELCYCLEINMS - DURATION_ms(rm)) * 0.001);
            //   rclcpp::sleep_for(std::chrono::milliseconds(
            //       static_cast<long>(ROADMODELCYCLEINMS - DURATION_ms(rm))));
        }
        // executor.spin_some();


        gw._EM2TRPCLongTargetsInfo_Provide.s.SetData(targetsInfo);
        gw._EM2TRPCLongTargetsInfo_Provide.Publish();
        gw._EM2TRPCLongTargetInfo_Provide.s.SetData(targetInfo);
        gw._EM2TRPCLongTargetInfo_Provide.Publish();
        gw._EM2TRPCLongRoadEdgeInfo_Provide.s.SetData(roadEdgeInfo);
        gw._EM2TRPCLongLaneMarkerInfo_Provide.s.SetData(laneMarkerInfo);
        gw._EM2DMRoadInfo_Provide.s.SetData(road_info);
        gw._EM2DMRoadInfo_Provide.Publish();


        gw._EM2DMRMHeader_Provide.s.SetData(rmHeader);
        gw._EM2DMRMHeader_Provide.Publish();
        gw._EM2DMIndex_Provide.s.SetData(index);
        gw._EM2DMIndex_Provide.Publish();
        gw._EM2DMCarPosition_Provide.s.SetData(carPosition);
        gw._EM2DMCarPosition_Provide.Publish();
        gw._EM2DMLane_Provide.s.SetData(lane_provide);
        gw._EM2DMLane_Provide.Publish();
        gw._EM2DMLaneMarker_Provide.s.SetData(laneMarker);
        gw._EM2DMLaneMarker_Provide.Publish();
        gw._EM2DMObject_Provide.s.SetData(object);
        gw._EM2DMObject_Provide.Publish();
        gw._EM2DMRoadEdge_Provide.s.SetData(roadEdge);
        gw._EM2DMRoadEdge_Provide.Publish();
        gw._EM2DMNeighborLane_Provide.s.SetData(neighborLane);
        gw._EM2DMNeighborLane_Provide.Publish();
        gw._EM2DMCorridor_Provide.s.SetData(ats_corridor); ///
        gw._EM2DMCorridor_Provide.Publish();
        gw._EM2DMSamplingPoint_Provide.s.SetData(samplingPoint);
        gw._EM2DMSamplingPoint_Provide.Publish();
        gw._EM2DMLineColor_Provide.s.SetData(lineColor);
        gw._EM2DMLineColor_Provide.Publish();
        gw._EM2DMLineType_Provide.s.SetData(lineType);
        gw._EM2DMLineType_Provide.Publish();
        gw._EM2DMObjectLocation_Provide.s.SetData(objectLocation);
        gw._EM2DMObjectLocation_Provide.Publish();
        gw._EM2DMSLPoint_Provide.s.SetData(slPoint);
        gw._EM2DMSLPoint_Provide.Publish();
        gw._EM2DMLaneControl_Provide.s.SetData(laneControl);
        gw._EM2DMLaneControl_Provide.Publish();
        gw._EM2DMLaneBoundary_Provide.s.SetData(laneBoundary);
        gw._EM2DMLaneBoundary_Provide.Publish();
        gw._EM2DMLineGeometry_Provide.s.SetData(lineGeometry);
        gw._EM2DMLineGeometry_Provide.Publish();
        gw._EM2DMRoadEdgeSegment_Provide.s.SetData(roadEdgeSegment);
        gw._EM2DMRoadEdgeSegment_Provide.Publish();
        gw._EM2SMRMSMMessage_Provide.s.SetData(rm_sm_msg); ///
        gw._EM2SMRMSMMessage_Provide.Publish();
        gw._EM2SMLaneInfo_Provide.s.SetData(laneInfo);
        gw._EM2SMLaneInfo_Provide.Publish();
        gw._EM2SMLeftLine_Provide.s.SetData(leftLine);
        gw._EM2SMLeftLine_Provide.Publish();
        gw._EM2SMRightLine_Provide.s.SetData(rightLine);
        gw._EM2SMRightLine_Provide.Publish();
        gw._EM2SMRightRoadEdge_Provide.s.SetData(rightRoadEdge);
        gw._EM2SMRightRoadEdge_Provide.Publish();
        gw._EM2SMLeftRoadEdge_Provide.s.SetData(leftRoadEdge);
        gw._EM2SMLeftRoadEdge_Provide.Publish();
        gw._EM2SMODDInfo_Provide.s.SetData(oddInfo);
        gw._EM2SMODDInfo_Provide.Publish();
        gw._EM2SMRMEgoLftLnegeometry_Provide.s.SetData(rmEgoLftLineGeometry);
        gw._EM2SMRMEgoLftLnegeometry_Provide.Publish();
        gw._EM2SMRMEgoRgtLnegeometry_Provide.s.SetData(rmEgoRgtLineGeometry);
        gw._EM2SMRMEgoRgtLnegeometry_Provide.Publish();
        gw._EM2SMRMRdEdgeLftgeometry_Provide.s.SetData(rmrdEdgeLftGeometry);
        gw._EM2SMRMRdEdgeLftgeometry_Provide.Publish();
        gw._EM2SMRMRdEdgeRgtgeometry_Provide.s.SetData(rmrdEdgeRgtGeometry);
        gw._EM2SMRMRdEdgeRgtgeometry_Provide.Publish();
    }
    //   executor.cancel();
    //   spin_thread.join();
    //   rclcpp::shutdown();
    return 0;
}
