/*
 * @Description:
 * @version:
 * @Date: 2021-06-28 17:07:53
 * @LastEditors: Please set LastEditors
 * @LastEditTime: 2022-03-11 22:33:41
 */

#include <string>

#include "gflags.h"
#include "gtest.h"
#include "logging.h"
#include "road_model_gflags.h"

using namespace rm;

int main(int argc, char *argv[]) {
  // SaveRoadModelConfig();
  /**********Test和Log的初始化**********/
  testing::InitGoogleTest(&argc, argv);  // google的test库
  google::InitGoogleLogging(argv[0]);    // google的日志库

  /**********Test的相关设置**********/
  testing::GTEST_FLAG(filter) = "TestStateMachine.*";  //过滤 只测试这个test
  testing::GTEST_FLAG(repeat) = 1;                     //反复测试n次
  testing::GTEST_FLAG(catch_exceptions) = false;       //反复测试n次
  /**********Log的相关设置**********/
  FLAGS_logtostderr = false;  // true: 设置日志消息转到标准输出 而不是日志文件
  FLAGS_alsologtostderr =
      false;  // true: 设置日志消息除了日志文件之外也去标准输出
  FLAGS_colorlogtostderr = true;  // true: log为彩色
  FLAGS_max_log_size = 10;  // true: 设置最大日志文件大小（以MB为单位）
  FLAGS_log_dir = FLAGS_selflog_dir;  //有此句才可以输出日志文件
  FLAGS_v = 4;  //设置clog的输出级别 ADEBUG的级别是4 FLAGS_v小于4时不打印ADEBUG
  google::SetLogDestination(google::GLOG_INFO,
                            (FLAGS_selflog_dir + "INFO_").c_str());
  google::SetLogDestination(google::GLOG_WARNING,
                            (FLAGS_selflog_dir + "WARNING_").c_str());
  google::SetLogDestination(google::GLOG_ERROR,
                            (FLAGS_selflog_dir + "ERROR_").c_str());
  google::SetLogDestination(google::GLOG_FATAL,
                            (FLAGS_selflog_dir + "FATAL_").c_str());
  //设置特定严重级别的日志的输出目录和前缀。第一个参数为日志级别，第二个参数表示输出目录及日志文件名前缀
  google::SetLogFilenameExtension(".log");
  //输出日志
  // DLOG(INFO) << "info test";         // 会输出一个INFO日志    里面有DEBUG
  // VLOG INFO WARNING和ERROR DLOG(WARNING) << "warning test";   //
  // 会输出一个Warning日志 里面有 WARNING和ERROR DLOG(ERROR) << "error test"; //
  // 会输出一个Error日志   里面只有ERROR DLOG(FATAL) << "fatal test";       //
  // 最严重的错误 打印内容后就会终止程序
  // // ADEBUG << "adebug test";          // 这个命令并不是debug模式才会打印
  // CHECK(1)<<"check1";               // CHECK 为false时 报错并强制退出
  // CHECK(0)<<"check0";
  // VDLOG(20)<<"vlog test";
  /**********运形所有test后关闭log**********/
  RUN_ALL_TESTS();
  google::ShutdownGoogleLogging();  //关闭log服务 否则会内存溢出：

  return 0;
}
