#pragma once

#include <chrono>
#include <cmath>
#include <ctime>
#include <iostream>
#include <memory>
// #include <rclcpp/rclcpp.hpp>
#include <vector>
// #include <visualization_msgs/msg/marker.hpp>
// #include <visualization_msgs/msg/marker_array.hpp>

#include "freespace.h"
// #include "mpc_drv_msgs/msg/road_info.hpp"
#include "impl_type_roadinfo.h"
// #include "mpc_drv_msgs/msg/targets_info.hpp"
#include "impl_type_targetsinfo.h"
#include "odometry.h"
#include "road_model.h"
#include "ros_recv.h"
#include "vehicle_state_provider.h"
using namespace std;
// using namespace mpc_drv_msgs;
using namespace rm;
using namespace std::chrono_literals;

void gettimestr(time_t &time, tm *lotime, char *buf) {
  lotime = localtime(&time);
  strftime(buf, 64, "%Y:%m:%d %H:%M:%S", lotime);
}

// void rm_rviz_display(
//     const mpc_drv_msgs::msg::RoadInfo &road_info,
//     const mpc_drv_msgs::msg::TargetsInfo &targets_info,
//     rclcpp::Node::SharedPtr &road_model_node, RoadModel &road_model,
//     rclcpp::Publisher<visualization_msgs::msg::Marker>::SharedPtr &marker_pub,
//     rclcpp::Publisher<visualization_msgs::msg::MarkerArray>::SharedPtr
//         &marker_arr_pub,
//     rclcpp::Publisher<visualization_msgs::msg::Marker>::SharedPtr
//         &debug_string_pub) {
//   int k = 0;
//   visualization_msgs::msg::Marker corridor_model;
//   std::vector<visualization_msgs::msg::Marker> corridor; // line_list[2],
//   visualization_msgs::msg::MarkerArray line_list;
//   corridor_model.header.frame_id = "base_link";
//   corridor_model.header.stamp = road_model_node->now();
//   corridor_model.ns = "road_rviz";
//   // corridor_model.action = visualization_msgs::msg::Marker::ADD;
//   corridor_model.pose.orientation.w = 1.0;
//   corridor_model.type = visualization_msgs::msg::Marker::LINE_STRIP;
//   corridor_model.scale.x = 0.1;
//   //初始化颜色
//   corridor_model.color.g = 1.0;
//   corridor_model.color.a = 1.0;
//   corridor_model.lifetime = rclcpp::Duration::from_seconds(0.04);
//   for (auto lane : road_info.lane_list) {
//     std::vector<mpc_drv_msgs::msg::Corridor> cor;
//     cor.insert(cor.end(), lane.corridor_list.begin(), lane.corridor_list.end());
//     cor.insert(cor.end(), lane.back_corridor_list.begin(),
//                lane.back_corridor_list.end());
//     for (auto rm_corridor : cor) {
//       corridor_model.id = k + 100;
//       corridor.push_back(corridor_model);
//       mpc_drv_msgs::msg::LineGeometry line = rm_corridor.reference_line;
//       for (int x = line.start_range; x <= line.end_range; x = x + 1) {
//         geometry_msgs::msg::Point p;
//         p.x = x;
//         p.y = line.c0 + line.c1 * x + line.c2 * x * x + line.c3 * x * x * x;
//         p.z = 0;
//         corridor[k].points.push_back(p);
//       }
//       line_list.markers.emplace_back(corridor[k]);
//       k++;
//     }
//   }

//   // time stamp calculator
//   time_t t = targets_info.timestamp / 1e9;
//   tm *local;
//   char datetime_string[128] = {0};
//   gettimestr(t, local, datetime_string);

//   // line_list.markers.clear();
//   int cnt = 0;
//   for (auto lane_marker : road_info.lane_marker_list) {
//     std::vector<mpc_drv_msgs::msg::LaneBoundary> vec;
//     vec.insert(vec.end(), lane_marker.front_lane_boundary_list.begin(),
//                lane_marker.front_lane_boundary_list.end());
//     vec.insert(vec.end(), lane_marker.back_lane_boundary_list.begin(),
//                lane_marker.back_lane_boundary_list.end());

//     for (auto boundary : vec) {
//       // if(boundary.line_geometry.empty()) continue;
//       mpc_drv_msgs::msg::LineGeometry line = boundary.line_geometry;
//       visualization_msgs::msg::Marker marker_line;
//       //初始化
//       marker_line.header.frame_id = "base_link";
//       marker_line.header.stamp = road_model_node->now();
//       marker_line.ns = "road_rviz"; //命名空间
//       marker_line.action = visualization_msgs::msg::Marker::ADD;
//       marker_line.lifetime = rclcpp::Duration::from_seconds(0.04);

//       // switch (boundary.line_color) { //初始化颜色
//       // case mpc_drv_msgs::msg::LaneBoundary::LINECOLOR_WHITE: {
//       //   marker_line.color.r = 1.0;
//       //   marker_line.color.g = 1.0;
//       //   marker_line.color.b = 1.0;
//       //   marker_line.color.a = 1.0;
//       //   break;
//       // }
//       // case mpc_drv_msgs::msg::LaneBoundary::LINECOLOR_YELLOW: {
//       //   marker_line.color.r = 1.0;
//       //   marker_line.color.g = 153.0 / 255.0;
//       //   marker_line.color.b = 0.0;
//       //   marker_line.color.a = 1.0;
//       //   break;
//       // }
//       // default: {
//       marker_line.color.r = 1.0;
//       marker_line.color.g = 1.0;
//       marker_line.color.b = 1.0;
//       marker_line.color.a = 1.0;
//       // }
//       // }

//       // switch (boundary.line_type) { //初始化线型
//       // case mpc_drv_msgs::msg::LaneBoundary::LINETYPE_SOLID: {
//       //   marker_line.type = visualization_msgs::msg::Marker::LINE_STRIP;
//       //   //实线 break;
//       // }
//       // case mpc_drv_msgs::msg::LaneBoundary::LINETYPE_DASHED: {
//       //   marker_line.type = visualization_msgs::msg::Marker::LINE_LIST;
//       //   break;
//       // }
//       // default: {
//       marker_line.type = visualization_msgs::msg::Marker::LINE_LIST;
//       // }
//       // }

//       for (int x = line.start_range; x <= line.end_range; x++) {
//         geometry_msgs::msg::Point p;
//         p.x = x;
//         p.y = line.c0 + line.c1 * x + line.c2 * x * x + line.c3 * x * x * x;
//         p.z = 0;
//         marker_line.points.push_back(p);
//       }
//       marker_line.scale.x = 0.1; //初始化大小
//       marker_line.id = cnt;      //唯一ID
//       marker_line.lifetime = rclcpp::Duration::from_seconds(0.04);
//       marker_line.pose.orientation.w = 1.0;

//       if (marker_line.points.size() % 2 ==
//           1) // number of points should be a even number for LINE_LIST marker
//       {
//         marker_line.points.pop_back();
//       }

//       line_list.markers.emplace_back(marker_line);

//       cnt++;
//       // if (cnt > 1)
//       //     break;
//     }
//   }

//   for (auto road_edge : road_info.road_edge_list) {
//     for (auto road_edge_seg : road_edge.road_edge_segment_list) {
//       mpc_drv_msgs::msg::LineGeometry line = road_edge_seg.line_geometry;
//       visualization_msgs::msg::Marker marker_line;
//       //初始化
//       marker_line.header.frame_id = "base_link";
//       marker_line.header.stamp = road_model_node->now();
//       marker_line.ns = "road_rviz"; //命名空间
//       marker_line.action = visualization_msgs::msg::Marker::ADD;
//       marker_line.lifetime = rclcpp::Duration::from_seconds(0.04);
//       marker_line.color.r = 1.0;
//       marker_line.color.g = 1.0;
//       marker_line.color.a = 1.0;

//       marker_line.type = visualization_msgs::msg::Marker::LINE_STRIP;

//       for (int x = line.start_range; x <= line.end_range; x++) {
//         geometry_msgs::msg::Point p;
//         p.x = x;
//         p.y = line.c0 + line.c1 * x + line.c2 * x * x + line.c3 * x * x * x;
//         p.z = 0;
//         marker_line.points.push_back(p);
//       }
//       marker_line.scale.x = 0.1; //初始化大小
//       marker_line.id = cnt;      //唯一ID
//       marker_line.lifetime = rclcpp::Duration::from_seconds(0.04);
//       marker_line.pose.orientation.w = 1.0;

//       line_list.markers.emplace_back(marker_line);

//       cnt++;
//     }
//   }

//   // ============ Objects ===================
//   visualization_msgs::msg::Marker points;
//   points.header.frame_id = "base_link";
//   points.header.stamp = road_model_node->now();
//   points.ns = "road_rviz";
//   points.action = visualization_msgs::msg::Marker::ADD;
//   points.type = visualization_msgs::msg::Marker::POINTS;
//   points.scale.x = 1;
//   points.scale.y = 1;
//   points.scale.z = 1;
//   points.lifetime = rclcpp::Duration::from_seconds(0.04);
//   points.id = cnt + 10;

//   points.color.r = 1.0;
//   points.color.a = 1.0;

//   for (auto obj : road_info.object_list) {
//     geometry_msgs::msg::Point objpos;
//     objpos.z = 0;
//     objpos.x = obj.relative_center_x;
//     objpos.y = obj.relative_center_y;
//     points.points.push_back(objpos);
//   }

//   // marker_pub.publish(corridor);
//   marker_pub->publish(points);

//   // ============ Objects tags ===================
//   // in_corridor_id_list
//   std::map<uint32_t, mpc_drv_msgs::msg::SLPoint> in_corridor_id_list;

//   if (!road_info.lane_list.empty()) {
//     for (auto lane_elem : road_info.lane_list) {
//       if (lane_elem.start_id == road_info.car_position.ego_lane_id &&
//           !lane_elem.corridor_list.empty()) {
//         auto obj_in_cor_list =
//             lane_elem.corridor_list.front().object_in_corridor_list;
//         auto obj_out_cor_list =
//             lane_elem.corridor_list.front().relevant_object_corridor_list;
//         for (auto iter = obj_in_cor_list.begin(); iter != obj_in_cor_list.end();
//              ++iter) {
//           // iter->reference_point2corridor_frenet;
//           in_corridor_id_list.emplace(std::make_pair(
//               iter->object_id, iter->reference_point2corridor_frenet));
//         }
//       }
//     }
//   }

//   // ----- 2. Show objects tag
//   // -----------------------------------------------------------------
//   visualization_msgs::msg::MarkerArray marker_array_object_tag;
//   marker_array_object_tag.markers.clear();
//   uint32_t marker_id = 2000;
//   uint32_t iv_id = targets_info.iv.indx_tgtid;
//   uint32_t iiv_id = targets_info.iiv.indx_tgtid;
//   uint32_t riv_id = targets_info.riv.indx_tgtid;
//   uint32_t fiv_id = targets_info.flniv.indx_tgtid;
//   uint32_t fiiv_id = targets_info.flniiv.indx_tgtid;
//   uint32_t friv_id = targets_info.flnriv.indx_tgtid;
//   uint32_t siv_id = targets_info.slniv.indx_tgtid;
//   uint32_t siiv_id = targets_info.slniiv.indx_tgtid;
//   uint32_t sriv_id = targets_info.slnriv.indx_tgtid;
//   bool fiv_lc_flg = targets_info.flniv.is_tgtlnechgflag;
//   bool fiiv_lc_flg = targets_info.flniiv.is_tgtlnechgflag;
//   bool siv_lc_flg = targets_info.slniv.is_tgtlnechgflag;
//   bool siiv_lc_flg = targets_info.slniiv.is_tgtlnechgflag;
//   for (auto obj : road_info.object_list) {
//     visualization_msgs::msg::Marker marker_tag;

//     marker_tag.header.frame_id = "base_link";
//     marker_tag.header.stamp = road_model_node->now();
//     marker_tag.ns = "object_tag";
//     marker_tag.id = marker_id;
//     marker_tag.type = visualization_msgs::msg::Marker::TEXT_VIEW_FACING;

//     if (in_corridor_id_list.find(obj.object_id) != in_corridor_id_list.end()) {
//       marker_tag.text =
//           "In_Cor, s=" +
//           std::to_string(in_corridor_id_list.find(obj.object_id)->second.s) +
//           ",l=" +
//           std::to_string(in_corridor_id_list.find(obj.object_id)->second.l) +
//           "\n id: " + std::to_string(obj.object_id) +
//           ",dx: " + std::to_string(obj.relative_center_x) +
//           ",dy: " + std::to_string(obj.relative_center_y) +
//           ",h:" + std::to_string(obj.absolute_yawrate);
//       if (obj.object_id == iv_id)
//         marker_tag.text = marker_tag.text + ", IV";
//       if (obj.object_id == iiv_id)
//         marker_tag.text = marker_tag.text + ", IIV";
//       if (obj.object_id == riv_id)
//         marker_tag.text = marker_tag.text + ", RIV";
//       marker_tag.color.a = 1.0; // Don't forget to set the alpha!
//       marker_tag.color.r = 1.0;
//       marker_tag.color.g = 0.0;
//       marker_tag.color.b = 0.0;
//     } else {
//       marker_tag.text = "Out_Cor \n id: " + std::to_string(obj.object_id);
//       if (obj.object_id == fiv_id)
//         marker_tag.text = marker_tag.text + ", FIV" + " \n" +
//                           "lc: " + std::to_string(fiv_lc_flg);
//       if (obj.object_id == fiiv_id)
//         marker_tag.text = marker_tag.text + ", FIIV" + " \n" +
//                           "lc: " + std::to_string(fiiv_lc_flg);
//       if (obj.object_id == friv_id)
//         marker_tag.text = marker_tag.text + ", FRIV";
//       if (obj.object_id == siv_id)
//         marker_tag.text = marker_tag.text + ", SIV" + " \n" +
//                           "lc: " + std::to_string(siv_lc_flg);
//       if (obj.object_id == siiv_id)
//         marker_tag.text = marker_tag.text + ", SIIV" + " \n" +
//                           "lc: " + std::to_string(siiv_lc_flg);
//       if (obj.object_id == sriv_id)
//         marker_tag.text = marker_tag.text + ", SRIV";
//       marker_tag.color.a = 1.0; // Don't forget to set the alpha!
//       marker_tag.color.r = 0.0;
//       marker_tag.color.g = 1.0;
//       marker_tag.color.b = 0.0;
//     }

//     marker_tag.action = visualization_msgs::msg::Marker::MODIFY;
//     marker_tag.pose.position.x = obj.relative_center_x + 3.0;
//     marker_tag.pose.position.y = obj.relative_center_y;
//     marker_tag.pose.position.z = 0.0;
//     marker_tag.scale.x = 1;
//     marker_tag.scale.y = 1;
//     marker_tag.scale.z = 1;

//     marker_tag.lifetime = rclcpp::Duration::from_seconds(0.04);

//     marker_id++;
//     line_list.markers.emplace_back(marker_tag);
//   }
//   // ego veh state
//   visualization_msgs::msg::Marker ego_marker_tag;
//   ego_marker_tag.header.frame_id = "base_link";
//   ego_marker_tag.header.stamp = road_model_node->now();
//   ego_marker_tag.ns = "ego_tag";
//   ego_marker_tag.id = marker_id++;
//   ego_marker_tag.type = visualization_msgs::msg::Marker::TEXT_VIEW_FACING;
//   ego_marker_tag.text =
//       "velocity: " +
//       std::to_string(VehicleStateProvider::Instance()->lon_velocity()) + "\n" +
//       "yaw rate: " +
//       std::to_string(VehicleStateProvider::Instance()->yaw_rate()) + "\n" +
//       "str whl: " +
//       std::to_string(VehicleStateProvider::Instance()->steering_wheel_angle()) +
//       "\n" + "ts: " + std::string(datetime_string);
//   ego_marker_tag.color.a = 1.0; // Don't forget to set the alpha!
//   ego_marker_tag.color.r = 0.5;
//   ego_marker_tag.color.g = 0.5;
//   ego_marker_tag.color.b = 0.5;
//   ego_marker_tag.action = visualization_msgs::msg::Marker::MODIFY;
//   ego_marker_tag.pose.position.x = 0.0;
//   ego_marker_tag.pose.position.y = 0.0;
//   ego_marker_tag.pose.position.z = 0.0;
//   ego_marker_tag.scale.x = 1;
//   ego_marker_tag.scale.y = 1;
//   ego_marker_tag.scale.z = 1;
//   ego_marker_tag.lifetime = rclcpp::Duration::from_seconds(0.1);
//   line_list.markers.emplace_back(ego_marker_tag);

//   // Lane id marker
//   visualization_msgs::msg::MarkerArray marker_array_lane_tag;
//   marker_array_lane_tag.markers.clear();
//   for (auto lane : road_info.lane_list) {
//     if (lane.corridor_list.empty())
//       continue;
//     visualization_msgs::msg::Marker corridor_tag, left_marker_tag,
//         right_marker_tag;
//     corridor_tag.header.frame_id = left_marker_tag.header.frame_id =
//         right_marker_tag.header.frame_id = "base_link";
//     corridor_tag.header.stamp = left_marker_tag.header.stamp =
//         right_marker_tag.header.stamp = road_model_node->now();
//     corridor_tag.ns = left_marker_tag.ns = right_marker_tag.ns = "lane_tag";
//     corridor_tag.id = marker_id++;
//     left_marker_tag.id = marker_id++;
//     right_marker_tag.id = marker_id++;
//     corridor_tag.type = left_marker_tag.type = right_marker_tag.type =
//         visualization_msgs::msg::Marker::TEXT_VIEW_FACING;
//     corridor_tag.text = left_marker_tag.text = right_marker_tag.text =
//         std::to_string(lane.start_id);
//     corridor_tag.action = left_marker_tag.action = right_marker_tag.action =
//         visualization_msgs::msg::Marker::MODIFY;
//     corridor_tag.pose.position.x = right_marker_tag.pose.position.x = 0.0;
//     corridor_tag.pose.position.y =
//         static_cast<float>(lane.corridor_list.front().reference_line.c0);
//     corridor_tag.pose.position.z = left_marker_tag.pose.position.z =
//         right_marker_tag.pose.position.z = 0.0;
//     corridor_tag.color.a = 1.0; // Don't forget to set the alpha!
//     corridor_tag.color.r = 0.0;
//     corridor_tag.color.g = 1.0;
//     corridor_tag.color.b = 0.0;
//     corridor_tag.scale.x = left_marker_tag.scale.x = right_marker_tag.scale.x =
//         1;
//     corridor_tag.scale.y = left_marker_tag.scale.y = right_marker_tag.scale.y =
//         1;
//     corridor_tag.scale.z = left_marker_tag.scale.z = right_marker_tag.scale.z =
//         1;
//     corridor_tag.lifetime = left_marker_tag.lifetime =
//         right_marker_tag.lifetime = rclcpp::Duration::from_seconds(0.04);

//     for (auto lane_marker : road_info.lane_marker_list) {
//       if (lane_marker.front_lane_boundary_list.empty())
//         continue;
//       if (!lane.left_lane_marker_id_list.empty() &&
//           lane.left_lane_marker_id_list.front() == lane_marker.id) {
//         float length = lane_marker.front_lane_boundary_list.front()
//                            .line_geometry.end_range;
//         left_marker_tag.pose.position.x = length;
//         float y =
//             lane_marker.front_lane_boundary_list.front().line_geometry.c0 +
//             lane_marker.front_lane_boundary_list.front().line_geometry.c1 *
//                 length +
//             lane_marker.front_lane_boundary_list.front().line_geometry.c2 *
//                 length * length +
//             lane_marker.front_lane_boundary_list.front().line_geometry.c3 *
//                 length * length * length;
//         left_marker_tag.pose.position.y = static_cast<float>(y - 0.7);
//         left_marker_tag.color.a = 1.0; // Don't forget to set the alpha!
//         left_marker_tag.color.r = 1.0;
//         left_marker_tag.color.g = 0.0;
//         left_marker_tag.color.b = 1.0;
//         line_list.markers.emplace_back(left_marker_tag);
//       }
//       if (!lane.right_lane_marker_id_list.empty() &&
//           lane.right_lane_marker_id_list.front() == lane_marker.id) {
//         float length = lane_marker.front_lane_boundary_list.front()
//                            .line_geometry.end_range;
//         right_marker_tag.pose.position.x = length;
//         float y =
//             lane_marker.front_lane_boundary_list.front().line_geometry.c0 +
//             lane_marker.front_lane_boundary_list.front().line_geometry.c1 *
//                 length +
//             lane_marker.front_lane_boundary_list.front().line_geometry.c2 *
//                 length * length +
//             lane_marker.front_lane_boundary_list.front().line_geometry.c3 *
//                 length * length * length;
//         right_marker_tag.pose.position.y = static_cast<float>(y + 0.7);
//         right_marker_tag.color.a = 1.0; // Don't forget to set the alpha!
//         right_marker_tag.color.r = 1.0;
//         right_marker_tag.color.g = 0.0;
//         right_marker_tag.color.b = 1.0;
//         line_list.markers.emplace_back(right_marker_tag);
//       }
//     }
//     line_list.markers.emplace_back(corridor_tag);
//   }
//   marker_arr_pub->publish(line_list);

//   // monitor string
//   visualization_msgs::msg::Marker debug_string;
//   debug_string.header.frame_id = "base_link";
//   debug_string.header.stamp = road_model_node->now();
//   debug_string.ns = "debug_string";
//   debug_string.action = visualization_msgs::msg::Marker::ADD;
//   debug_string.id = marker_id++;
//   debug_string.type = visualization_msgs::msg::Marker::TEXT_VIEW_FACING;
//   debug_string.text =
//       road_model.mutable_frame()->mutable_ilc_info()->ilc_monitor_str();
//   debug_string.color.a = 1.0;
//   debug_string.color.r = 0.1;
//   debug_string.color.g = 0.8;
//   debug_string.color.b = 0.1;
//   debug_string.pose.position.x = 20.0;
//   debug_string.pose.position.y = 40.0;
//   debug_string.pose.position.z = 3.0;
//   debug_string.scale.z = 2;
//   debug_string.lifetime = rclcpp::Duration::from_seconds(0.1);
//   debug_string_pub->publish(debug_string);
// }