/*
 * @Author: your name
 * @Date: 2021-09-28 10:09:02
 * @LastEditTime: 2022-03-09 18:32:58
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath: /RM/roadmodel/modules/common/road/dependency_injector.h
 */
// TODO 依赖注入
#pragma once

#include "enum_list.h"
#include "lane_maker_id_info.h"
#include <utility>
#include <vector>
// #include "vehicle_state_provider.h"
namespace rm {

class DependencyInjector {
public:
  DependencyInjector() = default;
  ~DependencyInjector() = default;

  // PlanningContext* planning_context() {
  //   return &planning_context_;
  // }
  // FrameHistory* frame_history() {
  //   return &frame_history_;
  // }
  // History* history() {
  //   return &history_;
  // }
  // EgoInfo* ego_info() {
  //   return &ego_info_;
  // }
  // VehicleStateProvider* vehicle_state() {
  //   return &vehicle_state_;
  // }
  // LearningBasedData* learning_based_data() {
  //   return &learning_based_data_;
  // }

  uint8_t *mutable_ego_lane_id_last_cycle() { return &ego_lane_id_last_cycle_; }

  uint8_t *mutable_left_lane_id_last_cycle() { return &left_lane_id_last_cycle_; }

  uint8_t *mutable_right_lane_id_last_cycle() { return &right_lane_id_last_cycle_; }

  uint8_t ego_lane_id_last_cycle() const { return ego_lane_id_last_cycle_; }

  uint8_t left_lane_id_last_cycle() const { return left_lane_id_last_cycle_; }

  uint8_t right_lane_id_last_cycle() const { return right_lane_id_last_cycle_; }

  std::vector<LaneMarkerIDInfo> *mutable_lane_marker_id_info_last_cycle() {
    return &lane_marker_id_info_last_cycle_;
  }

  std::vector<std::pair<uint32_t, bool>> *
  mutable_line_follow_corridor_id_info_last_cycle() {
    return &line_follow_corridor_id_info_last_cycle_;
  }

  SensorStatus* mutable_traffic_road_sensor_source_last_cycle() {
    return &traffic_road_sensor_source_last_cycle_;
  }

  SensorStatus traffic_road_sensor_source_last_cycle() {
    return traffic_road_sensor_source_last_cycle_;
  }

private:
  uint8_t ego_lane_id_last_cycle_;
  uint8_t left_lane_id_last_cycle_;
  uint8_t right_lane_id_last_cycle_;
  std::vector<LaneMarkerIDInfo> lane_marker_id_info_last_cycle_;
  std::vector<std::pair<uint32_t, bool>>
      line_follow_corridor_id_info_last_cycle_;
  SensorStatus traffic_road_sensor_source_last_cycle_;
  // PlanningContext planning_context_;
  // FrameHistory frame_history_;
  // History history_;
  // EgoInfo ego_info_;
  // VehicleStateProvider vehicle_state_;
};

} // namespace rm
