/*
 * @Author: your name
 * @Date: 2021-09-17 16:59:19
 * @LastEditTime: 2022-01-17 08:53:53
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath:
 * /NOP_EHR/media/igs/xnm/ros/RM/roadmodel/modules/common/road/enum_list.h
 */
#pragma once
namespace rm {
/**
 * @enum: LineType
 * @brief :用于描述车道线类型
 */
enum struct LineType {
  UNKNOWN = 0,
  SOLID,
  DASHED,
  DOUBLE_SOLID_DASHED,
  DOUBLE_DASHED_SOLID,
  DOUBLE_SOLID_SOLID,
  DOUBLE_DASHED_DASHED,
  BOTTS,
  DECELERATION,
  OTHERS,
  COMP,
  VIRTUAL,
};
/**
 * @enum: RoadEdgeType
 * @brief :用于描述车道线类型
 */
enum struct RoadEdgeType {
  UNKNOWN = 0,
  FLAT,
  CURB,
  ELEVATED,
  CONE_AND_POLE,
  PARKED_CARS,
};

/**
 * @enum: LineColor
 * @brief :用于描述车道线颜色
 */
enum struct LineColor {
  UNKNOWN = 0,
  WHITE,
  YELLOW,
  BLUE,
  RED,
};

/**
 * @enum: SensorSource
 * @brief :传感器来源
 */
enum struct SensorSource {
  FVCM = 1,
  LIDAR = 1 << 1,
  MONOCULAR_CAMERA = 1 << 2,
  FISH_EYE_CAMERA = 1 << 3,
  LIDAR_AND_MONOCULAR_FUSION = 1 << 4,
  LIDAR_AND_FISH_EYE_FUSION = 1 << 5,
  HDMAP = 1 << 6,
  TRAFFICFLOW = 1 << 7,
  OLA = 1 << 8,
  ROAD_EDGE = 1 << 9,
  FLE = 1 << 10,
  OTHERS = 1 << 11,
};

enum struct RoadEdgeSensorSource {
  FVCM = 0,
  RADAR,
  LIDAR,
  MONOCULAR_CAMERA,
  FISH_EYE_CAMERA,
  LIDAR_AND_MOMOCULAR_FUSION,
  LIDAR_AND_FISH_EYE_FUSION,
  LIDAR_AND_RADAR_FUSION,
  RADAR_AND_MONOCULAR_FUSION,
  HDMAP,
};

/**
 * @enum: CorridorReason
 * @brief :描述生成corridor的原因
 */
enum struct CorridorReason {
  STATIC_BOUNDARY,
  FOLLOW_FRONT_VECHICLE,
};
/**
 * @enum: LanePosition
 * @brief :描述车道的位置
 */
enum struct LanePosition {
  UNKNOWN,
  EGO_LANE,
  LEFT1,
  LEFT2,
  LEFT3,
  LEFT4,
  LEFT5,
  LEFT6,
  RIGHT1,
  RIGHT2,
  RIGHT3,
  RIGHT4,
  RIGHT5,
  RIGHT6,
};
/**
 * @enum: LaneType
 * @brief :描述车道类型
 */
enum struct LaneType {
  UNKNOWN,
  REGULAR_LANE,
  DRIVALE_SHOULDER_LANE,
  SLOW_LANE,
  CARPOOL_LANE,
  EMERGENCY_LANE,
  BOTH_DIRECTION_LANE,
  BUS_LANE,
  DRIVABLE_PARING_LANE,
  ACCLERATION_LANE,
  DECELERATION_LANE,
  DIVERSION,
  EMERGENCY_PARKING_BAR,
  VIRTUAL_LANE,
  NON_MOTORIZED_VEHICLE_LANE,
  VIRTUAL_EXTEND_LANE,
  ENTRY,
  EXIT,
  ON_RAMP,
  OFF_RAMP,
  CONNECTING_RAMP,
  EMERGENCY_PARKING_STRIP,
  NORMAL,
};

/**
 * @enum: LaneDirection
 * @brief :描述车道的位置
 */
enum struct LaneDirection {
  UNKNOWN,
  BOTH,
  ALONG_DRIVING_DIRECTION,
  AGAINST_DRIVING_DIRECTION,
};
/**
 * @enum: VehicleMovingStatus
 * @brief :描述车辆运动方向
 */
enum struct VehicleMovingStatus {
  STANDSTILL = 0,
  MOVING_FORWARD,
  MOVING_BACKWARD,
  UNKNOWN,
};

enum struct ObstacleMotionProperty {
  UNKNOWN = 0,
  STATIONARY,
  MOVING,
  STOPPED,
  MOVING_SLOWLY,
};

enum struct ObstacleMovingDirection {
  UNKOWN = 0,
  PRECEDING,
  ONCOMING,
  CROSS,
};

enum struct ObstacleType {
  UNKNOWN = 0, ///未知
  CAR,         ///汽车
  TRUCK,       ///卡车
  BUS,         ///公交
  BICYCLE,     //两轮车
  PEDESTRIAN,  ///行人
};

enum struct CorridorFeatureTag {
  NOTAVLBL = 0, //不适用
  LINEFOLLOW,   //跟随车道中心线
  CARFOLLOW,    //跟随目标车
  LINEDEVIATE,  //跟随偏移车道中心线
  LINEMISS,     // 车道线未检测
  LINEEXTEND,   // 车道线延长
};

/**
 * @enum: RoadClass
 * @brief :描述道路类型
 */
enum struct RoadType {
  UNKNOWN = 0,
  FAST_WAY_INSIDE_CITY,
  NORMAL,
};

/**
 * @enum: SensorStatus
 * @brief :描述传感器状态
 */
enum struct SensorStatus {
  INIT = 0,
  ONLY_FVCM_VALID,
  FVCM_AND_HDM_VALID,
};

enum struct TargetType {
  IV = 0,
  IIV,
  FLNIV,
  FLNIIV,
  FLNRIV,
  SLNIV,
  SLNIIV,
  SLNRIV,
  RIV,
  OTHER,
};

enum struct LaneLineCrossedType {
  NONE = 0,
  CROSSED_LEFT_LINE,
  CROSSED_RIGHT_LINE,
};

enum struct BoundaryPairType {
  BOTH_INVALID = 0,
  LEFT_VALID,
  RIGHT_VALID,
  BOTH_VALID,
};

enum struct TransitType {
  None = 0,
  RIGHTEXITBEGIN,
  RIGHTEXITEND,
  LEFTEXITBEGIN,
  LEFTEXITEND,
  RIGHTENTERBEGIN,
  RIGHTENTEREND,
  LEFTENTERBEGIN,
  LEFTENTEREND,
  SPLIT,
  MERGE,
  LANEEND,
  LANEADDRIGHT,
  LANEADDLEFT,
};

enum struct TargetRoadType {
  NOTMATCH = 0,
  NONAVIPOINT,
  RIGHT2MAIN,
  LEFT2MAIN,
  LEFT2RAMP,
  RIGHT2RAMP,
  OTHERS,
};

enum struct ReminderTargetRoadType {
  NOTUNNEL = 0,
  TUNNEL,
};

enum struct RoadEdgePostion {
  UNKNOWN = 0,
  LEFT,
  RIGHT,
};

enum struct RemainDistanceMajorPathType {
  TOLL = 0,
  SD_ENDING,
  SDHD_NOTMATCH,
  RESERVED,
  HD_ENDING_NOT_IN_HIGHWAY,
  HD_ENDING_IN_HIGHWAY,
  ASSOCIATION_TABLE_NEWEST,
};

enum struct FilterStatus {
  INVALID = 0,
  PREDICT,
  UPDATE,
};

enum struct MeasurementState {
  DELETED = 0,
  NEW,
  MEASURED,
  PREDICTED,
  INACTIVE,
  VIRTUAL,
};

enum struct ReferencePointType {
  FRONTLEFT = 0,
  FRONTCENTER,
  FRONTRIGHT,
  RIGHTCENTER,
  REARRIGHT,
  REARCENTER,
  REARLEFT,
  LEFTCENTER,
  CENTER,
};

enum struct SMTjaIcaStatus {
  OFF = 0,
  STANDBY,
  ACTIVE,
  OVERRIDE,
  PASSIVE,
};

} // namespace rm