#pragma once

#include <stdint.h>

#include <vector>

namespace rm {

class ILCInfo {
 public:
  ILCInfo(){};

  ~ILCInfo(){};

  void add_ilc_target_id(uint32_t id) { ilc_target_id_list_.push_back(id); }

  const std::vector<uint32_t>& ilc_target_id_list() const {
    return ilc_target_id_list_;
  }

  const std::string& ilc_monitor_str() const { return ilc_monitor_str_; }

  std::vector<uint32_t>* mutable_ilc_target_id_list() {
    return &ilc_target_id_list_;
  }

  void set_ilc_target_id_list(const std::vector<uint32_t>& ilc_target_id) {
    ilc_target_id_list_ = ilc_target_id;
  }

  void set_ilc_monitor_str(const std::string& str) { ilc_monitor_str_ = str; }

 private:
  std::vector<uint32_t> ilc_target_id_list_;
  std::string ilc_monitor_str_;
};

}  // namespace rm