/*
 * @Author: your name
 * @Date: 2021-09-29 13:45:07
 * @LastEditTime: 2022-01-20 14:11:25
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath: /RM/roadmodel/modules/common/road/lane_info.cc
 */
#include "lane_info.h"

namespace rm {
LaneInfo ::LaneInfo(const Lane& lane) : lane_(lane) {}

const Lane& LaneInfo::lane() const { return lane_; }

void LaneInfo::set_boundary(const std::pair<Boundary, Boundary>& boundary) {
  boundary_ = boundary;
  set_boundary_pair_type();
  // DLOG(INFO) << PRINT(+static_cast<uint8_t>(boundary_pair_type_));
}

void LaneInfo::set_back_boundary(
    const std::pair<Boundary, Boundary>& boundary) {
  back_boundary_ = boundary;
}

const std::pair<Boundary, Boundary>& LaneInfo::boundary() const {
  return boundary_;
}

std::pair<Boundary, Boundary>* LaneInfo::mutable_boundary() {
  return &boundary_;
}

const std::pair<Boundary, Boundary>& LaneInfo::back_boundary() const {
  return back_boundary_;
}

std::vector<Corridor>* LaneInfo::mutable_corridor() { return &corridor_; }

std::vector<Corridor>* LaneInfo::mutable_back_corridor() {
  return &back_corridor_;
}

const std::vector<Corridor>& LaneInfo::corridor() const { return corridor_; }

const std::vector<Corridor>& LaneInfo::back_corridor() const {
  return back_corridor_;
}

void LaneInfo::set_boundary_pair_type() {
  if (boundary_.first.valid() && boundary_.second.valid()) {
    boundary_pair_type_ = BoundaryPairType::BOTH_VALID;
  } else if (boundary_.first.valid() && !boundary_.second.valid()) {
    boundary_pair_type_ = BoundaryPairType::LEFT_VALID;
  } else if (!boundary_.first.valid() && boundary_.second.valid()) {
    boundary_pair_type_ = BoundaryPairType::RIGHT_VALID;
  } else {
    boundary_pair_type_ = BoundaryPairType::BOTH_INVALID;
  }
}

BoundaryPairType LaneInfo::boundary_pair_type() const {
  return boundary_pair_type_;
}

}  // namespace rm