/*
 * @Author: your name
 * @Date: 2021-10-09 14:26:22
 * @LastEditTime: 2022-03-09 19:14:54
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath:
 * /c++test/media/igs/xnm/RM/rm/modules/common/road/boundary_segment.h
 */
#pragma once

#include <stdint.h>

#include <bitset>
#include <list>
#include <vector>

//#include "cem_interfaces/msg/geometry_line_struct.hpp"
#include "dpc/impl_type_geometrylinestruct.h"
#include "enum_list.h"
#include "line_geometry.h"
#include "polynom_line.h"
#include "sampling_point.h"
namespace rm {
/**
 * @class: LaneMarkerSegment
 * @brief: 存储cem的lanemarkersegment
 */
class LaneMarkerSegment {
 public:
  LaneMarkerSegment() = default;
  ~LaneMarkerSegment() = default;
  /**
   * @brief: 存取函数
   * @param {uint32_t} &lane_marker_segment_id
   * @return {*}
   */
  void set_lane_marker_segment_id(const uint32_t &lane_marker_segment_id);

  void set_line_geometry(const LineGeometry &gemotry);

  void set_lane_marker_width(const float lane_marker_width);

  void set_color(const LineColor &color);

  void set_type(const LineType &type);

  void set_sensor_source(uint16_t sensor_source) {
    sensor_source_ = sensor_source;
  }

  void set_sampling_point_list(
      const dpc::GeometryLineStruct &geometryline);

  void set_is_sampling_point_valid(bool is_sampling_point);

  void compute_arc_length_from_geometry();

  void compute_arc_length_from_sampling_points();

  void compute_arc_length();

  LineGeometry *mutable_geometry();

  uint32_t lane_marker_segment_id() const;

  const LineGeometry &geometry() const;

  LineType type() const;

  LineColor color() const;

  uint16_t sensor_source() const { return sensor_source_; }

  bool operator==(const uint32_t id) const;

  const std::vector<SamplingPoint> &sampling_point_list() const;

  std::vector<SamplingPoint> *mutable_sampling_point_list();

  float arc_length() const;

  bool is_sampling_point_valid() const;

 private:
  uint32_t lane_marker_segment_id_;  //车道线ID
  LineGeometry geometry_;            //车道线表达
  float lane_marker_width_;          //车道线的宽度
  LineColor color_;                  //车道线颜色
  LineType type_;                    //车道线类型
  uint16_t sensor_source_;           //传感器来源
  bool is_sampling_point_valid_;
  std::vector<SamplingPoint> sampling_point_list_;
  float arc_length_ = 0.0F;
};
}  // namespace rm
