#pragma once

#include "enum_list.h"
#include <stdint.h>

namespace rm {

class LaneMarkerSegmentAttribute {
public:
  LaneMarkerSegmentAttribute(){};

  LaneMarkerSegmentAttribute(float start_offset, float end_offset,
                             rm::LineType line_type, rm::LineColor line_color)
      : start_offset_(start_offset), end_offset_(end_offset),
        line_type_(line_type), line_color_(line_color){};

  void set_start_offset(float start_offset) { start_offset_ = start_offset; }

  void set_end_offset(float end_offset) { end_offset_ = end_offset; }

  void set_line_type(uint8_t line_type) {
    line_type_ = static_cast<rm::LineType>(line_type);
  }

  void set_line_color(uint8_t line_color) {
    line_color_ = static_cast<rm::LineColor>(line_color);
  }

  float start_offset() const { return start_offset_; }

  float end_offset() const { return end_offset_; }

  rm::LineType line_type() const { return line_type_; }

  rm::LineColor line_color() const { return line_color_; }

private:
  float start_offset_;
  float end_offset_;
  rm::LineType line_type_;
  rm::LineColor line_color_;
};

} // namespace rm