/*
 * @Author: your name
 * @Date: 2021-10-26 11:14:22
 * @LastEditTime: 2022-03-09 20:54:44
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath:
 * /media/igs/xnm/roadmodel/src/CtApRoadModel/source/common/road/lane_segment.h
 */
#pragma once
#include <vector>

//#include "cem_interfaces/msg/geometry_line_struct.hpp"
#include "dpc/impl_type_geometrylinestruct.h"
#include "glog/logging.h"
#include "sampling_point.h"
#include "stdint.h"
namespace rm {
class LaneSegment {
 public:
  void set_lane_segment_id(uint32_t lane_segment_id) {
    lane_segment_id_ = lane_segment_id;
  }
  void set_lane_width(float lane_width) { lane_width_ = lane_width; }
  void set_max_speed_limit(float max_speed_limit) {
    max_speed_limit_ = max_speed_limit;
  }
  void set_min_speed_limit(float min_speed_limit) {
    min_speed_limit_ = min_speed_limit;
  }
  void set_sampling_point_list(
      const dpc::GeometryLineStruct &geometryline) {
    for (const auto &sample_point : geometryline.sampling_point_list) {
      sampling_point_list_.emplace_back(sample_point.x, sample_point.y,
                                        sample_point.curve, sample_point.offset);
    }
  }
  const std::vector<SamplingPoint> &sampling_point_list() const {
    return sampling_point_list_;
  }
  std::vector<SamplingPoint> *mutable_sampling_point_list() {
    return &sampling_point_list_;
  }
  float lane_width() const { return lane_width_; }

  void set_is_sampling_point_valid(bool flag) { is_sampling_point_valid_ = flag; }

  bool is_sampling_point_valid() const {return is_sampling_point_valid_;}

 private:
  uint32_t lane_segment_id_;
  float lane_width_;
  float max_speed_limit_;
  float min_speed_limit_;
  std::vector<SamplingPoint> sampling_point_list_;
  bool is_sampling_point_valid_;
};

}  // namespace rm
