/*
 * @Author: your name
 * @Date: 2021-11-16 11:26:44
 * @LastEditTime: 2021-12-07 10:21:13
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath: /roadmodel/src/CtApRoadModel/source/common/math/sl_point.h
 */
#pragma once
#include <stdint.h>
#include <vector>

#include "enum_list.h"
#include "sl_point.h"
namespace rm {

struct ObjectLocation {
  uint32_t object_id;
  SLPoint reference_point2corridor_frenet;
  bool in_corridor;
  rm::ObstacleType classification;
  float relative_center_x;
  float relative_center_y;
  float size_width;
  float size_length;
  ObjectLocation()
      : object_id(0U),
        reference_point2corridor_frenet(0.0, 0.0, 0.0, 0.0, 0.0, 0.0),
        in_corridor(false), classification(rm::ObstacleType::UNKNOWN),
        relative_center_x(0.0), relative_center_y(0.0), size_width(0.0),
        size_length(0.0){};
  ObjectLocation(uint32_t id, float s, float ds, float dds, float l, float dl,
                 float ddl, bool in_flag, rm::ObstacleType type, float center_x,
                 float center_y, float width, float length)
      : object_id(id), reference_point2corridor_frenet(s, ds, dds, l, dl, ddl),
        in_corridor(in_flag), classification(type), relative_center_x(center_x),
        relative_center_y(center_y), size_width(width), size_length(length){};
  bool operator<(const ObjectLocation &temp) const {
    float dis_shift = (reference_point2corridor_frenet.s() >= 0.0)
                          ? -0.5F * size_length
                          : 0.5F * size_length;
    float temp_dis_shift = (temp.reference_point2corridor_frenet.s() >= 0.0)
                               ? -0.5F * temp.size_length
                               : 0.5F * temp.size_length;
    return reference_point2corridor_frenet.s() + dis_shift <
           temp.reference_point2corridor_frenet.s() + temp_dis_shift;
  };
};

} // namespace rm