#pragma once

#include <stdint.h>

#include <algorithm>
#include <iostream>
#include <vector>

#include "enum_list.h"
#include "road_edge_segment.h"

namespace rm {

class RoadEdge {
 public:
  void set_road_edge_id(uint32_t id);

  void set_position(rm::RoadEdgePostion position);

  void add_linked_lane_segment_id(uint32_t lane_seg_id);

  RoadEdgeSegment *add_road_edge_segment();

  uint32_t road_edge_id() const;

  rm::RoadEdgePostion position() const;

  const std::vector<uint32_t> &linked_lane_segment_id_list() const;

  const std::vector<RoadEdgeSegment> &road_edge_segment_list() const;

  std::vector<RoadEdgeSegment> *mutable_road_edge_segment_list();

  bool get_current_road_edge_segment(RoadEdgeSegment &segment);

 private:
  uint32_t road_edge_id_;
  rm::RoadEdgePostion position_;
  std::vector<uint32_t> linked_lane_segment_id_list_;
  std::vector<RoadEdgeSegment> road_edge_segment_list_;
};

}  // namespace rm