/*
 * @Author: your name
 * @Date: 2021-12-03 14:28:49
 * @LastEditTime: 2021-12-28 13:13:15
 * @LastEditors: Please set LastEditors
 * @Description: 打开koroFileHeader查看配置 进行设置:
 * https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 * @FilePath:
 * /EHR/home/igs/roadmodel/src/CtApRoadModel/source/road/lane_marker_segment.cc
 */
#pragma once

#include "road_edge_segment.h"

namespace rm {

void RoadEdgeSegment::set_road_edge_segment_id(
    const uint32_t &road_edge_segment_id) {
  road_edge_segment_id_ = road_edge_segment_id;
}

void RoadEdgeSegment::set_line_geometry(const LineGeometry &gemotry) {
  geometry_ = gemotry;
}

void RoadEdgeSegment::set_type(const RoadEdgeType &type) { type_ = type; }

void RoadEdgeSegment::set_end_out_of_view(uint8_t end_out_of_view) {
  end_out_of_view_ = end_out_of_view;
}

void RoadEdgeSegment::set_start_out_of_view(uint8_t start_out_of_range) {
  start_out_of_view_ = start_out_of_range;
}

void RoadEdgeSegment::set_height_above_ground(float height_above_ground) {
  height_above_ground_ = height_above_ground;
}

LineGeometry *RoadEdgeSegment::mutable_geometry() { return &geometry_; }

uint32_t RoadEdgeSegment::road_edge_segment_id() const {
  return road_edge_segment_id_;
}

const LineGeometry &RoadEdgeSegment::geometry() const { return geometry_; }

RoadEdgeType RoadEdgeSegment::type() const { return type_; }

bool RoadEdgeSegment::operator==(const uint32_t id) const {
  return road_edge_segment_id_ == id;
}

uint8_t RoadEdgeSegment::end_out_of_view() const { return end_out_of_view_; }

uint8_t RoadEdgeSegment::start_out_of_view() const {
  return start_out_of_view_;
}

float RoadEdgeSegment::height_above_ground() const {
  return height_above_ground_;
}

}  // namespace rm