/*
 * @Author: your name
 * @Date: 2021-10-09 14:26:22
 * @LastEditTime: 2021-12-28 13:08:43
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath:
 * /c++test/media/igs/xnm/RM/rm/modules/common/road/boundary_segment.h
 */
#pragma once

#include <stdint.h>

#include <list>

#include "enum_list.h"
#include "line_geometry.h"
#include "polynom_line.h"
namespace rm {
/**
 * @class: RoadEdgeSegment
 * @brief: 存储cem的RoadEdgeSegment
 */
class RoadEdgeSegment {
 public:
  RoadEdgeSegment() = default;
  ~RoadEdgeSegment() = default;
  /**
   * @brief: 存取函数
   * @param {uint32_t} &
   * @return {*}
   */
  void set_road_edge_segment_id(const uint32_t &road_edge_segment_id);

  void set_line_geometry(const LineGeometry &gemotry);

  void set_type(const RoadEdgeType &type);

  void set_sensor_source(const RoadEdgeSensorSource &sensor_source) {
    sensor_source_ = sensor_source;
  }

  void set_end_out_of_view(uint8_t end_out_of_view);

  void set_start_out_of_view(uint8_t start_out_of_range);

  void set_height_above_ground(float height_above_ground);

  LineGeometry *mutable_geometry();

  uint32_t road_edge_segment_id() const;

  const LineGeometry &geometry() const;

  RoadEdgeType type() const;

  RoadEdgeSensorSource sensor_source() const { return sensor_source_; }

  bool operator==(const uint32_t id) const;

  uint8_t end_out_of_view() const;

  uint8_t start_out_of_view() const;

  float height_above_ground() const;

 private:
  uint32_t road_edge_segment_id_;       // road edge segment ID
  LineGeometry geometry_;               // roadedge表达
  RoadEdgeSensorSource sensor_source_;  //传感器来源
  RoadEdgeType type_;                   // roadedge 类型
  float height_above_ground_;
  uint8_t
      end_out_of_view_;  // 0:unknown 1:end out of view 2: real end of road edge
  uint8_t start_out_of_view_;  // 0:unknown 1:start out of view 2: real end of
                               // road edge
};
}  // namespace rm