
/*
 * @Author: your name
 * @Date: 2021-12-20 09:55:04
 * @LastEditTime: 2022-03-09 19:42:57
 * @LastEditors: Please set LastEditors
 * @Description: 打开koroFileHeader查看配置 进行设置:
 * https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 * @FilePath: /EHR/home/igs/roadmodel/src/core/source/road/road_info_adapter.h
 */
#include "road_info_provider.h"

#include<iostream>
#include<iomanip>
#include<cmath>
#include <memory>
#include <vector>

namespace rm {

class RoadInfoAdapter : public RoadInfoProvider {
 public:
  RoadInfoAdapter(const std::shared_ptr<Observer>& observer)
      : RoadInfoProvider(observer) {}

  virtual void Update(const LocalView& local_view) override {
    traffic_road_ = local_view.traffic_road;
    // traffic_road_edge_ = local_view.traffic_road_edge;
    traffic_participant_ = local_view.traffic_participant;
    // sm_way_points_ = local_view.sm_waypoints;
    // traffic_freespace_ = local_view.traffic_freespace;
    traffic_odometry_ = local_view.traffic_odometry;
    // ehr_mapscene_ = local_view.ehr_mapscene;
    // roadModelLines2LaneMarkers();
    UpdateTrafficRoad();
    // UpdateTrafficRoadEdge();
    UpdateTrafficParticipant();
    // UpdateWPExtendLaneList();
    // UpdateFreespace();
    UpdateOdometry();
  }

  /**
   * @brief: 更新cem的静态环境信息
   * @param  traffic_road cem发来的静态环境数据
   * @return {*}
   */
  void UpdateTrafficRoad();
  /**
   * @brief: 更行cem的动态环境信息
   * @param  traffic_participant cem发来的动态环境数据
   * @return {*}
   */
  void UpdateTrafficParticipant();

  // void UpdateTrafficRoadEdge();

  // void UpdateWPExtendLaneList();

  // void UpdateFreespace();

  void UpdateOdometry();

  void DeleteObjectNotExist();

 private:
  std::shared_ptr<dpc::slam_road_model> traffic_road_;
  // std::shared_ptr<cem_interfaces::msg::TrafficRoadEdgeStruct>
  //     traffic_road_edge_;
  std::shared_ptr<dpc::TrafficParticipantStruct>
      traffic_participant_;
  // std::shared_ptr<mpc_drv_msgs::msg::SMWaypoints> sm_way_points_;
  // std::shared_ptr<nav_msgs::msg::OccupancyGrid> traffic_freespace_;
  std::shared_ptr<dpc::slam_odometry> traffic_odometry_;
  // std::shared_ptr<cem_interfaces::msg::MapScene> ehr_mapscene_;

  static std::pair<bool, std::unique_ptr<rm::PolynomLine>> fitPoly3(dpc::vector_line_point& line_points);
  void roadModelLines2LaneMarkers();
};

}  // namespace rm
