/*
 * @Author: your name
 * @Date: 2021-10-21 20:51:17
 * @LastEditTime: 2021-12-23 09:16:09
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath:
 * //media/xnm/xnm/☆☆项目建档(禁删)☆☆/test/c++test/patterns/observer.cpp
 */
// 观察者模式是软件设计模式的一种。在此种模式中，一个目标对象管理所有相依于它的观察者对象，
// 并且在它本身的状态改变时主动发出通知。这通常透过呼叫各观察者所提供的方法来实现。
// 此种模式通常被用来实时事件处理系统。如动态调参？
// 观察者模式包括一下角色：
//可以用于ros的动态调参 参数更新后通知观察者来更新自己关新的数据
#pragma once
#include <iostream>
#include <vector>

#include "observer.h"
using namespace std;

namespace rm {
//具体观察者
class RoadInfoProviderObserver : public Observer {
 public:
  RoadInfoProviderObserver(shared_ptr<Subject> subject)
      : subject_(subject),
        config_(DynamicConfig::ConfigType::ROAD_INFO_PROVIDER) {
    name_ = config_.ConfigTypeName();
  };

  ~RoadInfoProviderObserver(){

  };

  //具体观察者中将目标加进来后可以按需挑选关心的数据
  void update() {
    // config_.road_info_provider_config->int_param    =
    // subject_->getConfigs().int_param;
    // config_.road_info_provider_config->proc_x_cov   =
    // subject_->getConfigs().proc_x_cov;
    // config_.road_info_provider_config->proc_y_cov   =
    // subject_->getConfigs().proc_y_cov;
    // config_.road_info_provider_config->proc_v_cov   =
    // subject_->getConfigs().proc_v_cov;
    // config_.road_info_provider_config->proc_a_cov   =
    // subject_->getConfigs().proc_a_cov;
    // config_.road_info_provider_config->proc_yaw_cov   =
    // subject_->getConfigs().proc_yaw_cov;
    // config_.road_info_provider_config->proc_yawrate_cov   =
    // subject_->getConfigs().proc_yawrate_cov;
    // config_.road_info_provider_config->meas_x_cov   =
    // subject_->getConfigs().meas_x_cov;
    // config_.road_info_provider_config->meas_y_cov   =
    // subject_->getConfigs().meas_y_cov;
    // config_.road_info_provider_config->meas_v_cov   =
    // subject_->getConfigs().meas_v_cov;
    // config_.road_info_provider_config->meas_a_cov   =
    // subject_->getConfigs().meas_a_cov;
    // config_.road_info_provider_config->meas_yaw_cov   =
    // subject_->getConfigs().meas_yaw_cov;
    // config_.road_info_provider_config->meas_yawrate_cov   =
    // subject_->getConfigs().meas_yawrate_cov;
    // // task_config.boundary_builder_config->double_param =
    // m_subject->getConfigs().double_param;
  }
  string getName() const { return name_; }
  DynamicConfig *getDynamicConfig() { return &config_; }

 private:
  string name_;                  //观察者名称
  shared_ptr<Subject> subject_;  //观察的目标
  DynamicConfig config_;
};
}  // namespace rm