/*
 * @Author: your name
 * @Date: 2021-12-07 10:20:46
 * @LastEditTime: 2021-12-07 10:50:41
 * @LastEditors: Please set LastEditors
 * @Description: 打开koroFileHeader查看配置 进行设置: https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 * @FilePath: /EHR/home/igs/roadmodel/src/CtApRoadModel/source/road/sl_point.cc
 */
#include "sl_point.h"

namespace rm{
    // const OneDimLookupTable SLPoint::dds_time_table = OneDimLookupTable({3.0,2.0,1.0,0.0},{1.0,2.0,3.0,100.0});
    const OneDimLookupTable SLPoint::dds_time_table = OneDimLookupTable({0.0,1.0,2.0,3.0},{100.0,3.0,2.0,1.0});
    // const OneDimLookupTable SLPoint::dl_time_table = OneDimLookupTable({1.0,0.5,0.1,0},{1.0,2.0,3.0,100.0});
    const OneDimLookupTable SLPoint::dl_time_table = OneDimLookupTable({0.0,0.1,0.5,1.0},{100.0,3.0,2.0,1.0});
    const OneDimLookupTable SLPoint::ddl_time_table = OneDimLookupTable({0.0,0.1,0.5,1.0},{50.0,1.5,1.0,0.5});
    const std::pair<float, float> SLPoint::s_range = std::make_pair(-200, 200);
    const std::pair<float, float> SLPoint::ds_range = std::make_pair(0, 60);
    const std::pair<float, float> SLPoint::dds_range = std::make_pair(-10, 10);
    const std::pair<float, float> SLPoint::l_range = std::make_pair(-50, 50);
    const std::pair<float, float> SLPoint::dl_range = std::make_pair(-10, 10);
    const std::pair<float, float> SLPoint::ddl_range = std::make_pair(-10, 10);

    void SLPoint::set_s(float s) {s_ = s;}
    
    void SLPoint::set_ds(float ds){ds_ = ds;}

    void SLPoint::set_dds(float dds) {dds_ = dds;}

    void SLPoint::set_l(float l) {l_ = l;}

    void SLPoint::set_dl(float dl) {dl_ = dl;}

    void SLPoint::set_ddl(float ddl){ddl_ = ddl;}

    void SLPoint::set_dds_valid_time(float dds_valid_time){dds_valid_time_ = dds_valid_time;}

    void SLPoint::set_dl_valid_time(float dl_valid_time){dl_valid_time_ = dl_valid_time;}

    void SLPoint::set_ddl_valid_time(float ddl_valid_time){ddl_valid_time_ = ddl_valid_time;}
    
    float SLPoint::s() const{return s_;}

    float SLPoint::ds() const{return ds_;}

    float SLPoint::dds() const{return dds_;}

    float SLPoint::l() const{return l_;}

    float SLPoint::dl() const{return dl_;}

    float SLPoint::ddl() const{return ddl_;}

    float SLPoint::dds_valid_time() const{return dds_valid_time_;}

    float SLPoint::dl_valid_time() const{return dl_valid_time_;}
    
    float SLPoint::ddl_valid_time() const{return ddl_valid_time_;}

    void SLPoint::ComputeValidTime(){
        dds_valid_time_ = dds_time_table.Evaluate(std::abs(dds_));
        dl_valid_time_ = dl_time_table.Evaluate(std::abs(dl_));
        ddl_valid_time_ = ddl_time_table.Evaluate(std::abs(ddl_));
    }

    void SLPoint::Sat_SLValue()
    {
        Saturation(s_, s_range);
        Saturation(ds_, ds_range);
        Saturation(dds_,  dds_range);
        Saturation(l_, l_range);
        Saturation(dl_, dl_range);
        Saturation(ddl_, ddl_range);
    }

    void SLPoint::Sat_Rear_SLValue(){
        // saturate the rear objects sl, keep s below 0.0
        Saturation(s_, std::make_pair(s_range.first, 0.0));
        Saturation(ds_, ds_range);
        Saturation(dds_,  dds_range);
        Saturation(l_, l_range);
        Saturation(dl_, dl_range);
        Saturation(ddl_, ddl_range);
    }

    void SLPoint::Saturation(float &value, const std::pair<float, float > &range)
    {
        if (value >= range.second)
        {
            value = range.second;
        }
        else if (value <= range.first)
        {
            value = range.first;
        }
        else
        {
            // do nothing
        }
    }

    std::ostream &operator<<(std::ostream &os, const SLPoint &slpoint) {
        os << "s = "<<slpoint.s_<< ", ds = "<< slpoint.ds_ << ", dds = "<< slpoint.dds_  << ", l = "<<slpoint.l_ << ", dl = "<<slpoint.dl_<<", ddl = "<<slpoint.ddl_;
        return os;
    }
}