#pragma once

#include "debouncer.h"
#include "delay.h"
#include "road_info_provider.h"
#include "vehicle_state_provider.h"
#include "macros.h"
#include "glog/logging.h"

namespace rm {
class StraightDrivingDetector {
public:
  StraightDrivingDetector(){};
  ~StraightDrivingDetector(){};
  bool RunDetector();
  void Reset();

private:
  void UpdateInput();

  Debouncer steering_wheel_deb_{3.0, 5.0};
  Delay<bool> steeing_wheel_delay_{2.5, 0, false};
  Debouncer yaw_rate_deb_{0.3, 0.5};
  Delay<bool> yaw_rate_delay_{2.5, 0, false};

  float abs_steering_wheel_angle_; // absolute steering wheel angle - deg
  float abs_yaw_rate_;             // absolute yaw rate - rad/s
};
} // namespace rm
