/*
 * @Author: your name
 * @Date: 2021-11-18 13:54:06
 * @LastEditTime: 2022-03-09 19:27:04
 * @LastEditors: Please set LastEditors
 * @Description: 打开koroFileHeader查看配置 进行设置:
 * https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 * @FilePath:
 * /EHR/home/igs/roadmodel/src/CtApRoadModel/source/road/vehicle_state_provider.cc
 */

#include "vehicle_state_provider.h"

// #include <cmath>

// #include "Eigen/Core"

using rm::common::Status;
namespace rm {
SINGLETON_STATIC(VehicleStateProvider)

Status VehicleStateProvider::Update(
    const dpc::VED4DPC &vehicle_state/*,
    const vehicle_msgs::msg::ApSas10msPdu00 &sas_info,
    const vehicle_msgs::msg::ApEps010msPdu00 &eps_info,
    const mpc_drv_msgs::msg::MsgSM2TRPC &sm_info
    const rm_interface::slam_road_model &slam_info*/) {
  // TODO(ningmeng)需判断header是否更新 若无更新 直接退出
  lon_velocity_ = vehicle_state.LongitudinalVelocity;
  lon_acceleration_ = vehicle_state.LongitudinalAcceleration;
  lat_acceleration_ = vehicle_state.LateralAcceleration;
//   lon_slope_ = vehicle_state.vse_longitudinalslope;
  yaw_rate_ =
      vehicle_state.Yawrate; // internal counterclockwise + clockwise -
//   moving_status_ = VehicleMovingStatus(vehicle_state.vse_movingstatus);
//   vse_cyclecounter_ = vehicle_state.cyclecounter;
//   steering_wheel_angle_ = sas_info.istrgwhlang;
//   steering_wheel_angle_validity_ =
//       sas_info.istrgwhlangv; // 0: valid, 1: not valid
//   column_torque_ = eps_info.idrvrstrgdlvrdtoq;
//   column_torque_validity_ =
//       eps_info.idrvrstrgdlvrdtoqv; // 0: valid, 1: not valid
//   CalDrivingCurv();
//   tja_ica_status_ =
//       static_cast<rm::SMTjaIcaStatus>(sm_info.sm_trp_indx_tjaicasts);
  return Status::OK();
}

void VehicleStateProvider::CalDrivingCurv() {
  double yaw_rate_filtered = yaw_rate_lpf_.run(yaw_rate_);
  driving_curvature_ = (lon_velocity_ < 0.1)
                           ? 0.0
                           : yaw_rate_filtered * rm::DEG2RAD / lon_velocity_;
}

} // namespace rm