#include "wpextend_lane.h"

namespace rm {
void WPExtendLane::set_lane_id(const uint8_t &lane_id) { lane_id_ = lane_id; }

uint8_t WPExtendLane::lane_id() const { return lane_id_; }

void WPExtendLane::set_is_emergency_lane(const uint8_t &is_emergency_lane) {
  is_emergency_lane_ = is_emergency_lane;
}

uint8_t WPExtendLane::is_emergency_lane() const { return is_emergency_lane_; }

void WPExtendLane::add_left_extend_lane(
    const AdjacentExtendLane &left_extend_lane) {
  left_extend_lane_.push_back(left_extend_lane);
}

void WPExtendLane::add_right_extend_lane(
    const AdjacentExtendLane &right_extend_lane) {
  right_extend_lane_.push_back(right_extend_lane);
}

const std::list<AdjacentExtendLane> &WPExtendLane::left_extend_lane() const {
  return left_extend_lane_;
}

const std::list<AdjacentExtendLane> &WPExtendLane::right_extend_lane() const {
  return right_extend_lane_;
}

void WPExtendLane::add_odd_info(const ODDInfo &odd_info) {
  odd_info_.emplace_back(odd_info);
}

const std::vector<ODDInfo> &WPExtendLane::odd_info() const { return odd_info_; }

std::vector<ODDInfo> *WPExtendLane::mutable_odd_info() { return &odd_info_; }

}  // namespace rm
