#pragma once
#include <stdint.h>

#include <list>
#include <vector>

#include "adjacent_extend_lane.h"
#include "odd_info.h"

namespace rm {
class WPExtendLane {
 public:
  WPExtendLane()
      : lane_id_(0),
        lane_latest_lcpoint_offset_(0.0),
        lane_priority_(0),
        is_emergency_lane_(0){};

  void set_lane_id(const uint8_t &lane_id);

  uint8_t lane_id() const;

  void set_is_emergency_lane(const uint8_t &is_emergency_lane);

  uint8_t is_emergency_lane() const;

  void add_left_extend_lane(const AdjacentExtendLane &left_extend_lane);

  const std::list<AdjacentExtendLane> &left_extend_lane() const;

  void add_right_extend_lane(const AdjacentExtendLane &right_extend_lane);

  const std::list<AdjacentExtendLane> &right_extend_lane() const;

  void add_odd_info(const ODDInfo &odd_info);

  const std::vector<ODDInfo> &odd_info() const;

  std::vector<ODDInfo> *mutable_odd_info();

  bool operator==(const uint8_t id) const { return id == lane_id_; };

 private:
  uint8_t lane_id_;
  float lane_latest_lcpoint_offset_;
  uint8_t lane_priority_;
  uint8_t is_emergency_lane_;
  float current_extend_lane_offset_;
  float current_extend_lane_end_Offset_;
  std::list<AdjacentExtendLane> left_extend_lane_;
  std::list<AdjacentExtendLane> right_extend_lane_;
  std::vector<ODDInfo> odd_info_;
};
}  // namespace rm
