/*
 * @Author: your name
 * @Date: 2021-10-29 13:52:56
 * @LastEditTime: 2021-12-23 09:17:54
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath:
 * /media/igs/xnm/roadmodel/src/CtApRoadModel/source/task/builders/boundary_builder/boundary_builder.h
 */

/**
 * @file
 **/

#pragma once

#include <list>
#include <memory>
#include <string>

#include "builder.h"
#include "delay.h"
#include "road_edge_segment.h"
#include "vec2d.h"
#include "rm_config.h"

namespace rm {

class BoundaryBuilder : public Builder {
public:
  BoundaryBuilder(const std::shared_ptr<Observer> &observer,
                  const std::shared_ptr<DependencyInjector> &injector);
  static void ResetBoundaryBuilder();

private:
  common::Status Process(Frame *frame,
                         LaneInfo *const current_lane_info) override;
  void RoadEdgeLaneMrkTypeOverwrite(std::vector<RoadEdge *> road_edge_ptrs,
                                    rm::LaneMarker *lane_marker, bool is_left);
  static rm::Delay<bool> le_lnmrk_ovlapped_by_rdedge_;
  static rm::Delay<bool> ri_lnmrk_ovrlapped_by_rdedge_;
  double left_overlap_range_x_{0.0}, right_overlap_range_x_{0.0}, rdedg_lnmrk_dis_threshold{0.8};
};

} // namespace rm
