/*
 * @Author: your name
 * @Date: 2021-10-21 20:51:17
 * @LastEditTime: 2021-12-23 09:17:41
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath:
 * /media/xnm/xnm/☆☆项目建档(禁删)☆☆/test/c++test/patterns/observer.cpp
 */
// 观察者模式是软件设计模式的一种。在此种模式中，一个目标对象管理所有相依于它的观察者对象，
// 并且在它本身的状态改变时主动发出通知。这通常透过呼叫各观察者所提供的方法来实现。
// 此种模式通常被用来实时事件处理系统。如动态调参？
// 观察者模式包括一下角色：
//可以用于ros的动态调参 参数更新后通知观察者来更新自己关新的数据
#pragma once
#include <iostream>
#include <vector>

#include "observer.h"
using namespace std;

namespace rm {
//具体观察者
class BoundaryBuilderObserver : public Observer {
 public:
  BoundaryBuilderObserver(shared_ptr<Subject> subject)
      : subject_(subject),
        config_(DynamicConfig::ConfigType::BOUNDARY_BUILDER) {
    name_ = config_.ConfigTypeName();
  };

  ~BoundaryBuilderObserver(){

  };

  //具体观察者中将目标加进来后可以按需挑选关心的数据
  void update() {
    // config_.boundary_builder_config->int_param    =
    // subject_->getConfigs().int_param;
    // config_.boundary_builder_config->double_param =
    // subject_->getConfigs().double_param;
  }
  string getName() const { return name_; }
  DynamicConfig *getDynamicConfig() { return &config_; }

 private:
  string name_;                  //观察者名称
  shared_ptr<Subject> subject_;  //观察的目标
  DynamicConfig config_;
};
}  // namespace rm