/*
 * @Description: 
 * @version: 
  
 * @Date: 2021-03-25 18:44:40
 * @LastEditors: Please set LastEditors
 * @LastEditTime: 2022-01-20 10:24:30
 */


/**
 * @file
 **/

#pragma once

#include <list>
#include <memory>
#include <string>
#include "lane_info.h"
#include "builder.h"
#include "intersection_virtual_lane_generator.h"
#include "global_parameters.h"

namespace rm {
 

class CorridorBuilder : public Builder {
 public:
  CorridorBuilder(  const std::shared_ptr<Observer>& observer,
                    const std::shared_ptr<DependencyInjector>& injector);

 private:
  common::Status Process(
      Frame* frame,
      LaneInfo* const current_lane_info) override;
      
  Corridor GenerateCorridor(std::pair<Boundary,Boundary> boundarys);
  Corridor GenerateCorridor(BoundarySegement left_seg, BoundarySegement right_seg, bool is_front_marker);
};

 
}  // namespace rm
