/*
 * @Author: your name
 * @Date: 2021-09-18 10:42:18
 * @LastEditTime: 2022-01-25 14:23:13
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath:
 * /NOP_EHR/media/igs/xnm/ros/RM/roadmodel/modules/task/deciders/lane_change_decider/lane_change_decider.cc
 */
#include "ilc_corridor_builder.h"

#include <iomanip>
#include <iostream>
#include <limits>
#include <memory>

#include "corridor.h"
#include "glog/logging.h"
#include "macros.h"
#include "status.h"
using namespace std;

namespace rm {

using rm::common::ErrorCode;
using rm::common::Status;

ILCCorridorBuilder::ILCCorridorBuilder(
    const std::shared_ptr<Observer> &observer,
    const std::shared_ptr<DependencyInjector> &injector)
    : Builder(observer, injector) {
  // CHECK(config_.has_corridor_builder_config());//config_在task类中
  // 相当于把config赋值给task中的config_
}

Status ILCCorridorBuilder::Process(Frame *frame,
                                   LaneInfo *const current_lane_info) {
  // DLOG(INFO) << "******** ilc corridor builder start********";
  if (current_lane_info->corridor().empty()) return Status::OK();
  if (current_lane_info->lane().lane_position() == rm::LanePosition::EGO_LANE) {
    state_machine_.SetTaskInput(frame, current_lane_info);
    state_machine_.RunOnce();
    state_machine_.TaskOutput(frame);
  }
  // DLOG(INFO) << "******** ilc corridor builder end ********";
  return Status::OK();
}

}  // namespace rm
