/*
 * @Description:
 * @version:

 * @Date: 2021-03-25 18:44:40
 * @LastEditors: Please set LastEditors
 * @LastEditTime: 2022-01-20 10:24:30
 */

/**
 * @file
 **/

#pragma once

#include <list>
#include <memory>
#include <string>

#include "builder.h"
#include "global_parameters.h"
#include "ilc_state_machine.h"
#include "lane_info.h"

namespace rm {

class ILCCorridorBuilder : public Builder {
 public:
  ILCCorridorBuilder(const std::shared_ptr<Observer> &observer,
                     const std::shared_ptr<DependencyInjector> &injector);

 private:
  common::Status Process(Frame *frame,
                         LaneInfo *const current_lane_info) override;
  ILCStateMachine state_machine_;
};

}  // namespace rm
