/*
 * @Description:
 * @version:

 * @Date: 2021-03-25 18:44:40
 * @LastEditors: Please set LastEditors
 * @LastEditTime: 2022-03-09 19:23:16
 */

/**
 * @file
 **/

#pragma once

#include <list>
#include <memory>
#include <string>

#include "builder.h"
#include "delay.h"
#include "enum_list.h"

namespace rm {

class ObjectAssignmentBuilder : public Builder {
 public:
  ObjectAssignmentBuilder(const std::shared_ptr<Observer>& observer,
                          const std::shared_ptr<DependencyInjector>& injector);

 private:
  common::Status Process(Frame* frame,
                         LaneInfo* const current_lane_info) override;
  // Delay delay_oncoming_;
  // Delay delay_rearobj_;
  // ros::NodeHandle n_;
  // ros::Publisher pub_ =
  // n_.advertise<visualization_msgs::Marker>("object_assignment", 10);
  void InCorridorCheck(const Lane& lane, Corridor* const corridor,
                       ObjectLocation& object_location, Obstacle& obstacle,
                       bool option);
  void InCorridorCheck(const Lane& lane, Corridor* const corridor,
                       ObjectLocation& object_location, Obstacle& obstacle,
                       bool option, double ego_offset, bool lane_changed_delay);
  Delay<bool> lane_change_falling_edge_delay_{0.0, 0.5, false};
};

}  // namespace rm
