/*
 * @Author: your name
 * @Date: 2021-09-14 17:01:52
 * @LastEditTime: 2021-12-23 09:17:13
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath: /NOP_EHR/media/igs/xnm/☆☆项目建档(禁删)☆☆/rm_task/module/task/task_factory.cc
 */


/**
 * @file
 **/

#include "task_factory.h"
#include <iostream>
#include "status.h"
#include "task.h"
#include "boundary_builder.h"
#include "corridor_builder.h"
#include "object_assignment_builder.h"
#include "ilc_corridor_builder.h"

using namespace std;
namespace rm {
 

rm::common::util::Factory<
    DynamicConfig::ConfigType, Task,
    Task* (*)(const std::shared_ptr<Observer>& observer,
              const std::shared_ptr<DependencyInjector>& injector),
    std::unordered_map<
        DynamicConfig::ConfigType,
        Task* (*)(const std::shared_ptr<Observer>& observer,
                  const std::shared_ptr<DependencyInjector>& injector),
        std::hash<int>>>
    TaskFactory::task_factory_;

void TaskFactory::Init() {
  task_factory_.Register(
      DynamicConfig::BOUNDARY_BUILDER,
      [](const std::shared_ptr<Observer>& observer,
         const std::shared_ptr<DependencyInjector>& injector) -> Task* {
        return new BoundaryBuilder(observer, injector);
      });
  task_factory_.Register(
      DynamicConfig::CORRIDOR_BUILDER,
      [](const std::shared_ptr<Observer>& observer,
         const std::shared_ptr<DependencyInjector>& injector) -> Task* {
        return new CorridorBuilder(observer, injector);
      });
  task_factory_.Register(
      DynamicConfig::OBJECT_ASSIGNMENT_BUILDER,
      [](const std::shared_ptr<Observer>& observer,
         const std::shared_ptr<DependencyInjector>& injector) -> Task* {
        return new ObjectAssignmentBuilder(observer, injector);
      });
  task_factory_.Register(
      DynamicConfig::ILC_CORRIDOR_BUILDER,
      [](const std::shared_ptr<Observer>& observer,
         const std::shared_ptr<DependencyInjector>& injector) -> Task* {
        return new ILCCorridorBuilder(observer, injector);
      });
}

std::unique_ptr<Task> TaskFactory::CreateTask(
    const std::shared_ptr<Observer> &observer,
    const std::shared_ptr<DependencyInjector>& injector) {
      
  return task_factory_.CreateObject(observer->getDynamicConfig()->config_type(), observer,
                                    injector);
}

 
}  // namespace rm
