/*
 * @Description: 
 * @version: 
  
 * @Date: 2021-06-02 09:43:15
 * @LastEditors: Please set LastEditors
 * @LastEditTime: 2021-12-23 09:17:22
 */


/**
 * @file
 **/

#pragma once

#include <memory>
#include <unordered_map>

#include "factory.h"
// #include "roadmodel_config.pb.h"
#include "task.h"
#include "observer.h"
namespace rm {
 

class TaskFactory {
 public:
  static void Init();
                   
  static std::unique_ptr<Task> CreateTask(
      const std::shared_ptr<Observer> &observer,
      const std::shared_ptr<DependencyInjector> &injector);

 private:
  static rm::common::util::Factory<
      DynamicConfig::ConfigType, 
      Task,
      Task *(*)(const std::shared_ptr<Observer> &observer,const std::shared_ptr<DependencyInjector> &injector),
      std::unordered_map<
          DynamicConfig::ConfigType,
          Task *(*)(const std::shared_ptr<Observer> &observer,const std::shared_ptr<DependencyInjector> &injector),
          std::hash<int>>>
      task_factory_;
};

 
}  // namespace rm
