/*
 * @Author: your name
 * @Date: 2022-03-09 17:59:19
 * @LastEditTime: 2022-03-09 18:25:11
 * @LastEditors: Please set LastEditors
 * @Description: 打开koroFileHeader查看配置 进行设置:
 * https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 * @FilePath: /dev_roadmodel_ros2/src/mpc_drv_ctAp_rm/src/update_local_view.h
 */
#pragma once

#include <chrono>
#include <iostream>
#include <mutex>
#include <thread>

// #include "cem_interfaces/msg/traffic_participant_struct.hpp"
#include "impl_type_trafficparticipantstruct.h"
// #include "cem_interfaces/msg/traffic_road_edge_struct.hpp"
// #include "cem_interfaces/msg/traffic_road_struct.hpp"
#include "impl_type_slam_road_model.h"
// #include "cem_interfaces/msg/map_scene.hpp"
#include "common/base/ros_recv.h"
// #include "loc_msgs/msg/odometry.hpp"
#include "impl_type_slam_odometry.h"
// #include "mpc_drv_msgs/msg/msg_sm2_trpc.hpp"
// #include "mpc_drv_msgs/msg/vehicle_state_output.hpp"
#include "impl_type_ved4dpc.h"
// #include "nav_msgs/msg/occupancy_grid.hpp"
#include "road/local_view.h"
// #include "vehicle_msgs/msg/ap_ibs20ms_pdu15.hpp"
// #include "vehicle_msgs/msg/ap_sas10ms_pdu00.hpp"
// #include "vehicle_msgs/msg/can_copy_cp2_ap10ms_struct.hpp"
// #include "vehicle_msgs/msg/can_copy_cp2_ap20ms_struct.hpp"
// #include "vehicle_msgs/msg/can_copy_cp2_ap50ms_struct.hpp"

using namespace rm;
void UpdateLocalView(
    LocalView &local_view,
    RosRecv<dpc::slam_road_model> &traffic_road,
    // RosRecv<cem_interfaces::msg::TrafficRoadEdgeStruct> &traffic_road_edge,
    RosRecv<dpc::TrafficParticipantStruct> &traffic_Participant,
    RosRecv<dpc::VED4DPC> &vehicle_state,
    // RosRecv<mpc_drv_msgs::msg::SMWaypoints> &sm_waypoints,
    // RosRecv<nav_msgs::msg::OccupancyGrid> &traffic_freespace,
    RosRecv<dpc::slam_odometry> &traffic_odometry
    // RosRecv<vehicle_msgs::msg::CanCopyCp2Ap50msStruct> &cp2ap50ms_recv,
    // RosRecv<vehicle_msgs::msg::CanCopyCp2Ap20msStruct> &cp2ap20ms_recv,
    // RosRecv<vehicle_msgs::msg::CanCopyCp2Ap10msStruct> &cp2ap10ms_recv,
    // RosRecv<vehicle_msgs::msg::ApIbs20msPdu15> &ibs_20ms_pdu15,
    // RosRecv<vehicle_msgs::msg::ApSas10msPdu00> &sas_10ms_pdu00,
    // RosRecv<mpc_drv_msgs::msg::MsgSM2TRPC> &sm_info_recv,
    // RosRecv<cem_interfaces::msg::MapScene> &ehr_mapscene_recv
    ) {
  //   DLOG(INFO) << "*********************num of received
  //   objects*********************";
  {
        //std::lock_guard<std::mutex> lock(traffic_road.data_mutex_);
    local_view.traffic_road =
        std::make_shared<dpc::slam_road_model>(
            traffic_road.data_); //静态环境信息
  }
  // {
  //   //std::lock_guard<std::mutex> lock(traffic_road_edge.data_mutex_);
  //   local_view.traffic_road_edge =
  //       std::make_shared<cem_interfaces::msg::TrafficRoadEdgeStruct>(
  //           traffic_road_edge); // road edge info
  // }
  {
    //std::lock_guard<std::mutex> lock(traffic_Participant.data_mutex_);
    local_view.traffic_participant =
        std::make_shared<dpc::TrafficParticipantStruct>(
            traffic_Participant.data_); //交通参与者
    // DLOG(INFO) << PRINT(local_view.traffic_participant->NumberOfObjects);
  }
  {
    //std::lock_guard<std::mutex> lock(vehicle_state.data_mutex_);
    local_view.vehicle_state =
        std::make_shared<dpc::VED4DPC>(
            vehicle_state.data_); //交通参与者
    // DLOG(INFO) << PRINT(local_view.traffic_participant->NumberOfObjects);
  }
  // {
  //   //std::lock_guard<std::mutex> lock(sm_waypoints.data_mutex_);
  //   local_view.sm_waypoints = std::make_shared<mpc_drv_msgs::msg::SMWaypoints>(
  //       sm_waypoints); //交通参与者
  //   // DLOG(INFO) << PRINT(local_view.traffic_participant->NumberOfObjects);
  // }
  // {
  //   //std::lock_guard<std::mutex> lock(cp2ap50ms_recv.data_mutex_);
  //   local_view.bcm_50ms_pdu02 =
  //       std::make_shared<vehicle_msgs::msg::ApBcm50msPdu02>(
  //           cp2ap50ms_recv.bcm50mspdu02); //交通参与者
  // }
  // {
  //   //std::lock_guard<std::mutex> lock(cp2ap20ms_recv.data_mutex_);
  //   local_view.ibs_20ms_pdu08 =
  //       std::make_shared<vehicle_msgs::msg::ApIbs20msPdu08>(
  //           cp2ap20ms_recv.ibs20mspdu08); //交通参与者
  //   local_view.ibs_20ms_pdu18 =
  //       std::make_shared<vehicle_msgs::msg::ApIbs20msPdu18>(
  //           cp2ap20ms_recv.ibs20mspdu18); //交通参与者
  // }
  // {
  //   //std::lock_guard<std::mutex> lock(cp2ap10ms_recv.data_mutex_);
  //   local_view.eps_10ms_pdu00 =
  //       std::make_shared<vehicle_msgs::msg::ApEps010msPdu00>(
  //           cp2ap10ms_recv.eps010mspdu00);
  // }
  // {
  //   //std::lock_guard<std::mutex> lock(ibs_20ms_pdu15.data_mutex_);
  //   local_view.ibs_20ms_pdu15 =
  //       std::make_shared<vehicle_msgs::msg::ApIbs20msPdu15>(
  //           ibs_20ms_pdu15); //交通参与者
  //   // DLOG(INFO) << PRINT(local_view.ibs_20ms_pdu15->NumberOfObjects);
  // }
  // {
  //   //std::lock_guard<std::mutex> lock(sas_10ms_pdu00.data_mutex_);
  //   local_view.sas_10ms_pdu00 =
  //       std::make_shared<vehicle_msgs::msg::ApSas10msPdu00>(
  //           sas_10ms_pdu00); //交通参与者
  //   // DLOG(INFO) << PRINT(local_view.sas_10ms_pdu00->NumberOfObjects);
  // }
  // {
  //   //std::lock_guard<std::mutex> lock(traffic_freespace.data_mutex_);
  //   local_view.traffic_freespace =
  //       std::make_shared<nav_msgs::msg::OccupancyGrid>(
  //           traffic_freespace); // road edge info
  // }
  {
    //std::lock_guard<std::mutex> lock(traffic_odometry.data_mutex_);
    local_view.traffic_odometry = std::make_shared<dpc::slam_odometry>(
        traffic_odometry.data_); // road edge info
  }
  // {
  //   //std::lock_guard<std::mutex> lock(sm_info_recv.data_mutex_);
  //   local_view.sm_info = std::make_shared<mpc_drv_msgs::msg::MsgSM2TRPC>(
  //       sm_info_recv); // sm info
  // }
  // {
  //   //std::lock_guard<std::mutex> lock(ehr_mapscene_recv .data_mutex_);
  //   local_view.ehr_mapscene = std::make_shared<cem_interfaces::msg::MapScene>(
  //       ehr_mapscene_recv); // ehr map scene info
  // }
}
