#ifndef EM_GENERAL_WRAPPER_HEADER_H
#define EM_GENERAL_WRAPPER_HEADER_H
#include "pub/PubWrapperHelper.h"
#include "pub/PubDataWrapper.h"
#include "sub/SubWrapperHelper.h"
#include "EM_PubDataWrapper.h"
#include "EM_SubDataWrapper.h"
#include "dpc_em/executable.h"

// using namespace huawei::ap::sample::skeleton;
using namespace jac::ap::emservice::skeleton;
using namespace jac::ap::slamservice::proxy;
using namespace jac::ap::fusionservice::proxy;
using namespace jac::ap::canservice::proxy;

//PubWrappers
GENERATE_PUB_WRAPPER(EM2TRPCLongTargetsInfo_Provide, EM2TRPCLongTargetsInfo_PubDataWrapper, EMServiceSkeleton, dpc::TargetsInfo, TargetsInfoEvent);
GENERATE_PUB_WRAPPER(EM2TRPCLongTargetInfo_Provide, EM2TRPCLongTargetInfo_PubDataWrapper, EMServiceSkeleton, dpc::TargetInfo, TargetInfoEvent);
GENERATE_PUB_WRAPPER(EM2TRPCLongRoadEdgeInfo_Provide, EM2TRPCLongRoadEdgeInfo_PubDataWrapper, EMServiceSkeleton, dpc::RoadEdgeInfo, RoadEdgeInfoEvent);
GENERATE_PUB_WRAPPER(EM2TRPCLongLaneMarkerInfo_Provide, EM2TRPCLongLaneMarkerInfo_PubDataWrapper, EMServiceSkeleton, dpc::LaneMarkerInfo, LaneMarkerInfoEvent);
GENERATE_PUB_WRAPPER(EM2DMRoadInfo_Provide, EM2DMRoadInfo_PubDataWrapper, EMServiceSkeleton, dpc::RoadInfo, RoadInfoEvent);
GENERATE_PUB_WRAPPER(EM2DMRMHeader_Provide, EM2DMRMHeader_PubDataWrapper, EMServiceSkeleton, dpc::RMHeader, RMHeaderEvent);
GENERATE_PUB_WRAPPER(EM2DMIndex_Provide, EM2DMIndex_PubDataWrapper, EMServiceSkeleton, dpc::Index, IndexEvent);
GENERATE_PUB_WRAPPER(EM2DMCarPosition_Provide, EM2DMCarPosition_PubDataWrapper, EMServiceSkeleton, dpc::CarPosition, CarPositionEvent);
GENERATE_PUB_WRAPPER(EM2DMLane_Provide, EM2DMLane_PubDataWrapper, EMServiceSkeleton, dpc::Lane, LaneEvent);
GENERATE_PUB_WRAPPER(EM2DMLaneMarker_Provide, EM2DMLaneMarker_PubDataWrapper, EMServiceSkeleton, dpc::LaneMarker, LaneMarkerEvent);
GENERATE_PUB_WRAPPER(EM2DMObject_Provide, EM2DMObject_PubDataWrapper, EMServiceSkeleton, dpc::Object, ObjectEvent);
GENERATE_PUB_WRAPPER(EM2DMRoadEdge_Provide, EM2DMRoadEdge_PubDataWrapper, EMServiceSkeleton, dpc::RoadEdge, RoadEdgeEvent);
GENERATE_PUB_WRAPPER(EM2DMNeighborLane_Provide, EM2DMNeighborLane_PubDataWrapper, EMServiceSkeleton, dpc::NeighborLane, NeighborLaneEvent);
GENERATE_PUB_WRAPPER(EM2DMCorridor_Provide, EM2DMCorridor_PubDataWrapper, EMServiceSkeleton, dpc::Corridor, CorridorEvent);
GENERATE_PUB_WRAPPER(EM2DMSamplingPoint_Provide, EM2DMSamplingPoint_PubDataWrapper, EMServiceSkeleton, dpc::SamplingPoint, SamplingPointEvent);
GENERATE_PUB_WRAPPER(EM2DMLineColor_Provide, EM2DMLineColor_PubDataWrapper, EMServiceSkeleton, dpc::LineColor, LineColorEvent);
GENERATE_PUB_WRAPPER(EM2DMLineType_Provide, EM2DMLineType_PubDataWrapper, EMServiceSkeleton, dpc::LineType, LineTypeEvent);
GENERATE_PUB_WRAPPER(EM2DMObjectLocation_Provide, EM2DMObjectLocation_PubDataWrapper, EMServiceSkeleton, dpc::ObjectLocation, ObjectLocationEvent);
GENERATE_PUB_WRAPPER(EM2DMSLPoint_Provide, EM2DMSLPoint_PubDataWrapper, EMServiceSkeleton, dpc::SLPoint, SLPointEvent);
GENERATE_PUB_WRAPPER(EM2DMLaneControl_Provide, EM2DMLaneControl_PubDataWrapper, EMServiceSkeleton, dpc::LaneControl, LaneControlEvent);
GENERATE_PUB_WRAPPER(EM2DMLaneBoundary_Provide, EM2DMLaneBoundary_PubDataWrapper, EMServiceSkeleton, dpc::LaneBoundary, LaneBoundryEvent);
GENERATE_PUB_WRAPPER(EM2DMLineGeometry_Provide, EM2DMLineGeometry_PubDataWrapper, EMServiceSkeleton, dpc::LineGeometry, LineGeometryEvent);
GENERATE_PUB_WRAPPER(EM2DMRoadEdgeSegment_Provide, EM2DMRoadEdgeSegment_PubDataWrapper, EMServiceSkeleton, dpc::RoadEdgeSegment, RoadEdgeSegmentEvent);
GENERATE_PUB_WRAPPER(EM2SMRMSMMessage_Provide, EM2SMRMSMMessage_PubDataWrapper, EMServiceSkeleton, dpc::RMSMMessage, RMSMMessageEvent);
GENERATE_PUB_WRAPPER(EM2SMLaneInfo_Provide, EM2SMLaneInfo_PubDataWrapper, EMServiceSkeleton, dpc::LaneInfo, LaneInfoEvent);
GENERATE_PUB_WRAPPER(EM2SMLeftLine_Provide, EM2SMLeftLine_PubDataWrapper, EMServiceSkeleton, dpc::LeftLine, LeftLineEvent);
GENERATE_PUB_WRAPPER(EM2SMRightLine_Provide, EM2SMRightLine_PubDataWrapper, EMServiceSkeleton, dpc::RightLine, RightLineEvent);
GENERATE_PUB_WRAPPER(EM2SMRightRoadEdge_Provide, EM2SMRightRoadEdge_PubDataWrapper, EMServiceSkeleton, dpc::RightRoadEdge, RightRoadEdgeEvent);
GENERATE_PUB_WRAPPER(EM2SMLeftRoadEdge_Provide, EM2SMLeftRoadEdge_PubDataWrapper, EMServiceSkeleton, dpc::LeftRoadEdge, LeftRoadEdgeEvent);
GENERATE_PUB_WRAPPER(EM2SMODDInfo_Provide, EM2SMODDInfo_PubDataWrapper, EMServiceSkeleton, dpc::ODDInfo, ODDInfoEvent);
GENERATE_PUB_WRAPPER(EM2SMRMEgoLftLnegeometry_Provide, EM2SMRMEgoLftLnegeometry_PubDataWrapper, EMServiceSkeleton, dpc::RMEgoLftLnegeometry, RMEgoLftLnegeometryEvent);
GENERATE_PUB_WRAPPER(EM2SMRMEgoRgtLnegeometry_Provide, EM2SMRMEgoRgtLnegeometry_PubDataWrapper, EMServiceSkeleton, dpc::RMEgoRgtLnegeometry, RMEgoRgtLnegeometryEvent);
GENERATE_PUB_WRAPPER(EM2SMRMRdEdgeLftgeometry_Provide, EM2SMRMRdEdgeLftgeometry_PubDataWrapper, EMServiceSkeleton, dpc::RMRdEdgeLftgeometry, RMRdEdgeLftgeometryEvent);
GENERATE_PUB_WRAPPER(EM2SMRMRdEdgeRgtgeometry_Provide, EM2SMRMRdEdgeRgtgeometry_PubDataWrapper, EMServiceSkeleton, dpc::RMRdEdgeRgtgeometry, RMRdEdgeRgtgeometryEvent);

// //SubWrappers
GENERATE_SUB_WRAPPER(SLAM2EMposition_Required, SLAM2EMposition_SubDataWrapper, SLAMServiceProxy, dpc::position, PositionEvent, "8", 10);
GENERATE_SUB_WRAPPER(SLAM2EMattribute_Required, SLAM2EMattribute_SubDataWrapper, SLAMServiceProxy, dpc::attribute, AttributeEvent, "8", 10);
GENERATE_SUB_WRAPPER(SLAM2EMline_point_Required, SLAM2EMline_point_SubDataWrapper, SLAMServiceProxy, dpc::line_point, LinePointEvent, "8", 10);
GENERATE_SUB_WRAPPER(SLAM2EMline_Required, SLAM2EMline_SubDataWrapper, SLAMServiceProxy, dpc::line, LineEvent, "8", 10);
GENERATE_SUB_WRAPPER(SLAM2EMspeed_limit_Required, SLAM2EMspeed_limit_SubDataWrapper, SLAMServiceProxy, dpc::speed_limit, SpeedLimitEvent, "8", 10);
GENERATE_SUB_WRAPPER(SLAM2EMtraffic_object_Required, SLAM2EMtraffic_object_SubDataWrapper, SLAMServiceProxy, dpc::traffic_object, TrafficObjectEvent, "8", 10);
GENERATE_SUB_WRAPPER(SLAM2EMlane_Required, SLAM2EMlane_SubDataWrapper, SLAMServiceProxy, dpc::Lane, LaneEventSlam, "8", 10);
GENERATE_SUB_WRAPPER(SLAM2EMroad_edge_Required, SLAM2EMroad_edge_SubDataWrapper, SLAMServiceProxy, dpc::RoadEdge, RoadEdgeEvent, "8", 10);
GENERATE_SUB_WRAPPER(SLAM2EMslam_road_model_Required, SLAM2EMslam_road_model_SubDataWrapper, SLAMServiceProxy, dpc::slam_road_model, SLAMRoadModelEvent, "8", 10);
GENERATE_SUB_WRAPPER(FusionObjects_Required, FusionObjects_SubDataWrapper, FusionServiceProxy, dpc::TrafficParticipantStruct, ObjectEvent, "7", 10);
GENERATE_SUB_WRAPPER(CAN2EM_Required, CAN2EM_SubDataWrapper, CANServiceProxy, CAN2SWC, CAN2SWCEvent, "3", 10);

class GeneralWrapper {
public:
    //Providers
    EM2TRPCLongTargetsInfo_Provide  _EM2TRPCLongTargetsInfo_Provide;
    EM2TRPCLongTargetInfo_Provide  _EM2TRPCLongTargetInfo_Provide;
    EM2TRPCLongRoadEdgeInfo_Provide  _EM2TRPCLongRoadEdgeInfo_Provide;
    EM2TRPCLongLaneMarkerInfo_Provide  _EM2TRPCLongLaneMarkerInfo_Provide;
    EM2DMRoadInfo_Provide  _EM2DMRoadInfo_Provide;
    EM2DMRMHeader_Provide  _EM2DMRMHeader_Provide;
    EM2DMIndex_Provide  _EM2DMIndex_Provide;
    EM2DMCarPosition_Provide  _EM2DMCarPosition_Provide;
    EM2DMLane_Provide  _EM2DMLane_Provide;
    EM2DMLaneMarker_Provide  _EM2DMLaneMarker_Provide;
    EM2DMObject_Provide  _EM2DMObject_Provide;
    EM2DMRoadEdge_Provide  _EM2DMRoadEdge_Provide;
    EM2DMNeighborLane_Provide  _EM2DMNeighborLane_Provide;
    EM2DMCorridor_Provide  _EM2DMCorridor_Provide;
    EM2DMSamplingPoint_Provide  _EM2DMSamplingPoint_Provide;
    EM2DMLineColor_Provide  _EM2DMLineColor_Provide;
    EM2DMLineType_Provide  _EM2DMLineType_Provide;
    EM2DMObjectLocation_Provide  _EM2DMObjectLocation_Provide;
    EM2DMSLPoint_Provide  _EM2DMSLPoint_Provide;
    EM2DMLaneControl_Provide  _EM2DMLaneControl_Provide;
    EM2DMLaneBoundary_Provide  _EM2DMLaneBoundary_Provide;
    EM2DMLineGeometry_Provide  _EM2DMLineGeometry_Provide;
    EM2DMRoadEdgeSegment_Provide  _EM2DMRoadEdgeSegment_Provide;
    EM2SMRMSMMessage_Provide  _EM2SMRMSMMessage_Provide;
    EM2SMLaneInfo_Provide  _EM2SMLaneInfo_Provide;
    EM2SMLeftLine_Provide  _EM2SMLeftLine_Provide;
    EM2SMRightLine_Provide  _EM2SMRightLine_Provide;
    EM2SMRightRoadEdge_Provide  _EM2SMRightRoadEdge_Provide;
    EM2SMLeftRoadEdge_Provide  _EM2SMLeftRoadEdge_Provide;
    EM2SMODDInfo_Provide  _EM2SMODDInfo_Provide;
    EM2SMRMEgoLftLnegeometry_Provide  _EM2SMRMEgoLftLnegeometry_Provide;
    EM2SMRMEgoRgtLnegeometry_Provide  _EM2SMRMEgoRgtLnegeometry_Provide;
    EM2SMRMRdEdgeLftgeometry_Provide  _EM2SMRMRdEdgeLftgeometry_Provide;
    EM2SMRMRdEdgeRgtgeometry_Provide  _EM2SMRMRdEdgeRgtgeometry_Provide;

    //Requireds
    SLAM2EMposition_Required  _SLAM2EMposition_Required;
    SLAM2EMattribute_Required  _SLAM2EMattribute_Required;
    SLAM2EMline_point_Required  _SLAM2EMline_point_Required;
    SLAM2EMline_Required  _SLAM2EMline_Required;
    SLAM2EMspeed_limit_Required  _SLAM2EMspeed_limit_Required;
    SLAM2EMtraffic_object_Required  _SLAM2EMtraffic_object_Required;
    SLAM2EMlane_Required  _SLAM2EMlane_Required;
    SLAM2EMroad_edge_Required  _SLAM2EMroad_edge_Required;
    SLAM2EMslam_road_model_Required  _SLAM2EMslam_road_model_Required;
    FusionObjects_Required  _FusionObjects_Required;
    CAN2EM_Required _CAN2EM_Required;

    GeneralWrapper(ara::log::Logger& mainLog);
    ~GeneralWrapper();
};


#endif
