#ifndef EMPubDataWrapper_WRAPPER_HEADER_H
#define EMPubDataWrapper_WRAPPER_HEADER_H

#include "pub/PubDataWrapper.h"
#include "dpc_em/executable.h"
#include <random>

template <typename EventType>
class EM2TRPCLongTargetsInfo_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::TargetsInfo _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::TargetsInfo>(std::move(_data));
    }

    void SetData(dpc::TargetsInfo& data)
    {
        _data = std::move(data);
    }

};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2TRPCLongTargetInfo_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::TargetInfo _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::TargetInfo>(std::move(_data));
    }

    void SetData(dpc::TargetInfo& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2TRPCLongRoadEdgeInfo_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::RoadEdgeInfo _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::RoadEdgeInfo>(std::move(_data));
    }

    void SetData(dpc::RoadEdgeInfo& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2TRPCLongLaneMarkerInfo_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::LaneMarkerInfo _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::LaneMarkerInfo>(std::move(_data));
    }

    void SetData(dpc::LaneMarkerInfo& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2DMRoadInfo_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::RoadInfo _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::RoadInfo>(std::move(_data));
    }

    void SetData(dpc::RoadInfo& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2DMRMHeader_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::RMHeader _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::RMHeader>(std::move(_data));
    }

    void SetData(dpc::RMHeader& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2DMIndex_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::Index _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::Index>(std::move(_data));
    }

    void SetData(dpc::Index& data)
    {
        _data = std::move(data);
    }

};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2DMCarPosition_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::CarPosition _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::CarPosition>(std::move(_data));
    }

    void SetData(dpc::CarPosition& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2DMLane_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::Lane _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::Lane>(std::move(_data));
    }

    void SetData(dpc::Lane& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2DMLaneMarker_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::LaneMarker _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::LaneMarker>(std::move(_data));
    }

    void SetData(dpc::LaneMarker& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2DMObject_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::Object _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::Object>(std::move(_data));
    }

    void SetData(dpc::Object& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2DMRoadEdge_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::RoadEdge _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::RoadEdge>(std::move(_data));
    }

    void SetData(dpc::RoadEdge& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2DMNeighborLane_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::NeighborLane _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::NeighborLane>(std::move(_data));
    }

    void SetData(dpc::NeighborLane& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2DMCorridor_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::Corridor _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::Corridor>(std::move(_data));
    }

    void SetData(dpc::Corridor& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2DMSamplingPoint_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::SamplingPoint _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::SamplingPoint>(std::move(_data));
    }

    void SetData(dpc::SamplingPoint& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2DMLineColor_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::LineColor _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::LineColor>(std::move(_data));
    }

    void SetData(dpc::LineColor& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2DMLineType_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::LineType _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::LineType>(std::move(_data));
    }

    void SetData(dpc::LineType& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2DMObjectLocation_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::ObjectLocation _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::ObjectLocation>(std::move(_data));
    }

    void SetData(dpc::ObjectLocation& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2DMSLPoint_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::SLPoint _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::SLPoint>(std::move(_data));
    }

    void SetData(dpc::SLPoint& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2DMLaneControl_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::LaneControl _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::LaneControl>(std::move(_data));
    }

    void SetData(dpc::LaneControl& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2DMLaneBoundary_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::LaneBoundary _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::LaneBoundary>(std::move(_data));
    }

    void SetData(dpc::LaneBoundary& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2DMLineGeometry_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::LineGeometry _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::LineGeometry>(std::move(_data));
    }

    void SetData(dpc::LineGeometry& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2DMRoadEdgeSegment_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::RoadEdgeSegment _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::RoadEdgeSegment>(std::move(_data));
    }

    void SetData(dpc::RoadEdgeSegment& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2SMRMSMMessage_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::RMSMMessage _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::RMSMMessage>(std::move(_data));
    }

    void SetData(dpc::RMSMMessage& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2SMLaneInfo_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::LaneInfo _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::LaneInfo>(std::move(_data));
    }

    void SetData(dpc::LaneInfo& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2SMLeftLine_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::LeftLine _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::LeftLine>(std::move(_data));
    }

    void SetData(dpc::LeftLine& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2SMRightLine_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::RightLine _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::RightLine>(std::move(_data));
    }

    void SetData(dpc::RightLine& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2SMRightRoadEdge_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::RightRoadEdge _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::RightRoadEdge>(std::move(_data));
    }

    void SetData(dpc::RightRoadEdge& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2SMLeftRoadEdge_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::LeftRoadEdge _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::LeftRoadEdge>(std::move(_data));
    }

    void SetData(dpc::LeftRoadEdge& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2SMODDInfo_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::ODDInfo _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::ODDInfo>(std::move(_data));
    }

    void SetData(dpc::ODDInfo& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2SMRMEgoLftLnegeometry_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::RMEgoLftLnegeometry _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::RMEgoLftLnegeometry>(std::move(_data));
    }

    void SetData(dpc::RMEgoLftLnegeometry& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2SMRMEgoRgtLnegeometry_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::RMEgoRgtLnegeometry _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::RMEgoRgtLnegeometry>(std::move(_data));
    }

    void SetData(dpc::RMEgoRgtLnegeometry& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2SMRMRdEdgeLftgeometry_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::RMRdEdgeLftgeometry _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::RMRdEdgeLftgeometry>(std::move(_data));
    }

    void SetData(dpc::RMRdEdgeLftgeometry& data)
    {
        _data = std::move(data);
    }
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename EventType>
class EM2SMRMRdEdgeRgtgeometry_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::RMRdEdgeRgtgeometry _data;
public:
    void GetData(ara::com::SampleAllocateePtr<EventType>& data) override
    {
        data = std::make_unique<dpc::RMRdEdgeRgtgeometry>(std::move(_data));
    }

    void SetData(dpc::RMRdEdgeRgtgeometry& data)
    {
        _data = std::move(data);
    }

};

#endif // EMPubDataWrapper_WRAPPER_HEADER_H
