 
#ifdef __cplusplus
extern "C" {
#endif

#include "Fusion_SLAM_types.h"
#include "Fusion_main.h"

#define FUSION_RECONSITUTION

#include "TueObjFusn_ObjectListType.h"
#ifdef RESNICS
#include "Sensor_LidarProcess.h"
#endif
// #include "Sensor_RadarProcess.h"
#include "Sensor_LidarProcess.h"
#include "Sensor_CameraProcess.h"
#include "TueObjFusn_ErrorCodes.h"
#include "tue_prv_objectSelection_int.h"
#include "ContiRadarConverter.h"
	
#include "SimUtils.h"
#include "TueObjFusn_Params.h" //guotao 20190508 add for fusion
#include "tue_Fusion.h"
#include "sfObjectFusionMpf_func.h"
#include <string.h>

#include "fusion_ext.h"

//#include "TueObjFusn_ErrorBufferType.h" 
//#include "TueObjFusn_EgoMotionType.h" 
#ifdef TRIBOARD_TC37XA
#pragma section  ".data_cpu1"
#endif

// static TueObjFusn_EgoMotionType fusion_in_ego_motion;
static Lidar_input_lists fusion_in_lidar_objects;
static Camera_input_lists fusion_in_camera_objects;

static Fusion_Out_ObjectList_t fusion_out_objs;
static Fusn_ErrorBufferOut fusion_out_error_buf;

float32 ego_veh_lateral_curvature;

#ifdef FUSION_RECONSITUTION
// static TueObjFusn_ObjectListType FusionInRadarObjects;
static TueObjFusn_ObjectListType FusionInLidarObjects;
static TueObjFusn_ObjectListType FusionInCameraObjects;

//this array saved the mapping relationship of FusionTrackID -> FPSObjectID.
//TrackIdToObjectIdMap[394] = 25, which meas 394th fusion track saved in the 25th element of EnvmData.pPrivObjList[] 
static int TrackIdToObjectIdMap[TUEOBJFUSN_IDPROVIDER_U16ID_MAX + 1];
static TueObjFusn_ObjectListType pFusnObjLists_Output;
static TueObjFusn_ErrorBufferType pErrorBuffer;
static TueObjFusn_EgoMotionType FusionInputEgoMotion = 
{
	0,
	0,
	0,
	0.,
	0.,
	0.,
	0.
};

extern VehDyn_t* FusionInput_RawData;
// extern ExtObjectList_t* FusionInput_RadarObjList;
//extern LidarObjectList_t* FusionInput_LidarObjList;
extern Lidar_input_lists* Lidartemp;
//extern CamObjectList* FusionInput_CameraObjList;
extern Camera_input_lists* Cameratemp;
extern ObjectList_t FusionOutput_ObjList;
extern SimTimestamp fusion_cycle_ts;
extern uint32 system_ts;

#endif


#if ALGO_TUE_TTTA_OBJECT_FUSION_SWITCH
//this array saved the mapping relationship of FusionTrackID -> FPSObjectID.
//TrackIdToObjectIdMap[394] = 25, which meas 394th fusion track saved in the 25th element of EnvmData.pPrivObjList[] 
	static int TrackIdToObjectIdMap[TUEOBJFUSN_IDPROVIDER_U16ID_MAX + 1];
	static TueObjFusn_ObjectListType pFusnObjLists_Output;
	static TueObjFusn_ErrorBufferType pErrorBuffer;
	static TueObjFusn_EgoMotionType EgoMotion = 
	{
		0,
		0,
		0,
		0.,
		0.,
		0.,
		0.
	};
#endif

/*==================[Functions]=============================================*/
static void convert_lidar_objs(
    LidarObjectList_t* const conv_lidar_objs,
    const Lidar_input_lists* const Lidartemp
);

static void convert_lidar_obj(
    LidarObjects_t* const conv_lidar_obj,
    const Lidar_In_Objects_t* const in_lidar_obj
);

static void convert_camera_objs(                             
    CamObjectList* const conv_camera_objs,
    const Camera_input_lists* const Cameratemp
);

static void convert_camera_obj(                           
    CamObject* const conv_camera_obj,
    const Camera_In_Objects_t* const in_camera_obj
);

static void convert_fusion_objs(  
    Fusion_Out_ObjectList_t* const conv_fusion_objs ,
    const TueObjFusn_ObjectListType* const in_fusion_objs
);
static void convert_fusion_obj(    
    Fusion_Out_Objects_t* const conv_fusion_obj,
    const TueObjFusn_TrackableType* const in_fusion_obj     
);

static void convert_fusion_errors(
    Fusn_ErrorBufferOut* const conv_fus_error,
    const TueObjFusn_ErrorBufferType* const in_fus_error
);


//FIXME: Note that since we are using uint32 for timestamp,
// It can only represent up to 2^32 microseconds before overflowing.
// Therefore, if you do the math, it can hold about an hour timestamp

// Possible implementations:
// 1. Calculating with respect to a base time
// static uint32 DLG_STM1_GET_HIGHRES_TIMESTAMP(){
// 	static boolean init = TRUE;
// 	struct timeval t1;
// 	static uint64 base_timestamp = 0;
// 	if (init){
// 		gettimeofday(&t1, NULL);
// 		base_timestamp = t1.tv_sec * (uint32) 1e6 + t1.tv_usec;
// 		init = FALSE;
// 	}
// 	gettimeofday(&t1, NULL);
// 	uint64 current_time = t1.tv_sec * (uint32) 1e6 + t1.tv_usec;
// 	uint32 timestamp = (uint32) (current_time - base_timestamp);
// 	return timestamp;
// }

// 2. Real system timestamp - Note that the result might overflow
// static uint32 DLG_STM1_GET_HIGHRES_TIMESTAMP(){
// 	struct timeval t;
// 	gettimeofday(&t, NULL);
// 	uint32 timestamp = (uint32) (t.tv_sec * (uint32) 1e6 + t.tv_usec);
// 	return timestamp;
// }

// 3. use FusionInput_RawData->sSigHeader.uiTimeStamp instead

/**
 * @brief Returns system timestmap
 * 
 * System timestamp in microsecond is calculated and
 * retireved. When the code is implemented on the actual
 * embededd system, this function will return currect system timestamp.
 * However, while we're doing simulation, it will return last ego vehicle
 * timestamp value.
 * 
 * @return system timestamp is returned
*/
static uint32 DLG_STM1_GET_HIGHRES_TIMESTAMP(){
	// printf("Current sts: ");
	// printf("%u\n", system_ts);
	return system_ts;
	// return fusion_cycle_ts.timestamp[fusion_cycle_ts.idx];
}

/**
 * @brief Calculates fusion cycle time
 * 
 * This function returns fusion cycle time. The first time it is called, the base time is calculated
 * and next time it is called, the difference in time in seconds is returned. Also, new time is 
 * saved into the memory for the next calls of this function.
 * 
 * @param[out] cycle_time
 * 
 * @return cycletime in seconds
*/
static float32 EM_f_GetCycleTime(){
	static boolean init = TRUE;
	static uint32 pre_ts = 0u;
	uint32 current_ts = DLG_STM1_GET_HIGHRES_TIMESTAMP();
	float32 f32Dt = 0.f;
	if (init)
		init = FALSE;
	else
		f32Dt = (float32) (current_ts - pre_ts) / 1e6;
	pre_ts = current_ts;
	return f32Dt;
}

//#if ALGO_TUE_TTTA_OBJECT_FUSION_SWITCH

/**
 * @brief Initializes fusion parameters
 * 
 * Initialization is done by calling sfObjectFusionMpf_Init_wrapper
 * 
 * 
 * @return Nothing
*/
void Fusion_Init(void)
{

		memset(TrackIdToObjectIdMap, -1, sizeof(int) * (TUEOBJFUSN_IDPROVIDER_U16ID_MAX + 1));
	
		sfObjectFusionMpf_Init_wrapper(
			16778240,//3641720, //This parameter is logical OR of the sensors pattern ID //(0x1000400u) TUEOBJFUSN_TRACKABLE_U32SENSOR_MVS_FRONT | TUEOBJFUSN_TRACKABLE_U32SENSOR_LIDAR_FRONT_CENTER
			20.0f,
			0.1f,
			0.01f,
			0.1f,
			0.01f,
			TRUE,
			FALSE,
			FALSE,
			TRUE,
			FALSE);
		//sfObjectFusionMpf_Init_wrapper(
		//	TUEOBJFUSN_PARAMS_U32SENSORMODE_DEFAULT,
		//	TUEOBJFUSN_PARAMS_F32MATCHGATE_DEFAULT,
		//	TUEOBJFUSN_PARAMS_F32PEDESTRIANVARIANCEINXFORQ_DEFAULT,
		//	TUEOBJFUSN_PARAMS_F32PEDESTRIANVARIANCEINYFORQ_DEFAULT,
		//	TUEOBJFUSN_PARAMS_F32PEDESTRIANVARIANCEINXFORQ_DEFAULT,
		//	TUEOBJFUSN_PARAMS_F32PEDESTRIANVARIANCEINYFORQ_DEFAULT,
		//	TRUE,
		//	FALSE,
		//	TUEOBJFUSN_PARAMS_BOUTPUTISOVERGROUND_DEFAULT,
		//	TUEOBJFUSN_PARAMS_BUSECOASTING_DEFAULT,
		//	FALSE);//set default value for testing now

}


#ifdef FUSION_RECONSITUTION

/**
 * @brief Prepares input to the fusion process
 * 
 * Two object lists for lidar and camera are created and filled with the data 
 * from lidar and camera input. For camera and lidar, only a set of objects is kept.
 * Only 5 objects are kept for each of the camera (#SENSOR_CAMERA2FUSION) 
 * and lidar (#SENSOR_LIDAR2FUSION) sensor. 
 * 
 * @param[in] u32TimeStamp system timestmap
 * 
 * @return Nothing
*/
void FusionProcessInput(uint32 u32TimeStamp)
{
	// Allocate required memory on the heap
	LidarObjectList_t* conv_lidar_objs = malloc(TUE_LIDAR_RAW_OBJECT_NUM * sizeof(LidarObjectList_t));
	if (conv_lidar_objs == NULL) {
		LogWrite("Unable to allocate ego_vehicle_fake_data");
		return;
	}

	CamObjectList* conv_camera_objs = malloc(TUE_CAMERA_RAW_OBJECT_NUM * sizeof(CamObjectList));
	if (conv_camera_objs == NULL) {
		LogWrite("Unable to allocate conv_camera_objs");
		free(conv_lidar_objs);
		return;

	}

	// Trackable_initObjectList(&FusionInRadarObjects);
	Trackable_initObjectList(&FusionInLidarObjects);
	Trackable_initObjectList(&FusionInCameraObjects);

	//clear history data
	memset(&FusionInputEgoMotion, 0u, sizeof(TueObjFusn_EgoMotionType));
	memset(&pFusnObjLists_Output, 0u, sizeof(TueObjFusn_ObjectListType));
	memset(&pErrorBuffer, 0u, sizeof(TueObjFusn_ErrorBufferType));

	//set Fusion EgoMotion structure with VDY data
	FusionInputEgoMotion.bIsValid = FusionInput_RawData->sSigHeader.eSigStatus;
	FusionInputEgoMotion.f32Acc = FusionInput_RawData->Longitudinal.AccelCorr.corrAccel;
	FusionInputEgoMotion.f32Age = MAX(0, MIN(0.2, (float32)(DLG_STM1_GET_HIGHRES_TIMESTAMP() - FusionInput_RawData->sSigHeader.uiTimeStamp) / 1000000)); //us -> s
	FusionInputEgoMotion.f32Speed = FusionInput_RawData->Longitudinal.VeloCorr.corrVelo;
	FusionInputEgoMotion.f32YawRate = FusionInput_RawData->Lateral.YawRate.YawRate;

	convert_lidar_objs(conv_lidar_objs, Lidartemp);
	convert_camera_objs(conv_camera_objs, Cameratemp);
	LidarObjectList_t* FusionInput_LidarObjList = conv_lidar_objs;
	CamObjectList* FusionInput_CameraObjList = conv_camera_objs;
 

	Fusion_LidarObjectPreSelection(FusionInput_LidarObjList, &FusionInLidarObjects, u32TimeStamp);
	Fusion_CameraObjectPreSelection(FusionInput_CameraObjList, &FusionInCameraObjects, u32TimeStamp);

	free(conv_lidar_objs);
	free(conv_camera_objs);
}

/**
 * @brief Prepares output object list of fused tracks
 * 
 * Extra processing is done on the output of sfObjectFusionMpf_Outputs_wrapper 
 * in this function to prepare the list of fused objects.
 * 
 * 
 * @return Nothing
*/
void FusionProcessOutput(void)
{
	uint16 i, j, k;
	static uint16 uiCycleCounter = 0;
	for (i = 0; i < BSW_NR_PRIVOBJECTS; i++)
	{
		//clear all the object data before fusion result output
		(void)memset(&FusionOutput_ObjList.Objects[i], 0u, sizeof(Objects_t));
	}
	//set object list time stamp to current time since fusion finished time compensate process
	FusionOutput_ObjList.sSigHeader.uiTimeStamp = DLG_STM1_GET_HIGHRES_TIMESTAMP();
	
	FusionOutput_ObjList.sSigHeader.eSigStatus = 1;
	FusionOutput_ObjList.sSigHeader.uiCycleCounter = uiCycleCounter;
	FusionOutput_ObjList.sSigHeader.uiMeasurementCounter = uiCycleCounter;
	FusionOutput_ObjList.uiVersionNumber = FusionInput_RawData->uiVersionNumber;

//		EnvmData.pPrivObjList->uiTimeStamp = EnvmData.pPrivObjList->sSigHeader.uiTimeStamp;	
//		EnvmData.pPrivObjList->uiCycleCounter = uiCycleCounter ;
//		EnvmData.pPrivObjList->eSigStatus = 1;


	//	for (i = 0; i < BSW_NR_PRIVOBJECTS; i++)
	
		//copy signal header to EnvmData.pPrivObjList
		for (i = 0; i < TUEOBJFUSN_IDPROVIDER_U16ID_MAX + 1; i++)
		{
			for (j = 0; j < pFusnObjLists_Output.u16NumObjects; j++)
			{
				if (i == pFusnObjLists_Output.aTrackable[j].u16ID)
				{
					break;
				} 
			//clear all the object data before fusion result output
	//			else 
			}
			if ( j == pFusnObjLists_Output.u16NumObjects)
			{
				if (TrackIdToObjectIdMap[i] >= 0 && TrackIdToObjectIdMap[i] < BSW_NR_PRIVOBJECTS)
				{
					//reset OPS object quality value of invalid object
					// FPSDeleteObject(TrackIdToObjectIdMap[i]);
				}
				TrackIdToObjectIdMap[i] = -1;
			}
		}
	
		for (i = 0; i < pFusnObjLists_Output.u16NumObjects; i++)
		{
			if (/*fusionResultInput.aTrackable[i].bUpdated != 0 && */
				TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID] == -1)
			{
				for (j = 0; (j < BSW_NR_PRIVOBJECTS && TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID] == -1); j++)
				{
					for (k = 0; k < TUEOBJFUSN_IDPROVIDER_U16ID_MAX + 1; k++)
					{
						if (j == TrackIdToObjectIdMap[k])
						{
							break;
						}
	//					else 
					}
					if (k == TUEOBJFUSN_IDPROVIDER_U16ID_MAX+1)
					{
						TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID] = j;
	//					break;
					}
				}
			}
		}
		//set number of object
		FusionOutput_ObjList.HeaderObjList.iNumOfUsedObjects = pFusnObjLists_Output.u16NumObjects;
		// EnvmData.pPrivObjList->HeaderObjList.iNumOfUsedObjects = pFusnObjLists_Output.u16NumObjects;
		//TrackIdToObjectIdMap[i]
		//LogWrite("pFusnObjLists_Output.u16NumObjects :%d, OutBufsize:%d, %d ", pFusnObjLists_Output.u16NumObjects, TUEOBJFUSN_OBJECTLIST_U16NUMOBJECTS_MAX, sizeof(pFusnObjLists_Output));
		for (i = 0; i < pFusnObjLists_Output.u16NumObjects; i++)
		{
			//if fusion result object is only checked by camera, set PoE to 99 if camera's PoE is more than 90
			//reason: FPS PoE check threshold is set according to the lidar parameter. Camera result PoE more than 90 is enough for the FPS check
			if (pFusnObjLists_Output.aTrackable[i].u8CyclesNoLidar != 0 && pFusnObjLists_Output.aTrackable[i].u8CyclesNoVision == 0 && pFusnObjLists_Output.aTrackable[i].f32ExistenceQuality >= 90)
			{
				pFusnObjLists_Output.aTrackable[i].f32ExistenceQuality = 99;
			}
	
			//convert fusion result to EM structure which would be the input of FPS
			if (TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID] >= 0 && TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID] < BSW_NR_PRIVOBJECTS)
			{
			//	LogWrite("FusionProcessOutput 1 %d, %d, %.02f,  %.02f => %d, %d, %.02f,  %.02f",
				//    i,
				//    pFusnObjLists_Output.aTrackable[i].u16ID,
				//    pFusnObjLists_Output.aTrackable[i].vecX.data[0],
				//    pFusnObjLists_Output.aTrackable[i].vecX.data[1],
				//    TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID],
				//    FusionOutput_ObjList.Objects[TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID]].ObjectId,
				//    FusionOutput_ObjList.Objects[TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID]].Kinematic.fDistX,
				//    FusionOutput_ObjList.Objects[TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID]].Kinematic.fDistY);

				TueFusionObjListToContiRaObjListConverter(&(FusionOutput_ObjList.Objects[TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID]]), &(pFusnObjLists_Output.aTrackable[i]));
				// TueFusionObjListToContiRaObjListConverter(&(EnvmData.pPrivObjList->Objects[TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID]]), &(pFusnObjLists_Output.aTrackable[i]));

				//LogWrite("FusionProcessOutput 2 %d, %d, %.02f,  %.02f => %d, %d, %.02f,  %.02f",
				//    i,
				//    pFusnObjLists_Output.aTrackable[i].u16ID,
				//    pFusnObjLists_Output.aTrackable[i].vecX.data[0],
				//    pFusnObjLists_Output.aTrackable[i].vecX.data[1],
				//    TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID],
				//    FusionOutput_ObjList.Objects[TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID]].ObjectId,
				//    FusionOutput_ObjList.Objects[TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID]].Kinematic.fDistX,
				//    FusionOutput_ObjList.Objects[TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID]].Kinematic.fDistY);


			}
			else 
			{
	//#if TU_ALGO_SIMULATION_VS_CONF_200_DT
	//			Debug("TrackIdToObjectIdMap wrong, TrackIdToObjectIdMap[%d]: %d \n", pFusnObjLists_Output.aTrackable[i].u16ID, TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID]);
	//#endif
			}
		}
#ifdef TU_ALGO_SIMULATION_VS_CONF_200_DT
#if ALGO_TUE_TTTA_OBJECT_FUSION_SWITCH == TRUE
		//printf fusioned objects properties: distX, distY
		//SimulationDataOut_ObjectFusionResult(EnvmData.pExtObjList, EnvmData.pCamObject, EnvmData.pPrivObjList);
#endif
		setObjectList_ForSimulation(EnvmData.pPrivObjList);
	
#endif
	uiCycleCounter++;

}


/**
 * @brief Object fusion main function
 * 
 * timestamp and cycle time is calculated. Lidar and camera object variable
 * is created and finally, error buffer and fusion object list output is set.
 * 
 * 
 * @return Nothing
*/
//LidarObjectList_t* FusionInput_LidarObjList;
void Fusion_Process(void)
{
	float32 CycleDeltaTime = EM_f_GetCycleTime(); // in s, float32 type
	LogWrite("CYCLE DELTA TIME: %f", CycleDeltaTime);
	
	uint32 u32TimeStamp = DLG_STM1_GET_HIGHRES_TIMESTAMP(); // system time in us
	uint8 i , j;
//	LogWrite("Lidar type Fusion_Process: %d, %.02f ", FusionInput_LidarObjList->HeaderObjList.iNumOfUsedObjects, CycleDeltaTime);
	//  LogWrite("AR410 Fusion_Process: %d, %.02f ", EnvmData.pExtObjList->HeaderObjList.iNumOfUsedObjects, CycleDeltaTime);

FusionProcessInput(u32TimeStamp);
	for(i = 0; i < FusionInCameraObjects.u16NumObjects; i++) {
		LogWrite("Fusion_Process Camera : %d,  %.02f, %.02f ",
			 FusionInCameraObjects.aTrackable[i].u16ID,
			 FusionInCameraObjects.aTrackable[i].vecX.data[0],
			 FusionInCameraObjects.aTrackable[i].vecX.data[1]);
	}
	// for(i = 0; i < FusionInRadarObjects.u16NumObjects; i++) {
	// 	LogWrite("Fusion_Process Radar: %d, %.02f, %.02f ",
	// 		 FusionInRadarObjects.aTrackable[i].u16ID,
	// 		 FusionInRadarObjects.aTrackable[i].vecX.data[0],
	// 		 FusionInRadarObjects.aTrackable[i].vecX.data[1]);
	// }
	for(i = 0; i < FusionInLidarObjects.u16NumObjects; i++) {
		LogWrite("Fusion_Process Lidar: %d, %.02f, %.02f ",
			 FusionInLidarObjects.aTrackable[i].u16ID,
			 FusionInLidarObjects.aTrackable[i].vecX.data[0],
			 FusionInLidarObjects.aTrackable[i].vecX.data[1]);
	}

	//Fusion wrapper main function
	sfObjectFusionMpf_Outputs_wrapper(
		// &FusionInRadarObjects,
		&FusionInLidarObjects,
		&FusionInCameraObjects,
		&FusionInputEgoMotion,
		CycleDeltaTime,
		&pFusnObjLists_Output,
		&pErrorBuffer);



	FusionProcessOutput();

}
#endif


// #if ALGO_TUE_TTTA_OBJECT_FUSION_SWITCH
// /* ****************************************************************************

//   Functionname:     TUEObjectFusionProcess                                              */ /*!

//   @brief            object fusion main function

//   @description      Set fusion function input value: radar object list, camera object list,
//                     ego motion value, system time stamp, fusion object list output, error buffer.

//   @param            void

//   @return           void

//   @pre              None
//   @post             No changes


// **************************************************************************** */
// void TUEObjectFusionProcess(void)
// {
// 	uint16 i, j, k;

// 	//clear history data
// 	(void)memset(&EgoMotion, 0u, sizeof(TueObjFusn_EgoMotionType));
// 	(void)memset(&pFusnObjLists_Output, 0u, sizeof(TueObjFusn_ObjectListType));
// 	(void)memset(&pErrorBuffer, 0u, sizeof(TueObjFusn_ErrorBufferType));

// 	//set Fusion EgoMotion structure with VDY data
// 	EgoMotion.bIsValid = GET_EGO_RAW_DATA_PTR->sSigHeader.eSigStatus;
// 	EgoMotion.f32Acc = GET_EGO_RAW_DATA_PTR->Longitudinal.AccelCorr.corrAccel;
// 	EgoMotion.f32Age = MAX(0,
// 		MIN(0.2, (float32)(DLG_STM1_GET_HIGHRES_TIMESTAMP() - GET_EGO_RAW_DATA_PTR->sSigHeader.uiTimeStamp) / 1000000));//us -> s
// 	EgoMotion.f32Speed = GET_EGO_RAW_DATA_PTR->Longitudinal.VeloCorr.corrVelo;
// 	EgoMotion.f32YawRate = GET_EGO_RAW_DATA_PTR->Lateral.YawRate.YawRate;

// 	//Fusion wrapper main function
// 	sfObjectFusionMpf_Outputs_wrapper(
// 		EnvmData.pPrivObjList,
// 		EnvmData.pCamObject,
// 		&EgoMotion,
// 		DLG_STM1_GET_HIGHRES_TIMESTAMP(),
// 		&pFusnObjLists_Output,
// 		&pErrorBuffer);

// 	for (i = 0; i < BSW_NR_PRIVOBJECTS; i++)
// 	{
// 		//clear all the object data before fusion result output
// 		(void)memset(&EnvmData.pPrivObjList->Objects[i], 0u, sizeof(Objects_t));
// 	}
//     //set object list time stamp to current time since fusion finished time compensate process
//     EnvmData.pPrivObjList->sSigHeader.ui = DLG_STM1_GET_HIGHRES_TIMESTAMP();
// //    EnvmData.pPrivObjList->uiTimeStamp = DLG_STM1_GET_HIGHRES_TIMESTAMP();
// //	for (i = 0; i < BSW_NR_PRIVOBJECTS; i++)

// 	//copy signal header to EnvmData.pPrivObjList
// 	for (i = 0; i < TUEOBJFUSN_IDPROVIDER_U16ID_MAX + 1; i++)
// 	{
// 		for (j = 0; j < pFusnObjLists_Output.u16NumObjects; j++)
// 		{
// 			if (i == pFusnObjLists_Output.aTrackable[j].u16ID)
// 			{
// 				break;
// 			} 
// 		//clear all the object data before fusion result output
// 			else if ( j == pFusnObjLists_Output.u16NumObjects - 1)
// 			{
//                 if (TrackIdToObjectIdMap[i] >= 0 && TrackIdToObjectIdMap[i] < BSW_NR_PRIVOBJECTS)
//                 {
//                     //reset OPS object quality value of invalid object
//                     FPSDeleteObject(TrackIdToObjectIdMap[i]);
//                 }
//                 TrackIdToObjectIdMap[i] = -1;
// 			}
// 		}
// 	}

// 	for (i = 0; i < pFusnObjLists_Output.u16NumObjects; i++)
// 	{
// 		if (/*fusionResultInput.aTrackable[i].bUpdated != 0 && */
// 			TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID] == -1)
// 		{
// 			for (j = 0; (j < BSW_NR_PRIVOBJECTS && TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID] == -1); j++)
// 			{
// 				for (k = 0; k < TUEOBJFUSN_IDPROVIDER_U16ID_MAX + 1; k++)
// 				{
// 					if (j == TrackIdToObjectIdMap[k])
// 					{
// 						break;
// 	}
// 					else if (k == TUEOBJFUSN_IDPROVIDER_U16ID_MAX)
// 					{
// 						TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID] = j;
// 						break;
// 					}
// 				}
// 			}
// 		}
// 	}
// 	//set number of object
// 	EnvmData.pPrivObjList->HeaderObjList.iNumOfUsedObjects = pFusnObjLists_Output.u16NumObjects;
// 	//TrackIdToObjectIdMap[i]
// 	for (i = 0; i < pFusnObjLists_Output.u16NumObjects; i++)
// 	{
// 		//if fusion result object is only checked by camera, set PoE to 99 if camera's PoE is more than 90
// 		//reason: FPS PoE check threshold is set according to the radar parameter. Camera result PoE more than 90 is enough for the FPS check
// 		if (pFusnObjLists_Output.aTrackable[i].u8CyclesNoRadar != 0 && pFusnObjLists_Output.aTrackable[i].u8CyclesNoVision == 0 && pFusnObjLists_Output.aTrackable[i].f32ExistenceQuality >= 90)
// 		{
// 			pFusnObjLists_Output.aTrackable[i].f32ExistenceQuality = 99;
// 		}
// 		//convert fusion result to EM structure which would be the input of FPS
// 		if (TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID] >= 0 && TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID] < BSW_NR_PRIVOBJECTS)
// 		{
// 			TueFusionObjListToContiRaObjListConverter(&(EnvmData.pPrivObjList->Objects[TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID]]), &(pFusnObjLists_Output.aTrackable[i]));
// 		}
// 		else 
// 		{
// #if TU_ALGO_SIMULATION_VS_CONF_200
// 			Debug("TrackIdToObjectIdMap wrong, TrackIdToObjectIdMap[%d]: %d \n", pFusnObjLists_Output.aTrackable[i].u16ID, TrackIdToObjectIdMap[pFusnObjLists_Output.aTrackable[i].u16ID]);
// #endif
// 		}
// 	}
// #ifdef TU_ALGO_SIMULATION_VS_CONF_200
// #if ALGO_TUE_TTTA_OBJECT_FUSION_SWITCH == TRUE
// 	//printf fusioned objects properties: distX, distY
// 	//SimulationDataOut_ObjectFusionResult(EnvmData.pExtObjList, EnvmData.pCamObject, EnvmData.pPrivObjList);
// #endif
// #endif


// }
// #endif

/**
 * @brief Convert all Lidar objects
 *
 * This function converts all objects in Lidartemp of
 * Fusion_Lidar_input_lists type to conv_lidar_objs
 * of LidarObjectList_t type one by one.
 *
 * @param[in] Lidartemp input Lidar objects
 * @param[out] conv_lidar_objs converted Lidar objects
 *
 * @return None
*/
void convert_lidar_objs(
    LidarObjectList_t* const conv_lidar_objs,
    const Lidar_input_lists* const Lidartemp)
{
    const Lidar_In_ObjectList_t* const lidar_in_tracks = &(Lidartemp->Lidarobjlists[0]);
    conv_lidar_objs->sSigHeader.uiTimeStamp = lidar_in_tracks->timestamp;
	conv_lidar_objs->HeaderObjList.iNumOfUsedObjects =(sint8) lidar_in_tracks->uNumOfUsedObjects;
// TUE_LIDAR_RAW_OBJECT_NUM ---> 40
    for(int i = 0; i < 40; i++)
        convert_lidar_obj(&(conv_lidar_objs->Objects[i]),
                          &(lidar_in_tracks->Objects[i]));
}

/**
 * @brief Convert the type of a single Lidar object
 *
 * This function converts in_lidar_obj of Lidar_In_Objects_t type
 * to conv_lidar_obj of LidarObjects_t type
 *
 * @param[in] in_lidar_obj input Lidar object
 * @param[out] conv_lidar_obj converted Lidar object
 *
 * @return None
*/
void convert_lidar_obj(
    LidarObjects_t* const conv_lidar_obj,
    const Lidar_In_Objects_t* const in_lidar_obj)

{
    // ObjectID
    conv_lidar_obj->ObjectId = in_lidar_obj->ID;
    // Kinematic
    // Copy the members
    conv_lidar_obj->Kinematic.fDistX = in_lidar_obj->Kinematic.fDist.data[0];
	conv_lidar_obj->Kinematic.fDistY = in_lidar_obj->Kinematic.fDist.data[1];
	conv_lidar_obj->Kinematic.fVrelX = in_lidar_obj->Kinematic.fVel.data[0];
	conv_lidar_obj->Kinematic.fVrelY = in_lidar_obj->Kinematic.fVel.data[1];
	conv_lidar_obj->Kinematic.fArelX = in_lidar_obj->Kinematic.fAcc.data[0];
	conv_lidar_obj->Kinematic.fArelY = in_lidar_obj->Kinematic.fAcc.data[1];
    // Copy Covariance matrix
    conv_lidar_obj->Kinematic.fDistXStd = in_lidar_obj->Kinematic.fCovDist.data[0][0];
	conv_lidar_obj->Kinematic.fDistYStd = in_lidar_obj->Kinematic.fCovDist.data[1][1];
	conv_lidar_obj->Kinematic.fVrelXStd = in_lidar_obj->Kinematic.fCovVel.data[0][0];
	conv_lidar_obj->Kinematic.fVrelYStd = in_lidar_obj->Kinematic.fCovVel.data[1][1];
	conv_lidar_obj->Kinematic.fArelXStd = in_lidar_obj->Kinematic.fCovAcc.data[0][0];
	conv_lidar_obj->Kinematic.fArelYStd = in_lidar_obj->Kinematic.fCovAcc.data[1][1];
	
    // Geometry
    conv_lidar_obj->Geometry.fWidth= (float32) in_lidar_obj->Geometry.width;
    conv_lidar_obj->Geometry.fLength = (float32) in_lidar_obj->Geometry.length;
    conv_lidar_obj->Geometry.fOrientation = (float32) in_lidar_obj->Geometry.theta;
    (void)memset(&(conv_lidar_obj->Geometry.fOrientationStd), 0u, sizeof(conv_lidar_obj->Geometry.fOrientationStd));
    (void)memset(&(conv_lidar_obj->Geometry.fOrientationValid), 0u, sizeof(conv_lidar_obj->Geometry.fOrientationValid));
    
    // Attributes
    // Attributes - Type & SubType
    if (in_lidar_obj->Attributes.Type == 5 && in_lidar_obj->Attributes.SubType == 3)        //vehicle - car
    {
        conv_lidar_obj->Attributes.eClassification = 1U; 
    }
    else if (in_lidar_obj->Attributes.Type == 5 && in_lidar_obj->Attributes.SubType == 5)   // vehicle - truck
    {
        conv_lidar_obj->Attributes.eClassification = 2U; 
    }
    else if (in_lidar_obj->Attributes.Type == 3)                                            // pedestrian
    {
        conv_lidar_obj->Attributes.eClassification = 3U; 
    }
    else if (in_lidar_obj->Attributes.Type == 4 && in_lidar_obj->Attributes.SubType == 8)   // Bicycle - Motorcycle
    {
        conv_lidar_obj->Attributes.eClassification = 4U; 
    }
    else if (in_lidar_obj->Attributes.Type == 4 && in_lidar_obj->Attributes.SubType == 6)    // Bicycle - Cyclist
    {
        conv_lidar_obj->Attributes.eClassification = 5U; 
    }
    else if (in_lidar_obj->Attributes.Type == 2)                                            // Pathblocking
    {
        conv_lidar_obj->Attributes.eClassification = 6U; 
    }
    else                                                                                    // unknown
    {
        conv_lidar_obj->Attributes.eClassification = 0U;
    }
    // Attributes - confidence
    conv_lidar_obj->Attributes.uiClassConfidence = (uint8) in_lidar_obj->Attributes.confidence; // TODO: check the value!
    // Attributes - Other fiels
    (void)memset(&(conv_lidar_obj->Attributes.eDynamicProperty), 0u, sizeof(conv_lidar_obj->Attributes.eDynamicProperty));
    (void)memset(&(conv_lidar_obj->Attributes.uiStoppedConfidence), 0u, sizeof(conv_lidar_obj->Attributes.uiStoppedConfidence));
    (void)memset(&(conv_lidar_obj->Attributes.eAbsMovingState), 0u, sizeof(conv_lidar_obj->Attributes.eAbsMovingState));

    // General
    (void)memset(&(conv_lidar_obj->General.cObjMergingID), 0u, sizeof(conv_lidar_obj->General.cObjMergingID));
    (void)memset(&(conv_lidar_obj->General.eObjMaintenanceState), 0u, sizeof(conv_lidar_obj->General.eObjMaintenanceState));
    (void)memset(&(conv_lidar_obj->General.fLifeTime), 0u, sizeof(conv_lidar_obj->General.fLifeTime));
    (void)memset(&(conv_lidar_obj->General.fTimeStamp), 0u, sizeof(conv_lidar_obj->General.fTimeStamp));


    // Qualifiers
    (void)memset(&(conv_lidar_obj->Qualifiers.fProbabilityOfExistence), 0u, sizeof(conv_lidar_obj->Qualifiers.fProbabilityOfExistence));
    (void)memset(&(conv_lidar_obj->Qualifiers.ucObstacleProbability), 0u, sizeof(conv_lidar_obj->Qualifiers.ucObstacleProbability));

    // Sensor specific - not defiend in new data type

    // Legacy - not defiend in new data type

}


/**
 * @brief Convert all Camera objects
 *
 * This function converts all objects in Cameratemp of
 * camera_input_lists type to conv_camera_objs
 * of cameraObjectList_t type one by one.
 *
 * @param[in] Cameratemp input Camera objects
 * @param[out] conv_camera_objs converted Camera objects
 *
 * @return None
*/

void convert_camera_objs(
    CamObjectList* const conv_camera_objs,
    const Camera_input_lists* const Cameratemp)
{
    const Camera_In_ObjectList_t* const camera_in_tracks = &(Cameratemp->Cameraobjlists[0]);
    conv_camera_objs->sSigHeader.uiTimeStamp = camera_in_tracks->last_measure_update_timestamp_ns;   //uint32...unsigned long long
    for(int i = 0; i < TUE_CAMERA_RAW_OBJECT_NUM; i++)
        convert_camera_obj(&(conv_camera_objs->aObject[i]),
                          &(camera_in_tracks->Objects[i]));
}

/**
 * @brief Convert the type of a single Camera object
 *
 * This function converts in_camera_obj of Camera_In_Objects_t type
 * to conv_camera_obj of CameraObjects_t type
 *
 * @param[in] in_camera_obj input Camera object
 * @param[out] conv_camera_obj converted Camera object
 *
 * @return None
*/

void convert_camera_obj(
    CamObject* const conv_camera_obj,
    const Camera_In_Objects_t* const in_camera_obj)
{
    // ObjectID of camera
    conv_camera_obj->ObjectID = in_camera_obj->track_id;
     // Kinematic
    // Copy the members
    conv_camera_obj->Kinematic.fDistX = in_camera_obj->Kinematic.fDist.data[0];
	conv_camera_obj->Kinematic.fDistY = in_camera_obj->Kinematic.fDist.data[1];
	conv_camera_obj->Kinematic.fVx = in_camera_obj->Kinematic.fVel.data[0];
	conv_camera_obj->Kinematic.fVy = in_camera_obj->Kinematic.fVel.data[1];
	conv_camera_obj->Kinematic.fAx = in_camera_obj->Kinematic.fAcc.data[0];
	conv_camera_obj->Kinematic.fAy = in_camera_obj->Kinematic.fAcc.data[1];
    // Copy Covariance matrix
    conv_camera_obj->Kinematic.fDistXStd = in_camera_obj->Kinematic.fCovDist.data[0][0];
	conv_camera_obj->Kinematic.fDistYStd = in_camera_obj->Kinematic.fCovDist.data[1][1];
	conv_camera_obj->Kinematic.fVxStd = in_camera_obj->Kinematic.fCovVel.data[0][0];
	conv_camera_obj->Kinematic.fVyStd = in_camera_obj->Kinematic.fCovVel.data[1][1];
	conv_camera_obj->Kinematic.fAxStd = in_camera_obj->Kinematic.fCovAcc.data[0][0];
	conv_camera_obj->Kinematic.fAyStd = in_camera_obj->Kinematic.fCovAcc.data[1][1];    
	
	// Geometry
    conv_camera_obj->Geometry.fWidth = (float32) in_camera_obj->Geometry.width;
    conv_camera_obj->Geometry.fLength = (float32) in_camera_obj->Geometry.length;
    conv_camera_obj->Geometry.fHeight = (float32) in_camera_obj->Geometry.height;

     // Attributes  
    (void)memset(&(conv_camera_obj->Attributes.eStatusBrakeLight), 0u, sizeof(conv_camera_obj->Attributes.eStatusBrakeLight));
    (void)memset(&(conv_camera_obj->Attributes.uiBrakeLightConfidence), 0u, sizeof(conv_camera_obj->Attributes.uiBrakeLightConfidence));
    (void)memset(&(conv_camera_obj->Attributes.eStatusTurnIndicator), 0u, sizeof(conv_camera_obj->Attributes.eStatusTurnIndicator));
    (void)memset(&(conv_camera_obj->Attributes.uiTurnIndicatorConfidence), 0u, sizeof(conv_camera_obj->Attributes.uiTurnIndicatorConfidence));
    (void)memset(&(conv_camera_obj->Attributes.eAssociatedLane), 0u, sizeof(conv_camera_obj->Attributes.eAssociatedLane));
    (void)memset(&(conv_camera_obj->Attributes.uiAssociatedLaneConfidence), 0u, sizeof(conv_camera_obj->Attributes.uiAssociatedLaneConfidence));
    (void)memset(&(conv_camera_obj->Attributes.eLaneChangeManeuver), 0u, sizeof(conv_camera_obj->Attributes.eLaneChangeManeuver));
    (void)memset(&(conv_camera_obj->Attributes.percentageOwnDrivingLane), 0u, sizeof(conv_camera_obj->Attributes.percentageOwnDrivingLane));
    (void)memset(&(conv_camera_obj->Attributes.percentageSideDrivingLaneLeft), 0u, sizeof(conv_camera_obj->Attributes.percentageSideDrivingLaneLeft));
    (void)memset(&(conv_camera_obj->Attributes.percentageSideDrivingLaneRight), 0u, sizeof(conv_camera_obj->Attributes.percentageSideDrivingLaneRight));
    conv_camera_obj->Attributes.eMainteanceState = (uint8) in_camera_obj->Attributes.maintenance_status;  //uint8...short
    conv_camera_obj->Attributes.percentageProbOfExist=(uint8)in_camera_obj->Attributes.existence_confidence; //uint8...float
    conv_camera_obj->Attributes.ObjectLifeCycles=(uint32)in_camera_obj->Attributes.track_age_time_second; //uint32...float
    (void)memset(&(conv_camera_obj->Attributes.eMotionState), 0u, sizeof(conv_camera_obj->Attributes.eMotionState));

    
}



/**
 * @brief Convert all fusion objects to use in dpc team               
 *
 *
 * @param[in] in_fusion_objs output fusion objects
 * @param[out] conv_fusion_objs converted fusion objects which go to DPC side
 *
 * @return None
*/

void convert_fusion_objs(
    Fusion_Out_ObjectList_t* const conv_fusion_objs ,
    const TueObjFusn_ObjectListType* const in_fusion_objs)
{
    for(int i = 0; i <FUSION_NR_EXTERNAL_OBJECTS; i++)
        convert_fusion_obj(&(conv_fusion_objs->Objects[i]),
                          &(in_fusion_objs->aTrackable[i]));
}

/**
 * @brief Convert each track in fusion output
 *
 * This function converts in_fus_track of Objects_t
 * type to conv_fus_track of Fusion_Out_Objects_t type. Deep copy is performed
 * instead of shallow copy due to pointer in the types.
 *
 * @param[in] in_fus_track input track resulting from fusion process
 * @param[out] conv_fus_track converted fusion tracks
 *
 * @return None
*/

void convert_fusion_obj(
    Fusion_Out_Objects_t* const conv_fusion_obj,
    const TueObjFusn_TrackableType* const in_fusion_obj)
{
    
    // ObjectID 
     conv_fusion_obj->id = in_fusion_obj->u16ID;

     // Kinematic
     conv_fusion_obj->relative_x = in_fusion_obj->vecX.data[0];
     conv_fusion_obj->relative_y = in_fusion_obj->vecX.data[1];
     conv_fusion_obj->absolute_velocity_x = in_fusion_obj->vecX.data[2];
     conv_fusion_obj->absolute_velocity_y = in_fusion_obj->vecX.data[3];
     conv_fusion_obj->absolute_acceleration_x = in_fusion_obj->vecX.data[4];
     conv_fusion_obj->absolute_acceleration_y = in_fusion_obj->vecX.data[5];
     
     // Geometry
     conv_fusion_obj->width = in_fusion_obj->f32Width;
     conv_fusion_obj->length = in_fusion_obj->f32Length;

     // Attributes  
     conv_fusion_obj->motion_type = in_fusion_obj->u16MotionType;
     conv_fusion_obj->contributing_sensor = in_fusion_obj->au16SensorID[1];
    
}

/**
 * @brief Convert fusion error buffer type
 *
 * This function converts error buffer of fusion. This buffer
 * holds various errors that the fusion encountered during
 * the algorithm procedure.
 *
 * @param[in] in_fus_error input fusion errors
 * @param[out] conv_fus_error converted fusion error type
 *
 * @return None
*/
void convert_fusion_errors(
    Fusn_ErrorBufferOut* const conv_fus_error,
    const TueObjFusn_ErrorBufferType* const in_fus_error)
{
    conv_fus_error->u16NextWriteIdx = in_fus_error->u16NextWriteIdx;
    conv_fus_error->u16NumOfItems = in_fus_error->u16NumOfItems;
    memcpy(conv_fus_error->aErrorBuffer, in_fus_error->aErrorBuffer,
        TUE_PRV_ERROR_MANAGEMENT_BUFFER_SIZE*sizeof(Fusn_ErrorTypeOut));
}


#ifdef __cplusplus
}
#endif


