/** \addtogroup tuePrvmodes
 *  @{
 * \file        tue_prv_modes_filtering.h
 * \brief header file for tue_prv_modes_filtering.c
 * 
 *
 *
 *          (C) Copyright Tuerme Inc. All rights reserved.
 *
 */

#ifndef TUE_PRV_MODES_FILTERING_H
#define TUE_PRV_MODES_FILTERING_H

#ifdef __cplusplus
extern "C" {
#endif

/*==================[inclusions]============================================*/
#include "tue_prv_common_types.h"
#include "TueObjFusn_ObjectListType.h"
#include "TueObjFusn_EgoMotionType.h"
#include "TueObjFusn_MatchIndex.h"
#include "TueObjFusn_TrackableProps.h"

/*==================[macros]================================================*/

/*==================[type definitions]======================================*/
/*==================[forward declarations]==================================*/
/*==================[symbolic constants]====================================*/
/*==================[return codes]==========================================*/
/*==================[functions]=============================================*/

#define ObjFusn_START_SEC_CODE


/** initializer method */
extern void modes_filtering_init(void);

extern uint32 modes_filtering_preCycle(const float32 f32dt,
                                       CONSTP2CONST(TueObjFusn_EgoMotionType,
                                                    AUTOMATIC,
                                                    ObjFusn_VAR_NOINIT)
                                           pEgoMotion);

uint32 modes_filtering_cycle_SensorEvent(CONSTP2VAR(
    TueObjFusn_ObjectListType, AUTOMATIC, ObjFusn_VAR_NOINIT) pObjectList);

extern uint32 modes_filtering_cycle_TimerEvent(CONSTP2VAR(
    TueObjFusn_ObjectListType, AUTOMATIC, ObjFusn_VAR_NOINIT) pObjList_Output);

extern uint32 modes_filtering_postCycle(const float32 f32dt,
                                        const uint32 u32SensorsUpdatePattern);

extern  uint32  modes_filtering_removeDeadSensor(const uint32 u32Sensor);

//void writeInternalTracksToFile();

//void writeMeasTracksToFile(CONSTP2CONST(TueObjFusn_ObjectListType, AUTOMATIC, ObjFusn_VAR_NOINIT) tracks);

//void writeMatchIndicesToFile(CONSTP2CONST(stMatchIndexArrayType, AUTOMATIC, ObjFusn_VAR_NOINIT) matches);

#define ObjFusn_STOP_SEC_CODE

/*==================[external function declarations]========================*/
/*==================[external constants]====================================*/
/*==================[external data]=========================================*/

#ifdef __cplusplus
}
#endif

#endif // TUE_PRV_MODES_FILTERING_H
/**@}==================[end of file]===========================================*/
