#ifndef OBJFUSNOBJLISTTOVOLVOSNSRFUSNCONVERT_H_
#define OBJFUSNOBJLISTTOVOLVOSNSRFUSNCONVERT_H_ 1

/******************************************************************************

AUTOLIV ELECTRONIC document.

-------------------------------------------------------------------------------

Copyright Tuerme Inc. All rights reserved.

*******************************************************************************
H-File Template Version: 
*******************************************************************************

Overview of the interfaces:
   Conversion from TUEObjList v131 to RaCamObjList

******************************************************************************/
/* PRQA S 0288 ++ */
/*
 * Explanation:
 *    Output adapter from TUEObjList v131 to Volvo RaCamObjList defined within CADS4
 */
/*
*/
/* PRQA S 0288 -- */
/*****************************************************************************/
/******************************************************************************
EXTERNAL DEPENDENCIES
******************************************************************************/


#include "TueObjFusn_ObjectListType.h"
#include "TueRACAM_ObjListInput.h"
#include "TueObjFusn_EgoMotionType.h"
#include "TueObjFusn_TrackableProps.h"

#ifdef __cplusplus
extern "C" {
#endif
 
/******************************************************************************
DEFINITION OF CONSTANTS
******************************************************************************/

/******************************************************************************
DECLARATION OF TYPES
******************************************************************************/

/******************************************************************************
DECLARATION OF VARIABLES
******************************************************************************/

/******************************************************************************
DECLARATION OF CONSTANT DATA
******************************************************************************/

/******************************************************************************
DECLARATION OF FUNCTIONS
******************************************************************************/

boolean  ObjFusnObjListToVolvoSnsrFusnConvertInit(void);

boolean  ObjFusnObjListToVolvoSnsrFusnConvert(CONSTP2CONST(TueObjFusn_ObjectListType, AUTOMATIC, ObjFusn_VAR_NOINIT) pObjList,
                                             CONSTP2CONST(TueObjFusn_EgoMotionType, AUTOMATIC, ObjFusn_VAR_NOINIT) pEgoMotion,
                                             CONSTP2VAR(typeRaCamObjectVcc, AUTOMATIC, ObjFusn_VAR_NOINIT) pRACAMObjListOut,
                                             CONST(uint32, ObjFusn_VAR_NOINIT) u32TimeStamp);

boolean  initRaCamObjList(CONSTP2VAR(typeRaCamObjectVcc, AUTOMATIC, ObjFusn_VAR_NOINIT) pRACAMObjListOut);

/******************************************************************************
DECLARATION OF FUNCTION-LIKE MACROS
******************************************************************************/

#ifdef __cplusplus
}
#endif
/******************************************************************************
End Of File
*****************************************************************************/

#endif /* _OBJFUSNOBJLISTTOSITAOBJLISTCONVERT_H_ */
