/*
 * Copyright (C) 2022-2024 by SoftwareMotion Group Limited. All rights reserved.
 * zhang guanglin
 */
#ifndef SoftwareMotion_PILOT_DECISION_PILOT_DECISION_SDK_DECISION_SRC_FUSION_FUSION_EXT_H_
#define SoftwareMotion_PILOT_DECISION_PILOT_DECISION_SDK_DECISION_SRC_FUSION_FUSION_EXT_H_
#ifdef __cplusplus
extern "C" {
#endif
// #include "Platform_Types.h"

#ifndef false
#define false (0)
#endif

#ifndef true
#define true (!false)
#endif

#ifndef FALSE
#define FALSE false
#endif

#ifndef TRUE
#define TRUE true
#endif

#define SRR_RAM_OBJ_NUM 40
#define FUSION_NR_PRIVOBJECTS (40)

//#ifndef TUE_RADAR_RAW_OBJECT_NUM
//#define TUE_RADAR_RAW_OBJECT_NUM 40  // RADAR object number get from sensor
//#endif

#ifndef TUE_LIDAR_RAW_OBJECT_NUM
#define TUE_LIDAR_RAW_OBJECT_NUM 40  // LIDAR object number get from sensor
#endif

#ifndef TUE_CAMERA_RAW_OBJECT_NUM
#define TUE_CAMERA_RAW_OBJECT_NUM 24  // CAMERA object number get from sensor
#endif

#ifndef FUSION_NR_EXTERNAL_OBJECTS
#define FUSION_NR_EXTERNAL_OBJECTS 25  // FUSION object number
#endif

#define TUE_FRONT_RADAR_RAW_OBJECT_NUM 40
#define TUE_FRONT_LEFT_RADAR_RAW_OBJECT_NUM 12
#define TUE_FRONT_RIGHT_RADAR_RAW_OBJECT_NUM 12
#define TUE_REAR_RIGHT_RADAR_RAW_OBJECT_NUM 16
#define TUE_REAR_LEFT_RADAR_RAW_OBJECT_NUM 16
#define TUE_FUS_OUTPUT_OBJ_NUMBER 100
#define EM_SINGAL_SRR_GEN_OBJECT_NUM \
    SRR_RAM_OBJ_NUM  // number of object output for one single SRR object
#define MULTI_SENSOR_RADAR_FUSION_QUANTITY (1u)
#define MULTI_SENSOR_LIDAR_QUANTITY (1u)
#define MULTI_SENSOR_CAMERA_QUANTITY (1u)
#define CAMERA_OBJ_INPUT_NUM (24u)

#define TU_OBJECT_DYNPROP_MOVING (0)
#define TU_OBJECT_DYNPROP_STATIONARY (1)
#define TU_OBJECT_DYNPROP_ONCOMING (2)
#define TU_OBJECT_DYNPROP_STATIONARY_CANDITATE (3)
#define TU_OBJECT_DYNPROP_UNKNOWN (4)
#define TU_OBJECT_DYNPROP_CROSSING_STATIONARY (5)
#define TU_OBJECT_DYNPROP_CROSSING_MOVING (6)
#define TU_OBJECT_DYNPROP_STOPPED (7)

#ifndef MT_STATE_MEASURED
#define MT_STATE_MEASURED (2U)
#endif

#define TASK_CYCLE_TIME_50 0.050F

#define POSX (0u)
#define POSY (1u)
#define VELX (2u)
#define VELY (3u)
#define ACCX (4u)
#define ACCY (5u)

#define VARIANCE_POSX (0u)
#define VARIANCE_POSY (2u)
#define VARIANCE_VELX (5u)
#define VARIANCE_VELY (9u)
#define VARIANCE_ACCX (14u)
#define VARIANCE_ACCY (20u)

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "Fusion_SLAM_types.h"
//#include "TueObjFusn_ErrorCodes.h"
// #ifndef RTE_TYPE_CamLane_t
// #define RTE_TYPE_CamLane_t
// typedef struct
// {
//     uint8 Type;
//     uint8 Quality;
//     float Position;
//     float Curvature;
//     float CurvatureDer;
//     float WidthMarking;
//     float HeadingAngle;		// degree
//     float ViewRangeStart;
//     float ViewRangeEnd;
//     uint8 LineCrossing;
//     uint8 LineMarkColor;	// eLineCol_Type
//     uint8 CanMsgEnd;
// } CamLane_t;
// #endif

// #ifndef RTE_TYPE_CAM_LANE_ARRAY_
// #define RTE_TYPE_CAM_LANE_ARRAY_
// typedef CamLane_t CamLane_array_t[4];
// #endif

// #ifndef FUSION_SLAM_TYPE_BSW_SignalHeader_t
// #define FUSION_SLAM_TYPE_BSW_SignalHeader_t
// typedef struct
// {
//     uint32 uiTimeStamp;
//     uint16 uiMeasurementCounter;
//     uint16 uiCycleCounter;
//     uint8 eSigStatus;
// } BSW_SignalHeader_t;
// #endif

// #ifndef _FUSION_EXT_CAM_OBJ_KINEMATICS_
// #define _FUSION_EXT_CAM_OBJ_KINEMATICS_
// typedef struct {
//     float32 fDistX;
//     float32 fDistXStd;
//     float32 fDistY;
//     float32 fDistYStd;
//     float32 fVx;
//     float32 fVxStd;
//     float32 fVy;
//     float32 fVyStd;
//     float32 fAx;
//     float32 fAxStd;
//     float32 fAy;
//     float32 fAyStd;
//     float32 fOrientation;
//     uint8 eRefpointLocation;
// } CamObjKinematics;
// #endif

// #ifndef _FUSION_EXT_CAM_OBJ_GEOMETRY_
// #define _FUSION_EXT_CAM_OBJ_GEOMETRY_
// typedef struct {
//     float32 fHeight;
//     float32 fOffsetToGround;
//     float32 fLength;
//     float32 fWidth;
// } CamObjGeometry;
// #endif

// #ifndef _FUSION_EXT_CAM_OBJ_CLASSIFICATION_
// #define _FUSION_EXT_CAM_OBJ_CLASSIFICATION_
// typedef struct {
//     uint8 probabilityOfClassification;
//     uint8 ObjectType;
// } CamObjClassification;
// #endif

// #ifndef _FUSION_EXT_CAM_OBJ_ATTS_
// #define _FUSION_EXT_CAM_OBJ_ATTS_
// typedef struct {
//     uint8 eStatusBrakeLight;
//     uint8 uiBrakeLightConfidence;
//     uint8 eStatusTurnIndicator;
//     uint8 uiTurnIndicatorConfidence;
//     uint8 eAssociatedLane;
//     uint8 uiAssociatedLaneConfidence;
//     uint8 eLaneChangeManeuver;
//     uint8 percentageOwnDrivingLane;
//     uint8 percentageSideDrivingLaneLeft;
//     uint8 percentageSideDrivingLaneRight;
//     uint8 eMainteanceState;
//     uint8 percentageProbOfExist;
//     uint8 eMotionState;
//     uint8 eObjectOcclusion;
//     uint32 ObjectLifeCycles;
// } CamObjAttributes;
// #endif

// #ifndef _FUSION_EXT_CAM_OBJECT_
// #define _FUSION_EXT_CAM_OBJECT_
// typedef struct {
//     uint8 ObjectID;
//     boolean bCamObjValid;
//     CamObjKinematics Kinematic;
//     CamObjGeometry Geometry;
//     CamObjClassification Classification;
//     CamObjAttributes Attributes;
// } CamObject;
// #endif

// #ifndef _FUSION_EXT_CAM_OBJ_ARRAY_
// #define _FUSION_EXT_CAM_OBJ_ARRAY_
// typedef CamObject CamObjectArray[CAMERA_OBJ_INPUT_NUM];
// #endif

// #ifndef FUSION_SLAM_CamObjectList
// #define FUSION_SLAM_CamObjectList
// typedef struct
// {
//     uint32 uiVersionNumber;
//     BSW_SignalHeader_t sSigHeader;
//     CamObjectArray aObject;
//     CamLane_array_t sLaneLines;
// } CamObjectList;
// #endif

typedef struct {
    float32 fDistX;
    float32 fDistXStd;
    float32 fDistY;
    float32 fDistYStd;
    float32 fVrelX;
    float32 fVrelXStd;
    float32 fVrelY;
    float32 fVrelYStd;
    float32 fArelX;
    float32 fArelXStd;
    float32 fArelY;
    float32 fArelYStd;
} fus_Kinematic_t;

typedef struct {
    float32 fWidth;
    float32 fLength;
    float32 fOrientation;
    float32 fOrientationStd;
    float32 fOrientationValid;
} fus_Geometry_t;

typedef struct {
    uint8 eDynamicProperty;
    uint8 uiStoppedConfidence;
    uint8 eAbsMovingState;
    uint8 eClassification;
    uint8 uiClassConfidence;
} fus_Attributes_t;

typedef struct {
    float32 fLifeTime;
    uint32 fTimeStamp;
    uint8 eObjMaintenanceState;
    uint8 cObjMergingID;
} fus_General_t;

typedef struct {
    float32 fProbabilityOfExistence;
    uint8 ucObstacleProbability;  // add Obstacle Probability for ars410 radar
    uint8 uMeasuredTargetFrequencyNear;
    uint8 uMeasuredTargetFrequencyFar;
} fus_Qualifiers_t;

typedef struct {
    float32 fRCS;
    boolean bCamConfirmed;  // true: object has been observed by camera in last
                            // 100 cycle
} fus_SensorSpecific_t;

typedef struct {
    uint16 eEbaInhibitionMask;
    uint8 ucEbaMovingObjQuality;
    uint8 eEbaHypCat;
    boolean bCrossingPedEbaPresel;
} fus_EBAPresel_t;

typedef struct {
    float32 fMaxAccelY;
    float32 fRCSTargetThresholdUncomp;
    uint16 uiLifeTime;
    uint8 eDynamicSubProperty;
} fus_LegacyObj_t;

typedef struct {
    sint32 ObjectId;  // changed by 20210915    //uint8
    fus_Kinematic_t Kinematic;
    fus_Geometry_t Geometry;
    fus_Attributes_t Attributes;
    fus_General_t General;
    fus_Qualifiers_t Qualifiers;
    fus_SensorSpecific_t SensorSpecific;
    fus_EBAPresel_t EBAPresel;
    fus_LegacyObj_t Legacy;
} FusObjects_t;

typedef FusObjects_t FusObjects_array_t[TUE_LIDAR_RAW_OBJECT_NUM];

typedef struct {
    uint32  uiTimeStamp;
    uint16  uiCycleCounter;
    uint8   eSigStatus;
    uint16  uNumOfUsedObjects;
    FusObjects_array_t Objects;
} FusObjectList_t;

typedef struct {
    boolean bIsValid; /**< valid flag to check whether valid data is read on RTE */
    uint8   u8Reserved;   /**< reserved value to ensure 4 byte alignment */
    uint16  u16Reserved; /**< reserved value to ensure 4 byte alignment */
    float32 f32Speed;   /**< Speed of ego vehicle [m/s] */
    float32 f32Acc;     /**< Acceleration of ego vehicle [m/s^2] */
    float32 f32YawRate; /**< Yaw rate of ego vehicle [rad/s] */
    float32 f32Age;     /**< age of ego motion, including latency [s]*/
    float32 f32Curve;   /**< Lateral curvature, used in Fusion SLAM OPS*/
} VedInfo_t;

//typedef FusObjectList_t
//    MultiRadar_ObjectList_t[MULTI_SENSOR_RADAR_FUSION_QUANTITY];

//typedef struct {
 //   MultiRadar_ObjectList_t Radarobjlists;
//} Fusion_Radar_input_lists;

// typedef struct {
//     // uint32 index;
//     VedInfo_t vedInput;
//     CamObjectList camObject;
//     Fusion_Radar_input_lists radarList;
// } reqFusionPrtList_t;

/**
 * Object list for external Fusion interface
 */
typedef struct {
    float32 data[6]; /**< data */
    uint16 nRows;    /**< number of rows */
    uint16 u16Reserved;
} Vec_t;

typedef struct {
    float32 data[21];
    uint16 u16Size;
    uint16 u16Reserved;
} SymMatrix_t;

typedef struct {
    /* Object Information */
    boolean bUpdated;         /** Updated in current cycle */
    uint8 u8CoordSystem;      // Indicates in which coordinate system the ego
                                //  position lives
    uint8 u8TrkblBinPosition; // Indicate the objects bin position for object
                                //  selection
    uint8 u8VisionIdx; /** vision idx for vision ID mapping in output converter */

    uint16 u16ID;  // u16ID is an identifier number that allows for tracking of
                    //   persistent objects over time. 0 is a valid ID
    uint16 u16Age; // Time [ms] that has passed since initialization of
                    //   underlying track: 0...65000 is 0...65sec; 65001 is more
                    //   than 65sec(saturation value)
    uint16 u16Lifespan; // Lifespan of trackable to handle coasting and to see
                        //    if trackable is valid or not
    uint16 u16RefPoint; // Indicates which point of the target object is given
                        //    by the coordinates
    uint8 u8CyclesNoVision; // number of consequitve vision updates without
                            //    confirmation of this object -> reset to 0 if
                            //    object is updated
    uint8 u8CyclesNoRadar;  // number of consequitve radar updates without
                            //    confirmation of this object -> reset to 0 if
                            //    object is updated

    uint16 au16SensorID[6]; // u16ID of the sensor input object. 0 is a valid
                            //    ID. The order must always map to the sensor
                            //    pattern array in trackabListUtils
    uint16 au16SensorIDLast[6]; // u16ID of the sensor nput object from the
                                //    last update. 0 is a valid ID. The order must
                                //    always map to the sensor pattern array in
                                //    trackabListUtils

    uint32 u32SensorsCurr; // Bit pattern that indicates which sensors have
                            //   seen this object during their last measurements.
                            //   Each of the first 31 bits has a specific meaning
                            //   (see defines)
    uint32
        u32SensorsHist; // Bit pattern that indicates which sensors have seen
                        //    this object at some point in time. Each of the 31 LSB
                        //    Bits has a specific meaning (see defines)

    /* Kinematics */
    Vec_t vecX; // state vector from Kalman filter including position,
                //    velocity, acceleration

    SymMatrix_t matP; // P matrix from Kalman filter including variances and
                        //  covariances of all states

    float32 f32Gain;    /** camera gain for this object */
    float32 f32GainVar; /** Variance of camera gain for this object */

    /* Coordinated Turn Model */
    float32 f32YawRate;             /** Yaw rate of target vehicle */
    float32 f32YawRateVar;          /** Variance of yaw rate for this object */
    float32 f32Heading;             /** Heading for this object */
    float32 f32HeadingVar;          /** Variance of heading for this object */
    float32 f32CovarHeadingYawRate; // Covariance of heading and yaw rate for
                                    //    this object

    /* Qualities */
    float32 f32ObstacleProbability; /** Track Quality **/
    float32 f32ExistenceQuality;    /** Existence Quality **/
    float32 fRCS;  // set RCS value for radar, new value for the tuerme
    uint8 eObjMaintenanceState;  // set eObjMaintenanceState value for radar,
                                 // new value for the tuerme

    /* Geometry */
    float32 f32Width;  /** [m] */
    float32 f32Length; /** [m] */
    float32 f32Height; /** [m] */

    /* Object Definition */
    uint16
        u16MotionType; // stationary, moving, stopped, ... (find the definition
                        //   in: TueObjFusn_ObjListInputConstants.h)
    uint16
        u16Class; // Object Class: vehicle, two-wheeler, pedestrian, ... (find
                    //  the definition in: TueObjFusn_ObjListInputConstants.h)
    uint16 u16ClassProb; // classification probability(0 is default; 1...99
                            // is "probability value"; 101 is "probability
                            // undecided/unavailable"

    uint8 u8RadarMotionTypeInput;  // get motion type from radar input, new
                                   // value for the tuerme. set value from enum
                                   // TueFusion_SensorInputMotion
} Fusn_TrackTypeOut;

typedef struct {
    uint16 u16ListUpdateCounter; // Counter that is incremented whenever a
                                    // module outputs an updated object(starting
                                    // from 0, maximum value is 60.000, counter
                                    // will overflow to 0 afterwards)
    uint16 u16NumObjects;        // Number of trackables which have a non-dying
                                 // lifespan
    uint32 u32SensorPattern;     // Sensor pattern
    float32
        f32MeasurementLatency; // Common age [s] of all object estimations
                                // within the data array: positive latencies
                                // indicate outdated information; negative
                                // latencies indicate predicted object data
    Fusn_TrackTypeOut aTrackable[TUE_FUS_OUTPUT_OBJ_NUMBER]; /** object array with limited capacity */
} Fusn_ObjectListOut;

typedef struct {
    uint32 u32ErrorCode;
    uint8 u8AAU_Code;
    uint8 u8FunctionCode;
    uint16 u16Age;
} Fusn_ErrorTypeOut;

typedef struct {
    Fusn_ErrorTypeOut
        aErrorBuffer[5];    // ringbuffer items for an amount of time
    uint16 u16NextWriteIdx; // index of next free item
    uint16 u16NumOfItems;   // Note that u16NumOfItems does not necessarily
                            //    point to the last object in the buffer
} Fusn_ErrorBufferOut;

typedef struct {
    Fusn_ObjectListOut objListOutput;
    // Fusn_ObjectListOut objListOutputIDManager;
    Fusn_ErrorBufferOut errTypeOutput;
} proFusionPrtList_t;


// **************** LIDAR Object list **********************

typedef struct {
    float32 data[3];             
} Point3D_;

typedef struct {
    float32 data[3][3];             
} CovMat3D;

typedef struct {
    // uint8 eDynamicProperty;
    // uint8 uiStoppedConfidence;
    // uint8 eAbsMovingState;
    uint8 Type;           // uint8 eClassification;
    uint8 SubType;
    float64 confidence;  //double // uint8 uiClassConfidence;
} Lidar_Attributes_t;

typedef struct {
    float64 width;      //double
    float64 length;      //double
    float64 height;       //double
    float64 theta;      //double
    // float32 fOrientationStd;
    // float32 fOrientationValid;
} Lidar_Geometry_t;


typedef struct {
    Point3D_ fDist;
    CovMat3D fCovDist;
    Point3D_ fVel;
    CovMat3D fCovVel;
    Point3D_ fAcc;
    CovMat3D fCovAcc;
    // float32 fDistX;
    // float32 fDistXStd;
    // float32 fDistY;
    // float32 fDistYStd;
    // float32 fVrelX;
    // float32 fVrelXStd;
    // float32 fVrelY;
    // float32 fVrelYStd;
    // float32 fArelX;
    // float32 fArelXStd;
    // float32 fArelY;
    // float32 fArelYStd;
} Lidar_Kinematic_t;

typedef struct {
    float32 fProbabilityOfExistence;
    uint8 ucObstacleProbability;  // add Obstacle Probability for ars410 radar
    //uint8 uMeasuredTargetFrequencyNear;
    //uint8 uMeasuredTargetFrequencyFar;
} Lidar_Qualifiers_t;

typedef struct {
    sint32 ID;                  //sint32 ObjectId;  
    Lidar_Kinematic_t Kinematic;
    Lidar_Geometry_t Geometry;
    Lidar_Attributes_t Attributes;
    // Lidar_General_t General;
    Lidar_Qualifiers_t Qualifiers;
    //fus_SensorSpecific_t SensorSpecific;
    //fus_EBAPresel_t EBAPresel;
    //fus_LegacyObj_t Legacy;
} Lidar_In_Objects_t;

typedef Lidar_In_Objects_t LidarInObjects_array_t[TUE_LIDAR_RAW_OBJECT_NUM];

typedef struct {
    double  timestamp; //uint32  uiTimeStamp;
    //uint16  uiCycleCounter;
    //uint8   eSigStatus;
    uint16  uNumOfUsedObjects;
    LidarInObjects_array_t Objects;
} Lidar_In_ObjectList_t;

typedef Lidar_In_ObjectList_t
    MultiLidar_ObjectList_t[MULTI_SENSOR_LIDAR_QUANTITY];

typedef struct {
    MultiLidar_ObjectList_t Lidarobjlists;
} Lidar_input_lists;


 // **************** CAMERA Object list **********************

typedef struct {
    float32 data[3];    /**< data */
} Vector3d;

typedef struct {
    float32 data[3][3];
} Matrix3f;

typedef struct {
    float32 yaw;
    //float yaw_uncertainty;
    //float yaw_rate;
   // float yaw_rate_uncertainty;
} directionInfo;


typedef struct {
    Point3D_ fDist;
    CovMat3D fCovDist;
    Point3D_ fVel;
    CovMat3D fCovVel;
    Point3D_ fAcc;
    CovMat3D fCovAcc;
    // float32 fDistX;
    // float32 fDistXStd;
    // float32 fDistY;
    // float32 fDistYStd;
    // float32 fVrelX;
    // float32 fVrelXStd;
    // float32 fVrelY;
    // float32 fVrelYStd;
    // float32 fArelX;
    // float32 fArelXStd;
    // float32 fArelY;
    // float32 fArelYStd;
    //uint8 eRefpointLocation;
} Camera_Kinematic_t;

typedef struct {
    float32 width;                           //float32 fwidth;
    float32 length;                          //float32 flength;
    float32 height;                          //float32 fheight; 
    //float32 fOffsetToGround;
} Camera_Geometry_t;

typedef struct {
    float32  type_confidence;               //uint8 probabilityOfClassification
    uint8 ObjectType;
} Camera_classification_t;

typedef struct {
    //eStatusBrakeLight uint8
    // uint8 uiBrakeLightConfidence;
    // uint8 eStatusTurnIndicator;
    // uint8 uiTurnIndicatorConfidence;
    // uint8 eAssociatedLane;
    // uint8 uiAssociatedLaneConfidence
    // uint8 eLaneChangeManeuver;
    //uint8  percentageOwnDrivingLane;
    // uint8 percentageSideDrivingLaneLeft;
   //uint8 percentageSideDrivingLaneRight;
   uint16 maintenance_status;           //uint8 eMainteanceState
   float32 existence_confidence;        //uint8 percentageProbOfExist
   uint16 motion_status;               //eMotionState uint8
   float32 track_age_time_second;     //uint32 ObjectLifeCycles
} Camera_Attributes_t;

typedef struct {
    uint32 track_id;               //uint8 ObjectID; 
    Camera_Kinematic_t Kinematic;
    Camera_Geometry_t Geometry;
    Camera_Attributes_t Attributes;
    Camera_classification_t Classification;
} Camera_In_Objects_t;

typedef Camera_In_Objects_t CameraInObjects_array_t[TUE_CAMERA_RAW_OBJECT_NUM];

typedef struct {
    uint32 last_measure_update_timestamp_ns; //uint32  uiTimeStamp;
    //uint16  uiCycleCounter;
    //uint8   eSigStatus;
    //uint16  uiMeasurementCounter;
    CameraInObjects_array_t Objects;
} Camera_In_ObjectList_t;

typedef Camera_In_ObjectList_t       
    Multicamera_ObjectList_t[MULTI_SENSOR_CAMERA_QUANTITY];

typedef struct {                     
    Multicamera_ObjectList_t Cameraobjlists;
} Camera_input_lists;


//************************ FUSION 2 DPC data type ************************

typedef struct {
    uint8 id;                
    uint8 type;
    float32 relative_x;
    float32 relative_y;
    float32 absolute_velocity_x;
    float32 absolute_velocity_y;
    float32 absolute_acceleration_x;
    float32 absolute_acceleration_y;
    float32 width;
    float32 height;
    float32 length;
    uint8 motion_type;
    uint8 contributing_sensor;
} Fusion_Out_Objects_t;

typedef Fusion_Out_Objects_t FusionOutObjects_array_t[FUSION_NR_EXTERNAL_OBJECTS];

typedef struct {
    FusionOutObjects_array_t Objects;
} Fusion_Out_ObjectList_t;



/*****************************************************************************
  FUNCTION PROTOTYPES
*****************************************************************************/
// __declspec(dllexport) void ENVM_Exec(const reqEMPrtList_t* reqPorts,
// proEnvmPrtList_t* proPorts);
// void ENVM_Exec(const reqEMPrtList_t* reqPorts, proEnvmPrtList_t* proPorts);
// void Fusion_Init();
// void Fusion_Main(void);
// __declspec(dllexport) void ENVM_Exec_Wrapper(const baseReqEMPrtList_t*
// reqPorts, baseProEnvmPrtList_t* proPorts, ExtObjectList_t* pRadarInput,
// CamObjectList* pCamerInput, uint32 uTimestamp); extern void
// ENVM_Exec_Wrapper(const baseReqEMPrtList_t* reqPorts, baseProEnvmPrtList_t*
// proPorts,ExtObjectList_t* pRadarInput , CamObjectList* pCamerInput, uint32
// uTimestamp);

#ifdef __cplusplus
}
#endif
#endif // SoftwareMotion_PILOT_DECISION_PILOT_DECISION_SDK_DECISION_SRC_FUSION_FUSION_EXT_H_
