#ifndef CLIDAROBJECTSWRAPPERTOFUSION_H
#define CLIDAROBJECTSWRAPPERTOFUSION_H
//#include "LidarObjectStructure.h"
#include "wrappers/Fusion_GeneralWrapper.h"
extern "C" {
	#include <stdio.h>
	#include <stdlib.h>
	#include "Fusion_main.h"
	#include "Fusion_SLAM_types.h"
	#include "SimUtils.h"
	#include "TueObjFusn_TrackableListProps.h"
	#include "TueObjFusn_ObjectListProps.h"
	#include "TueObjFusn_MatchIndex.h"
	#include "tue_prv_common_matrix.h"
	#include "fusion_ext.h"
}
class CLidarObjectsWrapperToFusion
{
private:
    static Lidar_In_Objects_t Convert( perception::LiDARPerception2Fusion lidarObject)
    {
		Lidar_In_Objects_t tmp;
		tmp.Attributes.SubType = lidarObject.subtype;
		tmp.Attributes.Type = lidarObject.type;
		tmp.Attributes.confidence = lidarObject.confidence;
		tmp.Geometry.height = lidarObject.height;
		tmp.Geometry.length = lidarObject.length;
		tmp.Geometry.theta = lidarObject.theta;
		tmp.Geometry.width = lidarObject.width;
		tmp.ID = lidarObject.ID;
		tmp.Kinematic.fAcc.data[0] = lidarObject.acceleration.x;
		tmp.Kinematic.fAcc.data[1] = lidarObject.acceleration.y;
		tmp.Kinematic.fAcc.data[2] = lidarObject.acceleration.z;
		tmp.Kinematic.fCovAcc.data[0][0] = lidarObject.acceleration_covariance[0];
		tmp.Kinematic.fCovAcc.data[1][1] = lidarObject.acceleration_covariance[1];
		tmp.Kinematic.fCovAcc.data[2][2] = lidarObject.acceleration_covariance[2];
		tmp.Kinematic.fDist.data[0] = lidarObject.position.x;
		tmp.Kinematic.fDist.data[1] = lidarObject.position.y;
		tmp.Kinematic.fDist.data[2] = lidarObject.position.z;
		tmp.Kinematic.fCovDist.data[0][0] = lidarObject.position_covariance[0];
		tmp.Kinematic.fCovDist.data[1][1] = lidarObject.position_covariance[1];
		tmp.Kinematic.fCovDist.data[2][2] = lidarObject.position_covariance[2];
		tmp.Kinematic.fVel.data[0] = lidarObject.velocity.x;
		tmp.Kinematic.fVel.data[1] = lidarObject.velocity.y;
		tmp.Kinematic.fVel.data[2] = lidarObject.velocity.z;
		tmp.Kinematic.fCovVel.data[0][0] = lidarObject.velocity_covariance[0];
		tmp.Kinematic.fCovVel.data[1][1] = lidarObject.velocity_covariance[1];
		tmp.Kinematic.fCovVel.data[2][2] = lidarObject.velocity_covariance[2];
		tmp.Qualifiers.fProbabilityOfExistence = 1;
		tmp.Qualifiers.ucObstacleProbability = 1;
		return tmp;
    };
public:
    static Lidar_input_lists ConvertLidar2FusionToLIdar(perception::vector_LiDARPerception2Fusion data)
    {
    	Lidar_input_lists tmp;
		tmp.Lidarobjlists[0].timestamp = 0;
		int i = 0;
		for(auto& datum : data)
		{
			tmp.Lidarobjlists[0].timestamp += datum.timestamp;
			tmp.Lidarobjlists[0].Objects[i++] = Convert(datum);
		}
		tmp.Lidarobjlists[0].timestamp /= data.size();
		tmp.Lidarobjlists[0].uNumOfUsedObjects = data.size();
		return tmp;
    };
};

#endif // CLIDAROBJECTSWRAPPERTOFUSION_H
