
#include "Fusion_GeneralWrapper.h"

#include "ara/log/logging.h"


GeneralWrapper::GeneralWrapper(ara::log::Logger& mainLog) : 
    _Object_Provide("fusion/fusion/FusionObjectsPPort" ,mainLog),
    _FrontCamDrvPerception2Fusion_Required("fusion/fusion/FrontCamDrvPerception2FusionRPort", mainLog),
    _LeftCamDrvPerception2Fusion_Required("fusion/fusion/LeftCamDrvPerception2FusionRPort", mainLog),
    _RightCamDrvPerception2Fusion_Required("fusion/fusion/RightCamDrvPerception2FusionRPort", mainLog),
    _RearCamDrvPerception2Fusion_Required("fusion/fusion/RearCamDrvPerception2FusionRPort", mainLog),
    _CamPrkPerception2Fusion_Required("fusion/fusion/CamPrkPerception2FusionRPort" ,mainLog),
    _VED2FusionEgoMotion_Required("fusion/fusion/VED2FusionEgoMotionRPort" ,mainLog),
    _LidarPerception2Fusion_Required("fusion/fusion/LidarPerception2FusionRPort" ,mainLog)
{
    _Object_Provide.Init();
    _CamPrkPerception2Fusion_Required.Init();
    _FrontCamDrvPerception2Fusion_Required.Init();
    _LeftCamDrvPerception2Fusion_Required.Init();
    _RightCamDrvPerception2Fusion_Required.Init();
    _RearCamDrvPerception2Fusion_Required.Init();
    _VED2FusionEgoMotion_Required.Init();
    _LidarPerception2Fusion_Required.Init();
}

GeneralWrapper::~GeneralWrapper() {
    _CamPrkPerception2Fusion_Required.Destroy();
    _FrontCamDrvPerception2Fusion_Required.Destroy();
    _LeftCamDrvPerception2Fusion_Required.Destroy();
    _RightCamDrvPerception2Fusion_Required.Destroy();
    _RearCamDrvPerception2Fusion_Required.Destroy();
    _VED2FusionEgoMotion_Required.Destroy();
    _LidarPerception2Fusion_Required.Destroy();
}

