#ifndef SLAM_INTERFACE_COMMON_TYPE_H_
#define SLAM_INTERFACE_COMMON_TYPE_H_

#include <cstdint>

namespace slam
{

  struct Vector2d
  {
    /// @brief x
    double x;
    /// @brief y
    double y;
    Vector2d(): x(0.0), y(0.0){}
  };

  struct Vector2f
  {
    /// @brief x
    float x;
    /// @brief y
    float y;
  };

  struct Vector3f
  {
    /// @brief x
    float x;
    /// @brief y
    float y;
    /// @brief z
    float z;
  };

  struct Vector3d
  {
    double x;
    double y;
    double z;
  };

  struct Quaternionf
  {
    float x;
    float y;
    float z;
    float w;
  };

  struct Quaterniond
  {
    double w, x, y, z;
  };

  // Wheel speed direction
  enum class WheelSpeedDirection : std::uint8_t
  {
    FORWARD = 0,    // Forward
    BACKWARD = 1,   // Backward
    MOTIONLESS = 2, // Motionless
    INVALID = 3,    // Invalid
  };

  

} // namespace slam

#endif // SLAM_INTERFACE_COMMON_TYPE_H_
