#ifndef SLAM_UTIL_TOOL_H
#define SLAM_UTIL_TOOL_H

#include <iostream>
#include <cmath>
#include <vector>
#include "interface/common_type.h"
#include <limits>



namespace slam
{
    class SlamUtil
    {

    public:
        static Quaterniond EulerToQuaternion(double roll, double pitch, double yaw);

        static int findNearestPointIndex(const slam::Vector2d& cur_host_pos,
                                     const std::vector<slam::Vector2d>& ref_line,
                                     double max_distance, double min_distance);

        static slam::Vector2d globalToLocal(slam::Vector2d glb_p,slam::Vector2d center_p, double heading);
        
    private:
        /* data */
    };

} // namespace slam

#endif // SLAM_UTIL_TOOL_H
