#include "data_manager/data_manager.h"

namespace slam{

DataManager::DataManager()
{
}

void DataManager::Init()
{
    cam_manager_ = std::make_shared<CommonDataManager<RoadFrame>>();
    cam_manager_->Init("Cam", 5);

    imu_manager_ = std::make_shared<CommonDataManager<ImuData>>();
    imu_manager_->Init("Imu", 20);

    gnss_manager_ = std::make_shared<CommonDataManager<GnssData>>();
    gnss_manager_->Init("gnss", 20);

    ins_manager_ = std::make_shared<CommonDataManager<InsData>>();
    ins_manager_->Init("gnss", 5);

    can_manager_ = std::make_shared<CommonDataManager<VehicleData>>();
    can_manager_->Init("can", 20);

    odom_manager_ = std::make_shared<CommonDataManager<slam_odometry>>();
    odom_manager_->Init("odom", 2);

    decision_manager_ = std::make_shared<CommonDataManager<ControlWaypoints>>();
    decision_manager_->Init("dcp", 2);

    rm_manager_ = std::make_shared<CommonDataManager<slam_road_model>>();
    rm_manager_->Init("rm", 2);
}

void DataManager::InputVisionMsg(RoadFrame* cam_msg) {
    cam_manager_->InputData(cam_msg);
}

void DataManager::InputCanMsg(VehicleData* _can_msg) {

    can_manager_->InputData(_can_msg);
}

void DataManager::InputImuMsg(ImuData* _imu_msg) {

    imu_manager_->InputData(_imu_msg);
}

void DataManager::InputGnssMsg(GnssData* _gnss_msg)
{
    gnss_manager_->InputData(_gnss_msg);
}

void DataManager::InputInsMsg(InsData* _ins_msg)
{
    ins_manager_->InputData(_ins_msg);
}



} //slam
