#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QCoreApplication>
#include <QObject>
#include <QDebug>
#include <QMainWindow>
#include <Eigen/Dense>

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

class MainWindow : public QMainWindow
{
    Q_OBJECT


public:
    EIGEN_MAKE_ALIGNED_OPERATOR_NEW
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

private slots:
    void on_actionfocus_triggered();

    void on_actionplay_triggered();

    void on_action3DQuat_triggered();

private:
    Ui::MainWindow *ui;

    void Create3DFrame();
    void SetSignals();

    void PlotNdm();

    void ReadInsData(std::string fp_);
};
#endif // MAINWINDOW_H
