#ifndef MAPVIEWER_H
#define MAPVIEWER_H

#include "qcustomplot.h"
#include <Eigen/Dense>
#include <vector>
#include <map>
#include <iostream>
#include <math.h>
#include <mutex>

#include <QPixmap>
#include <QLabel>
#include "chartform.h"

using namespace std;

class MapViewer: public QObject {
    Q_OBJECT

public:

    void Init(QCustomPlot *customPlot_);
    std::mutex mtx_ui;
    void SetOdomFocus()
    {
        std::lock_guard<std::mutex> lock(mtx_ui);
        odo_focused = !odo_focused;
    }

    void Show3DQuaternion(QWidget* _p);

private:

    void SetBackGround();

    QCustomPlot *customPlot;

    void PlotLine(QVector<QCPCurveData> dataSpiral, QColor _color, int _width);
    void PlotPoints(QVector<QCPCurveData> dataSpiral, QColor _color);

    void SetHostCorners();
    vector<Eigen::Vector2d> m_host_corner;
    map<int, QCPCurve *> vehicle_shp;
    QCPCurve *odo_curve;

    bool odo_focused{false};

    ChartForm *chartForm;
    bool chartForm_flag = false;

};

#endif // MAPVIEWER_H
