#ifndef VISION_ODOM_H
#define VISION_ODOM_H
#include "vision_common.h"
#include "lane_msg_info.h"
#include "matched_frame.h"
#include "iomanip"
namespace Localization
{
namespace PointLoc
{
class PoseComputeICP
{
public:
  PoseComputeICP();
  bool ComputeByFrameVCS(const MatchFrame &input,PointLocResult &locRes);
private:

  void VehAddOpt2Prior(Eigen::Vector3d priorPos,Eigen::Matrix3d priorRot,
                       Eigen::Vector3d dPos,Eigen::Matrix3d dRot,
                       PointLocResult &locRes);
  bool CalTransformCeres(std::vector<Eigen::Vector3d> &aimClouds,std::vector<Eigen::Vector3d> &bigClouds,
                         std::vector<float> &weights,const Eigen::Vector3d &posIn,
                         const Eigen::Matrix3d &rotYPRIn,Eigen::Vector3d &posOut,Eigen::Matrix3d &rotYPROut);
  void InterPolateFrameLinesVCS(const MatchFrame &input,
                                std::vector<std::vector<Eigen::Vector3d>> &camLines,
                                std::vector<std::vector<Eigen::Vector3d>> &mapLines);
  void ComputeWeights(const std::vector<std::vector<Eigen::Vector3d>> &camLines,
                                      const std::vector<std::vector<Eigen::Vector3d>> &mapLines,
                                      std::vector<Eigen::Vector3d> &camCloud,
                                      std::vector<Eigen::Vector3d> &mapCloud,
                                      std::vector<float> &weights);
};
} // namespace PointLoc
} // namespace Localization
#endif
