#include "pub/PubWrapperHelper.h"
#include "pub/PubDataWrapper.h"
#include "SLAM_PubDataWrapper.h"
#include "slam/executable.h"

#include "SLAM_GeneralWrapper.h"


GeneralWrapper::GeneralWrapper(ara::log::Logger& mainLog) : 
//Provides 
_SLAM2EMposition_Provide("slam/slam/SLAM2EMpositionPPort" ,mainLog),
_SLAM2EMattribute_Provide("slam/slam/SLAM2EMattributePPort" ,mainLog),
_SLAM2EMline_point_Provide("slam/slam/SLAM2EMline_pointPPort" ,mainLog),
_SLAM2EMline_Provide("slam/slam/SLAM2EMlinePPort" ,mainLog),
_SLAM2EMspeed_limit_Provide("slam/slam/SLAM2EMspeed_limitPPort" ,mainLog),
_SLAM2EMtraffic_object_Provide("slam/slam/SLAM2EMtraffic_objectPPort" ,mainLog),
_SLAM2EMlane_Provide("slam/slam/SLAM2EMlanePPort" ,mainLog),
_SLAM2EMroad_edge_Provide("slam/slam/SLAM2EMroad_edgePPort" ,mainLog),
_SLAM2EMslam_road_model_Provide("slam/slam/SLAM2EMslam_road_modelPPort" ,mainLog),
_SLAM2DMAdjacentExtendLaneStruct_Provide("slam/slam/SLAM2DMAdjacentExtendLaneStructPPort" ,mainLog),
_SLAM2DMSMAStruct_Provide("slam/slam/SLAM2DMSMAStructPPort" ,mainLog),
_SLAM2DMWPExtendLaneStruct_Provide("slam/slam/SLAM2DMWPExtendLaneStructPPort" ,mainLog),
_SLAM2DMRemindWaypointStruct_Provide("slam/slam/SLAM2DMRemindWaypointStructPPort" ,mainLog),
_SLAM2DMControlWaypointStruct_Provide("slam/slam/SLAM2DMControlWaypointStructPPort" ,mainLog),
_SLAM2DMMsgHeader_Provide("slam/slam/SLAM2DMMsgHeaderPPort" ,mainLog),
_SLAM2DMTransitLaneStruct_Provide("slam/slam/SLAM2DMTransitLaneStructPPort" ,mainLog),
_SLAM2DMControlWaypoints_Provide("slam/slam/SLAM2DMControlWaypointsPPort" ,mainLog),
_Slam2PerceptionOdom_Provide("slam/slam/Slam2PerceptionOdomPPort" ,mainLog),
//Requireds
_CAN2SLAM_Required("slam/slam/CAN2SLAMRPort" ,mainLog)
{
    //Provides
    _SLAM2EMposition_Provide.Init();
    _SLAM2EMattribute_Provide.Init(_SLAM2EMposition_Provide._skeleton);
    _SLAM2EMline_point_Provide.Init();
    _SLAM2EMline_Provide.Init(_SLAM2EMposition_Provide._skeleton);
    _SLAM2EMspeed_limit_Provide.Init(_SLAM2EMposition_Provide._skeleton);
    _SLAM2EMtraffic_object_Provide.Init(_SLAM2EMposition_Provide._skeleton);
    _SLAM2EMlane_Provide.Init(_SLAM2EMposition_Provide._skeleton);
    _SLAM2EMroad_edge_Provide.Init(_SLAM2EMposition_Provide._skeleton);
    _SLAM2EMslam_road_model_Provide.Init(_SLAM2EMposition_Provide._skeleton);
    _SLAM2DMAdjacentExtendLaneStruct_Provide.Init(_SLAM2EMposition_Provide._skeleton);
    _SLAM2DMSMAStruct_Provide.Init(_SLAM2EMposition_Provide._skeleton);
    _SLAM2DMWPExtendLaneStruct_Provide.Init(_SLAM2EMposition_Provide._skeleton);
    _SLAM2DMRemindWaypointStruct_Provide.Init(_SLAM2EMposition_Provide._skeleton);
    _SLAM2DMControlWaypointStruct_Provide.Init(_SLAM2EMposition_Provide._skeleton);
    _SLAM2DMMsgHeader_Provide.Init(_SLAM2EMposition_Provide._skeleton);
    _SLAM2DMTransitLaneStruct_Provide.Init(_SLAM2EMposition_Provide._skeleton);
    _SLAM2DMControlWaypoints_Provide.Init(_SLAM2EMposition_Provide._skeleton);
    _Slam2PerceptionOdom_Provide.Init(_SLAM2EMposition_Provide._skeleton);

    //Requireds
    _CAN2SLAM_Required.Init();

}

GeneralWrapper::~GeneralWrapper() 
{
    _CAN2SLAM_Required.Destroy();
}

/*
Data filling 
*/

