#ifndef SLAM_GENERAL_WRAPPER_HEADER_H
#define SLAM_GENERAL_WRAPPER_HEADER_H
#include "pub/PubWrapperHelper.h"
#include "pub/PubDataWrapper.h"
#include "sub/SubWrapperHelper.h"
#include "SLAM_PubDataWrapper.h"
#include "SLAM_SubDataWrapper.h"
#include "slam/executable.h"

using namespace jac::ap::slamservice::skeleton;
using namespace jac::ap::canservice::proxy;

//PubWrappers
GENERATE_PUB_WRAPPER(SLAM2EMposition_Provide, SLAM2EMposition_PubDataWrapper, SLAMServiceSkeleton, dpc::position, PositionEvent);
GENERATE_PUB_WRAPPER(SLAM2EMattribute_Provide, SLAM2EMattribute_PubDataWrapper, SLAMServiceSkeleton, dpc::attribute, AttributeEvent);
GENERATE_PUB_WRAPPER(SLAM2EMline_point_Provide, SLAM2EMline_point_PubDataWrapper, SLAMServiceSkeleton, dpc::line_point, LinePointEvent);
GENERATE_PUB_WRAPPER(SLAM2EMline_Provide, SLAM2EMline_PubDataWrapper, SLAMServiceSkeleton, dpc::line, LineEvent);
GENERATE_PUB_WRAPPER(SLAM2EMspeed_limit_Provide, SLAM2EMspeed_limit_PubDataWrapper, SLAMServiceSkeleton, dpc::speed_limit, SpeedLimitEvent);
GENERATE_PUB_WRAPPER(SLAM2EMtraffic_object_Provide, SLAM2EMtraffic_object_PubDataWrapper, SLAMServiceSkeleton, dpc::traffic_object, TrafficObjectEvent);
GENERATE_PUB_WRAPPER(SLAM2EMlane_Provide, SLAM2EMlane_PubDataWrapper, SLAMServiceSkeleton, dpc::Lane, LaneEventSlam);
GENERATE_PUB_WRAPPER(SLAM2EMroad_edge_Provide, SLAM2EMroad_edge_PubDataWrapper, SLAMServiceSkeleton, dpc::RoadEdge, RoadEdgeEvent);
GENERATE_PUB_WRAPPER(SLAM2EMslam_road_model_Provide, SLAM2EMslam_road_model_PubDataWrapper, SLAMServiceSkeleton, dpc::slam_road_model, SLAMRoadModelEvent);
GENERATE_PUB_WRAPPER(SLAM2DMAdjacentExtendLaneStruct_Provide, SLAM2DMAdjacentExtendLaneStruct_PubDataWrapper, SLAMServiceSkeleton, dpc::AdjacentExtendLaneStruct, AdjacentExtendLaneStructEvent);
GENERATE_PUB_WRAPPER(SLAM2DMSMAStruct_Provide, SLAM2DMSMAStruct_PubDataWrapper, SLAMServiceSkeleton, dpc::SMAStruct, SMAStructEvent);
GENERATE_PUB_WRAPPER(SLAM2DMWPExtendLaneStruct_Provide, SLAM2DMWPExtendLaneStruct_PubDataWrapper, SLAMServiceSkeleton, dpc::WPExtendLaneStruct, WPExtendLaneStructEvent);
GENERATE_PUB_WRAPPER(SLAM2DMRemindWaypointStruct_Provide, SLAM2DMRemindWaypointStruct_PubDataWrapper, SLAMServiceSkeleton, dpc::RemindWayPointStruct, RemindWayPointStructEvent);
GENERATE_PUB_WRAPPER(SLAM2DMControlWaypointStruct_Provide, SLAM2DMControlWaypointStruct_PubDataWrapper, SLAMServiceSkeleton, dpc::ControlWayPointStruct, ControlWayPointStructEvent);
GENERATE_PUB_WRAPPER(SLAM2DMMsgHeader_Provide, SLAM2DMMsgHeader_PubDataWrapper, SLAMServiceSkeleton, dpc::MsgHeader, MsgHeaderEvent);
GENERATE_PUB_WRAPPER(SLAM2DMTransitLaneStruct_Provide, SLAM2DMTransitLaneStruct_PubDataWrapper, SLAMServiceSkeleton, dpc::TransitLaneStruct, TransitLaneStructEvent);
GENERATE_PUB_WRAPPER(SLAM2DMControlWaypoints_Provide, SLAM2DMControlWaypoints_PubDataWrapper, SLAMServiceSkeleton, dpc::ControlWaypoints, ControlWayPointsEvent);
GENERATE_PUB_WRAPPER(Slam2PerceptionOdom_Provide, Slam2PerceptionOdom_PubDataWrapper, SLAMServiceSkeleton, dpc::slam_odometry, SLAMOdometryEvent);
//SubWrappers
GENERATE_SUB_WRAPPER(CAN2SLAM_Required, CAN2SLAM_SubDataWrapper, CANServiceProxy, CAN2SWC, CAN2SWCEvent, "3", 10);

class GeneralWrapper {
public:
    //Providers
    SLAM2EMposition_Provide _SLAM2EMposition_Provide;
    SLAM2EMattribute_Provide _SLAM2EMattribute_Provide;
    SLAM2EMline_point_Provide _SLAM2EMline_point_Provide;
    SLAM2EMline_Provide _SLAM2EMline_Provide;
    SLAM2EMspeed_limit_Provide _SLAM2EMspeed_limit_Provide;
    SLAM2EMtraffic_object_Provide _SLAM2EMtraffic_object_Provide;
    SLAM2EMlane_Provide _SLAM2EMlane_Provide;
    SLAM2EMroad_edge_Provide _SLAM2EMroad_edge_Provide;
    SLAM2EMslam_road_model_Provide _SLAM2EMslam_road_model_Provide;
    SLAM2DMAdjacentExtendLaneStruct_Provide _SLAM2DMAdjacentExtendLaneStruct_Provide;
    SLAM2DMSMAStruct_Provide _SLAM2DMSMAStruct_Provide;
    SLAM2DMWPExtendLaneStruct_Provide _SLAM2DMWPExtendLaneStruct_Provide;
    SLAM2DMRemindWaypointStruct_Provide _SLAM2DMRemindWaypointStruct_Provide;
    SLAM2DMControlWaypointStruct_Provide _SLAM2DMControlWaypointStruct_Provide;
    SLAM2DMMsgHeader_Provide _SLAM2DMMsgHeader_Provide;
    SLAM2DMTransitLaneStruct_Provide _SLAM2DMTransitLaneStruct_Provide;
    SLAM2DMControlWaypoints_Provide _SLAM2DMControlWaypoints_Provide;
    Slam2PerceptionOdom_Provide _Slam2PerceptionOdom_Provide;

    //Requireds
    CAN2SLAM_Required _CAN2SLAM_Required;

    GeneralWrapper(ara::log::Logger& mainLog);
    ~GeneralWrapper();
};


#endif

