#ifndef SLAMPubDataWrapper_WRAPPER_HEADER_H
#define SLAMPubDataWrapper_WRAPPER_HEADER_H

#include "pub/PubDataWrapper.h"
#include "slam/executable.h"


/*-------------------------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class SLAM2EMposition_PubDataWrapper: public PubDataWrapper<EventType>

{
private:
	dpc::position slam_position_data;
public:

	void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
	{
		data->x = slam_position_data.x;
//		std::cout<< __LINE__ <<std::endl;

		data->y = slam_position_data.y;
//		std::cout<<"SLAM2EMposition x:"<<data->x<<std::endl;
//		std::cout<<"SLAM2EMposition y:"<<data->y<<std::endl;
	}

	void SetData(dpc::position &_slam_position_data)
	{
		slam_position_data.x = _slam_position_data.x;
//		std::cout<< __LINE__ <<std::endl;

		slam_position_data.y = _slam_position_data.y;
//		std::cout<< __LINE__ <<std::endl;
		return;

	}
};


/*-------------------------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class SLAM2EMattribute_PubDataWrapper: public PubDataWrapper<EventType>

{
private:
	dpc::attribute slam_attribute_data;
public:
	void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
	{
		data->curve = slam_attribute_data.curve;
		data->offset = slam_attribute_data.offset;
		data->lane_marker_type = slam_attribute_data.lane_marker_type;
		//data->attribute = slam_attribute_data.attribute;
//		std::cout<<"SLAM2EMattribute curve:"<<data->curve<<std::endl;
//		std::cout<<"SLAM2EMattribute offset:"<<data->offset<<std::endl;
//		std::cout<<"SLAM2EMattribute lane_marker_type:"<<data->lane_marker_type<<std::endl;

	}

	void SetData(dpc::attribute &_slam_attribute_data)
	{
		slam_attribute_data.curve = _slam_attribute_data.curve;
		slam_attribute_data.offset = _slam_attribute_data.offset;
		slam_attribute_data.lane_marker_type = _slam_attribute_data.lane_marker_type;
		//slam_attribute_data.attribute = data.attribute;

	}
};


/*-------------------------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class SLAM2EMline_point_PubDataWrapper: public PubDataWrapper<EventType>

{
private:
	dpc::line_point slam_line_point_data;
public:
	void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
	{
		data->point = slam_line_point_data.point;
		data->point_attri = slam_line_point_data.point_attri;
//		std::cout<<"SLAM2EMline_point point.x:"<<data->point.x<<std::endl;
//		std::cout<<"SLAM2EMline_point point.y:"<<data->point.y<<std::endl;
//		std::cout<<"SLAM2EMline_point point_attri.curve:"<<data->point_attri.curve<<std::endl;
//		std::cout<<"SLAM2EMline_point point_attri.offset:"<<data->point_attri.offset<<std::endl;
//		std::cout<<"SLAM2EMline_point point_attri.lane_marker_type:"<<data->point_attri.lane_marker_type<<std::endl;
	}

	void SetData(dpc::line_point &_slam_line_point_data)
	{
		slam_line_point_data.point = _slam_line_point_data.point;
		slam_line_point_data.point_attri = _slam_line_point_data.point_attri;
	}
};


/*-------------------------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class SLAM2EMline_PubDataWrapper: public PubDataWrapper<EventType>

{
private:
	dpc::line slam_line_data;
public:
	void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
	{
		data->color = slam_line_data.color;
		data->direction = slam_line_data.direction;
		data->end_offset = slam_line_data.end_offset;
		data->id = slam_line_data.id;
		data->points = slam_line_data.points;
		data->position_type = slam_line_data.position_type;
		data->start_offset = slam_line_data.start_offset;
		data->width = slam_line_data.width;
//		std::cout<<"SLAM2EMline color:"<<data->color<<std::endl;
//		std::cout<<"SLAM2EMline direction:"<<data->direction<<std::endl;
//		std::cout<<"SLAM2EMline end_offset:"<<data->end_offset<<std::endl;
//		std::cout<<"SLAM2EMline id:"<<data->id<<std::endl;
//		for (size_t i = 0; i < data->points.size(); i++)
//		{
//			std::cout<<"SLAM2EMline points"<<i<<" :"<<data->points.at(i).point.x<<std::endl;
//		}
//		std::cout<<"SLAM2EMline position_type:"<<data->position_type<<std::endl;
//		std::cout<<"SLAM2EMline start_offset:"<<data->start_offset<<std::endl;
//		std::cout<<"SLAM2EMline width:"<<data->width<<std::endl;
	}

	void SetData(dpc::line &_slam_line_data)
	{
		slam_line_data.color = _slam_line_data.color;
		slam_line_data.direction = _slam_line_data.direction;
		slam_line_data.end_offset = _slam_line_data.end_offset;
		slam_line_data.id = _slam_line_data.id;
		slam_line_data.points = _slam_line_data.points;
		slam_line_data.position_type = _slam_line_data.position_type;
		slam_line_data.start_offset = _slam_line_data.start_offset;
		slam_line_data.width = _slam_line_data.width;
	}
};


/*-------------------------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class SLAM2EMspeed_limit_PubDataWrapper: public PubDataWrapper<EventType>

{
private:
	dpc::speed_limit slam_speed_limit_data;
public:
	void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
	{
		data->max_speed_limit = slam_speed_limit_data.max_speed_limit;
		data->min_speed_limit = slam_speed_limit_data.min_speed_limit;
		data->rec_speed_limit = slam_speed_limit_data.rec_speed_limit;
//		std::cout<<"SLAM2EMspeed_limit max_speed_limit:"<<data->max_speed_limit<<std::endl;
//		std::cout<<"SLAM2EMspeed_limit min_speed_limit:"<<data->min_speed_limit<<std::endl;
//		std::cout<<"SLAM2EMspeed_limit rec_speed_limit:"<<data->rec_speed_limit<<std::endl;
	}

	void SetData(dpc::speed_limit &_slam_speed_limit_data)
	{
		slam_speed_limit_data.max_speed_limit = _slam_speed_limit_data.max_speed_limit;
		slam_speed_limit_data.min_speed_limit = _slam_speed_limit_data.min_speed_limit;
		slam_speed_limit_data.rec_speed_limit = _slam_speed_limit_data.rec_speed_limit;
	}
};


/*-------------------------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class SLAM2EMtraffic_object_PubDataWrapper: public PubDataWrapper<EventType>

{
private:
	dpc::traffic_object slam_traffic_object_data;
public:
	void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
	{
		data->end_offset = slam_traffic_object_data.end_offset;
//		std::cout<<"SLAM2EMtraffic_object end_offset:"<<data->end_offset<<std::endl;
	}

	void SetData(dpc::traffic_object &_slam_traffic_object_data)
	{
		slam_traffic_object_data.end_offset = _slam_traffic_object_data.end_offset;
	}
};


/*-------------------------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class SLAM2EMlane_PubDataWrapper: public PubDataWrapper<EventType>

{
private:
	dpc::Lane slam_lane_data;
public:
	void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
	{
		data->start_id = slam_lane_data.start_id;
//		std::cout<<"SLAM2EMlane start_id:"<<data->start_id<<std::endl;
	}

	void SetData(dpc::Lane &_slam_lane_data)
	{
		slam_lane_data.start_id = _slam_lane_data.start_id;
	}
};


/*-------------------------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class SLAM2EMroad_edge_PubDataWrapper: public PubDataWrapper<EventType>

{
private:
	dpc::RoadEdge slam_road_edge_data;
public:
	void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
	{
		data->road_edge_id = slam_road_edge_data.road_edge_id;
//		std::cout<<" SLAM2EMroad_edge road_edge_id:"<<data->road_edge_id<<std::endl;
	}

	void SetData(dpc::RoadEdge &_slam_road_edge_data)
	{
		slam_road_edge_data.road_edge_id = _slam_road_edge_data.road_edge_id;
	}
};


/*-------------------------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class SLAM2EMslam_road_model_PubDataWrapper: public PubDataWrapper<EventType>

{
private:
	dpc::slam_road_model slam_road_model_data;
public:
	void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
	{
		data->lanes = slam_road_model_data.lanes;
		data->lines = slam_road_model_data.lines;
//		for (size_t i = 0; i < data->lanes.size(); i++)
//		{
//			std::cout<<"SLAM2EMslam_road_model lanes"<<i<<" :"<<data->lanes.at(i).lane_type<<std::endl;
//		}
//		for (size_t i = 0; i < data->lines.size(); i++)
//		{
//			std::cout<<"SLAM2EMslam_road_model lines"<<i<<" :"<<data->lines.at(i).id<<std::endl;
//		}

	}

	void SetData(dpc::slam_road_model &_slam_road_model_data)
	{
		slam_road_model_data.lanes = _slam_road_model_data.lanes;
		slam_road_model_data.lines = _slam_road_model_data.lines;
	}
};


/*-------------------------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class SLAM2DMAdjacentExtendLaneStruct_PubDataWrapper: public PubDataWrapper<EventType>

{
private:
	dpc::AdjacentExtendLaneStruct slam_adjacent_data;
public:
	void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
	{
		data->adjacent_extendlane_endoffset = slam_adjacent_data.adjacent_extendlane_endoffset;
	}

	void SetData(dpc::AdjacentExtendLaneStruct &_slam_adjacent_data)
	{
		slam_adjacent_data.adjacent_extendlane_endoffset = _slam_adjacent_data.adjacent_extendlane_endoffset;
	}
};


/*-------------------------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class SLAM2DMSMAStruct_PubDataWrapper: public PubDataWrapper<EventType>

{
private:
	dpc::SMAStruct slam_smas_data;
public:
	void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
	{
		data->end_offset = slam_smas_data.end_offset;
	}

	void SetData(dpc::SMAStruct &_slam_smas_data)
	{
		slam_smas_data.end_offset = _slam_smas_data.end_offset;
	}
};


/*-------------------------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class SLAM2DMWPExtendLaneStruct_PubDataWrapper: public PubDataWrapper<EventType>

{
private:
	dpc::WPExtendLaneStruct slam_wpes_data;
public:
	void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
	{
		data->current_extendlane_endoffset = slam_wpes_data.current_extendlane_endoffset;
	}

	void SetData(dpc::WPExtendLaneStruct &_slam_wpes_data)
	{
		slam_wpes_data.current_extendlane_endoffset = _slam_wpes_data.current_extendlane_endoffset;
	}
};


/*-------------------------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class SLAM2DMRemindWaypointStruct_PubDataWrapper: public PubDataWrapper<EventType>

{
private:
	dpc::RemindWayPointStruct slam_rwps_data;
public:
	void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
	{
		data->reminder_waypoint_id = slam_rwps_data.reminder_waypoint_id;
	}

	void SetData(dpc::RemindWayPointStruct &_slam_rwps_data)
	{
		slam_rwps_data.reminder_waypoint_id = _slam_rwps_data.reminder_waypoint_id;
	}
};


/*-------------------------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class SLAM2DMControlWaypointStruct_PubDataWrapper: public PubDataWrapper<EventType>

{
private:
	dpc::ControlWayPointStruct slam_cps_data;
public:
	void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
	{
		data->control_waypoint_id = slam_cps_data.control_waypoint_id;
	}

	void SetData(dpc::ControlWayPointStruct &_slam_cps_data)
	{
		slam_cps_data.control_waypoint_id = _slam_cps_data.control_waypoint_id;
	}
};


/*-------------------------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class SLAM2DMMsgHeader_PubDataWrapper: public PubDataWrapper<EventType>

{
private:
	dpc::MsgHeader slam_header_data;
public:
	void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
	{
		data->time_stamp = slam_header_data.time_stamp;
	}

	void SetData(dpc::MsgHeader &_slam_header_data)
	{
		slam_header_data.time_stamp = _slam_header_data.time_stamp;
	}
};


/*-------------------------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class SLAM2DMTransitLaneStruct_PubDataWrapper: public PubDataWrapper<EventType>

{
private:
	dpc::TransitLaneStruct slam_tls_data;
public:
	void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
	{
//		data->transit_connected_lane_id = slam_tls_data.transit_connected_lane_id;
		data->transit_type = 1;
	}

	void SetData(dpc::TransitLaneStruct &_slam_tls_data)
	{
		slam_tls_data.transit_connected_lane_id = _slam_tls_data.transit_connected_lane_id;
	}
};


/*-------------------------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class SLAM2DMControlWaypoints_PubDataWrapper: public PubDataWrapper<EventType>

{
private:
	dpc::ControlWaypoints slam_con_wayp_data;
public:
	void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
	{
		data->control_waypoints_list =  slam_con_wayp_data.control_waypoints_list;
	}

	void SetData(dpc::ControlWaypoints &_slam_con_wayp_data)
	{
		slam_con_wayp_data.control_waypoints_list = _slam_con_wayp_data.control_waypoints_list ;
	}
};
/*-------------------------------------------------------------------------------------------------------------------------*/
template<typename EventType>
class Slam2PerceptionOdom_PubDataWrapper: public PubDataWrapper<EventType>

{
private:
	// dpc::slam_odometry slam_odom_data;
public:
	void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
	{

	}

	void SetData(dpc::slam_odometry &_slam_con_wayp_data)
	{

	}
};
#endif //SLAMPubDataWrapper_WRAPPER_HEADER_H
