#ifndef CANMESSAGE_H
#define CANMESSAGE_H

#include <iostream>
#include <cstring>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <unistd.h>
#include <thread>
#include <arpa/inet.h>

#include "pub/PubWrapperHelper.h"
#include "can_msg_node/executable.h"
#include "ara/log/logging.h"
#include "CAN_PubDataWrapper.h"
#include "CAN_GeneralWrapper.h"

//using namespace jac::ap::canservice::skeleton;

//GENERATE_PUB_WRAPPER(CAN2SWC_Provide, CAN2SWC_PubDataWrapper, CANServiceSkeleton, CAN2SWC, CAN2SWCEvent);

class CanMessage
{
public:
    CanMessage(char** argv, GeneralWrapper* gw);

private:
    const std::string LOCAL_IP = "239.10.0.188";
    const std::string MULTICAST_GROUP = "239.10.0.188";
    const uint16_t PORT = 51800;
    const uint16_t MAX_BUFFER_SIZE = 1024;

    int sockfd;
    char** m_argv;

    CAN2SWC _all_messages;
    //CAN2SWC_Provide pubWrapper;
    physical_control_request1_t _control_request1_msg;

	GeneralWrapper* _general_wrapper;

    std::thread *receiving_from_software_components_thread;
    std::thread *sending_to_mcu_thread;
    std::thread *receiving_thread;
    std::thread *send_to_swc_thread;

    void receiving_init();

    bool set_receiving_udp_connection();
    
    void send_to_swc();

    void start_listening();

    bool is_timestamp_packet(const char* buffer)const;

    void calculate_sec_nanosec(uint64_t& seconds, uint64_t& nanoseconds, char* buffer) const;

    void cal_print_diff_timestampt_soc_mcu(const uint64_t& seconds,
        const uint64_t& nano_seconds)const;

    void handle_can_message(uint8_t *data,
    		                unsigned int can_id,
    						uint64_t timestamp_s,
    						uint64_t timestamp_ns,
    						uint8_t CRC);

    void sending_message_to_mcu();

    void receiving_from_software_components();
    void control_request1_msg_parser(SWC2CAN message);

};

#endif // CANMESSAGE_H
