/**
 * The MIT License (MIT)
 *
 * Copyright (c) 2018-2019 Erik Moqvist
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/**
 * This file was generated by cantools version 37.2.0 Tue Feb  6 13:09:08 2024.
 */

#include "by_nav_x2_can_v0.hpp"

#include <string.h>


static inline uint8_t pack_left_shift_u8(
    uint8_t value,
    uint8_t shift,
    uint8_t mask)
{
    return (uint8_t)((uint8_t)(value << shift) & mask);
}

static inline uint8_t pack_left_shift_u16(
    uint16_t value,
    uint8_t shift,
    uint8_t mask)
{
    return (uint8_t)((uint8_t)(value << shift) & mask);
}

static inline uint8_t pack_left_shift_u32(
    uint32_t value,
    uint8_t shift,
    uint8_t mask)
{
    return (uint8_t)((uint8_t)(value << shift) & mask);
}

static inline uint8_t pack_right_shift_u16(
    uint16_t value,
    uint8_t shift,
    uint8_t mask)
{
    return (uint8_t)((uint8_t)(value >> shift) & mask);
}

static inline uint8_t pack_right_shift_u32(
    uint32_t value,
    uint8_t shift,
    uint8_t mask)
{
    return (uint8_t)((uint8_t)(value >> shift) & mask);
}

static inline uint16_t unpack_left_shift_u16(
    uint8_t value,
    uint8_t shift,
    uint8_t mask)
{
    return (uint16_t)((uint16_t)(value & mask) << shift);
}

static inline uint32_t unpack_left_shift_u32(
    uint8_t value,
    uint8_t shift,
    uint8_t mask)
{
    return (uint32_t)((uint32_t)(value & mask) << shift);
}

static inline uint8_t unpack_right_shift_u8(
    uint8_t value,
    uint8_t shift,
    uint8_t mask)
{
    return (uint8_t)((uint8_t)(value & mask) >> shift);
}

static inline uint16_t unpack_right_shift_u16(
    uint8_t value,
    uint8_t shift,
    uint8_t mask)
{
    return (uint16_t)((uint16_t)(value & mask) >> shift);
}

static inline uint32_t unpack_right_shift_u32(
    uint8_t value,
    uint8_t shift,
    uint8_t mask)
{
    return (uint32_t)((uint32_t)(value & mask) >> shift);
}

int ultrasonic_radar_message_hs_can_100_pack()
{
    return (8);
}

int ultrasonic_radar_message_hs_can_100_unpack(
    struct ultrasonic_radar_message_hs_can_100_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->message_hs_can_100_pas_mode = unpack_right_shift_u8(src_p[0], 0u, 0x0f);
    dst_p->message_hs_can_100_pas_warn_tone = unpack_right_shift_u8(src_p[0], 4u, 0xf0);
    dst_p->message_hs_can_100_pas_rl_distance = unpack_right_shift_u8(src_p[2], 0u, 0xff);
    dst_p->message_hs_can_100_pas_rl_mid_distance = unpack_right_shift_u8(src_p[3], 0u, 0xff);
    dst_p->message_hs_can_100_pas_rr_mid_distance = unpack_right_shift_u8(src_p[4], 0u, 0xff);
    dst_p->message_hs_can_100_pas_rr_distance = unpack_right_shift_u8(src_p[5], 0u, 0xff);

    return (0);

}

uint8_t ultrasonic_radar_message_hs_can_100_pas_mode_decode(uint8_t value)
{
    return value;
}

uint8_t ultrasonic_radar_message_hs_can_100_pas_warn_tone_decode(uint8_t value)
{
    return value;
}

uint8_t ultrasonic_radar_message_hs_can_100_pas_rl_distance_decode(uint8_t value)
{
    return value;
}

uint8_t ultrasonic_radar_message_hs_can_100_pas_rl_mid_distance_decode(uint8_t value)
{
    return value;
}

uint8_t ultrasonic_radar_message_hs_can_100_pas_rr_mid_distance_decode(uint8_t value)
{
    return value;
}

uint8_t ultrasonic_radar_message_hs_can_100_pas_rr_distance_decode(uint8_t value)
{
    return value;
}

int ultrasonic_radar_message_hs_can_101_unpack(
    struct ultrasonic_radar_message_hs_can_101_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->message_hs_can_101_pas_fl_distance = unpack_right_shift_u8(src_p[0], 0u, 0xff);
    dst_p->message_hs_can_101_pas_fl_mid_distance = unpack_right_shift_u8(src_p[1], 0u, 0xff);
    dst_p->message_hs_can_101_pas_fr_mid_distance = unpack_right_shift_u8(src_p[2], 0u, 0xff);
    dst_p->message_hs_can_101_pas_fr_distance = unpack_right_shift_u8(src_p[3], 0u, 0xff);
    dst_p->message_hs_can_101_pas_rl_sns_err_flag = unpack_right_shift_u8(src_p[6], 0u, 0x01);
    dst_p->message_hs_can_101_pas_rl_mid_sns_err_flag = unpack_right_shift_u8(src_p[6], 1u, 0x02);
    dst_p->message_hs_can_101_pas_rr_mid_sns_err_flag = unpack_right_shift_u8(src_p[6], 2u, 0x04);
    dst_p->message_hs_can_101_pas_rr_sns_err_flag = unpack_right_shift_u8(src_p[6], 3u, 0x08);
    dst_p->message_hs_can_101_pas_fl_sns_err_flag = unpack_right_shift_u8(src_p[7], 0u, 0x01);
    dst_p->message_hs_can_101_pas_fl_mid_sns_err_flag = unpack_right_shift_u8(src_p[7], 1u, 0x02);
    dst_p->message_hs_can_101_pas_fr_mid_sns_err_flag = unpack_right_shift_u8(src_p[7], 2u, 0x04);
    dst_p->message_hs_can_101_pas_fr_sns_err_flag = unpack_right_shift_u8(src_p[7], 3u, 0x08);

    return (0);
}

uint8_t ultrasonic_radar_message_hs_can_101_pas_fl_distance_decode(uint8_t value)
{
    return value;
}

uint8_t ultrasonic_radar_message_hs_can_101_pas_fl_mid_distance_decode(uint8_t value)
{
    return value;
}

uint8_t ultrasonic_radar_message_hs_can_101_pas_fr_mid_distance_decode(uint8_t value)
{
    return value;
}

uint8_t ultrasonic_radar_message_hs_can_101_pas_fr_distance_decode(uint8_t value)
{
    return value;
}

uint8_t ultrasonic_radar_message_hs_can_101_pas_rl_sns_err_flag_decode(uint8_t value)
{
    return value;
}

uint8_t ultrasonic_radar_message_hs_can_101_pas_rl_mid_sns_err_flag_decode(uint8_t value)
{
    return value;
}

uint8_t ultrasonic_radar_message_hs_can_101_pas_rr_mid_sns_err_flag_decode(uint8_t value)
{
    return value;
}

uint8_t ultrasonic_radar_message_hs_can_101_pas_rr_sns_err_flag_decode(uint8_t value)
{
    return value;
}

uint8_t ultrasonic_radar_message_hs_can_101_pas_fl_sns_err_flag_decode(uint8_t value)
{
    return value;
}

uint8_t ultrasonic_radar_message_hs_can_101_pas_fl_mid_sns_err_flag_decode(uint8_t value)
{
    return value;
}

uint8_t ultrasonic_radar_message_hs_can_101_pas_fr_mid_sns_err_flag_decode(uint8_t value)
{
    return value;
}

uint8_t ultrasonic_radar_message_hs_can_101_pas_fr_sns_err_flag_decode(uint8_t value)
{
    return value;
}

int by_nav_x2_can_v0_1_devstatus_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_devstatus_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u16(src_p->devstatus_ap_temperatue, 8u, 0xffu);
    dst_p[1] |= pack_left_shift_u16(src_p->devstatus_ap_temperatue, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_devstatus_unpack(
    struct by_nav_x2_can_v0_1_devstatus_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->devstatus_ap_temperatue = unpack_left_shift_u16(src_p[0], 8u, 0xffu);
    dst_p->devstatus_ap_temperatue |= unpack_right_shift_u16(src_p[1], 0u, 0xffu);

    return (0);
}

uint16_t by_nav_x2_can_v0_1_devstatus_devstatus_ap_temperatue_encode(double value)
{
    return (uint16_t)((value - -100.0) / 0.01);
}

double by_nav_x2_can_v0_1_devstatus_devstatus_ap_temperatue_decode(uint16_t value)
{
    return (((double)value * 0.01) + -100.0);
}

bool by_nav_x2_can_v0_1_devstatus_devstatus_ap_temperatue_is_in_range(uint16_t value)
{
    return (value <= 30000u);
}

int by_nav_x2_can_v0_1_heading_angle_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_heading_angle_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u16(src_p->heading_heading, 8u, 0xffu);
    dst_p[1] |= pack_left_shift_u16(src_p->heading_heading, 0u, 0xffu);
    dst_p[2] |= pack_right_shift_u16(src_p->heading_pitch, 8u, 0xffu);
    dst_p[3] |= pack_left_shift_u16(src_p->heading_pitch, 0u, 0xffu);
    dst_p[4] |= pack_right_shift_u16(src_p->heading_heading_std, 2u, 0xffu);
    dst_p[5] |= pack_left_shift_u16(src_p->heading_heading_std, 6u, 0xc0u);
    dst_p[5] |= pack_right_shift_u16(src_p->heading_pitch_std, 4u, 0x3fu);
    dst_p[6] |= pack_left_shift_u16(src_p->heading_pitch_std, 4u, 0xf0u);
    dst_p[6] |= pack_right_shift_u16(src_p->heading_length, 8u, 0x0fu);
    dst_p[7] |= pack_left_shift_u16(src_p->heading_length, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_heading_angle_unpack(
    struct by_nav_x2_can_v0_1_heading_angle_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->heading_heading = unpack_left_shift_u16(src_p[0], 8u, 0xffu);
    dst_p->heading_heading |= unpack_right_shift_u16(src_p[1], 0u, 0xffu);
    dst_p->heading_pitch = unpack_left_shift_u16(src_p[2], 8u, 0xffu);
    dst_p->heading_pitch |= unpack_right_shift_u16(src_p[3], 0u, 0xffu);
    dst_p->heading_heading_std = unpack_left_shift_u16(src_p[4], 2u, 0xffu);
    dst_p->heading_heading_std |= unpack_right_shift_u16(src_p[5], 6u, 0xc0u);
    dst_p->heading_pitch_std = unpack_left_shift_u16(src_p[5], 4u, 0x3fu);
    dst_p->heading_pitch_std |= unpack_right_shift_u16(src_p[6], 4u, 0xf0u);
    dst_p->heading_length = unpack_left_shift_u16(src_p[6], 8u, 0x0fu);
    dst_p->heading_length |= unpack_right_shift_u16(src_p[7], 0u, 0xffu);

    return (0);
}

uint16_t by_nav_x2_can_v0_1_heading_angle_heading_heading_encode(double value)
{
    return (uint16_t)(value / 0.01);
}

double by_nav_x2_can_v0_1_heading_angle_heading_heading_decode(uint16_t value)
{
    return ((double)value * 0.01);
}

bool by_nav_x2_can_v0_1_heading_angle_heading_heading_is_in_range(uint16_t value)
{
    return (value <= 36000u);
}

uint16_t by_nav_x2_can_v0_1_heading_angle_heading_pitch_encode(double value)
{
    return (uint16_t)((value - -90.0) / 0.01);
}

double by_nav_x2_can_v0_1_heading_angle_heading_pitch_decode(uint16_t value)
{
    return (((double)value * 0.01) + -90.0);
}

bool by_nav_x2_can_v0_1_heading_angle_heading_pitch_is_in_range(uint16_t value)
{
    return (value <= 18000u);
}

uint16_t by_nav_x2_can_v0_1_heading_angle_heading_heading_std_encode(double value)
{
    return (uint16_t)(value / 0.01);
}

double by_nav_x2_can_v0_1_heading_angle_heading_heading_std_decode(uint16_t value)
{
    return ((double)value * 0.01);
}

bool by_nav_x2_can_v0_1_heading_angle_heading_heading_std_is_in_range(uint16_t value)
{
    return (value <= 1000u);
}

uint16_t by_nav_x2_can_v0_1_heading_angle_heading_pitch_std_encode(double value)
{
    return (uint16_t)(value / 0.01);
}

double by_nav_x2_can_v0_1_heading_angle_heading_pitch_std_decode(uint16_t value)
{
    return ((double)value * 0.01);
}

bool by_nav_x2_can_v0_1_heading_angle_heading_pitch_std_is_in_range(uint16_t value)
{
    return (value <= 1000u);
}

uint16_t by_nav_x2_can_v0_1_heading_angle_heading_length_encode(double value)
{
    return (uint16_t)(value / 0.01);
}

double by_nav_x2_can_v0_1_heading_angle_heading_length_decode(uint16_t value)
{
    return ((double)value * 0.01);
}

bool by_nav_x2_can_v0_1_heading_angle_heading_length_is_in_range(uint16_t value)
{
    return (value <= 20000u);
}

int by_nav_x2_can_v0_1_gnss_sol_result_latency_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_gnss_sol_result_latency_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u32(src_p->gnss_measure_latency, 24u, 0xffu);
    dst_p[1] |= pack_right_shift_u32(src_p->gnss_measure_latency, 16u, 0xffu);
    dst_p[2] |= pack_right_shift_u32(src_p->gnss_measure_latency, 8u, 0xffu);
    dst_p[3] |= pack_left_shift_u32(src_p->gnss_measure_latency, 0u, 0xffu);
    dst_p[4] |= pack_right_shift_u32(src_p->gnss_diff_age, 24u, 0xffu);
    dst_p[5] |= pack_right_shift_u32(src_p->gnss_diff_age, 16u, 0xffu);
    dst_p[6] |= pack_right_shift_u32(src_p->gnss_diff_age, 8u, 0xffu);
    dst_p[7] |= pack_left_shift_u32(src_p->gnss_diff_age, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_gnss_sol_result_latency_unpack(
    struct by_nav_x2_can_v0_1_gnss_sol_result_latency_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->gnss_measure_latency = unpack_left_shift_u32(src_p[0], 24u, 0xffu);
    dst_p->gnss_measure_latency |= unpack_left_shift_u32(src_p[1], 16u, 0xffu);
    dst_p->gnss_measure_latency |= unpack_left_shift_u32(src_p[2], 8u, 0xffu);
    dst_p->gnss_measure_latency |= unpack_right_shift_u32(src_p[3], 0u, 0xffu);
    dst_p->gnss_diff_age = unpack_left_shift_u32(src_p[4], 24u, 0xffu);
    dst_p->gnss_diff_age |= unpack_left_shift_u32(src_p[5], 16u, 0xffu);
    dst_p->gnss_diff_age |= unpack_left_shift_u32(src_p[6], 8u, 0xffu);
    dst_p->gnss_diff_age |= unpack_right_shift_u32(src_p[7], 0u, 0xffu);

    return (0);
}

uint32_t by_nav_x2_can_v0_1_gnss_sol_result_latency_gnss_measure_latency_encode(double value)
{
    return (uint32_t)(value * 10);
}

double by_nav_x2_can_v0_1_gnss_sol_result_latency_gnss_measure_latency_decode(uint32_t value)
{
    return ((double)value * 0.1);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_latency_gnss_measure_latency_is_in_range(uint32_t value)
{
    return (value <= 1000u);
}

uint32_t by_nav_x2_can_v0_1_gnss_sol_result_latency_gnss_diff_age_encode(double value)
{
    return (uint32_t)(value * 10);
}

double by_nav_x2_can_v0_1_gnss_sol_result_latency_gnss_diff_age_decode(uint32_t value)
{
    return ((double)value * 0.1);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_latency_gnss_diff_age_is_in_range(uint32_t value)
{
    return (value <= 1000u);
}

int by_nav_x2_can_v0_1_ins_sol_result_status_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_ins_sol_result_status_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_left_shift_u8(src_p->ins_ins_status, 0u, 0xffu);
    dst_p[1] |= pack_left_shift_u8(src_p->ins_pos_type, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_ins_sol_result_status_unpack(
    struct by_nav_x2_can_v0_1_ins_sol_result_status_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->ins_ins_status = unpack_right_shift_u8(src_p[0], 0u, 0xffu);
    dst_p->ins_pos_type = unpack_right_shift_u8(src_p[1], 0u, 0xffu);

    return (0);
}

uint8_t by_nav_x2_can_v0_1_ins_sol_result_status_ins_ins_status_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_ins_sol_result_status_ins_ins_status_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_ins_sol_result_status_ins_ins_status_is_in_range(uint8_t value)
{
    (void)value;

    return (true);
}

uint8_t by_nav_x2_can_v0_1_ins_sol_result_status_ins_pos_type_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_ins_sol_result_status_ins_pos_type_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_ins_sol_result_status_ins_pos_type_is_in_range(uint8_t value)
{
    (void)value;

    return (true);
}

int by_nav_x2_can_v0_1_ins_sol_result_vel_std_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_ins_sol_result_vel_std_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u16(src_p->ins_velocity_std, 8u, 0xffu);
    dst_p[1] |= pack_left_shift_u16(src_p->ins_velocity_std, 0u, 0xffu);
    dst_p[2] |= pack_right_shift_u16(src_p->ins_velocity_e_std, 8u, 0xffu);
    dst_p[3] |= pack_left_shift_u16(src_p->ins_velocity_e_std, 0u, 0xffu);
    dst_p[4] |= pack_right_shift_u16(src_p->ins_velocity_n_std, 8u, 0xffu);
    dst_p[5] |= pack_left_shift_u16(src_p->ins_velocity_n_std, 0u, 0xffu);
    dst_p[6] |= pack_right_shift_u16(src_p->ins_velocity_u_std, 8u, 0xffu);
    dst_p[7] |= pack_left_shift_u16(src_p->ins_velocity_u_std, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_ins_sol_result_vel_std_unpack(
    struct by_nav_x2_can_v0_1_ins_sol_result_vel_std_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->ins_velocity_std = unpack_left_shift_u16(src_p[0], 8u, 0xffu);
    dst_p->ins_velocity_std |= unpack_right_shift_u16(src_p[1], 0u, 0xffu);
    dst_p->ins_velocity_e_std = unpack_left_shift_u16(src_p[2], 8u, 0xffu);
    dst_p->ins_velocity_e_std |= unpack_right_shift_u16(src_p[3], 0u, 0xffu);
    dst_p->ins_velocity_n_std = unpack_left_shift_u16(src_p[4], 8u, 0xffu);
    dst_p->ins_velocity_n_std |= unpack_right_shift_u16(src_p[5], 0u, 0xffu);
    dst_p->ins_velocity_u_std = unpack_left_shift_u16(src_p[6], 8u, 0xffu);
    dst_p->ins_velocity_u_std |= unpack_right_shift_u16(src_p[7], 0u, 0xffu);

    return (0);
}

uint16_t by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_std_encode(double value)
{
    return (uint16_t)(value / 0.01);
}

double by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_std_decode(uint16_t value)
{
    return ((double)value * 0.01);
}

bool by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_std_is_in_range(uint16_t value)
{
    return (value <= 6554u);
}

uint16_t by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_e_std_encode(double value)
{
    return (uint16_t)(value / 0.01);
}

double by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_e_std_decode(uint16_t value)
{
    return ((double)value * 0.01);
}

bool by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_e_std_is_in_range(uint16_t value)
{
    return (value <= 6554u);
}

uint16_t by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_n_std_encode(double value)
{
    return (uint16_t)(value / 0.01);
}

double by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_n_std_decode(uint16_t value)
{
    return ((double)value * 0.01);
}

bool by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_n_std_is_in_range(uint16_t value)
{
    return (value <= 6554u);
}

uint16_t by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_u_std_encode(double value)
{
    return (uint16_t)(value / 0.01);
}

double by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_u_std_decode(uint16_t value)
{
    return ((double)value * 0.01);
}

bool by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_u_std_is_in_range(uint16_t value)
{
    return (value <= 6554u);
}

int by_nav_x2_can_v0_1_ins_sol_result_vel_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_ins_sol_result_vel_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u16(src_p->ins_velocity, 8u, 0xffu);
    dst_p[1] |= pack_left_shift_u16(src_p->ins_velocity, 0u, 0xffu);
    dst_p[2] |= pack_right_shift_u16(src_p->ins_velocity_e, 8u, 0xffu);
    dst_p[3] |= pack_left_shift_u16(src_p->ins_velocity_e, 0u, 0xffu);
    dst_p[4] |= pack_right_shift_u16(src_p->ins_velocity_n, 8u, 0xffu);
    dst_p[5] |= pack_left_shift_u16(src_p->ins_velocity_n, 0u, 0xffu);
    dst_p[6] |= pack_right_shift_u16(src_p->ins_velocity_u, 8u, 0xffu);
    dst_p[7] |= pack_left_shift_u16(src_p->ins_velocity_u, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_ins_sol_result_vel_unpack(
    struct by_nav_x2_can_v0_1_ins_sol_result_vel_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->ins_velocity = unpack_left_shift_u16(src_p[0], 8u, 0xffu);
    dst_p->ins_velocity |= unpack_right_shift_u16(src_p[1], 0u, 0xffu);
    dst_p->ins_velocity_e = unpack_left_shift_u16(src_p[2], 8u, 0xffu);
    dst_p->ins_velocity_e |= unpack_right_shift_u16(src_p[3], 0u, 0xffu);
    dst_p->ins_velocity_n = unpack_left_shift_u16(src_p[4], 8u, 0xffu);
    dst_p->ins_velocity_n |= unpack_right_shift_u16(src_p[5], 0u, 0xffu);
    dst_p->ins_velocity_u = unpack_left_shift_u16(src_p[6], 8u, 0xffu);
    dst_p->ins_velocity_u |= unpack_right_shift_u16(src_p[7], 0u, 0xffu);

    return (0);
}

uint16_t by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_encode(double value)
{
    return (uint16_t)(value / 0.01);
}

double by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_decode(uint16_t value)
{
    return ((double)value * 0.01);
}

bool by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_is_in_range(uint16_t value)
{
    return (value <= 20000u);
}

uint16_t by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_e_encode(double value)
{
    return (uint16_t)((value - -100.0) / 0.01);
}

double by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_e_decode(uint16_t value)
{
    return (((double)value * 0.01) + -100.0);
}

bool by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_e_is_in_range(uint16_t value)
{
    return (value <= 20000u);
}

uint16_t by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_n_encode(double value)
{
    return (uint16_t)((value - -100.0) / 0.01);
}

double by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_n_decode(uint16_t value)
{
    return (((double)value * 0.01) + -100.0);
}

bool by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_n_is_in_range(uint16_t value)
{
    return (value <= 20000u);
}

uint16_t by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_u_encode(double value)
{
    return (uint16_t)((value - -100.0) / 0.01);
}

double by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_u_decode(uint16_t value)
{
    return (((double)value * 0.01) + -100.0);
}

bool by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_u_is_in_range(uint16_t value)
{
    return (value <= 20000u);
}

int by_nav_x2_can_v0_1_ins_sol_result_angle_std_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_ins_sol_result_angle_std_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u16(src_p->ins_course_angle_std, 8u, 0xffu);
    dst_p[1] |= pack_left_shift_u16(src_p->ins_course_angle_std, 0u, 0xffu);
    dst_p[2] |= pack_right_shift_u16(src_p->ins_yaw_angle_std, 8u, 0xffu);
    dst_p[3] |= pack_left_shift_u16(src_p->ins_yaw_angle_std, 0u, 0xffu);
    dst_p[4] |= pack_right_shift_u16(src_p->ins_pitch_std, 8u, 0xffu);
    dst_p[5] |= pack_left_shift_u16(src_p->ins_pitch_std, 0u, 0xffu);
    dst_p[6] |= pack_right_shift_u16(src_p->ins_roll_std, 8u, 0xffu);
    dst_p[7] |= pack_left_shift_u16(src_p->ins_roll_std, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_ins_sol_result_angle_std_unpack(
    struct by_nav_x2_can_v0_1_ins_sol_result_angle_std_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->ins_course_angle_std = unpack_left_shift_u16(src_p[0], 8u, 0xffu);
    dst_p->ins_course_angle_std |= unpack_right_shift_u16(src_p[1], 0u, 0xffu);
    dst_p->ins_yaw_angle_std = unpack_left_shift_u16(src_p[2], 8u, 0xffu);
    dst_p->ins_yaw_angle_std |= unpack_right_shift_u16(src_p[3], 0u, 0xffu);
    dst_p->ins_pitch_std = unpack_left_shift_u16(src_p[4], 8u, 0xffu);
    dst_p->ins_pitch_std |= unpack_right_shift_u16(src_p[5], 0u, 0xffu);
    dst_p->ins_roll_std = unpack_left_shift_u16(src_p[6], 8u, 0xffu);
    dst_p->ins_roll_std |= unpack_right_shift_u16(src_p[7], 0u, 0xffu);

    return (0);
}

uint16_t by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_course_angle_std_encode(double value)
{
    return (uint16_t)(value / 0.01);
}

double by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_course_angle_std_decode(uint16_t value)
{
    return ((double)value * 0.01);
}

bool by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_course_angle_std_is_in_range(uint16_t value)
{
    return (value <= 6554u);
}

uint16_t by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_yaw_angle_std_encode(double value)
{
    return (uint16_t)(value / 0.01);
}

double by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_yaw_angle_std_decode(uint16_t value)
{
    return ((double)value * 0.01);
}

bool by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_yaw_angle_std_is_in_range(uint16_t value)
{
    return (value <= 6554u);
}

uint16_t by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_pitch_std_encode(double value)
{
    return (uint16_t)(value / 0.01);
}

double by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_pitch_std_decode(uint16_t value)
{
    return ((double)value * 0.01);
}

bool by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_pitch_std_is_in_range(uint16_t value)
{
    return (value <= 6554u);
}

uint16_t by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_roll_std_encode(double value)
{
    return (uint16_t)(value / 0.01);
}

double by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_roll_std_decode(uint16_t value)
{
    return ((double)value * 0.01);
}

bool by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_roll_std_is_in_range(uint16_t value)
{
    return (value <= 6554u);
}

int by_nav_x2_can_v0_1_ins_sol_result_angle_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_ins_sol_result_angle_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u16(src_p->ins_course_angle, 8u, 0xffu);
    dst_p[1] |= pack_left_shift_u16(src_p->ins_course_angle, 0u, 0xffu);
    dst_p[2] |= pack_right_shift_u16(src_p->ins_yaw_angle, 8u, 0xffu);
    dst_p[3] |= pack_left_shift_u16(src_p->ins_yaw_angle, 0u, 0xffu);
    dst_p[4] |= pack_right_shift_u16(src_p->ins_pitch, 8u, 0xffu);
    dst_p[5] |= pack_left_shift_u16(src_p->ins_pitch, 0u, 0xffu);
    dst_p[6] |= pack_right_shift_u16(src_p->ins_roll, 8u, 0xffu);
    dst_p[7] |= pack_left_shift_u16(src_p->ins_roll, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_ins_sol_result_angle_unpack(
    struct by_nav_x2_can_v0_1_ins_sol_result_angle_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->ins_course_angle = unpack_left_shift_u16(src_p[0], 8u, 0xffu);
    dst_p->ins_course_angle |= unpack_right_shift_u16(src_p[1], 0u, 0xffu);
    dst_p->ins_yaw_angle = unpack_left_shift_u16(src_p[2], 8u, 0xffu);
    dst_p->ins_yaw_angle |= unpack_right_shift_u16(src_p[3], 0u, 0xffu);
    dst_p->ins_pitch = unpack_left_shift_u16(src_p[4], 8u, 0xffu);
    dst_p->ins_pitch |= unpack_right_shift_u16(src_p[5], 0u, 0xffu);
    dst_p->ins_roll = unpack_left_shift_u16(src_p[6], 8u, 0xffu);
    dst_p->ins_roll |= unpack_right_shift_u16(src_p[7], 0u, 0xffu);

    return (0);
}

uint16_t by_nav_x2_can_v0_1_ins_sol_result_angle_ins_course_angle_encode(double value)
{
    return (uint16_t)(value / 0.01);
}

double by_nav_x2_can_v0_1_ins_sol_result_angle_ins_course_angle_decode(uint16_t value)
{
    return ((double)value * 0.01);
}

bool by_nav_x2_can_v0_1_ins_sol_result_angle_ins_course_angle_is_in_range(uint16_t value)
{
    return (value <= 36000u);
}

uint16_t by_nav_x2_can_v0_1_ins_sol_result_angle_ins_yaw_angle_encode(double value)
{
    return (uint16_t)((value - -180.0) / 0.01);
}

double by_nav_x2_can_v0_1_ins_sol_result_angle_ins_yaw_angle_decode(uint16_t value)
{
    return (((double)value * 0.01) + -180.0);
}

bool by_nav_x2_can_v0_1_ins_sol_result_angle_ins_yaw_angle_is_in_range(uint16_t value)
{
    return (value <= 36000u);
}

uint16_t by_nav_x2_can_v0_1_ins_sol_result_angle_ins_pitch_encode(double value)
{
    return (uint16_t)((value - -90.0) / 0.01);
}

double by_nav_x2_can_v0_1_ins_sol_result_angle_ins_pitch_decode(uint16_t value)
{
    return (((double)value * 0.01) + -90.0);
}

bool by_nav_x2_can_v0_1_ins_sol_result_angle_ins_pitch_is_in_range(uint16_t value)
{
    return (value <= 18000u);
}

uint16_t by_nav_x2_can_v0_1_ins_sol_result_angle_ins_roll_encode(double value)
{
    return (uint16_t)((value - -180.0) / 0.01);
}

double by_nav_x2_can_v0_1_ins_sol_result_angle_ins_roll_decode(uint16_t value)
{
    return (((double)value * 0.01) + -180.0);
}

bool by_nav_x2_can_v0_1_ins_sol_result_angle_ins_roll_is_in_range(uint16_t value)
{
    return (value <= 36000u);
}

int by_nav_x2_can_v0_1_ins_sol_result_altitude_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_ins_sol_result_altitude_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u32(src_p->ins_altitude, 16u, 0xffu);
    dst_p[1] |= pack_right_shift_u32(src_p->ins_altitude, 8u, 0xffu);
    dst_p[2] |= pack_left_shift_u32(src_p->ins_altitude, 0u, 0xffu);
    dst_p[3] |= pack_right_shift_u16(src_p->ins_altitude_std, 8u, 0xffu);
    dst_p[4] |= pack_left_shift_u16(src_p->ins_altitude_std, 0u, 0xffu);
    dst_p[5] |= pack_right_shift_u32(src_p->ins_undulation, 16u, 0xffu);
    dst_p[6] |= pack_right_shift_u32(src_p->ins_undulation, 8u, 0xffu);
    dst_p[7] |= pack_left_shift_u32(src_p->ins_undulation, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_ins_sol_result_altitude_unpack(
    struct by_nav_x2_can_v0_1_ins_sol_result_altitude_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->ins_altitude = unpack_left_shift_u32(src_p[0], 16u, 0xffu);
    dst_p->ins_altitude |= unpack_left_shift_u32(src_p[1], 8u, 0xffu);
    dst_p->ins_altitude |= unpack_right_shift_u32(src_p[2], 0u, 0xffu);
    dst_p->ins_altitude_std = unpack_left_shift_u16(src_p[3], 8u, 0xffu);
    dst_p->ins_altitude_std |= unpack_right_shift_u16(src_p[4], 0u, 0xffu);
    dst_p->ins_undulation = unpack_left_shift_u32(src_p[5], 16u, 0xffu);
    dst_p->ins_undulation |= unpack_left_shift_u32(src_p[6], 8u, 0xffu);
    dst_p->ins_undulation |= unpack_right_shift_u32(src_p[7], 0u, 0xffu);

    return (0);
}

uint32_t by_nav_x2_can_v0_1_ins_sol_result_altitude_ins_altitude_encode(double value)
{
    return (uint32_t)((value - -10000.0) / 0.01);
}

double by_nav_x2_can_v0_1_ins_sol_result_altitude_ins_altitude_decode(uint32_t value)
{
    return (((double)value * 0.01) + -10000.0);
}

bool by_nav_x2_can_v0_1_ins_sol_result_altitude_ins_altitude_is_in_range(uint32_t value)
{
    return (value <= 2000000u);
}

uint16_t by_nav_x2_can_v0_1_ins_sol_result_altitude_ins_altitude_std_encode(double value)
{
    return (uint16_t)(value / 0.01);
}

double by_nav_x2_can_v0_1_ins_sol_result_altitude_ins_altitude_std_decode(uint16_t value)
{
    return ((double)value * 0.01);
}

bool by_nav_x2_can_v0_1_ins_sol_result_altitude_ins_altitude_std_is_in_range(uint16_t value)
{
    return (value <= 6554u);
}

uint32_t by_nav_x2_can_v0_1_ins_sol_result_altitude_ins_undulation_encode(double value)
{
    return (uint32_t)((value - -10000.0) / 0.01);
}

double by_nav_x2_can_v0_1_ins_sol_result_altitude_ins_undulation_decode(uint32_t value)
{
    return (((double)value * 0.01) + -10000.0);
}

bool by_nav_x2_can_v0_1_ins_sol_result_altitude_ins_undulation_is_in_range(uint32_t value)
{
    return (value <= 2000000u);
}

int by_nav_x2_can_v0_1_ins_sol_result_longitude_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_ins_sol_result_longitude_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u32(src_p->ins_longitude, 24u, 0xffu);
    dst_p[1] |= pack_right_shift_u32(src_p->ins_longitude, 16u, 0xffu);
    dst_p[2] |= pack_right_shift_u32(src_p->ins_longitude, 8u, 0xffu);
    dst_p[3] |= pack_left_shift_u32(src_p->ins_longitude, 0u, 0xffu);
    dst_p[4] |= pack_right_shift_u16(src_p->ins_longitude_std, 8u, 0xffu);
    dst_p[5] |= pack_left_shift_u16(src_p->ins_longitude_std, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_ins_sol_result_longitude_unpack(
    struct by_nav_x2_can_v0_1_ins_sol_result_longitude_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->ins_longitude = unpack_left_shift_u32(src_p[0], 24u, 0xffu);
    dst_p->ins_longitude |= unpack_left_shift_u32(src_p[1], 16u, 0xffu);
    dst_p->ins_longitude |= unpack_left_shift_u32(src_p[2], 8u, 0xffu);
    dst_p->ins_longitude |= unpack_right_shift_u32(src_p[3], 0u, 0xffu);
    dst_p->ins_longitude_std = unpack_left_shift_u16(src_p[4], 8u, 0xffu);
    dst_p->ins_longitude_std |= unpack_right_shift_u16(src_p[5], 0u, 0xffu);

    return (0);
}

uint32_t by_nav_x2_can_v0_1_ins_sol_result_longitude_ins_longitude_encode(double value)
{
    return (uint32_t)((value - -180.0) / 1E-7);
}

double by_nav_x2_can_v0_1_ins_sol_result_longitude_ins_longitude_decode(uint32_t value)
{
    return (((double)value * 1E-7) + -180.0);
}

bool by_nav_x2_can_v0_1_ins_sol_result_longitude_ins_longitude_is_in_range(uint32_t value)
{
    return (value <= 3600000000u);
}

uint16_t by_nav_x2_can_v0_1_ins_sol_result_longitude_ins_longitude_std_encode(double value)
{
    return (uint16_t)(value / 0.01);
}

double by_nav_x2_can_v0_1_ins_sol_result_longitude_ins_longitude_std_decode(uint16_t value)
{
    return ((double)value * 0.01);
}

bool by_nav_x2_can_v0_1_ins_sol_result_longitude_ins_longitude_std_is_in_range(uint16_t value)
{
    return (value <= 6554u);
}

int by_nav_x2_can_v0_1_ins_sol_result_latitude_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_ins_sol_result_latitude_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u32(src_p->ins_latitude, 24u, 0xffu);
    dst_p[1] |= pack_right_shift_u32(src_p->ins_latitude, 16u, 0xffu);
    dst_p[2] |= pack_right_shift_u32(src_p->ins_latitude, 8u, 0xffu);
    dst_p[3] |= pack_left_shift_u32(src_p->ins_latitude, 0u, 0xffu);
    dst_p[4] |= pack_right_shift_u16(src_p->ins_latitude_std, 8u, 0xffu);
    dst_p[5] |= pack_left_shift_u16(src_p->ins_latitude_std, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_ins_sol_result_latitude_unpack(
    struct by_nav_x2_can_v0_1_ins_sol_result_latitude_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->ins_latitude = unpack_left_shift_u32(src_p[0], 24u, 0xffu);
    dst_p->ins_latitude |= unpack_left_shift_u32(src_p[1], 16u, 0xffu);
    dst_p->ins_latitude |= unpack_left_shift_u32(src_p[2], 8u, 0xffu);
    dst_p->ins_latitude |= unpack_right_shift_u32(src_p[3], 0u, 0xffu);
    dst_p->ins_latitude_std = unpack_left_shift_u16(src_p[4], 8u, 0xffu);
    dst_p->ins_latitude_std |= unpack_right_shift_u16(src_p[5], 0u, 0xffu);

    return (0);
}

uint32_t by_nav_x2_can_v0_1_ins_sol_result_latitude_ins_latitude_encode(double value)
{
    return (uint32_t)((value - -90.0) / 1E-7);
}

double by_nav_x2_can_v0_1_ins_sol_result_latitude_ins_latitude_decode(uint32_t value)
{
    return (((double)value * 1E-7) + -90.0);
}

bool by_nav_x2_can_v0_1_ins_sol_result_latitude_ins_latitude_is_in_range(uint32_t value)
{
    return (value <= 1800000000u);
}

uint16_t by_nav_x2_can_v0_1_ins_sol_result_latitude_ins_latitude_std_encode(double value)
{
    return (uint16_t)(value / 0.01);
}

double by_nav_x2_can_v0_1_ins_sol_result_latitude_ins_latitude_std_decode(uint16_t value)
{
    return ((double)value * 0.01);
}

bool by_nav_x2_can_v0_1_ins_sol_result_latitude_ins_latitude_std_is_in_range(uint16_t value)
{
    return (value <= 6554u);
}

int by_nav_x2_can_v0_1_ins_sol_result_common_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_ins_sol_result_common_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u16(src_p->ins_gps_week, 8u, 0xffu);
    dst_p[1] |= pack_left_shift_u16(src_p->ins_gps_week, 0u, 0xffu);
    dst_p[2] |= pack_right_shift_u32(src_p->ins_gps_sow, 24u, 0xffu);
    dst_p[3] |= pack_right_shift_u32(src_p->ins_gps_sow, 16u, 0xffu);
    dst_p[4] |= pack_right_shift_u32(src_p->ins_gps_sow, 8u, 0xffu);
    dst_p[5] |= pack_left_shift_u32(src_p->ins_gps_sow, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_ins_sol_result_common_unpack(
    struct by_nav_x2_can_v0_1_ins_sol_result_common_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->ins_gps_week = unpack_left_shift_u16(src_p[0], 8u, 0xffu);
    dst_p->ins_gps_week |= unpack_right_shift_u16(src_p[1], 0u, 0xffu);
    dst_p->ins_gps_sow = unpack_left_shift_u32(src_p[2], 24u, 0xffu);
    dst_p->ins_gps_sow |= unpack_left_shift_u32(src_p[3], 16u, 0xffu);
    dst_p->ins_gps_sow |= unpack_left_shift_u32(src_p[4], 8u, 0xffu);
    dst_p->ins_gps_sow |= unpack_right_shift_u32(src_p[5], 0u, 0xffu);

    return (0);
}

uint16_t by_nav_x2_can_v0_1_ins_sol_result_common_ins_gps_week_encode(double value)
{
    return (uint16_t)(value);
}

double by_nav_x2_can_v0_1_ins_sol_result_common_ins_gps_week_decode(uint16_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_ins_sol_result_common_ins_gps_week_is_in_range(uint16_t value)
{
    (void)value;

    return (true);
}

uint32_t by_nav_x2_can_v0_1_ins_sol_result_common_ins_gps_sow_encode(double value)
{
    return (uint32_t)(value);
}

double by_nav_x2_can_v0_1_ins_sol_result_common_ins_gps_sow_decode(uint32_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_ins_sol_result_common_ins_gps_sow_is_in_range(uint32_t value)
{
    return (value <= 604800000u);
}

int by_nav_x2_can_v0_1_gnss_sol_result_spd_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_gnss_sol_result_spd_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u16(src_p->gnss_horizontal_spd, 8u, 0xffu);
    dst_p[1] |= pack_left_shift_u16(src_p->gnss_horizontal_spd, 0u, 0xffu);
    dst_p[2] |= pack_right_shift_u16(src_p->gnss_track_over_ground, 8u, 0xffu);
    dst_p[3] |= pack_left_shift_u16(src_p->gnss_track_over_ground, 0u, 0xffu);
    dst_p[4] |= pack_right_shift_u16(src_p->gnss_vertical_spd, 8u, 0xffu);
    dst_p[5] |= pack_left_shift_u16(src_p->gnss_vertical_spd, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_gnss_sol_result_spd_unpack(
    struct by_nav_x2_can_v0_1_gnss_sol_result_spd_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->gnss_horizontal_spd = unpack_left_shift_u16(src_p[0], 8u, 0xffu);
    dst_p->gnss_horizontal_spd |= unpack_right_shift_u16(src_p[1], 0u, 0xffu);
    dst_p->gnss_track_over_ground = unpack_left_shift_u16(src_p[2], 8u, 0xffu);
    dst_p->gnss_track_over_ground |= unpack_right_shift_u16(src_p[3], 0u, 0xffu);
    dst_p->gnss_vertical_spd = unpack_left_shift_u16(src_p[4], 8u, 0xffu);
    dst_p->gnss_vertical_spd |= unpack_right_shift_u16(src_p[5], 0u, 0xffu);

    return (0);
}

uint16_t by_nav_x2_can_v0_1_gnss_sol_result_spd_gnss_horizontal_spd_encode(double value)
{
    return (uint16_t)((value - -100.0) / 0.01);
}

double by_nav_x2_can_v0_1_gnss_sol_result_spd_gnss_horizontal_spd_decode(uint16_t value)
{
    return (((double)value * 0.01) + -100.0);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_spd_gnss_horizontal_spd_is_in_range(uint16_t value)
{
    return (value <= 20000u);
}

uint16_t by_nav_x2_can_v0_1_gnss_sol_result_spd_gnss_track_over_ground_encode(double value)
{
    return (uint16_t)((value - -180.0) / 0.01);
}

double by_nav_x2_can_v0_1_gnss_sol_result_spd_gnss_track_over_ground_decode(uint16_t value)
{
    return (((double)value * 0.01) + -180.0);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_spd_gnss_track_over_ground_is_in_range(uint16_t value)
{
    return (value <= 36000u);
}

uint16_t by_nav_x2_can_v0_1_gnss_sol_result_spd_gnss_vertical_spd_encode(double value)
{
    return (uint16_t)((value - -100.0) / 0.01);
}

double by_nav_x2_can_v0_1_gnss_sol_result_spd_gnss_vertical_spd_decode(uint16_t value)
{
    return (((double)value * 0.01) + -100.0);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_spd_gnss_vertical_spd_is_in_range(uint16_t value)
{
    return (value <= 20000u);
}

int by_nav_x2_can_v0_1_gnss_sol_result_altitude_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_gnss_sol_result_altitude_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u32(src_p->gnss_altitude, 16u, 0xffu);
    dst_p[1] |= pack_right_shift_u32(src_p->gnss_altitude, 8u, 0xffu);
    dst_p[2] |= pack_left_shift_u32(src_p->gnss_altitude, 0u, 0xffu);
    dst_p[3] |= pack_right_shift_u16(src_p->gnss_altitude_std, 8u, 0xffu);
    dst_p[4] |= pack_left_shift_u16(src_p->gnss_altitude_std, 0u, 0xffu);
    dst_p[5] |= pack_right_shift_u32(src_p->gnss_undulation, 16u, 0xffu);
    dst_p[6] |= pack_right_shift_u32(src_p->gnss_undulation, 8u, 0xffu);
    dst_p[7] |= pack_left_shift_u32(src_p->gnss_undulation, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_gnss_sol_result_altitude_unpack(
    struct by_nav_x2_can_v0_1_gnss_sol_result_altitude_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->gnss_altitude = unpack_left_shift_u32(src_p[0], 16u, 0xffu);
    dst_p->gnss_altitude |= unpack_left_shift_u32(src_p[1], 8u, 0xffu);
    dst_p->gnss_altitude |= unpack_right_shift_u32(src_p[2], 0u, 0xffu);
    dst_p->gnss_altitude_std = unpack_left_shift_u16(src_p[3], 8u, 0xffu);
    dst_p->gnss_altitude_std |= unpack_right_shift_u16(src_p[4], 0u, 0xffu);
    dst_p->gnss_undulation = unpack_left_shift_u32(src_p[5], 16u, 0xffu);
    dst_p->gnss_undulation |= unpack_left_shift_u32(src_p[6], 8u, 0xffu);
    dst_p->gnss_undulation |= unpack_right_shift_u32(src_p[7], 0u, 0xffu);

    return (0);
}

uint32_t by_nav_x2_can_v0_1_gnss_sol_result_altitude_gnss_altitude_encode(double value)
{
    return (uint32_t)((value - -10000.0) / 0.01);
}

double by_nav_x2_can_v0_1_gnss_sol_result_altitude_gnss_altitude_decode(uint32_t value)
{
    return (((double)value * 0.01) + -10000.0);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_altitude_gnss_altitude_is_in_range(uint32_t value)
{
    return (value <= 2000000u);
}

uint16_t by_nav_x2_can_v0_1_gnss_sol_result_altitude_gnss_altitude_std_encode(double value)
{
    return (uint16_t)(value / 0.01);
}

double by_nav_x2_can_v0_1_gnss_sol_result_altitude_gnss_altitude_std_decode(uint16_t value)
{
    return ((double)value * 0.01);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_altitude_gnss_altitude_std_is_in_range(uint16_t value)
{
    return (value <= 6554u);
}

uint32_t by_nav_x2_can_v0_1_gnss_sol_result_altitude_gnss_undulation_encode(double value)
{
    return (uint32_t)((value - -10000.0) / 0.01);
}

double by_nav_x2_can_v0_1_gnss_sol_result_altitude_gnss_undulation_decode(uint32_t value)
{
    return (((double)value * 0.01) + -10000.0);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_altitude_gnss_undulation_is_in_range(uint32_t value)
{
    return (value <= 2000000u);
}

int by_nav_x2_can_v0_1_gnss_sol_result_longitude_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_gnss_sol_result_longitude_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u32(src_p->gnss_longitude, 24u, 0xffu);
    dst_p[1] |= pack_right_shift_u32(src_p->gnss_longitude, 16u, 0xffu);
    dst_p[2] |= pack_right_shift_u32(src_p->gnss_longitude, 8u, 0xffu);
    dst_p[3] |= pack_left_shift_u32(src_p->gnss_longitude, 0u, 0xffu);
    dst_p[4] |= pack_right_shift_u16(src_p->gnss_longitude_std, 8u, 0xffu);
    dst_p[5] |= pack_left_shift_u16(src_p->gnss_longitude_std, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_gnss_sol_result_longitude_unpack(
    struct by_nav_x2_can_v0_1_gnss_sol_result_longitude_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->gnss_longitude = unpack_left_shift_u32(src_p[0], 24u, 0xffu);
    dst_p->gnss_longitude |= unpack_left_shift_u32(src_p[1], 16u, 0xffu);
    dst_p->gnss_longitude |= unpack_left_shift_u32(src_p[2], 8u, 0xffu);
    dst_p->gnss_longitude |= unpack_right_shift_u32(src_p[3], 0u, 0xffu);
    dst_p->gnss_longitude_std = unpack_left_shift_u16(src_p[4], 8u, 0xffu);
    dst_p->gnss_longitude_std |= unpack_right_shift_u16(src_p[5], 0u, 0xffu);

    return (0);
}

uint32_t by_nav_x2_can_v0_1_gnss_sol_result_longitude_gnss_longitude_encode(double value)
{
    return (uint32_t)((value - -180.0) / 1E-7);
}

double by_nav_x2_can_v0_1_gnss_sol_result_longitude_gnss_longitude_decode(uint32_t value)
{
    return (((double)value * 1E-7) + -180.0);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_longitude_gnss_longitude_is_in_range(uint32_t value)
{
    return (value <= 3600000000u);
}

uint16_t by_nav_x2_can_v0_1_gnss_sol_result_longitude_gnss_longitude_std_encode(double value)
{
    return (uint16_t)(value / 0.01);
}

double by_nav_x2_can_v0_1_gnss_sol_result_longitude_gnss_longitude_std_decode(uint16_t value)
{
    return ((double)value * 0.01);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_longitude_gnss_longitude_std_is_in_range(uint16_t value)
{
    (void)value;

    return (true);
}

int by_nav_x2_can_v0_1_gnss_sol_result_latitude_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_gnss_sol_result_latitude_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u32(src_p->gnss_latitude, 24u, 0xffu);
    dst_p[1] |= pack_right_shift_u32(src_p->gnss_latitude, 16u, 0xffu);
    dst_p[2] |= pack_right_shift_u32(src_p->gnss_latitude, 8u, 0xffu);
    dst_p[3] |= pack_left_shift_u32(src_p->gnss_latitude, 0u, 0xffu);
    dst_p[4] |= pack_right_shift_u16(src_p->gnss_latitude_std, 8u, 0xffu);
    dst_p[5] |= pack_left_shift_u16(src_p->gnss_latitude_std, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_gnss_sol_result_latitude_unpack(
    struct by_nav_x2_can_v0_1_gnss_sol_result_latitude_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->gnss_latitude = unpack_left_shift_u32(src_p[0], 24u, 0xffu);
    dst_p->gnss_latitude |= unpack_left_shift_u32(src_p[1], 16u, 0xffu);
    dst_p->gnss_latitude |= unpack_left_shift_u32(src_p[2], 8u, 0xffu);
    dst_p->gnss_latitude |= unpack_right_shift_u32(src_p[3], 0u, 0xffu);
    dst_p->gnss_latitude_std = unpack_left_shift_u16(src_p[4], 8u, 0xffu);
    dst_p->gnss_latitude_std |= unpack_right_shift_u16(src_p[5], 0u, 0xffu);

    return (0);
}

uint32_t by_nav_x2_can_v0_1_gnss_sol_result_latitude_gnss_latitude_encode(double value)
{
    return (uint32_t)((value - -90.0) / 1E-7);
}

double by_nav_x2_can_v0_1_gnss_sol_result_latitude_gnss_latitude_decode(uint32_t value)
{
    return (((double)value * 1E-7) + -90.0);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_latitude_gnss_latitude_is_in_range(uint32_t value)
{
    return (value <= 1800000000u);
}

uint16_t by_nav_x2_can_v0_1_gnss_sol_result_latitude_gnss_latitude_std_encode(double value)
{
    return (uint16_t)(value / 0.01);
}

double by_nav_x2_can_v0_1_gnss_sol_result_latitude_gnss_latitude_std_decode(uint16_t value)
{
    return ((double)value * 0.01);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_latitude_gnss_latitude_std_is_in_range(uint16_t value)
{
    return (value <= 6554u);
}

int by_nav_x2_can_v0_1_gnss_sol_result_status_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_gnss_sol_result_status_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_left_shift_u8(src_p->gnss_postion_type, 0u, 0xffu);
    dst_p[1] |= pack_left_shift_u8(src_p->gnss_solution_type, 0u, 0xffu);
    dst_p[2] |= pack_left_shift_u8(src_p->heading_position_type, 0u, 0xffu);
    dst_p[3] |= pack_left_shift_u8(src_p->heading_solution_type, 0u, 0xffu);
    dst_p[4] |= pack_left_shift_u8(src_p->gnss_velocity_type, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_gnss_sol_result_status_unpack(
    struct by_nav_x2_can_v0_1_gnss_sol_result_status_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->gnss_postion_type = unpack_right_shift_u8(src_p[0], 0u, 0xffu);
    dst_p->gnss_solution_type = unpack_right_shift_u8(src_p[1], 0u, 0xffu);
    dst_p->heading_position_type = unpack_right_shift_u8(src_p[2], 0u, 0xffu);
    dst_p->heading_solution_type = unpack_right_shift_u8(src_p[3], 0u, 0xffu);
    dst_p->gnss_velocity_type = unpack_right_shift_u8(src_p[4], 0u, 0xffu);

    return (0);
}

uint8_t by_nav_x2_can_v0_1_gnss_sol_result_status_gnss_postion_type_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_gnss_sol_result_status_gnss_postion_type_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_status_gnss_postion_type_is_in_range(uint8_t value)
{
    (void)value;

    return (true);
}

uint8_t by_nav_x2_can_v0_1_gnss_sol_result_status_gnss_solution_type_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_gnss_sol_result_status_gnss_solution_type_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_status_gnss_solution_type_is_in_range(uint8_t value)
{
    (void)value;

    return (true);
}

uint8_t by_nav_x2_can_v0_1_gnss_sol_result_status_heading_position_type_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_gnss_sol_result_status_heading_position_type_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_status_heading_position_type_is_in_range(uint8_t value)
{
    (void)value;

    return (true);
}

uint8_t by_nav_x2_can_v0_1_gnss_sol_result_status_heading_solution_type_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_gnss_sol_result_status_heading_solution_type_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_status_heading_solution_type_is_in_range(uint8_t value)
{
    (void)value;

    return (true);
}

uint8_t by_nav_x2_can_v0_1_gnss_sol_result_status_gnss_velocity_type_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_gnss_sol_result_status_gnss_velocity_type_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_status_gnss_velocity_type_is_in_range(uint8_t value)
{
    (void)value;

    return (true);
}

int by_nav_x2_can_v0_1_gnss_sol_result_common_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_gnss_sol_result_common_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u16(src_p->gnss_gps_week, 8u, 0xffu);
    dst_p[1] |= pack_left_shift_u16(src_p->gnss_gps_week, 0u, 0xffu);
    dst_p[2] |= pack_right_shift_u32(src_p->gnss_gps_sow, 24u, 0xffu);
    dst_p[3] |= pack_right_shift_u32(src_p->gnss_gps_sow, 16u, 0xffu);
    dst_p[4] |= pack_right_shift_u32(src_p->gnss_gps_sow, 8u, 0xffu);
    dst_p[5] |= pack_left_shift_u32(src_p->gnss_gps_sow, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_gnss_sol_result_common_unpack(
    struct by_nav_x2_can_v0_1_gnss_sol_result_common_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->gnss_gps_week = unpack_left_shift_u16(src_p[0], 8u, 0xffu);
    dst_p->gnss_gps_week |= unpack_right_shift_u16(src_p[1], 0u, 0xffu);
    dst_p->gnss_gps_sow = unpack_left_shift_u32(src_p[2], 24u, 0xffu);
    dst_p->gnss_gps_sow |= unpack_left_shift_u32(src_p[3], 16u, 0xffu);
    dst_p->gnss_gps_sow |= unpack_left_shift_u32(src_p[4], 8u, 0xffu);
    dst_p->gnss_gps_sow |= unpack_right_shift_u32(src_p[5], 0u, 0xffu);

    return (0);
}

uint16_t by_nav_x2_can_v0_1_gnss_sol_result_common_gnss_gps_week_encode(double value)
{
    return (uint16_t)(value);
}

double by_nav_x2_can_v0_1_gnss_sol_result_common_gnss_gps_week_decode(uint16_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_common_gnss_gps_week_is_in_range(uint16_t value)
{
    (void)value;

    return (true);
}

uint32_t by_nav_x2_can_v0_1_gnss_sol_result_common_gnss_gps_sow_encode(double value)
{
    return (uint32_t)(value);
}

double by_nav_x2_can_v0_1_gnss_sol_result_common_gnss_gps_sow_decode(uint32_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_common_gnss_gps_sow_is_in_range(uint32_t value)
{
    return (value <= 604800000u);
}

int by_nav_x2_can_v0_1_gnss_sol_result_dop_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_gnss_sol_result_dop_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u16(src_p->gnss_hdop, 8u, 0xffu);
    dst_p[1] |= pack_left_shift_u16(src_p->gnss_hdop, 0u, 0xffu);
    dst_p[2] |= pack_right_shift_u16(src_p->gnss_pdop, 8u, 0xffu);
    dst_p[3] |= pack_left_shift_u16(src_p->gnss_pdop, 0u, 0xffu);
    dst_p[4] |= pack_right_shift_u16(src_p->gnss_vdop, 8u, 0xffu);
    dst_p[5] |= pack_left_shift_u16(src_p->gnss_vdop, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_gnss_sol_result_dop_unpack(
    struct by_nav_x2_can_v0_1_gnss_sol_result_dop_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->gnss_hdop = unpack_left_shift_u16(src_p[0], 8u, 0xffu);
    dst_p->gnss_hdop |= unpack_right_shift_u16(src_p[1], 0u, 0xffu);
    dst_p->gnss_pdop = unpack_left_shift_u16(src_p[2], 8u, 0xffu);
    dst_p->gnss_pdop |= unpack_right_shift_u16(src_p[3], 0u, 0xffu);
    dst_p->gnss_vdop = unpack_left_shift_u16(src_p[4], 8u, 0xffu);
    dst_p->gnss_vdop |= unpack_right_shift_u16(src_p[5], 0u, 0xffu);

    return (0);
}

uint16_t by_nav_x2_can_v0_1_gnss_sol_result_dop_gnss_hdop_encode(double value)
{
    return (uint16_t)((value - -327.0) / 0.01);
}

double by_nav_x2_can_v0_1_gnss_sol_result_dop_gnss_hdop_decode(uint16_t value)
{
    return (((double)value * 0.01) + -327.0);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_dop_gnss_hdop_is_in_range(uint16_t value)
{
    return (value <= 65400u);
}

uint16_t by_nav_x2_can_v0_1_gnss_sol_result_dop_gnss_pdop_encode(double value)
{
    return (uint16_t)((value - -327.0) / 0.01);
}

double by_nav_x2_can_v0_1_gnss_sol_result_dop_gnss_pdop_decode(uint16_t value)
{
    return (((double)value * 0.01) + -327.0);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_dop_gnss_pdop_is_in_range(uint16_t value)
{
    return (value <= 65400u);
}

uint16_t by_nav_x2_can_v0_1_gnss_sol_result_dop_gnss_vdop_encode(double value)
{
    return (uint16_t)((value - -327.0) / 0.01);
}

double by_nav_x2_can_v0_1_gnss_sol_result_dop_gnss_vdop_decode(uint16_t value)
{
    return (((double)value * 0.01) + -327.0);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_dop_gnss_vdop_is_in_range(uint16_t value)
{
    return (value <= 65400u);
}

int by_nav_x2_can_v0_1_gnss_sol_result_num_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_gnss_sol_result_num_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_left_shift_u8(src_p->gnss_num_sats, 0u, 0xffu);
    dst_p[1] |= pack_left_shift_u8(src_p->gnss_num_sats_used, 0u, 0xffu);
    dst_p[2] |= pack_left_shift_u8(src_p->gnss_used_snr_avg, 0u, 0xffu);
    dst_p[3] |= pack_left_shift_u8(src_p->heading_svs, 0u, 0xffu);
    dst_p[4] |= pack_left_shift_u8(src_p->heading_soln_svs, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_gnss_sol_result_num_unpack(
    struct by_nav_x2_can_v0_1_gnss_sol_result_num_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->gnss_num_sats = unpack_right_shift_u8(src_p[0], 0u, 0xffu);
    dst_p->gnss_num_sats_used = unpack_right_shift_u8(src_p[1], 0u, 0xffu);
    dst_p->gnss_used_snr_avg = unpack_right_shift_u8(src_p[2], 0u, 0xffu);
    dst_p->heading_svs = unpack_right_shift_u8(src_p[3], 0u, 0xffu);
    dst_p->heading_soln_svs = unpack_right_shift_u8(src_p[4], 0u, 0xffu);

    return (0);
}

uint8_t by_nav_x2_can_v0_1_gnss_sol_result_num_gnss_num_sats_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_gnss_sol_result_num_gnss_num_sats_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_num_gnss_num_sats_is_in_range(uint8_t value)
{
    (void)value;

    return (true);
}

uint8_t by_nav_x2_can_v0_1_gnss_sol_result_num_gnss_num_sats_used_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_gnss_sol_result_num_gnss_num_sats_used_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_num_gnss_num_sats_used_is_in_range(uint8_t value)
{
    (void)value;

    return (true);
}

uint8_t by_nav_x2_can_v0_1_gnss_sol_result_num_gnss_used_snr_avg_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_gnss_sol_result_num_gnss_used_snr_avg_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_num_gnss_used_snr_avg_is_in_range(uint8_t value)
{
    (void)value;

    return (true);
}

uint8_t by_nav_x2_can_v0_1_gnss_sol_result_num_heading_svs_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_gnss_sol_result_num_heading_svs_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_num_heading_svs_is_in_range(uint8_t value)
{
    (void)value;

    return (true);
}

uint8_t by_nav_x2_can_v0_1_gnss_sol_result_num_heading_soln_svs_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_gnss_sol_result_num_heading_soln_svs_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_gnss_sol_result_num_heading_soln_svs_is_in_range(uint8_t value)
{
    (void)value;

    return (true);
}

int by_nav_x2_can_v0_1_imu_bias_corrected_common_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_imu_bias_corrected_common_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u16(src_p->imu_gps_week, 8u, 0xffu);
    dst_p[1] |= pack_left_shift_u16(src_p->imu_gps_week, 0u, 0xffu);
    dst_p[2] |= pack_right_shift_u32(src_p->imu_gps_sow, 24u, 0xffu);
    dst_p[3] |= pack_right_shift_u32(src_p->imu_gps_sow, 16u, 0xffu);
    dst_p[4] |= pack_right_shift_u32(src_p->imu_gps_sow, 8u, 0xffu);
    dst_p[5] |= pack_left_shift_u32(src_p->imu_gps_sow, 0u, 0xffu);
    dst_p[6] |= pack_right_shift_u16(src_p->imu_temperatue, 8u, 0xffu);
    dst_p[7] |= pack_left_shift_u16(src_p->imu_temperatue, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_imu_bias_corrected_common_unpack(
    struct by_nav_x2_can_v0_1_imu_bias_corrected_common_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->imu_gps_week = unpack_left_shift_u16(src_p[0], 8u, 0xffu);
    dst_p->imu_gps_week |= unpack_right_shift_u16(src_p[1], 0u, 0xffu);
    dst_p->imu_gps_sow = unpack_left_shift_u32(src_p[2], 24u, 0xffu);
    dst_p->imu_gps_sow |= unpack_left_shift_u32(src_p[3], 16u, 0xffu);
    dst_p->imu_gps_sow |= unpack_left_shift_u32(src_p[4], 8u, 0xffu);
    dst_p->imu_gps_sow |= unpack_right_shift_u32(src_p[5], 0u, 0xffu);
    dst_p->imu_temperatue = unpack_left_shift_u16(src_p[6], 8u, 0xffu);
    dst_p->imu_temperatue |= unpack_right_shift_u16(src_p[7], 0u, 0xffu);

    return (0);
}

uint16_t by_nav_x2_can_v0_1_imu_bias_corrected_common_imu_gps_week_encode(double value)
{
    return (uint16_t)(value);
}

double by_nav_x2_can_v0_1_imu_bias_corrected_common_imu_gps_week_decode(uint16_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_imu_bias_corrected_common_imu_gps_week_is_in_range(uint16_t value)
{
    (void)value;

    return (true);
}

uint32_t by_nav_x2_can_v0_1_imu_bias_corrected_common_imu_gps_sow_encode(double value)
{
    return (uint32_t)(value);
}

double by_nav_x2_can_v0_1_imu_bias_corrected_common_imu_gps_sow_decode(uint32_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_imu_bias_corrected_common_imu_gps_sow_is_in_range(uint32_t value)
{
    return (value <= 604800000u);
}

uint16_t by_nav_x2_can_v0_1_imu_bias_corrected_common_imu_temperatue_encode(double value)
{
    return (uint16_t)((value - -100.0) / 0.01);
}

double by_nav_x2_can_v0_1_imu_bias_corrected_common_imu_temperatue_decode(uint16_t value)
{
    return (((double)value * 0.01) + -100.0);
}

bool by_nav_x2_can_v0_1_imu_bias_corrected_common_imu_temperatue_is_in_range(uint16_t value)
{
    return (value <= 30000u);
}

int by_nav_x2_can_v0_1_imu_bias_corrected_angrate_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_imu_bias_corrected_angrate_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u32(src_p->imu_bias_corrected_ang_rate_x, 12u, 0xffu);
    dst_p[1] |= pack_right_shift_u32(src_p->imu_bias_corrected_ang_rate_x, 4u, 0xffu);
    dst_p[2] |= pack_left_shift_u32(src_p->imu_bias_corrected_ang_rate_x, 4u, 0xf0u);
    dst_p[2] |= pack_right_shift_u32(src_p->imu_bias_corrected_ang_rate_y, 16u, 0x0fu);
    dst_p[3] |= pack_right_shift_u32(src_p->imu_bias_corrected_ang_rate_y, 8u, 0xffu);
    dst_p[4] |= pack_left_shift_u32(src_p->imu_bias_corrected_ang_rate_y, 0u, 0xffu);
    dst_p[5] |= pack_right_shift_u32(src_p->imu_bias_corrected_ang_rate_z, 16u, 0x0fu);
    dst_p[6] |= pack_right_shift_u32(src_p->imu_bias_corrected_ang_rate_z, 8u, 0xffu);
    dst_p[7] |= pack_left_shift_u32(src_p->imu_bias_corrected_ang_rate_z, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_imu_bias_corrected_angrate_unpack(
    struct by_nav_x2_can_v0_1_imu_bias_corrected_angrate_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->imu_bias_corrected_ang_rate_x = unpack_left_shift_u32(src_p[0], 12u, 0xffu);
    dst_p->imu_bias_corrected_ang_rate_x |= unpack_left_shift_u32(src_p[1], 4u, 0xffu);
    dst_p->imu_bias_corrected_ang_rate_x |= unpack_right_shift_u32(src_p[2], 4u, 0xf0u);
    dst_p->imu_bias_corrected_ang_rate_y = unpack_left_shift_u32(src_p[2], 16u, 0x0fu);
    dst_p->imu_bias_corrected_ang_rate_y |= unpack_left_shift_u32(src_p[3], 8u, 0xffu);
    dst_p->imu_bias_corrected_ang_rate_y |= unpack_right_shift_u32(src_p[4], 0u, 0xffu);
    dst_p->imu_bias_corrected_ang_rate_z = unpack_left_shift_u32(src_p[5], 16u, 0x0fu);
    dst_p->imu_bias_corrected_ang_rate_z |= unpack_left_shift_u32(src_p[6], 8u, 0xffu);
    dst_p->imu_bias_corrected_ang_rate_z |= unpack_right_shift_u32(src_p[7], 0u, 0xffu);

    return (0);
}

uint32_t by_nav_x2_can_v0_1_imu_bias_corrected_angrate_imu_bias_corrected_ang_rate_x_encode(double value)
{
    return (uint32_t)((value - -5.235987) / 0.00001);
}

double by_nav_x2_can_v0_1_imu_bias_corrected_angrate_imu_bias_corrected_ang_rate_x_decode(uint32_t value)
{
    return (((double)value * 0.00001) + -5.235987);
}

bool by_nav_x2_can_v0_1_imu_bias_corrected_angrate_imu_bias_corrected_ang_rate_x_is_in_range(uint32_t value)
{
    return (value <= 1047197u);
}

uint32_t by_nav_x2_can_v0_1_imu_bias_corrected_angrate_imu_bias_corrected_ang_rate_y_encode(double value)
{
    return (uint32_t)((value - -5.235987) / 0.00001);
}

double by_nav_x2_can_v0_1_imu_bias_corrected_angrate_imu_bias_corrected_ang_rate_y_decode(uint32_t value)
{
    return (((double)value * 0.00001) + -5.235987);
}

bool by_nav_x2_can_v0_1_imu_bias_corrected_angrate_imu_bias_corrected_ang_rate_y_is_in_range(uint32_t value)
{
    return (value <= 1047197u);
}

uint32_t by_nav_x2_can_v0_1_imu_bias_corrected_angrate_imu_bias_corrected_ang_rate_z_encode(double value)
{
    return (uint32_t)((value - -5.235987) / 0.00001);
}

double by_nav_x2_can_v0_1_imu_bias_corrected_angrate_imu_bias_corrected_ang_rate_z_decode(uint32_t value)
{
    return (((double)value * 0.00001) + -5.235987);
}

bool by_nav_x2_can_v0_1_imu_bias_corrected_angrate_imu_bias_corrected_ang_rate_z_is_in_range(uint32_t value)
{
    return (value <= 1047197u);
}

int by_nav_x2_can_v0_1_imu_bias_corrected_acc_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_imu_bias_corrected_acc_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u32(src_p->imu_bias_corrected_acc_x, 12u, 0xffu);
    dst_p[1] |= pack_right_shift_u32(src_p->imu_bias_corrected_acc_x, 4u, 0xffu);
    dst_p[2] |= pack_left_shift_u32(src_p->imu_bias_corrected_acc_x, 4u, 0xf0u);
    dst_p[2] |= pack_right_shift_u32(src_p->imu_bias_corrected_acc_y, 16u, 0x0fu);
    dst_p[3] |= pack_right_shift_u32(src_p->imu_bias_corrected_acc_y, 8u, 0xffu);
    dst_p[4] |= pack_left_shift_u32(src_p->imu_bias_corrected_acc_y, 0u, 0xffu);
    dst_p[5] |= pack_right_shift_u32(src_p->imu_bias_corrected_acc_z, 16u, 0x0fu);
    dst_p[6] |= pack_right_shift_u32(src_p->imu_bias_corrected_acc_z, 8u, 0xffu);
    dst_p[7] |= pack_left_shift_u32(src_p->imu_bias_corrected_acc_z, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_imu_bias_corrected_acc_unpack(
    struct by_nav_x2_can_v0_1_imu_bias_corrected_acc_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->imu_bias_corrected_acc_x = unpack_left_shift_u32(src_p[0], 12u, 0xffu);
    dst_p->imu_bias_corrected_acc_x |= unpack_left_shift_u32(src_p[1], 4u, 0xffu);
    dst_p->imu_bias_corrected_acc_x |= unpack_right_shift_u32(src_p[2], 4u, 0xf0u);
    dst_p->imu_bias_corrected_acc_y = unpack_left_shift_u32(src_p[2], 16u, 0x0fu);
    dst_p->imu_bias_corrected_acc_y |= unpack_left_shift_u32(src_p[3], 8u, 0xffu);
    dst_p->imu_bias_corrected_acc_y |= unpack_right_shift_u32(src_p[4], 0u, 0xffu);
    dst_p->imu_bias_corrected_acc_z = unpack_left_shift_u32(src_p[5], 16u, 0x0fu);
    dst_p->imu_bias_corrected_acc_z |= unpack_left_shift_u32(src_p[6], 8u, 0xffu);
    dst_p->imu_bias_corrected_acc_z |= unpack_right_shift_u32(src_p[7], 0u, 0xffu);

    return (0);
}

uint32_t by_nav_x2_can_v0_1_imu_bias_corrected_acc_imu_bias_corrected_acc_x_encode(double value)
{
    return (uint32_t)((value - -60.0) / 0.0001);
}

double by_nav_x2_can_v0_1_imu_bias_corrected_acc_imu_bias_corrected_acc_x_decode(uint32_t value)
{
    return (((double)value * 0.0001) + -60.0);
}

bool by_nav_x2_can_v0_1_imu_bias_corrected_acc_imu_bias_corrected_acc_x_is_in_range(uint32_t value)
{
    return (value <= 1200000u);
}

uint32_t by_nav_x2_can_v0_1_imu_bias_corrected_acc_imu_bias_corrected_acc_y_encode(double value)
{
    return (uint32_t)((value - -60.0) / 0.0001);
}

double by_nav_x2_can_v0_1_imu_bias_corrected_acc_imu_bias_corrected_acc_y_decode(uint32_t value)
{
    return (((double)value * 0.0001) + -60.0);
}

bool by_nav_x2_can_v0_1_imu_bias_corrected_acc_imu_bias_corrected_acc_y_is_in_range(uint32_t value)
{
    return (value <= 1200000u);
}

uint32_t by_nav_x2_can_v0_1_imu_bias_corrected_acc_imu_bias_corrected_acc_z_encode(double value)
{
    return (uint32_t)((value - -60.0) / 0.0001);
}

double by_nav_x2_can_v0_1_imu_bias_corrected_acc_imu_bias_corrected_acc_z_decode(uint32_t value)
{
    return (((double)value * 0.0001) + -60.0);
}

bool by_nav_x2_can_v0_1_imu_bias_corrected_acc_imu_bias_corrected_acc_z_is_in_range(uint32_t value)
{
    return (value <= 1200000u);
}

int by_nav_x2_can_v0_1_imu_origin_common_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_imu_origin_common_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u16(src_p->imu_ori_gps_week, 8u, 0xffu);
    dst_p[1] |= pack_left_shift_u16(src_p->imu_ori_gps_week, 0u, 0xffu);
    dst_p[2] |= pack_right_shift_u32(src_p->imu_ori_gps_sow, 24u, 0xffu);
    dst_p[3] |= pack_right_shift_u32(src_p->imu_ori_gps_sow, 16u, 0xffu);
    dst_p[4] |= pack_right_shift_u32(src_p->imu_ori_gps_sow, 8u, 0xffu);
    dst_p[5] |= pack_left_shift_u32(src_p->imu_ori_gps_sow, 0u, 0xffu);
    dst_p[6] |= pack_right_shift_u16(src_p->imu_temperatue, 8u, 0xffu);
    dst_p[7] |= pack_left_shift_u16(src_p->imu_temperatue, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_imu_origin_common_unpack(
    struct by_nav_x2_can_v0_1_imu_origin_common_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->imu_ori_gps_week = unpack_left_shift_u16(src_p[0], 8u, 0xffu);
    dst_p->imu_ori_gps_week |= unpack_right_shift_u16(src_p[1], 0u, 0xffu);
    dst_p->imu_ori_gps_sow = unpack_left_shift_u32(src_p[2], 24u, 0xffu);
    dst_p->imu_ori_gps_sow |= unpack_left_shift_u32(src_p[3], 16u, 0xffu);
    dst_p->imu_ori_gps_sow |= unpack_left_shift_u32(src_p[4], 8u, 0xffu);
    dst_p->imu_ori_gps_sow |= unpack_right_shift_u32(src_p[5], 0u, 0xffu);
    dst_p->imu_temperatue = unpack_left_shift_u16(src_p[6], 8u, 0xffu);
    dst_p->imu_temperatue |= unpack_right_shift_u16(src_p[7], 0u, 0xffu);

    return (0);
}

uint16_t by_nav_x2_can_v0_1_imu_origin_common_imu_ori_gps_week_encode(double value)
{
    return (uint16_t)(value);
}

double by_nav_x2_can_v0_1_imu_origin_common_imu_ori_gps_week_decode(uint16_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_imu_origin_common_imu_ori_gps_week_is_in_range(uint16_t value)
{
    (void)value;

    return (true);
}

uint32_t by_nav_x2_can_v0_1_imu_origin_common_imu_ori_gps_sow_encode(double value)
{
    return (uint32_t)(value);
}

double by_nav_x2_can_v0_1_imu_origin_common_imu_ori_gps_sow_decode(uint32_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_imu_origin_common_imu_ori_gps_sow_is_in_range(uint32_t value)
{
    return (value <= 604800000u);
}

uint16_t by_nav_x2_can_v0_1_imu_origin_common_imu_temperatue_encode(double value)
{
    return (uint16_t)((value - -100.0) / 0.01);
}

double by_nav_x2_can_v0_1_imu_origin_common_imu_temperatue_decode(uint16_t value)
{
    return (((double)value * 0.01) + -100.0);
}

bool by_nav_x2_can_v0_1_imu_origin_common_imu_temperatue_is_in_range(uint16_t value)
{
    return (value <= 30000u);
}

int by_nav_x2_can_v0_1_imu_origin_acc_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_imu_origin_acc_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u32(src_p->imu_ori_acc_x, 12u, 0xffu);
    dst_p[1] |= pack_right_shift_u32(src_p->imu_ori_acc_x, 4u, 0xffu);
    dst_p[2] |= pack_left_shift_u32(src_p->imu_ori_acc_x, 4u, 0xf0u);
    dst_p[2] |= pack_right_shift_u32(src_p->imu_ori_acc_y, 16u, 0x0fu);
    dst_p[3] |= pack_right_shift_u32(src_p->imu_ori_acc_y, 8u, 0xffu);
    dst_p[4] |= pack_left_shift_u32(src_p->imu_ori_acc_y, 0u, 0xffu);
    dst_p[5] |= pack_right_shift_u32(src_p->imu_ori_acc_z, 16u, 0x0fu);
    dst_p[6] |= pack_right_shift_u32(src_p->imu_ori_acc_z, 8u, 0xffu);
    dst_p[7] |= pack_left_shift_u32(src_p->imu_ori_acc_z, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_imu_origin_acc_unpack(
    struct by_nav_x2_can_v0_1_imu_origin_acc_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->imu_ori_acc_x = unpack_left_shift_u32(src_p[0], 12u, 0xffu);
    dst_p->imu_ori_acc_x |= unpack_left_shift_u32(src_p[1], 4u, 0xffu);
    dst_p->imu_ori_acc_x |= unpack_right_shift_u32(src_p[2], 4u, 0xf0u);
    dst_p->imu_ori_acc_y = unpack_left_shift_u32(src_p[2], 16u, 0x0fu);
    dst_p->imu_ori_acc_y |= unpack_left_shift_u32(src_p[3], 8u, 0xffu);
    dst_p->imu_ori_acc_y |= unpack_right_shift_u32(src_p[4], 0u, 0xffu);
    dst_p->imu_ori_acc_z = unpack_left_shift_u32(src_p[5], 16u, 0x0fu);
    dst_p->imu_ori_acc_z |= unpack_left_shift_u32(src_p[6], 8u, 0xffu);
    dst_p->imu_ori_acc_z |= unpack_right_shift_u32(src_p[7], 0u, 0xffu);

    return (0);
}

uint32_t by_nav_x2_can_v0_1_imu_origin_acc_imu_ori_acc_x_encode(double value)
{
    return (uint32_t)((value - -60.0) / 0.0001);
}

double by_nav_x2_can_v0_1_imu_origin_acc_imu_ori_acc_x_decode(uint32_t value)
{
    return (((double)value * 0.0001) + -60.0);
}

bool by_nav_x2_can_v0_1_imu_origin_acc_imu_ori_acc_x_is_in_range(uint32_t value)
{
    return (value <= 1200000u);
}

uint32_t by_nav_x2_can_v0_1_imu_origin_acc_imu_ori_acc_y_encode(double value)
{
    return (uint32_t)((value - -60.0) / 0.0001);
}

double by_nav_x2_can_v0_1_imu_origin_acc_imu_ori_acc_y_decode(uint32_t value)
{
    return (((double)value * 0.0001) + -60.0);
}

bool by_nav_x2_can_v0_1_imu_origin_acc_imu_ori_acc_y_is_in_range(uint32_t value)
{
    return (value <= 1200000u);
}

uint32_t by_nav_x2_can_v0_1_imu_origin_acc_imu_ori_acc_z_encode(double value)
{
    return (uint32_t)((value - -60.0) / 0.0001);
}

double by_nav_x2_can_v0_1_imu_origin_acc_imu_ori_acc_z_decode(uint32_t value)
{
    return (((double)value * 0.0001) + -60.0);
}

bool by_nav_x2_can_v0_1_imu_origin_acc_imu_ori_acc_z_is_in_range(uint32_t value)
{
    return (value <= 1200000u);
}

int by_nav_x2_can_v0_1_imu_origin_gyro_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_imu_origin_gyro_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_right_shift_u32(src_p->imu_ori_gyro_x, 12u, 0xffu);
    dst_p[1] |= pack_right_shift_u32(src_p->imu_ori_gyro_x, 4u, 0xffu);
    dst_p[2] |= pack_left_shift_u32(src_p->imu_ori_gyro_x, 4u, 0xf0u);
    dst_p[2] |= pack_right_shift_u32(src_p->imu_ori_gyro_y, 16u, 0x0fu);
    dst_p[3] |= pack_right_shift_u32(src_p->imu_ori_gyro_y, 8u, 0xffu);
    dst_p[4] |= pack_left_shift_u32(src_p->imu_ori_gyro_y, 0u, 0xffu);
    dst_p[5] |= pack_right_shift_u32(src_p->imu_ori_gyro_z, 16u, 0x0fu);
    dst_p[6] |= pack_right_shift_u32(src_p->imu_ori_gyro_z, 8u, 0xffu);
    dst_p[7] |= pack_left_shift_u32(src_p->imu_ori_gyro_z, 0u, 0xffu);

    return (8);
}

int by_nav_x2_can_v0_1_imu_origin_gyro_unpack(
    struct by_nav_x2_can_v0_1_imu_origin_gyro_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->imu_ori_gyro_x = unpack_left_shift_u32(src_p[0], 12u, 0xffu);
    dst_p->imu_ori_gyro_x |= unpack_left_shift_u32(src_p[1], 4u, 0xffu);
    dst_p->imu_ori_gyro_x |= unpack_right_shift_u32(src_p[2], 4u, 0xf0u);
    dst_p->imu_ori_gyro_y = unpack_left_shift_u32(src_p[2], 16u, 0x0fu);
    dst_p->imu_ori_gyro_y |= unpack_left_shift_u32(src_p[3], 8u, 0xffu);
    dst_p->imu_ori_gyro_y |= unpack_right_shift_u32(src_p[4], 0u, 0xffu);
    dst_p->imu_ori_gyro_z = unpack_left_shift_u32(src_p[5], 16u, 0x0fu);
    dst_p->imu_ori_gyro_z |= unpack_left_shift_u32(src_p[6], 8u, 0xffu);
    dst_p->imu_ori_gyro_z |= unpack_right_shift_u32(src_p[7], 0u, 0xffu);

    return (0);
}

uint32_t by_nav_x2_can_v0_1_imu_origin_gyro_imu_ori_gyro_x_encode(double value)
{
    return (uint32_t)((value - -5.23598) / 0.00001);
}

double by_nav_x2_can_v0_1_imu_origin_gyro_imu_ori_gyro_x_decode(uint32_t value)
{
    return (((double)value * 0.00001) + -5.23598);
}

bool by_nav_x2_can_v0_1_imu_origin_gyro_imu_ori_gyro_x_is_in_range(uint32_t value)
{
    return (value <= 1047196u);
}

uint32_t by_nav_x2_can_v0_1_imu_origin_gyro_imu_ori_gyro_y_encode(double value)
{
    return (uint32_t)((value - -5.23598) / 0.00001);
}

double by_nav_x2_can_v0_1_imu_origin_gyro_imu_ori_gyro_y_decode(uint32_t value)
{
    return (((double)value * 0.00001) + -5.23598);
}

bool by_nav_x2_can_v0_1_imu_origin_gyro_imu_ori_gyro_y_is_in_range(uint32_t value)
{
    return (value <= 1047196u);
}

uint32_t by_nav_x2_can_v0_1_imu_origin_gyro_imu_ori_gyro_z_encode(double value)
{
    return (uint32_t)((value - -5.23598) / 0.00001);
}

double by_nav_x2_can_v0_1_imu_origin_gyro_imu_ori_gyro_z_decode(uint32_t value)
{
    return (((double)value * 0.00001) + -5.23598);
}

bool by_nav_x2_can_v0_1_imu_origin_gyro_imu_ori_gyro_z_is_in_range(uint32_t value)
{
    return (value <= 1047196u);
}


int by_nav_x2_can_v0_1_control_request1_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_control_request1_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_left_shift_u8(src_p->ipc_target_motor_en, 0u, 0x01u);
    dst_p[0] |= pack_left_shift_u8(src_p->ipc_target_gear, 1u, 0x06u);
    dst_p[0] |= pack_left_shift_u8(src_p->ipc_target_mode, 3u, 0x08u);
    dst_p[0] |= pack_left_shift_u8(src_p->ipc_life_signal, 4u, 0xf0u);
    dst_p[1] |= pack_left_shift_u8(src_p->ipc_target_speed, 0u, 0x7fu);
    dst_p[1] |= pack_left_shift_u8(src_p->ipc_target_spd_valid, 7u, 0x80u);
    dst_p[2] |= pack_left_shift_u8(src_p->ipc_target_brk_press, 0u, 0xffu);
    dst_p[3] |= pack_left_shift_u16(src_p->ipc_target_angle, 0u, 0xffu);
    dst_p[4] |= pack_right_shift_u16(src_p->ipc_target_angle, 8u, 0x7fu);
    dst_p[4] |= pack_left_shift_u8(src_p->ipc_target_steering_en, 7u, 0x80u);
    dst_p[5] |= pack_left_shift_u8(src_p->ipc_target_torque, 0u, 0xffu);
    dst_p[6] |= pack_left_shift_u8(src_p->ipc_torque_rpm_mode, 0u, 0x01u);
    dst_p[6] |= pack_left_shift_u8(src_p->ipc_turn_light, 1u, 0x06u);
    dst_p[6] |= pack_left_shift_u8(src_p->ipc_target_spd_mode, 3u, 0x18u);

    return (8);
}

int by_nav_x2_can_v0_1_control_request1_unpack(
    struct by_nav_x2_can_v0_1_control_request1_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->ipc_target_motor_en = unpack_right_shift_u8(src_p[0], 0u, 0x01u);
    dst_p->ipc_target_gear = unpack_right_shift_u8(src_p[0], 1u, 0x06u);
    dst_p->ipc_target_mode = unpack_right_shift_u8(src_p[0], 3u, 0x08u);
    dst_p->ipc_life_signal = unpack_right_shift_u8(src_p[0], 4u, 0xf0u);
    dst_p->ipc_target_speed = unpack_right_shift_u8(src_p[1], 0u, 0x7fu);
    dst_p->ipc_target_spd_valid = unpack_right_shift_u8(src_p[1], 7u, 0x80u);
    dst_p->ipc_target_brk_press = unpack_right_shift_u8(src_p[2], 0u, 0xffu);
    dst_p->ipc_target_angle = unpack_right_shift_u16(src_p[3], 0u, 0xffu);
    dst_p->ipc_target_angle |= unpack_left_shift_u16(src_p[4], 8u, 0x7fu);
    dst_p->ipc_target_steering_en = unpack_right_shift_u8(src_p[4], 7u, 0x80u);
    dst_p->ipc_target_torque = unpack_right_shift_u8(src_p[5], 0u, 0xffu);
    dst_p->ipc_torque_rpm_mode = unpack_right_shift_u8(src_p[6], 0u, 0x01u);
    dst_p->ipc_turn_light = unpack_right_shift_u8(src_p[6], 1u, 0x06u);
    dst_p->ipc_target_spd_mode = unpack_right_shift_u8(src_p[6], 3u, 0x18u);

    return (0);
}

int by_nav_x2_can_v0_1_control_request1_init(struct by_nav_x2_can_v0_1_control_request1_t *msg_p)
{
    if (msg_p == NULL) return -1;

    memset(msg_p, 0, sizeof(struct by_nav_x2_can_v0_1_control_request1_t));

    return 0;
}

uint8_t by_nav_x2_can_v0_1_control_request1_ipc_target_motor_en_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_control_request1_ipc_target_motor_en_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_control_request1_ipc_target_motor_en_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

uint8_t by_nav_x2_can_v0_1_control_request1_ipc_target_gear_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_control_request1_ipc_target_gear_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_control_request1_ipc_target_gear_is_in_range(uint8_t value)
{
    return (value <= 3u);
}

uint8_t by_nav_x2_can_v0_1_control_request1_ipc_target_mode_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_control_request1_ipc_target_mode_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_control_request1_ipc_target_mode_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

uint8_t by_nav_x2_can_v0_1_control_request1_ipc_life_signal_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_control_request1_ipc_life_signal_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_control_request1_ipc_life_signal_is_in_range(uint8_t value)
{
    return (value <= 15u);
}

uint8_t by_nav_x2_can_v0_1_control_request1_ipc_target_speed_encode(double value)
{
    return (uint8_t)(value * 10);
}

double by_nav_x2_can_v0_1_control_request1_ipc_target_speed_decode(uint8_t value)
{
    return ((double)value * 0.1);
}

bool by_nav_x2_can_v0_1_control_request1_ipc_target_speed_is_in_range(uint8_t value)
{
    return (value <= 127u);
}

uint8_t by_nav_x2_can_v0_1_control_request1_ipc_target_spd_valid_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_control_request1_ipc_target_spd_valid_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_control_request1_ipc_target_spd_valid_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

uint8_t by_nav_x2_can_v0_1_control_request1_ipc_target_brk_press_encode(double value)
{
    return (uint8_t)(value / 0.05);
}

double by_nav_x2_can_v0_1_control_request1_ipc_target_brk_press_decode(uint8_t value)
{
    return ((double)value * 0.05);
}

bool by_nav_x2_can_v0_1_control_request1_ipc_target_brk_press_is_in_range(uint8_t value)
{
    return (value <= 160u);
}

uint16_t by_nav_x2_can_v0_1_control_request1_ipc_target_angle_encode(double value)
{
    return (uint16_t)((value - -700.0) * 10);
}

double by_nav_x2_can_v0_1_control_request1_ipc_target_angle_decode(uint16_t value)
{
    return (((double)value * 0.1) + -700.0);
}

bool by_nav_x2_can_v0_1_control_request1_ipc_target_angle_is_in_range(uint16_t value)
{
    return (value <= 14000u);
}

uint8_t by_nav_x2_can_v0_1_control_request1_ipc_target_steering_en_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_control_request1_ipc_target_steering_en_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_control_request1_ipc_target_steering_en_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

uint8_t by_nav_x2_can_v0_1_control_request1_ipc_target_torque_encode(double value)
{
    return (uint8_t)(value * 10);
}

double by_nav_x2_can_v0_1_control_request1_ipc_target_torque_decode(uint8_t value)
{
    return ((double)value * 0.1);
}

bool by_nav_x2_can_v0_1_control_request1_ipc_target_torque_is_in_range(uint8_t value)
{
    (void)value;

    return (true);
}

uint8_t by_nav_x2_can_v0_1_control_request1_ipc_torque_rpm_mode_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_control_request1_ipc_torque_rpm_mode_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_control_request1_ipc_torque_rpm_mode_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

uint8_t by_nav_x2_can_v0_1_control_request1_ipc_turn_light_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_control_request1_ipc_turn_light_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_control_request1_ipc_turn_light_is_in_range(uint8_t value)
{
    return (value <= 3u);
}

uint8_t by_nav_x2_can_v0_1_control_request1_ipc_target_spd_mode_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_control_request1_ipc_target_spd_mode_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_control_request1_ipc_target_spd_mode_is_in_range(uint8_t value)
{
    return (value <= 3u);
}

int by_nav_x2_can_v0_1_vcu_info_1_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_vcu_info_1_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_left_shift_u16(src_p->current_angle, 0u, 0xffu);
    dst_p[1] |= pack_right_shift_u16(src_p->current_angle, 8u, 0x7fu);
    dst_p[1] |= pack_left_shift_u8(src_p->ses_en_sts, 7u, 0x80u);
    dst_p[2] |= pack_left_shift_u8(src_p->motor_en_sts, 0u, 0x01u);
    dst_p[2] |= pack_left_shift_u8(src_p->current_speed, 1u, 0xfeu);
    dst_p[3] |= pack_left_shift_u8(src_p->motor_torque, 0u, 0xffu);
    dst_p[4] |= pack_left_shift_u8(src_p->vcu_mode, 0u, 0x03u);
    dst_p[4] |= pack_left_shift_u8(src_p->controller_online_sts, 2u, 0x04u);
    dst_p[4] |= pack_left_shift_u8(src_p->ipc_online_status, 3u, 0x08u);
    dst_p[4] |= pack_left_shift_u8(src_p->vcu_life_signal, 4u, 0xf0u);
    dst_p[5] |= pack_left_shift_u8(src_p->current_brk_press, 0u, 0xffu);
    dst_p[6] |= pack_left_shift_u8(src_p->rseb_mode, 0u, 0x03u);
    dst_p[6] |= pack_left_shift_u8(src_p->battery_number, 2u, 0x0cu);
    dst_p[6] |= pack_left_shift_u8(src_p->current_gear, 4u, 0x30u);
    dst_p[6] |= pack_left_shift_u8(src_p->battery_warning, 6u, 0xc0u);
    dst_p[7] |= pack_left_shift_u8(src_p->current_spd_mode, 0u, 0x03u);

    return (8);
}

int by_nav_x2_can_v0_1_vcu_info_1_unpack(
    struct by_nav_x2_can_v0_1_vcu_info_1_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->current_angle = unpack_right_shift_u16(src_p[0], 0u, 0xffu);
    dst_p->current_angle |= unpack_left_shift_u16(src_p[1], 8u, 0x7fu);
    dst_p->ses_en_sts = unpack_right_shift_u8(src_p[1], 7u, 0x80u);
    dst_p->motor_en_sts = unpack_right_shift_u8(src_p[2], 0u, 0x01u);
    dst_p->current_speed = unpack_right_shift_u8(src_p[2], 1u, 0xfeu);
    dst_p->motor_torque = unpack_right_shift_u8(src_p[3], 0u, 0xffu);
    dst_p->vcu_mode = unpack_right_shift_u8(src_p[4], 0u, 0x03u);
    dst_p->controller_online_sts = unpack_right_shift_u8(src_p[4], 2u, 0x04u);
    dst_p->ipc_online_status = unpack_right_shift_u8(src_p[4], 3u, 0x08u);
    dst_p->vcu_life_signal = unpack_right_shift_u8(src_p[4], 4u, 0xf0u);
    dst_p->current_brk_press = unpack_right_shift_u8(src_p[5], 0u, 0xffu);
    dst_p->rseb_mode = unpack_right_shift_u8(src_p[6], 0u, 0x03u);
    dst_p->battery_number = unpack_right_shift_u8(src_p[6], 2u, 0x0cu);
    dst_p->current_gear = unpack_right_shift_u8(src_p[6], 4u, 0x30u);
    dst_p->battery_warning = unpack_right_shift_u8(src_p[6], 6u, 0xc0u);
    dst_p->current_spd_mode = unpack_right_shift_u8(src_p[7], 0u, 0x03u);

    return (0);
}

int by_nav_x2_can_v0_1_vcu_info_1_init(struct by_nav_x2_can_v0_1_vcu_info_1_t *msg_p)
{
    if (msg_p == NULL) return -1;

    memset(msg_p, 0, sizeof(struct by_nav_x2_can_v0_1_vcu_info_1_t));

    return 0;
}

uint16_t by_nav_x2_can_v0_1_vcu_info_1_current_angle_encode(double value)
{
    return (uint16_t)((value - -700.0) * 10);
}

double by_nav_x2_can_v0_1_vcu_info_1_current_angle_decode(uint16_t value)
{
    return (((double)value * 0.1) + -700.0);
}

bool by_nav_x2_can_v0_1_vcu_info_1_current_angle_is_in_range(uint16_t value)
{
    return (value <= 14000u);
}

uint8_t by_nav_x2_can_v0_1_vcu_info_1_ses_en_sts_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_vcu_info_1_ses_en_sts_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_vcu_info_1_ses_en_sts_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

uint8_t by_nav_x2_can_v0_1_vcu_info_1_motor_en_sts_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_vcu_info_1_motor_en_sts_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_vcu_info_1_motor_en_sts_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

uint8_t by_nav_x2_can_v0_1_vcu_info_1_current_speed_encode(double value)
{
    return (uint8_t)(value * 10);
}

double by_nav_x2_can_v0_1_vcu_info_1_current_speed_decode(uint8_t value)
{
    return ((double)value * 0.1);
}

bool by_nav_x2_can_v0_1_vcu_info_1_current_speed_is_in_range(uint8_t value)
{
    return (value <= 127u);
}

uint8_t by_nav_x2_can_v0_1_vcu_info_1_motor_torque_encode(double value)
{
    return (uint8_t)(value * 10);
}

double by_nav_x2_can_v0_1_vcu_info_1_motor_torque_decode(uint8_t value)
{
    return ((double)value * 0.1);
}

bool by_nav_x2_can_v0_1_vcu_info_1_motor_torque_is_in_range(uint8_t value)
{
    (void)value;

    return (true);
}

uint8_t by_nav_x2_can_v0_1_vcu_info_1_vcu_mode_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_vcu_info_1_vcu_mode_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_vcu_info_1_vcu_mode_is_in_range(uint8_t value)
{
    return (value <= 3u);
}

uint8_t by_nav_x2_can_v0_1_vcu_info_1_controller_online_sts_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_vcu_info_1_controller_online_sts_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_vcu_info_1_controller_online_sts_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

uint8_t by_nav_x2_can_v0_1_vcu_info_1_ipc_online_status_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_vcu_info_1_ipc_online_status_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_vcu_info_1_ipc_online_status_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

uint8_t by_nav_x2_can_v0_1_vcu_info_1_vcu_life_signal_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_vcu_info_1_vcu_life_signal_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_vcu_info_1_vcu_life_signal_is_in_range(uint8_t value)
{
    return (value <= 15u);
}

uint8_t by_nav_x2_can_v0_1_vcu_info_1_current_brk_press_encode(double value)
{
    return (uint8_t)(value / 0.05);
}

double by_nav_x2_can_v0_1_vcu_info_1_current_brk_press_decode(uint8_t value)
{
    return ((double)value * 0.05);
}

bool by_nav_x2_can_v0_1_vcu_info_1_current_brk_press_is_in_range(uint8_t value)
{
    return (value <= 160u);
}

uint8_t by_nav_x2_can_v0_1_vcu_info_1_rseb_mode_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_vcu_info_1_rseb_mode_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_vcu_info_1_rseb_mode_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

uint8_t by_nav_x2_can_v0_1_vcu_info_1_battery_number_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_vcu_info_1_battery_number_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_vcu_info_1_battery_number_is_in_range(uint8_t value)
{
    return (value <= 2u);
}

uint8_t by_nav_x2_can_v0_1_vcu_info_1_current_gear_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_vcu_info_1_current_gear_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_vcu_info_1_current_gear_is_in_range(uint8_t value)
{
    return (value <= 3u);
}

uint8_t by_nav_x2_can_v0_1_vcu_info_1_battery_warning_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_vcu_info_1_battery_warning_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_vcu_info_1_battery_warning_is_in_range(uint8_t value)
{
    return (value <= 3u);
}

uint8_t by_nav_x2_can_v0_1_vcu_info_1_current_spd_mode_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_vcu_info_1_current_spd_mode_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_vcu_info_1_current_spd_mode_is_in_range(uint8_t value)
{
    return (value <= 3u);
}

int by_nav_x2_can_v0_1_vcu_info_2_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_vcu_info_2_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= pack_left_shift_u8(src_p->soc1, 0u, 0xffu);
    dst_p[1] |= pack_left_shift_u8(src_p->soc2, 0u, 0xffu);
    dst_p[2] |= pack_left_shift_u8(src_p->collision_status, 0u, 0x01u);
    dst_p[6] |= pack_left_shift_u8(src_p->motor_direction, 0u, 0x03u);

    return (8);
}

int by_nav_x2_can_v0_1_vcu_info_2_unpack(
    struct by_nav_x2_can_v0_1_vcu_info_2_t *dst_p,
    const uint8_t *src_p,
    size_t size)
{
    if (size < 8u) {
        return (-EINVAL);
    }

    dst_p->soc1 = unpack_right_shift_u8(src_p[0], 0u, 0xffu);
    dst_p->soc2 = unpack_right_shift_u8(src_p[1], 0u, 0xffu);
    dst_p->collision_status = unpack_right_shift_u8(src_p[2], 0u, 0x01u);
    dst_p->motor_direction = unpack_right_shift_u8(src_p[6], 0u, 0x03u);

    return (0);
}

int by_nav_x2_can_v0_1_vcu_info_2_init(struct by_nav_x2_can_v0_1_vcu_info_2_t *msg_p)
{
    if (msg_p == NULL) return -1;

    memset(msg_p, 0, sizeof(struct by_nav_x2_can_v0_1_vcu_info_2_t));

    return 0;
}

uint8_t by_nav_x2_can_v0_1_vcu_info_2_soc1_encode(double value)
{
    return (uint8_t)(value / 0.4);
}

double by_nav_x2_can_v0_1_vcu_info_2_soc1_decode(uint8_t value)
{
    return ((double)value * 0.4);
}

bool by_nav_x2_can_v0_1_vcu_info_2_soc1_is_in_range(uint8_t value)
{
    return (value <= 250u);
}

uint8_t by_nav_x2_can_v0_1_vcu_info_2_soc2_encode(double value)
{
    return (uint8_t)(value / 0.4);
}

double by_nav_x2_can_v0_1_vcu_info_2_soc2_decode(uint8_t value)
{
    return ((double)value * 0.4);
}

bool by_nav_x2_can_v0_1_vcu_info_2_soc2_is_in_range(uint8_t value)
{
    return (value <= 250u);
}

uint8_t by_nav_x2_can_v0_1_vcu_info_2_collision_status_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_vcu_info_2_collision_status_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_vcu_info_2_collision_status_is_in_range(uint8_t value)
{
    return (value <= 1u);
}

uint8_t by_nav_x2_can_v0_1_vcu_info_2_motor_direction_encode(double value)
{
    return (uint8_t)(value);
}

double by_nav_x2_can_v0_1_vcu_info_2_motor_direction_decode(uint8_t value)
{
    return ((double)value);
}

bool by_nav_x2_can_v0_1_vcu_info_2_motor_direction_is_in_range(uint8_t value)
{
    return (value <= 3u);
}
