/**
 * The MIT License (MIT)
 *
 * Copyright (c) 2018-2019 Erik Moqvist
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/**
 * This file was generated by cantools version 37.2.0 Tue Feb  6 13:09:08 2024.
 */

#ifndef BY_NAV_X2_CAN_V0_1_H
#define BY_NAV_X2_CAN_V0_1_H

#include <stdint.h>
#include <stdbool.h>
#include <stddef.h>

#include "can_msg_node/executable.h"
#ifndef EINVAL
#    define EINVAL 22
#endif

/* Frame ids. */
#define ULTRASONIC_RADAR_MESSAGE_HS_CAN_100_FRAME_ID (0x100u)
#define ULTRASONIC_RADAR_MESSAGE_HS_CAN_101_FRAME_ID (0x101u)

#define BY_NAV_X2_CAN_V0_1_DEVSTATUS_FRAME_ID (0x420u)
#define BY_NAV_X2_CAN_V0_1_HEADING_ANGLE_FRAME_ID (0x41au)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_LATENCY_FRAME_ID (0x410u)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_STATUS_FRAME_ID (0x419u)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_VEL_STD_FRAME_ID (0x418u)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_VEL_FRAME_ID (0x417u)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_ANGLE_STD_FRAME_ID (0x416u)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_ANGLE_FRAME_ID (0x415u)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_ALTITUDE_FRAME_ID (0x414u)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_LONGITUDE_FRAME_ID (0x413u)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_LATITUDE_FRAME_ID (0x412u)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_COMMON_FRAME_ID (0x411u)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_SPD_FRAME_ID (0x40fu)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_ALTITUDE_FRAME_ID (0x40eu)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_LONGITUDE_FRAME_ID (0x40du)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_LATITUDE_FRAME_ID (0x40cu)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_STATUS_FRAME_ID (0x40bu)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_COMMON_FRAME_ID (0x40au)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_DOP_FRAME_ID (0x409u)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_NUM_FRAME_ID (0x408u)
#define BY_NAV_X2_CAN_V0_1_IMU_BIAS_CORRECTED_COMMON_FRAME_ID (0x406u)
#define BY_NAV_X2_CAN_V0_1_IMU_BIAS_CORRECTED_ANGRATE_FRAME_ID (0x405u)
#define BY_NAV_X2_CAN_V0_1_IMU_BIAS_CORRECTED_ACC_FRAME_ID (0x404u)
#define BY_NAV_X2_CAN_V0_1_IMU_ORIGIN_COMMON_FRAME_ID (0x402u)
#define BY_NAV_X2_CAN_V0_1_IMU_ORIGIN_ACC_FRAME_ID (0x401u)
#define BY_NAV_X2_CAN_V0_1_IMU_ORIGIN_GYRO_FRAME_ID (0x400u)

#define BY_NAV_X2_CAN_V0_1_CONTROL_REQUEST1_FRAME_ID (0xa1u)
#define BY_NAV_X2_CAN_V0_1_VCU_INFO_1_FRAME_ID (0xb1u)
#define BY_NAV_X2_CAN_V0_1_VCU_INFO_2_FRAME_ID (0xb2u)

/* Frame lengths in bytes. */
#define BY_NAV_X2_CAN_V0_1_DEVSTATUS_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_HEADING_ANGLE_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_LATENCY_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_STATUS_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_VEL_STD_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_VEL_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_ANGLE_STD_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_ANGLE_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_ALTITUDE_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_LONGITUDE_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_LATITUDE_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_COMMON_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_SPD_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_ALTITUDE_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_LONGITUDE_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_LATITUDE_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_STATUS_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_COMMON_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_DOP_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_NUM_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_IMU_BIAS_CORRECTED_COMMON_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_IMU_BIAS_CORRECTED_ANGRATE_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_IMU_BIAS_CORRECTED_ACC_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_IMU_ORIGIN_COMMON_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_IMU_ORIGIN_ACC_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_IMU_ORIGIN_GYRO_LENGTH (8u)

#define BY_NAV_X2_CAN_V0_1_CONTROL_REQUEST1_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_VCU_INFO_1_LENGTH (8u)
#define BY_NAV_X2_CAN_V0_1_VCU_INFO_2_LENGTH (8u)

/* Extended or standard frame types. */
#define BY_NAV_X2_CAN_V0_1_DEVSTATUS_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_HEADING_ANGLE_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_LATENCY_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_STATUS_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_VEL_STD_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_VEL_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_ANGLE_STD_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_ANGLE_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_ALTITUDE_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_LONGITUDE_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_LATITUDE_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_INS_SOL_RESULT_COMMON_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_SPD_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_ALTITUDE_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_LONGITUDE_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_LATITUDE_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_STATUS_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_COMMON_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_DOP_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_GNSS_SOL_RESULT_NUM_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_IMU_BIAS_CORRECTED_COMMON_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_IMU_BIAS_CORRECTED_ANGRATE_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_IMU_BIAS_CORRECTED_ACC_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_IMU_ORIGIN_COMMON_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_IMU_ORIGIN_ACC_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_IMU_ORIGIN_GYRO_IS_EXTENDED (0)

#define BY_NAV_X2_CAN_V0_1_CONTROL_REQUEST1_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_VCU_INFO_1_IS_EXTENDED (0)
#define BY_NAV_X2_CAN_V0_1_VCU_INFO_2_IS_EXTENDED (0)

/* Frame cycle times in milliseconds. */

#define BY_NAV_X2_CAN_V0_1_CONTROL_REQUEST1_CYCLE_TIME_MS (10u)
#define BY_NAV_X2_CAN_V0_1_VCU_INFO_1_CYCLE_TIME_MS (20u)
#define BY_NAV_X2_CAN_V0_1_VCU_INFO_2_CYCLE_TIME_MS (100u)

/* Signal choices. */



/**
 * Signals in message DEVSTATUS.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_devstatus_t {
    /**
     * �豸�¶�
     *
     * Range: 0..30000 (-100..200 ��)
     * Scale: 0.01
     * Offset: -100
     */
    uint16_t devstatus_ap_temperatue;
};

struct ultrasonic_radar_message_hs_can_100_t {
    uint8_t message_hs_can_100_pas_mode;
    uint8_t message_hs_can_100_pas_warn_tone;
    uint8_t message_hs_can_100_pas_rl_distance;
    uint8_t message_hs_can_100_pas_rl_mid_distance;
    uint8_t message_hs_can_100_pas_rr_mid_distance;
    uint8_t message_hs_can_100_pas_rr_distance;
};

struct ultrasonic_radar_message_hs_can_101_t {
    uint8_t message_hs_can_101_pas_fl_distance;
    uint8_t message_hs_can_101_pas_fl_mid_distance;
    uint8_t message_hs_can_101_pas_fr_mid_distance;
    uint8_t message_hs_can_101_pas_fr_distance;
    uint8_t message_hs_can_101_pas_rl_sns_err_flag;
    uint8_t message_hs_can_101_pas_rl_mid_sns_err_flag;
    uint8_t message_hs_can_101_pas_rr_mid_sns_err_flag;
    uint8_t message_hs_can_101_pas_rr_sns_err_flag;
    uint8_t message_hs_can_101_pas_fl_sns_err_flag;
    uint8_t message_hs_can_101_pas_fl_mid_sns_err_flag;
    uint8_t message_hs_can_101_pas_fr_mid_sns_err_flag;
    uint8_t message_hs_can_101_pas_fr_sns_err_flag;
};

/**
 * Signals in message HEADING_ANGLE.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_heading_angle_t {
    /**
     * ��λ��
     *
     * Range: 0..36000 (0..360 degree)
     * Scale: 0.01
     * Offset: 0
     */
    uint16_t heading_heading;

    /**
     * ������
     *
     * Range: 0..18000 (-90..90 degree)
     * Scale: 0.01
     * Offset: -90
     */
    uint16_t heading_pitch;

    /**
     * ��λ�Ǳ�׼��
     *
     * Range: 0..1000 (0..10 degree)
     * Scale: 0.01
     * Offset: 0
     */
    uint16_t heading_heading_std;

    /**
     * �����Ǳ�׼��
     *
     * Range: 0..1000 (0..10 degree)
     * Scale: 0.01
     * Offset: 0
     */
    uint16_t heading_pitch_std;

    /**
     * ������߳���
     *
     * Range: 0..20000 (0..200 m)
     * Scale: 0.01
     * Offset: 0
     */
    uint16_t heading_length;
};

/**
 * Signals in message GNSS_SOL_RESULT_LATENCY.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_gnss_sol_result_latency_t {
    /**
     * �ӳ�
     *
     * Range: 0..1000 (0..100 s)
     * Scale: 0.1
     * Offset: 0
     */
    uint32_t gnss_measure_latency;

    /**
     * gnss�������	�������
     *
     * Range: 0..1000 (0..100 s)
     * Scale: 0.1
     * Offset: 0
     */
    uint32_t gnss_diff_age;
};

/**
 * Signals in message INS_SOL_RESULT_STATUS.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_ins_sol_result_status_t {
    /**
     * INS����״̬    ͬINSPVAXЭ���е�INS Status
     *
     * Range: 0..255 (0..255 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ins_ins_status;

    /**
     * ��λ״̬    ͬINSPVAXЭ���е�PosType
     *
     * Range: 0..255 (0..255 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ins_pos_type;
};

/**
 * Signals in message INS_SOL_RESULT_VEL_STD.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_ins_sol_result_vel_std_t {
    /**
     * �ٶȱ�׼��	�û���������ϵԭ���˶��ĺ��ٶȱ�׼��
     *
     * Range: 0..6554 (0..65.54 m/s)
     * Scale: 0.01
     * Offset: 0
     */
    uint16_t ins_velocity_std;

    /**
     * �����ٶȱ�׼��	�û���������ϵԭ��Ķ����ٶȱ�׼��
     *
     * Range: 0..6554 (0..65.54 m/s)
     * Scale: 0.01
     * Offset: 0
     */
    uint16_t ins_velocity_e_std;

    /**
     * �����ٶȱ�׼��	�û���������ϵԭ��ı����ٶȱ�׼��
     *
     * Range: 0..6554 (0..65.54 m/s)
     * Scale: 0.01
     * Offset: 0
     */
    uint16_t ins_velocity_n_std;

    /**
     * �����ٶȱ�׼��	�û���������ϵԭ��������ٶȱ�׼��
     *
     * Range: 0..6554 (0..65.54 m/s)
     * Scale: 0.01
     * Offset: 0
     */
    uint16_t ins_velocity_u_std;
};

/**
 * Signals in message INS_SOL_RESULT_VEL.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_ins_sol_result_vel_t {
    /**
     * �ٶ�	�û���������ϵԭ���˶��ĺ��ٶ�
     *
     * Range: 0..20000 (0..200 m/s)
     * Scale: 0.01
     * Offset: 0
     */
    uint16_t ins_velocity;

    /**
     * �����ٶ�	�û���������ϵԭ��Ķ����ٶ�
     *
     * Range: 0..20000 (-100..100 m/s)
     * Scale: 0.01
     * Offset: -100
     */
    uint16_t ins_velocity_e;

    /**
     * �����ٶ�	�û���������ϵԭ��ı����ٶ�
     *
     * Range: 0..20000 (-100..100 m/s)
     * Scale: 0.01
     * Offset: -100
     */
    uint16_t ins_velocity_n;

    /**
     * �����ٶ�	�û���������ϵԭ��������ٶ�
     *
     * Range: 0..20000 (-100..100 m/s)
     * Scale: 0.01
     * Offset: -100
     */
    uint16_t ins_velocity_u;
};

/**
 * Signals in message INS_SOL_RESULT_ANGLE_STD.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_ins_sol_result_angle_std_t {
    /**
     * �����Ǳ�׼��	�����˶��켣���߷����ٶȷ�������������ļнǵı�׼��
     *
     * Range: 0..6554 (0..65.54 degree)
     * Scale: 0.01
     * Offset: 0
     */
    uint16_t ins_course_angle_std;

    /**
     * �����׼��	���峵ͷǰ����������������ļнǱ�׼��
     *
     * Range: 0..6554 (0..65.54 degree)
     * Scale: 0.01
     * Offset: 0
     */
    uint16_t ins_yaw_angle_std;

    /**
     * �����Ǳ�׼��	���峵ͷ������б�ĽǶȱ�׼��
     *
     * Range: 0..6554 (0..65.54 degree)
     * Scale: 0.01
     * Offset: 0
     */
    uint16_t ins_pitch_std;

    /**
     * �����Ǳ�׼��	���峵��������б�ĽǶȱ�׼��
     *
     * Range: 0..6554 (0..65.54 degree)
     * Scale: 0.01
     * Offset: 0
     */
    uint16_t ins_roll_std;
};

/**
 * Signals in message INS_SOL_RESULT_ANGLE.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_ins_sol_result_angle_t {
    /**
     * �����ǣ��˶��켣���߷����������нǣ�	�����˶��켣���߷����ٶȷ�������������ļн�
     *
     * Range: 0..36000 (0..360 degree)
     * Scale: 0.01
     * Offset: 0
     */
    uint16_t ins_course_angle;

    /**
     * ���򣨳�ͷǰ�������������нǣ�	���峵ͷǰ����������������ļн�
     *
     * Range: 0..36000 (-180..180 degree)
     * Scale: 0.01
     * Offset: -180
     */
    uint16_t ins_yaw_angle;

    /**
     * ������	���峵ͷ������б�ĽǶ�
     *
     * Range: 0..18000 (-90..90 degree)
     * Scale: 0.01
     * Offset: -90
     */
    uint16_t ins_pitch;

    /**
     * ������	���峵��������б�ĽǶ�
     *
     * Range: 0..36000 (-180..180 degree)
     * Scale: 0.01
     * Offset: -180
     */
    uint16_t ins_roll;
};

/**
 * Signals in message INS_SOL_RESULT_ALTITUDE.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_ins_sol_result_altitude_t {
    /**
     * ����	�û���������ϵԭ���γ�ȣ�WGS84��
     *
     * Range: 0..2000000 (-10000..10000 m)
     * Scale: 0.01
     * Offset: -10000
     */
    uint32_t ins_altitude;

    /**
     * ���α�׼��	�û���������ϵԭ���γ�ȣ�WGS84��
     *
     * Range: 0..6554 (0..65.54 m)
     * Scale: 0.01
     * Offset: 0
     */
    uint16_t ins_altitude_std;

    /**
     * 10hz
     *
     * Range: 0..2000000 (-10000..10000 m)
     * Scale: 0.01
     * Offset: -10000
     */
    uint32_t ins_undulation;
};

/**
 * Signals in message INS_SOL_RESULT_LONGITUDE.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_ins_sol_result_longitude_t {
    /**
     * ����	�û���������ϵԭ���γ�ȣ�WGS84��
     *
     * Range: 0..3600000000 (-180..180 degree)
     * Scale: 1e-07
     * Offset: -180
     */
    uint32_t ins_longitude;

    /**
     * ���ȱ�׼��	�û���������ϵԭ���γ�ȣ�WGS84��
     *
     * Range: 0..6554 (0..65.54 m)
     * Scale: 0.01
     * Offset: 0
     */
    uint16_t ins_longitude_std;
};

/**
 * Signals in message INS_SOL_RESULT_LATITUDE.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_ins_sol_result_latitude_t {
    /**
     * γ��	�û���������ϵԭ���γ�ȣ�WGS84��
     *
     * Range: 0..1800000000 (-90..90 degree)
     * Scale: 1e-07
     * Offset: -90
     */
    uint32_t ins_latitude;

    /**
     * γ�ȱ�׼��	�û���������ϵԭ���γ�ȣ�WGS84��
     *
     * Range: 0..6554 (0..65.54 m)
     * Scale: 0.01
     * Offset: 0
     */
    uint16_t ins_latitude_std;
};

/**
 * Signals in message INS_SOL_RESULT_COMMON.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_ins_sol_result_common_t {
    /**
     * ʱ�����GPS��	��1980��1��6��0�������ھ���������
     *
     * Range: 0..65535 (0..65535 week)
     * Scale: 1
     * Offset: 0
     */
    uint16_t ins_gps_week;

    /**
     * ʱ�����GPS������	�Ը�����ʼʱ�䵽���ھ���������
     *
     * Range: 0..604800000 (0..604800000 ms)
     * Scale: 1
     * Offset: 0
     */
    uint32_t ins_gps_sow;
};

/**
 * Signals in message GNSS_SOL_RESULT_SPD.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_gnss_sol_result_spd_t {
    /**
     * ˮƽ�ٶ�
     *
     * Range: 0..20000 (-100..100 m/s)
     * Scale: 0.01
     * Offset: -100
     */
    uint16_t gnss_horizontal_spd;

    /**
     * ǰ���������汱�ļн�
     *
     * Range: 0..36000 (-180..180 degree)
     * Scale: 0.01
     * Offset: -180
     */
    uint16_t gnss_track_over_ground;

    /**
     * ��ֱ�ٶ�	������ֵ��ʾ�߶ȣ�����)���ӣ���ֵ��ʾ�߶�(�½�)����
     *
     * Range: 0..20000 (-100..100 m/s)
     * Scale: 0.01
     * Offset: -100
     */
    uint16_t gnss_vertical_spd;
};

/**
 * Signals in message GNSS_SOL_RESULT_ALTITUDE.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_gnss_sol_result_altitude_t {
    /**
     * ����	������λ�õĺ��θ߶ȣ�WGS84��
     *
     * Range: 0..2000000 (-10000..10000 m)
     * Scale: 0.01
     * Offset: -10000
     */
    uint32_t gnss_altitude;

    /**
     * ���α�׼��	������λ�õĺ��θ߶ȣ�WGS84��
     *
     * Range: 0..6554 (0..65.54 m)
     * Scale: 0.01
     * Offset: 0
     */
    uint16_t gnss_altitude_std;

    /**
     * �߳��쳣ֵ
     *
     * Range: 0..2000000 (-10000..10000 m)
     * Scale: 0.01
     * Offset: -10000
     */
    uint32_t gnss_undulation;
};

/**
 * Signals in message GNSS_SOL_RESULT_LONGITUDE.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_gnss_sol_result_longitude_t {
    /**
     * ����	������λ�õľ��ȣ�WGS84��
     *
     * Range: 0..3600000000 (-180..180 degree)
     * Scale: 1e-07
     * Offset: -180
     */
    uint32_t gnss_longitude;

    /**
     * ���ȱ�׼��	������λ�õľ��ȣ�WGS84��
     *
     * Range: 0..65535 (0..655.35 m)
     * Scale: 0.01
     * Offset: 0
     */
    uint16_t gnss_longitude_std;
};

/**
 * Signals in message GNSS_SOL_RESULT_LATITUDE.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_gnss_sol_result_latitude_t {
    /**
     * γ��	������λ�õ�γ�ȣ�WGS84��
     *
     * Range: 0..1800000000 (-90..90 degree)
     * Scale: 1e-07
     * Offset: -90
     */
    uint32_t gnss_latitude;

    /**
     * γ�ȱ�׼��	������λ�õ�γ�ȣ�WGS84��
     *
     * Range: 0..6554 (0..65.54 m)
     * Scale: 0.01
     * Offset: 0
     */
    uint16_t gnss_latitude_std;
};

/**
 * Signals in message GNSS_SOL_RESULT_STATUS.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_gnss_sol_result_status_t {
    /**
     * ��λ״̬    ͬBESTGNSSPOSЭ����PosType
     *
     * Range: 0..255 (0..255 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t gnss_postion_type;

    /**
     * GNSS����״̬    ͬBESTGNSSPOSЭ����SolType
     *
     * Range: 0..255 (0..255 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t gnss_solution_type;

    /**
     * ��������
     *
     * Range: 0..255 (0..255 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t heading_position_type;

    /**
     * ����״̬
     *
     * Range: 0..255 (0..255 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t heading_solution_type;

    /**
     * �ٶ�����	�붨λ״̬һ��
     *
     * Range: 0..255 (0..255 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t gnss_velocity_type;
};

/**
 * Signals in message GNSS_SOL_RESULT_COMMON.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_gnss_sol_result_common_t {
    /**
     * ʱ�����GPS��	��1980��1��6��0�������ھ���������
     *
     * Range: 0..65535 (0..65535 week)
     * Scale: 1
     * Offset: 0
     */
    uint16_t gnss_gps_week;

    /**
     * ʱ�����GPS������	�Ը�����ʼʱ�䵽���ھ���������
     *
     * Range: 0..604800000 (0..604800000 ms)
     * Scale: 1
     * Offset: 0
     */
    uint32_t gnss_gps_sow;
};

/**
 * Signals in message GNSS_SOL_RESULT_DOP.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_gnss_sol_result_dop_t {
    /**
     * ˮƽλ�þ�������	ˮƽλ�þ�������
     *
     * Range: 0..65400 (-327..327 -)
     * Scale: 0.01
     * Offset: -327
     */
    uint16_t gnss_hdop;

    /**
     * �ռ�λ�þ�������	�ռ�λ�þ�������
     *
     * Range: 0..65400 (-327..327 -)
     * Scale: 0.01
     * Offset: -327
     */
    uint16_t gnss_pdop;

    /**
     * �߳̾�������	�߳̾�������
     *
     * Range: 0..65400 (-327..327 -)
     * Scale: 0.01
     * Offset: -327
     */
    uint16_t gnss_vdop;
};

/**
 * Signals in message GNSS_SOL_RESULT_NUM.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_gnss_sol_result_num_t {
    /**
     * ������������	������������
     *
     * Range: 0..255 (0..255 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t gnss_num_sats;

    /**
     * �����߲������������	�����߲������������
     *
     * Range: 0..255 (0..255 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t gnss_num_sats_used;

    /**
     * �����߲���������ǵ�ƽ�������	�����߲���������ǵ�ƽ�������
     *
     * Range: 0..255 (0..255 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t gnss_used_snr_avg;

    /**
     * �������߿ɼ�������
     *
     * Range: 0..255 (0..255 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t heading_svs;

    /**
     * ���붨���������
     *
     * Range: 0..255 (0..255 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t heading_soln_svs;
};

/**
 * Signals in message IMU_BIAS_CORRECTED_COMMON.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_imu_bias_corrected_common_t {
    /**
     * ʱ�����GPS��	��1980��1��6��0�������ھ���������
     *
     * Range: 0..65535 (0..65535 week)
     * Scale: 1
     * Offset: 0
     */
    uint16_t imu_gps_week;

    /**
     * ʱ�����GPS������	�Ը�����ʼʱ�䵽���ھ���������
     *
     * Range: 0..604800000 (0..604800000 ms)
     * Scale: 1
     * Offset: 0
     */
    uint32_t imu_gps_sow;

    /**
     * �¶�	�¶ȣ����϶ȣ�
     *
     * Range: 0..30000 (-100..200 ��C)
     * Scale: 0.01
     * Offset: -100
     */
    uint16_t imu_temperatue;
};

/**
 * Signals in message IMU_BIAS_CORRECTED_ANGRATE.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_imu_bias_corrected_angrate_t {
    /**
     * ����X�ᣨ�����źţ�	IMU��������ϵ��������X������
     *
     * Range: 0..1047197.4 (-5.235987..5.235987 rad/s)
     * Scale: 1e-05
     * Offset: -5.235987
     */
    uint32_t imu_bias_corrected_ang_rate_x;

    /**
     * ����Y�ᣨ�����źţ�	IMU��������ϵ��������Y������
     *
     * Range: 0..1047197.4 (-5.235987..5.235987 rad/s)
     * Scale: 1e-05
     * Offset: -5.235987
     */
    uint32_t imu_bias_corrected_ang_rate_y;

    /**
     * ����Z�ᣨ�����źţ�	IMU��������ϵ��������Z������
     *
     * Range: 0..1047197.4 (-5.235987..5.235987 rad/s)
     * Scale: 1e-05
     * Offset: -5.235987
     */
    uint32_t imu_bias_corrected_ang_rate_z;
};

/**
 * Signals in message IMU_BIAS_CORRECTED_ACC.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_imu_bias_corrected_acc_t {
    /**
     * �Ӽ�X�ᣨ�����źţ�	IMU��������ϵ�¼��ٶȼ�X������
     *
     * Range: 0..1200000 (-60..60 m/s2)
     * Scale: 0.0001
     * Offset: -60
     */
    uint32_t imu_bias_corrected_acc_x;

    /**
     * �Ӽ�Y�ᣨ�����źţ�	IMU��������ϵ�¼��ٶȼ�Y������
     *
     * Range: 0..1200000 (-60..60 m/s2)
     * Scale: 0.0001
     * Offset: -60
     */
    uint32_t imu_bias_corrected_acc_y;

    /**
     * �Ӽ�Z�ᣨ�����źţ�	IMU��������ϵ�¼��ٶȼ�Z������
     *
     * Range: 0..1200000 (-60..60 m/s2)
     * Scale: 0.0001
     * Offset: -60
     */
    uint32_t imu_bias_corrected_acc_z;
};

/**
 * Signals in message IMU_ORIGIN_COMMON.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_imu_origin_common_t {
    /**
     * ʱ�����GPS��	��1980��1��6��0�������ھ���������
     *
     * Range: 0..65535 (0..65535 week)
     * Scale: 1
     * Offset: 0
     */
    uint16_t imu_ori_gps_week;

    /**
     * ʱ�����GPS������	�Ը�����ʼʱ�䵽���ھ���������
     *
     * Range: 0..604800000 (0..604800000 ms)
     * Scale: 1
     * Offset: 0
     */
    uint32_t imu_ori_gps_sow;

    /**
     * �¶�	�¶ȣ����϶ȣ�
     *
     * Range: 0..30000 (-100..200 ��C)
     * Scale: 0.01
     * Offset: -100
     */
    uint16_t imu_temperatue;
};

/**
 * Signals in message IMU_ORIGIN_ACC.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_imu_origin_acc_t {
    /**
     * �Ӽ�X�ᣨԭʼ�źţ�	IMU��������ϵ�¼��ٶȼ�X������
     *
     * Range: 0..1200000 (-60..60 m/s2)
     * Scale: 0.0001
     * Offset: -60
     */
    uint32_t imu_ori_acc_x;

    /**
     * �Ӽ�Y�ᣨԭʼ�źţ�	IMU��������ϵ�¼��ٶȼ�Y������
     *
     * Range: 0..1200000 (-60..60 m/s2)
     * Scale: 0.0001
     * Offset: -60
     */
    uint32_t imu_ori_acc_y;

    /**
     * �Ӽ�Z�ᣨԭʼ�źţ�	IMU��������ϵ�¼��ٶȼ�Z������
     *
     * Range: 0..1200000 (-60..60 m/s2)
     * Scale: 0.0001
     * Offset: -60
     */
    uint32_t imu_ori_acc_z;
};

/**
 * Signals in message IMU_ORIGIN_GYRO.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_imu_origin_gyro_t {
    /**
     * ����X�ᣨԭʼ�źţ�	IMU��������ϵ��������X������
     *
     * Range: 0..1047196 (-5.23598..5.23598 rad/s)
     * Scale: 1e-05
     * Offset: -5.23598
     */
    uint32_t imu_ori_gyro_x;

    /**
     * ����Y�ᣨԭʼ�źţ�	IMU��������ϵ��������Y������
     *
     * Range: 0..1047196 (-5.23598..5.23598 rad/s)
     * Scale: 1e-05
     * Offset: -5.23598
     */
    uint32_t imu_ori_gyro_y;

    /**
     * ����Z�ᣨԭʼ�źţ�	IMU��������ϵ��������Z������
     *
     * Range: 0..1047196 (-5.23598..5.23598 rad/s)
     * Scale: 1e-05
     * Offset: -5.23598
     */
    uint32_t imu_ori_gyro_z;
};



/**
 * Signals in message Control_Request1.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_control_request1_t {
    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ipc_target_motor_en;

    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ipc_target_gear;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ipc_target_mode;

    /**
     * Range: 0..15 (0..15 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ipc_life_signal;

    /**
     * Range: 0..127 (0..12.7 -)
     * Scale: 0.1
     * Offset: 0
     */
    uint8_t ipc_target_speed;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ipc_target_spd_valid;

    /**
     * Range: 0..160 (0..8 -)
     * Scale: 0.05
     * Offset: 0
     */
    uint8_t ipc_target_brk_press;

    /**
     * Range: 0..14000 (-700..700 -)
     * Scale: 0.1
     * Offset: -700
     */
    uint16_t ipc_target_angle;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ipc_target_steering_en;

    /**
     * Range: 0..255 (0..25.5 -)
     * Scale: 0.1
     * Offset: 0
     */
    uint8_t ipc_target_torque;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ipc_torque_rpm_mode;

    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ipc_turn_light;

    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ipc_target_spd_mode;
};

/**
 * Signals in message VCU_Info_1.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_vcu_info_1_t {
    /**
     * Range: 0..14000 (-700..700 -)
     * Scale: 0.1
     * Offset: -700
     */
    uint16_t current_angle;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ses_en_sts;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t motor_en_sts;

    /**
     * Range: 0..127 (0..12.7 -)
     * Scale: 0.1
     * Offset: 0
     */
    uint8_t current_speed;

    /**
     * Range: 0..255 (0..25.5 -)
     * Scale: 0.1
     * Offset: 0
     */
    uint8_t motor_torque;

    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t vcu_mode;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t controller_online_sts;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t ipc_online_status;

    /**
     * Range: 0..15 (0..15 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t vcu_life_signal;

    /**
     * Range: 0..160 (0..8 -)
     * Scale: 0.05
     * Offset: 0
     */
    uint8_t current_brk_press;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t rseb_mode;

    /**
     * Range: 0..2 (0..2 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t battery_number;

    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t current_gear;

    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t battery_warning;

    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t current_spd_mode;
};

/**
 * Signals in message VCU_Info_2.
 *
 * All signal values are as on the CAN bus.
 */
struct by_nav_x2_can_v0_1_vcu_info_2_t {
    /**
     * Range: 0..250 (0..100 -)
     * Scale: 0.4
     * Offset: 0
     */
    uint8_t soc1;

    /**
     * Range: 0..250 (0..100 -)
     * Scale: 0.4
     * Offset: 0
     */
    uint8_t soc2;

    /**
     * Range: 0..1 (0..1 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t collision_status;

    /**
     * Range: 0..3 (0..3 -)
     * Scale: 1
     * Offset: 0
     */
    uint8_t motor_direction;
};

int ultrasonic_radar_message_hs_can_100_pack();

int ultrasonic_radar_message_hs_can_100_unpack(
    struct ultrasonic_radar_message_hs_can_100_t *dst_p,
    const uint8_t *src_p,
    size_t size);

uint8_t ultrasonic_radar_message_hs_can_100_pas_mode_decode(uint8_t value);

uint8_t ultrasonic_radar_message_hs_can_100_pas_warn_tone_decode(uint8_t value);

uint8_t ultrasonic_radar_message_hs_can_100_pas_rl_distance_decode(uint8_t value);

uint8_t ultrasonic_radar_message_hs_can_100_pas_rl_mid_distance_decode(uint8_t value);

uint8_t ultrasonic_radar_message_hs_can_100_pas_rr_mid_distance_decode(uint8_t value);

uint8_t ultrasonic_radar_message_hs_can_100_pas_rr_distance_decode(uint8_t value);

int ultrasonic_radar_message_hs_can_101_unpack(
    struct ultrasonic_radar_message_hs_can_101_t *dst_p,
    const uint8_t *src_p,
    size_t size);

uint8_t ultrasonic_radar_message_hs_can_101_pas_fl_distance_decode(uint8_t value);

uint8_t ultrasonic_radar_message_hs_can_101_pas_fl_mid_distance_decode(uint8_t value);

uint8_t ultrasonic_radar_message_hs_can_101_pas_fr_mid_distance_decode(uint8_t value);

uint8_t ultrasonic_radar_message_hs_can_101_pas_fr_distance_decode(uint8_t value);

uint8_t ultrasonic_radar_message_hs_can_101_pas_rl_sns_err_flag_decode(uint8_t value);

uint8_t ultrasonic_radar_message_hs_can_101_pas_rl_mid_sns_err_flag_decode(uint8_t value);

uint8_t ultrasonic_radar_message_hs_can_101_pas_rr_mid_sns_err_flag_decode(uint8_t value);

uint8_t ultrasonic_radar_message_hs_can_101_pas_rr_sns_err_flag_decode(uint8_t value);

uint8_t ultrasonic_radar_message_hs_can_101_pas_fl_sns_err_flag_decode(uint8_t value);

uint8_t ultrasonic_radar_message_hs_can_101_pas_fl_mid_sns_err_flag_decode(uint8_t value);

uint8_t ultrasonic_radar_message_hs_can_101_pas_fr_mid_sns_err_flag_decode(uint8_t value);

uint8_t ultrasonic_radar_message_hs_can_101_pas_fr_sns_err_flag_decode(uint8_t value);

/**
 * Pack message DEVSTATUS.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_devstatus_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_devstatus_t *src_p,
    size_t size);

/**
 * Unpack message DEVSTATUS.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_devstatus_unpack(
    struct by_nav_x2_can_v0_1_devstatus_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_devstatus_devstatus_ap_temperatue_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_devstatus_devstatus_ap_temperatue_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_devstatus_devstatus_ap_temperatue_is_in_range(uint16_t value);

/**
 * Pack message HEADING_ANGLE.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_heading_angle_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_heading_angle_t *src_p,
    size_t size);

/**
 * Unpack message HEADING_ANGLE.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_heading_angle_unpack(
    struct by_nav_x2_can_v0_1_heading_angle_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_heading_angle_heading_heading_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_heading_angle_heading_heading_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_heading_angle_heading_heading_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_heading_angle_heading_pitch_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_heading_angle_heading_pitch_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_heading_angle_heading_pitch_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_heading_angle_heading_heading_std_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_heading_angle_heading_heading_std_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_heading_angle_heading_heading_std_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_heading_angle_heading_pitch_std_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_heading_angle_heading_pitch_std_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_heading_angle_heading_pitch_std_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_heading_angle_heading_length_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_heading_angle_heading_length_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_heading_angle_heading_length_is_in_range(uint16_t value);

/**
 * Pack message GNSS_SOL_RESULT_LATENCY.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_gnss_sol_result_latency_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_gnss_sol_result_latency_t *src_p,
    size_t size);

/**
 * Unpack message GNSS_SOL_RESULT_LATENCY.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_gnss_sol_result_latency_unpack(
    struct by_nav_x2_can_v0_1_gnss_sol_result_latency_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_gnss_sol_result_latency_gnss_measure_latency_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_latency_gnss_measure_latency_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_latency_gnss_measure_latency_is_in_range(uint32_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_gnss_sol_result_latency_gnss_diff_age_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_latency_gnss_diff_age_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_latency_gnss_diff_age_is_in_range(uint32_t value);

/**
 * Pack message INS_SOL_RESULT_STATUS.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_ins_sol_result_status_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_ins_sol_result_status_t *src_p,
    size_t size);

/**
 * Unpack message INS_SOL_RESULT_STATUS.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_ins_sol_result_status_unpack(
    struct by_nav_x2_can_v0_1_ins_sol_result_status_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_ins_sol_result_status_ins_ins_status_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_status_ins_ins_status_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_status_ins_ins_status_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_ins_sol_result_status_ins_pos_type_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_status_ins_pos_type_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_status_ins_pos_type_is_in_range(uint8_t value);

/**
 * Pack message INS_SOL_RESULT_VEL_STD.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_ins_sol_result_vel_std_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_ins_sol_result_vel_std_t *src_p,
    size_t size);

/**
 * Unpack message INS_SOL_RESULT_VEL_STD.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_ins_sol_result_vel_std_unpack(
    struct by_nav_x2_can_v0_1_ins_sol_result_vel_std_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_std_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_std_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_std_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_e_std_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_e_std_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_e_std_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_n_std_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_n_std_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_n_std_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_u_std_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_u_std_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_vel_std_ins_velocity_u_std_is_in_range(uint16_t value);

/**
 * Pack message INS_SOL_RESULT_VEL.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_ins_sol_result_vel_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_ins_sol_result_vel_t *src_p,
    size_t size);

/**
 * Unpack message INS_SOL_RESULT_VEL.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_ins_sol_result_vel_unpack(
    struct by_nav_x2_can_v0_1_ins_sol_result_vel_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_e_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_e_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_e_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_n_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_n_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_n_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_u_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_u_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_vel_ins_velocity_u_is_in_range(uint16_t value);

/**
 * Pack message INS_SOL_RESULT_ANGLE_STD.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_ins_sol_result_angle_std_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_ins_sol_result_angle_std_t *src_p,
    size_t size);

/**
 * Unpack message INS_SOL_RESULT_ANGLE_STD.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_ins_sol_result_angle_std_unpack(
    struct by_nav_x2_can_v0_1_ins_sol_result_angle_std_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_course_angle_std_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_course_angle_std_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_course_angle_std_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_yaw_angle_std_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_yaw_angle_std_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_yaw_angle_std_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_pitch_std_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_pitch_std_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_pitch_std_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_roll_std_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_roll_std_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_angle_std_ins_roll_std_is_in_range(uint16_t value);

/**
 * Pack message INS_SOL_RESULT_ANGLE.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_ins_sol_result_angle_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_ins_sol_result_angle_t *src_p,
    size_t size);

/**
 * Unpack message INS_SOL_RESULT_ANGLE.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_ins_sol_result_angle_unpack(
    struct by_nav_x2_can_v0_1_ins_sol_result_angle_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_ins_sol_result_angle_ins_course_angle_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_angle_ins_course_angle_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_angle_ins_course_angle_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_ins_sol_result_angle_ins_yaw_angle_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_angle_ins_yaw_angle_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_angle_ins_yaw_angle_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_ins_sol_result_angle_ins_pitch_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_angle_ins_pitch_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_angle_ins_pitch_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_ins_sol_result_angle_ins_roll_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_angle_ins_roll_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_angle_ins_roll_is_in_range(uint16_t value);

/**
 * Pack message INS_SOL_RESULT_ALTITUDE.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_ins_sol_result_altitude_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_ins_sol_result_altitude_t *src_p,
    size_t size);

/**
 * Unpack message INS_SOL_RESULT_ALTITUDE.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_ins_sol_result_altitude_unpack(
    struct by_nav_x2_can_v0_1_ins_sol_result_altitude_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_ins_sol_result_altitude_ins_altitude_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_altitude_ins_altitude_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_altitude_ins_altitude_is_in_range(uint32_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_ins_sol_result_altitude_ins_altitude_std_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_altitude_ins_altitude_std_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_altitude_ins_altitude_std_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_ins_sol_result_altitude_ins_undulation_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_altitude_ins_undulation_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_altitude_ins_undulation_is_in_range(uint32_t value);

/**
 * Pack message INS_SOL_RESULT_LONGITUDE.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_ins_sol_result_longitude_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_ins_sol_result_longitude_t *src_p,
    size_t size);

/**
 * Unpack message INS_SOL_RESULT_LONGITUDE.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_ins_sol_result_longitude_unpack(
    struct by_nav_x2_can_v0_1_ins_sol_result_longitude_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_ins_sol_result_longitude_ins_longitude_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_longitude_ins_longitude_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_longitude_ins_longitude_is_in_range(uint32_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_ins_sol_result_longitude_ins_longitude_std_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_longitude_ins_longitude_std_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_longitude_ins_longitude_std_is_in_range(uint16_t value);

/**
 * Pack message INS_SOL_RESULT_LATITUDE.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_ins_sol_result_latitude_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_ins_sol_result_latitude_t *src_p,
    size_t size);

/**
 * Unpack message INS_SOL_RESULT_LATITUDE.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_ins_sol_result_latitude_unpack(
    struct by_nav_x2_can_v0_1_ins_sol_result_latitude_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_ins_sol_result_latitude_ins_latitude_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_latitude_ins_latitude_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_latitude_ins_latitude_is_in_range(uint32_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_ins_sol_result_latitude_ins_latitude_std_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_latitude_ins_latitude_std_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_latitude_ins_latitude_std_is_in_range(uint16_t value);

/**
 * Pack message INS_SOL_RESULT_COMMON.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_ins_sol_result_common_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_ins_sol_result_common_t *src_p,
    size_t size);

/**
 * Unpack message INS_SOL_RESULT_COMMON.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_ins_sol_result_common_unpack(
    struct by_nav_x2_can_v0_1_ins_sol_result_common_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_ins_sol_result_common_ins_gps_week_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_common_ins_gps_week_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_common_ins_gps_week_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_ins_sol_result_common_ins_gps_sow_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_ins_sol_result_common_ins_gps_sow_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_ins_sol_result_common_ins_gps_sow_is_in_range(uint32_t value);

/**
 * Pack message GNSS_SOL_RESULT_SPD.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_gnss_sol_result_spd_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_gnss_sol_result_spd_t *src_p,
    size_t size);

/**
 * Unpack message GNSS_SOL_RESULT_SPD.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_gnss_sol_result_spd_unpack(
    struct by_nav_x2_can_v0_1_gnss_sol_result_spd_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_gnss_sol_result_spd_gnss_horizontal_spd_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_spd_gnss_horizontal_spd_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_spd_gnss_horizontal_spd_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_gnss_sol_result_spd_gnss_track_over_ground_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_spd_gnss_track_over_ground_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_spd_gnss_track_over_ground_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_gnss_sol_result_spd_gnss_vertical_spd_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_spd_gnss_vertical_spd_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_spd_gnss_vertical_spd_is_in_range(uint16_t value);

/**
 * Pack message GNSS_SOL_RESULT_ALTITUDE.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_gnss_sol_result_altitude_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_gnss_sol_result_altitude_t *src_p,
    size_t size);

/**
 * Unpack message GNSS_SOL_RESULT_ALTITUDE.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_gnss_sol_result_altitude_unpack(
    struct by_nav_x2_can_v0_1_gnss_sol_result_altitude_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_gnss_sol_result_altitude_gnss_altitude_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_altitude_gnss_altitude_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_altitude_gnss_altitude_is_in_range(uint32_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_gnss_sol_result_altitude_gnss_altitude_std_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_altitude_gnss_altitude_std_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_altitude_gnss_altitude_std_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_gnss_sol_result_altitude_gnss_undulation_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_altitude_gnss_undulation_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_altitude_gnss_undulation_is_in_range(uint32_t value);

/**
 * Pack message GNSS_SOL_RESULT_LONGITUDE.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_gnss_sol_result_longitude_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_gnss_sol_result_longitude_t *src_p,
    size_t size);

/**
 * Unpack message GNSS_SOL_RESULT_LONGITUDE.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_gnss_sol_result_longitude_unpack(
    struct by_nav_x2_can_v0_1_gnss_sol_result_longitude_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_gnss_sol_result_longitude_gnss_longitude_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_longitude_gnss_longitude_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_longitude_gnss_longitude_is_in_range(uint32_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_gnss_sol_result_longitude_gnss_longitude_std_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_longitude_gnss_longitude_std_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_longitude_gnss_longitude_std_is_in_range(uint16_t value);

/**
 * Pack message GNSS_SOL_RESULT_LATITUDE.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_gnss_sol_result_latitude_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_gnss_sol_result_latitude_t *src_p,
    size_t size);

/**
 * Unpack message GNSS_SOL_RESULT_LATITUDE.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_gnss_sol_result_latitude_unpack(
    struct by_nav_x2_can_v0_1_gnss_sol_result_latitude_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_gnss_sol_result_latitude_gnss_latitude_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_latitude_gnss_latitude_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_latitude_gnss_latitude_is_in_range(uint32_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_gnss_sol_result_latitude_gnss_latitude_std_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_latitude_gnss_latitude_std_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_latitude_gnss_latitude_std_is_in_range(uint16_t value);

/**
 * Pack message GNSS_SOL_RESULT_STATUS.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_gnss_sol_result_status_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_gnss_sol_result_status_t *src_p,
    size_t size);

/**
 * Unpack message GNSS_SOL_RESULT_STATUS.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_gnss_sol_result_status_unpack(
    struct by_nav_x2_can_v0_1_gnss_sol_result_status_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_gnss_sol_result_status_gnss_postion_type_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_status_gnss_postion_type_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_status_gnss_postion_type_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_gnss_sol_result_status_gnss_solution_type_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_status_gnss_solution_type_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_status_gnss_solution_type_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_gnss_sol_result_status_heading_position_type_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_status_heading_position_type_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_status_heading_position_type_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_gnss_sol_result_status_heading_solution_type_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_status_heading_solution_type_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_status_heading_solution_type_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_gnss_sol_result_status_gnss_velocity_type_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_status_gnss_velocity_type_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_status_gnss_velocity_type_is_in_range(uint8_t value);

/**
 * Pack message GNSS_SOL_RESULT_COMMON.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_gnss_sol_result_common_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_gnss_sol_result_common_t *src_p,
    size_t size);

/**
 * Unpack message GNSS_SOL_RESULT_COMMON.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_gnss_sol_result_common_unpack(
    struct by_nav_x2_can_v0_1_gnss_sol_result_common_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_gnss_sol_result_common_gnss_gps_week_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_common_gnss_gps_week_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_common_gnss_gps_week_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_gnss_sol_result_common_gnss_gps_sow_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_common_gnss_gps_sow_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_common_gnss_gps_sow_is_in_range(uint32_t value);

/**
 * Pack message GNSS_SOL_RESULT_DOP.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_gnss_sol_result_dop_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_gnss_sol_result_dop_t *src_p,
    size_t size);

/**
 * Unpack message GNSS_SOL_RESULT_DOP.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_gnss_sol_result_dop_unpack(
    struct by_nav_x2_can_v0_1_gnss_sol_result_dop_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_gnss_sol_result_dop_gnss_hdop_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_dop_gnss_hdop_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_dop_gnss_hdop_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_gnss_sol_result_dop_gnss_pdop_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_dop_gnss_pdop_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_dop_gnss_pdop_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_gnss_sol_result_dop_gnss_vdop_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_dop_gnss_vdop_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_dop_gnss_vdop_is_in_range(uint16_t value);

/**
 * Pack message GNSS_SOL_RESULT_NUM.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_gnss_sol_result_num_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_gnss_sol_result_num_t *src_p,
    size_t size);

/**
 * Unpack message GNSS_SOL_RESULT_NUM.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_gnss_sol_result_num_unpack(
    struct by_nav_x2_can_v0_1_gnss_sol_result_num_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_gnss_sol_result_num_gnss_num_sats_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_num_gnss_num_sats_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_num_gnss_num_sats_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_gnss_sol_result_num_gnss_num_sats_used_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_num_gnss_num_sats_used_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_num_gnss_num_sats_used_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_gnss_sol_result_num_gnss_used_snr_avg_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_num_gnss_used_snr_avg_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_num_gnss_used_snr_avg_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_gnss_sol_result_num_heading_svs_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_num_heading_svs_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_num_heading_svs_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_gnss_sol_result_num_heading_soln_svs_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_gnss_sol_result_num_heading_soln_svs_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_gnss_sol_result_num_heading_soln_svs_is_in_range(uint8_t value);

/**
 * Pack message IMU_BIAS_CORRECTED_COMMON.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_imu_bias_corrected_common_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_imu_bias_corrected_common_t *src_p,
    size_t size);

/**
 * Unpack message IMU_BIAS_CORRECTED_COMMON.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_imu_bias_corrected_common_unpack(
    struct by_nav_x2_can_v0_1_imu_bias_corrected_common_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_imu_bias_corrected_common_imu_gps_week_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_imu_bias_corrected_common_imu_gps_week_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_imu_bias_corrected_common_imu_gps_week_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_imu_bias_corrected_common_imu_gps_sow_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_imu_bias_corrected_common_imu_gps_sow_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_imu_bias_corrected_common_imu_gps_sow_is_in_range(uint32_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_imu_bias_corrected_common_imu_temperatue_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_imu_bias_corrected_common_imu_temperatue_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_imu_bias_corrected_common_imu_temperatue_is_in_range(uint16_t value);

/**
 * Pack message IMU_BIAS_CORRECTED_ANGRATE.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_imu_bias_corrected_angrate_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_imu_bias_corrected_angrate_t *src_p,
    size_t size);

/**
 * Unpack message IMU_BIAS_CORRECTED_ANGRATE.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_imu_bias_corrected_angrate_unpack(
    struct by_nav_x2_can_v0_1_imu_bias_corrected_angrate_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_imu_bias_corrected_angrate_imu_bias_corrected_ang_rate_x_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_imu_bias_corrected_angrate_imu_bias_corrected_ang_rate_x_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_imu_bias_corrected_angrate_imu_bias_corrected_ang_rate_x_is_in_range(uint32_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_imu_bias_corrected_angrate_imu_bias_corrected_ang_rate_y_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_imu_bias_corrected_angrate_imu_bias_corrected_ang_rate_y_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_imu_bias_corrected_angrate_imu_bias_corrected_ang_rate_y_is_in_range(uint32_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_imu_bias_corrected_angrate_imu_bias_corrected_ang_rate_z_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_imu_bias_corrected_angrate_imu_bias_corrected_ang_rate_z_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_imu_bias_corrected_angrate_imu_bias_corrected_ang_rate_z_is_in_range(uint32_t value);

/**
 * Pack message IMU_BIAS_CORRECTED_ACC.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_imu_bias_corrected_acc_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_imu_bias_corrected_acc_t *src_p,
    size_t size);

/**
 * Unpack message IMU_BIAS_CORRECTED_ACC.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_imu_bias_corrected_acc_unpack(
    struct by_nav_x2_can_v0_1_imu_bias_corrected_acc_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_imu_bias_corrected_acc_imu_bias_corrected_acc_x_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_imu_bias_corrected_acc_imu_bias_corrected_acc_x_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_imu_bias_corrected_acc_imu_bias_corrected_acc_x_is_in_range(uint32_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_imu_bias_corrected_acc_imu_bias_corrected_acc_y_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_imu_bias_corrected_acc_imu_bias_corrected_acc_y_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_imu_bias_corrected_acc_imu_bias_corrected_acc_y_is_in_range(uint32_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_imu_bias_corrected_acc_imu_bias_corrected_acc_z_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_imu_bias_corrected_acc_imu_bias_corrected_acc_z_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_imu_bias_corrected_acc_imu_bias_corrected_acc_z_is_in_range(uint32_t value);

/**
 * Pack message IMU_ORIGIN_COMMON.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_imu_origin_common_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_imu_origin_common_t *src_p,
    size_t size);

/**
 * Unpack message IMU_ORIGIN_COMMON.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_imu_origin_common_unpack(
    struct by_nav_x2_can_v0_1_imu_origin_common_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_imu_origin_common_imu_ori_gps_week_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_imu_origin_common_imu_ori_gps_week_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_imu_origin_common_imu_ori_gps_week_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_imu_origin_common_imu_ori_gps_sow_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_imu_origin_common_imu_ori_gps_sow_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_imu_origin_common_imu_ori_gps_sow_is_in_range(uint32_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_imu_origin_common_imu_temperatue_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_imu_origin_common_imu_temperatue_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_imu_origin_common_imu_temperatue_is_in_range(uint16_t value);

/**
 * Pack message IMU_ORIGIN_ACC.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_imu_origin_acc_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_imu_origin_acc_t *src_p,
    size_t size);

/**
 * Unpack message IMU_ORIGIN_ACC.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_imu_origin_acc_unpack(
    struct by_nav_x2_can_v0_1_imu_origin_acc_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_imu_origin_acc_imu_ori_acc_x_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_imu_origin_acc_imu_ori_acc_x_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_imu_origin_acc_imu_ori_acc_x_is_in_range(uint32_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_imu_origin_acc_imu_ori_acc_y_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_imu_origin_acc_imu_ori_acc_y_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_imu_origin_acc_imu_ori_acc_y_is_in_range(uint32_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_imu_origin_acc_imu_ori_acc_z_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_imu_origin_acc_imu_ori_acc_z_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_imu_origin_acc_imu_ori_acc_z_is_in_range(uint32_t value);

/**
 * Pack message IMU_ORIGIN_GYRO.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_imu_origin_gyro_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_imu_origin_gyro_t *src_p,
    size_t size);

/**
 * Unpack message IMU_ORIGIN_GYRO.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_imu_origin_gyro_unpack(
    struct by_nav_x2_can_v0_1_imu_origin_gyro_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_imu_origin_gyro_imu_ori_gyro_x_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_imu_origin_gyro_imu_ori_gyro_x_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_imu_origin_gyro_imu_ori_gyro_x_is_in_range(uint32_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_imu_origin_gyro_imu_ori_gyro_y_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_imu_origin_gyro_imu_ori_gyro_y_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_imu_origin_gyro_imu_ori_gyro_y_is_in_range(uint32_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint32_t by_nav_x2_can_v0_1_imu_origin_gyro_imu_ori_gyro_z_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_imu_origin_gyro_imu_ori_gyro_z_decode(uint32_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_imu_origin_gyro_imu_ori_gyro_z_is_in_range(uint32_t value);



/**
 * Pack message Control_Request1.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_control_request1_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_control_request1_t *src_p,
    size_t size);

/**
 * Unpack message Control_Request1.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_control_request1_unpack(
    struct by_nav_x2_can_v0_1_control_request1_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Init message fields to default values from Control_Request1.
 *
 * @param[in] msg_p Message to init.
 *
 * @return zero(0) on success or (-1) in case of nullptr argument.
 */
int by_nav_x2_can_v0_1_control_request1_init(struct by_nav_x2_can_v0_1_control_request1_t *msg_p);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_control_request1_ipc_target_motor_en_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_control_request1_ipc_target_motor_en_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_control_request1_ipc_target_motor_en_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_control_request1_ipc_target_gear_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_control_request1_ipc_target_gear_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_control_request1_ipc_target_gear_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_control_request1_ipc_target_mode_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_control_request1_ipc_target_mode_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_control_request1_ipc_target_mode_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_control_request1_ipc_life_signal_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_control_request1_ipc_life_signal_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_control_request1_ipc_life_signal_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_control_request1_ipc_target_speed_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_control_request1_ipc_target_speed_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_control_request1_ipc_target_speed_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_control_request1_ipc_target_spd_valid_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_control_request1_ipc_target_spd_valid_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_control_request1_ipc_target_spd_valid_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_control_request1_ipc_target_brk_press_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_control_request1_ipc_target_brk_press_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_control_request1_ipc_target_brk_press_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_control_request1_ipc_target_angle_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_control_request1_ipc_target_angle_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_control_request1_ipc_target_angle_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_control_request1_ipc_target_steering_en_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_control_request1_ipc_target_steering_en_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_control_request1_ipc_target_steering_en_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_control_request1_ipc_target_torque_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_control_request1_ipc_target_torque_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_control_request1_ipc_target_torque_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_control_request1_ipc_torque_rpm_mode_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_control_request1_ipc_torque_rpm_mode_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_control_request1_ipc_torque_rpm_mode_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_control_request1_ipc_turn_light_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_control_request1_ipc_turn_light_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_control_request1_ipc_turn_light_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_control_request1_ipc_target_spd_mode_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_control_request1_ipc_target_spd_mode_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_control_request1_ipc_target_spd_mode_is_in_range(uint8_t value);

/**
 * Pack message VCU_Info_1.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_vcu_info_1_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_vcu_info_1_t *src_p,
    size_t size);

/**
 * Unpack message VCU_Info_1.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_vcu_info_1_unpack(
    struct by_nav_x2_can_v0_1_vcu_info_1_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Init message fields to default values from VCU_Info_1.
 *
 * @param[in] msg_p Message to init.
 *
 * @return zero(0) on success or (-1) in case of nullptr argument.
 */
int by_nav_x2_can_v0_1_vcu_info_1_init(struct by_nav_x2_can_v0_1_vcu_info_1_t *msg_p);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint16_t by_nav_x2_can_v0_1_vcu_info_1_current_angle_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_vcu_info_1_current_angle_decode(uint16_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_vcu_info_1_current_angle_is_in_range(uint16_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_vcu_info_1_ses_en_sts_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_vcu_info_1_ses_en_sts_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_vcu_info_1_ses_en_sts_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_vcu_info_1_motor_en_sts_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_vcu_info_1_motor_en_sts_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_vcu_info_1_motor_en_sts_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_vcu_info_1_current_speed_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_vcu_info_1_current_speed_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_vcu_info_1_current_speed_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_vcu_info_1_motor_torque_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_vcu_info_1_motor_torque_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_vcu_info_1_motor_torque_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_vcu_info_1_vcu_mode_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_vcu_info_1_vcu_mode_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_vcu_info_1_vcu_mode_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_vcu_info_1_controller_online_sts_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_vcu_info_1_controller_online_sts_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_vcu_info_1_controller_online_sts_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_vcu_info_1_ipc_online_status_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_vcu_info_1_ipc_online_status_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_vcu_info_1_ipc_online_status_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_vcu_info_1_vcu_life_signal_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_vcu_info_1_vcu_life_signal_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_vcu_info_1_vcu_life_signal_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_vcu_info_1_current_brk_press_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_vcu_info_1_current_brk_press_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_vcu_info_1_current_brk_press_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_vcu_info_1_rseb_mode_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_vcu_info_1_rseb_mode_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_vcu_info_1_rseb_mode_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_vcu_info_1_battery_number_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_vcu_info_1_battery_number_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_vcu_info_1_battery_number_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_vcu_info_1_current_gear_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_vcu_info_1_current_gear_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_vcu_info_1_current_gear_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_vcu_info_1_battery_warning_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_vcu_info_1_battery_warning_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_vcu_info_1_battery_warning_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_vcu_info_1_current_spd_mode_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_vcu_info_1_current_spd_mode_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_vcu_info_1_current_spd_mode_is_in_range(uint8_t value);

/**
 * Pack message VCU_Info_2.
 *
 * @param[out] dst_p Buffer to pack the message into.
 * @param[in] src_p Data to pack.
 * @param[in] size Size of dst_p.
 *
 * @return Size of packed data, or negative error code.
 */
int by_nav_x2_can_v0_1_vcu_info_2_pack(
    uint8_t *dst_p,
    const struct by_nav_x2_can_v0_1_vcu_info_2_t *src_p,
    size_t size);

/**
 * Unpack message VCU_Info_2.
 *
 * @param[out] dst_p Object to unpack the message into.
 * @param[in] src_p Message to unpack.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int by_nav_x2_can_v0_1_vcu_info_2_unpack(
    struct by_nav_x2_can_v0_1_vcu_info_2_t *dst_p,
    const uint8_t *src_p,
    size_t size);

/**
 * Init message fields to default values from VCU_Info_2.
 *
 * @param[in] msg_p Message to init.
 *
 * @return zero(0) on success or (-1) in case of nullptr argument.
 */
int by_nav_x2_can_v0_1_vcu_info_2_init(struct by_nav_x2_can_v0_1_vcu_info_2_t *msg_p);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_vcu_info_2_soc1_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_vcu_info_2_soc1_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_vcu_info_2_soc1_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_vcu_info_2_soc2_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_vcu_info_2_soc2_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_vcu_info_2_soc2_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_vcu_info_2_collision_status_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_vcu_info_2_collision_status_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_vcu_info_2_collision_status_is_in_range(uint8_t value);

/**
 * Encode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to encode.
 *
 * @return Encoded signal.
 */
uint8_t by_nav_x2_can_v0_1_vcu_info_2_motor_direction_encode(double value);

/**
 * Decode given signal by applying scaling and offset.
 *
 * @param[in] value Signal to decode.
 *
 * @return Decoded signal.
 */
double by_nav_x2_can_v0_1_vcu_info_2_motor_direction_decode(uint8_t value);

/**
 * Check that given signal is in allowed range.
 *
 * @param[in] value Signal to check.
 *
 * @return true if in range, false otherwise.
 */
bool by_nav_x2_can_v0_1_vcu_info_2_motor_direction_is_in_range(uint8_t value);


//#ifdef __cplusplus
//}
//#endif

#endif
