#ifndef CAN_GENERAL_WRAPPER_HEADER_H
#define CAN_GENERAL_WRAPPER_HEADER_H


#include "ara/log/logging.h"
#include "can_msg_node/executable.h"
#include "sub/SubWrapperHelper.h"
#include "pub/PubWrapperHelper.h"
#include "ara/exec/execution_client.h"
#include "CAN_PubDataWrapper.h"
#include "CAN_SubDataWrapper.h" 

using namespace jac::ap::canservice::skeleton;
using namespace jac::ap::trpclatservice::proxy;
using namespace jac::ap::trpclongservice::proxy;


GENERATE_PUB_WRAPPER(CAN2SWC_Provide, CAN2SWC_PubDataWrapper, CANServiceSkeleton, CAN2SWC, CAN2SWCEvent);
GENERATE_SUB_WRAPPER(Lat2CAN_Required, Lat2CAN_SubDataWrapper, TRPCLatServiceProxy, SWC2CAN, TRPCLat2CANEvent, "13", 10);
GENERATE_SUB_WRAPPER(Long2CAN_Required, Long2CAN_SubDataWrapper, TRPCLongServiceProxy, SWC2CAN, TRPCLong2CANEvent, "14", 10);

class GeneralWrapper{
public:
    CAN2SWC_Provide _CAN2SWC_Provide;
    Lat2CAN_Required _Lat2CAN_Required;
    Long2CAN_Required _Long2CAN_Required;
    GeneralWrapper(ara::log::Logger& mainLog);
    ~GeneralWrapper();
};


#endif //CAN_GENERAL_WRAPPER_HEADER_H
