#ifndef CAN_PUB_DATA_WRAPPERS_H
#define CAN_PUB_DATA_WRAPPERS_H

#include "pub/PubDataWrapper.h"
#include "impl_type_signalstoswcs_type.h"
#include "../phy_signals.h"
#include "../Messages.h"
#include <cstring>
#include "stdlib.h"

template <typename EventType>
class DataWrapper : public PubDataWrapper<EventType>
{
    SignalsToSWCs_Type _data;

public:
    void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
    {
    }
    void setAllData(ALL_MESSAGES *data)
    {
        std::memcpy(&_data, data, sizeof(ALL_MESSAGES));
        // data.GNSS_SOL_RESULT_ALTITUDE_Signals.crc8 = 10;
    }
    void set_physical_vcu_info_1_t(physical_vcu_info_1_t *data)
    {
        memcpy(&_data.VCU_Info_1_Signals, data, sizeof(physical_vcu_info_1_t));
    }

    void set_physical_vcu_info_2_t(physical_vcu_info_2_t *data)
    {
        memcpy(&_data.VCU_Info_2_Signals, data, sizeof(physical_vcu_info_2_t));
    }

    void set_physical_devstatus_t(physical_devstatus_t *data)
    {
        memcpy(&_data.DEVSTATUS_Signals, data, sizeof(physical_devstatus_t));
    }

    void set_physical_heading_angle_t(physical_heading_angle_t *data)
    {
        memcpy(&_data.HEADING_ANGLE_Signals, data, sizeof(physical_heading_angle_t));
    }

    void set_physical_ins_sol_result_status_t(physical_ins_sol_result_status_t *data)
    {
        memcpy(&_data.INS_SOL_RESULT_STATUS_Signals, data, sizeof(physical_ins_sol_result_status_t));
    }

    void set_physical_ins_sol_result_vel_std_t(physical_ins_sol_result_vel_std_t *data)
    {
        memcpy(&_data.INS_SOL_RESULT_VEL_STD_Signals, data, sizeof(physical_ins_sol_result_vel_std_t));
    }

    void set_physical_ins_sol_result_vel_t(physical_ins_sol_result_vel_t *data)
    {
        memcpy(&_data.INS_SOL_RESULT_VEL_Signals, data, sizeof(physical_ins_sol_result_vel_t));
    }

    void set_physical_ins_sol_result_angle_std_t(physical_ins_sol_result_angle_std_t *data)
    {
        memcpy(&_data.INS_SOL_RESULT_ANGLE_STD_Signals, data, sizeof(physical_ins_sol_result_angle_std_t));
    }

    void set_physical_ins_sol_result_angle_t(physical_ins_sol_result_angle_t *data)
    {
        memcpy(&_data.INS_SOL_RESULT_ANGLE_Signals, data, sizeof(physical_ins_sol_result_angle_t));
    }

    void set_physical_ins_sol_result_altitude_t(physical_ins_sol_result_altitude_t *data)
    {
        memcpy(&_data.INS_SOL_RESULT_ALTITUDE_Signals, data, sizeof(physical_ins_sol_result_altitude_t));
    }

    void set_physical_ins_sol_result_longitude_t(physical_ins_sol_result_longitude_t *data)
    {
        memcpy(&_data.INS_SOL_RESULT_LONGITUDE_Signals, data, sizeof(physical_ins_sol_result_longitude_t));
    }

    void set_physical_ins_sol_result_latitude_t(physical_ins_sol_result_latitude_t *data)
    {
        memcpy(&_data.INS_SOL_RESULT_LATITUDE_Signals, data, sizeof(physical_ins_sol_result_latitude_t));
    }

    void set_physical_ins_sol_result_common_t(physical_ins_sol_result_common_t *data)
    {
        memcpy(&_data.INS_SOL_RESULT_COMMON_Signals, data, sizeof(physical_ins_sol_result_common_t));
    }

    void set_physical_gnss_sol_result_latency_t(physical_gnss_sol_result_latency_t *data)
    {
        memcpy(&_data.GNSS_SOL_RESULT_LATENCY_Signals, data, sizeof(physical_gnss_sol_result_latency_t));
    }

    void set_physical_gnss_sol_result_spd_t(physical_gnss_sol_result_spd_t *data)
    {
        memcpy(&_data.GNSS_SOL_RESULT_SPD_Signals, data, sizeof(physical_gnss_sol_result_spd_t));
    }

    void set_physical_gnss_sol_result_altitude_t(physical_gnss_sol_result_altitude_t *data)
    {
        memcpy(&_data.GNSS_SOL_RESULT_ALTITUDE_Signals, data, sizeof(physical_gnss_sol_result_altitude_t));
    }

    void set_physical_gnss_sol_result_longitude_t(physical_gnss_sol_result_longitude_t *data)
    {
        memcpy(&_data.GNSS_SOL_RESULT_LONGITUDE_Signals, data, sizeof(physical_gnss_sol_result_longitude_t));
    }

    void set_physical_gnss_sol_result_latitude_t(physical_gnss_sol_result_latitude_t *data)
    {
        memcpy(&_data.GNSS_SOL_RESULT_LATITUDE_Signals, data, sizeof(physical_gnss_sol_result_latitude_t));
    }

    void set_physical_gnss_sol_result_status_t(physical_gnss_sol_result_status_t *data)
    {
        memcpy(&_data.GNSS_SOL_RESULT_STATUS_Signals, data, sizeof(physical_gnss_sol_result_status_t));
    }

    void set_physical_gnss_sol_result_common_t(physical_gnss_sol_result_common_t *data)
    {
        memcpy(&_data.GNSS_SOL_RESULT_COMMON_Signals, data, sizeof(physical_gnss_sol_result_common_t));
    }

    void set_physical_gnss_sol_result_dop_t(physical_gnss_sol_result_dop_t *data)
    {
        memcpy(&_data.GNSS_SOL_RESULT_DOP_Signals, data, sizeof(physical_gnss_sol_result_dop_t));
    }

    void set_physical_gnss_sol_result_num_t(physical_gnss_sol_result_num_t *data)
    {
        memcpy(&_data.GNSS_SOL_RESULT_NUM_Signals, data, sizeof(physical_gnss_sol_result_num_t));
    }

    void set_physical_imu_bias_corrected_common_t(physical_imu_bias_corrected_common_t *data)
    {
        memcpy(&_data.IMU_BIAS_CORRECTED_COMMON_Signals, data, sizeof(physical_imu_bias_corrected_common_t));
    }

    void set_physical_imu_bias_corrected_angrate_t(physical_imu_bias_corrected_angrate_t *data)
    {
        memcpy(&_data.IMU_BIAS_CORRECTED_ANGRATE_Signals, data, sizeof(physical_imu_bias_corrected_angrate_t));
    }

    void set_physical_imu_bias_corrected_acc_t(physical_imu_bias_corrected_acc_t *data)
    {
        memcpy(&_data.IMU_BIAS_CORRECTED_ACC_Signals, data, sizeof(physical_imu_bias_corrected_acc_t));
    }

    void set_physical_imu_origin_common_t(physical_imu_origin_common_t *data)
    {
        memcpy(&_data.IMU_ORIGIN_COMMON_Signals, data, sizeof(physical_imu_origin_common_t));
    }

    void set_physical_imu_origin_acc_t(physical_imu_origin_acc_t *data)
    {
        memcpy(&_data.IMU_ORIGIN_ACC_Signals, data, sizeof(physical_imu_origin_acc_t));
    }

    void set_physical_imu_origin_gyro_t(physical_imu_origin_gyro_t *data)
    {
        memcpy(&_data.IMU_ORIGIN_GYRO_Signals, data, sizeof(physical_imu_origin_gyro_t));
    }
};

#endif /*CAN_PUB_DATA_WRAPPERS_H*/