/**********************************************************************************************************************
 *  COPYRIGHT
 *  -------------------------------------------------------------------------------------------------------------------
 *
 *                This software is copyright protected and proprietary to Vector Informatik GmbH.
 *                Vector Informatik GmbH grants to you only those rights as set out in the license conditions.
 *                All other rights remain with Vector Informatik GmbH.
 *  -------------------------------------------------------------------------------------------------------------------
 *  FILE DESCRIPTION
 *  -------------------------------------------------------------------------------------------------------------------
 *          File:  Rte_Hook.h
 *        Config:  Axera.dpa
 *   ECU-Project:  MyECU
 *
 *     Generator:  MICROSAR RTE Generator Version 4.19.0
 *                 RTE Core Version 1.19.0
 *       License:  CBD1900078
 *
 *   Description:  Header file containing definitions for VFB tracing
 *********************************************************************************************************************/


/**********************************************************************************************************************
 * Names of available VFB-Trace-Hooks
 **********************************************************************************************************************
 *
 * Not configured:
 *
 *  Rte_CallHook_Dcm_DataServices_Diag_RWDI_LightOnOffCounter_LightOnOffCounter_Value_ConditionCheckRead_Return
 *  Rte_CallHook_Dcm_DataServices_Diag_RWDI_LightOnOffCounter_LightOnOffCounter_Value_ConditionCheckRead_Start
 *  Rte_CallHook_Dcm_DataServices_Diag_RWDI_LightOnOffCounter_LightOnOffCounter_Value_ReadData_Return
 *  Rte_CallHook_Dcm_DataServices_Diag_RWDI_LightOnOffCounter_LightOnOffCounter_Value_ReadData_Start
 *  Rte_CallHook_Dcm_DataServices_Diag_RWDI_LightOnOffCounter_LightOnOffCounter_Value_WriteData_Return
 *  Rte_CallHook_Dcm_DataServices_Diag_RWDI_LightOnOffCounter_LightOnOffCounter_Value_WriteData_Start
 *  Rte_CallHook_Dcm_SecurityAccess_Level_01_CompareKey_Return
 *  Rte_CallHook_Dcm_SecurityAccess_Level_01_CompareKey_Start
 *  Rte_CallHook_Dcm_SecurityAccess_Level_01_GetSeed_Return
 *  Rte_CallHook_Dcm_SecurityAccess_Level_01_GetSeed_Start
 *  Rte_CallHook_DemMaster_0_CBReadData_OccurrenceCounter_OccurenceCounter_ReadData_Return
 *  Rte_CallHook_DemMaster_0_CBReadData_OccurrenceCounter_OccurenceCounter_ReadData_Start
 *  Rte_CallHook_DemMaster_0_CBReadData_OdometerValue_OdometerValue_ReadData_Return
 *  Rte_CallHook_DemMaster_0_CBReadData_OdometerValue_OdometerValue_ReadData_Start
 *  Rte_CallHook_DemSatellite_0_CBReadData_OccurrenceCounter_OccurenceCounter_ReadData_Return
 *  Rte_CallHook_DemSatellite_0_CBReadData_OccurrenceCounter_OccurenceCounter_ReadData_Start
 *  Rte_CallHook_DemSatellite_0_CBReadData_OdometerValue_OdometerValue_ReadData_Return
 *  Rte_CallHook_DemSatellite_0_CBReadData_OdometerValue_OdometerValue_ReadData_Start
 *  Rte_ReadHook_BswM_Request_ESH_PostRunRequest_0_requestedMode_Return
 *  Rte_ReadHook_BswM_Request_ESH_PostRunRequest_0_requestedMode_Start
 *  Rte_ReadHook_BswM_Request_ESH_PostRunRequest_1_requestedMode_Return
 *  Rte_ReadHook_BswM_Request_ESH_PostRunRequest_1_requestedMode_Start
 *  Rte_ReadHook_BswM_Request_ESH_RunRequest_0_requestedMode_Return
 *  Rte_ReadHook_BswM_Request_ESH_RunRequest_0_requestedMode_Start
 *  Rte_ReadHook_BswM_Request_ESH_RunRequest_1_requestedMode_Return
 *  Rte_ReadHook_BswM_Request_ESH_RunRequest_1_requestedMode_Start
 *  Rte_ReadHook_DMC_rLCFSEN_ST_LCF_SenGenericOutputs_t_ST_LCF_SenGenericOutputs_t_Return
 *  Rte_ReadHook_DMC_rLCFSEN_ST_LCF_SenGenericOutputs_t_ST_LCF_SenGenericOutputs_t_Start
 *  Rte_ReadHook_DMC_rLCFSEN_ST_LCF_SenToVehs_t_ST_LCF_SenToVehs_t_Return
 *  Rte_ReadHook_DMC_rLCFSEN_ST_LCF_SenToVehs_t_ST_LCF_SenToVehs_t_Start
 *  Rte_ReadHook_DMC_rLCFVEH_ST_LCF_VehGenericOutputs_t_ST_LCF_VehGenericOutputs_t_Return
 *  Rte_ReadHook_DMC_rLCFVEH_ST_LCF_VehGenericOutputs_t_ST_LCF_VehGenericOutputs_t_Start
 *  Rte_ReadHook_DMC_rNVRAM_LCF_DmcNVRAMData_t_LCF_DmcNVRAMData_t_Return
 *  Rte_ReadHook_DMC_rNVRAM_LCF_DmcNVRAMData_t_LCF_DmcNVRAMData_t_Start
 *  Rte_ReadHook_DMC_rSWCRX_EPSCtrlSt_EPSCtrlSt_Return
 *  Rte_ReadHook_DMC_rSWCRX_EPSCtrlSt_EPSCtrlSt_Start
 *  Rte_ReadHook_DMC_rVED_ST_VEDVehDyn_t_ST_VEDVehDyn_t_Return
 *  Rte_ReadHook_DMC_rVED_ST_VEDVehDyn_t_ST_VEDVehDyn_t_Start
 *  Rte_ReadHook_DMC_rVED_ST_VEDVehSig_t_ST_VEDVehSig_t_Return
 *  Rte_ReadHook_DMC_rVED_ST_VEDVehSig_t_ST_VEDVehSig_t_Start
 *  Rte_ReadHook_EM_Axera_Signal_Obstacle_Axera_Obstacle_Return
 *  Rte_ReadHook_EM_Axera_Signal_Obstacle_Axera_Obstacle_Start
 *  Rte_ReadHook_EM_ME_Signal_Obstacle_ME_Obstacle_Return
 *  Rte_ReadHook_EM_ME_Signal_Obstacle_ME_Obstacle_Start
 *  Rte_ReadHook_EM_rCTASEN_ST_reqCTASEN_SOA_HMI_t_ST_reqCTASEN_SOA_HMI_t_Return
 *  Rte_ReadHook_EM_rCTASEN_ST_reqCTASEN_SOA_HMI_t_ST_reqCTASEN_SOA_HMI_t_Start
 *  Rte_ReadHook_EM_rENVODD2MCU_t_In_ST_ENVODD2MCU_t_ST_ENVODD2MCU_t_Return
 *  Rte_ReadHook_EM_rENVODD2MCU_t_In_ST_ENVODD2MCU_t_ST_ENVODD2MCU_t_Start
 *  Rte_ReadHook_EM_rFusionLine_t_In_ST_FusionLine_t_ST_FusionLine_t_Return
 *  Rte_ReadHook_EM_rFusionLine_t_In_ST_FusionLine_t_ST_FusionLine_t_Start
 *  Rte_ReadHook_EM_rLBSSEN_ST_reqLBSSEN_SOA_HMI_t_ST_reqLBSSEN_SOA_HMI_t_Return
 *  Rte_ReadHook_EM_rLBSSEN_ST_reqLBSSEN_SOA_HMI_t_ST_reqLBSSEN_SOA_HMI_t_Start
 *  Rte_ReadHook_EM_rLCFSEN_ST_reqLCFSEN_SOA_HMI_t_ST_reqLCFSEN_SOA_HMI_t_Return
 *  Rte_ReadHook_EM_rLCFSEN_ST_reqLCFSEN_SOA_HMI_t_ST_reqLCFSEN_SOA_HMI_t_Start
 *  Rte_ReadHook_EM_rNVRAM_ST_EnvmNvm_t_ST_EnvmNvm_t_Return
 *  Rte_ReadHook_EM_rNVRAM_ST_EnvmNvm_t_ST_EnvmNvm_t_Start
 *  Rte_ReadHook_EM_rRoadSemantics2MCU_t_In_ST_RoadSemantics2MCU_t_ST_RoadSemantics2MCU_t_Return
 *  Rte_ReadHook_EM_rRoadSemantics2MCU_t_In_ST_RoadSemantics2MCU_t_ST_RoadSemantics2MCU_t_Start
 *  Rte_ReadHook_EM_rVED_ST_EMVEDVehPar_t_ST_EMVEDVehPar_t_Return
 *  Rte_ReadHook_EM_rVED_ST_EMVEDVehPar_t_ST_EMVEDVehPar_t_Start
 *  Rte_ReadHook_EM_rVED_ST_VEDVehDyn_t_ST_VEDVehDyn_t_Return
 *  Rte_ReadHook_EM_rVED_ST_VEDVehDyn_t_ST_VEDVehDyn_t_Start
 *  Rte_ReadHook_EM_rVLCSEN_ST_VLCSen_AssessedObjList_t_ST_VLCSen_AssessedObjList_t_Return
 *  Rte_ReadHook_EM_rVLCSEN_ST_VLCSen_AssessedObjList_t_ST_VLCSen_AssessedObjList_t_Start
 *  Rte_ReadHook_EM_rVLCVEH_ST_reqVLCVEH_SOA_HMI_t_ST_reqVLCVEH_SOA_HMI_t_Return
 *  Rte_ReadHook_EM_rVLCVEH_ST_reqVLCVEH_SOA_HMI_t_ST_reqVLCVEH_SOA_HMI_t_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_AdjLLnMrkingDispSt_ADAS_AdjLLnMrkingDispSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_AdjLLnMrkingDispSt_ADAS_AdjLLnMrkingDispSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_AdjRLnMrkingDispSt_ADAS_AdjRLnMrkingDispSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_AdjRLnMrkingDispSt_ADAS_AdjRLnMrkingDispSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_CrrtCycLock_ADAS_HWAHF_CrrtCycLock_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_CrrtCycLock_ADAS_HWAHF_CrrtCycLock_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_EyesOnRoadReq_ADAS_HWAHF_EyesOnRoadReq_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_EyesOnRoadReq_ADAS_HWAHF_EyesOnRoadReq_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_EyesOnRoadSoundWarn_ADAS_HWAHF_EyesOnRoadSoundWarn_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_EyesOnRoadSoundWarn_ADAS_HWAHF_EyesOnRoadSoundWarn_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_FailureSt_ADAS_HWAHF_FailureSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_FailureSt_ADAS_HWAHF_FailureSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_HandsOnPrompt_ADAS_HWAHF_HandsOnPrompt_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_HandsOnPrompt_ADAS_HWAHF_HandsOnPrompt_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_HandsOnReqSoundWarn_ADAS_HWAHF_HandsOnReqSoundWarn_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_HandsOnReqSoundWarn_ADAS_HWAHF_HandsOnReqSoundWarn_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_LegalDisclaimer_ADAS_HWAHF_LegalDisclaimer_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_LegalDisclaimer_ADAS_HWAHF_LegalDisclaimer_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_Lightbar_ADAS_HWAHF_Lightbar_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_Lightbar_ADAS_HWAHF_Lightbar_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_PedestrainDet_ADAS_HWAHF_PedestrainDet_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_PedestrainDet_ADAS_HWAHF_PedestrainDet_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_SafeStopSoundWarn_ADAS_HWAHF_SafeStopSoundWarn_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_SafeStopSoundWarn_ADAS_HWAHF_SafeStopSoundWarn_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_SafeStop_ADAS_HWAHF_SafeStop_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_SafeStop_ADAS_HWAHF_SafeStop_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_SpdDecRea_ADAS_HWAHF_SpdDecRea_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_SpdDecRea_ADAS_HWAHF_SpdDecRea_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_TakeOverReqSoundWarn_ADAS_HWAHF_TakeOverReqSoundWarn_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_TakeOverReqSoundWarn_ADAS_HWAHF_TakeOverReqSoundWarn_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_TakeOverReq_ADAS_HWAHF_TakeOverReq_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWAHF_TakeOverReq_ADAS_HWAHF_TakeOverReq_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWA_EnableSt_ADAS_HWA_EnableSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWA_EnableSt_ADAS_HWA_EnableSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWA_FailureSt_ADAS_HWA_FailureSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWA_FailureSt_ADAS_HWA_FailureSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWA_ILCAbortReason_ADAS_HWA_ILCAbortReason_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWA_ILCAbortReason_ADAS_HWA_ILCAbortReason_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWA_ILCAbortSoundWarn_ADAS_HWA_ILCAbortSoundWarn_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWA_ILCAbortSoundWarn_ADAS_HWA_ILCAbortSoundWarn_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWA_ILCLeftIndicator_ADAS_HWA_ILCLeftIndicator_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWA_ILCLeftIndicator_ADAS_HWA_ILCLeftIndicator_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWA_ILCLeftSt_ADAS_HWA_ILCLeftSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWA_ILCLeftSt_ADAS_HWA_ILCLeftSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWA_ILCRightIndicator_ADAS_HWA_ILCRightIndicator_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWA_ILCRightIndicator_ADAS_HWA_ILCRightIndicator_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWA_ILCRighttSt_ADAS_HWA_ILCRighttSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWA_ILCRighttSt_ADAS_HWA_ILCRighttSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWA_ILCTextInfo_ADAS_HWA_ILCTextInfo_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_HWA_ILCTextInfo_ADAS_HWA_ILCTextInfo_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_IntlCrusMode_ADAS_IntlCrusMode_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_IntlCrusMode_ADAS_IntlCrusMode_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_L2FunReqSt_ADAS_L2FunReqSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_L2FunReqSt_ADAS_L2FunReqSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_L3FunReqSt_ADAS_L3FunReqSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_L3FunReqSt_ADAS_L3FunReqSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LLnMarkingDisPropToLnWidth_ADAS_LLnMarkingDisPropToLnWidth_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LLnMarkingDisPropToLnWidth_ADAS_LLnMarkingDisPropToLnWidth_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LateralCtrlOvrrdFlg_ADAS_LateralCtrlOvrrdFlg_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LateralCtrlOvrrdFlg_ADAS_LateralCtrlOvrrdFlg_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LateralCtrlSt_ADAS_LateralCtrlSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LateralCtrlSt_ADAS_LateralCtrlSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LateralCtrlTyp_ADAS_LateralCtrlTyp_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LateralCtrlTyp_ADAS_LateralCtrlTyp_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LnMarkingCurvature_ADAS_LnMarkingCurvature_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LnMarkingCurvature_ADAS_LnMarkingCurvature_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LnMarkingHeadAngToVeh_ADAS_LnMarkingHeadAngToVeh_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LnMarkingHeadAngToVeh_ADAS_LnMarkingHeadAngToVeh_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LongCtrTargetAccelJerkMaxnValue_ADAS_LongCtrTargetAccelJerkMaxnValue_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LongCtrTargetAccelJerkMaxnValue_ADAS_LongCtrTargetAccelJerkMaxnValue_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LongCtrlAccelCtrlReq_ADAS_LongCtrlAccelCtrlReq_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LongCtrlAccelCtrlReq_ADAS_LongCtrlAccelCtrlReq_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LongCtrlDecToStopReq_ADAS_LongCtrlDecToStopReq_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LongCtrlDecToStopReq_ADAS_LongCtrlDecToStopReq_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LongCtrlDriveOff_ADAS_LongCtrlDriveOff_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LongCtrlDriveOff_ADAS_LongCtrlDriveOff_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LongCtrlModeForBrkSys_ADAS_LongCtrlModeForBrkSys_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LongCtrlModeForBrkSys_ADAS_LongCtrlModeForBrkSys_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LongCtrlShutdownReq_ADAS_LongCtrlShutdownReq_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LongCtrlShutdownReq_ADAS_LongCtrlShutdownReq_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LongCtrlTargetAccelJerkMinValue_ADAS_LongCtrlTargetAccelJerkMinValue_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LongCtrlTargetAccelJerkMinValue_ADAS_LongCtrlTargetAccelJerkMinValue_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LongCtrlTargetAccel_ADAS_LongCtrlTargetAccel_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LongCtrlTargetAccel_ADAS_LongCtrlTargetAccel_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LongCtrlTypReqLong_ADAS_LongCtrlTypReqLong_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LongCtrlTypReqLong_ADAS_LongCtrlTypReqLong_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LongCtrlTypReqMode_ADAS_LongCtrlTypReqMode_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_LongCtrlTypReqMode_ADAS_LongCtrlTypReqMode_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_SensorBlockedSts_ADAS_SensorBlockedSts_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_SensorBlockedSts_ADAS_SensorBlockedSts_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_SensorCalibrationSts_ADAS_SensorCalibrationSts_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_SensorCalibrationSts_ADAS_SensorCalibrationSts_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_SensorFailure_ADAS_SensorFailure_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_SensorFailure_ADAS_SensorFailure_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_StrAngleReq_ADAS_StrAngleReq_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_StrAngleReq_ADAS_StrAngleReq_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_TrkTargt2ObjClass_ADAS_TrkTargt2ObjClass_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_TrkTargt2ObjClass_ADAS_TrkTargt2ObjClass_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_TrkTargt2St_ADAS_TrkTargt2St_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_TrkTargt2St_ADAS_TrkTargt2St_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_TrkTargt2latPos_ADAS_TrkTargt2latPos_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_TrkTargt2latPos_ADAS_TrkTargt2latPos_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_TrkTargt3ObjClass_ADAS_TrkTargt3ObjClass_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_TrkTargt3ObjClass_ADAS_TrkTargt3ObjClass_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_TrkTargt3St_ADAS_TrkTargt3St_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_TrkTargt3St_ADAS_TrkTargt3St_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_TrkTargt3latPos_ADAS_TrkTargt3latPos_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_TrkTargt3latPos_ADAS_TrkTargt3latPos_Start
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_TrkTargt3longPos_ADAS_TrkTargt3longPos_Return
 *  Rte_ReadHook_FCU_pSWCTX_ADAS_TrkTargt3longPos_ADAS_TrkTargt3longPos_Start
 *  Rte_ReadHook_FCU_pSWCTX_EPS_HandsOffDetSt_EPS_HandsOffDetSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_EPS_HandsOffDetSt_EPS_HandsOffDetSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_EPS_LKACtrlSt_EPS_LKACtrlSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_EPS_LKACtrlSt_EPS_LKACtrlSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_IFC_AEBBrkPedalOverRide_IFC_AEBBrkPedalOverRide_Return
 *  Rte_ReadHook_FCU_pSWCTX_IFC_AEBBrkPedalOverRide_IFC_AEBBrkPedalOverRide_Start
 *  Rte_ReadHook_FCU_pSWCTX_IFC_CameraBlockageSt_IFC_CameraBlockageSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_IFC_CameraBlockageSt_IFC_CameraBlockageSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_IFC_CruiseMode_IFC_CruiseMode_Return
 *  Rte_ReadHook_FCU_pSWCTX_IFC_CruiseMode_IFC_CruiseMode_Start
 *  Rte_ReadHook_FCU_pSWCTX_IFC_ELKSt_IFC_ELKSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_IFC_ELKSt_IFC_ELKSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_IFC_ELKWarnL_IFC_ELKWarnL_Return
 *  Rte_ReadHook_FCU_pSWCTX_IFC_ELKWarnL_IFC_ELKWarnL_Start
 *  Rte_ReadHook_FCU_pSWCTX_IFC_ELKWarnR_IFC_ELKWarnR_Return
 *  Rte_ReadHook_FCU_pSWCTX_IFC_ELKWarnR_IFC_ELKWarnR_Start
 *  Rte_ReadHook_FCU_pSWCTX_IFC_LKS_LaneAssistType_IFC_LKS_LaneAssistType_Return
 *  Rte_ReadHook_FCU_pSWCTX_IFC_LKS_LaneAssistType_IFC_LKS_LaneAssistType_Start
 *  Rte_ReadHook_FCU_pSWCTX_IFC_LKS_TakeoverReq_IFC_LKS_TakeoverReq_Return
 *  Rte_ReadHook_FCU_pSWCTX_IFC_LKS_TakeoverReq_IFC_LKS_TakeoverReq_Start
 *  Rte_ReadHook_FCU_pSWCTX_IFC_LateralCtrlQuitWarn_IFC_LateralCtrlQuitWarn_Return
 *  Rte_ReadHook_FCU_pSWCTX_IFC_LateralCtrlQuitWarn_IFC_LateralCtrlQuitWarn_Start
 *  Rte_ReadHook_FCU_pSWCTX_IFC_LeftTrackingSt_IFC_LeftTrackingSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_IFC_LeftTrackingSt_IFC_LeftTrackingSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_IFC_RightTrackingSt_IFC_RightTrackingSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_IFC_RightTrackingSt_IFC_RightTrackingSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_IFC_SysCalibrationSt_IFC_SysCalibrationSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_IFC_SysCalibrationSt_IFC_SysCalibrationSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_IFC_TJA_ICA_St_IFC_TJA_ICA_St_Return
 *  Rte_ReadHook_FCU_pSWCTX_IFC_TJA_ICA_St_IFC_TJA_ICA_St_Start
 *  Rte_ReadHook_FCU_pSWCTX_IFC_TorqueReqSt_IFC_TorqueReqSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_IFC_TorqueReqSt_IFC_TorqueReqSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_IFC_TorqueReq_IFC_TorqueReq_Return
 *  Rte_ReadHook_FCU_pSWCTX_IFC_TorqueReq_IFC_TorqueReq_Start
 *  Rte_ReadHook_FCU_pSWCTX_LKS_Status_LKS_Status_Return
 *  Rte_ReadHook_FCU_pSWCTX_LKS_Status_LKS_Status_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCActiveSt_MRR_ACCActiveSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCActiveSt_MRR_ACCActiveSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCFaultSt_MRR_ACCFaultSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCFaultSt_MRR_ACCFaultSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCFuncCancel_MRR_ACCFuncCancel_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCFuncCancel_MRR_ACCFuncCancel_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCGoNotifier_MRR_ACCGoNotifier_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCGoNotifier_MRR_ACCGoNotifier_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCMode_MRR_ACCMode_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCMode_MRR_ACCMode_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCQuitSound_MRR_ACCQuitSound_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCQuitSound_MRR_ACCQuitSound_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCRecpDecelReq_MRR_ACCRecpDecelReq_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCRecpDecelReq_MRR_ACCRecpDecelReq_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCRecpDecel_MRR_ACCRecpDecel_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCRecpDecel_MRR_ACCRecpDecel_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCReqQua_MRR_ACCReqQua_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCReqQua_MRR_ACCReqQua_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCTakeOverReq_MRR_ACCTakeOverReq_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCTakeOverReq_MRR_ACCTakeOverReq_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCTextInfo_MRR_ACCTextInfo_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCTextInfo_MRR_ACCTextInfo_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCUnableActivated_MRR_ACCUnableActivated_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ACCUnableActivated_MRR_ACCUnableActivated_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_AEBFaultSt_MRR_AEBFaultSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_AEBFaultSt_MRR_AEBFaultSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_AEBLVehHoldReq_MRR_AEBLVehHoldReq_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_AEBLVehHoldReq_MRR_AEBLVehHoldReq_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_AEBOffSt_MRR_AEBOffSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_AEBOffSt_MRR_AEBOffSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_AEBTargetDecel_MRR_AEBTargetDecel_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_AEBTargetDecel_MRR_AEBTargetDecel_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_AWBLevel_MRR_AWBLevel_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_AWBLevel_MRR_AWBLevel_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_AWBReq_MRR_AWBReq_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_AWBReq_MRR_AWBReq_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ActTrqReqVD_MRR_ActTrqReqVD_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ActTrqReqVD_MRR_ActTrqReqVD_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ActTrqReq_MRR_ActTrqReq_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ActTrqReq_MRR_ActTrqReq_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_FCWFaultSt_MRR_FCWFaultSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_FCWFaultSt_MRR_FCWFaultSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_FCWOffSt_MRR_FCWOffSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_FCWOffSt_MRR_FCWOffSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_IFC_PriCANAvailableSt_MRR_IFC_PriCANAvailableSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_IFC_PriCANAvailableSt_MRR_IFC_PriCANAvailableSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_IFC_PriCANErrorSt_MRR_IFC_PriCANErrorSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_IFC_PriCANErrorSt_MRR_IFC_PriCANErrorSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ObjectCapturedSt_MRR_ObjectCapturedSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_ObjectCapturedSt_MRR_ObjectCapturedSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_PEBSObjType_MRR_PEBSObjType_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_PEBSObjType_MRR_PEBSObjType_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_TargetDistanceSt_MRR_TargetDistanceSt_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_TargetDistanceSt_MRR_TargetDistanceSt_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_TargetSpd_MRR_TargetSpd_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_TargetSpd_MRR_TargetSpd_Start
 *  Rte_ReadHook_FCU_pSWCTX_MRR_TauGapSet_MRR_TauGapSet_Return
 *  Rte_ReadHook_FCU_pSWCTX_MRR_TauGapSet_MRR_TauGapSet_Start
 *  Rte_ReadHook_FCU_pSWCTX_PCS_LDWStatus_PCS_LDWStatus_Return
 *  Rte_ReadHook_FCU_pSWCTX_PCS_LDWStatus_PCS_LDWStatus_Start
 *  Rte_ReadHook_FCU_pSWCTX_VCU_VehDrvMod_VCU_VehDrvMod_Return
 *  Rte_ReadHook_FCU_pSWCTX_VCU_VehDrvMod_VCU_VehDrvMod_Start
 *  Rte_ReadHook_LCFSEN_Axera_Signal_Lane_Axera_Lane_Return
 *  Rte_ReadHook_LCFSEN_Axera_Signal_Lane_Axera_Lane_Start
 *  Rte_ReadHook_LCFSEN_ME_Signal_Lane_ME_Lane_Return
 *  Rte_ReadHook_LCFSEN_ME_Signal_Lane_ME_Lane_Start
 *  Rte_ReadHook_LCFSEN_rDMC_ST_LCF_DmcGenericOutputs_t_ST_LCF_DmcGenericOutputs_t_Return
 *  Rte_ReadHook_LCFSEN_rDMC_ST_LCF_DmcGenericOutputs_t_ST_LCF_DmcGenericOutputs_t_Start
 *  Rte_ReadHook_LCFSEN_rEM_ST_EMFusionGenObjList_t_ST_EMFusionGenObjList_t_Return
 *  Rte_ReadHook_LCFSEN_rEM_ST_EMFusionGenObjList_t_ST_EMFusionGenObjList_t_Start
 *  Rte_ReadHook_LCFSEN_rEM_ST_Envm_t_CRObjectList_ST_Envm_t_CRObjectList_Return
 *  Rte_ReadHook_LCFSEN_rEM_ST_Envm_t_CRObjectList_ST_Envm_t_CRObjectList_Start
 *  Rte_ReadHook_LCFSEN_rEM_ST_Envm_t_GenObjectList_ST_Envm_t_GenObjectList_Return
 *  Rte_ReadHook_LCFSEN_rEM_ST_Envm_t_GenObjectList_ST_Envm_t_GenObjectList_Start
 *  Rte_ReadHook_LCFSEN_rLBSSEN_ST_LBSFunState_t_ST_LBSFunState_t_Return
 *  Rte_ReadHook_LCFSEN_rLBSSEN_ST_LBSFunState_t_ST_LBSFunState_t_Start
 *  Rte_ReadHook_LCFSEN_rLCFVEH_ST_LCF_VehGenericOutputs_t_ST_LCF_VehGenericOutputs_t_Return
 *  Rte_ReadHook_LCFSEN_rLCFVEH_ST_LCF_VehGenericOutputs_t_ST_LCF_VehGenericOutputs_t_Start
 *  Rte_ReadHook_LCFSEN_rNVRAM_ST_LCFSEN_NVRAMData_t_ST_LCFSEN_NVRAMData_t_Return
 *  Rte_ReadHook_LCFSEN_rNVRAM_ST_LCFSEN_NVRAMData_t_ST_LCFSEN_NVRAMData_t_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_ACU_LDW_LKACfg_ACU_LDW_LKACfg_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_ACU_LDW_LKACfg_ACU_LDW_LKACfg_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCM_HazardLampSt_BCM_HazardLampSt_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCM_HazardLampSt_BCM_HazardLampSt_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCM_LeftTurnLampSt_BCM_LeftTurnLampSt_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCM_LeftTurnLampSt_BCM_LeftTurnLampSt_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCM_RightTurnLampSt_BCM_RightTurnLampSt_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCM_RightTurnLampSt_BCM_RightTurnLampSt_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCM_TurnLightSwitchSt_BCM_TurnLightSwitchSt_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCM_TurnLightSwitchSt_BCM_TurnLightSwitchSt_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_ABSFaultSt_BCS_ABSFaultSt_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_ABSFaultSt_BCS_ABSFaultSt_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_ActVehLaltrlAccelVD_BCS_ActVehLaltrlAccelVD_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_ActVehLaltrlAccelVD_BCS_ActVehLaltrlAccelVD_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_ActVehLongAccelVD_BCS_ActVehLongAccelVD_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_ActVehLongAccelVD_BCS_ActVehLongAccelVD_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_BrakeOverHeat_BCS_BrakeOverHeat_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_BrakeOverHeat_BCS_BrakeOverHeat_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_EBDFaultSt_BCS_EBDFaultSt_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_EBDFaultSt_BCS_EBDFaultSt_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_FLWheelRotatedDirection_BCS_FLWheelRotatedDirection_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_FLWheelRotatedDirection_BCS_FLWheelRotatedDirection_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_FLWheelSpdVD_BCS_FLWheelSpdVD_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_FLWheelSpdVD_BCS_FLWheelSpdVD_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_FRWheelRotatedDirection_BCS_FRWheelRotatedDirection_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_FRWheelRotatedDirection_BCS_FRWheelRotatedDirection_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_FRWheelSpdVD_BCS_FRWheelSpdVD_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_FRWheelSpdVD_BCS_FRWheelSpdVD_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_HDCCtrlSt_BCS_HDCCtrlSt_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_HDCCtrlSt_BCS_HDCCtrlSt_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_RLWheelRotatedDirection_BCS_RLWheelRotatedDirection_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_RLWheelRotatedDirection_BCS_RLWheelRotatedDirection_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_RLWheelSpdVD_BCS_RLWheelSpdVD_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_RLWheelSpdVD_BCS_RLWheelSpdVD_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_RRWheelRotatedDirection_BCS_RRWheelRotatedDirection_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_RRWheelRotatedDirection_BCS_RRWheelRotatedDirection_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_RRWheelSpdVD_BCS_RRWheelSpdVD_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_RRWheelSpdVD_BCS_RRWheelSpdVD_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_TCSFaultSt_BCS_TCSFaultSt_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_TCSFaultSt_BCS_TCSFaultSt_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_VehSpdVD_BCS_VehSpdVD_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_VehSpdVD_BCS_VehSpdVD_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_VehicleStandStillSt_BCS_VehicleStandStillSt_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_VehicleStandStillSt_BCS_VehicleStandStillSt_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_YawRateSt_BCS_YawRateSt_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_BCS_YawRateSt_BCS_YawRateSt_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_EMS_ACCButtInfo_EMS_ACCButtInfo_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_EMS_ACCButtInfo_EMS_ACCButtInfo_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_EPB_SysSt_EPB_SysSt_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_EPB_SysSt_EPB_SysSt_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_EPSCtrlSt_EPSCtrlSt_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_EPSCtrlSt_EPSCtrlSt_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_EPS_SteeringAngleSpdVD_EPS_SteeringAngleSpdVD_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_EPS_SteeringAngleSpdVD_EPS_SteeringAngleSpdVD_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_EPS_SteeringAngleVD_EPS_SteeringAngleVD_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_EPS_SteeringAngleVD_EPS_SteeringAngleVD_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_EPS_StrngWhlTorqVD_EPS_StrngWhlTorqVD_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_EPS_StrngWhlTorqVD_EPS_StrngWhlTorqVD_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_ICM_DisFail_ICM_DisFail_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_ICM_DisFail_ICM_DisFail_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_SAS_CalibratedSt_SAS_CalibratedSt_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_SAS_CalibratedSt_SAS_CalibratedSt_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_VCU_CrntGearLvlVD_VCU_CrntGearLvlVD_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_VCU_CrntGearLvlVD_VCU_CrntGearLvlVD_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_VCU_EMS_AccPedalActPstVD_VCU_EMS_AccPedalActPstVD_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_VCU_EMS_AccPedalActPstVD_VCU_EMS_AccPedalActPstVD_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_VCU_EMS_BrkPedalStVD_VCU_EMS_BrkPedalStVD_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_VCU_EMS_BrkPedalStVD_VCU_EMS_BrkPedalStVD_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_VCU_LateralAssistBtnInfoVD_VCU_LateralAssistBtnInfoVD_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_VCU_LateralAssistBtnInfoVD_VCU_LateralAssistBtnInfoVD_Start
 *  Rte_ReadHook_LCFSEN_rSWCRX_VCU_LateralAssistBtnInfo_VCU_LateralAssistBtnInfo_Return
 *  Rte_ReadHook_LCFSEN_rSWCRX_VCU_LateralAssistBtnInfo_VCU_LateralAssistBtnInfo_Start
 *  Rte_ReadHook_LCFSEN_rVED_ST_VEDVehDyn_t_ST_VEDVehDyn_t_Return
 *  Rte_ReadHook_LCFSEN_rVED_ST_VEDVehDyn_t_ST_VEDVehDyn_t_Start
 *  Rte_ReadHook_LCFSEN_rVED_ST_VEDVehSig_t_ST_VEDVehSig_t_Return
 *  Rte_ReadHook_LCFSEN_rVED_ST_VEDVehSig_t_ST_VEDVehSig_t_Start
 *  Rte_ReadHook_LCFSEN_rVLCSEN_ST_VLCSen_AccOOI_List_t_ST_VLCSen_AccOOI_List_t_Return
 *  Rte_ReadHook_LCFSEN_rVLCSEN_ST_VLCSen_AccOOI_List_t_ST_VLCSen_AccOOI_List_t_Start
 *  Rte_ReadHook_LCFSEN_rVLCVEH_ST_VLCVEH_CANOut_ST_VLCVEH_CANOut_Return
 *  Rte_ReadHook_LCFSEN_rVLCVEH_ST_VLCVEH_CANOut_ST_VLCVEH_CANOut_Start
 *  Rte_ReadHook_LCFVEH_rDMC_ST_LCF_DmcGenericOutputs_t_ST_LCF_DmcGenericOutputs_t_Return
 *  Rte_ReadHook_LCFVEH_rDMC_ST_LCF_DmcGenericOutputs_t_ST_LCF_DmcGenericOutputs_t_Start
 *  Rte_ReadHook_LCFVEH_rLCFSEN_ST_LCF_SenGenericOutputs_t_ST_LCF_SenGenericOutputs_t_Return
 *  Rte_ReadHook_LCFVEH_rLCFSEN_ST_LCF_SenGenericOutputs_t_ST_LCF_SenGenericOutputs_t_Start
 *  Rte_ReadHook_LCFVEH_rLCFSEN_ST_LCF_SenToVehs_t_ST_LCF_SenToVehs_t_Return
 *  Rte_ReadHook_LCFVEH_rLCFSEN_ST_LCF_SenToVehs_t_ST_LCF_SenToVehs_t_Start
 *  Rte_ReadHook_LCFVEH_rNVRAM_LCF_VehNVRAMData_t_LCF_VehNVRAMData_t_Return
 *  Rte_ReadHook_LCFVEH_rNVRAM_LCF_VehNVRAMData_t_LCF_VehNVRAMData_t_Start
 *  Rte_ReadHook_LCFVEH_rVED_ST_VEDVehDyn_t_ST_VEDVehDyn_t_Return
 *  Rte_ReadHook_LCFVEH_rVED_ST_VEDVehDyn_t_ST_VEDVehDyn_t_Start
 *  Rte_ReadHook_LCFVEH_rVED_ST_VEDVehSig_t_ST_VEDVehSig_t_Return
 *  Rte_ReadHook_LCFVEH_rVED_ST_VEDVehSig_t_ST_VEDVehSig_t_Start
 *  Rte_ReadHook_VED_rNVRAM_ST_VEDNvIoDatas_t_ST_VEDNvIoDatas_t_Return
 *  Rte_ReadHook_VED_rNVRAM_ST_VEDNvIoDatas_t_ST_VEDNvIoDatas_t_Start
 *  Rte_ReadHook_VED_rSWCRX_BCM_DriverDoorAjarSt_BCM_DriverDoorAjarSt_Return
 *  Rte_ReadHook_VED_rSWCRX_BCM_DriverDoorAjarSt_BCM_DriverDoorAjarSt_Start
 *  Rte_ReadHook_VED_rSWCRX_BCM_FrontFogLampSt_BCM_FrontFogLampSt_Return
 *  Rte_ReadHook_VED_rSWCRX_BCM_FrontFogLampSt_BCM_FrontFogLampSt_Start
 *  Rte_ReadHook_VED_rSWCRX_BCM_FrontWasherSt_BCM_FrontWasherSt_Return
 *  Rte_ReadHook_VED_rSWCRX_BCM_FrontWasherSt_BCM_FrontWasherSt_Start
 *  Rte_ReadHook_VED_rSWCRX_BCM_FrontWiperSt_BCM_FrontWiperSt_Return
 *  Rte_ReadHook_VED_rSWCRX_BCM_FrontWiperSt_BCM_FrontWiperSt_Start
 *  Rte_ReadHook_VED_rSWCRX_BCM_HazardLampSt_BCM_HazardLampSt_Return
 *  Rte_ReadHook_VED_rSWCRX_BCM_HazardLampSt_BCM_HazardLampSt_Start
 *  Rte_ReadHook_VED_rSWCRX_BCM_HighBeamSt_BCM_HighBeamSt_Return
 *  Rte_ReadHook_VED_rSWCRX_BCM_HighBeamSt_BCM_HighBeamSt_Start
 *  Rte_ReadHook_VED_rSWCRX_BCM_KeySt_BCM_KeySt_Return
 *  Rte_ReadHook_VED_rSWCRX_BCM_KeySt_BCM_KeySt_Start
 *  Rte_ReadHook_VED_rSWCRX_BCM_LowBeamSt_BCM_LowBeamSt_Return
 *  Rte_ReadHook_VED_rSWCRX_BCM_LowBeamSt_BCM_LowBeamSt_Start
 *  Rte_ReadHook_VED_rSWCRX_BCM_PsngrDoorAjarSt_BCM_PsngrDoorAjarSt_Return
 *  Rte_ReadHook_VED_rSWCRX_BCM_PsngrDoorAjarSt_BCM_PsngrDoorAjarSt_Start
 *  Rte_ReadHook_VED_rSWCRX_BCM_RLDoorAjarSt_BCM_RLDoorAjarSt_Return
 *  Rte_ReadHook_VED_rSWCRX_BCM_RLDoorAjarSt_BCM_RLDoorAjarSt_Start
 *  Rte_ReadHook_VED_rSWCRX_BCM_RRDoorAjarSt_BCM_RRDoorAjarSt_Return
 *  Rte_ReadHook_VED_rSWCRX_BCM_RRDoorAjarSt_BCM_RRDoorAjarSt_Start
 *  Rte_ReadHook_VED_rSWCRX_BCM_RearFogLampSt_BCM_RearFogLampSt_Return
 *  Rte_ReadHook_VED_rSWCRX_BCM_RearFogLampSt_BCM_RearFogLampSt_Start
 *  Rte_ReadHook_VED_rSWCRX_BCM_TurnLightSwitchSt_BCM_TurnLightSwitchSt_Return
 *  Rte_ReadHook_VED_rSWCRX_BCM_TurnLightSwitchSt_BCM_TurnLightSwitchSt_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_ABSActiveSt_BCS_ABSActiveSt_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_ABSActiveSt_BCS_ABSActiveSt_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_AEBAvailable_BCS_AEBAvailable_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_AEBAvailable_BCS_AEBAvailable_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_AWBActive_BCS_AWBActive_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_AWBActive_BCS_AWBActive_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_ActVehLaltrlAccelVD_BCS_ActVehLaltrlAccelVD_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_ActVehLaltrlAccelVD_BCS_ActVehLaltrlAccelVD_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_ActVehLaltrlAccel_BCS_ActVehLaltrlAccel_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_ActVehLaltrlAccel_BCS_ActVehLaltrlAccel_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_ActVehLongAccelVD_BCS_ActVehLongAccelVD_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_ActVehLongAccelVD_BCS_ActVehLongAccelVD_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_ActVehLongAccel_BCS_ActVehLongAccel_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_ActVehLongAccel_BCS_ActVehLongAccel_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_FLWheelRotatedDirection_BCS_FLWheelRotatedDirection_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_FLWheelRotatedDirection_BCS_FLWheelRotatedDirection_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_FLWheelSpdEdgesSumVD_BCS_FLWheelSpdEdgesSumVD_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_FLWheelSpdEdgesSumVD_BCS_FLWheelSpdEdgesSumVD_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_FLWheelSpdEdgesSum_BCS_FLWheelSpdEdgesSum_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_FLWheelSpdEdgesSum_BCS_FLWheelSpdEdgesSum_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_FLWheelSpdVD_BCS_FLWheelSpdVD_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_FLWheelSpdVD_BCS_FLWheelSpdVD_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_FLWheelSpd_BCS_FLWheelSpd_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_FLWheelSpd_BCS_FLWheelSpd_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_FRWheelRotatedDirection_BCS_FRWheelRotatedDirection_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_FRWheelRotatedDirection_BCS_FRWheelRotatedDirection_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_FRWheelSpdEdgesSumVD_BCS_FRWheelSpdEdgesSumVD_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_FRWheelSpdEdgesSumVD_BCS_FRWheelSpdEdgesSumVD_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_FRWheelSpdEdgesSum_BCS_FRWheelSpdEdgesSum_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_FRWheelSpdEdgesSum_BCS_FRWheelSpdEdgesSum_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_FRWheelSpdVD_BCS_FRWheelSpdVD_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_FRWheelSpdVD_BCS_FRWheelSpdVD_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_FRWheelSpd_BCS_FRWheelSpd_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_FRWheelSpd_BCS_FRWheelSpd_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_HDCCtrlSt_BCS_HDCCtrlSt_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_HDCCtrlSt_BCS_HDCCtrlSt_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_RLWheelRotatedDirection_BCS_RLWheelRotatedDirection_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_RLWheelRotatedDirection_BCS_RLWheelRotatedDirection_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_RLWheelSpdEdgesSumVD_BCS_RLWheelSpdEdgesSumVD_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_RLWheelSpdEdgesSumVD_BCS_RLWheelSpdEdgesSumVD_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_RLWheelSpdEdgesSum_BCS_RLWheelSpdEdgesSum_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_RLWheelSpdEdgesSum_BCS_RLWheelSpdEdgesSum_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_RLWheelSpdVD_BCS_RLWheelSpdVD_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_RLWheelSpdVD_BCS_RLWheelSpdVD_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_RLWheelSpd_BCS_RLWheelSpd_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_RLWheelSpd_BCS_RLWheelSpd_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_RRWheelRotatedDirection_BCS_RRWheelRotatedDirection_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_RRWheelRotatedDirection_BCS_RRWheelRotatedDirection_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_RRWheelSpdEdgesSumVD_BCS_RRWheelSpdEdgesSumVD_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_RRWheelSpdEdgesSumVD_BCS_RRWheelSpdEdgesSumVD_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_RRWheelSpdEdgesSum_BCS_RRWheelSpdEdgesSum_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_RRWheelSpdEdgesSum_BCS_RRWheelSpdEdgesSum_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_RRWheelSpdVD_BCS_RRWheelSpdVD_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_RRWheelSpdVD_BCS_RRWheelSpdVD_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_RRWheelSpd_BCS_RRWheelSpd_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_RRWheelSpd_BCS_RRWheelSpd_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_TCSActiveSt_BCS_TCSActiveSt_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_TCSActiveSt_BCS_TCSActiveSt_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_TCSOff_BCS_TCSOff_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_TCSOff_BCS_TCSOff_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_VehSpdVD_BCS_VehSpdVD_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_VehSpdVD_BCS_VehSpdVD_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_VehSpd_BCS_VehSpd_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_VehSpd_BCS_VehSpd_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_VehicleStandStillSt_BCS_VehicleStandStillSt_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_VehicleStandStillSt_BCS_VehicleStandStillSt_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_YawRateSt_BCS_YawRateSt_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_YawRateSt_BCS_YawRateSt_Start
 *  Rte_ReadHook_VED_rSWCRX_BCS_YawRate_BCS_YawRate_Return
 *  Rte_ReadHook_VED_rSWCRX_BCS_YawRate_BCS_YawRate_Start
 *  Rte_ReadHook_VED_rSWCRX_DMS_FatigWarnSt_DMS_FatigWarnSt_Return
 *  Rte_ReadHook_VED_rSWCRX_DMS_FatigWarnSt_DMS_FatigWarnSt_Start
 *  Rte_ReadHook_VED_rSWCRX_EPB_FailSt_EPB_SysSt_Return
 *  Rte_ReadHook_VED_rSWCRX_EPB_FailSt_EPB_SysSt_Start
 *  Rte_ReadHook_VED_rSWCRX_EPB_SysSt_EPB_SysSt_Return
 *  Rte_ReadHook_VED_rSWCRX_EPB_SysSt_EPB_SysSt_Start
 *  Rte_ReadHook_VED_rSWCRX_EPS_LKACtrlAbortFeedback_EPS_LKACtrlAbortFeedback_Return
 *  Rte_ReadHook_VED_rSWCRX_EPS_LKACtrlAbortFeedback_EPS_LKACtrlAbortFeedback_Start
 *  Rte_ReadHook_VED_rSWCRX_EPS_SteeringAngleSpdVD_EPS_SteeringAngleSpdVD_Return
 *  Rte_ReadHook_VED_rSWCRX_EPS_SteeringAngleSpdVD_EPS_SteeringAngleSpdVD_Start
 *  Rte_ReadHook_VED_rSWCRX_EPS_SteeringAngleSpd_EPS_SteeringAngleSpd_Return
 *  Rte_ReadHook_VED_rSWCRX_EPS_SteeringAngleSpd_EPS_SteeringAngleSpd_Start
 *  Rte_ReadHook_VED_rSWCRX_EPS_SteeringAngleVD_EPS_SteeringAngleVD_Return
 *  Rte_ReadHook_VED_rSWCRX_EPS_SteeringAngleVD_EPS_SteeringAngleVD_Start
 *  Rte_ReadHook_VED_rSWCRX_EPS_SteeringAngle_EPS_SteeringAngle_Return
 *  Rte_ReadHook_VED_rSWCRX_EPS_SteeringAngle_EPS_SteeringAngle_Start
 *  Rte_ReadHook_VED_rSWCRX_EPS_StrngWhlTorqVD_EPS_StrngWhlTorqVD_Return
 *  Rte_ReadHook_VED_rSWCRX_EPS_StrngWhlTorqVD_EPS_StrngWhlTorqVD_Start
 *  Rte_ReadHook_VED_rSWCRX_EPS_StrngWhlTorq_EPS_StrngWhlTorq_Return
 *  Rte_ReadHook_VED_rSWCRX_EPS_StrngWhlTorq_EPS_StrngWhlTorq_Start
 *  Rte_ReadHook_VED_rSWCRX_HVAC_CorrectedExterTempVD_HVAC_CorrectedExterTempVD_Return
 *  Rte_ReadHook_VED_rSWCRX_HVAC_CorrectedExterTempVD_HVAC_CorrectedExterTempVD_Start
 *  Rte_ReadHook_VED_rSWCRX_HVAC_CorrectedExterTemp_HVAC_CorrectedExterTemp_Return
 *  Rte_ReadHook_VED_rSWCRX_HVAC_CorrectedExterTemp_HVAC_CorrectedExterTemp_Start
 *  Rte_ReadHook_VED_rSWCRX_ICM_DisFail_ICM_DisFail_Return
 *  Rte_ReadHook_VED_rSWCRX_ICM_DisFail_ICM_DisFail_Start
 *  Rte_ReadHook_VED_rSWCRX_ICM_TotalOdometer_ICM_TotalOdometer_Return
 *  Rte_ReadHook_VED_rSWCRX_ICM_TotalOdometer_ICM_TotalOdometer_Start
 *  Rte_ReadHook_VED_rSWCRX_ICM_VehInsSpd_ICM_VehInsSpd_Return
 *  Rte_ReadHook_VED_rSWCRX_ICM_VehInsSpd_ICM_VehInsSpd_Start
 *  Rte_ReadHook_VED_rSWCRX_SRS_DriverSeatBeltSt_SRS_DriverSeatBeltSt_Return
 *  Rte_ReadHook_VED_rSWCRX_SRS_DriverSeatBeltSt_SRS_DriverSeatBeltSt_Start
 *  Rte_ReadHook_VED_rSWCRX_VCU_ActVehWheelTorq_VCU_ActVehWheelTorq_Return
 *  Rte_ReadHook_VED_rSWCRX_VCU_ActVehWheelTorq_VCU_ActVehWheelTorq_Start
 *  Rte_ReadHook_VED_rSWCRX_VCU_CrntGearLvlVD_VCU_CrntGearLvlVD_Return
 *  Rte_ReadHook_VED_rSWCRX_VCU_CrntGearLvlVD_VCU_CrntGearLvlVD_Start
 *  Rte_ReadHook_VED_rSWCRX_VCU_CrntGearLvl_VCU_CrntGearLvl_Return
 *  Rte_ReadHook_VED_rSWCRX_VCU_CrntGearLvl_VCU_CrntGearLvl_Start
 *  Rte_ReadHook_VED_rSWCRX_VCU_EMS_AccPedalActPstVD_VCU_EMS_AccPedalActPstVD_Return
 *  Rte_ReadHook_VED_rSWCRX_VCU_EMS_AccPedalActPstVD_VCU_EMS_AccPedalActPstVD_Start
 *  Rte_ReadHook_VED_rSWCRX_VCU_EMS_AccPedalActPst_VCU_EMS_AccPedalActPst_Return
 *  Rte_ReadHook_VED_rSWCRX_VCU_EMS_AccPedalActPst_VCU_EMS_AccPedalActPst_Start
 *  Rte_ReadHook_VED_rSWCRX_VCU_EMS_BrkPedalStVD_VCU_EMS_BrkPedalStVD_Return
 *  Rte_ReadHook_VED_rSWCRX_VCU_EMS_BrkPedalStVD_VCU_EMS_BrkPedalStVD_Start
 *  Rte_ReadHook_VED_rSWCRX_VCU_EMS_BrkPedalSt_VCU_EMS_BrkPedalSt_Return
 *  Rte_ReadHook_VED_rSWCRX_VCU_EMS_BrkPedalSt_VCU_EMS_BrkPedalSt_Start
 *  Rte_ReadHook_VLCSEN_Axera_Signal_Lane_Axera_Lane_Return
 *  Rte_ReadHook_VLCSEN_Axera_Signal_Lane_Axera_Lane_Start
 *  Rte_ReadHook_VLCSEN_ME_Signal_Lane_ME_Lane_Return
 *  Rte_ReadHook_VLCSEN_ME_Signal_Lane_ME_Lane_Start
 *  Rte_ReadHook_VLCSEN_rEM_ST_ECAMtCyclEnvmode_t_ST_ECAMtCyclEnvmode_t_Return
 *  Rte_ReadHook_VLCSEN_rEM_ST_ECAMtCyclEnvmode_t_ST_ECAMtCyclEnvmode_t_Start
 *  Rte_ReadHook_VLCSEN_rEM_ST_Envm_t_CRObjectList_ST_Envm_t_CRObjectList_Return
 *  Rte_ReadHook_VLCSEN_rEM_ST_Envm_t_CRObjectList_ST_Envm_t_CRObjectList_Start
 *  Rte_ReadHook_VLCSEN_rEM_ST_Envm_t_GenObjectList_ST_Envm_t_GenObjectList_Return
 *  Rte_ReadHook_VLCSEN_rEM_ST_Envm_t_GenObjectList_ST_Envm_t_GenObjectList_Start
 *  Rte_ReadHook_VLCSEN_rNVRAM_VLCSen_NVRAMData_t_VLCSen_NVRAMData_t_Return
 *  Rte_ReadHook_VLCSEN_rNVRAM_VLCSen_NVRAMData_t_VLCSen_NVRAMData_t_Start
 *  Rte_ReadHook_VLCSEN_rSWCRX_BCM_LeftTurnLampSt_BCM_LeftTurnLampSt_Return
 *  Rte_ReadHook_VLCSEN_rSWCRX_BCM_LeftTurnLampSt_BCM_LeftTurnLampSt_Start
 *  Rte_ReadHook_VLCSEN_rSWCRX_BCM_RightTurnLampSt_BCM_RightTurnLampSt_Return
 *  Rte_ReadHook_VLCSEN_rSWCRX_BCM_RightTurnLampSt_BCM_RightTurnLampSt_Start
 *  Rte_ReadHook_VLCSEN_rSWCRX_ICM_TotalOdometer_ICM_TotalOdometer_Return
 *  Rte_ReadHook_VLCSEN_rSWCRX_ICM_TotalOdometer_ICM_TotalOdometer_Start
 *  Rte_ReadHook_VLCSEN_rVED_ST_EMVEDVehPar_t_ST_EMVEDVehPar_t_Return
 *  Rte_ReadHook_VLCSEN_rVED_ST_EMVEDVehPar_t_ST_EMVEDVehPar_t_Start
 *  Rte_ReadHook_VLCSEN_rVED_ST_VEDVehDyn_t_ST_VEDVehDyn_t_Return
 *  Rte_ReadHook_VLCSEN_rVED_ST_VEDVehDyn_t_ST_VEDVehDyn_t_Start
 *  Rte_ReadHook_VLCVEH_Axera_Signal_Lane_Axera_Lane_Return
 *  Rte_ReadHook_VLCVEH_Axera_Signal_Lane_Axera_Lane_Start
 *  Rte_ReadHook_VLCVEH_ME_Signal_Lane_ME_Lane_Return
 *  Rte_ReadHook_VLCVEH_ME_Signal_Lane_ME_Lane_Start
 *  Rte_ReadHook_VLCVEH_rNVRAM_ST_VLCVeh_NVRAMData_t_ST_VLCVeh_NVRAMData_t_Return
 *  Rte_ReadHook_VLCVEH_rNVRAM_ST_VLCVeh_NVRAMData_t_ST_VLCVeh_NVRAMData_t_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_ACU_FCWWarnDistanceCfg_ACU_FCWWarnDistanceCfg_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_ACU_FCWWarnDistanceCfg_ACU_FCWWarnDistanceCfg_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_ACU_iACC_SwitchReq_ACU_iACC_SwitchReq_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_ACU_iACC_SwitchReq_ACU_iACC_SwitchReq_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCM_DriverDoorAjarSt_BCM_DriverDoorAjarSt_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCM_DriverDoorAjarSt_BCM_DriverDoorAjarSt_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCM_HazardLampSt_BCM_HazardLampSt_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCM_HazardLampSt_BCM_HazardLampSt_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCM_LeftTurnLampSt_BCM_LeftTurnLampSt_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCM_LeftTurnLampSt_BCM_LeftTurnLampSt_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCM_PsngrDoorAjarSt_BCM_PsngrDoorAjarSt_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCM_PsngrDoorAjarSt_BCM_PsngrDoorAjarSt_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCM_RLDoorAjarSt_BCM_RLDoorAjarSt_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCM_RLDoorAjarSt_BCM_RLDoorAjarSt_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCM_RRDoorAjarSt_BCM_RRDoorAjarSt_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCM_RRDoorAjarSt_BCM_RRDoorAjarSt_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCM_RightTurnLampSt_BCM_RightTurnLampSt_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCM_RightTurnLampSt_BCM_RightTurnLampSt_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_ABSActiveSt_BCS_ABSActiveSt_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_ABSActiveSt_BCS_ABSActiveSt_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_ABSFaultSt_BCS_ABSFaultSt_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_ABSFaultSt_BCS_ABSFaultSt_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_AEBAvailable_BCS_AEBAvailable_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_AEBAvailable_BCS_AEBAvailable_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_AWBActive_BCS_AWBActive_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_AWBActive_BCS_AWBActive_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_ActVehLaltrlAccelVD_BCS_ActVehLaltrlAccelVD_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_ActVehLaltrlAccelVD_BCS_ActVehLaltrlAccelVD_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_ActVehLongAccelVD_BCS_ActVehLongAccelVD_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_ActVehLongAccelVD_BCS_ActVehLongAccelVD_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_ActVehLongAccel_BCS_ActVehLongAccel_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_ActVehLongAccel_BCS_ActVehLongAccel_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_BrakeOverHeat_BCS_BrakeOverHeat_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_BrakeOverHeat_BCS_BrakeOverHeat_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_EBDFaultSt_BCS_EBDFaultSt_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_EBDFaultSt_BCS_EBDFaultSt_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_FLWheelRotatedDirection_BCS_FLWheelRotatedDirection_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_FLWheelRotatedDirection_BCS_FLWheelRotatedDirection_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_FLWheelSpdVD_BCS_FLWheelSpdVD_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_FLWheelSpdVD_BCS_FLWheelSpdVD_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_FRWheelRotatedDirection_BCS_FRWheelRotatedDirection_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_FRWheelRotatedDirection_BCS_FRWheelRotatedDirection_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_FRWheelSpdVD_BCS_FRWheelSpdVD_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_FRWheelSpdVD_BCS_FRWheelSpdVD_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_HDCCtrlSt_BCS_HDCCtrlSt_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_HDCCtrlSt_BCS_HDCCtrlSt_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_NoBrakeForce_BCS_NoBrakeForce_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_NoBrakeForce_BCS_NoBrakeForce_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_RLWheelRotatedDirection_BCS_RLWheelRotatedDirection_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_RLWheelRotatedDirection_BCS_RLWheelRotatedDirection_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_RLWheelSpdVD_BCS_RLWheelSpdVD_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_RLWheelSpdVD_BCS_RLWheelSpdVD_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_RRWheelRotatedDirection_BCS_RRWheelRotatedDirection_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_RRWheelRotatedDirection_BCS_RRWheelRotatedDirection_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_RRWheelSpdVD_BCS_RRWheelSpdVD_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_RRWheelSpdVD_BCS_RRWheelSpdVD_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_TCSActiveSt_BCS_TCSActiveSt_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_TCSActiveSt_BCS_TCSActiveSt_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_TCSFaultSt_BCS_TCSFaultSt_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_TCSFaultSt_BCS_TCSFaultSt_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_TCSOff_BCS_TCSOff_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_TCSOff_BCS_TCSOff_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_VehSpdVD_BCS_VehSpdVD_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_VehSpdVD_BCS_VehSpdVD_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_VehSpd_BCS_VehSpd_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_VehSpd_BCS_VehSpd_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_VehicleStandStillSt_BCS_VehicleStandStillSt_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_VehicleStandStillSt_BCS_VehicleStandStillSt_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_YawRateSt_BCS_YawRateSt_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BCS_YawRateSt_BCS_YawRateSt_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_BSDM_RCTBPrefillReq_BSDM_RCTBPrefillReq_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_BSDM_RCTBPrefillReq_BSDM_RCTBPrefillReq_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_EMS_ACCButtInfo_EMS_ACCButtInfo_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_EMS_ACCButtInfo_EMS_ACCButtInfo_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_EPB_FailSt_EPB_SysSt_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_EPB_FailSt_EPB_SysSt_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_EPB_SysSt_EPB_SysSt_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_EPB_SysSt_EPB_SysSt_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_EPS_SteeringAngleSpdVD_EPS_SteeringAngleSpdVD_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_EPS_SteeringAngleSpdVD_EPS_SteeringAngleSpdVD_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_EPS_SteeringAngleSpd_EPS_SteeringAngleSpd_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_EPS_SteeringAngleSpd_EPS_SteeringAngleSpd_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_EPS_SteeringAngleVD_EPS_SteeringAngleVD_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_EPS_SteeringAngleVD_EPS_SteeringAngleVD_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_EPS_SteeringAngle_EPS_SteeringAngle_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_EPS_SteeringAngle_EPS_SteeringAngle_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_ICM_DisFail_ICM_DisFail_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_ICM_DisFail_ICM_DisFail_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_ICM_TotalOdometer_ICM_TotalOdometer_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_ICM_TotalOdometer_ICM_TotalOdometer_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_ICM_VehInsSpd_ICM_VehInsSpd_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_ICM_VehInsSpd_ICM_VehInsSpd_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_SAS_CalibratedSt_SAS_CalibratedSt_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_SAS_CalibratedSt_SAS_CalibratedSt_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_SRS_DriverSeatBeltSt_SRS_DriverSeatBeltSt_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_SRS_DriverSeatBeltSt_SRS_DriverSeatBeltSt_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_SWSM_A_CD_Add_Overtime_SWSM_A_CD_Add_Overtime_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_SWSM_A_CD_Add_Overtime_SWSM_A_CD_Add_Overtime_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_SWSM_A_CD_Minus_Overtime_SWSM_A_CD_Minus_Overtime_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_SWSM_A_CD_Minus_Overtime_SWSM_A_CD_Minus_Overtime_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_SWSM_A_CruiseDistance_Add_SWSM_A_CruiseDistance_Add_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_SWSM_A_CruiseDistance_Add_SWSM_A_CruiseDistance_Add_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_SWSM_A_CruiseDistance_Minus_SWSM_A_CruiseDistance_Minus_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_SWSM_A_CruiseDistance_Minus_SWSM_A_CruiseDistance_Minus_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_SWSM_A_CruiseSpeed_Add_SWSM_A_CruiseSpeed_Add_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_SWSM_A_CruiseSpeed_Add_SWSM_A_CruiseSpeed_Add_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_SWSM_A_CruiseSpeed_Minus_SWSM_A_CruiseSpeed_Minus_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_SWSM_A_CruiseSpeed_Minus_SWSM_A_CruiseSpeed_Minus_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_VCU_AccDriverOrvd_VCU_AccDriverOrvd_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_VCU_AccDriverOrvd_VCU_AccDriverOrvd_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_VCU_CrntGearLvlVD_VCU_CrntGearLvlVD_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_VCU_CrntGearLvlVD_VCU_CrntGearLvlVD_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_VCU_CrntGearLvl_VCU_CrntGearLvl_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_VCU_CrntGearLvl_VCU_CrntGearLvl_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_VCU_EMS_AccPedalActPstVD_VCU_EMS_AccPedalActPstVD_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_VCU_EMS_AccPedalActPstVD_VCU_EMS_AccPedalActPstVD_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_VCU_EMS_AccPedalActPst_VCU_EMS_AccPedalActPst_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_VCU_EMS_AccPedalActPst_VCU_EMS_AccPedalActPst_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_VCU_EMS_BrkPedalStVD_VCU_EMS_BrkPedalStVD_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_VCU_EMS_BrkPedalStVD_VCU_EMS_BrkPedalStVD_Start
 *  Rte_ReadHook_VLCVEH_rSWCRX_VCU_EMS_BrkPedalSt_VCU_EMS_BrkPedalSt_Return
 *  Rte_ReadHook_VLCVEH_rSWCRX_VCU_EMS_BrkPedalSt_VCU_EMS_BrkPedalSt_Start
 *  Rte_ReadHook_VLCVEH_rVED_ST_EMVEDVehPar_t_ST_EMVEDVehPar_t_Return
 *  Rte_ReadHook_VLCVEH_rVED_ST_EMVEDVehPar_t_ST_EMVEDVehPar_t_Start
 *  Rte_ReadHook_VLCVEH_rVED_ST_VEDVehDyn_t_ST_VEDVehDyn_t_Return
 *  Rte_ReadHook_VLCVEH_rVED_ST_VEDVehDyn_t_ST_VEDVehDyn_t_Start
 *  Rte_ReadHook_VLCVEH_rVED_ST_VEDVehSig_t_ST_VEDVehSig_t_Return
 *  Rte_ReadHook_VLCVEH_rVED_ST_VEDVehSig_t_ST_VEDVehSig_t_Start
 *  Rte_ReadHook_VLCVEH_rVLCSEN_ST_VLCSen_AccOOI_List_t_ST_VLCSen_AccOOI_List_t_Return
 *  Rte_ReadHook_VLCVEH_rVLCSEN_ST_VLCSen_AccOOI_List_t_ST_VLCSen_AccOOI_List_t_Start
 *  Rte_ReadHook_VLCVEH_rVLCSEN_ST_VLCSen_HypothesisIntf_t_ST_VLCSen_HypothesisIntf_t_Return
 *  Rte_ReadHook_VLCVEH_rVLCSEN_ST_VLCSen_HypothesisIntf_t_ST_VLCSen_HypothesisIntf_t_Start
 *  Rte_ReadHook_VLCVEH_rVLCSEN_ST_VLCSen_acc_object_t_ST_VLCSen_acc_object_t_Return
 *  Rte_ReadHook_VLCVEH_rVLCSEN_ST_VLCSen_acc_object_t_ST_VLCSen_acc_object_t_Start
 *  Rte_ReadHook_VLCVEH_rVLCSEN_ST_VLCSen_acc_output_data_t_ST_VLCSen_acc_output_data_t_Return
 *  Rte_ReadHook_VLCVEH_rVLCSEN_ST_VLCSen_acc_output_data_t_ST_VLCSen_acc_output_data_t_Start
 *  Rte_Runnable_BswM_BswM_MainFunction_Return
 *  Rte_Runnable_BswM_BswM_MainFunction_Start
 *  Rte_Runnable_ComM_ComM_MainFunction_0_Return
 *  Rte_Runnable_ComM_ComM_MainFunction_0_Start
 *  Rte_Runnable_ComM_ComM_MainFunction_1_Return
 *  Rte_Runnable_ComM_ComM_MainFunction_1_Start
 *  Rte_Runnable_ComM_ComM_MainFunction_2_Return
 *  Rte_Runnable_ComM_ComM_MainFunction_2_Start
 *  Rte_Runnable_ComM_GetCurrentComMode_Return
 *  Rte_Runnable_ComM_GetCurrentComMode_Start
 *  Rte_Runnable_ComM_GetInhibitionStatus_Return
 *  Rte_Runnable_ComM_GetInhibitionStatus_Start
 *  Rte_Runnable_ComM_GetMaxComMode_Return
 *  Rte_Runnable_ComM_GetMaxComMode_Start
 *  Rte_Runnable_ComM_GetRequestedComMode_Return
 *  Rte_Runnable_ComM_GetRequestedComMode_Start
 *  Rte_Runnable_ComM_LimitChannelToNoComMode_Return
 *  Rte_Runnable_ComM_LimitChannelToNoComMode_Start
 *  Rte_Runnable_ComM_LimitECUToNoComMode_Return
 *  Rte_Runnable_ComM_LimitECUToNoComMode_Start
 *  Rte_Runnable_ComM_PreventWakeUp_Return
 *  Rte_Runnable_ComM_PreventWakeUp_Start
 *  Rte_Runnable_ComM_ReadInhibitCounter_Return
 *  Rte_Runnable_ComM_ReadInhibitCounter_Start
 *  Rte_Runnable_ComM_RequestComMode_Return
 *  Rte_Runnable_ComM_RequestComMode_Start
 *  Rte_Runnable_ComM_ResetInhibitCounter_Return
 *  Rte_Runnable_ComM_ResetInhibitCounter_Start
 *  Rte_Runnable_ComM_SetECUGroupClassification_Return
 *  Rte_Runnable_ComM_SetECUGroupClassification_Start
 *  Rte_Runnable_Core4Dummy_Core4DummyRunnablee_Return
 *  Rte_Runnable_Core4Dummy_Core4DummyRunnablee_Start
 *  Rte_Runnable_Core5Dummy_Core5DummyRunnable_Return
 *  Rte_Runnable_Core5Dummy_Core5DummyRunnable_Start
 *  Rte_Runnable_Cpr_Cpr_InitFunction_Return
 *  Rte_Runnable_Cpr_Cpr_InitFunction_Start
 *  Rte_Runnable_Cpr_Cpr_MainFunction_Return
 *  Rte_Runnable_Cpr_Cpr_MainFunction_Start
 *  Rte_Runnable_Cps_Cps_InitFunction_Return
 *  Rte_Runnable_Cps_Cps_InitFunction_Start
 *  Rte_Runnable_Cps_Cps_MainFunction_Return
 *  Rte_Runnable_Cps_Cps_MainFunction_Start
 *  Rte_Runnable_DMC_DMC_Init_Return
 *  Rte_Runnable_DMC_DMC_Init_Start
 *  Rte_Runnable_DMC_DMC_Step_Return
 *  Rte_Runnable_DMC_DMC_Step_Start
 *  Rte_Runnable_Dcm_Dcm_MainFunction_Return
 *  Rte_Runnable_Dcm_Dcm_MainFunction_Start
 *  Rte_Runnable_Dcm_GetActiveProtocol_Return
 *  Rte_Runnable_Dcm_GetActiveProtocol_Start
 *  Rte_Runnable_Dcm_GetRequestKind_Return
 *  Rte_Runnable_Dcm_GetRequestKind_Start
 *  Rte_Runnable_Dcm_GetSecurityLevel_Return
 *  Rte_Runnable_Dcm_GetSecurityLevel_Start
 *  Rte_Runnable_Dcm_GetSesCtrlType_Return
 *  Rte_Runnable_Dcm_GetSesCtrlType_Start
 *  Rte_Runnable_Dcm_ResetToDefaultSession_Return
 *  Rte_Runnable_Dcm_ResetToDefaultSession_Start
 *  Rte_Runnable_Dcm_SetActiveDiagnostic_Return
 *  Rte_Runnable_Dcm_SetActiveDiagnostic_Start
 *  Rte_Runnable_DemMaster_0_ClearDTC_Return
 *  Rte_Runnable_DemMaster_0_ClearDTC_Start
 *  Rte_Runnable_DemMaster_0_Dem_MasterMainFunction_Return
 *  Rte_Runnable_DemMaster_0_Dem_MasterMainFunction_Start
 *  Rte_Runnable_DemMaster_0_GetDTCOfEvent_Return
 *  Rte_Runnable_DemMaster_0_GetDTCOfEvent_Start
 *  Rte_Runnable_DemMaster_0_GetDTCStatusAvailabilityMask_Return
 *  Rte_Runnable_DemMaster_0_GetDTCStatusAvailabilityMask_Start
 *  Rte_Runnable_DemMaster_0_GetDebouncingOfEvent_Return
 *  Rte_Runnable_DemMaster_0_GetDebouncingOfEvent_Start
 *  Rte_Runnable_DemMaster_0_GetEventEnableCondition_Return
 *  Rte_Runnable_DemMaster_0_GetEventEnableCondition_Start
 *  Rte_Runnable_DemMaster_0_GetEventExtendedDataRecordEx_Return
 *  Rte_Runnable_DemMaster_0_GetEventExtendedDataRecordEx_Start
 *  Rte_Runnable_DemMaster_0_GetEventFailed_Return
 *  Rte_Runnable_DemMaster_0_GetEventFailed_Start
 *  Rte_Runnable_DemMaster_0_GetEventFreezeFrameDataEx_Return
 *  Rte_Runnable_DemMaster_0_GetEventFreezeFrameDataEx_Start
 *  Rte_Runnable_DemMaster_0_GetEventMemoryOverflow_Return
 *  Rte_Runnable_DemMaster_0_GetEventMemoryOverflow_Start
 *  Rte_Runnable_DemMaster_0_GetEventStatus_Return
 *  Rte_Runnable_DemMaster_0_GetEventStatus_Start
 *  Rte_Runnable_DemMaster_0_GetEventTested_Return
 *  Rte_Runnable_DemMaster_0_GetEventTested_Start
 *  Rte_Runnable_DemMaster_0_GetEventUdsStatus_Return
 *  Rte_Runnable_DemMaster_0_GetEventUdsStatus_Start
 *  Rte_Runnable_DemMaster_0_GetFaultDetectionCounter_Return
 *  Rte_Runnable_DemMaster_0_GetFaultDetectionCounter_Start
 *  Rte_Runnable_DemMaster_0_GetMonitorStatus_Return
 *  Rte_Runnable_DemMaster_0_GetMonitorStatus_Start
 *  Rte_Runnable_DemMaster_0_GetNumberOfEventMemoryEntries_Return
 *  Rte_Runnable_DemMaster_0_GetNumberOfEventMemoryEntries_Start
 *  Rte_Runnable_DemMaster_0_GetOperationCycleState_Return
 *  Rte_Runnable_DemMaster_0_GetOperationCycleState_Start
 *  Rte_Runnable_DemMaster_0_PostRunRequested_Return
 *  Rte_Runnable_DemMaster_0_PostRunRequested_Start
 *  Rte_Runnable_DemMaster_0_SelectDTC_Return
 *  Rte_Runnable_DemMaster_0_SelectDTC_Start
 *  Rte_Runnable_DemMaster_0_SetOperationCycleState_Return
 *  Rte_Runnable_DemMaster_0_SetOperationCycleState_Start
 *  Rte_Runnable_DemSatellite_0_Dem_SatelliteMainFunction_Return
 *  Rte_Runnable_DemSatellite_0_Dem_SatelliteMainFunction_Start
 *  Rte_Runnable_DemSatellite_0_GetDTCOfEvent_Return
 *  Rte_Runnable_DemSatellite_0_GetDTCOfEvent_Start
 *  Rte_Runnable_DemSatellite_0_GetDebouncingOfEvent_Return
 *  Rte_Runnable_DemSatellite_0_GetDebouncingOfEvent_Start
 *  Rte_Runnable_DemSatellite_0_GetEventEnableCondition_Return
 *  Rte_Runnable_DemSatellite_0_GetEventEnableCondition_Start
 *  Rte_Runnable_DemSatellite_0_GetEventExtendedDataRecordEx_Return
 *  Rte_Runnable_DemSatellite_0_GetEventExtendedDataRecordEx_Start
 *  Rte_Runnable_DemSatellite_0_GetEventFailed_Return
 *  Rte_Runnable_DemSatellite_0_GetEventFailed_Start
 *  Rte_Runnable_DemSatellite_0_GetEventFreezeFrameDataEx_Return
 *  Rte_Runnable_DemSatellite_0_GetEventFreezeFrameDataEx_Start
 *  Rte_Runnable_DemSatellite_0_GetEventStatus_Return
 *  Rte_Runnable_DemSatellite_0_GetEventStatus_Start
 *  Rte_Runnable_DemSatellite_0_GetEventTested_Return
 *  Rte_Runnable_DemSatellite_0_GetEventTested_Start
 *  Rte_Runnable_DemSatellite_0_GetEventUdsStatus_Return
 *  Rte_Runnable_DemSatellite_0_GetEventUdsStatus_Start
 *  Rte_Runnable_DemSatellite_0_GetFaultDetectionCounter_Return
 *  Rte_Runnable_DemSatellite_0_GetFaultDetectionCounter_Start
 *  Rte_Runnable_DemSatellite_0_GetMonitorStatus_Return
 *  Rte_Runnable_DemSatellite_0_GetMonitorStatus_Start
 *  Rte_Runnable_DemSatellite_0_ResetEventDebounceStatus_Return
 *  Rte_Runnable_DemSatellite_0_ResetEventDebounceStatus_Start
 *  Rte_Runnable_DemSatellite_0_ResetEventStatus_Return
 *  Rte_Runnable_DemSatellite_0_ResetEventStatus_Start
 *  Rte_Runnable_DemSatellite_0_SetEventStatus_Return
 *  Rte_Runnable_DemSatellite_0_SetEventStatus_Start
 *  Rte_Runnable_Det_ReportError_Return
 *  Rte_Runnable_Det_ReportError_Start
 *  Rte_Runnable_EM_EM_Init_Return
 *  Rte_Runnable_EM_EM_Init_Start
 *  Rte_Runnable_EM_EM_Step_Return
 *  Rte_Runnable_EM_EM_Step_Start
 *  Rte_Runnable_EcuM_EcuM_MainFunction_Return
 *  Rte_Runnable_EcuM_EcuM_MainFunction_Start
 *  Rte_Runnable_EcuM_GetBootTarget_Return
 *  Rte_Runnable_EcuM_GetBootTarget_Start
 *  Rte_Runnable_EcuM_GetLastShutdownTarget_Return
 *  Rte_Runnable_EcuM_GetLastShutdownTarget_Start
 *  Rte_Runnable_EcuM_GetShutdownCause_Return
 *  Rte_Runnable_EcuM_GetShutdownCause_Start
 *  Rte_Runnable_EcuM_GetShutdownTarget_Return
 *  Rte_Runnable_EcuM_GetShutdownTarget_Start
 *  Rte_Runnable_EcuM_SelectBootTarget_Return
 *  Rte_Runnable_EcuM_SelectBootTarget_Start
 *  Rte_Runnable_EcuM_SelectShutdownCause_Return
 *  Rte_Runnable_EcuM_SelectShutdownCause_Start
 *  Rte_Runnable_EcuM_SelectShutdownTarget_Return
 *  Rte_Runnable_EcuM_SelectShutdownTarget_Start
 *  Rte_Runnable_FCU_Fcu_Init_Return
 *  Rte_Runnable_FCU_Fcu_Init_Start
 *  Rte_Runnable_FCU_Fcu_MainFunction_Return
 *  Rte_Runnable_FCU_Fcu_MainFunction_Start
 *  Rte_Runnable_LCFSEN_LCFSEN_Init_Return
 *  Rte_Runnable_LCFSEN_LCFSEN_Init_Start
 *  Rte_Runnable_LCFSEN_LCFSEN_Step_Return
 *  Rte_Runnable_LCFSEN_LCFSEN_Step_Start
 *  Rte_Runnable_LCFVEH_LCFVEH_Init_Return
 *  Rte_Runnable_LCFVEH_LCFVEH_Init_Start
 *  Rte_Runnable_LCFVEH_LCFVEH_Step_Return
 *  Rte_Runnable_LCFVEH_LCFVEH_Step_Start
 *  Rte_Runnable_Os_OsCore0_swc_GetCounterValue_Return
 *  Rte_Runnable_Os_OsCore0_swc_GetCounterValue_Start
 *  Rte_Runnable_Os_OsCore0_swc_GetElapsedValue_Return
 *  Rte_Runnable_Os_OsCore0_swc_GetElapsedValue_Start
 *  Rte_Runnable_Os_OsCore1_swc_GetCounterValue_Return
 *  Rte_Runnable_Os_OsCore1_swc_GetCounterValue_Start
 *  Rte_Runnable_Os_OsCore1_swc_GetElapsedValue_Return
 *  Rte_Runnable_Os_OsCore1_swc_GetElapsedValue_Start
 *  Rte_Runnable_Os_OsCore2_swc_GetCounterValue_Return
 *  Rte_Runnable_Os_OsCore2_swc_GetCounterValue_Start
 *  Rte_Runnable_Os_OsCore2_swc_GetElapsedValue_Return
 *  Rte_Runnable_Os_OsCore2_swc_GetElapsedValue_Start
 *  Rte_Runnable_Os_OsCore3_swc_GetCounterValue_Return
 *  Rte_Runnable_Os_OsCore3_swc_GetCounterValue_Start
 *  Rte_Runnable_Os_OsCore3_swc_GetElapsedValue_Return
 *  Rte_Runnable_Os_OsCore3_swc_GetElapsedValue_Start
 *  Rte_Runnable_Os_OsCore4_swc_GetCounterValue_Return
 *  Rte_Runnable_Os_OsCore4_swc_GetCounterValue_Start
 *  Rte_Runnable_Os_OsCore4_swc_GetElapsedValue_Return
 *  Rte_Runnable_Os_OsCore4_swc_GetElapsedValue_Start
 *  Rte_Runnable_Os_OsCore5_swc_GetCounterValue_Return
 *  Rte_Runnable_Os_OsCore5_swc_GetCounterValue_Start
 *  Rte_Runnable_Os_OsCore5_swc_GetElapsedValue_Return
 *  Rte_Runnable_Os_OsCore5_swc_GetElapsedValue_Start
 *  Rte_Runnable_SDC_Sdc_InitFunction_Return
 *  Rte_Runnable_SDC_Sdc_InitFunction_Start
 *  Rte_Runnable_SDC_Sdc_MainFunction_Return
 *  Rte_Runnable_SDC_Sdc_MainFunction_Start
 *  Rte_Runnable_UDC_Udc_InitFunction_Return
 *  Rte_Runnable_UDC_Udc_InitFunction_Start
 *  Rte_Runnable_UDC_Udc_MainFunction_Return
 *  Rte_Runnable_UDC_Udc_MainFunction_Start
 *  Rte_Runnable_VED_VED_Init_Return
 *  Rte_Runnable_VED_VED_Init_Start
 *  Rte_Runnable_VED_VED_Step_Return
 *  Rte_Runnable_VED_VED_Step_Start
 *  Rte_Runnable_VLCSEN_VLCSEN_Init_Return
 *  Rte_Runnable_VLCSEN_VLCSEN_Init_Start
 *  Rte_Runnable_VLCSEN_VLCSEN_Step_Return
 *  Rte_Runnable_VLCSEN_VLCSEN_Step_Start
 *  Rte_Runnable_VLCVEH_VLCVEH_Init_Return
 *  Rte_Runnable_VLCVEH_VLCVEH_Init_Start
 *  Rte_Runnable_VLCVEH_VLCVEH_Step_Return
 *  Rte_Runnable_VLCVEH_VLCVEH_Step_Start
 *  Rte_Runnable_Xcp_Events_Xcp_Event_100ms_Return
 *  Rte_Runnable_Xcp_Events_Xcp_Event_100ms_Start
 *  Rte_Runnable_Xcp_Events_Xcp_Event_20ms_Return
 *  Rte_Runnable_Xcp_Events_Xcp_Event_20ms_Start
 *  Rte_Runnable_Xcp_Events_Xcp_Event_50ms_Return
 *  Rte_Runnable_Xcp_Events_Xcp_Event_50ms_Start
 *  Rte_SwitchAckHook_Dcm_DcmEcuReset_DcmEcuReset_Return
 *  Rte_SwitchAckHook_Dcm_DcmEcuReset_DcmEcuReset_Start
 *  Rte_SwitchHook_BswM_Switch_ESH_ModeSwitch_BswM_MDGP_ESH_Mode_Return
 *  Rte_SwitchHook_BswM_Switch_ESH_ModeSwitch_BswM_MDGP_ESH_Mode_Start
 *  Rte_SwitchHook_Dcm_DcmControlDtcSetting_DcmControlDtcSetting_Return
 *  Rte_SwitchHook_Dcm_DcmControlDtcSetting_DcmControlDtcSetting_Start
 *  Rte_SwitchHook_Dcm_DcmDiagnosticSessionControl_DcmDiagnosticSessionControl_Return
 *  Rte_SwitchHook_Dcm_DcmDiagnosticSessionControl_DcmDiagnosticSessionControl_Start
 *  Rte_SwitchHook_Dcm_DcmEcuReset_DcmEcuReset_Return
 *  Rte_SwitchHook_Dcm_DcmEcuReset_DcmEcuReset_Start
 *  Rte_Task_Activate
 *  Rte_Task_Dispatch
 *  Rte_Task_WaitEvent
 *  Rte_Task_WaitEventRet
 *  Rte_WriteHook_DMC_pDMC_ST_LCF_DmcGenericOutputs_t_ST_LCF_DmcGenericOutputs_t_Return
 *  Rte_WriteHook_DMC_pDMC_ST_LCF_DmcGenericOutputs_t_ST_LCF_DmcGenericOutputs_t_Start
 *  Rte_WriteHook_DMC_pDMC_ST_LCF_DmcNVRAMData_t_ST_LCF_DmcNVRAMData_t_Return
 *  Rte_WriteHook_DMC_pDMC_ST_LCF_DmcNVRAMData_t_ST_LCF_DmcNVRAMData_t_Start
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_HWAHF_CrrtCycLock_ADAS_HWAHF_CrrtCycLock_Return
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_HWAHF_CrrtCycLock_ADAS_HWAHF_CrrtCycLock_Start
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_HWAHF_FailureSt_ADAS_HWAHF_FailureSt_Return
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_HWAHF_FailureSt_ADAS_HWAHF_FailureSt_Start
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_HWA_EnableSt_ADAS_HWA_EnableSt_Return
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_HWA_EnableSt_ADAS_HWA_EnableSt_Start
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_HWA_FailureSt_ADAS_HWA_FailureSt_Return
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_HWA_FailureSt_ADAS_HWA_FailureSt_Start
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_HWA_ILCAbortReason_ADAS_HWA_ILCAbortReason_Return
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_HWA_ILCAbortReason_ADAS_HWA_ILCAbortReason_Start
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_HWA_ILCAbortSoundWarn_ADAS_HWA_ILCAbortSoundWarn_Return
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_HWA_ILCAbortSoundWarn_ADAS_HWA_ILCAbortSoundWarn_Start
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_HWA_ILCLeftIndicator_ADAS_HWA_ILCLeftIndicator_Return
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_HWA_ILCLeftIndicator_ADAS_HWA_ILCLeftIndicator_Start
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_HWA_ILCLeftSt_ADAS_HWA_ILCLeftSt_Return
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_HWA_ILCLeftSt_ADAS_HWA_ILCLeftSt_Start
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_HWA_ILCRightIndicator_ADAS_HWA_ILCRightIndicator_Return
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_HWA_ILCRightIndicator_ADAS_HWA_ILCRightIndicator_Start
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_HWA_ILCRighttSt_ADAS_HWA_ILCRighttSt_Return
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_HWA_ILCRighttSt_ADAS_HWA_ILCRighttSt_Start
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_HWA_ILCTextInfo_ADAS_HWA_ILCTextInfo_Return
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_HWA_ILCTextInfo_ADAS_HWA_ILCTextInfo_Start
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_L2FunReqSt_ADAS_L2FunReqSt_Return
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_L2FunReqSt_ADAS_L2FunReqSt_Start
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_L3FunReqSt_ADAS_L3FunReqSt_Return
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_L3FunReqSt_ADAS_L3FunReqSt_Start
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_LateralCtrlSt_ADAS_LateralCtrlSt_Return
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_LateralCtrlSt_ADAS_LateralCtrlSt_Start
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_LateralCtrlTyp_ADAS_LateralCtrlTyp_Return
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_LateralCtrlTyp_ADAS_LateralCtrlTyp_Start
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_StrAngleReq_ADAS_StrAngleReq_Return
 *  Rte_WriteHook_DMC_pSWCTX_ADAS_StrAngleReq_ADAS_StrAngleReq_Start
 *  Rte_WriteHook_DMC_pSWCTX_EPS_LKACtrlSt_EPS_LKACtrlSt_Return
 *  Rte_WriteHook_DMC_pSWCTX_EPS_LKACtrlSt_EPS_LKACtrlSt_Start
 *  Rte_WriteHook_DMC_pSWCTX_IFC_CameraBlockageSt_IFC_CameraBlockageSt_Return
 *  Rte_WriteHook_DMC_pSWCTX_IFC_CameraBlockageSt_IFC_CameraBlockageSt_Start
 *  Rte_WriteHook_DMC_pSWCTX_IFC_ELKSt_IFC_ELKSt_Return
 *  Rte_WriteHook_DMC_pSWCTX_IFC_ELKSt_IFC_ELKSt_Start
 *  Rte_WriteHook_DMC_pSWCTX_IFC_ELKWarnL_IFC_ELKWarnL_Return
 *  Rte_WriteHook_DMC_pSWCTX_IFC_ELKWarnL_IFC_ELKWarnL_Start
 *  Rte_WriteHook_DMC_pSWCTX_IFC_ELKWarnR_IFC_ELKWarnR_Return
 *  Rte_WriteHook_DMC_pSWCTX_IFC_ELKWarnR_IFC_ELKWarnR_Start
 *  Rte_WriteHook_DMC_pSWCTX_IFC_LKS_LaneAssistType_IFC_LKS_LaneAssistType_Return
 *  Rte_WriteHook_DMC_pSWCTX_IFC_LKS_LaneAssistType_IFC_LKS_LaneAssistType_Start
 *  Rte_WriteHook_DMC_pSWCTX_IFC_LateralCtrlQuitWarn_IFC_LateralCtrlQuitWarn_Return
 *  Rte_WriteHook_DMC_pSWCTX_IFC_LateralCtrlQuitWarn_IFC_LateralCtrlQuitWarn_Start
 *  Rte_WriteHook_DMC_pSWCTX_IFC_LeftTrackingSt_IFC_LeftTrackingSt_Return
 *  Rte_WriteHook_DMC_pSWCTX_IFC_LeftTrackingSt_IFC_LeftTrackingSt_Start
 *  Rte_WriteHook_DMC_pSWCTX_IFC_RightTrackingSt_IFC_RightTrackingSt_Return
 *  Rte_WriteHook_DMC_pSWCTX_IFC_RightTrackingSt_IFC_RightTrackingSt_Start
 *  Rte_WriteHook_DMC_pSWCTX_IFC_SysCalibrationSt_IFC_SysCalibrationSt_Return
 *  Rte_WriteHook_DMC_pSWCTX_IFC_SysCalibrationSt_IFC_SysCalibrationSt_Start
 *  Rte_WriteHook_DMC_pSWCTX_IFC_TorqueReqSt_IFC_TorqueReqSt_Return
 *  Rte_WriteHook_DMC_pSWCTX_IFC_TorqueReqSt_IFC_TorqueReqSt_Start
 *  Rte_WriteHook_DMC_pSWCTX_IFC_TorqueReq_IFC_TorqueReq_Return
 *  Rte_WriteHook_DMC_pSWCTX_IFC_TorqueReq_IFC_TorqueReq_Start
 *  Rte_WriteHook_DMC_pSWCTX_LKS_Status_LKS_Status_Return
 *  Rte_WriteHook_DMC_pSWCTX_LKS_Status_LKS_Status_Start
 *  Rte_WriteHook_DMC_pSWCTX_PCS_LDWStatus_PCS_LDWStatus_Return
 *  Rte_WriteHook_DMC_pSWCTX_PCS_LDWStatus_PCS_LDWStatus_Start
 *  Rte_WriteHook_EM_pEM_ST_ADASHighlightID_t_ST_ADASHighlightID_t_Return
 *  Rte_WriteHook_EM_pEM_ST_ADASHighlightID_t_ST_ADASHighlightID_t_Start
 *  Rte_WriteHook_EM_pEM_ST_ECAMtCyclEnvmode_t_ST_ECAMtCyclEnvmode_t_Return
 *  Rte_WriteHook_EM_pEM_ST_ECAMtCyclEnvmode_t_ST_ECAMtCyclEnvmode_t_Start
 *  Rte_WriteHook_EM_pEM_ST_EMFusionGenObjList_t_ST_EMFusionGenObjList_t_Return
 *  Rte_WriteHook_EM_pEM_ST_EMFusionGenObjList_t_ST_EMFusionGenObjList_t_Start
 *  Rte_WriteHook_EM_pEM_ST_ENVODD2MCU_t_ST_ENVODD2MCU_t_Return
 *  Rte_WriteHook_EM_pEM_ST_ENVODD2MCU_t_ST_ENVODD2MCU_t_Start
 *  Rte_WriteHook_EM_pEM_ST_EnvmNvm_t_ST_EnvmNvm_t_Return
 *  Rte_WriteHook_EM_pEM_ST_EnvmNvm_t_ST_EnvmNvm_t_Start
 *  Rte_WriteHook_EM_pEM_ST_Envm_TrafficLight_t_ST_Envm_TrafficLight_t_Return
 *  Rte_WriteHook_EM_pEM_ST_Envm_TrafficLight_t_ST_Envm_TrafficLight_t_Start
 *  Rte_WriteHook_EM_pEM_ST_Envm_TrafficSign_t_ST_Envm_TrafficSign_t_Return
 *  Rte_WriteHook_EM_pEM_ST_Envm_TrafficSign_t_ST_Envm_TrafficSign_t_Start
 *  Rte_WriteHook_EM_pEM_ST_Envm_t_CRObjectList_ST_Envm_t_CRObjectList_Return
 *  Rte_WriteHook_EM_pEM_ST_Envm_t_CRObjectList_ST_Envm_t_CRObjectList_Start
 *  Rte_WriteHook_EM_pEM_ST_Envm_t_GenObjectList_ST_Envm_t_GenObjectList_Return
 *  Rte_WriteHook_EM_pEM_ST_Envm_t_GenObjectList_ST_Envm_t_GenObjectList_Start
 *  Rte_WriteHook_EM_pEM_ST_FusionLine_t_ST_FusionLine_t_Return
 *  Rte_WriteHook_EM_pEM_ST_FusionLine_t_ST_FusionLine_t_Start
 *  Rte_WriteHook_EM_pEM_ST_RoadSemantics2MCU_t_ST_RoadSemantics2MCU_t_Return
 *  Rte_WriteHook_EM_pEM_ST_RoadSemantics2MCU_t_ST_RoadSemantics2MCU_t_Start
 *  Rte_WriteHook_EM_pEM_ST_VEDVehDyn_t_SyncEgo_ST_VEDVehDyn_t_SyncEgo_Return
 *  Rte_WriteHook_EM_pEM_ST_VEDVehDyn_t_SyncEgo_ST_VEDVehDyn_t_SyncEgo_Start
 *  Rte_WriteHook_FCU_rSWCRX_ACU_FCWWarnDistanceCfg_ACU_FCWWarnDistanceCfg_Return
 *  Rte_WriteHook_FCU_rSWCRX_ACU_FCWWarnDistanceCfg_ACU_FCWWarnDistanceCfg_Start
 *  Rte_WriteHook_FCU_rSWCRX_ACU_LDW_LKACfg_ACU_LDW_LKACfg_Return
 *  Rte_WriteHook_FCU_rSWCRX_ACU_LDW_LKACfg_ACU_LDW_LKACfg_Start
 *  Rte_WriteHook_FCU_rSWCRX_ACU_iACC_SwitchReq_ACU_iACC_SwitchReq_Return
 *  Rte_WriteHook_FCU_rSWCRX_ACU_iACC_SwitchReq_ACU_iACC_SwitchReq_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCM_DriverDoorAjarSt_BCM_DriverDoorAjarSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCM_DriverDoorAjarSt_BCM_DriverDoorAjarSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCM_FrontFogLampSt_BCM_FrontFogLampSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCM_FrontFogLampSt_BCM_FrontFogLampSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCM_FrontWasherSt_BCM_FrontWasherSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCM_FrontWasherSt_BCM_FrontWasherSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCM_FrontWiperSt_BCM_FrontWiperSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCM_FrontWiperSt_BCM_FrontWiperSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCM_HazardLampSt_BCM_HazardLampSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCM_HazardLampSt_BCM_HazardLampSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCM_HighBeamSt_BCM_HighBeamSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCM_HighBeamSt_BCM_HighBeamSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCM_KeySt_BCM_KeySt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCM_KeySt_BCM_KeySt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCM_LeftTurnLampSt_BCM_LeftTurnLampSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCM_LeftTurnLampSt_BCM_LeftTurnLampSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCM_LowBeamSt_BCM_LowBeamSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCM_LowBeamSt_BCM_LowBeamSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCM_PsngrDoorAjarSt_BCM_PsngrDoorAjarSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCM_PsngrDoorAjarSt_BCM_PsngrDoorAjarSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCM_RLDoorAjarSt_BCM_RLDoorAjarSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCM_RLDoorAjarSt_BCM_RLDoorAjarSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCM_RRDoorAjarSt_BCM_RRDoorAjarSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCM_RRDoorAjarSt_BCM_RRDoorAjarSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCM_RearFogLampSt_BCM_RearFogLampSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCM_RearFogLampSt_BCM_RearFogLampSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCM_RightTurnLampSt_BCM_RightTurnLampSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCM_RightTurnLampSt_BCM_RightTurnLampSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCM_TurnLightSwitchSt_BCM_TurnLightSwitchSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCM_TurnLightSwitchSt_BCM_TurnLightSwitchSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_ABSActiveSt_BCS_ABSActiveSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_ABSActiveSt_BCS_ABSActiveSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_ABSFaultSt_BCS_ABSFaultSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_ABSFaultSt_BCS_ABSFaultSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_AEBAvailable_BCS_AEBAvailable_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_AEBAvailable_BCS_AEBAvailable_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_AWBActive_BCS_AWBActive_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_AWBActive_BCS_AWBActive_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_ActVehLaltrlAccelVD_BCS_ActVehLaltrlAccelVD_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_ActVehLaltrlAccelVD_BCS_ActVehLaltrlAccelVD_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_ActVehLaltrlAccel_BCS_ActVehLaltrlAccel_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_ActVehLaltrlAccel_BCS_ActVehLaltrlAccel_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_ActVehLongAccelVD_BCS_ActVehLongAccelVD_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_ActVehLongAccelVD_BCS_ActVehLongAccelVD_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_ActVehLongAccel_BCS_ActVehLongAccel_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_ActVehLongAccel_BCS_ActVehLongAccel_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_BrakeOverHeat_BCS_BrakeOverHeat_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_BrakeOverHeat_BCS_BrakeOverHeat_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_EBDFaultSt_BCS_EBDFaultSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_EBDFaultSt_BCS_EBDFaultSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_FLWheelRotatedDirection_BCS_FLWheelRotatedDirection_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_FLWheelRotatedDirection_BCS_FLWheelRotatedDirection_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_FLWheelSpdEdgesSumVD_BCS_FLWheelSpdEdgesSumVD_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_FLWheelSpdEdgesSumVD_BCS_FLWheelSpdEdgesSumVD_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_FLWheelSpdEdgesSum_BCS_FLWheelSpdEdgesSum_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_FLWheelSpdEdgesSum_BCS_FLWheelSpdEdgesSum_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_FLWheelSpdVD_BCS_FLWheelSpdVD_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_FLWheelSpdVD_BCS_FLWheelSpdVD_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_FLWheelSpd_BCS_FLWheelSpd_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_FLWheelSpd_BCS_FLWheelSpd_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_FRWheelRotatedDirection_BCS_FRWheelRotatedDirection_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_FRWheelRotatedDirection_BCS_FRWheelRotatedDirection_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_FRWheelSpdEdgesSumVD_BCS_FRWheelSpdEdgesSumVD_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_FRWheelSpdEdgesSumVD_BCS_FRWheelSpdEdgesSumVD_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_FRWheelSpdEdgesSum_BCS_FRWheelSpdEdgesSum_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_FRWheelSpdEdgesSum_BCS_FRWheelSpdEdgesSum_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_FRWheelSpdVD_BCS_FRWheelSpdVD_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_FRWheelSpdVD_BCS_FRWheelSpdVD_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_FRWheelSpd_BCS_FRWheelSpd_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_FRWheelSpd_BCS_FRWheelSpd_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_HDCCtrlSt_BCS_HDCCtrlSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_HDCCtrlSt_BCS_HDCCtrlSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_NoBrakeForce_BCS_NoBrakeForce_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_NoBrakeForce_BCS_NoBrakeForce_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_RLWheelRotatedDirection_BCS_RLWheelRotatedDirection_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_RLWheelRotatedDirection_BCS_RLWheelRotatedDirection_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_RLWheelSpdEdgesSumVD_BCS_RLWheelSpdEdgesSumVD_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_RLWheelSpdEdgesSumVD_BCS_RLWheelSpdEdgesSumVD_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_RLWheelSpdEdgesSum_BCS_RLWheelSpdEdgesSum_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_RLWheelSpdEdgesSum_BCS_RLWheelSpdEdgesSum_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_RLWheelSpdVD_BCS_RLWheelSpdVD_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_RLWheelSpdVD_BCS_RLWheelSpdVD_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_RLWheelSpd_BCS_RLWheelSpd_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_RLWheelSpd_BCS_RLWheelSpd_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_RRWheelRotatedDirection_BCS_RRWheelRotatedDirection_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_RRWheelRotatedDirection_BCS_RRWheelRotatedDirection_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_RRWheelSpdEdgesSumVD_BCS_RRWheelSpdEdgesSumVD_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_RRWheelSpdEdgesSumVD_BCS_RRWheelSpdEdgesSumVD_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_RRWheelSpdEdgesSum_BCS_RRWheelSpdEdgesSum_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_RRWheelSpdEdgesSum_BCS_RRWheelSpdEdgesSum_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_RRWheelSpdVD_BCS_RRWheelSpdVD_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_RRWheelSpdVD_BCS_RRWheelSpdVD_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_RRWheelSpd_BCS_RRWheelSpd_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_RRWheelSpd_BCS_RRWheelSpd_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_TCSActiveSt_BCS_TCSActiveSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_TCSActiveSt_BCS_TCSActiveSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_TCSFaultSt_BCS_TCSFaultSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_TCSFaultSt_BCS_TCSFaultSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_TCSOff_BCS_TCSOff_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_TCSOff_BCS_TCSOff_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_VehSpdVD_BCS_VehSpdVD_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_VehSpdVD_BCS_VehSpdVD_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_VehSpd_BCS_VehSpd_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_VehSpd_BCS_VehSpd_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_VehicleStandStillSt_BCS_VehicleStandStillSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_VehicleStandStillSt_BCS_VehicleStandStillSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_YawRateSt_BCS_YawRateSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_YawRateSt_BCS_YawRateSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_BCS_YawRate_BCS_YawRate_Return
 *  Rte_WriteHook_FCU_rSWCRX_BCS_YawRate_BCS_YawRate_Start
 *  Rte_WriteHook_FCU_rSWCRX_BSDM_RCTBPrefillReq_BSDM_RCTBPrefillReq_Return
 *  Rte_WriteHook_FCU_rSWCRX_BSDM_RCTBPrefillReq_BSDM_RCTBPrefillReq_Start
 *  Rte_WriteHook_FCU_rSWCRX_DMS_FatigWarnSt_DMS_FatigWarnSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_DMS_FatigWarnSt_DMS_FatigWarnSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_EMS_ACCButtInfo_EMS_ACCButtInfo_Return
 *  Rte_WriteHook_FCU_rSWCRX_EMS_ACCButtInfo_EMS_ACCButtInfo_Start
 *  Rte_WriteHook_FCU_rSWCRX_EPB_FailSt_EPB_SysSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_EPB_FailSt_EPB_SysSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_EPB_SysSt_EPB_SysSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_EPB_SysSt_EPB_SysSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_EPSCtrlSt_EPSCtrlSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_EPSCtrlSt_EPSCtrlSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_EPS_LKACtrlAbortFeedback_EPS_LKACtrlAbortFeedback_Return
 *  Rte_WriteHook_FCU_rSWCRX_EPS_LKACtrlAbortFeedback_EPS_LKACtrlAbortFeedback_Start
 *  Rte_WriteHook_FCU_rSWCRX_EPS_SteeringAngleSpdVD_EPS_SteeringAngleSpdVD_Return
 *  Rte_WriteHook_FCU_rSWCRX_EPS_SteeringAngleSpdVD_EPS_SteeringAngleSpdVD_Start
 *  Rte_WriteHook_FCU_rSWCRX_EPS_SteeringAngleSpd_EPS_SteeringAngleSpd_Return
 *  Rte_WriteHook_FCU_rSWCRX_EPS_SteeringAngleSpd_EPS_SteeringAngleSpd_Start
 *  Rte_WriteHook_FCU_rSWCRX_EPS_SteeringAngleVD_EPS_SteeringAngleVD_Return
 *  Rte_WriteHook_FCU_rSWCRX_EPS_SteeringAngleVD_EPS_SteeringAngleVD_Start
 *  Rte_WriteHook_FCU_rSWCRX_EPS_SteeringAngle_EPS_SteeringAngle_Return
 *  Rte_WriteHook_FCU_rSWCRX_EPS_SteeringAngle_EPS_SteeringAngle_Start
 *  Rte_WriteHook_FCU_rSWCRX_EPS_StrngWhlTorqVD_EPS_StrngWhlTorqVD_Return
 *  Rte_WriteHook_FCU_rSWCRX_EPS_StrngWhlTorqVD_EPS_StrngWhlTorqVD_Start
 *  Rte_WriteHook_FCU_rSWCRX_EPS_StrngWhlTorq_EPS_StrngWhlTorq_Return
 *  Rte_WriteHook_FCU_rSWCRX_EPS_StrngWhlTorq_EPS_StrngWhlTorq_Start
 *  Rte_WriteHook_FCU_rSWCRX_HVAC_CorrectedExterTempVD_HVAC_CorrectedExterTempVD_Return
 *  Rte_WriteHook_FCU_rSWCRX_HVAC_CorrectedExterTempVD_HVAC_CorrectedExterTempVD_Start
 *  Rte_WriteHook_FCU_rSWCRX_HVAC_CorrectedExterTemp_HVAC_CorrectedExterTemp_Return
 *  Rte_WriteHook_FCU_rSWCRX_HVAC_CorrectedExterTemp_HVAC_CorrectedExterTemp_Start
 *  Rte_WriteHook_FCU_rSWCRX_ICM_DisFail_ICM_DisFail_Return
 *  Rte_WriteHook_FCU_rSWCRX_ICM_DisFail_ICM_DisFail_Start
 *  Rte_WriteHook_FCU_rSWCRX_ICM_TotalOdometer_ICM_TotalOdometer_Return
 *  Rte_WriteHook_FCU_rSWCRX_ICM_TotalOdometer_ICM_TotalOdometer_Start
 *  Rte_WriteHook_FCU_rSWCRX_ICM_VehInsSpd_ICM_VehInsSpd_Return
 *  Rte_WriteHook_FCU_rSWCRX_ICM_VehInsSpd_ICM_VehInsSpd_Start
 *  Rte_WriteHook_FCU_rSWCRX_SAS_CalibratedSt_SAS_CalibratedSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_SAS_CalibratedSt_SAS_CalibratedSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_SRS_DriverSeatBeltSt_SRS_DriverSeatBeltSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_SRS_DriverSeatBeltSt_SRS_DriverSeatBeltSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_SWSM_A_CD_Add_Overtime_SWSM_A_CD_Add_Overtime_Return
 *  Rte_WriteHook_FCU_rSWCRX_SWSM_A_CD_Add_Overtime_SWSM_A_CD_Add_Overtime_Start
 *  Rte_WriteHook_FCU_rSWCRX_SWSM_A_CD_Minus_Overtime_SWSM_A_CD_Minus_Overtime_Return
 *  Rte_WriteHook_FCU_rSWCRX_SWSM_A_CD_Minus_Overtime_SWSM_A_CD_Minus_Overtime_Start
 *  Rte_WriteHook_FCU_rSWCRX_SWSM_A_CruiseDistance_Add_SWSM_A_CruiseDistance_Add_Return
 *  Rte_WriteHook_FCU_rSWCRX_SWSM_A_CruiseDistance_Add_SWSM_A_CruiseDistance_Add_Start
 *  Rte_WriteHook_FCU_rSWCRX_SWSM_A_CruiseDistance_Minus_SWSM_A_CruiseDistance_Minus_Return
 *  Rte_WriteHook_FCU_rSWCRX_SWSM_A_CruiseDistance_Minus_SWSM_A_CruiseDistance_Minus_Start
 *  Rte_WriteHook_FCU_rSWCRX_SWSM_A_CruiseSpeed_Add_SWSM_A_CruiseSpeed_Add_Return
 *  Rte_WriteHook_FCU_rSWCRX_SWSM_A_CruiseSpeed_Add_SWSM_A_CruiseSpeed_Add_Start
 *  Rte_WriteHook_FCU_rSWCRX_SWSM_A_CruiseSpeed_Minus_SWSM_A_CruiseSpeed_Minus_Return
 *  Rte_WriteHook_FCU_rSWCRX_SWSM_A_CruiseSpeed_Minus_SWSM_A_CruiseSpeed_Minus_Start
 *  Rte_WriteHook_FCU_rSWCRX_VCU_AccDriverOrvd_VCU_AccDriverOrvd_Return
 *  Rte_WriteHook_FCU_rSWCRX_VCU_AccDriverOrvd_VCU_AccDriverOrvd_Start
 *  Rte_WriteHook_FCU_rSWCRX_VCU_ActVehWheelTorq_VCU_ActVehWheelTorq_Return
 *  Rte_WriteHook_FCU_rSWCRX_VCU_ActVehWheelTorq_VCU_ActVehWheelTorq_Start
 *  Rte_WriteHook_FCU_rSWCRX_VCU_CrntGearLvlVD_VCU_CrntGearLvlVD_Return
 *  Rte_WriteHook_FCU_rSWCRX_VCU_CrntGearLvlVD_VCU_CrntGearLvlVD_Start
 *  Rte_WriteHook_FCU_rSWCRX_VCU_CrntGearLvl_VCU_CrntGearLvl_Return
 *  Rte_WriteHook_FCU_rSWCRX_VCU_CrntGearLvl_VCU_CrntGearLvl_Start
 *  Rte_WriteHook_FCU_rSWCRX_VCU_EMS_AccPedalActPstVD_VCU_EMS_AccPedalActPstVD_Return
 *  Rte_WriteHook_FCU_rSWCRX_VCU_EMS_AccPedalActPstVD_VCU_EMS_AccPedalActPstVD_Start
 *  Rte_WriteHook_FCU_rSWCRX_VCU_EMS_AccPedalActPst_VCU_EMS_AccPedalActPst_Return
 *  Rte_WriteHook_FCU_rSWCRX_VCU_EMS_AccPedalActPst_VCU_EMS_AccPedalActPst_Start
 *  Rte_WriteHook_FCU_rSWCRX_VCU_EMS_BrkPedalStVD_VCU_EMS_BrkPedalStVD_Return
 *  Rte_WriteHook_FCU_rSWCRX_VCU_EMS_BrkPedalStVD_VCU_EMS_BrkPedalStVD_Start
 *  Rte_WriteHook_FCU_rSWCRX_VCU_EMS_BrkPedalSt_VCU_EMS_BrkPedalSt_Return
 *  Rte_WriteHook_FCU_rSWCRX_VCU_EMS_BrkPedalSt_VCU_EMS_BrkPedalSt_Start
 *  Rte_WriteHook_FCU_rSWCRX_VCU_LateralAssistBtnInfoVD_VCU_LateralAssistBtnInfoVD_Return
 *  Rte_WriteHook_FCU_rSWCRX_VCU_LateralAssistBtnInfoVD_VCU_LateralAssistBtnInfoVD_Start
 *  Rte_WriteHook_FCU_rSWCRX_VCU_LateralAssistBtnInfo_VCU_LateralAssistBtnInfo_Return
 *  Rte_WriteHook_FCU_rSWCRX_VCU_LateralAssistBtnInfo_VCU_LateralAssistBtnInfo_Start
 *  Rte_WriteHook_LCFSEN_pLCFSEN_ST_LCFSEN_NVRAMData_t_ST_LCFSEN_NVRAMData_t_Return
 *  Rte_WriteHook_LCFSEN_pLCFSEN_ST_LCFSEN_NVRAMData_t_ST_LCFSEN_NVRAMData_t_Start
 *  Rte_WriteHook_LCFSEN_pLCFSEN_ST_LCF_SenGenericOutputs_t_ST_LCF_SenGenericOutputs_t_Return
 *  Rte_WriteHook_LCFSEN_pLCFSEN_ST_LCF_SenGenericOutputs_t_ST_LCF_SenGenericOutputs_t_Start
 *  Rte_WriteHook_LCFSEN_pLCFSEN_ST_LCF_SenToVehs_t_ST_LCF_SenToVehs_t_Return
 *  Rte_WriteHook_LCFSEN_pLCFSEN_ST_LCF_SenToVehs_t_ST_LCF_SenToVehs_t_Start
 *  Rte_WriteHook_LCFSEN_pLCFSEN_ST_reqLCFSEN_SOA_HMI_t_ST_reqLCFSEN_SOA_HMI_t_Return
 *  Rte_WriteHook_LCFSEN_pLCFSEN_ST_reqLCFSEN_SOA_HMI_t_ST_reqLCFSEN_SOA_HMI_t_Start
 *  Rte_WriteHook_LCFSEN_pSWCTX_ADAS_AdjLLnMrkingDispSt_ADAS_AdjLLnMrkingDispSt_Return
 *  Rte_WriteHook_LCFSEN_pSWCTX_ADAS_AdjLLnMrkingDispSt_ADAS_AdjLLnMrkingDispSt_Start
 *  Rte_WriteHook_LCFSEN_pSWCTX_ADAS_AdjRLnMrkingDispSt_ADAS_AdjRLnMrkingDispSt_Return
 *  Rte_WriteHook_LCFSEN_pSWCTX_ADAS_AdjRLnMrkingDispSt_ADAS_AdjRLnMrkingDispSt_Start
 *  Rte_WriteHook_LCFSEN_pSWCTX_ADAS_HWAHF_HandsOnReqSoundWarn_ADAS_HWAHF_HandsOnReqSoundWarn_Return
 *  Rte_WriteHook_LCFSEN_pSWCTX_ADAS_HWAHF_HandsOnReqSoundWarn_ADAS_HWAHF_HandsOnReqSoundWarn_Start
 *  Rte_WriteHook_LCFSEN_pSWCTX_ADAS_LLnMarkingDisPropToLnWidth_ADAS_LLnMarkingDisPropToLnWidth_Return
 *  Rte_WriteHook_LCFSEN_pSWCTX_ADAS_LLnMarkingDisPropToLnWidth_ADAS_LLnMarkingDisPropToLnWidth_Start
 *  Rte_WriteHook_LCFSEN_pSWCTX_ADAS_LnMarkingCurvature_ADAS_LnMarkingCurvature_Return
 *  Rte_WriteHook_LCFSEN_pSWCTX_ADAS_LnMarkingCurvature_ADAS_LnMarkingCurvature_Start
 *  Rte_WriteHook_LCFSEN_pSWCTX_ADAS_LnMarkingHeadAngToVeh_ADAS_LnMarkingHeadAngToVeh_Return
 *  Rte_WriteHook_LCFSEN_pSWCTX_ADAS_LnMarkingHeadAngToVeh_ADAS_LnMarkingHeadAngToVeh_Start
 *  Rte_WriteHook_LCFSEN_pSWCTX_EPS_HandsOffDetSt_EPS_HandsOffDetSt_Return
 *  Rte_WriteHook_LCFSEN_pSWCTX_EPS_HandsOffDetSt_EPS_HandsOffDetSt_Start
 *  Rte_WriteHook_LCFSEN_pSWCTX_EPS_LKACtrlSt_EPS_LKACtrlSt_Return
 *  Rte_WriteHook_LCFSEN_pSWCTX_EPS_LKACtrlSt_EPS_LKACtrlSt_Start
 *  Rte_WriteHook_LCFSEN_pSWCTX_IFC_CruiseMode_IFC_CruiseMode_Return
 *  Rte_WriteHook_LCFSEN_pSWCTX_IFC_CruiseMode_IFC_CruiseMode_Start
 *  Rte_WriteHook_LCFSEN_pSWCTX_IFC_LKS_TakeoverReq_IFC_LKS_TakeoverReq_Return
 *  Rte_WriteHook_LCFSEN_pSWCTX_IFC_LKS_TakeoverReq_IFC_LKS_TakeoverReq_Start
 *  Rte_WriteHook_LCFSEN_pSWCTX_LKS_Status_LKS_Status_Return
 *  Rte_WriteHook_LCFSEN_pSWCTX_LKS_Status_LKS_Status_Start
 *  Rte_WriteHook_LCFVEH_pLCFVEH_LCF_VehNVRAMData_t_LCF_VehNVRAMData_t_Return
 *  Rte_WriteHook_LCFVEH_pLCFVEH_LCF_VehNVRAMData_t_LCF_VehNVRAMData_t_Start
 *  Rte_WriteHook_LCFVEH_pLCFVEH_ST_LCF_VehGenericOutputs_t_ST_LCF_VehGenericOutputs_t_Return
 *  Rte_WriteHook_LCFVEH_pLCFVEH_ST_LCF_VehGenericOutputs_t_ST_LCF_VehGenericOutputs_t_Start
 *  Rte_WriteHook_LCFVEH_pSWCTX_ADAS_HWAHF_EyesOnRoadReq_ADAS_HWAHF_EyesOnRoadReq_Return
 *  Rte_WriteHook_LCFVEH_pSWCTX_ADAS_HWAHF_EyesOnRoadReq_ADAS_HWAHF_EyesOnRoadReq_Start
 *  Rte_WriteHook_LCFVEH_pSWCTX_ADAS_HWAHF_EyesOnRoadSoundWarn_ADAS_HWAHF_EyesOnRoadSoundWarn_Return
 *  Rte_WriteHook_LCFVEH_pSWCTX_ADAS_HWAHF_EyesOnRoadSoundWarn_ADAS_HWAHF_EyesOnRoadSoundWarn_Start
 *  Rte_WriteHook_LCFVEH_pSWCTX_ADAS_HWAHF_HandsOnPrompt_ADAS_HWAHF_HandsOnPrompt_Return
 *  Rte_WriteHook_LCFVEH_pSWCTX_ADAS_HWAHF_HandsOnPrompt_ADAS_HWAHF_HandsOnPrompt_Start
 *  Rte_WriteHook_LCFVEH_pSWCTX_ADAS_HWAHF_LegalDisclaimer_ADAS_HWAHF_LegalDisclaimer_Return
 *  Rte_WriteHook_LCFVEH_pSWCTX_ADAS_HWAHF_LegalDisclaimer_ADAS_HWAHF_LegalDisclaimer_Start
 *  Rte_WriteHook_LCFVEH_pSWCTX_ADAS_HWAHF_Lightbar_ADAS_HWAHF_Lightbar_Return
 *  Rte_WriteHook_LCFVEH_pSWCTX_ADAS_HWAHF_Lightbar_ADAS_HWAHF_Lightbar_Start
 *  Rte_WriteHook_LCFVEH_pSWCTX_ADAS_HWAHF_SafeStopSoundWarn_ADAS_HWAHF_SafeStopSoundWarn_Return
 *  Rte_WriteHook_LCFVEH_pSWCTX_ADAS_HWAHF_SafeStopSoundWarn_ADAS_HWAHF_SafeStopSoundWarn_Start
 *  Rte_WriteHook_LCFVEH_pSWCTX_ADAS_HWAHF_SafeStop_ADAS_HWAHF_SafeStop_Return
 *  Rte_WriteHook_LCFVEH_pSWCTX_ADAS_HWAHF_SafeStop_ADAS_HWAHF_SafeStop_Start
 *  Rte_WriteHook_LCFVEH_pSWCTX_ADAS_HWAHF_TakeOverReqSoundWarn_ADAS_HWAHF_TakeOverReqSoundWarn_Return
 *  Rte_WriteHook_LCFVEH_pSWCTX_ADAS_HWAHF_TakeOverReqSoundWarn_ADAS_HWAHF_TakeOverReqSoundWarn_Start
 *  Rte_WriteHook_LCFVEH_pSWCTX_ADAS_HWAHF_TakeOverReq_ADAS_HWAHF_TakeOverReq_Return
 *  Rte_WriteHook_LCFVEH_pSWCTX_ADAS_HWAHF_TakeOverReq_ADAS_HWAHF_TakeOverReq_Start
 *  Rte_WriteHook_LCFVEH_pSWCTX_ADAS_LateralCtrlOvrrdFlg_ADAS_LateralCtrlOvrrdFlg_Return
 *  Rte_WriteHook_LCFVEH_pSWCTX_ADAS_LateralCtrlOvrrdFlg_ADAS_LateralCtrlOvrrdFlg_Start
 *  Rte_WriteHook_LCFVEH_pSWCTX_IFC_TJA_ICA_St_IFC_TJA_ICA_St_Return
 *  Rte_WriteHook_LCFVEH_pSWCTX_IFC_TJA_ICA_St_IFC_TJA_ICA_St_Start
 *  Rte_WriteHook_SDC_Axera_Signal_Lane_Axera_Lane_Return
 *  Rte_WriteHook_SDC_Axera_Signal_Lane_Axera_Lane_Start
 *  Rte_WriteHook_SDC_Axera_Signal_Obstacle_Axera_Obstacle_Return
 *  Rte_WriteHook_SDC_Axera_Signal_Obstacle_Axera_Obstacle_Start
 *  Rte_WriteHook_UDC_ME_Signal_Lane_ME_Lane_Return
 *  Rte_WriteHook_UDC_ME_Signal_Lane_ME_Lane_Start
 *  Rte_WriteHook_UDC_ME_Signal_Obstacle_ME_Obstacle_Return
 *  Rte_WriteHook_UDC_ME_Signal_Obstacle_ME_Obstacle_Start
 *  Rte_WriteHook_VED_pVED_ST_EMVEDVehPar_t_ST_EMVEDVehPar_t_Return
 *  Rte_WriteHook_VED_pVED_ST_EMVEDVehPar_t_ST_EMVEDVehPar_t_Start
 *  Rte_WriteHook_VED_pVED_ST_VEDNvIoDatas_t_ST_VEDNvIoDatas_t_Return
 *  Rte_WriteHook_VED_pVED_ST_VEDNvIoDatas_t_ST_VEDNvIoDatas_t_Start
 *  Rte_WriteHook_VED_pVED_ST_VEDVehDyn_t_ST_VEDVehDyn_t_Return
 *  Rte_WriteHook_VED_pVED_ST_VEDVehDyn_t_ST_VEDVehDyn_t_Start
 *  Rte_WriteHook_VED_pVED_ST_VEDVehSig_t_ST_VEDVehSig_t_Return
 *  Rte_WriteHook_VED_pVED_ST_VEDVehSig_t_ST_VEDVehSig_t_Start
 *  Rte_WriteHook_VED_pVED_ST_VehicleDynamicSignals_t_ST_VehicleDynamicSignals_t_Return
 *  Rte_WriteHook_VED_pVED_ST_VehicleDynamicSignals_t_ST_VehicleDynamicSignals_t_Start
 *  Rte_WriteHook_VLCSEN_pSWCTX_ADAS_HWAHF_PedestrainDet_ADAS_HWAHF_PedestrainDet_Return
 *  Rte_WriteHook_VLCSEN_pSWCTX_ADAS_HWAHF_PedestrainDet_ADAS_HWAHF_PedestrainDet_Start
 *  Rte_WriteHook_VLCSEN_pSWCTX_ADAS_TrkTargt2ObjClass_ADAS_TrkTargt2ObjClass_Return
 *  Rte_WriteHook_VLCSEN_pSWCTX_ADAS_TrkTargt2ObjClass_ADAS_TrkTargt2ObjClass_Start
 *  Rte_WriteHook_VLCSEN_pSWCTX_ADAS_TrkTargt2St_ADAS_TrkTargt2St_Return
 *  Rte_WriteHook_VLCSEN_pSWCTX_ADAS_TrkTargt2St_ADAS_TrkTargt2St_Start
 *  Rte_WriteHook_VLCSEN_pSWCTX_ADAS_TrkTargt2latPos_ADAS_TrkTargt2latPos_Return
 *  Rte_WriteHook_VLCSEN_pSWCTX_ADAS_TrkTargt2latPos_ADAS_TrkTargt2latPos_Start
 *  Rte_WriteHook_VLCSEN_pSWCTX_ADAS_TrkTargt3ObjClass_ADAS_TrkTargt3ObjClass_Return
 *  Rte_WriteHook_VLCSEN_pSWCTX_ADAS_TrkTargt3ObjClass_ADAS_TrkTargt3ObjClass_Start
 *  Rte_WriteHook_VLCSEN_pSWCTX_ADAS_TrkTargt3St_ADAS_TrkTargt3St_Return
 *  Rte_WriteHook_VLCSEN_pSWCTX_ADAS_TrkTargt3St_ADAS_TrkTargt3St_Start
 *  Rte_WriteHook_VLCSEN_pSWCTX_ADAS_TrkTargt3latPos_ADAS_TrkTargt3latPos_Return
 *  Rte_WriteHook_VLCSEN_pSWCTX_ADAS_TrkTargt3latPos_ADAS_TrkTargt3latPos_Start
 *  Rte_WriteHook_VLCSEN_pSWCTX_ADAS_TrkTargt3longPos_ADAS_TrkTargt3longPos_Return
 *  Rte_WriteHook_VLCSEN_pSWCTX_ADAS_TrkTargt3longPos_ADAS_TrkTargt3longPos_Start
 *  Rte_WriteHook_VLCSEN_pSWCTX_MRR_ObjectCapturedSt_MRR_ObjectCapturedSt_Return
 *  Rte_WriteHook_VLCSEN_pSWCTX_MRR_ObjectCapturedSt_MRR_ObjectCapturedSt_Start
 *  Rte_WriteHook_VLCSEN_pVLCSEN_ST_VLCSen_AccOOI_List_t_ST_VLCSen_AccOOI_List_t_Return
 *  Rte_WriteHook_VLCSEN_pVLCSEN_ST_VLCSen_AccOOI_List_t_ST_VLCSen_AccOOI_List_t_Start
 *  Rte_WriteHook_VLCSEN_pVLCSEN_ST_VLCSen_AssessedObjList_t_ST_VLCSen_AssessedObjList_t_Return
 *  Rte_WriteHook_VLCSEN_pVLCSEN_ST_VLCSen_AssessedObjList_t_ST_VLCSen_AssessedObjList_t_Start
 *  Rte_WriteHook_VLCSEN_pVLCSEN_ST_VLCSen_HypothesisIntf_t_ST_VLCSen_HypothesisIntf_t_Return
 *  Rte_WriteHook_VLCSEN_pVLCSEN_ST_VLCSen_HypothesisIntf_t_ST_VLCSen_HypothesisIntf_t_Start
 *  Rte_WriteHook_VLCSEN_pVLCSEN_ST_VLCSen_NVRAMData_t_ST_VLCSen_NVRAMData_t_Return
 *  Rte_WriteHook_VLCSEN_pVLCSEN_ST_VLCSen_NVRAMData_t_ST_VLCSen_NVRAMData_t_Start
 *  Rte_WriteHook_VLCSEN_pVLCSEN_ST_VLCSen_acc_object_t_ST_VLCSen_acc_object_t_Return
 *  Rte_WriteHook_VLCSEN_pVLCSEN_ST_VLCSen_acc_object_t_ST_VLCSen_acc_object_t_Start
 *  Rte_WriteHook_VLCSEN_pVLCSEN_ST_VLCSen_acc_output_data_t_ST_VLCSen_acc_output_data_t_Return
 *  Rte_WriteHook_VLCSEN_pVLCSEN_ST_VLCSen_acc_output_data_t_ST_VLCSen_acc_output_data_t_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_HWAHF_SpdDecRea_ADAS_HWAHF_SpdDecRea_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_HWAHF_SpdDecRea_ADAS_HWAHF_SpdDecRea_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_IntlCrusMode_ADAS_IntlCrusMode_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_IntlCrusMode_ADAS_IntlCrusMode_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_LongCtrTargetAccelJerkMaxnValue_ADAS_LongCtrTargetAccelJerkMaxnValue_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_LongCtrTargetAccelJerkMaxnValue_ADAS_LongCtrTargetAccelJerkMaxnValue_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_LongCtrlAccelCtrlReq_ADAS_LongCtrlAccelCtrlReq_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_LongCtrlAccelCtrlReq_ADAS_LongCtrlAccelCtrlReq_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_LongCtrlDecToStopReq_ADAS_LongCtrlDecToStopReq_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_LongCtrlDecToStopReq_ADAS_LongCtrlDecToStopReq_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_LongCtrlDriveOff_ADAS_LongCtrlDriveOff_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_LongCtrlDriveOff_ADAS_LongCtrlDriveOff_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_LongCtrlModeForBrkSys_ADAS_LongCtrlModeForBrkSys_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_LongCtrlModeForBrkSys_ADAS_LongCtrlModeForBrkSys_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_LongCtrlShutdownReq_ADAS_LongCtrlShutdownReq_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_LongCtrlShutdownReq_ADAS_LongCtrlShutdownReq_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_LongCtrlTargetAccelJerkMinValue_ADAS_LongCtrlTargetAccelJerkMinValue_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_LongCtrlTargetAccelJerkMinValue_ADAS_LongCtrlTargetAccelJerkMinValue_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_LongCtrlTargetAccel_ADAS_LongCtrlTargetAccel_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_LongCtrlTargetAccel_ADAS_LongCtrlTargetAccel_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_LongCtrlTypReqLong_ADAS_LongCtrlTypReqLong_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_LongCtrlTypReqLong_ADAS_LongCtrlTypReqLong_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_LongCtrlTypReqMode_ADAS_LongCtrlTypReqMode_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_LongCtrlTypReqMode_ADAS_LongCtrlTypReqMode_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_SensorBlockedSts_ADAS_SensorBlockedSts_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_SensorBlockedSts_ADAS_SensorBlockedSts_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_SensorCalibrationSts_ADAS_SensorCalibrationSts_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_SensorCalibrationSts_ADAS_SensorCalibrationSts_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_SensorFailure_ADAS_SensorFailure_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_ADAS_SensorFailure_ADAS_SensorFailure_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_IFC_AEBBrkPedalOverRide_IFC_AEBBrkPedalOverRide_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_IFC_AEBBrkPedalOverRide_IFC_AEBBrkPedalOverRide_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCActiveSt_MRR_ACCActiveSt_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCActiveSt_MRR_ACCActiveSt_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCFaultSt_MRR_ACCFaultSt_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCFaultSt_MRR_ACCFaultSt_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCFuncCancel_MRR_ACCFuncCancel_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCFuncCancel_MRR_ACCFuncCancel_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCGoNotifier_MRR_ACCGoNotifier_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCGoNotifier_MRR_ACCGoNotifier_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCMode_MRR_ACCMode_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCMode_MRR_ACCMode_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCQuitSound_MRR_ACCQuitSound_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCQuitSound_MRR_ACCQuitSound_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCRecpDecelReq_MRR_ACCRecpDecelReq_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCRecpDecelReq_MRR_ACCRecpDecelReq_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCRecpDecel_MRR_ACCRecpDecel_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCRecpDecel_MRR_ACCRecpDecel_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCReqQua_MRR_ACCReqQua_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCReqQua_MRR_ACCReqQua_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCTakeOverReq_MRR_ACCTakeOverReq_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCTakeOverReq_MRR_ACCTakeOverReq_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCTextInfo_MRR_ACCTextInfo_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCTextInfo_MRR_ACCTextInfo_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCUnableActivated_MRR_ACCUnableActivated_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ACCUnableActivated_MRR_ACCUnableActivated_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_AEBFaultSt_MRR_AEBFaultSt_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_AEBFaultSt_MRR_AEBFaultSt_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_AEBLVehHoldReq_MRR_AEBLVehHoldReq_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_AEBLVehHoldReq_MRR_AEBLVehHoldReq_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_AEBOffSt_MRR_AEBOffSt_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_AEBOffSt_MRR_AEBOffSt_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_AEBTargetDecel_MRR_AEBTargetDecel_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_AEBTargetDecel_MRR_AEBTargetDecel_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_AWBLevel_MRR_AWBLevel_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_AWBLevel_MRR_AWBLevel_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_AWBReq_MRR_AWBReq_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_AWBReq_MRR_AWBReq_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ActTrqReqVD_MRR_ActTrqReqVD_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ActTrqReqVD_MRR_ActTrqReqVD_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ActTrqReq_MRR_ActTrqReq_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_ActTrqReq_MRR_ActTrqReq_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_FCWFaultSt_MRR_FCWFaultSt_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_FCWFaultSt_MRR_FCWFaultSt_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_FCWOffSt_MRR_FCWOffSt_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_FCWOffSt_MRR_FCWOffSt_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_IFC_PriCANAvailableSt_MRR_IFC_PriCANAvailableSt_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_IFC_PriCANAvailableSt_MRR_IFC_PriCANAvailableSt_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_IFC_PriCANErrorSt_MRR_IFC_PriCANErrorSt_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_IFC_PriCANErrorSt_MRR_IFC_PriCANErrorSt_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_PEBSObjType_MRR_PEBSObjType_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_PEBSObjType_MRR_PEBSObjType_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_TargetDistanceSt_MRR_TargetDistanceSt_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_TargetDistanceSt_MRR_TargetDistanceSt_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_TargetSpd_MRR_TargetSpd_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_TargetSpd_MRR_TargetSpd_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_TauGapSet_MRR_TauGapSet_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_MRR_TauGapSet_MRR_TauGapSet_Start
 *  Rte_WriteHook_VLCVEH_pSWCTX_VCU_VehDrvMod_VCU_VehDrvMod_Return
 *  Rte_WriteHook_VLCVEH_pSWCTX_VCU_VehDrvMod_VCU_VehDrvMod_Start
 *  Rte_WriteHook_VLCVEH_pVLCVEH_ST_VLCVeh_LongCtrlInput_t_ST_VLCVeh_LongCtrlInput_t_Return
 *  Rte_WriteHook_VLCVEH_pVLCVEH_ST_VLCVeh_LongCtrlInput_t_ST_VLCVeh_LongCtrlInput_t_Start
 *  Rte_WriteHook_VLCVEH_pVLCVEH_ST_VLCVeh_NVRAMData_t_ST_VLCVeh_NVRAMData_t_Return
 *  Rte_WriteHook_VLCVEH_pVLCVEH_ST_VLCVeh_NVRAMData_t_ST_VLCVeh_NVRAMData_t_Start
 *  Rte_WriteHook_VLCVEH_pVLCVEH_ST_reqVLCVEH_SOA_HMI_t_ST_reqVLCVEH_SOA_HMI_t_Return
 *  Rte_WriteHook_VLCVEH_pVLCVEH_ST_reqVLCVEH_SOA_HMI_t_ST_reqVLCVEH_SOA_HMI_t_Start
 *  SchM_EnterHook_BswM_BSWM_EXCLUSIVE_AREA_0_Return
 *  SchM_EnterHook_BswM_BSWM_EXCLUSIVE_AREA_0_Start
 *  SchM_EnterHook_CanIf_CANIF_EXCLUSIVE_AREA_0_Return
 *  SchM_EnterHook_CanIf_CANIF_EXCLUSIVE_AREA_0_Start
 *  SchM_EnterHook_CanIf_CANIF_EXCLUSIVE_AREA_1_Return
 *  SchM_EnterHook_CanIf_CANIF_EXCLUSIVE_AREA_1_Start
 *  SchM_EnterHook_CanIf_CANIF_EXCLUSIVE_AREA_2_Return
 *  SchM_EnterHook_CanIf_CANIF_EXCLUSIVE_AREA_2_Start
 *  SchM_EnterHook_CanIf_CANIF_EXCLUSIVE_AREA_3_Return
 *  SchM_EnterHook_CanIf_CANIF_EXCLUSIVE_AREA_3_Start
 *  SchM_EnterHook_CanIf_CANIF_EXCLUSIVE_AREA_4_Return
 *  SchM_EnterHook_CanIf_CANIF_EXCLUSIVE_AREA_4_Start
 *  SchM_EnterHook_CanIf_CANIF_EXCLUSIVE_AREA_5_Return
 *  SchM_EnterHook_CanIf_CANIF_EXCLUSIVE_AREA_5_Start
 *  SchM_EnterHook_CanIf_CANIF_EXCLUSIVE_AREA_6_Return
 *  SchM_EnterHook_CanIf_CANIF_EXCLUSIVE_AREA_6_Start
 *  SchM_EnterHook_CanIf_CANIF_EXCLUSIVE_AREA_7_Return
 *  SchM_EnterHook_CanIf_CANIF_EXCLUSIVE_AREA_7_Start
 *  SchM_EnterHook_CanNm_CANNM_EXCLUSIVE_AREA_0_Return
 *  SchM_EnterHook_CanNm_CANNM_EXCLUSIVE_AREA_0_Start
 *  SchM_EnterHook_CanNm_CANNM_EXCLUSIVE_AREA_1_Return
 *  SchM_EnterHook_CanNm_CANNM_EXCLUSIVE_AREA_1_Start
 *  SchM_EnterHook_CanNm_CANNM_EXCLUSIVE_AREA_2_Return
 *  SchM_EnterHook_CanNm_CANNM_EXCLUSIVE_AREA_2_Start
 *  SchM_EnterHook_CanNm_CANNM_EXCLUSIVE_AREA_3_Return
 *  SchM_EnterHook_CanNm_CANNM_EXCLUSIVE_AREA_3_Start
 *  SchM_EnterHook_CanNm_CANNM_EXCLUSIVE_AREA_4_Return
 *  SchM_EnterHook_CanNm_CANNM_EXCLUSIVE_AREA_4_Start
 *  SchM_EnterHook_CanNm_CANNM_EXCLUSIVE_AREA_5_Return
 *  SchM_EnterHook_CanNm_CANNM_EXCLUSIVE_AREA_5_Start
 *  SchM_EnterHook_CanSM_CANSM_EXCLUSIVE_AREA_1_Return
 *  SchM_EnterHook_CanSM_CANSM_EXCLUSIVE_AREA_1_Start
 *  SchM_EnterHook_CanSM_CANSM_EXCLUSIVE_AREA_2_Return
 *  SchM_EnterHook_CanSM_CANSM_EXCLUSIVE_AREA_2_Start
 *  SchM_EnterHook_CanSM_CANSM_EXCLUSIVE_AREA_3_Return
 *  SchM_EnterHook_CanSM_CANSM_EXCLUSIVE_AREA_3_Start
 *  SchM_EnterHook_CanSM_CANSM_EXCLUSIVE_AREA_4_Return
 *  SchM_EnterHook_CanSM_CANSM_EXCLUSIVE_AREA_4_Start
 *  SchM_EnterHook_CanSM_CANSM_EXCLUSIVE_AREA_5_Return
 *  SchM_EnterHook_CanSM_CANSM_EXCLUSIVE_AREA_5_Start
 *  SchM_EnterHook_CanSM_CANSM_EXCLUSIVE_AREA_6_Return
 *  SchM_EnterHook_CanSM_CANSM_EXCLUSIVE_AREA_6_Start
 *  SchM_EnterHook_CanTp_CANTP_EXCLUSIVE_AREA_0_Return
 *  SchM_EnterHook_CanTp_CANTP_EXCLUSIVE_AREA_0_Start
 *  SchM_EnterHook_Can_CAN_EXCLUSIVE_AREA_0_Return
 *  SchM_EnterHook_Can_CAN_EXCLUSIVE_AREA_0_Start
 *  SchM_EnterHook_Can_CAN_EXCLUSIVE_AREA_1_Return
 *  SchM_EnterHook_Can_CAN_EXCLUSIVE_AREA_1_Start
 *  SchM_EnterHook_Can_CAN_EXCLUSIVE_AREA_2_Return
 *  SchM_EnterHook_Can_CAN_EXCLUSIVE_AREA_2_Start
 *  SchM_EnterHook_Can_CAN_EXCLUSIVE_AREA_3_Return
 *  SchM_EnterHook_Can_CAN_EXCLUSIVE_AREA_3_Start
 *  SchM_EnterHook_Can_CAN_EXCLUSIVE_AREA_4_Return
 *  SchM_EnterHook_Can_CAN_EXCLUSIVE_AREA_4_Start
 *  SchM_EnterHook_Can_CAN_EXCLUSIVE_AREA_5_Return
 *  SchM_EnterHook_Can_CAN_EXCLUSIVE_AREA_5_Start
 *  SchM_EnterHook_Can_CAN_EXCLUSIVE_AREA_6_Return
 *  SchM_EnterHook_Can_CAN_EXCLUSIVE_AREA_6_Start
 *  SchM_EnterHook_Can_CAN_EXCLUSIVE_AREA_7_Return
 *  SchM_EnterHook_Can_CAN_EXCLUSIVE_AREA_7_Start
 *  SchM_EnterHook_ComM_COMM_EXCLUSIVE_AREA_0_Return
 *  SchM_EnterHook_ComM_COMM_EXCLUSIVE_AREA_0_Start
 *  SchM_EnterHook_ComM_COMM_EXCLUSIVE_AREA_1_Return
 *  SchM_EnterHook_ComM_COMM_EXCLUSIVE_AREA_1_Start
 *  SchM_EnterHook_Com_COM_EXCLUSIVE_AREA_BOTH_Return
 *  SchM_EnterHook_Com_COM_EXCLUSIVE_AREA_BOTH_Start
 *  SchM_EnterHook_Com_COM_EXCLUSIVE_AREA_RX_Return
 *  SchM_EnterHook_Com_COM_EXCLUSIVE_AREA_RX_Start
 *  SchM_EnterHook_Com_COM_EXCLUSIVE_AREA_TX_Return
 *  SchM_EnterHook_Com_COM_EXCLUSIVE_AREA_TX_Start
 *  SchM_EnterHook_Dcm_DCM_EXCLUSIVE_AREA_0_Return
 *  SchM_EnterHook_Dcm_DCM_EXCLUSIVE_AREA_0_Start
 *  SchM_EnterHook_Dem_DEM_EXCLUSIVE_AREA_0_Return
 *  SchM_EnterHook_Dem_DEM_EXCLUSIVE_AREA_0_Start
 *  SchM_EnterHook_Dem_DEM_EXCLUSIVE_AREA_1_Return
 *  SchM_EnterHook_Dem_DEM_EXCLUSIVE_AREA_1_Start
 *  SchM_EnterHook_Dem_DEM_EXCLUSIVE_AREA_2_Return
 *  SchM_EnterHook_Dem_DEM_EXCLUSIVE_AREA_2_Start
 *  SchM_EnterHook_Dem_DEM_EXCLUSIVE_AREA_3_Return
 *  SchM_EnterHook_Dem_DEM_EXCLUSIVE_AREA_3_Start
 *  SchM_EnterHook_Dem_DEM_EXCLUSIVE_AREA_4_Return
 *  SchM_EnterHook_Dem_DEM_EXCLUSIVE_AREA_4_Start
 *  SchM_EnterHook_Det_DET_EXCLUSIVE_AREA_0_Return
 *  SchM_EnterHook_Det_DET_EXCLUSIVE_AREA_0_Start
 *  SchM_EnterHook_EcuM_ECUM_EXCLUSIVE_AREA_0_Return
 *  SchM_EnterHook_EcuM_ECUM_EXCLUSIVE_AREA_0_Start
 *  SchM_EnterHook_EcuM_ECUM_EXCLUSIVE_AREA_1_Return
 *  SchM_EnterHook_EcuM_ECUM_EXCLUSIVE_AREA_1_Start
 *  SchM_EnterHook_EcuM_ECUM_EXCLUSIVE_AREA_2_Return
 *  SchM_EnterHook_EcuM_ECUM_EXCLUSIVE_AREA_2_Start
 *  SchM_EnterHook_McalLib_CpuEndInit_Return
 *  SchM_EnterHook_McalLib_CpuEndInit_Start
 *  SchM_EnterHook_McalLib_PeripheralEndInit_Return
 *  SchM_EnterHook_McalLib_PeripheralEndInit_Start
 *  SchM_EnterHook_McalLib_SafetyEndInit_Return
 *  SchM_EnterHook_McalLib_SafetyEndInit_Start
 *  SchM_EnterHook_McalLib_StmTimerResolution_Return
 *  SchM_EnterHook_McalLib_StmTimerResolution_Start
 *  SchM_EnterHook_Mcu_AtomAgcReg_Return
 *  SchM_EnterHook_Mcu_AtomAgcReg_Start
 *  SchM_EnterHook_Mcu_TomTgcReg_Return
 *  SchM_EnterHook_Mcu_TomTgcReg_Start
 *  SchM_EnterHook_Nm_NM_EXCLUSIVE_AREA_0_Return
 *  SchM_EnterHook_Nm_NM_EXCLUSIVE_AREA_0_Start
 *  SchM_EnterHook_Nm_NM_EXCLUSIVE_AREA_1_Return
 *  SchM_EnterHook_Nm_NM_EXCLUSIVE_AREA_1_Start
 *  SchM_EnterHook_PduR_PDUR_EXCLUSIVE_AREA_0_Return
 *  SchM_EnterHook_PduR_PDUR_EXCLUSIVE_AREA_0_Start
 *  SchM_EnterHook_Xcp_CANXCP_EXCLUSIVE_AREA_0_Return
 *  SchM_EnterHook_Xcp_CANXCP_EXCLUSIVE_AREA_0_Start
 *  SchM_EnterHook_Xcp_FRXCP_EXCLUSIVE_AREA_0_Return
 *  SchM_EnterHook_Xcp_FRXCP_EXCLUSIVE_AREA_0_Start
 *  SchM_EnterHook_Xcp_FRXCP_EXCLUSIVE_AREA_1_Return
 *  SchM_EnterHook_Xcp_FRXCP_EXCLUSIVE_AREA_1_Start
 *  SchM_EnterHook_Xcp_FRXCP_EXCLUSIVE_AREA_2_Return
 *  SchM_EnterHook_Xcp_FRXCP_EXCLUSIVE_AREA_2_Start
 *  SchM_EnterHook_Xcp_TCPIPXCP_EXCLUSIVE_AREA_0_Return
 *  SchM_EnterHook_Xcp_TCPIPXCP_EXCLUSIVE_AREA_0_Start
 *  SchM_EnterHook_Xcp_XCP_EXCLUSIVE_AREA_0_Return
 *  SchM_EnterHook_Xcp_XCP_EXCLUSIVE_AREA_0_Start
 *  SchM_EnterHook_Xcp_XCP_EXCLUSIVE_AREA_1_Return
 *  SchM_EnterHook_Xcp_XCP_EXCLUSIVE_AREA_1_Start
 *  SchM_EnterHook_Xcp_XCP_EXCLUSIVE_AREA_2_Return
 *  SchM_EnterHook_Xcp_XCP_EXCLUSIVE_AREA_2_Start
 *  SchM_ExitHook_BswM_BSWM_EXCLUSIVE_AREA_0_Return
 *  SchM_ExitHook_BswM_BSWM_EXCLUSIVE_AREA_0_Start
 *  SchM_ExitHook_CanIf_CANIF_EXCLUSIVE_AREA_0_Return
 *  SchM_ExitHook_CanIf_CANIF_EXCLUSIVE_AREA_0_Start
 *  SchM_ExitHook_CanIf_CANIF_EXCLUSIVE_AREA_1_Return
 *  SchM_ExitHook_CanIf_CANIF_EXCLUSIVE_AREA_1_Start
 *  SchM_ExitHook_CanIf_CANIF_EXCLUSIVE_AREA_2_Return
 *  SchM_ExitHook_CanIf_CANIF_EXCLUSIVE_AREA_2_Start
 *  SchM_ExitHook_CanIf_CANIF_EXCLUSIVE_AREA_3_Return
 *  SchM_ExitHook_CanIf_CANIF_EXCLUSIVE_AREA_3_Start
 *  SchM_ExitHook_CanIf_CANIF_EXCLUSIVE_AREA_4_Return
 *  SchM_ExitHook_CanIf_CANIF_EXCLUSIVE_AREA_4_Start
 *  SchM_ExitHook_CanIf_CANIF_EXCLUSIVE_AREA_5_Return
 *  SchM_ExitHook_CanIf_CANIF_EXCLUSIVE_AREA_5_Start
 *  SchM_ExitHook_CanIf_CANIF_EXCLUSIVE_AREA_6_Return
 *  SchM_ExitHook_CanIf_CANIF_EXCLUSIVE_AREA_6_Start
 *  SchM_ExitHook_CanIf_CANIF_EXCLUSIVE_AREA_7_Return
 *  SchM_ExitHook_CanIf_CANIF_EXCLUSIVE_AREA_7_Start
 *  SchM_ExitHook_CanNm_CANNM_EXCLUSIVE_AREA_0_Return
 *  SchM_ExitHook_CanNm_CANNM_EXCLUSIVE_AREA_0_Start
 *  SchM_ExitHook_CanNm_CANNM_EXCLUSIVE_AREA_1_Return
 *  SchM_ExitHook_CanNm_CANNM_EXCLUSIVE_AREA_1_Start
 *  SchM_ExitHook_CanNm_CANNM_EXCLUSIVE_AREA_2_Return
 *  SchM_ExitHook_CanNm_CANNM_EXCLUSIVE_AREA_2_Start
 *  SchM_ExitHook_CanNm_CANNM_EXCLUSIVE_AREA_3_Return
 *  SchM_ExitHook_CanNm_CANNM_EXCLUSIVE_AREA_3_Start
 *  SchM_ExitHook_CanNm_CANNM_EXCLUSIVE_AREA_4_Return
 *  SchM_ExitHook_CanNm_CANNM_EXCLUSIVE_AREA_4_Start
 *  SchM_ExitHook_CanNm_CANNM_EXCLUSIVE_AREA_5_Return
 *  SchM_ExitHook_CanNm_CANNM_EXCLUSIVE_AREA_5_Start
 *  SchM_ExitHook_CanSM_CANSM_EXCLUSIVE_AREA_1_Return
 *  SchM_ExitHook_CanSM_CANSM_EXCLUSIVE_AREA_1_Start
 *  SchM_ExitHook_CanSM_CANSM_EXCLUSIVE_AREA_2_Return
 *  SchM_ExitHook_CanSM_CANSM_EXCLUSIVE_AREA_2_Start
 *  SchM_ExitHook_CanSM_CANSM_EXCLUSIVE_AREA_3_Return
 *  SchM_ExitHook_CanSM_CANSM_EXCLUSIVE_AREA_3_Start
 *  SchM_ExitHook_CanSM_CANSM_EXCLUSIVE_AREA_4_Return
 *  SchM_ExitHook_CanSM_CANSM_EXCLUSIVE_AREA_4_Start
 *  SchM_ExitHook_CanSM_CANSM_EXCLUSIVE_AREA_5_Return
 *  SchM_ExitHook_CanSM_CANSM_EXCLUSIVE_AREA_5_Start
 *  SchM_ExitHook_CanSM_CANSM_EXCLUSIVE_AREA_6_Return
 *  SchM_ExitHook_CanSM_CANSM_EXCLUSIVE_AREA_6_Start
 *  SchM_ExitHook_CanTp_CANTP_EXCLUSIVE_AREA_0_Return
 *  SchM_ExitHook_CanTp_CANTP_EXCLUSIVE_AREA_0_Start
 *  SchM_ExitHook_Can_CAN_EXCLUSIVE_AREA_0_Return
 *  SchM_ExitHook_Can_CAN_EXCLUSIVE_AREA_0_Start
 *  SchM_ExitHook_Can_CAN_EXCLUSIVE_AREA_1_Return
 *  SchM_ExitHook_Can_CAN_EXCLUSIVE_AREA_1_Start
 *  SchM_ExitHook_Can_CAN_EXCLUSIVE_AREA_2_Return
 *  SchM_ExitHook_Can_CAN_EXCLUSIVE_AREA_2_Start
 *  SchM_ExitHook_Can_CAN_EXCLUSIVE_AREA_3_Return
 *  SchM_ExitHook_Can_CAN_EXCLUSIVE_AREA_3_Start
 *  SchM_ExitHook_Can_CAN_EXCLUSIVE_AREA_4_Return
 *  SchM_ExitHook_Can_CAN_EXCLUSIVE_AREA_4_Start
 *  SchM_ExitHook_Can_CAN_EXCLUSIVE_AREA_5_Return
 *  SchM_ExitHook_Can_CAN_EXCLUSIVE_AREA_5_Start
 *  SchM_ExitHook_Can_CAN_EXCLUSIVE_AREA_6_Return
 *  SchM_ExitHook_Can_CAN_EXCLUSIVE_AREA_6_Start
 *  SchM_ExitHook_Can_CAN_EXCLUSIVE_AREA_7_Return
 *  SchM_ExitHook_Can_CAN_EXCLUSIVE_AREA_7_Start
 *  SchM_ExitHook_ComM_COMM_EXCLUSIVE_AREA_0_Return
 *  SchM_ExitHook_ComM_COMM_EXCLUSIVE_AREA_0_Start
 *  SchM_ExitHook_ComM_COMM_EXCLUSIVE_AREA_1_Return
 *  SchM_ExitHook_ComM_COMM_EXCLUSIVE_AREA_1_Start
 *  SchM_ExitHook_Com_COM_EXCLUSIVE_AREA_BOTH_Return
 *  SchM_ExitHook_Com_COM_EXCLUSIVE_AREA_BOTH_Start
 *  SchM_ExitHook_Com_COM_EXCLUSIVE_AREA_RX_Return
 *  SchM_ExitHook_Com_COM_EXCLUSIVE_AREA_RX_Start
 *  SchM_ExitHook_Com_COM_EXCLUSIVE_AREA_TX_Return
 *  SchM_ExitHook_Com_COM_EXCLUSIVE_AREA_TX_Start
 *  SchM_ExitHook_Dcm_DCM_EXCLUSIVE_AREA_0_Return
 *  SchM_ExitHook_Dcm_DCM_EXCLUSIVE_AREA_0_Start
 *  SchM_ExitHook_Dem_DEM_EXCLUSIVE_AREA_0_Return
 *  SchM_ExitHook_Dem_DEM_EXCLUSIVE_AREA_0_Start
 *  SchM_ExitHook_Dem_DEM_EXCLUSIVE_AREA_1_Return
 *  SchM_ExitHook_Dem_DEM_EXCLUSIVE_AREA_1_Start
 *  SchM_ExitHook_Dem_DEM_EXCLUSIVE_AREA_2_Return
 *  SchM_ExitHook_Dem_DEM_EXCLUSIVE_AREA_2_Start
 *  SchM_ExitHook_Dem_DEM_EXCLUSIVE_AREA_3_Return
 *  SchM_ExitHook_Dem_DEM_EXCLUSIVE_AREA_3_Start
 *  SchM_ExitHook_Dem_DEM_EXCLUSIVE_AREA_4_Return
 *  SchM_ExitHook_Dem_DEM_EXCLUSIVE_AREA_4_Start
 *  SchM_ExitHook_Det_DET_EXCLUSIVE_AREA_0_Return
 *  SchM_ExitHook_Det_DET_EXCLUSIVE_AREA_0_Start
 *  SchM_ExitHook_EcuM_ECUM_EXCLUSIVE_AREA_0_Return
 *  SchM_ExitHook_EcuM_ECUM_EXCLUSIVE_AREA_0_Start
 *  SchM_ExitHook_EcuM_ECUM_EXCLUSIVE_AREA_1_Return
 *  SchM_ExitHook_EcuM_ECUM_EXCLUSIVE_AREA_1_Start
 *  SchM_ExitHook_EcuM_ECUM_EXCLUSIVE_AREA_2_Return
 *  SchM_ExitHook_EcuM_ECUM_EXCLUSIVE_AREA_2_Start
 *  SchM_ExitHook_McalLib_CpuEndInit_Return
 *  SchM_ExitHook_McalLib_CpuEndInit_Start
 *  SchM_ExitHook_McalLib_PeripheralEndInit_Return
 *  SchM_ExitHook_McalLib_PeripheralEndInit_Start
 *  SchM_ExitHook_McalLib_SafetyEndInit_Return
 *  SchM_ExitHook_McalLib_SafetyEndInit_Start
 *  SchM_ExitHook_McalLib_StmTimerResolution_Return
 *  SchM_ExitHook_McalLib_StmTimerResolution_Start
 *  SchM_ExitHook_Mcu_AtomAgcReg_Return
 *  SchM_ExitHook_Mcu_AtomAgcReg_Start
 *  SchM_ExitHook_Mcu_TomTgcReg_Return
 *  SchM_ExitHook_Mcu_TomTgcReg_Start
 *  SchM_ExitHook_Nm_NM_EXCLUSIVE_AREA_0_Return
 *  SchM_ExitHook_Nm_NM_EXCLUSIVE_AREA_0_Start
 *  SchM_ExitHook_Nm_NM_EXCLUSIVE_AREA_1_Return
 *  SchM_ExitHook_Nm_NM_EXCLUSIVE_AREA_1_Start
 *  SchM_ExitHook_PduR_PDUR_EXCLUSIVE_AREA_0_Return
 *  SchM_ExitHook_PduR_PDUR_EXCLUSIVE_AREA_0_Start
 *  SchM_ExitHook_Xcp_CANXCP_EXCLUSIVE_AREA_0_Return
 *  SchM_ExitHook_Xcp_CANXCP_EXCLUSIVE_AREA_0_Start
 *  SchM_ExitHook_Xcp_FRXCP_EXCLUSIVE_AREA_0_Return
 *  SchM_ExitHook_Xcp_FRXCP_EXCLUSIVE_AREA_0_Start
 *  SchM_ExitHook_Xcp_FRXCP_EXCLUSIVE_AREA_1_Return
 *  SchM_ExitHook_Xcp_FRXCP_EXCLUSIVE_AREA_1_Start
 *  SchM_ExitHook_Xcp_FRXCP_EXCLUSIVE_AREA_2_Return
 *  SchM_ExitHook_Xcp_FRXCP_EXCLUSIVE_AREA_2_Start
 *  SchM_ExitHook_Xcp_TCPIPXCP_EXCLUSIVE_AREA_0_Return
 *  SchM_ExitHook_Xcp_TCPIPXCP_EXCLUSIVE_AREA_0_Start
 *  SchM_ExitHook_Xcp_XCP_EXCLUSIVE_AREA_0_Return
 *  SchM_ExitHook_Xcp_XCP_EXCLUSIVE_AREA_0_Start
 *  SchM_ExitHook_Xcp_XCP_EXCLUSIVE_AREA_1_Return
 *  SchM_ExitHook_Xcp_XCP_EXCLUSIVE_AREA_1_Start
 *  SchM_ExitHook_Xcp_XCP_EXCLUSIVE_AREA_2_Return
 *  SchM_ExitHook_Xcp_XCP_EXCLUSIVE_AREA_2_Start
 *  SchM_Schedulable_BswM_BswM_MainFunction_Return
 *  SchM_Schedulable_BswM_BswM_MainFunction_Start
 *  SchM_Schedulable_CanNm_CanNm_MainFunction_Return
 *  SchM_Schedulable_CanNm_CanNm_MainFunction_Start
 *  SchM_Schedulable_CanSM_CanSM_MainFunction_Return
 *  SchM_Schedulable_CanSM_CanSM_MainFunction_Start
 *  SchM_Schedulable_CanTp_CanTp_MainFunction_Return
 *  SchM_Schedulable_CanTp_CanTp_MainFunction_Start
 *  SchM_Schedulable_Can_Can_MainFunction_BusOff_Return
 *  SchM_Schedulable_Can_Can_MainFunction_BusOff_Start
 *  SchM_Schedulable_Can_Can_MainFunction_Mode_Return
 *  SchM_Schedulable_Can_Can_MainFunction_Mode_Start
 *  SchM_Schedulable_Can_Can_MainFunction_Read_Return
 *  SchM_Schedulable_Can_Can_MainFunction_Read_Start
 *  SchM_Schedulable_Can_Can_MainFunction_Wakeup_Return
 *  SchM_Schedulable_Can_Can_MainFunction_Wakeup_Start
 *  SchM_Schedulable_Can_Can_MainFunction_Write_Return
 *  SchM_Schedulable_Can_Can_MainFunction_Write_Start
 *  SchM_Schedulable_ComM_ComM_MainFunction_0_Return
 *  SchM_Schedulable_ComM_ComM_MainFunction_0_Start
 *  SchM_Schedulable_ComM_ComM_MainFunction_1_Return
 *  SchM_Schedulable_ComM_ComM_MainFunction_1_Start
 *  SchM_Schedulable_ComM_ComM_MainFunction_2_Return
 *  SchM_Schedulable_ComM_ComM_MainFunction_2_Start
 *  SchM_Schedulable_Com_Com_MainFunctionRx_Return
 *  SchM_Schedulable_Com_Com_MainFunctionRx_Start
 *  SchM_Schedulable_Com_Com_MainFunctionTx_Return
 *  SchM_Schedulable_Com_Com_MainFunctionTx_Start
 *  SchM_Schedulable_Dcm_Dcm_MainFunction_Return
 *  SchM_Schedulable_Dcm_Dcm_MainFunction_Start
 *  SchM_Schedulable_Dem_Dem_MasterMainFunction_Return
 *  SchM_Schedulable_Dem_Dem_MasterMainFunction_Start
 *  SchM_Schedulable_Dem_Dem_SatelliteMainFunction_Return
 *  SchM_Schedulable_Dem_Dem_SatelliteMainFunction_Start
 *  SchM_Schedulable_EcuM_EcuM_MainFunction_Return
 *  SchM_Schedulable_EcuM_EcuM_MainFunction_Start
 *  SchM_Schedulable_Rte_Rte_ComSendSignalProxyPeriodic_Return
 *  SchM_Schedulable_Rte_Rte_ComSendSignalProxyPeriodic_Start
 *  SchM_Schedulable_Xcp_CanXcp_MainFunction_Return
 *  SchM_Schedulable_Xcp_CanXcp_MainFunction_Start
 *  SchM_Schedulable_Xcp_Xcp_MainFunction_Return
 *  SchM_Schedulable_Xcp_Xcp_MainFunction_Start
 *
 *********************************************************************************************************************/

/* double include prevention */
#ifndef _RTE_HOOK_H
# define _RTE_HOOK_H

# include "Os.h" /* PRQA S 0828, 0883 */ /* MD_MSR_1.1_828, MD_Rte_Os */

# include "Rte_Type.h"
# include "Rte_Cfg.h"

# ifndef RTE_VFB_TRACE
#  define RTE_VFB_TRACE (0)
# endif

#endif /* _RTE_HOOK_H */

/**********************************************************************************************************************
 MISRA 2004 violations and justifications
 *********************************************************************************************************************/

/* module specific MISRA deviations:
   MD_Rte_Os:
     Reason:     This justification is used as summary justification for all deviations caused by the MICROSAR OS
                 which is for testing of the RTE. Those deviations are no issues in the RTE code.
     Risk:       No functional risk.
     Prevention: Not required.

*/
