/**********************************************************************************************************************
 *  COPYRIGHT
 *  -------------------------------------------------------------------------------------------------------------------
 *
 *                This software is copyright protected and proprietary to Vector Informatik GmbH.
 *                Vector Informatik GmbH grants to you only those rights as set out in the license conditions.
 *                All other rights remain with Vector Informatik GmbH.
 *  -------------------------------------------------------------------------------------------------------------------
 *  FILE DESCRIPTION
 *  -------------------------------------------------------------------------------------------------------------------
 *          File:  Rte_Type.h
 *        Config:  Axera.dpa
 *   ECU-Project:  MyECU
 *
 *     Generator:  MICROSAR RTE Generator Version 4.19.0
 *                 RTE Core Version 1.19.0
 *       License:  CBD1900078
 *
 *   Description:  Header file containing user defined AUTOSAR types and RTE structures
 *********************************************************************************************************************/

/* double include prevention */
#ifndef _RTE_TYPE_H
# define _RTE_TYPE_H

# include "Rte.h"


/**********************************************************************************************************************
 * Data type definitions
 *********************************************************************************************************************/

# define Rte_TypeDef_LCDState_t
typedef uint8 LCDState_t;

# define Rte_TypeDef_VedInfo
typedef uint8 VedInfo;

# define Rte_TypeDef_id_t
typedef uint32 id_t;

# define Rte_TypeDef_lane_ids
typedef uint32 lane_ids;

# define Rte_TypeDef_DataArrayType_uint8_4
typedef uint8 DataArrayType_uint8_4[4];

# define Rte_TypeDef_Dcm_Data2ByteType
typedef uint8 Dcm_Data2ByteType[2];

# define Rte_TypeDef_Dcm_Data4ByteType
typedef uint8 Dcm_Data4ByteType[4];

# define Rte_TypeDef_Dem_MaxDataValueType
typedef uint8 Dem_MaxDataValueType[4];

# define Rte_TypeDef_Rte_DT_CamTrafficLight_t_15
typedef sint32 Rte_DT_CamTrafficLight_t_15[8];

# define Rte_TypeDef_Rte_DT_CamTrafficSign_t_14
typedef sint32 Rte_DT_CamTrafficSign_t_14[8];

# define Rte_TypeDef_Rte_DT_EMVEDSensorMounting_t_0
typedef uint8 Rte_DT_EMVEDSensorMounting_t_0[8];

# define Rte_TypeDef_Rte_DT_EMVEDSensor_t_0
typedef uint8 Rte_DT_EMVEDSensor_t_0[8];

# define Rte_TypeDef_Rte_DT_EMVEDVehParMain_t_0
typedef uint8 Rte_DT_EMVEDVehParMain_t_0[16];

# define Rte_TypeDef_Rte_DT_EMVEDswa_t_0
typedef float32 Rte_DT_EMVEDswa_t_0[2];

# define Rte_TypeDef_Rte_DT_EMVEDswa_t_1
typedef float32 Rte_DT_EMVEDswa_t_1[2];

# define Rte_TypeDef_Rte_DT_EMVEDvel_t_0
typedef float32 Rte_DT_EMVEDvel_t_0[2];

# define Rte_TypeDef_Rte_DT_EMVEDvel_t_1
typedef float32 Rte_DT_EMVEDvel_t_1[2];

# define Rte_TypeDef_Rte_DT_EMVehParAdd_t_0
typedef uint8 Rte_DT_EMVehParAdd_t_0[12];

# define Rte_TypeDef_Rte_DT_EM_t_GenObjListHeader_1
typedef sint8 Rte_DT_EM_t_GenObjListHeader_1[40];

# define Rte_TypeDef_Rte_DT_RoadMarkerData_8
typedef lane_ids Rte_DT_RoadMarkerData_8[20];

# define Rte_TypeDef_Rte_DT_ST_Envm_TrafficSign_t_6
typedef uint32 Rte_DT_ST_Envm_TrafficSign_t_6[2];

# define Rte_TypeDef_Rte_DT_ST_VEDVehDyn_t_6
typedef uint8 Rte_DT_ST_VEDVehDyn_t_6[12];

# define Rte_TypeDef_Rte_DT_ST_VLCSen_acc_object_t_25
typedef sint32 Rte_DT_ST_VLCSen_acc_object_t_25[47];

# define Rte_TypeDef_Rte_DT_ST_VLCSen_acc_object_t_26
typedef sint32 Rte_DT_ST_VLCSen_acc_object_t_26[47];

# define Rte_TypeDef_Rte_DT_ST_VLCSen_acc_object_t_4
typedef sint16 Rte_DT_ST_VLCSen_acc_object_t_4[5];

# define Rte_TypeDef_Rte_DT_TrafficLightData_10
typedef id_t Rte_DT_TrafficLightData_10[20];

# define Rte_TypeDef_Rte_DT_TrafficSignData_8
typedef lane_ids Rte_DT_TrafficSignData_8[20];

# define Rte_TypeDef_Rte_DT_VEDBrake_t_0
typedef uint8 Rte_DT_VEDBrake_t_0[13];

# define Rte_TypeDef_Rte_DT_VEDPowerTrain_t_4
typedef uint8 Rte_DT_VEDPowerTrain_t_4[4];

# define Rte_TypeDef_Rte_DT_VEDVehSigAdd_t_0
typedef uint8 Rte_DT_VEDVehSigAdd_t_0[52];

# define Rte_TypeDef_Rte_DT_VEDVehSigMain_t_0
typedef uint8 Rte_DT_VEDVehSigMain_t_0[32];

# define Rte_TypeDef_Rte_DT_VLCSen_HeaderAssessedObjList_t_2
typedef sint8 Rte_DT_VLCSen_HeaderAssessedObjList_t_2[6];

# define Rte_TypeDef_Rte_DT_sTJATCTInReq_st_44
typedef float32 Rte_DT_sTJATCTInReq_st_44[9];

# define Rte_TypeDef_Rte_DT_sTJATCTInReq_st_45
typedef float32 Rte_DT_sTJATCTInReq_st_45[9];

# define Rte_TypeDef_Rte_DT_sTJATCTInReq_st_46
typedef float32 Rte_DT_sTJATCTInReq_st_46[9];

# define Rte_TypeDef_Rte_DT_sTJATCTInReq_st_47
typedef float32 Rte_DT_sTJATCTInReq_st_47[9];

# define Rte_TypeDef_Rte_DT_sTJATCTInReq_st_48
typedef float32 Rte_DT_sTJATCTInReq_st_48[9];

# define Rte_TypeDef_rt_Array_UInt8_12
typedef uint8 rt_Array_UInt8_12[12];

# define Rte_TypeDef_Bbox2D
typedef struct
{
  boolean initialized;
  float32 top_left_x;
  float32 top_left_y;
  float32 bottom_right_x;
  float32 bottom_right_y;
  float32 confidence;
  boolean is_left_side_truncated;
  boolean is_right_side_truncated;
  boolean is_top_side_truncated;
  boolean is_bottom_side_truncated;
} Bbox2D;

# define Rte_TypeDef_CameraBlockageInfo
typedef struct
{
  sint8 blockage_type;
  sint8 glare_status;
} CameraBlockageInfo;

# define Rte_TypeDef_CoordinateSystem
typedef struct
{
  uint8 index;
} CoordinateSystem;

# define Rte_TypeDef_EMVEDCurveVehDyn_t
typedef struct
{
  float32 Curve;
  float32 C1;
  float32 Gradient;
  float32 varC0;
  float32 varC1;
  float32 Quality;
  float32 CrvError;
  uint8 CrvConf;
} EMVEDCurveVehDyn_t;

# define Rte_TypeDef_EMVEDDrvIntCurveVehDyn_t
typedef struct
{
  float32 Curve;
  float32 Variance;
  float32 Gradient;
} EMVEDDrvIntCurveVehDyn_t;

# define Rte_TypeDef_EMVEDLatAccelVehDyn_t
typedef struct
{
  float32 LatAccel;
  float32 Variance;
} EMVEDLatAccelVehDyn_t;

# define Rte_TypeDef_EMVEDLegacyVehDyn_t
typedef struct
{
  float32 YawRateMaxJitter;
  boolean bStandStill;
} EMVEDLegacyVehDyn_t;

# define Rte_TypeDef_EMVEDMotVarVehDyn_t
typedef struct
{
  float32 Velocity;
  float32 Accel;
  float32 varVelocity;
  float32 varAccel;
} EMVEDMotVarVehDyn_t;

# define Rte_TypeDef_EMVEDMotionStateVehDyn_t
typedef struct
{
  uint8 MotState;
  float32 Confidence;
} EMVEDMotionStateVehDyn_t;

# define Rte_TypeDef_EMVEDSideSlipVehDyn_t
typedef struct
{
  float32 SideSlipAngle;
  float32 Variance;
} EMVEDSideSlipVehDyn_t;

# define Rte_TypeDef_EMVEDVeloCorrVehDyn_t
typedef struct
{
  float32 corrFact;
  float32 corrVar;
  float32 corrVelo;
  float32 corrVeloVar;
  float32 minVelo;
  float32 maxVelo;
  uint8 corrQual;
  boolean bRollerTestBench;
} EMVEDVeloCorrVehDyn_t;

# define Rte_TypeDef_EMVEDYawRateVehDyn_t
typedef struct
{
  float32 YawRate;
  float32 Variance;
  float32 Quality;
} EMVEDYawRateVehDyn_t;

# define Rte_TypeDef_EM_Fusion_GenAttributes_t
typedef struct
{
  uint8 eDynamicProperty_nu;
  uint8 uiDynConfidence_per;
  uint32 eClassification_nu;
  uint8 uiClassConfidence_per;
} EM_Fusion_GenAttributes_t;

# define Rte_TypeDef_EM_Fusion_GenGenerals_t
typedef struct
{
  float32 fLifeTime_s;
  uint16 uiLifeCycles_nu;
  uint8 uiMaintenanceState_nu;
  uint16 uiID_nu;
  sint32 iRawFusionID_nu;
} EM_Fusion_GenGenerals_t;

# define Rte_TypeDef_EM_Fusion_GenGeometry_t
typedef struct
{
  float32 fWidth_met;
  float32 fWidthStd_met;
  float32 fWidthLeft_met;
  float32 fWidthRight_met;
  float32 fLength_met;
  float32 fLengthStd_met;
  float32 fLengthFront_met;
  float32 fLengthRear_met;
  float32 fOrientation_rad;
  float32 fOrientationStd_rad;
} EM_Fusion_GenGeometry_t;

# define Rte_TypeDef_EM_Fusion_GenKinematics_t
typedef struct
{
  float32 fDistX_met;
  float32 fDistXStd_met;
  float32 fDistY_met;
  float32 fDistYStd_met;
  float32 fVrelX_mps;
  float32 fVrelXStd_mps;
  float32 fVrelY_mps;
  float32 fVrelYStd_mps;
  float32 fArelX_mpss;
  float32 fArelXStd_mpss;
  float32 fArelY_mpss;
  float32 fArelYStd_mpss;
  float32 fVabsX_mps;
  float32 fVabsXStd_mps;
  float32 fVabsY_mps;
  float32 fVabsYStd_mps;
  float32 fAabsX_mpss;
  float32 fAabsXStd_mpss;
  float32 fAabsY_mpss;
  float32 fAabsYStd_mpss;
} EM_Fusion_GenKinematics_t;

# define Rte_TypeDef_EM_Fusion_GenQualifiers_t
typedef struct
{
  float32 fProbabilityOfExistence_per;
  uint8 uiMeasuredTargetFrequency_nu;
  boolean bObjStable;
} EM_Fusion_GenQualifiers_t;

# define Rte_TypeDef_EM_t_GenObjGenerals
typedef struct
{
  float32 fLifeTime;
  uint16 uiLifeCycles;
  uint8 eMaintenanceState;
  uint8 uiID;
  uint8 eSplitMergeState;
  uint8 uiMergeID;
  uint8 uiSplitID;
} EM_t_GenObjGenerals;

# define Rte_TypeDef_ENVMSignalHeader_t
typedef struct
{
  uint32 uiTimeStamp;
  uint16 uiMeasurementCounter;
  uint16 uiCycleCounter;
  uint8 eSigStatus;
} ENVMSignalHeader_t;

# define Rte_TypeDef_EnvmNvmState_t
typedef struct
{
  uint32 StateTrafficOrientation;
} EnvmNvmState_t;

# define Rte_TypeDef_Envm_t_CR_Attributes
typedef struct
{
  uint8 eClassification;
  uint8 uiClassConfidence;
  uint8 ui8Dummy;
  uint8 uiReferenceToTrace;
} Envm_t_CR_Attributes;

# define Rte_TypeDef_Envm_t_CR_Geometry
typedef struct
{
  float32 fWidth;
  float32 fLength;
  float32 fOrientation;
  float32 fOrientationStd;
} Envm_t_CR_Geometry;

# define Rte_TypeDef_Envm_t_CR_KinEnvmatic
typedef struct
{
  float32 fMaxAccelY;
} Envm_t_CR_KinEnvmatic;

# define Rte_TypeDef_Envm_t_CR_Legacy
typedef struct
{
  float32 fAngle;
  float32 fLastTargetDistY;
  float32 fLastTargetDistX;
} Envm_t_CR_Legacy;

# define Rte_TypeDef_Envm_t_CR_MotionAttributes
typedef struct
{
  uint8 eDynamicProperty;
  uint8 uiStoppedConfidence;
  uint8 eAbsMovingState;
  uint8 eDynamicSubProperty;
} Envm_t_CR_MotionAttributes;

# define Rte_TypeDef_Envm_t_CR_SensorSpecific
typedef struct
{
  float32 fRCS;
  uint8 ucMeasuredSources;
  uint8 eObjRelationsClass;
  uint8 eFOVOverlapFar;
  boolean bNearObjInBeam;
} Envm_t_CR_SensorSpecific;

# define Rte_TypeDef_Envm_t_GenObjAttributes
typedef struct
{
  uint8 eDynamicProperty;
  uint8 uiDynConfidence;
  uint8 eClassification;
  uint8 uiClassConfidence;
  uint8 eObjectOcclusion;
} Envm_t_GenObjAttributes;

# define Rte_TypeDef_Envm_t_GenObjKinEnvmatics
typedef struct
{
  float32 fDistX;
  float32 fDistXStd;
  float32 fDistY;
  float32 fDistYStd;
  float32 fVrelX;
  float32 fVrelXStd;
  float32 fVrelY;
  float32 fVrelYStd;
  float32 fArelX;
  float32 fArelXStd;
  float32 fArelY;
  float32 fArelYStd;
  float32 fVabsX;
  float32 fVabsXStd;
  float32 fVabsY;
  float32 fVabsYStd;
  float32 fAabsX;
  float32 fAabsXStd;
  float32 fAabsY;
  float32 fAabsYStd;
} Envm_t_GenObjKinEnvmatics;

# define Rte_TypeDef_Envm_t_GenObjQualifiers
typedef struct
{
  uint8 uiProbabilityOfExistence;
  uint8 uiAccObjQuality;
  uint8 uiEbaObjQuality;
  uint8 eEbaHypCat;
  uint16 eEbaInhibitionMask;
} Envm_t_GenObjQualifiers;

# define Rte_TypeDef_Envm_t_GenObjShapePointCoord
typedef struct
{
  float32 fPosX;
  float32 fPosY;
  uint16 uiPosXStd;
  uint16 uiPosYStd;
} Envm_t_GenObjShapePointCoord;

# define Rte_TypeDef_LCF_ALPOutput_t
typedef struct
{
  boolean bLeftAdjLnStepDeounced_bool;
  boolean bRightAdjLnStepDeounced_bool;
  boolean bLeftAdjLnBridging_bool;
  boolean bRightAdjLnBridging_bool;
  boolean bLeftAdjLnStepOnBridging_bool;
  boolean bRightAdjLnStepOnBridging_bool;
  uint16 uiLeftAdjLnInvalidQu_btf;
  uint16 uiRightAdjLnInvalidQu_btf;
  uint8 uiLeftAdjLnAliveCount_per;
  uint8 uiRightAdjLnAliveCount_per;
  float32 fLeftAdjLnDistance_met;
  float32 fLeftAdjLnYawAngle_rad;
  float32 fLeftAdjLnCurvature_1pm;
  float32 fLeftAdjLnCrvRate_1pm2;
  float32 fLeftAdjLnValidLength_met;
  float32 fRightAdjLnDistance_met;
  float32 fRightAdjLnYawAngle_rad;
  float32 fRightAdjLnCurvature_1pm;
  float32 fRightAdjLnCrvRate_1pm2;
  float32 fRightAdjLnValidLength_met;
} LCF_ALPOutput_t;

# define Rte_TypeDef_LCF_DmcNVRAMData_t
typedef struct
{
  boolean LCFVeh_Nb_SwitchReserved1_nu;
  boolean LCFVeh_Nb_SwitchReserved2_nu;
  boolean LCFVeh_Nb_SwitchReserved3_nu;
  boolean LCFVeh_Nb_SwitchReserved4_nu;
  boolean LCFVeh_Nb_SwitchReserved5_nu;
  boolean LCFVeh_Nb_SwitchReserved6_nu;
  boolean LCFVeh_Nb_SwitchReserved7_nu;
  boolean LCFVeh_Nb_SwitchReserved8_nu;
  boolean LCFVeh_Nb_SwitchReserved9_nu;
  boolean LCFVeh_Nb_SwitchReserved10_nu;
  uint8 LCFVeh_Nu_SensitivityReserved1_nu;
  uint8 LCFVeh_Nu_SensitivityReserved2_nu;
  uint8 LCFVeh_Nu_SensitivityReserved3_nu;
  uint8 LCFVeh_Nu_SensitivityReserved4_nu;
  uint8 LCFVeh_Nu_SensitivityReserved5_nu;
  float32 LCFVeh_Nf_SensitivityReserved1_nu;
  float32 LCFVeh_Nf_SensitivityReserved2_nu;
  float32 LCFVeh_Nf_SensitivityReserved3_nu;
  float32 LCFVeh_Nf_SensitivityReserved4_nu;
  float32 LCFVeh_Nf_SensitivityReserved5_nu;
  float32 LCFVeh_Nf_SensitivityReserved6_nu;
  float32 LCFVeh_Nf_SensitivityReserved7_nu;
  float32 LCFVeh_Nf_SensitivityReserved8_nu;
  float32 LCFVeh_Nf_SensitivityReserved9_nu;
  float32 LCFVeh_Nf_SensitivityReserved10_nu;
} LCF_DmcNVRAMData_t;

# define Rte_TypeDef_LCF_DmcSignalHeader_t
typedef struct
{
  uint32 uiTimeStamp;
  uint16 uiMeasurementCounter;
  uint16 uiCycleCounter;
  uint8 eSigStatus;
} LCF_DmcSignalHeader_t;

# define Rte_TypeDef_LCF_HODOutput_t
typedef struct
{
  uint8 HOD_StEstHandTrq;
  uint8 HOD_StSysWarning;
  float32 HOD_RatDrvAttention;
  boolean HOD_HandsOffAbuseWarn;
  boolean OD_EnaHandsOffCnfm;
} LCF_HODOutput_t;

# define Rte_TypeDef_LCF_LBPOutput_t
typedef struct
{
  uint16 uLaneInvalidQualifierLf;
  uint16 uLaneInvalidQualifierRi;
  float32 fLaneWidth;
  uint8 bLaneChangeDtct;
  float32 fPosX0CtrlLf;
  float32 fPosY0CtrlLf;
  float32 fHeadingCtrlLf;
  float32 fCrvCtrlLf;
  float32 fCrvRateCtrlLf;
  float32 fValidLengthCtrlLf;
  float32 fPosX0CtrlCntr;
  float32 fPosY0CtrlCntr;
  float32 fHeadingCtrlCntr;
  float32 fCrvCtrlCntr;
  float32 fCrvRateCtrlCntr;
  float32 fValidLengthCtrlCntr;
  float32 fPosX0CtrlRi;
  float32 fPosY0CtrlRi;
  float32 fHeadingCtrlRi;
  float32 fCrvCtrlRi;
  float32 fCrvRateCtrlRi;
  float32 fValidLengthCtrlRi;
  float32 fPosY0SafeLf;
  float32 fHeadingSafeLf;
  float32 fCrvSafeLf;
  float32 fPosY0SafeRi;
  float32 fHeadingSafeRi;
  float32 fCrvSafeRi;
  uint8 uInvalidQualifierSafeLf;
  uint8 uInvalidQualifierSafeRi;
  uint8 uLaneValidQualDMC;
  uint8 uVisualValidQualifier;
  uint8 uLaneTypeLf;
  uint8 uLaneTypeRi;
  uint8 bConstructionSiteDtct;
  uint8 uOverallQualityLf;
  uint8 uOverallQualityRi;
  uint8 uCrvQualityLf;
  uint8 uCrvQualityRi;
  float32 fABDTimeStamp;
  uint16 uRangeCheckQualifier;
  float32 fFltQualityCntr;
  uint8 uFltStatusCntr;
  uint16 uOutRangeCheckQualifier;
  uint8 uPercStraightDtct;
  uint8 uPercExitLf;
  uint8 uPercExitRi;
  uint8 bBridgePossibleUnCplLf;
  uint8 bBridgePossibleUnCplRi;
  uint8 uPercUpDownHillDtct;
  float32 fLaneWidthUnCpl;
  float32 fLaneWidthCpl;
  uint8 uOverallQualityUnCplLf;
  uint8 uOverallQualityUnCplRi;
  uint8 uOverallQualityCplLf;
  uint8 uOverallQualityCplRi;
  uint8 uBtfBridgeUnCpl;
} LCF_LBPOutput_t;

# define Rte_TypeDef_LCF_LCDOutput_t
typedef struct
{
  LCDState_t uiLCDState;
  boolean bTorqueReq;
  float32 fTorque;
  float32 fTorqueGrad;
} LCF_LCDOutput_t;

# define Rte_TypeDef_LCF_LDPSAOutput_t
typedef struct
{
  uint8 LDPSC_DgrSide_St;
  uint8 LDPSC_RdyToTrig_B;
  uint8 LDPSC_SysOut_St;
  float32 LDPDT_LnPstnLf_Mi;
  float32 LDPDT_LnPstnRi_Mi;
  float32 LDPDT_LnHeadLf_Rad;
  float32 LDPDT_LnHeadRi_Rad;
  float32 LDPDT_LnCltdCurvLf_ReMi;
  float32 LDPDT_LnCltdCurvRi_ReMi;
  float32 LDPVSE_NVRAMVehStartupSpd_Kmph;
  boolean LDPSC_NVRAMLDPSwitch_B;
} LCF_LDPSAOutput_t;

# define Rte_TypeDef_LCF_LDWSAOutput_t
typedef struct
{
  uint8 LDWC_DgrSide_St;
  uint8 LDWC_RdyToTrig_B;
  uint8 LDWC_SysOut_St;
  float32 LDVSE_NVRAMVehStartupSpd_kmph;
  boolean LDWC_NVRAMLDWSwitch_B;
} LCF_LDWSAOutput_t;

# define Rte_TypeDef_LCF_MCTLFCOut_st
typedef struct
{
  float32 CSCLTA_LeCridrBndPosX0_met;
  float32 CSCLTA_LeCridrBndPosY0_met;
  float32 CSCLTA_LeCridrHeadAng_rad;
  float32 CSCLTA_LeCridrBndCrv_1pm;
  float32 CSCLTA_LeCridrBndCrvChng_1pm2;
  float32 CSCLTA_LeCridrBndLength_met;
  float32 CSCLTA_RiCridrBndPosX0_met;
  float32 CSCLTA_RiCridrBndPosY0_met;
  float32 CSCLTA_RiCridrHeadAng_rad;
  float32 CSCLTA_RiCridrBndCrv_1pm;
  float32 CSCLTA_RiCridrBndCrvChng_1pm2;
  float32 CSCLTA_RiCridrBndLength_met;
  float32 CSCLTA_TgtTrajPosX0_met;
  float32 CSCLTA_TgtTrajPosY0_met;
  float32 CSCLTA_TgtTrajHeadAng_rad;
  float32 CSCLTA_TgtTrajCrv_1pm;
  float32 CSCLTA_TgtTrajCrvChng_1pm2;
  float32 CSCLTA_TgtTrajLength_met;
  float32 CSCLTA_WeightTgtDistY_nu;
  float32 CSCLTA_WeightEndTime_nu;
  float32 CSCLTA_DistYToILeTgtArea_met;
  float32 CSCLTA_DistYToIRiTgtArea_met;
  float32 CSCLTA_FTireAclMax_mps2;
  float32 CSCLTA_FTireAclMin_mps2;
  float32 CSCLTA_PredTimeHeadAng_sec;
  float32 CSCLTA_PredTimeCrv_sec;
  float32 CSCLTA_PlanningHorzion_sec;
  float32 CSCLTA_ObstacleVelX_mps;
  float32 CSCLTA_ObstacleAclX_mps2;
  float32 CSCLTA_ObstacleWidth_met;
  float32 CSCLTA_ObstacleDistX_met;
  float32 CSCLTA_ObstacleDistY_met;
  float32 CSCLTA_SensorTStamp_sec;
  float32 CSCLTA_MaxCrvTrajGuiCtrl_1pm;
  float32 CSCLTA_MaxCrvGrdBuildup_1pms;
  float32 CSCLTA_MaxCrvGrdRed_1pms;
  float32 CSCLTA_GrdLimitTgtCrvGC_1pms;
  float32 CSCLTA_StrWhStifLimit_nu;
  float32 CSCLTA_StrWhStifGrad_1ps;
  float32 CSCLTA_TrqRampGrad_1ps;
  float32 CSCLTA_MaxTrqScalLimit_nu;
  float32 CSCLTA_MaxTrqScalGrad_nu;
  float32 CSCLTA_LimiterDuration_sec;
  float32 CSCLTA_MaxJerkAllowed_mps3;
  uint8 CSCLTA_DeratingLevel_nu;
  uint8 CSCLTA_ControllingFunction_nu;
  uint8 CSCLTA_SysStateLCF;
  uint8 CSCLTA_TgtPlanServQu_nu;
  uint8 CSCLTA_TrajGuiQualifier_nu;
  boolean CSCLTA_TriggerReplan_nu;
  boolean CSCLTA_LatencyCompActivated_bool;
  boolean CSCLTA_HighStatAccu_bool;
  boolean CSCLTA_LimiterActivated_nu;
} LCF_MCTLFCOut_st;

# define Rte_TypeDef_LCF_SENTJASAOutput_t
typedef struct
{
  uint8 TJASTM_SysStateHWA_nu;
  uint8 TJASTM_NpilotSysInfo;
  uint8 TJASTM_PilotAudioPlay;
  uint8 TJASTM_LatCtrlHandsOffReleaseWarn_nu;
  uint8 TJASLC_LaneChangWarning_nu;
  uint8 TJASLC_SLCAudioPlay_nu;
  uint8 TJASTM_PilotEnableACCSwitch_nu;
  uint8 TJASTM_PilotDisableACCSwitch_nu;
} LCF_SENTJASAOutput_t;

# define Rte_TypeDef_LCF_SenSignalHeader_t
typedef struct
{
  uint32 uiTimeStamp;
  uint16 uiMeasurementCounter;
  uint16 uiCycleCounter;
  uint8 eSigStatus;
} LCF_SenSignalHeader_t;

# define Rte_TypeDef_LCF_TJADMCOutPro_t
typedef struct
{
  float32 fSteerAngle_deg;
  float32 fSteerWhlAngle_deg;
  float32 fLonAccCmd;
  uint8 uiEPSRequest_nu;
  uint8 uiLonAccRequest_nu;
  float32 fSteerWhlTqAdd_nm;
  float32 fDampingLevelRmp_nu;
} LCF_TJADMCOutPro_t;

# define Rte_TypeDef_LCF_TJASAOutput_t
typedef struct
{
  uint8 TJASTM_LatCtrlMode_nu;
} LCF_TJASAOutput_t;

# define Rte_TypeDef_LCF_TJATCTOut_st
typedef struct
{
  float32 TJATCT_TimerPlauCheck;
  float32 TJATCT_DeltaFCmd;
  float32 TJATCT_ReqFfcCrv;
  float32 TJATCT_SumCtrlCrv;
  float32 TJATCT_HldVehCrv;
  float32 TJATCT_ThdCrvPlauChkUp;
  float32 TJATCT_ThdCrvPlauChkLow;
  float32 TJATCT_ReqFbcDcCrv;
  float32 TJATCT_LmtReqFfcCrv;
  uint8 TJATCT_BtfQulifierTrajCtrl;
  boolean TJATCT_EnaUnplauRequest;
  boolean TJATCT_EnaSetDegrReq;
  boolean TJATCT_EnaRstDegrReq;
  boolean TJATCT_EnaPlausibilityCheck;
  boolean TJATCT_EnaHldVehCrv;
  boolean TJATCT_EnaLmtWarn;
  boolean TJATCT_EnaPlauCheck;
  boolean LGC_EnableCtrl_nu;
  float32 CDC_CtrlErrDistY;
  float32 CDC_CtrlErrHeading;
  float32 data_log_0;
  float32 data_log_1;
  float32 data_log_2;
  float32 data_log_3;
  float32 data_log_4;
  float32 data_log_5;
  float32 data_log_6;
  float32 data_log_7;
  float32 data_log_8;
  float32 data_log_9;
} LCF_TJATCTOut_st;

# define Rte_TypeDef_LCF_VehNVRAMData_t
typedef struct
{
  boolean LCFVeh_Nb_SwitchReserved1_nu;
  boolean LCFVeh_Nb_SwitchReserved2_nu;
  boolean LCFVeh_Nb_SwitchReserved3_nu;
  boolean LCFVeh_Nb_SwitchReserved4_nu;
  boolean LCFVeh_Nb_SwitchReserved5_nu;
  boolean LCFVeh_Nb_SwitchReserved6_nu;
  boolean LCFVeh_Nb_SwitchReserved7_nu;
  boolean LCFVeh_Nb_SwitchReserved8_nu;
  boolean LCFVeh_Nb_SwitchReserved9_nu;
  boolean LCFVeh_Nb_SwitchReserved10_nu;
  uint8 LCFVeh_Nu_SensitivityReserved1_nu;
  uint8 LCFVeh_Nu_SensitivityReserved2_nu;
  uint8 LCFVeh_Nu_SensitivityReserved3_nu;
  uint8 LCFVeh_Nu_SensitivityReserved4_nu;
  uint8 LCFVeh_Nu_SensitivityReserved5_nu;
  float32 LCFVeh_Nf_SensitivityReserved1_nu;
  float32 LCFVeh_Nf_SensitivityReserved2_nu;
  float32 LCFVeh_Nf_SensitivityReserved3_nu;
  float32 LCFVeh_Nf_SensitivityReserved4_nu;
  float32 LCFVeh_Nf_SensitivityReserved5_nu;
  float32 LCFVeh_Nf_SensitivityReserved6_nu;
  float32 LCFVeh_Nf_SensitivityReserved7_nu;
  float32 LCFVeh_Nf_SensitivityReserved8_nu;
  float32 LCFVeh_Nf_SensitivityReserved9_nu;
  float32 LCFVeh_Nf_SensitivityReserved10_nu;
} LCF_VehNVRAMData_t;

# define Rte_TypeDef_LCF_VehSignalHeader_t
typedef struct
{
  uint32 uiTimeStamp;
  uint16 uiMeasurementCounter;
  uint16 uiCycleCounter;
  uint8 eSigStatus;
} LCF_VehSignalHeader_t;

# define Rte_TypeDef_LaneData_type
typedef struct
{
  float32 LaneConfidence;
  uint8 LaneMarkerType;
  uint8 LaneMarkerColor;
  float32 LaneViewRangeStart;
  float32 LaneViewRangeEnd;
  float32 LaneModelC0;
  float32 LaneModelC1;
  float32 LaneModelC2;
  float32 LaneModelC3;
} LaneData_type;

# define Rte_TypeDef_MVEDAccelCorrVehDyn_t
typedef struct
{
  float32 corrAccel;
  float32 corrAccelVar;
} MVEDAccelCorrVehDyn_t;

# define Rte_TypeDef_ObjectData_Type
typedef struct
{
  uint8 ObjectId;
  uint32 ObjectAge;
  uint8 ObjectClass;
  uint8 ObjectMeasuringStatus;
  uint8 ObjectMotionStatus;
  uint8 ObjectMotionCategory;
  float32 ObjectDistX;
  float32 ObjectDistY;
  float32 ObjectAbsAccX;
  float32 ObjectAbsAccY;
  float32 ObjectWidth;
  float32 ObjectLength;
  float32 ObjectHeading;
  float32 ObjectAbsVelX;
  float32 ObjectAbsVelY;
} ObjectData_Type;

# define Rte_TypeDef_Point2f
typedef struct
{
  float32 x;
  float32 y;
} Point2f;

# define Rte_TypeDef_Point3d
typedef struct
{
  float64 x;
  float64 y;
  float64 z;
} Point3d;

# define Rte_TypeDef_Quaternionf
typedef struct
{
  float32 qx;
  float32 qy;
  float32 qz;
  float32 qw;
} Quaternionf;

# define Rte_TypeDef_STTime
typedef struct
{
  uint32 secs;
  uint32 nsecs;
} STTime;

# define Rte_TypeDef_ST_ECAMtCyclEnvmode_t
typedef struct
{
  uint32 uiVersionNumber;
  uint8 eCycleMode;
  float32 fECAMtCycleTime;
} ST_ECAMtCyclEnvmode_t;

# define Rte_TypeDef_ST_LCFSEN_NVRAMData_t
typedef struct
{
  boolean LCFSen_Nb_LDWPowerOffSwitch_nu;
  boolean LCFSen_Nb_LDPPowerOffSwitch_nu;
  boolean LCFSEN_Nb_DCLCSwitchNVRAM_nu;
  boolean LCFSen_Nb_SwitchReserved1_nu;
  boolean LCFSen_Nb_SwitchReserved2_nu;
  boolean LCFSen_Nb_SwitchReserved3_nu;
  boolean LCFSen_Nb_SwitchReserved4_nu;
  boolean LCFSen_Nb_SwitchReserved5_nu;
  boolean LCFSen_Nb_SwitchReserved6_nu;
  boolean LCFSen_Nb_SwitchReserved7_nu;
  boolean LCFSen_Nb_SwitchReserved8_nu;
  boolean LCFSen_Nb_SwitchReserved9_nu;
  boolean LCFSen_Nb_SwitchReserved10_nu;
  uint8 LCFSen_Nu_LDWSensitivity_nu;
  uint8 LCFSen_Nu_LDPSensitivity_nu;
  uint8 LCFSen_Nu_SensitivityReserved1_nu;
  uint8 LCFSen_Nu_SensitivityReserved2_nu;
  uint8 LCFSen_Nu_SensitivityReserved3_nu;
  uint8 LCFSen_Nu_SensitivityReserved4_nu;
  uint8 LCFSen_Nu_SensitivityReserved5_nu;
  float32 LCFSen_Nf_LDWStartupSpd_kph;
  float32 LCFSen_Nf_LDPStartupSpd_kph;
  float32 LCFSen_Nf_Reserved1_nu;
  float32 LCFSen_Nf_Reserved2_nu;
  float32 LCFSen_Nf_Reserved3_nu;
  float32 LCFSen_Nf_Reserved4_nu;
  float32 LCFSen_Nf_Reserved5_nu;
  float32 LCFSen_Nf_Reserved6_nu;
  float32 LCFSen_Nf_Reserved7_nu;
  float32 LCFSen_Nf_Reserved8_nu;
  float32 LCFSen_Nf_Reserved9_nu;
  float32 LCFSen_Nf_Reserved10_nu;
} ST_LCFSEN_NVRAMData_t;

# define Rte_TypeDef_ST_VLCVEH_CANOut
typedef struct
{
  uint8 ADCS8_AEB_SystemFaultStatus;
  uint8 ADCS8_AEB_SystemStatus;
  uint8 ADCS2_AEBPrefillReq;
  uint8 ADCS2_AEBPartialBrake;
  uint8 ADCS2_AEBFullBrake;
  uint8 ADCS2_AEB_DBSLevel;
  uint8 ADCS2_AEB_JerkReq;
  uint8 ADCS2_AEB_JerkLevel;
  float32 ADCS2_AEBTargetDeceleration;
  uint8 ADCS2_AEBVehicleHoldReq;
  uint8 ADCS8_FCWSystemFaultStatus;
  uint8 ADCS8_FCWStatus;
  uint8 ADCS8_FCWSensitiveLevel;
  uint8 ADCS8_FCW_State;
  uint8 ADCS8_ACCOnOffState;
  uint8 ADCS8_longitudCtrlTargetValidity;
  uint8 ADCS8_ACCSystemFaultStatus;
  uint8 ADCS8_ACCState;
  uint8 ADCS8_longitudCtrlTakeOverReq;
  boolean ADCS2_LongitudCtrlDecToStopReq;
  boolean ADCS2_LongitudCtrlDriveOff;
  boolean ADCS8_ADAS_DriveOffPossilbe;
  boolean ADCS8_TSR_SLFStatefeedback;
  uint8 ADCS12_longitudDisableInfo;
  boolean ADCS12_ADAS_DriveOffinhibition;
  boolean ADCS12_DriveOffBroadcast;
  boolean ADCS2_LongitudCtrlAccelCtrlReq;
  float32 ADCS2_LongitudCtrlTargetAccel;
  uint8 ADCS8_longitudCtrlSetSpeed;
  uint8 ADCS8_longitudCtrlSetDistance;
  boolean ADCS8_VoiceMode;
  uint8 ADCS12_longitudCtrlSysInfo;
} ST_VLCVEH_CANOut;

# define Rte_TypeDef_ST_VLCVeh_NVRAMData_t
typedef struct
{
  float32 VLCVEH_Nf_Reserved1;
  float32 VLCVEH_Nf_Reserved2;
  float32 VLCVEH_Nf_Reserved3;
  float32 VLCVEH_Nf_Reserved4;
  float32 VLCVEH_Nf_Reserved5;
  uint8 VLCVEH_Nu_FCWSensitivity;
  uint8 VLCVEH_Nu_Reserved2;
  uint8 VLCVEH_Nu_Reserved3;
  uint8 VLCVEH_Nu_Reserved4;
  uint8 VLCVEH_Nu_Reserved5;
  boolean VLCVEH_Nb_ACCOnOffSwitch;
  boolean VLCVEH_Nb_SLFOnOffSwitch;
  boolean VLCVEH_Nb_AEBOnOffSwitch;
  boolean VLCVEH_Nb_FCWOnOffSwitch;
  boolean VLCVEH_Nb_Reserved5;
} ST_VLCVeh_NVRAMData_t;

# define Rte_TypeDef_ST_reqCTASEN_SOA_HMI_t
typedef struct
{
  sint32 siFCTALeftHighlightID_nu;
  uint8 uiFCTALeftWarningLevel_enum;
  sint32 siFCTARightHighlightID_nu;
  uint8 uiFCTARightWarningLevel_enum;
  sint32 siRCTALeftHighlightID_nu;
  uint8 uiRCTALeftWarningLevel_enum;
  sint32 siRCTARightHighlightID_nu;
  uint8 uiRCTARightWarningLevel_enum;
} ST_reqCTASEN_SOA_HMI_t;

# define Rte_TypeDef_ST_reqLBSSEN_SOA_HMI_t
typedef struct
{
  sint32 siLCALeftHighlightID_nu;
  uint8 uiLCALeftWarningLevel_enum;
  sint32 siLCARightHighlightID_nu;
  uint8 uiLCARightWarningLevel_enum;
  sint32 siDOWLeftHighlightID_nu;
  uint8 uiDOWLeftWarningLevel_enum;
  sint32 siDOWRightHighlightID_nu;
  uint8 uiDOWRightWarningLevel_enum;
  sint32 siRCWHighlightID_nu;
  uint8 uiRCWWarningLevel_enum;
} ST_reqLBSSEN_SOA_HMI_t;

# define Rte_TypeDef_ST_reqLCFSEN_SOA_HMI_t
typedef struct
{
  sint32 siALCHighlightID_nu;
  uint8 uiALCWarningLevel_enum;
} ST_reqLCFSEN_SOA_HMI_t;

# define Rte_TypeDef_ST_reqVLCVEH_SOA_HMI_t
typedef struct
{
  sint32 siFCWHighlightID_nu;
  uint8 uiFCWWarningLevel_enum;
  sint32 siAEBHighlightID_nu;
  uint8 uiAEBWarningLevel_enum;
  sint32 siACCHighlightID_nu;
  uint8 uiACCWarningLevel_enum;
} ST_reqVLCVEH_SOA_HMI_t;

# define Rte_TypeDef_SceneInfo
typedef struct
{
  sint8 scene_brightness_info;
  sint8 scene_weather_info;
  sint8 scene_environment_info;
} SceneInfo;

# define Rte_TypeDef_SensorId
typedef struct
{
  uint32 SensorID;
} SensorId;

# define Rte_TypeDef_TRJPLN_TrajectoryPlanInReq_t
typedef struct
{
  float32 fEgoVelX_mps;
  float32 fEgoAccelX_mps2;
  float32 fEgoCurve_1pm;
  float32 fKappaSumCommand_1pm;
  float32 fCycleTimeVeh_sec;
  float32 fEPSManualTrqActVal_Nm;
  boolean bSysStOffLatDMC;
  boolean bSysStReqLatDMC;
  uint8 uiOdometerState_nu;
  float32 fEgoYawRate_rps;
  uint32 uiVehSync4LCO_us;
  uint32 uiSenToVehTStamp_us;
  float32 fPlanningHorizon_sec;
  uint8 uiSysStateLCF_nu;
  float32 fPredTimeCurve_sec;
  float32 fPredTimeHeadAng_sec;
  boolean bTriggerReplan;
  float32 fLeCridBndPosX0_met;
  float32 fLeCridBndPosY0_met;
  float32 fLeCridBndHeadAng_rad;
  float32 fLeCridBndCrv_1pm;
  float32 fLeCridBndCrvChng_1pm2;
  float32 fLeCridBndLength_met;
  float32 fRiCridBndPosX0_met;
  float32 fRiCridBndPosY0_met;
  float32 fRiCridBndHeadAng_rad;
  float32 fRiCridBndCrv_1pm;
  float32 fRiCridBndCrvChng_1pm2;
  float32 fRiCridBndLength_met;
  float32 fTgtTrajPosX0_met;
  float32 fTgtTrajPosY0_met;
  float32 fTgtTrajHeadingAng_rad;
  float32 fTgtTrajCurve_1pm;
  float32 fTgtTrajCrvChng_1pm2;
  float32 fTgtTrajLength_met;
  boolean bLatencyCompActivated;
  float32 fSensorTimeStamp_sec;
  uint8 uiTrajPlanServQu_nu;
  float32 fWeightTgtDistY_nu;
  float32 fWeightEndTime_nu;
  float32 fDistYToLeTgtArea_met;
  float32 fDistYToRiTgtArea_met;
  float32 fFTireAclMax_mps2;
  float32 fFTireAclMin_mps2;
  float32 fObstacleVelX_mps;
  float32 fObstacleAccelX_mps2;
  float32 fObstacleWidth_met;
  float32 fObstacleDistX_met;
  float32 fObstacleDistY_met;
  float32 fMaxJerkAllowed_mps3;
  uint8 uiTrajGuiQualifier_nu;
  uint8 uiLeLnQuality_per;
  uint8 uiRiLnQuality_per;
  uint8 uiLeCrvQuality_per;
  uint8 uiRiCrvQuality_per;
  uint8 uiLatCtrlMode_nu;
  uint8 uiControllingFunction_nu;
} TRJPLN_TrajectoryPlanInReq_t;

# define Rte_TypeDef_TRJPLN_TrajectoryPlanOutPro_t
typedef struct
{
  boolean bReplanCurValues;
  uint8 uiTrajGuiQualifier_nu;
  float32 fCurDistY_met;
  float32 fTrajDistY_met;
  float32 fTrajTgtCurve_1pm;
  float32 fCurHeading_rad;
  float32 fTrajHeadInclPrev_rad;
  float32 fTrajHeading_rad;
  float32 fTrajTgtCrvGrd_1pms;
  float32 fTrajHeadingPrev_rad;
  float32 fTrajTgtCrvPrev_1pm;
  float32 fCtrlErrDistY_met;
  float32 fCtrlErrHeadingAngle_rad;
  float32 fCtrlErrHeadAglPrev_rad;
  float32 fTrajDistYPrev_met;
  float32 fDeltaTargetCrv_1pm;
  float32 fDeltaTargetPosY0_met;
  float32 fDeltaTargetHeading_rad;
  boolean bUseTargetCorridor;
  boolean bTargetSwitch;
  boolean bGradLimitActive;
  boolean bPlausiCheckStatus;
  uint16 uiS_QuStatusTrajPlan_nu;
  float32 fTrajTgtCrvGrdPrev_1pms;
  uint16 uiD_QuStatusTrajPlan_nu;
} TRJPLN_TrajectoryPlanOutPro_t;

# define Rte_TypeDef_Timestamp
typedef struct
{
  boolean is_valid;
  uint32 secs;
  uint32 nsecs;
} Timestamp;

# define Rte_TypeDef_TrafficSignal
typedef struct
{
  uint8 shape;
  uint8 status;
} TrafficSignal;

# define Rte_TypeDef_VEDAccelCorrVehDyn_t
typedef struct
{
  float32 corrAccel;
  float32 corrAccelVar;
} VEDAccelCorrVehDyn_t;

# define Rte_TypeDef_VEDAddCalculateSign_t
typedef struct
{
  float32 SpeedOdometerCalculate_mps;
} VEDAddCalculateSign_t;

# define Rte_TypeDef_VEDCurveVehDyn
typedef struct
{
  float32 curve;
  float32 c1;
  float32 gradient;
  float32 var_c0;
  float32 var_c1;
  float32 quality;
  uint8 crv_error;
  boolean crv_conf;
} VEDCurveVehDyn;

# define Rte_TypeDef_VEDCurveVehDyn_t
typedef struct
{
  float32 Curve;
  float32 C1;
  float32 Gradient;
  float32 varC0;
  float32 varC1;
  float32 Quality;
  float32 CrvError;
  uint8 CrvConf;
} VEDCurveVehDyn_t;

# define Rte_TypeDef_VEDDrvIntCurveVehDyn_t
typedef struct
{
  float32 Curve;
  float32 Variance;
  float32 Gradient;
} VEDDrvIntCurveVehDyn_t;

# define Rte_TypeDef_VEDLatAcc_t
typedef struct
{
  float32 ZeroAccel;
  uint32 CalStatus;
} VEDLatAcc_t;

# define Rte_TypeDef_VEDLatAccelVehDyn_t
typedef struct
{
  float32 LatAccel;
  float32 Variance;
} VEDLatAccelVehDyn_t;

# define Rte_TypeDef_VEDLegacyVehDyn_t
typedef struct
{
  float32 YawRateMaxJitter;
  boolean bStandStill;
} VEDLegacyVehDyn_t;

# define Rte_TypeDef_VEDMotVarVehDyn_t
typedef struct
{
  float32 Velocity;
  float32 Accel;
  float32 varVelocity;
  float32 varAccel;
} VEDMotVarVehDyn_t;

# define Rte_TypeDef_VEDMotionStateVehDyn_t
typedef struct
{
  uint8 MotState;
  float32 Confidence;
} VEDMotionStateVehDyn_t;

# define Rte_TypeDef_VEDNvSlfStGradCalc_t
typedef struct
{
  float32 SlfStGrad;
  uint8 SlfStGradMax;
  uint8 SlfStGradMin;
  sint8 CalStatus;
  uint8 Dummy;
} VEDNvSlfStGradCalc_t;

# define Rte_TypeDef_VEDNvStWhlAngCalc_t
typedef struct
{
  float32 ZeroAngle;
  uint32 CalStatus;
} VEDNvStWhlAngCalc_t;

# define Rte_TypeDef_VEDNvWldCalc_t
typedef struct
{
  float32 Wld_front;
  float32 Wld_rear;
  uint8 Wld_front_quality;
  uint8 Wld_rear_quality;
} VEDNvWldCalc_t;

# define Rte_TypeDef_VEDSideSlipVehDyn_t
typedef struct
{
  float32 SideSlipAngle;
  float32 Variance;
} VEDSideSlipVehDyn_t;

# define Rte_TypeDef_VEDSignalHeader_t
typedef struct
{
  uint32 uiTimeStamp;
  uint16 uiMeasurementCounter;
  uint16 uiCycleCounter;
  uint8 eSigStatus;
} VEDSignalHeader_t;

# define Rte_TypeDef_VEDVelCorr_t
typedef struct
{
  float32 CorrFact;
  float32 Velo;
  float32 Dev;
} VEDVelCorr_t;

# define Rte_TypeDef_VEDVeloCorrVehDyn_t
typedef struct
{
  float32 corrFact;
  float32 corrVar;
  float32 corrVelo;
  float32 corrVeloVar;
  float32 minVelo;
  float32 maxVelo;
  uint8 corrQual;
  boolean bRollerTestBench;
} VEDVeloCorrVehDyn_t;

# define Rte_TypeDef_VEDWheelHeightLevel_t
typedef struct
{
  sint16 FrontLeft;
  sint16 FrontRight;
  sint16 RearLeft;
  sint16 RearRight;
} VEDWheelHeightLevel_t;

# define Rte_TypeDef_VEDYawRateVehDyn_t
typedef struct
{
  float32 YawRate;
  float32 Variance;
  float32 Quality;
} VEDYawRateVehDyn_t;

# define Rte_TypeDef_VEDYwRate_t
typedef struct
{
  float32 ZeroRate;
  float32 ZeroRateMin;
  float32 ZeroRateMax;
  uint32 CalStatus;
} VEDYwRate_t;

# define Rte_TypeDef_VLCSen_AccOOIGenAttributes_t
typedef struct
{
  uint8 uiCutInOutProbability;
  uint8 eDynamicProperty;
  float32 fLifeTime;
  uint16 uiLifeCycles;
  uint8 eMaintenanceState;
  sint8 uiObjectID;
  uint8 eUsageState;
} VLCSen_AccOOIGenAttributes_t;

# define Rte_TypeDef_VLCSen_AccOOIGenKinematics_t
typedef struct
{
  float32 fDistX;
  float32 fDistY;
  float32 fVrelX;
  float32 fVrelY;
  float32 fArelX;
  float32 fArelY;
  float32 fVabsX;
  float32 fVabsY;
  float32 fAabsX;
  float32 fAabsY;
} VLCSen_AccOOIGenKinematics_t;

# define Rte_TypeDef_VLCSen_Fuzzy_Rule_Input_t
typedef struct
{
  sint32 fv_rel_distance_close;
  sint32 fv_speed_rel_slower;
  sint32 fv_speed_rel_faster;
  sint32 fv_v_own_stillstand;
  sint32 fv_a_obj_braking;
  sint32 fv_speed_rel_same_speed;
  sint32 fv_a_obj_lowaccel;
  sint32 fv_distance_min_error_to_far;
  sint32 fv_v_own_urban;
  sint32 fv_speed_rel_much_slower;
  sint32 fv_distance_set_error_near;
  sint32 fv_softness_soft;
  sint32 fv_speed_rel_littleslower;
  sint32 fv_a_obj_accelerating;
  sint32 fv_a_obj_rolling;
  sint32 fv_v_obj_standstill;
  sint32 fv_distance_min_error_veryshort;
  sint32 fv_rel_distance_still_OK;
  sint32 fv_distance_min_error_short;
  sint32 fv_v_own_fast;
  sint32 fv_speed_rel_littlefaster;
  sint32 fv_distance_min_error_below;
  sint32 fv_v_own_slow;
  sint32 fv_rel_distance_far;
  sint32 fv_rel_distance_OK;
  sint32 fv_a_obj_hard_braking;
  sint32 fv_distance_min_error_near;
  sint32 fv_distance_set_error_close;
  sint32 fv_distance_set_error_not_close_enough;
  sint32 fv_softness_very_dynamic;
  sint32 fv_distance_to_close;
  sint32 fv_v_obj_fast;
  sint32 fv_distance_set_error_to_close;
  sint32 fv_a_obj_soft_braking;
  sint32 fv_distance_set_error_to_far;
  sint32 fv_v_obj_urban;
  sint32 fv_speed_rel_really_slower;
  sint32 fv_distance_set_error_more_than_requested;
} VLCSen_Fuzzy_Rule_Input_t;

# define Rte_TypeDef_VLCSen_Fuzzy_Signal_Input_t
typedef struct
{
  sint32 fuzzy_rel_distance;
  sint32 fuzzy_a_obj;
  sint32 fuzzy_distance_set_error;
  sint32 fuzzy_distance_min_error;
  sint32 fuzzy_softness;
  sint32 fuzzy_v_own;
  sint32 fuzzy_v_obj;
  sint32 fuzzy_distance;
  sint32 fuzzy_speed_rel;
} VLCSen_Fuzzy_Signal_Input_t;

# define Rte_TypeDef_VLCSen_HypoIntfCustom_t
typedef struct
{
  float32 fTTSEmergency;
  float32 fTTSEmergencyStd;
} VLCSen_HypoIntfCustom_t;

# define Rte_TypeDef_VLCSen_HypoIntfDegrPerf_t
typedef struct
{
  float32 fMaxDistALN;
  float32 fMaxDistHRZ;
  float32 fMaxDistVIS;
  float32 fMaxDist;
} VLCSen_HypoIntfDegrPerf_t;

# define Rte_TypeDef_VLCSen_HypoIntfDegrSfty_t
typedef struct
{
  float32 fMaxDistALN;
  float32 fMaxDistHRZ;
  float32 fMaxDistVIS;
  float32 fMaxDist;
} VLCSen_HypoIntfDegrSfty_t;

# define Rte_TypeDef_VLCSen_HypoIntfHeader_t
typedef struct
{
  uint8 uiNumOfHypotheses;
} VLCSen_HypoIntfHeader_t;

# define Rte_TypeDef_VLCSen_LaneInformation_t
typedef struct
{
  uint8 eAssociatedLane;
  uint8 eFuncAssociatedLane;
  uint8 uiCutInProbability;
  uint8 uiCutOutProbability;
} VLCSen_LaneInformation_t;

# define Rte_TypeDef_VLCSen_LegacyAOL_t
typedef struct
{
  float32 fDistToRef;
} VLCSen_LegacyAOL_t;

# define Rte_TypeDef_VLCSen_NVRAMData_t
typedef struct
{
  float32 VLCSEN_Nf_Reserved1;
  float32 VLCSEN_Nf_Reserved2;
  float32 VLCSEN_Nf_Reserved3;
  float32 VLCSEN_Nf_Reserved4;
  float32 VLCSEN_Nf_Reserved5;
  uint8 VLCSEN_Nu_Reserved1;
  uint8 VLCSEN_Nu_Reserved2;
  uint8 VLCSEN_Nu_Reserved3;
  uint8 VLCSEN_Nu_Reserved4;
  uint8 VLCSEN_Nu_Reserved5;
  boolean VLCSEN_Nb_Reserved1;
  boolean VLCSEN_Nb_Reserved2;
  boolean VLCSEN_Nb_Reserved3;
  boolean VLCSEN_Nb_Reserved4;
  boolean VLCSEN_Nb_Reserved5;
} VLCSen_NVRAMData_t;

# define Rte_TypeDef_VLCSen_ObjOfInterest_t
typedef struct
{
  uint8 cExternalID;
  sint8 eObjOOI;
} VLCSen_ObjOfInterest_t;

# define Rte_TypeDef_VLCSen_SignalHeader_t
typedef struct
{
  uint32 uiTimeStamp;
  uint16 uiMeasurementCounter;
  uint16 uiCycleCounter;
  uint8 eSigStatus;
} VLCSen_SignalHeader_t;

# define Rte_TypeDef_VLCSen_TcuSysInfo_t
typedef struct
{
  uint32 uiCycleCounter;
  uint32 uiCycleStart;
  uint32 uiCycleEnd;
} VLCSen_TcuSysInfo_t;

# define Rte_TypeDef_VLCSen_acc_object_usage_status_t
typedef struct
{
  boolean INTEREST;
  boolean USE_FOR_CONTROL;
  boolean USE_FOR_ALERT;
  boolean LOST_REASON;
} VLCSen_acc_object_usage_status_t;

# define Rte_TypeDef_VLCSen_acc_output_status_t
typedef struct
{
  boolean ALERT;
  boolean INHIBITED;
  uint8 INHIBITION_REASON;
  boolean ALLOW_INIT;
} VLCSen_acc_output_status_t;

# define Rte_TypeDef_VLCSen_acc_situation_classifier_t
typedef struct
{
  uint8 SITUATION;
  uint8 CRITICALITY;
} VLCSen_acc_situation_classifier_t;

# define Rte_TypeDef_VLCSen_obj_status_t
typedef struct
{
  boolean MEASURED;
  boolean TRACKED;
  boolean NEW;
  boolean STANDING;
  boolean STOPPED;
  boolean MOVING;
  boolean DETECTED;
} VLCSen_obj_status_t;

# define Rte_TypeDef_VLCVeh_KinCtrlDynInput_t
typedef struct
{
  uint8 longi_initialization_accel;
  float32 steer_angle;
  float32 steer_speed;
  boolean stand_still_detected;
  uint8 DC_status_information;
  boolean driver_override_accel_pedal;
  boolean driver_override_decel_pedal;
  boolean driver_braking;
  boolean DAS_accel_request_limited;
  boolean DAS_decel_request_limited;
  boolean longi_shutoff_acknowledged;
  boolean acc_enable;
  boolean acc_inhibit;
  boolean acc_reset;
  boolean park_brk_eng;
  boolean brk_sw;
  boolean door_state_fr;
  boolean door_state_fl;
  boolean door_state_rr;
  boolean door_state_rl;
  boolean hood_state;
  boolean trunk_state;
  uint8 seatbelt_state;
  uint8 country_code;
} VLCVeh_KinCtrlDynInput_t;

# define Rte_TypeDef_VLCVeh_KinDisplayInput_t
typedef struct
{
  uint8 speed_unit;
  uint16 speedometer_speed;
} VLCVeh_KinDisplayInput_t;

# define Rte_TypeDef_VLCVeh_NavInfo
typedef struct
{
  uint8 nav_speed_limit;
  boolean nav_active;
} VLCVeh_NavInfo;

# define Rte_TypeDef_VLCVeh_SignalHeader_t
typedef struct
{
  uint32 uiTimeStamp;
  uint16 uiMeasurementCounter;
  uint16 uiCycleCounter;
  uint8 eSigStatus;
} VLCVeh_SignalHeader_t;

# define Rte_TypeDef_VLCVeh_TSRInfo
typedef struct
{
  uint8 tsr_speed_limit;
  uint8 tsr_flag;
  boolean tsr_active;
} VLCVeh_TSRInfo;

# define Rte_TypeDef_Vector3f
typedef struct
{
  float32 x;
  float32 y;
  float32 z;
} Vector3f;

# define Rte_TypeDef_bWarnLevel_t
typedef struct
{
  boolean bPreWarnActive;
  boolean bAcuteWarnActive;
  boolean bDoorLockingActive;
} bWarnLevel_t;

# define Rte_TypeDef_Blob
typedef struct
{
  uint32 object_track_id;
  uint32 obejct_paired_id;
  uint16 object_cycles_traced;
  Bbox2D det_bbox_2d;
  float32 pos_x;
  float32 pos_y;
  float32 pos_z;
  float32 distance;
  float32 left_angle;
  float32 right_angle;
  float32 top_angle;
  float32 bottom_angle;
  float32 class_confidence;
  uint8 blob_type;
  uint8 blob_status;
  uint8 probability_vehicle_oncoming;
  uint8 probability_vehicle_preceeding;
} Blob;

# define Rte_TypeDef_Blob_64
typedef Blob Blob_64[64];

# define Rte_TypeDef_BswM_ESH_Mode
typedef uint8 BswM_ESH_Mode;

# define Rte_TypeDef_BswM_ESH_RunRequest
typedef uint8 BswM_ESH_RunRequest;

# define Rte_TypeDef_CamTrafficLight_t
typedef struct
{
  uint32 id;
  float32 position_x;
  float32 position_y;
  float32 position_z;
  float32 quaternion_x;
  float32 quaternion_y;
  float32 quaternion_z;
  float32 quaternion_w;
  float32 length;
  float32 width;
  float32 height;
  uint8 detection_status;
  uint8 confidence;
  uint8 status_label;
  uint8 type_label;
  Rte_DT_CamTrafficLight_t_15 lane_ids_8;
} CamTrafficLight_t;

# define Rte_TypeDef_CamTrafficSign_t
typedef struct
{
  uint32 id;
  float32 position_x;
  float32 position_y;
  float32 position_z;
  float32 quaternion_x;
  float32 quaternion_y;
  float32 quaternion_z;
  float32 quaternion_w;
  float32 length;
  float32 width;
  float32 height;
  uint8 detection_status;
  uint8 confidence;
  uint32 label;
  Rte_DT_CamTrafficSign_t_14 lane_ids_8;
} CamTrafficSign_t;

# define Rte_TypeDef_ComM_InhibitionStatusType
typedef uint8 ComM_InhibitionStatusType;

# define Rte_TypeDef_ComM_ModeType
typedef uint8 ComM_ModeType;

# define Rte_TypeDef_ComM_UserHandleType
typedef uint8 ComM_UserHandleType;

# define Rte_TypeDef_Dcm_CommunicationModeType
typedef uint8 Dcm_CommunicationModeType;

# define Rte_TypeDef_Dcm_ConfirmationStatusType
typedef uint8 Dcm_ConfirmationStatusType;

# define Rte_TypeDef_Dcm_ControlDtcSettingType
typedef uint8 Dcm_ControlDtcSettingType;

# define Rte_TypeDef_Dcm_DiagnosticSessionControlType
typedef uint8 Dcm_DiagnosticSessionControlType;

# define Rte_TypeDef_Dcm_EcuResetType
typedef uint8 Dcm_EcuResetType;

# define Rte_TypeDef_Dcm_NegativeResponseCodeType
typedef uint8 Dcm_NegativeResponseCodeType;

# define Rte_TypeDef_Dcm_OpStatusType
typedef uint8 Dcm_OpStatusType;

# define Rte_TypeDef_Dcm_ProtocolType
typedef uint8 Dcm_ProtocolType;

# define Rte_TypeDef_Dcm_RequestKindType
typedef uint8 Dcm_RequestKindType;

# define Rte_TypeDef_Dcm_SecLevelType
typedef uint8 Dcm_SecLevelType;

# define Rte_TypeDef_Dcm_SesCtrlType
typedef uint8 Dcm_SesCtrlType;

# define Rte_TypeDef_Dem_DTCFormatType
typedef uint8 Dem_DTCFormatType;

# define Rte_TypeDef_Dem_DTCGroupType
typedef uint32 Dem_DTCGroupType;

# define Rte_TypeDef_Dem_DTCKindType
typedef uint8 Dem_DTCKindType;

# define Rte_TypeDef_Dem_DTCOriginType
typedef uint16 Dem_DTCOriginType;

# define Rte_TypeDef_Dem_DTCSeverityType
typedef uint8 Dem_DTCSeverityType;

# define Rte_TypeDef_Dem_DTCStatusMaskType
typedef uint8 Dem_DTCStatusMaskType;

# define Rte_TypeDef_Dem_DTRControlType
typedef uint8 Dem_DTRControlType;

# define Rte_TypeDef_Dem_DebounceResetStatusType
typedef uint8 Dem_DebounceResetStatusType;

# define Rte_TypeDef_Dem_DebouncingStateType
typedef uint8 Dem_DebouncingStateType;

# define Rte_TypeDef_Dem_EventIdType
typedef uint16 Dem_EventIdType;

# define Rte_TypeDef_Dem_EventStatusType
typedef uint8 Dem_EventStatusType;

# define Rte_TypeDef_Dem_IndicatorStatusType
typedef uint8 Dem_IndicatorStatusType;

# define Rte_TypeDef_Dem_InitMonitorReasonType
typedef uint8 Dem_InitMonitorReasonType;

# define Rte_TypeDef_Dem_IumprDenomCondIdType
typedef uint8 Dem_IumprDenomCondIdType;

# define Rte_TypeDef_Dem_IumprDenomCondStatusType
typedef uint8 Dem_IumprDenomCondStatusType;

# define Rte_TypeDef_Dem_IumprReadinessGroupType
typedef uint8 Dem_IumprReadinessGroupType;

# define Rte_TypeDef_Dem_MonitorStatusType
typedef uint8 Dem_MonitorStatusType;

# define Rte_TypeDef_Dem_OperationCycleIdType
typedef uint8 Dem_OperationCycleIdType;

# define Rte_TypeDef_Dem_OperationCycleStateType
typedef uint8 Dem_OperationCycleStateType;

# define Rte_TypeDef_Dem_RatioIdType
typedef uint16 Dem_RatioIdType;

# define Rte_TypeDef_Dem_UdsStatusByteType
typedef uint8 Dem_UdsStatusByteType;

# define Rte_TypeDef_EMVEDLateral_t
typedef struct
{
  EMVEDYawRateVehDyn_t YawRate;
  float32 OffCompStWheelAngle;
  EMVEDCurveVehDyn_t Curve;
  EMVEDDrvIntCurveVehDyn_t DrvIntCurve;
  EMVEDLatAccelVehDyn_t Accel;
  EMVEDSideSlipVehDyn_t SlipAngle;
} EMVEDLateral_t;

# define Rte_TypeDef_EMVEDLongitudinal_t
typedef struct
{
  EMVEDMotVarVehDyn_t MotVar;
  EMVEDVeloCorrVehDyn_t VeloCorr;
  MVEDAccelCorrVehDyn_t AccelCorr;
} EMVEDLongitudinal_t;

# define Rte_TypeDef_EMVEDSensorMounting_t
typedef struct
{
  Rte_DT_EMVEDSensorMounting_t_0 State;
  float32 LatPos;
  float32 LongPos;
  float32 VertPos;
  float32 LongPosToCoG;
  float32 PitchAngle;
  uint8 Orientation;
  float32 RollAngle;
  float32 YawAngle;
} EMVEDSensorMounting_t;

# define Rte_TypeDef_EMVEDSensor_t
typedef struct
{
  Rte_DT_EMVEDSensor_t_0 State;
  float32 CoverDamping;
  float32 fCoverageAngle;
  float32 fLobeAngle;
  float32 fCycleTime;
  uint8 uNoOfScans;
} EMVEDSensor_t;

# define Rte_TypeDef_EMVEDVehDyn_t
typedef struct
{
  uint32 uiVersionNumber;
  ENVMSignalHeader_t sSigHeader;
  EMVEDLongitudinal_t Longitudinal;
  EMVEDLateral_t Lateral;
  EMVEDMotionStateVehDyn_t MotionState;
  EMVEDLegacyVehDyn_t Legacy;
  rt_Array_UInt8_12 State;
} EMVEDVehDyn_t;

# define Rte_TypeDef_EMVEDswa_t
typedef struct
{
  Rte_DT_EMVEDswa_t_0 ang;
  Rte_DT_EMVEDswa_t_1 rat;
} EMVEDswa_t;

# define Rte_TypeDef_EMVEDvel_t
typedef struct
{
  Rte_DT_EMVEDvel_t_0 vel;
  Rte_DT_EMVEDvel_t_1 rat;
} EMVEDvel_t;

# define Rte_TypeDef_EMVehParAdd_t
typedef struct
{
  Rte_DT_EMVehParAdd_t_0 State;
  float32 VehicleWidth;
  float32 VehicleLength;
  float32 CurbWeight;
  float32 OverhangFront;
  float32 FrontAxleRoadDist;
  float32 WheelWidth;
  float32 PassableHeight;
  float32 DistCameraToHoodX;
  float32 DistCameraToHoodY;
  uint8 SteeringVariant;
} EMVehParAdd_t;

# define Rte_TypeDef_EM_Fusion_GenObject_t
typedef struct
{
  EM_Fusion_GenKinematics_t sKinematic;
  EM_Fusion_GenGeometry_t sGeometry;
  EM_Fusion_GenGenerals_t sGeneral;
  EM_Fusion_GenAttributes_t sAttribute;
  EM_Fusion_GenQualifiers_t sQualifier;
} EM_Fusion_GenObject_t;

# define Rte_TypeDef_EM_t_ARSObject
typedef struct
{
  Envm_t_CR_KinEnvmatic Kinematic;
  Envm_t_CR_Geometry Geometry;
  Envm_t_CR_MotionAttributes MotionAttributes;
  Envm_t_CR_Attributes Attributes;
  Envm_t_CR_SensorSpecific SensorSpecific;
  Envm_t_CR_Legacy Legacy;
} EM_t_ARSObject;

# define Rte_TypeDef_EM_t_GenObjListHeader
typedef struct
{
  sint8 iNumOfUsedObjects;
  Rte_DT_EM_t_GenObjListHeader_1 iSortedObjectList;
  uint16 eObjListSource;
} EM_t_GenObjListHeader;

# define Rte_TypeDef_EcuM_BootTargetType
typedef uint8 EcuM_BootTargetType;

# define Rte_TypeDef_EcuM_ModeType
typedef uint8 EcuM_ModeType;

# define Rte_TypeDef_EcuM_ShutdownCauseType
typedef uint8 EcuM_ShutdownCauseType;

# define Rte_TypeDef_EcuM_StateType
typedef uint8 EcuM_StateType;

# define Rte_TypeDef_EcuM_TimeType
typedef uint32 EcuM_TimeType;

# define Rte_TypeDef_EcuM_UserType
typedef uint8 EcuM_UserType;

# define Rte_TypeDef_Lane_type
typedef struct
{
  LaneData_type LeftLaneData;
  LaneData_type RightLaneData;
  LaneData_type NextLeftLaneData;
  LaneData_type NextRightLaneData;
} Lane_type;

# define Rte_TypeDef_LineColor
typedef struct
{
  Point2f cut_point;
  uint8 color;
} LineColor;

# define Rte_TypeDef_LineType
typedef struct
{
  Point2f cut_point;
  uint8 type;
} LineType;

# define Rte_TypeDef_LineWidth
typedef struct
{
  Point2f cut_point;
  float32 width;
} LineWidth;

# define Rte_TypeDef_MsgHeader
typedef struct
{
  uint32 seq;
  STTime stamp;
  uint32 frame_id;
} MsgHeader;

# define Rte_TypeDef_RoadMarkerData
typedef struct
{
  uint32 id;
  Point3d centroid;
  Quaternionf quaternion;
  float32 length;
  float32 width;
  float32 height;
  uint8 detection_status;
  float32 confidence;
  Rte_DT_RoadMarkerData_8 lane_ids;
  uint8 road_marker_type;
  uint8 color;
} RoadMarkerData;

# define Rte_TypeDef_Rte_DT_EM_t_GenObjGeometry_0
typedef Envm_t_GenObjShapePointCoord Rte_DT_EM_t_GenObjGeometry_0[4];

# define Rte_TypeDef_Rte_DT_ST_EMFusionGenObjList_t_3
typedef EM_Fusion_GenObject_t Rte_DT_ST_EMFusionGenObjList_t_3[20];

# define Rte_TypeDef_Rte_DT_ST_Envm_TrafficLight_t_3
typedef CamTrafficLight_t Rte_DT_ST_Envm_TrafficLight_t_3[10];

# define Rte_TypeDef_Rte_DT_ST_Envm_TrafficSign_t_10
typedef CamTrafficSign_t Rte_DT_ST_Envm_TrafficSign_t_10[10];

# define Rte_TypeDef_Rte_DT_ST_Envm_TrafficSign_t_12
typedef CamTrafficSign_t Rte_DT_ST_Envm_TrafficSign_t_12[10];

# define Rte_TypeDef_Rte_DT_ST_Envm_TrafficSign_t_8
typedef CamTrafficSign_t Rte_DT_ST_Envm_TrafficSign_t_8[10];

# define Rte_TypeDef_Rte_DT_ST_Envm_t_CRObjectList_2
typedef EM_t_ARSObject Rte_DT_ST_Envm_t_CRObjectList_2[40];

# define Rte_TypeDef_Rte_DT_ST_RoadSemantics2MCU_t_9
typedef RoadMarkerData Rte_DT_ST_RoadSemantics2MCU_t_9[16];

# define Rte_TypeDef_Rte_DT_ST_VEDNvIoDatas_t_6
typedef VEDVelCorr_t Rte_DT_ST_VEDNvIoDatas_t_6[3];

# define Rte_TypeDef_Rte_DT_TrafficLightData_9
typedef TrafficSignal Rte_DT_TrafficLightData_9[1];

# define Rte_TypeDef_Rte_array_Objects_Type_ObjectData_t
typedef ObjectData_Type Rte_array_Objects_Type_ObjectData_t[20];

# define Rte_TypeDef_ST_ADASHighlightID_t
typedef struct
{
  MsgHeader header;
  sint32 siFCWHighlightID_nu;
  uint8 uiFCWWarningLevel_enum;
  sint32 siAEBHighlightID_nu;
  uint8 uiAEBWarningLevel_enum;
  sint32 siACCHighlightID_nu;
  uint8 uiACCWarningLevel_enum;
  sint32 siFCTALeftHighlightID_nu;
  uint8 uiFCTALeftWarningLevel_enum;
  sint32 siFCTARightHighlightID_nu;
  uint8 uiFCTARightWarningLevel_enum;
  sint32 siRCTALeftHighlightID_nu;
  uint8 uiRCTALeftWarningLevel_enum;
  sint32 siRCTARightHighlightID_nu;
  uint8 uiRCTARightWarningLevel_enum;
  sint32 siLCALeftHighlightID_nu;
  uint8 uiLCALeftWarningLevel_enum;
  sint32 siLCARightHighlightID_nu;
  uint8 uiLCARightWarningLevel_enum;
  sint32 siDOWLeftHighlightID_nu;
  uint8 uiDOWLeftWarningLevel_enum;
  sint32 siDOWRightHighlightID_nu;
  uint8 uiDOWRightWarningLevel_enum;
  sint32 siRCWHighlightID_nu;
  uint8 uiRCWWarningLevel_enum;
  sint32 siALCHighlightID_nu;
  uint8 uiALCWarningLevel_enum;
} ST_ADASHighlightID_t;

# define Rte_TypeDef_ST_EMFusionGenObjList_t
typedef struct
{
  uint32 uiVersionNumber;
  ENVMSignalHeader_t sSigHeader;
  uint8 uNumOfUsedObjects;
  Rte_DT_ST_EMFusionGenObjList_t_3 aObjects;
} ST_EMFusionGenObjList_t;

# define Rte_TypeDef_ST_ENVODD2MCU_t
typedef struct
{
  Timestamp timestamp_t;
  CoordinateSystem coordinate;
  SensorId sensor_id;
  CameraBlockageInfo blockage_info;
  SceneInfo scene_info;
  sint8 city_lights_info;
  uint16 blob_num;
  Blob_64 blob_object_list;
} ST_ENVODD2MCU_t;

# define Rte_TypeDef_ST_EnvmNvm_t
typedef struct
{
  uint8 TrafficOrientation;
  EnvmNvmState_t NVMInState;
  float32 ENVM_Nf_Reserved1;
  float32 ENVM_Nf_Reserved2;
  float32 ENVM_Nf_Reserved3;
  float32 ENVM_Nf_Reserved4;
  float32 ENVM_Nf_Reserved5;
  uint8 ENVM_Nu_Reserved1;
  uint8 ENVM_Nu_Reserved2;
  uint8 ENVM_Nu_Reserved3;
  uint8 ENVM_Nu_Reserved4;
  uint8 ENVM_Nu_Reserved5;
  boolean ENVM_Nb_Reserved1;
  boolean ENVM_Nb_Reserved2;
  boolean ENVM_Nb_Reserved3;
  boolean ENVM_Nb_Reserved4;
  boolean ENVM_Nb_Reserved5;
} ST_EnvmNvm_t;

# define Rte_TypeDef_ST_Envm_TrafficLight_t
typedef struct
{
  uint32 uiVersionNumber;
  ENVMSignalHeader_t sSigHeader;
  uint8 uTrafficLightsize;
  Rte_DT_ST_Envm_TrafficLight_t_3 sTrafficLights;
} ST_Envm_TrafficLight_t;

# define Rte_TypeDef_ST_Envm_TrafficSign_t
typedef struct
{
  uint32 uiVersionNumber;
  ENVMSignalHeader_t sSigHeader;
  uint16 CAM_SpeedUpperLimit_btf;
  uint16 CAM_SpeedLowerLimit_btf;
  uint16 CAM_SpeedRelUpperLimit_btf;
  uint16 CAM_SpeedRelLowerLimit_btf;
  Rte_DT_ST_Envm_TrafficSign_t_6 CAM_ForbiddenSign_btf_2;
  uint8 uSpeedUpperLimitSize;
  Rte_DT_ST_Envm_TrafficSign_t_8 sSpeedUpperLimit_10;
  uint8 uSpeedLowerLimitSize;
  Rte_DT_ST_Envm_TrafficSign_t_10 sSpeedLowerLimit_10;
  uint8 uForbiddenSignSize;
  Rte_DT_ST_Envm_TrafficSign_t_12 sForbiddenSign_10;
} ST_Envm_TrafficSign_t;

# define Rte_TypeDef_ST_Envm_t_CRObjectList
typedef struct
{
  uint32 uiVersionNumber;
  ENVMSignalHeader_t sSigHeader;
  Rte_DT_ST_Envm_t_CRObjectList_2 aObject;
} ST_Envm_t_CRObjectList;

# define Rte_TypeDef_ST_LBSFunState_t
typedef struct
{
  boolean bBSDWarning;
  boolean bBSDWarningLeft;
  boolean bBSDWarningRight;
  boolean bLCAWarning;
  boolean bLCAWarningLeft;
  boolean bLCAWarningRight;
  bWarnLevel_t bOSEWarning;
  bWarnLevel_t bOSEWarningLeft;
  bWarnLevel_t bOSEWarningRight;
  uint8 uRCWWarning;
  float32 fTTC_s;
} ST_LBSFunState_t;

# define Rte_TypeDef_ST_LCF_DmcGenericOutputs_t
typedef struct
{
  uint32 uiVersionNumber;
  LCF_DmcSignalHeader_t sSigHeader;
  LCF_TJADMCOutPro_t sDMCOutput;
} ST_LCF_DmcGenericOutputs_t;

# define Rte_TypeDef_ST_LCF_SenGenericOutputs_t
typedef struct
{
  uint32 uiVersionNumber;
  LCF_SenSignalHeader_t sSigHeader;
  LCF_LDWSAOutput_t sLDWSAOutput;
  LCF_LDPSAOutput_t sLDPSAOutput;
  LCF_LBPOutput_t sLBPOutput;
  LCF_ALPOutput_t sALPOutput;
  LCF_SENTJASAOutput_t sTJAOutput;
} ST_LCF_SenGenericOutputs_t;

# define Rte_TypeDef_ST_LCF_SenToVehs_t
typedef struct
{
  uint32 uiVersionNumber;
  LCF_SenSignalHeader_t sSigHeader;
  uint8 ControllingFunction_nu;
  uint8 ActFctEnabled_nu;
  uint8 ActFctLevel_nu;
  uint8 SpecialDrivingCorridor__nu;
  float32 MaxJerkAllowed_mps3;
  uint8 OcObjActSide_nu;
  uint8 AngReqMaxLimitScale_per;
  uint8 AngReqRateMaxLimitScale_per;
  float32 Reserved1_nu;
  float32 Reserved2_nu;
  LCF_TJASAOutput_t sTJASAOutput;
  LCF_MCTLFCOut_st sMCTLFCOut;
} ST_LCF_SenToVehs_t;

# define Rte_TypeDef_ST_VEDNvIoDatas_t
typedef struct
{
  uint32 uiVersionNumber;
  VEDSignalHeader_t sSigHeader;
  VEDNvStWhlAngCalc_t StWhlAng;
  VEDNvSlfStGradCalc_t SlfstGrad;
  VEDYwRate_t YwRate;
  VEDLatAcc_t LatAcc;
  Rte_DT_ST_VEDNvIoDatas_t_6 VelCorr;
  VEDNvWldCalc_t Wld;
  uint32 State;
  uint8 checkSum;
  float32 VED_Nf_Reserved1;
  float32 VED_Nf_Reserved2;
  float32 VED_Nf_Reserved3;
  float32 VED_Nf_Reserved4;
  float32 VED_Nf_Reserved5;
  uint8 VED_Nu_Reserved1;
  uint8 VED_Nu_Reserved2;
  uint8 VED_Nu_Reserved3;
  uint8 VED_Nu_Reserved4;
  uint8 VED_Nu_Reserved5;
  boolean VED_Nb_Reserved1;
  boolean VED_Nb_Reserved2;
  boolean VED_Nb_Reserved3;
  boolean VED_Nb_Reserved4;
  boolean VED_Nb_Reserved5;
} ST_VEDNvIoDatas_t;

# define Rte_TypeDef_ST_VEDVehDyn_t_SyncEgo
typedef struct
{
  EMVEDVehDyn_t pObjSyncEgoDynamic;
} ST_VEDVehDyn_t_SyncEgo;

# define Rte_TypeDef_ST_VLCSen_acc_output_data_t
typedef struct
{
  uint32 uiVersionNumber;
  VLCSen_SignalHeader_t sSigHeader;
  sint16 DISTANCE_CTRL_ACCEL_MAX;
  sint16 DISTANCE_CTRL_ACCEL_MIN;
  sint16 MAX_AVLC_ACCELERATION;
  sint16 MAX_AVLC_DECELERATION;
  uint16 REQUESTED_TIMEGAP;
  sint16 REQUESTED_DISTANCE;
  sint16 REQUESTED_MAX_INTRUSION;
  sint16 RECOMMENDED_VELOCITY;
  uint8 HEADWAY_SETTING;
  VLCSen_acc_output_status_t AVLC_OUTPUT_STATUS;
  VLCSen_acc_situation_classifier_t SITUATION_CLASS;
} ST_VLCSen_acc_output_data_t;

# define Rte_TypeDef_ST_VehicleDynamicSignals_t
typedef struct
{
  Timestamp timestamp_t;
  Timestamp measurement_time;
  VedInfo status_info;
  Vector3f linear_velocity;
  Vector3f linear_acceleration;
  Vector3f angular_velocity;
  VEDCurveVehDyn curve;
} ST_VehicleDynamicSignals_t;

# define Rte_TypeDef_TimeInMicrosecondsType
typedef uint32 TimeInMicrosecondsType;

# define Rte_TypeDef_TrafficLightData
typedef struct
{
  uint32 id;
  Point3d centroid;
  Quaternionf quaternion;
  float32 length;
  float32 width;
  float32 height;
  uint8 detection_status;
  float32 confidence;
  sint16 countdown;
  Rte_DT_TrafficLightData_9 signals;
  Rte_DT_TrafficLightData_10 lane_ids;
} TrafficLightData;

# define Rte_TypeDef_TrafficSignData
typedef struct
{
  uint32 id;
  Point3d centroid;
  Quaternionf quaternion;
  float32 length;
  float32 width;
  float32 height;
  uint8 detection_status;
  float32 confidence;
  Rte_DT_TrafficSignData_8 lane_ids;
  uint8 traffic_sign_type;
} TrafficSignData;

# define Rte_TypeDef_VEDBrake_t
typedef struct
{
  Rte_DT_VEDBrake_t_0 State;
  boolean ABSCtrl;
  boolean TCSCtrl;
  boolean bESCActive_nu;
  boolean bESCDisable_nu;
  boolean bTCSDisable_nu;
  uint8 IDB5_ABAavailable;
  uint8 IDB5_JerkActive;
  uint8 IDB5_Jerkfail;
  uint8 IDB5_AEB_Enable;
  boolean IDB7_ARPACTIVE;
  uint8 IDB7_ARPFailure;
  uint8 IDB1_FailedState;
  boolean bHDCEnable_nu;
} VEDBrake_t;

# define Rte_TypeDef_VEDLateral_t
typedef struct
{
  VEDYawRateVehDyn_t YawRate;
  float32 OffCompStWheelAngle;
  VEDCurveVehDyn_t Curve;
  VEDDrvIntCurveVehDyn_t DrvIntCurve;
  VEDLatAccelVehDyn_t Accel;
  VEDSideSlipVehDyn_t SlipAngle;
  float32 fStWheelAngleGradient_rps;
} VEDLateral_t;

# define Rte_TypeDef_VEDLongitudinal_t
typedef struct
{
  VEDMotVarVehDyn_t MotVar;
  VEDVeloCorrVehDyn_t VeloCorr;
  VEDAccelCorrVehDyn_t AccelCorr;
  float32 fBrakePedalPosGrad_nu;
  float32 fGasPedalPosGrad_nu;
} VEDLongitudinal_t;

# define Rte_TypeDef_VEDPowerTrain_t
typedef struct
{
  uint8 ActualGear;
  uint8 TargetGear;
  boolean EngineRunning;
  uint8 FillByte;
  Rte_DT_VEDPowerTrain_t_4 state;
} VEDPowerTrain_t;

# define Rte_TypeDef_VEDVehSigAdd_t
typedef struct
{
  Rte_DT_VEDVehSigAdd_t_0 State;
  float32 EnvTemp;
  uint8 WiperState;
  uint8 WiperStage;
  boolean WiperOutParkPos;
  uint8 WiperWasherFrontState;
  boolean RainSensor;
  uint8 TurnSignal;
  boolean FogLampFront;
  boolean FogLampRear;
  float32 RoadWhlAngFr;
  float32 RoadWhlAngRe;
  float32 Odometer;
  uint8 GasPedalPos;
  boolean KickDown;
  boolean BrakePedalPressed;
  boolean DriverTired;
  uint8 SpeedUnit;
  float32 SpeedoSpeed;
  uint8 TrailerConnection;
  uint8 TrailerConnBeforeShutDown;
  uint8 TrailerLengthInput;
  uint8 ParkAidDet_L;
  uint8 ParkAidDet_CL;
  uint8 ParkAidDet_CR;
  uint8 ParkAidDet_R;
  uint8 IgnitionSwitch;
  uint8 eSuspensionSystem;
  uint8 eHeightLevel;
  VEDWheelHeightLevel_t WheelHeightLevel;
  boolean bDriverSeatBelt_nu;
  boolean bDoorAllClosed_nu;
  boolean bLowBeamActive_nu;
  boolean bHighBeamActive_nu;
  boolean bHazardLightActive_nu;
  float32 fBrakePedalPos_nu;
  uint8 uFrontLampState_nu;
  uint8 CDCS11_VoiceMode;
  uint8 CDCS11_ADAS_SndCtrlOnOff;
  float32 EPS1_TorsionBarTorque;
  uint8 CS1_GearPositionReqSt;
  uint8 EPS2_ADAS_Available;
  uint8 EPS2_ADAS_Active;
  float32 EPS2_MotCntrl;
  uint8 EPS2_ADAS_CtrlAbortFeedback;
  uint8 DDCU1_FLDoorAjar;
  uint8 DDCU1_RLDoorAjar;
  uint8 PDCU1_FRDoorAjar;
  uint8 PDCU1_RRDoorAjar;
  uint8 BDCS1_TrunkLockSts;
  uint8 BDCS1_HoodAjarSts;
  uint8 CDCS5_ResetAllSetup;
  uint8 CDCS5_FactoryReset;
} VEDVehSigAdd_t;

# define Rte_TypeDef_VEDVehSigMain_t
typedef struct
{
  Rte_DT_VEDVehSigMain_t_0 state;
  float32 YawRate;
  float32 YawRateTemp;
  float32 StWheelAngle;
  float32 LatAccel;
  float32 WhlVelFrLeft;
  float32 WhlVelFrRight;
  float32 WhlVelReLeft;
  float32 WhlVelReRight;
  float32 YawRateInt;
  float32 YawRateIntTemp;
  float32 LongAccel;
  float32 RearWhlAngle;
  float32 VehVelocityExt;
  float32 VehLongAccelExt;
  uint8 WhlDirFrLeft;
  uint8 WhlDirFrRight;
  uint8 WhlDirReLeft;
  uint8 WhlDirReRight;
  uint8 WhlTicksDevFrLeft;
  uint8 WhlTicksDevFrRight;
  uint8 WhlTicksDevReLeft;
  uint8 WhlTicksDevReRight;
  uint8 ActGearPos;
  uint16 BrakeActLevel;
  uint8 ParkBrakeState;
  uint8 VehLongDirExt;
  uint8 VehLongMotStateExt;
  float32 CurveC0Ext;
  float32 CurveC1Ext;
  float32 SideSlipAngleExt;
  float32 fStWheelAngleGradient_nu;
} VEDVehSigMain_t;

# define Rte_TypeDef_VLCSen_AccOOINextLong_t
typedef struct
{
  VLCSen_AccOOIGenKinematics_t Kinematic;
  VLCSen_AccOOIGenAttributes_t Attributes;
  uint8 eRelObjLossReason;
} VLCSen_AccOOINextLong_t;

# define Rte_TypeDef_VLCSen_AccOOI_t
typedef struct
{
  VLCSen_AccOOIGenKinematics_t Kinematic;
  VLCSen_AccOOIGenAttributes_t Attributes;
} VLCSen_AccOOI_t;

# define Rte_TypeDef_VLCSen_HeaderAssessedObjList_t
typedef struct
{
  sint8 iNumOfUsedObjects;
  uint8 iPadding;
  Rte_DT_VLCSen_HeaderAssessedObjList_t_2 aiOOIList;
  uint8 eRelObjLossReason;
} VLCSen_HeaderAssessedObjList_t;

# define Rte_TypeDef_VLCSen_HypoIntfDegr_t
typedef struct
{
  VLCSen_HypoIntfDegrSfty_t Safety;
  VLCSen_HypoIntfDegrPerf_t Performance;
} VLCSen_HypoIntfDegr_t;

# define Rte_TypeDef_VLCSen_Hypothesis_t_6
typedef struct
{
  sint8 uiObjectRef;
  uint8 eType;
  uint8 uiObjectProbability;
  uint8 eEBAObjectClass;
  uint8 eEBADynProp;
  uint16 eEBAInhibitionMask;
  uint8 uiHypothesisProbability;
  float32 fHypothesisLifetime;
  float32 fTTC;
  float32 fTTCStd;
  float32 fTTC2;
  float32 fTTC3;
  float32 fTTC4;
  float32 fTTBPre;
  float32 fTTBPreStd;
  float32 fTTBAcute;
  float32 fTTBAcuteStd;
  float32 fTTSPre;
  float32 fTTSPreStd;
  float32 fTTSAcute;
  float32 fTTSAcuteStd;
  float32 fLongNecAccel;
  float32 fLatNecAccel;
  float32 fDistX;
  float32 fDistXStd;
  float32 fVrelX;
  float32 fVrelXStd;
  float32 fArelX;
  float32 fArelXStd;
  float32 fDistY;
  float32 fDistYStd;
  float32 fVrelY;
  float32 fVrelYStd;
  float32 fArelY;
  float32 fArelYStd;
  float32 fClosingVelocity;
  float32 fClosingVelocityStd;
  VLCSen_HypoIntfCustom_t Custom;
} VLCSen_Hypothesis_t_6;

# define Rte_TypeDef_VLCSen_PubObject_t
typedef struct
{
  VLCSen_LaneInformation_t LaneInformation;
  VLCSen_ObjOfInterest_t ObjOfInterest;
  VLCSen_LegacyAOL_t Legacy;
} VLCSen_PubObject_t;

# define Rte_TypeDef_VLCSen_object_t
typedef struct
{
  sint16 REL_LONG_SPEED;
  sint16 REL_LAT_SPEED;
  sint16 LONG_DISPLACEMENT;
  sint16 LAT_DISPLACEMENT;
  sint16 REL_LONG_ACCEL;
  sint16 REL_LAT_ACCEL;
  uint8 QUALITY;
  uint8 CLASS;
  VLCSen_obj_status_t OBJECT_STATUS;
  sint16 WIDTH;
  sint8 OBJECT_ID;
} VLCSen_object_t;

# define Rte_TypeDef_VLCVeh_LongCtrlInputCustom_In_t
typedef struct
{
  boolean AVLC_ReversibleFail;
  boolean AVLC_IrreversibleFail;
  boolean Camera_Availability;
  boolean ESC_Status;
  boolean ABS_Active;
  boolean AEB_Active;
  boolean APA_Active;
  boolean AYC_Active;
  boolean TCS_Active;
  boolean EPB_Active;
  boolean HDC_Active;
  boolean USR_Active;
  boolean NNP_Active;
  boolean ISA_Active;
  boolean Door_Open;
  VLCVeh_TSRInfo tsr_info;
  VLCVeh_NavInfo nav_info;
} VLCVeh_LongCtrlInputCustom_In_t;

# define Rte_TypeDef_VLCVeh_LongCtrlInputCustom_t
typedef struct
{
  VLCVeh_LongCtrlInputCustom_In_t LongCtrlInputCustom;
} VLCVeh_LongCtrlInputCustom_t;

# define Rte_TypeDef_line_color_vector_5
typedef LineColor line_color_vector_5[5];

# define Rte_TypeDef_line_type_vector_5
typedef LineType line_type_vector_5[5];

# define Rte_TypeDef_line_width_vector_5
typedef LineWidth line_width_vector_5[5];

# define Rte_TypeDef_sTJATCTInReq_st
typedef struct
{
  float32 TCTI_TimeSysCycle;
  float32 TCTI_VehicleVelX;
  float32 TCTI_VehYawRate;
  float32 TCTI_WhlSteerAngleVdy;
  float32 TCTI_SteerAngleLaDmc;
  boolean TCTI_EnaReplanCurValues;
  uint8 TCTI_BtfTrajGuiQualifier;
  float32 TCTI_ReqTrajDistYTpl;
  float32 TCTI_CurTrajDistYTpl;
  float32 TCTI_ReqTrajCrvTpl;
  uint8 TCTI_StCntrlFcn;
  uint8 TCTI_StLatCtrlMode;
  float32 TCTI_EstSelfSteerGrdnt;
  float32 TCTI_ReqTrajCrvCsc;
  float32 TCTI_ReqTrajHeadTpl;
  float32 TCTI_InclPrevTrajHeadTpl;
  float32 TCTI_MaxCrvGrdBuildup;
  float32 TCTI_MaxCrvGrdRed;
  float32 TCTI_LmtReqTrajCrvGrd;
  float32 TCTI_MaxTrajCrv;
  uint8 TCTI_StVehOdo;
  float32 TCTI_VehCurvature;
  uint8 TCTI_EnaLmtActCsc;
  float32 TCTI_TimeLmtDur;
  uint8 TCTI_StLaneLaKmc;
  uint8 TCTI_StLcfSys;
  uint8 TestFlag_EnableFF;
  uint8 TestFlag_EnableTP;
  uint8 TestFlag_EnableOL;
  float32 Test_CoeffMainPGainLdc;
  float32 Test_CoeffPGainLdc;
  float32 Test_CoeffIGainLdc;
  float32 Test_CoeffDGainLdc;
  float32 Test_TimeDT1Ldc;
  float32 Test_CoeffPT1GainLdc;
  float32 Test_TimePT1Ldc;
  float32 Test_CoeffMainPGainCac;
  float32 Test_CoeffPGainCac;
  float32 Test_CoeffIGainCac;
  float32 Test_CoeffDGainCac;
  float32 Test_TimeDT1Cac;
  float32 Test_CoeffPT1GainCac;
  float32 Test_TimePT1Cac;
  float32 Test_CDCTimeFltCurHeading;
  Rte_DT_sTJATCTInReq_st_44 LQR_e1_gains;
  Rte_DT_sTJATCTInReq_st_45 LQR_e1dot_gains;
  Rte_DT_sTJATCTInReq_st_46 LQR_e2_gains;
  Rte_DT_sTJATCTInReq_st_47 LQR_e2dot_gains;
  Rte_DT_sTJATCTInReq_st_48 LQR_Feedforward_gains;
} sTJATCTInReq_st;

# define Rte_TypeDef_EMVEDStRatio_t
typedef struct
{
  EMVEDswa_t swa;
  EMVEDvel_t vel;
} EMVEDStRatio_t;

# define Rte_TypeDef_EMVEDVehParMain_t
typedef struct
{
  Rte_DT_EMVEDVehParMain_t_0 State;
  float32 SelfSteerGrad;
  EMVEDStRatio_t SteeringRatio;
  float32 DIST_FrontAxle_to_FontBumper;
  float32 WheelBase;
  float32 TrackWidthFront;
  float32 TrackWidthRear;
  float32 VehWeight;
  float32 CntrOfGravHeight;
  float32 AxisLoadDistr;
  float32 WhlLoadDepFrontAxle;
  float32 WhlLoadDepRearAxle;
  float32 WhlCircumference;
  uint8 DrvAxle;
  uint8 WhlTcksPerRev;
  float32 FrCrnrStiff;
  float32 ReCrnrStiff;
} EMVEDVehParMain_t;

# define Rte_TypeDef_EM_t_GenObjGeometry
typedef struct
{
  Rte_DT_EM_t_GenObjGeometry_0 aShapePointCoordinates;
} EM_t_GenObjGeometry;

# define Rte_TypeDef_Envm_t_GenObject
typedef struct
{
  Envm_t_GenObjKinEnvmatics Kinematic;
  EM_t_GenObjGeometry Geometry;
  Envm_t_GenObjAttributes Attributes;
  EM_t_GenObjGenerals General;
  Envm_t_GenObjQualifiers Qualifiers;
} Envm_t_GenObject;

# define Rte_TypeDef_LineBoundary
typedef struct
{
  uint32 line_id;
  uint32 left_lane_id;
  uint32 right_lane_id;
  uint8 line_position_index;
  float32 confidence;
  uint8 availability;
  float32 c0;
  float32 c1;
  float32 c2;
  float32 c3;
  float32 range_start;
  float32 range_end;
  line_type_vector_5 line_type_vector;
  line_color_vector_5 line_color_vector;
  line_width_vector_5 line_width_vector;
  uint8 detection_status;
} LineBoundary;

# define Rte_TypeDef_Objects_Type
typedef struct
{
  Rte_array_Objects_Type_ObjectData_t ObjectData;
} Objects_Type;

# define Rte_TypeDef_Rte_DT_ST_Envm_t_GenObjectList_3
typedef Envm_t_GenObject Rte_DT_ST_Envm_t_GenObjectList_3[40];

# define Rte_TypeDef_Rte_DT_ST_RoadSemantics2MCU_t_7
typedef TrafficLightData Rte_DT_ST_RoadSemantics2MCU_t_7[5];

# define Rte_TypeDef_Rte_DT_ST_RoadSemantics2MCU_t_8
typedef TrafficSignData Rte_DT_ST_RoadSemantics2MCU_t_8[16];

# define Rte_TypeDef_Rte_DT_ST_VLCSen_AssessedObjList_t_3
typedef VLCSen_PubObject_t Rte_DT_ST_VLCSen_AssessedObjList_t_3[40];

# define Rte_TypeDef_Rte_DT_ST_VLCSen_HypothesisIntf_t_4
typedef VLCSen_Hypothesis_t_6 Rte_DT_ST_VLCSen_HypothesisIntf_t_4[6];

# define Rte_TypeDef_ST_EMVEDVehPar_t
typedef struct
{
  uint32 uiVersionNumber;
  ENVMSignalHeader_t sSigHeader;
  EMVEDVehParMain_t VehParMain;
  EMVehParAdd_t VehParAdd;
  EMVEDSensorMounting_t SensorMounting;
  EMVEDSensor_t Sensor;
} ST_EMVEDVehPar_t;

# define Rte_TypeDef_ST_Envm_t_GenObjectList
typedef struct
{
  uint32 uiVersionNumber;
  ENVMSignalHeader_t sSigHeader;
  EM_t_GenObjListHeader HeaderObjList;
  Rte_DT_ST_Envm_t_GenObjectList_3 aObject;
} ST_Envm_t_GenObjectList;

# define Rte_TypeDef_ST_LCF_VehGenericOutputs_t
typedef struct
{
  uint32 uiVersionNumber;
  LCF_VehSignalHeader_t sSigHeader;
  LCF_TJATCTOut_st sTCOutput;
  LCF_LCDOutput_t sLCDOutput;
  TRJPLN_TrajectoryPlanOutPro_t sTPOutput;
  TRJPLN_TrajectoryPlanInReq_t sTPInput;
  sTJATCTInReq_st pTCInput;
  LCF_HODOutput_t sHODOutput;
} ST_LCF_VehGenericOutputs_t;

# define Rte_TypeDef_ST_RoadSemantics2MCU_t
typedef struct
{
  Timestamp timestamp_t;
  Timestamp actual_time_ns;
  CoordinateSystem coordinate;
  SensorId sensor_id;
  uint8 tlr_num;
  uint8 tsr_num;
  uint8 rm_num;
  Rte_DT_ST_RoadSemantics2MCU_t_7 traffic_lights;
  Rte_DT_ST_RoadSemantics2MCU_t_8 traffic_signs;
  Rte_DT_ST_RoadSemantics2MCU_t_9 road_markers;
} ST_RoadSemantics2MCU_t;

# define Rte_TypeDef_ST_VEDVehDyn_t
typedef struct
{
  uint32 uiVersionNumber;
  VEDSignalHeader_t sSigHeader;
  VEDLongitudinal_t Longitudinal;
  VEDLateral_t Lateral;
  VEDMotionStateVehDyn_t MotionState;
  VEDLegacyVehDyn_t Legacy;
  Rte_DT_ST_VEDVehDyn_t_6 rt_Array_UInt8_12_12;
  VEDAddCalculateSign_t AddCalculateSign;
} ST_VEDVehDyn_t;

# define Rte_TypeDef_ST_VEDVehSig_t
typedef struct
{
  uint32 uiVersionNumber;
  VEDSignalHeader_t sSigHeader;
  VEDVehSigMain_t VehSigMain;
  VEDVehSigAdd_t VehSigAdd;
  VEDPowerTrain_t PowerTrain;
  VEDBrake_t Brake;
} ST_VEDVehSig_t;

# define Rte_TypeDef_ST_VLCSen_AccOOI_List_t
typedef struct
{
  uint32 uiVersionNumber;
  VLCSen_SignalHeader_t sSigHeader;
  VLCSen_AccOOINextLong_t AccOOINextLong;
  VLCSen_AccOOI_t AccOOIHiddenNextLong;
  VLCSen_AccOOI_t AccOOINextLeft;
  VLCSen_AccOOI_t AccOOINextRight;
  VLCSen_AccOOI_t AccOOIHiddenNextLeft;
  VLCSen_AccOOI_t AccOOIHiddenNextRight;
} ST_VLCSen_AccOOI_List_t;

# define Rte_TypeDef_ST_VLCSen_AssessedObjList_t
typedef struct
{
  uint32 uiVersionNumber;
  VLCSen_SignalHeader_t sSigHeader;
  VLCSen_HeaderAssessedObjList_t HeaderAssessedObjList;
  Rte_DT_ST_VLCSen_AssessedObjList_t_3 ObjList;
} ST_VLCSen_AssessedObjList_t;

# define Rte_TypeDef_ST_VLCSen_HypothesisIntf_t
typedef struct
{
  uint32 uiVersionNumber;
  VLCSen_SignalHeader_t sSigHeader;
  VLCSen_HypoIntfHeader_t Header;
  VLCSen_HypoIntfDegr_t Degradation;
  Rte_DT_ST_VLCSen_HypothesisIntf_t_4 Hypothesis;
  VLCSen_TcuSysInfo_t sTcuSysInfo;
} ST_VLCSen_HypothesisIntf_t;

# define Rte_TypeDef_ST_VLCSen_acc_object_t
typedef struct
{
  uint32 uiVersionNumber;
  VLCSen_SignalHeader_t sSigHeade;
  VLCSen_object_t AUTOSAR;
  sint16 LONG_SPEED;
  Rte_DT_ST_VLCSen_acc_object_t_4 LONG_SPEED_HISTORY;
  sint16 LONG_ACCEL;
  sint16 LAT_DISPL_FROM_LANE;
  sint8 LANE_INFORMATION;
  sint16 MAX_ALLOWED_DECEL;
  sint16 MAX_ALLOWED_ACCEL;
  sint16 CONTROL_ACCEL;
  sint16 NEEDED_DECEL;
  uint16 TTC;
  uint8 AVLC_CUT_IN_OUT_POTENTIAL;
  VLCSen_acc_object_usage_status_t USAGE_STATUS;
  sint16 REQUESTED_DISTANCE_MODIFIED_ACT;
  sint16 REQUESTED_DISTANCE_MODIFIED_PRED;
  sint8 CONTROL_SMOOTHNESS;
  sint16 ALERT_MODIFICATION_FACTOR;
  sint8 LAST_OBJECT_ID;
  sint16 LONG_ACCEL_MODIFIED;
  sint16 TTS;
  sint16 ACCEL_REQUEST_FUZZY;
  sint16 ACCEL_REQUEST_TTS;
  sint16 ACCEL_REQUEST_DMIN;
  Rte_DT_ST_VLCSen_acc_object_t_25 FuzzyAreaArray;
  Rte_DT_ST_VLCSen_acc_object_t_26 FuzzyAreaPosArray;
  VLCSen_Fuzzy_Signal_Input_t Fuzzy_Signal_Input;
  VLCSen_Fuzzy_Rule_Input_t Fuzzy_Rule_Input;
} ST_VLCSen_acc_object_t;

# define Rte_TypeDef_ST_VLCVeh_LongCtrlInput_t
typedef struct
{
  uint32 uiVersionNumber;
  VLCVeh_SignalHeader_t sSigHeader;
  VLCVeh_KinCtrlDynInput_t KinCtrlDynInput;
  VLCVeh_KinDisplayInput_t DisplayOutput;
  VLCVeh_LongCtrlInputCustom_t Custom;
} ST_VLCVeh_LongCtrlInput_t;

# define Rte_TypeDef_rt_Array_LineBoundary_15
typedef LineBoundary rt_Array_LineBoundary_15[15];

# define Rte_TypeDef_ST_FusionLine_t
typedef struct
{
  Timestamp timestamp_t;
  Timestamp actual_time_ns;
  CoordinateSystem coordinate;
  SensorId sensor_id;
  uint8 line_num;
  uint32 cur_lane_id;
  rt_Array_LineBoundary_15 line_boundaries;
} ST_FusionLine_t;


# ifndef RTE_SUPPRESS_UNUSED_DATATYPES
/**********************************************************************************************************************
 * Unused Data type definitions
 *********************************************************************************************************************/

#  define Rte_TypeDef_ACU1_CrashStatus
typedef boolean ACU1_CrashStatus;

#  define Rte_TypeDef_ACU1_Driver_Buckle
typedef uint8 ACU1_Driver_Buckle;

#  define Rte_TypeDef_ACU1_Driver_Buckle_t
typedef uint8 ACU1_Driver_Buckle_t;

#  define Rte_TypeDef_ACU1_Passenger_Buckle
typedef uint8 ACU1_Passenger_Buckle;

#  define Rte_TypeDef_ACU1_Passenger_ODS
typedef uint8 ACU1_Passenger_ODS;

#  define Rte_TypeDef_ACU1_Rear_Left_Buckle
typedef uint8 ACU1_Rear_Left_Buckle;

#  define Rte_TypeDef_ACU1_Rear_Middle_Buckle
typedef uint8 ACU1_Rear_Middle_Buckle;

#  define Rte_TypeDef_ACU1_Rear_Right_Buckle
typedef uint8 ACU1_Rear_Right_Buckle;

#  define Rte_TypeDef_ACU1_warningLight
typedef uint8 ACU1_warningLight;

#  define Rte_TypeDef_ACU2_Checksum
typedef uint8 ACU2_Checksum;

#  define Rte_TypeDef_ACU2_LatAccSensorValue
typedef uint16 ACU2_LatAccSensorValue;

#  define Rte_TypeDef_ACU2_LatAccSensorValueV
typedef boolean ACU2_LatAccSensorValueV;

#  define Rte_TypeDef_ACU2_LatAccSensorValueV_t
typedef boolean ACU2_LatAccSensorValueV_t;

#  define Rte_TypeDef_ACU2_LatAccSensorValue_t
typedef float32 ACU2_LatAccSensorValue_t;

#  define Rte_TypeDef_ACU2_LongAccSensorValue
typedef uint16 ACU2_LongAccSensorValue;

#  define Rte_TypeDef_ACU2_LongAccSensorValueV
typedef boolean ACU2_LongAccSensorValueV;

#  define Rte_TypeDef_ACU2_LongAccSensorValueV_t
typedef boolean ACU2_LongAccSensorValueV_t;

#  define Rte_TypeDef_ACU2_LongAccSensorValue_t
typedef float32 ACU2_LongAccSensorValue_t;

#  define Rte_TypeDef_ACU2_MsgCounter
typedef uint8 ACU2_MsgCounter;

#  define Rte_TypeDef_ACU2_Sensorcalibration
typedef boolean ACU2_Sensorcalibration;

#  define Rte_TypeDef_ACU2_VehicleDynYawRate
typedef uint16 ACU2_VehicleDynYawRate;

#  define Rte_TypeDef_ACU2_VehicleDynYawRateV
typedef boolean ACU2_VehicleDynYawRateV;

#  define Rte_TypeDef_ACU2_VehicleDynYawRateV_t
typedef boolean ACU2_VehicleDynYawRateV_t;

#  define Rte_TypeDef_ACU2_VehicleDynYawRate_t
typedef float32 ACU2_VehicleDynYawRate_t;

#  define Rte_TypeDef_ADAS8_LateralCtrHandOffReleasewarning_t
typedef boolean ADAS8_LateralCtrHandOffReleasewarning_t;

#  define Rte_TypeDef_ADAS_TimeSync_Timer_Count_Front_t
typedef uint32 ADAS_TimeSync_Timer_Count_Front_t;

#  define Rte_TypeDef_ADAS_TimeSync_Timer_Count_Rear_t
typedef uint32 ADAS_TimeSync_Timer_Count_Rear_t;

#  define Rte_TypeDef_ADAS_TimeSync_Timer_Count_t
typedef uint32 ADAS_TimeSync_Timer_Count_t;

#  define Rte_TypeDef_ADAS_TimeSync_Trig_Counter_Front_t
typedef uint16 ADAS_TimeSync_Trig_Counter_Front_t;

#  define Rte_TypeDef_ADAS_TimeSync_Trig_Counter_Rear_t
typedef uint16 ADAS_TimeSync_Trig_Counter_Rear_t;

#  define Rte_TypeDef_ADAS_TimeSync_Trig_Counter_t
typedef uint16 ADAS_TimeSync_Trig_Counter_t;

#  define Rte_TypeDef_ADCS11_APA_FLWindowsCtrl
typedef uint8 ADCS11_APA_FLWindowsCtrl;

#  define Rte_TypeDef_ADCS11_APA_FRWindowsCtrl
typedef uint8 ADCS11_APA_FRWindowsCtrl;

#  define Rte_TypeDef_ADCS11_APA_RLWindowsCtrl
typedef uint8 ADCS11_APA_RLWindowsCtrl;

#  define Rte_TypeDef_ADCS11_APA_RRWindowsCtrl
typedef uint8 ADCS11_APA_RRWindowsCtrl;

#  define Rte_TypeDef_ADCS11_APA_RemoteLockCtrl
typedef uint8 ADCS11_APA_RemoteLockCtrl;

#  define Rte_TypeDef_ADCS11_APA_RemoteShutdownReq
typedef boolean ADCS11_APA_RemoteShutdownReq;

#  define Rte_TypeDef_ADCS11_APA_RemoteStartReq
typedef boolean ADCS11_APA_RemoteStartReq;

#  define Rte_TypeDef_ADCS11_APA_requestMirrorFoldSt
typedef uint8 ADCS11_APA_requestMirrorFoldSt;

#  define Rte_TypeDef_ADCS11_Checksum0
typedef uint8 ADCS11_Checksum0;

#  define Rte_TypeDef_ADCS11_Currentgear
typedef uint8 ADCS11_Currentgear;

#  define Rte_TypeDef_ADCS11_HPAGuideSts
typedef uint8 ADCS11_HPAGuideSts;

#  define Rte_TypeDef_ADCS11_HPAPathlearning_WorkSts
typedef uint8 ADCS11_HPAPathlearning_WorkSts;

#  define Rte_TypeDef_ADCS11_HPAPathwaytoCloud_WorkSts
typedef uint8 ADCS11_HPAPathwaytoCloud_WorkSts;

#  define Rte_TypeDef_ADCS11_HPA_BacktoEntrance
typedef boolean ADCS11_HPA_BacktoEntrance;

#  define Rte_TypeDef_ADCS11_HPA_BacktoStart
typedef boolean ADCS11_HPA_BacktoStart;

#  define Rte_TypeDef_ADCS11_HPA_Path_exist
typedef uint8 ADCS11_HPA_Path_exist;

#  define Rte_TypeDef_ADCS11_HPA_Pathavailable_ID1
typedef uint8 ADCS11_HPA_Pathavailable_ID1;

#  define Rte_TypeDef_ADCS11_HPA_Pathavailable_ID2
typedef uint8 ADCS11_HPA_Pathavailable_ID2;

#  define Rte_TypeDef_ADCS11_HPA_PathlearningSt
typedef uint8 ADCS11_HPA_PathlearningSt;

#  define Rte_TypeDef_ADCS11_HPA_WorkSts
typedef uint8 ADCS11_HPA_WorkSts;

#  define Rte_TypeDef_ADCS11_HPA_distance
typedef uint16 ADCS11_HPA_distance;

#  define Rte_TypeDef_ADCS11_HPA_learnpathdistance
typedef uint16 ADCS11_HPA_learnpathdistance;

#  define Rte_TypeDef_ADCS11_HighBeam
typedef uint8 ADCS11_HighBeam;

#  define Rte_TypeDef_ADCS11_LowBeam
typedef uint8 ADCS11_LowBeam;

#  define Rte_TypeDef_ADCS11_MirrorFoldrequest
typedef uint8 ADCS11_MirrorFoldrequest;

#  define Rte_TypeDef_ADCS11_MsgCounter0
typedef uint8 ADCS11_MsgCounter0;

#  define Rte_TypeDef_ADCS11_NNS_distance
typedef uint16 ADCS11_NNS_distance;

#  define Rte_TypeDef_ADCS11_PA_BrakemodeReq
typedef uint8 ADCS11_PA_BrakemodeReq;

#  define Rte_TypeDef_ADCS11_PA_EPSAngleReq
typedef uint16 ADCS11_PA_EPSAngleReq;

#  define Rte_TypeDef_ADCS11_PA_EPSAngleReqSt
typedef boolean ADCS11_PA_EPSAngleReqSt;

#  define Rte_TypeDef_ADCS11_PA_EPSAngleReqV
typedef boolean ADCS11_PA_EPSAngleReqV;

#  define Rte_TypeDef_ADCS11_PA_EpbReq
typedef uint8 ADCS11_PA_EpbReq;

#  define Rte_TypeDef_ADCS11_PA_GearPosReq
typedef uint8 ADCS11_PA_GearPosReq;

#  define Rte_TypeDef_ADCS11_PA_GearPosReqVail
typedef boolean ADCS11_PA_GearPosReqVail;

#  define Rte_TypeDef_ADCS11_PA_GearReq
typedef boolean ADCS11_PA_GearReq;

#  define Rte_TypeDef_ADCS11_PA_IDBControlReq
typedef uint8 ADCS11_PA_IDBControlReq;

#  define Rte_TypeDef_ADCS11_PA_IDBControlReqV
typedef boolean ADCS11_PA_IDBControlReqV;

#  define Rte_TypeDef_ADCS11_PA_IDB_TorqReqValidity
typedef boolean ADCS11_PA_IDB_TorqReqValidity;

#  define Rte_TypeDef_ADCS11_PA_IDB_TorqReqValue
typedef uint16 ADCS11_PA_IDB_TorqReqValue;

#  define Rte_TypeDef_ADCS11_PA_PAMaxSpd
typedef uint16 ADCS11_PA_PAMaxSpd;

#  define Rte_TypeDef_ADCS11_PA_ParkingFnMd
typedef uint8 ADCS11_PA_ParkingFnMd;

#  define Rte_TypeDef_ADCS11_PA_Pause_Recover
typedef uint8 ADCS11_PA_Pause_Recover;

#  define Rte_TypeDef_ADCS11_PA_PickSt
typedef boolean ADCS11_PA_PickSt;

#  define Rte_TypeDef_ADCS11_PA_Recover
typedef boolean ADCS11_PA_Recover;

#  define Rte_TypeDef_ADCS11_PA_StopDistance
typedef uint16 ADCS11_PA_StopDistance;

#  define Rte_TypeDef_ADCS11_PA_StopDistanceValid
typedef boolean ADCS11_PA_StopDistanceValid;

#  define Rte_TypeDef_ADCS11_PA_StopReq
typedef boolean ADCS11_PA_StopReq;

#  define Rte_TypeDef_ADCS11_PA_TarDecel
typedef uint16 ADCS11_PA_TarDecel;

#  define Rte_TypeDef_ADCS11_PA_TarDecelreq
typedef boolean ADCS11_PA_TarDecelreq;

#  define Rte_TypeDef_ADCS11_PA_TorqReq
typedef boolean ADCS11_PA_TorqReq;

#  define Rte_TypeDef_ADCS11_PA_TorqReqValidity
typedef boolean ADCS11_PA_TorqReqValidity;

#  define Rte_TypeDef_ADCS11_PA_TorqReqValue
typedef uint16 ADCS11_PA_TorqReqValue;

#  define Rte_TypeDef_ADCS11_PA_lampreq
typedef uint8 ADCS11_PA_lampreq;

#  define Rte_TypeDef_ADCS11_PA_prefillReq
typedef boolean ADCS11_PA_prefillReq;

#  define Rte_TypeDef_ADCS11_PA_screenReq
typedef uint8 ADCS11_PA_screenReq;

#  define Rte_TypeDef_ADCS11_Parking_WorkSts
typedef uint8 ADCS11_Parking_WorkSts;

#  define Rte_TypeDef_ADCS11_Parking_WorkSts_t
typedef uint8 ADCS11_Parking_WorkSts_t;

#  define Rte_TypeDef_ADCS11_Parkingtimeremaining
typedef uint16 ADCS11_Parkingtimeremaining;

#  define Rte_TypeDef_ADCS11_PrkngFctnModeReq
typedef uint8 ADCS11_PrkngFctnModeReq;

#  define Rte_TypeDef_ADCS11_RPA_RemoteParkAppStartReq
typedef boolean ADCS11_RPA_RemoteParkAppStartReq;

#  define Rte_TypeDef_ADCS11_ReqPwmode
typedef uint8 ADCS11_ReqPwmode;

#  define Rte_TypeDef_ADCS11_SecuritySts
typedef uint8 ADCS11_SecuritySts;

#  define Rte_TypeDef_ADCS11_SetPathwayWorkSts
typedef uint8 ADCS11_SetPathwayWorkSts;

#  define Rte_TypeDef_ADCS11_TrackreverseWorkSts
typedef uint8 ADCS11_TrackreverseWorkSts;

#  define Rte_TypeDef_ADCS11_TurnLampReq
typedef uint8 ADCS11_TurnLampReq;

#  define Rte_TypeDef_ADCS12_ADAS_DriveOffinhibition_t
typedef boolean ADCS12_ADAS_DriveOffinhibition_t;

#  define Rte_TypeDef_ADCS12_DCLCAudioplay_t
typedef uint8 ADCS12_DCLCAudioplay_t;

#  define Rte_TypeDef_ADCS12_DOWWarnAudioplay_t
typedef boolean ADCS12_DOWWarnAudioplay_t;

#  define Rte_TypeDef_ADCS12_DriveOffBroadcast_t
typedef boolean ADCS12_DriveOffBroadcast_t;

#  define Rte_TypeDef_ADCS12_EyeOffBroadcast_t
typedef boolean ADCS12_EyeOffBroadcast_t;

#  define Rte_TypeDef_ADCS12_FCTAWarnAudioplay_t
typedef uint8 ADCS12_FCTAWarnAudioplay_t;

#  define Rte_TypeDef_ADCS12_FCWWarnAudioplay_t
typedef boolean ADCS12_FCWWarnAudioplay_t;

#  define Rte_TypeDef_ADCS12_HandOffAudioplay_t
typedef uint8 ADCS12_HandOffAudioplay_t;

#  define Rte_TypeDef_ADCS12_LCAudioPlay_t
typedef uint8 ADCS12_LCAudioPlay_t;

#  define Rte_TypeDef_ADCS12_LaneChangePendingAlert_t
typedef boolean ADCS12_LaneChangePendingAlert_t;

#  define Rte_TypeDef_ADCS12_Lcsndrconfirm_t
typedef uint8 ADCS12_Lcsndrconfirm_t;

#  define Rte_TypeDef_ADCS12_Lcsndrequest_t
typedef uint8 ADCS12_Lcsndrequest_t;

#  define Rte_TypeDef_ADCS12_MRMAudioPlay_t
typedef uint8 ADCS12_MRMAudioPlay_t;

#  define Rte_TypeDef_ADCS12_NNPCancelAudioPlay_t
typedef boolean ADCS12_NNPCancelAudioPlay_t;

#  define Rte_TypeDef_ADCS12_NNP_LightRemind_t
typedef boolean ADCS12_NNP_LightRemind_t;

#  define Rte_TypeDef_ADCS12_NNP_RINO_t
typedef uint8 ADCS12_NNP_RINO_t;

#  define Rte_TypeDef_ADCS12_NNP_ResumeAudioplay_t
typedef uint8 ADCS12_NNP_ResumeAudioplay_t;

#  define Rte_TypeDef_ADCS12_NNP_Scenarios_AudioPlay_t
typedef uint8 ADCS12_NNP_Scenarios_AudioPlay_t;

#  define Rte_TypeDef_ADCS12_NNP_State_Reminder_t
typedef uint8 ADCS12_NNP_State_Reminder_t;

#  define Rte_TypeDef_ADCS12_NPilotSysInfo_t
typedef uint8 ADCS12_NPilotSysInfo_t;

#  define Rte_TypeDef_ADCS12_P2N_State_Reminder_t
typedef uint8 ADCS12_P2N_State_Reminder_t;

#  define Rte_TypeDef_ADCS12_PayModeConfirm_t
typedef boolean ADCS12_PayModeConfirm_t;

#  define Rte_TypeDef_ADCS12_PilotAudioPlay_t
typedef uint8 ADCS12_PilotAudioPlay_t;

#  define Rte_TypeDef_ADCS12_RCTAWarnAudioplay_t
typedef uint8 ADCS12_RCTAWarnAudioplay_t;

#  define Rte_TypeDef_ADCS12_RCWWarnAudioplay_t
typedef boolean ADCS12_RCWWarnAudioplay_t;

#  define Rte_TypeDef_ADCS12_SpeedAdaptComfirm_t
typedef boolean ADCS12_SpeedAdaptComfirm_t;

#  define Rte_TypeDef_ADCS12_SpeedWarnAudioplay_t
typedef boolean ADCS12_SpeedWarnAudioplay_t;

#  define Rte_TypeDef_ADCS12_longitudCtrlSysInfo_t
typedef uint8 ADCS12_longitudCtrlSysInfo_t;

#  define Rte_TypeDef_ADCS12_longitudDisableInfo_t
typedef uint8 ADCS12_longitudDisableInfo_t;

#  define Rte_TypeDef_ADCS1_AutoAVMSwtSet_Sts
typedef boolean ADCS1_AutoAVMSwtSet_Sts;

#  define Rte_TypeDef_ADCS1_AutoViewChgFuncSts
typedef boolean ADCS1_AutoViewChgFuncSts;

#  define Rte_TypeDef_ADCS1_CarMdlDispSts
typedef boolean ADCS1_CarMdlDispSts;

#  define Rte_TypeDef_ADCS1_CarMdlTrsprcySts
typedef uint8 ADCS1_CarMdlTrsprcySts;

#  define Rte_TypeDef_ADCS1_GuidOvlDispSts
typedef uint8 ADCS1_GuidOvlDispSts;

#  define Rte_TypeDef_ADCS1_MOD_AlarmSts
typedef boolean ADCS1_MOD_AlarmSts;

#  define Rte_TypeDef_ADCS1_MOD_WorkSts
typedef boolean ADCS1_MOD_WorkSts;

#  define Rte_TypeDef_ADCS1_SigViewIndcn
typedef uint8 ADCS1_SigViewIndcn;

#  define Rte_TypeDef_ADCS2_ADAS_EPSAngleReqSt_t
typedef boolean ADCS2_ADAS_EPSAngleReqSt_t;

#  define Rte_TypeDef_ADCS2_ADAS_EPSAngleReq_t
typedef float32 ADCS2_ADAS_EPSAngleReq_t;

#  define Rte_TypeDef_ADCS2_ADAS_EPSLateralCtrlType_t
typedef uint8 ADCS2_ADAS_EPSLateralCtrlType_t;

#  define Rte_TypeDef_ADCS2_ADAS_IHBCSysState_t
typedef uint8 ADCS2_ADAS_IHBCSysState_t;

#  define Rte_TypeDef_ADCS2_ADSDriving_mode_t
typedef uint8 ADCS2_ADSDriving_mode_t;

#  define Rte_TypeDef_ADCS2_AEBFullBrake
typedef boolean ADCS2_AEBFullBrake;

#  define Rte_TypeDef_ADCS2_AEBFullBrake_t
typedef boolean ADCS2_AEBFullBrake_t;

#  define Rte_TypeDef_ADCS2_AEBPartialBrake
typedef boolean ADCS2_AEBPartialBrake;

#  define Rte_TypeDef_ADCS2_AEBPartialBrake_t
typedef boolean ADCS2_AEBPartialBrake_t;

#  define Rte_TypeDef_ADCS2_AEBPrefillReq
typedef boolean ADCS2_AEBPrefillReq;

#  define Rte_TypeDef_ADCS2_AEBPrefillReq_t
typedef boolean ADCS2_AEBPrefillReq_t;

#  define Rte_TypeDef_ADCS2_AEBTargetDeceleration_t
typedef float32 ADCS2_AEBTargetDeceleration_t;

#  define Rte_TypeDef_ADCS2_AEBVehicleHoldReq
typedef boolean ADCS2_AEBVehicleHoldReq;

#  define Rte_TypeDef_ADCS2_AEBVehicleHoldReq_t
typedef boolean ADCS2_AEBVehicleHoldReq_t;

#  define Rte_TypeDef_ADCS2_AEB_DBSLevel
typedef uint8 ADCS2_AEB_DBSLevel;

#  define Rte_TypeDef_ADCS2_AEB_DBSLevel_t
typedef uint8 ADCS2_AEB_DBSLevel_t;

#  define Rte_TypeDef_ADCS2_AEB_JerkLevel_t
typedef uint8 ADCS2_AEB_JerkLevel_t;

#  define Rte_TypeDef_ADCS2_AEB_JerkReq
typedef boolean ADCS2_AEB_JerkReq;

#  define Rte_TypeDef_ADCS2_AEB_JerkReq_t
typedef boolean ADCS2_AEB_JerkReq_t;

#  define Rte_TypeDef_ADCS2_ALCDirection_t
typedef uint8 ADCS2_ALCDirection_t;

#  define Rte_TypeDef_ADCS2_EPS_ELKState_t
typedef uint8 ADCS2_EPS_ELKState_t;

#  define Rte_TypeDef_ADCS2_EPS_LDPState_t
typedef uint8 ADCS2_EPS_LDPState_t;

#  define Rte_TypeDef_ADCS2_LongitudCtrlAccelCtrlReq_t
typedef boolean ADCS2_LongitudCtrlAccelCtrlReq_t;

#  define Rte_TypeDef_ADCS2_LongitudCtrlDecToStopReq_t
typedef boolean ADCS2_LongitudCtrlDecToStopReq_t;

#  define Rte_TypeDef_ADCS2_LongitudCtrlDriveOff_t
typedef boolean ADCS2_LongitudCtrlDriveOff_t;

#  define Rte_TypeDef_ADCS2_LongitudCtrlTargetAccel_t
typedef float32 ADCS2_LongitudCtrlTargetAccel_t;

#  define Rte_TypeDef_ADCS2_NNP_SystemFaultStatus_t
typedef uint8 ADCS2_NNP_SystemFaultStatus_t;

#  define Rte_TypeDef_ADCS2_longitudCtrlType_t
typedef uint8 ADCS2_longitudCtrlType_t;

#  define Rte_TypeDef_ADCS4_APA_FunctionMode
typedef uint8 ADCS4_APA_FunctionMode;

#  define Rte_TypeDef_ADCS4_AVM_BSD_SysSts
typedef uint8 ADCS4_AVM_BSD_SysSts;

#  define Rte_TypeDef_ADCS4_AVM_BSD_warningReqLeft
typedef uint8 ADCS4_AVM_BSD_warningReqLeft;

#  define Rte_TypeDef_ADCS4_AVM_BSD_warningReqRight
typedef uint8 ADCS4_AVM_BSD_warningReqRight;

#  define Rte_TypeDef_ADCS4_AVM_Sts
typedef uint8 ADCS4_AVM_Sts;

#  define Rte_TypeDef_ADCS4_AVM_SysSoundIndication
typedef uint8 ADCS4_AVM_SysSoundIndication;

#  define Rte_TypeDef_ADCS4_AVM_vedioReq
typedef uint8 ADCS4_AVM_vedioReq;

#  define Rte_TypeDef_ADCS4_Checksum0
typedef uint8 ADCS4_Checksum0;

#  define Rte_TypeDef_ADCS4_DCWlevel
typedef uint8 ADCS4_DCWlevel;

#  define Rte_TypeDef_ADCS4_DCWposition
typedef uint8 ADCS4_DCWposition;

#  define Rte_TypeDef_ADCS4_DCWtext
typedef uint8 ADCS4_DCWtext;

#  define Rte_TypeDef_ADCS4_DCWworkSt
typedef uint8 ADCS4_DCWworkSt;

#  define Rte_TypeDef_ADCS4_FindCarAvmStatus
typedef uint8 ADCS4_FindCarAvmStatus;

#  define Rte_TypeDef_ADCS4_GMState
typedef uint8 ADCS4_GMState;

#  define Rte_TypeDef_ADCS4_GMWarnState
typedef uint8 ADCS4_GMWarnState;

#  define Rte_TypeDef_ADCS4_GMWorkState
typedef uint8 ADCS4_GMWorkState;

#  define Rte_TypeDef_ADCS4_GM_SystemFaultStatus
typedef uint8 ADCS4_GM_SystemFaultStatus;

#  define Rte_TypeDef_ADCS4_HPAWarningInfo
typedef uint8 ADCS4_HPAWarningInfo;

#  define Rte_TypeDef_ADCS4_HPA_FunctionMode
typedef boolean ADCS4_HPA_FunctionMode;

#  define Rte_TypeDef_ADCS4_HPA_deleteMapSt
typedef uint8 ADCS4_HPA_deleteMapSt;

#  define Rte_TypeDef_ADCS4_HPA_failinfo
typedef uint8 ADCS4_HPA_failinfo;

#  define Rte_TypeDef_ADCS4_HPA_uploadMapSt
typedef uint8 ADCS4_HPA_uploadMapSt;

#  define Rte_TypeDef_ADCS4_HornReq
typedef boolean ADCS4_HornReq;

#  define Rte_TypeDef_ADCS4_HourOfDay
typedef uint8 ADCS4_HourOfDay;

#  define Rte_TypeDef_ADCS4_MinuteOfHour
typedef uint8 ADCS4_MinuteOfHour;

#  define Rte_TypeDef_ADCS4_MsgCounter0
typedef uint8 ADCS4_MsgCounter0;

#  define Rte_TypeDef_ADCS4_NNS_FunctionMode
typedef uint8 ADCS4_NNS_FunctionMode;

#  define Rte_TypeDef_ADCS4_PA_GuideLineE_Xmax
typedef uint16 ADCS4_PA_GuideLineE_Xmax;

#  define Rte_TypeDef_ADCS4_PA_GuideLineE_Xmin
typedef uint16 ADCS4_PA_GuideLineE_Xmin;

#  define Rte_TypeDef_ADCS4_PA_GuideLineE_a
typedef uint16 ADCS4_PA_GuideLineE_a;

#  define Rte_TypeDef_ADCS4_PA_GuideLineE_b
typedef uint16 ADCS4_PA_GuideLineE_b;

#  define Rte_TypeDef_ADCS4_PA_GuideLineE_c
typedef uint16 ADCS4_PA_GuideLineE_c;

#  define Rte_TypeDef_ADCS4_PA_GuideLineE_d
typedef uint16 ADCS4_PA_GuideLineE_d;

#  define Rte_TypeDef_ADCS4_PA_InfoDisplayReq
typedef uint8 ADCS4_PA_InfoDisplayReq;

#  define Rte_TypeDef_ADCS4_PA_ParkBarPercent
typedef uint8 ADCS4_PA_ParkBarPercent;

#  define Rte_TypeDef_ADCS4_PA_Sound_Location
typedef uint8 ADCS4_PA_Sound_Location;

#  define Rte_TypeDef_ADCS4_PA_SysSoundIndication
typedef uint8 ADCS4_PA_SysSoundIndication;

#  define Rte_TypeDef_ADCS4_PA_failinfo
typedef uint8 ADCS4_PA_failinfo;

#  define Rte_TypeDef_ADCS4_ParkingTime
typedef uint16 ADCS4_ParkingTime;

#  define Rte_TypeDef_ADCS4_ParkingswithReq
typedef boolean ADCS4_ParkingswithReq;

#  define Rte_TypeDef_ADCS4_RPA_FunctionMode
typedef uint8 ADCS4_RPA_FunctionMode;

#  define Rte_TypeDef_ADCS4_RPA_RemoteParkFinishReq
typedef uint8 ADCS4_RPA_RemoteParkFinishReq;

#  define Rte_TypeDef_ADCS4_SecondOfMinute
typedef uint8 ADCS4_SecondOfMinute;

#  define Rte_TypeDef_ADCS4_Slotavaliable
typedef uint8 ADCS4_Slotavaliable;

#  define Rte_TypeDef_ADCS4_SystemFault2
typedef uint8 ADCS4_SystemFault2;

#  define Rte_TypeDef_ADCS4_Text
typedef uint8 ADCS4_Text;

#  define Rte_TypeDef_ADCS4_TractionswithReq
typedef boolean ADCS4_TractionswithReq;

#  define Rte_TypeDef_ADCS4_UPA_Sound_Location
typedef uint8 ADCS4_UPA_Sound_Location;

#  define Rte_TypeDef_ADCS4_UPA_SysSoundIndication
typedef uint8 ADCS4_UPA_SysSoundIndication;

#  define Rte_TypeDef_ADCS4_locationSt
typedef uint8 ADCS4_locationSt;

#  define Rte_TypeDef_ADCS5_RPA_ParkingSlotDepth1
typedef uint16 ADCS5_RPA_ParkingSlotDepth1;

#  define Rte_TypeDef_ADCS5_RPA_ParkingSlotDepth2
typedef uint16 ADCS5_RPA_ParkingSlotDepth2;

#  define Rte_TypeDef_ADCS5_RPA_ParkingSlotDepth3
typedef uint16 ADCS5_RPA_ParkingSlotDepth3;

#  define Rte_TypeDef_ADCS5_RPA_ParkingSlotDirection1
typedef uint8 ADCS5_RPA_ParkingSlotDirection1;

#  define Rte_TypeDef_ADCS5_RPA_ParkingSlotDirection2
typedef uint8 ADCS5_RPA_ParkingSlotDirection2;

#  define Rte_TypeDef_ADCS5_RPA_ParkingSlotDirection3
typedef uint8 ADCS5_RPA_ParkingSlotDirection3;

#  define Rte_TypeDef_ADCS5_RPA_ParkingSlotType1
typedef uint8 ADCS5_RPA_ParkingSlotType1;

#  define Rte_TypeDef_ADCS5_RPA_ParkingSlotType2
typedef uint8 ADCS5_RPA_ParkingSlotType2;

#  define Rte_TypeDef_ADCS5_RPA_ParkingSlotType3
typedef uint8 ADCS5_RPA_ParkingSlotType3;

#  define Rte_TypeDef_ADCS5_RPA_ParkingSlotWidth1
typedef uint16 ADCS5_RPA_ParkingSlotWidth1;

#  define Rte_TypeDef_ADCS5_RPA_ParkingSlotWidth2
typedef uint16 ADCS5_RPA_ParkingSlotWidth2;

#  define Rte_TypeDef_ADCS5_RPA_ParkingSlotWidth3
typedef uint16 ADCS5_RPA_ParkingSlotWidth3;

#  define Rte_TypeDef_ADCS5_RPA_slot_Angle1
typedef uint16 ADCS5_RPA_slot_Angle1;

#  define Rte_TypeDef_ADCS5_RPA_slot_Angle2
typedef uint16 ADCS5_RPA_slot_Angle2;

#  define Rte_TypeDef_ADCS5_RPA_slot_Angle3
typedef uint16 ADCS5_RPA_slot_Angle3;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_1_P0_X
typedef uint16 ADCS5_RPA_slot_ID_1_P0_X;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_1_P0_Y
typedef uint16 ADCS5_RPA_slot_ID_1_P0_Y;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_1_P1_X
typedef uint16 ADCS5_RPA_slot_ID_1_P1_X;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_1_P1_Y
typedef uint16 ADCS5_RPA_slot_ID_1_P1_Y;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_1_P2_X
typedef uint16 ADCS5_RPA_slot_ID_1_P2_X;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_1_P2_Y
typedef uint16 ADCS5_RPA_slot_ID_1_P2_Y;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_1_P3_X
typedef uint16 ADCS5_RPA_slot_ID_1_P3_X;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_1_P3_Y
typedef uint16 ADCS5_RPA_slot_ID_1_P3_Y;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_1_Status
typedef uint8 ADCS5_RPA_slot_ID_1_Status;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_2_P0_X
typedef uint16 ADCS5_RPA_slot_ID_2_P0_X;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_2_P0_Y
typedef uint16 ADCS5_RPA_slot_ID_2_P0_Y;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_2_P1_X
typedef uint16 ADCS5_RPA_slot_ID_2_P1_X;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_2_P1_Y
typedef uint16 ADCS5_RPA_slot_ID_2_P1_Y;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_2_P2_X
typedef uint16 ADCS5_RPA_slot_ID_2_P2_X;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_2_P2_Y
typedef uint16 ADCS5_RPA_slot_ID_2_P2_Y;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_2_P3_X
typedef uint16 ADCS5_RPA_slot_ID_2_P3_X;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_2_P3_Y
typedef uint16 ADCS5_RPA_slot_ID_2_P3_Y;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_2_Status
typedef uint8 ADCS5_RPA_slot_ID_2_Status;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_3_P0_X
typedef uint16 ADCS5_RPA_slot_ID_3_P0_X;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_3_P0_Y
typedef uint16 ADCS5_RPA_slot_ID_3_P0_Y;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_3_P1_X
typedef uint16 ADCS5_RPA_slot_ID_3_P1_X;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_3_P1_Y
typedef uint16 ADCS5_RPA_slot_ID_3_P1_Y;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_3_P2_X
typedef uint16 ADCS5_RPA_slot_ID_3_P2_X;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_3_P2_Y
typedef uint16 ADCS5_RPA_slot_ID_3_P2_Y;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_3_P3_X
typedef uint16 ADCS5_RPA_slot_ID_3_P3_X;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_3_P3_Y
typedef uint16 ADCS5_RPA_slot_ID_3_P3_Y;

#  define Rte_TypeDef_ADCS5_RPA_slot_ID_3_Status
typedef uint8 ADCS5_RPA_slot_ID_3_Status;

#  define Rte_TypeDef_ADCS6_RPA_ParkingSlotDepth4
typedef uint16 ADCS6_RPA_ParkingSlotDepth4;

#  define Rte_TypeDef_ADCS6_RPA_ParkingSlotDepth5
typedef uint16 ADCS6_RPA_ParkingSlotDepth5;

#  define Rte_TypeDef_ADCS6_RPA_ParkingSlotDepth6
typedef uint16 ADCS6_RPA_ParkingSlotDepth6;

#  define Rte_TypeDef_ADCS6_RPA_ParkingSlotDirection4
typedef uint8 ADCS6_RPA_ParkingSlotDirection4;

#  define Rte_TypeDef_ADCS6_RPA_ParkingSlotDirection5
typedef uint8 ADCS6_RPA_ParkingSlotDirection5;

#  define Rte_TypeDef_ADCS6_RPA_ParkingSlotDirection6
typedef uint8 ADCS6_RPA_ParkingSlotDirection6;

#  define Rte_TypeDef_ADCS6_RPA_ParkingSlotType4
typedef uint8 ADCS6_RPA_ParkingSlotType4;

#  define Rte_TypeDef_ADCS6_RPA_ParkingSlotType5
typedef uint8 ADCS6_RPA_ParkingSlotType5;

#  define Rte_TypeDef_ADCS6_RPA_ParkingSlotType6
typedef uint8 ADCS6_RPA_ParkingSlotType6;

#  define Rte_TypeDef_ADCS6_RPA_ParkingSlotWidth4
typedef uint16 ADCS6_RPA_ParkingSlotWidth4;

#  define Rte_TypeDef_ADCS6_RPA_ParkingSlotWidth5
typedef uint16 ADCS6_RPA_ParkingSlotWidth5;

#  define Rte_TypeDef_ADCS6_RPA_ParkingSlotWidth6
typedef uint16 ADCS6_RPA_ParkingSlotWidth6;

#  define Rte_TypeDef_ADCS6_RPA_slot_Angle4
typedef uint16 ADCS6_RPA_slot_Angle4;

#  define Rte_TypeDef_ADCS6_RPA_slot_Angle5
typedef uint16 ADCS6_RPA_slot_Angle5;

#  define Rte_TypeDef_ADCS6_RPA_slot_Angle6
typedef uint16 ADCS6_RPA_slot_Angle6;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_4_P0_X
typedef uint16 ADCS6_RPA_slot_ID_4_P0_X;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_4_P0_Y
typedef uint16 ADCS6_RPA_slot_ID_4_P0_Y;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_4_P1_X
typedef uint16 ADCS6_RPA_slot_ID_4_P1_X;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_4_P1_Y
typedef uint16 ADCS6_RPA_slot_ID_4_P1_Y;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_4_P2_X
typedef uint16 ADCS6_RPA_slot_ID_4_P2_X;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_4_P2_Y
typedef uint16 ADCS6_RPA_slot_ID_4_P2_Y;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_4_P3_X
typedef uint16 ADCS6_RPA_slot_ID_4_P3_X;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_4_P3_Y
typedef uint16 ADCS6_RPA_slot_ID_4_P3_Y;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_4_Status
typedef uint8 ADCS6_RPA_slot_ID_4_Status;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_5_P0_X
typedef uint16 ADCS6_RPA_slot_ID_5_P0_X;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_5_P0_Y
typedef uint16 ADCS6_RPA_slot_ID_5_P0_Y;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_5_P1_X
typedef uint16 ADCS6_RPA_slot_ID_5_P1_X;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_5_P1_Y
typedef uint16 ADCS6_RPA_slot_ID_5_P1_Y;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_5_P2_X
typedef uint16 ADCS6_RPA_slot_ID_5_P2_X;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_5_P2_Y
typedef uint16 ADCS6_RPA_slot_ID_5_P2_Y;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_5_P3_X
typedef uint16 ADCS6_RPA_slot_ID_5_P3_X;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_5_P3_Y
typedef uint16 ADCS6_RPA_slot_ID_5_P3_Y;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_5_Status
typedef uint8 ADCS6_RPA_slot_ID_5_Status;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_6_P0_X
typedef uint16 ADCS6_RPA_slot_ID_6_P0_X;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_6_P0_Y
typedef uint16 ADCS6_RPA_slot_ID_6_P0_Y;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_6_P1_X
typedef uint16 ADCS6_RPA_slot_ID_6_P1_X;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_6_P1_Y
typedef uint16 ADCS6_RPA_slot_ID_6_P1_Y;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_6_P2_X
typedef uint16 ADCS6_RPA_slot_ID_6_P2_X;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_6_P2_Y
typedef uint16 ADCS6_RPA_slot_ID_6_P2_Y;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_6_P3_X
typedef uint16 ADCS6_RPA_slot_ID_6_P3_X;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_6_P3_Y
typedef uint16 ADCS6_RPA_slot_ID_6_P3_Y;

#  define Rte_TypeDef_ADCS6_RPA_slot_ID_6_Status
typedef uint8 ADCS6_RPA_slot_ID_6_Status;

#  define Rte_TypeDef_ADCS7_PA_ObsDist_F
typedef uint8 ADCS7_PA_ObsDist_F;

#  define Rte_TypeDef_ADCS7_PA_ObsDist_R
typedef uint8 ADCS7_PA_ObsDist_R;

#  define Rte_TypeDef_ADCS7_RPA_ObsArea
typedef uint8 ADCS7_RPA_ObsArea;

#  define Rte_TypeDef_ADCS7_RPA_ObsDist
typedef uint8 ADCS7_RPA_ObsDist;

#  define Rte_TypeDef_ADCS7_RPA_ParkingSlotDepth7
typedef uint16 ADCS7_RPA_ParkingSlotDepth7;

#  define Rte_TypeDef_ADCS7_RPA_ParkingSlotDepth8
typedef uint16 ADCS7_RPA_ParkingSlotDepth8;

#  define Rte_TypeDef_ADCS7_RPA_ParkingSlotDirection7
typedef uint8 ADCS7_RPA_ParkingSlotDirection7;

#  define Rte_TypeDef_ADCS7_RPA_ParkingSlotDirection8
typedef uint8 ADCS7_RPA_ParkingSlotDirection8;

#  define Rte_TypeDef_ADCS7_RPA_ParkingSlotType7
typedef uint8 ADCS7_RPA_ParkingSlotType7;

#  define Rte_TypeDef_ADCS7_RPA_ParkingSlotType8
typedef uint8 ADCS7_RPA_ParkingSlotType8;

#  define Rte_TypeDef_ADCS7_RPA_ParkingSlotWidth7
typedef uint16 ADCS7_RPA_ParkingSlotWidth7;

#  define Rte_TypeDef_ADCS7_RPA_ParkingSlotWidth8
typedef uint16 ADCS7_RPA_ParkingSlotWidth8;

#  define Rte_TypeDef_ADCS7_RPA_slot_Angle7
typedef uint16 ADCS7_RPA_slot_Angle7;

#  define Rte_TypeDef_ADCS7_RPA_slot_Angle8
typedef uint16 ADCS7_RPA_slot_Angle8;

#  define Rte_TypeDef_ADCS7_RPA_slot_ID_7_P0_X
typedef uint16 ADCS7_RPA_slot_ID_7_P0_X;

#  define Rte_TypeDef_ADCS7_RPA_slot_ID_7_P0_Y
typedef uint16 ADCS7_RPA_slot_ID_7_P0_Y;

#  define Rte_TypeDef_ADCS7_RPA_slot_ID_7_P1_X
typedef uint16 ADCS7_RPA_slot_ID_7_P1_X;

#  define Rte_TypeDef_ADCS7_RPA_slot_ID_7_P1_Y
typedef uint16 ADCS7_RPA_slot_ID_7_P1_Y;

#  define Rte_TypeDef_ADCS7_RPA_slot_ID_7_P2_X
typedef uint16 ADCS7_RPA_slot_ID_7_P2_X;

#  define Rte_TypeDef_ADCS7_RPA_slot_ID_7_P2_Y
typedef uint16 ADCS7_RPA_slot_ID_7_P2_Y;

#  define Rte_TypeDef_ADCS7_RPA_slot_ID_7_P3_X
typedef uint16 ADCS7_RPA_slot_ID_7_P3_X;

#  define Rte_TypeDef_ADCS7_RPA_slot_ID_7_P3_Y
typedef uint16 ADCS7_RPA_slot_ID_7_P3_Y;

#  define Rte_TypeDef_ADCS7_RPA_slot_ID_7_Status
typedef uint8 ADCS7_RPA_slot_ID_7_Status;

#  define Rte_TypeDef_ADCS7_RPA_slot_ID_8_P0_X
typedef uint16 ADCS7_RPA_slot_ID_8_P0_X;

#  define Rte_TypeDef_ADCS7_RPA_slot_ID_8_P0_Y
typedef uint16 ADCS7_RPA_slot_ID_8_P0_Y;

#  define Rte_TypeDef_ADCS7_RPA_slot_ID_8_P1_X
typedef uint16 ADCS7_RPA_slot_ID_8_P1_X;

#  define Rte_TypeDef_ADCS7_RPA_slot_ID_8_P1_Y
typedef uint16 ADCS7_RPA_slot_ID_8_P1_Y;

#  define Rte_TypeDef_ADCS7_RPA_slot_ID_8_P2_X
typedef uint16 ADCS7_RPA_slot_ID_8_P2_X;

#  define Rte_TypeDef_ADCS7_RPA_slot_ID_8_P2_Y
typedef uint16 ADCS7_RPA_slot_ID_8_P2_Y;

#  define Rte_TypeDef_ADCS7_RPA_slot_ID_8_P3_X
typedef uint16 ADCS7_RPA_slot_ID_8_P3_X;

#  define Rte_TypeDef_ADCS7_RPA_slot_ID_8_P3_Y
typedef uint16 ADCS7_RPA_slot_ID_8_P3_Y;

#  define Rte_TypeDef_ADCS7_RPA_slot_ID_8_Status
typedef uint8 ADCS7_RPA_slot_ID_8_Status;

#  define Rte_TypeDef_ADCS8_ACCOnOffState_t
typedef boolean ADCS8_ACCOnOffState_t;

#  define Rte_TypeDef_ADCS8_ACCState
typedef uint8 ADCS8_ACCState;

#  define Rte_TypeDef_ADCS8_ACCState_t
typedef uint8 ADCS8_ACCState_t;

#  define Rte_TypeDef_ADCS8_ACCSystemFaultStatus_t
typedef uint8 ADCS8_ACCSystemFaultStatus_t;

#  define Rte_TypeDef_ADCS8_ADAS_DriveOffPossilbe_t
typedef boolean ADCS8_ADAS_DriveOffPossilbe_t;

#  define Rte_TypeDef_ADCS8_ADAS_IHBCStat_t
typedef uint8 ADCS8_ADAS_IHBCStat_t;

#  define Rte_TypeDef_ADCS8_ADSDriving_mode_t
typedef uint8 ADCS8_ADSDriving_mode_t;

#  define Rte_TypeDef_ADCS8_AEB_SystemFaultStatus_t
typedef uint8 ADCS8_AEB_SystemFaultStatus_t;

#  define Rte_TypeDef_ADCS8_AEB_SystemStatus
typedef uint8 ADCS8_AEB_SystemStatus;

#  define Rte_TypeDef_ADCS8_AEB_SystemStatus_t
typedef uint8 ADCS8_AEB_SystemStatus_t;

#  define Rte_TypeDef_ADCS8_ALC_mode_t
typedef boolean ADCS8_ALC_mode_t;

#  define Rte_TypeDef_ADCS8_AVM_MODWarning
typedef boolean ADCS8_AVM_MODWarning;

#  define Rte_TypeDef_ADCS8_AVM_RomoteAVMFeedBack
typedef boolean ADCS8_AVM_RomoteAVMFeedBack;

#  define Rte_TypeDef_ADCS8_AudBpRate_F
typedef uint8 ADCS8_AudBpRate_F;

#  define Rte_TypeDef_ADCS8_AudBpRate_R
typedef uint8 ADCS8_AudBpRate_R;

#  define Rte_TypeDef_ADCS8_DCLCSysState_t
typedef uint8 ADCS8_DCLCSysState_t;

#  define Rte_TypeDef_ADCS8_DOWLeftWarnState_t
typedef uint8 ADCS8_DOWLeftWarnState_t;

#  define Rte_TypeDef_ADCS8_DOWRightWarnState_t
typedef uint8 ADCS8_DOWRightWarnState_t;

#  define Rte_TypeDef_ADCS8_DOWState_t
typedef uint8 ADCS8_DOWState_t;

#  define Rte_TypeDef_ADCS8_DOW_SystemFaultStatus_t
typedef uint8 ADCS8_DOW_SystemFaultStatus_t;

#  define Rte_TypeDef_ADCS8_DoorUnlock_t
typedef boolean ADCS8_DoorUnlock_t;

#  define Rte_TypeDef_ADCS8_DriveOffinhibitionObjType_t
typedef uint8 ADCS8_DriveOffinhibitionObjType_t;

#  define Rte_TypeDef_ADCS8_ELKMode_t
typedef boolean ADCS8_ELKMode_t;

#  define Rte_TypeDef_ADCS8_FCTALeftActiveSt_t
typedef uint8 ADCS8_FCTALeftActiveSt_t;

#  define Rte_TypeDef_ADCS8_FCTARightActiveSt_t
typedef uint8 ADCS8_FCTARightActiveSt_t;

#  define Rte_TypeDef_ADCS8_FCTAWarnObjType_t
typedef uint8 ADCS8_FCTAWarnObjType_t;

#  define Rte_TypeDef_ADCS8_FCTA_State_t
typedef uint8 ADCS8_FCTA_State_t;

#  define Rte_TypeDef_ADCS8_FCTA_SystemFaultStatus_t
typedef uint8 ADCS8_FCTA_SystemFaultStatus_t;

#  define Rte_TypeDef_ADCS8_FCWSensitiveLevel_t
typedef uint8 ADCS8_FCWSensitiveLevel_t;

#  define Rte_TypeDef_ADCS8_FCWStatus
typedef uint8 ADCS8_FCWStatus;

#  define Rte_TypeDef_ADCS8_FCWStatus_t
typedef uint8 ADCS8_FCWStatus_t;

#  define Rte_TypeDef_ADCS8_FCWSystemFaultStatus_t
typedef uint8 ADCS8_FCWSystemFaultStatus_t;

#  define Rte_TypeDef_ADCS8_FCW_State_t
typedef uint8 ADCS8_FCW_State_t;

#  define Rte_TypeDef_ADCS8_FRS_Fail_t
typedef uint8 ADCS8_FRS_Fail_t;

#  define Rte_TypeDef_ADCS8_FVC_120_Fail_t
typedef uint8 ADCS8_FVC_120_Fail_t;

#  define Rte_TypeDef_ADCS8_FVC_30_Fail_t
typedef uint8 ADCS8_FVC_30_Fail_t;

#  define Rte_TypeDef_ADCS8_HornReq_t
typedef boolean ADCS8_HornReq_t;

#  define Rte_TypeDef_ADCS8_LCALeftWarnSt_t
typedef uint8 ADCS8_LCALeftWarnSt_t;

#  define Rte_TypeDef_ADCS8_LCARightWarnSt_t
typedef uint8 ADCS8_LCARightWarnSt_t;

#  define Rte_TypeDef_ADCS8_LCAState_t
typedef uint8 ADCS8_LCAState_t;

#  define Rte_TypeDef_ADCS8_LCASystemFaultStatus_t
typedef uint8 ADCS8_LCASystemFaultStatus_t;

#  define Rte_TypeDef_ADCS8_LDPELKWarnState_t
typedef uint8 ADCS8_LDPELKWarnState_t;

#  define Rte_TypeDef_ADCS8_LDPELKtakeoverWarningstate_t
typedef uint8 ADCS8_LDPELKtakeoverWarningstate_t;

#  define Rte_TypeDef_ADCS8_LDPMode_t
typedef boolean ADCS8_LDPMode_t;

#  define Rte_TypeDef_ADCS8_LDWMode_t
typedef boolean ADCS8_LDWMode_t;

#  define Rte_TypeDef_ADCS8_LDWState_t
typedef uint8 ADCS8_LDWState_t;

#  define Rte_TypeDef_ADCS8_LDWWarnState_t
typedef uint8 ADCS8_LDWWarnState_t;

#  define Rte_TypeDef_ADCS8_LKSSetspeed_t
typedef uint8 ADCS8_LKSSetspeed_t;

#  define Rte_TypeDef_ADCS8_LaneChangeSystemFaultStatus_t
typedef uint8 ADCS8_LaneChangeSystemFaultStatus_t;

#  define Rte_TypeDef_ADCS8_LaneChangeWarning_t
typedef uint8 ADCS8_LaneChangeWarning_t;

#  define Rte_TypeDef_ADCS8_Lanechangedirection_t
typedef uint8 ADCS8_Lanechangedirection_t;

#  define Rte_TypeDef_ADCS8_Lanechangeinfor_t
typedef uint8 ADCS8_Lanechangeinfor_t;

#  define Rte_TypeDef_ADCS8_MissingExitAlert_t
typedef uint8 ADCS8_MissingExitAlert_t;

#  define Rte_TypeDef_ADCS8_Mod_Object_MovingDirection
typedef uint8 ADCS8_Mod_Object_MovingDirection;

#  define Rte_TypeDef_ADCS8_NNPSysState_t
typedef uint8 ADCS8_NNPSysState_t;

#  define Rte_TypeDef_ADCS8_NNP_AutoOnOffSet_t
typedef uint8 ADCS8_NNP_AutoOnOffSet_t;

#  define Rte_TypeDef_ADCS8_NNP_MRM_status_t
typedef uint8 ADCS8_NNP_MRM_status_t;

#  define Rte_TypeDef_ADCS8_NNP_SOAAudioplay_t
typedef boolean ADCS8_NNP_SOAAudioplay_t;

#  define Rte_TypeDef_ADCS8_NNP_Scenarios_t
typedef uint8 ADCS8_NNP_Scenarios_t;

#  define Rte_TypeDef_ADCS8_NNP_State_t
typedef boolean ADCS8_NNP_State_t;

#  define Rte_TypeDef_ADCS8_NNP_SystemFaultStatus_t
typedef uint8 ADCS8_NNP_SystemFaultStatus_t;

#  define Rte_TypeDef_ADCS8_NPilot_SysState
typedef uint8 ADCS8_NPilot_SysState;

#  define Rte_TypeDef_ADCS8_NPilot_SysState_t
typedef uint8 ADCS8_NPilot_SysState_t;

#  define Rte_TypeDef_ADCS8_NPilot_SystemFaultStatus_t
typedef uint8 ADCS8_NPilot_SystemFaultStatus_t;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SensorFaultStsFLC
typedef boolean ADCS8_PA_FPAS_SensorFaultStsFLC;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SensorFaultStsFLC_t
typedef boolean ADCS8_PA_FPAS_SensorFaultStsFLC_t;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SensorFaultStsFLM
typedef boolean ADCS8_PA_FPAS_SensorFaultStsFLM;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SensorFaultStsFLM_t
typedef boolean ADCS8_PA_FPAS_SensorFaultStsFLM_t;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SensorFaultStsFRC
typedef boolean ADCS8_PA_FPAS_SensorFaultStsFRC;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SensorFaultStsFRC_t
typedef boolean ADCS8_PA_FPAS_SensorFaultStsFRC_t;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SensorFaultStsFRM
typedef boolean ADCS8_PA_FPAS_SensorFaultStsFRM;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SensorFaultStsFRM_t
typedef boolean ADCS8_PA_FPAS_SensorFaultStsFRM_t;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SensorFaultStsSFL
typedef boolean ADCS8_PA_FPAS_SensorFaultStsSFL;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SensorFaultStsSFR
typedef boolean ADCS8_PA_FPAS_SensorFaultStsSFR;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrDist_FLC
typedef uint8 ADCS8_PA_FPAS_SnsrDist_FLC;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrDist_FLC_t
typedef uint8 ADCS8_PA_FPAS_SnsrDist_FLC_t;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrDist_FLM
typedef uint8 ADCS8_PA_FPAS_SnsrDist_FLM;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrDist_FLM_t
typedef uint8 ADCS8_PA_FPAS_SnsrDist_FLM_t;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrDist_FRC
typedef uint8 ADCS8_PA_FPAS_SnsrDist_FRC;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrDist_FRC_t
typedef uint8 ADCS8_PA_FPAS_SnsrDist_FRC_t;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrDist_FRM
typedef uint8 ADCS8_PA_FPAS_SnsrDist_FRM;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrDist_FRM_t
typedef uint8 ADCS8_PA_FPAS_SnsrDist_FRM_t;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrDist_RLC
typedef uint8 ADCS8_PA_FPAS_SnsrDist_RLC;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrDist_RLM
typedef uint8 ADCS8_PA_FPAS_SnsrDist_RLM;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrDist_RRC
typedef uint8 ADCS8_PA_FPAS_SnsrDist_RRC;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrDist_RRM
typedef uint8 ADCS8_PA_FPAS_SnsrDist_RRM;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrDist_SFL
typedef uint16 ADCS8_PA_FPAS_SnsrDist_SFL;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrDist_SFR
typedef uint16 ADCS8_PA_FPAS_SnsrDist_SFR;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrDist_SRL
typedef uint16 ADCS8_PA_FPAS_SnsrDist_SRL;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrDist_SRR
typedef uint16 ADCS8_PA_FPAS_SnsrDist_SRR;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrObjWrnngZn_FLC
typedef uint8 ADCS8_PA_FPAS_SnsrObjWrnngZn_FLC;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrObjWrnngZn_FLM
typedef uint8 ADCS8_PA_FPAS_SnsrObjWrnngZn_FLM;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrObjWrnngZn_FRC
typedef uint8 ADCS8_PA_FPAS_SnsrObjWrnngZn_FRC;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrObjWrnngZn_FRM
typedef uint8 ADCS8_PA_FPAS_SnsrObjWrnngZn_FRM;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrObjWrnngZn_LSDW
typedef uint8 ADCS8_PA_FPAS_SnsrObjWrnngZn_LSDW;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrObjWrnngZn_RLC
typedef uint8 ADCS8_PA_FPAS_SnsrObjWrnngZn_RLC;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrObjWrnngZn_RLM
typedef uint8 ADCS8_PA_FPAS_SnsrObjWrnngZn_RLM;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrObjWrnngZn_RRC
typedef uint8 ADCS8_PA_FPAS_SnsrObjWrnngZn_RRC;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrObjWrnngZn_RRM
typedef uint8 ADCS8_PA_FPAS_SnsrObjWrnngZn_RRM;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrObjWrnngZn_RSDW
typedef uint8 ADCS8_PA_FPAS_SnsrObjWrnngZn_RSDW;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrObjWrnngZn_SFL
typedef uint8 ADCS8_PA_FPAS_SnsrObjWrnngZn_SFL;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrObjWrnngZn_SFR
typedef uint8 ADCS8_PA_FPAS_SnsrObjWrnngZn_SFR;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrObjWrnngZn_SRL
typedef uint8 ADCS8_PA_FPAS_SnsrObjWrnngZn_SRL;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrObjWrnngZn_SRR
typedef uint8 ADCS8_PA_FPAS_SnsrObjWrnngZn_SRR;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrObjWrnnglc_LSDW
typedef uint8 ADCS8_PA_FPAS_SnsrObjWrnnglc_LSDW;

#  define Rte_TypeDef_ADCS8_PA_FPAS_SnsrObjWrnnglc_RSDW
typedef uint8 ADCS8_PA_FPAS_SnsrObjWrnnglc_RSDW;

#  define Rte_TypeDef_ADCS8_PA_FPAS_WorkSts
typedef uint8 ADCS8_PA_FPAS_WorkSts;

#  define Rte_TypeDef_ADCS8_PA_RPAS_SensorFaultStsRLC
typedef boolean ADCS8_PA_RPAS_SensorFaultStsRLC;

#  define Rte_TypeDef_ADCS8_PA_RPAS_SensorFaultStsRLM
typedef boolean ADCS8_PA_RPAS_SensorFaultStsRLM;

#  define Rte_TypeDef_ADCS8_PA_RPAS_SensorFaultStsRRC
typedef boolean ADCS8_PA_RPAS_SensorFaultStsRRC;

#  define Rte_TypeDef_ADCS8_PA_RPAS_SensorFaultStsRRM
typedef boolean ADCS8_PA_RPAS_SensorFaultStsRRM;

#  define Rte_TypeDef_ADCS8_PA_RPAS_SensorFaultStsSRL
typedef boolean ADCS8_PA_RPAS_SensorFaultStsSRL;

#  define Rte_TypeDef_ADCS8_PA_RPAS_SensorFaultStsSRR
typedef boolean ADCS8_PA_RPAS_SensorFaultStsSRR;

#  define Rte_TypeDef_ADCS8_PA_RPAS_WorkSts
typedef uint8 ADCS8_PA_RPAS_WorkSts;

#  define Rte_TypeDef_ADCS8_PA_warninginfo
typedef uint8 ADCS8_PA_warninginfo;

#  define Rte_TypeDef_ADCS8_RCTALeftWarnSt_t
typedef uint8 ADCS8_RCTALeftWarnSt_t;

#  define Rte_TypeDef_ADCS8_RCTARightWarnSt_t
typedef uint8 ADCS8_RCTARightWarnSt_t;

#  define Rte_TypeDef_ADCS8_RCTA_State_t
typedef uint8 ADCS8_RCTA_State_t;

#  define Rte_TypeDef_ADCS8_RCTA_SystemFaultStatus_t
typedef uint8 ADCS8_RCTA_SystemFaultStatus_t;

#  define Rte_TypeDef_ADCS8_RCW_State_t
typedef uint8 ADCS8_RCW_State_t;

#  define Rte_TypeDef_ADCS8_RCW_SystemFaultStatus_t
typedef uint8 ADCS8_RCW_SystemFaultStatus_t;

#  define Rte_TypeDef_ADCS8_RCW_WarnState_t
typedef uint8 ADCS8_RCW_WarnState_t;

#  define Rte_TypeDef_ADCS8_RPA_CheckListDispReq1
typedef boolean ADCS8_RPA_CheckListDispReq1;

#  define Rte_TypeDef_ADCS8_RPA_CheckListDispReq2
typedef boolean ADCS8_RPA_CheckListDispReq2;

#  define Rte_TypeDef_ADCS8_RPA_CheckListDispReq3
typedef boolean ADCS8_RPA_CheckListDispReq3;

#  define Rte_TypeDef_ADCS8_RPA_CheckListDispReq4
typedef boolean ADCS8_RPA_CheckListDispReq4;

#  define Rte_TypeDef_ADCS8_RPA_CheckListDispReq5
typedef boolean ADCS8_RPA_CheckListDispReq5;

#  define Rte_TypeDef_ADCS8_RPA_CheckListDispReq6
typedef boolean ADCS8_RPA_CheckListDispReq6;

#  define Rte_TypeDef_ADCS8_RPA_CheckListDispReq7
typedef boolean ADCS8_RPA_CheckListDispReq7;

#  define Rte_TypeDef_ADCS8_RPA_CheckListDispReq8
typedef boolean ADCS8_RPA_CheckListDispReq8;

#  define Rte_TypeDef_ADCS8_SRR_FL_Fail_t
typedef uint8 ADCS8_SRR_FL_Fail_t;

#  define Rte_TypeDef_ADCS8_SRR_FR_Fail_t
typedef uint8 ADCS8_SRR_FR_Fail_t;

#  define Rte_TypeDef_ADCS8_SRR_RL_Fail_t
typedef uint8 ADCS8_SRR_RL_Fail_t;

#  define Rte_TypeDef_ADCS8_SRR_RR_Fail_t
typedef uint8 ADCS8_SRR_RR_Fail_t;

#  define Rte_TypeDef_ADCS8_SVC_FL_Fail_t
typedef uint8 ADCS8_SVC_FL_Fail_t;

#  define Rte_TypeDef_ADCS8_SVC_FR_Fail_t
typedef uint8 ADCS8_SVC_FR_Fail_t;

#  define Rte_TypeDef_ADCS8_SVC_RL_Fail_t
typedef uint8 ADCS8_SVC_RL_Fail_t;

#  define Rte_TypeDef_ADCS8_SVC_RR_Fail_t
typedef uint8 ADCS8_SVC_RR_Fail_t;

#  define Rte_TypeDef_ADCS8_SystemFault_t
typedef uint8 ADCS8_SystemFault_t;

#  define Rte_TypeDef_ADCS8_TBA_text
typedef uint8 ADCS8_TBA_text;

#  define Rte_TypeDef_ADCS8_TSRState_t
typedef uint8 ADCS8_TSRState_t;

#  define Rte_TypeDef_ADCS8_TSR_ForbiddenSign_t
typedef uint8 ADCS8_TSR_ForbiddenSign_t;

#  define Rte_TypeDef_ADCS8_TSR_LeftLightColor_t
typedef uint8 ADCS8_TSR_LeftLightColor_t;

#  define Rte_TypeDef_ADCS8_TSR_OverspeedOnOffSet_t
typedef uint8 ADCS8_TSR_OverspeedOnOffSet_t;

#  define Rte_TypeDef_ADCS8_TSR_RightLightColor_t
typedef uint8 ADCS8_TSR_RightLightColor_t;

#  define Rte_TypeDef_ADCS8_TSR_SLFStatefeedback_t
typedef uint8 ADCS8_TSR_SLFStatefeedback_t;

#  define Rte_TypeDef_ADCS8_TSR_SpeedSign_t
typedef uint8 ADCS8_TSR_SpeedSign_t;

#  define Rte_TypeDef_ADCS8_TSR_SpeedWarnState_t
typedef boolean ADCS8_TSR_SpeedWarnState_t;

#  define Rte_TypeDef_ADCS8_TSR_StrLightColor_t
typedef uint8 ADCS8_TSR_StrLightColor_t;

#  define Rte_TypeDef_ADCS8_TSR_SystemFaultStatus_t
typedef uint8 ADCS8_TSR_SystemFaultStatus_t;

#  define Rte_TypeDef_ADCS8_VoiceMode_t
typedef boolean ADCS8_VoiceMode_t;

#  define Rte_TypeDef_ADCS8_VoiceNotifFrequency_mode_t
typedef uint8 ADCS8_VoiceNotifFrequency_mode_t;

#  define Rte_TypeDef_ADCS8_lateralCtrHandsEyesOffWarning_t
typedef uint8 ADCS8_lateralCtrHandsEyesOffWarning_t;

#  define Rte_TypeDef_ADCS8_lateralCtrtakeover_t
typedef boolean ADCS8_lateralCtrtakeover_t;

#  define Rte_TypeDef_ADCS8_longitudCtrlSetDistance_t
typedef uint8 ADCS8_longitudCtrlSetDistance_t;

#  define Rte_TypeDef_ADCS8_longitudCtrlSetSpeed_t
typedef uint8 ADCS8_longitudCtrlSetSpeed_t;

#  define Rte_TypeDef_ADCS8_longitudCtrlTakeOverReq_t
typedef boolean ADCS8_longitudCtrlTakeOverReq_t;

#  define Rte_TypeDef_ADCS8_longitudCtrlTargetValidity_t
typedef boolean ADCS8_longitudCtrlTargetValidity_t;

#  define Rte_TypeDef_ADCS9_AVMFrontCAMFault
typedef uint8 ADCS9_AVMFrontCAMFault;

#  define Rte_TypeDef_ADCS9_AVMLeftCAMFault
typedef uint8 ADCS9_AVMLeftCAMFault;

#  define Rte_TypeDef_ADCS9_AVMRearCAMFault
typedef uint8 ADCS9_AVMRearCAMFault;

#  define Rte_TypeDef_ADCS9_AVMRightCAMFault
typedef uint8 ADCS9_AVMRightCAMFault;

#  define Rte_TypeDef_ADCS9_AVM_3DRotateSts
typedef boolean ADCS9_AVM_3DRotateSts;

#  define Rte_TypeDef_ADCS9_AVM_Diaphaneity
typedef uint8 ADCS9_AVM_Diaphaneity;

#  define Rte_TypeDef_ADCS9_AVM_InitializationSts
typedef boolean ADCS9_AVM_InitializationSts;

#  define Rte_TypeDef_ADCS9_AVM_LowSpeedBSDSts
typedef boolean ADCS9_AVM_LowSpeedBSDSts;

#  define Rte_TypeDef_ADCS9_AVM_MODdetectionSts
typedef boolean ADCS9_AVM_MODdetectionSts;

#  define Rte_TypeDef_ADCS9_AVM_MagnifiedviewSts
typedef boolean ADCS9_AVM_MagnifiedviewSts;

#  define Rte_TypeDef_ADCS9_AVM_RaderdisplaySts
typedef boolean ADCS9_AVM_RaderdisplaySts;

#  define Rte_TypeDef_ADCS9_AVM_SpeViewSts
typedef uint8 ADCS9_AVM_SpeViewSts;

#  define Rte_TypeDef_ADCS9_AVM_SteeringstartSts
typedef boolean ADCS9_AVM_SteeringstartSts;

#  define Rte_TypeDef_ADCS9_AVM_TransparentchassisSts
typedef boolean ADCS9_AVM_TransparentchassisSts;

#  define Rte_TypeDef_ADCS9_AVM_TurnlightstartSts
typedef boolean ADCS9_AVM_TurnlightstartSts;

#  define Rte_TypeDef_ADCS9_AVM_auxiliarylineSts
typedef boolean ADCS9_AVM_auxiliarylineSts;

#  define Rte_TypeDef_ADCS9_AVM_bodySyncSts
typedef boolean ADCS9_AVM_bodySyncSts;

#  define Rte_TypeDef_ADCS9_AVM_startMode
typedef uint8 ADCS9_AVM_startMode;

#  define Rte_TypeDef_ADCS9_CDCS_CertificateState
typedef boolean ADCS9_CDCS_CertificateState;

#  define Rte_TypeDef_ADCS9_PA_FRS_Onoffset
typedef boolean ADCS9_PA_FRS_Onoffset;

#  define Rte_TypeDef_ADCS_AVM_RCW_warningReq
typedef uint8 ADCS_AVM_RCW_warningReq;

#  define Rte_TypeDef_ADCS_MDC1_FlowReq
typedef uint8 ADCS_MDC1_FlowReq;

#  define Rte_TypeDef_ADCS_MDC1_ThmPostRun
typedef boolean ADCS_MDC1_ThmPostRun;

#  define Rte_TypeDef_ADCS_Pilot_SystemFaultStatus_t
typedef uint8 ADCS_Pilot_SystemFaultStatus_t;

#  define Rte_TypeDef_AICS2_BootRequestHVShut
typedef boolean AICS2_BootRequestHVShut;

#  define Rte_TypeDef_AICS2_OTAMode
typedef uint8 AICS2_OTAMode;

#  define Rte_TypeDef_AICS2_StopChargeing
typedef uint8 AICS2_StopChargeing;

#  define Rte_TypeDef_AlgoCycleCounter_t
typedef uint16 AlgoCycleCounter_t;

#  define Rte_TypeDef_AlgoDataTimeStamp_t
typedef uint32 AlgoDataTimeStamp_t;

#  define Rte_TypeDef_AlgoInterfaceVersionNumber_t
typedef uint32 AlgoInterfaceVersionNumber_t;

#  define Rte_TypeDef_AlgoSignalState_t
typedef uint8 AlgoSignalState_t;

#  define Rte_TypeDef_BDCS10_AC_OutsideTemp
typedef uint8 BDCS10_AC_OutsideTemp;

#  define Rte_TypeDef_BDCS10_AC_OutsideTempValid
typedef boolean BDCS10_AC_OutsideTempValid;

#  define Rte_TypeDef_BDCS10_AC_OutsideTempValid_t
typedef boolean BDCS10_AC_OutsideTempValid_t;

#  define Rte_TypeDef_BDCS10_AC_OutsideTemp_t
typedef float32 BDCS10_AC_OutsideTemp_t;

#  define Rte_TypeDef_BDCS13_RLS_RQ_WiperSPD
typedef uint8 BDCS13_RLS_RQ_WiperSPD;

#  define Rte_TypeDef_BDCS1_BacklightStatus
typedef boolean BDCS1_BacklightStatus;

#  define Rte_TypeDef_BDCS1_Checksum
typedef uint8 BDCS1_Checksum;

#  define Rte_TypeDef_BDCS1_FrontFogLampSt
typedef boolean BDCS1_FrontFogLampSt;

#  define Rte_TypeDef_BDCS1_FrontFogLampSt_t
typedef boolean BDCS1_FrontFogLampSt_t;

#  define Rte_TypeDef_BDCS1_FrontLampSt
typedef uint8 BDCS1_FrontLampSt;

#  define Rte_TypeDef_BDCS1_FrontLampSt_t
typedef uint8 BDCS1_FrontLampSt_t;

#  define Rte_TypeDef_BDCS1_HazardLampSt
typedef boolean BDCS1_HazardLampSt;

#  define Rte_TypeDef_BDCS1_HazardLampSt_t
typedef boolean BDCS1_HazardLampSt_t;

#  define Rte_TypeDef_BDCS1_HazardSwSt
typedef boolean BDCS1_HazardSwSt;

#  define Rte_TypeDef_BDCS1_HighBeamSW
typedef uint8 BDCS1_HighBeamSW;

#  define Rte_TypeDef_BDCS1_HighBeamSt
typedef boolean BDCS1_HighBeamSt;

#  define Rte_TypeDef_BDCS1_HighBeamSt_t
typedef boolean BDCS1_HighBeamSt_t;

#  define Rte_TypeDef_BDCS1_HoodAjarSts
typedef boolean BDCS1_HoodAjarSts;

#  define Rte_TypeDef_BDCS1_HoodAjarSts_t
typedef boolean BDCS1_HoodAjarSts_t;

#  define Rte_TypeDef_BDCS1_LeftTurnLightSt
typedef boolean BDCS1_LeftTurnLightSt;

#  define Rte_TypeDef_BDCS1_LeftTurnLightSt_t
typedef boolean BDCS1_LeftTurnLightSt_t;

#  define Rte_TypeDef_BDCS1_LowBeamSt
typedef boolean BDCS1_LowBeamSt;

#  define Rte_TypeDef_BDCS1_LowBeamSt_t
typedef boolean BDCS1_LowBeamSt_t;

#  define Rte_TypeDef_BDCS1_MsgCounter
typedef uint8 BDCS1_MsgCounter;

#  define Rte_TypeDef_BDCS1_PositionLightSts
typedef boolean BDCS1_PositionLightSts;

#  define Rte_TypeDef_BDCS1_PowerManageMode
typedef uint8 BDCS1_PowerManageMode;

#  define Rte_TypeDef_BDCS1_PowerMode
typedef uint8 BDCS1_PowerMode;

#  define Rte_TypeDef_BDCS1_PowerMode_t
typedef uint8 BDCS1_PowerMode_t;

#  define Rte_TypeDef_BDCS1_RearFogLampSt
typedef boolean BDCS1_RearFogLampSt;

#  define Rte_TypeDef_BDCS1_RearFogLampSt_t
typedef boolean BDCS1_RearFogLampSt_t;

#  define Rte_TypeDef_BDCS1_RightTurnLightSt
typedef boolean BDCS1_RightTurnLightSt;

#  define Rte_TypeDef_BDCS1_RightTurnLightSt_t
typedef boolean BDCS1_RightTurnLightSt_t;

#  define Rte_TypeDef_BDCS1_TrunkLockSts
typedef boolean BDCS1_TrunkLockSts;

#  define Rte_TypeDef_BDCS1_TrunkLockSts_t
typedef boolean BDCS1_TrunkLockSts_t;

#  define Rte_TypeDef_BDCS1_TurnLightSW
typedef uint8 BDCS1_TurnLightSW;

#  define Rte_TypeDef_BDCS3_ADCSAuthenSts
typedef uint8 BDCS3_ADCSAuthenSts;

#  define Rte_TypeDef_BDCS3_BackDoorAjar
typedef uint8 BDCS3_BackDoorAjar;

#  define Rte_TypeDef_BDCS3_RemoteAuthenSts
typedef uint8 BDCS3_RemoteAuthenSts;

#  define Rte_TypeDef_BDCS4_FLTyre_LearntSt
typedef boolean BDCS4_FLTyre_LearntSt;

#  define Rte_TypeDef_BDCS4_FLTyre_LowBattery
typedef boolean BDCS4_FLTyre_LowBattery;

#  define Rte_TypeDef_BDCS4_FLTyre_Pressure
typedef uint8 BDCS4_FLTyre_Pressure;

#  define Rte_TypeDef_BDCS4_FLTyre_PressureWarn
typedef uint8 BDCS4_FLTyre_PressureWarn;

#  define Rte_TypeDef_BDCS4_FLTyre_QucikLeak
typedef boolean BDCS4_FLTyre_QucikLeak;

#  define Rte_TypeDef_BDCS4_FLTyre_SensorFailure
typedef boolean BDCS4_FLTyre_SensorFailure;

#  define Rte_TypeDef_BDCS4_FLTyre_Temperature
typedef uint8 BDCS4_FLTyre_Temperature;

#  define Rte_TypeDef_BDCS4_FLTyre_TemperatureWarn
typedef boolean BDCS4_FLTyre_TemperatureWarn;

#  define Rte_TypeDef_BDCS4_FRTyre_LearntSt
typedef boolean BDCS4_FRTyre_LearntSt;

#  define Rte_TypeDef_BDCS4_FRTyre_LowBattery
typedef boolean BDCS4_FRTyre_LowBattery;

#  define Rte_TypeDef_BDCS4_FRTyre_Pressure
typedef uint8 BDCS4_FRTyre_Pressure;

#  define Rte_TypeDef_BDCS4_FRTyre_PressureWarn
typedef uint8 BDCS4_FRTyre_PressureWarn;

#  define Rte_TypeDef_BDCS4_FRTyre_QucikLeak
typedef boolean BDCS4_FRTyre_QucikLeak;

#  define Rte_TypeDef_BDCS4_FRTyre_SensorFailure
typedef boolean BDCS4_FRTyre_SensorFailure;

#  define Rte_TypeDef_BDCS4_FRTyre_Temperature
typedef uint8 BDCS4_FRTyre_Temperature;

#  define Rte_TypeDef_BDCS4_FRTyre_TemperatureWarn
typedef boolean BDCS4_FRTyre_TemperatureWarn;

#  define Rte_TypeDef_BDCS4_Ftyre_Status
typedef boolean BDCS4_Ftyre_Status;

#  define Rte_TypeDef_BDCS4_SystemFailure
typedef uint8 BDCS4_SystemFailure;

#  define Rte_TypeDef_BDCS4_Testmode
typedef boolean BDCS4_Testmode;

#  define Rte_TypeDef_BDCS5_RLTyre_LearntSt
typedef boolean BDCS5_RLTyre_LearntSt;

#  define Rte_TypeDef_BDCS5_RLTyre_LowBattery
typedef boolean BDCS5_RLTyre_LowBattery;

#  define Rte_TypeDef_BDCS5_RLTyre_Pressure
typedef uint8 BDCS5_RLTyre_Pressure;

#  define Rte_TypeDef_BDCS5_RLTyre_PressureWarn
typedef uint8 BDCS5_RLTyre_PressureWarn;

#  define Rte_TypeDef_BDCS5_RLTyre_QucikLeak
typedef boolean BDCS5_RLTyre_QucikLeak;

#  define Rte_TypeDef_BDCS5_RLTyre_SensorFailure
typedef boolean BDCS5_RLTyre_SensorFailure;

#  define Rte_TypeDef_BDCS5_RLTyre_Temperature
typedef uint8 BDCS5_RLTyre_Temperature;

#  define Rte_TypeDef_BDCS5_RLTyre_TemperatureWarn
typedef boolean BDCS5_RLTyre_TemperatureWarn;

#  define Rte_TypeDef_BDCS5_RRTyre_LearntSt
typedef boolean BDCS5_RRTyre_LearntSt;

#  define Rte_TypeDef_BDCS5_RRTyre_LowBattery
typedef boolean BDCS5_RRTyre_LowBattery;

#  define Rte_TypeDef_BDCS5_RRTyre_Pressure
typedef uint8 BDCS5_RRTyre_Pressure;

#  define Rte_TypeDef_BDCS5_RRTyre_PressureWarn
typedef uint8 BDCS5_RRTyre_PressureWarn;

#  define Rte_TypeDef_BDCS5_RRTyre_QucikLeak
typedef boolean BDCS5_RRTyre_QucikLeak;

#  define Rte_TypeDef_BDCS5_RRTyre_SensorFailure
typedef boolean BDCS5_RRTyre_SensorFailure;

#  define Rte_TypeDef_BDCS5_RRTyre_Temperature
typedef uint8 BDCS5_RRTyre_Temperature;

#  define Rte_TypeDef_BDCS5_RRTyre_TemperatureWarn
typedef boolean BDCS5_RRTyre_TemperatureWarn;

#  define Rte_TypeDef_BDCS5_Rtyre_Status
typedef boolean BDCS5_Rtyre_Status;

#  define Rte_TypeDef_BDCS6_DayNightMode_t
typedef uint8 BDCS6_DayNightMode_t;

#  define Rte_TypeDef_BDCS6_FrontWiperParkPos
typedef boolean BDCS6_FrontWiperParkPos;

#  define Rte_TypeDef_BDCS6_FrontWiperSts
typedef uint8 BDCS6_FrontWiperSts;

#  define Rte_TypeDef_BDM_Chall_ADCS_Random_0
typedef uint8 BDM_Chall_ADCS_Random_0;

#  define Rte_TypeDef_BDM_Chall_ADCS_Random_1
typedef uint8 BDM_Chall_ADCS_Random_1;

#  define Rte_TypeDef_BDM_Chall_ADCS_Random_2
typedef uint8 BDM_Chall_ADCS_Random_2;

#  define Rte_TypeDef_BDM_Chall_ADCS_Random_3
typedef uint8 BDM_Chall_ADCS_Random_3;

#  define Rte_TypeDef_BDM_Chall_ADCS_Random_4
typedef uint8 BDM_Chall_ADCS_Random_4;

#  define Rte_TypeDef_BDM_Chall_ADCS_Random_5
typedef uint8 BDM_Chall_ADCS_Random_5;

#  define Rte_TypeDef_BDM_Chall_ADCS_Random_6
typedef uint8 BDM_Chall_ADCS_Random_6;

#  define Rte_TypeDef_BDM_Chall_ADCS_Random_7
typedef uint8 BDM_Chall_ADCS_Random_7;

#  define Rte_TypeDef_BMS3_Charge_State
typedef uint8 BMS3_Charge_State;

#  define Rte_TypeDef_BMS3_StateOfCharge
typedef uint16 BMS3_StateOfCharge;

#  define Rte_TypeDef_BTM1_Checksum
typedef uint8 BTM1_Checksum;

#  define Rte_TypeDef_BTM1_Fixslot
typedef uint8 BTM1_Fixslot;

#  define Rte_TypeDef_BTM1_FunctionMode
typedef uint8 BTM1_FunctionMode;

#  define Rte_TypeDef_BTM1_Movectrl
typedef uint8 BTM1_Movectrl;

#  define Rte_TypeDef_BTM1_OptionalSlotAngle
typedef uint16 BTM1_OptionalSlotAngle;

#  define Rte_TypeDef_BTM1_OptionalSlotCoor_P0_X
typedef uint16 BTM1_OptionalSlotCoor_P0_X;

#  define Rte_TypeDef_BTM1_OptionalSlotCoor_P0_Y
typedef uint16 BTM1_OptionalSlotCoor_P0_Y;

#  define Rte_TypeDef_BTM1_OptionalSlotCoor_P1_X
typedef uint16 BTM1_OptionalSlotCoor_P1_X;

#  define Rte_TypeDef_BTM1_OptionalSlotCoor_P1_Y
typedef uint16 BTM1_OptionalSlotCoor_P1_Y;

#  define Rte_TypeDef_BTM1_OptionalSlotCoor_P2_X
typedef uint16 BTM1_OptionalSlotCoor_P2_X;

#  define Rte_TypeDef_BTM1_OptionalSlotCoor_P2_Y
typedef uint16 BTM1_OptionalSlotCoor_P2_Y;

#  define Rte_TypeDef_BTM1_OptionalSlotCoor_P3_X
typedef uint16 BTM1_OptionalSlotCoor_P3_X;

#  define Rte_TypeDef_BTM1_OptionalSlotCoor_P3_Y
typedef uint16 BTM1_OptionalSlotCoor_P3_Y;

#  define Rte_TypeDef_BTM1_OptionalSlotType
typedef uint8 BTM1_OptionalSlotType;

#  define Rte_TypeDef_BTM1_OptionalSlot_Dire
typedef uint8 BTM1_OptionalSlot_Dire;

#  define Rte_TypeDef_BTM1_ParkingReq
typedef uint8 BTM1_ParkingReq;

#  define Rte_TypeDef_BTM1_PhoneBatSts
typedef boolean BTM1_PhoneBatSts;

#  define Rte_TypeDef_BTM1_Recover
typedef boolean BTM1_Recover;

#  define Rte_TypeDef_BTM1_RemoteIntModSel
typedef uint8 BTM1_RemoteIntModSel;

#  define Rte_TypeDef_BTM1_RemoteParkReq
typedef uint8 BTM1_RemoteParkReq;

#  define Rte_TypeDef_BTM1_Retry
typedef uint8 BTM1_Retry;

#  define Rte_TypeDef_BTM1_RollingCounter
typedef uint8 BTM1_RollingCounter;

#  define Rte_TypeDef_BTM1_SecuritySts
typedef uint8 BTM1_SecuritySts;

#  define Rte_TypeDef_BTM1_SelectSlotID
typedef uint8 BTM1_SelectSlotID;

#  define Rte_TypeDef_BTM1_parkingoutSlotType
typedef uint8 BTM1_parkingoutSlotType;

#  define Rte_TypeDef_BTM1_parkingoutSlot_Dire
typedef uint8 BTM1_parkingoutSlot_Dire;

#  define Rte_TypeDef_BTM2_ConnectSts
typedef uint8 BTM2_ConnectSts;

#  define Rte_TypeDef_BTM2_Key_Position
typedef uint8 BTM2_Key_Position;

#  define Rte_TypeDef_BTM3_RKECmd
typedef uint8 BTM3_RKECmd;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_0_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_0_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_100_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_100_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_101_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_101_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_102_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_102_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_103_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_103_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_104_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_104_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_105_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_105_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_106_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_106_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_107_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_107_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_108_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_108_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_109_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_109_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_10_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_10_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_110_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_110_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_111_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_111_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_112_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_112_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_113_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_113_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_114_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_114_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_115_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_115_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_116_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_116_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_117_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_117_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_118_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_118_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_119_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_119_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_11_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_11_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_120_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_120_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_121_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_121_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_122_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_122_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_123_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_123_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_124_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_124_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_125_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_125_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_126_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_126_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_127_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_127_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_12_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_12_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_13_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_13_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_14_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_14_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_15_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_15_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_16_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_16_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_17_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_17_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_18_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_18_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_19_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_19_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_1_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_1_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_20_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_20_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_21_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_21_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_22_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_22_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_23_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_23_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_24_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_24_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_25_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_25_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_26_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_26_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_27_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_27_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_28_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_28_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_29_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_29_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_2_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_2_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_30_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_30_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_31_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_31_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_32_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_32_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_33_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_33_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_34_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_34_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_35_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_35_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_36_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_36_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_37_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_37_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_38_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_38_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_39_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_39_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_3_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_3_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_40_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_40_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_41_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_41_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_42_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_42_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_43_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_43_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_44_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_44_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_45_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_45_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_46_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_46_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_47_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_47_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_48_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_48_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_49_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_49_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_4_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_4_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_50_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_50_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_51_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_51_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_52_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_52_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_53_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_53_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_54_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_54_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_55_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_55_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_56_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_56_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_57_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_57_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_58_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_58_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_59_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_59_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_5_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_5_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_60_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_60_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_61_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_61_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_62_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_62_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_63_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_63_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_64_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_64_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_65_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_65_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_66_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_66_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_67_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_67_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_68_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_68_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_69_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_69_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_6_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_6_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_70_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_70_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_71_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_71_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_72_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_72_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_73_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_73_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_74_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_74_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_75_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_75_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_76_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_76_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_77_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_77_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_78_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_78_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_79_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_79_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_7_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_7_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_80_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_80_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_81_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_81_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_82_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_82_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_83_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_83_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_84_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_84_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_85_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_85_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_86_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_86_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_87_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_87_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_88_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_88_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_89_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_89_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_8_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_8_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_90_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_90_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_91_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_91_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_92_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_92_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_93_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_93_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_94_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_94_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_95_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_95_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_96_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_96_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_97_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_97_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_98_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_98_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_99_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_99_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LAT_9_t
typedef float32 CAN_TX_OBJ_ACC_REL_LAT_9_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_0_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_0_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_100_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_100_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_101_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_101_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_102_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_102_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_103_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_103_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_104_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_104_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_105_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_105_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_106_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_106_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_107_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_107_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_108_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_108_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_109_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_109_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_10_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_10_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_110_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_110_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_111_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_111_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_112_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_112_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_113_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_113_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_114_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_114_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_115_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_115_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_116_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_116_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_117_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_117_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_118_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_118_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_119_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_119_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_11_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_11_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_120_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_120_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_121_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_121_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_122_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_122_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_123_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_123_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_124_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_124_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_125_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_125_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_126_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_126_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_127_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_127_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_12_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_12_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_13_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_13_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_14_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_14_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_15_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_15_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_16_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_16_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_17_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_17_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_18_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_18_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_19_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_19_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_1_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_1_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_20_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_20_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_21_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_21_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_22_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_22_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_23_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_23_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_24_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_24_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_25_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_25_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_26_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_26_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_27_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_27_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_28_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_28_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_29_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_29_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_2_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_2_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_30_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_30_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_31_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_31_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_32_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_32_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_33_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_33_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_34_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_34_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_35_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_35_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_36_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_36_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_37_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_37_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_38_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_38_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_39_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_39_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_3_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_3_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_40_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_40_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_41_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_41_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_42_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_42_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_43_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_43_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_44_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_44_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_45_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_45_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_46_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_46_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_47_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_47_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_48_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_48_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_49_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_49_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_4_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_4_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_50_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_50_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_51_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_51_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_52_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_52_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_53_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_53_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_54_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_54_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_55_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_55_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_56_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_56_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_57_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_57_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_58_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_58_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_59_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_59_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_5_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_5_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_60_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_60_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_61_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_61_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_62_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_62_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_63_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_63_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_64_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_64_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_65_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_65_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_66_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_66_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_67_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_67_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_68_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_68_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_69_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_69_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_6_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_6_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_70_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_70_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_71_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_71_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_72_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_72_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_73_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_73_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_74_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_74_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_75_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_75_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_76_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_76_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_77_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_77_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_78_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_78_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_79_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_79_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_7_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_7_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_80_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_80_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_81_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_81_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_82_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_82_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_83_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_83_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_84_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_84_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_85_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_85_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_86_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_86_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_87_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_87_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_88_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_88_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_89_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_89_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_8_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_8_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_90_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_90_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_91_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_91_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_92_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_92_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_93_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_93_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_94_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_94_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_95_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_95_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_96_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_96_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_97_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_97_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_98_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_98_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_99_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_99_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ACC_REL_LONG_9_t
typedef float32 CAN_TX_OBJ_ACC_REL_LONG_9_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_0_t
typedef uint8 CAN_TX_OBJ_CLASS_0_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_100_t
typedef uint8 CAN_TX_OBJ_CLASS_100_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_101_t
typedef uint8 CAN_TX_OBJ_CLASS_101_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_102_t
typedef uint8 CAN_TX_OBJ_CLASS_102_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_103_t
typedef uint8 CAN_TX_OBJ_CLASS_103_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_104_t
typedef uint8 CAN_TX_OBJ_CLASS_104_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_105_t
typedef uint8 CAN_TX_OBJ_CLASS_105_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_106_t
typedef uint8 CAN_TX_OBJ_CLASS_106_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_107_t
typedef uint8 CAN_TX_OBJ_CLASS_107_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_108_t
typedef uint8 CAN_TX_OBJ_CLASS_108_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_109_t
typedef uint8 CAN_TX_OBJ_CLASS_109_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_10_t
typedef uint8 CAN_TX_OBJ_CLASS_10_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_110_t
typedef uint8 CAN_TX_OBJ_CLASS_110_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_111_t
typedef uint8 CAN_TX_OBJ_CLASS_111_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_112_t
typedef uint8 CAN_TX_OBJ_CLASS_112_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_113_t
typedef uint8 CAN_TX_OBJ_CLASS_113_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_114_t
typedef uint8 CAN_TX_OBJ_CLASS_114_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_115_t
typedef uint8 CAN_TX_OBJ_CLASS_115_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_116_t
typedef uint8 CAN_TX_OBJ_CLASS_116_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_117_t
typedef uint8 CAN_TX_OBJ_CLASS_117_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_118_t
typedef uint8 CAN_TX_OBJ_CLASS_118_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_119_t
typedef uint8 CAN_TX_OBJ_CLASS_119_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_11_t
typedef uint8 CAN_TX_OBJ_CLASS_11_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_120_t
typedef uint8 CAN_TX_OBJ_CLASS_120_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_121_t
typedef uint8 CAN_TX_OBJ_CLASS_121_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_122_t
typedef uint8 CAN_TX_OBJ_CLASS_122_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_123_t
typedef uint8 CAN_TX_OBJ_CLASS_123_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_124_t
typedef uint8 CAN_TX_OBJ_CLASS_124_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_125_t
typedef uint8 CAN_TX_OBJ_CLASS_125_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_126_t
typedef uint8 CAN_TX_OBJ_CLASS_126_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_127_t
typedef uint8 CAN_TX_OBJ_CLASS_127_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_12_t
typedef uint8 CAN_TX_OBJ_CLASS_12_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_13_t
typedef uint8 CAN_TX_OBJ_CLASS_13_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_14_t
typedef uint8 CAN_TX_OBJ_CLASS_14_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_15_t
typedef uint8 CAN_TX_OBJ_CLASS_15_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_16_t
typedef uint8 CAN_TX_OBJ_CLASS_16_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_17_t
typedef uint8 CAN_TX_OBJ_CLASS_17_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_18_t
typedef uint8 CAN_TX_OBJ_CLASS_18_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_19_t
typedef uint8 CAN_TX_OBJ_CLASS_19_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_1_t
typedef uint8 CAN_TX_OBJ_CLASS_1_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_20_t
typedef uint8 CAN_TX_OBJ_CLASS_20_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_21_t
typedef uint8 CAN_TX_OBJ_CLASS_21_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_22_t
typedef uint8 CAN_TX_OBJ_CLASS_22_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_23_t
typedef uint8 CAN_TX_OBJ_CLASS_23_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_24_t
typedef uint8 CAN_TX_OBJ_CLASS_24_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_25_t
typedef uint8 CAN_TX_OBJ_CLASS_25_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_26_t
typedef uint8 CAN_TX_OBJ_CLASS_26_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_27_t
typedef uint8 CAN_TX_OBJ_CLASS_27_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_28_t
typedef uint8 CAN_TX_OBJ_CLASS_28_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_29_t
typedef uint8 CAN_TX_OBJ_CLASS_29_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_2_t
typedef uint8 CAN_TX_OBJ_CLASS_2_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_30_t
typedef uint8 CAN_TX_OBJ_CLASS_30_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_31_t
typedef uint8 CAN_TX_OBJ_CLASS_31_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_32_t
typedef uint8 CAN_TX_OBJ_CLASS_32_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_33_t
typedef uint8 CAN_TX_OBJ_CLASS_33_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_34_t
typedef uint8 CAN_TX_OBJ_CLASS_34_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_35_t
typedef uint8 CAN_TX_OBJ_CLASS_35_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_36_t
typedef uint8 CAN_TX_OBJ_CLASS_36_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_37_t
typedef uint8 CAN_TX_OBJ_CLASS_37_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_38_t
typedef uint8 CAN_TX_OBJ_CLASS_38_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_39_t
typedef uint8 CAN_TX_OBJ_CLASS_39_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_3_t
typedef uint8 CAN_TX_OBJ_CLASS_3_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_40_t
typedef uint8 CAN_TX_OBJ_CLASS_40_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_41_t
typedef uint8 CAN_TX_OBJ_CLASS_41_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_42_t
typedef uint8 CAN_TX_OBJ_CLASS_42_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_43_t
typedef uint8 CAN_TX_OBJ_CLASS_43_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_44_t
typedef uint8 CAN_TX_OBJ_CLASS_44_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_45_t
typedef uint8 CAN_TX_OBJ_CLASS_45_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_46_t
typedef uint8 CAN_TX_OBJ_CLASS_46_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_47_t
typedef uint8 CAN_TX_OBJ_CLASS_47_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_48_t
typedef uint8 CAN_TX_OBJ_CLASS_48_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_49_t
typedef uint8 CAN_TX_OBJ_CLASS_49_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_4_t
typedef uint8 CAN_TX_OBJ_CLASS_4_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_50_t
typedef uint8 CAN_TX_OBJ_CLASS_50_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_51_t
typedef uint8 CAN_TX_OBJ_CLASS_51_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_52_t
typedef uint8 CAN_TX_OBJ_CLASS_52_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_53_t
typedef uint8 CAN_TX_OBJ_CLASS_53_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_54_t
typedef uint8 CAN_TX_OBJ_CLASS_54_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_55_t
typedef uint8 CAN_TX_OBJ_CLASS_55_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_56_t
typedef uint8 CAN_TX_OBJ_CLASS_56_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_57_t
typedef uint8 CAN_TX_OBJ_CLASS_57_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_58_t
typedef uint8 CAN_TX_OBJ_CLASS_58_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_59_t
typedef uint8 CAN_TX_OBJ_CLASS_59_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_5_t
typedef uint8 CAN_TX_OBJ_CLASS_5_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_60_t
typedef uint8 CAN_TX_OBJ_CLASS_60_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_61_t
typedef uint8 CAN_TX_OBJ_CLASS_61_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_62_t
typedef uint8 CAN_TX_OBJ_CLASS_62_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_63_t
typedef uint8 CAN_TX_OBJ_CLASS_63_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_64_t
typedef uint8 CAN_TX_OBJ_CLASS_64_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_65_t
typedef uint8 CAN_TX_OBJ_CLASS_65_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_66_t
typedef uint8 CAN_TX_OBJ_CLASS_66_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_67_t
typedef uint8 CAN_TX_OBJ_CLASS_67_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_68_t
typedef uint8 CAN_TX_OBJ_CLASS_68_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_69_t
typedef uint8 CAN_TX_OBJ_CLASS_69_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_6_t
typedef uint8 CAN_TX_OBJ_CLASS_6_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_70_t
typedef uint8 CAN_TX_OBJ_CLASS_70_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_71_t
typedef uint8 CAN_TX_OBJ_CLASS_71_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_72_t
typedef uint8 CAN_TX_OBJ_CLASS_72_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_73_t
typedef uint8 CAN_TX_OBJ_CLASS_73_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_74_t
typedef uint8 CAN_TX_OBJ_CLASS_74_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_75_t
typedef uint8 CAN_TX_OBJ_CLASS_75_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_76_t
typedef uint8 CAN_TX_OBJ_CLASS_76_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_77_t
typedef uint8 CAN_TX_OBJ_CLASS_77_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_78_t
typedef uint8 CAN_TX_OBJ_CLASS_78_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_79_t
typedef uint8 CAN_TX_OBJ_CLASS_79_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_7_t
typedef uint8 CAN_TX_OBJ_CLASS_7_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_80_t
typedef uint8 CAN_TX_OBJ_CLASS_80_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_81_t
typedef uint8 CAN_TX_OBJ_CLASS_81_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_82_t
typedef uint8 CAN_TX_OBJ_CLASS_82_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_83_t
typedef uint8 CAN_TX_OBJ_CLASS_83_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_84_t
typedef uint8 CAN_TX_OBJ_CLASS_84_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_85_t
typedef uint8 CAN_TX_OBJ_CLASS_85_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_86_t
typedef uint8 CAN_TX_OBJ_CLASS_86_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_87_t
typedef uint8 CAN_TX_OBJ_CLASS_87_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_88_t
typedef uint8 CAN_TX_OBJ_CLASS_88_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_89_t
typedef uint8 CAN_TX_OBJ_CLASS_89_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_8_t
typedef uint8 CAN_TX_OBJ_CLASS_8_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_90_t
typedef uint8 CAN_TX_OBJ_CLASS_90_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_91_t
typedef uint8 CAN_TX_OBJ_CLASS_91_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_92_t
typedef uint8 CAN_TX_OBJ_CLASS_92_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_93_t
typedef uint8 CAN_TX_OBJ_CLASS_93_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_94_t
typedef uint8 CAN_TX_OBJ_CLASS_94_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_95_t
typedef uint8 CAN_TX_OBJ_CLASS_95_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_96_t
typedef uint8 CAN_TX_OBJ_CLASS_96_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_97_t
typedef uint8 CAN_TX_OBJ_CLASS_97_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_98_t
typedef uint8 CAN_TX_OBJ_CLASS_98_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_99_t
typedef uint8 CAN_TX_OBJ_CLASS_99_t;

#  define Rte_TypeDef_CAN_TX_OBJ_CLASS_9_t
typedef uint8 CAN_TX_OBJ_CLASS_9_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_0_t
typedef float32 CAN_TX_OBJ_HEADING_0_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_100_t
typedef float32 CAN_TX_OBJ_HEADING_100_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_101_t
typedef float32 CAN_TX_OBJ_HEADING_101_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_102_t
typedef float32 CAN_TX_OBJ_HEADING_102_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_103_t
typedef float32 CAN_TX_OBJ_HEADING_103_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_104_t
typedef float32 CAN_TX_OBJ_HEADING_104_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_105_t
typedef float32 CAN_TX_OBJ_HEADING_105_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_106_t
typedef float32 CAN_TX_OBJ_HEADING_106_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_107_t
typedef float32 CAN_TX_OBJ_HEADING_107_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_108_t
typedef float32 CAN_TX_OBJ_HEADING_108_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_109_t
typedef float32 CAN_TX_OBJ_HEADING_109_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_10_t
typedef float32 CAN_TX_OBJ_HEADING_10_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_110_t
typedef float32 CAN_TX_OBJ_HEADING_110_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_111_t
typedef float32 CAN_TX_OBJ_HEADING_111_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_112_t
typedef float32 CAN_TX_OBJ_HEADING_112_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_113_t
typedef float32 CAN_TX_OBJ_HEADING_113_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_114_t
typedef float32 CAN_TX_OBJ_HEADING_114_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_115_t
typedef float32 CAN_TX_OBJ_HEADING_115_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_116_t
typedef float32 CAN_TX_OBJ_HEADING_116_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_117_t
typedef float32 CAN_TX_OBJ_HEADING_117_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_118_t
typedef float32 CAN_TX_OBJ_HEADING_118_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_119_t
typedef float32 CAN_TX_OBJ_HEADING_119_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_11_t
typedef float32 CAN_TX_OBJ_HEADING_11_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_120_t
typedef float32 CAN_TX_OBJ_HEADING_120_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_121_t
typedef float32 CAN_TX_OBJ_HEADING_121_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_122_t
typedef float32 CAN_TX_OBJ_HEADING_122_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_123_t
typedef float32 CAN_TX_OBJ_HEADING_123_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_124_t
typedef float32 CAN_TX_OBJ_HEADING_124_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_125_t
typedef float32 CAN_TX_OBJ_HEADING_125_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_126_t
typedef float32 CAN_TX_OBJ_HEADING_126_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_127_t
typedef float32 CAN_TX_OBJ_HEADING_127_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_12_t
typedef float32 CAN_TX_OBJ_HEADING_12_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_13_t
typedef float32 CAN_TX_OBJ_HEADING_13_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_14_t
typedef float32 CAN_TX_OBJ_HEADING_14_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_15_t
typedef float32 CAN_TX_OBJ_HEADING_15_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_16_t
typedef float32 CAN_TX_OBJ_HEADING_16_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_17_t
typedef float32 CAN_TX_OBJ_HEADING_17_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_18_t
typedef float32 CAN_TX_OBJ_HEADING_18_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_19_t
typedef float32 CAN_TX_OBJ_HEADING_19_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_1_t
typedef float32 CAN_TX_OBJ_HEADING_1_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_20_t
typedef float32 CAN_TX_OBJ_HEADING_20_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_21_t
typedef float32 CAN_TX_OBJ_HEADING_21_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_22_t
typedef float32 CAN_TX_OBJ_HEADING_22_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_23_t
typedef float32 CAN_TX_OBJ_HEADING_23_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_24_t
typedef float32 CAN_TX_OBJ_HEADING_24_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_25_t
typedef float32 CAN_TX_OBJ_HEADING_25_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_26_t
typedef float32 CAN_TX_OBJ_HEADING_26_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_27_t
typedef float32 CAN_TX_OBJ_HEADING_27_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_28_t
typedef float32 CAN_TX_OBJ_HEADING_28_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_29_t
typedef float32 CAN_TX_OBJ_HEADING_29_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_2_t
typedef float32 CAN_TX_OBJ_HEADING_2_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_30_t
typedef float32 CAN_TX_OBJ_HEADING_30_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_31_t
typedef float32 CAN_TX_OBJ_HEADING_31_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_32_t
typedef float32 CAN_TX_OBJ_HEADING_32_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_33_t
typedef float32 CAN_TX_OBJ_HEADING_33_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_34_t
typedef float32 CAN_TX_OBJ_HEADING_34_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_35_t
typedef float32 CAN_TX_OBJ_HEADING_35_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_36_t
typedef float32 CAN_TX_OBJ_HEADING_36_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_37_t
typedef float32 CAN_TX_OBJ_HEADING_37_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_38_t
typedef float32 CAN_TX_OBJ_HEADING_38_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_39_t
typedef float32 CAN_TX_OBJ_HEADING_39_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_3_t
typedef float32 CAN_TX_OBJ_HEADING_3_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_40_t
typedef float32 CAN_TX_OBJ_HEADING_40_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_41_t
typedef float32 CAN_TX_OBJ_HEADING_41_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_42_t
typedef float32 CAN_TX_OBJ_HEADING_42_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_43_t
typedef float32 CAN_TX_OBJ_HEADING_43_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_44_t
typedef float32 CAN_TX_OBJ_HEADING_44_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_45_t
typedef float32 CAN_TX_OBJ_HEADING_45_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_46_t
typedef float32 CAN_TX_OBJ_HEADING_46_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_47_t
typedef float32 CAN_TX_OBJ_HEADING_47_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_48_t
typedef float32 CAN_TX_OBJ_HEADING_48_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_49_t
typedef float32 CAN_TX_OBJ_HEADING_49_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_4_t
typedef float32 CAN_TX_OBJ_HEADING_4_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_50_t
typedef float32 CAN_TX_OBJ_HEADING_50_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_51_t
typedef float32 CAN_TX_OBJ_HEADING_51_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_52_t
typedef float32 CAN_TX_OBJ_HEADING_52_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_53_t
typedef float32 CAN_TX_OBJ_HEADING_53_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_54_t
typedef float32 CAN_TX_OBJ_HEADING_54_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_55_t
typedef float32 CAN_TX_OBJ_HEADING_55_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_56_t
typedef float32 CAN_TX_OBJ_HEADING_56_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_57_t
typedef float32 CAN_TX_OBJ_HEADING_57_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_58_t
typedef float32 CAN_TX_OBJ_HEADING_58_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_59_t
typedef float32 CAN_TX_OBJ_HEADING_59_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_5_t
typedef float32 CAN_TX_OBJ_HEADING_5_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_60_t
typedef float32 CAN_TX_OBJ_HEADING_60_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_61_t
typedef float32 CAN_TX_OBJ_HEADING_61_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_62_t
typedef float32 CAN_TX_OBJ_HEADING_62_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_63_t
typedef float32 CAN_TX_OBJ_HEADING_63_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_64_t
typedef float32 CAN_TX_OBJ_HEADING_64_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_65_t
typedef float32 CAN_TX_OBJ_HEADING_65_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_66_t
typedef float32 CAN_TX_OBJ_HEADING_66_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_67_t
typedef float32 CAN_TX_OBJ_HEADING_67_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_68_t
typedef float32 CAN_TX_OBJ_HEADING_68_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_69_t
typedef float32 CAN_TX_OBJ_HEADING_69_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_6_t
typedef float32 CAN_TX_OBJ_HEADING_6_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_70_t
typedef float32 CAN_TX_OBJ_HEADING_70_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_71_t
typedef float32 CAN_TX_OBJ_HEADING_71_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_72_t
typedef float32 CAN_TX_OBJ_HEADING_72_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_73_t
typedef float32 CAN_TX_OBJ_HEADING_73_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_74_t
typedef float32 CAN_TX_OBJ_HEADING_74_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_75_t
typedef float32 CAN_TX_OBJ_HEADING_75_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_76_t
typedef float32 CAN_TX_OBJ_HEADING_76_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_77_t
typedef float32 CAN_TX_OBJ_HEADING_77_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_78_t
typedef float32 CAN_TX_OBJ_HEADING_78_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_79_t
typedef float32 CAN_TX_OBJ_HEADING_79_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_7_t
typedef float32 CAN_TX_OBJ_HEADING_7_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_80_t
typedef float32 CAN_TX_OBJ_HEADING_80_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_81_t
typedef float32 CAN_TX_OBJ_HEADING_81_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_82_t
typedef float32 CAN_TX_OBJ_HEADING_82_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_83_t
typedef float32 CAN_TX_OBJ_HEADING_83_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_84_t
typedef float32 CAN_TX_OBJ_HEADING_84_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_85_t
typedef float32 CAN_TX_OBJ_HEADING_85_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_86_t
typedef float32 CAN_TX_OBJ_HEADING_86_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_87_t
typedef float32 CAN_TX_OBJ_HEADING_87_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_88_t
typedef float32 CAN_TX_OBJ_HEADING_88_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_89_t
typedef float32 CAN_TX_OBJ_HEADING_89_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_8_t
typedef float32 CAN_TX_OBJ_HEADING_8_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_90_t
typedef float32 CAN_TX_OBJ_HEADING_90_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_91_t
typedef float32 CAN_TX_OBJ_HEADING_91_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_92_t
typedef float32 CAN_TX_OBJ_HEADING_92_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_93_t
typedef float32 CAN_TX_OBJ_HEADING_93_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_94_t
typedef float32 CAN_TX_OBJ_HEADING_94_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_95_t
typedef float32 CAN_TX_OBJ_HEADING_95_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_96_t
typedef float32 CAN_TX_OBJ_HEADING_96_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_97_t
typedef float32 CAN_TX_OBJ_HEADING_97_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_98_t
typedef float32 CAN_TX_OBJ_HEADING_98_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_99_t
typedef float32 CAN_TX_OBJ_HEADING_99_t;

#  define Rte_TypeDef_CAN_TX_OBJ_HEADING_9_t
typedef float32 CAN_TX_OBJ_HEADING_9_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_0_t
typedef uint8 CAN_TX_OBJ_ID_0_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_100_t
typedef uint8 CAN_TX_OBJ_ID_100_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_101_t
typedef uint8 CAN_TX_OBJ_ID_101_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_102_t
typedef uint8 CAN_TX_OBJ_ID_102_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_103_t
typedef uint8 CAN_TX_OBJ_ID_103_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_104_t
typedef uint8 CAN_TX_OBJ_ID_104_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_105_t
typedef uint8 CAN_TX_OBJ_ID_105_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_106_t
typedef uint8 CAN_TX_OBJ_ID_106_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_107_t
typedef uint8 CAN_TX_OBJ_ID_107_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_108_t
typedef uint8 CAN_TX_OBJ_ID_108_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_109_t
typedef uint8 CAN_TX_OBJ_ID_109_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_10_t
typedef uint8 CAN_TX_OBJ_ID_10_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_110_t
typedef uint8 CAN_TX_OBJ_ID_110_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_111_t
typedef uint8 CAN_TX_OBJ_ID_111_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_112_t
typedef uint8 CAN_TX_OBJ_ID_112_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_113_t
typedef uint8 CAN_TX_OBJ_ID_113_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_114_t
typedef uint8 CAN_TX_OBJ_ID_114_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_115_t
typedef uint8 CAN_TX_OBJ_ID_115_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_116_t
typedef uint8 CAN_TX_OBJ_ID_116_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_117_t
typedef uint8 CAN_TX_OBJ_ID_117_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_118_t
typedef uint8 CAN_TX_OBJ_ID_118_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_119_t
typedef uint8 CAN_TX_OBJ_ID_119_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_11_t
typedef uint8 CAN_TX_OBJ_ID_11_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_120_t
typedef uint8 CAN_TX_OBJ_ID_120_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_121_t
typedef uint8 CAN_TX_OBJ_ID_121_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_122_t
typedef uint8 CAN_TX_OBJ_ID_122_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_123_t
typedef uint8 CAN_TX_OBJ_ID_123_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_124_t
typedef uint8 CAN_TX_OBJ_ID_124_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_125_t
typedef uint8 CAN_TX_OBJ_ID_125_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_126_t
typedef uint8 CAN_TX_OBJ_ID_126_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_127_t
typedef uint8 CAN_TX_OBJ_ID_127_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_12_t
typedef uint8 CAN_TX_OBJ_ID_12_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_13_t
typedef uint8 CAN_TX_OBJ_ID_13_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_14_t
typedef uint8 CAN_TX_OBJ_ID_14_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_15_t
typedef uint8 CAN_TX_OBJ_ID_15_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_16_t
typedef uint8 CAN_TX_OBJ_ID_16_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_17_t
typedef uint8 CAN_TX_OBJ_ID_17_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_18_t
typedef uint8 CAN_TX_OBJ_ID_18_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_19_t
typedef uint8 CAN_TX_OBJ_ID_19_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_1_t
typedef uint8 CAN_TX_OBJ_ID_1_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_20_t
typedef uint8 CAN_TX_OBJ_ID_20_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_21_t
typedef uint8 CAN_TX_OBJ_ID_21_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_22_t
typedef uint8 CAN_TX_OBJ_ID_22_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_23_t
typedef uint8 CAN_TX_OBJ_ID_23_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_24_t
typedef uint8 CAN_TX_OBJ_ID_24_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_25_t
typedef uint8 CAN_TX_OBJ_ID_25_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_26_t
typedef uint8 CAN_TX_OBJ_ID_26_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_27_t
typedef uint8 CAN_TX_OBJ_ID_27_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_28_t
typedef uint8 CAN_TX_OBJ_ID_28_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_29_t
typedef uint8 CAN_TX_OBJ_ID_29_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_2_t
typedef uint8 CAN_TX_OBJ_ID_2_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_30_t
typedef uint8 CAN_TX_OBJ_ID_30_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_31_t
typedef uint8 CAN_TX_OBJ_ID_31_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_32_t
typedef uint8 CAN_TX_OBJ_ID_32_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_33_t
typedef uint8 CAN_TX_OBJ_ID_33_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_34_t
typedef uint8 CAN_TX_OBJ_ID_34_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_35_t
typedef uint8 CAN_TX_OBJ_ID_35_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_36_t
typedef uint8 CAN_TX_OBJ_ID_36_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_37_t
typedef uint8 CAN_TX_OBJ_ID_37_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_38_t
typedef uint8 CAN_TX_OBJ_ID_38_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_39_t
typedef uint8 CAN_TX_OBJ_ID_39_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_3_t
typedef uint8 CAN_TX_OBJ_ID_3_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_40_t
typedef uint8 CAN_TX_OBJ_ID_40_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_41_t
typedef uint8 CAN_TX_OBJ_ID_41_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_42_t
typedef uint8 CAN_TX_OBJ_ID_42_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_43_t
typedef uint8 CAN_TX_OBJ_ID_43_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_44_t
typedef uint8 CAN_TX_OBJ_ID_44_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_45_t
typedef uint8 CAN_TX_OBJ_ID_45_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_46_t
typedef uint8 CAN_TX_OBJ_ID_46_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_47_t
typedef uint8 CAN_TX_OBJ_ID_47_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_48_t
typedef uint8 CAN_TX_OBJ_ID_48_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_49_t
typedef uint8 CAN_TX_OBJ_ID_49_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_4_t
typedef uint8 CAN_TX_OBJ_ID_4_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_50_t
typedef uint8 CAN_TX_OBJ_ID_50_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_51_t
typedef uint8 CAN_TX_OBJ_ID_51_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_52_t
typedef uint8 CAN_TX_OBJ_ID_52_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_53_t
typedef uint8 CAN_TX_OBJ_ID_53_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_54_t
typedef uint8 CAN_TX_OBJ_ID_54_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_55_t
typedef uint8 CAN_TX_OBJ_ID_55_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_56_t
typedef uint8 CAN_TX_OBJ_ID_56_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_57_t
typedef uint8 CAN_TX_OBJ_ID_57_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_58_t
typedef uint8 CAN_TX_OBJ_ID_58_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_59_t
typedef uint8 CAN_TX_OBJ_ID_59_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_5_t
typedef uint8 CAN_TX_OBJ_ID_5_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_60_t
typedef uint8 CAN_TX_OBJ_ID_60_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_61_t
typedef uint8 CAN_TX_OBJ_ID_61_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_62_t
typedef uint8 CAN_TX_OBJ_ID_62_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_63_t
typedef uint8 CAN_TX_OBJ_ID_63_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_64_t
typedef uint8 CAN_TX_OBJ_ID_64_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_65_t
typedef uint8 CAN_TX_OBJ_ID_65_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_66_t
typedef uint8 CAN_TX_OBJ_ID_66_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_67_t
typedef uint8 CAN_TX_OBJ_ID_67_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_68_t
typedef uint8 CAN_TX_OBJ_ID_68_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_69_t
typedef uint8 CAN_TX_OBJ_ID_69_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_6_t
typedef uint8 CAN_TX_OBJ_ID_6_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_70_t
typedef uint8 CAN_TX_OBJ_ID_70_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_71_t
typedef uint8 CAN_TX_OBJ_ID_71_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_72_t
typedef uint8 CAN_TX_OBJ_ID_72_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_73_t
typedef uint8 CAN_TX_OBJ_ID_73_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_74_t
typedef uint8 CAN_TX_OBJ_ID_74_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_75_t
typedef uint8 CAN_TX_OBJ_ID_75_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_76_t
typedef uint8 CAN_TX_OBJ_ID_76_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_77_t
typedef uint8 CAN_TX_OBJ_ID_77_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_78_t
typedef uint8 CAN_TX_OBJ_ID_78_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_79_t
typedef uint8 CAN_TX_OBJ_ID_79_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_7_t
typedef uint8 CAN_TX_OBJ_ID_7_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_80_t
typedef uint8 CAN_TX_OBJ_ID_80_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_81_t
typedef uint8 CAN_TX_OBJ_ID_81_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_82_t
typedef uint8 CAN_TX_OBJ_ID_82_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_83_t
typedef uint8 CAN_TX_OBJ_ID_83_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_84_t
typedef uint8 CAN_TX_OBJ_ID_84_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_85_t
typedef uint8 CAN_TX_OBJ_ID_85_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_86_t
typedef uint8 CAN_TX_OBJ_ID_86_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_87_t
typedef uint8 CAN_TX_OBJ_ID_87_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_88_t
typedef uint8 CAN_TX_OBJ_ID_88_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_89_t
typedef uint8 CAN_TX_OBJ_ID_89_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_8_t
typedef uint8 CAN_TX_OBJ_ID_8_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_90_t
typedef uint8 CAN_TX_OBJ_ID_90_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_91_t
typedef uint8 CAN_TX_OBJ_ID_91_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_92_t
typedef uint8 CAN_TX_OBJ_ID_92_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_93_t
typedef uint8 CAN_TX_OBJ_ID_93_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_94_t
typedef uint8 CAN_TX_OBJ_ID_94_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_95_t
typedef uint8 CAN_TX_OBJ_ID_95_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_96_t
typedef uint8 CAN_TX_OBJ_ID_96_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_97_t
typedef uint8 CAN_TX_OBJ_ID_97_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_98_t
typedef uint8 CAN_TX_OBJ_ID_98_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_99_t
typedef uint8 CAN_TX_OBJ_ID_99_t;

#  define Rte_TypeDef_CAN_TX_OBJ_ID_9_t
typedef uint8 CAN_TX_OBJ_ID_9_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_0_t
typedef float32 CAN_TX_OBJ_LENGTH_0_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_100_t
typedef float32 CAN_TX_OBJ_LENGTH_100_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_101_t
typedef float32 CAN_TX_OBJ_LENGTH_101_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_102_t
typedef float32 CAN_TX_OBJ_LENGTH_102_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_103_t
typedef float32 CAN_TX_OBJ_LENGTH_103_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_104_t
typedef float32 CAN_TX_OBJ_LENGTH_104_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_105_t
typedef float32 CAN_TX_OBJ_LENGTH_105_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_106_t
typedef float32 CAN_TX_OBJ_LENGTH_106_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_107_t
typedef float32 CAN_TX_OBJ_LENGTH_107_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_108_t
typedef float32 CAN_TX_OBJ_LENGTH_108_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_109_t
typedef float32 CAN_TX_OBJ_LENGTH_109_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_10_t
typedef float32 CAN_TX_OBJ_LENGTH_10_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_110_t
typedef float32 CAN_TX_OBJ_LENGTH_110_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_111_t
typedef float32 CAN_TX_OBJ_LENGTH_111_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_112_t
typedef float32 CAN_TX_OBJ_LENGTH_112_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_113_t
typedef float32 CAN_TX_OBJ_LENGTH_113_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_114_t
typedef float32 CAN_TX_OBJ_LENGTH_114_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_115_t
typedef float32 CAN_TX_OBJ_LENGTH_115_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_116_t
typedef float32 CAN_TX_OBJ_LENGTH_116_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_117_t
typedef float32 CAN_TX_OBJ_LENGTH_117_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_118_t
typedef float32 CAN_TX_OBJ_LENGTH_118_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_119_t
typedef float32 CAN_TX_OBJ_LENGTH_119_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_11_t
typedef float32 CAN_TX_OBJ_LENGTH_11_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_120_t
typedef float32 CAN_TX_OBJ_LENGTH_120_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_121_t
typedef float32 CAN_TX_OBJ_LENGTH_121_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_122_t
typedef float32 CAN_TX_OBJ_LENGTH_122_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_123_t
typedef float32 CAN_TX_OBJ_LENGTH_123_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_124_t
typedef float32 CAN_TX_OBJ_LENGTH_124_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_125_t
typedef float32 CAN_TX_OBJ_LENGTH_125_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_126_t
typedef float32 CAN_TX_OBJ_LENGTH_126_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_127_t
typedef float32 CAN_TX_OBJ_LENGTH_127_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_12_t
typedef float32 CAN_TX_OBJ_LENGTH_12_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_13_t
typedef float32 CAN_TX_OBJ_LENGTH_13_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_14_t
typedef float32 CAN_TX_OBJ_LENGTH_14_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_15_t
typedef float32 CAN_TX_OBJ_LENGTH_15_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_16_t
typedef float32 CAN_TX_OBJ_LENGTH_16_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_17_t
typedef float32 CAN_TX_OBJ_LENGTH_17_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_18_t
typedef float32 CAN_TX_OBJ_LENGTH_18_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_19_t
typedef float32 CAN_TX_OBJ_LENGTH_19_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_1_t
typedef float32 CAN_TX_OBJ_LENGTH_1_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_20_t
typedef float32 CAN_TX_OBJ_LENGTH_20_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_21_t
typedef float32 CAN_TX_OBJ_LENGTH_21_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_22_t
typedef float32 CAN_TX_OBJ_LENGTH_22_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_23_t
typedef float32 CAN_TX_OBJ_LENGTH_23_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_24_t
typedef float32 CAN_TX_OBJ_LENGTH_24_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_25_t
typedef float32 CAN_TX_OBJ_LENGTH_25_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_26_t
typedef float32 CAN_TX_OBJ_LENGTH_26_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_27_t
typedef float32 CAN_TX_OBJ_LENGTH_27_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_28_t
typedef float32 CAN_TX_OBJ_LENGTH_28_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_29_t
typedef float32 CAN_TX_OBJ_LENGTH_29_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_2_t
typedef float32 CAN_TX_OBJ_LENGTH_2_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_30_t
typedef float32 CAN_TX_OBJ_LENGTH_30_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_31_t
typedef float32 CAN_TX_OBJ_LENGTH_31_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_32_t
typedef float32 CAN_TX_OBJ_LENGTH_32_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_33_t
typedef float32 CAN_TX_OBJ_LENGTH_33_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_34_t
typedef float32 CAN_TX_OBJ_LENGTH_34_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_35_t
typedef float32 CAN_TX_OBJ_LENGTH_35_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_36_t
typedef float32 CAN_TX_OBJ_LENGTH_36_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_37_t
typedef float32 CAN_TX_OBJ_LENGTH_37_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_38_t
typedef float32 CAN_TX_OBJ_LENGTH_38_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_39_t
typedef float32 CAN_TX_OBJ_LENGTH_39_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_3_t
typedef float32 CAN_TX_OBJ_LENGTH_3_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_40_t
typedef float32 CAN_TX_OBJ_LENGTH_40_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_41_t
typedef float32 CAN_TX_OBJ_LENGTH_41_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_42_t
typedef float32 CAN_TX_OBJ_LENGTH_42_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_43_t
typedef float32 CAN_TX_OBJ_LENGTH_43_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_44_t
typedef float32 CAN_TX_OBJ_LENGTH_44_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_45_t
typedef float32 CAN_TX_OBJ_LENGTH_45_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_46_t
typedef float32 CAN_TX_OBJ_LENGTH_46_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_47_t
typedef float32 CAN_TX_OBJ_LENGTH_47_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_48_t
typedef float32 CAN_TX_OBJ_LENGTH_48_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_49_t
typedef float32 CAN_TX_OBJ_LENGTH_49_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_4_t
typedef float32 CAN_TX_OBJ_LENGTH_4_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_50_t
typedef float32 CAN_TX_OBJ_LENGTH_50_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_51_t
typedef float32 CAN_TX_OBJ_LENGTH_51_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_52_t
typedef float32 CAN_TX_OBJ_LENGTH_52_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_53_t
typedef float32 CAN_TX_OBJ_LENGTH_53_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_54_t
typedef float32 CAN_TX_OBJ_LENGTH_54_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_55_t
typedef float32 CAN_TX_OBJ_LENGTH_55_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_56_t
typedef float32 CAN_TX_OBJ_LENGTH_56_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_57_t
typedef float32 CAN_TX_OBJ_LENGTH_57_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_58_t
typedef float32 CAN_TX_OBJ_LENGTH_58_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_59_t
typedef float32 CAN_TX_OBJ_LENGTH_59_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_5_t
typedef float32 CAN_TX_OBJ_LENGTH_5_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_60_t
typedef float32 CAN_TX_OBJ_LENGTH_60_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_61_t
typedef float32 CAN_TX_OBJ_LENGTH_61_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_62_t
typedef float32 CAN_TX_OBJ_LENGTH_62_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_63_t
typedef float32 CAN_TX_OBJ_LENGTH_63_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_64_t
typedef float32 CAN_TX_OBJ_LENGTH_64_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_65_t
typedef float32 CAN_TX_OBJ_LENGTH_65_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_66_t
typedef float32 CAN_TX_OBJ_LENGTH_66_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_67_t
typedef float32 CAN_TX_OBJ_LENGTH_67_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_68_t
typedef float32 CAN_TX_OBJ_LENGTH_68_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_69_t
typedef float32 CAN_TX_OBJ_LENGTH_69_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_6_t
typedef float32 CAN_TX_OBJ_LENGTH_6_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_70_t
typedef float32 CAN_TX_OBJ_LENGTH_70_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_71_t
typedef float32 CAN_TX_OBJ_LENGTH_71_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_72_t
typedef float32 CAN_TX_OBJ_LENGTH_72_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_73_t
typedef float32 CAN_TX_OBJ_LENGTH_73_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_74_t
typedef float32 CAN_TX_OBJ_LENGTH_74_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_75_t
typedef float32 CAN_TX_OBJ_LENGTH_75_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_76_t
typedef float32 CAN_TX_OBJ_LENGTH_76_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_77_t
typedef float32 CAN_TX_OBJ_LENGTH_77_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_78_t
typedef float32 CAN_TX_OBJ_LENGTH_78_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_79_t
typedef float32 CAN_TX_OBJ_LENGTH_79_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_7_t
typedef float32 CAN_TX_OBJ_LENGTH_7_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_80_t
typedef float32 CAN_TX_OBJ_LENGTH_80_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_81_t
typedef float32 CAN_TX_OBJ_LENGTH_81_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_82_t
typedef float32 CAN_TX_OBJ_LENGTH_82_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_83_t
typedef float32 CAN_TX_OBJ_LENGTH_83_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_84_t
typedef float32 CAN_TX_OBJ_LENGTH_84_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_85_t
typedef float32 CAN_TX_OBJ_LENGTH_85_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_86_t
typedef float32 CAN_TX_OBJ_LENGTH_86_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_87_t
typedef float32 CAN_TX_OBJ_LENGTH_87_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_88_t
typedef float32 CAN_TX_OBJ_LENGTH_88_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_89_t
typedef float32 CAN_TX_OBJ_LENGTH_89_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_8_t
typedef float32 CAN_TX_OBJ_LENGTH_8_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_90_t
typedef float32 CAN_TX_OBJ_LENGTH_90_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_91_t
typedef float32 CAN_TX_OBJ_LENGTH_91_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_92_t
typedef float32 CAN_TX_OBJ_LENGTH_92_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_93_t
typedef float32 CAN_TX_OBJ_LENGTH_93_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_94_t
typedef float32 CAN_TX_OBJ_LENGTH_94_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_95_t
typedef float32 CAN_TX_OBJ_LENGTH_95_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_96_t
typedef float32 CAN_TX_OBJ_LENGTH_96_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_97_t
typedef float32 CAN_TX_OBJ_LENGTH_97_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_98_t
typedef float32 CAN_TX_OBJ_LENGTH_98_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_99_t
typedef float32 CAN_TX_OBJ_LENGTH_99_t;

#  define Rte_TypeDef_CAN_TX_OBJ_LENGTH_9_t
typedef float32 CAN_TX_OBJ_LENGTH_9_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_0_t
typedef float32 CAN_TX_OBJ_POS_LAT_0_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_100_t
typedef float32 CAN_TX_OBJ_POS_LAT_100_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_101_t
typedef float32 CAN_TX_OBJ_POS_LAT_101_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_102_t
typedef float32 CAN_TX_OBJ_POS_LAT_102_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_103_t
typedef float32 CAN_TX_OBJ_POS_LAT_103_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_104_t
typedef float32 CAN_TX_OBJ_POS_LAT_104_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_105_t
typedef float32 CAN_TX_OBJ_POS_LAT_105_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_106_t
typedef float32 CAN_TX_OBJ_POS_LAT_106_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_107_t
typedef float32 CAN_TX_OBJ_POS_LAT_107_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_108_t
typedef float32 CAN_TX_OBJ_POS_LAT_108_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_109_t
typedef float32 CAN_TX_OBJ_POS_LAT_109_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_10_t
typedef float32 CAN_TX_OBJ_POS_LAT_10_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_110_t
typedef float32 CAN_TX_OBJ_POS_LAT_110_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_111_t
typedef float32 CAN_TX_OBJ_POS_LAT_111_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_112_t
typedef float32 CAN_TX_OBJ_POS_LAT_112_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_113_t
typedef float32 CAN_TX_OBJ_POS_LAT_113_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_114_t
typedef float32 CAN_TX_OBJ_POS_LAT_114_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_115_t
typedef float32 CAN_TX_OBJ_POS_LAT_115_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_116_t
typedef float32 CAN_TX_OBJ_POS_LAT_116_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_117_t
typedef float32 CAN_TX_OBJ_POS_LAT_117_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_118_t
typedef float32 CAN_TX_OBJ_POS_LAT_118_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_119_t
typedef float32 CAN_TX_OBJ_POS_LAT_119_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_11_t
typedef float32 CAN_TX_OBJ_POS_LAT_11_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_120_t
typedef float32 CAN_TX_OBJ_POS_LAT_120_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_121_t
typedef float32 CAN_TX_OBJ_POS_LAT_121_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_122_t
typedef float32 CAN_TX_OBJ_POS_LAT_122_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_123_t
typedef float32 CAN_TX_OBJ_POS_LAT_123_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_124_t
typedef float32 CAN_TX_OBJ_POS_LAT_124_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_125_t
typedef float32 CAN_TX_OBJ_POS_LAT_125_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_126_t
typedef float32 CAN_TX_OBJ_POS_LAT_126_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_127_t
typedef float32 CAN_TX_OBJ_POS_LAT_127_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_12_t
typedef float32 CAN_TX_OBJ_POS_LAT_12_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_13_t
typedef float32 CAN_TX_OBJ_POS_LAT_13_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_14_t
typedef float32 CAN_TX_OBJ_POS_LAT_14_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_15_t
typedef float32 CAN_TX_OBJ_POS_LAT_15_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_16_t
typedef float32 CAN_TX_OBJ_POS_LAT_16_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_17_t
typedef float32 CAN_TX_OBJ_POS_LAT_17_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_18_t
typedef float32 CAN_TX_OBJ_POS_LAT_18_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_19_t
typedef float32 CAN_TX_OBJ_POS_LAT_19_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_1_t
typedef float32 CAN_TX_OBJ_POS_LAT_1_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_20_t
typedef float32 CAN_TX_OBJ_POS_LAT_20_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_21_t
typedef float32 CAN_TX_OBJ_POS_LAT_21_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_22_t
typedef float32 CAN_TX_OBJ_POS_LAT_22_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_23_t
typedef float32 CAN_TX_OBJ_POS_LAT_23_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_24_t
typedef float32 CAN_TX_OBJ_POS_LAT_24_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_25_t
typedef float32 CAN_TX_OBJ_POS_LAT_25_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_26_t
typedef float32 CAN_TX_OBJ_POS_LAT_26_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_27_t
typedef float32 CAN_TX_OBJ_POS_LAT_27_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_28_t
typedef float32 CAN_TX_OBJ_POS_LAT_28_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_29_t
typedef float32 CAN_TX_OBJ_POS_LAT_29_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_2_t
typedef float32 CAN_TX_OBJ_POS_LAT_2_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_30_t
typedef float32 CAN_TX_OBJ_POS_LAT_30_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_31_t
typedef float32 CAN_TX_OBJ_POS_LAT_31_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_32_t
typedef float32 CAN_TX_OBJ_POS_LAT_32_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_33_t
typedef float32 CAN_TX_OBJ_POS_LAT_33_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_34_t
typedef float32 CAN_TX_OBJ_POS_LAT_34_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_35_t
typedef float32 CAN_TX_OBJ_POS_LAT_35_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_36_t
typedef float32 CAN_TX_OBJ_POS_LAT_36_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_37_t
typedef float32 CAN_TX_OBJ_POS_LAT_37_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_38_t
typedef float32 CAN_TX_OBJ_POS_LAT_38_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_39_t
typedef float32 CAN_TX_OBJ_POS_LAT_39_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_3_t
typedef float32 CAN_TX_OBJ_POS_LAT_3_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_40_t
typedef float32 CAN_TX_OBJ_POS_LAT_40_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_41_t
typedef float32 CAN_TX_OBJ_POS_LAT_41_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_42_t
typedef float32 CAN_TX_OBJ_POS_LAT_42_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_43_t
typedef float32 CAN_TX_OBJ_POS_LAT_43_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_44_t
typedef float32 CAN_TX_OBJ_POS_LAT_44_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_45_t
typedef float32 CAN_TX_OBJ_POS_LAT_45_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_46_t
typedef float32 CAN_TX_OBJ_POS_LAT_46_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_47_t
typedef float32 CAN_TX_OBJ_POS_LAT_47_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_48_t
typedef float32 CAN_TX_OBJ_POS_LAT_48_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_49_t
typedef float32 CAN_TX_OBJ_POS_LAT_49_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_4_t
typedef float32 CAN_TX_OBJ_POS_LAT_4_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_50_t
typedef float32 CAN_TX_OBJ_POS_LAT_50_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_51_t
typedef float32 CAN_TX_OBJ_POS_LAT_51_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_52_t
typedef float32 CAN_TX_OBJ_POS_LAT_52_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_53_t
typedef float32 CAN_TX_OBJ_POS_LAT_53_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_54_t
typedef float32 CAN_TX_OBJ_POS_LAT_54_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_55_t
typedef float32 CAN_TX_OBJ_POS_LAT_55_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_56_t
typedef float32 CAN_TX_OBJ_POS_LAT_56_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_57_t
typedef float32 CAN_TX_OBJ_POS_LAT_57_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_58_t
typedef float32 CAN_TX_OBJ_POS_LAT_58_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_59_t
typedef float32 CAN_TX_OBJ_POS_LAT_59_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_5_t
typedef float32 CAN_TX_OBJ_POS_LAT_5_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_60_t
typedef float32 CAN_TX_OBJ_POS_LAT_60_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_61_t
typedef float32 CAN_TX_OBJ_POS_LAT_61_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_62_t
typedef float32 CAN_TX_OBJ_POS_LAT_62_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_63_t
typedef float32 CAN_TX_OBJ_POS_LAT_63_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_64_t
typedef float32 CAN_TX_OBJ_POS_LAT_64_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_65_t
typedef float32 CAN_TX_OBJ_POS_LAT_65_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_66_t
typedef float32 CAN_TX_OBJ_POS_LAT_66_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_67_t
typedef float32 CAN_TX_OBJ_POS_LAT_67_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_68_t
typedef float32 CAN_TX_OBJ_POS_LAT_68_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_69_t
typedef float32 CAN_TX_OBJ_POS_LAT_69_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_6_t
typedef float32 CAN_TX_OBJ_POS_LAT_6_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_70_t
typedef float32 CAN_TX_OBJ_POS_LAT_70_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_71_t
typedef float32 CAN_TX_OBJ_POS_LAT_71_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_72_t
typedef float32 CAN_TX_OBJ_POS_LAT_72_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_73_t
typedef float32 CAN_TX_OBJ_POS_LAT_73_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_74_t
typedef float32 CAN_TX_OBJ_POS_LAT_74_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_75_t
typedef float32 CAN_TX_OBJ_POS_LAT_75_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_76_t
typedef float32 CAN_TX_OBJ_POS_LAT_76_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_77_t
typedef float32 CAN_TX_OBJ_POS_LAT_77_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_78_t
typedef float32 CAN_TX_OBJ_POS_LAT_78_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_79_t
typedef float32 CAN_TX_OBJ_POS_LAT_79_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_7_t
typedef float32 CAN_TX_OBJ_POS_LAT_7_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_80_t
typedef float32 CAN_TX_OBJ_POS_LAT_80_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_81_t
typedef float32 CAN_TX_OBJ_POS_LAT_81_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_82_t
typedef float32 CAN_TX_OBJ_POS_LAT_82_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_83_t
typedef float32 CAN_TX_OBJ_POS_LAT_83_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_84_t
typedef float32 CAN_TX_OBJ_POS_LAT_84_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_85_t
typedef float32 CAN_TX_OBJ_POS_LAT_85_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_86_t
typedef float32 CAN_TX_OBJ_POS_LAT_86_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_87_t
typedef float32 CAN_TX_OBJ_POS_LAT_87_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_88_t
typedef float32 CAN_TX_OBJ_POS_LAT_88_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_89_t
typedef float32 CAN_TX_OBJ_POS_LAT_89_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_8_t
typedef float32 CAN_TX_OBJ_POS_LAT_8_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_90_t
typedef float32 CAN_TX_OBJ_POS_LAT_90_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_91_t
typedef float32 CAN_TX_OBJ_POS_LAT_91_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_92_t
typedef float32 CAN_TX_OBJ_POS_LAT_92_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_93_t
typedef float32 CAN_TX_OBJ_POS_LAT_93_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_94_t
typedef float32 CAN_TX_OBJ_POS_LAT_94_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_95_t
typedef float32 CAN_TX_OBJ_POS_LAT_95_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_96_t
typedef float32 CAN_TX_OBJ_POS_LAT_96_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_97_t
typedef float32 CAN_TX_OBJ_POS_LAT_97_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_98_t
typedef float32 CAN_TX_OBJ_POS_LAT_98_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_99_t
typedef float32 CAN_TX_OBJ_POS_LAT_99_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LAT_9_t
typedef float32 CAN_TX_OBJ_POS_LAT_9_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_0_t
typedef float32 CAN_TX_OBJ_POS_LONG_0_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_100_t
typedef float32 CAN_TX_OBJ_POS_LONG_100_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_101_t
typedef float32 CAN_TX_OBJ_POS_LONG_101_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_102_t
typedef float32 CAN_TX_OBJ_POS_LONG_102_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_103_t
typedef float32 CAN_TX_OBJ_POS_LONG_103_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_104_t
typedef float32 CAN_TX_OBJ_POS_LONG_104_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_105_t
typedef float32 CAN_TX_OBJ_POS_LONG_105_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_106_t
typedef float32 CAN_TX_OBJ_POS_LONG_106_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_107_t
typedef float32 CAN_TX_OBJ_POS_LONG_107_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_108_t
typedef float32 CAN_TX_OBJ_POS_LONG_108_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_109_t
typedef float32 CAN_TX_OBJ_POS_LONG_109_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_10_t
typedef float32 CAN_TX_OBJ_POS_LONG_10_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_110_t
typedef float32 CAN_TX_OBJ_POS_LONG_110_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_111_t
typedef float32 CAN_TX_OBJ_POS_LONG_111_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_112_t
typedef float32 CAN_TX_OBJ_POS_LONG_112_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_113_t
typedef float32 CAN_TX_OBJ_POS_LONG_113_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_114_t
typedef float32 CAN_TX_OBJ_POS_LONG_114_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_115_t
typedef float32 CAN_TX_OBJ_POS_LONG_115_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_116_t
typedef float32 CAN_TX_OBJ_POS_LONG_116_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_117_t
typedef float32 CAN_TX_OBJ_POS_LONG_117_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_118_t
typedef float32 CAN_TX_OBJ_POS_LONG_118_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_119_t
typedef float32 CAN_TX_OBJ_POS_LONG_119_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_11_t
typedef float32 CAN_TX_OBJ_POS_LONG_11_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_120_t
typedef float32 CAN_TX_OBJ_POS_LONG_120_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_121_t
typedef float32 CAN_TX_OBJ_POS_LONG_121_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_122_t
typedef float32 CAN_TX_OBJ_POS_LONG_122_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_123_t
typedef float32 CAN_TX_OBJ_POS_LONG_123_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_124_t
typedef float32 CAN_TX_OBJ_POS_LONG_124_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_125_t
typedef float32 CAN_TX_OBJ_POS_LONG_125_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_126_t
typedef float32 CAN_TX_OBJ_POS_LONG_126_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_127_t
typedef float32 CAN_TX_OBJ_POS_LONG_127_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_12_t
typedef float32 CAN_TX_OBJ_POS_LONG_12_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_13_t
typedef float32 CAN_TX_OBJ_POS_LONG_13_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_14_t
typedef float32 CAN_TX_OBJ_POS_LONG_14_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_15_t
typedef float32 CAN_TX_OBJ_POS_LONG_15_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_16_t
typedef float32 CAN_TX_OBJ_POS_LONG_16_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_17_t
typedef float32 CAN_TX_OBJ_POS_LONG_17_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_18_t
typedef float32 CAN_TX_OBJ_POS_LONG_18_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_19_t
typedef float32 CAN_TX_OBJ_POS_LONG_19_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_1_t
typedef float32 CAN_TX_OBJ_POS_LONG_1_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_20_t
typedef float32 CAN_TX_OBJ_POS_LONG_20_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_21_t
typedef float32 CAN_TX_OBJ_POS_LONG_21_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_22_t
typedef float32 CAN_TX_OBJ_POS_LONG_22_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_23_t
typedef float32 CAN_TX_OBJ_POS_LONG_23_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_24_t
typedef float32 CAN_TX_OBJ_POS_LONG_24_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_25_t
typedef float32 CAN_TX_OBJ_POS_LONG_25_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_26_t
typedef float32 CAN_TX_OBJ_POS_LONG_26_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_27_t
typedef float32 CAN_TX_OBJ_POS_LONG_27_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_28_t
typedef float32 CAN_TX_OBJ_POS_LONG_28_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_29_t
typedef float32 CAN_TX_OBJ_POS_LONG_29_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_2_t
typedef float32 CAN_TX_OBJ_POS_LONG_2_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_30_t
typedef float32 CAN_TX_OBJ_POS_LONG_30_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_31_t
typedef float32 CAN_TX_OBJ_POS_LONG_31_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_32_t
typedef float32 CAN_TX_OBJ_POS_LONG_32_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_33_t
typedef float32 CAN_TX_OBJ_POS_LONG_33_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_34_t
typedef float32 CAN_TX_OBJ_POS_LONG_34_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_35_t
typedef float32 CAN_TX_OBJ_POS_LONG_35_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_36_t
typedef float32 CAN_TX_OBJ_POS_LONG_36_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_37_t
typedef float32 CAN_TX_OBJ_POS_LONG_37_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_38_t
typedef float32 CAN_TX_OBJ_POS_LONG_38_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_39_t
typedef float32 CAN_TX_OBJ_POS_LONG_39_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_3_t
typedef float32 CAN_TX_OBJ_POS_LONG_3_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_40_t
typedef float32 CAN_TX_OBJ_POS_LONG_40_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_41_t
typedef float32 CAN_TX_OBJ_POS_LONG_41_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_42_t
typedef float32 CAN_TX_OBJ_POS_LONG_42_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_43_t
typedef float32 CAN_TX_OBJ_POS_LONG_43_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_44_t
typedef float32 CAN_TX_OBJ_POS_LONG_44_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_45_t
typedef float32 CAN_TX_OBJ_POS_LONG_45_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_46_t
typedef float32 CAN_TX_OBJ_POS_LONG_46_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_47_t
typedef float32 CAN_TX_OBJ_POS_LONG_47_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_48_t
typedef float32 CAN_TX_OBJ_POS_LONG_48_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_49_t
typedef float32 CAN_TX_OBJ_POS_LONG_49_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_4_t
typedef float32 CAN_TX_OBJ_POS_LONG_4_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_50_t
typedef float32 CAN_TX_OBJ_POS_LONG_50_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_51_t
typedef float32 CAN_TX_OBJ_POS_LONG_51_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_52_t
typedef float32 CAN_TX_OBJ_POS_LONG_52_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_53_t
typedef float32 CAN_TX_OBJ_POS_LONG_53_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_54_t
typedef float32 CAN_TX_OBJ_POS_LONG_54_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_55_t
typedef float32 CAN_TX_OBJ_POS_LONG_55_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_56_t
typedef float32 CAN_TX_OBJ_POS_LONG_56_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_57_t
typedef float32 CAN_TX_OBJ_POS_LONG_57_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_58_t
typedef float32 CAN_TX_OBJ_POS_LONG_58_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_59_t
typedef float32 CAN_TX_OBJ_POS_LONG_59_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_5_t
typedef float32 CAN_TX_OBJ_POS_LONG_5_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_60_t
typedef float32 CAN_TX_OBJ_POS_LONG_60_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_61_t
typedef float32 CAN_TX_OBJ_POS_LONG_61_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_62_t
typedef float32 CAN_TX_OBJ_POS_LONG_62_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_63_t
typedef float32 CAN_TX_OBJ_POS_LONG_63_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_64_t
typedef float32 CAN_TX_OBJ_POS_LONG_64_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_65_t
typedef float32 CAN_TX_OBJ_POS_LONG_65_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_66_t
typedef float32 CAN_TX_OBJ_POS_LONG_66_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_67_t
typedef float32 CAN_TX_OBJ_POS_LONG_67_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_68_t
typedef float32 CAN_TX_OBJ_POS_LONG_68_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_69_t
typedef float32 CAN_TX_OBJ_POS_LONG_69_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_6_t
typedef float32 CAN_TX_OBJ_POS_LONG_6_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_70_t
typedef float32 CAN_TX_OBJ_POS_LONG_70_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_71_t
typedef float32 CAN_TX_OBJ_POS_LONG_71_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_72_t
typedef float32 CAN_TX_OBJ_POS_LONG_72_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_73_t
typedef float32 CAN_TX_OBJ_POS_LONG_73_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_74_t
typedef float32 CAN_TX_OBJ_POS_LONG_74_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_75_t
typedef float32 CAN_TX_OBJ_POS_LONG_75_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_76_t
typedef float32 CAN_TX_OBJ_POS_LONG_76_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_77_t
typedef float32 CAN_TX_OBJ_POS_LONG_77_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_78_t
typedef float32 CAN_TX_OBJ_POS_LONG_78_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_79_t
typedef float32 CAN_TX_OBJ_POS_LONG_79_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_7_t
typedef float32 CAN_TX_OBJ_POS_LONG_7_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_80_t
typedef float32 CAN_TX_OBJ_POS_LONG_80_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_81_t
typedef float32 CAN_TX_OBJ_POS_LONG_81_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_82_t
typedef float32 CAN_TX_OBJ_POS_LONG_82_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_83_t
typedef float32 CAN_TX_OBJ_POS_LONG_83_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_84_t
typedef float32 CAN_TX_OBJ_POS_LONG_84_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_85_t
typedef float32 CAN_TX_OBJ_POS_LONG_85_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_86_t
typedef float32 CAN_TX_OBJ_POS_LONG_86_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_87_t
typedef float32 CAN_TX_OBJ_POS_LONG_87_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_88_t
typedef float32 CAN_TX_OBJ_POS_LONG_88_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_89_t
typedef float32 CAN_TX_OBJ_POS_LONG_89_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_8_t
typedef float32 CAN_TX_OBJ_POS_LONG_8_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_90_t
typedef float32 CAN_TX_OBJ_POS_LONG_90_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_91_t
typedef float32 CAN_TX_OBJ_POS_LONG_91_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_92_t
typedef float32 CAN_TX_OBJ_POS_LONG_92_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_93_t
typedef float32 CAN_TX_OBJ_POS_LONG_93_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_94_t
typedef float32 CAN_TX_OBJ_POS_LONG_94_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_95_t
typedef float32 CAN_TX_OBJ_POS_LONG_95_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_96_t
typedef float32 CAN_TX_OBJ_POS_LONG_96_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_97_t
typedef float32 CAN_TX_OBJ_POS_LONG_97_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_98_t
typedef float32 CAN_TX_OBJ_POS_LONG_98_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_99_t
typedef float32 CAN_TX_OBJ_POS_LONG_99_t;

#  define Rte_TypeDef_CAN_TX_OBJ_POS_LONG_9_t
typedef float32 CAN_TX_OBJ_POS_LONG_9_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_0_t
typedef uint8 CAN_TX_OBJ_REF_POS_0_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_100_t
typedef uint8 CAN_TX_OBJ_REF_POS_100_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_101_t
typedef uint8 CAN_TX_OBJ_REF_POS_101_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_102_t
typedef uint8 CAN_TX_OBJ_REF_POS_102_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_103_t
typedef uint8 CAN_TX_OBJ_REF_POS_103_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_104_t
typedef uint8 CAN_TX_OBJ_REF_POS_104_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_105_t
typedef uint8 CAN_TX_OBJ_REF_POS_105_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_106_t
typedef uint8 CAN_TX_OBJ_REF_POS_106_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_107_t
typedef uint8 CAN_TX_OBJ_REF_POS_107_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_108_t
typedef uint8 CAN_TX_OBJ_REF_POS_108_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_109_t
typedef uint8 CAN_TX_OBJ_REF_POS_109_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_10_t
typedef uint8 CAN_TX_OBJ_REF_POS_10_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_110_t
typedef uint8 CAN_TX_OBJ_REF_POS_110_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_111_t
typedef uint8 CAN_TX_OBJ_REF_POS_111_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_112_t
typedef uint8 CAN_TX_OBJ_REF_POS_112_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_113_t
typedef uint8 CAN_TX_OBJ_REF_POS_113_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_114_t
typedef uint8 CAN_TX_OBJ_REF_POS_114_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_115_t
typedef uint8 CAN_TX_OBJ_REF_POS_115_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_116_t
typedef uint8 CAN_TX_OBJ_REF_POS_116_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_117_t
typedef uint8 CAN_TX_OBJ_REF_POS_117_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_118_t
typedef uint8 CAN_TX_OBJ_REF_POS_118_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_119_t
typedef uint8 CAN_TX_OBJ_REF_POS_119_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_11_t
typedef uint8 CAN_TX_OBJ_REF_POS_11_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_120_t
typedef uint8 CAN_TX_OBJ_REF_POS_120_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_121_t
typedef uint8 CAN_TX_OBJ_REF_POS_121_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_122_t
typedef uint8 CAN_TX_OBJ_REF_POS_122_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_123_t
typedef uint8 CAN_TX_OBJ_REF_POS_123_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_124_t
typedef uint8 CAN_TX_OBJ_REF_POS_124_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_125_t
typedef uint8 CAN_TX_OBJ_REF_POS_125_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_126_t
typedef uint8 CAN_TX_OBJ_REF_POS_126_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_127_t
typedef uint8 CAN_TX_OBJ_REF_POS_127_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_12_t
typedef uint8 CAN_TX_OBJ_REF_POS_12_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_13_t
typedef uint8 CAN_TX_OBJ_REF_POS_13_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_14_t
typedef uint8 CAN_TX_OBJ_REF_POS_14_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_15_t
typedef uint8 CAN_TX_OBJ_REF_POS_15_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_16_t
typedef uint8 CAN_TX_OBJ_REF_POS_16_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_17_t
typedef uint8 CAN_TX_OBJ_REF_POS_17_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_18_t
typedef uint8 CAN_TX_OBJ_REF_POS_18_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_19_t
typedef uint8 CAN_TX_OBJ_REF_POS_19_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_1_t
typedef uint8 CAN_TX_OBJ_REF_POS_1_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_20_t
typedef uint8 CAN_TX_OBJ_REF_POS_20_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_21_t
typedef uint8 CAN_TX_OBJ_REF_POS_21_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_22_t
typedef uint8 CAN_TX_OBJ_REF_POS_22_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_23_t
typedef uint8 CAN_TX_OBJ_REF_POS_23_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_24_t
typedef uint8 CAN_TX_OBJ_REF_POS_24_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_25_t
typedef uint8 CAN_TX_OBJ_REF_POS_25_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_26_t
typedef uint8 CAN_TX_OBJ_REF_POS_26_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_27_t
typedef uint8 CAN_TX_OBJ_REF_POS_27_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_28_t
typedef uint8 CAN_TX_OBJ_REF_POS_28_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_29_t
typedef uint8 CAN_TX_OBJ_REF_POS_29_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_2_t
typedef uint8 CAN_TX_OBJ_REF_POS_2_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_30_t
typedef uint8 CAN_TX_OBJ_REF_POS_30_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_31_t
typedef uint8 CAN_TX_OBJ_REF_POS_31_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_32_t
typedef uint8 CAN_TX_OBJ_REF_POS_32_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_33_t
typedef uint8 CAN_TX_OBJ_REF_POS_33_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_34_t
typedef uint8 CAN_TX_OBJ_REF_POS_34_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_35_t
typedef uint8 CAN_TX_OBJ_REF_POS_35_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_36_t
typedef uint8 CAN_TX_OBJ_REF_POS_36_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_37_t
typedef uint8 CAN_TX_OBJ_REF_POS_37_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_38_t
typedef uint8 CAN_TX_OBJ_REF_POS_38_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_39_t
typedef uint8 CAN_TX_OBJ_REF_POS_39_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_3_t
typedef uint8 CAN_TX_OBJ_REF_POS_3_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_40_t
typedef uint8 CAN_TX_OBJ_REF_POS_40_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_41_t
typedef uint8 CAN_TX_OBJ_REF_POS_41_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_42_t
typedef uint8 CAN_TX_OBJ_REF_POS_42_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_43_t
typedef uint8 CAN_TX_OBJ_REF_POS_43_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_44_t
typedef uint8 CAN_TX_OBJ_REF_POS_44_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_45_t
typedef uint8 CAN_TX_OBJ_REF_POS_45_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_46_t
typedef uint8 CAN_TX_OBJ_REF_POS_46_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_47_t
typedef uint8 CAN_TX_OBJ_REF_POS_47_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_48_t
typedef uint8 CAN_TX_OBJ_REF_POS_48_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_49_t
typedef uint8 CAN_TX_OBJ_REF_POS_49_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_4_t
typedef uint8 CAN_TX_OBJ_REF_POS_4_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_50_t
typedef uint8 CAN_TX_OBJ_REF_POS_50_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_51_t
typedef uint8 CAN_TX_OBJ_REF_POS_51_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_52_t
typedef uint8 CAN_TX_OBJ_REF_POS_52_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_53_t
typedef uint8 CAN_TX_OBJ_REF_POS_53_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_54_t
typedef uint8 CAN_TX_OBJ_REF_POS_54_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_55_t
typedef uint8 CAN_TX_OBJ_REF_POS_55_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_56_t
typedef uint8 CAN_TX_OBJ_REF_POS_56_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_57_t
typedef uint8 CAN_TX_OBJ_REF_POS_57_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_58_t
typedef uint8 CAN_TX_OBJ_REF_POS_58_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_59_t
typedef uint8 CAN_TX_OBJ_REF_POS_59_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_5_t
typedef uint8 CAN_TX_OBJ_REF_POS_5_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_60_t
typedef uint8 CAN_TX_OBJ_REF_POS_60_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_61_t
typedef uint8 CAN_TX_OBJ_REF_POS_61_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_62_t
typedef uint8 CAN_TX_OBJ_REF_POS_62_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_63_t
typedef uint8 CAN_TX_OBJ_REF_POS_63_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_64_t
typedef uint8 CAN_TX_OBJ_REF_POS_64_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_65_t
typedef uint8 CAN_TX_OBJ_REF_POS_65_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_66_t
typedef uint8 CAN_TX_OBJ_REF_POS_66_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_67_t
typedef uint8 CAN_TX_OBJ_REF_POS_67_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_68_t
typedef uint8 CAN_TX_OBJ_REF_POS_68_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_69_t
typedef uint8 CAN_TX_OBJ_REF_POS_69_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_6_t
typedef uint8 CAN_TX_OBJ_REF_POS_6_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_70_t
typedef uint8 CAN_TX_OBJ_REF_POS_70_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_71_t
typedef uint8 CAN_TX_OBJ_REF_POS_71_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_72_t
typedef uint8 CAN_TX_OBJ_REF_POS_72_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_73_t
typedef uint8 CAN_TX_OBJ_REF_POS_73_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_74_t
typedef uint8 CAN_TX_OBJ_REF_POS_74_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_75_t
typedef uint8 CAN_TX_OBJ_REF_POS_75_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_76_t
typedef uint8 CAN_TX_OBJ_REF_POS_76_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_77_t
typedef uint8 CAN_TX_OBJ_REF_POS_77_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_78_t
typedef uint8 CAN_TX_OBJ_REF_POS_78_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_79_t
typedef uint8 CAN_TX_OBJ_REF_POS_79_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_7_t
typedef uint8 CAN_TX_OBJ_REF_POS_7_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_80_t
typedef uint8 CAN_TX_OBJ_REF_POS_80_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_81_t
typedef uint8 CAN_TX_OBJ_REF_POS_81_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_82_t
typedef uint8 CAN_TX_OBJ_REF_POS_82_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_83_t
typedef uint8 CAN_TX_OBJ_REF_POS_83_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_84_t
typedef uint8 CAN_TX_OBJ_REF_POS_84_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_85_t
typedef uint8 CAN_TX_OBJ_REF_POS_85_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_86_t
typedef uint8 CAN_TX_OBJ_REF_POS_86_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_87_t
typedef uint8 CAN_TX_OBJ_REF_POS_87_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_88_t
typedef uint8 CAN_TX_OBJ_REF_POS_88_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_89_t
typedef uint8 CAN_TX_OBJ_REF_POS_89_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_8_t
typedef uint8 CAN_TX_OBJ_REF_POS_8_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_90_t
typedef uint8 CAN_TX_OBJ_REF_POS_90_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_91_t
typedef uint8 CAN_TX_OBJ_REF_POS_91_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_92_t
typedef uint8 CAN_TX_OBJ_REF_POS_92_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_93_t
typedef uint8 CAN_TX_OBJ_REF_POS_93_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_94_t
typedef uint8 CAN_TX_OBJ_REF_POS_94_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_95_t
typedef uint8 CAN_TX_OBJ_REF_POS_95_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_96_t
typedef uint8 CAN_TX_OBJ_REF_POS_96_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_97_t
typedef uint8 CAN_TX_OBJ_REF_POS_97_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_98_t
typedef uint8 CAN_TX_OBJ_REF_POS_98_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_99_t
typedef uint8 CAN_TX_OBJ_REF_POS_99_t;

#  define Rte_TypeDef_CAN_TX_OBJ_REF_POS_9_t
typedef uint8 CAN_TX_OBJ_REF_POS_9_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_0_t
typedef float32 CAN_TX_OBJ_SPEED_0_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_100_t
typedef float32 CAN_TX_OBJ_SPEED_100_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_101_t
typedef float32 CAN_TX_OBJ_SPEED_101_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_102_t
typedef float32 CAN_TX_OBJ_SPEED_102_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_103_t
typedef float32 CAN_TX_OBJ_SPEED_103_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_104_t
typedef float32 CAN_TX_OBJ_SPEED_104_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_105_t
typedef float32 CAN_TX_OBJ_SPEED_105_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_106_t
typedef float32 CAN_TX_OBJ_SPEED_106_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_107_t
typedef float32 CAN_TX_OBJ_SPEED_107_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_108_t
typedef float32 CAN_TX_OBJ_SPEED_108_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_109_t
typedef float32 CAN_TX_OBJ_SPEED_109_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_10_t
typedef float32 CAN_TX_OBJ_SPEED_10_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_110_t
typedef float32 CAN_TX_OBJ_SPEED_110_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_111_t
typedef float32 CAN_TX_OBJ_SPEED_111_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_112_t
typedef float32 CAN_TX_OBJ_SPEED_112_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_113_t
typedef float32 CAN_TX_OBJ_SPEED_113_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_114_t
typedef float32 CAN_TX_OBJ_SPEED_114_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_115_t
typedef float32 CAN_TX_OBJ_SPEED_115_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_116_t
typedef float32 CAN_TX_OBJ_SPEED_116_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_117_t
typedef float32 CAN_TX_OBJ_SPEED_117_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_118_t
typedef float32 CAN_TX_OBJ_SPEED_118_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_119_t
typedef float32 CAN_TX_OBJ_SPEED_119_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_11_t
typedef float32 CAN_TX_OBJ_SPEED_11_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_120_t
typedef float32 CAN_TX_OBJ_SPEED_120_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_121_t
typedef float32 CAN_TX_OBJ_SPEED_121_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_122_t
typedef float32 CAN_TX_OBJ_SPEED_122_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_123_t
typedef float32 CAN_TX_OBJ_SPEED_123_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_124_t
typedef float32 CAN_TX_OBJ_SPEED_124_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_125_t
typedef float32 CAN_TX_OBJ_SPEED_125_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_126_t
typedef float32 CAN_TX_OBJ_SPEED_126_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_127_t
typedef float32 CAN_TX_OBJ_SPEED_127_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_12_t
typedef float32 CAN_TX_OBJ_SPEED_12_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_13_t
typedef float32 CAN_TX_OBJ_SPEED_13_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_14_t
typedef float32 CAN_TX_OBJ_SPEED_14_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_15_t
typedef float32 CAN_TX_OBJ_SPEED_15_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_16_t
typedef float32 CAN_TX_OBJ_SPEED_16_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_17_t
typedef float32 CAN_TX_OBJ_SPEED_17_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_18_t
typedef float32 CAN_TX_OBJ_SPEED_18_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_19_t
typedef float32 CAN_TX_OBJ_SPEED_19_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_1_t
typedef float32 CAN_TX_OBJ_SPEED_1_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_20_t
typedef float32 CAN_TX_OBJ_SPEED_20_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_21_t
typedef float32 CAN_TX_OBJ_SPEED_21_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_22_t
typedef float32 CAN_TX_OBJ_SPEED_22_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_23_t
typedef float32 CAN_TX_OBJ_SPEED_23_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_24_t
typedef float32 CAN_TX_OBJ_SPEED_24_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_25_t
typedef float32 CAN_TX_OBJ_SPEED_25_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_26_t
typedef float32 CAN_TX_OBJ_SPEED_26_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_27_t
typedef float32 CAN_TX_OBJ_SPEED_27_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_28_t
typedef float32 CAN_TX_OBJ_SPEED_28_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_29_t
typedef float32 CAN_TX_OBJ_SPEED_29_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_2_t
typedef float32 CAN_TX_OBJ_SPEED_2_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_30_t
typedef float32 CAN_TX_OBJ_SPEED_30_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_31_t
typedef float32 CAN_TX_OBJ_SPEED_31_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_32_t
typedef float32 CAN_TX_OBJ_SPEED_32_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_33_t
typedef float32 CAN_TX_OBJ_SPEED_33_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_34_t
typedef float32 CAN_TX_OBJ_SPEED_34_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_35_t
typedef float32 CAN_TX_OBJ_SPEED_35_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_36_t
typedef float32 CAN_TX_OBJ_SPEED_36_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_37_t
typedef float32 CAN_TX_OBJ_SPEED_37_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_38_t
typedef float32 CAN_TX_OBJ_SPEED_38_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_39_t
typedef float32 CAN_TX_OBJ_SPEED_39_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_3_t
typedef float32 CAN_TX_OBJ_SPEED_3_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_40_t
typedef float32 CAN_TX_OBJ_SPEED_40_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_41_t
typedef float32 CAN_TX_OBJ_SPEED_41_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_42_t
typedef float32 CAN_TX_OBJ_SPEED_42_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_43_t
typedef float32 CAN_TX_OBJ_SPEED_43_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_44_t
typedef float32 CAN_TX_OBJ_SPEED_44_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_45_t
typedef float32 CAN_TX_OBJ_SPEED_45_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_46_t
typedef float32 CAN_TX_OBJ_SPEED_46_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_47_t
typedef float32 CAN_TX_OBJ_SPEED_47_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_48_t
typedef float32 CAN_TX_OBJ_SPEED_48_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_49_t
typedef float32 CAN_TX_OBJ_SPEED_49_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_4_t
typedef float32 CAN_TX_OBJ_SPEED_4_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_50_t
typedef float32 CAN_TX_OBJ_SPEED_50_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_51_t
typedef float32 CAN_TX_OBJ_SPEED_51_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_52_t
typedef float32 CAN_TX_OBJ_SPEED_52_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_53_t
typedef float32 CAN_TX_OBJ_SPEED_53_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_54_t
typedef float32 CAN_TX_OBJ_SPEED_54_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_55_t
typedef float32 CAN_TX_OBJ_SPEED_55_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_56_t
typedef float32 CAN_TX_OBJ_SPEED_56_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_57_t
typedef float32 CAN_TX_OBJ_SPEED_57_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_58_t
typedef float32 CAN_TX_OBJ_SPEED_58_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_59_t
typedef float32 CAN_TX_OBJ_SPEED_59_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_5_t
typedef float32 CAN_TX_OBJ_SPEED_5_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_60_t
typedef float32 CAN_TX_OBJ_SPEED_60_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_61_t
typedef float32 CAN_TX_OBJ_SPEED_61_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_62_t
typedef float32 CAN_TX_OBJ_SPEED_62_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_63_t
typedef float32 CAN_TX_OBJ_SPEED_63_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_64_t
typedef float32 CAN_TX_OBJ_SPEED_64_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_65_t
typedef float32 CAN_TX_OBJ_SPEED_65_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_66_t
typedef float32 CAN_TX_OBJ_SPEED_66_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_67_t
typedef float32 CAN_TX_OBJ_SPEED_67_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_68_t
typedef float32 CAN_TX_OBJ_SPEED_68_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_69_t
typedef float32 CAN_TX_OBJ_SPEED_69_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_6_t
typedef float32 CAN_TX_OBJ_SPEED_6_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_70_t
typedef float32 CAN_TX_OBJ_SPEED_70_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_71_t
typedef float32 CAN_TX_OBJ_SPEED_71_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_72_t
typedef float32 CAN_TX_OBJ_SPEED_72_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_73_t
typedef float32 CAN_TX_OBJ_SPEED_73_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_74_t
typedef float32 CAN_TX_OBJ_SPEED_74_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_75_t
typedef float32 CAN_TX_OBJ_SPEED_75_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_76_t
typedef float32 CAN_TX_OBJ_SPEED_76_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_77_t
typedef float32 CAN_TX_OBJ_SPEED_77_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_78_t
typedef float32 CAN_TX_OBJ_SPEED_78_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_79_t
typedef float32 CAN_TX_OBJ_SPEED_79_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_7_t
typedef float32 CAN_TX_OBJ_SPEED_7_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_80_t
typedef float32 CAN_TX_OBJ_SPEED_80_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_81_t
typedef float32 CAN_TX_OBJ_SPEED_81_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_82_t
typedef float32 CAN_TX_OBJ_SPEED_82_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_83_t
typedef float32 CAN_TX_OBJ_SPEED_83_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_84_t
typedef float32 CAN_TX_OBJ_SPEED_84_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_85_t
typedef float32 CAN_TX_OBJ_SPEED_85_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_86_t
typedef float32 CAN_TX_OBJ_SPEED_86_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_87_t
typedef float32 CAN_TX_OBJ_SPEED_87_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_88_t
typedef float32 CAN_TX_OBJ_SPEED_88_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_89_t
typedef float32 CAN_TX_OBJ_SPEED_89_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_8_t
typedef float32 CAN_TX_OBJ_SPEED_8_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_90_t
typedef float32 CAN_TX_OBJ_SPEED_90_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_91_t
typedef float32 CAN_TX_OBJ_SPEED_91_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_92_t
typedef float32 CAN_TX_OBJ_SPEED_92_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_93_t
typedef float32 CAN_TX_OBJ_SPEED_93_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_94_t
typedef float32 CAN_TX_OBJ_SPEED_94_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_95_t
typedef float32 CAN_TX_OBJ_SPEED_95_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_96_t
typedef float32 CAN_TX_OBJ_SPEED_96_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_97_t
typedef float32 CAN_TX_OBJ_SPEED_97_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_98_t
typedef float32 CAN_TX_OBJ_SPEED_98_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_99_t
typedef float32 CAN_TX_OBJ_SPEED_99_t;

#  define Rte_TypeDef_CAN_TX_OBJ_SPEED_9_t
typedef float32 CAN_TX_OBJ_SPEED_9_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_0_t
typedef boolean CAN_TX_OBJ_STATIONARY_0_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_100_t
typedef boolean CAN_TX_OBJ_STATIONARY_100_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_101_t
typedef boolean CAN_TX_OBJ_STATIONARY_101_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_102_t
typedef boolean CAN_TX_OBJ_STATIONARY_102_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_103_t
typedef boolean CAN_TX_OBJ_STATIONARY_103_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_104_t
typedef boolean CAN_TX_OBJ_STATIONARY_104_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_105_t
typedef boolean CAN_TX_OBJ_STATIONARY_105_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_106_t
typedef boolean CAN_TX_OBJ_STATIONARY_106_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_107_t
typedef boolean CAN_TX_OBJ_STATIONARY_107_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_108_t
typedef boolean CAN_TX_OBJ_STATIONARY_108_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_109_t
typedef boolean CAN_TX_OBJ_STATIONARY_109_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_10_t
typedef boolean CAN_TX_OBJ_STATIONARY_10_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_110_t
typedef boolean CAN_TX_OBJ_STATIONARY_110_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_111_t
typedef boolean CAN_TX_OBJ_STATIONARY_111_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_112_t
typedef boolean CAN_TX_OBJ_STATIONARY_112_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_113_t
typedef boolean CAN_TX_OBJ_STATIONARY_113_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_114_t
typedef boolean CAN_TX_OBJ_STATIONARY_114_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_115_t
typedef boolean CAN_TX_OBJ_STATIONARY_115_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_116_t
typedef boolean CAN_TX_OBJ_STATIONARY_116_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_117_t
typedef boolean CAN_TX_OBJ_STATIONARY_117_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_118_t
typedef boolean CAN_TX_OBJ_STATIONARY_118_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_119_t
typedef boolean CAN_TX_OBJ_STATIONARY_119_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_11_t
typedef boolean CAN_TX_OBJ_STATIONARY_11_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_120_t
typedef boolean CAN_TX_OBJ_STATIONARY_120_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_121_t
typedef boolean CAN_TX_OBJ_STATIONARY_121_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_122_t
typedef boolean CAN_TX_OBJ_STATIONARY_122_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_123_t
typedef boolean CAN_TX_OBJ_STATIONARY_123_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_124_t
typedef boolean CAN_TX_OBJ_STATIONARY_124_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_125_t
typedef boolean CAN_TX_OBJ_STATIONARY_125_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_126_t
typedef boolean CAN_TX_OBJ_STATIONARY_126_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_127_t
typedef boolean CAN_TX_OBJ_STATIONARY_127_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_12_t
typedef boolean CAN_TX_OBJ_STATIONARY_12_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_13_t
typedef boolean CAN_TX_OBJ_STATIONARY_13_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_14_t
typedef boolean CAN_TX_OBJ_STATIONARY_14_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_15_t
typedef boolean CAN_TX_OBJ_STATIONARY_15_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_16_t
typedef boolean CAN_TX_OBJ_STATIONARY_16_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_17_t
typedef boolean CAN_TX_OBJ_STATIONARY_17_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_18_t
typedef boolean CAN_TX_OBJ_STATIONARY_18_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_19_t
typedef boolean CAN_TX_OBJ_STATIONARY_19_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_1_t
typedef boolean CAN_TX_OBJ_STATIONARY_1_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_20_t
typedef boolean CAN_TX_OBJ_STATIONARY_20_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_21_t
typedef boolean CAN_TX_OBJ_STATIONARY_21_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_22_t
typedef boolean CAN_TX_OBJ_STATIONARY_22_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_23_t
typedef boolean CAN_TX_OBJ_STATIONARY_23_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_24_t
typedef boolean CAN_TX_OBJ_STATIONARY_24_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_25_t
typedef boolean CAN_TX_OBJ_STATIONARY_25_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_26_t
typedef boolean CAN_TX_OBJ_STATIONARY_26_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_27_t
typedef boolean CAN_TX_OBJ_STATIONARY_27_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_28_t
typedef boolean CAN_TX_OBJ_STATIONARY_28_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_29_t
typedef boolean CAN_TX_OBJ_STATIONARY_29_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_2_t
typedef boolean CAN_TX_OBJ_STATIONARY_2_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_30_t
typedef boolean CAN_TX_OBJ_STATIONARY_30_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_31_t
typedef boolean CAN_TX_OBJ_STATIONARY_31_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_32_t
typedef boolean CAN_TX_OBJ_STATIONARY_32_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_33_t
typedef boolean CAN_TX_OBJ_STATIONARY_33_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_34_t
typedef boolean CAN_TX_OBJ_STATIONARY_34_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_35_t
typedef boolean CAN_TX_OBJ_STATIONARY_35_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_36_t
typedef boolean CAN_TX_OBJ_STATIONARY_36_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_37_t
typedef boolean CAN_TX_OBJ_STATIONARY_37_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_38_t
typedef boolean CAN_TX_OBJ_STATIONARY_38_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_39_t
typedef boolean CAN_TX_OBJ_STATIONARY_39_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_3_t
typedef boolean CAN_TX_OBJ_STATIONARY_3_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_40_t
typedef boolean CAN_TX_OBJ_STATIONARY_40_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_41_t
typedef boolean CAN_TX_OBJ_STATIONARY_41_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_42_t
typedef boolean CAN_TX_OBJ_STATIONARY_42_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_43_t
typedef boolean CAN_TX_OBJ_STATIONARY_43_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_44_t
typedef boolean CAN_TX_OBJ_STATIONARY_44_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_45_t
typedef boolean CAN_TX_OBJ_STATIONARY_45_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_46_t
typedef boolean CAN_TX_OBJ_STATIONARY_46_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_47_t
typedef boolean CAN_TX_OBJ_STATIONARY_47_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_48_t
typedef boolean CAN_TX_OBJ_STATIONARY_48_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_49_t
typedef boolean CAN_TX_OBJ_STATIONARY_49_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_4_t
typedef boolean CAN_TX_OBJ_STATIONARY_4_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_50_t
typedef boolean CAN_TX_OBJ_STATIONARY_50_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_51_t
typedef boolean CAN_TX_OBJ_STATIONARY_51_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_52_t
typedef boolean CAN_TX_OBJ_STATIONARY_52_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_53_t
typedef boolean CAN_TX_OBJ_STATIONARY_53_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_54_t
typedef boolean CAN_TX_OBJ_STATIONARY_54_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_55_t
typedef boolean CAN_TX_OBJ_STATIONARY_55_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_56_t
typedef boolean CAN_TX_OBJ_STATIONARY_56_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_57_t
typedef boolean CAN_TX_OBJ_STATIONARY_57_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_58_t
typedef boolean CAN_TX_OBJ_STATIONARY_58_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_59_t
typedef boolean CAN_TX_OBJ_STATIONARY_59_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_5_t
typedef boolean CAN_TX_OBJ_STATIONARY_5_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_60_t
typedef boolean CAN_TX_OBJ_STATIONARY_60_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_61_t
typedef boolean CAN_TX_OBJ_STATIONARY_61_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_62_t
typedef boolean CAN_TX_OBJ_STATIONARY_62_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_63_t
typedef boolean CAN_TX_OBJ_STATIONARY_63_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_64_t
typedef boolean CAN_TX_OBJ_STATIONARY_64_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_65_t
typedef boolean CAN_TX_OBJ_STATIONARY_65_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_66_t
typedef boolean CAN_TX_OBJ_STATIONARY_66_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_67_t
typedef boolean CAN_TX_OBJ_STATIONARY_67_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_68_t
typedef boolean CAN_TX_OBJ_STATIONARY_68_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_69_t
typedef boolean CAN_TX_OBJ_STATIONARY_69_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_6_t
typedef boolean CAN_TX_OBJ_STATIONARY_6_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_70_t
typedef boolean CAN_TX_OBJ_STATIONARY_70_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_71_t
typedef boolean CAN_TX_OBJ_STATIONARY_71_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_72_t
typedef boolean CAN_TX_OBJ_STATIONARY_72_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_73_t
typedef boolean CAN_TX_OBJ_STATIONARY_73_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_74_t
typedef boolean CAN_TX_OBJ_STATIONARY_74_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_75_t
typedef boolean CAN_TX_OBJ_STATIONARY_75_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_76_t
typedef boolean CAN_TX_OBJ_STATIONARY_76_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_77_t
typedef boolean CAN_TX_OBJ_STATIONARY_77_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_78_t
typedef boolean CAN_TX_OBJ_STATIONARY_78_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_79_t
typedef boolean CAN_TX_OBJ_STATIONARY_79_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_7_t
typedef boolean CAN_TX_OBJ_STATIONARY_7_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_80_t
typedef boolean CAN_TX_OBJ_STATIONARY_80_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_81_t
typedef boolean CAN_TX_OBJ_STATIONARY_81_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_82_t
typedef boolean CAN_TX_OBJ_STATIONARY_82_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_83_t
typedef boolean CAN_TX_OBJ_STATIONARY_83_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_84_t
typedef boolean CAN_TX_OBJ_STATIONARY_84_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_85_t
typedef boolean CAN_TX_OBJ_STATIONARY_85_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_86_t
typedef boolean CAN_TX_OBJ_STATIONARY_86_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_87_t
typedef boolean CAN_TX_OBJ_STATIONARY_87_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_88_t
typedef boolean CAN_TX_OBJ_STATIONARY_88_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_89_t
typedef boolean CAN_TX_OBJ_STATIONARY_89_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_8_t
typedef boolean CAN_TX_OBJ_STATIONARY_8_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_90_t
typedef boolean CAN_TX_OBJ_STATIONARY_90_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_91_t
typedef boolean CAN_TX_OBJ_STATIONARY_91_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_92_t
typedef boolean CAN_TX_OBJ_STATIONARY_92_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_93_t
typedef boolean CAN_TX_OBJ_STATIONARY_93_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_94_t
typedef boolean CAN_TX_OBJ_STATIONARY_94_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_95_t
typedef boolean CAN_TX_OBJ_STATIONARY_95_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_96_t
typedef boolean CAN_TX_OBJ_STATIONARY_96_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_97_t
typedef boolean CAN_TX_OBJ_STATIONARY_97_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_98_t
typedef boolean CAN_TX_OBJ_STATIONARY_98_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_99_t
typedef boolean CAN_TX_OBJ_STATIONARY_99_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATIONARY_9_t
typedef boolean CAN_TX_OBJ_STATIONARY_9_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_0_t
typedef uint8 CAN_TX_OBJ_STATUS_0_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_100_t
typedef uint8 CAN_TX_OBJ_STATUS_100_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_101_t
typedef uint8 CAN_TX_OBJ_STATUS_101_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_102_t
typedef uint8 CAN_TX_OBJ_STATUS_102_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_103_t
typedef uint8 CAN_TX_OBJ_STATUS_103_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_104_t
typedef uint8 CAN_TX_OBJ_STATUS_104_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_105_t
typedef uint8 CAN_TX_OBJ_STATUS_105_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_106_t
typedef uint8 CAN_TX_OBJ_STATUS_106_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_107_t
typedef uint8 CAN_TX_OBJ_STATUS_107_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_108_t
typedef uint8 CAN_TX_OBJ_STATUS_108_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_109_t
typedef uint8 CAN_TX_OBJ_STATUS_109_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_10_t
typedef uint8 CAN_TX_OBJ_STATUS_10_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_110_t
typedef uint8 CAN_TX_OBJ_STATUS_110_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_111_t
typedef uint8 CAN_TX_OBJ_STATUS_111_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_112_t
typedef uint8 CAN_TX_OBJ_STATUS_112_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_113_t
typedef uint8 CAN_TX_OBJ_STATUS_113_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_114_t
typedef uint8 CAN_TX_OBJ_STATUS_114_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_115_t
typedef uint8 CAN_TX_OBJ_STATUS_115_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_116_t
typedef uint8 CAN_TX_OBJ_STATUS_116_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_117_t
typedef uint8 CAN_TX_OBJ_STATUS_117_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_118_t
typedef uint8 CAN_TX_OBJ_STATUS_118_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_119_t
typedef uint8 CAN_TX_OBJ_STATUS_119_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_11_t
typedef uint8 CAN_TX_OBJ_STATUS_11_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_120_t
typedef uint8 CAN_TX_OBJ_STATUS_120_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_121_t
typedef uint8 CAN_TX_OBJ_STATUS_121_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_122_t
typedef uint8 CAN_TX_OBJ_STATUS_122_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_123_t
typedef uint8 CAN_TX_OBJ_STATUS_123_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_124_t
typedef uint8 CAN_TX_OBJ_STATUS_124_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_125_t
typedef uint8 CAN_TX_OBJ_STATUS_125_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_126_t
typedef uint8 CAN_TX_OBJ_STATUS_126_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_127_t
typedef uint8 CAN_TX_OBJ_STATUS_127_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_12_t
typedef uint8 CAN_TX_OBJ_STATUS_12_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_13_t
typedef uint8 CAN_TX_OBJ_STATUS_13_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_14_t
typedef uint8 CAN_TX_OBJ_STATUS_14_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_15_t
typedef uint8 CAN_TX_OBJ_STATUS_15_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_16_t
typedef uint8 CAN_TX_OBJ_STATUS_16_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_17_t
typedef uint8 CAN_TX_OBJ_STATUS_17_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_18_t
typedef uint8 CAN_TX_OBJ_STATUS_18_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_19_t
typedef uint8 CAN_TX_OBJ_STATUS_19_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_1_t
typedef uint8 CAN_TX_OBJ_STATUS_1_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_20_t
typedef uint8 CAN_TX_OBJ_STATUS_20_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_21_t
typedef uint8 CAN_TX_OBJ_STATUS_21_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_22_t
typedef uint8 CAN_TX_OBJ_STATUS_22_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_23_t
typedef uint8 CAN_TX_OBJ_STATUS_23_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_24_t
typedef uint8 CAN_TX_OBJ_STATUS_24_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_25_t
typedef uint8 CAN_TX_OBJ_STATUS_25_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_26_t
typedef uint8 CAN_TX_OBJ_STATUS_26_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_27_t
typedef uint8 CAN_TX_OBJ_STATUS_27_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_28_t
typedef uint8 CAN_TX_OBJ_STATUS_28_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_29_t
typedef uint8 CAN_TX_OBJ_STATUS_29_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_2_t
typedef uint8 CAN_TX_OBJ_STATUS_2_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_30_t
typedef uint8 CAN_TX_OBJ_STATUS_30_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_31_t
typedef uint8 CAN_TX_OBJ_STATUS_31_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_32_t
typedef uint8 CAN_TX_OBJ_STATUS_32_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_33_t
typedef uint8 CAN_TX_OBJ_STATUS_33_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_34_t
typedef uint8 CAN_TX_OBJ_STATUS_34_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_35_t
typedef uint8 CAN_TX_OBJ_STATUS_35_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_36_t
typedef uint8 CAN_TX_OBJ_STATUS_36_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_37_t
typedef uint8 CAN_TX_OBJ_STATUS_37_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_38_t
typedef uint8 CAN_TX_OBJ_STATUS_38_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_39_t
typedef uint8 CAN_TX_OBJ_STATUS_39_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_3_t
typedef uint8 CAN_TX_OBJ_STATUS_3_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_40_t
typedef uint8 CAN_TX_OBJ_STATUS_40_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_41_t
typedef uint8 CAN_TX_OBJ_STATUS_41_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_42_t
typedef uint8 CAN_TX_OBJ_STATUS_42_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_43_t
typedef uint8 CAN_TX_OBJ_STATUS_43_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_44_t
typedef uint8 CAN_TX_OBJ_STATUS_44_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_45_t
typedef uint8 CAN_TX_OBJ_STATUS_45_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_46_t
typedef uint8 CAN_TX_OBJ_STATUS_46_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_47_t
typedef uint8 CAN_TX_OBJ_STATUS_47_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_48_t
typedef uint8 CAN_TX_OBJ_STATUS_48_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_49_t
typedef uint8 CAN_TX_OBJ_STATUS_49_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_4_t
typedef uint8 CAN_TX_OBJ_STATUS_4_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_50_t
typedef uint8 CAN_TX_OBJ_STATUS_50_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_51_t
typedef uint8 CAN_TX_OBJ_STATUS_51_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_52_t
typedef uint8 CAN_TX_OBJ_STATUS_52_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_53_t
typedef uint8 CAN_TX_OBJ_STATUS_53_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_54_t
typedef uint8 CAN_TX_OBJ_STATUS_54_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_55_t
typedef uint8 CAN_TX_OBJ_STATUS_55_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_56_t
typedef uint8 CAN_TX_OBJ_STATUS_56_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_57_t
typedef uint8 CAN_TX_OBJ_STATUS_57_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_58_t
typedef uint8 CAN_TX_OBJ_STATUS_58_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_59_t
typedef uint8 CAN_TX_OBJ_STATUS_59_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_5_t
typedef uint8 CAN_TX_OBJ_STATUS_5_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_60_t
typedef uint8 CAN_TX_OBJ_STATUS_60_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_61_t
typedef uint8 CAN_TX_OBJ_STATUS_61_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_62_t
typedef uint8 CAN_TX_OBJ_STATUS_62_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_63_t
typedef uint8 CAN_TX_OBJ_STATUS_63_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_64_t
typedef uint8 CAN_TX_OBJ_STATUS_64_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_65_t
typedef uint8 CAN_TX_OBJ_STATUS_65_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_66_t
typedef uint8 CAN_TX_OBJ_STATUS_66_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_67_t
typedef uint8 CAN_TX_OBJ_STATUS_67_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_68_t
typedef uint8 CAN_TX_OBJ_STATUS_68_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_69_t
typedef uint8 CAN_TX_OBJ_STATUS_69_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_6_t
typedef uint8 CAN_TX_OBJ_STATUS_6_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_70_t
typedef uint8 CAN_TX_OBJ_STATUS_70_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_71_t
typedef uint8 CAN_TX_OBJ_STATUS_71_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_72_t
typedef uint8 CAN_TX_OBJ_STATUS_72_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_73_t
typedef uint8 CAN_TX_OBJ_STATUS_73_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_74_t
typedef uint8 CAN_TX_OBJ_STATUS_74_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_75_t
typedef uint8 CAN_TX_OBJ_STATUS_75_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_76_t
typedef uint8 CAN_TX_OBJ_STATUS_76_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_77_t
typedef uint8 CAN_TX_OBJ_STATUS_77_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_78_t
typedef uint8 CAN_TX_OBJ_STATUS_78_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_79_t
typedef uint8 CAN_TX_OBJ_STATUS_79_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_7_t
typedef uint8 CAN_TX_OBJ_STATUS_7_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_80_t
typedef uint8 CAN_TX_OBJ_STATUS_80_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_81_t
typedef uint8 CAN_TX_OBJ_STATUS_81_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_82_t
typedef uint8 CAN_TX_OBJ_STATUS_82_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_83_t
typedef uint8 CAN_TX_OBJ_STATUS_83_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_84_t
typedef uint8 CAN_TX_OBJ_STATUS_84_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_85_t
typedef uint8 CAN_TX_OBJ_STATUS_85_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_86_t
typedef uint8 CAN_TX_OBJ_STATUS_86_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_87_t
typedef uint8 CAN_TX_OBJ_STATUS_87_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_88_t
typedef uint8 CAN_TX_OBJ_STATUS_88_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_89_t
typedef uint8 CAN_TX_OBJ_STATUS_89_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_8_t
typedef uint8 CAN_TX_OBJ_STATUS_8_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_90_t
typedef uint8 CAN_TX_OBJ_STATUS_90_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_91_t
typedef uint8 CAN_TX_OBJ_STATUS_91_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_92_t
typedef uint8 CAN_TX_OBJ_STATUS_92_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_93_t
typedef uint8 CAN_TX_OBJ_STATUS_93_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_94_t
typedef uint8 CAN_TX_OBJ_STATUS_94_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_95_t
typedef uint8 CAN_TX_OBJ_STATUS_95_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_96_t
typedef uint8 CAN_TX_OBJ_STATUS_96_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_97_t
typedef uint8 CAN_TX_OBJ_STATUS_97_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_98_t
typedef uint8 CAN_TX_OBJ_STATUS_98_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_99_t
typedef uint8 CAN_TX_OBJ_STATUS_99_t;

#  define Rte_TypeDef_CAN_TX_OBJ_STATUS_9_t
typedef uint8 CAN_TX_OBJ_STATUS_9_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_0_t
typedef boolean CAN_TX_OBJ_VALID_0_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_100_t
typedef boolean CAN_TX_OBJ_VALID_100_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_101_t
typedef boolean CAN_TX_OBJ_VALID_101_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_102_t
typedef boolean CAN_TX_OBJ_VALID_102_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_103_t
typedef boolean CAN_TX_OBJ_VALID_103_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_104_t
typedef boolean CAN_TX_OBJ_VALID_104_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_105_t
typedef boolean CAN_TX_OBJ_VALID_105_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_106_t
typedef boolean CAN_TX_OBJ_VALID_106_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_107_t
typedef boolean CAN_TX_OBJ_VALID_107_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_108_t
typedef boolean CAN_TX_OBJ_VALID_108_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_109_t
typedef boolean CAN_TX_OBJ_VALID_109_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_10_t
typedef boolean CAN_TX_OBJ_VALID_10_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_110_t
typedef boolean CAN_TX_OBJ_VALID_110_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_111_t
typedef boolean CAN_TX_OBJ_VALID_111_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_112_t
typedef boolean CAN_TX_OBJ_VALID_112_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_113_t
typedef boolean CAN_TX_OBJ_VALID_113_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_114_t
typedef boolean CAN_TX_OBJ_VALID_114_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_115_t
typedef boolean CAN_TX_OBJ_VALID_115_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_116_t
typedef boolean CAN_TX_OBJ_VALID_116_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_117_t
typedef boolean CAN_TX_OBJ_VALID_117_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_118_t
typedef boolean CAN_TX_OBJ_VALID_118_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_119_t
typedef boolean CAN_TX_OBJ_VALID_119_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_11_t
typedef boolean CAN_TX_OBJ_VALID_11_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_120_t
typedef boolean CAN_TX_OBJ_VALID_120_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_121_t
typedef boolean CAN_TX_OBJ_VALID_121_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_122_t
typedef boolean CAN_TX_OBJ_VALID_122_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_123_t
typedef boolean CAN_TX_OBJ_VALID_123_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_124_t
typedef boolean CAN_TX_OBJ_VALID_124_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_125_t
typedef boolean CAN_TX_OBJ_VALID_125_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_126_t
typedef boolean CAN_TX_OBJ_VALID_126_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_127_t
typedef boolean CAN_TX_OBJ_VALID_127_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_12_t
typedef boolean CAN_TX_OBJ_VALID_12_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_13_t
typedef boolean CAN_TX_OBJ_VALID_13_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_14_t
typedef boolean CAN_TX_OBJ_VALID_14_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_15_t
typedef boolean CAN_TX_OBJ_VALID_15_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_16_t
typedef boolean CAN_TX_OBJ_VALID_16_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_17_t
typedef boolean CAN_TX_OBJ_VALID_17_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_18_t
typedef boolean CAN_TX_OBJ_VALID_18_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_19_t
typedef boolean CAN_TX_OBJ_VALID_19_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_1_t
typedef boolean CAN_TX_OBJ_VALID_1_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_20_t
typedef boolean CAN_TX_OBJ_VALID_20_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_21_t
typedef boolean CAN_TX_OBJ_VALID_21_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_22_t
typedef boolean CAN_TX_OBJ_VALID_22_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_23_t
typedef boolean CAN_TX_OBJ_VALID_23_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_24_t
typedef boolean CAN_TX_OBJ_VALID_24_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_25_t
typedef boolean CAN_TX_OBJ_VALID_25_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_26_t
typedef boolean CAN_TX_OBJ_VALID_26_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_27_t
typedef boolean CAN_TX_OBJ_VALID_27_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_28_t
typedef boolean CAN_TX_OBJ_VALID_28_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_29_t
typedef boolean CAN_TX_OBJ_VALID_29_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_2_t
typedef boolean CAN_TX_OBJ_VALID_2_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_30_t
typedef boolean CAN_TX_OBJ_VALID_30_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_31_t
typedef boolean CAN_TX_OBJ_VALID_31_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_32_t
typedef boolean CAN_TX_OBJ_VALID_32_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_33_t
typedef boolean CAN_TX_OBJ_VALID_33_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_34_t
typedef boolean CAN_TX_OBJ_VALID_34_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_35_t
typedef boolean CAN_TX_OBJ_VALID_35_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_36_t
typedef boolean CAN_TX_OBJ_VALID_36_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_37_t
typedef boolean CAN_TX_OBJ_VALID_37_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_38_t
typedef boolean CAN_TX_OBJ_VALID_38_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_39_t
typedef boolean CAN_TX_OBJ_VALID_39_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_3_t
typedef boolean CAN_TX_OBJ_VALID_3_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_40_t
typedef boolean CAN_TX_OBJ_VALID_40_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_41_t
typedef boolean CAN_TX_OBJ_VALID_41_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_42_t
typedef boolean CAN_TX_OBJ_VALID_42_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_43_t
typedef boolean CAN_TX_OBJ_VALID_43_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_44_t
typedef boolean CAN_TX_OBJ_VALID_44_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_45_t
typedef boolean CAN_TX_OBJ_VALID_45_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_46_t
typedef boolean CAN_TX_OBJ_VALID_46_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_47_t
typedef boolean CAN_TX_OBJ_VALID_47_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_48_t
typedef boolean CAN_TX_OBJ_VALID_48_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_49_t
typedef boolean CAN_TX_OBJ_VALID_49_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_4_t
typedef boolean CAN_TX_OBJ_VALID_4_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_50_t
typedef boolean CAN_TX_OBJ_VALID_50_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_51_t
typedef boolean CAN_TX_OBJ_VALID_51_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_52_t
typedef boolean CAN_TX_OBJ_VALID_52_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_53_t
typedef boolean CAN_TX_OBJ_VALID_53_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_54_t
typedef boolean CAN_TX_OBJ_VALID_54_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_55_t
typedef boolean CAN_TX_OBJ_VALID_55_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_56_t
typedef boolean CAN_TX_OBJ_VALID_56_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_57_t
typedef boolean CAN_TX_OBJ_VALID_57_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_58_t
typedef boolean CAN_TX_OBJ_VALID_58_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_59_t
typedef boolean CAN_TX_OBJ_VALID_59_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_5_t
typedef boolean CAN_TX_OBJ_VALID_5_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_60_t
typedef boolean CAN_TX_OBJ_VALID_60_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_61_t
typedef boolean CAN_TX_OBJ_VALID_61_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_62_t
typedef boolean CAN_TX_OBJ_VALID_62_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_63_t
typedef boolean CAN_TX_OBJ_VALID_63_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_64_t
typedef boolean CAN_TX_OBJ_VALID_64_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_65_t
typedef boolean CAN_TX_OBJ_VALID_65_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_66_t
typedef boolean CAN_TX_OBJ_VALID_66_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_67_t
typedef boolean CAN_TX_OBJ_VALID_67_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_68_t
typedef boolean CAN_TX_OBJ_VALID_68_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_69_t
typedef boolean CAN_TX_OBJ_VALID_69_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_6_t
typedef boolean CAN_TX_OBJ_VALID_6_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_70_t
typedef boolean CAN_TX_OBJ_VALID_70_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_71_t
typedef boolean CAN_TX_OBJ_VALID_71_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_72_t
typedef boolean CAN_TX_OBJ_VALID_72_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_73_t
typedef boolean CAN_TX_OBJ_VALID_73_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_74_t
typedef boolean CAN_TX_OBJ_VALID_74_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_75_t
typedef boolean CAN_TX_OBJ_VALID_75_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_76_t
typedef boolean CAN_TX_OBJ_VALID_76_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_77_t
typedef boolean CAN_TX_OBJ_VALID_77_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_78_t
typedef boolean CAN_TX_OBJ_VALID_78_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_79_t
typedef boolean CAN_TX_OBJ_VALID_79_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_7_t
typedef boolean CAN_TX_OBJ_VALID_7_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_80_t
typedef boolean CAN_TX_OBJ_VALID_80_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_81_t
typedef boolean CAN_TX_OBJ_VALID_81_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_82_t
typedef boolean CAN_TX_OBJ_VALID_82_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_83_t
typedef boolean CAN_TX_OBJ_VALID_83_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_84_t
typedef boolean CAN_TX_OBJ_VALID_84_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_85_t
typedef boolean CAN_TX_OBJ_VALID_85_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_86_t
typedef boolean CAN_TX_OBJ_VALID_86_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_87_t
typedef boolean CAN_TX_OBJ_VALID_87_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_88_t
typedef boolean CAN_TX_OBJ_VALID_88_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_89_t
typedef boolean CAN_TX_OBJ_VALID_89_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_8_t
typedef boolean CAN_TX_OBJ_VALID_8_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_90_t
typedef boolean CAN_TX_OBJ_VALID_90_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_91_t
typedef boolean CAN_TX_OBJ_VALID_91_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_92_t
typedef boolean CAN_TX_OBJ_VALID_92_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_93_t
typedef boolean CAN_TX_OBJ_VALID_93_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_94_t
typedef boolean CAN_TX_OBJ_VALID_94_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_95_t
typedef boolean CAN_TX_OBJ_VALID_95_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_96_t
typedef boolean CAN_TX_OBJ_VALID_96_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_97_t
typedef boolean CAN_TX_OBJ_VALID_97_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_98_t
typedef boolean CAN_TX_OBJ_VALID_98_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_99_t
typedef boolean CAN_TX_OBJ_VALID_99_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VALID_9_t
typedef boolean CAN_TX_OBJ_VALID_9_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_0_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_0_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_100_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_100_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_101_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_101_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_102_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_102_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_103_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_103_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_104_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_104_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_105_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_105_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_106_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_106_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_107_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_107_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_108_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_108_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_109_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_109_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_10_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_10_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_110_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_110_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_111_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_111_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_112_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_112_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_113_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_113_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_114_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_114_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_115_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_115_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_116_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_116_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_117_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_117_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_118_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_118_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_119_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_119_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_11_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_11_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_120_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_120_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_121_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_121_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_122_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_122_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_123_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_123_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_124_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_124_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_125_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_125_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_126_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_126_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_127_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_127_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_12_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_12_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_13_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_13_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_14_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_14_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_15_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_15_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_16_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_16_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_17_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_17_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_18_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_18_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_19_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_19_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_1_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_1_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_20_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_20_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_21_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_21_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_22_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_22_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_23_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_23_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_24_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_24_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_25_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_25_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_26_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_26_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_27_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_27_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_28_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_28_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_29_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_29_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_2_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_2_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_30_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_30_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_31_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_31_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_32_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_32_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_33_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_33_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_34_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_34_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_35_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_35_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_36_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_36_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_37_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_37_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_38_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_38_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_39_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_39_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_3_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_3_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_40_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_40_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_41_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_41_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_42_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_42_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_43_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_43_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_44_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_44_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_45_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_45_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_46_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_46_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_47_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_47_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_48_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_48_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_49_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_49_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_4_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_4_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_50_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_50_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_51_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_51_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_52_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_52_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_53_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_53_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_54_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_54_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_55_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_55_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_56_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_56_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_57_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_57_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_58_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_58_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_59_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_59_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_5_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_5_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_60_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_60_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_61_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_61_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_62_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_62_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_63_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_63_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_64_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_64_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_65_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_65_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_66_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_66_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_67_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_67_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_68_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_68_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_69_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_69_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_6_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_6_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_70_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_70_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_71_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_71_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_72_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_72_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_73_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_73_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_74_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_74_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_75_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_75_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_76_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_76_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_77_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_77_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_78_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_78_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_79_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_79_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_7_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_7_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_80_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_80_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_81_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_81_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_82_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_82_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_83_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_83_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_84_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_84_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_85_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_85_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_86_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_86_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_87_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_87_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_88_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_88_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_89_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_89_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_8_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_8_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_90_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_90_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_91_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_91_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_92_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_92_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_93_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_93_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_94_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_94_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_95_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_95_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_96_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_96_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_97_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_97_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_98_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_98_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_99_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_99_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LAT_9_t
typedef float32 CAN_TX_OBJ_VEL_REL_LAT_9_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_0_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_0_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_100_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_100_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_101_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_101_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_102_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_102_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_103_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_103_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_104_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_104_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_105_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_105_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_106_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_106_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_107_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_107_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_108_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_108_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_109_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_109_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_10_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_10_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_110_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_110_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_111_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_111_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_112_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_112_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_113_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_113_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_114_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_114_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_115_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_115_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_116_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_116_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_117_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_117_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_118_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_118_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_119_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_119_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_11_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_11_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_120_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_120_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_121_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_121_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_122_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_122_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_123_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_123_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_124_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_124_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_125_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_125_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_126_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_126_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_127_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_127_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_12_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_12_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_13_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_13_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_14_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_14_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_15_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_15_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_16_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_16_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_17_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_17_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_18_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_18_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_19_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_19_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_1_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_1_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_20_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_20_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_21_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_21_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_22_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_22_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_23_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_23_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_24_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_24_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_25_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_25_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_26_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_26_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_27_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_27_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_28_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_28_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_29_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_29_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_2_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_2_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_30_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_30_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_31_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_31_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_32_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_32_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_33_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_33_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_34_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_34_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_35_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_35_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_36_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_36_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_37_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_37_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_38_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_38_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_39_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_39_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_3_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_3_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_40_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_40_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_41_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_41_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_42_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_42_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_43_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_43_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_44_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_44_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_45_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_45_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_46_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_46_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_47_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_47_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_48_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_48_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_49_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_49_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_4_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_4_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_50_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_50_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_51_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_51_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_52_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_52_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_53_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_53_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_54_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_54_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_55_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_55_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_56_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_56_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_57_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_57_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_58_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_58_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_59_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_59_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_5_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_5_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_60_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_60_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_61_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_61_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_62_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_62_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_63_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_63_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_64_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_64_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_65_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_65_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_66_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_66_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_67_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_67_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_68_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_68_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_69_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_69_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_6_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_6_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_70_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_70_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_71_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_71_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_72_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_72_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_73_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_73_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_74_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_74_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_75_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_75_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_76_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_76_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_77_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_77_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_78_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_78_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_79_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_79_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_7_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_7_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_80_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_80_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_81_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_81_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_82_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_82_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_83_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_83_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_84_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_84_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_85_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_85_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_86_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_86_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_87_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_87_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_88_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_88_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_89_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_89_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_8_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_8_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_90_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_90_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_91_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_91_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_92_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_92_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_93_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_93_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_94_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_94_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_95_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_95_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_96_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_96_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_97_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_97_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_98_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_98_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_99_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_99_t;

#  define Rte_TypeDef_CAN_TX_OBJ_VEL_REL_LONG_9_t
typedef float32 CAN_TX_OBJ_VEL_REL_LONG_9_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_0_t
typedef float32 CAN_TX_OBJ_WIDTH_0_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_100_t
typedef float32 CAN_TX_OBJ_WIDTH_100_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_101_t
typedef float32 CAN_TX_OBJ_WIDTH_101_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_102_t
typedef float32 CAN_TX_OBJ_WIDTH_102_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_103_t
typedef float32 CAN_TX_OBJ_WIDTH_103_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_104_t
typedef float32 CAN_TX_OBJ_WIDTH_104_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_105_t
typedef float32 CAN_TX_OBJ_WIDTH_105_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_106_t
typedef float32 CAN_TX_OBJ_WIDTH_106_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_107_t
typedef float32 CAN_TX_OBJ_WIDTH_107_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_108_t
typedef float32 CAN_TX_OBJ_WIDTH_108_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_109_t
typedef float32 CAN_TX_OBJ_WIDTH_109_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_10_t
typedef float32 CAN_TX_OBJ_WIDTH_10_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_110_t
typedef float32 CAN_TX_OBJ_WIDTH_110_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_111_t
typedef float32 CAN_TX_OBJ_WIDTH_111_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_112_t
typedef float32 CAN_TX_OBJ_WIDTH_112_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_113_t
typedef float32 CAN_TX_OBJ_WIDTH_113_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_114_t
typedef float32 CAN_TX_OBJ_WIDTH_114_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_115_t
typedef float32 CAN_TX_OBJ_WIDTH_115_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_116_t
typedef float32 CAN_TX_OBJ_WIDTH_116_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_117_t
typedef float32 CAN_TX_OBJ_WIDTH_117_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_118_t
typedef float32 CAN_TX_OBJ_WIDTH_118_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_119_t
typedef float32 CAN_TX_OBJ_WIDTH_119_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_11_t
typedef float32 CAN_TX_OBJ_WIDTH_11_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_120_t
typedef float32 CAN_TX_OBJ_WIDTH_120_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_121_t
typedef float32 CAN_TX_OBJ_WIDTH_121_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_122_t
typedef float32 CAN_TX_OBJ_WIDTH_122_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_123_t
typedef float32 CAN_TX_OBJ_WIDTH_123_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_124_t
typedef float32 CAN_TX_OBJ_WIDTH_124_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_125_t
typedef float32 CAN_TX_OBJ_WIDTH_125_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_126_t
typedef float32 CAN_TX_OBJ_WIDTH_126_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_127_t
typedef float32 CAN_TX_OBJ_WIDTH_127_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_12_t
typedef float32 CAN_TX_OBJ_WIDTH_12_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_13_t
typedef float32 CAN_TX_OBJ_WIDTH_13_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_14_t
typedef float32 CAN_TX_OBJ_WIDTH_14_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_15_t
typedef float32 CAN_TX_OBJ_WIDTH_15_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_16_t
typedef float32 CAN_TX_OBJ_WIDTH_16_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_17_t
typedef float32 CAN_TX_OBJ_WIDTH_17_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_18_t
typedef float32 CAN_TX_OBJ_WIDTH_18_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_19_t
typedef float32 CAN_TX_OBJ_WIDTH_19_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_1_t
typedef float32 CAN_TX_OBJ_WIDTH_1_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_20_t
typedef float32 CAN_TX_OBJ_WIDTH_20_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_21_t
typedef float32 CAN_TX_OBJ_WIDTH_21_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_22_t
typedef float32 CAN_TX_OBJ_WIDTH_22_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_23_t
typedef float32 CAN_TX_OBJ_WIDTH_23_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_24_t
typedef float32 CAN_TX_OBJ_WIDTH_24_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_25_t
typedef float32 CAN_TX_OBJ_WIDTH_25_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_26_t
typedef float32 CAN_TX_OBJ_WIDTH_26_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_27_t
typedef float32 CAN_TX_OBJ_WIDTH_27_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_28_t
typedef float32 CAN_TX_OBJ_WIDTH_28_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_29_t
typedef float32 CAN_TX_OBJ_WIDTH_29_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_2_t
typedef float32 CAN_TX_OBJ_WIDTH_2_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_30_t
typedef float32 CAN_TX_OBJ_WIDTH_30_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_31_t
typedef float32 CAN_TX_OBJ_WIDTH_31_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_32_t
typedef float32 CAN_TX_OBJ_WIDTH_32_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_33_t
typedef float32 CAN_TX_OBJ_WIDTH_33_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_34_t
typedef float32 CAN_TX_OBJ_WIDTH_34_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_35_t
typedef float32 CAN_TX_OBJ_WIDTH_35_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_36_t
typedef float32 CAN_TX_OBJ_WIDTH_36_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_37_t
typedef float32 CAN_TX_OBJ_WIDTH_37_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_38_t
typedef float32 CAN_TX_OBJ_WIDTH_38_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_39_t
typedef float32 CAN_TX_OBJ_WIDTH_39_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_3_t
typedef float32 CAN_TX_OBJ_WIDTH_3_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_40_t
typedef float32 CAN_TX_OBJ_WIDTH_40_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_41_t
typedef float32 CAN_TX_OBJ_WIDTH_41_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_42_t
typedef float32 CAN_TX_OBJ_WIDTH_42_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_43_t
typedef float32 CAN_TX_OBJ_WIDTH_43_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_44_t
typedef float32 CAN_TX_OBJ_WIDTH_44_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_45_t
typedef float32 CAN_TX_OBJ_WIDTH_45_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_46_t
typedef float32 CAN_TX_OBJ_WIDTH_46_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_47_t
typedef float32 CAN_TX_OBJ_WIDTH_47_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_48_t
typedef float32 CAN_TX_OBJ_WIDTH_48_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_49_t
typedef float32 CAN_TX_OBJ_WIDTH_49_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_4_t
typedef float32 CAN_TX_OBJ_WIDTH_4_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_50_t
typedef float32 CAN_TX_OBJ_WIDTH_50_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_51_t
typedef float32 CAN_TX_OBJ_WIDTH_51_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_52_t
typedef float32 CAN_TX_OBJ_WIDTH_52_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_53_t
typedef float32 CAN_TX_OBJ_WIDTH_53_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_54_t
typedef float32 CAN_TX_OBJ_WIDTH_54_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_55_t
typedef float32 CAN_TX_OBJ_WIDTH_55_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_56_t
typedef float32 CAN_TX_OBJ_WIDTH_56_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_57_t
typedef float32 CAN_TX_OBJ_WIDTH_57_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_58_t
typedef float32 CAN_TX_OBJ_WIDTH_58_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_59_t
typedef float32 CAN_TX_OBJ_WIDTH_59_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_5_t
typedef float32 CAN_TX_OBJ_WIDTH_5_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_60_t
typedef float32 CAN_TX_OBJ_WIDTH_60_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_61_t
typedef float32 CAN_TX_OBJ_WIDTH_61_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_62_t
typedef float32 CAN_TX_OBJ_WIDTH_62_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_63_t
typedef float32 CAN_TX_OBJ_WIDTH_63_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_64_t
typedef float32 CAN_TX_OBJ_WIDTH_64_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_65_t
typedef float32 CAN_TX_OBJ_WIDTH_65_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_66_t
typedef float32 CAN_TX_OBJ_WIDTH_66_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_67_t
typedef float32 CAN_TX_OBJ_WIDTH_67_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_68_t
typedef float32 CAN_TX_OBJ_WIDTH_68_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_69_t
typedef float32 CAN_TX_OBJ_WIDTH_69_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_6_t
typedef float32 CAN_TX_OBJ_WIDTH_6_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_70_t
typedef float32 CAN_TX_OBJ_WIDTH_70_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_71_t
typedef float32 CAN_TX_OBJ_WIDTH_71_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_72_t
typedef float32 CAN_TX_OBJ_WIDTH_72_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_73_t
typedef float32 CAN_TX_OBJ_WIDTH_73_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_74_t
typedef float32 CAN_TX_OBJ_WIDTH_74_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_75_t
typedef float32 CAN_TX_OBJ_WIDTH_75_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_76_t
typedef float32 CAN_TX_OBJ_WIDTH_76_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_77_t
typedef float32 CAN_TX_OBJ_WIDTH_77_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_78_t
typedef float32 CAN_TX_OBJ_WIDTH_78_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_79_t
typedef float32 CAN_TX_OBJ_WIDTH_79_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_7_t
typedef float32 CAN_TX_OBJ_WIDTH_7_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_80_t
typedef float32 CAN_TX_OBJ_WIDTH_80_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_81_t
typedef float32 CAN_TX_OBJ_WIDTH_81_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_82_t
typedef float32 CAN_TX_OBJ_WIDTH_82_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_83_t
typedef float32 CAN_TX_OBJ_WIDTH_83_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_84_t
typedef float32 CAN_TX_OBJ_WIDTH_84_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_85_t
typedef float32 CAN_TX_OBJ_WIDTH_85_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_86_t
typedef float32 CAN_TX_OBJ_WIDTH_86_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_87_t
typedef float32 CAN_TX_OBJ_WIDTH_87_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_88_t
typedef float32 CAN_TX_OBJ_WIDTH_88_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_89_t
typedef float32 CAN_TX_OBJ_WIDTH_89_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_8_t
typedef float32 CAN_TX_OBJ_WIDTH_8_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_90_t
typedef float32 CAN_TX_OBJ_WIDTH_90_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_91_t
typedef float32 CAN_TX_OBJ_WIDTH_91_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_92_t
typedef float32 CAN_TX_OBJ_WIDTH_92_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_93_t
typedef float32 CAN_TX_OBJ_WIDTH_93_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_94_t
typedef float32 CAN_TX_OBJ_WIDTH_94_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_95_t
typedef float32 CAN_TX_OBJ_WIDTH_95_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_96_t
typedef float32 CAN_TX_OBJ_WIDTH_96_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_97_t
typedef float32 CAN_TX_OBJ_WIDTH_97_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_98_t
typedef float32 CAN_TX_OBJ_WIDTH_98_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_99_t
typedef float32 CAN_TX_OBJ_WIDTH_99_t;

#  define Rte_TypeDef_CAN_TX_OBJ_WIDTH_9_t
typedef float32 CAN_TX_OBJ_WIDTH_9_t;

#  define Rte_TypeDef_CDCS10_WorK_status
typedef uint8 CDCS10_WorK_status;

#  define Rte_TypeDef_CDCS11_ACCOnOffSet
typedef uint8 CDCS11_ACCOnOffSet;

#  define Rte_TypeDef_CDCS11_ACCOnOffSet_t
typedef uint8 CDCS11_ACCOnOffSet_t;

#  define Rte_TypeDef_CDCS11_ADAS_SndCtrlOnOff
typedef uint8 CDCS11_ADAS_SndCtrlOnOff;

#  define Rte_TypeDef_CDCS11_ADAS_SndCtrlOnOff_t
typedef uint8 CDCS11_ADAS_SndCtrlOnOff_t;

#  define Rte_TypeDef_CDCS11_ADSDriving_mode
typedef uint8 CDCS11_ADSDriving_mode;

#  define Rte_TypeDef_CDCS11_AEB_OnOffSet
typedef uint8 CDCS11_AEB_OnOffSet;

#  define Rte_TypeDef_CDCS11_AEB_OnOffSet_t
typedef uint8 CDCS11_AEB_OnOffSet_t;

#  define Rte_TypeDef_CDCS11_ALCSysState
typedef uint8 CDCS11_ALCSysState;

#  define Rte_TypeDef_CDCS11_ALCSysState_t
typedef uint8 CDCS11_ALCSysState_t;

#  define Rte_TypeDef_CDCS11_ALC_mode
typedef uint8 CDCS11_ALC_mode;

#  define Rte_TypeDef_CDCS11_ALC_mode_t
typedef uint8 CDCS11_ALC_mode_t;

#  define Rte_TypeDef_CDCS11_APA_FunctionMode
typedef uint8 CDCS11_APA_FunctionMode;

#  define Rte_TypeDef_CDCS11_AVMSw
typedef uint8 CDCS11_AVMSw;

#  define Rte_TypeDef_CDCS11_AVM_3DRotate
typedef uint8 CDCS11_AVM_3DRotate;

#  define Rte_TypeDef_CDCS11_AVM_Diaphaneity
typedef uint8 CDCS11_AVM_Diaphaneity;

#  define Rte_TypeDef_CDCS11_AVM_DiaphaneitySw
typedef boolean CDCS11_AVM_DiaphaneitySw;

#  define Rte_TypeDef_CDCS11_AVM_Initialization
typedef boolean CDCS11_AVM_Initialization;

#  define Rte_TypeDef_CDCS11_AVM_LicensePlateNO1
typedef uint8 CDCS11_AVM_LicensePlateNO1;

#  define Rte_TypeDef_CDCS11_AVM_LicensePlateNO2
typedef uint8 CDCS11_AVM_LicensePlateNO2;

#  define Rte_TypeDef_CDCS11_AVM_LicensePlateNO3
typedef uint8 CDCS11_AVM_LicensePlateNO3;

#  define Rte_TypeDef_CDCS11_AVM_LicensePlateNO4
typedef uint8 CDCS11_AVM_LicensePlateNO4;

#  define Rte_TypeDef_CDCS11_AVM_LicensePlateNO5
typedef uint8 CDCS11_AVM_LicensePlateNO5;

#  define Rte_TypeDef_CDCS11_AVM_LicensePlateNO6
typedef uint8 CDCS11_AVM_LicensePlateNO6;

#  define Rte_TypeDef_CDCS11_AVM_LicensePlateNO7
typedef uint8 CDCS11_AVM_LicensePlateNO7;

#  define Rte_TypeDef_CDCS11_AVM_LicensePlateNO8
typedef uint8 CDCS11_AVM_LicensePlateNO8;

#  define Rte_TypeDef_CDCS11_AVM_MODdetection
typedef uint8 CDCS11_AVM_MODdetection;

#  define Rte_TypeDef_CDCS11_AVM_Magnifiedview
typedef uint8 CDCS11_AVM_Magnifiedview;

#  define Rte_TypeDef_CDCS11_AVM_Powertype
typedef uint8 CDCS11_AVM_Powertype;

#  define Rte_TypeDef_CDCS11_AVM_Raderdisplay
typedef uint8 CDCS11_AVM_Raderdisplay;

#  define Rte_TypeDef_CDCS11_AVM_SpeView
typedef uint8 CDCS11_AVM_SpeView;

#  define Rte_TypeDef_CDCS11_AVM_StartMode
typedef uint8 CDCS11_AVM_StartMode;

#  define Rte_TypeDef_CDCS11_AVM_Steeringstart
typedef uint8 CDCS11_AVM_Steeringstart;

#  define Rte_TypeDef_CDCS11_AVM_Transparentchassis
typedef uint8 CDCS11_AVM_Transparentchassis;

#  define Rte_TypeDef_CDCS11_AVM_Turnlightstart
typedef uint8 CDCS11_AVM_Turnlightstart;

#  define Rte_TypeDef_CDCS11_AVM_VideoOutputFail
typedef boolean CDCS11_AVM_VideoOutputFail;

#  define Rte_TypeDef_CDCS11_AVM_ViewMode
typedef uint8 CDCS11_AVM_ViewMode;

#  define Rte_TypeDef_CDCS11_AVM_auxiliaryline
typedef uint8 CDCS11_AVM_auxiliaryline;

#  define Rte_TypeDef_CDCS11_AVM_bodySync
typedef uint8 CDCS11_AVM_bodySync;

#  define Rte_TypeDef_CDCS11_AVM_licenseplateArea
typedef uint8 CDCS11_AVM_licenseplateArea;

#  define Rte_TypeDef_CDCS11_AVM_licenseplateabbr
typedef uint8 CDCS11_AVM_licenseplateabbr;

#  define Rte_TypeDef_CDCS11_DCLCSysState
typedef uint8 CDCS11_DCLCSysState;

#  define Rte_TypeDef_CDCS11_DCLCSysState_t
typedef uint8 CDCS11_DCLCSysState_t;

#  define Rte_TypeDef_CDCS11_DCWposition
typedef uint8 CDCS11_DCWposition;

#  define Rte_TypeDef_CDCS11_DOW_OnOffSet
typedef uint8 CDCS11_DOW_OnOffSet;

#  define Rte_TypeDef_CDCS11_DOW_OnOffSet_t
typedef uint8 CDCS11_DOW_OnOffSet_t;

#  define Rte_TypeDef_CDCS11_DeleteMapID
typedef uint8 CDCS11_DeleteMapID;

#  define Rte_TypeDef_CDCS11_DriveOffPossilbeswitch
typedef uint8 CDCS11_DriveOffPossilbeswitch;

#  define Rte_TypeDef_CDCS11_DriveOffinhibitionswitch
typedef uint8 CDCS11_DriveOffinhibitionswitch;

#  define Rte_TypeDef_CDCS11_ELK_OnOffSet
typedef uint8 CDCS11_ELK_OnOffSet;

#  define Rte_TypeDef_CDCS11_ELK_OnOffSet_t
typedef uint8 CDCS11_ELK_OnOffSet_t;

#  define Rte_TypeDef_CDCS11_EOL_Fdbk
typedef uint8 CDCS11_EOL_Fdbk;

#  define Rte_TypeDef_CDCS11_FCTA_OnOffSet
typedef uint8 CDCS11_FCTA_OnOffSet;

#  define Rte_TypeDef_CDCS11_FCTA_OnOffSet_t
typedef uint8 CDCS11_FCTA_OnOffSet_t;

#  define Rte_TypeDef_CDCS11_FCW_OnOffSet
typedef uint8 CDCS11_FCW_OnOffSet;

#  define Rte_TypeDef_CDCS11_FCW_OnOffSet_t
typedef uint8 CDCS11_FCW_OnOffSet_t;

#  define Rte_TypeDef_CDCS11_FCW_WarnTiming
typedef uint8 CDCS11_FCW_WarnTiming;

#  define Rte_TypeDef_CDCS11_FCW_WarnTiming_t
typedef uint8 CDCS11_FCW_WarnTiming_t;

#  define Rte_TypeDef_CDCS11_FindCarAvmReq
typedef uint8 CDCS11_FindCarAvmReq;

#  define Rte_TypeDef_CDCS11_GM_OnOffSet
typedef uint8 CDCS11_GM_OnOffSet;

#  define Rte_TypeDef_CDCS11_GM_VidedIn
typedef uint8 CDCS11_GM_VidedIn;

#  define Rte_TypeDef_CDCS11_HPAActiveConfirm
typedef boolean CDCS11_HPAActiveConfirm;

#  define Rte_TypeDef_CDCS11_HPAGuideSW
typedef uint8 CDCS11_HPAGuideSW;

#  define Rte_TypeDef_CDCS11_HPAPathwaytoCloudSW
typedef uint8 CDCS11_HPAPathwaytoCloudSW;

#  define Rte_TypeDef_CDCS11_HPAPathwaytoCloud_WorkSts
typedef uint8 CDCS11_HPAPathwaytoCloud_WorkSts;

#  define Rte_TypeDef_CDCS11_HPASw
typedef uint8 CDCS11_HPASw;

#  define Rte_TypeDef_CDCS11_HPA_ONPath_ID1
typedef uint8 CDCS11_HPA_ONPath_ID1;

#  define Rte_TypeDef_CDCS11_HPA_ONPath_ID2
typedef uint8 CDCS11_HPA_ONPath_ID2;

#  define Rte_TypeDef_CDCS11_HPA_ONPath_ID3
typedef uint8 CDCS11_HPA_ONPath_ID3;

#  define Rte_TypeDef_CDCS11_HPA_ONPath_ID4
typedef uint8 CDCS11_HPA_ONPath_ID4;

#  define Rte_TypeDef_CDCS11_HPA_Select_ID
typedef uint8 CDCS11_HPA_Select_ID;

#  define Rte_TypeDef_CDCS11_HPApreparkingSw
typedef uint8 CDCS11_HPApreparkingSw;

#  define Rte_TypeDef_CDCS11_IHBC_SysSwState
typedef uint8 CDCS11_IHBC_SysSwState;

#  define Rte_TypeDef_CDCS11_IHBC_SysSwState_t
typedef uint8 CDCS11_IHBC_SysSwState_t;

#  define Rte_TypeDef_CDCS11_LCA_OnOffSet
typedef uint8 CDCS11_LCA_OnOffSet;

#  define Rte_TypeDef_CDCS11_LCA_OnOffSet_t
typedef uint8 CDCS11_LCA_OnOffSet_t;

#  define Rte_TypeDef_CDCS11_LDP_OnOffSet
typedef uint8 CDCS11_LDP_OnOffSet;

#  define Rte_TypeDef_CDCS11_LDP_OnOffSet_t
typedef uint8 CDCS11_LDP_OnOffSet_t;

#  define Rte_TypeDef_CDCS11_LDW_OnOffSet
typedef uint8 CDCS11_LDW_OnOffSet;

#  define Rte_TypeDef_CDCS11_LDW_OnOffSet_t
typedef uint8 CDCS11_LDW_OnOffSet_t;

#  define Rte_TypeDef_CDCS11_LKSSetspeed
typedef uint8 CDCS11_LKSSetspeed;

#  define Rte_TypeDef_CDCS11_LKSSetspeed_t
typedef uint8 CDCS11_LKSSetspeed_t;

#  define Rte_TypeDef_CDCS11_LowSpeedBSDSw
typedef uint8 CDCS11_LowSpeedBSDSw;

#  define Rte_TypeDef_CDCS11_LowSpeedBSDSw_t
typedef uint8 CDCS11_LowSpeedBSDSw_t;

#  define Rte_TypeDef_CDCS11_MODSw
typedef uint8 CDCS11_MODSw;

#  define Rte_TypeDef_CDCS11_MOD_BSD_Sw
typedef uint8 CDCS11_MOD_BSD_Sw;

#  define Rte_TypeDef_CDCS11_MOD_Sound_Sw
typedef uint8 CDCS11_MOD_Sound_Sw;

#  define Rte_TypeDef_CDCS11_NNP_Active_OnOffSet
typedef uint8 CDCS11_NNP_Active_OnOffSet;

#  define Rte_TypeDef_CDCS11_NNP_AutoOnOffSet
typedef uint8 CDCS11_NNP_AutoOnOffSet;

#  define Rte_TypeDef_CDCS11_NNP_AutoOnOffSet_t
typedef uint8 CDCS11_NNP_AutoOnOffSet_t;

#  define Rte_TypeDef_CDCS11_NNP_OnOffSet
typedef uint8 CDCS11_NNP_OnOffSet;

#  define Rte_TypeDef_CDCS11_OptionalSlotAngle
typedef uint8 CDCS11_OptionalSlotAngle;

#  define Rte_TypeDef_CDCS11_OptionalSlotCoor_P0_X
typedef uint16 CDCS11_OptionalSlotCoor_P0_X;

#  define Rte_TypeDef_CDCS11_OptionalSlotCoor_P0_Y
typedef uint16 CDCS11_OptionalSlotCoor_P0_Y;

#  define Rte_TypeDef_CDCS11_OptionalSlotCoor_P1_X
typedef uint16 CDCS11_OptionalSlotCoor_P1_X;

#  define Rte_TypeDef_CDCS11_OptionalSlotCoor_P1_Y
typedef uint16 CDCS11_OptionalSlotCoor_P1_Y;

#  define Rte_TypeDef_CDCS11_OptionalSlotCoor_P2_X
typedef uint16 CDCS11_OptionalSlotCoor_P2_X;

#  define Rte_TypeDef_CDCS11_OptionalSlotCoor_P2_Y
typedef uint16 CDCS11_OptionalSlotCoor_P2_Y;

#  define Rte_TypeDef_CDCS11_OptionalSlotCoor_P3_X
typedef uint16 CDCS11_OptionalSlotCoor_P3_X;

#  define Rte_TypeDef_CDCS11_OptionalSlotCoor_P3_Y
typedef uint16 CDCS11_OptionalSlotCoor_P3_Y;

#  define Rte_TypeDef_CDCS11_OptionalSlot_Dire
typedef uint8 CDCS11_OptionalSlot_Dire;

#  define Rte_TypeDef_CDCS11_OptionalSlot_Type
typedef uint8 CDCS11_OptionalSlot_Type;

#  define Rte_TypeDef_CDCS11_PASw
typedef uint8 CDCS11_PASw;

#  define Rte_TypeDef_CDCS11_PASw_t
typedef uint8 CDCS11_PASw_t;

#  define Rte_TypeDef_CDCS11_PA_3D_OnOffSet
typedef uint8 CDCS11_PA_3D_OnOffSet;

#  define Rte_TypeDef_CDCS11_PA_FRS_OnOffSet
typedef uint8 CDCS11_PA_FRS_OnOffSet;

#  define Rte_TypeDef_CDCS11_PA_Recover
typedef boolean CDCS11_PA_Recover;

#  define Rte_TypeDef_CDCS11_PA_Select_ID
typedef uint8 CDCS11_PA_Select_ID;

#  define Rte_TypeDef_CDCS11_PA_changeLanguage
typedef uint8 CDCS11_PA_changeLanguage;

#  define Rte_TypeDef_CDCS11_PA_measure_OnOffSet
typedef uint8 CDCS11_PA_measure_OnOffSet;

#  define Rte_TypeDef_CDCS11_PA_screenMd
typedef uint8 CDCS11_PA_screenMd;

#  define Rte_TypeDef_CDCS11_ParkingInReq
typedef uint8 CDCS11_ParkingInReq;

#  define Rte_TypeDef_CDCS11_ParkingOutReq
typedef uint8 CDCS11_ParkingOutReq;

#  define Rte_TypeDef_CDCS11_ParkingoutSlot_Dire
typedef uint8 CDCS11_ParkingoutSlot_Dire;

#  define Rte_TypeDef_CDCS11_ParkingoutSlot_Type
typedef uint8 CDCS11_ParkingoutSlot_Type;

#  define Rte_TypeDef_CDCS11_PathlearningSw
typedef uint8 CDCS11_PathlearningSw;

#  define Rte_TypeDef_CDCS11_Pathrefresh
typedef boolean CDCS11_Pathrefresh;

#  define Rte_TypeDef_CDCS11_RCTA_OnOffSet
typedef uint8 CDCS11_RCTA_OnOffSet;

#  define Rte_TypeDef_CDCS11_RCTA_OnOffSet_t
typedef uint8 CDCS11_RCTA_OnOffSet_t;

#  define Rte_TypeDef_CDCS11_RCW_OnOffSet
typedef uint8 CDCS11_RCW_OnOffSet;

#  define Rte_TypeDef_CDCS11_RCW_OnOffSet_t
typedef uint8 CDCS11_RCW_OnOffSet_t;

#  define Rte_TypeDef_CDCS11_RPASw
typedef uint8 CDCS11_RPASw;

#  define Rte_TypeDef_CDCS11_RPA_FunctionMode
typedef uint8 CDCS11_RPA_FunctionMode;

#  define Rte_TypeDef_CDCS11_SelectSlotID
typedef uint8 CDCS11_SelectSlotID;

#  define Rte_TypeDef_CDCS11_SetPathwaySW
typedef uint8 CDCS11_SetPathwaySW;

#  define Rte_TypeDef_CDCS11_SetSw
typedef boolean CDCS11_SetSw;

#  define Rte_TypeDef_CDCS11_SnCtrl_NNP_OnOff
typedef uint8 CDCS11_SnCtrl_NNP_OnOff;

#  define Rte_TypeDef_CDCS11_SoundCtrlSetReq
typedef uint8 CDCS11_SoundCtrlSetReq;

#  define Rte_TypeDef_CDCS11_TSR_OnOffSet
typedef uint8 CDCS11_TSR_OnOffSet;

#  define Rte_TypeDef_CDCS11_TSR_OnOffSet_t
typedef uint8 CDCS11_TSR_OnOffSet_t;

#  define Rte_TypeDef_CDCS11_TSR_OverspeedOnoffSet
typedef uint8 CDCS11_TSR_OverspeedOnoffSet;

#  define Rte_TypeDef_CDCS11_TSR_OverspeedOnoffSet_t
typedef uint8 CDCS11_TSR_OverspeedOnoffSet_t;

#  define Rte_TypeDef_CDCS11_TSR_SLFOnOffSet
typedef uint8 CDCS11_TSR_SLFOnOffSet;

#  define Rte_TypeDef_CDCS11_TSR_SLFOnOffSet_t
typedef uint8 CDCS11_TSR_SLFOnOffSet_t;

#  define Rte_TypeDef_CDCS11_TrackreverseSW
typedef uint8 CDCS11_TrackreverseSW;

#  define Rte_TypeDef_CDCS11_UploadMapID
typedef uint8 CDCS11_UploadMapID;

#  define Rte_TypeDef_CDCS11_VoiceMode
typedef uint8 CDCS11_VoiceMode;

#  define Rte_TypeDef_CDCS11_VoiceMode_t
typedef uint8 CDCS11_VoiceMode_t;

#  define Rte_TypeDef_CDCS11_VoiceNotifFrequency_mode
typedef uint8 CDCS11_VoiceNotifFrequency_mode;

#  define Rte_TypeDef_CDCS11_learnpath_St
typedef uint8 CDCS11_learnpath_St;

#  define Rte_TypeDef_CDCS11_location_sw
typedef boolean CDCS11_location_sw;

#  define Rte_TypeDef_CDCS11_tryHPP
typedef boolean CDCS11_tryHPP;

#  define Rte_TypeDef_CDCS13_SwSmMode
typedef uint8 CDCS13_SwSmMode;

#  define Rte_TypeDef_CDCS13_SwSmMode_t
typedef uint8 CDCS13_SwSmMode_t;

#  define Rte_TypeDef_CDCS15_NNP_DriverStatus
typedef uint8 CDCS15_NNP_DriverStatus;

#  define Rte_TypeDef_CDCS15_NNP_DriverStatus_t
typedef uint8 CDCS15_NNP_DriverStatus_t;

#  define Rte_TypeDef_CDCS15_Storage_St
typedef boolean CDCS15_Storage_St;

#  define Rte_TypeDef_CDCS15_USB_St
typedef boolean CDCS15_USB_St;

#  define Rte_TypeDef_CDCS15_UserSceneMode
typedef uint8 CDCS15_UserSceneMode;

#  define Rte_TypeDef_CDCS3_DriveModeSet
typedef uint8 CDCS3_DriveModeSet;

#  define Rte_TypeDef_CDCS3_ESCOffSw
typedef uint8 CDCS3_ESCOffSw;

#  define Rte_TypeDef_CDCS3_ESCOffSw_t
typedef uint8 CDCS3_ESCOffSw_t;

#  define Rte_TypeDef_CDCS3_HDCSw
typedef uint8 CDCS3_HDCSw;

#  define Rte_TypeDef_CDCS3_TouchEvtTyp
typedef uint8 CDCS3_TouchEvtTyp;

#  define Rte_TypeDef_CDCS3_XGestureSpd
typedef uint8 CDCS3_XGestureSpd;

#  define Rte_TypeDef_CDCS3_Xcoordinate
typedef uint16 CDCS3_Xcoordinate;

#  define Rte_TypeDef_CDCS3_YGestureSpd
typedef uint8 CDCS3_YGestureSpd;

#  define Rte_TypeDef_CDCS3_Ycoordinate
typedef uint16 CDCS3_Ycoordinate;

#  define Rte_TypeDef_CDCS5_FactoryReset
typedef boolean CDCS5_FactoryReset;

#  define Rte_TypeDef_CDCS5_FactoryReset_t
typedef boolean CDCS5_FactoryReset_t;

#  define Rte_TypeDef_CDCS5_ResetAllSetup
typedef boolean CDCS5_ResetAllSetup;

#  define Rte_TypeDef_CDCS5_ResetAllSetup_t
typedef boolean CDCS5_ResetAllSetup_t;

#  define Rte_TypeDef_CDCS_Lcsndconfirm
typedef uint8 CDCS_Lcsndconfirm;

#  define Rte_TypeDef_CDCS_Lcsndrequest
typedef uint8 CDCS_Lcsndrequest;

#  define Rte_TypeDef_CDCS_PayModeConfirm
typedef uint8 CDCS_PayModeConfirm;

#  define Rte_TypeDef_CDCS_SpdAdaptComfirm
typedef uint8 CDCS_SpdAdaptComfirm;

#  define Rte_TypeDef_CDCS_SpdAdaptComfirm_t
typedef uint8 CDCS_SpdAdaptComfirm_t;

#  define Rte_TypeDef_CS1_Checksum
typedef uint8 CS1_Checksum;

#  define Rte_TypeDef_CS1_FrontWiperMISTReqSt
typedef boolean CS1_FrontWiperMISTReqSt;

#  define Rte_TypeDef_CS1_FrontWiperMISTReqSt_t
typedef boolean CS1_FrontWiperMISTReqSt_t;

#  define Rte_TypeDef_CS1_FrontWiperReqSt
typedef uint8 CS1_FrontWiperReqSt;

#  define Rte_TypeDef_CS1_FrontWiperReqSt_t
typedef uint8 CS1_FrontWiperReqSt_t;

#  define Rte_TypeDef_CS1_FrontWiperWashReqSt
typedef boolean CS1_FrontWiperWashReqSt;

#  define Rte_TypeDef_CS1_FrontWiperWashReqSt_t
typedef boolean CS1_FrontWiperWashReqSt_t;

#  define Rte_TypeDef_CS1_GearPositionReqSt
typedef uint8 CS1_GearPositionReqSt;

#  define Rte_TypeDef_CS1_GearPositionReqStInv
typedef uint8 CS1_GearPositionReqStInv;

#  define Rte_TypeDef_CS1_GearPositionReqStInv_t
typedef uint8 CS1_GearPositionReqStInv_t;

#  define Rte_TypeDef_CS1_GearPositionReqStValid
typedef boolean CS1_GearPositionReqStValid;

#  define Rte_TypeDef_CS1_GearPositionReqStValid_t
typedef boolean CS1_GearPositionReqStValid_t;

#  define Rte_TypeDef_CS1_GearPositionReqSt_t
typedef uint8 CS1_GearPositionReqSt_t;

#  define Rte_TypeDef_CS1_HighBeamFlashReqSt
typedef boolean CS1_HighBeamFlashReqSt;

#  define Rte_TypeDef_CS1_HighBeamFlashReqSt_t
typedef boolean CS1_HighBeamFlashReqSt_t;

#  define Rte_TypeDef_CS1_HighBeamReqSt
typedef boolean CS1_HighBeamReqSt;

#  define Rte_TypeDef_CS1_HighBeamReqSt_t
typedef boolean CS1_HighBeamReqSt_t;

#  define Rte_TypeDef_CS1_MsgCounter
typedef uint8 CS1_MsgCounter;

#  define Rte_TypeDef_CS1_RearWiperReqSt_Reserved
typedef boolean CS1_RearWiperReqSt_Reserved;

#  define Rte_TypeDef_CS1_RearWiperReqSt_Reserved_t
typedef boolean CS1_RearWiperReqSt_Reserved_t;

#  define Rte_TypeDef_CS1_RearWiperWashReqSt_Reserved
typedef boolean CS1_RearWiperWashReqSt_Reserved;

#  define Rte_TypeDef_CS1_RearWiperWashReqSt_Reserved_t
typedef boolean CS1_RearWiperWashReqSt_Reserved_t;

#  define Rte_TypeDef_CS1_TurnLightReqSt
typedef uint8 CS1_TurnLightReqSt;

#  define Rte_TypeDef_CS1_TurnLightReqSt_t
typedef uint8 CS1_TurnLightReqSt_t;

#  define Rte_TypeDef_CalendarDay
typedef uint8 CalendarDay;

#  define Rte_TypeDef_CalendarMonth
typedef uint8 CalendarMonth;

#  define Rte_TypeDef_CalendarYear
typedef uint8 CalendarYear;

#  define Rte_TypeDef_DDCU1_FLDoorAjar
typedef uint8 DDCU1_FLDoorAjar;

#  define Rte_TypeDef_DDCU1_FLDoorAjar_t
typedef uint8 DDCU1_FLDoorAjar_t;

#  define Rte_TypeDef_DDCU1_FL_LockSt
typedef uint8 DDCU1_FL_LockSt;

#  define Rte_TypeDef_DDCU1_FL_WinPos
typedef uint8 DDCU1_FL_WinPos;

#  define Rte_TypeDef_DDCU1_MirrorFoldSt
typedef boolean DDCU1_MirrorFoldSt;

#  define Rte_TypeDef_DDCU1_RLDoorAjar
typedef uint8 DDCU1_RLDoorAjar;

#  define Rte_TypeDef_DDCU1_RLDoorAjar_t
typedef uint8 DDCU1_RLDoorAjar_t;

#  define Rte_TypeDef_DDCU1_RL_LockSt
typedef uint8 DDCU1_RL_LockSt;

#  define Rte_TypeDef_DDCU1_RL_WinPos
typedef uint8 DDCU1_RL_WinPos;

#  define Rte_TypeDef_DataPrimitiveType_uint16
typedef uint16 DataPrimitiveType_uint16;

#  define Rte_TypeDef_DataPrimitiveType_uint8
typedef uint8 DataPrimitiveType_uint8;

#  define Rte_TypeDef_EDU5_OperMod
typedef uint8 EDU5_OperMod;

#  define Rte_TypeDef_EDU6_MotInpWtrT
typedef uint16 EDU6_MotInpWtrT;

#  define Rte_TypeDef_EPS1_Checksum
typedef uint8 EPS1_Checksum;

#  define Rte_TypeDef_EPS1_HSTWCalibrated
typedef boolean EPS1_HSTWCalibrated;

#  define Rte_TypeDef_EPS1_HSTWCalibrated_t
typedef boolean EPS1_HSTWCalibrated_t;

#  define Rte_TypeDef_EPS1_MsgCounter
typedef uint8 EPS1_MsgCounter;

#  define Rte_TypeDef_EPS1_SteerAngleSpd
typedef uint16 EPS1_SteerAngleSpd;

#  define Rte_TypeDef_EPS1_SteerAngleSpdValid
typedef boolean EPS1_SteerAngleSpdValid;

#  define Rte_TypeDef_EPS1_SteerAngleSpdValid_t
typedef boolean EPS1_SteerAngleSpdValid_t;

#  define Rte_TypeDef_EPS1_SteerAngleSpd_t
typedef float32 EPS1_SteerAngleSpd_t;

#  define Rte_TypeDef_EPS1_SteeringAngle
typedef uint16 EPS1_SteeringAngle;

#  define Rte_TypeDef_EPS1_SteeringAngleValid
typedef boolean EPS1_SteeringAngleValid;

#  define Rte_TypeDef_EPS1_SteeringAngleValid_t
typedef boolean EPS1_SteeringAngleValid_t;

#  define Rte_TypeDef_EPS1_SteeringAngle_t
typedef float32 EPS1_SteeringAngle_t;

#  define Rte_TypeDef_EPS1_TorsionBarTorque
typedef uint16 EPS1_TorsionBarTorque;

#  define Rte_TypeDef_EPS1_TorsionBarTorqueValid
typedef boolean EPS1_TorsionBarTorqueValid;

#  define Rte_TypeDef_EPS1_TorsionBarTorqueValid_t
typedef boolean EPS1_TorsionBarTorqueValid_t;

#  define Rte_TypeDef_EPS1_TorsionBarTorque_t
typedef float32 EPS1_TorsionBarTorque_t;

#  define Rte_TypeDef_EPS1_WarningLampRed
typedef boolean EPS1_WarningLampRed;

#  define Rte_TypeDef_EPS1_WarningLampYellow
typedef uint8 EPS1_WarningLampYellow;

#  define Rte_TypeDef_EPS2_ADAS_Active
typedef boolean EPS2_ADAS_Active;

#  define Rte_TypeDef_EPS2_ADAS_Active_t
typedef boolean EPS2_ADAS_Active_t;

#  define Rte_TypeDef_EPS2_ADAS_Available
typedef boolean EPS2_ADAS_Available;

#  define Rte_TypeDef_EPS2_ADAS_Available_t
typedef boolean EPS2_ADAS_Available_t;

#  define Rte_TypeDef_EPS2_ADAS_CtrlAbortFeedback
typedef uint8 EPS2_ADAS_CtrlAbortFeedback;

#  define Rte_TypeDef_EPS2_ADAS_CtrlAbortFeedback_t
typedef uint8 EPS2_ADAS_CtrlAbortFeedback_t;

#  define Rte_TypeDef_EPS2_AssistPraSwitchToDAS
typedef uint8 EPS2_AssistPraSwitchToDAS;

#  define Rte_TypeDef_EPS2_Checksum
typedef uint8 EPS2_Checksum;

#  define Rte_TypeDef_EPS2_MotCntrl
typedef uint16 EPS2_MotCntrl;

#  define Rte_TypeDef_EPS2_MotCntrlValid
typedef boolean EPS2_MotCntrlValid;

#  define Rte_TypeDef_EPS2_MotCntrlValid_t
typedef boolean EPS2_MotCntrlValid_t;

#  define Rte_TypeDef_EPS2_MotCntrl_t
typedef float32 EPS2_MotCntrl_t;

#  define Rte_TypeDef_EPS2_MsgCounter
typedef uint8 EPS2_MsgCounter;

#  define Rte_TypeDef_EPS2_PA_Active
typedef boolean EPS2_PA_Active;

#  define Rte_TypeDef_EPS2_PA_Available
typedef boolean EPS2_PA_Available;

#  define Rte_TypeDef_EPS2_PA_CtrlAbortFeedback
typedef uint8 EPS2_PA_CtrlAbortFeedback;

#  define Rte_TypeDef_FL_CAN_TX_DETECTION_CRC_t
typedef uint32 FL_CAN_TX_DETECTION_CRC_t;

#  define Rte_TypeDef_FL_CAN_TX_LOOK_ID_t
typedef uint8 FL_CAN_TX_LOOK_ID_t;

#  define Rte_TypeDef_FL_CAN_TX_LOOK_INDEX_8_t
typedef uint16 FL_CAN_TX_LOOK_INDEX_8_t;

#  define Rte_TypeDef_FL_CAN_TX_LOOK_TYPE_t
typedef uint8 FL_CAN_TX_LOOK_TYPE_t;

#  define Rte_TypeDef_FL_CAN_TX_NUMBER_OF_DETECTIONS_t
typedef uint8 FL_CAN_TX_NUMBER_OF_DETECTIONS_t;

#  define Rte_TypeDef_FL_CAN_TX_SCAN_INDEX_TRACKER_FUS_t
typedef uint16 FL_CAN_TX_SCAN_INDEX_TRACKER_FUS_t;

#  define Rte_TypeDef_FL_CAN_TX_TIMESTAMP_CONSISTENCY_t
typedef boolean FL_CAN_TX_TIMESTAMP_CONSISTENCY_t;

#  define Rte_TypeDef_FL_CAN_TX_TimeStamp_Fraction_Sec_t
typedef uint32 FL_CAN_TX_TimeStamp_Fraction_Sec_t;

#  define Rte_TypeDef_FL_CAN_TX_TimeStamp_Sec_t
typedef uint32 FL_CAN_TX_TimeStamp_Sec_t;

#  define Rte_TypeDef_FMCU1_AliveCounter
typedef uint8 FMCU1_AliveCounter;

#  define Rte_TypeDef_FMCU1_Checksum
typedef uint8 FMCU1_Checksum;

#  define Rte_TypeDef_FMCU1_ControllerTorque
typedef uint16 FMCU1_ControllerTorque;

#  define Rte_TypeDef_FMCU1_CurrentTorque
typedef uint16 FMCU1_CurrentTorque;

#  define Rte_TypeDef_FMCU1_CurrentTorqueValid
typedef boolean FMCU1_CurrentTorqueValid;

#  define Rte_TypeDef_FMCU1_MotorSpeed
typedef uint16 FMCU1_MotorSpeed;

#  define Rte_TypeDef_FMCU1_presentActivityFault
typedef uint8 FMCU1_presentActivityFault;

#  define Rte_TypeDef_FR_CAN_TX_DETECTION_CRC_t
typedef uint32 FR_CAN_TX_DETECTION_CRC_t;

#  define Rte_TypeDef_FR_CAN_TX_LOOK_ID_t
typedef uint8 FR_CAN_TX_LOOK_ID_t;

#  define Rte_TypeDef_FR_CAN_TX_LOOK_INDEX_8_t
typedef uint16 FR_CAN_TX_LOOK_INDEX_8_t;

#  define Rte_TypeDef_FR_CAN_TX_LOOK_TYPE_t
typedef uint8 FR_CAN_TX_LOOK_TYPE_t;

#  define Rte_TypeDef_FR_CAN_TX_NUMBER_OF_DETECTIONS_t
typedef uint8 FR_CAN_TX_NUMBER_OF_DETECTIONS_t;

#  define Rte_TypeDef_FR_CAN_TX_SCAN_INDEX_TRACKER_FUS_t
typedef uint16 FR_CAN_TX_SCAN_INDEX_TRACKER_FUS_t;

#  define Rte_TypeDef_FR_CAN_TX_TIMESTAMP_CONSISTENCY_t
typedef boolean FR_CAN_TX_TIMESTAMP_CONSISTENCY_t;

#  define Rte_TypeDef_FR_CAN_TX_TimeStamp_Fraction_Sec_t
typedef uint32 FR_CAN_TX_TimeStamp_Fraction_Sec_t;

#  define Rte_TypeDef_FR_CAN_TX_TimeStamp_Sec_t
typedef uint32 FR_CAN_TX_TimeStamp_Sec_t;

#  define Rte_TypeDef_HNS1_AliveCounter
typedef uint8 HNS1_AliveCounter;

#  define Rte_TypeDef_HNS1_BatCur
typedef uint32 HNS1_BatCur;

#  define Rte_TypeDef_HNS1_BatCur_status
typedef boolean HNS1_BatCur_status;

#  define Rte_TypeDef_HNS1_BatVol
typedef uint16 HNS1_BatVol;

#  define Rte_TypeDef_HNS1_BatVol_status
typedef boolean HNS1_BatVol_status;

#  define Rte_TypeDef_HNS1_Checksum
typedef uint8 HNS1_Checksum;

#  define Rte_TypeDef_HNS1_CurrentSts
typedef uint8 HNS1_CurrentSts;

#  define Rte_TypeDef_HNS1_DCDCCur
typedef uint32 HNS1_DCDCCur;

#  define Rte_TypeDef_HNS1_DCDCCur_status
typedef boolean HNS1_DCDCCur_status;

#  define Rte_TypeDef_HNS1_DCDCVol
typedef uint16 HNS1_DCDCVol;

#  define Rte_TypeDef_HNS1_DCDCVol_status
typedef boolean HNS1_DCDCVol_status;

#  define Rte_TypeDef_HNS1_FaultSts
typedef uint8 HNS1_FaultSts;

#  define Rte_TypeDef_HNS1_MainSwSts
typedef uint8 HNS1_MainSwSts;

#  define Rte_TypeDef_HNS1_VoltageSts
typedef uint8 HNS1_VoltageSts;

#  define Rte_TypeDef_HourOfDay
typedef uint8 HourOfDay;

#  define Rte_TypeDef_ICU1_VehicleSpdDisplay
typedef uint16 ICU1_VehicleSpdDisplay;

#  define Rte_TypeDef_ICU1_VehicleSpdDisplayValid
typedef boolean ICU1_VehicleSpdDisplayValid;

#  define Rte_TypeDef_ICU1_VehicleSpdDisplayValid_t
typedef boolean ICU1_VehicleSpdDisplayValid_t;

#  define Rte_TypeDef_ICU1_VehicleSpdDisplay_t
typedef uint16 ICU1_VehicleSpdDisplay_t;

#  define Rte_TypeDef_ICU2_Odometer
typedef uint32 ICU2_Odometer;

#  define Rte_TypeDef_ICU2_Odometer_t
typedef uint32 ICU2_Odometer_t;

#  define Rte_TypeDef_ID10_Angle
typedef uint16 ID10_Angle;

#  define Rte_TypeDef_ID10_PA_object_Type
typedef uint8 ID10_PA_object_Type;

#  define Rte_TypeDef_ID10_axle_X
typedef uint16 ID10_axle_X;

#  define Rte_TypeDef_ID10_axle_Y
typedef uint16 ID10_axle_Y;

#  define Rte_TypeDef_ID10_axle_Z
typedef uint16 ID10_axle_Z;

#  define Rte_TypeDef_ID11_Angle
typedef uint16 ID11_Angle;

#  define Rte_TypeDef_ID11_PA_object_Type
typedef uint8 ID11_PA_object_Type;

#  define Rte_TypeDef_ID11_axle_X
typedef uint16 ID11_axle_X;

#  define Rte_TypeDef_ID11_axle_Y
typedef uint16 ID11_axle_Y;

#  define Rte_TypeDef_ID11_axle_Z
typedef uint16 ID11_axle_Z;

#  define Rte_TypeDef_ID12_Angle
typedef uint16 ID12_Angle;

#  define Rte_TypeDef_ID12_PA_object_Type
typedef uint8 ID12_PA_object_Type;

#  define Rte_TypeDef_ID12_axle_X
typedef uint16 ID12_axle_X;

#  define Rte_TypeDef_ID12_axle_Y
typedef uint16 ID12_axle_Y;

#  define Rte_TypeDef_ID12_axle_Z
typedef uint16 ID12_axle_Z;

#  define Rte_TypeDef_ID13_Angle
typedef uint16 ID13_Angle;

#  define Rte_TypeDef_ID13_PA_object_Type
typedef uint8 ID13_PA_object_Type;

#  define Rte_TypeDef_ID13_axle_X
typedef uint16 ID13_axle_X;

#  define Rte_TypeDef_ID13_axle_Y
typedef uint16 ID13_axle_Y;

#  define Rte_TypeDef_ID13_axle_Z
typedef uint16 ID13_axle_Z;

#  define Rte_TypeDef_ID14_Angle
typedef uint16 ID14_Angle;

#  define Rte_TypeDef_ID14_PA_object_Type
typedef uint8 ID14_PA_object_Type;

#  define Rte_TypeDef_ID14_axle_X
typedef uint16 ID14_axle_X;

#  define Rte_TypeDef_ID14_axle_Y
typedef uint16 ID14_axle_Y;

#  define Rte_TypeDef_ID14_axle_Z
typedef uint16 ID14_axle_Z;

#  define Rte_TypeDef_ID15_Angle
typedef uint16 ID15_Angle;

#  define Rte_TypeDef_ID15_PA_object_Type
typedef uint8 ID15_PA_object_Type;

#  define Rte_TypeDef_ID15_axle_X
typedef uint16 ID15_axle_X;

#  define Rte_TypeDef_ID15_axle_Y
typedef uint16 ID15_axle_Y;

#  define Rte_TypeDef_ID15_axle_Z
typedef uint16 ID15_axle_Z;

#  define Rte_TypeDef_ID16_Angle
typedef uint16 ID16_Angle;

#  define Rte_TypeDef_ID16_PA_object_Type
typedef uint8 ID16_PA_object_Type;

#  define Rte_TypeDef_ID16_axle_X
typedef uint16 ID16_axle_X;

#  define Rte_TypeDef_ID16_axle_Y
typedef uint16 ID16_axle_Y;

#  define Rte_TypeDef_ID16_axle_Z
typedef uint16 ID16_axle_Z;

#  define Rte_TypeDef_ID1_Angle
typedef uint16 ID1_Angle;

#  define Rte_TypeDef_ID1_PA_object_Type
typedef uint8 ID1_PA_object_Type;

#  define Rte_TypeDef_ID1_axle_X
typedef uint16 ID1_axle_X;

#  define Rte_TypeDef_ID1_axle_Y
typedef uint16 ID1_axle_Y;

#  define Rte_TypeDef_ID1_axle_Z
typedef uint16 ID1_axle_Z;

#  define Rte_TypeDef_ID2_Angle
typedef uint16 ID2_Angle;

#  define Rte_TypeDef_ID2_PA_object_Type
typedef uint8 ID2_PA_object_Type;

#  define Rte_TypeDef_ID2_axle_X
typedef uint16 ID2_axle_X;

#  define Rte_TypeDef_ID2_axle_Y
typedef uint16 ID2_axle_Y;

#  define Rte_TypeDef_ID2_axle_Z
typedef uint16 ID2_axle_Z;

#  define Rte_TypeDef_ID3_Angle
typedef uint16 ID3_Angle;

#  define Rte_TypeDef_ID3_PA_object_Type
typedef uint8 ID3_PA_object_Type;

#  define Rte_TypeDef_ID3_axle_X
typedef uint16 ID3_axle_X;

#  define Rte_TypeDef_ID3_axle_Y
typedef uint16 ID3_axle_Y;

#  define Rte_TypeDef_ID3_axle_Z
typedef uint16 ID3_axle_Z;

#  define Rte_TypeDef_ID4_Angle
typedef uint16 ID4_Angle;

#  define Rte_TypeDef_ID4_PA_object_Type
typedef uint8 ID4_PA_object_Type;

#  define Rte_TypeDef_ID4_axle_X
typedef uint16 ID4_axle_X;

#  define Rte_TypeDef_ID4_axle_Y
typedef uint16 ID4_axle_Y;

#  define Rte_TypeDef_ID4_axle_Z
typedef uint16 ID4_axle_Z;

#  define Rte_TypeDef_ID5_Angle
typedef uint16 ID5_Angle;

#  define Rte_TypeDef_ID5_PA_object_Type
typedef uint8 ID5_PA_object_Type;

#  define Rte_TypeDef_ID5_axle_X
typedef uint16 ID5_axle_X;

#  define Rte_TypeDef_ID5_axle_Y
typedef uint16 ID5_axle_Y;

#  define Rte_TypeDef_ID5_axle_Z
typedef uint16 ID5_axle_Z;

#  define Rte_TypeDef_ID6_Angle
typedef uint16 ID6_Angle;

#  define Rte_TypeDef_ID6_PA_object_Type
typedef uint8 ID6_PA_object_Type;

#  define Rte_TypeDef_ID6_axle_X
typedef uint16 ID6_axle_X;

#  define Rte_TypeDef_ID6_axle_Y
typedef uint16 ID6_axle_Y;

#  define Rte_TypeDef_ID6_axle_Z
typedef uint16 ID6_axle_Z;

#  define Rte_TypeDef_ID7_Angle
typedef uint16 ID7_Angle;

#  define Rte_TypeDef_ID7_PA_object_Type
typedef uint8 ID7_PA_object_Type;

#  define Rte_TypeDef_ID7_axle_X
typedef uint16 ID7_axle_X;

#  define Rte_TypeDef_ID7_axle_Y
typedef uint16 ID7_axle_Y;

#  define Rte_TypeDef_ID7_axle_Z
typedef uint16 ID7_axle_Z;

#  define Rte_TypeDef_ID8_Angle
typedef uint16 ID8_Angle;

#  define Rte_TypeDef_ID8_PA_object_Type
typedef uint8 ID8_PA_object_Type;

#  define Rte_TypeDef_ID8_axle_X
typedef uint16 ID8_axle_X;

#  define Rte_TypeDef_ID8_axle_Y
typedef uint16 ID8_axle_Y;

#  define Rte_TypeDef_ID8_axle_Z
typedef uint16 ID8_axle_Z;

#  define Rte_TypeDef_ID9_Angle
typedef uint16 ID9_Angle;

#  define Rte_TypeDef_ID9_PA_object_Type
typedef uint8 ID9_PA_object_Type;

#  define Rte_TypeDef_ID9_axle_X
typedef uint16 ID9_axle_X;

#  define Rte_TypeDef_ID9_axle_Y
typedef uint16 ID9_axle_Y;

#  define Rte_TypeDef_ID9_axle_Z
typedef uint16 ID9_axle_Z;

#  define Rte_TypeDef_IDB10_ADAS_DrvTorque
typedef uint16 IDB10_ADAS_DrvTorque;

#  define Rte_TypeDef_IDB10_ADAS_DrvTorqueReq
typedef boolean IDB10_ADAS_DrvTorqueReq;

#  define Rte_TypeDef_IDB10_MotrTrqFrntAxleTargt
typedef uint16 IDB10_MotrTrqFrntAxleTargt;

#  define Rte_TypeDef_IDB10_MotrTrqFrntAxleTargtReq
typedef boolean IDB10_MotrTrqFrntAxleTargtReq;

#  define Rte_TypeDef_IDB10_MotrTrqRearAxleTargt
typedef uint16 IDB10_MotrTrqRearAxleTargt;

#  define Rte_TypeDef_IDB10_MotrTrqRearAxleTargtReq
typedef boolean IDB10_MotrTrqRearAxleTargtReq;

#  define Rte_TypeDef_IDB1_BrakePedalApplied
typedef boolean IDB1_BrakePedalApplied;

#  define Rte_TypeDef_IDB1_BrakePedalAppliedV
typedef boolean IDB1_BrakePedalAppliedV;

#  define Rte_TypeDef_IDB1_BrakePedalAppliedV_t
typedef boolean IDB1_BrakePedalAppliedV_t;

#  define Rte_TypeDef_IDB1_BrakePedalApplied_t
typedef boolean IDB1_BrakePedalApplied_t;

#  define Rte_TypeDef_IDB1_Brakestyle_Enabled
typedef boolean IDB1_Brakestyle_Enabled;

#  define Rte_TypeDef_IDB1_Brakestyle_Fail
typedef boolean IDB1_Brakestyle_Fail;

#  define Rte_TypeDef_IDB1_CSTAtive
typedef boolean IDB1_CSTAtive;

#  define Rte_TypeDef_IDB1_CSTEnabled
typedef boolean IDB1_CSTEnabled;

#  define Rte_TypeDef_IDB1_CSTFail
typedef boolean IDB1_CSTFail;

#  define Rte_TypeDef_IDB1_FailedState
typedef uint8 IDB1_FailedState;

#  define Rte_TypeDef_IDB1_FailedState_t
typedef uint8 IDB1_FailedState_t;

#  define Rte_TypeDef_IDB1_Fr01_Checksum
typedef uint8 IDB1_Fr01_Checksum;

#  define Rte_TypeDef_IDB1_Fr01_MsgCounter
typedef uint8 IDB1_Fr01_MsgCounter;

#  define Rte_TypeDef_IDB2_FLWhlPulCnt
typedef uint16 IDB2_FLWhlPulCnt;

#  define Rte_TypeDef_IDB2_FLWhlPulCntValid
typedef boolean IDB2_FLWhlPulCntValid;

#  define Rte_TypeDef_IDB2_FLWhlPulCntValid_t
typedef boolean IDB2_FLWhlPulCntValid_t;

#  define Rte_TypeDef_IDB2_FLWhlPulCnt_t
typedef float32 IDB2_FLWhlPulCnt_t;

#  define Rte_TypeDef_IDB2_FRWhlPulCnt
typedef uint16 IDB2_FRWhlPulCnt;

#  define Rte_TypeDef_IDB2_FRWhlPulCntValid
typedef boolean IDB2_FRWhlPulCntValid;

#  define Rte_TypeDef_IDB2_FRWhlPulCntValid_t
typedef boolean IDB2_FRWhlPulCntValid_t;

#  define Rte_TypeDef_IDB2_FRWhlPulCnt_t
typedef float32 IDB2_FRWhlPulCnt_t;

#  define Rte_TypeDef_IDB2_Fr02_Checksum
typedef uint8 IDB2_Fr02_Checksum;

#  define Rte_TypeDef_IDB2_Fr02_MsgCounter
typedef uint8 IDB2_Fr02_MsgCounter;

#  define Rte_TypeDef_IDB3_Checksum
typedef uint8 IDB3_Checksum;

#  define Rte_TypeDef_IDB3_MasterCylPressure
typedef uint16 IDB3_MasterCylPressure;

#  define Rte_TypeDef_IDB3_MasterCylPressureInvalid
typedef boolean IDB3_MasterCylPressureInvalid;

#  define Rte_TypeDef_IDB3_MsgCounter
typedef uint8 IDB3_MsgCounter;

#  define Rte_TypeDef_IDB3_VehicleSpd
typedef uint16 IDB3_VehicleSpd;

#  define Rte_TypeDef_IDB3_VehicleSpdValid
typedef boolean IDB3_VehicleSpdValid;

#  define Rte_TypeDef_IDB3_VehicleSpdValid_t
typedef boolean IDB3_VehicleSpdValid_t;

#  define Rte_TypeDef_IDB3_VehicleSpd_t
typedef float32 IDB3_VehicleSpd_t;

#  define Rte_TypeDef_IDB4_Checksum
typedef uint8 IDB4_Checksum;

#  define Rte_TypeDef_IDB4_FLWhlDir
typedef uint8 IDB4_FLWhlDir;

#  define Rte_TypeDef_IDB4_FLWhlDir_t
typedef uint8 IDB4_FLWhlDir_t;

#  define Rte_TypeDef_IDB4_FLWhlVelocity
typedef uint16 IDB4_FLWhlVelocity;

#  define Rte_TypeDef_IDB4_FLWhlVelocityValid
typedef boolean IDB4_FLWhlVelocityValid;

#  define Rte_TypeDef_IDB4_FLWhlVelocityValid_t
typedef boolean IDB4_FLWhlVelocityValid_t;

#  define Rte_TypeDef_IDB4_FLWhlVelocity_t
typedef float32 IDB4_FLWhlVelocity_t;

#  define Rte_TypeDef_IDB4_FRWhlDir
typedef uint8 IDB4_FRWhlDir;

#  define Rte_TypeDef_IDB4_FRWhlDir_t
typedef uint8 IDB4_FRWhlDir_t;

#  define Rte_TypeDef_IDB4_FRWhlVelocity
typedef uint16 IDB4_FRWhlVelocity;

#  define Rte_TypeDef_IDB4_FRWhlVelocityValid
typedef boolean IDB4_FRWhlVelocityValid;

#  define Rte_TypeDef_IDB4_FRWhlVelocityValid_t
typedef boolean IDB4_FRWhlVelocityValid_t;

#  define Rte_TypeDef_IDB4_FRWhlVelocity_t
typedef float32 IDB4_FRWhlVelocity_t;

#  define Rte_TypeDef_IDB4_MsgCounter
typedef uint8 IDB4_MsgCounter;

#  define Rte_TypeDef_IDB4_RLWhlDir
typedef uint8 IDB4_RLWhlDir;

#  define Rte_TypeDef_IDB4_RLWhlDir_t
typedef uint8 IDB4_RLWhlDir_t;

#  define Rte_TypeDef_IDB4_RLWhlPulCnt
typedef uint16 IDB4_RLWhlPulCnt;

#  define Rte_TypeDef_IDB4_RLWhlPulCntValid
typedef boolean IDB4_RLWhlPulCntValid;

#  define Rte_TypeDef_IDB4_RLWhlPulCntValid_t
typedef boolean IDB4_RLWhlPulCntValid_t;

#  define Rte_TypeDef_IDB4_RLWhlPulCnt_t
typedef float32 IDB4_RLWhlPulCnt_t;

#  define Rte_TypeDef_IDB4_RLWhlVelocity
typedef uint16 IDB4_RLWhlVelocity;

#  define Rte_TypeDef_IDB4_RLWhlVelocityValid
typedef boolean IDB4_RLWhlVelocityValid;

#  define Rte_TypeDef_IDB4_RLWhlVelocityValid_t
typedef boolean IDB4_RLWhlVelocityValid_t;

#  define Rte_TypeDef_IDB4_RLWhlVelocity_t
typedef float32 IDB4_RLWhlVelocity_t;

#  define Rte_TypeDef_IDB4_RRWhlDir
typedef uint8 IDB4_RRWhlDir;

#  define Rte_TypeDef_IDB4_RRWhlDir_t
typedef uint8 IDB4_RRWhlDir_t;

#  define Rte_TypeDef_IDB4_RRWhlPulCnt
typedef uint16 IDB4_RRWhlPulCnt;

#  define Rte_TypeDef_IDB4_RRWhlPulCntValid
typedef boolean IDB4_RRWhlPulCntValid;

#  define Rte_TypeDef_IDB4_RRWhlPulCntValid_t
typedef boolean IDB4_RRWhlPulCntValid_t;

#  define Rte_TypeDef_IDB4_RRWhlPulCnt_t
typedef float32 IDB4_RRWhlPulCnt_t;

#  define Rte_TypeDef_IDB4_RRWhlVelocity
typedef uint16 IDB4_RRWhlVelocity;

#  define Rte_TypeDef_IDB4_RRWhlVelocityValid
typedef boolean IDB4_RRWhlVelocityValid;

#  define Rte_TypeDef_IDB4_RRWhlVelocityValid_t
typedef boolean IDB4_RRWhlVelocityValid_t;

#  define Rte_TypeDef_IDB4_RRWhlVelocity_t
typedef float32 IDB4_RRWhlVelocity_t;

#  define Rte_TypeDef_IDB5_ABAactive
typedef boolean IDB5_ABAactive;

#  define Rte_TypeDef_IDB5_ABAactive_t
typedef boolean IDB5_ABAactive_t;

#  define Rte_TypeDef_IDB5_ACC_Enable
typedef uint8 IDB5_ACC_Enable;

#  define Rte_TypeDef_IDB5_ACC_Enable_t
typedef uint8 IDB5_ACC_Enable_t;

#  define Rte_TypeDef_IDB5_ACC_ReferenceAccel
typedef uint16 IDB5_ACC_ReferenceAccel;

#  define Rte_TypeDef_IDB5_ACC_ReqLim
typedef uint8 IDB5_ACC_ReqLim;

#  define Rte_TypeDef_IDB5_ACC_ReqLim_t
typedef uint8 IDB5_ACC_ReqLim_t;

#  define Rte_TypeDef_IDB5_ACC_Sta
typedef boolean IDB5_ACC_Sta;

#  define Rte_TypeDef_IDB5_ACC_Sta_t
typedef boolean IDB5_ACC_Sta_t;

#  define Rte_TypeDef_IDB5_ADAS_PrefillSts
typedef uint8 IDB5_ADAS_PrefillSts;

#  define Rte_TypeDef_IDB5_AEB_Enable
typedef uint8 IDB5_AEB_Enable;

#  define Rte_TypeDef_IDB5_AEB_Enable_t
typedef uint8 IDB5_AEB_Enable_t;

#  define Rte_TypeDef_IDB5_AEBactive
typedef boolean IDB5_AEBactive;

#  define Rte_TypeDef_IDB5_BrakeDiscTempSts
typedef boolean IDB5_BrakeDiscTempSts;

#  define Rte_TypeDef_IDB5_BrakeDiscTempSts_t
typedef boolean IDB5_BrakeDiscTempSts_t;

#  define Rte_TypeDef_IDB5_Checksum
typedef uint8 IDB5_Checksum;

#  define Rte_TypeDef_IDB5_DBSavailable
typedef boolean IDB5_DBSavailable;

#  define Rte_TypeDef_IDB5_DBSavailable_t
typedef boolean IDB5_DBSavailable_t;

#  define Rte_TypeDef_IDB5_DriverOverride
typedef uint8 IDB5_DriverOverride;

#  define Rte_TypeDef_IDB5_DriverOverride_t
typedef uint8 IDB5_DriverOverride_t;

#  define Rte_TypeDef_IDB5_JerkActive
typedef boolean IDB5_JerkActive;

#  define Rte_TypeDef_IDB5_JerkActive_t
typedef boolean IDB5_JerkActive_t;

#  define Rte_TypeDef_IDB5_Jerkfail
typedef boolean IDB5_Jerkfail;

#  define Rte_TypeDef_IDB5_Jerkfail_t
typedef boolean IDB5_Jerkfail_t;

#  define Rte_TypeDef_IDB5_MsgCounter
typedef uint8 IDB5_MsgCounter;

#  define Rte_TypeDef_IDB5_Prefillavailable
typedef boolean IDB5_Prefillavailable;

#  define Rte_TypeDef_IDB5_Prefillavailable_t
typedef boolean IDB5_Prefillavailable_t;

#  define Rte_TypeDef_IDB5_VehicleStanstill
typedef uint8 IDB5_VehicleStanstill;

#  define Rte_TypeDef_IDB5_VehicleStanstill_t
typedef uint8 IDB5_VehicleStanstill_t;

#  define Rte_TypeDef_IDB6_EPBAvailable
typedef uint8 IDB6_EPBAvailable;

#  define Rte_TypeDef_IDB6_EPBAvailable_t
typedef uint8 IDB6_EPBAvailable_t;

#  define Rte_TypeDef_IDB6_EPBStatus
typedef uint8 IDB6_EPBStatus;

#  define Rte_TypeDef_IDB6_EPBStatus_t
typedef uint8 IDB6_EPBStatus_t;

#  define Rte_TypeDef_IDB7_ABSActive
typedef boolean IDB7_ABSActive;

#  define Rte_TypeDef_IDB7_ABSActive_t
typedef boolean IDB7_ABSActive_t;

#  define Rte_TypeDef_IDB7_ABSFail
typedef boolean IDB7_ABSFail;

#  define Rte_TypeDef_IDB7_ABSFail_t
typedef boolean IDB7_ABSFail_t;

#  define Rte_TypeDef_IDB7_AVHDispMSG
typedef uint8 IDB7_AVHDispMSG;

#  define Rte_TypeDef_IDB7_AVHEnabled
typedef boolean IDB7_AVHEnabled;

#  define Rte_TypeDef_IDB7_AVHLampReq
typedef uint8 IDB7_AVHLampReq;

#  define Rte_TypeDef_IDB7_AVHStatus
typedef uint8 IDB7_AVHStatus;

#  define Rte_TypeDef_IDB7_Checksum
typedef uint8 IDB7_Checksum;

#  define Rte_TypeDef_IDB7_DiagMode
typedef boolean IDB7_DiagMode;

#  define Rte_TypeDef_IDB7_DynParkBrkByIDBActive
typedef boolean IDB7_DynParkBrkByIDBActive;

#  define Rte_TypeDef_IDB7_DynParkBrkByIDBActive_t
typedef boolean IDB7_DynParkBrkByIDBActive_t;

#  define Rte_TypeDef_IDB7_DynParkBrkByIDBAvailable
typedef boolean IDB7_DynParkBrkByIDBAvailable;

#  define Rte_TypeDef_IDB7_EBD_Active
typedef boolean IDB7_EBD_Active;

#  define Rte_TypeDef_IDB7_EBD_Fail
typedef boolean IDB7_EBD_Fail;

#  define Rte_TypeDef_IDB7_EBD_Fail_t
typedef boolean IDB7_EBD_Fail_t;

#  define Rte_TypeDef_IDB7_ESCActive
typedef boolean IDB7_ESCActive;

#  define Rte_TypeDef_IDB7_ESCActive_t
typedef boolean IDB7_ESCActive_t;

#  define Rte_TypeDef_IDB7_ESCDisable
typedef boolean IDB7_ESCDisable;

#  define Rte_TypeDef_IDB7_ESCDisable_t
typedef boolean IDB7_ESCDisable_t;

#  define Rte_TypeDef_IDB7_ESCFail
typedef boolean IDB7_ESCFail;

#  define Rte_TypeDef_IDB7_ESCFail_t
typedef boolean IDB7_ESCFail_t;

#  define Rte_TypeDef_IDB7_HBAActive
typedef boolean IDB7_HBAActive;

#  define Rte_TypeDef_IDB7_HBAFail
typedef boolean IDB7_HBAFail;

#  define Rte_TypeDef_IDB7_HDCAtive
typedef boolean IDB7_HDCAtive;

#  define Rte_TypeDef_IDB7_HDCAtive_t
typedef boolean IDB7_HDCAtive_t;

#  define Rte_TypeDef_IDB7_HDCEnabled
typedef boolean IDB7_HDCEnabled;

#  define Rte_TypeDef_IDB7_HDCEnabled_t
typedef boolean IDB7_HDCEnabled_t;

#  define Rte_TypeDef_IDB7_HDCFail
typedef boolean IDB7_HDCFail;

#  define Rte_TypeDef_IDB7_HSAActive
typedef boolean IDB7_HSAActive;

#  define Rte_TypeDef_IDB7_HSAFail
typedef boolean IDB7_HSAFail;

#  define Rte_TypeDef_IDB7_MsgCounter
typedef uint8 IDB7_MsgCounter;

#  define Rte_TypeDef_IDB7_ROPACTIVE
typedef boolean IDB7_ROPACTIVE;

#  define Rte_TypeDef_IDB7_ROPACTIVE_t
typedef boolean IDB7_ROPACTIVE_t;

#  define Rte_TypeDef_IDB7_ROPFailure
typedef boolean IDB7_ROPFailure;

#  define Rte_TypeDef_IDB7_ROPFailure_t
typedef boolean IDB7_ROPFailure_t;

#  define Rte_TypeDef_IDB7_TCSActive
typedef boolean IDB7_TCSActive;

#  define Rte_TypeDef_IDB7_TCSActive_t
typedef boolean IDB7_TCSActive_t;

#  define Rte_TypeDef_IDB7_TCSDisable
typedef boolean IDB7_TCSDisable;

#  define Rte_TypeDef_IDB7_TCSDisable_t
typedef boolean IDB7_TCSDisable_t;

#  define Rte_TypeDef_IDB7_TCSFail
typedef boolean IDB7_TCSFail;

#  define Rte_TypeDef_IDB7_TCSFail_t
typedef boolean IDB7_TCSFail_t;

#  define Rte_TypeDef_IDB9_Checksum
typedef uint8 IDB9_Checksum;

#  define Rte_TypeDef_IDB9_MsgCounter
typedef uint8 IDB9_MsgCounter;

#  define Rte_TypeDef_IDB9_PAStandStill
typedef boolean IDB9_PAStandStill;

#  define Rte_TypeDef_IDB9_PASts
typedef uint8 IDB9_PASts;

#  define Rte_TypeDef_IDB9_PA_ApaCtrlSts
typedef uint8 IDB9_PA_ApaCtrlSts;

#  define Rte_TypeDef_IDB9_PA_CtrlAbortFeedback
typedef uint8 IDB9_PA_CtrlAbortFeedback;

#  define Rte_TypeDef_IDB9_PA_ParkingAvailable
typedef boolean IDB9_PA_ParkingAvailable;

#  define Rte_TypeDef_IDB9_PA_ParkingBrkMdSeln
typedef uint8 IDB9_PA_ParkingBrkMdSeln;

#  define Rte_TypeDef_IDB9_PA_ParkingFnMd
typedef uint8 IDB9_PA_ParkingFnMd;

#  define Rte_TypeDef_IDB9_PA_Prefill
typedef boolean IDB9_PA_Prefill;

#  define Rte_TypeDef_Idt_IoCtrl
typedef uint8 Idt_IoCtrl;

#  define Rte_TypeDef_Idt_IoCtrlCallerId
typedef uint8 Idt_IoCtrlCallerId;

#  define Rte_TypeDef_Idt_IoCtrlReturn
typedef uint8 Idt_IoCtrlReturn;

#  define Rte_TypeDef_LRR_AVD_Det_CRC_01_t
typedef uint8 LRR_AVD_Det_CRC_01_t;

#  define Rte_TypeDef_LRR_AVD_Det_CRC_02_t
typedef uint8 LRR_AVD_Det_CRC_02_t;

#  define Rte_TypeDef_LRR_AVD_Det_CRC_03_t
typedef uint8 LRR_AVD_Det_CRC_03_t;

#  define Rte_TypeDef_LRR_AVD_Det_CRC_04_t
typedef uint8 LRR_AVD_Det_CRC_04_t;

#  define Rte_TypeDef_LRR_AVD_Det_CRC_05_t
typedef uint8 LRR_AVD_Det_CRC_05_t;

#  define Rte_TypeDef_LRR_AVD_Det_CRC_06_t
typedef uint8 LRR_AVD_Det_CRC_06_t;

#  define Rte_TypeDef_LRR_AVD_Det_CRC_07_t
typedef uint8 LRR_AVD_Det_CRC_07_t;

#  define Rte_TypeDef_LRR_AVD_Det_CRC_08_t
typedef uint8 LRR_AVD_Det_CRC_08_t;

#  define Rte_TypeDef_LRR_AVD_Det_CRC_09_t
typedef uint8 LRR_AVD_Det_CRC_09_t;

#  define Rte_TypeDef_LRR_AVD_Det_CRC_10_t
typedef uint8 LRR_AVD_Det_CRC_10_t;

#  define Rte_TypeDef_LRR_AVD_Det_CRC_11_t
typedef uint8 LRR_AVD_Det_CRC_11_t;

#  define Rte_TypeDef_LRR_AVD_Det_CRC_12_t
typedef uint8 LRR_AVD_Det_CRC_12_t;

#  define Rte_TypeDef_LRR_AVD_Det_CRC_13_t
typedef uint8 LRR_AVD_Det_CRC_13_t;

#  define Rte_TypeDef_LRR_AVD_Det_CRC_14_t
typedef uint8 LRR_AVD_Det_CRC_14_t;

#  define Rte_TypeDef_LRR_AVD_Det_CRC_15_t
typedef uint8 LRR_AVD_Det_CRC_15_t;

#  define Rte_TypeDef_LRR_AVD_Det_CRC_16_t
typedef uint8 LRR_AVD_Det_CRC_16_t;

#  define Rte_TypeDef_LRR_AVD_Det_CRC_17_t
typedef uint8 LRR_AVD_Det_CRC_17_t;

#  define Rte_TypeDef_LRR_AVD_Det_CRC_18_t
typedef uint8 LRR_AVD_Det_CRC_18_t;

#  define Rte_TypeDef_LRR_AVD_Det_CRC_19_t
typedef uint8 LRR_AVD_Det_CRC_19_t;

#  define Rte_TypeDef_LRR_AVD_Det_CRC_20_t
typedef uint8 LRR_AVD_Det_CRC_20_t;

#  define Rte_TypeDef_LRR_AVD_Det_CRC_21_t
typedef uint8 LRR_AVD_Det_CRC_21_t;

#  define Rte_TypeDef_LRR_AVD_Det_CRC_22_t
typedef uint8 LRR_AVD_Det_CRC_22_t;

#  define Rte_TypeDef_LRR_AVD_Det_MC_01_t
typedef uint8 LRR_AVD_Det_MC_01_t;

#  define Rte_TypeDef_LRR_AVD_Det_MC_02_t
typedef uint8 LRR_AVD_Det_MC_02_t;

#  define Rte_TypeDef_LRR_AVD_Det_MC_03_t
typedef uint8 LRR_AVD_Det_MC_03_t;

#  define Rte_TypeDef_LRR_AVD_Det_MC_04_t
typedef uint8 LRR_AVD_Det_MC_04_t;

#  define Rte_TypeDef_LRR_AVD_Det_MC_05_t
typedef uint8 LRR_AVD_Det_MC_05_t;

#  define Rte_TypeDef_LRR_AVD_Det_MC_06_t
typedef uint8 LRR_AVD_Det_MC_06_t;

#  define Rte_TypeDef_LRR_AVD_Det_MC_07_t
typedef uint8 LRR_AVD_Det_MC_07_t;

#  define Rte_TypeDef_LRR_AVD_Det_MC_08_t
typedef uint8 LRR_AVD_Det_MC_08_t;

#  define Rte_TypeDef_LRR_AVD_Det_MC_09_t
typedef uint8 LRR_AVD_Det_MC_09_t;

#  define Rte_TypeDef_LRR_AVD_Det_MC_10_t
typedef uint8 LRR_AVD_Det_MC_10_t;

#  define Rte_TypeDef_LRR_AVD_Det_MC_11_t
typedef uint8 LRR_AVD_Det_MC_11_t;

#  define Rte_TypeDef_LRR_AVD_Det_MC_12_t
typedef uint8 LRR_AVD_Det_MC_12_t;

#  define Rte_TypeDef_LRR_AVD_Det_MC_13_t
typedef uint8 LRR_AVD_Det_MC_13_t;

#  define Rte_TypeDef_LRR_AVD_Det_MC_14_t
typedef uint8 LRR_AVD_Det_MC_14_t;

#  define Rte_TypeDef_LRR_AVD_Det_MC_15_t
typedef uint8 LRR_AVD_Det_MC_15_t;

#  define Rte_TypeDef_LRR_AVD_Det_MC_16_t
typedef uint8 LRR_AVD_Det_MC_16_t;

#  define Rte_TypeDef_LRR_AVD_Det_MC_17_t
typedef uint8 LRR_AVD_Det_MC_17_t;

#  define Rte_TypeDef_LRR_AVD_Det_MC_18_t
typedef uint8 LRR_AVD_Det_MC_18_t;

#  define Rte_TypeDef_LRR_AVD_Det_MC_19_t
typedef uint8 LRR_AVD_Det_MC_19_t;

#  define Rte_TypeDef_LRR_AVD_Det_MC_20_t
typedef uint8 LRR_AVD_Det_MC_20_t;

#  define Rte_TypeDef_LRR_AVD_Det_MC_21_t
typedef uint8 LRR_AVD_Det_MC_21_t;

#  define Rte_TypeDef_LRR_AVD_Det_MC_22_t
typedef uint8 LRR_AVD_Det_MC_22_t;

#  define Rte_TypeDef_LRR_Align_Horizontal_Angle_t
typedef float32 LRR_Align_Horizontal_Angle_t;

#  define Rte_TypeDef_LRR_Align_Horizontal_QF_t
typedef uint8 LRR_Align_Horizontal_QF_t;

#  define Rte_TypeDef_LRR_Align_Horizontal_Ref_t
typedef float32 LRR_Align_Horizontal_Ref_t;

#  define Rte_TypeDef_LRR_Align_Vertical_Angle_t
typedef float32 LRR_Align_Vertical_Angle_t;

#  define Rte_TypeDef_LRR_Align_Vertical_QF_t
typedef uint8 LRR_Align_Vertical_QF_t;

#  define Rte_TypeDef_LRR_Align_Vertical_Ref_t
typedef float32 LRR_Align_Vertical_Ref_t;

#  define Rte_TypeDef_LRR_AlignmentIncomplete_Fault_t
typedef boolean LRR_AlignmentIncomplete_Fault_t;

#  define Rte_TypeDef_LRR_Alignment_Out_of_Range_Fault_t
typedef boolean LRR_Alignment_Out_of_Range_Fault_t;

#  define Rte_TypeDef_LRR_Blockage_Fault_t
typedef boolean LRR_Blockage_Fault_t;

#  define Rte_TypeDef_LRR_CAN_BLKG_SIDELOBE_FILTER_VAL_t
typedef uint8 LRR_CAN_BLKG_SIDELOBE_FILTER_VAL_t;

#  define Rte_TypeDef_LRR_CAN_BLOCKAGE_MNR_t
typedef boolean LRR_CAN_BLOCKAGE_MNR_t;

#  define Rte_TypeDef_LRR_CAN_COMPENSATED_SIGNALS_USED_t
typedef uint8 LRR_CAN_COMPENSATED_SIGNALS_USED_t;

#  define Rte_TypeDef_LRR_CAN_Core0_Instant_Cpu_Load_t
typedef float32 LRR_CAN_Core0_Instant_Cpu_Load_t;

#  define Rte_TypeDef_LRR_CAN_Core0_Max_Cpu_Load_t
typedef float32 LRR_CAN_Core0_Max_Cpu_Load_t;

#  define Rte_TypeDef_LRR_CAN_Core1_Instant_Cpu_Load_t
typedef float32 LRR_CAN_Core1_Instant_Cpu_Load_t;

#  define Rte_TypeDef_LRR_CAN_Core1_Max_Cpu_Load_t
typedef float32 LRR_CAN_Core1_Max_Cpu_Load_t;

#  define Rte_TypeDef_LRR_CAN_Core2_Instant_Cpu_Load_t
typedef float32 LRR_CAN_Core2_Instant_Cpu_Load_t;

#  define Rte_TypeDef_LRR_CAN_Core2_Max_Cpu_Load_t
typedef float32 LRR_CAN_Core2_Max_Cpu_Load_t;

#  define Rte_TypeDef_LRR_CAN_DET_TIME_SINCE_MEAS_t
typedef float32 LRR_CAN_DET_TIME_SINCE_MEAS_t;

#  define Rte_TypeDef_LRR_CAN_DOPPLER_COVERAGE_t
typedef float32 LRR_CAN_DOPPLER_COVERAGE_t;

#  define Rte_TypeDef_LRR_CAN_Dyn_Align_Algo_Ver_Major_t
typedef uint8 LRR_CAN_Dyn_Align_Algo_Ver_Major_t;

#  define Rte_TypeDef_LRR_CAN_Dyn_Align_Algo_Ver_Minor_t
typedef uint8 LRR_CAN_Dyn_Align_Algo_Ver_Minor_t;

#  define Rte_TypeDef_LRR_CAN_Dyn_Align_Algo_Ver_Promt_t
typedef uint8 LRR_CAN_Dyn_Align_Algo_Ver_Promt_t;

#  define Rte_TypeDef_LRR_CAN_HRZNTL_ALIGN_UPDATES_Nbr_t
typedef uint16 LRR_CAN_HRZNTL_ALIGN_UPDATES_Nbr_t;

#  define Rte_TypeDef_LRR_CAN_INTERFERENCE_TYPE_t
typedef uint8 LRR_CAN_INTERFERENCE_TYPE_t;

#  define Rte_TypeDef_LRR_CAN_KAM_Major_t
typedef uint8 LRR_CAN_KAM_Major_t;

#  define Rte_TypeDef_LRR_CAN_KAM_Minor_t
typedef uint8 LRR_CAN_KAM_Minor_t;

#  define Rte_TypeDef_LRR_CAN_LOOK_ID_t
typedef uint8 LRR_CAN_LOOK_ID_t;

#  define Rte_TypeDef_LRR_CAN_LOOK_INDEX_t
typedef uint16 LRR_CAN_LOOK_INDEX_t;

#  define Rte_TypeDef_LRR_CAN_NUMBER_OF_DET_t
typedef uint8 LRR_CAN_NUMBER_OF_DET_t;

#  define Rte_TypeDef_LRR_CAN_PBL_Field_Revision_t
typedef uint8 LRR_CAN_PBL_Field_Revision_t;

#  define Rte_TypeDef_LRR_CAN_PBL_Promote_Revision_t
typedef uint8 LRR_CAN_PBL_Promote_Revision_t;

#  define Rte_TypeDef_LRR_CAN_PBL_Release_Revision_t
typedef uint8 LRR_CAN_PBL_Release_Revision_t;

#  define Rte_TypeDef_LRR_CAN_PCAN_MAJOR_LRR_t
typedef uint8 LRR_CAN_PCAN_MAJOR_LRR_t;

#  define Rte_TypeDef_LRR_CAN_PCAN_MINOR_LRR_t
typedef uint8 LRR_CAN_PCAN_MINOR_LRR_t;

#  define Rte_TypeDef_LRR_CAN_PCAN_PROMOTE_LRR_t
typedef uint8 LRR_CAN_PCAN_PROMOTE_LRR_t;

#  define Rte_TypeDef_LRR_CAN_RADAR_CommonModeFailure_t
typedef uint8 LRR_CAN_RADAR_CommonModeFailure_t;

#  define Rte_TypeDef_LRR_CAN_RADAR_OVERHEAT_ERROR_t
typedef boolean LRR_CAN_RADAR_OVERHEAT_ERROR_t;

#  define Rte_TypeDef_LRR_CAN_RANGE_COVERAGE_t
typedef float32 LRR_CAN_RANGE_COVERAGE_t;

#  define Rte_TypeDef_LRR_CAN_RECOMMEND_UNCONVERGE_t
typedef boolean LRR_CAN_RECOMMEND_UNCONVERGE_t;

#  define Rte_TypeDef_LRR_CAN_ReSync_counter_t
typedef uint16 LRR_CAN_ReSync_counter_t;

#  define Rte_TypeDef_LRR_CAN_SENSOR_AlignRngTolHorz_t
typedef float32 LRR_CAN_SENSOR_AlignRngTolHorz_t;

#  define Rte_TypeDef_LRR_CAN_SENSOR_AlignRngTolVert_t
typedef float32 LRR_CAN_SENSOR_AlignRngTolVert_t;

#  define Rte_TypeDef_LRR_CAN_SENSOR_FOV_HOR_t
typedef uint8 LRR_CAN_SENSOR_FOV_HOR_t;

#  define Rte_TypeDef_LRR_CAN_SENSOR_FOV_VER_t
typedef uint8 LRR_CAN_SENSOR_FOV_VER_t;

#  define Rte_TypeDef_LRR_CAN_SENSOR_FcAlnRngTolHorz_t
typedef float32 LRR_CAN_SENSOR_FcAlnRngTolHorz_t;

#  define Rte_TypeDef_LRR_CAN_SENSOR_FcAlnRngTolVert_t
typedef float32 LRR_CAN_SENSOR_FcAlnRngTolVert_t;

#  define Rte_TypeDef_LRR_CAN_SENSOR_LatPos_t
typedef uint16 LRR_CAN_SENSOR_LatPos_t;

#  define Rte_TypeDef_LRR_CAN_SENSOR_LongPos_t
typedef uint16 LRR_CAN_SENSOR_LongPos_t;

#  define Rte_TypeDef_LRR_CAN_SENSOR_Orientation_t
typedef sint8 LRR_CAN_SENSOR_Orientation_t;

#  define Rte_TypeDef_LRR_CAN_SENSOR_Pitch_t
typedef float32 LRR_CAN_SENSOR_Pitch_t;

#  define Rte_TypeDef_LRR_CAN_SENSOR_TIME_STAMP_t
typedef uint32 LRR_CAN_SENSOR_TIME_STAMP_t;

#  define Rte_TypeDef_LRR_CAN_SENSOR_VertPos_t
typedef uint16 LRR_CAN_SENSOR_VertPos_t;

#  define Rte_TypeDef_LRR_CAN_SENSOR_Yaw_t
typedef float32 LRR_CAN_SENSOR_Yaw_t;

#  define Rte_TypeDef_LRR_CAN_SMC_Field_t
typedef uint8 LRR_CAN_SMC_Field_t;

#  define Rte_TypeDef_LRR_CAN_SMC_Major_t
typedef uint8 LRR_CAN_SMC_Major_t;

#  define Rte_TypeDef_LRR_CAN_SMC_Minor_t
typedef uint8 LRR_CAN_SMC_Minor_t;

#  define Rte_TypeDef_LRR_CAN_SMC_Promote_t
typedef uint8 LRR_CAN_SMC_Promote_t;

#  define Rte_TypeDef_LRR_CAN_SW_Field_Revision_t
typedef uint8 LRR_CAN_SW_Field_Revision_t;

#  define Rte_TypeDef_LRR_CAN_SW_Field_t
typedef uint8 LRR_CAN_SW_Field_t;

#  define Rte_TypeDef_LRR_CAN_SW_Promote_Revision_t
typedef uint8 LRR_CAN_SW_Promote_Revision_t;

#  define Rte_TypeDef_LRR_CAN_SW_Release_Revision_t
typedef uint8 LRR_CAN_SW_Release_Revision_t;

#  define Rte_TypeDef_LRR_CAN_USC_Field_t
typedef uint8 LRR_CAN_USC_Field_t;

#  define Rte_TypeDef_LRR_CAN_USC_Major_t
typedef uint8 LRR_CAN_USC_Major_t;

#  define Rte_TypeDef_LRR_CAN_USC_Minor_t
typedef uint8 LRR_CAN_USC_Minor_t;

#  define Rte_TypeDef_LRR_CAN_USC_Promote_t
typedef uint8 LRR_CAN_USC_Promote_t;

#  define Rte_TypeDef_LRR_CAN_VEHICLE_GEAR_ECHO_t
typedef uint8 LRR_CAN_VEHICLE_GEAR_ECHO_t;

#  define Rte_TypeDef_LRR_CAN_VEHICLE_SPEED_CALC_QF_EC_t
typedef uint8 LRR_CAN_VEHICLE_SPEED_CALC_QF_EC_t;

#  define Rte_TypeDef_LRR_CAN_VEHICLE_SPEED_ECHO_t
typedef float32 LRR_CAN_VEHICLE_SPEED_ECHO_t;

#  define Rte_TypeDef_LRR_CAN_VRTCL_ALIGN_UPDATES_Nbr_t
typedef uint16 LRR_CAN_VRTCL_ALIGN_UPDATES_Nbr_t;

#  define Rte_TypeDef_LRR_CAN_XCVR_OPERATIONAL_t
typedef boolean LRR_CAN_XCVR_OPERATIONAL_t;

#  define Rte_TypeDef_LRR_CAN_YAW_RATE_BIAS_ECHO_t
typedef float32 LRR_CAN_YAW_RATE_BIAS_ECHO_t;

#  define Rte_TypeDef_LRR_CAN_YAW_RATE_CALC_QF_ECHO_t
typedef uint8 LRR_CAN_YAW_RATE_CALC_QF_ECHO_t;

#  define Rte_TypeDef_LRR_CAN_YAW_RATE_ECHO_t
typedef float32 LRR_CAN_YAW_RATE_ECHO_t;

#  define Rte_TypeDef_LRR_Calibration_Not_Learned_Fault_t
typedef boolean LRR_Calibration_Not_Learned_Fault_t;

#  define Rte_TypeDef_LRR_Core_Radar_BB_Version_Field_t
typedef uint8 LRR_Core_Radar_BB_Version_Field_t;

#  define Rte_TypeDef_LRR_Core_Radar_BB_Version_Major_t
typedef uint8 LRR_Core_Radar_BB_Version_Major_t;

#  define Rte_TypeDef_LRR_Core_Radar_BB_Version_Minor_t
typedef uint8 LRR_Core_Radar_BB_Version_Minor_t;

#  define Rte_TypeDef_LRR_Core_Radar_BB_Version_Promt_t
typedef uint8 LRR_Core_Radar_BB_Version_Promt_t;

#  define Rte_TypeDef_LRR_Det_CRC_01_t
typedef uint8 LRR_Det_CRC_01_t;

#  define Rte_TypeDef_LRR_Det_CRC_02_t
typedef uint8 LRR_Det_CRC_02_t;

#  define Rte_TypeDef_LRR_Det_CRC_03_t
typedef uint8 LRR_Det_CRC_03_t;

#  define Rte_TypeDef_LRR_Det_CRC_04_t
typedef uint8 LRR_Det_CRC_04_t;

#  define Rte_TypeDef_LRR_Det_CRC_05_t
typedef uint8 LRR_Det_CRC_05_t;

#  define Rte_TypeDef_LRR_Det_CRC_06_t
typedef uint8 LRR_Det_CRC_06_t;

#  define Rte_TypeDef_LRR_Det_CRC_07_t
typedef uint8 LRR_Det_CRC_07_t;

#  define Rte_TypeDef_LRR_Det_CRC_08_t
typedef uint8 LRR_Det_CRC_08_t;

#  define Rte_TypeDef_LRR_Det_CRC_09_t
typedef uint8 LRR_Det_CRC_09_t;

#  define Rte_TypeDef_LRR_Det_CRC_10_t
typedef uint8 LRR_Det_CRC_10_t;

#  define Rte_TypeDef_LRR_Det_CRC_11_t
typedef uint8 LRR_Det_CRC_11_t;

#  define Rte_TypeDef_LRR_Det_CRC_12_t
typedef uint8 LRR_Det_CRC_12_t;

#  define Rte_TypeDef_LRR_Det_CRC_13_t
typedef uint8 LRR_Det_CRC_13_t;

#  define Rte_TypeDef_LRR_Det_CRC_14_t
typedef uint8 LRR_Det_CRC_14_t;

#  define Rte_TypeDef_LRR_Det_CRC_15_t
typedef uint8 LRR_Det_CRC_15_t;

#  define Rte_TypeDef_LRR_Det_CRC_16_t
typedef uint8 LRR_Det_CRC_16_t;

#  define Rte_TypeDef_LRR_Det_CRC_17_t
typedef uint8 LRR_Det_CRC_17_t;

#  define Rte_TypeDef_LRR_Det_CRC_18_t
typedef uint8 LRR_Det_CRC_18_t;

#  define Rte_TypeDef_LRR_Det_CRC_19_t
typedef uint8 LRR_Det_CRC_19_t;

#  define Rte_TypeDef_LRR_Det_CRC_20_t
typedef uint8 LRR_Det_CRC_20_t;

#  define Rte_TypeDef_LRR_Det_CRC_21_t
typedef uint8 LRR_Det_CRC_21_t;

#  define Rte_TypeDef_LRR_Det_CRC_22_t
typedef uint8 LRR_Det_CRC_22_t;

#  define Rte_TypeDef_LRR_Det_MC_01_t
typedef uint8 LRR_Det_MC_01_t;

#  define Rte_TypeDef_LRR_Det_MC_02_t
typedef uint8 LRR_Det_MC_02_t;

#  define Rte_TypeDef_LRR_Det_MC_03_t
typedef uint8 LRR_Det_MC_03_t;

#  define Rte_TypeDef_LRR_Det_MC_04_t
typedef uint8 LRR_Det_MC_04_t;

#  define Rte_TypeDef_LRR_Det_MC_05_t
typedef uint8 LRR_Det_MC_05_t;

#  define Rte_TypeDef_LRR_Det_MC_06_t
typedef uint8 LRR_Det_MC_06_t;

#  define Rte_TypeDef_LRR_Det_MC_07_t
typedef uint8 LRR_Det_MC_07_t;

#  define Rte_TypeDef_LRR_Det_MC_08_t
typedef uint8 LRR_Det_MC_08_t;

#  define Rte_TypeDef_LRR_Det_MC_09_t
typedef uint8 LRR_Det_MC_09_t;

#  define Rte_TypeDef_LRR_Det_MC_10_t
typedef uint8 LRR_Det_MC_10_t;

#  define Rte_TypeDef_LRR_Det_MC_11_t
typedef uint8 LRR_Det_MC_11_t;

#  define Rte_TypeDef_LRR_Det_MC_12_t
typedef uint8 LRR_Det_MC_12_t;

#  define Rte_TypeDef_LRR_Det_MC_13_t
typedef uint8 LRR_Det_MC_13_t;

#  define Rte_TypeDef_LRR_Det_MC_14_t
typedef uint8 LRR_Det_MC_14_t;

#  define Rte_TypeDef_LRR_Det_MC_15_t
typedef uint8 LRR_Det_MC_15_t;

#  define Rte_TypeDef_LRR_Det_MC_16_t
typedef uint8 LRR_Det_MC_16_t;

#  define Rte_TypeDef_LRR_Det_MC_17_t
typedef uint8 LRR_Det_MC_17_t;

#  define Rte_TypeDef_LRR_Det_MC_18_t
typedef uint8 LRR_Det_MC_18_t;

#  define Rte_TypeDef_LRR_Det_MC_19_t
typedef uint8 LRR_Det_MC_19_t;

#  define Rte_TypeDef_LRR_Det_MC_20_t
typedef uint8 LRR_Det_MC_20_t;

#  define Rte_TypeDef_LRR_Det_MC_21_t
typedef uint8 LRR_Det_MC_21_t;

#  define Rte_TypeDef_LRR_Det_MC_22_t
typedef uint8 LRR_Det_MC_22_t;

#  define Rte_TypeDef_LRR_HeadAlignSts_CRC_t
typedef uint8 LRR_HeadAlignSts_CRC_t;

#  define Rte_TypeDef_LRR_HeadAlignSts_MC_t
typedef uint8 LRR_HeadAlignSts_MC_t;

#  define Rte_TypeDef_LRR_HeadInfoDec_CRC_t
typedef uint8 LRR_HeadInfoDec_CRC_t;

#  define Rte_TypeDef_LRR_HeadInfoDec_MC_t
typedef uint8 LRR_HeadInfoDec_MC_t;

#  define Rte_TypeDef_LRR_HeadSenCov_CRC_t
typedef uint8 LRR_HeadSenCov_CRC_t;

#  define Rte_TypeDef_LRR_HeadSenCov_MC_t
typedef uint8 LRR_HeadSenCov_MC_t;

#  define Rte_TypeDef_LRR_HeadTimestamps_CRC_t
typedef uint8 LRR_HeadTimestamps_CRC_t;

#  define Rte_TypeDef_LRR_HeadTimestamps_MC_t
typedef uint8 LRR_HeadTimestamps_MC_t;

#  define Rte_TypeDef_LRR_Horizontal_Alignment_State_t
typedef uint8 LRR_Horizontal_Alignment_State_t;

#  define Rte_TypeDef_LRR_Horizontal_Alignment_Status_t
typedef uint8 LRR_Horizontal_Alignment_Status_t;

#  define Rte_TypeDef_LRR_Internal_Fault_t
typedef boolean LRR_Internal_Fault_t;

#  define Rte_TypeDef_LRR_LRR_CAN_SCAN_INDEX_t
typedef uint16 LRR_LRR_CAN_SCAN_INDEX_t;

#  define Rte_TypeDef_LRR_MEC_t
typedef boolean LRR_MEC_t;

#  define Rte_TypeDef_LRR_NUMBER_OF_OBJECTS_t
typedef uint8 LRR_NUMBER_OF_OBJECTS_t;

#  define Rte_TypeDef_LRR_S2_Invalid_Data_ASDM_Fault_t
typedef boolean LRR_S2_Invalid_Data_ASDM_Fault_t;

#  define Rte_TypeDef_LRR_S2_Lost_Comm_ASDM_Fault_t
typedef boolean LRR_S2_Lost_Comm_ASDM_Fault_t;

#  define Rte_TypeDef_LRR_SW_Flash_Counter_t
typedef uint32 LRR_SW_Flash_Counter_t;

#  define Rte_TypeDef_LRR_StsCANVer_CRC_t
typedef uint8 LRR_StsCANVer_CRC_t;

#  define Rte_TypeDef_LRR_StsCANVer_MC_t
typedef uint8 LRR_StsCANVer_MC_t;

#  define Rte_TypeDef_LRR_StsRadar_CRC_t
typedef uint8 LRR_StsRadar_CRC_t;

#  define Rte_TypeDef_LRR_StsRadar_MC_t
typedef uint8 LRR_StsRadar_MC_t;

#  define Rte_TypeDef_LRR_System_Operation_Mode_Status_t
typedef uint8 LRR_System_Operation_Mode_Status_t;

#  define Rte_TypeDef_LRR_Temperature_High_Fault_Fault_t
typedef boolean LRR_Temperature_High_Fault_Fault_t;

#  define Rte_TypeDef_LRR_Tracker_Valid_t
typedef uint8 LRR_Tracker_Valid_t;

#  define Rte_TypeDef_LRR_VIN_Mismatch_Fault_t
typedef boolean LRR_VIN_Mismatch_Fault_t;

#  define Rte_TypeDef_LRR_VIN_Not_Programmed_Fault_t
typedef boolean LRR_VIN_Not_Programmed_Fault_t;

#  define Rte_TypeDef_LRR_Vertical_Alignment_State_t
typedef uint8 LRR_Vertical_Alignment_State_t;

#  define Rte_TypeDef_LRR_Vertical_Alignment_Status_t
typedef uint8 LRR_Vertical_Alignment_Status_t;

#  define Rte_TypeDef_LRR_Voltage_Above_Thresh_Fault_t
typedef boolean LRR_Voltage_Above_Thresh_Fault_t;

#  define Rte_TypeDef_LRR_Voltage_Below_Thresh_Fault_t
typedef boolean LRR_Voltage_Below_Thresh_Fault_t;

#  define Rte_TypeDef_MCU1_AliveCounter
typedef uint8 MCU1_AliveCounter;

#  define Rte_TypeDef_MCU1_ControllerTorque
typedef uint16 MCU1_ControllerTorque;

#  define Rte_TypeDef_MCU1_CurrentTorque
typedef uint16 MCU1_CurrentTorque;

#  define Rte_TypeDef_MCU1_CurrentTorqueValid
typedef boolean MCU1_CurrentTorqueValid;

#  define Rte_TypeDef_MCU1_MotorSpeed
typedef uint16 MCU1_MotorSpeed;

#  define Rte_TypeDef_MCU1_presentActivityFault
typedef uint8 MCU1_presentActivityFault;

#  define Rte_TypeDef_MRR_ObjAccelX_10_idt
typedef uint16 MRR_ObjAccelX_10_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_11_idt
typedef uint16 MRR_ObjAccelX_11_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_12_idt
typedef uint16 MRR_ObjAccelX_12_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_13_idt
typedef uint16 MRR_ObjAccelX_13_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_14_idt
typedef uint16 MRR_ObjAccelX_14_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_15_idt
typedef uint16 MRR_ObjAccelX_15_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_16_idt
typedef uint16 MRR_ObjAccelX_16_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_17_idt
typedef uint16 MRR_ObjAccelX_17_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_18_idt
typedef uint16 MRR_ObjAccelX_18_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_19_idt
typedef uint16 MRR_ObjAccelX_19_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_1_idt
typedef uint16 MRR_ObjAccelX_1_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_20_idt
typedef uint16 MRR_ObjAccelX_20_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_21_idt
typedef uint16 MRR_ObjAccelX_21_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_22_idt
typedef uint16 MRR_ObjAccelX_22_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_23_idt
typedef uint16 MRR_ObjAccelX_23_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_24_idt
typedef uint16 MRR_ObjAccelX_24_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_25_idt
typedef uint16 MRR_ObjAccelX_25_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_26_idt
typedef uint16 MRR_ObjAccelX_26_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_27_idt
typedef uint16 MRR_ObjAccelX_27_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_28_idt
typedef uint16 MRR_ObjAccelX_28_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_29_idt
typedef uint16 MRR_ObjAccelX_29_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_2_idt
typedef uint16 MRR_ObjAccelX_2_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_30_idt
typedef uint16 MRR_ObjAccelX_30_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_31_idt
typedef uint16 MRR_ObjAccelX_31_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_32_idt
typedef uint16 MRR_ObjAccelX_32_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_3_idt
typedef uint16 MRR_ObjAccelX_3_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_4_idt
typedef uint16 MRR_ObjAccelX_4_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_5_idt
typedef uint16 MRR_ObjAccelX_5_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_6_idt
typedef uint16 MRR_ObjAccelX_6_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_7_idt
typedef uint16 MRR_ObjAccelX_7_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_8_idt
typedef uint16 MRR_ObjAccelX_8_idt;

#  define Rte_TypeDef_MRR_ObjAccelX_9_idt
typedef uint16 MRR_ObjAccelX_9_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_10_idt
typedef uint16 MRR_ObjAccelY_10_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_11_idt
typedef uint16 MRR_ObjAccelY_11_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_12_idt
typedef uint16 MRR_ObjAccelY_12_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_13_idt
typedef uint16 MRR_ObjAccelY_13_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_14_idt
typedef uint16 MRR_ObjAccelY_14_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_15_idt
typedef uint16 MRR_ObjAccelY_15_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_16_idt
typedef uint16 MRR_ObjAccelY_16_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_17_idt
typedef uint16 MRR_ObjAccelY_17_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_18_idt
typedef uint16 MRR_ObjAccelY_18_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_19_idt
typedef uint16 MRR_ObjAccelY_19_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_1_idt
typedef uint16 MRR_ObjAccelY_1_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_20_idt
typedef uint16 MRR_ObjAccelY_20_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_21_idt
typedef uint16 MRR_ObjAccelY_21_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_22_idt
typedef uint16 MRR_ObjAccelY_22_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_23_idt
typedef uint16 MRR_ObjAccelY_23_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_24_idt
typedef uint16 MRR_ObjAccelY_24_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_25_idt
typedef uint16 MRR_ObjAccelY_25_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_26_idt
typedef uint16 MRR_ObjAccelY_26_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_27_idt
typedef uint16 MRR_ObjAccelY_27_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_28_idt
typedef uint16 MRR_ObjAccelY_28_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_29_idt
typedef uint16 MRR_ObjAccelY_29_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_2_idt
typedef uint16 MRR_ObjAccelY_2_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_30_idt
typedef uint16 MRR_ObjAccelY_30_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_31_idt
typedef uint16 MRR_ObjAccelY_31_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_32_idt
typedef uint16 MRR_ObjAccelY_32_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_3_idt
typedef uint16 MRR_ObjAccelY_3_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_4_idt
typedef uint16 MRR_ObjAccelY_4_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_5_idt
typedef uint16 MRR_ObjAccelY_5_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_6_idt
typedef uint16 MRR_ObjAccelY_6_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_7_idt
typedef uint16 MRR_ObjAccelY_7_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_8_idt
typedef uint16 MRR_ObjAccelY_8_idt;

#  define Rte_TypeDef_MRR_ObjAccelY_9_idt
typedef uint16 MRR_ObjAccelY_9_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_10_idt
typedef uint8 MRR_ObjDistXStd_10_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_11_idt
typedef uint8 MRR_ObjDistXStd_11_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_12_idt
typedef uint8 MRR_ObjDistXStd_12_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_13_idt
typedef uint8 MRR_ObjDistXStd_13_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_14_idt
typedef uint8 MRR_ObjDistXStd_14_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_15_idt
typedef uint8 MRR_ObjDistXStd_15_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_16_idt
typedef uint8 MRR_ObjDistXStd_16_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_17_idt
typedef uint8 MRR_ObjDistXStd_17_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_18_idt
typedef uint8 MRR_ObjDistXStd_18_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_19_idt
typedef uint8 MRR_ObjDistXStd_19_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_1_idt
typedef uint8 MRR_ObjDistXStd_1_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_20_idt
typedef uint8 MRR_ObjDistXStd_20_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_21_idt
typedef uint8 MRR_ObjDistXStd_21_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_22_idt
typedef uint8 MRR_ObjDistXStd_22_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_23_idt
typedef uint8 MRR_ObjDistXStd_23_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_24_idt
typedef uint8 MRR_ObjDistXStd_24_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_25_idt
typedef uint8 MRR_ObjDistXStd_25_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_26_idt
typedef uint8 MRR_ObjDistXStd_26_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_27_idt
typedef uint8 MRR_ObjDistXStd_27_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_28_idt
typedef uint8 MRR_ObjDistXStd_28_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_29_idt
typedef uint8 MRR_ObjDistXStd_29_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_2_idt
typedef uint8 MRR_ObjDistXStd_2_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_30_idt
typedef uint8 MRR_ObjDistXStd_30_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_31_idt
typedef uint8 MRR_ObjDistXStd_31_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_32_idt
typedef uint8 MRR_ObjDistXStd_32_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_3_idt
typedef uint8 MRR_ObjDistXStd_3_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_4_idt
typedef uint8 MRR_ObjDistXStd_4_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_5_idt
typedef uint8 MRR_ObjDistXStd_5_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_6_idt
typedef uint8 MRR_ObjDistXStd_6_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_7_idt
typedef uint8 MRR_ObjDistXStd_7_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_8_idt
typedef uint8 MRR_ObjDistXStd_8_idt;

#  define Rte_TypeDef_MRR_ObjDistXStd_9_idt
typedef uint8 MRR_ObjDistXStd_9_idt;

#  define Rte_TypeDef_MRR_ObjDistX_10_idt
typedef uint16 MRR_ObjDistX_10_idt;

#  define Rte_TypeDef_MRR_ObjDistX_11_idt
typedef uint16 MRR_ObjDistX_11_idt;

#  define Rte_TypeDef_MRR_ObjDistX_12_idt
typedef uint16 MRR_ObjDistX_12_idt;

#  define Rte_TypeDef_MRR_ObjDistX_13_idt
typedef uint16 MRR_ObjDistX_13_idt;

#  define Rte_TypeDef_MRR_ObjDistX_14_idt
typedef uint16 MRR_ObjDistX_14_idt;

#  define Rte_TypeDef_MRR_ObjDistX_15_idt
typedef uint16 MRR_ObjDistX_15_idt;

#  define Rte_TypeDef_MRR_ObjDistX_16_idt
typedef uint16 MRR_ObjDistX_16_idt;

#  define Rte_TypeDef_MRR_ObjDistX_17_idt
typedef uint16 MRR_ObjDistX_17_idt;

#  define Rte_TypeDef_MRR_ObjDistX_18_idt
typedef uint16 MRR_ObjDistX_18_idt;

#  define Rte_TypeDef_MRR_ObjDistX_19_idt
typedef uint16 MRR_ObjDistX_19_idt;

#  define Rte_TypeDef_MRR_ObjDistX_1_idt
typedef uint16 MRR_ObjDistX_1_idt;

#  define Rte_TypeDef_MRR_ObjDistX_20_idt
typedef uint16 MRR_ObjDistX_20_idt;

#  define Rte_TypeDef_MRR_ObjDistX_21_idt
typedef uint16 MRR_ObjDistX_21_idt;

#  define Rte_TypeDef_MRR_ObjDistX_22_idt
typedef uint16 MRR_ObjDistX_22_idt;

#  define Rte_TypeDef_MRR_ObjDistX_23_idt
typedef uint16 MRR_ObjDistX_23_idt;

#  define Rte_TypeDef_MRR_ObjDistX_24_idt
typedef uint16 MRR_ObjDistX_24_idt;

#  define Rte_TypeDef_MRR_ObjDistX_25_idt
typedef uint16 MRR_ObjDistX_25_idt;

#  define Rte_TypeDef_MRR_ObjDistX_26_idt
typedef uint16 MRR_ObjDistX_26_idt;

#  define Rte_TypeDef_MRR_ObjDistX_27_idt
typedef uint16 MRR_ObjDistX_27_idt;

#  define Rte_TypeDef_MRR_ObjDistX_28_idt
typedef uint16 MRR_ObjDistX_28_idt;

#  define Rte_TypeDef_MRR_ObjDistX_29_idt
typedef uint16 MRR_ObjDistX_29_idt;

#  define Rte_TypeDef_MRR_ObjDistX_2_idt
typedef uint16 MRR_ObjDistX_2_idt;

#  define Rte_TypeDef_MRR_ObjDistX_30_idt
typedef uint16 MRR_ObjDistX_30_idt;

#  define Rte_TypeDef_MRR_ObjDistX_31_idt
typedef uint16 MRR_ObjDistX_31_idt;

#  define Rte_TypeDef_MRR_ObjDistX_32_idt
typedef uint16 MRR_ObjDistX_32_idt;

#  define Rte_TypeDef_MRR_ObjDistX_3_idt
typedef uint16 MRR_ObjDistX_3_idt;

#  define Rte_TypeDef_MRR_ObjDistX_4_idt
typedef uint16 MRR_ObjDistX_4_idt;

#  define Rte_TypeDef_MRR_ObjDistX_5_idt
typedef uint16 MRR_ObjDistX_5_idt;

#  define Rte_TypeDef_MRR_ObjDistX_6_idt
typedef uint16 MRR_ObjDistX_6_idt;

#  define Rte_TypeDef_MRR_ObjDistX_7_idt
typedef uint16 MRR_ObjDistX_7_idt;

#  define Rte_TypeDef_MRR_ObjDistX_8_idt
typedef uint16 MRR_ObjDistX_8_idt;

#  define Rte_TypeDef_MRR_ObjDistX_9_idt
typedef uint16 MRR_ObjDistX_9_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_10_idt
typedef uint8 MRR_ObjDistYStd_10_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_11_idt
typedef uint8 MRR_ObjDistYStd_11_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_12_idt
typedef uint8 MRR_ObjDistYStd_12_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_13_idt
typedef uint8 MRR_ObjDistYStd_13_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_14_idt
typedef uint8 MRR_ObjDistYStd_14_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_15_idt
typedef uint8 MRR_ObjDistYStd_15_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_16_idt
typedef uint8 MRR_ObjDistYStd_16_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_17_idt
typedef uint8 MRR_ObjDistYStd_17_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_18_idt
typedef uint8 MRR_ObjDistYStd_18_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_19_idt
typedef uint8 MRR_ObjDistYStd_19_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_1_idt
typedef uint8 MRR_ObjDistYStd_1_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_20_idt
typedef uint8 MRR_ObjDistYStd_20_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_21_idt
typedef uint8 MRR_ObjDistYStd_21_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_22_idt
typedef uint8 MRR_ObjDistYStd_22_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_23_idt
typedef uint8 MRR_ObjDistYStd_23_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_24_idt
typedef uint8 MRR_ObjDistYStd_24_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_25_idt
typedef uint8 MRR_ObjDistYStd_25_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_26_idt
typedef uint8 MRR_ObjDistYStd_26_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_27_idt
typedef uint8 MRR_ObjDistYStd_27_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_28_idt
typedef uint8 MRR_ObjDistYStd_28_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_29_idt
typedef uint8 MRR_ObjDistYStd_29_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_2_idt
typedef uint8 MRR_ObjDistYStd_2_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_30_idt
typedef uint8 MRR_ObjDistYStd_30_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_31_idt
typedef uint8 MRR_ObjDistYStd_31_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_32_idt
typedef uint8 MRR_ObjDistYStd_32_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_3_idt
typedef uint8 MRR_ObjDistYStd_3_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_4_idt
typedef uint8 MRR_ObjDistYStd_4_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_5_idt
typedef uint8 MRR_ObjDistYStd_5_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_6_idt
typedef uint8 MRR_ObjDistYStd_6_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_7_idt
typedef uint8 MRR_ObjDistYStd_7_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_8_idt
typedef uint8 MRR_ObjDistYStd_8_idt;

#  define Rte_TypeDef_MRR_ObjDistYStd_9_idt
typedef uint8 MRR_ObjDistYStd_9_idt;

#  define Rte_TypeDef_MRR_ObjDistY_10_idt
typedef uint16 MRR_ObjDistY_10_idt;

#  define Rte_TypeDef_MRR_ObjDistY_11_idt
typedef uint16 MRR_ObjDistY_11_idt;

#  define Rte_TypeDef_MRR_ObjDistY_12_idt
typedef uint16 MRR_ObjDistY_12_idt;

#  define Rte_TypeDef_MRR_ObjDistY_13_idt
typedef uint16 MRR_ObjDistY_13_idt;

#  define Rte_TypeDef_MRR_ObjDistY_14_idt
typedef uint16 MRR_ObjDistY_14_idt;

#  define Rte_TypeDef_MRR_ObjDistY_15_idt
typedef uint16 MRR_ObjDistY_15_idt;

#  define Rte_TypeDef_MRR_ObjDistY_16_idt
typedef uint16 MRR_ObjDistY_16_idt;

#  define Rte_TypeDef_MRR_ObjDistY_17_idt
typedef uint16 MRR_ObjDistY_17_idt;

#  define Rte_TypeDef_MRR_ObjDistY_18_idt
typedef uint16 MRR_ObjDistY_18_idt;

#  define Rte_TypeDef_MRR_ObjDistY_19_idt
typedef uint16 MRR_ObjDistY_19_idt;

#  define Rte_TypeDef_MRR_ObjDistY_1_idt
typedef uint16 MRR_ObjDistY_1_idt;

#  define Rte_TypeDef_MRR_ObjDistY_20_idt
typedef uint16 MRR_ObjDistY_20_idt;

#  define Rte_TypeDef_MRR_ObjDistY_21_idt
typedef uint16 MRR_ObjDistY_21_idt;

#  define Rte_TypeDef_MRR_ObjDistY_22_idt
typedef uint16 MRR_ObjDistY_22_idt;

#  define Rte_TypeDef_MRR_ObjDistY_23_idt
typedef uint16 MRR_ObjDistY_23_idt;

#  define Rte_TypeDef_MRR_ObjDistY_24_idt
typedef uint16 MRR_ObjDistY_24_idt;

#  define Rte_TypeDef_MRR_ObjDistY_25_idt
typedef uint16 MRR_ObjDistY_25_idt;

#  define Rte_TypeDef_MRR_ObjDistY_26_idt
typedef uint16 MRR_ObjDistY_26_idt;

#  define Rte_TypeDef_MRR_ObjDistY_27_idt
typedef uint16 MRR_ObjDistY_27_idt;

#  define Rte_TypeDef_MRR_ObjDistY_28_idt
typedef uint16 MRR_ObjDistY_28_idt;

#  define Rte_TypeDef_MRR_ObjDistY_29_idt
typedef uint16 MRR_ObjDistY_29_idt;

#  define Rte_TypeDef_MRR_ObjDistY_2_idt
typedef uint16 MRR_ObjDistY_2_idt;

#  define Rte_TypeDef_MRR_ObjDistY_30_idt
typedef uint16 MRR_ObjDistY_30_idt;

#  define Rte_TypeDef_MRR_ObjDistY_31_idt
typedef uint16 MRR_ObjDistY_31_idt;

#  define Rte_TypeDef_MRR_ObjDistY_32_idt
typedef uint16 MRR_ObjDistY_32_idt;

#  define Rte_TypeDef_MRR_ObjDistY_3_idt
typedef uint16 MRR_ObjDistY_3_idt;

#  define Rte_TypeDef_MRR_ObjDistY_4_idt
typedef uint16 MRR_ObjDistY_4_idt;

#  define Rte_TypeDef_MRR_ObjDistY_5_idt
typedef uint16 MRR_ObjDistY_5_idt;

#  define Rte_TypeDef_MRR_ObjDistY_6_idt
typedef uint16 MRR_ObjDistY_6_idt;

#  define Rte_TypeDef_MRR_ObjDistY_7_idt
typedef uint16 MRR_ObjDistY_7_idt;

#  define Rte_TypeDef_MRR_ObjDistY_8_idt
typedef uint16 MRR_ObjDistY_8_idt;

#  define Rte_TypeDef_MRR_ObjDistY_9_idt
typedef uint16 MRR_ObjDistY_9_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_10_idt
typedef uint8 MRR_ObjExistProb_10_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_11_idt
typedef uint8 MRR_ObjExistProb_11_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_12_idt
typedef uint8 MRR_ObjExistProb_12_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_13_idt
typedef uint8 MRR_ObjExistProb_13_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_14_idt
typedef uint8 MRR_ObjExistProb_14_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_15_idt
typedef uint8 MRR_ObjExistProb_15_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_16_idt
typedef uint8 MRR_ObjExistProb_16_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_17_idt
typedef uint8 MRR_ObjExistProb_17_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_18_idt
typedef uint8 MRR_ObjExistProb_18_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_19_idt
typedef uint8 MRR_ObjExistProb_19_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_1_idt
typedef uint8 MRR_ObjExistProb_1_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_20_idt
typedef uint8 MRR_ObjExistProb_20_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_21_idt
typedef uint8 MRR_ObjExistProb_21_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_22_idt
typedef uint8 MRR_ObjExistProb_22_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_23_idt
typedef uint8 MRR_ObjExistProb_23_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_24_idt
typedef uint8 MRR_ObjExistProb_24_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_25_idt
typedef uint8 MRR_ObjExistProb_25_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_26_idt
typedef uint8 MRR_ObjExistProb_26_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_27_idt
typedef uint8 MRR_ObjExistProb_27_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_28_idt
typedef uint8 MRR_ObjExistProb_28_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_29_idt
typedef uint8 MRR_ObjExistProb_29_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_2_idt
typedef uint8 MRR_ObjExistProb_2_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_30_idt
typedef uint8 MRR_ObjExistProb_30_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_31_idt
typedef uint8 MRR_ObjExistProb_31_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_32_idt
typedef uint8 MRR_ObjExistProb_32_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_3_idt
typedef uint8 MRR_ObjExistProb_3_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_4_idt
typedef uint8 MRR_ObjExistProb_4_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_5_idt
typedef uint8 MRR_ObjExistProb_5_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_6_idt
typedef uint8 MRR_ObjExistProb_6_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_7_idt
typedef uint8 MRR_ObjExistProb_7_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_8_idt
typedef uint8 MRR_ObjExistProb_8_idt;

#  define Rte_TypeDef_MRR_ObjExistProb_9_idt
typedef uint8 MRR_ObjExistProb_9_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_10_idt
typedef uint8 MRR_ObjObstacleProb_10_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_11_idt
typedef uint8 MRR_ObjObstacleProb_11_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_12_idt
typedef uint8 MRR_ObjObstacleProb_12_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_13_idt
typedef uint8 MRR_ObjObstacleProb_13_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_14_idt
typedef uint8 MRR_ObjObstacleProb_14_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_15_idt
typedef uint8 MRR_ObjObstacleProb_15_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_16_idt
typedef uint8 MRR_ObjObstacleProb_16_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_17_idt
typedef uint8 MRR_ObjObstacleProb_17_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_18_idt
typedef uint8 MRR_ObjObstacleProb_18_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_19_idt
typedef uint8 MRR_ObjObstacleProb_19_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_1_idt
typedef uint8 MRR_ObjObstacleProb_1_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_20_idt
typedef uint8 MRR_ObjObstacleProb_20_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_21_idt
typedef uint8 MRR_ObjObstacleProb_21_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_22_idt
typedef uint8 MRR_ObjObstacleProb_22_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_23_idt
typedef uint8 MRR_ObjObstacleProb_23_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_24_idt
typedef uint8 MRR_ObjObstacleProb_24_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_25_idt
typedef uint8 MRR_ObjObstacleProb_25_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_26_idt
typedef uint8 MRR_ObjObstacleProb_26_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_27_idt
typedef uint8 MRR_ObjObstacleProb_27_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_28_idt
typedef uint8 MRR_ObjObstacleProb_28_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_29_idt
typedef uint8 MRR_ObjObstacleProb_29_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_2_idt
typedef uint8 MRR_ObjObstacleProb_2_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_30_idt
typedef uint8 MRR_ObjObstacleProb_30_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_31_idt
typedef uint8 MRR_ObjObstacleProb_31_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_32_idt
typedef uint8 MRR_ObjObstacleProb_32_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_3_idt
typedef uint8 MRR_ObjObstacleProb_3_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_4_idt
typedef uint8 MRR_ObjObstacleProb_4_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_5_idt
typedef uint8 MRR_ObjObstacleProb_5_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_6_idt
typedef uint8 MRR_ObjObstacleProb_6_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_7_idt
typedef uint8 MRR_ObjObstacleProb_7_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_8_idt
typedef uint8 MRR_ObjObstacleProb_8_idt;

#  define Rte_TypeDef_MRR_ObjObstacleProb_9_idt
typedef uint8 MRR_ObjObstacleProb_9_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_10_idt
typedef uint8 MRR_ObjRAccelXStd_10_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_11_idt
typedef uint8 MRR_ObjRAccelXStd_11_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_12_idt
typedef uint8 MRR_ObjRAccelXStd_12_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_13_idt
typedef uint8 MRR_ObjRAccelXStd_13_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_14_idt
typedef uint8 MRR_ObjRAccelXStd_14_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_15_idt
typedef uint8 MRR_ObjRAccelXStd_15_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_16_idt
typedef uint8 MRR_ObjRAccelXStd_16_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_17_idt
typedef uint8 MRR_ObjRAccelXStd_17_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_18_idt
typedef uint8 MRR_ObjRAccelXStd_18_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_19_idt
typedef uint8 MRR_ObjRAccelXStd_19_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_1_idt
typedef uint8 MRR_ObjRAccelXStd_1_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_20_idt
typedef uint8 MRR_ObjRAccelXStd_20_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_21_idt
typedef uint8 MRR_ObjRAccelXStd_21_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_22_idt
typedef uint8 MRR_ObjRAccelXStd_22_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_23_idt
typedef uint8 MRR_ObjRAccelXStd_23_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_24_idt
typedef uint8 MRR_ObjRAccelXStd_24_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_25_idt
typedef uint8 MRR_ObjRAccelXStd_25_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_26_idt
typedef uint8 MRR_ObjRAccelXStd_26_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_27_idt
typedef uint8 MRR_ObjRAccelXStd_27_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_28_idt
typedef uint8 MRR_ObjRAccelXStd_28_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_29_idt
typedef uint8 MRR_ObjRAccelXStd_29_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_2_idt
typedef uint8 MRR_ObjRAccelXStd_2_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_30_idt
typedef uint8 MRR_ObjRAccelXStd_30_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_31_idt
typedef uint8 MRR_ObjRAccelXStd_31_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_32_idt
typedef uint8 MRR_ObjRAccelXStd_32_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_3_idt
typedef uint8 MRR_ObjRAccelXStd_3_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_4_idt
typedef uint8 MRR_ObjRAccelXStd_4_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_5_idt
typedef uint8 MRR_ObjRAccelXStd_5_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_6_idt
typedef uint8 MRR_ObjRAccelXStd_6_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_7_idt
typedef uint8 MRR_ObjRAccelXStd_7_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_8_idt
typedef uint8 MRR_ObjRAccelXStd_8_idt;

#  define Rte_TypeDef_MRR_ObjRAccelXStd_9_idt
typedef uint8 MRR_ObjRAccelXStd_9_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_10_idt
typedef uint8 MRR_ObjRAccelYStd_10_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_11_idt
typedef uint8 MRR_ObjRAccelYStd_11_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_12_idt
typedef uint8 MRR_ObjRAccelYStd_12_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_13_idt
typedef uint8 MRR_ObjRAccelYStd_13_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_14_idt
typedef uint8 MRR_ObjRAccelYStd_14_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_15_idt
typedef uint8 MRR_ObjRAccelYStd_15_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_16_idt
typedef uint8 MRR_ObjRAccelYStd_16_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_17_idt
typedef uint8 MRR_ObjRAccelYStd_17_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_18_idt
typedef uint8 MRR_ObjRAccelYStd_18_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_19_idt
typedef uint8 MRR_ObjRAccelYStd_19_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_1_idt
typedef uint8 MRR_ObjRAccelYStd_1_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_20_idt
typedef uint8 MRR_ObjRAccelYStd_20_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_21_idt
typedef uint8 MRR_ObjRAccelYStd_21_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_22_idt
typedef uint8 MRR_ObjRAccelYStd_22_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_23_idt
typedef uint8 MRR_ObjRAccelYStd_23_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_24_idt
typedef uint8 MRR_ObjRAccelYStd_24_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_25_idt
typedef uint8 MRR_ObjRAccelYStd_25_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_26_idt
typedef uint8 MRR_ObjRAccelYStd_26_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_27_idt
typedef uint8 MRR_ObjRAccelYStd_27_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_28_idt
typedef uint8 MRR_ObjRAccelYStd_28_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_29_idt
typedef uint8 MRR_ObjRAccelYStd_29_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_2_idt
typedef uint8 MRR_ObjRAccelYStd_2_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_30_idt
typedef uint8 MRR_ObjRAccelYStd_30_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_31_idt
typedef uint8 MRR_ObjRAccelYStd_31_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_32_idt
typedef uint8 MRR_ObjRAccelYStd_32_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_3_idt
typedef uint8 MRR_ObjRAccelYStd_3_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_4_idt
typedef uint8 MRR_ObjRAccelYStd_4_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_5_idt
typedef uint8 MRR_ObjRAccelYStd_5_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_6_idt
typedef uint8 MRR_ObjRAccelYStd_6_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_7_idt
typedef uint8 MRR_ObjRAccelYStd_7_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_8_idt
typedef uint8 MRR_ObjRAccelYStd_8_idt;

#  define Rte_TypeDef_MRR_ObjRAccelYStd_9_idt
typedef uint8 MRR_ObjRAccelYStd_9_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_10_idt
typedef uint8 MRR_ObjRelVelXStd_10_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_11_idt
typedef uint8 MRR_ObjRelVelXStd_11_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_12_idt
typedef uint8 MRR_ObjRelVelXStd_12_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_13_idt
typedef uint8 MRR_ObjRelVelXStd_13_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_14_idt
typedef uint8 MRR_ObjRelVelXStd_14_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_15_idt
typedef uint8 MRR_ObjRelVelXStd_15_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_16_idt
typedef uint8 MRR_ObjRelVelXStd_16_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_17_idt
typedef uint8 MRR_ObjRelVelXStd_17_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_18_idt
typedef uint8 MRR_ObjRelVelXStd_18_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_19_idt
typedef uint8 MRR_ObjRelVelXStd_19_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_1_idt
typedef uint8 MRR_ObjRelVelXStd_1_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_20_idt
typedef uint8 MRR_ObjRelVelXStd_20_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_21_idt
typedef uint8 MRR_ObjRelVelXStd_21_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_22_idt
typedef uint8 MRR_ObjRelVelXStd_22_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_23_idt
typedef uint8 MRR_ObjRelVelXStd_23_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_24_idt
typedef uint8 MRR_ObjRelVelXStd_24_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_25_idt
typedef uint8 MRR_ObjRelVelXStd_25_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_26_idt
typedef uint8 MRR_ObjRelVelXStd_26_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_27_idt
typedef uint8 MRR_ObjRelVelXStd_27_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_28_idt
typedef uint8 MRR_ObjRelVelXStd_28_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_29_idt
typedef uint8 MRR_ObjRelVelXStd_29_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_2_idt
typedef uint8 MRR_ObjRelVelXStd_2_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_30_idt
typedef uint8 MRR_ObjRelVelXStd_30_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_31_idt
typedef uint8 MRR_ObjRelVelXStd_31_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_32_idt
typedef uint8 MRR_ObjRelVelXStd_32_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_3_idt
typedef uint8 MRR_ObjRelVelXStd_3_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_4_idt
typedef uint8 MRR_ObjRelVelXStd_4_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_5_idt
typedef uint8 MRR_ObjRelVelXStd_5_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_6_idt
typedef uint8 MRR_ObjRelVelXStd_6_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_7_idt
typedef uint8 MRR_ObjRelVelXStd_7_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_8_idt
typedef uint8 MRR_ObjRelVelXStd_8_idt;

#  define Rte_TypeDef_MRR_ObjRelVelXStd_9_idt
typedef uint8 MRR_ObjRelVelXStd_9_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_10_idt
typedef uint16 MRR_ObjRelVelX_10_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_11_idt
typedef uint16 MRR_ObjRelVelX_11_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_12_idt
typedef uint16 MRR_ObjRelVelX_12_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_13_idt
typedef uint16 MRR_ObjRelVelX_13_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_14_idt
typedef uint16 MRR_ObjRelVelX_14_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_15_idt
typedef uint16 MRR_ObjRelVelX_15_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_16_idt
typedef uint16 MRR_ObjRelVelX_16_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_17_idt
typedef uint16 MRR_ObjRelVelX_17_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_18_idt
typedef uint16 MRR_ObjRelVelX_18_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_19_idt
typedef uint16 MRR_ObjRelVelX_19_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_1_idt
typedef uint16 MRR_ObjRelVelX_1_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_20_idt
typedef uint16 MRR_ObjRelVelX_20_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_21_idt
typedef uint16 MRR_ObjRelVelX_21_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_22_idt
typedef uint16 MRR_ObjRelVelX_22_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_23_idt
typedef uint16 MRR_ObjRelVelX_23_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_24_idt
typedef uint16 MRR_ObjRelVelX_24_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_25_idt
typedef uint16 MRR_ObjRelVelX_25_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_26_idt
typedef uint16 MRR_ObjRelVelX_26_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_27_idt
typedef uint16 MRR_ObjRelVelX_27_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_28_idt
typedef uint16 MRR_ObjRelVelX_28_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_29_idt
typedef uint16 MRR_ObjRelVelX_29_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_2_idt
typedef uint16 MRR_ObjRelVelX_2_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_30_idt
typedef uint16 MRR_ObjRelVelX_30_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_31_idt
typedef uint16 MRR_ObjRelVelX_31_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_32_idt
typedef uint16 MRR_ObjRelVelX_32_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_3_idt
typedef uint16 MRR_ObjRelVelX_3_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_4_idt
typedef uint16 MRR_ObjRelVelX_4_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_5_idt
typedef uint16 MRR_ObjRelVelX_5_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_6_idt
typedef uint16 MRR_ObjRelVelX_6_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_7_idt
typedef uint16 MRR_ObjRelVelX_7_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_8_idt
typedef uint16 MRR_ObjRelVelX_8_idt;

#  define Rte_TypeDef_MRR_ObjRelVelX_9_idt
typedef uint16 MRR_ObjRelVelX_9_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_10_idt
typedef uint8 MRR_ObjRelVelYStd_10_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_11_idt
typedef uint8 MRR_ObjRelVelYStd_11_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_12_idt
typedef uint8 MRR_ObjRelVelYStd_12_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_13_idt
typedef uint8 MRR_ObjRelVelYStd_13_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_14_idt
typedef uint8 MRR_ObjRelVelYStd_14_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_15_idt
typedef uint8 MRR_ObjRelVelYStd_15_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_16_idt
typedef uint8 MRR_ObjRelVelYStd_16_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_17_idt
typedef uint8 MRR_ObjRelVelYStd_17_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_18_idt
typedef uint8 MRR_ObjRelVelYStd_18_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_19_idt
typedef uint8 MRR_ObjRelVelYStd_19_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_1_idt
typedef uint8 MRR_ObjRelVelYStd_1_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_20_idt
typedef uint8 MRR_ObjRelVelYStd_20_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_21_idt
typedef uint8 MRR_ObjRelVelYStd_21_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_22_idt
typedef uint8 MRR_ObjRelVelYStd_22_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_23_idt
typedef uint8 MRR_ObjRelVelYStd_23_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_24_idt
typedef uint8 MRR_ObjRelVelYStd_24_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_25_idt
typedef uint8 MRR_ObjRelVelYStd_25_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_26_idt
typedef uint8 MRR_ObjRelVelYStd_26_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_27_idt
typedef uint8 MRR_ObjRelVelYStd_27_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_28_idt
typedef uint8 MRR_ObjRelVelYStd_28_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_29_idt
typedef uint8 MRR_ObjRelVelYStd_29_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_2_idt
typedef uint8 MRR_ObjRelVelYStd_2_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_30_idt
typedef uint8 MRR_ObjRelVelYStd_30_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_31_idt
typedef uint8 MRR_ObjRelVelYStd_31_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_32_idt
typedef uint8 MRR_ObjRelVelYStd_32_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_3_idt
typedef uint8 MRR_ObjRelVelYStd_3_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_4_idt
typedef uint8 MRR_ObjRelVelYStd_4_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_5_idt
typedef uint8 MRR_ObjRelVelYStd_5_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_6_idt
typedef uint8 MRR_ObjRelVelYStd_6_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_7_idt
typedef uint8 MRR_ObjRelVelYStd_7_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_8_idt
typedef uint8 MRR_ObjRelVelYStd_8_idt;

#  define Rte_TypeDef_MRR_ObjRelVelYStd_9_idt
typedef uint8 MRR_ObjRelVelYStd_9_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_10_idt
typedef uint16 MRR_ObjRelVelY_10_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_11_idt
typedef uint16 MRR_ObjRelVelY_11_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_12_idt
typedef uint16 MRR_ObjRelVelY_12_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_13_idt
typedef uint16 MRR_ObjRelVelY_13_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_14_idt
typedef uint16 MRR_ObjRelVelY_14_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_15_idt
typedef uint16 MRR_ObjRelVelY_15_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_16_idt
typedef uint16 MRR_ObjRelVelY_16_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_17_idt
typedef uint16 MRR_ObjRelVelY_17_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_18_idt
typedef uint16 MRR_ObjRelVelY_18_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_19_idt
typedef uint16 MRR_ObjRelVelY_19_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_1_idt
typedef uint16 MRR_ObjRelVelY_1_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_20_idt
typedef uint16 MRR_ObjRelVelY_20_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_21_idt
typedef uint16 MRR_ObjRelVelY_21_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_22_idt
typedef uint16 MRR_ObjRelVelY_22_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_23_idt
typedef uint16 MRR_ObjRelVelY_23_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_24_idt
typedef uint16 MRR_ObjRelVelY_24_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_25_idt
typedef uint16 MRR_ObjRelVelY_25_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_26_idt
typedef uint16 MRR_ObjRelVelY_26_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_27_idt
typedef uint16 MRR_ObjRelVelY_27_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_28_idt
typedef uint16 MRR_ObjRelVelY_28_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_29_idt
typedef uint16 MRR_ObjRelVelY_29_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_2_idt
typedef uint16 MRR_ObjRelVelY_2_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_30_idt
typedef uint16 MRR_ObjRelVelY_30_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_31_idt
typedef uint16 MRR_ObjRelVelY_31_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_32_idt
typedef uint16 MRR_ObjRelVelY_32_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_3_idt
typedef uint16 MRR_ObjRelVelY_3_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_4_idt
typedef uint16 MRR_ObjRelVelY_4_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_5_idt
typedef uint16 MRR_ObjRelVelY_5_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_6_idt
typedef uint16 MRR_ObjRelVelY_6_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_7_idt
typedef uint16 MRR_ObjRelVelY_7_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_8_idt
typedef uint16 MRR_ObjRelVelY_8_idt;

#  define Rte_TypeDef_MRR_ObjRelVelY_9_idt
typedef uint16 MRR_ObjRelVelY_9_idt;

#  define Rte_TypeDef_MinuteOfHour
typedef uint8 MinuteOfHour;

#  define Rte_TypeDef_ObsDataTmsp_idt
typedef uint32 ObsDataTmsp_idt;

#  define Rte_TypeDef_PA_object_ID1
typedef uint8 PA_object_ID1;

#  define Rte_TypeDef_PA_object_ID10
typedef uint8 PA_object_ID10;

#  define Rte_TypeDef_PA_object_ID11
typedef uint8 PA_object_ID11;

#  define Rte_TypeDef_PA_object_ID12
typedef uint8 PA_object_ID12;

#  define Rte_TypeDef_PA_object_ID13
typedef uint8 PA_object_ID13;

#  define Rte_TypeDef_PA_object_ID14
typedef uint8 PA_object_ID14;

#  define Rte_TypeDef_PA_object_ID15
typedef uint8 PA_object_ID15;

#  define Rte_TypeDef_PA_object_ID16
typedef uint8 PA_object_ID16;

#  define Rte_TypeDef_PA_object_ID2
typedef uint8 PA_object_ID2;

#  define Rte_TypeDef_PA_object_ID3
typedef uint8 PA_object_ID3;

#  define Rte_TypeDef_PA_object_ID4
typedef uint8 PA_object_ID4;

#  define Rte_TypeDef_PA_object_ID5
typedef uint8 PA_object_ID5;

#  define Rte_TypeDef_PA_object_ID6
typedef uint8 PA_object_ID6;

#  define Rte_TypeDef_PA_object_ID7
typedef uint8 PA_object_ID7;

#  define Rte_TypeDef_PA_object_ID8
typedef uint8 PA_object_ID8;

#  define Rte_TypeDef_PA_object_ID9
typedef uint8 PA_object_ID9;

#  define Rte_TypeDef_PDCU1_FRDoorAjar
typedef uint8 PDCU1_FRDoorAjar;

#  define Rte_TypeDef_PDCU1_FRDoorAjar_t
typedef uint8 PDCU1_FRDoorAjar_t;

#  define Rte_TypeDef_PDCU1_FR_LockSt
typedef uint8 PDCU1_FR_LockSt;

#  define Rte_TypeDef_PDCU1_FR_WinPos
typedef uint8 PDCU1_FR_WinPos;

#  define Rte_TypeDef_PDCU1_RRDoorAjar
typedef uint8 PDCU1_RRDoorAjar;

#  define Rte_TypeDef_PDCU1_RRDoorAjar_t
typedef uint8 PDCU1_RRDoorAjar_t;

#  define Rte_TypeDef_PDCU1_RR_LockSt
typedef uint8 PDCU1_RR_LockSt;

#  define Rte_TypeDef_PDCU1_RR_WinPos
typedef uint8 PDCU1_RR_WinPos;

#  define Rte_TypeDef_RCU1_BBSFail
typedef boolean RCU1_BBSFail;

#  define Rte_TypeDef_RCU1_BBS_ActiveSta
typedef boolean RCU1_BBS_ActiveSta;

#  define Rte_TypeDef_RCU1_BrakPedalDisp
typedef uint16 RCU1_BrakPedalDisp;

#  define Rte_TypeDef_RCU1_BrakPedalDisp_Q
typedef boolean RCU1_BrakPedalDisp_Q;

#  define Rte_TypeDef_RCU1_BrakePedalApplied
typedef boolean RCU1_BrakePedalApplied;

#  define Rte_TypeDef_RCU1_BrakePedalAppliedV
typedef boolean RCU1_BrakePedalAppliedV;

#  define Rte_TypeDef_RCU1_BrkPedVal
typedef uint16 RCU1_BrkPedVal;

#  define Rte_TypeDef_RCU1_BrkPedVal_vaild
typedef uint8 RCU1_BrkPedVal_vaild;

#  define Rte_TypeDef_RCU1_FailedState
typedef uint8 RCU1_FailedState;

#  define Rte_TypeDef_RCU1_TrvSnsCalSts
typedef boolean RCU1_TrvSnsCalSts;

#  define Rte_TypeDef_RCU2_FLWhlPulCnt
typedef uint16 RCU2_FLWhlPulCnt;

#  define Rte_TypeDef_RCU2_FLWhlPulCntValid
typedef boolean RCU2_FLWhlPulCntValid;

#  define Rte_TypeDef_RCU2_FRWhlPulCnt
typedef uint16 RCU2_FRWhlPulCnt;

#  define Rte_TypeDef_RCU2_FRWhlPulCntValid
typedef boolean RCU2_FRWhlPulCntValid;

#  define Rte_TypeDef_RCU2_Fr02_Checksum
typedef uint8 RCU2_Fr02_Checksum;

#  define Rte_TypeDef_RCU2_Fr02_MsgCounter
typedef uint8 RCU2_Fr02_MsgCounter;

#  define Rte_TypeDef_RCU3_Checksum
typedef uint8 RCU3_Checksum;

#  define Rte_TypeDef_RCU3_MasterCylPressure
typedef uint16 RCU3_MasterCylPressure;

#  define Rte_TypeDef_RCU3_MasterCylPressureInvalid
typedef boolean RCU3_MasterCylPressureInvalid;

#  define Rte_TypeDef_RCU3_MsgCounter
typedef uint8 RCU3_MsgCounter;

#  define Rte_TypeDef_RCU3_VehicleSpd
typedef uint16 RCU3_VehicleSpd;

#  define Rte_TypeDef_RCU3_VehicleSpdValid
typedef boolean RCU3_VehicleSpdValid;

#  define Rte_TypeDef_RCU4_Checksum
typedef uint8 RCU4_Checksum;

#  define Rte_TypeDef_RCU4_FLWhlDir
typedef uint8 RCU4_FLWhlDir;

#  define Rte_TypeDef_RCU4_FLWhlVelocity
typedef uint16 RCU4_FLWhlVelocity;

#  define Rte_TypeDef_RCU4_FLWhlVelocityValid
typedef boolean RCU4_FLWhlVelocityValid;

#  define Rte_TypeDef_RCU4_FRWhlDir
typedef uint8 RCU4_FRWhlDir;

#  define Rte_TypeDef_RCU4_FRWhlVelocity
typedef uint16 RCU4_FRWhlVelocity;

#  define Rte_TypeDef_RCU4_FRWhlVelocityValid
typedef boolean RCU4_FRWhlVelocityValid;

#  define Rte_TypeDef_RCU4_MsgCounter
typedef uint8 RCU4_MsgCounter;

#  define Rte_TypeDef_RCU4_RLWhlDir
typedef uint8 RCU4_RLWhlDir;

#  define Rte_TypeDef_RCU4_RLWhlPulCnt
typedef uint16 RCU4_RLWhlPulCnt;

#  define Rte_TypeDef_RCU4_RLWhlPulCntValid
typedef boolean RCU4_RLWhlPulCntValid;

#  define Rte_TypeDef_RCU4_RLWhlVelocity
typedef uint16 RCU4_RLWhlVelocity;

#  define Rte_TypeDef_RCU4_RLWhlVelocityValid
typedef boolean RCU4_RLWhlVelocityValid;

#  define Rte_TypeDef_RCU4_RRWhlDir
typedef uint8 RCU4_RRWhlDir;

#  define Rte_TypeDef_RCU4_RRWhlPulCnt
typedef uint16 RCU4_RRWhlPulCnt;

#  define Rte_TypeDef_RCU4_RRWhlPulCntValid
typedef boolean RCU4_RRWhlPulCntValid;

#  define Rte_TypeDef_RCU4_RRWhlVelocity
typedef uint16 RCU4_RRWhlVelocity;

#  define Rte_TypeDef_RCU4_RRWhlVelocityValid
typedef boolean RCU4_RRWhlVelocityValid;

#  define Rte_TypeDef_RCU5_ACC_Enable
typedef uint8 RCU5_ACC_Enable;

#  define Rte_TypeDef_RCU5_ACC_ReferenceAccel
typedef uint16 RCU5_ACC_ReferenceAccel;

#  define Rte_TypeDef_RCU5_ACC_ReqLim
typedef uint8 RCU5_ACC_ReqLim;

#  define Rte_TypeDef_RCU5_AEB_Enable
typedef uint8 RCU5_AEB_Enable;

#  define Rte_TypeDef_RCU5_BrakeDiscTempSts
typedef boolean RCU5_BrakeDiscTempSts;

#  define Rte_TypeDef_RCU5_Checksum
typedef uint8 RCU5_Checksum;

#  define Rte_TypeDef_RCU5_DriverOverride
typedef uint8 RCU5_DriverOverride;

#  define Rte_TypeDef_RCU5_JerkActive
typedef boolean RCU5_JerkActive;

#  define Rte_TypeDef_RCU5_Jerkfail
typedef boolean RCU5_Jerkfail;

#  define Rte_TypeDef_RCU5_MsgCounter
typedef uint8 RCU5_MsgCounter;

#  define Rte_TypeDef_RCU6_EPBAvailable
typedef uint8 RCU6_EPBAvailable;

#  define Rte_TypeDef_RCU6_EPBClusterDispMSG
typedef uint8 RCU6_EPBClusterDispMSG;

#  define Rte_TypeDef_RCU6_EPBCruiseCtrlCancelReq
typedef boolean RCU6_EPBCruiseCtrlCancelReq;

#  define Rte_TypeDef_RCU6_EPBStatus
typedef uint8 RCU6_EPBStatus;

#  define Rte_TypeDef_RCU6_EPBStatusLampReq
typedef uint8 RCU6_EPBStatusLampReq;

#  define Rte_TypeDef_RCU6_EPBSysBrkLightsReq
typedef boolean RCU6_EPBSysBrkLightsReq;

#  define Rte_TypeDef_RCU6_EPBWarnLampReq
typedef uint8 RCU6_EPBWarnLampReq;

#  define Rte_TypeDef_RCU6_EPB_ActuatorSt_L
typedef uint8 RCU6_EPB_ActuatorSt_L;

#  define Rte_TypeDef_RCU6_EPB_ActuatorSt_R
typedef uint8 RCU6_EPB_ActuatorSt_R;

#  define Rte_TypeDef_RCU6_EPB_DisplayMsgID
typedef uint8 RCU6_EPB_DisplayMsgID;

#  define Rte_TypeDef_RCU7_ABSActive
typedef boolean RCU7_ABSActive;

#  define Rte_TypeDef_RCU7_ABSFail
typedef boolean RCU7_ABSFail;

#  define Rte_TypeDef_RCU7_AVHDispMSG
typedef uint8 RCU7_AVHDispMSG;

#  define Rte_TypeDef_RCU7_AVHEnabled
typedef boolean RCU7_AVHEnabled;

#  define Rte_TypeDef_RCU7_AVHLampReq
typedef uint8 RCU7_AVHLampReq;

#  define Rte_TypeDef_RCU7_BrakeWarningLamp
typedef uint8 RCU7_BrakeWarningLamp;

#  define Rte_TypeDef_RCU7_BrkLightReq
typedef boolean RCU7_BrkLightReq;

#  define Rte_TypeDef_RCU7_Checksum
typedef uint8 RCU7_Checksum;

#  define Rte_TypeDef_RCU7_ESCActive
typedef boolean RCU7_ESCActive;

#  define Rte_TypeDef_RCU7_ESCFail
typedef boolean RCU7_ESCFail;

#  define Rte_TypeDef_RCU7_ESSActiveReq
typedef uint8 RCU7_ESSActiveReq;

#  define Rte_TypeDef_RCU7_HSAActive
typedef boolean RCU7_HSAActive;

#  define Rte_TypeDef_RCU7_HSAFail
typedef boolean RCU7_HSAFail;

#  define Rte_TypeDef_RCU7_MsgCounter
typedef uint8 RCU7_MsgCounter;

#  define Rte_TypeDef_RCU7_TCSActive
typedef boolean RCU7_TCSActive;

#  define Rte_TypeDef_RCU7_TCSDisable
typedef boolean RCU7_TCSDisable;

#  define Rte_TypeDef_RCU7_TCSFail
typedef boolean RCU7_TCSFail;

#  define Rte_TypeDef_RCU8_BrakeActive
typedef boolean RCU8_BrakeActive;

#  define Rte_TypeDef_RCU8_Checksum
typedef uint8 RCU8_Checksum;

#  define Rte_TypeDef_RCU8_MsgCounter
typedef uint8 RCU8_MsgCounter;

#  define Rte_TypeDef_RCU9_Checksum
typedef uint8 RCU9_Checksum;

#  define Rte_TypeDef_RCU9_MsgCounter
typedef uint8 RCU9_MsgCounter;

#  define Rte_TypeDef_RCU9_PAStandStill
typedef boolean RCU9_PAStandStill;

#  define Rte_TypeDef_RCU9_PASts
typedef uint8 RCU9_PASts;

#  define Rte_TypeDef_RCU9_PA_CtrlAbortFeedback
typedef uint8 RCU9_PA_CtrlAbortFeedback;

#  define Rte_TypeDef_RCU9_PA_ParkingAvailable
typedef boolean RCU9_PA_ParkingAvailable;

#  define Rte_TypeDef_RCU9_PA_ParkingBrkMdSeln
typedef uint8 RCU9_PA_ParkingBrkMdSeln;

#  define Rte_TypeDef_RCU9_PA_ParkingFnMd
typedef uint8 RCU9_PA_ParkingFnMd;

#  define Rte_TypeDef_RCU_9_PA_RdnyBrkModeActv
typedef boolean RCU_9_PA_RdnyBrkModeActv;

#  define Rte_TypeDef_RL_CAN_TX_DETECTION_CRC_t
typedef uint32 RL_CAN_TX_DETECTION_CRC_t;

#  define Rte_TypeDef_RL_CAN_TX_LOOK_ID_t
typedef uint8 RL_CAN_TX_LOOK_ID_t;

#  define Rte_TypeDef_RL_CAN_TX_LOOK_INDEX_8_t
typedef uint16 RL_CAN_TX_LOOK_INDEX_8_t;

#  define Rte_TypeDef_RL_CAN_TX_LOOK_TYPE_t
typedef uint8 RL_CAN_TX_LOOK_TYPE_t;

#  define Rte_TypeDef_RL_CAN_TX_NUMBER_OF_DETECTIONS_t
typedef uint8 RL_CAN_TX_NUMBER_OF_DETECTIONS_t;

#  define Rte_TypeDef_RL_CAN_TX_SCAN_INDEX_TRACKER_FUSED_t
typedef uint16 RL_CAN_TX_SCAN_INDEX_TRACKER_FUSED_t;

#  define Rte_TypeDef_RL_CAN_TX_TIMESTAMP_CONSISTENCY_FLG_t
typedef boolean RL_CAN_TX_TIMESTAMP_CONSISTENCY_FLG_t;

#  define Rte_TypeDef_RL_CAN_TX_TimeStamp_Fraction_Sec_t
typedef uint32 RL_CAN_TX_TimeStamp_Fraction_Sec_t;

#  define Rte_TypeDef_RL_CAN_TX_TimeStamp_Sec_t
typedef uint32 RL_CAN_TX_TimeStamp_Sec_t;

#  define Rte_TypeDef_RR_CAN_TX_DETECTION_CRC_t
typedef uint32 RR_CAN_TX_DETECTION_CRC_t;

#  define Rte_TypeDef_RR_CAN_TX_LOOK_ID_t
typedef uint8 RR_CAN_TX_LOOK_ID_t;

#  define Rte_TypeDef_RR_CAN_TX_LOOK_INDEX_8_t
typedef uint16 RR_CAN_TX_LOOK_INDEX_8_t;

#  define Rte_TypeDef_RR_CAN_TX_LOOK_TYPE_t
typedef uint8 RR_CAN_TX_LOOK_TYPE_t;

#  define Rte_TypeDef_RR_CAN_TX_NUMBER_OF_DETECTIONS_t
typedef uint8 RR_CAN_TX_NUMBER_OF_DETECTIONS_t;

#  define Rte_TypeDef_RR_CAN_TX_SCAN_INDEX_TRACKER_FUSED_t
typedef uint16 RR_CAN_TX_SCAN_INDEX_TRACKER_FUSED_t;

#  define Rte_TypeDef_RR_CAN_TX_TIMESTAMP_CONSISTENCY_FLG_t
typedef boolean RR_CAN_TX_TIMESTAMP_CONSISTENCY_FLG_t;

#  define Rte_TypeDef_RR_CAN_TX_TimeStamp_Fraction_Sec_t
typedef uint32 RR_CAN_TX_TimeStamp_Fraction_Sec_t;

#  define Rte_TypeDef_RR_CAN_TX_TimeStamp_Sec_t
typedef uint32 RR_CAN_TX_TimeStamp_Sec_t;

#  define Rte_TypeDef_RadarAlign_FA_SER_Incomplete_CCM_t
typedef boolean RadarAlign_FA_SER_Incomplete_CCM_t;

#  define Rte_TypeDef_RadarAlign_FA_SER_Incomplete_FL_t
typedef boolean RadarAlign_FA_SER_Incomplete_FL_t;

#  define Rte_TypeDef_RadarAlign_FA_SER_Incomplete_FR_t
typedef boolean RadarAlign_FA_SER_Incomplete_FR_t;

#  define Rte_TypeDef_RadarAlign_FA_SER_Incomplete_RL_t
typedef boolean RadarAlign_FA_SER_Incomplete_RL_t;

#  define Rte_TypeDef_RadarAlign_FA_SER_Incomplete_RR_t
typedef boolean RadarAlign_FA_SER_Incomplete_RR_t;

#  define Rte_TypeDef_RadarAlign_FA_SER_NotStarted_CCM_t
typedef boolean RadarAlign_FA_SER_NotStarted_CCM_t;

#  define Rte_TypeDef_RadarAlign_FA_SER_NotStarted_FL_t
typedef boolean RadarAlign_FA_SER_NotStarted_FL_t;

#  define Rte_TypeDef_RadarAlign_FA_SER_NotStarted_FR_t
typedef boolean RadarAlign_FA_SER_NotStarted_FR_t;

#  define Rte_TypeDef_RadarAlign_FA_SER_NotStarted_RL_t
typedef boolean RadarAlign_FA_SER_NotStarted_RL_t;

#  define Rte_TypeDef_RadarAlign_FA_SER_NotStarted_RR_t
typedef boolean RadarAlign_FA_SER_NotStarted_RR_t;

#  define Rte_TypeDef_RadarAlign_FA_SER_OutOfRange_CCM_t
typedef boolean RadarAlign_FA_SER_OutOfRange_CCM_t;

#  define Rte_TypeDef_RadarAlign_FA_SER_OutOfRange_FL_t
typedef boolean RadarAlign_FA_SER_OutOfRange_FL_t;

#  define Rte_TypeDef_RadarAlign_FA_SER_OutOfRange_FR_t
typedef boolean RadarAlign_FA_SER_OutOfRange_FR_t;

#  define Rte_TypeDef_RadarAlign_FA_SER_OutOfRange_RL_t
typedef boolean RadarAlign_FA_SER_OutOfRange_RL_t;

#  define Rte_TypeDef_RadarAlign_FA_SER_OutOfRange_RR_t
typedef boolean RadarAlign_FA_SER_OutOfRange_RR_t;

#  define Rte_TypeDef_RadarBlockageDetected_CCM_FL_t
typedef boolean RadarBlockageDetected_CCM_FL_t;

#  define Rte_TypeDef_RadarBlockageDetected_CCM_FR_t
typedef boolean RadarBlockageDetected_CCM_FR_t;

#  define Rte_TypeDef_RadarBlockageDetected_CCM_RL_t
typedef boolean RadarBlockageDetected_CCM_RL_t;

#  define Rte_TypeDef_RadarBlockageDetected_CCM_RR_t
typedef boolean RadarBlockageDetected_CCM_RR_t;

#  define Rte_TypeDef_RadarBlockageDetected_CCM_t
typedef boolean RadarBlockageDetected_CCM_t;

#  define Rte_TypeDef_RadarBlockageSidelobe_CCM_FL_t
typedef boolean RadarBlockageSidelobe_CCM_FL_t;

#  define Rte_TypeDef_RadarBlockageSidelobe_CCM_FR_t
typedef boolean RadarBlockageSidelobe_CCM_FR_t;

#  define Rte_TypeDef_RadarBlockageSidelobe_CCM_RL_t
typedef boolean RadarBlockageSidelobe_CCM_RL_t;

#  define Rte_TypeDef_RadarBlockageSidelobe_CCM_RR_t
typedef boolean RadarBlockageSidelobe_CCM_RR_t;

#  define Rte_TypeDef_RadarBlockageSidelobe_CCM_t
typedef boolean RadarBlockageSidelobe_CCM_t;

#  define Rte_TypeDef_RadarExternalCondNotOK_CCM_FL_t
typedef boolean RadarExternalCondNotOK_CCM_FL_t;

#  define Rte_TypeDef_RadarExternalCondNotOK_CCM_FR_t
typedef boolean RadarExternalCondNotOK_CCM_FR_t;

#  define Rte_TypeDef_RadarExternalCondNotOK_CCM_RL_t
typedef boolean RadarExternalCondNotOK_CCM_RL_t;

#  define Rte_TypeDef_RadarExternalCondNotOK_CCM_RR_t
typedef boolean RadarExternalCondNotOK_CCM_RR_t;

#  define Rte_TypeDef_RadarExternalConditionsNotOK_CCM_t
typedef boolean RadarExternalConditionsNotOK_CCM_t;

#  define Rte_TypeDef_RadarSensorNotOperational_CCM_FL_t
typedef boolean RadarSensorNotOperational_CCM_FL_t;

#  define Rte_TypeDef_RadarSensorNotOperational_CCM_FR_t
typedef boolean RadarSensorNotOperational_CCM_FR_t;

#  define Rte_TypeDef_RadarSensorNotOperational_CCM_RL_t
typedef boolean RadarSensorNotOperational_CCM_RL_t;

#  define Rte_TypeDef_RadarSensorNotOperational_CCM_RR_t
typedef boolean RadarSensorNotOperational_CCM_RR_t;

#  define Rte_TypeDef_RadarSensorNotOperational_CCM_t
typedef boolean RadarSensorNotOperational_CCM_t;

#  define Rte_TypeDef_Radar_Trig_Control_CRC_Front_t
typedef uint8 Radar_Trig_Control_CRC_Front_t;

#  define Rte_TypeDef_Radar_Trig_Control_CRC_Rear_t
typedef uint8 Radar_Trig_Control_CRC_Rear_t;

#  define Rte_TypeDef_Radar_Trig_Control_CRC_t
typedef uint8 Radar_Trig_Control_CRC_t;

#  define Rte_TypeDef_Radar_Trig_Control_MC_Front_t
typedef uint8 Radar_Trig_Control_MC_Front_t;

#  define Rte_TypeDef_Radar_Trig_Control_MC_Rear_t
typedef uint8 Radar_Trig_Control_MC_Rear_t;

#  define Rte_TypeDef_Radar_Trig_Control_MC_t
typedef uint8 Radar_Trig_Control_MC_t;

#  define Rte_TypeDef_Region_A_SwError
typedef boolean Region_A_SwError;

#  define Rte_TypeDef_Region_A_SwError_t
typedef boolean Region_A_SwError_t;

#  define Rte_TypeDef_Rte_DT_Idt_BcsIntDid_T_0
typedef uint8 Rte_DT_Idt_BcsIntDid_T_0;

#  define Rte_TypeDef_Rte_DT_Idt_EcuInstallDate_T_0
typedef uint8 Rte_DT_Idt_EcuInstallDate_T_0;

#  define Rte_TypeDef_Rte_DT_Idt_EcuManuDate_T_0
typedef uint8 Rte_DT_Idt_EcuManuDate_T_0;

#  define Rte_TypeDef_Rte_DT_Idt_EcuSerialNum_T_0
typedef uint8 Rte_DT_Idt_EcuSerialNum_T_0;

#  define Rte_TypeDef_Rte_DT_Idt_FBL_or_APP_EE_0_0
typedef uint8 Rte_DT_Idt_FBL_or_APP_EE_0_0;

#  define Rte_TypeDef_Rte_DT_Idt_FBL_or_APP_EE_1_0
typedef uint8 Rte_DT_Idt_FBL_or_APP_EE_1_0;

#  define Rte_TypeDef_Rte_DT_Idt_FBL_or_APP_EE_2_0
typedef uint8 Rte_DT_Idt_FBL_or_APP_EE_2_0;

#  define Rte_TypeDef_Rte_DT_Idt_FBL_or_APP_EE_3_0
typedef uint8 Rte_DT_Idt_FBL_or_APP_EE_3_0;

#  define Rte_TypeDef_Rte_DT_Idt_OS_TrapInfo_T_2
typedef uint32 Rte_DT_Idt_OS_TrapInfo_T_2;

#  define Rte_TypeDef_Rte_DT_Idt_OS_TrapInfo_T_3
typedef uint32 Rte_DT_Idt_OS_TrapInfo_T_3;

#  define Rte_TypeDef_Rte_DT_Idt_OS_TrapInfo_T_4
typedef uint8 Rte_DT_Idt_OS_TrapInfo_T_4;

#  define Rte_TypeDef_Rte_DT_Idt_OS_TrapInfo_T_5
typedef uint8 Rte_DT_Idt_OS_TrapInfo_T_5;

#  define Rte_TypeDef_Rte_DT_Idt_PdcModSwtSt_T_0
typedef uint8 Rte_DT_Idt_PdcModSwtSt_T_0;

#  define Rte_TypeDef_Rte_DT_Idt_Reset_Counter_and_Reason_0
typedef uint8 Rte_DT_Idt_Reset_Counter_and_Reason_0;

#  define Rte_TypeDef_Rte_DT_Idt_Reset_Counter_and_Reason_1
typedef uint8 Rte_DT_Idt_Reset_Counter_and_Reason_1;

#  define Rte_TypeDef_Rte_DT_Idt_Reset_Counter_and_Reason_2
typedef uint8 Rte_DT_Idt_Reset_Counter_and_Reason_2;

#  define Rte_TypeDef_Rte_DT_Idt_Reset_Counter_and_Reason_3
typedef uint8 Rte_DT_Idt_Reset_Counter_and_Reason_3;

#  define Rte_TypeDef_Rte_DT_Idt_SMU_Faults_T_6
typedef uint16 Rte_DT_Idt_SMU_Faults_T_6;

#  define Rte_TypeDef_Rte_DT_Idt_VIN_T_0
typedef uint8 Rte_DT_Idt_VIN_T_0;

#  define Rte_TypeDef_Rte_DT_Idt_VechileCfg_T_0
typedef uint8 Rte_DT_Idt_VechileCfg_T_0;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_001_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_001_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_002_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_002_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_003_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_003_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_004_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_004_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_005_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_005_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_006_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_006_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_007_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_007_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_008_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_008_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_009_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_009_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_010_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_010_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_011_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_011_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_012_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_012_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_013_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_013_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_014_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_014_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_015_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_015_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_016_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_016_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_017_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_017_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_018_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_018_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_019_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_019_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_020_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_020_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_021_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_021_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_022_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_022_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_023_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_023_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_024_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_024_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_025_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_025_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_026_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_026_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_027_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_027_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_028_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_028_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_029_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_029_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_030_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_030_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_031_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_031_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_032_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_032_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_033_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_033_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_034_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_034_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_035_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_035_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_036_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_036_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_037_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_037_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_038_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_038_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_039_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_039_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_040_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_040_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_041_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_041_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_042_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_042_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_043_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_043_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_044_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_044_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_045_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_045_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_046_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_046_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_047_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_047_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_048_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_048_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_049_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_049_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_050_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_050_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_051_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_051_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_052_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_052_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_053_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_053_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_054_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_054_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_055_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_055_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_056_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_056_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_057_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_057_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_058_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_058_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_059_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_059_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_060_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_060_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_061_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_061_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_062_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_062_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_063_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_063_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_064_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_064_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_065_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_065_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_066_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_066_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_067_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_067_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_068_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_068_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_069_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_069_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_070_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_070_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_071_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_071_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_072_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_072_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_073_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_073_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_074_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_074_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_075_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_075_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_076_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_076_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_077_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_077_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_078_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_078_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_079_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_079_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_080_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_080_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_081_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_081_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_082_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_082_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_083_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_083_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_084_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_084_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_085_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_085_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_086_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_086_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_087_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_087_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_088_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_088_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_089_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_089_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_090_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_090_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_091_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_091_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_092_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_092_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_093_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_093_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_094_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_094_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_095_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_095_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_096_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_096_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_097_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_097_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_098_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_098_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_099_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_099_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_100_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_100_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_101_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_101_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_102_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_102_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_103_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_103_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_104_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_104_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_105_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_105_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_106_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_106_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_107_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_107_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_108_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_108_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_109_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_109_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_110_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_110_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_111_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_111_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_112_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_112_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_113_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_113_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_114_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_114_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_115_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_115_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_116_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_116_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_117_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_117_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_118_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_118_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_119_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_119_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_120_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_120_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_121_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_121_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_122_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_122_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_123_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_123_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_124_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_124_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_125_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_125_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_126_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_126_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_127_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_127_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_AVD_Detection_128_t_2
typedef uint8 Rte_DT_SG_LRR_AVD_Detection_128_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_001_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_001_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_002_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_002_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_003_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_003_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_004_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_004_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_005_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_005_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_006_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_006_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_007_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_007_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_008_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_008_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_009_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_009_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_010_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_010_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_011_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_011_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_012_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_012_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_013_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_013_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_014_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_014_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_015_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_015_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_016_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_016_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_017_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_017_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_018_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_018_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_019_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_019_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_020_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_020_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_021_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_021_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_022_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_022_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_023_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_023_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_024_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_024_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_025_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_025_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_026_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_026_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_027_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_027_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_028_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_028_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_029_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_029_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_030_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_030_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_031_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_031_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_032_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_032_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_033_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_033_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_034_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_034_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_035_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_035_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_036_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_036_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_037_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_037_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_038_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_038_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_039_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_039_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_040_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_040_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_041_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_041_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_042_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_042_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_043_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_043_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_044_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_044_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_045_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_045_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_046_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_046_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_047_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_047_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_048_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_048_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_049_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_049_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_050_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_050_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_051_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_051_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_052_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_052_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_053_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_053_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_054_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_054_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_055_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_055_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_056_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_056_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_057_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_057_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_058_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_058_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_059_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_059_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_060_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_060_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_061_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_061_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_062_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_062_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_063_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_063_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_064_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_064_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_065_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_065_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_066_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_066_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_067_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_067_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_068_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_068_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_069_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_069_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_070_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_070_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_071_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_071_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_072_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_072_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_073_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_073_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_074_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_074_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_075_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_075_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_076_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_076_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_077_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_077_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_078_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_078_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_079_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_079_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_080_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_080_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_081_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_081_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_082_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_082_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_083_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_083_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_084_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_084_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_085_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_085_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_086_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_086_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_087_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_087_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_088_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_088_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_089_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_089_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_090_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_090_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_091_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_091_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_092_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_092_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_093_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_093_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_094_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_094_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_095_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_095_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_096_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_096_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_097_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_097_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_098_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_098_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_099_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_099_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_100_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_100_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_101_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_101_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_102_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_102_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_103_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_103_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_104_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_104_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_105_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_105_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_106_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_106_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_107_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_107_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_108_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_108_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_109_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_109_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_110_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_110_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_111_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_111_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_112_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_112_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_113_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_113_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_114_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_114_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_115_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_115_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_116_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_116_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_117_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_117_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_118_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_118_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_119_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_119_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_120_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_120_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_121_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_121_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_122_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_122_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_123_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_123_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_124_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_124_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_125_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_125_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_126_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_126_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_127_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_127_t_2;

#  define Rte_TypeDef_Rte_DT_SG_LRR_Detection_128_t_2
typedef uint8 Rte_DT_SG_LRR_Detection_128_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_001_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_001_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_002_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_002_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_003_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_003_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_004_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_004_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_005_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_005_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_006_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_006_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_007_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_007_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_008_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_008_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_009_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_009_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_010_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_010_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_011_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_011_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_012_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_012_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_013_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_013_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_014_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_014_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_015_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_015_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_016_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_016_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_017_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_017_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_018_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_018_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_019_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_019_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_020_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_020_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_021_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_021_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_022_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_022_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_023_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_023_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_024_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_024_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_025_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_025_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_026_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_026_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_027_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_027_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_028_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_028_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_029_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_029_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_030_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_030_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_031_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_031_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_032_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_032_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_033_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_033_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_034_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_034_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_035_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_035_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_036_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_036_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_037_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_037_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_038_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_038_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_039_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_039_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_040_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_040_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_041_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_041_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_042_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_042_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_043_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_043_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_044_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_044_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_045_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_045_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_046_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_046_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_047_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_047_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_048_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_048_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_049_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_049_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_050_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_050_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_051_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_051_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_052_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_052_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_053_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_053_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_054_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_054_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_055_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_055_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_056_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_056_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_057_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_057_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_058_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_058_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_059_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_059_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_060_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_060_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_061_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_061_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_062_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_062_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_063_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_063_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_064_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_064_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_065_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_065_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_066_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_066_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_067_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_067_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_068_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_068_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_069_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_069_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_070_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_070_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_071_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_071_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_072_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_072_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_073_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_073_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_074_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_074_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_075_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_075_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_076_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_076_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_077_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_077_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_078_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_078_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_079_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_079_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_080_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_080_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_081_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_081_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_082_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_082_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_083_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_083_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_084_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_084_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_085_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_085_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_086_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_086_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_087_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_087_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_088_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_088_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_089_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_089_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_090_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_090_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_091_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_091_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_092_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_092_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_093_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_093_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_094_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_094_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_095_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_095_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_096_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_096_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_097_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_097_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_098_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_098_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_099_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_099_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_100_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_100_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_101_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_101_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_102_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_102_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_103_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_103_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_104_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_104_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_105_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_105_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_106_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_106_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_107_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_107_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_108_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_108_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_109_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_109_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_110_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_110_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_111_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_111_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_112_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_112_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_113_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_113_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_114_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_114_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_115_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_115_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_116_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_116_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_117_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_117_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_118_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_118_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_119_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_119_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_120_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_120_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_121_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_121_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_122_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_122_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_123_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_123_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_124_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_124_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_125_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_125_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_126_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_126_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_127_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_127_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FL_Detection_128_t_2
typedef uint8 Rte_DT_SG_SRR_FL_Detection_128_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_001_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_001_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_002_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_002_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_003_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_003_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_004_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_004_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_005_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_005_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_006_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_006_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_007_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_007_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_008_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_008_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_009_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_009_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_010_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_010_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_011_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_011_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_012_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_012_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_013_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_013_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_014_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_014_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_015_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_015_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_016_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_016_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_017_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_017_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_018_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_018_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_019_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_019_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_020_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_020_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_021_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_021_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_022_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_022_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_023_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_023_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_024_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_024_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_025_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_025_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_026_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_026_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_027_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_027_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_028_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_028_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_029_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_029_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_030_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_030_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_031_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_031_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_032_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_032_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_033_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_033_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_034_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_034_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_035_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_035_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_036_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_036_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_037_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_037_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_038_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_038_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_039_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_039_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_040_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_040_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_041_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_041_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_042_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_042_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_043_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_043_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_044_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_044_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_045_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_045_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_046_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_046_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_047_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_047_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_048_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_048_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_049_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_049_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_050_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_050_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_051_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_051_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_052_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_052_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_053_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_053_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_054_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_054_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_055_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_055_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_056_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_056_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_057_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_057_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_058_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_058_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_059_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_059_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_060_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_060_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_061_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_061_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_062_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_062_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_063_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_063_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_064_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_064_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_065_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_065_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_066_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_066_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_067_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_067_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_068_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_068_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_069_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_069_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_070_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_070_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_071_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_071_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_072_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_072_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_073_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_073_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_074_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_074_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_075_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_075_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_076_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_076_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_077_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_077_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_078_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_078_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_079_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_079_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_080_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_080_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_081_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_081_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_082_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_082_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_083_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_083_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_084_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_084_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_085_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_085_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_086_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_086_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_087_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_087_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_088_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_088_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_089_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_089_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_090_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_090_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_091_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_091_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_092_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_092_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_093_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_093_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_094_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_094_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_095_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_095_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_096_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_096_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_097_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_097_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_098_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_098_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_099_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_099_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_100_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_100_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_101_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_101_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_102_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_102_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_103_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_103_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_104_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_104_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_105_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_105_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_106_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_106_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_107_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_107_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_108_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_108_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_109_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_109_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_110_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_110_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_111_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_111_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_112_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_112_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_113_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_113_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_114_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_114_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_115_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_115_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_116_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_116_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_117_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_117_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_118_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_118_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_119_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_119_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_120_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_120_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_121_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_121_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_122_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_122_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_123_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_123_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_124_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_124_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_125_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_125_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_126_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_126_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_127_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_127_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_FR_Detection_128_t_2
typedef uint8 Rte_DT_SG_SRR_FR_Detection_128_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_001_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_001_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_002_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_002_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_003_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_003_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_004_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_004_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_005_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_005_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_006_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_006_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_007_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_007_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_008_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_008_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_009_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_009_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_010_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_010_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_011_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_011_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_012_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_012_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_013_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_013_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_014_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_014_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_015_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_015_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_016_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_016_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_017_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_017_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_018_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_018_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_019_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_019_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_020_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_020_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_021_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_021_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_022_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_022_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_023_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_023_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_024_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_024_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_025_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_025_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_026_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_026_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_027_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_027_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_028_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_028_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_029_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_029_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_030_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_030_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_031_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_031_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_032_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_032_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_033_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_033_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_034_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_034_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_035_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_035_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_036_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_036_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_037_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_037_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_038_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_038_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_039_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_039_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_040_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_040_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_041_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_041_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_042_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_042_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_043_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_043_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_044_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_044_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_045_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_045_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_046_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_046_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_047_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_047_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_048_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_048_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_049_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_049_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_050_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_050_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_051_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_051_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_052_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_052_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_053_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_053_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_054_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_054_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_055_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_055_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_056_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_056_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_057_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_057_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_058_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_058_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_059_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_059_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_060_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_060_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_061_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_061_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_062_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_062_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_063_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_063_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_064_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_064_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_065_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_065_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_066_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_066_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_067_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_067_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_068_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_068_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_069_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_069_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_070_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_070_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_071_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_071_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_072_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_072_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_073_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_073_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_074_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_074_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_075_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_075_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_076_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_076_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_077_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_077_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_078_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_078_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_079_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_079_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_080_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_080_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_081_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_081_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_082_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_082_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_083_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_083_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_084_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_084_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_085_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_085_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_086_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_086_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_087_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_087_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_088_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_088_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_089_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_089_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_090_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_090_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_091_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_091_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_092_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_092_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_093_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_093_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_094_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_094_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_095_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_095_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_096_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_096_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_097_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_097_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_098_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_098_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_099_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_099_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_100_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_100_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_101_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_101_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_102_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_102_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_103_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_103_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_104_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_104_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_105_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_105_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_106_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_106_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_107_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_107_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_108_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_108_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_109_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_109_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_110_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_110_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_111_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_111_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_112_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_112_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_113_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_113_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_114_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_114_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_115_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_115_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_116_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_116_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_117_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_117_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_118_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_118_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_119_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_119_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_120_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_120_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_121_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_121_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_122_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_122_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_123_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_123_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_124_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_124_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_125_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_125_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_126_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_126_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_127_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_127_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RL_Detection_128_t_2
typedef uint8 Rte_DT_SG_SRR_RL_Detection_128_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_001_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_001_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_002_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_002_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_003_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_003_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_004_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_004_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_005_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_005_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_006_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_006_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_007_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_007_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_008_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_008_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_009_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_009_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_010_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_010_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_011_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_011_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_012_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_012_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_013_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_013_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_014_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_014_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_015_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_015_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_016_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_016_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_017_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_017_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_018_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_018_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_019_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_019_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_020_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_020_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_021_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_021_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_022_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_022_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_023_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_023_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_024_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_024_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_025_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_025_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_026_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_026_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_027_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_027_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_028_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_028_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_029_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_029_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_030_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_030_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_031_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_031_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_032_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_032_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_033_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_033_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_034_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_034_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_035_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_035_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_036_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_036_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_037_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_037_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_038_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_038_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_039_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_039_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_040_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_040_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_041_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_041_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_042_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_042_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_043_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_043_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_044_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_044_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_045_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_045_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_046_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_046_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_047_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_047_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_048_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_048_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_049_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_049_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_050_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_050_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_051_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_051_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_052_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_052_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_053_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_053_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_054_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_054_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_055_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_055_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_056_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_056_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_057_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_057_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_058_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_058_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_059_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_059_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_060_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_060_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_061_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_061_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_062_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_062_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_063_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_063_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_064_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_064_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_065_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_065_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_066_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_066_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_067_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_067_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_068_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_068_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_069_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_069_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_070_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_070_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_071_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_071_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_072_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_072_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_073_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_073_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_074_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_074_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_075_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_075_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_076_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_076_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_077_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_077_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_078_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_078_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_079_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_079_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_080_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_080_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_081_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_081_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_082_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_082_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_083_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_083_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_084_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_084_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_085_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_085_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_086_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_086_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_087_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_087_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_088_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_088_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_089_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_089_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_090_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_090_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_091_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_091_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_092_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_092_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_093_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_093_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_094_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_094_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_095_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_095_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_096_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_096_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_097_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_097_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_098_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_098_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_099_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_099_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_100_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_100_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_101_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_101_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_102_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_102_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_103_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_103_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_104_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_104_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_105_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_105_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_106_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_106_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_107_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_107_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_108_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_108_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_109_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_109_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_110_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_110_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_111_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_111_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_112_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_112_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_113_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_113_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_114_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_114_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_115_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_115_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_116_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_116_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_117_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_117_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_118_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_118_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_119_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_119_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_120_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_120_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_121_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_121_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_122_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_122_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_123_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_123_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_124_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_124_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_125_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_125_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_126_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_126_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_127_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_127_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SRR_RR_Detection_128_t_2
typedef uint8 Rte_DT_SG_SRR_RR_Detection_128_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_260_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_260_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_260_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_260_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_260_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_260_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_260_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_260_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_260_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_260_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_260_4_t_0
typedef boolean Rte_DT_SG_SigGroup_260_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_260_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_260_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_260_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_260_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_260_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_260_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_260_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_260_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_260_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_260_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_260_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_260_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_260_8_t_1
typedef boolean Rte_DT_SG_SigGroup_260_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_260_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_260_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_261_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_261_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_261_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_261_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_261_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_261_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_261_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_261_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_261_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_261_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_261_4_t_0
typedef boolean Rte_DT_SG_SigGroup_261_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_261_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_261_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_261_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_261_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_261_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_261_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_261_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_261_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_261_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_261_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_261_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_261_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_261_8_t_1
typedef boolean Rte_DT_SG_SigGroup_261_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_261_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_261_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_262_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_262_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_262_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_262_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_262_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_262_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_262_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_262_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_262_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_262_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_262_4_t_0
typedef boolean Rte_DT_SG_SigGroup_262_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_262_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_262_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_262_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_262_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_262_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_262_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_262_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_262_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_262_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_262_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_262_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_262_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_262_8_t_1
typedef boolean Rte_DT_SG_SigGroup_262_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_262_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_262_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_263_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_263_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_263_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_263_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_263_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_263_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_263_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_263_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_263_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_263_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_263_4_t_0
typedef boolean Rte_DT_SG_SigGroup_263_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_263_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_263_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_263_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_263_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_263_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_263_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_263_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_263_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_263_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_263_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_263_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_263_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_263_8_t_1
typedef boolean Rte_DT_SG_SigGroup_263_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_263_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_263_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_264_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_264_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_264_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_264_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_264_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_264_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_264_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_264_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_264_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_264_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_264_4_t_0
typedef boolean Rte_DT_SG_SigGroup_264_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_264_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_264_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_264_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_264_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_264_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_264_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_264_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_264_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_264_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_264_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_264_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_264_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_264_8_t_1
typedef boolean Rte_DT_SG_SigGroup_264_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_264_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_264_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_265_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_265_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_265_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_265_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_265_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_265_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_265_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_265_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_265_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_265_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_265_4_t_0
typedef boolean Rte_DT_SG_SigGroup_265_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_265_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_265_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_265_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_265_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_265_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_265_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_265_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_265_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_265_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_265_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_265_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_265_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_265_8_t_1
typedef boolean Rte_DT_SG_SigGroup_265_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_265_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_265_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_360_1_Copy_1_t_0
typedef uint8 Rte_DT_SG_SigGroup_360_1_Copy_1_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_360_1_Copy_1_t_3
typedef uint8 Rte_DT_SG_SigGroup_360_1_Copy_1_t_3;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_360_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_360_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_360_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_360_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_360_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_360_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_360_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_360_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_360_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_360_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_360_4_t_0
typedef boolean Rte_DT_SG_SigGroup_360_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_360_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_360_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_360_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_360_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_360_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_360_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_360_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_360_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_360_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_360_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_360_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_360_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_360_8_t_1
typedef boolean Rte_DT_SG_SigGroup_360_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_360_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_360_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_361_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_361_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_361_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_361_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_361_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_361_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_361_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_361_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_361_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_361_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_361_4_t_0
typedef boolean Rte_DT_SG_SigGroup_361_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_361_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_361_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_361_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_361_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_361_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_361_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_361_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_361_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_361_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_361_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_361_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_361_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_361_8_t_1
typedef boolean Rte_DT_SG_SigGroup_361_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_361_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_361_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_362_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_362_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_362_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_362_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_362_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_362_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_362_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_362_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_362_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_362_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_362_4_t_0
typedef boolean Rte_DT_SG_SigGroup_362_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_362_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_362_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_362_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_362_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_362_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_362_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_362_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_362_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_362_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_362_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_362_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_362_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_362_8_t_1
typedef boolean Rte_DT_SG_SigGroup_362_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_362_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_362_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_363_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_363_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_363_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_363_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_363_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_363_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_363_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_363_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_363_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_363_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_363_4_t_0
typedef boolean Rte_DT_SG_SigGroup_363_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_363_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_363_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_363_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_363_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_363_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_363_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_363_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_363_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_363_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_363_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_363_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_363_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_363_8_t_1
typedef boolean Rte_DT_SG_SigGroup_363_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_363_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_363_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_364_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_364_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_364_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_364_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_364_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_364_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_364_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_364_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_364_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_364_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_364_4_t_0
typedef boolean Rte_DT_SG_SigGroup_364_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_364_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_364_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_364_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_364_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_364_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_364_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_364_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_364_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_364_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_364_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_364_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_364_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_364_8_t_1
typedef boolean Rte_DT_SG_SigGroup_364_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_364_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_364_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_365_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_365_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_365_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_365_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_365_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_365_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_365_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_365_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_365_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_365_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_365_4_t_0
typedef boolean Rte_DT_SG_SigGroup_365_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_365_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_365_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_365_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_365_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_365_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_365_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_365_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_365_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_365_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_365_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_365_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_365_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_365_8_t_1
typedef boolean Rte_DT_SG_SigGroup_365_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_365_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_365_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_460_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_460_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_460_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_460_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_460_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_460_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_460_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_460_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_460_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_460_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_460_4_t_0
typedef boolean Rte_DT_SG_SigGroup_460_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_460_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_460_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_460_5_Copy_1_t_0
typedef uint8 Rte_DT_SG_SigGroup_460_5_Copy_1_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_460_5_Copy_1_t_3
typedef uint8 Rte_DT_SG_SigGroup_460_5_Copy_1_t_3;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_460_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_460_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_460_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_460_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_460_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_460_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_460_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_460_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_460_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_460_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_460_8_t_1
typedef boolean Rte_DT_SG_SigGroup_460_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_460_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_460_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_461_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_461_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_461_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_461_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_461_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_461_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_461_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_461_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_461_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_461_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_461_4_t_0
typedef boolean Rte_DT_SG_SigGroup_461_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_461_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_461_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_461_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_461_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_461_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_461_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_461_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_461_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_461_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_461_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_461_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_461_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_461_8_t_1
typedef boolean Rte_DT_SG_SigGroup_461_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_461_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_461_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_462_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_462_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_462_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_462_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_462_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_462_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_462_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_462_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_462_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_462_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_462_4_t_0
typedef boolean Rte_DT_SG_SigGroup_462_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_462_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_462_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_462_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_462_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_462_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_462_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_462_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_462_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_462_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_462_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_462_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_462_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_462_8_t_1
typedef boolean Rte_DT_SG_SigGroup_462_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_462_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_462_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_463_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_463_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_463_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_463_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_463_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_463_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_463_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_463_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_463_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_463_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_463_4_t_0
typedef boolean Rte_DT_SG_SigGroup_463_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_463_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_463_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_463_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_463_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_463_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_463_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_463_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_463_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_463_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_463_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_463_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_463_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_463_8_t_1
typedef boolean Rte_DT_SG_SigGroup_463_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_463_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_463_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_464_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_464_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_464_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_464_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_464_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_464_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_464_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_464_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_464_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_464_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_464_4_t_0
typedef boolean Rte_DT_SG_SigGroup_464_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_464_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_464_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_464_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_464_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_464_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_464_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_464_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_464_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_464_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_464_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_464_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_464_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_464_8_t_1
typedef boolean Rte_DT_SG_SigGroup_464_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_464_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_464_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_465_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_465_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_465_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_465_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_465_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_465_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_465_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_465_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_465_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_465_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_465_4_t_0
typedef boolean Rte_DT_SG_SigGroup_465_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_465_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_465_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_465_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_465_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_465_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_465_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_465_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_465_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_465_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_465_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_465_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_465_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_465_8_t_1
typedef boolean Rte_DT_SG_SigGroup_465_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_465_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_465_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_466_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_466_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_466_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_466_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_466_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_466_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_466_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_466_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_466_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_466_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_466_4_t_0
typedef boolean Rte_DT_SG_SigGroup_466_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_466_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_466_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_466_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_466_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_466_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_466_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_466_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_466_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_466_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_466_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_466_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_466_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_466_8_t_1
typedef boolean Rte_DT_SG_SigGroup_466_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_466_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_466_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_467_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_467_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_467_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_467_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_467_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_467_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_467_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_467_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_467_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_467_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_467_4_t_0
typedef boolean Rte_DT_SG_SigGroup_467_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_467_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_467_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_467_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_467_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_467_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_467_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_467_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_467_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_467_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_467_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_467_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_467_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_467_8_t_1
typedef boolean Rte_DT_SG_SigGroup_467_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_467_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_467_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_560_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_560_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_560_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_560_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_560_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_560_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_560_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_560_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_560_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_560_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_560_4_t_0
typedef boolean Rte_DT_SG_SigGroup_560_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_560_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_560_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_560_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_560_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_560_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_560_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_560_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_560_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_560_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_560_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_560_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_560_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_560_8_t_1
typedef boolean Rte_DT_SG_SigGroup_560_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_560_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_560_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_561_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_561_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_561_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_561_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_561_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_561_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_561_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_561_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_561_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_561_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_561_4_t_0
typedef boolean Rte_DT_SG_SigGroup_561_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_561_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_561_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_561_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_561_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_561_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_561_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_561_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_561_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_561_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_561_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_561_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_561_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_561_8_t_1
typedef boolean Rte_DT_SG_SigGroup_561_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_561_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_561_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_562_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_562_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_562_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_562_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_562_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_562_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_562_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_562_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_562_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_562_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_562_4_t_0
typedef boolean Rte_DT_SG_SigGroup_562_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_562_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_562_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_562_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_562_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_562_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_562_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_562_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_562_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_562_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_562_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_562_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_562_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_562_8_t_1
typedef boolean Rte_DT_SG_SigGroup_562_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_562_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_562_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_563_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_563_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_563_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_563_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_563_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_563_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_563_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_563_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_563_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_563_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_563_4_t_0
typedef boolean Rte_DT_SG_SigGroup_563_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_563_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_563_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_563_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_563_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_563_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_563_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_563_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_563_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_563_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_563_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_563_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_563_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_563_8_t_1
typedef boolean Rte_DT_SG_SigGroup_563_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_563_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_563_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_564_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_564_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_564_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_564_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_564_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_564_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_564_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_564_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_564_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_564_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_564_4_t_0
typedef boolean Rte_DT_SG_SigGroup_564_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_564_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_564_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_564_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_564_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_564_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_564_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_564_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_564_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_564_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_564_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_564_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_564_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_564_8_t_1
typedef boolean Rte_DT_SG_SigGroup_564_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_564_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_564_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_565_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_565_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_565_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_565_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_565_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_565_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_565_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_565_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_565_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_565_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_565_4_t_0
typedef boolean Rte_DT_SG_SigGroup_565_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_565_4_t_4
typedef uint16 Rte_DT_SG_SigGroup_565_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_565_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_565_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_565_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_565_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_565_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_565_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_565_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_565_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_565_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_565_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_565_8_t_1
typedef boolean Rte_DT_SG_SigGroup_565_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_565_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_565_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_566_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_566_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_566_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_566_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_566_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_566_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_566_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_566_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_566_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_566_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_566_4_t_0
typedef boolean Rte_DT_SG_SigGroup_566_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_566_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_566_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_566_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_566_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_566_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_566_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_566_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_566_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_566_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_566_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_566_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_566_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_566_8_t_1
typedef boolean Rte_DT_SG_SigGroup_566_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_566_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_566_8_t_5;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_567_1_t_2
typedef uint8 Rte_DT_SG_SigGroup_567_1_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_567_1_t_9
typedef uint8 Rte_DT_SG_SigGroup_567_1_t_9;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_567_2_t_0
typedef uint8 Rte_DT_SG_SigGroup_567_2_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_567_2_t_1
typedef uint8 Rte_DT_SG_SigGroup_567_2_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_567_3_t_2
typedef uint8 Rte_DT_SG_SigGroup_567_3_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_567_4_t_0
typedef boolean Rte_DT_SG_SigGroup_567_4_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_567_4_t_4
typedef uint8 Rte_DT_SG_SigGroup_567_4_t_4;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_567_5_t_0
typedef uint8 Rte_DT_SG_SigGroup_567_5_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_567_5_t_7
typedef uint8 Rte_DT_SG_SigGroup_567_5_t_7;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_567_6_t_0
typedef uint8 Rte_DT_SG_SigGroup_567_6_t_0;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_567_6_t_1
typedef uint8 Rte_DT_SG_SigGroup_567_6_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_567_7_t_2
typedef uint8 Rte_DT_SG_SigGroup_567_7_t_2;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_567_8_t_1
typedef boolean Rte_DT_SG_SigGroup_567_8_t_1;

#  define Rte_TypeDef_Rte_DT_SG_SigGroup_567_8_t_5
typedef uint8 Rte_DT_SG_SigGroup_567_8_t_5;

#  define Rte_TypeDef_SRR_Align_Horizontal_Angle_FL_t
typedef float32 SRR_Align_Horizontal_Angle_FL_t;

#  define Rte_TypeDef_SRR_Align_Horizontal_Angle_FR_t
typedef float32 SRR_Align_Horizontal_Angle_FR_t;

#  define Rte_TypeDef_SRR_Align_Horizontal_Angle_RL_t
typedef float32 SRR_Align_Horizontal_Angle_RL_t;

#  define Rte_TypeDef_SRR_Align_Horizontal_Angle_RR_t
typedef float32 SRR_Align_Horizontal_Angle_RR_t;

#  define Rte_TypeDef_SRR_Align_Horizontal_QF_FL_t
typedef uint8 SRR_Align_Horizontal_QF_FL_t;

#  define Rte_TypeDef_SRR_Align_Horizontal_QF_FR_t
typedef uint8 SRR_Align_Horizontal_QF_FR_t;

#  define Rte_TypeDef_SRR_Align_Horizontal_QF_RL_t
typedef uint8 SRR_Align_Horizontal_QF_RL_t;

#  define Rte_TypeDef_SRR_Align_Horizontal_QF_RR_t
typedef uint8 SRR_Align_Horizontal_QF_RR_t;

#  define Rte_TypeDef_SRR_Align_Horizontal_Ref_FL_t
typedef float32 SRR_Align_Horizontal_Ref_FL_t;

#  define Rte_TypeDef_SRR_Align_Horizontal_Ref_FR_t
typedef float32 SRR_Align_Horizontal_Ref_FR_t;

#  define Rte_TypeDef_SRR_Align_Horizontal_Ref_RL_t
typedef float32 SRR_Align_Horizontal_Ref_RL_t;

#  define Rte_TypeDef_SRR_Align_Horizontal_Ref_RR_t
typedef float32 SRR_Align_Horizontal_Ref_RR_t;

#  define Rte_TypeDef_SRR_Align_Out_of_Range_Fault_FL_t
typedef boolean SRR_Align_Out_of_Range_Fault_FL_t;

#  define Rte_TypeDef_SRR_Align_Out_of_Range_Fault_FR_t
typedef boolean SRR_Align_Out_of_Range_Fault_FR_t;

#  define Rte_TypeDef_SRR_Align_Out_of_Range_Fault_RL_t
typedef boolean SRR_Align_Out_of_Range_Fault_RL_t;

#  define Rte_TypeDef_SRR_Align_Out_of_Range_Fault_RR_t
typedef boolean SRR_Align_Out_of_Range_Fault_RR_t;

#  define Rte_TypeDef_SRR_Align_Vertical_Angle_FL_t
typedef float32 SRR_Align_Vertical_Angle_FL_t;

#  define Rte_TypeDef_SRR_Align_Vertical_Angle_FR_t
typedef float32 SRR_Align_Vertical_Angle_FR_t;

#  define Rte_TypeDef_SRR_Align_Vertical_Angle_RL_t
typedef float32 SRR_Align_Vertical_Angle_RL_t;

#  define Rte_TypeDef_SRR_Align_Vertical_Angle_RR_t
typedef float32 SRR_Align_Vertical_Angle_RR_t;

#  define Rte_TypeDef_SRR_Align_Vertical_QF_FL_t
typedef uint8 SRR_Align_Vertical_QF_FL_t;

#  define Rte_TypeDef_SRR_Align_Vertical_QF_FR_t
typedef uint8 SRR_Align_Vertical_QF_FR_t;

#  define Rte_TypeDef_SRR_Align_Vertical_QF_RL_t
typedef uint8 SRR_Align_Vertical_QF_RL_t;

#  define Rte_TypeDef_SRR_Align_Vertical_QF_RR_t
typedef uint8 SRR_Align_Vertical_QF_RR_t;

#  define Rte_TypeDef_SRR_Align_Vertical_Ref_FL_t
typedef float32 SRR_Align_Vertical_Ref_FL_t;

#  define Rte_TypeDef_SRR_Align_Vertical_Ref_FR_t
typedef float32 SRR_Align_Vertical_Ref_FR_t;

#  define Rte_TypeDef_SRR_Align_Vertical_Ref_RL_t
typedef float32 SRR_Align_Vertical_Ref_RL_t;

#  define Rte_TypeDef_SRR_Align_Vertical_Ref_RR_t
typedef float32 SRR_Align_Vertical_Ref_RR_t;

#  define Rte_TypeDef_SRR_AlignmentIncomplete_Fault_FL_t
typedef boolean SRR_AlignmentIncomplete_Fault_FL_t;

#  define Rte_TypeDef_SRR_AlignmentIncomplete_Fault_FR_t
typedef boolean SRR_AlignmentIncomplete_Fault_FR_t;

#  define Rte_TypeDef_SRR_AlignmentIncomplete_Fault_RL_t
typedef boolean SRR_AlignmentIncomplete_Fault_RL_t;

#  define Rte_TypeDef_SRR_AlignmentIncomplete_Fault_RR_t
typedef boolean SRR_AlignmentIncomplete_Fault_RR_t;

#  define Rte_TypeDef_SRR_BLKG_SIDELOBE_FILTER_VAL_FL_t
typedef uint8 SRR_BLKG_SIDELOBE_FILTER_VAL_FL_t;

#  define Rte_TypeDef_SRR_BLKG_SIDELOBE_FILTER_VAL_FR_t
typedef uint8 SRR_BLKG_SIDELOBE_FILTER_VAL_FR_t;

#  define Rte_TypeDef_SRR_BLKG_SIDELOBE_FILTER_VAL_RL_t
typedef uint8 SRR_BLKG_SIDELOBE_FILTER_VAL_RL_t;

#  define Rte_TypeDef_SRR_BLKG_SIDELOBE_FILTER_VAL_RR_t
typedef uint8 SRR_BLKG_SIDELOBE_FILTER_VAL_RR_t;

#  define Rte_TypeDef_SRR_BLOCKAGE_MNR_FL_t
typedef boolean SRR_BLOCKAGE_MNR_FL_t;

#  define Rte_TypeDef_SRR_BLOCKAGE_MNR_FR_t
typedef boolean SRR_BLOCKAGE_MNR_FR_t;

#  define Rte_TypeDef_SRR_BLOCKAGE_MNR_RL_t
typedef boolean SRR_BLOCKAGE_MNR_RL_t;

#  define Rte_TypeDef_SRR_BLOCKAGE_MNR_RR_t
typedef boolean SRR_BLOCKAGE_MNR_RR_t;

#  define Rte_TypeDef_SRR_Blockage_Fault_FL_t
typedef boolean SRR_Blockage_Fault_FL_t;

#  define Rte_TypeDef_SRR_Blockage_Fault_FR_t
typedef boolean SRR_Blockage_Fault_FR_t;

#  define Rte_TypeDef_SRR_Blockage_Fault_RL_t
typedef boolean SRR_Blockage_Fault_RL_t;

#  define Rte_TypeDef_SRR_Blockage_Fault_RR_t
typedef boolean SRR_Blockage_Fault_RR_t;

#  define Rte_TypeDef_SRR_CAN_DynAlignAlgoVer_Major_FL_t
typedef uint8 SRR_CAN_DynAlignAlgoVer_Major_FL_t;

#  define Rte_TypeDef_SRR_CAN_DynAlignAlgoVer_Major_FR_t
typedef uint8 SRR_CAN_DynAlignAlgoVer_Major_FR_t;

#  define Rte_TypeDef_SRR_CAN_DynAlignAlgoVer_Major_RL_t
typedef uint8 SRR_CAN_DynAlignAlgoVer_Major_RL_t;

#  define Rte_TypeDef_SRR_CAN_DynAlignAlgoVer_Major_RR_t
typedef uint8 SRR_CAN_DynAlignAlgoVer_Major_RR_t;

#  define Rte_TypeDef_SRR_CAN_DynAlignAlgoVer_Minor_FL_t
typedef uint8 SRR_CAN_DynAlignAlgoVer_Minor_FL_t;

#  define Rte_TypeDef_SRR_CAN_DynAlignAlgoVer_Minor_FR_t
typedef uint8 SRR_CAN_DynAlignAlgoVer_Minor_FR_t;

#  define Rte_TypeDef_SRR_CAN_DynAlignAlgoVer_Minor_RL_t
typedef uint8 SRR_CAN_DynAlignAlgoVer_Minor_RL_t;

#  define Rte_TypeDef_SRR_CAN_DynAlignAlgoVer_Minor_RR_t
typedef uint8 SRR_CAN_DynAlignAlgoVer_Minor_RR_t;

#  define Rte_TypeDef_SRR_CAN_DynAlignAlgoVer_Promt_FL_t
typedef uint8 SRR_CAN_DynAlignAlgoVer_Promt_FL_t;

#  define Rte_TypeDef_SRR_CAN_DynAlignAlgoVer_Promt_FR_t
typedef uint8 SRR_CAN_DynAlignAlgoVer_Promt_FR_t;

#  define Rte_TypeDef_SRR_CAN_DynAlignAlgoVer_Promt_RL_t
typedef uint8 SRR_CAN_DynAlignAlgoVer_Promt_RL_t;

#  define Rte_TypeDef_SRR_CAN_DynAlignAlgoVer_Promt_RR_t
typedef uint8 SRR_CAN_DynAlignAlgoVer_Promt_RR_t;

#  define Rte_TypeDef_SRR_CAN_KAM_Major_FL_t
typedef uint8 SRR_CAN_KAM_Major_FL_t;

#  define Rte_TypeDef_SRR_CAN_KAM_Major_FR_t
typedef uint8 SRR_CAN_KAM_Major_FR_t;

#  define Rte_TypeDef_SRR_CAN_KAM_Major_RL_t
typedef uint8 SRR_CAN_KAM_Major_RL_t;

#  define Rte_TypeDef_SRR_CAN_KAM_Major_RR_t
typedef uint8 SRR_CAN_KAM_Major_RR_t;

#  define Rte_TypeDef_SRR_CAN_KAM_Minor_FL_t
typedef uint8 SRR_CAN_KAM_Minor_FL_t;

#  define Rte_TypeDef_SRR_CAN_KAM_Minor_FR_t
typedef uint8 SRR_CAN_KAM_Minor_FR_t;

#  define Rte_TypeDef_SRR_CAN_KAM_Minor_RL_t
typedef uint8 SRR_CAN_KAM_Minor_RL_t;

#  define Rte_TypeDef_SRR_CAN_KAM_Minor_RR_t
typedef uint8 SRR_CAN_KAM_Minor_RR_t;

#  define Rte_TypeDef_SRR_CAN_PBL_Field_Revision_FL_t
typedef uint8 SRR_CAN_PBL_Field_Revision_FL_t;

#  define Rte_TypeDef_SRR_CAN_PBL_Field_Revision_FR_t
typedef uint8 SRR_CAN_PBL_Field_Revision_FR_t;

#  define Rte_TypeDef_SRR_CAN_PBL_Field_Revision_RL_t
typedef uint8 SRR_CAN_PBL_Field_Revision_RL_t;

#  define Rte_TypeDef_SRR_CAN_PBL_Field_Revision_RR_t
typedef uint8 SRR_CAN_PBL_Field_Revision_RR_t;

#  define Rte_TypeDef_SRR_CAN_PBL_Promote_Revision_FL_t
typedef uint8 SRR_CAN_PBL_Promote_Revision_FL_t;

#  define Rte_TypeDef_SRR_CAN_PBL_Promote_Revision_FR_t
typedef uint8 SRR_CAN_PBL_Promote_Revision_FR_t;

#  define Rte_TypeDef_SRR_CAN_PBL_Promote_Revision_RL_t
typedef uint8 SRR_CAN_PBL_Promote_Revision_RL_t;

#  define Rte_TypeDef_SRR_CAN_PBL_Promote_Revision_RR_t
typedef uint8 SRR_CAN_PBL_Promote_Revision_RR_t;

#  define Rte_TypeDef_SRR_CAN_PBL_Release_Revision_FL_t
typedef uint8 SRR_CAN_PBL_Release_Revision_FL_t;

#  define Rte_TypeDef_SRR_CAN_PBL_Release_Revision_FR_t
typedef uint8 SRR_CAN_PBL_Release_Revision_FR_t;

#  define Rte_TypeDef_SRR_CAN_PBL_Release_Revision_RL_t
typedef uint8 SRR_CAN_PBL_Release_Revision_RL_t;

#  define Rte_TypeDef_SRR_CAN_PBL_Release_Revision_RR_t
typedef uint8 SRR_CAN_PBL_Release_Revision_RR_t;

#  define Rte_TypeDef_SRR_CAN_PCAN_MAJOR_SRR_FL_t
typedef uint8 SRR_CAN_PCAN_MAJOR_SRR_FL_t;

#  define Rte_TypeDef_SRR_CAN_PCAN_MAJOR_SRR_FR_t
typedef uint8 SRR_CAN_PCAN_MAJOR_SRR_FR_t;

#  define Rte_TypeDef_SRR_CAN_PCAN_MAJOR_SRR_RL_t
typedef uint8 SRR_CAN_PCAN_MAJOR_SRR_RL_t;

#  define Rte_TypeDef_SRR_CAN_PCAN_MAJOR_SRR_RR_t
typedef uint8 SRR_CAN_PCAN_MAJOR_SRR_RR_t;

#  define Rte_TypeDef_SRR_CAN_PCAN_MINOR_SRR_FL_t
typedef uint8 SRR_CAN_PCAN_MINOR_SRR_FL_t;

#  define Rte_TypeDef_SRR_CAN_PCAN_MINOR_SRR_FR_t
typedef uint8 SRR_CAN_PCAN_MINOR_SRR_FR_t;

#  define Rte_TypeDef_SRR_CAN_PCAN_MINOR_SRR_RL_t
typedef uint8 SRR_CAN_PCAN_MINOR_SRR_RL_t;

#  define Rte_TypeDef_SRR_CAN_PCAN_MINOR_SRR_RR_t
typedef uint8 SRR_CAN_PCAN_MINOR_SRR_RR_t;

#  define Rte_TypeDef_SRR_CAN_PCAN_PROMOTE_SRR_FL_t
typedef uint8 SRR_CAN_PCAN_PROMOTE_SRR_FL_t;

#  define Rte_TypeDef_SRR_CAN_PCAN_PROMOTE_SRR_FR_t
typedef uint8 SRR_CAN_PCAN_PROMOTE_SRR_FR_t;

#  define Rte_TypeDef_SRR_CAN_PCAN_PROMOTE_SRR_RL_t
typedef uint8 SRR_CAN_PCAN_PROMOTE_SRR_RL_t;

#  define Rte_TypeDef_SRR_CAN_PCAN_PROMOTE_SRR_RR_t
typedef uint8 SRR_CAN_PCAN_PROMOTE_SRR_RR_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_LatPos_FL_t
typedef uint16 SRR_CAN_SENSOR_LatPos_FL_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_LatPos_FR_t
typedef uint16 SRR_CAN_SENSOR_LatPos_FR_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_LatPos_RL_t
typedef uint16 SRR_CAN_SENSOR_LatPos_RL_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_LatPos_RR_t
typedef uint16 SRR_CAN_SENSOR_LatPos_RR_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_LongPos_FL_t
typedef uint16 SRR_CAN_SENSOR_LongPos_FL_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_LongPos_FR_t
typedef uint16 SRR_CAN_SENSOR_LongPos_FR_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_LongPos_RL_t
typedef uint16 SRR_CAN_SENSOR_LongPos_RL_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_LongPos_RR_t
typedef uint16 SRR_CAN_SENSOR_LongPos_RR_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_Orientation_FL_t
typedef sint8 SRR_CAN_SENSOR_Orientation_FL_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_Orientation_FR_t
typedef sint8 SRR_CAN_SENSOR_Orientation_FR_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_Orientation_RL_t
typedef uint8 SRR_CAN_SENSOR_Orientation_RL_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_Orientation_RR_t
typedef sint8 SRR_CAN_SENSOR_Orientation_RR_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_Pitch_FL_t
typedef float32 SRR_CAN_SENSOR_Pitch_FL_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_Pitch_FR_t
typedef float32 SRR_CAN_SENSOR_Pitch_FR_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_Pitch_RL_t
typedef float32 SRR_CAN_SENSOR_Pitch_RL_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_Pitch_RR_t
typedef float32 SRR_CAN_SENSOR_Pitch_RR_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_VertPos_FL_t
typedef uint16 SRR_CAN_SENSOR_VertPos_FL_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_VertPos_FR_t
typedef uint16 SRR_CAN_SENSOR_VertPos_FR_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_VertPos_RL_t
typedef uint16 SRR_CAN_SENSOR_VertPos_RL_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_VertPos_RR_t
typedef uint16 SRR_CAN_SENSOR_VertPos_RR_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_Yaw_FL_t
typedef float32 SRR_CAN_SENSOR_Yaw_FL_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_Yaw_FR_t
typedef float32 SRR_CAN_SENSOR_Yaw_FR_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_Yaw_RL_t
typedef float32 SRR_CAN_SENSOR_Yaw_RL_t;

#  define Rte_TypeDef_SRR_CAN_SENSOR_Yaw_RR_t
typedef float32 SRR_CAN_SENSOR_Yaw_RR_t;

#  define Rte_TypeDef_SRR_CAN_SMC_Field_FL_t
typedef uint8 SRR_CAN_SMC_Field_FL_t;

#  define Rte_TypeDef_SRR_CAN_SMC_Field_FR_t
typedef uint8 SRR_CAN_SMC_Field_FR_t;

#  define Rte_TypeDef_SRR_CAN_SMC_Field_RL_t
typedef uint8 SRR_CAN_SMC_Field_RL_t;

#  define Rte_TypeDef_SRR_CAN_SMC_Field_RR_t
typedef uint8 SRR_CAN_SMC_Field_RR_t;

#  define Rte_TypeDef_SRR_CAN_SMC_Major_FL_t
typedef uint8 SRR_CAN_SMC_Major_FL_t;

#  define Rte_TypeDef_SRR_CAN_SMC_Major_FR_t
typedef uint8 SRR_CAN_SMC_Major_FR_t;

#  define Rte_TypeDef_SRR_CAN_SMC_Major_RL_t
typedef uint8 SRR_CAN_SMC_Major_RL_t;

#  define Rte_TypeDef_SRR_CAN_SMC_Major_RR_t
typedef uint8 SRR_CAN_SMC_Major_RR_t;

#  define Rte_TypeDef_SRR_CAN_SMC_Minor_FL_t
typedef uint8 SRR_CAN_SMC_Minor_FL_t;

#  define Rte_TypeDef_SRR_CAN_SMC_Minor_FR_t
typedef uint8 SRR_CAN_SMC_Minor_FR_t;

#  define Rte_TypeDef_SRR_CAN_SMC_Minor_RL_t
typedef uint8 SRR_CAN_SMC_Minor_RL_t;

#  define Rte_TypeDef_SRR_CAN_SMC_Minor_RR_t
typedef uint8 SRR_CAN_SMC_Minor_RR_t;

#  define Rte_TypeDef_SRR_CAN_SMC_Promote_FL_t
typedef uint8 SRR_CAN_SMC_Promote_FL_t;

#  define Rte_TypeDef_SRR_CAN_SMC_Promote_FR_t
typedef uint8 SRR_CAN_SMC_Promote_FR_t;

#  define Rte_TypeDef_SRR_CAN_SMC_Promote_RL_t
typedef uint8 SRR_CAN_SMC_Promote_RL_t;

#  define Rte_TypeDef_SRR_CAN_SMC_Promote_RR_t
typedef uint8 SRR_CAN_SMC_Promote_RR_t;

#  define Rte_TypeDef_SRR_CAN_SW_Field_FL_t
typedef uint8 SRR_CAN_SW_Field_FL_t;

#  define Rte_TypeDef_SRR_CAN_SW_Field_FR_t
typedef uint8 SRR_CAN_SW_Field_FR_t;

#  define Rte_TypeDef_SRR_CAN_SW_Field_RL_t
typedef uint8 SRR_CAN_SW_Field_RL_t;

#  define Rte_TypeDef_SRR_CAN_SW_Field_RR_t
typedef uint8 SRR_CAN_SW_Field_RR_t;

#  define Rte_TypeDef_SRR_CAN_SW_Field_Revision_FL_t
typedef uint8 SRR_CAN_SW_Field_Revision_FL_t;

#  define Rte_TypeDef_SRR_CAN_SW_Field_Revision_FR_t
typedef uint8 SRR_CAN_SW_Field_Revision_FR_t;

#  define Rte_TypeDef_SRR_CAN_SW_Field_Revision_RL_t
typedef uint8 SRR_CAN_SW_Field_Revision_RL_t;

#  define Rte_TypeDef_SRR_CAN_SW_Field_Revision_RR_t
typedef uint8 SRR_CAN_SW_Field_Revision_RR_t;

#  define Rte_TypeDef_SRR_CAN_SW_Promote_Revision_FL_t
typedef uint8 SRR_CAN_SW_Promote_Revision_FL_t;

#  define Rte_TypeDef_SRR_CAN_SW_Promote_Revision_FR_t
typedef uint8 SRR_CAN_SW_Promote_Revision_FR_t;

#  define Rte_TypeDef_SRR_CAN_SW_Promote_Revision_RL_t
typedef uint8 SRR_CAN_SW_Promote_Revision_RL_t;

#  define Rte_TypeDef_SRR_CAN_SW_Promote_Revision_RR_t
typedef uint8 SRR_CAN_SW_Promote_Revision_RR_t;

#  define Rte_TypeDef_SRR_CAN_SW_Release_Revision_FL_t
typedef uint8 SRR_CAN_SW_Release_Revision_FL_t;

#  define Rte_TypeDef_SRR_CAN_SW_Release_Revision_FR_t
typedef uint8 SRR_CAN_SW_Release_Revision_FR_t;

#  define Rte_TypeDef_SRR_CAN_SW_Release_Revision_RL_t
typedef uint8 SRR_CAN_SW_Release_Revision_RL_t;

#  define Rte_TypeDef_SRR_CAN_SW_Release_Revision_RR_t
typedef uint8 SRR_CAN_SW_Release_Revision_RR_t;

#  define Rte_TypeDef_SRR_CAN_USC_Field_FL_t
typedef uint8 SRR_CAN_USC_Field_FL_t;

#  define Rte_TypeDef_SRR_CAN_USC_Field_FR_t
typedef uint8 SRR_CAN_USC_Field_FR_t;

#  define Rte_TypeDef_SRR_CAN_USC_Field_RL_t
typedef uint8 SRR_CAN_USC_Field_RL_t;

#  define Rte_TypeDef_SRR_CAN_USC_Field_RR_t
typedef uint8 SRR_CAN_USC_Field_RR_t;

#  define Rte_TypeDef_SRR_CAN_USC_Major_FL_t
typedef uint8 SRR_CAN_USC_Major_FL_t;

#  define Rte_TypeDef_SRR_CAN_USC_Major_FR_t
typedef uint8 SRR_CAN_USC_Major_FR_t;

#  define Rte_TypeDef_SRR_CAN_USC_Major_RL_t
typedef uint8 SRR_CAN_USC_Major_RL_t;

#  define Rte_TypeDef_SRR_CAN_USC_Major_RR_t
typedef uint8 SRR_CAN_USC_Major_RR_t;

#  define Rte_TypeDef_SRR_CAN_USC_Minor_FL_t
typedef uint8 SRR_CAN_USC_Minor_FL_t;

#  define Rte_TypeDef_SRR_CAN_USC_Minor_FR_t
typedef uint8 SRR_CAN_USC_Minor_FR_t;

#  define Rte_TypeDef_SRR_CAN_USC_Minor_RL_t
typedef uint8 SRR_CAN_USC_Minor_RL_t;

#  define Rte_TypeDef_SRR_CAN_USC_Minor_RR_t
typedef uint8 SRR_CAN_USC_Minor_RR_t;

#  define Rte_TypeDef_SRR_CAN_USC_Promote_FL_t
typedef uint8 SRR_CAN_USC_Promote_FL_t;

#  define Rte_TypeDef_SRR_CAN_USC_Promote_FR_t
typedef uint8 SRR_CAN_USC_Promote_FR_t;

#  define Rte_TypeDef_SRR_CAN_USC_Promote_RL_t
typedef uint8 SRR_CAN_USC_Promote_RL_t;

#  define Rte_TypeDef_SRR_CAN_USC_Promote_RR_t
typedef uint8 SRR_CAN_USC_Promote_RR_t;

#  define Rte_TypeDef_SRR_COMPENSATED_SIGNALS_USED_FL_t
typedef uint8 SRR_COMPENSATED_SIGNALS_USED_FL_t;

#  define Rte_TypeDef_SRR_COMPENSATED_SIGNALS_USED_FR_t
typedef uint8 SRR_COMPENSATED_SIGNALS_USED_FR_t;

#  define Rte_TypeDef_SRR_COMPENSATED_SIGNALS_USED_RL_t
typedef uint8 SRR_COMPENSATED_SIGNALS_USED_RL_t;

#  define Rte_TypeDef_SRR_COMPENSATED_SIGNALS_USED_RR_t
typedef uint8 SRR_COMPENSATED_SIGNALS_USED_RR_t;

#  define Rte_TypeDef_SRR_Calib_Not_Learned_Fault_FL_t
typedef boolean SRR_Calib_Not_Learned_Fault_FL_t;

#  define Rte_TypeDef_SRR_Calib_Not_Learned_Fault_FR_t
typedef boolean SRR_Calib_Not_Learned_Fault_FR_t;

#  define Rte_TypeDef_SRR_Calib_Not_Learned_Fault_RL_t
typedef boolean SRR_Calib_Not_Learned_Fault_RL_t;

#  define Rte_TypeDef_SRR_Calib_Not_Learned_Fault_RR_t
typedef boolean SRR_Calib_Not_Learned_Fault_RR_t;

#  define Rte_TypeDef_SRR_Core0_Instant_Cpu_Load_FL_t
typedef uint32 SRR_Core0_Instant_Cpu_Load_FL_t;

#  define Rte_TypeDef_SRR_Core0_Instant_Cpu_Load_FR_t
typedef uint32 SRR_Core0_Instant_Cpu_Load_FR_t;

#  define Rte_TypeDef_SRR_Core0_Instant_Cpu_Load_RL_t
typedef uint32 SRR_Core0_Instant_Cpu_Load_RL_t;

#  define Rte_TypeDef_SRR_Core0_Instant_Cpu_Load_RR_t
typedef uint32 SRR_Core0_Instant_Cpu_Load_RR_t;

#  define Rte_TypeDef_SRR_Core0_Max_Cpu_Load_FL_t
typedef uint32 SRR_Core0_Max_Cpu_Load_FL_t;

#  define Rte_TypeDef_SRR_Core0_Max_Cpu_Load_FR_t
typedef uint32 SRR_Core0_Max_Cpu_Load_FR_t;

#  define Rte_TypeDef_SRR_Core0_Max_Cpu_Load_RL_t
typedef uint32 SRR_Core0_Max_Cpu_Load_RL_t;

#  define Rte_TypeDef_SRR_Core0_Max_Cpu_Load_RR_t
typedef uint32 SRR_Core0_Max_Cpu_Load_RR_t;

#  define Rte_TypeDef_SRR_Core1_Instant_Cpu_Load_FL_t
typedef uint32 SRR_Core1_Instant_Cpu_Load_FL_t;

#  define Rte_TypeDef_SRR_Core1_Instant_Cpu_Load_FR_t
typedef uint32 SRR_Core1_Instant_Cpu_Load_FR_t;

#  define Rte_TypeDef_SRR_Core1_Instant_Cpu_Load_RL_t
typedef uint32 SRR_Core1_Instant_Cpu_Load_RL_t;

#  define Rte_TypeDef_SRR_Core1_Instant_Cpu_Load_RR_t
typedef uint32 SRR_Core1_Instant_Cpu_Load_RR_t;

#  define Rte_TypeDef_SRR_Core1_Max_Cpu_Load_FL_t
typedef uint32 SRR_Core1_Max_Cpu_Load_FL_t;

#  define Rte_TypeDef_SRR_Core1_Max_Cpu_Load_FR_t
typedef uint32 SRR_Core1_Max_Cpu_Load_FR_t;

#  define Rte_TypeDef_SRR_Core1_Max_Cpu_Load_RL_t
typedef uint32 SRR_Core1_Max_Cpu_Load_RL_t;

#  define Rte_TypeDef_SRR_Core1_Max_Cpu_Load_RR_t
typedef uint32 SRR_Core1_Max_Cpu_Load_RR_t;

#  define Rte_TypeDef_SRR_Core2_Instant_Cpu_Load_FL_t
typedef uint32 SRR_Core2_Instant_Cpu_Load_FL_t;

#  define Rte_TypeDef_SRR_Core2_Instant_Cpu_Load_FR_t
typedef uint32 SRR_Core2_Instant_Cpu_Load_FR_t;

#  define Rte_TypeDef_SRR_Core2_Instant_Cpu_Load_RL_t
typedef uint32 SRR_Core2_Instant_Cpu_Load_RL_t;

#  define Rte_TypeDef_SRR_Core2_Instant_Cpu_Load_RR_t
typedef uint32 SRR_Core2_Instant_Cpu_Load_RR_t;

#  define Rte_TypeDef_SRR_Core2_Max_Cpu_Load_FL_t
typedef uint32 SRR_Core2_Max_Cpu_Load_FL_t;

#  define Rte_TypeDef_SRR_Core2_Max_Cpu_Load_FR_t
typedef uint32 SRR_Core2_Max_Cpu_Load_FR_t;

#  define Rte_TypeDef_SRR_Core2_Max_Cpu_Load_RL_t
typedef uint32 SRR_Core2_Max_Cpu_Load_RL_t;

#  define Rte_TypeDef_SRR_Core2_Max_Cpu_Load_RR_t
typedef uint32 SRR_Core2_Max_Cpu_Load_RR_t;

#  define Rte_TypeDef_SRR_CoreRadarBBVersion_Field_FL_t
typedef uint8 SRR_CoreRadarBBVersion_Field_FL_t;

#  define Rte_TypeDef_SRR_CoreRadarBBVersion_Field_FR_t
typedef uint8 SRR_CoreRadarBBVersion_Field_FR_t;

#  define Rte_TypeDef_SRR_CoreRadarBBVersion_Field_RL_t
typedef uint8 SRR_CoreRadarBBVersion_Field_RL_t;

#  define Rte_TypeDef_SRR_CoreRadarBBVersion_Field_RR_t
typedef uint8 SRR_CoreRadarBBVersion_Field_RR_t;

#  define Rte_TypeDef_SRR_CoreRadarBBVersion_Major_FL_t
typedef uint8 SRR_CoreRadarBBVersion_Major_FL_t;

#  define Rte_TypeDef_SRR_CoreRadarBBVersion_Major_FR_t
typedef uint8 SRR_CoreRadarBBVersion_Major_FR_t;

#  define Rte_TypeDef_SRR_CoreRadarBBVersion_Major_RL_t
typedef uint8 SRR_CoreRadarBBVersion_Major_RL_t;

#  define Rte_TypeDef_SRR_CoreRadarBBVersion_Major_RR_t
typedef uint8 SRR_CoreRadarBBVersion_Major_RR_t;

#  define Rte_TypeDef_SRR_CoreRadarBBVersion_Minor_FL_t
typedef uint8 SRR_CoreRadarBBVersion_Minor_FL_t;

#  define Rte_TypeDef_SRR_CoreRadarBBVersion_Minor_FR_t
typedef uint8 SRR_CoreRadarBBVersion_Minor_FR_t;

#  define Rte_TypeDef_SRR_CoreRadarBBVersion_Minor_RL_t
typedef uint8 SRR_CoreRadarBBVersion_Minor_RL_t;

#  define Rte_TypeDef_SRR_CoreRadarBBVersion_Minor_RR_t
typedef uint8 SRR_CoreRadarBBVersion_Minor_RR_t;

#  define Rte_TypeDef_SRR_CoreRadarBBVersion_Promt_FL_t
typedef uint8 SRR_CoreRadarBBVersion_Promt_FL_t;

#  define Rte_TypeDef_SRR_CoreRadarBBVersion_Promt_FR_t
typedef uint8 SRR_CoreRadarBBVersion_Promt_FR_t;

#  define Rte_TypeDef_SRR_CoreRadarBBVersion_Promt_RL_t
typedef uint8 SRR_CoreRadarBBVersion_Promt_RL_t;

#  define Rte_TypeDef_SRR_CoreRadarBBVersion_Promt_RR_t
typedef uint8 SRR_CoreRadarBBVersion_Promt_RR_t;

#  define Rte_TypeDef_SRR_FL_HeadAlignSts_CRC_t
typedef uint8 SRR_FL_HeadAlignSts_CRC_t;

#  define Rte_TypeDef_SRR_FL_HeadAlignSts_MC_t
typedef uint8 SRR_FL_HeadAlignSts_MC_t;

#  define Rte_TypeDef_SRR_FL_StsCANVer_CRC_t
typedef uint8 SRR_FL_StsCANVer_CRC_t;

#  define Rte_TypeDef_SRR_FL_StsCANVer_MC_t
typedef uint8 SRR_FL_StsCANVer_MC_t;

#  define Rte_TypeDef_SRR_FL_StsRadar_CRC_t
typedef uint8 SRR_FL_StsRadar_CRC_t;

#  define Rte_TypeDef_SRR_FL_StsRadar_MC_t
typedef uint8 SRR_FL_StsRadar_MC_t;

#  define Rte_TypeDef_SRR_FR_HeadAlignSts_CRC_t
typedef uint8 SRR_FR_HeadAlignSts_CRC_t;

#  define Rte_TypeDef_SRR_FR_HeadAlignSts_MC_t
typedef uint8 SRR_FR_HeadAlignSts_MC_t;

#  define Rte_TypeDef_SRR_FR_StsCANVer_CRC_t
typedef uint8 SRR_FR_StsCANVer_CRC_t;

#  define Rte_TypeDef_SRR_FR_StsCANVer_MC_t
typedef uint8 SRR_FR_StsCANVer_MC_t;

#  define Rte_TypeDef_SRR_FR_StsRadar_CRC_t
typedef uint8 SRR_FR_StsRadar_CRC_t;

#  define Rte_TypeDef_SRR_FR_StsRadar_MC_t
typedef uint8 SRR_FR_StsRadar_MC_t;

#  define Rte_TypeDef_SRR_HRZNTL_ALIGN_UPDATES_Nbr_FL_t
typedef uint16 SRR_HRZNTL_ALIGN_UPDATES_Nbr_FL_t;

#  define Rte_TypeDef_SRR_HRZNTL_ALIGN_UPDATES_Nbr_FR_t
typedef uint16 SRR_HRZNTL_ALIGN_UPDATES_Nbr_FR_t;

#  define Rte_TypeDef_SRR_HRZNTL_ALIGN_UPDATES_Nbr_RL_t
typedef uint16 SRR_HRZNTL_ALIGN_UPDATES_Nbr_RL_t;

#  define Rte_TypeDef_SRR_HRZNTL_ALIGN_UPDATES_Nbr_RR_t
typedef uint16 SRR_HRZNTL_ALIGN_UPDATES_Nbr_RR_t;

#  define Rte_TypeDef_SRR_Horizontal_Alignment_St_FL_t
typedef uint8 SRR_Horizontal_Alignment_St_FL_t;

#  define Rte_TypeDef_SRR_Horizontal_Alignment_St_FR_t
typedef uint8 SRR_Horizontal_Alignment_St_FR_t;

#  define Rte_TypeDef_SRR_Horizontal_Alignment_St_RL_t
typedef uint8 SRR_Horizontal_Alignment_St_RL_t;

#  define Rte_TypeDef_SRR_Horizontal_Alignment_St_RR_t
typedef uint8 SRR_Horizontal_Alignment_St_RR_t;

#  define Rte_TypeDef_SRR_Horizontal_Alignment_Sts_FL_t
typedef uint8 SRR_Horizontal_Alignment_Sts_FL_t;

#  define Rte_TypeDef_SRR_Horizontal_Alignment_Sts_FR_t
typedef uint8 SRR_Horizontal_Alignment_Sts_FR_t;

#  define Rte_TypeDef_SRR_Horizontal_Alignment_Sts_RL_t
typedef uint8 SRR_Horizontal_Alignment_Sts_RL_t;

#  define Rte_TypeDef_SRR_Horizontal_Alignment_Sts_RR_t
typedef uint8 SRR_Horizontal_Alignment_Sts_RR_t;

#  define Rte_TypeDef_SRR_INTERFERENCE_TYPE_FL_t
typedef uint8 SRR_INTERFERENCE_TYPE_FL_t;

#  define Rte_TypeDef_SRR_INTERFERENCE_TYPE_FR_t
typedef uint8 SRR_INTERFERENCE_TYPE_FR_t;

#  define Rte_TypeDef_SRR_INTERFERENCE_TYPE_RL_t
typedef uint8 SRR_INTERFERENCE_TYPE_RL_t;

#  define Rte_TypeDef_SRR_INTERFERENCE_TYPE_RR_t
typedef uint8 SRR_INTERFERENCE_TYPE_RR_t;

#  define Rte_TypeDef_SRR_Internal_Fault_FL_t
typedef boolean SRR_Internal_Fault_FL_t;

#  define Rte_TypeDef_SRR_Internal_Fault_FR_t
typedef boolean SRR_Internal_Fault_FR_t;

#  define Rte_TypeDef_SRR_Internal_Fault_RL_t
typedef boolean SRR_Internal_Fault_RL_t;

#  define Rte_TypeDef_SRR_Internal_Fault_RR_t
typedef boolean SRR_Internal_Fault_RR_t;

#  define Rte_TypeDef_SRR_MEC_FL_t
typedef boolean SRR_MEC_FL_t;

#  define Rte_TypeDef_SRR_MEC_FR_t
typedef boolean SRR_MEC_FR_t;

#  define Rte_TypeDef_SRR_MEC_RL_t
typedef boolean SRR_MEC_RL_t;

#  define Rte_TypeDef_SRR_MEC_RR_t
typedef boolean SRR_MEC_RR_t;

#  define Rte_TypeDef_SRR_RADAR_CommonModeFailure_FL_t
typedef uint8 SRR_RADAR_CommonModeFailure_FL_t;

#  define Rte_TypeDef_SRR_RADAR_CommonModeFailure_FR_t
typedef uint8 SRR_RADAR_CommonModeFailure_FR_t;

#  define Rte_TypeDef_SRR_RADAR_CommonModeFailure_RL_t
typedef uint8 SRR_RADAR_CommonModeFailure_RL_t;

#  define Rte_TypeDef_SRR_RADAR_CommonModeFailure_RR_t
typedef uint8 SRR_RADAR_CommonModeFailure_RR_t;

#  define Rte_TypeDef_SRR_RADAR_OVERHEAT_ERROR_FL_t
typedef boolean SRR_RADAR_OVERHEAT_ERROR_FL_t;

#  define Rte_TypeDef_SRR_RADAR_OVERHEAT_ERROR_FR_t
typedef boolean SRR_RADAR_OVERHEAT_ERROR_FR_t;

#  define Rte_TypeDef_SRR_RADAR_OVERHEAT_ERROR_RL_t
typedef boolean SRR_RADAR_OVERHEAT_ERROR_RL_t;

#  define Rte_TypeDef_SRR_RADAR_OVERHEAT_ERROR_RR_t
typedef boolean SRR_RADAR_OVERHEAT_ERROR_RR_t;

#  define Rte_TypeDef_SRR_RECOMMEND_UNCONVERGE_FL_t
typedef boolean SRR_RECOMMEND_UNCONVERGE_FL_t;

#  define Rte_TypeDef_SRR_RECOMMEND_UNCONVERGE_FR_t
typedef boolean SRR_RECOMMEND_UNCONVERGE_FR_t;

#  define Rte_TypeDef_SRR_RECOMMEND_UNCONVERGE_RL_t
typedef boolean SRR_RECOMMEND_UNCONVERGE_RL_t;

#  define Rte_TypeDef_SRR_RECOMMEND_UNCONVERGE_RR_t
typedef boolean SRR_RECOMMEND_UNCONVERGE_RR_t;

#  define Rte_TypeDef_SRR_RL_HeadAlignSts_CRC_t
typedef uint8 SRR_RL_HeadAlignSts_CRC_t;

#  define Rte_TypeDef_SRR_RL_HeadAlignSts_MC_t
typedef uint8 SRR_RL_HeadAlignSts_MC_t;

#  define Rte_TypeDef_SRR_RL_StsCANVer_CRC_t
typedef uint8 SRR_RL_StsCANVer_CRC_t;

#  define Rte_TypeDef_SRR_RL_StsCANVer_MC_t
typedef uint8 SRR_RL_StsCANVer_MC_t;

#  define Rte_TypeDef_SRR_RL_StsRadar_CRC_t
typedef uint8 SRR_RL_StsRadar_CRC_t;

#  define Rte_TypeDef_SRR_RL_StsRadar_MC_t
typedef uint8 SRR_RL_StsRadar_MC_t;

#  define Rte_TypeDef_SRR_RR_HeadAlignSts_CRC_t
typedef uint8 SRR_RR_HeadAlignSts_CRC_t;

#  define Rte_TypeDef_SRR_RR_HeadAlignSts_MC_t
typedef uint8 SRR_RR_HeadAlignSts_MC_t;

#  define Rte_TypeDef_SRR_RR_StsCANVer_CRC_t
typedef uint8 SRR_RR_StsCANVer_CRC_t;

#  define Rte_TypeDef_SRR_RR_StsCANVer_MC_t
typedef uint8 SRR_RR_StsCANVer_MC_t;

#  define Rte_TypeDef_SRR_RR_StsRadar_CRC_t
typedef uint8 SRR_RR_StsRadar_CRC_t;

#  define Rte_TypeDef_SRR_RR_StsRadar_MC_t
typedef uint8 SRR_RR_StsRadar_MC_t;

#  define Rte_TypeDef_SRR_S2InvalidDataFrom_ASDM_Fa_FL_t
typedef boolean SRR_S2InvalidDataFrom_ASDM_Fa_FL_t;

#  define Rte_TypeDef_SRR_S2InvalidDataFrom_ASDM_Fa_FR_t
typedef boolean SRR_S2InvalidDataFrom_ASDM_Fa_FR_t;

#  define Rte_TypeDef_SRR_S2InvalidDataFrom_ASDM_Fa_RL_t
typedef boolean SRR_S2InvalidDataFrom_ASDM_Fa_RL_t;

#  define Rte_TypeDef_SRR_S2InvalidDataFrom_ASDM_Fa_RR_t
typedef boolean SRR_S2InvalidDataFrom_ASDM_Fa_RR_t;

#  define Rte_TypeDef_SRR_S2LostCommunicationASDM_F_FL_t
typedef boolean SRR_S2LostCommunicationASDM_F_FL_t;

#  define Rte_TypeDef_SRR_S2LostCommunicationASDM_F_FR_t
typedef boolean SRR_S2LostCommunicationASDM_F_FR_t;

#  define Rte_TypeDef_SRR_S2LostCommunicationASDM_F_RL_t
typedef boolean SRR_S2LostCommunicationASDM_F_RL_t;

#  define Rte_TypeDef_SRR_S2LostCommunicationASDM_F_RR_t
typedef boolean SRR_S2LostCommunicationASDM_F_RR_t;

#  define Rte_TypeDef_SRR_SW_Flash_Counter_FL_t
typedef uint32 SRR_SW_Flash_Counter_FL_t;

#  define Rte_TypeDef_SRR_SW_Flash_Counter_FR_t
typedef uint32 SRR_SW_Flash_Counter_FR_t;

#  define Rte_TypeDef_SRR_SW_Flash_Counter_RL_t
typedef uint32 SRR_SW_Flash_Counter_RL_t;

#  define Rte_TypeDef_SRR_SW_Flash_Counter_RR_t
typedef uint32 SRR_SW_Flash_Counter_RR_t;

#  define Rte_TypeDef_SRR_System_Operation_Mode_Sts_FL_t
typedef uint8 SRR_System_Operation_Mode_Sts_FL_t;

#  define Rte_TypeDef_SRR_System_Operation_Mode_Sts_FR_t
typedef uint8 SRR_System_Operation_Mode_Sts_FR_t;

#  define Rte_TypeDef_SRR_System_Operation_Mode_Sts_RL_t
typedef uint8 SRR_System_Operation_Mode_Sts_RL_t;

#  define Rte_TypeDef_SRR_System_Operation_Mode_Sts_RR_t
typedef uint8 SRR_System_Operation_Mode_Sts_RR_t;

#  define Rte_TypeDef_SRR_Temperature_High_Fault_FL_t
typedef boolean SRR_Temperature_High_Fault_FL_t;

#  define Rte_TypeDef_SRR_Temperature_High_Fault_FR_t
typedef boolean SRR_Temperature_High_Fault_FR_t;

#  define Rte_TypeDef_SRR_Temperature_High_Fault_RL_t
typedef boolean SRR_Temperature_High_Fault_RL_t;

#  define Rte_TypeDef_SRR_Temperature_High_Fault_RR_t
typedef boolean SRR_Temperature_High_Fault_RR_t;

#  define Rte_TypeDef_SRR_VEHICLE_GEAR_ECHO_FL_t
typedef uint8 SRR_VEHICLE_GEAR_ECHO_FL_t;

#  define Rte_TypeDef_SRR_VEHICLE_GEAR_ECHO_FR_t
typedef uint8 SRR_VEHICLE_GEAR_ECHO_FR_t;

#  define Rte_TypeDef_SRR_VEHICLE_GEAR_ECHO_RL_t
typedef uint8 SRR_VEHICLE_GEAR_ECHO_RL_t;

#  define Rte_TypeDef_SRR_VEHICLE_GEAR_ECHO_RR_t
typedef uint8 SRR_VEHICLE_GEAR_ECHO_RR_t;

#  define Rte_TypeDef_SRR_VEHICLE_SPEED_CALC_QF_EC_FL_t
typedef uint8 SRR_VEHICLE_SPEED_CALC_QF_EC_FL_t;

#  define Rte_TypeDef_SRR_VEHICLE_SPEED_CALC_QF_EC_FR_t
typedef uint8 SRR_VEHICLE_SPEED_CALC_QF_EC_FR_t;

#  define Rte_TypeDef_SRR_VEHICLE_SPEED_CALC_QF_EC_RL_t
typedef uint8 SRR_VEHICLE_SPEED_CALC_QF_EC_RL_t;

#  define Rte_TypeDef_SRR_VEHICLE_SPEED_CALC_QF_EC_RR_t
typedef uint8 SRR_VEHICLE_SPEED_CALC_QF_EC_RR_t;

#  define Rte_TypeDef_SRR_VEHICLE_SPEED_ECHO_FL_t
typedef float32 SRR_VEHICLE_SPEED_ECHO_FL_t;

#  define Rte_TypeDef_SRR_VEHICLE_SPEED_ECHO_FR_t
typedef float32 SRR_VEHICLE_SPEED_ECHO_FR_t;

#  define Rte_TypeDef_SRR_VEHICLE_SPEED_ECHO_RL_t
typedef float32 SRR_VEHICLE_SPEED_ECHO_RL_t;

#  define Rte_TypeDef_SRR_VEHICLE_SPEED_ECHO_RR_t
typedef float32 SRR_VEHICLE_SPEED_ECHO_RR_t;

#  define Rte_TypeDef_SRR_VIN_Mismatch_Fault_FL_t
typedef boolean SRR_VIN_Mismatch_Fault_FL_t;

#  define Rte_TypeDef_SRR_VIN_Mismatch_Fault_FR_t
typedef boolean SRR_VIN_Mismatch_Fault_FR_t;

#  define Rte_TypeDef_SRR_VIN_Mismatch_Fault_RL_t
typedef boolean SRR_VIN_Mismatch_Fault_RL_t;

#  define Rte_TypeDef_SRR_VIN_Mismatch_Fault_RR_t
typedef boolean SRR_VIN_Mismatch_Fault_RR_t;

#  define Rte_TypeDef_SRR_VIN_Not_Programmed_Fault_FL_t
typedef boolean SRR_VIN_Not_Programmed_Fault_FL_t;

#  define Rte_TypeDef_SRR_VIN_Not_Programmed_Fault_FR_t
typedef boolean SRR_VIN_Not_Programmed_Fault_FR_t;

#  define Rte_TypeDef_SRR_VIN_Not_Programmed_Fault_RL_t
typedef boolean SRR_VIN_Not_Programmed_Fault_RL_t;

#  define Rte_TypeDef_SRR_VIN_Not_Programmed_Fault_RR_t
typedef boolean SRR_VIN_Not_Programmed_Fault_RR_t;

#  define Rte_TypeDef_SRR_VRTCL_ALIGN_UPDATES_Nbr_FL_t
typedef uint16 SRR_VRTCL_ALIGN_UPDATES_Nbr_FL_t;

#  define Rte_TypeDef_SRR_VRTCL_ALIGN_UPDATES_Nbr_FR_t
typedef uint16 SRR_VRTCL_ALIGN_UPDATES_Nbr_FR_t;

#  define Rte_TypeDef_SRR_VRTCL_ALIGN_UPDATES_Nbr_RL_t
typedef uint16 SRR_VRTCL_ALIGN_UPDATES_Nbr_RL_t;

#  define Rte_TypeDef_SRR_VRTCL_ALIGN_UPDATES_Nbr_RR_t
typedef uint16 SRR_VRTCL_ALIGN_UPDATES_Nbr_RR_t;

#  define Rte_TypeDef_SRR_Vertical_Alignment_St_FL_t
typedef uint8 SRR_Vertical_Alignment_St_FL_t;

#  define Rte_TypeDef_SRR_Vertical_Alignment_St_FR_t
typedef uint8 SRR_Vertical_Alignment_St_FR_t;

#  define Rte_TypeDef_SRR_Vertical_Alignment_State_RL_t
typedef uint8 SRR_Vertical_Alignment_State_RL_t;

#  define Rte_TypeDef_SRR_Vertical_Alignment_State_RR_t
typedef uint8 SRR_Vertical_Alignment_State_RR_t;

#  define Rte_TypeDef_SRR_Vertical_Alignment_Status_RL_t
typedef uint8 SRR_Vertical_Alignment_Status_RL_t;

#  define Rte_TypeDef_SRR_Vertical_Alignment_Status_RR_t
typedef uint8 SRR_Vertical_Alignment_Status_RR_t;

#  define Rte_TypeDef_SRR_Vertical_Alignment_Sts_FL_t
typedef uint8 SRR_Vertical_Alignment_Sts_FL_t;

#  define Rte_TypeDef_SRR_Vertical_Alignment_Sts_FR_t
typedef uint8 SRR_Vertical_Alignment_Sts_FR_t;

#  define Rte_TypeDef_SRR_Vol_Above_Threshold_Fault_FL_t
typedef boolean SRR_Vol_Above_Threshold_Fault_FL_t;

#  define Rte_TypeDef_SRR_Vol_Above_Threshold_Fault_FR_t
typedef boolean SRR_Vol_Above_Threshold_Fault_FR_t;

#  define Rte_TypeDef_SRR_Vol_Above_Threshold_Fault_RL_t
typedef boolean SRR_Vol_Above_Threshold_Fault_RL_t;

#  define Rte_TypeDef_SRR_Vol_Above_Threshold_Fault_RR_t
typedef boolean SRR_Vol_Above_Threshold_Fault_RR_t;

#  define Rte_TypeDef_SRR_Vol_Below_Threshold_Fault_FL_t
typedef boolean SRR_Vol_Below_Threshold_Fault_FL_t;

#  define Rte_TypeDef_SRR_Vol_Below_Threshold_Fault_FR_t
typedef boolean SRR_Vol_Below_Threshold_Fault_FR_t;

#  define Rte_TypeDef_SRR_Vol_Below_Threshold_Fault_RL_t
typedef boolean SRR_Vol_Below_Threshold_Fault_RL_t;

#  define Rte_TypeDef_SRR_Vol_Below_Threshold_Fault_RR_t
typedef boolean SRR_Vol_Below_Threshold_Fault_RR_t;

#  define Rte_TypeDef_SRR_XCVR_OPERATIONAL_FL_t
typedef boolean SRR_XCVR_OPERATIONAL_FL_t;

#  define Rte_TypeDef_SRR_XCVR_OPERATIONAL_FR_t
typedef boolean SRR_XCVR_OPERATIONAL_FR_t;

#  define Rte_TypeDef_SRR_XCVR_OPERATIONAL_RL_t
typedef boolean SRR_XCVR_OPERATIONAL_RL_t;

#  define Rte_TypeDef_SRR_XCVR_OPERATIONAL_RR_t
typedef boolean SRR_XCVR_OPERATIONAL_RR_t;

#  define Rte_TypeDef_SRR_YAW_RATE_BIAS_ECHO_FL_t
typedef float32 SRR_YAW_RATE_BIAS_ECHO_FL_t;

#  define Rte_TypeDef_SRR_YAW_RATE_BIAS_ECHO_FR_t
typedef float32 SRR_YAW_RATE_BIAS_ECHO_FR_t;

#  define Rte_TypeDef_SRR_YAW_RATE_BIAS_ECHO_RL_t
typedef float32 SRR_YAW_RATE_BIAS_ECHO_RL_t;

#  define Rte_TypeDef_SRR_YAW_RATE_BIAS_ECHO_RR_t
typedef float32 SRR_YAW_RATE_BIAS_ECHO_RR_t;

#  define Rte_TypeDef_SRR_YAW_RATE_CALC_QF_ECHO_FL_t
typedef uint8 SRR_YAW_RATE_CALC_QF_ECHO_FL_t;

#  define Rte_TypeDef_SRR_YAW_RATE_CALC_QF_ECHO_FR_t
typedef uint8 SRR_YAW_RATE_CALC_QF_ECHO_FR_t;

#  define Rte_TypeDef_SRR_YAW_RATE_CALC_QF_ECHO_RL_t
typedef uint8 SRR_YAW_RATE_CALC_QF_ECHO_RL_t;

#  define Rte_TypeDef_SRR_YAW_RATE_CALC_QF_ECHO_RR_t
typedef uint8 SRR_YAW_RATE_CALC_QF_ECHO_RR_t;

#  define Rte_TypeDef_SRR_YAW_RATE_ECHO_FL_t
typedef float32 SRR_YAW_RATE_ECHO_FL_t;

#  define Rte_TypeDef_SRR_YAW_RATE_ECHO_FR_t
typedef float32 SRR_YAW_RATE_ECHO_FR_t;

#  define Rte_TypeDef_SRR_YAW_RATE_ECHO_RL_t
typedef float32 SRR_YAW_RATE_ECHO_RL_t;

#  define Rte_TypeDef_SRR_YAW_RATE_ECHO_RR_t
typedef float32 SRR_YAW_RATE_ECHO_RR_t;

#  define Rte_TypeDef_SWSM_A_CD_Add_Overtime
typedef boolean SWSM_A_CD_Add_Overtime;

#  define Rte_TypeDef_SWSM_A_CD_Add_Overtime_t
typedef boolean SWSM_A_CD_Add_Overtime_t;

#  define Rte_TypeDef_SWSM_A_CD_Minus_Overtime
typedef boolean SWSM_A_CD_Minus_Overtime;

#  define Rte_TypeDef_SWSM_A_CD_Minus_Overtime_t
typedef boolean SWSM_A_CD_Minus_Overtime_t;

#  define Rte_TypeDef_SWSM_A_CruiseDistance_Add
typedef boolean SWSM_A_CruiseDistance_Add;

#  define Rte_TypeDef_SWSM_A_CruiseDistance_Add_t
typedef boolean SWSM_A_CruiseDistance_Add_t;

#  define Rte_TypeDef_SWSM_A_CruiseDistance_Minus
typedef boolean SWSM_A_CruiseDistance_Minus;

#  define Rte_TypeDef_SWSM_A_CruiseDistance_Minus_t
typedef boolean SWSM_A_CruiseDistance_Minus_t;

#  define Rte_TypeDef_SWSM_A_CruiseSpeed_Add
typedef uint8 SWSM_A_CruiseSpeed_Add;

#  define Rte_TypeDef_SWSM_A_CruiseSpeed_Add_t
typedef uint8 SWSM_A_CruiseSpeed_Add_t;

#  define Rte_TypeDef_SWSM_A_CruiseSpeed_Minus
typedef uint8 SWSM_A_CruiseSpeed_Minus;

#  define Rte_TypeDef_SWSM_A_CruiseSpeed_Minus_t
typedef uint8 SWSM_A_CruiseSpeed_Minus_t;

#  define Rte_TypeDef_SWSM_A_SpeechInputSw
typedef uint8 SWSM_A_SpeechInputSw;

#  define Rte_TypeDef_SecsOfMinute
typedef uint8 SecsOfMinute;

#  define Rte_TypeDef_SensorCfg_LRR_AlignRngTolHorz_t
typedef float32 SensorCfg_LRR_AlignRngTolHorz_t;

#  define Rte_TypeDef_SensorCfg_LRR_AlignRngTolVert_t
typedef float32 SensorCfg_LRR_AlignRngTolVert_t;

#  define Rte_TypeDef_SensorCfg_LRR_CRC_t
typedef uint8 SensorCfg_LRR_CRC_t;

#  define Rte_TypeDef_SensorCfg_LRR_FcAlnRngTolHorz_t
typedef float32 SensorCfg_LRR_FcAlnRngTolHorz_t;

#  define Rte_TypeDef_SensorCfg_LRR_FcAlnRngTolVert_t
typedef float32 SensorCfg_LRR_FcAlnRngTolVert_t;

#  define Rte_TypeDef_SensorCfg_LRR_LatPos_t
typedef uint16 SensorCfg_LRR_LatPos_t;

#  define Rte_TypeDef_SensorCfg_LRR_LongPos_t
typedef uint16 SensorCfg_LRR_LongPos_t;

#  define Rte_TypeDef_SensorCfg_LRR_Orientation_t
typedef uint8 SensorCfg_LRR_Orientation_t;

#  define Rte_TypeDef_SensorCfg_LRR_Pitch_t
typedef float32 SensorCfg_LRR_Pitch_t;

#  define Rte_TypeDef_SensorCfg_LRR_VertPos_t
typedef uint16 SensorCfg_LRR_VertPos_t;

#  define Rte_TypeDef_SensorCfg_LRR_Yaw_t
typedef float32 SensorCfg_LRR_Yaw_t;

#  define Rte_TypeDef_SensorCfg_Parameters_SRR_CRC_F_t
typedef uint8 SensorCfg_Parameters_SRR_CRC_F_t;

#  define Rte_TypeDef_SensorCfg_Parameters_SRR_CRC_R_t
typedef uint8 SensorCfg_Parameters_SRR_CRC_R_t;

#  define Rte_TypeDef_SensorCfg_SRR_FL_LatPos_t
typedef uint16 SensorCfg_SRR_FL_LatPos_t;

#  define Rte_TypeDef_SensorCfg_SRR_FL_LongPos_t
typedef uint16 SensorCfg_SRR_FL_LongPos_t;

#  define Rte_TypeDef_SensorCfg_SRR_FL_Orientation_t
typedef sint8 SensorCfg_SRR_FL_Orientation_t;

#  define Rte_TypeDef_SensorCfg_SRR_FL_Pitch_t
typedef float32 SensorCfg_SRR_FL_Pitch_t;

#  define Rte_TypeDef_SensorCfg_SRR_FL_VertPos_t
typedef uint16 SensorCfg_SRR_FL_VertPos_t;

#  define Rte_TypeDef_SensorCfg_SRR_FL_Yaw_t
typedef float32 SensorCfg_SRR_FL_Yaw_t;

#  define Rte_TypeDef_SensorCfg_SRR_FR_LatPos_t
typedef uint16 SensorCfg_SRR_FR_LatPos_t;

#  define Rte_TypeDef_SensorCfg_SRR_FR_LongPos_t
typedef uint16 SensorCfg_SRR_FR_LongPos_t;

#  define Rte_TypeDef_SensorCfg_SRR_FR_Orientation_t
typedef sint8 SensorCfg_SRR_FR_Orientation_t;

#  define Rte_TypeDef_SensorCfg_SRR_FR_Pitch_t
typedef float32 SensorCfg_SRR_FR_Pitch_t;

#  define Rte_TypeDef_SensorCfg_SRR_FR_VertPos_t
typedef uint16 SensorCfg_SRR_FR_VertPos_t;

#  define Rte_TypeDef_SensorCfg_SRR_FR_Yaw_t
typedef float32 SensorCfg_SRR_FR_Yaw_t;

#  define Rte_TypeDef_SensorCfg_SRR_RL_LatPos_t
typedef uint16 SensorCfg_SRR_RL_LatPos_t;

#  define Rte_TypeDef_SensorCfg_SRR_RL_LongPos_t
typedef uint16 SensorCfg_SRR_RL_LongPos_t;

#  define Rte_TypeDef_SensorCfg_SRR_RL_Orientation_t
typedef sint8 SensorCfg_SRR_RL_Orientation_t;

#  define Rte_TypeDef_SensorCfg_SRR_RL_Pitch_t
typedef float32 SensorCfg_SRR_RL_Pitch_t;

#  define Rte_TypeDef_SensorCfg_SRR_RL_VertPos_t
typedef uint16 SensorCfg_SRR_RL_VertPos_t;

#  define Rte_TypeDef_SensorCfg_SRR_RL_Yaw_t
typedef float32 SensorCfg_SRR_RL_Yaw_t;

#  define Rte_TypeDef_SensorCfg_SRR_RR_LatPos_t
typedef uint16 SensorCfg_SRR_RR_LatPos_t;

#  define Rte_TypeDef_SensorCfg_SRR_RR_LongPos_t
typedef uint16 SensorCfg_SRR_RR_LongPos_t;

#  define Rte_TypeDef_SensorCfg_SRR_RR_Orientation_t
typedef sint8 SensorCfg_SRR_RR_Orientation_t;

#  define Rte_TypeDef_SensorCfg_SRR_RR_Pitch_t
typedef float32 SensorCfg_SRR_RR_Pitch_t;

#  define Rte_TypeDef_SensorCfg_SRR_RR_VertPos_t
typedef uint16 SensorCfg_SRR_RR_VertPos_t;

#  define Rte_TypeDef_SensorCfg_SRR_RR_Yaw_t
typedef float32 SensorCfg_SRR_RR_Yaw_t;

#  define Rte_TypeDef_TBOX2_360SpecView
typedef uint8 TBOX2_360SpecView;

#  define Rte_TypeDef_TBOX2_360viewReq
typedef uint8 TBOX2_360viewReq;

#  define Rte_TypeDef_TBOX2_AVMOnReq
typedef uint8 TBOX2_AVMOnReq;

#  define Rte_TypeDef_TBOX2_AVMviewReq
typedef uint8 TBOX2_AVMviewReq;

#  define Rte_TypeDef_TBOX2_Checksum
typedef uint8 TBOX2_Checksum;

#  define Rte_TypeDef_TBOX2_ConnectSts
typedef uint8 TBOX2_ConnectSts;

#  define Rte_TypeDef_TBOX2_GMOnreq
typedef uint8 TBOX2_GMOnreq;

#  define Rte_TypeDef_TBOX2_HPA_ONPath_ID
typedef uint8 TBOX2_HPA_ONPath_ID;

#  define Rte_TypeDef_TBOX2_HPA_PickPath_ID
typedef uint8 TBOX2_HPA_PickPath_ID;

#  define Rte_TypeDef_TBOX2_NNSSW
typedef uint8 TBOX2_NNSSW;

#  define Rte_TypeDef_TBOX2_NNSsuspend
typedef uint8 TBOX2_NNSsuspend;

#  define Rte_TypeDef_TBOX2_NRPReq
typedef uint8 TBOX2_NRPReq;

#  define Rte_TypeDef_TBOX2_PA_PauseRecover_Req
typedef uint8 TBOX2_PA_PauseRecover_Req;

#  define Rte_TypeDef_TBOX2_PhoneBatSts
typedef boolean TBOX2_PhoneBatSts;

#  define Rte_TypeDef_TBOX2_PhoneInCar
typedef uint8 TBOX2_PhoneInCar;

#  define Rte_TypeDef_TBOX2_RemoteCtrModSel
typedef uint8 TBOX2_RemoteCtrModSel;

#  define Rte_TypeDef_TBOX2_RemoteCtrSw
typedef boolean TBOX2_RemoteCtrSw;

#  define Rte_TypeDef_TBOX2_RemoteHPP
typedef boolean TBOX2_RemoteHPP;

#  define Rte_TypeDef_TBOX2_RemoteIntModSel
typedef uint8 TBOX2_RemoteIntModSel;

#  define Rte_TypeDef_TBOX2_RemoteParkAbortReq
typedef boolean TBOX2_RemoteParkAbortReq;

#  define Rte_TypeDef_TBOX2_RemoteParkOutModSel
typedef uint8 TBOX2_RemoteParkOutModSel;

#  define Rte_TypeDef_TBOX2_RemoteParkReq
typedef boolean TBOX2_RemoteParkReq;

#  define Rte_TypeDef_TBOX2_RemoteParkStartPressReq
typedef boolean TBOX2_RemoteParkStartPressReq;

#  define Rte_TypeDef_TBOX2_RemoteParkStartPressReqSts
typedef boolean TBOX2_RemoteParkStartPressReqSts;

#  define Rte_TypeDef_TBOX2_RemoteSw
typedef boolean TBOX2_RemoteSw;

#  define Rte_TypeDef_TBOX2_RemoteVhpower
typedef uint8 TBOX2_RemoteVhpower;

#  define Rte_TypeDef_TBOX2_Remotepick
typedef boolean TBOX2_Remotepick;

#  define Rte_TypeDef_TBOX2_RollingCounter
typedef uint8 TBOX2_RollingCounter;

#  define Rte_TypeDef_TBOX2_SDMapReq
typedef uint8 TBOX2_SDMapReq;

#  define Rte_TypeDef_TBOX2_SecuritySts
typedef uint8 TBOX2_SecuritySts;

#  define Rte_TypeDef_TimeDspFmt
typedef boolean TimeDspFmt;

#  define Rte_TypeDef_VCU14_ACC_Ready
typedef boolean VCU14_ACC_Ready;

#  define Rte_TypeDef_VCU14_ACC_Ready_t
typedef boolean VCU14_ACC_Ready_t;

#  define Rte_TypeDef_VCU14_Fr0E_Checksum
typedef uint8 VCU14_Fr0E_Checksum;

#  define Rte_TypeDef_VCU14_Fr0E_MsgCounter
typedef uint8 VCU14_Fr0E_MsgCounter;

#  define Rte_TypeDef_VCU14_Gear_ErrorSts_M01
typedef boolean VCU14_Gear_ErrorSts_M01;

#  define Rte_TypeDef_VCU14_Gear_PAActive
typedef uint8 VCU14_Gear_PAActive;

#  define Rte_TypeDef_VCU14_Gear_PAAvailable
typedef boolean VCU14_Gear_PAAvailable;

#  define Rte_TypeDef_VCU14_Gear_PACtrlAbortFeedback
typedef uint8 VCU14_Gear_PACtrlAbortFeedback;

#  define Rte_TypeDef_VCU14_PAActive
typedef boolean VCU14_PAActive;

#  define Rte_TypeDef_VCU14_PAAvailable
typedef boolean VCU14_PAAvailable;

#  define Rte_TypeDef_VCU14_PA_FailCode
typedef uint8 VCU14_PA_FailCode;

#  define Rte_TypeDef_VCU14_PA_ParkingFnMd
typedef uint8 VCU14_PA_ParkingFnMd;

#  define Rte_TypeDef_VCU3_EPBBackupCtrlActv
typedef boolean VCU3_EPBBackupCtrlActv;

#  define Rte_TypeDef_VCU3_EPBBackupCtrlSts
typedef uint8 VCU3_EPBBackupCtrlSts;

#  define Rte_TypeDef_VCU4_PA_DeceltorSts
typedef boolean VCU4_PA_DeceltorSts;

#  define Rte_TypeDef_VCU4_PA_TargetTrqValue
typedef uint16 VCU4_PA_TargetTrqValue;

#  define Rte_TypeDef_VCU4_PA_TargetTrqValueValidity
typedef boolean VCU4_PA_TargetTrqValueValidity;

#  define Rte_TypeDef_VCU5_AccelPosition
typedef uint8 VCU5_AccelPosition;

#  define Rte_TypeDef_VCU5_AccelPositionValid
typedef boolean VCU5_AccelPositionValid;

#  define Rte_TypeDef_VCU5_AccelPositionValid_t
typedef boolean VCU5_AccelPositionValid_t;

#  define Rte_TypeDef_VCU5_AccelPosition_t
typedef uint8 VCU5_AccelPosition_t;

#  define Rte_TypeDef_VCU5_ActGear
typedef uint8 VCU5_ActGear;

#  define Rte_TypeDef_VCU5_ActGearValid
typedef boolean VCU5_ActGearValid;

#  define Rte_TypeDef_VCU5_ActGearValid_t
typedef boolean VCU5_ActGearValid_t;

#  define Rte_TypeDef_VCU5_ActGear_t
typedef uint8 VCU5_ActGear_t;

#  define Rte_TypeDef_VCU5_AliveCounter
typedef uint8 VCU5_AliveCounter;

#  define Rte_TypeDef_VCU5_Checksum
typedef uint8 VCU5_Checksum;

#  define Rte_TypeDef_VCU5_DriveMode_fb
typedef uint8 VCU5_DriveMode_fb;

#  define Rte_TypeDef_VCU5_DriveMode_fb_t
typedef uint8 VCU5_DriveMode_fb_t;

#  define Rte_TypeDef_VCU5_DriverOvertakeMode
typedef boolean VCU5_DriverOvertakeMode;

#  define Rte_TypeDef_VCU5_DriverOvertakeMode_t
typedef boolean VCU5_DriverOvertakeMode_t;

#  define Rte_TypeDef_VCU5_EmuEngineSts
typedef boolean VCU5_EmuEngineSts;

#  define Rte_TypeDef_VCU5_HVReady
typedef boolean VCU5_HVReady;

#  define Rte_TypeDef_VCU5_PwrTrainFailureLevel
typedef uint8 VCU5_PwrTrainFailureLevel;

#  define Rte_TypeDef_VCU5_READYLightSts
typedef boolean VCU5_READYLightSts;

#  define Rte_TypeDef_VCU6_StrtgyGear
typedef uint8 VCU6_StrtgyGear;

#  define Rte_TypeDef_VCU6_SystemWarnLightSts
typedef boolean VCU6_SystemWarnLightSts;

#  define Rte_TypeDef_VCU7_MaxFMotGenTq
typedef uint16 VCU7_MaxFMotGenTq;

#  define Rte_TypeDef_VCU7_MaxFMotPosTq
typedef uint16 VCU7_MaxFMotPosTq;

#  define Rte_TypeDef_VCU7_MaxMotGenTq
typedef uint16 VCU7_MaxMotGenTq;

#  define Rte_TypeDef_VCU7_MaxMotPosTq
typedef uint16 VCU7_MaxMotPosTq;

#  define Rte_TypeDef_Veh_CAN_DAY_NIGHT_STATUS_F_t
typedef boolean Veh_CAN_DAY_NIGHT_STATUS_F_t;

#  define Rte_TypeDef_Veh_CAN_DAY_NIGHT_STATUS_R_t
typedef boolean Veh_CAN_DAY_NIGHT_STATUS_R_t;

#  define Rte_TypeDef_Veh_CAN_DAY_NIGHT_STATUS_t
typedef boolean Veh_CAN_DAY_NIGHT_STATUS_t;

#  define Rte_TypeDef_Veh_CAN_PSA_F_t
typedef boolean Veh_CAN_PSA_F_t;

#  define Rte_TypeDef_Veh_CAN_PSA_R_t
typedef boolean Veh_CAN_PSA_R_t;

#  define Rte_TypeDef_Veh_CAN_PSA_t
typedef boolean Veh_CAN_PSA_t;

#  define Rte_TypeDef_Veh_CAN_STEERING_ANGLE_F_t
typedef float32 Veh_CAN_STEERING_ANGLE_F_t;

#  define Rte_TypeDef_Veh_CAN_STEERING_ANGLE_R_t
typedef float32 Veh_CAN_STEERING_ANGLE_R_t;

#  define Rte_TypeDef_Veh_CAN_STEERING_ANGLE_SIGN_F_t
typedef boolean Veh_CAN_STEERING_ANGLE_SIGN_F_t;

#  define Rte_TypeDef_Veh_CAN_STEERING_ANGLE_SIGN_R_t
typedef boolean Veh_CAN_STEERING_ANGLE_SIGN_R_t;

#  define Rte_TypeDef_Veh_CAN_STEERING_ANGLE_SIGN_t
typedef boolean Veh_CAN_STEERING_ANGLE_SIGN_t;

#  define Rte_TypeDef_Veh_CAN_STEERING_ANGLE_t
typedef float32 Veh_CAN_STEERING_ANGLE_t;

#  define Rte_TypeDef_Veh_CAN_SYSPOWERMODE_VALIDITY_F_t
typedef boolean Veh_CAN_SYSPOWERMODE_VALIDITY_F_t;

#  define Rte_TypeDef_Veh_CAN_SYSPOWERMODE_VALIDITY_R_t
typedef boolean Veh_CAN_SYSPOWERMODE_VALIDITY_R_t;

#  define Rte_TypeDef_Veh_CAN_SYS_POWER_MODE_F_t
typedef uint8 Veh_CAN_SYS_POWER_MODE_F_t;

#  define Rte_TypeDef_Veh_CAN_SYS_POWER_MODE_R_t
typedef uint8 Veh_CAN_SYS_POWER_MODE_R_t;

#  define Rte_TypeDef_Veh_CAN_SYS_POWER_MODE_VALIDITY_t
typedef boolean Veh_CAN_SYS_POWER_MODE_VALIDITY_t;

#  define Rte_TypeDef_Veh_CAN_SYS_POWER_MODE_t
typedef uint8 Veh_CAN_SYS_POWER_MODE_t;

#  define Rte_TypeDef_Veh_CAN_VEHICLE_MODE_F_t
typedef uint8 Veh_CAN_VEHICLE_MODE_F_t;

#  define Rte_TypeDef_Veh_CAN_VEHICLE_MODE_R_t
typedef uint8 Veh_CAN_VEHICLE_MODE_R_t;

#  define Rte_TypeDef_Veh_CAN_VEHICLE_MODE_t
typedef uint8 Veh_CAN_VEHICLE_MODE_t;

#  define Rte_TypeDef_Veh_CAN_VEHICLE_SPEED_DIRECTION_t
typedef boolean Veh_CAN_VEHICLE_SPEED_DIRECTION_t;

#  define Rte_TypeDef_Veh_CAN_VEHICLE_SPEED_F_t
typedef float32 Veh_CAN_VEHICLE_SPEED_F_t;

#  define Rte_TypeDef_Veh_CAN_VEHICLE_SPEED_R_t
typedef float32 Veh_CAN_VEHICLE_SPEED_R_t;

#  define Rte_TypeDef_Veh_CAN_VEHICLE_SPEED_VALIDITY_F_t
typedef boolean Veh_CAN_VEHICLE_SPEED_VALIDITY_F_t;

#  define Rte_TypeDef_Veh_CAN_VEHICLE_SPEED_VALIDITY_R_t
typedef boolean Veh_CAN_VEHICLE_SPEED_VALIDITY_R_t;

#  define Rte_TypeDef_Veh_CAN_VEHICLE_SPEED_VALIDITY_t
typedef boolean Veh_CAN_VEHICLE_SPEED_VALIDITY_t;

#  define Rte_TypeDef_Veh_CAN_VEHICLE_SPEED_t
typedef float32 Veh_CAN_VEHICLE_SPEED_t;

#  define Rte_TypeDef_Veh_CAN_VEHICLE_STAT_F_t
typedef boolean Veh_CAN_VEHICLE_STAT_F_t;

#  define Rte_TypeDef_Veh_CAN_VEHICLE_STAT_R_t
typedef boolean Veh_CAN_VEHICLE_STAT_R_t;

#  define Rte_TypeDef_Veh_CAN_VEHICLE_STAT_t
typedef boolean Veh_CAN_VEHICLE_STAT_t;

#  define Rte_TypeDef_Veh_CAN_VEH_DRV_DIRECTION_F_t
typedef boolean Veh_CAN_VEH_DRV_DIRECTION_F_t;

#  define Rte_TypeDef_Veh_CAN_VEH_DRV_DIRECTION_R_t
typedef boolean Veh_CAN_VEH_DRV_DIRECTION_R_t;

#  define Rte_TypeDef_Veh_CAN_VEH_DRV_DIRECTION_t
typedef boolean Veh_CAN_VEH_DRV_DIRECTION_t;

#  define Rte_TypeDef_Veh_CAN_VEH_SPEED_DIRECTION_F_t
typedef boolean Veh_CAN_VEH_SPEED_DIRECTION_F_t;

#  define Rte_TypeDef_Veh_CAN_VEH_SPEED_DIRECTION_R_t
typedef boolean Veh_CAN_VEH_SPEED_DIRECTION_R_t;

#  define Rte_TypeDef_Veh_CAN_WIPER_STATUS_F_t
typedef boolean Veh_CAN_WIPER_STATUS_F_t;

#  define Rte_TypeDef_Veh_CAN_WIPER_STATUS_R_t
typedef boolean Veh_CAN_WIPER_STATUS_R_t;

#  define Rte_TypeDef_Veh_CAN_WIPER_STATUS_t
typedef boolean Veh_CAN_WIPER_STATUS_t;

#  define Rte_TypeDef_Veh_CAN_YAW_RATE_F_t
typedef float32 Veh_CAN_YAW_RATE_F_t;

#  define Rte_TypeDef_Veh_CAN_YAW_RATE_R_t
typedef float32 Veh_CAN_YAW_RATE_R_t;

#  define Rte_TypeDef_Veh_CAN_YAW_RATE_VALIDITY_F_t
typedef boolean Veh_CAN_YAW_RATE_VALIDITY_F_t;

#  define Rte_TypeDef_Veh_CAN_YAW_RATE_VALIDITY_R_t
typedef boolean Veh_CAN_YAW_RATE_VALIDITY_R_t;

#  define Rte_TypeDef_Veh_CAN_YAW_RATE_VALIDITY_t
typedef boolean Veh_CAN_YAW_RATE_VALIDITY_t;

#  define Rte_TypeDef_Veh_CAN_YAW_RATE_t
typedef float32 Veh_CAN_YAW_RATE_t;

#  define Rte_TypeDef_Veh_SYS_STATUS_CRC_F_t
typedef uint8 Veh_SYS_STATUS_CRC_F_t;

#  define Rte_TypeDef_Veh_SYS_STATUS_CRC_R_t
typedef uint8 Veh_SYS_STATUS_CRC_R_t;

#  define Rte_TypeDef_Veh_SYS_STATUS_CRC_t
typedef uint8 Veh_SYS_STATUS_CRC_t;

#  define Rte_TypeDef_Veh_SYS_STATUS_MC_F_t
typedef uint8 Veh_SYS_STATUS_MC_F_t;

#  define Rte_TypeDef_Veh_SYS_STATUS_MC_R_t
typedef uint8 Veh_SYS_STATUS_MC_R_t;

#  define Rte_TypeDef_Veh_SYS_STATUS_MC_t
typedef uint8 Veh_SYS_STATUS_MC_t;

#  define Rte_TypeDef_WdgM_CheckpointIdType
typedef uint16 WdgM_CheckpointIdType;

#  define Rte_TypeDef_WdgM_GlobalStatusType
typedef uint8 WdgM_GlobalStatusType;

#  define Rte_TypeDef_WdgM_LocalStatusType
typedef uint8 WdgM_LocalStatusType;

#  define Rte_TypeDef_WdgM_ModeType
typedef uint8 WdgM_ModeType;

#  define Rte_TypeDef_WdgM_SupervisedEntityIdType
typedef uint16 WdgM_SupervisedEntityIdType;

#  define Rte_TypeDef_dtRef_VOID
typedef void * dtRef_VOID;

#  define Rte_TypeDef_dtRef_const_VOID
typedef const void * dtRef_const_VOID;

#  define Rte_TypeDef_DataArrayType_uint8_25
typedef uint8 DataArrayType_uint8_25[25];

#  define Rte_TypeDef_DataArrayType_uint8_3
typedef uint8 DataArrayType_uint8_3[3];

#  define Rte_TypeDef_Idt_BcsIntDid_T
typedef Rte_DT_Idt_BcsIntDid_T_0 Idt_BcsIntDid_T[5];

#  define Rte_TypeDef_Idt_EcuInstallDate_T
typedef Rte_DT_Idt_EcuInstallDate_T_0 Idt_EcuInstallDate_T[4];

#  define Rte_TypeDef_Idt_EcuManuDate_T
typedef Rte_DT_Idt_EcuManuDate_T_0 Idt_EcuManuDate_T[4];

#  define Rte_TypeDef_Idt_EcuSerialNum_T
typedef Rte_DT_Idt_EcuSerialNum_T_0 Idt_EcuSerialNum_T[18];

#  define Rte_TypeDef_Idt_FETMode_T
typedef boolean Idt_FETMode_T[10];

#  define Rte_TypeDef_Idt_FETShort_Cnt_T
typedef uint16 Idt_FETShort_Cnt_T[10];

#  define Rte_TypeDef_Idt_PdcModSwtSt_T
typedef Rte_DT_Idt_PdcModSwtSt_T_0 Idt_PdcModSwtSt_T[2];

#  define Rte_TypeDef_Idt_VIN_T
typedef Rte_DT_Idt_VIN_T_0 Idt_VIN_T[17];

#  define Rte_TypeDef_Idt_VechileCfg_T
typedef Rte_DT_Idt_VechileCfg_T_0 Idt_VechileCfg_T[58];

#  define Rte_TypeDef_Rte_DT_Idt_FBL_or_APP_EE_0
typedef Rte_DT_Idt_FBL_or_APP_EE_0_0 Rte_DT_Idt_FBL_or_APP_EE_0[4];

#  define Rte_TypeDef_Rte_DT_Idt_FBL_or_APP_EE_1
typedef Rte_DT_Idt_FBL_or_APP_EE_1_0 Rte_DT_Idt_FBL_or_APP_EE_1[10];

#  define Rte_TypeDef_Rte_DT_Idt_FBL_or_APP_EE_2
typedef Rte_DT_Idt_FBL_or_APP_EE_2_0 Rte_DT_Idt_FBL_or_APP_EE_2[2];

#  define Rte_TypeDef_Rte_DT_Idt_FBL_or_APP_EE_3
typedef Rte_DT_Idt_FBL_or_APP_EE_3_0 Rte_DT_Idt_FBL_or_APP_EE_3[496];

#  define Rte_TypeDef_Rte_DT_Idt_Os_ExceptionContextType_Tag_0
typedef uint32 Rte_DT_Idt_Os_ExceptionContextType_Tag_0[16];

#  define Rte_TypeDef_Rte_DT_Idt_Os_ExceptionContextType_Tag_1
typedef uint32 Rte_DT_Idt_Os_ExceptionContextType_Tag_1[16];

#  define Rte_TypeDef_Rte_DT_Idt_UserTrap_ExceptionAddress_0
typedef uint32 Rte_DT_Idt_UserTrap_ExceptionAddress_0[32];

#  define Rte_TypeDef_Rte_array_Pept_HB_LANE_Type_Unsed_t
typedef uint8 Rte_array_Pept_HB_LANE_Type_Unsed_t[4];

#  define Rte_TypeDef_Rte_array_Pept_Hb_Obstacle_Type_Unsed_t
typedef uint8 Rte_array_Pept_Hb_Obstacle_Type_Unsed_t[4];

#  define Rte_TypeDef_Rte_array_Pept_Hb_Sync_Type_Unsed_t
typedef uint8 Rte_array_Pept_Hb_Sync_Type_Unsed_t[4];

#  define Rte_TypeDef_Idt_BswErrorType
typedef struct
{
  uint16 ModuleId;
  uint8 ErrorId;
} Idt_BswErrorType;

#  define Rte_TypeDef_Idt_DetErrorInformationType
typedef struct
{
  uint16 ModuleId;
  uint8 InstanceId;
  uint8 ApiId;
  uint8 ErrorId;
} Idt_DetErrorInformationType;

#  define Rte_TypeDef_Idt_ExtendInformType
typedef struct
{
  uint32 errorhook_taskid;
  uint32 errorhook_isr_id;
  uint32 errorhook_trusted_function_index;
  uint32 errorhook_alarm;
  uint32 errorhook_resource;
  uint32 errorhook_application;
  uint32 errorhook_eventmask;
} Idt_ExtendInformType;

#  define Rte_TypeDef_Idt_HardwareFaultType
typedef struct
{
  uint32 ExceptionSource;
  uint32 ReturnAddress;
  uint32 ErrorAddress;
  uint32 DSTR;
  uint32 DATR;
  uint32 PSTR;
} Idt_HardwareFaultType;

#  define Rte_TypeDef_Idt_Os_ErrorInformationType
typedef struct
{
  uint8 Service;
  uint8 Error;
  uint16 DetailedError;
} Idt_Os_ErrorInformationType;

#  define Rte_TypeDef_Idt_Reset_Counter_and_Reason
typedef struct
{
  Rte_DT_Idt_Reset_Counter_and_Reason_0 System_Reset_Counter;
  Rte_DT_Idt_Reset_Counter_and_Reason_1 Hardware_Reset_Reason;
  Rte_DT_Idt_Reset_Counter_and_Reason_2 Software_Reset_Reason;
  Rte_DT_Idt_Reset_Counter_and_Reason_3 EyeQ_Reset_Reason;
} Idt_Reset_Counter_and_Reason;

#  define Rte_TypeDef_Idt_SMU_Faults_T
typedef struct
{
  uint8 Alarm_Group_Number;
  uint8 Alarm_Number;
  uint8 Error_Counter;
  uint32 ECC_Address_Code;
  uint32 ECC_Data_Code;
  uint16 RAM_MISC;
  Rte_DT_Idt_SMU_Faults_T_6 Cfast;
} Idt_SMU_Faults_T;

#  define Rte_TypeDef_Idt_WdtErrorType
typedef struct
{
  uint16 EntityId;
  uint8 Status;
} Idt_WdtErrorType;

#  define Rte_TypeDef_LKA_Cone_Road_Edge_A_Type
typedef struct
{
  uint32 ConeRoadEdgeTrackID;
  uint32 ConeRoadEdgeConfidence;
  uint32 ConeRoadEdgeMeasuringStatus;
  uint32 ConeRoadEdgeTypeClass;
  uint32 ConeRoadEdgeQuality;
  uint32 ConeRoadEdgeViewRangeStart;
  uint32 ConeRoadEdgeParsingConfidence;
} LKA_Cone_Road_Edge_A_Type;

#  define Rte_TypeDef_LKA_Cone_Road_Edge_B_Type
typedef struct
{
  uint32 ConeRoadEdgeViewRangeEnd;
  uint32 ConeRoadEdgeModelC0;
  float32 ConeRoadEdgeModelC1;
} LKA_Cone_Road_Edge_B_Type;

#  define Rte_TypeDef_LKA_Cone_Road_Edge_C_Type
typedef struct
{
  float32 ConeRoadEdgeModelC2;
  float32 ConeRoadEdgeModelC3;
} LKA_Cone_Road_Edge_C_Type;

#  define Rte_TypeDef_LKA_Lane_A_Type
typedef struct
{
  uint32 LaneTrackID;
  uint32 laneConfidence;
  uint32 LaneMeasuringStatus;
  uint32 LaneTypeClass;
  uint32 LaneMarkColor;
  uint32 LaneQuality;
  uint32 LaneCrossing;
  uint32 LaneWidthMarking;
} LKA_Lane_A_Type;

#  define Rte_TypeDef_LKA_Lane_B_Type
typedef struct
{
  uint32 LaneViewRangeStart;
  uint32 LaneViewRangeEnd;
  sint16 LaneModelC0;
  uint16 LaneTLC;
  uint32 unused;
} LKA_Lane_B_Type;

#  define Rte_TypeDef_LKA_Lane_C_Type
typedef struct
{
  float32 LaneModelC1;
  float32 LaneModelC2;
} LKA_Lane_C_Type;

#  define Rte_TypeDef_LKA_Lane_D_Type
typedef struct
{
  float32 LaneModelC3;
  uint32 ObstacleFlag;
  uint32 LaneExtraNearPointType;
  uint32 LaneExtraFarPointType;
  uint32 Stopline_Relevancy;
  uint32 LaneExtraFarPointPosX;
} LKA_Lane_D_Type;

#  define Rte_TypeDef_LKA_Lane_E_Type
typedef struct
{
  uint32 LaneExtraFarPointPosY;
  uint32 LaneExtraNearPointPosX;
  sint16 LaneExtraNearPointPosY;
  uint32 LaneParsingConfidence;
  uint32 LineRmse;
} LKA_Lane_E_Type;

#  define Rte_TypeDef_LKA_Road_Edge_A_Type
typedef struct
{
  uint32 RoadEdgeTrackID;
  uint32 RoadEdgeConfidence;
  uint32 RoadEdgeMeasuringStatus;
  uint32 RoadEdgeTypeClass;
  uint32 RoadEdgeQuality;
  uint32 RoadEdgeViewRangeStart;
  uint32 RoadEdgeParsingConfidence;
} LKA_Road_Edge_A_Type;

#  define Rte_TypeDef_LKA_Road_Edge_B_Type
typedef struct
{
  uint32 RoadEdgeViewRangeEnd;
  uint32 RoadEdgeModelC0;
  float32 RoadEdgeModelC1;
} LKA_Road_Edge_B_Type;

#  define Rte_TypeDef_LKA_Road_Edge_C_Type
typedef struct
{
  float32 RoadEdgeModelC2;
  float32 RoadEdgeModelC3;
} LKA_Road_Edge_C_Type;

#  define Rte_TypeDef_LaneCRC_Type
typedef struct
{
  uint32 RollingCounter_Lane;
  uint32 reserved_0;
  uint32 CRCChecksum_Lane;
} LaneCRC_Type;

#  define Rte_TypeDef_Lane_Road_Information_Type
typedef struct
{
  uint32 RoadType;
  uint32 HostEstimatedWidth;
  uint32 CurrentWeather;
  uint32 CurrentTime;
  uint32 LightType;
  sint16 DisStopline;
  uint32 DisStoplineValid;
  uint32 ProtocolMajorVersion;
  uint32 ProtocolMinorVersion;
} Lane_Road_Information_Type;

#  define Rte_TypeDef_NOP_OutControlResult_t
typedef struct
{
  float32 fFrontWheelAngReq_rad;
  float32 fAccelerationReq_mpss;
  boolean bFrontWheelAngReq_nu;
  boolean bAccelerationReq_nu;
} NOP_OutControlResult_t;

#  define Rte_TypeDef_NOP_OutFuncDegradation_t
typedef struct
{
  uint8 uiP2NStateReminder_nu;
} NOP_OutFuncDegradation_t;

#  define Rte_TypeDef_NOP_OutNeedNvRamWrite_t
typedef struct
{
  boolean bDrivingModeNvRamWrite;
  boolean bVoiceModeNvRamWrite;
  boolean bAutoOnOffSetNvRamWrite;
  boolean bStateNvRamWrite;
  boolean bOnOffAudioPlayNvRamWrite;
  boolean bVoiceNotifFrequencyModeNvRamWrite;
  boolean bHeadWayNvRamWrite;
  boolean bALCModeNvRAMWrite;
  boolean bNOPOnOFFSetNvRAMWrite;
} NOP_OutNeedNvRamWrite_t;

#  define Rte_TypeDef_NOP_OutSystemState_t
typedef struct
{
  uint8 uiSysState_nu;
} NOP_OutSystemState_t;

#  define Rte_TypeDef_NOP_OutVehicleState_t
typedef struct
{
  uint8 enumGearPos_nu;
  boolean bParkBrake_nu;
  uint8 uiALCMode_nu;
  uint8 uiVoiceMode_nu;
  uint8 uiState_nu;
  uint8 uiNNPScenarios_nu;
  uint8 uiNNPScenariosAudioPlay_nu;
  uint8 uiNNPRINO_nu;
  uint8 uiOnOffAudioPlay_nu;
  uint8 uiAutoOnOffSet_nu;
  uint8 uiSndState_nu;
  uint8 uiVoiceNotifFrequencyMode_nu;
  uint8 uiCancelAudioPlay_nu;
  uint8 uiStateReminder_nu;
  uint8 uiMRMStatus_nu;
  uint8 uiMRMAudioPlay_nu;
  uint8 uiOverrideState_nu;
  uint8 uiResumeAudioPlay_nu;
  uint8 uiLCSndRequest_nu;
  uint8 uiTrafficState_nu;
  uint8 uiSpeedAdaptConfirm_nu;
  uint8 uiOSAStatus_nu;
  uint8 uiOSAAudioPlay_nu;
  uint8 uiLightRemind_nu;
  uint8 uiPayModeConfirmReq_nu;
  uint8 uiPayModeConfirm_nu;
  uint8 uiLaneChangeInfor_nu;
  uint8 uiLaneChangeDirction_nu;
  uint8 uiLaneChangeAudioPlay_nu;
  uint8 uiLaneChangePendingAlert_nu;
  uint8 uiDrivingMode_nu;
  uint8 uiHandsOffWarning_nu;
  uint8 uiOverTakeConfirm_nu;
  boolean bVehicleHornReq;
  boolean bStolenAlarmWarnReq;
  boolean bHighBeamReq;
  boolean bLowBeamReq;
  uint8 uiLightRequest;
  uint8 uiCruiseSpeedAddFeedbcak_nu;
  uint8 uiCruiseSpeedMinusFeedback_nu;
  uint8 uiCruiseDistanceAddFeedback_nu;
  uint8 uiCruiseDistanceMinusFeedback_nu;
  uint16 uiLongitudeCtrlSetSpeed_kph;
  uint8 uiCurrentHeadwaySetting_nu;
  uint8 uiEyeOffBroadcast_nu;
} NOP_OutVehicleState_t;

#  define Rte_TypeDef_ObstacleDataA_Type
typedef struct
{
  uint8 ObstacleID;
  float32 ObstacleValid;
  uint8 ObstacleReplaced;
  uint16 ObstacleAge;
  uint8 ObstacleConfidence;
  uint8 ObstacleMotionCategory;
  uint8 ObstacleMotionStatus;
  uint8 ObstacleMeasuringStatus;
  uint8 ObstacleClass;
  uint8 VehicleSubType;
  uint8 PedSubType;
} ObstacleDataA_Type;

#  define Rte_TypeDef_ObstacleDataB_Type
typedef struct
{
  uint32 PedPos;
  uint32 PedOrientation;
  uint32 ObstacleLaneAssignment;
  uint32 ObstacleOccluded;
  uint16 ObstacleLength;
  uint16 ObstacleWidth;
} ObstacleDataB_Type;

#  define Rte_TypeDef_ObstacleDataC_Type
typedef struct
{
  uint16 ObstacleHeight;
  uint32 CIPVFlag;
  uint32 MCPFlag;
  uint32 ObstacleBlinkerInfo;
  uint32 ObstacleBrakeLights;
  float32 ObstacleCenterAngle;
} ObstacleDataC_Type;

#  define Rte_TypeDef_ObstacleDataD_Type
typedef struct
{
  uint32 ObstaclePositionType;
  uint32 ObstacleHeadreartype;
  uint32 Obstacle_TTC;
  float32 ObstaclePosX;
} ObstacleDataD_Type;

#  define Rte_TypeDef_ObstacleDataE_Type
typedef struct
{
  float32 ObstaclePosY;
  float32 ObstacleVelX;
} ObstacleDataE_Type;

#  define Rte_TypeDef_ObstacleDataF_Type
typedef struct
{
  float32 ObstacleVelY;
  float32 ObstacleAccX;
} ObstacleDataF_Type;

#  define Rte_TypeDef_ObstacleDataG_Type
typedef struct
{
  float32 ObstaclePosXSTD;
  float32 ObstaclePosYSTD;
} ObstacleDataG_Type;

#  define Rte_TypeDef_ObstacleDataH_Type
typedef struct
{
  float32 ObstacleVelXSTD;
  float32 ObstacleVelYSTD;
} ObstacleDataH_Type;

#  define Rte_TypeDef_ObstacleDataI_Type
typedef struct
{
  float32 ObstacleAccY;
  float32 ObstacleAngle;
} ObstacleDataI_Type;

#  define Rte_TypeDef_ObstacleDataJ_Type
typedef struct
{
  float32 ObstacleAngleStd;
  float32 ObstacleVelXAbs;
} ObstacleDataJ_Type;

#  define Rte_TypeDef_ObstacleDataK_Type
typedef struct
{
  float32 ObstacleVelYAbs;
  uint32 RollingCounter_Obstacle;
  uint32 Checksum_Obstacle;
  uint32 CrossingGhost;
} ObstacleDataK_Type;

#  define Rte_TypeDef_ObstacleDataL_Type
typedef struct
{
  float32 ObjCornerPointPoxX;
  float32 CutInDistance;
} ObstacleDataL_Type;

#  define Rte_TypeDef_ObstacleDataM_Type
typedef struct
{
  float32 ObjCornerPointPoxY;
  float32 ObstacleCurvatureRadius;
} ObstacleDataM_Type;

#  define Rte_TypeDef_ObstacleDataN_Type
typedef struct
{
  uint32 ObstacleTrackingConfidence;
  uint32 CutInFlag;
  uint8 CutInLane;
  uint32 LeftDoor;
  uint32 RightDoor;
  uint32 TrunkDoor;
  float32 CutinSpeed;
} ObstacleDataN_Type;

#  define Rte_TypeDef_ObstacleDataO_Type
typedef struct
{
  float32 ObstacleAccRefX;
  float32 ObstacleAccRefY;
} ObstacleDataO_Type;

#  define Rte_TypeDef_ObstacleDataP_Type
typedef struct
{
  uint16 Img2dBox_Left;
  uint16 Img2dBox_Top;
  uint16 Img2dBox_Right;
  uint16 Img2dBox_Button;
} ObstacleDataP_Type;

#  define Rte_TypeDef_ObstacleHeader1_Type
typedef struct
{
  uint32 ProtocolMajorVersion;
  uint32 ProtocolMinorVersion;
  uint32 NumObstacles;
  uint32 ID_CIPV;
  uint32 ID_MCP;
  uint32 CIPV_TTC;
  uint32 MCP_TTC;
} ObstacleHeader1_Type;

#  define Rte_TypeDef_ObstacleHeader2_Type
typedef struct
{
  uint32 MCP_TTC_Valid;
  uint32 CIPV_TTC_Valid;
  uint32 CIPV_HWM_Valid;
  uint32 CIPV_HWM;
} ObstacleHeader2_Type;

#  define Rte_TypeDef_ObstacleInternalID_Type
typedef struct
{
  uint32 Obstacle_Internal_ID;
  uint32 CutinSpeedValid;
  uint32 ObsProNotOnRoadValid;
  uint32 ObsProCoverdByOthersValid;
  uint32 ObsProObserveJumpValid;
  uint32 ObsProObserveSideValid;
  uint32 ObsProBtTapLevel1Valid;
  uint32 ObsProBtTapLevel2Valid;
  uint32 ObsProBtTapLevel3Valid;
} ObstacleInternalID_Type;

#  define Rte_TypeDef_ObstacleTypeInfo
typedef struct
{
  uint16 type;
  uint16 sub_type;
} ObstacleTypeInfo;

#  define Rte_TypeDef_Pept_Hb_ObstacleCRC_Type
typedef struct
{
  uint32 RollingCounter_Obstacle;
  uint32 reserved_4;
  uint32 CRCChecksum_Obstacle;
} Pept_Hb_ObstacleCRC_Type;

#  define Rte_TypeDef_REG_SenSignalHeader_t
typedef struct
{
  uint32 uiTimeStamp;
  uint16 uiMeasurementCounter;
  uint16 uiCycleCounter;
  uint8 eSigStatus;
} REG_SenSignalHeader_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_001_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_01;
  float32 LRR_CAN_AVD_DET_AZIMUTH_01;
  Rte_DT_SG_LRR_AVD_Detection_001_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_01;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_01;
  float32 LRR_CAN_AVD_DET_ELEVATION_01;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_01;
  boolean LRR_CAN_AVD_DET_Near_TARGET_01;
  float32 LRR_CAN_AVD_DET_RANGE_01;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_01;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_01;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_01;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_01;
} SG_LRR_AVD_Detection_001_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_002_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_02;
  float32 LRR_CAN_AVD_DET_AZIMUTH_02;
  Rte_DT_SG_LRR_AVD_Detection_002_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_02;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_02;
  float32 LRR_CAN_AVD_DET_ELEVATION_02;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_02;
  boolean LRR_CAN_AVD_DET_Near_TARGET_02;
  float32 LRR_CAN_AVD_DET_RANGE_02;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_02;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_02;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_02;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_02;
} SG_LRR_AVD_Detection_002_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_003_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_03;
  float32 LRR_CAN_AVD_DET_AZIMUTH_03;
  Rte_DT_SG_LRR_AVD_Detection_003_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_03;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_03;
  float32 LRR_CAN_AVD_DET_ELEVATION_03;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_03;
  boolean LRR_CAN_AVD_DET_Near_TARGET_03;
  float32 LRR_CAN_AVD_DET_RANGE_03;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_03;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_03;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_03;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_03;
} SG_LRR_AVD_Detection_003_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_004_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_04;
  float32 LRR_CAN_AVD_DET_AZIMUTH_04;
  Rte_DT_SG_LRR_AVD_Detection_004_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_04;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_04;
  float32 LRR_CAN_AVD_DET_ELEVATION_04;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_04;
  boolean LRR_CAN_AVD_DET_Near_TARGET_04;
  float32 LRR_CAN_AVD_DET_RANGE_04;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_04;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_04;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_04;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_04;
} SG_LRR_AVD_Detection_004_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_005_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_05;
  float32 LRR_CAN_AVD_DET_AZIMUTH_05;
  Rte_DT_SG_LRR_AVD_Detection_005_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_05;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_05;
  float32 LRR_CAN_AVD_DET_ELEVATION_05;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_05;
  boolean LRR_CAN_AVD_DET_Near_TARGET_05;
  float32 LRR_CAN_AVD_DET_RANGE_05;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_05;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_05;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_05;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_05;
} SG_LRR_AVD_Detection_005_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_006_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_06;
  float32 LRR_CAN_AVD_DET_AZIMUTH_06;
  Rte_DT_SG_LRR_AVD_Detection_006_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_06;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_06;
  float32 LRR_CAN_AVD_DET_ELEVATION_06;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_06;
  boolean LRR_CAN_AVD_DET_Near_TARGET_06;
  float32 LRR_CAN_AVD_DET_RANGE_06;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_06;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_06;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_06;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_06;
} SG_LRR_AVD_Detection_006_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_007_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_07;
  float32 LRR_CAN_AVD_DET_AZIMUTH_07;
  Rte_DT_SG_LRR_AVD_Detection_007_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_07;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_07;
  float32 LRR_CAN_AVD_DET_ELEVATION_07;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_07;
  boolean LRR_CAN_AVD_DET_Near_TARGET_07;
  float32 LRR_CAN_AVD_DET_RANGE_07;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_07;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_07;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_07;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_07;
} SG_LRR_AVD_Detection_007_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_008_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_08;
  float32 LRR_CAN_AVD_DET_AZIMUTH_08;
  Rte_DT_SG_LRR_AVD_Detection_008_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_08;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_08;
  float32 LRR_CAN_AVD_DET_ELEVATION_08;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_08;
  boolean LRR_CAN_AVD_DET_Near_TARGET_08;
  float32 LRR_CAN_AVD_DET_RANGE_08;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_08;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_08;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_08;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_08;
} SG_LRR_AVD_Detection_008_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_009_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_09;
  float32 LRR_CAN_AVD_DET_AZIMUTH_09;
  Rte_DT_SG_LRR_AVD_Detection_009_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_09;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_09;
  float32 LRR_CAN_AVD_DET_ELEVATION_09;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_09;
  boolean LRR_CAN_AVD_DET_Near_TARGET_09;
  float32 LRR_CAN_AVD_DET_RANGE_09;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_09;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_09;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_09;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_09;
} SG_LRR_AVD_Detection_009_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_010_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_10;
  float32 LRR_CAN_AVD_DET_AZIMUTH_10;
  Rte_DT_SG_LRR_AVD_Detection_010_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_10;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_10;
  float32 LRR_CAN_AVD_DET_ELEVATION_10;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_10;
  boolean LRR_CAN_AVD_DET_Near_TARGET_10;
  float32 LRR_CAN_AVD_DET_RANGE_10;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_10;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_10;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_10;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_10;
} SG_LRR_AVD_Detection_010_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_011_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_11;
  float32 LRR_CAN_AVD_DET_AZIMUTH_11;
  Rte_DT_SG_LRR_AVD_Detection_011_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_11;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_11;
  float32 LRR_CAN_AVD_DET_ELEVATION_11;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_11;
  boolean LRR_CAN_AVD_DET_Near_TARGET_11;
  float32 LRR_CAN_AVD_DET_RANGE_11;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_11;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_11;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_11;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_11;
} SG_LRR_AVD_Detection_011_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_012_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_12;
  float32 LRR_CAN_AVD_DET_AZIMUTH_12;
  Rte_DT_SG_LRR_AVD_Detection_012_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_12;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_12;
  float32 LRR_CAN_AVD_DET_ELEVATION_12;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_12;
  boolean LRR_CAN_AVD_DET_Near_TARGET_12;
  float32 LRR_CAN_AVD_DET_RANGE_12;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_12;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_12;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_12;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_12;
} SG_LRR_AVD_Detection_012_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_013_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_13;
  float32 LRR_CAN_AVD_DET_AZIMUTH_13;
  Rte_DT_SG_LRR_AVD_Detection_013_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_13;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_13;
  float32 LRR_CAN_AVD_DET_ELEVATION_13;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_13;
  boolean LRR_CAN_AVD_DET_Near_TARGET_13;
  float32 LRR_CAN_AVD_DET_RANGE_13;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_13;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_13;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_13;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_13;
} SG_LRR_AVD_Detection_013_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_014_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_14;
  float32 LRR_CAN_AVD_DET_AZIMUTH_14;
  Rte_DT_SG_LRR_AVD_Detection_014_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_14;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_14;
  float32 LRR_CAN_AVD_DET_ELEVATION_14;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_14;
  boolean LRR_CAN_AVD_DET_Near_TARGET_14;
  float32 LRR_CAN_AVD_DET_RANGE_14;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_14;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_14;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_14;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_14;
} SG_LRR_AVD_Detection_014_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_015_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_15;
  float32 LRR_CAN_AVD_DET_AZIMUTH_15;
  Rte_DT_SG_LRR_AVD_Detection_015_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_15;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_15;
  float32 LRR_CAN_AVD_DET_ELEVATION_15;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_15;
  boolean LRR_CAN_AVD_DET_Near_TARGET_15;
  float32 LRR_CAN_AVD_DET_RANGE_15;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_15;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_15;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_15;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_15;
} SG_LRR_AVD_Detection_015_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_016_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_16;
  float32 LRR_CAN_AVD_DET_AZIMUTH_16;
  Rte_DT_SG_LRR_AVD_Detection_016_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_16;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_16;
  float32 LRR_CAN_AVD_DET_ELEVATION_16;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_16;
  boolean LRR_CAN_AVD_DET_Near_TARGET_16;
  float32 LRR_CAN_AVD_DET_RANGE_16;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_16;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_16;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_16;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_16;
} SG_LRR_AVD_Detection_016_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_017_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_17;
  float32 LRR_CAN_AVD_DET_AZIMUTH_17;
  Rte_DT_SG_LRR_AVD_Detection_017_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_17;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_17;
  float32 LRR_CAN_AVD_DET_ELEVATION_17;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_17;
  boolean LRR_CAN_AVD_DET_Near_TARGET_17;
  float32 LRR_CAN_AVD_DET_RANGE_17;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_17;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_17;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_17;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_17;
} SG_LRR_AVD_Detection_017_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_018_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_18;
  float32 LRR_CAN_AVD_DET_AZIMUTH_18;
  Rte_DT_SG_LRR_AVD_Detection_018_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_18;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_18;
  float32 LRR_CAN_AVD_DET_ELEVATION_18;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_18;
  boolean LRR_CAN_AVD_DET_Near_TARGET_18;
  float32 LRR_CAN_AVD_DET_RANGE_18;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_18;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_18;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_18;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_18;
} SG_LRR_AVD_Detection_018_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_019_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_19;
  float32 LRR_CAN_AVD_DET_AZIMUTH_19;
  Rte_DT_SG_LRR_AVD_Detection_019_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_19;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_19;
  float32 LRR_CAN_AVD_DET_ELEVATION_19;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_19;
  boolean LRR_CAN_AVD_DET_Near_TARGET_19;
  float32 LRR_CAN_AVD_DET_RANGE_19;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_19;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_19;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_19;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_19;
} SG_LRR_AVD_Detection_019_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_020_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_20;
  float32 LRR_CAN_AVD_DET_AZIMUTH_20;
  Rte_DT_SG_LRR_AVD_Detection_020_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_20;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_20;
  float32 LRR_CAN_AVD_DET_ELEVATION_20;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_20;
  boolean LRR_CAN_AVD_DET_Near_TARGET_20;
  float32 LRR_CAN_AVD_DET_RANGE_20;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_20;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_20;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_20;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_20;
} SG_LRR_AVD_Detection_020_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_021_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_21;
  float32 LRR_CAN_AVD_DET_AZIMUTH_21;
  Rte_DT_SG_LRR_AVD_Detection_021_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_21;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_21;
  float32 LRR_CAN_AVD_DET_ELEVATION_21;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_21;
  boolean LRR_CAN_AVD_DET_Near_TARGET_21;
  float32 LRR_CAN_AVD_DET_RANGE_21;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_21;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_21;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_21;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_21;
} SG_LRR_AVD_Detection_021_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_022_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_22;
  float32 LRR_CAN_AVD_DET_AZIMUTH_22;
  Rte_DT_SG_LRR_AVD_Detection_022_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_22;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_22;
  float32 LRR_CAN_AVD_DET_ELEVATION_22;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_22;
  boolean LRR_CAN_AVD_DET_Near_TARGET_22;
  float32 LRR_CAN_AVD_DET_RANGE_22;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_22;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_22;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_22;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_22;
} SG_LRR_AVD_Detection_022_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_023_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_23;
  float32 LRR_CAN_AVD_DET_AZIMUTH_23;
  Rte_DT_SG_LRR_AVD_Detection_023_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_23;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_23;
  float32 LRR_CAN_AVD_DET_ELEVATION_23;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_23;
  boolean LRR_CAN_AVD_DET_Near_TARGET_23;
  float32 LRR_CAN_AVD_DET_RANGE_23;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_23;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_23;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_23;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_23;
} SG_LRR_AVD_Detection_023_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_024_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_24;
  float32 LRR_CAN_AVD_DET_AZIMUTH_24;
  Rte_DT_SG_LRR_AVD_Detection_024_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_24;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_24;
  float32 LRR_CAN_AVD_DET_ELEVATION_24;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_24;
  boolean LRR_CAN_AVD_DET_Near_TARGET_24;
  float32 LRR_CAN_AVD_DET_RANGE_24;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_24;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_24;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_24;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_24;
} SG_LRR_AVD_Detection_024_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_025_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_25;
  float32 LRR_CAN_AVD_DET_AZIMUTH_25;
  Rte_DT_SG_LRR_AVD_Detection_025_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_25;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_25;
  float32 LRR_CAN_AVD_DET_ELEVATION_25;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_25;
  boolean LRR_CAN_AVD_DET_Near_TARGET_25;
  float32 LRR_CAN_AVD_DET_RANGE_25;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_25;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_25;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_25;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_25;
} SG_LRR_AVD_Detection_025_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_026_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_26;
  float32 LRR_CAN_AVD_DET_AZIMUTH_26;
  Rte_DT_SG_LRR_AVD_Detection_026_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_26;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_26;
  float32 LRR_CAN_AVD_DET_ELEVATION_26;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_26;
  boolean LRR_CAN_AVD_DET_Near_TARGET_26;
  float32 LRR_CAN_AVD_DET_RANGE_26;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_26;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_26;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_26;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_26;
} SG_LRR_AVD_Detection_026_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_027_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_27;
  float32 LRR_CAN_AVD_DET_AZIMUTH_27;
  Rte_DT_SG_LRR_AVD_Detection_027_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_27;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_27;
  float32 LRR_CAN_AVD_DET_ELEVATION_27;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_27;
  boolean LRR_CAN_AVD_DET_Near_TARGET_27;
  float32 LRR_CAN_AVD_DET_RANGE_27;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_27;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_27;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_27;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_27;
} SG_LRR_AVD_Detection_027_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_028_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_28;
  float32 LRR_CAN_AVD_DET_AZIMUTH_28;
  Rte_DT_SG_LRR_AVD_Detection_028_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_28;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_28;
  float32 LRR_CAN_AVD_DET_ELEVATION_28;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_28;
  boolean LRR_CAN_AVD_DET_Near_TARGET_28;
  float32 LRR_CAN_AVD_DET_RANGE_28;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_28;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_28;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_28;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_28;
} SG_LRR_AVD_Detection_028_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_029_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_29;
  float32 LRR_CAN_AVD_DET_AZIMUTH_29;
  Rte_DT_SG_LRR_AVD_Detection_029_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_29;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_29;
  float32 LRR_CAN_AVD_DET_ELEVATION_29;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_29;
  boolean LRR_CAN_AVD_DET_Near_TARGET_29;
  float32 LRR_CAN_AVD_DET_RANGE_29;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_29;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_29;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_29;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_29;
} SG_LRR_AVD_Detection_029_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_030_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_30;
  float32 LRR_CAN_AVD_DET_AZIMUTH_30;
  Rte_DT_SG_LRR_AVD_Detection_030_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_30;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_30;
  float32 LRR_CAN_AVD_DET_ELEVATION_30;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_30;
  boolean LRR_CAN_AVD_DET_Near_TARGET_30;
  float32 LRR_CAN_AVD_DET_RANGE_30;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_30;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_30;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_30;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_30;
} SG_LRR_AVD_Detection_030_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_031_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_31;
  float32 LRR_CAN_AVD_DET_AZIMUTH_31;
  Rte_DT_SG_LRR_AVD_Detection_031_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_31;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_31;
  float32 LRR_CAN_AVD_DET_ELEVATION_31;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_31;
  boolean LRR_CAN_AVD_DET_Near_TARGET_31;
  float32 LRR_CAN_AVD_DET_RANGE_31;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_31;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_31;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_31;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_31;
} SG_LRR_AVD_Detection_031_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_032_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_32;
  float32 LRR_CAN_AVD_DET_AZIMUTH_32;
  Rte_DT_SG_LRR_AVD_Detection_032_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_32;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_32;
  float32 LRR_CAN_AVD_DET_ELEVATION_32;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_32;
  boolean LRR_CAN_AVD_DET_Near_TARGET_32;
  float32 LRR_CAN_AVD_DET_RANGE_32;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_32;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_32;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_32;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_32;
} SG_LRR_AVD_Detection_032_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_033_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_33;
  float32 LRR_CAN_AVD_DET_AZIMUTH_33;
  Rte_DT_SG_LRR_AVD_Detection_033_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_33;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_33;
  float32 LRR_CAN_AVD_DET_ELEVATION_33;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_33;
  boolean LRR_CAN_AVD_DET_Near_TARGET_33;
  float32 LRR_CAN_AVD_DET_RANGE_33;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_33;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_33;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_33;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_33;
} SG_LRR_AVD_Detection_033_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_034_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_34;
  float32 LRR_CAN_AVD_DET_AZIMUTH_34;
  Rte_DT_SG_LRR_AVD_Detection_034_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_34;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_34;
  float32 LRR_CAN_AVD_DET_ELEVATION_34;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_34;
  boolean LRR_CAN_AVD_DET_Near_TARGET_34;
  float32 LRR_CAN_AVD_DET_RANGE_34;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_34;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_34;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_34;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_34;
} SG_LRR_AVD_Detection_034_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_035_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_35;
  float32 LRR_CAN_AVD_DET_AZIMUTH_35;
  Rte_DT_SG_LRR_AVD_Detection_035_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_35;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_35;
  float32 LRR_CAN_AVD_DET_ELEVATION_35;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_35;
  boolean LRR_CAN_AVD_DET_Near_TARGET_35;
  float32 LRR_CAN_AVD_DET_RANGE_35;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_35;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_35;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_35;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_35;
} SG_LRR_AVD_Detection_035_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_036_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_36;
  float32 LRR_CAN_AVD_DET_AZIMUTH_36;
  Rte_DT_SG_LRR_AVD_Detection_036_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_36;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_36;
  float32 LRR_CAN_AVD_DET_ELEVATION_36;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_36;
  boolean LRR_CAN_AVD_DET_Near_TARGET_36;
  float32 LRR_CAN_AVD_DET_RANGE_36;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_36;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_36;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_36;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_36;
} SG_LRR_AVD_Detection_036_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_037_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_37;
  float32 LRR_CAN_AVD_DET_AZIMUTH_37;
  Rte_DT_SG_LRR_AVD_Detection_037_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_37;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_37;
  float32 LRR_CAN_AVD_DET_ELEVATION_37;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_37;
  boolean LRR_CAN_AVD_DET_Near_TARGET_37;
  float32 LRR_CAN_AVD_DET_RANGE_37;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_37;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_37;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_37;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_37;
} SG_LRR_AVD_Detection_037_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_038_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_38;
  float32 LRR_CAN_AVD_DET_AZIMUTH_38;
  Rte_DT_SG_LRR_AVD_Detection_038_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_38;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_38;
  float32 LRR_CAN_AVD_DET_ELEVATION_38;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_38;
  boolean LRR_CAN_AVD_DET_Near_TARGET_38;
  float32 LRR_CAN_AVD_DET_RANGE_38;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_38;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_38;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_38;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_38;
} SG_LRR_AVD_Detection_038_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_039_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_39;
  float32 LRR_CAN_AVD_DET_AZIMUTH_39;
  Rte_DT_SG_LRR_AVD_Detection_039_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_39;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_39;
  float32 LRR_CAN_AVD_DET_ELEVATION_39;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_39;
  boolean LRR_CAN_AVD_DET_Near_TARGET_39;
  float32 LRR_CAN_AVD_DET_RANGE_39;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_39;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_39;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_39;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_39;
} SG_LRR_AVD_Detection_039_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_040_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_40;
  float32 LRR_CAN_AVD_DET_AZIMUTH_40;
  Rte_DT_SG_LRR_AVD_Detection_040_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_40;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_40;
  float32 LRR_CAN_AVD_DET_ELEVATION_40;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_40;
  boolean LRR_CAN_AVD_DET_Near_TARGET_40;
  float32 LRR_CAN_AVD_DET_RANGE_40;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_40;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_40;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_40;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_40;
} SG_LRR_AVD_Detection_040_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_041_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_41;
  float32 LRR_CAN_AVD_DET_AZIMUTH_41;
  Rte_DT_SG_LRR_AVD_Detection_041_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_41;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_41;
  float32 LRR_CAN_AVD_DET_ELEVATION_41;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_41;
  boolean LRR_CAN_AVD_DET_Near_TARGET_41;
  float32 LRR_CAN_AVD_DET_RANGE_41;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_41;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_41;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_41;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_41;
} SG_LRR_AVD_Detection_041_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_042_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_42;
  float32 LRR_CAN_AVD_DET_AZIMUTH_42;
  Rte_DT_SG_LRR_AVD_Detection_042_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_42;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_42;
  float32 LRR_CAN_AVD_DET_ELEVATION_42;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_42;
  boolean LRR_CAN_AVD_DET_Near_TARGET_42;
  float32 LRR_CAN_AVD_DET_RANGE_42;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_42;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_42;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_42;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_42;
} SG_LRR_AVD_Detection_042_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_043_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_43;
  float32 LRR_CAN_AVD_DET_AZIMUTH_43;
  Rte_DT_SG_LRR_AVD_Detection_043_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_43;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_43;
  float32 LRR_CAN_AVD_DET_ELEVATION_43;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_43;
  boolean LRR_CAN_AVD_DET_Near_TARGET_43;
  float32 LRR_CAN_AVD_DET_RANGE_43;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_43;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_43;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_43;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_43;
} SG_LRR_AVD_Detection_043_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_044_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_44;
  float32 LRR_CAN_AVD_DET_AZIMUTH_44;
  Rte_DT_SG_LRR_AVD_Detection_044_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_44;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_44;
  float32 LRR_CAN_AVD_DET_ELEVATION_44;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_44;
  boolean LRR_CAN_AVD_DET_Near_TARGET_44;
  float32 LRR_CAN_AVD_DET_RANGE_44;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_44;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_44;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_44;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_44;
} SG_LRR_AVD_Detection_044_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_045_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_45;
  float32 LRR_CAN_AVD_DET_AZIMUTH_45;
  Rte_DT_SG_LRR_AVD_Detection_045_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_45;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_45;
  float32 LRR_CAN_AVD_DET_ELEVATION_45;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_45;
  boolean LRR_CAN_AVD_DET_Near_TARGET_45;
  float32 LRR_CAN_AVD_DET_RANGE_45;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_45;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_45;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_45;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_45;
} SG_LRR_AVD_Detection_045_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_046_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_46;
  float32 LRR_CAN_AVD_DET_AZIMUTH_46;
  Rte_DT_SG_LRR_AVD_Detection_046_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_46;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_46;
  float32 LRR_CAN_AVD_DET_ELEVATION_46;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_46;
  boolean LRR_CAN_AVD_DET_Near_TARGET_46;
  float32 LRR_CAN_AVD_DET_RANGE_46;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_46;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_46;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_46;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_46;
} SG_LRR_AVD_Detection_046_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_047_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_47;
  float32 LRR_CAN_AVD_DET_AZIMUTH_47;
  Rte_DT_SG_LRR_AVD_Detection_047_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_47;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_47;
  float32 LRR_CAN_AVD_DET_ELEVATION_47;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_47;
  boolean LRR_CAN_AVD_DET_Near_TARGET_47;
  float32 LRR_CAN_AVD_DET_RANGE_47;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_47;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_47;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_47;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_47;
} SG_LRR_AVD_Detection_047_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_048_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_48;
  float32 LRR_CAN_AVD_DET_AZIMUTH_48;
  Rte_DT_SG_LRR_AVD_Detection_048_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_48;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_48;
  float32 LRR_CAN_AVD_DET_ELEVATION_48;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_48;
  boolean LRR_CAN_AVD_DET_Near_TARGET_48;
  float32 LRR_CAN_AVD_DET_RANGE_48;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_48;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_48;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_48;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_48;
} SG_LRR_AVD_Detection_048_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_049_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_49;
  float32 LRR_CAN_AVD_DET_AZIMUTH_49;
  Rte_DT_SG_LRR_AVD_Detection_049_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_49;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_49;
  float32 LRR_CAN_AVD_DET_ELEVATION_49;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_49;
  boolean LRR_CAN_AVD_DET_Near_TARGET_49;
  float32 LRR_CAN_AVD_DET_RANGE_49;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_49;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_49;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_49;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_49;
} SG_LRR_AVD_Detection_049_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_050_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_50;
  float32 LRR_CAN_AVD_DET_AZIMUTH_50;
  Rte_DT_SG_LRR_AVD_Detection_050_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_50;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_50;
  float32 LRR_CAN_AVD_DET_ELEVATION_50;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_50;
  boolean LRR_CAN_AVD_DET_Near_TARGET_50;
  float32 LRR_CAN_AVD_DET_RANGE_50;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_50;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_50;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_50;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_50;
} SG_LRR_AVD_Detection_050_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_051_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_51;
  float32 LRR_CAN_AVD_DET_AZIMUTH_51;
  Rte_DT_SG_LRR_AVD_Detection_051_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_51;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_51;
  float32 LRR_CAN_AVD_DET_ELEVATION_51;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_51;
  boolean LRR_CAN_AVD_DET_Near_TARGET_51;
  float32 LRR_CAN_AVD_DET_RANGE_51;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_51;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_51;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_51;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_51;
} SG_LRR_AVD_Detection_051_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_052_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_52;
  float32 LRR_CAN_AVD_DET_AZIMUTH_52;
  Rte_DT_SG_LRR_AVD_Detection_052_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_52;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_52;
  float32 LRR_CAN_AVD_DET_ELEVATION_52;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_52;
  boolean LRR_CAN_AVD_DET_Near_TARGET_52;
  float32 LRR_CAN_AVD_DET_RANGE_52;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_52;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_52;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_52;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_52;
} SG_LRR_AVD_Detection_052_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_053_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_53;
  float32 LRR_CAN_AVD_DET_AZIMUTH_53;
  Rte_DT_SG_LRR_AVD_Detection_053_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_53;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_53;
  float32 LRR_CAN_AVD_DET_ELEVATION_53;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_53;
  boolean LRR_CAN_AVD_DET_Near_TARGET_53;
  float32 LRR_CAN_AVD_DET_RANGE_53;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_53;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_53;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_53;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_53;
} SG_LRR_AVD_Detection_053_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_054_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_54;
  float32 LRR_CAN_AVD_DET_AZIMUTH_54;
  Rte_DT_SG_LRR_AVD_Detection_054_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_54;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_54;
  float32 LRR_CAN_AVD_DET_ELEVATION_54;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_54;
  boolean LRR_CAN_AVD_DET_Near_TARGET_54;
  float32 LRR_CAN_AVD_DET_RANGE_54;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_54;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_54;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_54;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_54;
} SG_LRR_AVD_Detection_054_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_055_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_55;
  float32 LRR_CAN_AVD_DET_AZIMUTH_55;
  Rte_DT_SG_LRR_AVD_Detection_055_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_55;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_55;
  float32 LRR_CAN_AVD_DET_ELEVATION_55;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_55;
  boolean LRR_CAN_AVD_DET_Near_TARGET_55;
  float32 LRR_CAN_AVD_DET_RANGE_55;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_55;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_55;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_55;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_55;
} SG_LRR_AVD_Detection_055_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_056_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_56;
  float32 LRR_CAN_AVD_DET_AZIMUTH_56;
  Rte_DT_SG_LRR_AVD_Detection_056_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_56;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_56;
  float32 LRR_CAN_AVD_DET_ELEVATION_56;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_56;
  boolean LRR_CAN_AVD_DET_Near_TARGET_56;
  float32 LRR_CAN_AVD_DET_RANGE_56;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_56;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_56;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_56;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_56;
} SG_LRR_AVD_Detection_056_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_057_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_57;
  float32 LRR_CAN_AVD_DET_AZIMUTH_57;
  Rte_DT_SG_LRR_AVD_Detection_057_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_57;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_57;
  float32 LRR_CAN_AVD_DET_ELEVATION_57;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_57;
  boolean LRR_CAN_AVD_DET_Near_TARGET_57;
  float32 LRR_CAN_AVD_DET_RANGE_57;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_57;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_57;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_57;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_57;
} SG_LRR_AVD_Detection_057_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_058_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_58;
  float32 LRR_CAN_AVD_DET_AZIMUTH_58;
  Rte_DT_SG_LRR_AVD_Detection_058_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_58;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_58;
  float32 LRR_CAN_AVD_DET_ELEVATION_58;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_58;
  boolean LRR_CAN_AVD_DET_Near_TARGET_58;
  float32 LRR_CAN_AVD_DET_RANGE_58;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_58;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_58;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_58;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_58;
} SG_LRR_AVD_Detection_058_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_059_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_59;
  float32 LRR_CAN_AVD_DET_AZIMUTH_59;
  Rte_DT_SG_LRR_AVD_Detection_059_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_59;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_59;
  float32 LRR_CAN_AVD_DET_ELEVATION_59;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_59;
  boolean LRR_CAN_AVD_DET_Near_TARGET_59;
  float32 LRR_CAN_AVD_DET_RANGE_59;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_59;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_59;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_59;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_59;
} SG_LRR_AVD_Detection_059_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_060_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_60;
  float32 LRR_CAN_AVD_DET_AZIMUTH_60;
  Rte_DT_SG_LRR_AVD_Detection_060_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_60;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_60;
  float32 LRR_CAN_AVD_DET_ELEVATION_60;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_60;
  boolean LRR_CAN_AVD_DET_Near_TARGET_60;
  float32 LRR_CAN_AVD_DET_RANGE_60;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_60;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_60;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_60;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_60;
} SG_LRR_AVD_Detection_060_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_061_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_61;
  float32 LRR_CAN_AVD_DET_AZIMUTH_61;
  Rte_DT_SG_LRR_AVD_Detection_061_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_61;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_61;
  float32 LRR_CAN_AVD_DET_ELEVATION_61;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_61;
  boolean LRR_CAN_AVD_DET_Near_TARGET_61;
  float32 LRR_CAN_AVD_DET_RANGE_61;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_61;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_61;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_61;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_61;
} SG_LRR_AVD_Detection_061_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_062_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_62;
  float32 LRR_CAN_AVD_DET_AZIMUTH_62;
  Rte_DT_SG_LRR_AVD_Detection_062_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_62;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_62;
  float32 LRR_CAN_AVD_DET_ELEVATION_62;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_62;
  boolean LRR_CAN_AVD_DET_Near_TARGET_62;
  float32 LRR_CAN_AVD_DET_RANGE_62;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_62;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_62;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_62;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_62;
} SG_LRR_AVD_Detection_062_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_063_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_63;
  float32 LRR_CAN_AVD_DET_AZIMUTH_63;
  Rte_DT_SG_LRR_AVD_Detection_063_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_63;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_63;
  float32 LRR_CAN_AVD_DET_ELEVATION_63;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_63;
  boolean LRR_CAN_AVD_DET_Near_TARGET_63;
  float32 LRR_CAN_AVD_DET_RANGE_63;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_63;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_63;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_63;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_63;
} SG_LRR_AVD_Detection_063_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_064_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_64;
  float32 LRR_CAN_AVD_DET_AZIMUTH_64;
  Rte_DT_SG_LRR_AVD_Detection_064_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_64;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_64;
  float32 LRR_CAN_AVD_DET_ELEVATION_64;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_64;
  boolean LRR_CAN_AVD_DET_Near_TARGET_64;
  float32 LRR_CAN_AVD_DET_RANGE_64;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_64;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_64;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_64;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_64;
} SG_LRR_AVD_Detection_064_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_065_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_65;
  float32 LRR_CAN_AVD_DET_AZIMUTH_65;
  Rte_DT_SG_LRR_AVD_Detection_065_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_65;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_65;
  float32 LRR_CAN_AVD_DET_ELEVATION_65;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_65;
  boolean LRR_CAN_AVD_DET_Near_TARGET_65;
  float32 LRR_CAN_AVD_DET_RANGE_65;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_65;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_65;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_65;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_65;
} SG_LRR_AVD_Detection_065_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_066_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_66;
  float32 LRR_CAN_AVD_DET_AZIMUTH_66;
  Rte_DT_SG_LRR_AVD_Detection_066_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_66;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_66;
  float32 LRR_CAN_AVD_DET_ELEVATION_66;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_66;
  boolean LRR_CAN_AVD_DET_Near_TARGET_66;
  float32 LRR_CAN_AVD_DET_RANGE_66;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_66;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_66;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_66;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_66;
} SG_LRR_AVD_Detection_066_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_067_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_67;
  float32 LRR_CAN_AVD_DET_AZIMUTH_67;
  Rte_DT_SG_LRR_AVD_Detection_067_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_67;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_67;
  float32 LRR_CAN_AVD_DET_ELEVATION_67;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_67;
  boolean LRR_CAN_AVD_DET_Near_TARGET_67;
  float32 LRR_CAN_AVD_DET_RANGE_67;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_67;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_67;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_67;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_67;
} SG_LRR_AVD_Detection_067_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_068_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_68;
  float32 LRR_CAN_AVD_DET_AZIMUTH_68;
  Rte_DT_SG_LRR_AVD_Detection_068_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_68;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_68;
  float32 LRR_CAN_AVD_DET_ELEVATION_68;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_68;
  boolean LRR_CAN_AVD_DET_Near_TARGET_68;
  float32 LRR_CAN_AVD_DET_RANGE_68;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_68;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_68;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_68;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_68;
} SG_LRR_AVD_Detection_068_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_069_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_69;
  float32 LRR_CAN_AVD_DET_AZIMUTH_69;
  Rte_DT_SG_LRR_AVD_Detection_069_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_69;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_69;
  float32 LRR_CAN_AVD_DET_ELEVATION_69;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_69;
  boolean LRR_CAN_AVD_DET_Near_TARGET_69;
  float32 LRR_CAN_AVD_DET_RANGE_69;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_69;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_69;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_69;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_69;
} SG_LRR_AVD_Detection_069_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_070_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_70;
  float32 LRR_CAN_AVD_DET_AZIMUTH_70;
  Rte_DT_SG_LRR_AVD_Detection_070_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_70;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_70;
  float32 LRR_CAN_AVD_DET_ELEVATION_70;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_70;
  boolean LRR_CAN_AVD_DET_Near_TARGET_70;
  float32 LRR_CAN_AVD_DET_RANGE_70;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_70;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_70;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_70;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_70;
} SG_LRR_AVD_Detection_070_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_071_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_71;
  float32 LRR_CAN_AVD_DET_AZIMUTH_71;
  Rte_DT_SG_LRR_AVD_Detection_071_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_71;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_71;
  float32 LRR_CAN_AVD_DET_ELEVATION_71;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_71;
  boolean LRR_CAN_AVD_DET_Near_TARGET_71;
  float32 LRR_CAN_AVD_DET_RANGE_71;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_71;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_71;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_71;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_71;
} SG_LRR_AVD_Detection_071_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_072_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_72;
  float32 LRR_CAN_AVD_DET_AZIMUTH_72;
  Rte_DT_SG_LRR_AVD_Detection_072_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_72;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_72;
  float32 LRR_CAN_AVD_DET_ELEVATION_72;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_72;
  boolean LRR_CAN_AVD_DET_Near_TARGET_72;
  float32 LRR_CAN_AVD_DET_RANGE_72;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_72;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_72;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_72;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_72;
} SG_LRR_AVD_Detection_072_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_073_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_73;
  float32 LRR_CAN_AVD_DET_AZIMUTH_73;
  Rte_DT_SG_LRR_AVD_Detection_073_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_73;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_73;
  float32 LRR_CAN_AVD_DET_ELEVATION_73;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_73;
  boolean LRR_CAN_AVD_DET_Near_TARGET_73;
  float32 LRR_CAN_AVD_DET_RANGE_73;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_73;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_73;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_73;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_73;
} SG_LRR_AVD_Detection_073_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_074_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_74;
  float32 LRR_CAN_AVD_DET_AZIMUTH_74;
  Rte_DT_SG_LRR_AVD_Detection_074_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_74;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_74;
  float32 LRR_CAN_AVD_DET_ELEVATION_74;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_74;
  boolean LRR_CAN_AVD_DET_Near_TARGET_74;
  float32 LRR_CAN_AVD_DET_RANGE_74;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_74;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_74;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_74;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_74;
} SG_LRR_AVD_Detection_074_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_075_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_75;
  float32 LRR_CAN_AVD_DET_AZIMUTH_75;
  Rte_DT_SG_LRR_AVD_Detection_075_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_75;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_75;
  float32 LRR_CAN_AVD_DET_ELEVATION_75;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_75;
  boolean LRR_CAN_AVD_DET_Near_TARGET_75;
  float32 LRR_CAN_AVD_DET_RANGE_75;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_75;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_75;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_75;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_75;
} SG_LRR_AVD_Detection_075_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_076_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_76;
  float32 LRR_CAN_AVD_DET_AZIMUTH_76;
  Rte_DT_SG_LRR_AVD_Detection_076_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_76;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_76;
  float32 LRR_CAN_AVD_DET_ELEVATION_76;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_76;
  boolean LRR_CAN_AVD_DET_Near_TARGET_76;
  float32 LRR_CAN_AVD_DET_RANGE_76;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_76;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_76;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_76;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_76;
} SG_LRR_AVD_Detection_076_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_077_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_77;
  float32 LRR_CAN_AVD_DET_AZIMUTH_77;
  Rte_DT_SG_LRR_AVD_Detection_077_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_77;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_77;
  float32 LRR_CAN_AVD_DET_ELEVATION_77;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_77;
  boolean LRR_CAN_AVD_DET_Near_TARGET_77;
  float32 LRR_CAN_AVD_DET_RANGE_77;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_77;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_77;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_77;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_77;
} SG_LRR_AVD_Detection_077_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_078_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_78;
  float32 LRR_CAN_AVD_DET_AZIMUTH_78;
  Rte_DT_SG_LRR_AVD_Detection_078_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_78;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_78;
  float32 LRR_CAN_AVD_DET_ELEVATION_78;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_78;
  boolean LRR_CAN_AVD_DET_Near_TARGET_78;
  float32 LRR_CAN_AVD_DET_RANGE_78;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_78;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_78;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_78;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_78;
} SG_LRR_AVD_Detection_078_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_079_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_79;
  float32 LRR_CAN_AVD_DET_AZIMUTH_79;
  Rte_DT_SG_LRR_AVD_Detection_079_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_79;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_79;
  float32 LRR_CAN_AVD_DET_ELEVATION_79;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_79;
  boolean LRR_CAN_AVD_DET_Near_TARGET_79;
  float32 LRR_CAN_AVD_DET_RANGE_79;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_79;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_79;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_79;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_79;
} SG_LRR_AVD_Detection_079_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_080_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_80;
  float32 LRR_CAN_AVD_DET_AZIMUTH_80;
  Rte_DT_SG_LRR_AVD_Detection_080_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_80;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_80;
  float32 LRR_CAN_AVD_DET_ELEVATION_80;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_80;
  boolean LRR_CAN_AVD_DET_Near_TARGET_80;
  float32 LRR_CAN_AVD_DET_RANGE_80;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_80;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_80;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_80;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_80;
} SG_LRR_AVD_Detection_080_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_081_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_81;
  float32 LRR_CAN_AVD_DET_AZIMUTH_81;
  Rte_DT_SG_LRR_AVD_Detection_081_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_81;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_81;
  float32 LRR_CAN_AVD_DET_ELEVATION_81;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_81;
  boolean LRR_CAN_AVD_DET_Near_TARGET_81;
  float32 LRR_CAN_AVD_DET_RANGE_81;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_81;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_81;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_81;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_81;
} SG_LRR_AVD_Detection_081_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_082_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_82;
  float32 LRR_CAN_AVD_DET_AZIMUTH_82;
  Rte_DT_SG_LRR_AVD_Detection_082_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_82;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_82;
  float32 LRR_CAN_AVD_DET_ELEVATION_82;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_82;
  boolean LRR_CAN_AVD_DET_Near_TARGET_82;
  float32 LRR_CAN_AVD_DET_RANGE_82;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_82;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_82;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_82;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_82;
} SG_LRR_AVD_Detection_082_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_083_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_83;
  float32 LRR_CAN_AVD_DET_AZIMUTH_83;
  Rte_DT_SG_LRR_AVD_Detection_083_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_83;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_83;
  float32 LRR_CAN_AVD_DET_ELEVATION_83;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_83;
  boolean LRR_CAN_AVD_DET_Near_TARGET_83;
  float32 LRR_CAN_AVD_DET_RANGE_83;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_83;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_83;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_83;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_83;
} SG_LRR_AVD_Detection_083_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_084_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_84;
  float32 LRR_CAN_AVD_DET_AZIMUTH_84;
  Rte_DT_SG_LRR_AVD_Detection_084_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_84;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_84;
  float32 LRR_CAN_AVD_DET_ELEVATION_84;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_84;
  boolean LRR_CAN_AVD_DET_Near_TARGET_84;
  float32 LRR_CAN_AVD_DET_RANGE_84;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_84;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_84;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_84;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_84;
} SG_LRR_AVD_Detection_084_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_085_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_85;
  float32 LRR_CAN_AVD_DET_AZIMUTH_85;
  Rte_DT_SG_LRR_AVD_Detection_085_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_85;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_85;
  float32 LRR_CAN_AVD_DET_ELEVATION_85;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_85;
  boolean LRR_CAN_AVD_DET_Near_TARGET_85;
  float32 LRR_CAN_AVD_DET_RANGE_85;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_85;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_85;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_85;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_85;
} SG_LRR_AVD_Detection_085_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_086_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_86;
  float32 LRR_CAN_AVD_DET_AZIMUTH_86;
  Rte_DT_SG_LRR_AVD_Detection_086_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_86;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_86;
  float32 LRR_CAN_AVD_DET_ELEVATION_86;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_86;
  boolean LRR_CAN_AVD_DET_Near_TARGET_86;
  float32 LRR_CAN_AVD_DET_RANGE_86;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_86;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_86;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_86;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_86;
} SG_LRR_AVD_Detection_086_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_087_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_87;
  float32 LRR_CAN_AVD_DET_AZIMUTH_87;
  Rte_DT_SG_LRR_AVD_Detection_087_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_87;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_87;
  float32 LRR_CAN_AVD_DET_ELEVATION_87;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_87;
  boolean LRR_CAN_AVD_DET_Near_TARGET_87;
  float32 LRR_CAN_AVD_DET_RANGE_87;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_87;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_87;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_87;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_87;
} SG_LRR_AVD_Detection_087_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_088_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_88;
  float32 LRR_CAN_AVD_DET_AZIMUTH_88;
  Rte_DT_SG_LRR_AVD_Detection_088_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_88;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_88;
  float32 LRR_CAN_AVD_DET_ELEVATION_88;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_88;
  boolean LRR_CAN_AVD_DET_Near_TARGET_88;
  float32 LRR_CAN_AVD_DET_RANGE_88;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_88;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_88;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_88;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_88;
} SG_LRR_AVD_Detection_088_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_089_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_89;
  float32 LRR_CAN_AVD_DET_AZIMUTH_89;
  Rte_DT_SG_LRR_AVD_Detection_089_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_89;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_89;
  float32 LRR_CAN_AVD_DET_ELEVATION_89;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_89;
  boolean LRR_CAN_AVD_DET_Near_TARGET_89;
  float32 LRR_CAN_AVD_DET_RANGE_89;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_89;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_89;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_89;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_89;
} SG_LRR_AVD_Detection_089_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_090_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_90;
  float32 LRR_CAN_AVD_DET_AZIMUTH_90;
  Rte_DT_SG_LRR_AVD_Detection_090_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_90;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_90;
  float32 LRR_CAN_AVD_DET_ELEVATION_90;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_90;
  boolean LRR_CAN_AVD_DET_Near_TARGET_90;
  float32 LRR_CAN_AVD_DET_RANGE_90;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_90;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_90;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_90;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_90;
} SG_LRR_AVD_Detection_090_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_091_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_91;
  float32 LRR_CAN_AVD_DET_AZIMUTH_91;
  Rte_DT_SG_LRR_AVD_Detection_091_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_91;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_91;
  float32 LRR_CAN_AVD_DET_ELEVATION_91;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_91;
  boolean LRR_CAN_AVD_DET_Near_TARGET_91;
  float32 LRR_CAN_AVD_DET_RANGE_91;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_91;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_91;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_91;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_91;
} SG_LRR_AVD_Detection_091_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_092_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_92;
  float32 LRR_CAN_AVD_DET_AZIMUTH_92;
  Rte_DT_SG_LRR_AVD_Detection_092_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_92;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_92;
  float32 LRR_CAN_AVD_DET_ELEVATION_92;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_92;
  boolean LRR_CAN_AVD_DET_Near_TARGET_92;
  float32 LRR_CAN_AVD_DET_RANGE_92;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_92;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_92;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_92;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_92;
} SG_LRR_AVD_Detection_092_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_093_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_93;
  float32 LRR_CAN_AVD_DET_AZIMUTH_93;
  Rte_DT_SG_LRR_AVD_Detection_093_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_93;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_93;
  float32 LRR_CAN_AVD_DET_ELEVATION_93;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_93;
  boolean LRR_CAN_AVD_DET_Near_TARGET_93;
  float32 LRR_CAN_AVD_DET_RANGE_93;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_93;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_93;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_93;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_93;
} SG_LRR_AVD_Detection_093_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_094_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_94;
  float32 LRR_CAN_AVD_DET_AZIMUTH_94;
  Rte_DT_SG_LRR_AVD_Detection_094_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_94;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_94;
  float32 LRR_CAN_AVD_DET_ELEVATION_94;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_94;
  boolean LRR_CAN_AVD_DET_Near_TARGET_94;
  float32 LRR_CAN_AVD_DET_RANGE_94;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_94;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_94;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_94;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_94;
} SG_LRR_AVD_Detection_094_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_095_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_95;
  float32 LRR_CAN_AVD_DET_AZIMUTH_95;
  Rte_DT_SG_LRR_AVD_Detection_095_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_95;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_95;
  float32 LRR_CAN_AVD_DET_ELEVATION_95;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_95;
  boolean LRR_CAN_AVD_DET_Near_TARGET_95;
  float32 LRR_CAN_AVD_DET_RANGE_95;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_95;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_95;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_95;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_95;
} SG_LRR_AVD_Detection_095_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_096_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_96;
  float32 LRR_CAN_AVD_DET_AZIMUTH_96;
  Rte_DT_SG_LRR_AVD_Detection_096_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_96;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_96;
  float32 LRR_CAN_AVD_DET_ELEVATION_96;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_96;
  boolean LRR_CAN_AVD_DET_Near_TARGET_96;
  float32 LRR_CAN_AVD_DET_RANGE_96;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_96;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_96;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_96;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_96;
} SG_LRR_AVD_Detection_096_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_097_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_97;
  float32 LRR_CAN_AVD_DET_AZIMUTH_97;
  Rte_DT_SG_LRR_AVD_Detection_097_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_97;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_97;
  float32 LRR_CAN_AVD_DET_ELEVATION_97;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_97;
  boolean LRR_CAN_AVD_DET_Near_TARGET_97;
  float32 LRR_CAN_AVD_DET_RANGE_97;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_97;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_97;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_97;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_97;
} SG_LRR_AVD_Detection_097_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_098_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_98;
  float32 LRR_CAN_AVD_DET_AZIMUTH_98;
  Rte_DT_SG_LRR_AVD_Detection_098_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_98;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_98;
  float32 LRR_CAN_AVD_DET_ELEVATION_98;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_98;
  boolean LRR_CAN_AVD_DET_Near_TARGET_98;
  float32 LRR_CAN_AVD_DET_RANGE_98;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_98;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_98;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_98;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_98;
} SG_LRR_AVD_Detection_098_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_099_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_99;
  float32 LRR_CAN_AVD_DET_AZIMUTH_99;
  Rte_DT_SG_LRR_AVD_Detection_099_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_99;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_99;
  float32 LRR_CAN_AVD_DET_ELEVATION_99;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_99;
  boolean LRR_CAN_AVD_DET_Near_TARGET_99;
  float32 LRR_CAN_AVD_DET_RANGE_99;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_99;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_99;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_99;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_99;
} SG_LRR_AVD_Detection_099_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_100_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_100;
  float32 LRR_CAN_AVD_DET_AZIMUTH_100;
  Rte_DT_SG_LRR_AVD_Detection_100_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_100;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_100;
  float32 LRR_CAN_AVD_DET_ELEVATION_100;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_100;
  boolean LRR_CAN_AVD_DET_Near_TARGET_100;
  float32 LRR_CAN_AVD_DET_RANGE_100;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_100;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_100;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_100;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_100;
} SG_LRR_AVD_Detection_100_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_101_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_101;
  float32 LRR_CAN_AVD_DET_AZIMUTH_101;
  Rte_DT_SG_LRR_AVD_Detection_101_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_101;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_101;
  float32 LRR_CAN_AVD_DET_ELEVATION_101;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_101;
  boolean LRR_CAN_AVD_DET_Near_TARGET_101;
  float32 LRR_CAN_AVD_DET_RANGE_101;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_101;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_101;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_101;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_101;
} SG_LRR_AVD_Detection_101_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_102_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_102;
  float32 LRR_CAN_AVD_DET_AZIMUTH_102;
  Rte_DT_SG_LRR_AVD_Detection_102_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_102;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_102;
  float32 LRR_CAN_AVD_DET_ELEVATION_102;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_102;
  boolean LRR_CAN_AVD_DET_Near_TARGET_102;
  float32 LRR_CAN_AVD_DET_RANGE_102;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_102;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_102;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_102;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_102;
} SG_LRR_AVD_Detection_102_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_103_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_103;
  float32 LRR_CAN_AVD_DET_AZIMUTH_103;
  Rte_DT_SG_LRR_AVD_Detection_103_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_103;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_103;
  float32 LRR_CAN_AVD_DET_ELEVATION_103;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_103;
  boolean LRR_CAN_AVD_DET_Near_TARGET_103;
  float32 LRR_CAN_AVD_DET_RANGE_103;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_103;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_103;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_103;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_103;
} SG_LRR_AVD_Detection_103_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_104_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_104;
  float32 LRR_CAN_AVD_DET_AZIMUTH_104;
  Rte_DT_SG_LRR_AVD_Detection_104_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_104;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_104;
  float32 LRR_CAN_AVD_DET_ELEVATION_104;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_104;
  boolean LRR_CAN_AVD_DET_Near_TARGET_104;
  float32 LRR_CAN_AVD_DET_RANGE_104;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_104;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_104;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_104;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_104;
} SG_LRR_AVD_Detection_104_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_105_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_105;
  float32 LRR_CAN_AVD_DET_AZIMUTH_105;
  Rte_DT_SG_LRR_AVD_Detection_105_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_105;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_105;
  float32 LRR_CAN_AVD_DET_ELEVATION_105;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_105;
  boolean LRR_CAN_AVD_DET_Near_TARGET_105;
  float32 LRR_CAN_AVD_DET_RANGE_105;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_105;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_105;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_105;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_105;
} SG_LRR_AVD_Detection_105_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_106_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_106;
  float32 LRR_CAN_AVD_DET_AZIMUTH_106;
  Rte_DT_SG_LRR_AVD_Detection_106_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_106;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_106;
  float32 LRR_CAN_AVD_DET_ELEVATION_106;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_106;
  boolean LRR_CAN_AVD_DET_Near_TARGET_106;
  float32 LRR_CAN_AVD_DET_RANGE_106;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_106;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_106;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_106;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_106;
} SG_LRR_AVD_Detection_106_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_107_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_107;
  float32 LRR_CAN_AVD_DET_AZIMUTH_107;
  Rte_DT_SG_LRR_AVD_Detection_107_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_107;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_107;
  float32 LRR_CAN_AVD_DET_ELEVATION_107;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_107;
  boolean LRR_CAN_AVD_DET_Near_TARGET_107;
  float32 LRR_CAN_AVD_DET_RANGE_107;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_107;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_107;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_107;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_107;
} SG_LRR_AVD_Detection_107_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_108_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_108;
  float32 LRR_CAN_AVD_DET_AZIMUTH_108;
  Rte_DT_SG_LRR_AVD_Detection_108_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_108;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_108;
  float32 LRR_CAN_AVD_DET_ELEVATION_108;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_108;
  boolean LRR_CAN_AVD_DET_Near_TARGET_108;
  float32 LRR_CAN_AVD_DET_RANGE_108;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_108;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_108;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_108;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_108;
} SG_LRR_AVD_Detection_108_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_109_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_109;
  float32 LRR_CAN_AVD_DET_AZIMUTH_109;
  Rte_DT_SG_LRR_AVD_Detection_109_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_109;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_109;
  float32 LRR_CAN_AVD_DET_ELEVATION_109;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_109;
  boolean LRR_CAN_AVD_DET_Near_TARGET_109;
  float32 LRR_CAN_AVD_DET_RANGE_109;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_109;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_109;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_109;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_109;
} SG_LRR_AVD_Detection_109_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_110_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_110;
  float32 LRR_CAN_AVD_DET_AZIMUTH_110;
  Rte_DT_SG_LRR_AVD_Detection_110_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_110;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_110;
  float32 LRR_CAN_AVD_DET_ELEVATION_110;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_110;
  boolean LRR_CAN_AVD_DET_Near_TARGET_110;
  float32 LRR_CAN_AVD_DET_RANGE_110;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_110;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_110;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_110;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_110;
} SG_LRR_AVD_Detection_110_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_111_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_111;
  float32 LRR_CAN_AVD_DET_AZIMUTH_111;
  Rte_DT_SG_LRR_AVD_Detection_111_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_111;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_111;
  float32 LRR_CAN_AVD_DET_ELEVATION_111;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_111;
  boolean LRR_CAN_AVD_DET_Near_TARGET_111;
  float32 LRR_CAN_AVD_DET_RANGE_111;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_111;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_111;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_111;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_111;
} SG_LRR_AVD_Detection_111_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_112_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_112;
  float32 LRR_CAN_AVD_DET_AZIMUTH_112;
  Rte_DT_SG_LRR_AVD_Detection_112_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_112;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_112;
  float32 LRR_CAN_AVD_DET_ELEVATION_112;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_112;
  boolean LRR_CAN_AVD_DET_Near_TARGET_112;
  float32 LRR_CAN_AVD_DET_RANGE_112;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_112;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_112;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_112;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_112;
} SG_LRR_AVD_Detection_112_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_113_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_113;
  float32 LRR_CAN_AVD_DET_AZIMUTH_113;
  Rte_DT_SG_LRR_AVD_Detection_113_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_113;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_113;
  float32 LRR_CAN_AVD_DET_ELEVATION_113;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_113;
  boolean LRR_CAN_AVD_DET_Near_TARGET_113;
  float32 LRR_CAN_AVD_DET_RANGE_113;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_113;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_113;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_113;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_113;
} SG_LRR_AVD_Detection_113_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_114_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_114;
  float32 LRR_CAN_AVD_DET_AZIMUTH_114;
  Rte_DT_SG_LRR_AVD_Detection_114_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_114;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_114;
  float32 LRR_CAN_AVD_DET_ELEVATION_114;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_114;
  boolean LRR_CAN_AVD_DET_Near_TARGET_114;
  float32 LRR_CAN_AVD_DET_RANGE_114;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_114;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_114;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_114;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_114;
} SG_LRR_AVD_Detection_114_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_115_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_115;
  float32 LRR_CAN_AVD_DET_AZIMUTH_115;
  Rte_DT_SG_LRR_AVD_Detection_115_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_115;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_115;
  float32 LRR_CAN_AVD_DET_ELEVATION_115;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_115;
  boolean LRR_CAN_AVD_DET_Near_TARGET_115;
  float32 LRR_CAN_AVD_DET_RANGE_115;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_115;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_115;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_115;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_115;
} SG_LRR_AVD_Detection_115_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_116_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_116;
  float32 LRR_CAN_AVD_DET_AZIMUTH_116;
  Rte_DT_SG_LRR_AVD_Detection_116_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_116;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_116;
  float32 LRR_CAN_AVD_DET_ELEVATION_116;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_116;
  boolean LRR_CAN_AVD_DET_Near_TARGET_116;
  float32 LRR_CAN_AVD_DET_RANGE_116;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_116;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_116;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_116;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_116;
} SG_LRR_AVD_Detection_116_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_117_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_117;
  float32 LRR_CAN_AVD_DET_AZIMUTH_117;
  Rte_DT_SG_LRR_AVD_Detection_117_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_117;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_117;
  float32 LRR_CAN_AVD_DET_ELEVATION_117;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_117;
  boolean LRR_CAN_AVD_DET_Near_TARGET_117;
  float32 LRR_CAN_AVD_DET_RANGE_117;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_117;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_117;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_117;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_117;
} SG_LRR_AVD_Detection_117_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_118_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_118;
  float32 LRR_CAN_AVD_DET_AZIMUTH_118;
  Rte_DT_SG_LRR_AVD_Detection_118_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_118;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_118;
  float32 LRR_CAN_AVD_DET_ELEVATION_118;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_118;
  boolean LRR_CAN_AVD_DET_Near_TARGET_118;
  float32 LRR_CAN_AVD_DET_RANGE_118;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_118;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_118;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_118;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_118;
} SG_LRR_AVD_Detection_118_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_119_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_119;
  float32 LRR_CAN_AVD_DET_AZIMUTH_119;
  Rte_DT_SG_LRR_AVD_Detection_119_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_119;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_119;
  float32 LRR_CAN_AVD_DET_ELEVATION_119;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_119;
  boolean LRR_CAN_AVD_DET_Near_TARGET_119;
  float32 LRR_CAN_AVD_DET_RANGE_119;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_119;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_119;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_119;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_119;
} SG_LRR_AVD_Detection_119_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_120_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_120;
  float32 LRR_CAN_AVD_DET_AZIMUTH_120;
  Rte_DT_SG_LRR_AVD_Detection_120_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_120;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_120;
  float32 LRR_CAN_AVD_DET_ELEVATION_120;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_120;
  boolean LRR_CAN_AVD_DET_Near_TARGET_120;
  float32 LRR_CAN_AVD_DET_RANGE_120;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_120;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_120;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_120;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_120;
} SG_LRR_AVD_Detection_120_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_121_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_121;
  float32 LRR_CAN_AVD_DET_AZIMUTH_121;
  Rte_DT_SG_LRR_AVD_Detection_121_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_121;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_121;
  float32 LRR_CAN_AVD_DET_ELEVATION_121;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_121;
  boolean LRR_CAN_AVD_DET_Near_TARGET_121;
  float32 LRR_CAN_AVD_DET_RANGE_121;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_121;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_121;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_121;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_121;
} SG_LRR_AVD_Detection_121_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_122_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_122;
  float32 LRR_CAN_AVD_DET_AZIMUTH_122;
  Rte_DT_SG_LRR_AVD_Detection_122_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_122;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_122;
  float32 LRR_CAN_AVD_DET_ELEVATION_122;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_122;
  boolean LRR_CAN_AVD_DET_Near_TARGET_122;
  float32 LRR_CAN_AVD_DET_RANGE_122;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_122;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_122;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_122;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_122;
} SG_LRR_AVD_Detection_122_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_123_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_123;
  float32 LRR_CAN_AVD_DET_AZIMUTH_123;
  Rte_DT_SG_LRR_AVD_Detection_123_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_123;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_123;
  float32 LRR_CAN_AVD_DET_ELEVATION_123;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_123;
  boolean LRR_CAN_AVD_DET_Near_TARGET_123;
  float32 LRR_CAN_AVD_DET_RANGE_123;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_123;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_123;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_123;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_123;
} SG_LRR_AVD_Detection_123_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_124_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_124;
  float32 LRR_CAN_AVD_DET_AZIMUTH_124;
  Rte_DT_SG_LRR_AVD_Detection_124_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_124;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_124;
  float32 LRR_CAN_AVD_DET_ELEVATION_124;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_124;
  boolean LRR_CAN_AVD_DET_Near_TARGET_124;
  float32 LRR_CAN_AVD_DET_RANGE_124;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_124;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_124;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_124;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_124;
} SG_LRR_AVD_Detection_124_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_125_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_125;
  float32 LRR_CAN_AVD_DET_AZIMUTH_125;
  Rte_DT_SG_LRR_AVD_Detection_125_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_125;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_125;
  float32 LRR_CAN_AVD_DET_ELEVATION_125;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_125;
  boolean LRR_CAN_AVD_DET_Near_TARGET_125;
  float32 LRR_CAN_AVD_DET_RANGE_125;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_125;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_125;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_125;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_125;
} SG_LRR_AVD_Detection_125_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_126_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_126;
  float32 LRR_CAN_AVD_DET_AZIMUTH_126;
  Rte_DT_SG_LRR_AVD_Detection_126_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_126;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_126;
  float32 LRR_CAN_AVD_DET_ELEVATION_126;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_126;
  boolean LRR_CAN_AVD_DET_Near_TARGET_126;
  float32 LRR_CAN_AVD_DET_RANGE_126;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_126;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_126;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_126;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_126;
} SG_LRR_AVD_Detection_126_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_127_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_127;
  float32 LRR_CAN_AVD_DET_AZIMUTH_127;
  Rte_DT_SG_LRR_AVD_Detection_127_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_127;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_127;
  float32 LRR_CAN_AVD_DET_ELEVATION_127;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_127;
  boolean LRR_CAN_AVD_DET_Near_TARGET_127;
  float32 LRR_CAN_AVD_DET_RANGE_127;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_127;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_127;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_127;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_127;
} SG_LRR_AVD_Detection_127_t;

#  define Rte_TypeDef_SG_LRR_AVD_Detection_128_t
typedef struct
{
  sint8 LRR_CAN_AVD_DET_AMPLITUDE_128;
  float32 LRR_CAN_AVD_DET_AZIMUTH_128;
  Rte_DT_SG_LRR_AVD_Detection_128_t_2 LRR_CAN_AVD_DET_CONFID_AZIMUTH_128;
  boolean LRR_CAN_AVD_DET_CONFID_ELEVATION_128;
  float32 LRR_CAN_AVD_DET_ELEVATION_128;
  boolean LRR_CAN_AVD_DET_HOST_VEH_CLUTTER_128;
  boolean LRR_CAN_AVD_DET_Near_TARGET_128;
  float32 LRR_CAN_AVD_DET_RANGE_128;
  float32 LRR_CAN_AVD_DET_RANGE_RATE_128;
  boolean LRR_CAN_AVD_DET_SUPER_RES_TARGET_128;
  boolean LRR_CAN_AVD_DET_VALID_LEVEL_128;
  uint8 LRR_CAN_AVD_SCAN_INDEX_2LSB_128;
} SG_LRR_AVD_Detection_128_t;

#  define Rte_TypeDef_SG_LRR_Detection_001_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_01;
  float32 LRR_CAN_DET_AZIMUTH_01;
  Rte_DT_SG_LRR_Detection_001_t_2 LRR_CAN_DET_CONFID_AZIMUTH_01;
  boolean LRR_CAN_DET_CONFID_ELEVATION_01;
  float32 LRR_CAN_DET_ELEVATION_01;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_01;
  boolean LRR_CAN_DET_Near_TARGET_01;
  float32 LRR_CAN_DET_RANGE_01;
  float32 LRR_CAN_DET_RANGE_RATE_01;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_01;
  boolean LRR_CAN_DET_VALID_LEVEL_01;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_01;
} SG_LRR_Detection_001_t;

#  define Rte_TypeDef_SG_LRR_Detection_002_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_02;
  float32 LRR_CAN_DET_AZIMUTH_02;
  Rte_DT_SG_LRR_Detection_002_t_2 LRR_CAN_DET_CONFID_AZIMUTH_02;
  boolean LRR_CAN_DET_CONFID_ELEVATION_02;
  float32 LRR_CAN_DET_ELEVATION_02;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_02;
  boolean LRR_CAN_DET_Near_TARGET_02;
  float32 LRR_CAN_DET_RANGE_02;
  float32 LRR_CAN_DET_RANGE_RATE_02;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_02;
  boolean LRR_CAN_DET_VALID_LEVEL_02;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_02;
} SG_LRR_Detection_002_t;

#  define Rte_TypeDef_SG_LRR_Detection_003_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_03;
  float32 LRR_CAN_DET_AZIMUTH_03;
  Rte_DT_SG_LRR_Detection_003_t_2 LRR_CAN_DET_CONFID_AZIMUTH_03;
  boolean LRR_CAN_DET_CONFID_ELEVATION_03;
  float32 LRR_CAN_DET_ELEVATION_03;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_03;
  boolean LRR_CAN_DET_Near_TARGET_03;
  float32 LRR_CAN_DET_RANGE_03;
  float32 LRR_CAN_DET_RANGE_RATE_03;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_03;
  boolean LRR_CAN_DET_VALID_LEVEL_03;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_03;
} SG_LRR_Detection_003_t;

#  define Rte_TypeDef_SG_LRR_Detection_004_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_04;
  float32 LRR_CAN_DET_AZIMUTH_04;
  Rte_DT_SG_LRR_Detection_004_t_2 LRR_CAN_DET_CONFID_AZIMUTH_04;
  boolean LRR_CAN_DET_CONFID_ELEVATION_04;
  float32 LRR_CAN_DET_ELEVATION_04;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_04;
  boolean LRR_CAN_DET_Near_TARGET_04;
  float32 LRR_CAN_DET_RANGE_04;
  float32 LRR_CAN_DET_RANGE_RATE_04;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_04;
  boolean LRR_CAN_DET_VALID_LEVEL_04;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_04;
} SG_LRR_Detection_004_t;

#  define Rte_TypeDef_SG_LRR_Detection_005_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_05;
  float32 LRR_CAN_DET_AZIMUTH_05;
  Rte_DT_SG_LRR_Detection_005_t_2 LRR_CAN_DET_CONFID_AZIMUTH_05;
  boolean LRR_CAN_DET_CONFID_ELEVATION_05;
  float32 LRR_CAN_DET_ELEVATION_05;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_05;
  boolean LRR_CAN_DET_Near_TARGET_05;
  float32 LRR_CAN_DET_RANGE_05;
  float32 LRR_CAN_DET_RANGE_RATE_05;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_05;
  boolean LRR_CAN_DET_VALID_LEVEL_05;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_05;
} SG_LRR_Detection_005_t;

#  define Rte_TypeDef_SG_LRR_Detection_006_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_06;
  float32 LRR_CAN_DET_AZIMUTH_06;
  Rte_DT_SG_LRR_Detection_006_t_2 LRR_CAN_DET_CONFID_AZIMUTH_06;
  boolean LRR_CAN_DET_CONFID_ELEVATION_06;
  float32 LRR_CAN_DET_ELEVATION_06;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_06;
  boolean LRR_CAN_DET_Near_TARGET_06;
  float32 LRR_CAN_DET_RANGE_06;
  float32 LRR_CAN_DET_RANGE_RATE_06;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_06;
  boolean LRR_CAN_DET_VALID_LEVEL_06;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_06;
} SG_LRR_Detection_006_t;

#  define Rte_TypeDef_SG_LRR_Detection_007_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_07;
  float32 LRR_CAN_DET_AZIMUTH_07;
  Rte_DT_SG_LRR_Detection_007_t_2 LRR_CAN_DET_CONFID_AZIMUTH_07;
  boolean LRR_CAN_DET_CONFID_ELEVATION_07;
  float32 LRR_CAN_DET_ELEVATION_07;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_07;
  boolean LRR_CAN_DET_Near_TARGET_07;
  float32 LRR_CAN_DET_RANGE_07;
  float32 LRR_CAN_DET_RANGE_RATE_07;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_07;
  boolean LRR_CAN_DET_VALID_LEVEL_07;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_07;
} SG_LRR_Detection_007_t;

#  define Rte_TypeDef_SG_LRR_Detection_008_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_08;
  float32 LRR_CAN_DET_AZIMUTH_08;
  Rte_DT_SG_LRR_Detection_008_t_2 LRR_CAN_DET_CONFID_AZIMUTH_08;
  boolean LRR_CAN_DET_CONFID_ELEVATION_08;
  float32 LRR_CAN_DET_ELEVATION_08;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_08;
  boolean LRR_CAN_DET_Near_TARGET_08;
  float32 LRR_CAN_DET_RANGE_08;
  float32 LRR_CAN_DET_RANGE_RATE_08;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_08;
  boolean LRR_CAN_DET_VALID_LEVEL_08;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_08;
} SG_LRR_Detection_008_t;

#  define Rte_TypeDef_SG_LRR_Detection_009_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_09;
  float32 LRR_CAN_DET_AZIMUTH_09;
  Rte_DT_SG_LRR_Detection_009_t_2 LRR_CAN_DET_CONFID_AZIMUTH_09;
  boolean LRR_CAN_DET_CONFID_ELEVATION_09;
  float32 LRR_CAN_DET_ELEVATION_09;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_09;
  boolean LRR_CAN_DET_Near_TARGET_09;
  float32 LRR_CAN_DET_RANGE_09;
  float32 LRR_CAN_DET_RANGE_RATE_09;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_09;
  boolean LRR_CAN_DET_VALID_LEVEL_09;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_09;
} SG_LRR_Detection_009_t;

#  define Rte_TypeDef_SG_LRR_Detection_010_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_10;
  float32 LRR_CAN_DET_AZIMUTH_10;
  Rte_DT_SG_LRR_Detection_010_t_2 LRR_CAN_DET_CONFID_AZIMUTH_10;
  boolean LRR_CAN_DET_CONFID_ELEVATION_10;
  float32 LRR_CAN_DET_ELEVATION_10;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_10;
  boolean LRR_CAN_DET_Near_TARGET_10;
  float32 LRR_CAN_DET_RANGE_10;
  float32 LRR_CAN_DET_RANGE_RATE_10;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_10;
  boolean LRR_CAN_DET_VALID_LEVEL_10;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_10;
} SG_LRR_Detection_010_t;

#  define Rte_TypeDef_SG_LRR_Detection_011_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_11;
  float32 LRR_CAN_DET_AZIMUTH_11;
  Rte_DT_SG_LRR_Detection_011_t_2 LRR_CAN_DET_CONFID_AZIMUTH_11;
  boolean LRR_CAN_DET_CONFID_ELEVATION_11;
  float32 LRR_CAN_DET_ELEVATION_11;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_11;
  boolean LRR_CAN_DET_Near_TARGET_11;
  float32 LRR_CAN_DET_RANGE_11;
  float32 LRR_CAN_DET_RANGE_RATE_11;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_11;
  boolean LRR_CAN_DET_VALID_LEVEL_11;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_11;
} SG_LRR_Detection_011_t;

#  define Rte_TypeDef_SG_LRR_Detection_012_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_12;
  float32 LRR_CAN_DET_AZIMUTH_12;
  Rte_DT_SG_LRR_Detection_012_t_2 LRR_CAN_DET_CONFID_AZIMUTH_12;
  boolean LRR_CAN_DET_CONFID_ELEVATION_12;
  float32 LRR_CAN_DET_ELEVATION_12;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_12;
  boolean LRR_CAN_DET_Near_TARGET_12;
  float32 LRR_CAN_DET_RANGE_12;
  float32 LRR_CAN_DET_RANGE_RATE_12;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_12;
  boolean LRR_CAN_DET_VALID_LEVEL_12;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_12;
} SG_LRR_Detection_012_t;

#  define Rte_TypeDef_SG_LRR_Detection_013_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_13;
  float32 LRR_CAN_DET_AZIMUTH_13;
  Rte_DT_SG_LRR_Detection_013_t_2 LRR_CAN_DET_CONFID_AZIMUTH_13;
  boolean LRR_CAN_DET_CONFID_ELEVATION_13;
  float32 LRR_CAN_DET_ELEVATION_13;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_13;
  boolean LRR_CAN_DET_Near_TARGET_13;
  float32 LRR_CAN_DET_RANGE_13;
  float32 LRR_CAN_DET_RANGE_RATE_13;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_13;
  boolean LRR_CAN_DET_VALID_LEVEL_13;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_13;
} SG_LRR_Detection_013_t;

#  define Rte_TypeDef_SG_LRR_Detection_014_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_14;
  float32 LRR_CAN_DET_AZIMUTH_14;
  Rte_DT_SG_LRR_Detection_014_t_2 LRR_CAN_DET_CONFID_AZIMUTH_14;
  boolean LRR_CAN_DET_CONFID_ELEVATION_14;
  float32 LRR_CAN_DET_ELEVATION_14;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_14;
  boolean LRR_CAN_DET_Near_TARGET_14;
  float32 LRR_CAN_DET_RANGE_14;
  float32 LRR_CAN_DET_RANGE_RATE_14;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_14;
  boolean LRR_CAN_DET_VALID_LEVEL_14;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_14;
} SG_LRR_Detection_014_t;

#  define Rte_TypeDef_SG_LRR_Detection_015_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_15;
  float32 LRR_CAN_DET_AZIMUTH_15;
  Rte_DT_SG_LRR_Detection_015_t_2 LRR_CAN_DET_CONFID_AZIMUTH_15;
  boolean LRR_CAN_DET_CONFID_ELEVATION_15;
  float32 LRR_CAN_DET_ELEVATION_15;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_15;
  boolean LRR_CAN_DET_Near_TARGET_15;
  float32 LRR_CAN_DET_RANGE_15;
  float32 LRR_CAN_DET_RANGE_RATE_15;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_15;
  boolean LRR_CAN_DET_VALID_LEVEL_15;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_15;
} SG_LRR_Detection_015_t;

#  define Rte_TypeDef_SG_LRR_Detection_016_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_16;
  float32 LRR_CAN_DET_AZIMUTH_16;
  Rte_DT_SG_LRR_Detection_016_t_2 LRR_CAN_DET_CONFID_AZIMUTH_16;
  boolean LRR_CAN_DET_CONFID_ELEVATION_16;
  float32 LRR_CAN_DET_ELEVATION_16;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_16;
  boolean LRR_CAN_DET_Near_TARGET_16;
  float32 LRR_CAN_DET_RANGE_16;
  float32 LRR_CAN_DET_RANGE_RATE_16;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_16;
  boolean LRR_CAN_DET_VALID_LEVEL_16;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_16;
} SG_LRR_Detection_016_t;

#  define Rte_TypeDef_SG_LRR_Detection_017_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_17;
  float32 LRR_CAN_DET_AZIMUTH_17;
  Rte_DT_SG_LRR_Detection_017_t_2 LRR_CAN_DET_CONFID_AZIMUTH_17;
  boolean LRR_CAN_DET_CONFID_ELEVATION_17;
  float32 LRR_CAN_DET_ELEVATION_17;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_17;
  boolean LRR_CAN_DET_Near_TARGET_17;
  float32 LRR_CAN_DET_RANGE_17;
  float32 LRR_CAN_DET_RANGE_RATE_17;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_17;
  boolean LRR_CAN_DET_VALID_LEVEL_17;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_17;
} SG_LRR_Detection_017_t;

#  define Rte_TypeDef_SG_LRR_Detection_018_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_18;
  float32 LRR_CAN_DET_AZIMUTH_18;
  Rte_DT_SG_LRR_Detection_018_t_2 LRR_CAN_DET_CONFID_AZIMUTH_18;
  boolean LRR_CAN_DET_CONFID_ELEVATION_18;
  float32 LRR_CAN_DET_ELEVATION_18;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_18;
  boolean LRR_CAN_DET_Near_TARGET_18;
  float32 LRR_CAN_DET_RANGE_18;
  float32 LRR_CAN_DET_RANGE_RATE_18;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_18;
  boolean LRR_CAN_DET_VALID_LEVEL_18;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_18;
} SG_LRR_Detection_018_t;

#  define Rte_TypeDef_SG_LRR_Detection_019_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_19;
  float32 LRR_CAN_DET_AZIMUTH_19;
  Rte_DT_SG_LRR_Detection_019_t_2 LRR_CAN_DET_CONFID_AZIMUTH_19;
  boolean LRR_CAN_DET_CONFID_ELEVATION_19;
  float32 LRR_CAN_DET_ELEVATION_19;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_19;
  boolean LRR_CAN_DET_Near_TARGET_19;
  float32 LRR_CAN_DET_RANGE_19;
  float32 LRR_CAN_DET_RANGE_RATE_19;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_19;
  boolean LRR_CAN_DET_VALID_LEVEL_19;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_19;
} SG_LRR_Detection_019_t;

#  define Rte_TypeDef_SG_LRR_Detection_020_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_20;
  float32 LRR_CAN_DET_AZIMUTH_20;
  Rte_DT_SG_LRR_Detection_020_t_2 LRR_CAN_DET_CONFID_AZIMUTH_20;
  boolean LRR_CAN_DET_CONFID_ELEVATION_20;
  float32 LRR_CAN_DET_ELEVATION_20;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_20;
  boolean LRR_CAN_DET_Near_TARGET_20;
  float32 LRR_CAN_DET_RANGE_20;
  float32 LRR_CAN_DET_RANGE_RATE_20;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_20;
  boolean LRR_CAN_DET_VALID_LEVEL_20;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_20;
} SG_LRR_Detection_020_t;

#  define Rte_TypeDef_SG_LRR_Detection_021_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_21;
  float32 LRR_CAN_DET_AZIMUTH_21;
  Rte_DT_SG_LRR_Detection_021_t_2 LRR_CAN_DET_CONFID_AZIMUTH_21;
  boolean LRR_CAN_DET_CONFID_ELEVATION_21;
  float32 LRR_CAN_DET_ELEVATION_21;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_21;
  boolean LRR_CAN_DET_Near_TARGET_21;
  float32 LRR_CAN_DET_RANGE_21;
  float32 LRR_CAN_DET_RANGE_RATE_21;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_21;
  boolean LRR_CAN_DET_VALID_LEVEL_21;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_21;
} SG_LRR_Detection_021_t;

#  define Rte_TypeDef_SG_LRR_Detection_022_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_22;
  float32 LRR_CAN_DET_AZIMUTH_22;
  Rte_DT_SG_LRR_Detection_022_t_2 LRR_CAN_DET_CONFID_AZIMUTH_22;
  boolean LRR_CAN_DET_CONFID_ELEVATION_22;
  float32 LRR_CAN_DET_ELEVATION_22;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_22;
  boolean LRR_CAN_DET_Near_TARGET_22;
  float32 LRR_CAN_DET_RANGE_22;
  float32 LRR_CAN_DET_RANGE_RATE_22;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_22;
  boolean LRR_CAN_DET_VALID_LEVEL_22;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_22;
} SG_LRR_Detection_022_t;

#  define Rte_TypeDef_SG_LRR_Detection_023_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_23;
  float32 LRR_CAN_DET_AZIMUTH_23;
  Rte_DT_SG_LRR_Detection_023_t_2 LRR_CAN_DET_CONFID_AZIMUTH_23;
  boolean LRR_CAN_DET_CONFID_ELEVATION_23;
  float32 LRR_CAN_DET_ELEVATION_23;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_23;
  boolean LRR_CAN_DET_Near_TARGET_23;
  float32 LRR_CAN_DET_RANGE_23;
  float32 LRR_CAN_DET_RANGE_RATE_23;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_23;
  boolean LRR_CAN_DET_VALID_LEVEL_23;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_23;
} SG_LRR_Detection_023_t;

#  define Rte_TypeDef_SG_LRR_Detection_024_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_24;
  float32 LRR_CAN_DET_AZIMUTH_24;
  Rte_DT_SG_LRR_Detection_024_t_2 LRR_CAN_DET_CONFID_AZIMUTH_24;
  boolean LRR_CAN_DET_CONFID_ELEVATION_24;
  float32 LRR_CAN_DET_ELEVATION_24;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_24;
  boolean LRR_CAN_DET_Near_TARGET_24;
  float32 LRR_CAN_DET_RANGE_24;
  float32 LRR_CAN_DET_RANGE_RATE_24;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_24;
  boolean LRR_CAN_DET_VALID_LEVEL_24;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_24;
} SG_LRR_Detection_024_t;

#  define Rte_TypeDef_SG_LRR_Detection_025_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_25;
  float32 LRR_CAN_DET_AZIMUTH_25;
  Rte_DT_SG_LRR_Detection_025_t_2 LRR_CAN_DET_CONFID_AZIMUTH_25;
  boolean LRR_CAN_DET_CONFID_ELEVATION_25;
  float32 LRR_CAN_DET_ELEVATION_25;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_25;
  boolean LRR_CAN_DET_Near_TARGET_25;
  float32 LRR_CAN_DET_RANGE_25;
  float32 LRR_CAN_DET_RANGE_RATE_25;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_25;
  boolean LRR_CAN_DET_VALID_LEVEL_25;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_25;
} SG_LRR_Detection_025_t;

#  define Rte_TypeDef_SG_LRR_Detection_026_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_26;
  float32 LRR_CAN_DET_AZIMUTH_26;
  Rte_DT_SG_LRR_Detection_026_t_2 LRR_CAN_DET_CONFID_AZIMUTH_26;
  boolean LRR_CAN_DET_CONFID_ELEVATION_26;
  float32 LRR_CAN_DET_ELEVATION_26;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_26;
  boolean LRR_CAN_DET_Near_TARGET_26;
  float32 LRR_CAN_DET_RANGE_26;
  float32 LRR_CAN_DET_RANGE_RATE_26;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_26;
  boolean LRR_CAN_DET_VALID_LEVEL_26;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_26;
} SG_LRR_Detection_026_t;

#  define Rte_TypeDef_SG_LRR_Detection_027_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_27;
  float32 LRR_CAN_DET_AZIMUTH_27;
  Rte_DT_SG_LRR_Detection_027_t_2 LRR_CAN_DET_CONFID_AZIMUTH_27;
  boolean LRR_CAN_DET_CONFID_ELEVATION_27;
  float32 LRR_CAN_DET_ELEVATION_27;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_27;
  boolean LRR_CAN_DET_Near_TARGET_27;
  float32 LRR_CAN_DET_RANGE_27;
  float32 LRR_CAN_DET_RANGE_RATE_27;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_27;
  boolean LRR_CAN_DET_VALID_LEVEL_27;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_27;
} SG_LRR_Detection_027_t;

#  define Rte_TypeDef_SG_LRR_Detection_028_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_28;
  float32 LRR_CAN_DET_AZIMUTH_28;
  Rte_DT_SG_LRR_Detection_028_t_2 LRR_CAN_DET_CONFID_AZIMUTH_28;
  boolean LRR_CAN_DET_CONFID_ELEVATION_28;
  float32 LRR_CAN_DET_ELEVATION_28;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_28;
  boolean LRR_CAN_DET_Near_TARGET_28;
  float32 LRR_CAN_DET_RANGE_28;
  float32 LRR_CAN_DET_RANGE_RATE_28;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_28;
  boolean LRR_CAN_DET_VALID_LEVEL_28;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_28;
} SG_LRR_Detection_028_t;

#  define Rte_TypeDef_SG_LRR_Detection_029_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_29;
  float32 LRR_CAN_DET_AZIMUTH_29;
  Rte_DT_SG_LRR_Detection_029_t_2 LRR_CAN_DET_CONFID_AZIMUTH_29;
  boolean LRR_CAN_DET_CONFID_ELEVATION_29;
  float32 LRR_CAN_DET_ELEVATION_29;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_29;
  boolean LRR_CAN_DET_Near_TARGET_29;
  float32 LRR_CAN_DET_RANGE_29;
  float32 LRR_CAN_DET_RANGE_RATE_29;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_29;
  boolean LRR_CAN_DET_VALID_LEVEL_29;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_29;
} SG_LRR_Detection_029_t;

#  define Rte_TypeDef_SG_LRR_Detection_030_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_30;
  float32 LRR_CAN_DET_AZIMUTH_30;
  Rte_DT_SG_LRR_Detection_030_t_2 LRR_CAN_DET_CONFID_AZIMUTH_30;
  boolean LRR_CAN_DET_CONFID_ELEVATION_30;
  float32 LRR_CAN_DET_ELEVATION_30;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_30;
  boolean LRR_CAN_DET_Near_TARGET_30;
  float32 LRR_CAN_DET_RANGE_30;
  float32 LRR_CAN_DET_RANGE_RATE_30;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_30;
  boolean LRR_CAN_DET_VALID_LEVEL_30;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_30;
} SG_LRR_Detection_030_t;

#  define Rte_TypeDef_SG_LRR_Detection_031_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_31;
  float32 LRR_CAN_DET_AZIMUTH_31;
  Rte_DT_SG_LRR_Detection_031_t_2 LRR_CAN_DET_CONFID_AZIMUTH_31;
  boolean LRR_CAN_DET_CONFID_ELEVATION_31;
  float32 LRR_CAN_DET_ELEVATION_31;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_31;
  boolean LRR_CAN_DET_Near_TARGET_31;
  float32 LRR_CAN_DET_RANGE_31;
  float32 LRR_CAN_DET_RANGE_RATE_31;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_31;
  boolean LRR_CAN_DET_VALID_LEVEL_31;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_31;
} SG_LRR_Detection_031_t;

#  define Rte_TypeDef_SG_LRR_Detection_032_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_32;
  float32 LRR_CAN_DET_AZIMUTH_32;
  Rte_DT_SG_LRR_Detection_032_t_2 LRR_CAN_DET_CONFID_AZIMUTH_32;
  boolean LRR_CAN_DET_CONFID_ELEVATION_32;
  float32 LRR_CAN_DET_ELEVATION_32;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_32;
  boolean LRR_CAN_DET_Near_TARGET_32;
  float32 LRR_CAN_DET_RANGE_32;
  float32 LRR_CAN_DET_RANGE_RATE_32;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_32;
  boolean LRR_CAN_DET_VALID_LEVEL_32;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_32;
} SG_LRR_Detection_032_t;

#  define Rte_TypeDef_SG_LRR_Detection_033_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_33;
  float32 LRR_CAN_DET_AZIMUTH_33;
  Rte_DT_SG_LRR_Detection_033_t_2 LRR_CAN_DET_CONFID_AZIMUTH_33;
  boolean LRR_CAN_DET_CONFID_ELEVATION_33;
  float32 LRR_CAN_DET_ELEVATION_33;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_33;
  boolean LRR_CAN_DET_Near_TARGET_33;
  float32 LRR_CAN_DET_RANGE_33;
  float32 LRR_CAN_DET_RANGE_RATE_33;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_33;
  boolean LRR_CAN_DET_VALID_LEVEL_33;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_33;
} SG_LRR_Detection_033_t;

#  define Rte_TypeDef_SG_LRR_Detection_034_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_34;
  float32 LRR_CAN_DET_AZIMUTH_34;
  Rte_DT_SG_LRR_Detection_034_t_2 LRR_CAN_DET_CONFID_AZIMUTH_34;
  boolean LRR_CAN_DET_CONFID_ELEVATION_34;
  float32 LRR_CAN_DET_ELEVATION_34;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_34;
  boolean LRR_CAN_DET_Near_TARGET_34;
  float32 LRR_CAN_DET_RANGE_34;
  float32 LRR_CAN_DET_RANGE_RATE_34;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_34;
  boolean LRR_CAN_DET_VALID_LEVEL_34;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_34;
} SG_LRR_Detection_034_t;

#  define Rte_TypeDef_SG_LRR_Detection_035_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_35;
  float32 LRR_CAN_DET_AZIMUTH_35;
  Rte_DT_SG_LRR_Detection_035_t_2 LRR_CAN_DET_CONFID_AZIMUTH_35;
  boolean LRR_CAN_DET_CONFID_ELEVATION_35;
  float32 LRR_CAN_DET_ELEVATION_35;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_35;
  boolean LRR_CAN_DET_Near_TARGET_35;
  float32 LRR_CAN_DET_RANGE_35;
  float32 LRR_CAN_DET_RANGE_RATE_35;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_35;
  boolean LRR_CAN_DET_VALID_LEVEL_35;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_35;
} SG_LRR_Detection_035_t;

#  define Rte_TypeDef_SG_LRR_Detection_036_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_36;
  float32 LRR_CAN_DET_AZIMUTH_36;
  Rte_DT_SG_LRR_Detection_036_t_2 LRR_CAN_DET_CONFID_AZIMUTH_36;
  boolean LRR_CAN_DET_CONFID_ELEVATION_36;
  float32 LRR_CAN_DET_ELEVATION_36;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_36;
  boolean LRR_CAN_DET_Near_TARGET_36;
  float32 LRR_CAN_DET_RANGE_36;
  float32 LRR_CAN_DET_RANGE_RATE_36;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_36;
  boolean LRR_CAN_DET_VALID_LEVEL_36;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_36;
} SG_LRR_Detection_036_t;

#  define Rte_TypeDef_SG_LRR_Detection_037_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_37;
  float32 LRR_CAN_DET_AZIMUTH_37;
  Rte_DT_SG_LRR_Detection_037_t_2 LRR_CAN_DET_CONFID_AZIMUTH_37;
  boolean LRR_CAN_DET_CONFID_ELEVATION_37;
  float32 LRR_CAN_DET_ELEVATION_37;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_37;
  boolean LRR_CAN_DET_Near_TARGET_37;
  float32 LRR_CAN_DET_RANGE_37;
  float32 LRR_CAN_DET_RANGE_RATE_37;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_37;
  boolean LRR_CAN_DET_VALID_LEVEL_37;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_37;
} SG_LRR_Detection_037_t;

#  define Rte_TypeDef_SG_LRR_Detection_038_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_38;
  float32 LRR_CAN_DET_AZIMUTH_38;
  Rte_DT_SG_LRR_Detection_038_t_2 LRR_CAN_DET_CONFID_AZIMUTH_38;
  boolean LRR_CAN_DET_CONFID_ELEVATION_38;
  float32 LRR_CAN_DET_ELEVATION_38;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_38;
  boolean LRR_CAN_DET_Near_TARGET_38;
  float32 LRR_CAN_DET_RANGE_38;
  float32 LRR_CAN_DET_RANGE_RATE_38;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_38;
  boolean LRR_CAN_DET_VALID_LEVEL_38;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_38;
} SG_LRR_Detection_038_t;

#  define Rte_TypeDef_SG_LRR_Detection_039_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_39;
  float32 LRR_CAN_DET_AZIMUTH_39;
  Rte_DT_SG_LRR_Detection_039_t_2 LRR_CAN_DET_CONFID_AZIMUTH_39;
  boolean LRR_CAN_DET_CONFID_ELEVATION_39;
  float32 LRR_CAN_DET_ELEVATION_39;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_39;
  boolean LRR_CAN_DET_Near_TARGET_39;
  float32 LRR_CAN_DET_RANGE_39;
  float32 LRR_CAN_DET_RANGE_RATE_39;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_39;
  boolean LRR_CAN_DET_VALID_LEVEL_39;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_39;
} SG_LRR_Detection_039_t;

#  define Rte_TypeDef_SG_LRR_Detection_040_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_40;
  float32 LRR_CAN_DET_AZIMUTH_40;
  Rte_DT_SG_LRR_Detection_040_t_2 LRR_CAN_DET_CONFID_AZIMUTH_40;
  boolean LRR_CAN_DET_CONFID_ELEVATION_40;
  float32 LRR_CAN_DET_ELEVATION_40;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_40;
  boolean LRR_CAN_DET_Near_TARGET_40;
  float32 LRR_CAN_DET_RANGE_40;
  float32 LRR_CAN_DET_RANGE_RATE_40;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_40;
  boolean LRR_CAN_DET_VALID_LEVEL_40;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_40;
} SG_LRR_Detection_040_t;

#  define Rte_TypeDef_SG_LRR_Detection_041_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_41;
  float32 LRR_CAN_DET_AZIMUTH_41;
  Rte_DT_SG_LRR_Detection_041_t_2 LRR_CAN_DET_CONFID_AZIMUTH_41;
  boolean LRR_CAN_DET_CONFID_ELEVATION_41;
  float32 LRR_CAN_DET_ELEVATION_41;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_41;
  boolean LRR_CAN_DET_Near_TARGET_41;
  float32 LRR_CAN_DET_RANGE_41;
  float32 LRR_CAN_DET_RANGE_RATE_41;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_41;
  boolean LRR_CAN_DET_VALID_LEVEL_41;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_41;
} SG_LRR_Detection_041_t;

#  define Rte_TypeDef_SG_LRR_Detection_042_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_42;
  float32 LRR_CAN_DET_AZIMUTH_42;
  Rte_DT_SG_LRR_Detection_042_t_2 LRR_CAN_DET_CONFID_AZIMUTH_42;
  boolean LRR_CAN_DET_CONFID_ELEVATION_42;
  float32 LRR_CAN_DET_ELEVATION_42;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_42;
  boolean LRR_CAN_DET_Near_TARGET_42;
  float32 LRR_CAN_DET_RANGE_42;
  float32 LRR_CAN_DET_RANGE_RATE_42;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_42;
  boolean LRR_CAN_DET_VALID_LEVEL_42;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_42;
} SG_LRR_Detection_042_t;

#  define Rte_TypeDef_SG_LRR_Detection_043_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_43;
  float32 LRR_CAN_DET_AZIMUTH_43;
  Rte_DT_SG_LRR_Detection_043_t_2 LRR_CAN_DET_CONFID_AZIMUTH_43;
  boolean LRR_CAN_DET_CONFID_ELEVATION_43;
  float32 LRR_CAN_DET_ELEVATION_43;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_43;
  boolean LRR_CAN_DET_Near_TARGET_43;
  float32 LRR_CAN_DET_RANGE_43;
  float32 LRR_CAN_DET_RANGE_RATE_43;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_43;
  boolean LRR_CAN_DET_VALID_LEVEL_43;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_43;
} SG_LRR_Detection_043_t;

#  define Rte_TypeDef_SG_LRR_Detection_044_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_44;
  float32 LRR_CAN_DET_AZIMUTH_44;
  Rte_DT_SG_LRR_Detection_044_t_2 LRR_CAN_DET_CONFID_AZIMUTH_44;
  boolean LRR_CAN_DET_CONFID_ELEVATION_44;
  float32 LRR_CAN_DET_ELEVATION_44;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_44;
  boolean LRR_CAN_DET_Near_TARGET_44;
  float32 LRR_CAN_DET_RANGE_44;
  float32 LRR_CAN_DET_RANGE_RATE_44;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_44;
  boolean LRR_CAN_DET_VALID_LEVEL_44;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_44;
} SG_LRR_Detection_044_t;

#  define Rte_TypeDef_SG_LRR_Detection_045_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_45;
  float32 LRR_CAN_DET_AZIMUTH_45;
  Rte_DT_SG_LRR_Detection_045_t_2 LRR_CAN_DET_CONFID_AZIMUTH_45;
  boolean LRR_CAN_DET_CONFID_ELEVATION_45;
  float32 LRR_CAN_DET_ELEVATION_45;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_45;
  boolean LRR_CAN_DET_Near_TARGET_45;
  float32 LRR_CAN_DET_RANGE_45;
  float32 LRR_CAN_DET_RANGE_RATE_45;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_45;
  boolean LRR_CAN_DET_VALID_LEVEL_45;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_45;
} SG_LRR_Detection_045_t;

#  define Rte_TypeDef_SG_LRR_Detection_046_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_46;
  float32 LRR_CAN_DET_AZIMUTH_46;
  Rte_DT_SG_LRR_Detection_046_t_2 LRR_CAN_DET_CONFID_AZIMUTH_46;
  boolean LRR_CAN_DET_CONFID_ELEVATION_46;
  float32 LRR_CAN_DET_ELEVATION_46;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_46;
  boolean LRR_CAN_DET_Near_TARGET_46;
  float32 LRR_CAN_DET_RANGE_46;
  float32 LRR_CAN_DET_RANGE_RATE_46;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_46;
  boolean LRR_CAN_DET_VALID_LEVEL_46;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_46;
} SG_LRR_Detection_046_t;

#  define Rte_TypeDef_SG_LRR_Detection_047_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_47;
  float32 LRR_CAN_DET_AZIMUTH_47;
  Rte_DT_SG_LRR_Detection_047_t_2 LRR_CAN_DET_CONFID_AZIMUTH_47;
  boolean LRR_CAN_DET_CONFID_ELEVATION_47;
  float32 LRR_CAN_DET_ELEVATION_47;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_47;
  boolean LRR_CAN_DET_Near_TARGET_47;
  float32 LRR_CAN_DET_RANGE_47;
  float32 LRR_CAN_DET_RANGE_RATE_47;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_47;
  boolean LRR_CAN_DET_VALID_LEVEL_47;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_47;
} SG_LRR_Detection_047_t;

#  define Rte_TypeDef_SG_LRR_Detection_048_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_48;
  float32 LRR_CAN_DET_AZIMUTH_48;
  Rte_DT_SG_LRR_Detection_048_t_2 LRR_CAN_DET_CONFID_AZIMUTH_48;
  boolean LRR_CAN_DET_CONFID_ELEVATION_48;
  float32 LRR_CAN_DET_ELEVATION_48;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_48;
  boolean LRR_CAN_DET_Near_TARGET_48;
  float32 LRR_CAN_DET_RANGE_48;
  float32 LRR_CAN_DET_RANGE_RATE_48;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_48;
  boolean LRR_CAN_DET_VALID_LEVEL_48;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_48;
} SG_LRR_Detection_048_t;

#  define Rte_TypeDef_SG_LRR_Detection_049_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_49;
  float32 LRR_CAN_DET_AZIMUTH_49;
  Rte_DT_SG_LRR_Detection_049_t_2 LRR_CAN_DET_CONFID_AZIMUTH_49;
  boolean LRR_CAN_DET_CONFID_ELEVATION_49;
  float32 LRR_CAN_DET_ELEVATION_49;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_49;
  boolean LRR_CAN_DET_Near_TARGET_49;
  float32 LRR_CAN_DET_RANGE_49;
  float32 LRR_CAN_DET_RANGE_RATE_49;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_49;
  boolean LRR_CAN_DET_VALID_LEVEL_49;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_49;
} SG_LRR_Detection_049_t;

#  define Rte_TypeDef_SG_LRR_Detection_050_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_50;
  float32 LRR_CAN_DET_AZIMUTH_50;
  Rte_DT_SG_LRR_Detection_050_t_2 LRR_CAN_DET_CONFID_AZIMUTH_50;
  boolean LRR_CAN_DET_CONFID_ELEVATION_50;
  float32 LRR_CAN_DET_ELEVATION_50;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_50;
  boolean LRR_CAN_DET_Near_TARGET_50;
  float32 LRR_CAN_DET_RANGE_50;
  float32 LRR_CAN_DET_RANGE_RATE_50;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_50;
  boolean LRR_CAN_DET_VALID_LEVEL_50;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_50;
} SG_LRR_Detection_050_t;

#  define Rte_TypeDef_SG_LRR_Detection_051_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_51;
  float32 LRR_CAN_DET_AZIMUTH_51;
  Rte_DT_SG_LRR_Detection_051_t_2 LRR_CAN_DET_CONFID_AZIMUTH_51;
  boolean LRR_CAN_DET_CONFID_ELEVATION_51;
  float32 LRR_CAN_DET_ELEVATION_51;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_51;
  boolean LRR_CAN_DET_Near_TARGET_51;
  float32 LRR_CAN_DET_RANGE_51;
  float32 LRR_CAN_DET_RANGE_RATE_51;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_51;
  boolean LRR_CAN_DET_VALID_LEVEL_51;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_51;
} SG_LRR_Detection_051_t;

#  define Rte_TypeDef_SG_LRR_Detection_052_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_52;
  float32 LRR_CAN_DET_AZIMUTH_52;
  Rte_DT_SG_LRR_Detection_052_t_2 LRR_CAN_DET_CONFID_AZIMUTH_52;
  boolean LRR_CAN_DET_CONFID_ELEVATION_52;
  float32 LRR_CAN_DET_ELEVATION_52;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_52;
  boolean LRR_CAN_DET_Near_TARGET_52;
  float32 LRR_CAN_DET_RANGE_52;
  float32 LRR_CAN_DET_RANGE_RATE_52;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_52;
  boolean LRR_CAN_DET_VALID_LEVEL_52;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_52;
} SG_LRR_Detection_052_t;

#  define Rte_TypeDef_SG_LRR_Detection_053_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_53;
  float32 LRR_CAN_DET_AZIMUTH_53;
  Rte_DT_SG_LRR_Detection_053_t_2 LRR_CAN_DET_CONFID_AZIMUTH_53;
  boolean LRR_CAN_DET_CONFID_ELEVATION_53;
  float32 LRR_CAN_DET_ELEVATION_53;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_53;
  boolean LRR_CAN_DET_Near_TARGET_53;
  float32 LRR_CAN_DET_RANGE_53;
  float32 LRR_CAN_DET_RANGE_RATE_53;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_53;
  boolean LRR_CAN_DET_VALID_LEVEL_53;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_53;
} SG_LRR_Detection_053_t;

#  define Rte_TypeDef_SG_LRR_Detection_054_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_54;
  float32 LRR_CAN_DET_AZIMUTH_54;
  Rte_DT_SG_LRR_Detection_054_t_2 LRR_CAN_DET_CONFID_AZIMUTH_54;
  boolean LRR_CAN_DET_CONFID_ELEVATION_54;
  float32 LRR_CAN_DET_ELEVATION_54;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_54;
  boolean LRR_CAN_DET_Near_TARGET_54;
  float32 LRR_CAN_DET_RANGE_54;
  float32 LRR_CAN_DET_RANGE_RATE_54;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_54;
  boolean LRR_CAN_DET_VALID_LEVEL_54;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_54;
} SG_LRR_Detection_054_t;

#  define Rte_TypeDef_SG_LRR_Detection_055_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_55;
  float32 LRR_CAN_DET_AZIMUTH_55;
  Rte_DT_SG_LRR_Detection_055_t_2 LRR_CAN_DET_CONFID_AZIMUTH_55;
  boolean LRR_CAN_DET_CONFID_ELEVATION_55;
  float32 LRR_CAN_DET_ELEVATION_55;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_55;
  boolean LRR_CAN_DET_Near_TARGET_55;
  float32 LRR_CAN_DET_RANGE_55;
  float32 LRR_CAN_DET_RANGE_RATE_55;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_55;
  boolean LRR_CAN_DET_VALID_LEVEL_55;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_55;
} SG_LRR_Detection_055_t;

#  define Rte_TypeDef_SG_LRR_Detection_056_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_56;
  float32 LRR_CAN_DET_AZIMUTH_56;
  Rte_DT_SG_LRR_Detection_056_t_2 LRR_CAN_DET_CONFID_AZIMUTH_56;
  boolean LRR_CAN_DET_CONFID_ELEVATION_56;
  float32 LRR_CAN_DET_ELEVATION_56;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_56;
  boolean LRR_CAN_DET_Near_TARGET_56;
  float32 LRR_CAN_DET_RANGE_56;
  float32 LRR_CAN_DET_RANGE_RATE_56;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_56;
  boolean LRR_CAN_DET_VALID_LEVEL_56;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_56;
} SG_LRR_Detection_056_t;

#  define Rte_TypeDef_SG_LRR_Detection_057_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_57;
  float32 LRR_CAN_DET_AZIMUTH_57;
  Rte_DT_SG_LRR_Detection_057_t_2 LRR_CAN_DET_CONFID_AZIMUTH_57;
  boolean LRR_CAN_DET_CONFID_ELEVATION_57;
  float32 LRR_CAN_DET_ELEVATION_57;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_57;
  boolean LRR_CAN_DET_Near_TARGET_57;
  float32 LRR_CAN_DET_RANGE_57;
  float32 LRR_CAN_DET_RANGE_RATE_57;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_57;
  boolean LRR_CAN_DET_VALID_LEVEL_57;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_57;
} SG_LRR_Detection_057_t;

#  define Rte_TypeDef_SG_LRR_Detection_058_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_58;
  float32 LRR_CAN_DET_AZIMUTH_58;
  Rte_DT_SG_LRR_Detection_058_t_2 LRR_CAN_DET_CONFID_AZIMUTH_58;
  boolean LRR_CAN_DET_CONFID_ELEVATION_58;
  float32 LRR_CAN_DET_ELEVATION_58;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_58;
  boolean LRR_CAN_DET_Near_TARGET_58;
  float32 LRR_CAN_DET_RANGE_58;
  float32 LRR_CAN_DET_RANGE_RATE_58;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_58;
  boolean LRR_CAN_DET_VALID_LEVEL_58;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_58;
} SG_LRR_Detection_058_t;

#  define Rte_TypeDef_SG_LRR_Detection_059_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_59;
  float32 LRR_CAN_DET_AZIMUTH_59;
  Rte_DT_SG_LRR_Detection_059_t_2 LRR_CAN_DET_CONFID_AZIMUTH_59;
  boolean LRR_CAN_DET_CONFID_ELEVATION_59;
  float32 LRR_CAN_DET_ELEVATION_59;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_59;
  boolean LRR_CAN_DET_Near_TARGET_59;
  float32 LRR_CAN_DET_RANGE_59;
  float32 LRR_CAN_DET_RANGE_RATE_59;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_59;
  boolean LRR_CAN_DET_VALID_LEVEL_59;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_59;
} SG_LRR_Detection_059_t;

#  define Rte_TypeDef_SG_LRR_Detection_060_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_60;
  float32 LRR_CAN_DET_AZIMUTH_60;
  Rte_DT_SG_LRR_Detection_060_t_2 LRR_CAN_DET_CONFID_AZIMUTH_60;
  boolean LRR_CAN_DET_CONFID_ELEVATION_60;
  float32 LRR_CAN_DET_ELEVATION_60;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_60;
  boolean LRR_CAN_DET_Near_TARGET_60;
  float32 LRR_CAN_DET_RANGE_60;
  float32 LRR_CAN_DET_RANGE_RATE_60;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_60;
  boolean LRR_CAN_DET_VALID_LEVEL_60;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_60;
} SG_LRR_Detection_060_t;

#  define Rte_TypeDef_SG_LRR_Detection_061_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_61;
  float32 LRR_CAN_DET_AZIMUTH_61;
  Rte_DT_SG_LRR_Detection_061_t_2 LRR_CAN_DET_CONFID_AZIMUTH_61;
  boolean LRR_CAN_DET_CONFID_ELEVATION_61;
  float32 LRR_CAN_DET_ELEVATION_61;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_61;
  boolean LRR_CAN_DET_Near_TARGET_61;
  float32 LRR_CAN_DET_RANGE_61;
  float32 LRR_CAN_DET_RANGE_RATE_61;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_61;
  boolean LRR_CAN_DET_VALID_LEVEL_61;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_61;
} SG_LRR_Detection_061_t;

#  define Rte_TypeDef_SG_LRR_Detection_062_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_62;
  float32 LRR_CAN_DET_AZIMUTH_62;
  Rte_DT_SG_LRR_Detection_062_t_2 LRR_CAN_DET_CONFID_AZIMUTH_62;
  boolean LRR_CAN_DET_CONFID_ELEVATION_62;
  float32 LRR_CAN_DET_ELEVATION_62;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_62;
  boolean LRR_CAN_DET_Near_TARGET_62;
  float32 LRR_CAN_DET_RANGE_62;
  float32 LRR_CAN_DET_RANGE_RATE_62;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_62;
  boolean LRR_CAN_DET_VALID_LEVEL_62;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_62;
} SG_LRR_Detection_062_t;

#  define Rte_TypeDef_SG_LRR_Detection_063_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_63;
  float32 LRR_CAN_DET_AZIMUTH_63;
  Rte_DT_SG_LRR_Detection_063_t_2 LRR_CAN_DET_CONFID_AZIMUTH_63;
  boolean LRR_CAN_DET_CONFID_ELEVATION_63;
  float32 LRR_CAN_DET_ELEVATION_63;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_63;
  boolean LRR_CAN_DET_Near_TARGET_63;
  float32 LRR_CAN_DET_RANGE_63;
  float32 LRR_CAN_DET_RANGE_RATE_63;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_63;
  boolean LRR_CAN_DET_VALID_LEVEL_63;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_63;
} SG_LRR_Detection_063_t;

#  define Rte_TypeDef_SG_LRR_Detection_064_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_64;
  float32 LRR_CAN_DET_AZIMUTH_64;
  Rte_DT_SG_LRR_Detection_064_t_2 LRR_CAN_DET_CONFID_AZIMUTH_64;
  boolean LRR_CAN_DET_CONFID_ELEVATION_64;
  float32 LRR_CAN_DET_ELEVATION_64;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_64;
  boolean LRR_CAN_DET_Near_TARGET_64;
  float32 LRR_CAN_DET_RANGE_64;
  float32 LRR_CAN_DET_RANGE_RATE_64;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_64;
  boolean LRR_CAN_DET_VALID_LEVEL_64;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_64;
} SG_LRR_Detection_064_t;

#  define Rte_TypeDef_SG_LRR_Detection_065_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_65;
  float32 LRR_CAN_DET_AZIMUTH_65;
  Rte_DT_SG_LRR_Detection_065_t_2 LRR_CAN_DET_CONFID_AZIMUTH_65;
  boolean LRR_CAN_DET_CONFID_ELEVATION_65;
  float32 LRR_CAN_DET_ELEVATION_65;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_65;
  boolean LRR_CAN_DET_Near_TARGET_65;
  float32 LRR_CAN_DET_RANGE_65;
  float32 LRR_CAN_DET_RANGE_RATE_65;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_65;
  boolean LRR_CAN_DET_VALID_LEVEL_65;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_65;
} SG_LRR_Detection_065_t;

#  define Rte_TypeDef_SG_LRR_Detection_066_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_66;
  float32 LRR_CAN_DET_AZIMUTH_66;
  Rte_DT_SG_LRR_Detection_066_t_2 LRR_CAN_DET_CONFID_AZIMUTH_66;
  boolean LRR_CAN_DET_CONFID_ELEVATION_66;
  float32 LRR_CAN_DET_ELEVATION_66;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_66;
  boolean LRR_CAN_DET_Near_TARGET_66;
  float32 LRR_CAN_DET_RANGE_66;
  float32 LRR_CAN_DET_RANGE_RATE_66;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_66;
  boolean LRR_CAN_DET_VALID_LEVEL_66;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_66;
} SG_LRR_Detection_066_t;

#  define Rte_TypeDef_SG_LRR_Detection_067_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_67;
  float32 LRR_CAN_DET_AZIMUTH_67;
  Rte_DT_SG_LRR_Detection_067_t_2 LRR_CAN_DET_CONFID_AZIMUTH_67;
  boolean LRR_CAN_DET_CONFID_ELEVATION_67;
  float32 LRR_CAN_DET_ELEVATION_67;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_67;
  boolean LRR_CAN_DET_Near_TARGET_67;
  float32 LRR_CAN_DET_RANGE_67;
  float32 LRR_CAN_DET_RANGE_RATE_67;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_67;
  boolean LRR_CAN_DET_VALID_LEVEL_67;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_67;
} SG_LRR_Detection_067_t;

#  define Rte_TypeDef_SG_LRR_Detection_068_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_68;
  float32 LRR_CAN_DET_AZIMUTH_68;
  Rte_DT_SG_LRR_Detection_068_t_2 LRR_CAN_DET_CONFID_AZIMUTH_68;
  boolean LRR_CAN_DET_CONFID_ELEVATION_68;
  float32 LRR_CAN_DET_ELEVATION_68;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_68;
  boolean LRR_CAN_DET_Near_TARGET_68;
  float32 LRR_CAN_DET_RANGE_68;
  float32 LRR_CAN_DET_RANGE_RATE_68;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_68;
  boolean LRR_CAN_DET_VALID_LEVEL_68;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_68;
} SG_LRR_Detection_068_t;

#  define Rte_TypeDef_SG_LRR_Detection_069_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_69;
  float32 LRR_CAN_DET_AZIMUTH_69;
  Rte_DT_SG_LRR_Detection_069_t_2 LRR_CAN_DET_CONFID_AZIMUTH_69;
  boolean LRR_CAN_DET_CONFID_ELEVATION_69;
  float32 LRR_CAN_DET_ELEVATION_69;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_69;
  boolean LRR_CAN_DET_Near_TARGET_69;
  float32 LRR_CAN_DET_RANGE_69;
  float32 LRR_CAN_DET_RANGE_RATE_69;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_69;
  boolean LRR_CAN_DET_VALID_LEVEL_69;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_69;
} SG_LRR_Detection_069_t;

#  define Rte_TypeDef_SG_LRR_Detection_070_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_70;
  float32 LRR_CAN_DET_AZIMUTH_70;
  Rte_DT_SG_LRR_Detection_070_t_2 LRR_CAN_DET_CONFID_AZIMUTH_70;
  boolean LRR_CAN_DET_CONFID_ELEVATION_70;
  float32 LRR_CAN_DET_ELEVATION_70;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_70;
  boolean LRR_CAN_DET_Near_TARGET_70;
  float32 LRR_CAN_DET_RANGE_70;
  float32 LRR_CAN_DET_RANGE_RATE_70;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_70;
  boolean LRR_CAN_DET_VALID_LEVEL_70;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_70;
} SG_LRR_Detection_070_t;

#  define Rte_TypeDef_SG_LRR_Detection_071_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_71;
  float32 LRR_CAN_DET_AZIMUTH_71;
  Rte_DT_SG_LRR_Detection_071_t_2 LRR_CAN_DET_CONFID_AZIMUTH_71;
  boolean LRR_CAN_DET_CONFID_ELEVATION_71;
  float32 LRR_CAN_DET_ELEVATION_71;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_71;
  boolean LRR_CAN_DET_Near_TARGET_71;
  float32 LRR_CAN_DET_RANGE_71;
  float32 LRR_CAN_DET_RANGE_RATE_71;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_71;
  boolean LRR_CAN_DET_VALID_LEVEL_71;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_71;
} SG_LRR_Detection_071_t;

#  define Rte_TypeDef_SG_LRR_Detection_072_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_72;
  float32 LRR_CAN_DET_AZIMUTH_72;
  Rte_DT_SG_LRR_Detection_072_t_2 LRR_CAN_DET_CONFID_AZIMUTH_72;
  boolean LRR_CAN_DET_CONFID_ELEVATION_72;
  float32 LRR_CAN_DET_ELEVATION_72;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_72;
  boolean LRR_CAN_DET_Near_TARGET_72;
  float32 LRR_CAN_DET_RANGE_72;
  float32 LRR_CAN_DET_RANGE_RATE_72;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_72;
  boolean LRR_CAN_DET_VALID_LEVEL_72;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_72;
} SG_LRR_Detection_072_t;

#  define Rte_TypeDef_SG_LRR_Detection_073_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_73;
  float32 LRR_CAN_DET_AZIMUTH_73;
  Rte_DT_SG_LRR_Detection_073_t_2 LRR_CAN_DET_CONFID_AZIMUTH_73;
  boolean LRR_CAN_DET_CONFID_ELEVATION_73;
  float32 LRR_CAN_DET_ELEVATION_73;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_73;
  boolean LRR_CAN_DET_Near_TARGET_73;
  float32 LRR_CAN_DET_RANGE_73;
  float32 LRR_CAN_DET_RANGE_RATE_73;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_73;
  boolean LRR_CAN_DET_VALID_LEVEL_73;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_73;
} SG_LRR_Detection_073_t;

#  define Rte_TypeDef_SG_LRR_Detection_074_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_74;
  float32 LRR_CAN_DET_AZIMUTH_74;
  Rte_DT_SG_LRR_Detection_074_t_2 LRR_CAN_DET_CONFID_AZIMUTH_74;
  boolean LRR_CAN_DET_CONFID_ELEVATION_74;
  float32 LRR_CAN_DET_ELEVATION_74;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_74;
  boolean LRR_CAN_DET_Near_TARGET_74;
  float32 LRR_CAN_DET_RANGE_74;
  float32 LRR_CAN_DET_RANGE_RATE_74;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_74;
  boolean LRR_CAN_DET_VALID_LEVEL_74;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_74;
} SG_LRR_Detection_074_t;

#  define Rte_TypeDef_SG_LRR_Detection_075_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_75;
  float32 LRR_CAN_DET_AZIMUTH_75;
  Rte_DT_SG_LRR_Detection_075_t_2 LRR_CAN_DET_CONFID_AZIMUTH_75;
  boolean LRR_CAN_DET_CONFID_ELEVATION_75;
  float32 LRR_CAN_DET_ELEVATION_75;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_75;
  boolean LRR_CAN_DET_Near_TARGET_75;
  float32 LRR_CAN_DET_RANGE_75;
  float32 LRR_CAN_DET_RANGE_RATE_75;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_75;
  boolean LRR_CAN_DET_VALID_LEVEL_75;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_75;
} SG_LRR_Detection_075_t;

#  define Rte_TypeDef_SG_LRR_Detection_076_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_76;
  float32 LRR_CAN_DET_AZIMUTH_76;
  Rte_DT_SG_LRR_Detection_076_t_2 LRR_CAN_DET_CONFID_AZIMUTH_76;
  boolean LRR_CAN_DET_CONFID_ELEVATION_76;
  float32 LRR_CAN_DET_ELEVATION_76;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_76;
  boolean LRR_CAN_DET_Near_TARGET_76;
  float32 LRR_CAN_DET_RANGE_76;
  float32 LRR_CAN_DET_RANGE_RATE_76;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_76;
  boolean LRR_CAN_DET_VALID_LEVEL_76;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_76;
} SG_LRR_Detection_076_t;

#  define Rte_TypeDef_SG_LRR_Detection_077_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_77;
  float32 LRR_CAN_DET_AZIMUTH_77;
  Rte_DT_SG_LRR_Detection_077_t_2 LRR_CAN_DET_CONFID_AZIMUTH_77;
  boolean LRR_CAN_DET_CONFID_ELEVATION_77;
  float32 LRR_CAN_DET_ELEVATION_77;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_77;
  boolean LRR_CAN_DET_Near_TARGET_77;
  float32 LRR_CAN_DET_RANGE_77;
  float32 LRR_CAN_DET_RANGE_RATE_77;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_77;
  boolean LRR_CAN_DET_VALID_LEVEL_77;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_77;
} SG_LRR_Detection_077_t;

#  define Rte_TypeDef_SG_LRR_Detection_078_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_78;
  float32 LRR_CAN_DET_AZIMUTH_78;
  Rte_DT_SG_LRR_Detection_078_t_2 LRR_CAN_DET_CONFID_AZIMUTH_78;
  boolean LRR_CAN_DET_CONFID_ELEVATION_78;
  float32 LRR_CAN_DET_ELEVATION_78;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_78;
  boolean LRR_CAN_DET_Near_TARGET_78;
  float32 LRR_CAN_DET_RANGE_78;
  float32 LRR_CAN_DET_RANGE_RATE_78;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_78;
  boolean LRR_CAN_DET_VALID_LEVEL_78;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_78;
} SG_LRR_Detection_078_t;

#  define Rte_TypeDef_SG_LRR_Detection_079_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_79;
  float32 LRR_CAN_DET_AZIMUTH_79;
  Rte_DT_SG_LRR_Detection_079_t_2 LRR_CAN_DET_CONFID_AZIMUTH_79;
  boolean LRR_CAN_DET_CONFID_ELEVATION_79;
  float32 LRR_CAN_DET_ELEVATION_79;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_79;
  boolean LRR_CAN_DET_Near_TARGET_79;
  float32 LRR_CAN_DET_RANGE_79;
  float32 LRR_CAN_DET_RANGE_RATE_79;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_79;
  boolean LRR_CAN_DET_VALID_LEVEL_79;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_79;
} SG_LRR_Detection_079_t;

#  define Rte_TypeDef_SG_LRR_Detection_080_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_80;
  float32 LRR_CAN_DET_AZIMUTH_80;
  Rte_DT_SG_LRR_Detection_080_t_2 LRR_CAN_DET_CONFID_AZIMUTH_80;
  boolean LRR_CAN_DET_CONFID_ELEVATION_80;
  float32 LRR_CAN_DET_ELEVATION_80;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_80;
  boolean LRR_CAN_DET_Near_TARGET_80;
  float32 LRR_CAN_DET_RANGE_80;
  float32 LRR_CAN_DET_RANGE_RATE_80;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_80;
  boolean LRR_CAN_DET_VALID_LEVEL_80;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_80;
} SG_LRR_Detection_080_t;

#  define Rte_TypeDef_SG_LRR_Detection_081_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_81;
  float32 LRR_CAN_DET_AZIMUTH_81;
  Rte_DT_SG_LRR_Detection_081_t_2 LRR_CAN_DET_CONFID_AZIMUTH_81;
  boolean LRR_CAN_DET_CONFID_ELEVATION_81;
  float32 LRR_CAN_DET_ELEVATION_81;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_81;
  boolean LRR_CAN_DET_Near_TARGET_81;
  float32 LRR_CAN_DET_RANGE_81;
  float32 LRR_CAN_DET_RANGE_RATE_81;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_81;
  boolean LRR_CAN_DET_VALID_LEVEL_81;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_81;
} SG_LRR_Detection_081_t;

#  define Rte_TypeDef_SG_LRR_Detection_082_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_82;
  float32 LRR_CAN_DET_AZIMUTH_82;
  Rte_DT_SG_LRR_Detection_082_t_2 LRR_CAN_DET_CONFID_AZIMUTH_82;
  boolean LRR_CAN_DET_CONFID_ELEVATION_82;
  float32 LRR_CAN_DET_ELEVATION_82;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_82;
  boolean LRR_CAN_DET_Near_TARGET_82;
  float32 LRR_CAN_DET_RANGE_82;
  float32 LRR_CAN_DET_RANGE_RATE_82;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_82;
  boolean LRR_CAN_DET_VALID_LEVEL_82;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_82;
} SG_LRR_Detection_082_t;

#  define Rte_TypeDef_SG_LRR_Detection_083_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_83;
  float32 LRR_CAN_DET_AZIMUTH_83;
  Rte_DT_SG_LRR_Detection_083_t_2 LRR_CAN_DET_CONFID_AZIMUTH_83;
  boolean LRR_CAN_DET_CONFID_ELEVATION_83;
  float32 LRR_CAN_DET_ELEVATION_83;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_83;
  boolean LRR_CAN_DET_Near_TARGET_83;
  float32 LRR_CAN_DET_RANGE_83;
  float32 LRR_CAN_DET_RANGE_RATE_83;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_83;
  boolean LRR_CAN_DET_VALID_LEVEL_83;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_83;
} SG_LRR_Detection_083_t;

#  define Rte_TypeDef_SG_LRR_Detection_084_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_84;
  float32 LRR_CAN_DET_AZIMUTH_84;
  Rte_DT_SG_LRR_Detection_084_t_2 LRR_CAN_DET_CONFID_AZIMUTH_84;
  boolean LRR_CAN_DET_CONFID_ELEVATION_84;
  float32 LRR_CAN_DET_ELEVATION_84;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_84;
  boolean LRR_CAN_DET_Near_TARGET_84;
  float32 LRR_CAN_DET_RANGE_84;
  float32 LRR_CAN_DET_RANGE_RATE_84;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_84;
  boolean LRR_CAN_DET_VALID_LEVEL_84;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_84;
} SG_LRR_Detection_084_t;

#  define Rte_TypeDef_SG_LRR_Detection_085_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_85;
  float32 LRR_CAN_DET_AZIMUTH_85;
  Rte_DT_SG_LRR_Detection_085_t_2 LRR_CAN_DET_CONFID_AZIMUTH_85;
  boolean LRR_CAN_DET_CONFID_ELEVATION_85;
  float32 LRR_CAN_DET_ELEVATION_85;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_85;
  boolean LRR_CAN_DET_Near_TARGET_85;
  float32 LRR_CAN_DET_RANGE_85;
  float32 LRR_CAN_DET_RANGE_RATE_85;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_85;
  boolean LRR_CAN_DET_VALID_LEVEL_85;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_85;
} SG_LRR_Detection_085_t;

#  define Rte_TypeDef_SG_LRR_Detection_086_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_86;
  float32 LRR_CAN_DET_AZIMUTH_86;
  Rte_DT_SG_LRR_Detection_086_t_2 LRR_CAN_DET_CONFID_AZIMUTH_86;
  boolean LRR_CAN_DET_CONFID_ELEVATION_86;
  float32 LRR_CAN_DET_ELEVATION_86;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_86;
  boolean LRR_CAN_DET_Near_TARGET_86;
  float32 LRR_CAN_DET_RANGE_86;
  float32 LRR_CAN_DET_RANGE_RATE_86;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_86;
  boolean LRR_CAN_DET_VALID_LEVEL_86;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_86;
} SG_LRR_Detection_086_t;

#  define Rte_TypeDef_SG_LRR_Detection_087_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_87;
  float32 LRR_CAN_DET_AZIMUTH_87;
  Rte_DT_SG_LRR_Detection_087_t_2 LRR_CAN_DET_CONFID_AZIMUTH_87;
  boolean LRR_CAN_DET_CONFID_ELEVATION_87;
  float32 LRR_CAN_DET_ELEVATION_87;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_87;
  boolean LRR_CAN_DET_Near_TARGET_87;
  float32 LRR_CAN_DET_RANGE_87;
  float32 LRR_CAN_DET_RANGE_RATE_87;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_87;
  boolean LRR_CAN_DET_VALID_LEVEL_87;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_87;
} SG_LRR_Detection_087_t;

#  define Rte_TypeDef_SG_LRR_Detection_088_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_88;
  float32 LRR_CAN_DET_AZIMUTH_88;
  Rte_DT_SG_LRR_Detection_088_t_2 LRR_CAN_DET_CONFID_AZIMUTH_88;
  boolean LRR_CAN_DET_CONFID_ELEVATION_88;
  float32 LRR_CAN_DET_ELEVATION_88;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_88;
  boolean LRR_CAN_DET_Near_TARGET_88;
  float32 LRR_CAN_DET_RANGE_88;
  float32 LRR_CAN_DET_RANGE_RATE_88;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_88;
  boolean LRR_CAN_DET_VALID_LEVEL_88;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_88;
} SG_LRR_Detection_088_t;

#  define Rte_TypeDef_SG_LRR_Detection_089_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_89;
  float32 LRR_CAN_DET_AZIMUTH_89;
  Rte_DT_SG_LRR_Detection_089_t_2 LRR_CAN_DET_CONFID_AZIMUTH_89;
  boolean LRR_CAN_DET_CONFID_ELEVATION_89;
  float32 LRR_CAN_DET_ELEVATION_89;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_89;
  boolean LRR_CAN_DET_Near_TARGET_89;
  float32 LRR_CAN_DET_RANGE_89;
  float32 LRR_CAN_DET_RANGE_RATE_89;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_89;
  boolean LRR_CAN_DET_VALID_LEVEL_89;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_89;
} SG_LRR_Detection_089_t;

#  define Rte_TypeDef_SG_LRR_Detection_090_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_90;
  float32 LRR_CAN_DET_AZIMUTH_90;
  Rte_DT_SG_LRR_Detection_090_t_2 LRR_CAN_DET_CONFID_AZIMUTH_90;
  boolean LRR_CAN_DET_CONFID_ELEVATION_90;
  float32 LRR_CAN_DET_ELEVATION_90;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_90;
  boolean LRR_CAN_DET_Near_TARGET_90;
  float32 LRR_CAN_DET_RANGE_90;
  float32 LRR_CAN_DET_RANGE_RATE_90;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_90;
  boolean LRR_CAN_DET_VALID_LEVEL_90;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_90;
} SG_LRR_Detection_090_t;

#  define Rte_TypeDef_SG_LRR_Detection_091_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_91;
  float32 LRR_CAN_DET_AZIMUTH_91;
  Rte_DT_SG_LRR_Detection_091_t_2 LRR_CAN_DET_CONFID_AZIMUTH_91;
  boolean LRR_CAN_DET_CONFID_ELEVATION_91;
  float32 LRR_CAN_DET_ELEVATION_91;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_91;
  boolean LRR_CAN_DET_Near_TARGET_91;
  float32 LRR_CAN_DET_RANGE_91;
  float32 LRR_CAN_DET_RANGE_RATE_91;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_91;
  boolean LRR_CAN_DET_VALID_LEVEL_91;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_91;
} SG_LRR_Detection_091_t;

#  define Rte_TypeDef_SG_LRR_Detection_092_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_92;
  float32 LRR_CAN_DET_AZIMUTH_92;
  Rte_DT_SG_LRR_Detection_092_t_2 LRR_CAN_DET_CONFID_AZIMUTH_92;
  boolean LRR_CAN_DET_CONFID_ELEVATION_92;
  float32 LRR_CAN_DET_ELEVATION_92;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_92;
  boolean LRR_CAN_DET_Near_TARGET_92;
  float32 LRR_CAN_DET_RANGE_92;
  float32 LRR_CAN_DET_RANGE_RATE_92;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_92;
  boolean LRR_CAN_DET_VALID_LEVEL_92;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_92;
} SG_LRR_Detection_092_t;

#  define Rte_TypeDef_SG_LRR_Detection_093_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_93;
  float32 LRR_CAN_DET_AZIMUTH_93;
  Rte_DT_SG_LRR_Detection_093_t_2 LRR_CAN_DET_CONFID_AZIMUTH_93;
  boolean LRR_CAN_DET_CONFID_ELEVATION_93;
  float32 LRR_CAN_DET_ELEVATION_93;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_93;
  boolean LRR_CAN_DET_Near_TARGET_93;
  float32 LRR_CAN_DET_RANGE_93;
  float32 LRR_CAN_DET_RANGE_RATE_93;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_93;
  boolean LRR_CAN_DET_VALID_LEVEL_93;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_93;
} SG_LRR_Detection_093_t;

#  define Rte_TypeDef_SG_LRR_Detection_094_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_94;
  float32 LRR_CAN_DET_AZIMUTH_94;
  Rte_DT_SG_LRR_Detection_094_t_2 LRR_CAN_DET_CONFID_AZIMUTH_94;
  boolean LRR_CAN_DET_CONFID_ELEVATION_94;
  float32 LRR_CAN_DET_ELEVATION_94;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_94;
  boolean LRR_CAN_DET_Near_TARGET_94;
  float32 LRR_CAN_DET_RANGE_94;
  float32 LRR_CAN_DET_RANGE_RATE_94;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_94;
  boolean LRR_CAN_DET_VALID_LEVEL_94;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_94;
} SG_LRR_Detection_094_t;

#  define Rte_TypeDef_SG_LRR_Detection_095_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_95;
  float32 LRR_CAN_DET_AZIMUTH_95;
  Rte_DT_SG_LRR_Detection_095_t_2 LRR_CAN_DET_CONFID_AZIMUTH_95;
  boolean LRR_CAN_DET_CONFID_ELEVATION_95;
  float32 LRR_CAN_DET_ELEVATION_95;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_95;
  boolean LRR_CAN_DET_Near_TARGET_95;
  float32 LRR_CAN_DET_RANGE_95;
  float32 LRR_CAN_DET_RANGE_RATE_95;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_95;
  boolean LRR_CAN_DET_VALID_LEVEL_95;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_95;
} SG_LRR_Detection_095_t;

#  define Rte_TypeDef_SG_LRR_Detection_096_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_96;
  float32 LRR_CAN_DET_AZIMUTH_96;
  Rte_DT_SG_LRR_Detection_096_t_2 LRR_CAN_DET_CONFID_AZIMUTH_96;
  boolean LRR_CAN_DET_CONFID_ELEVATION_96;
  float32 LRR_CAN_DET_ELEVATION_96;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_96;
  boolean LRR_CAN_DET_Near_TARGET_96;
  float32 LRR_CAN_DET_RANGE_96;
  float32 LRR_CAN_DET_RANGE_RATE_96;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_96;
  boolean LRR_CAN_DET_VALID_LEVEL_96;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_96;
} SG_LRR_Detection_096_t;

#  define Rte_TypeDef_SG_LRR_Detection_097_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_97;
  float32 LRR_CAN_DET_AZIMUTH_97;
  Rte_DT_SG_LRR_Detection_097_t_2 LRR_CAN_DET_CONFID_AZIMUTH_97;
  boolean LRR_CAN_DET_CONFID_ELEVATION_97;
  float32 LRR_CAN_DET_ELEVATION_97;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_97;
  boolean LRR_CAN_DET_Near_TARGET_97;
  float32 LRR_CAN_DET_RANGE_97;
  float32 LRR_CAN_DET_RANGE_RATE_97;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_97;
  boolean LRR_CAN_DET_VALID_LEVEL_97;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_97;
} SG_LRR_Detection_097_t;

#  define Rte_TypeDef_SG_LRR_Detection_098_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_98;
  float32 LRR_CAN_DET_AZIMUTH_98;
  Rte_DT_SG_LRR_Detection_098_t_2 LRR_CAN_DET_CONFID_AZIMUTH_98;
  boolean LRR_CAN_DET_CONFID_ELEVATION_98;
  float32 LRR_CAN_DET_ELEVATION_98;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_98;
  boolean LRR_CAN_DET_Near_TARGET_98;
  float32 LRR_CAN_DET_RANGE_98;
  float32 LRR_CAN_DET_RANGE_RATE_98;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_98;
  boolean LRR_CAN_DET_VALID_LEVEL_98;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_98;
} SG_LRR_Detection_098_t;

#  define Rte_TypeDef_SG_LRR_Detection_099_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_99;
  float32 LRR_CAN_DET_AZIMUTH_99;
  Rte_DT_SG_LRR_Detection_099_t_2 LRR_CAN_DET_CONFID_AZIMUTH_99;
  boolean LRR_CAN_DET_CONFID_ELEVATION_99;
  float32 LRR_CAN_DET_ELEVATION_99;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_99;
  boolean LRR_CAN_DET_Near_TARGET_99;
  float32 LRR_CAN_DET_RANGE_99;
  float32 LRR_CAN_DET_RANGE_RATE_99;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_99;
  boolean LRR_CAN_DET_VALID_LEVEL_99;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_99;
} SG_LRR_Detection_099_t;

#  define Rte_TypeDef_SG_LRR_Detection_100_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_100;
  float32 LRR_CAN_DET_AZIMUTH_100;
  Rte_DT_SG_LRR_Detection_100_t_2 LRR_CAN_DET_CONFID_AZIMUTH_100;
  boolean LRR_CAN_DET_CONFID_ELEVATION_100;
  float32 LRR_CAN_DET_ELEVATION_100;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_100;
  boolean LRR_CAN_DET_Near_TARGET_100;
  float32 LRR_CAN_DET_RANGE_100;
  float32 LRR_CAN_DET_RANGE_RATE_100;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_100;
  boolean LRR_CAN_DET_VALID_LEVEL_100;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_100;
} SG_LRR_Detection_100_t;

#  define Rte_TypeDef_SG_LRR_Detection_101_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_101;
  float32 LRR_CAN_DET_AZIMUTH_101;
  Rte_DT_SG_LRR_Detection_101_t_2 LRR_CAN_DET_CONFID_AZIMUTH_101;
  boolean LRR_CAN_DET_CONFID_ELEVATION_101;
  float32 LRR_CAN_DET_ELEVATION_101;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_101;
  boolean LRR_CAN_DET_Near_TARGET_101;
  float32 LRR_CAN_DET_RANGE_101;
  float32 LRR_CAN_DET_RANGE_RATE_101;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_101;
  boolean LRR_CAN_DET_VALID_LEVEL_101;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_101;
} SG_LRR_Detection_101_t;

#  define Rte_TypeDef_SG_LRR_Detection_102_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_102;
  float32 LRR_CAN_DET_AZIMUTH_102;
  Rte_DT_SG_LRR_Detection_102_t_2 LRR_CAN_DET_CONFID_AZIMUTH_102;
  boolean LRR_CAN_DET_CONFID_ELEVATION_102;
  float32 LRR_CAN_DET_ELEVATION_102;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_102;
  boolean LRR_CAN_DET_Near_TARGET_102;
  float32 LRR_CAN_DET_RANGE_102;
  float32 LRR_CAN_DET_RANGE_RATE_102;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_102;
  boolean LRR_CAN_DET_VALID_LEVEL_102;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_102;
} SG_LRR_Detection_102_t;

#  define Rte_TypeDef_SG_LRR_Detection_103_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_103;
  float32 LRR_CAN_DET_AZIMUTH_103;
  Rte_DT_SG_LRR_Detection_103_t_2 LRR_CAN_DET_CONFID_AZIMUTH_103;
  boolean LRR_CAN_DET_CONFID_ELEVATION_103;
  float32 LRR_CAN_DET_ELEVATION_103;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_103;
  boolean LRR_CAN_DET_Near_TARGET_103;
  float32 LRR_CAN_DET_RANGE_103;
  float32 LRR_CAN_DET_RANGE_RATE_103;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_103;
  boolean LRR_CAN_DET_VALID_LEVEL_103;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_103;
} SG_LRR_Detection_103_t;

#  define Rte_TypeDef_SG_LRR_Detection_104_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_104;
  float32 LRR_CAN_DET_AZIMUTH_104;
  Rte_DT_SG_LRR_Detection_104_t_2 LRR_CAN_DET_CONFID_AZIMUTH_104;
  boolean LRR_CAN_DET_CONFID_ELEVATION_104;
  float32 LRR_CAN_DET_ELEVATION_104;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_104;
  boolean LRR_CAN_DET_Near_TARGET_104;
  float32 LRR_CAN_DET_RANGE_104;
  float32 LRR_CAN_DET_RANGE_RATE_104;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_104;
  boolean LRR_CAN_DET_VALID_LEVEL_104;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_104;
} SG_LRR_Detection_104_t;

#  define Rte_TypeDef_SG_LRR_Detection_105_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_105;
  float32 LRR_CAN_DET_AZIMUTH_105;
  Rte_DT_SG_LRR_Detection_105_t_2 LRR_CAN_DET_CONFID_AZIMUTH_105;
  boolean LRR_CAN_DET_CONFID_ELEVATION_105;
  float32 LRR_CAN_DET_ELEVATION_105;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_105;
  boolean LRR_CAN_DET_Near_TARGET_105;
  float32 LRR_CAN_DET_RANGE_105;
  float32 LRR_CAN_DET_RANGE_RATE_105;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_105;
  boolean LRR_CAN_DET_VALID_LEVEL_105;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_105;
} SG_LRR_Detection_105_t;

#  define Rte_TypeDef_SG_LRR_Detection_106_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_106;
  float32 LRR_CAN_DET_AZIMUTH_106;
  Rte_DT_SG_LRR_Detection_106_t_2 LRR_CAN_DET_CONFID_AZIMUTH_106;
  boolean LRR_CAN_DET_CONFID_ELEVATION_106;
  float32 LRR_CAN_DET_ELEVATION_106;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_106;
  boolean LRR_CAN_DET_Near_TARGET_106;
  float32 LRR_CAN_DET_RANGE_106;
  float32 LRR_CAN_DET_RANGE_RATE_106;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_106;
  boolean LRR_CAN_DET_VALID_LEVEL_106;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_106;
} SG_LRR_Detection_106_t;

#  define Rte_TypeDef_SG_LRR_Detection_107_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_107;
  float32 LRR_CAN_DET_AZIMUTH_107;
  Rte_DT_SG_LRR_Detection_107_t_2 LRR_CAN_DET_CONFID_AZIMUTH_107;
  boolean LRR_CAN_DET_CONFID_ELEVATION_107;
  float32 LRR_CAN_DET_ELEVATION_107;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_107;
  boolean LRR_CAN_DET_Near_TARGET_107;
  float32 LRR_CAN_DET_RANGE_107;
  float32 LRR_CAN_DET_RANGE_RATE_107;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_107;
  boolean LRR_CAN_DET_VALID_LEVEL_107;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_107;
} SG_LRR_Detection_107_t;

#  define Rte_TypeDef_SG_LRR_Detection_108_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_108;
  float32 LRR_CAN_DET_AZIMUTH_108;
  Rte_DT_SG_LRR_Detection_108_t_2 LRR_CAN_DET_CONFID_AZIMUTH_108;
  boolean LRR_CAN_DET_CONFID_ELEVATION_108;
  float32 LRR_CAN_DET_ELEVATION_108;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_108;
  boolean LRR_CAN_DET_Near_TARGET_108;
  float32 LRR_CAN_DET_RANGE_108;
  float32 LRR_CAN_DET_RANGE_RATE_108;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_108;
  boolean LRR_CAN_DET_VALID_LEVEL_108;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_108;
} SG_LRR_Detection_108_t;

#  define Rte_TypeDef_SG_LRR_Detection_109_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_109;
  float32 LRR_CAN_DET_AZIMUTH_109;
  Rte_DT_SG_LRR_Detection_109_t_2 LRR_CAN_DET_CONFID_AZIMUTH_109;
  boolean LRR_CAN_DET_CONFID_ELEVATION_109;
  float32 LRR_CAN_DET_ELEVATION_109;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_109;
  boolean LRR_CAN_DET_Near_TARGET_109;
  float32 LRR_CAN_DET_RANGE_109;
  float32 LRR_CAN_DET_RANGE_RATE_109;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_109;
  boolean LRR_CAN_DET_VALID_LEVEL_109;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_109;
} SG_LRR_Detection_109_t;

#  define Rte_TypeDef_SG_LRR_Detection_110_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_110;
  float32 LRR_CAN_DET_AZIMUTH_110;
  Rte_DT_SG_LRR_Detection_110_t_2 LRR_CAN_DET_CONFID_AZIMUTH_110;
  boolean LRR_CAN_DET_CONFID_ELEVATION_110;
  float32 LRR_CAN_DET_ELEVATION_110;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_110;
  boolean LRR_CAN_DET_Near_TARGET_110;
  float32 LRR_CAN_DET_RANGE_110;
  float32 LRR_CAN_DET_RANGE_RATE_110;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_110;
  boolean LRR_CAN_DET_VALID_LEVEL_110;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_110;
} SG_LRR_Detection_110_t;

#  define Rte_TypeDef_SG_LRR_Detection_111_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_111;
  float32 LRR_CAN_DET_AZIMUTH_111;
  Rte_DT_SG_LRR_Detection_111_t_2 LRR_CAN_DET_CONFID_AZIMUTH_111;
  boolean LRR_CAN_DET_CONFID_ELEVATION_111;
  float32 LRR_CAN_DET_ELEVATION_111;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_111;
  boolean LRR_CAN_DET_Near_TARGET_111;
  float32 LRR_CAN_DET_RANGE_111;
  float32 LRR_CAN_DET_RANGE_RATE_111;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_111;
  boolean LRR_CAN_DET_VALID_LEVEL_111;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_111;
} SG_LRR_Detection_111_t;

#  define Rte_TypeDef_SG_LRR_Detection_112_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_112;
  float32 LRR_CAN_DET_AZIMUTH_112;
  Rte_DT_SG_LRR_Detection_112_t_2 LRR_CAN_DET_CONFID_AZIMUTH_112;
  boolean LRR_CAN_DET_CONFID_ELEVATION_112;
  float32 LRR_CAN_DET_ELEVATION_112;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_112;
  boolean LRR_CAN_DET_Near_TARGET_112;
  float32 LRR_CAN_DET_RANGE_112;
  float32 LRR_CAN_DET_RANGE_RATE_112;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_112;
  boolean LRR_CAN_DET_VALID_LEVEL_112;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_112;
} SG_LRR_Detection_112_t;

#  define Rte_TypeDef_SG_LRR_Detection_113_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_113;
  float32 LRR_CAN_DET_AZIMUTH_113;
  Rte_DT_SG_LRR_Detection_113_t_2 LRR_CAN_DET_CONFID_AZIMUTH_113;
  boolean LRR_CAN_DET_CONFID_ELEVATION_113;
  float32 LRR_CAN_DET_ELEVATION_113;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_113;
  boolean LRR_CAN_DET_Near_TARGET_113;
  float32 LRR_CAN_DET_RANGE_113;
  float32 LRR_CAN_DET_RANGE_RATE_113;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_113;
  boolean LRR_CAN_DET_VALID_LEVEL_113;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_113;
} SG_LRR_Detection_113_t;

#  define Rte_TypeDef_SG_LRR_Detection_114_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_114;
  float32 LRR_CAN_DET_AZIMUTH_114;
  Rte_DT_SG_LRR_Detection_114_t_2 LRR_CAN_DET_CONFID_AZIMUTH_114;
  boolean LRR_CAN_DET_CONFID_ELEVATION_114;
  float32 LRR_CAN_DET_ELEVATION_114;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_114;
  boolean LRR_CAN_DET_Near_TARGET_114;
  float32 LRR_CAN_DET_RANGE_114;
  float32 LRR_CAN_DET_RANGE_RATE_114;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_114;
  boolean LRR_CAN_DET_VALID_LEVEL_114;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_114;
} SG_LRR_Detection_114_t;

#  define Rte_TypeDef_SG_LRR_Detection_115_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_115;
  float32 LRR_CAN_DET_AZIMUTH_115;
  Rte_DT_SG_LRR_Detection_115_t_2 LRR_CAN_DET_CONFID_AZIMUTH_115;
  boolean LRR_CAN_DET_CONFID_ELEVATION_115;
  float32 LRR_CAN_DET_ELEVATION_115;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_115;
  boolean LRR_CAN_DET_Near_TARGET_115;
  float32 LRR_CAN_DET_RANGE_115;
  float32 LRR_CAN_DET_RANGE_RATE_115;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_115;
  boolean LRR_CAN_DET_VALID_LEVEL_115;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_115;
} SG_LRR_Detection_115_t;

#  define Rte_TypeDef_SG_LRR_Detection_116_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_116;
  float32 LRR_CAN_DET_AZIMUTH_116;
  Rte_DT_SG_LRR_Detection_116_t_2 LRR_CAN_DET_CONFID_AZIMUTH_116;
  boolean LRR_CAN_DET_CONFID_ELEVATION_116;
  float32 LRR_CAN_DET_ELEVATION_116;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_116;
  boolean LRR_CAN_DET_Near_TARGET_116;
  float32 LRR_CAN_DET_RANGE_116;
  float32 LRR_CAN_DET_RANGE_RATE_116;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_116;
  boolean LRR_CAN_DET_VALID_LEVEL_116;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_116;
} SG_LRR_Detection_116_t;

#  define Rte_TypeDef_SG_LRR_Detection_117_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_117;
  float32 LRR_CAN_DET_AZIMUTH_117;
  Rte_DT_SG_LRR_Detection_117_t_2 LRR_CAN_DET_CONFID_AZIMUTH_117;
  boolean LRR_CAN_DET_CONFID_ELEVATION_117;
  float32 LRR_CAN_DET_ELEVATION_117;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_117;
  boolean LRR_CAN_DET_Near_TARGET_117;
  float32 LRR_CAN_DET_RANGE_117;
  float32 LRR_CAN_DET_RANGE_RATE_117;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_117;
  boolean LRR_CAN_DET_VALID_LEVEL_117;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_117;
} SG_LRR_Detection_117_t;

#  define Rte_TypeDef_SG_LRR_Detection_118_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_118;
  float32 LRR_CAN_DET_AZIMUTH_118;
  Rte_DT_SG_LRR_Detection_118_t_2 LRR_CAN_DET_CONFID_AZIMUTH_118;
  boolean LRR_CAN_DET_CONFID_ELEVATION_118;
  float32 LRR_CAN_DET_ELEVATION_118;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_118;
  boolean LRR_CAN_DET_Near_TARGET_118;
  float32 LRR_CAN_DET_RANGE_118;
  float32 LRR_CAN_DET_RANGE_RATE_118;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_118;
  boolean LRR_CAN_DET_VALID_LEVEL_118;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_118;
} SG_LRR_Detection_118_t;

#  define Rte_TypeDef_SG_LRR_Detection_119_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_119;
  float32 LRR_CAN_DET_AZIMUTH_119;
  Rte_DT_SG_LRR_Detection_119_t_2 LRR_CAN_DET_CONFID_AZIMUTH_119;
  boolean LRR_CAN_DET_CONFID_ELEVATION_119;
  float32 LRR_CAN_DET_ELEVATION_119;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_119;
  boolean LRR_CAN_DET_Near_TARGET_119;
  float32 LRR_CAN_DET_RANGE_119;
  float32 LRR_CAN_DET_RANGE_RATE_119;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_119;
  boolean LRR_CAN_DET_VALID_LEVEL_119;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_119;
} SG_LRR_Detection_119_t;

#  define Rte_TypeDef_SG_LRR_Detection_120_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_120;
  float32 LRR_CAN_DET_AZIMUTH_120;
  Rte_DT_SG_LRR_Detection_120_t_2 LRR_CAN_DET_CONFID_AZIMUTH_120;
  boolean LRR_CAN_DET_CONFID_ELEVATION_120;
  float32 LRR_CAN_DET_ELEVATION_120;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_120;
  boolean LRR_CAN_DET_Near_TARGET_120;
  float32 LRR_CAN_DET_RANGE_120;
  float32 LRR_CAN_DET_RANGE_RATE_120;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_120;
  boolean LRR_CAN_DET_VALID_LEVEL_120;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_120;
} SG_LRR_Detection_120_t;

#  define Rte_TypeDef_SG_LRR_Detection_121_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_121;
  float32 LRR_CAN_DET_AZIMUTH_121;
  Rte_DT_SG_LRR_Detection_121_t_2 LRR_CAN_DET_CONFID_AZIMUTH_121;
  boolean LRR_CAN_DET_CONFID_ELEVATION_121;
  float32 LRR_CAN_DET_ELEVATION_121;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_121;
  boolean LRR_CAN_DET_Near_TARGET_121;
  float32 LRR_CAN_DET_RANGE_121;
  float32 LRR_CAN_DET_RANGE_RATE_121;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_121;
  boolean LRR_CAN_DET_VALID_LEVEL_121;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_121;
} SG_LRR_Detection_121_t;

#  define Rte_TypeDef_SG_LRR_Detection_122_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_122;
  float32 LRR_CAN_DET_AZIMUTH_122;
  Rte_DT_SG_LRR_Detection_122_t_2 LRR_CAN_DET_CONFID_AZIMUTH_122;
  boolean LRR_CAN_DET_CONFID_ELEVATION_122;
  float32 LRR_CAN_DET_ELEVATION_122;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_122;
  boolean LRR_CAN_DET_Near_TARGET_122;
  float32 LRR_CAN_DET_RANGE_122;
  float32 LRR_CAN_DET_RANGE_RATE_122;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_122;
  boolean LRR_CAN_DET_VALID_LEVEL_122;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_122;
} SG_LRR_Detection_122_t;

#  define Rte_TypeDef_SG_LRR_Detection_123_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_123;
  float32 LRR_CAN_DET_AZIMUTH_123;
  Rte_DT_SG_LRR_Detection_123_t_2 LRR_CAN_DET_CONFID_AZIMUTH_123;
  boolean LRR_CAN_DET_CONFID_ELEVATION_123;
  float32 LRR_CAN_DET_ELEVATION_123;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_123;
  boolean LRR_CAN_DET_Near_TARGET_123;
  float32 LRR_CAN_DET_RANGE_123;
  float32 LRR_CAN_DET_RANGE_RATE_123;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_123;
  boolean LRR_CAN_DET_VALID_LEVEL_123;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_123;
} SG_LRR_Detection_123_t;

#  define Rte_TypeDef_SG_LRR_Detection_124_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_124;
  float32 LRR_CAN_DET_AZIMUTH_124;
  Rte_DT_SG_LRR_Detection_124_t_2 LRR_CAN_DET_CONFID_AZIMUTH_124;
  boolean LRR_CAN_DET_CONFID_ELEVATION_124;
  float32 LRR_CAN_DET_ELEVATION_124;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_124;
  boolean LRR_CAN_DET_Near_TARGET_124;
  float32 LRR_CAN_DET_RANGE_124;
  float32 LRR_CAN_DET_RANGE_RATE_124;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_124;
  boolean LRR_CAN_DET_VALID_LEVEL_124;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_124;
} SG_LRR_Detection_124_t;

#  define Rte_TypeDef_SG_LRR_Detection_125_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_125;
  float32 LRR_CAN_DET_AZIMUTH_125;
  Rte_DT_SG_LRR_Detection_125_t_2 LRR_CAN_DET_CONFID_AZIMUTH_125;
  boolean LRR_CAN_DET_CONFID_ELEVATION_125;
  float32 LRR_CAN_DET_ELEVATION_125;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_125;
  boolean LRR_CAN_DET_Near_TARGET_125;
  float32 LRR_CAN_DET_RANGE_125;
  float32 LRR_CAN_DET_RANGE_RATE_125;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_125;
  boolean LRR_CAN_DET_VALID_LEVEL_125;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_125;
} SG_LRR_Detection_125_t;

#  define Rte_TypeDef_SG_LRR_Detection_126_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_126;
  float32 LRR_CAN_DET_AZIMUTH_126;
  Rte_DT_SG_LRR_Detection_126_t_2 LRR_CAN_DET_CONFID_AZIMUTH_126;
  boolean LRR_CAN_DET_CONFID_ELEVATION_126;
  float32 LRR_CAN_DET_ELEVATION_126;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_126;
  boolean LRR_CAN_DET_Near_TARGET_126;
  float32 LRR_CAN_DET_RANGE_126;
  float32 LRR_CAN_DET_RANGE_RATE_126;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_126;
  boolean LRR_CAN_DET_VALID_LEVEL_126;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_126;
} SG_LRR_Detection_126_t;

#  define Rte_TypeDef_SG_LRR_Detection_127_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_127;
  float32 LRR_CAN_DET_AZIMUTH_127;
  Rte_DT_SG_LRR_Detection_127_t_2 LRR_CAN_DET_CONFID_AZIMUTH_127;
  boolean LRR_CAN_DET_CONFID_ELEVATION_127;
  float32 LRR_CAN_DET_ELEVATION_127;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_127;
  boolean LRR_CAN_DET_Near_TARGET_127;
  float32 LRR_CAN_DET_RANGE_127;
  float32 LRR_CAN_DET_RANGE_RATE_127;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_127;
  boolean LRR_CAN_DET_VALID_LEVEL_127;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_127;
} SG_LRR_Detection_127_t;

#  define Rte_TypeDef_SG_LRR_Detection_128_t
typedef struct
{
  sint8 LRR_CAN_DET_AMPLITUDE_128;
  float32 LRR_CAN_DET_AZIMUTH_128;
  Rte_DT_SG_LRR_Detection_128_t_2 LRR_CAN_DET_CONFID_AZIMUTH_128;
  boolean LRR_CAN_DET_CONFID_ELEVATION_128;
  float32 LRR_CAN_DET_ELEVATION_128;
  boolean LRR_CAN_DET_HOST_VEH_CLUTTER_128;
  boolean LRR_CAN_DET_Near_TARGET_128;
  float32 LRR_CAN_DET_RANGE_128;
  float32 LRR_CAN_DET_RANGE_RATE_128;
  boolean LRR_CAN_DET_SUPER_RES_TARGET_128;
  boolean LRR_CAN_DET_VALID_LEVEL_128;
  uint8 LRR_CAN_SCAN_INDEX_2LSB_128;
} SG_LRR_Detection_128_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_001_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_01;
  float32 SRR_FL_CAN_DET_AZIMUTH_01;
  Rte_DT_SG_SRR_FL_Detection_001_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_01;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_01;
  float32 SRR_FL_CAN_DET_ELEVATION_01;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_01;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_01;
  boolean SRR_FL_CAN_DET_Near_TARGET_01;
  float32 SRR_FL_CAN_DET_RANGE_01;
  float32 SRR_FL_CAN_DET_RANGE_RATE_01;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_01;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_01;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_01;
} SG_SRR_FL_Detection_001_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_002_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_02;
  float32 SRR_FL_CAN_DET_AZIMUTH_02;
  Rte_DT_SG_SRR_FL_Detection_002_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_02;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_02;
  float32 SRR_FL_CAN_DET_ELEVATION_02;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_02;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_02;
  boolean SRR_FL_CAN_DET_Near_TARGET_02;
  float32 SRR_FL_CAN_DET_RANGE_02;
  float32 SRR_FL_CAN_DET_RANGE_RATE_02;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_02;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_02;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_02;
} SG_SRR_FL_Detection_002_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_003_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_03;
  float32 SRR_FL_CAN_DET_AZIMUTH_03;
  Rte_DT_SG_SRR_FL_Detection_003_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_03;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_03;
  float32 SRR_FL_CAN_DET_ELEVATION_03;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_03;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_03;
  boolean SRR_FL_CAN_DET_Near_TARGET_03;
  float32 SRR_FL_CAN_DET_RANGE_03;
  float32 SRR_FL_CAN_DET_RANGE_RATE_03;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_03;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_03;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_03;
} SG_SRR_FL_Detection_003_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_004_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_04;
  float32 SRR_FL_CAN_DET_AZIMUTH_04;
  Rte_DT_SG_SRR_FL_Detection_004_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_04;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_04;
  float32 SRR_FL_CAN_DET_ELEVATION_04;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_04;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_04;
  boolean SRR_FL_CAN_DET_Near_TARGET_04;
  float32 SRR_FL_CAN_DET_RANGE_04;
  float32 SRR_FL_CAN_DET_RANGE_RATE_04;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_04;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_04;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_04;
} SG_SRR_FL_Detection_004_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_005_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_05;
  float32 SRR_FL_CAN_DET_AZIMUTH_05;
  Rte_DT_SG_SRR_FL_Detection_005_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_05;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_05;
  float32 SRR_FL_CAN_DET_ELEVATION_05;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_05;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_05;
  boolean SRR_FL_CAN_DET_Near_TARGET_05;
  float32 SRR_FL_CAN_DET_RANGE_05;
  float32 SRR_FL_CAN_DET_RANGE_RATE_05;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_05;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_05;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_05;
} SG_SRR_FL_Detection_005_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_006_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_06;
  float32 SRR_FL_CAN_DET_AZIMUTH_06;
  Rte_DT_SG_SRR_FL_Detection_006_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_06;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_06;
  float32 SRR_FL_CAN_DET_ELEVATION_06;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_06;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_06;
  boolean SRR_FL_CAN_DET_Near_TARGET_06;
  float32 SRR_FL_CAN_DET_RANGE_06;
  float32 SRR_FL_CAN_DET_RANGE_RATE_06;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_06;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_06;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_06;
} SG_SRR_FL_Detection_006_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_007_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_07;
  float32 SRR_FL_CAN_DET_AZIMUTH_07;
  Rte_DT_SG_SRR_FL_Detection_007_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_07;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_07;
  float32 SRR_FL_CAN_DET_ELEVATION_07;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_07;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_07;
  boolean SRR_FL_CAN_DET_Near_TARGET_07;
  float32 SRR_FL_CAN_DET_RANGE_07;
  float32 SRR_FL_CAN_DET_RANGE_RATE_07;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_07;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_07;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_07;
} SG_SRR_FL_Detection_007_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_008_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_08;
  float32 SRR_FL_CAN_DET_AZIMUTH_08;
  Rte_DT_SG_SRR_FL_Detection_008_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_08;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_08;
  float32 SRR_FL_CAN_DET_ELEVATION_08;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_08;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_08;
  boolean SRR_FL_CAN_DET_Near_TARGET_08;
  float32 SRR_FL_CAN_DET_RANGE_08;
  float32 SRR_FL_CAN_DET_RANGE_RATE_08;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_08;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_08;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_08;
} SG_SRR_FL_Detection_008_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_009_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_09;
  float32 SRR_FL_CAN_DET_AZIMUTH_09;
  Rte_DT_SG_SRR_FL_Detection_009_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_09;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_09;
  float32 SRR_FL_CAN_DET_ELEVATION_09;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_09;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_09;
  boolean SRR_FL_CAN_DET_Near_TARGET_09;
  float32 SRR_FL_CAN_DET_RANGE_09;
  float32 SRR_FL_CAN_DET_RANGE_RATE_09;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_09;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_09;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_09;
} SG_SRR_FL_Detection_009_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_010_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_10;
  float32 SRR_FL_CAN_DET_AZIMUTH_10;
  Rte_DT_SG_SRR_FL_Detection_010_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_10;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_10;
  float32 SRR_FL_CAN_DET_ELEVATION_10;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_10;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_10;
  boolean SRR_FL_CAN_DET_Near_TARGET_10;
  float32 SRR_FL_CAN_DET_RANGE_10;
  float32 SRR_FL_CAN_DET_RANGE_RATE_10;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_10;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_10;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_10;
} SG_SRR_FL_Detection_010_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_011_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_11;
  float32 SRR_FL_CAN_DET_AZIMUTH_11;
  Rte_DT_SG_SRR_FL_Detection_011_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_11;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_11;
  float32 SRR_FL_CAN_DET_ELEVATION_11;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_11;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_11;
  boolean SRR_FL_CAN_DET_Near_TARGET_11;
  float32 SRR_FL_CAN_DET_RANGE_11;
  float32 SRR_FL_CAN_DET_RANGE_RATE_11;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_11;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_11;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_11;
} SG_SRR_FL_Detection_011_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_012_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_12;
  float32 SRR_FL_CAN_DET_AZIMUTH_12;
  Rte_DT_SG_SRR_FL_Detection_012_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_12;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_12;
  float32 SRR_FL_CAN_DET_ELEVATION_12;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_12;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_12;
  boolean SRR_FL_CAN_DET_Near_TARGET_12;
  float32 SRR_FL_CAN_DET_RANGE_12;
  float32 SRR_FL_CAN_DET_RANGE_RATE_12;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_12;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_12;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_12;
} SG_SRR_FL_Detection_012_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_013_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_13;
  float32 SRR_FL_CAN_DET_AZIMUTH_13;
  Rte_DT_SG_SRR_FL_Detection_013_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_13;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_13;
  float32 SRR_FL_CAN_DET_ELEVATION_13;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_13;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_13;
  boolean SRR_FL_CAN_DET_Near_TARGET_13;
  float32 SRR_FL_CAN_DET_RANGE_13;
  float32 SRR_FL_CAN_DET_RANGE_RATE_13;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_13;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_13;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_13;
} SG_SRR_FL_Detection_013_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_014_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_14;
  float32 SRR_FL_CAN_DET_AZIMUTH_14;
  Rte_DT_SG_SRR_FL_Detection_014_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_14;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_14;
  float32 SRR_FL_CAN_DET_ELEVATION_14;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_14;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_14;
  boolean SRR_FL_CAN_DET_Near_TARGET_14;
  float32 SRR_FL_CAN_DET_RANGE_14;
  float32 SRR_FL_CAN_DET_RANGE_RATE_14;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_14;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_14;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_14;
} SG_SRR_FL_Detection_014_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_015_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_15;
  float32 SRR_FL_CAN_DET_AZIMUTH_15;
  Rte_DT_SG_SRR_FL_Detection_015_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_15;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_15;
  float32 SRR_FL_CAN_DET_ELEVATION_15;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_15;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_15;
  boolean SRR_FL_CAN_DET_Near_TARGET_15;
  float32 SRR_FL_CAN_DET_RANGE_15;
  float32 SRR_FL_CAN_DET_RANGE_RATE_15;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_15;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_15;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_15;
} SG_SRR_FL_Detection_015_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_016_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_16;
  float32 SRR_FL_CAN_DET_AZIMUTH_16;
  Rte_DT_SG_SRR_FL_Detection_016_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_16;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_16;
  float32 SRR_FL_CAN_DET_ELEVATION_16;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_16;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_16;
  boolean SRR_FL_CAN_DET_Near_TARGET_16;
  float32 SRR_FL_CAN_DET_RANGE_16;
  float32 SRR_FL_CAN_DET_RANGE_RATE_16;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_16;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_16;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_16;
} SG_SRR_FL_Detection_016_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_017_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_17;
  float32 SRR_FL_CAN_DET_AZIMUTH_17;
  Rte_DT_SG_SRR_FL_Detection_017_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_17;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_17;
  float32 SRR_FL_CAN_DET_ELEVATION_17;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_17;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_17;
  boolean SRR_FL_CAN_DET_Near_TARGET_17;
  float32 SRR_FL_CAN_DET_RANGE_17;
  float32 SRR_FL_CAN_DET_RANGE_RATE_17;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_17;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_17;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_17;
} SG_SRR_FL_Detection_017_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_018_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_18;
  float32 SRR_FL_CAN_DET_AZIMUTH_18;
  Rte_DT_SG_SRR_FL_Detection_018_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_18;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_18;
  float32 SRR_FL_CAN_DET_ELEVATION_18;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_18;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_18;
  boolean SRR_FL_CAN_DET_Near_TARGET_18;
  float32 SRR_FL_CAN_DET_RANGE_18;
  float32 SRR_FL_CAN_DET_RANGE_RATE_18;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_18;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_18;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_18;
} SG_SRR_FL_Detection_018_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_019_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_19;
  float32 SRR_FL_CAN_DET_AZIMUTH_19;
  Rte_DT_SG_SRR_FL_Detection_019_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_19;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_19;
  float32 SRR_FL_CAN_DET_ELEVATION_19;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_19;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_19;
  boolean SRR_FL_CAN_DET_Near_TARGET_19;
  float32 SRR_FL_CAN_DET_RANGE_19;
  float32 SRR_FL_CAN_DET_RANGE_RATE_19;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_19;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_19;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_19;
} SG_SRR_FL_Detection_019_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_020_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_20;
  float32 SRR_FL_CAN_DET_AZIMUTH_20;
  Rte_DT_SG_SRR_FL_Detection_020_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_20;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_20;
  float32 SRR_FL_CAN_DET_ELEVATION_20;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_20;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_20;
  boolean SRR_FL_CAN_DET_Near_TARGET_20;
  float32 SRR_FL_CAN_DET_RANGE_20;
  float32 SRR_FL_CAN_DET_RANGE_RATE_20;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_20;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_20;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_20;
} SG_SRR_FL_Detection_020_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_021_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_21;
  float32 SRR_FL_CAN_DET_AZIMUTH_21;
  Rte_DT_SG_SRR_FL_Detection_021_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_21;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_21;
  float32 SRR_FL_CAN_DET_ELEVATION_21;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_21;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_21;
  boolean SRR_FL_CAN_DET_Near_TARGET_21;
  float32 SRR_FL_CAN_DET_RANGE_21;
  float32 SRR_FL_CAN_DET_RANGE_RATE_21;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_21;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_21;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_21;
} SG_SRR_FL_Detection_021_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_022_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_22;
  float32 SRR_FL_CAN_DET_AZIMUTH_22;
  Rte_DT_SG_SRR_FL_Detection_022_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_22;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_22;
  float32 SRR_FL_CAN_DET_ELEVATION_22;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_22;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_22;
  boolean SRR_FL_CAN_DET_Near_TARGET_22;
  float32 SRR_FL_CAN_DET_RANGE_22;
  float32 SRR_FL_CAN_DET_RANGE_RATE_22;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_22;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_22;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_22;
} SG_SRR_FL_Detection_022_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_023_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_23;
  float32 SRR_FL_CAN_DET_AZIMUTH_23;
  Rte_DT_SG_SRR_FL_Detection_023_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_23;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_23;
  float32 SRR_FL_CAN_DET_ELEVATION_23;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_23;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_23;
  boolean SRR_FL_CAN_DET_Near_TARGET_23;
  float32 SRR_FL_CAN_DET_RANGE_23;
  float32 SRR_FL_CAN_DET_RANGE_RATE_23;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_23;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_23;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_23;
} SG_SRR_FL_Detection_023_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_024_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_24;
  float32 SRR_FL_CAN_DET_AZIMUTH_24;
  Rte_DT_SG_SRR_FL_Detection_024_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_24;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_24;
  float32 SRR_FL_CAN_DET_ELEVATION_24;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_24;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_24;
  boolean SRR_FL_CAN_DET_Near_TARGET_24;
  float32 SRR_FL_CAN_DET_RANGE_24;
  float32 SRR_FL_CAN_DET_RANGE_RATE_24;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_24;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_24;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_24;
} SG_SRR_FL_Detection_024_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_025_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_25;
  float32 SRR_FL_CAN_DET_AZIMUTH_25;
  Rte_DT_SG_SRR_FL_Detection_025_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_25;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_25;
  float32 SRR_FL_CAN_DET_ELEVATION_25;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_25;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_25;
  boolean SRR_FL_CAN_DET_Near_TARGET_25;
  float32 SRR_FL_CAN_DET_RANGE_25;
  float32 SRR_FL_CAN_DET_RANGE_RATE_25;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_25;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_25;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_25;
} SG_SRR_FL_Detection_025_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_026_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_26;
  float32 SRR_FL_CAN_DET_AZIMUTH_26;
  Rte_DT_SG_SRR_FL_Detection_026_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_26;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_26;
  float32 SRR_FL_CAN_DET_ELEVATION_26;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_26;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_26;
  boolean SRR_FL_CAN_DET_Near_TARGET_26;
  float32 SRR_FL_CAN_DET_RANGE_26;
  float32 SRR_FL_CAN_DET_RANGE_RATE_26;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_26;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_26;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_26;
} SG_SRR_FL_Detection_026_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_027_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_27;
  float32 SRR_FL_CAN_DET_AZIMUTH_27;
  Rte_DT_SG_SRR_FL_Detection_027_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_27;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_27;
  float32 SRR_FL_CAN_DET_ELEVATION_27;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_27;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_27;
  boolean SRR_FL_CAN_DET_Near_TARGET_27;
  float32 SRR_FL_CAN_DET_RANGE_27;
  float32 SRR_FL_CAN_DET_RANGE_RATE_27;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_27;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_27;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_27;
} SG_SRR_FL_Detection_027_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_028_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_28;
  float32 SRR_FL_CAN_DET_AZIMUTH_28;
  Rte_DT_SG_SRR_FL_Detection_028_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_28;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_28;
  float32 SRR_FL_CAN_DET_ELEVATION_28;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_28;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_28;
  boolean SRR_FL_CAN_DET_Near_TARGET_28;
  float32 SRR_FL_CAN_DET_RANGE_28;
  float32 SRR_FL_CAN_DET_RANGE_RATE_28;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_28;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_28;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_28;
} SG_SRR_FL_Detection_028_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_029_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_29;
  float32 SRR_FL_CAN_DET_AZIMUTH_29;
  Rte_DT_SG_SRR_FL_Detection_029_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_29;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_29;
  float32 SRR_FL_CAN_DET_ELEVATION_29;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_29;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_29;
  boolean SRR_FL_CAN_DET_Near_TARGET_29;
  float32 SRR_FL_CAN_DET_RANGE_29;
  float32 SRR_FL_CAN_DET_RANGE_RATE_29;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_29;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_29;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_29;
} SG_SRR_FL_Detection_029_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_030_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_30;
  float32 SRR_FL_CAN_DET_AZIMUTH_30;
  Rte_DT_SG_SRR_FL_Detection_030_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_30;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_30;
  float32 SRR_FL_CAN_DET_ELEVATION_30;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_30;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_30;
  boolean SRR_FL_CAN_DET_Near_TARGET_30;
  float32 SRR_FL_CAN_DET_RANGE_30;
  float32 SRR_FL_CAN_DET_RANGE_RATE_30;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_30;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_30;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_30;
} SG_SRR_FL_Detection_030_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_031_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_31;
  float32 SRR_FL_CAN_DET_AZIMUTH_31;
  Rte_DT_SG_SRR_FL_Detection_031_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_31;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_31;
  float32 SRR_FL_CAN_DET_ELEVATION_31;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_31;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_31;
  boolean SRR_FL_CAN_DET_Near_TARGET_31;
  float32 SRR_FL_CAN_DET_RANGE_31;
  float32 SRR_FL_CAN_DET_RANGE_RATE_31;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_31;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_31;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_31;
} SG_SRR_FL_Detection_031_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_032_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_32;
  float32 SRR_FL_CAN_DET_AZIMUTH_32;
  Rte_DT_SG_SRR_FL_Detection_032_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_32;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_32;
  float32 SRR_FL_CAN_DET_ELEVATION_32;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_32;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_32;
  boolean SRR_FL_CAN_DET_Near_TARGET_32;
  float32 SRR_FL_CAN_DET_RANGE_32;
  float32 SRR_FL_CAN_DET_RANGE_RATE_32;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_32;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_32;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_32;
} SG_SRR_FL_Detection_032_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_033_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_33;
  float32 SRR_FL_CAN_DET_AZIMUTH_33;
  Rte_DT_SG_SRR_FL_Detection_033_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_33;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_33;
  float32 SRR_FL_CAN_DET_ELEVATION_33;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_33;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_33;
  boolean SRR_FL_CAN_DET_Near_TARGET_33;
  float32 SRR_FL_CAN_DET_RANGE_33;
  float32 SRR_FL_CAN_DET_RANGE_RATE_33;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_33;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_33;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_33;
} SG_SRR_FL_Detection_033_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_034_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_34;
  float32 SRR_FL_CAN_DET_AZIMUTH_34;
  Rte_DT_SG_SRR_FL_Detection_034_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_34;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_34;
  float32 SRR_FL_CAN_DET_ELEVATION_34;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_34;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_34;
  boolean SRR_FL_CAN_DET_Near_TARGET_34;
  float32 SRR_FL_CAN_DET_RANGE_34;
  float32 SRR_FL_CAN_DET_RANGE_RATE_34;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_34;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_34;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_34;
} SG_SRR_FL_Detection_034_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_035_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_35;
  float32 SRR_FL_CAN_DET_AZIMUTH_35;
  Rte_DT_SG_SRR_FL_Detection_035_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_35;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_35;
  float32 SRR_FL_CAN_DET_ELEVATION_35;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_35;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_35;
  boolean SRR_FL_CAN_DET_Near_TARGET_35;
  float32 SRR_FL_CAN_DET_RANGE_35;
  float32 SRR_FL_CAN_DET_RANGE_RATE_35;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_35;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_35;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_35;
} SG_SRR_FL_Detection_035_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_036_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_36;
  float32 SRR_FL_CAN_DET_AZIMUTH_36;
  Rte_DT_SG_SRR_FL_Detection_036_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_36;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_36;
  float32 SRR_FL_CAN_DET_ELEVATION_36;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_36;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_36;
  boolean SRR_FL_CAN_DET_Near_TARGET_36;
  float32 SRR_FL_CAN_DET_RANGE_36;
  float32 SRR_FL_CAN_DET_RANGE_RATE_36;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_36;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_36;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_36;
} SG_SRR_FL_Detection_036_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_037_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_37;
  float32 SRR_FL_CAN_DET_AZIMUTH_37;
  Rte_DT_SG_SRR_FL_Detection_037_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_37;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_37;
  float32 SRR_FL_CAN_DET_ELEVATION_37;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_37;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_37;
  boolean SRR_FL_CAN_DET_Near_TARGET_37;
  float32 SRR_FL_CAN_DET_RANGE_37;
  float32 SRR_FL_CAN_DET_RANGE_RATE_37;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_37;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_37;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_37;
} SG_SRR_FL_Detection_037_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_038_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_38;
  float32 SRR_FL_CAN_DET_AZIMUTH_38;
  Rte_DT_SG_SRR_FL_Detection_038_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_38;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_38;
  float32 SRR_FL_CAN_DET_ELEVATION_38;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_38;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_38;
  boolean SRR_FL_CAN_DET_Near_TARGET_38;
  float32 SRR_FL_CAN_DET_RANGE_38;
  float32 SRR_FL_CAN_DET_RANGE_RATE_38;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_38;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_38;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_38;
} SG_SRR_FL_Detection_038_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_039_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_39;
  float32 SRR_FL_CAN_DET_AZIMUTH_39;
  Rte_DT_SG_SRR_FL_Detection_039_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_39;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_39;
  float32 SRR_FL_CAN_DET_ELEVATION_39;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_39;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_39;
  boolean SRR_FL_CAN_DET_Near_TARGET_39;
  float32 SRR_FL_CAN_DET_RANGE_39;
  float32 SRR_FL_CAN_DET_RANGE_RATE_39;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_39;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_39;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_39;
} SG_SRR_FL_Detection_039_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_040_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_40;
  float32 SRR_FL_CAN_DET_AZIMUTH_40;
  Rte_DT_SG_SRR_FL_Detection_040_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_40;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_40;
  float32 SRR_FL_CAN_DET_ELEVATION_40;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_40;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_40;
  boolean SRR_FL_CAN_DET_Near_TARGET_40;
  float32 SRR_FL_CAN_DET_RANGE_40;
  float32 SRR_FL_CAN_DET_RANGE_RATE_40;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_40;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_40;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_40;
} SG_SRR_FL_Detection_040_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_041_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_41;
  float32 SRR_FL_CAN_DET_AZIMUTH_41;
  Rte_DT_SG_SRR_FL_Detection_041_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_41;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_41;
  float32 SRR_FL_CAN_DET_ELEVATION_41;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_41;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_41;
  boolean SRR_FL_CAN_DET_Near_TARGET_41;
  float32 SRR_FL_CAN_DET_RANGE_41;
  float32 SRR_FL_CAN_DET_RANGE_RATE_41;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_41;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_41;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_41;
} SG_SRR_FL_Detection_041_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_042_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_42;
  float32 SRR_FL_CAN_DET_AZIMUTH_42;
  Rte_DT_SG_SRR_FL_Detection_042_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_42;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_42;
  float32 SRR_FL_CAN_DET_ELEVATION_42;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_42;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_42;
  boolean SRR_FL_CAN_DET_Near_TARGET_42;
  float32 SRR_FL_CAN_DET_RANGE_42;
  float32 SRR_FL_CAN_DET_RANGE_RATE_42;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_42;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_42;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_42;
} SG_SRR_FL_Detection_042_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_043_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_43;
  float32 SRR_FL_CAN_DET_AZIMUTH_43;
  Rte_DT_SG_SRR_FL_Detection_043_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_43;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_43;
  float32 SRR_FL_CAN_DET_ELEVATION_43;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_43;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_43;
  boolean SRR_FL_CAN_DET_Near_TARGET_43;
  float32 SRR_FL_CAN_DET_RANGE_43;
  float32 SRR_FL_CAN_DET_RANGE_RATE_43;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_43;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_43;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_43;
} SG_SRR_FL_Detection_043_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_044_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_44;
  float32 SRR_FL_CAN_DET_AZIMUTH_44;
  Rte_DT_SG_SRR_FL_Detection_044_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_44;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_44;
  float32 SRR_FL_CAN_DET_ELEVATION_44;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_44;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_44;
  boolean SRR_FL_CAN_DET_Near_TARGET_44;
  float32 SRR_FL_CAN_DET_RANGE_44;
  float32 SRR_FL_CAN_DET_RANGE_RATE_44;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_44;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_44;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_44;
} SG_SRR_FL_Detection_044_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_045_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_45;
  float32 SRR_FL_CAN_DET_AZIMUTH_45;
  Rte_DT_SG_SRR_FL_Detection_045_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_45;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_45;
  float32 SRR_FL_CAN_DET_ELEVATION_45;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_45;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_45;
  boolean SRR_FL_CAN_DET_Near_TARGET_45;
  float32 SRR_FL_CAN_DET_RANGE_45;
  float32 SRR_FL_CAN_DET_RANGE_RATE_45;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_45;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_45;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_45;
} SG_SRR_FL_Detection_045_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_046_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_46;
  float32 SRR_FL_CAN_DET_AZIMUTH_46;
  Rte_DT_SG_SRR_FL_Detection_046_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_46;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_46;
  float32 SRR_FL_CAN_DET_ELEVATION_46;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_46;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_46;
  boolean SRR_FL_CAN_DET_Near_TARGET_46;
  float32 SRR_FL_CAN_DET_RANGE_46;
  float32 SRR_FL_CAN_DET_RANGE_RATE_46;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_46;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_46;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_46;
} SG_SRR_FL_Detection_046_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_047_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_47;
  float32 SRR_FL_CAN_DET_AZIMUTH_47;
  Rte_DT_SG_SRR_FL_Detection_047_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_47;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_47;
  float32 SRR_FL_CAN_DET_ELEVATION_47;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_47;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_47;
  boolean SRR_FL_CAN_DET_Near_TARGET_47;
  float32 SRR_FL_CAN_DET_RANGE_47;
  float32 SRR_FL_CAN_DET_RANGE_RATE_47;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_47;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_47;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_47;
} SG_SRR_FL_Detection_047_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_048_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_48;
  float32 SRR_FL_CAN_DET_AZIMUTH_48;
  Rte_DT_SG_SRR_FL_Detection_048_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_48;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_48;
  float32 SRR_FL_CAN_DET_ELEVATION_48;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_48;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_48;
  boolean SRR_FL_CAN_DET_Near_TARGET_48;
  float32 SRR_FL_CAN_DET_RANGE_48;
  float32 SRR_FL_CAN_DET_RANGE_RATE_48;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_48;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_48;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_48;
} SG_SRR_FL_Detection_048_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_049_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_49;
  float32 SRR_FL_CAN_DET_AZIMUTH_49;
  Rte_DT_SG_SRR_FL_Detection_049_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_49;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_49;
  float32 SRR_FL_CAN_DET_ELEVATION_49;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_49;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_49;
  boolean SRR_FL_CAN_DET_Near_TARGET_49;
  float32 SRR_FL_CAN_DET_RANGE_49;
  float32 SRR_FL_CAN_DET_RANGE_RATE_49;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_49;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_49;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_49;
} SG_SRR_FL_Detection_049_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_050_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_50;
  float32 SRR_FL_CAN_DET_AZIMUTH_50;
  Rte_DT_SG_SRR_FL_Detection_050_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_50;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_50;
  float32 SRR_FL_CAN_DET_ELEVATION_50;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_50;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_50;
  boolean SRR_FL_CAN_DET_Near_TARGET_50;
  float32 SRR_FL_CAN_DET_RANGE_50;
  float32 SRR_FL_CAN_DET_RANGE_RATE_50;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_50;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_50;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_50;
} SG_SRR_FL_Detection_050_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_051_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_51;
  float32 SRR_FL_CAN_DET_AZIMUTH_51;
  Rte_DT_SG_SRR_FL_Detection_051_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_51;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_51;
  float32 SRR_FL_CAN_DET_ELEVATION_51;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_51;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_51;
  boolean SRR_FL_CAN_DET_Near_TARGET_51;
  float32 SRR_FL_CAN_DET_RANGE_51;
  float32 SRR_FL_CAN_DET_RANGE_RATE_51;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_51;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_51;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_51;
} SG_SRR_FL_Detection_051_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_052_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_52;
  float32 SRR_FL_CAN_DET_AZIMUTH_52;
  Rte_DT_SG_SRR_FL_Detection_052_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_52;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_52;
  float32 SRR_FL_CAN_DET_ELEVATION_52;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_52;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_52;
  boolean SRR_FL_CAN_DET_Near_TARGET_52;
  float32 SRR_FL_CAN_DET_RANGE_52;
  float32 SRR_FL_CAN_DET_RANGE_RATE_52;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_52;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_52;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_52;
} SG_SRR_FL_Detection_052_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_053_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_53;
  float32 SRR_FL_CAN_DET_AZIMUTH_53;
  Rte_DT_SG_SRR_FL_Detection_053_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_53;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_53;
  float32 SRR_FL_CAN_DET_ELEVATION_53;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_53;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_53;
  boolean SRR_FL_CAN_DET_Near_TARGET_53;
  float32 SRR_FL_CAN_DET_RANGE_53;
  float32 SRR_FL_CAN_DET_RANGE_RATE_53;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_53;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_53;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_53;
} SG_SRR_FL_Detection_053_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_054_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_54;
  float32 SRR_FL_CAN_DET_AZIMUTH_54;
  Rte_DT_SG_SRR_FL_Detection_054_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_54;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_54;
  float32 SRR_FL_CAN_DET_ELEVATION_54;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_54;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_54;
  boolean SRR_FL_CAN_DET_Near_TARGET_54;
  float32 SRR_FL_CAN_DET_RANGE_54;
  float32 SRR_FL_CAN_DET_RANGE_RATE_54;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_54;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_54;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_54;
} SG_SRR_FL_Detection_054_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_055_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_55;
  float32 SRR_FL_CAN_DET_AZIMUTH_55;
  Rte_DT_SG_SRR_FL_Detection_055_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_55;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_55;
  float32 SRR_FL_CAN_DET_ELEVATION_55;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_55;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_55;
  boolean SRR_FL_CAN_DET_Near_TARGET_55;
  float32 SRR_FL_CAN_DET_RANGE_55;
  float32 SRR_FL_CAN_DET_RANGE_RATE_55;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_55;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_55;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_55;
} SG_SRR_FL_Detection_055_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_056_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_56;
  float32 SRR_FL_CAN_DET_AZIMUTH_56;
  Rte_DT_SG_SRR_FL_Detection_056_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_56;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_56;
  float32 SRR_FL_CAN_DET_ELEVATION_56;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_56;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_56;
  boolean SRR_FL_CAN_DET_Near_TARGET_56;
  float32 SRR_FL_CAN_DET_RANGE_56;
  float32 SRR_FL_CAN_DET_RANGE_RATE_56;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_56;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_56;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_56;
} SG_SRR_FL_Detection_056_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_057_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_57;
  float32 SRR_FL_CAN_DET_AZIMUTH_57;
  Rte_DT_SG_SRR_FL_Detection_057_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_57;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_57;
  float32 SRR_FL_CAN_DET_ELEVATION_57;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_57;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_57;
  boolean SRR_FL_CAN_DET_Near_TARGET_57;
  float32 SRR_FL_CAN_DET_RANGE_57;
  float32 SRR_FL_CAN_DET_RANGE_RATE_57;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_57;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_57;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_57;
} SG_SRR_FL_Detection_057_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_058_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_58;
  float32 SRR_FL_CAN_DET_AZIMUTH_58;
  Rte_DT_SG_SRR_FL_Detection_058_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_58;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_58;
  float32 SRR_FL_CAN_DET_ELEVATION_58;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_58;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_58;
  boolean SRR_FL_CAN_DET_Near_TARGET_58;
  float32 SRR_FL_CAN_DET_RANGE_58;
  float32 SRR_FL_CAN_DET_RANGE_RATE_58;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_58;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_58;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_58;
} SG_SRR_FL_Detection_058_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_059_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_59;
  float32 SRR_FL_CAN_DET_AZIMUTH_59;
  Rte_DT_SG_SRR_FL_Detection_059_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_59;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_59;
  float32 SRR_FL_CAN_DET_ELEVATION_59;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_59;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_59;
  boolean SRR_FL_CAN_DET_Near_TARGET_59;
  float32 SRR_FL_CAN_DET_RANGE_59;
  float32 SRR_FL_CAN_DET_RANGE_RATE_59;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_59;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_59;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_59;
} SG_SRR_FL_Detection_059_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_060_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_60;
  float32 SRR_FL_CAN_DET_AZIMUTH_60;
  Rte_DT_SG_SRR_FL_Detection_060_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_60;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_60;
  float32 SRR_FL_CAN_DET_ELEVATION_60;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_60;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_60;
  boolean SRR_FL_CAN_DET_Near_TARGET_60;
  float32 SRR_FL_CAN_DET_RANGE_60;
  float32 SRR_FL_CAN_DET_RANGE_RATE_60;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_60;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_60;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_60;
} SG_SRR_FL_Detection_060_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_061_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_61;
  float32 SRR_FL_CAN_DET_AZIMUTH_61;
  Rte_DT_SG_SRR_FL_Detection_061_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_61;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_61;
  float32 SRR_FL_CAN_DET_ELEVATION_61;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_61;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_61;
  boolean SRR_FL_CAN_DET_Near_TARGET_61;
  float32 SRR_FL_CAN_DET_RANGE_61;
  float32 SRR_FL_CAN_DET_RANGE_RATE_61;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_61;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_61;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_61;
} SG_SRR_FL_Detection_061_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_062_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_62;
  float32 SRR_FL_CAN_DET_AZIMUTH_62;
  Rte_DT_SG_SRR_FL_Detection_062_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_62;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_62;
  float32 SRR_FL_CAN_DET_ELEVATION_62;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_62;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_62;
  boolean SRR_FL_CAN_DET_Near_TARGET_62;
  float32 SRR_FL_CAN_DET_RANGE_62;
  float32 SRR_FL_CAN_DET_RANGE_RATE_62;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_62;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_62;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_62;
} SG_SRR_FL_Detection_062_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_063_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_63;
  float32 SRR_FL_CAN_DET_AZIMUTH_63;
  Rte_DT_SG_SRR_FL_Detection_063_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_63;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_63;
  float32 SRR_FL_CAN_DET_ELEVATION_63;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_63;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_63;
  boolean SRR_FL_CAN_DET_Near_TARGET_63;
  float32 SRR_FL_CAN_DET_RANGE_63;
  float32 SRR_FL_CAN_DET_RANGE_RATE_63;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_63;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_63;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_63;
} SG_SRR_FL_Detection_063_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_064_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_64;
  float32 SRR_FL_CAN_DET_AZIMUTH_64;
  Rte_DT_SG_SRR_FL_Detection_064_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_64;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_64;
  float32 SRR_FL_CAN_DET_ELEVATION_64;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_64;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_64;
  boolean SRR_FL_CAN_DET_Near_TARGET_64;
  float32 SRR_FL_CAN_DET_RANGE_64;
  float32 SRR_FL_CAN_DET_RANGE_RATE_64;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_64;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_64;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_64;
} SG_SRR_FL_Detection_064_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_065_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_65;
  float32 SRR_FL_CAN_DET_AZIMUTH_65;
  Rte_DT_SG_SRR_FL_Detection_065_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_65;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_65;
  float32 SRR_FL_CAN_DET_ELEVATION_65;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_65;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_65;
  boolean SRR_FL_CAN_DET_Near_TARGET_65;
  float32 SRR_FL_CAN_DET_RANGE_65;
  float32 SRR_FL_CAN_DET_RANGE_RATE_65;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_65;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_65;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_65;
} SG_SRR_FL_Detection_065_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_066_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_66;
  float32 SRR_FL_CAN_DET_AZIMUTH_66;
  Rte_DT_SG_SRR_FL_Detection_066_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_66;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_66;
  float32 SRR_FL_CAN_DET_ELEVATION_66;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_66;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_66;
  boolean SRR_FL_CAN_DET_Near_TARGET_66;
  float32 SRR_FL_CAN_DET_RANGE_66;
  float32 SRR_FL_CAN_DET_RANGE_RATE_66;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_66;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_66;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_66;
} SG_SRR_FL_Detection_066_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_067_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_67;
  float32 SRR_FL_CAN_DET_AZIMUTH_67;
  Rte_DT_SG_SRR_FL_Detection_067_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_67;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_67;
  float32 SRR_FL_CAN_DET_ELEVATION_67;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_67;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_67;
  boolean SRR_FL_CAN_DET_Near_TARGET_67;
  float32 SRR_FL_CAN_DET_RANGE_67;
  float32 SRR_FL_CAN_DET_RANGE_RATE_67;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_67;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_67;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_67;
} SG_SRR_FL_Detection_067_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_068_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_68;
  float32 SRR_FL_CAN_DET_AZIMUTH_68;
  Rte_DT_SG_SRR_FL_Detection_068_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_68;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_68;
  float32 SRR_FL_CAN_DET_ELEVATION_68;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_68;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_68;
  boolean SRR_FL_CAN_DET_Near_TARGET_68;
  float32 SRR_FL_CAN_DET_RANGE_68;
  float32 SRR_FL_CAN_DET_RANGE_RATE_68;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_68;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_68;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_68;
} SG_SRR_FL_Detection_068_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_069_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_69;
  float32 SRR_FL_CAN_DET_AZIMUTH_69;
  Rte_DT_SG_SRR_FL_Detection_069_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_69;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_69;
  float32 SRR_FL_CAN_DET_ELEVATION_69;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_69;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_69;
  boolean SRR_FL_CAN_DET_Near_TARGET_69;
  float32 SRR_FL_CAN_DET_RANGE_69;
  float32 SRR_FL_CAN_DET_RANGE_RATE_69;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_69;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_69;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_69;
} SG_SRR_FL_Detection_069_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_070_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_70;
  float32 SRR_FL_CAN_DET_AZIMUTH_70;
  Rte_DT_SG_SRR_FL_Detection_070_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_70;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_70;
  float32 SRR_FL_CAN_DET_ELEVATION_70;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_70;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_70;
  boolean SRR_FL_CAN_DET_Near_TARGET_70;
  float32 SRR_FL_CAN_DET_RANGE_70;
  float32 SRR_FL_CAN_DET_RANGE_RATE_70;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_70;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_70;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_70;
} SG_SRR_FL_Detection_070_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_071_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_71;
  float32 SRR_FL_CAN_DET_AZIMUTH_71;
  Rte_DT_SG_SRR_FL_Detection_071_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_71;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_71;
  float32 SRR_FL_CAN_DET_ELEVATION_71;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_71;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_71;
  boolean SRR_FL_CAN_DET_Near_TARGET_71;
  float32 SRR_FL_CAN_DET_RANGE_71;
  float32 SRR_FL_CAN_DET_RANGE_RATE_71;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_71;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_71;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_71;
} SG_SRR_FL_Detection_071_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_072_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_72;
  float32 SRR_FL_CAN_DET_AZIMUTH_72;
  Rte_DT_SG_SRR_FL_Detection_072_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_72;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_72;
  float32 SRR_FL_CAN_DET_ELEVATION_72;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_72;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_72;
  boolean SRR_FL_CAN_DET_Near_TARGET_72;
  float32 SRR_FL_CAN_DET_RANGE_72;
  float32 SRR_FL_CAN_DET_RANGE_RATE_72;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_72;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_72;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_72;
} SG_SRR_FL_Detection_072_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_073_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_73;
  float32 SRR_FL_CAN_DET_AZIMUTH_73;
  Rte_DT_SG_SRR_FL_Detection_073_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_73;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_73;
  float32 SRR_FL_CAN_DET_ELEVATION_73;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_73;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_73;
  boolean SRR_FL_CAN_DET_Near_TARGET_73;
  float32 SRR_FL_CAN_DET_RANGE_73;
  float32 SRR_FL_CAN_DET_RANGE_RATE_73;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_73;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_73;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_73;
} SG_SRR_FL_Detection_073_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_074_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_74;
  float32 SRR_FL_CAN_DET_AZIMUTH_74;
  Rte_DT_SG_SRR_FL_Detection_074_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_74;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_74;
  float32 SRR_FL_CAN_DET_ELEVATION_74;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_74;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_74;
  boolean SRR_FL_CAN_DET_Near_TARGET_74;
  float32 SRR_FL_CAN_DET_RANGE_74;
  float32 SRR_FL_CAN_DET_RANGE_RATE_74;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_74;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_74;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_74;
} SG_SRR_FL_Detection_074_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_075_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_75;
  float32 SRR_FL_CAN_DET_AZIMUTH_75;
  Rte_DT_SG_SRR_FL_Detection_075_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_75;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_75;
  float32 SRR_FL_CAN_DET_ELEVATION_75;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_75;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_75;
  boolean SRR_FL_CAN_DET_Near_TARGET_75;
  float32 SRR_FL_CAN_DET_RANGE_75;
  float32 SRR_FL_CAN_DET_RANGE_RATE_75;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_75;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_75;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_75;
} SG_SRR_FL_Detection_075_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_076_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_76;
  float32 SRR_FL_CAN_DET_AZIMUTH_76;
  Rte_DT_SG_SRR_FL_Detection_076_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_76;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_76;
  float32 SRR_FL_CAN_DET_ELEVATION_76;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_76;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_76;
  boolean SRR_FL_CAN_DET_Near_TARGET_76;
  float32 SRR_FL_CAN_DET_RANGE_76;
  float32 SRR_FL_CAN_DET_RANGE_RATE_76;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_76;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_76;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_76;
} SG_SRR_FL_Detection_076_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_077_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_77;
  float32 SRR_FL_CAN_DET_AZIMUTH_77;
  Rte_DT_SG_SRR_FL_Detection_077_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_77;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_77;
  float32 SRR_FL_CAN_DET_ELEVATION_77;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_77;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_77;
  boolean SRR_FL_CAN_DET_Near_TARGET_77;
  float32 SRR_FL_CAN_DET_RANGE_77;
  float32 SRR_FL_CAN_DET_RANGE_RATE_77;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_77;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_77;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_77;
} SG_SRR_FL_Detection_077_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_078_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_78;
  float32 SRR_FL_CAN_DET_AZIMUTH_78;
  Rte_DT_SG_SRR_FL_Detection_078_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_78;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_78;
  float32 SRR_FL_CAN_DET_ELEVATION_78;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_78;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_78;
  boolean SRR_FL_CAN_DET_Near_TARGET_78;
  float32 SRR_FL_CAN_DET_RANGE_78;
  float32 SRR_FL_CAN_DET_RANGE_RATE_78;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_78;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_78;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_78;
} SG_SRR_FL_Detection_078_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_079_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_79;
  float32 SRR_FL_CAN_DET_AZIMUTH_79;
  Rte_DT_SG_SRR_FL_Detection_079_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_79;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_79;
  float32 SRR_FL_CAN_DET_ELEVATION_79;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_79;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_79;
  boolean SRR_FL_CAN_DET_Near_TARGET_79;
  float32 SRR_FL_CAN_DET_RANGE_79;
  float32 SRR_FL_CAN_DET_RANGE_RATE_79;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_79;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_79;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_79;
} SG_SRR_FL_Detection_079_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_080_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_80;
  float32 SRR_FL_CAN_DET_AZIMUTH_80;
  Rte_DT_SG_SRR_FL_Detection_080_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_80;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_80;
  float32 SRR_FL_CAN_DET_ELEVATION_80;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_80;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_80;
  boolean SRR_FL_CAN_DET_Near_TARGET_80;
  float32 SRR_FL_CAN_DET_RANGE_80;
  float32 SRR_FL_CAN_DET_RANGE_RATE_80;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_80;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_80;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_80;
} SG_SRR_FL_Detection_080_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_081_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_81;
  float32 SRR_FL_CAN_DET_AZIMUTH_81;
  Rte_DT_SG_SRR_FL_Detection_081_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_81;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_81;
  float32 SRR_FL_CAN_DET_ELEVATION_81;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_81;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_81;
  boolean SRR_FL_CAN_DET_Near_TARGET_81;
  float32 SRR_FL_CAN_DET_RANGE_81;
  float32 SRR_FL_CAN_DET_RANGE_RATE_81;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_81;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_81;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_81;
} SG_SRR_FL_Detection_081_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_082_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_82;
  float32 SRR_FL_CAN_DET_AZIMUTH_82;
  Rte_DT_SG_SRR_FL_Detection_082_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_82;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_82;
  float32 SRR_FL_CAN_DET_ELEVATION_82;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_82;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_82;
  boolean SRR_FL_CAN_DET_Near_TARGET_82;
  float32 SRR_FL_CAN_DET_RANGE_82;
  float32 SRR_FL_CAN_DET_RANGE_RATE_82;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_82;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_82;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_82;
} SG_SRR_FL_Detection_082_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_083_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_83;
  float32 SRR_FL_CAN_DET_AZIMUTH_83;
  Rte_DT_SG_SRR_FL_Detection_083_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_83;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_83;
  float32 SRR_FL_CAN_DET_ELEVATION_83;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_83;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_83;
  boolean SRR_FL_CAN_DET_Near_TARGET_83;
  float32 SRR_FL_CAN_DET_RANGE_83;
  float32 SRR_FL_CAN_DET_RANGE_RATE_83;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_83;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_83;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_83;
} SG_SRR_FL_Detection_083_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_084_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_84;
  float32 SRR_FL_CAN_DET_AZIMUTH_84;
  Rte_DT_SG_SRR_FL_Detection_084_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_84;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_84;
  float32 SRR_FL_CAN_DET_ELEVATION_84;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_84;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_84;
  boolean SRR_FL_CAN_DET_Near_TARGET_84;
  float32 SRR_FL_CAN_DET_RANGE_84;
  float32 SRR_FL_CAN_DET_RANGE_RATE_84;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_84;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_84;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_84;
} SG_SRR_FL_Detection_084_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_085_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_85;
  float32 SRR_FL_CAN_DET_AZIMUTH_85;
  Rte_DT_SG_SRR_FL_Detection_085_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_85;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_85;
  float32 SRR_FL_CAN_DET_ELEVATION_85;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_85;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_85;
  boolean SRR_FL_CAN_DET_Near_TARGET_85;
  float32 SRR_FL_CAN_DET_RANGE_85;
  float32 SRR_FL_CAN_DET_RANGE_RATE_85;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_85;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_85;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_85;
} SG_SRR_FL_Detection_085_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_086_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_86;
  float32 SRR_FL_CAN_DET_AZIMUTH_86;
  Rte_DT_SG_SRR_FL_Detection_086_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_86;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_86;
  float32 SRR_FL_CAN_DET_ELEVATION_86;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_86;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_86;
  boolean SRR_FL_CAN_DET_Near_TARGET_86;
  float32 SRR_FL_CAN_DET_RANGE_86;
  float32 SRR_FL_CAN_DET_RANGE_RATE_86;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_86;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_86;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_86;
} SG_SRR_FL_Detection_086_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_087_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_87;
  float32 SRR_FL_CAN_DET_AZIMUTH_87;
  Rte_DT_SG_SRR_FL_Detection_087_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_87;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_87;
  float32 SRR_FL_CAN_DET_ELEVATION_87;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_87;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_87;
  boolean SRR_FL_CAN_DET_Near_TARGET_87;
  float32 SRR_FL_CAN_DET_RANGE_87;
  float32 SRR_FL_CAN_DET_RANGE_RATE_87;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_87;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_87;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_87;
} SG_SRR_FL_Detection_087_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_088_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_88;
  float32 SRR_FL_CAN_DET_AZIMUTH_88;
  Rte_DT_SG_SRR_FL_Detection_088_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_88;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_88;
  float32 SRR_FL_CAN_DET_ELEVATION_88;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_88;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_88;
  boolean SRR_FL_CAN_DET_Near_TARGET_88;
  float32 SRR_FL_CAN_DET_RANGE_88;
  float32 SRR_FL_CAN_DET_RANGE_RATE_88;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_88;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_88;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_88;
} SG_SRR_FL_Detection_088_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_089_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_89;
  float32 SRR_FL_CAN_DET_AZIMUTH_89;
  Rte_DT_SG_SRR_FL_Detection_089_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_89;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_89;
  float32 SRR_FL_CAN_DET_ELEVATION_89;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_89;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_89;
  boolean SRR_FL_CAN_DET_Near_TARGET_89;
  float32 SRR_FL_CAN_DET_RANGE_89;
  float32 SRR_FL_CAN_DET_RANGE_RATE_89;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_89;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_89;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_89;
} SG_SRR_FL_Detection_089_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_090_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_90;
  float32 SRR_FL_CAN_DET_AZIMUTH_90;
  Rte_DT_SG_SRR_FL_Detection_090_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_90;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_90;
  float32 SRR_FL_CAN_DET_ELEVATION_90;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_90;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_90;
  boolean SRR_FL_CAN_DET_Near_TARGET_90;
  float32 SRR_FL_CAN_DET_RANGE_90;
  float32 SRR_FL_CAN_DET_RANGE_RATE_90;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_90;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_90;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_90;
} SG_SRR_FL_Detection_090_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_091_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_91;
  float32 SRR_FL_CAN_DET_AZIMUTH_91;
  Rte_DT_SG_SRR_FL_Detection_091_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_91;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_91;
  float32 SRR_FL_CAN_DET_ELEVATION_91;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_91;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_91;
  boolean SRR_FL_CAN_DET_Near_TARGET_91;
  float32 SRR_FL_CAN_DET_RANGE_91;
  float32 SRR_FL_CAN_DET_RANGE_RATE_91;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_91;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_91;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_91;
} SG_SRR_FL_Detection_091_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_092_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_92;
  float32 SRR_FL_CAN_DET_AZIMUTH_92;
  Rte_DT_SG_SRR_FL_Detection_092_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_92;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_92;
  float32 SRR_FL_CAN_DET_ELEVATION_92;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_92;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_92;
  boolean SRR_FL_CAN_DET_Near_TARGET_92;
  float32 SRR_FL_CAN_DET_RANGE_92;
  float32 SRR_FL_CAN_DET_RANGE_RATE_92;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_92;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_92;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_92;
} SG_SRR_FL_Detection_092_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_093_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_93;
  float32 SRR_FL_CAN_DET_AZIMUTH_93;
  Rte_DT_SG_SRR_FL_Detection_093_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_93;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_93;
  float32 SRR_FL_CAN_DET_ELEVATION_93;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_93;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_93;
  boolean SRR_FL_CAN_DET_Near_TARGET_93;
  float32 SRR_FL_CAN_DET_RANGE_93;
  float32 SRR_FL_CAN_DET_RANGE_RATE_93;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_93;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_93;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_93;
} SG_SRR_FL_Detection_093_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_094_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_94;
  float32 SRR_FL_CAN_DET_AZIMUTH_94;
  Rte_DT_SG_SRR_FL_Detection_094_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_94;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_94;
  float32 SRR_FL_CAN_DET_ELEVATION_94;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_94;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_94;
  boolean SRR_FL_CAN_DET_Near_TARGET_94;
  float32 SRR_FL_CAN_DET_RANGE_94;
  float32 SRR_FL_CAN_DET_RANGE_RATE_94;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_94;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_94;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_94;
} SG_SRR_FL_Detection_094_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_095_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_95;
  float32 SRR_FL_CAN_DET_AZIMUTH_95;
  Rte_DT_SG_SRR_FL_Detection_095_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_95;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_95;
  float32 SRR_FL_CAN_DET_ELEVATION_95;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_95;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_95;
  boolean SRR_FL_CAN_DET_Near_TARGET_95;
  float32 SRR_FL_CAN_DET_RANGE_95;
  float32 SRR_FL_CAN_DET_RANGE_RATE_95;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_95;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_95;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_95;
} SG_SRR_FL_Detection_095_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_096_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_96;
  float32 SRR_FL_CAN_DET_AZIMUTH_96;
  Rte_DT_SG_SRR_FL_Detection_096_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_96;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_96;
  float32 SRR_FL_CAN_DET_ELEVATION_96;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_96;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_96;
  boolean SRR_FL_CAN_DET_Near_TARGET_96;
  float32 SRR_FL_CAN_DET_RANGE_96;
  float32 SRR_FL_CAN_DET_RANGE_RATE_96;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_96;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_96;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_96;
} SG_SRR_FL_Detection_096_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_097_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_97;
  float32 SRR_FL_CAN_DET_AZIMUTH_97;
  Rte_DT_SG_SRR_FL_Detection_097_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_97;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_97;
  float32 SRR_FL_CAN_DET_ELEVATION_97;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_97;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_97;
  boolean SRR_FL_CAN_DET_Near_TARGET_97;
  float32 SRR_FL_CAN_DET_RANGE_97;
  float32 SRR_FL_CAN_DET_RANGE_RATE_97;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_97;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_97;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_97;
} SG_SRR_FL_Detection_097_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_098_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_98;
  float32 SRR_FL_CAN_DET_AZIMUTH_98;
  Rte_DT_SG_SRR_FL_Detection_098_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_98;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_98;
  float32 SRR_FL_CAN_DET_ELEVATION_98;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_98;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_98;
  boolean SRR_FL_CAN_DET_Near_TARGET_98;
  float32 SRR_FL_CAN_DET_RANGE_98;
  float32 SRR_FL_CAN_DET_RANGE_RATE_98;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_98;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_98;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_98;
} SG_SRR_FL_Detection_098_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_099_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_99;
  float32 SRR_FL_CAN_DET_AZIMUTH_99;
  Rte_DT_SG_SRR_FL_Detection_099_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_99;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_99;
  float32 SRR_FL_CAN_DET_ELEVATION_99;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_99;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_99;
  boolean SRR_FL_CAN_DET_Near_TARGET_99;
  float32 SRR_FL_CAN_DET_RANGE_99;
  float32 SRR_FL_CAN_DET_RANGE_RATE_99;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_99;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_99;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_99;
} SG_SRR_FL_Detection_099_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_100_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_100;
  float32 SRR_FL_CAN_DET_AZIMUTH_100;
  Rte_DT_SG_SRR_FL_Detection_100_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_100;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_100;
  float32 SRR_FL_CAN_DET_ELEVATION_100;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_100;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_100;
  boolean SRR_FL_CAN_DET_Near_TARGET_100;
  float32 SRR_FL_CAN_DET_RANGE_100;
  float32 SRR_FL_CAN_DET_RANGE_RATE_100;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_100;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_100;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_100;
} SG_SRR_FL_Detection_100_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_101_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_101;
  float32 SRR_FL_CAN_DET_AZIMUTH_101;
  Rte_DT_SG_SRR_FL_Detection_101_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_101;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_101;
  float32 SRR_FL_CAN_DET_ELEVATION_101;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_101;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_101;
  boolean SRR_FL_CAN_DET_Near_TARGET_101;
  float32 SRR_FL_CAN_DET_RANGE_101;
  float32 SRR_FL_CAN_DET_RANGE_RATE_101;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_101;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_101;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_101;
} SG_SRR_FL_Detection_101_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_102_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_102;
  float32 SRR_FL_CAN_DET_AZIMUTH_102;
  Rte_DT_SG_SRR_FL_Detection_102_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_102;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_102;
  float32 SRR_FL_CAN_DET_ELEVATION_102;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_102;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_102;
  boolean SRR_FL_CAN_DET_Near_TARGET_102;
  float32 SRR_FL_CAN_DET_RANGE_102;
  float32 SRR_FL_CAN_DET_RANGE_RATE_102;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_102;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_102;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_102;
} SG_SRR_FL_Detection_102_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_103_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_103;
  float32 SRR_FL_CAN_DET_AZIMUTH_103;
  Rte_DT_SG_SRR_FL_Detection_103_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_103;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_103;
  float32 SRR_FL_CAN_DET_ELEVATION_103;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_103;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_103;
  boolean SRR_FL_CAN_DET_Near_TARGET_103;
  float32 SRR_FL_CAN_DET_RANGE_103;
  float32 SRR_FL_CAN_DET_RANGE_RATE_103;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_103;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_103;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_103;
} SG_SRR_FL_Detection_103_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_104_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_104;
  float32 SRR_FL_CAN_DET_AZIMUTH_104;
  Rte_DT_SG_SRR_FL_Detection_104_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_104;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_104;
  float32 SRR_FL_CAN_DET_ELEVATION_104;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_104;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_104;
  boolean SRR_FL_CAN_DET_Near_TARGET_104;
  float32 SRR_FL_CAN_DET_RANGE_104;
  float32 SRR_FL_CAN_DET_RANGE_RATE_104;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_104;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_104;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_104;
} SG_SRR_FL_Detection_104_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_105_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_105;
  float32 SRR_FL_CAN_DET_AZIMUTH_105;
  Rte_DT_SG_SRR_FL_Detection_105_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_105;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_105;
  float32 SRR_FL_CAN_DET_ELEVATION_105;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_105;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_105;
  boolean SRR_FL_CAN_DET_Near_TARGET_105;
  float32 SRR_FL_CAN_DET_RANGE_105;
  float32 SRR_FL_CAN_DET_RANGE_RATE_105;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_105;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_105;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_105;
} SG_SRR_FL_Detection_105_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_106_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_106;
  float32 SRR_FL_CAN_DET_AZIMUTH_106;
  Rte_DT_SG_SRR_FL_Detection_106_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_106;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_106;
  float32 SRR_FL_CAN_DET_ELEVATION_106;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_106;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_106;
  boolean SRR_FL_CAN_DET_Near_TARGET_106;
  float32 SRR_FL_CAN_DET_RANGE_106;
  float32 SRR_FL_CAN_DET_RANGE_RATE_106;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_106;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_106;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_106;
} SG_SRR_FL_Detection_106_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_107_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_107;
  float32 SRR_FL_CAN_DET_AZIMUTH_107;
  Rte_DT_SG_SRR_FL_Detection_107_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_107;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_107;
  float32 SRR_FL_CAN_DET_ELEVATION_107;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_107;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_107;
  boolean SRR_FL_CAN_DET_Near_TARGET_107;
  float32 SRR_FL_CAN_DET_RANGE_107;
  float32 SRR_FL_CAN_DET_RANGE_RATE_107;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_107;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_107;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_107;
} SG_SRR_FL_Detection_107_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_108_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_108;
  float32 SRR_FL_CAN_DET_AZIMUTH_108;
  Rte_DT_SG_SRR_FL_Detection_108_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_108;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_108;
  float32 SRR_FL_CAN_DET_ELEVATION_108;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_108;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_108;
  boolean SRR_FL_CAN_DET_Near_TARGET_108;
  float32 SRR_FL_CAN_DET_RANGE_108;
  float32 SRR_FL_CAN_DET_RANGE_RATE_108;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_108;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_108;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_108;
} SG_SRR_FL_Detection_108_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_109_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_109;
  float32 SRR_FL_CAN_DET_AZIMUTH_109;
  Rte_DT_SG_SRR_FL_Detection_109_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_109;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_109;
  float32 SRR_FL_CAN_DET_ELEVATION_109;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_109;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_109;
  boolean SRR_FL_CAN_DET_Near_TARGET_109;
  float32 SRR_FL_CAN_DET_RANGE_109;
  float32 SRR_FL_CAN_DET_RANGE_RATE_109;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_109;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_109;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_109;
} SG_SRR_FL_Detection_109_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_110_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_110;
  float32 SRR_FL_CAN_DET_AZIMUTH_110;
  Rte_DT_SG_SRR_FL_Detection_110_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_110;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_110;
  float32 SRR_FL_CAN_DET_ELEVATION_110;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_110;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_110;
  boolean SRR_FL_CAN_DET_Near_TARGET_110;
  float32 SRR_FL_CAN_DET_RANGE_110;
  float32 SRR_FL_CAN_DET_RANGE_RATE_110;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_110;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_110;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_110;
} SG_SRR_FL_Detection_110_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_111_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_111;
  float32 SRR_FL_CAN_DET_AZIMUTH_111;
  Rte_DT_SG_SRR_FL_Detection_111_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_111;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_111;
  float32 SRR_FL_CAN_DET_ELEVATION_111;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_111;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_111;
  boolean SRR_FL_CAN_DET_Near_TARGET_111;
  float32 SRR_FL_CAN_DET_RANGE_111;
  float32 SRR_FL_CAN_DET_RANGE_RATE_111;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_111;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_111;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_111;
} SG_SRR_FL_Detection_111_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_112_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_112;
  float32 SRR_FL_CAN_DET_AZIMUTH_112;
  Rte_DT_SG_SRR_FL_Detection_112_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_112;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_112;
  float32 SRR_FL_CAN_DET_ELEVATION_112;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_112;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_112;
  boolean SRR_FL_CAN_DET_Near_TARGET_112;
  float32 SRR_FL_CAN_DET_RANGE_112;
  float32 SRR_FL_CAN_DET_RANGE_RATE_112;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_112;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_112;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_112;
} SG_SRR_FL_Detection_112_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_113_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_113;
  float32 SRR_FL_CAN_DET_AZIMUTH_113;
  Rte_DT_SG_SRR_FL_Detection_113_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_113;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_113;
  float32 SRR_FL_CAN_DET_ELEVATION_113;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_113;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_113;
  boolean SRR_FL_CAN_DET_Near_TARGET_113;
  float32 SRR_FL_CAN_DET_RANGE_113;
  float32 SRR_FL_CAN_DET_RANGE_RATE_113;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_113;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_113;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_113;
} SG_SRR_FL_Detection_113_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_114_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_114;
  float32 SRR_FL_CAN_DET_AZIMUTH_114;
  Rte_DT_SG_SRR_FL_Detection_114_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_114;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_114;
  float32 SRR_FL_CAN_DET_ELEVATION_114;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_114;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_114;
  boolean SRR_FL_CAN_DET_Near_TARGET_114;
  float32 SRR_FL_CAN_DET_RANGE_114;
  float32 SRR_FL_CAN_DET_RANGE_RATE_114;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_114;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_114;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_114;
} SG_SRR_FL_Detection_114_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_115_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_115;
  float32 SRR_FL_CAN_DET_AZIMUTH_115;
  Rte_DT_SG_SRR_FL_Detection_115_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_115;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_115;
  float32 SRR_FL_CAN_DET_ELEVATION_115;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_115;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_115;
  boolean SRR_FL_CAN_DET_Near_TARGET_115;
  float32 SRR_FL_CAN_DET_RANGE_115;
  float32 SRR_FL_CAN_DET_RANGE_RATE_115;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_115;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_115;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_115;
} SG_SRR_FL_Detection_115_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_116_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_116;
  float32 SRR_FL_CAN_DET_AZIMUTH_116;
  Rte_DT_SG_SRR_FL_Detection_116_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_116;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_116;
  float32 SRR_FL_CAN_DET_ELEVATION_116;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_116;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_116;
  boolean SRR_FL_CAN_DET_Near_TARGET_116;
  float32 SRR_FL_CAN_DET_RANGE_116;
  float32 SRR_FL_CAN_DET_RANGE_RATE_116;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_116;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_116;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_116;
} SG_SRR_FL_Detection_116_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_117_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_117;
  float32 SRR_FL_CAN_DET_AZIMUTH_117;
  Rte_DT_SG_SRR_FL_Detection_117_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_117;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_117;
  float32 SRR_FL_CAN_DET_ELEVATION_117;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_117;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_117;
  boolean SRR_FL_CAN_DET_Near_TARGET_117;
  float32 SRR_FL_CAN_DET_RANGE_117;
  float32 SRR_FL_CAN_DET_RANGE_RATE_117;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_117;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_117;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_117;
} SG_SRR_FL_Detection_117_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_118_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_118;
  float32 SRR_FL_CAN_DET_AZIMUTH_118;
  Rte_DT_SG_SRR_FL_Detection_118_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_118;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_118;
  float32 SRR_FL_CAN_DET_ELEVATION_118;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_118;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_118;
  boolean SRR_FL_CAN_DET_Near_TARGET_118;
  float32 SRR_FL_CAN_DET_RANGE_118;
  float32 SRR_FL_CAN_DET_RANGE_RATE_118;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_118;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_118;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_118;
} SG_SRR_FL_Detection_118_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_119_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_119;
  float32 SRR_FL_CAN_DET_AZIMUTH_119;
  Rte_DT_SG_SRR_FL_Detection_119_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_119;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_119;
  float32 SRR_FL_CAN_DET_ELEVATION_119;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_119;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_119;
  boolean SRR_FL_CAN_DET_Near_TARGET_119;
  float32 SRR_FL_CAN_DET_RANGE_119;
  float32 SRR_FL_CAN_DET_RANGE_RATE_119;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_119;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_119;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_119;
} SG_SRR_FL_Detection_119_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_120_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_120;
  float32 SRR_FL_CAN_DET_AZIMUTH_120;
  Rte_DT_SG_SRR_FL_Detection_120_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_120;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_120;
  float32 SRR_FL_CAN_DET_ELEVATION_120;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_120;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_120;
  boolean SRR_FL_CAN_DET_Near_TARGET_120;
  float32 SRR_FL_CAN_DET_RANGE_120;
  float32 SRR_FL_CAN_DET_RANGE_RATE_120;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_120;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_120;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_120;
} SG_SRR_FL_Detection_120_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_121_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_121;
  float32 SRR_FL_CAN_DET_AZIMUTH_121;
  Rte_DT_SG_SRR_FL_Detection_121_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_121;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_121;
  float32 SRR_FL_CAN_DET_ELEVATION_121;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_121;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_121;
  boolean SRR_FL_CAN_DET_Near_TARGET_121;
  float32 SRR_FL_CAN_DET_RANGE_121;
  float32 SRR_FL_CAN_DET_RANGE_RATE_121;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_121;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_121;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_121;
} SG_SRR_FL_Detection_121_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_122_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_122;
  float32 SRR_FL_CAN_DET_AZIMUTH_122;
  Rte_DT_SG_SRR_FL_Detection_122_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_122;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_122;
  float32 SRR_FL_CAN_DET_ELEVATION_122;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_122;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_122;
  boolean SRR_FL_CAN_DET_Near_TARGET_122;
  float32 SRR_FL_CAN_DET_RANGE_122;
  float32 SRR_FL_CAN_DET_RANGE_RATE_122;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_122;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_122;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_122;
} SG_SRR_FL_Detection_122_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_123_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_123;
  float32 SRR_FL_CAN_DET_AZIMUTH_123;
  Rte_DT_SG_SRR_FL_Detection_123_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_123;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_123;
  float32 SRR_FL_CAN_DET_ELEVATION_123;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_123;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_123;
  boolean SRR_FL_CAN_DET_Near_TARGET_123;
  float32 SRR_FL_CAN_DET_RANGE_123;
  float32 SRR_FL_CAN_DET_RANGE_RATE_123;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_123;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_123;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_123;
} SG_SRR_FL_Detection_123_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_124_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_124;
  float32 SRR_FL_CAN_DET_AZIMUTH_124;
  Rte_DT_SG_SRR_FL_Detection_124_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_124;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_124;
  float32 SRR_FL_CAN_DET_ELEVATION_124;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_124;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_124;
  boolean SRR_FL_CAN_DET_Near_TARGET_124;
  float32 SRR_FL_CAN_DET_RANGE_124;
  float32 SRR_FL_CAN_DET_RANGE_RATE_124;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_124;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_124;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_124;
} SG_SRR_FL_Detection_124_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_125_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_125;
  float32 SRR_FL_CAN_DET_AZIMUTH_125;
  Rte_DT_SG_SRR_FL_Detection_125_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_125;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_125;
  float32 SRR_FL_CAN_DET_ELEVATION_125;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_125;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_125;
  boolean SRR_FL_CAN_DET_Near_TARGET_125;
  float32 SRR_FL_CAN_DET_RANGE_125;
  float32 SRR_FL_CAN_DET_RANGE_RATE_125;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_125;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_125;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_125;
} SG_SRR_FL_Detection_125_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_126_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_126;
  float32 SRR_FL_CAN_DET_AZIMUTH_126;
  Rte_DT_SG_SRR_FL_Detection_126_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_126;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_126;
  float32 SRR_FL_CAN_DET_ELEVATION_126;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_126;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_126;
  boolean SRR_FL_CAN_DET_Near_TARGET_126;
  float32 SRR_FL_CAN_DET_RANGE_126;
  float32 SRR_FL_CAN_DET_RANGE_RATE_126;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_126;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_126;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_126;
} SG_SRR_FL_Detection_126_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_127_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_127;
  float32 SRR_FL_CAN_DET_AZIMUTH_127;
  Rte_DT_SG_SRR_FL_Detection_127_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_127;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_127;
  float32 SRR_FL_CAN_DET_ELEVATION_127;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_127;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_127;
  boolean SRR_FL_CAN_DET_Near_TARGET_127;
  float32 SRR_FL_CAN_DET_RANGE_127;
  float32 SRR_FL_CAN_DET_RANGE_RATE_127;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_127;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_127;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_127;
} SG_SRR_FL_Detection_127_t;

#  define Rte_TypeDef_SG_SRR_FL_Detection_128_t
typedef struct
{
  sint8 SRR_FL_CAN_DET_AMPLITUDE_128;
  float32 SRR_FL_CAN_DET_AZIMUTH_128;
  Rte_DT_SG_SRR_FL_Detection_128_t_2 SRR_FL_CAN_DET_CONFID_AZIMUTH_128;
  boolean SRR_FL_CAN_DET_CONFID_ELEVATION_128;
  float32 SRR_FL_CAN_DET_ELEVATION_128;
  boolean SRR_FL_CAN_DET_GUARD_RAIL_128;
  boolean SRR_FL_CAN_DET_HOST_VEH_CLUTTER_128;
  boolean SRR_FL_CAN_DET_Near_TARGET_128;
  float32 SRR_FL_CAN_DET_RANGE_128;
  float32 SRR_FL_CAN_DET_RANGE_RATE_128;
  boolean SRR_FL_CAN_DET_SUPER_RES_TARGET_128;
  boolean SRR_FL_CAN_DET_VALID_LEVEL_128;
  uint8 SRR_FL_CAN_SCAN_INDEX_2LSB_128;
} SG_SRR_FL_Detection_128_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_001_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_01;
  float32 SRR_FR_CAN_DET_AZIMUTH_01;
  Rte_DT_SG_SRR_FR_Detection_001_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_01;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_01;
  float32 SRR_FR_CAN_DET_ELEVATION_01;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_01;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_01;
  boolean SRR_FR_CAN_DET_Near_TARGET_01;
  float32 SRR_FR_CAN_DET_RANGE_01;
  float32 SRR_FR_CAN_DET_RANGE_RATE_01;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_01;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_01;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_01;
} SG_SRR_FR_Detection_001_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_002_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_02;
  float32 SRR_FR_CAN_DET_AZIMUTH_02;
  Rte_DT_SG_SRR_FR_Detection_002_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_02;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_02;
  float32 SRR_FR_CAN_DET_ELEVATION_02;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_02;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_02;
  boolean SRR_FR_CAN_DET_Near_TARGET_02;
  float32 SRR_FR_CAN_DET_RANGE_02;
  float32 SRR_FR_CAN_DET_RANGE_RATE_02;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_02;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_02;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_02;
} SG_SRR_FR_Detection_002_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_003_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_03;
  float32 SRR_FR_CAN_DET_AZIMUTH_03;
  Rte_DT_SG_SRR_FR_Detection_003_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_03;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_03;
  float32 SRR_FR_CAN_DET_ELEVATION_03;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_03;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_03;
  boolean SRR_FR_CAN_DET_Near_TARGET_03;
  float32 SRR_FR_CAN_DET_RANGE_03;
  float32 SRR_FR_CAN_DET_RANGE_RATE_03;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_03;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_03;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_03;
} SG_SRR_FR_Detection_003_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_004_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_04;
  float32 SRR_FR_CAN_DET_AZIMUTH_04;
  Rte_DT_SG_SRR_FR_Detection_004_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_04;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_04;
  float32 SRR_FR_CAN_DET_ELEVATION_04;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_04;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_04;
  boolean SRR_FR_CAN_DET_Near_TARGET_04;
  float32 SRR_FR_CAN_DET_RANGE_04;
  float32 SRR_FR_CAN_DET_RANGE_RATE_04;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_04;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_04;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_04;
} SG_SRR_FR_Detection_004_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_005_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_05;
  float32 SRR_FR_CAN_DET_AZIMUTH_05;
  Rte_DT_SG_SRR_FR_Detection_005_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_05;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_05;
  float32 SRR_FR_CAN_DET_ELEVATION_05;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_05;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_05;
  boolean SRR_FR_CAN_DET_Near_TARGET_05;
  float32 SRR_FR_CAN_DET_RANGE_05;
  float32 SRR_FR_CAN_DET_RANGE_RATE_05;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_05;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_05;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_05;
} SG_SRR_FR_Detection_005_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_006_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_06;
  float32 SRR_FR_CAN_DET_AZIMUTH_06;
  Rte_DT_SG_SRR_FR_Detection_006_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_06;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_06;
  float32 SRR_FR_CAN_DET_ELEVATION_06;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_06;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_06;
  boolean SRR_FR_CAN_DET_Near_TARGET_06;
  float32 SRR_FR_CAN_DET_RANGE_06;
  float32 SRR_FR_CAN_DET_RANGE_RATE_06;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_06;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_06;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_06;
} SG_SRR_FR_Detection_006_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_007_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_07;
  float32 SRR_FR_CAN_DET_AZIMUTH_07;
  Rte_DT_SG_SRR_FR_Detection_007_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_07;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_07;
  float32 SRR_FR_CAN_DET_ELEVATION_07;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_07;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_07;
  boolean SRR_FR_CAN_DET_Near_TARGET_07;
  float32 SRR_FR_CAN_DET_RANGE_07;
  float32 SRR_FR_CAN_DET_RANGE_RATE_07;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_07;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_07;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_07;
} SG_SRR_FR_Detection_007_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_008_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_08;
  float32 SRR_FR_CAN_DET_AZIMUTH_08;
  Rte_DT_SG_SRR_FR_Detection_008_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_08;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_08;
  float32 SRR_FR_CAN_DET_ELEVATION_08;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_08;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_08;
  boolean SRR_FR_CAN_DET_Near_TARGET_08;
  float32 SRR_FR_CAN_DET_RANGE_08;
  float32 SRR_FR_CAN_DET_RANGE_RATE_08;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_08;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_08;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_08;
} SG_SRR_FR_Detection_008_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_009_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_09;
  float32 SRR_FR_CAN_DET_AZIMUTH_09;
  Rte_DT_SG_SRR_FR_Detection_009_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_09;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_09;
  float32 SRR_FR_CAN_DET_ELEVATION_09;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_09;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_09;
  boolean SRR_FR_CAN_DET_Near_TARGET_09;
  float32 SRR_FR_CAN_DET_RANGE_09;
  float32 SRR_FR_CAN_DET_RANGE_RATE_09;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_09;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_09;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_09;
} SG_SRR_FR_Detection_009_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_010_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_10;
  float32 SRR_FR_CAN_DET_AZIMUTH_10;
  Rte_DT_SG_SRR_FR_Detection_010_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_10;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_10;
  float32 SRR_FR_CAN_DET_ELEVATION_10;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_10;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_10;
  boolean SRR_FR_CAN_DET_Near_TARGET_10;
  float32 SRR_FR_CAN_DET_RANGE_10;
  float32 SRR_FR_CAN_DET_RANGE_RATE_10;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_10;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_10;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_10;
} SG_SRR_FR_Detection_010_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_011_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_11;
  float32 SRR_FR_CAN_DET_AZIMUTH_11;
  Rte_DT_SG_SRR_FR_Detection_011_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_11;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_11;
  float32 SRR_FR_CAN_DET_ELEVATION_11;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_11;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_11;
  boolean SRR_FR_CAN_DET_Near_TARGET_11;
  float32 SRR_FR_CAN_DET_RANGE_11;
  float32 SRR_FR_CAN_DET_RANGE_RATE_11;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_11;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_11;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_11;
} SG_SRR_FR_Detection_011_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_012_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_12;
  float32 SRR_FR_CAN_DET_AZIMUTH_12;
  Rte_DT_SG_SRR_FR_Detection_012_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_12;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_12;
  float32 SRR_FR_CAN_DET_ELEVATION_12;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_12;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_12;
  boolean SRR_FR_CAN_DET_Near_TARGET_12;
  float32 SRR_FR_CAN_DET_RANGE_12;
  float32 SRR_FR_CAN_DET_RANGE_RATE_12;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_12;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_12;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_12;
} SG_SRR_FR_Detection_012_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_013_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_13;
  float32 SRR_FR_CAN_DET_AZIMUTH_13;
  Rte_DT_SG_SRR_FR_Detection_013_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_13;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_13;
  float32 SRR_FR_CAN_DET_ELEVATION_13;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_13;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_13;
  boolean SRR_FR_CAN_DET_Near_TARGET_13;
  float32 SRR_FR_CAN_DET_RANGE_13;
  float32 SRR_FR_CAN_DET_RANGE_RATE_13;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_13;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_13;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_13;
} SG_SRR_FR_Detection_013_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_014_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_14;
  float32 SRR_FR_CAN_DET_AZIMUTH_14;
  Rte_DT_SG_SRR_FR_Detection_014_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_14;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_14;
  float32 SRR_FR_CAN_DET_ELEVATION_14;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_14;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_14;
  boolean SRR_FR_CAN_DET_Near_TARGET_14;
  float32 SRR_FR_CAN_DET_RANGE_14;
  float32 SRR_FR_CAN_DET_RANGE_RATE_14;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_14;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_14;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_14;
} SG_SRR_FR_Detection_014_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_015_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_15;
  float32 SRR_FR_CAN_DET_AZIMUTH_15;
  Rte_DT_SG_SRR_FR_Detection_015_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_15;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_15;
  float32 SRR_FR_CAN_DET_ELEVATION_15;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_15;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_15;
  boolean SRR_FR_CAN_DET_Near_TARGET_15;
  float32 SRR_FR_CAN_DET_RANGE_15;
  float32 SRR_FR_CAN_DET_RANGE_RATE_15;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_15;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_15;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_15;
} SG_SRR_FR_Detection_015_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_016_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_16;
  float32 SRR_FR_CAN_DET_AZIMUTH_16;
  Rte_DT_SG_SRR_FR_Detection_016_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_16;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_16;
  float32 SRR_FR_CAN_DET_ELEVATION_16;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_16;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_16;
  boolean SRR_FR_CAN_DET_Near_TARGET_16;
  float32 SRR_FR_CAN_DET_RANGE_16;
  float32 SRR_FR_CAN_DET_RANGE_RATE_16;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_16;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_16;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_16;
} SG_SRR_FR_Detection_016_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_017_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_17;
  float32 SRR_FR_CAN_DET_AZIMUTH_17;
  Rte_DT_SG_SRR_FR_Detection_017_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_17;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_17;
  float32 SRR_FR_CAN_DET_ELEVATION_17;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_17;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_17;
  boolean SRR_FR_CAN_DET_Near_TARGET_17;
  float32 SRR_FR_CAN_DET_RANGE_17;
  float32 SRR_FR_CAN_DET_RANGE_RATE_17;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_17;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_17;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_17;
} SG_SRR_FR_Detection_017_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_018_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_18;
  float32 SRR_FR_CAN_DET_AZIMUTH_18;
  Rte_DT_SG_SRR_FR_Detection_018_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_18;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_18;
  float32 SRR_FR_CAN_DET_ELEVATION_18;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_18;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_18;
  boolean SRR_FR_CAN_DET_Near_TARGET_18;
  float32 SRR_FR_CAN_DET_RANGE_18;
  float32 SRR_FR_CAN_DET_RANGE_RATE_18;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_18;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_18;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_18;
} SG_SRR_FR_Detection_018_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_019_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_19;
  float32 SRR_FR_CAN_DET_AZIMUTH_19;
  Rte_DT_SG_SRR_FR_Detection_019_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_19;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_19;
  float32 SRR_FR_CAN_DET_ELEVATION_19;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_19;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_19;
  boolean SRR_FR_CAN_DET_Near_TARGET_19;
  float32 SRR_FR_CAN_DET_RANGE_19;
  float32 SRR_FR_CAN_DET_RANGE_RATE_19;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_19;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_19;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_19;
} SG_SRR_FR_Detection_019_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_020_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_20;
  float32 SRR_FR_CAN_DET_AZIMUTH_20;
  Rte_DT_SG_SRR_FR_Detection_020_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_20;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_20;
  float32 SRR_FR_CAN_DET_ELEVATION_20;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_20;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_20;
  boolean SRR_FR_CAN_DET_Near_TARGET_20;
  float32 SRR_FR_CAN_DET_RANGE_20;
  float32 SRR_FR_CAN_DET_RANGE_RATE_20;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_20;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_20;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_20;
} SG_SRR_FR_Detection_020_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_021_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_21;
  float32 SRR_FR_CAN_DET_AZIMUTH_21;
  Rte_DT_SG_SRR_FR_Detection_021_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_21;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_21;
  float32 SRR_FR_CAN_DET_ELEVATION_21;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_21;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_21;
  boolean SRR_FR_CAN_DET_Near_TARGET_21;
  float32 SRR_FR_CAN_DET_RANGE_21;
  float32 SRR_FR_CAN_DET_RANGE_RATE_21;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_21;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_21;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_21;
} SG_SRR_FR_Detection_021_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_022_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_22;
  float32 SRR_FR_CAN_DET_AZIMUTH_22;
  Rte_DT_SG_SRR_FR_Detection_022_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_22;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_22;
  float32 SRR_FR_CAN_DET_ELEVATION_22;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_22;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_22;
  boolean SRR_FR_CAN_DET_Near_TARGET_22;
  float32 SRR_FR_CAN_DET_RANGE_22;
  float32 SRR_FR_CAN_DET_RANGE_RATE_22;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_22;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_22;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_22;
} SG_SRR_FR_Detection_022_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_023_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_23;
  float32 SRR_FR_CAN_DET_AZIMUTH_23;
  Rte_DT_SG_SRR_FR_Detection_023_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_23;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_23;
  float32 SRR_FR_CAN_DET_ELEVATION_23;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_23;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_23;
  boolean SRR_FR_CAN_DET_Near_TARGET_23;
  float32 SRR_FR_CAN_DET_RANGE_23;
  float32 SRR_FR_CAN_DET_RANGE_RATE_23;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_23;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_23;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_23;
} SG_SRR_FR_Detection_023_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_024_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_24;
  float32 SRR_FR_CAN_DET_AZIMUTH_24;
  Rte_DT_SG_SRR_FR_Detection_024_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_24;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_24;
  float32 SRR_FR_CAN_DET_ELEVATION_24;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_24;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_24;
  boolean SRR_FR_CAN_DET_Near_TARGET_24;
  float32 SRR_FR_CAN_DET_RANGE_24;
  float32 SRR_FR_CAN_DET_RANGE_RATE_24;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_24;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_24;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_24;
} SG_SRR_FR_Detection_024_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_025_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_25;
  float32 SRR_FR_CAN_DET_AZIMUTH_25;
  Rte_DT_SG_SRR_FR_Detection_025_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_25;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_25;
  float32 SRR_FR_CAN_DET_ELEVATION_25;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_25;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_25;
  boolean SRR_FR_CAN_DET_Near_TARGET_25;
  float32 SRR_FR_CAN_DET_RANGE_25;
  float32 SRR_FR_CAN_DET_RANGE_RATE_25;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_25;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_25;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_25;
} SG_SRR_FR_Detection_025_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_026_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_26;
  float32 SRR_FR_CAN_DET_AZIMUTH_26;
  Rte_DT_SG_SRR_FR_Detection_026_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_26;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_26;
  float32 SRR_FR_CAN_DET_ELEVATION_26;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_26;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_26;
  boolean SRR_FR_CAN_DET_Near_TARGET_26;
  float32 SRR_FR_CAN_DET_RANGE_26;
  float32 SRR_FR_CAN_DET_RANGE_RATE_26;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_26;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_26;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_26;
} SG_SRR_FR_Detection_026_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_027_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_27;
  float32 SRR_FR_CAN_DET_AZIMUTH_27;
  Rte_DT_SG_SRR_FR_Detection_027_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_27;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_27;
  float32 SRR_FR_CAN_DET_ELEVATION_27;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_27;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_27;
  boolean SRR_FR_CAN_DET_Near_TARGET_27;
  float32 SRR_FR_CAN_DET_RANGE_27;
  float32 SRR_FR_CAN_DET_RANGE_RATE_27;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_27;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_27;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_27;
} SG_SRR_FR_Detection_027_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_028_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_28;
  float32 SRR_FR_CAN_DET_AZIMUTH_28;
  Rte_DT_SG_SRR_FR_Detection_028_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_28;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_28;
  float32 SRR_FR_CAN_DET_ELEVATION_28;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_28;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_28;
  boolean SRR_FR_CAN_DET_Near_TARGET_28;
  float32 SRR_FR_CAN_DET_RANGE_28;
  float32 SRR_FR_CAN_DET_RANGE_RATE_28;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_28;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_28;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_28;
} SG_SRR_FR_Detection_028_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_029_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_29;
  float32 SRR_FR_CAN_DET_AZIMUTH_29;
  Rte_DT_SG_SRR_FR_Detection_029_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_29;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_29;
  float32 SRR_FR_CAN_DET_ELEVATION_29;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_29;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_29;
  boolean SRR_FR_CAN_DET_Near_TARGET_29;
  float32 SRR_FR_CAN_DET_RANGE_29;
  float32 SRR_FR_CAN_DET_RANGE_RATE_29;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_29;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_29;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_29;
} SG_SRR_FR_Detection_029_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_030_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_30;
  float32 SRR_FR_CAN_DET_AZIMUTH_30;
  Rte_DT_SG_SRR_FR_Detection_030_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_30;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_30;
  float32 SRR_FR_CAN_DET_ELEVATION_30;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_30;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_30;
  boolean SRR_FR_CAN_DET_Near_TARGET_30;
  float32 SRR_FR_CAN_DET_RANGE_30;
  float32 SRR_FR_CAN_DET_RANGE_RATE_30;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_30;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_30;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_30;
} SG_SRR_FR_Detection_030_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_031_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_31;
  float32 SRR_FR_CAN_DET_AZIMUTH_31;
  Rte_DT_SG_SRR_FR_Detection_031_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_31;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_31;
  float32 SRR_FR_CAN_DET_ELEVATION_31;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_31;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_31;
  boolean SRR_FR_CAN_DET_Near_TARGET_31;
  float32 SRR_FR_CAN_DET_RANGE_31;
  float32 SRR_FR_CAN_DET_RANGE_RATE_31;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_31;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_31;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_31;
} SG_SRR_FR_Detection_031_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_032_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_32;
  float32 SRR_FR_CAN_DET_AZIMUTH_32;
  Rte_DT_SG_SRR_FR_Detection_032_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_32;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_32;
  float32 SRR_FR_CAN_DET_ELEVATION_32;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_32;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_32;
  boolean SRR_FR_CAN_DET_Near_TARGET_32;
  float32 SRR_FR_CAN_DET_RANGE_32;
  float32 SRR_FR_CAN_DET_RANGE_RATE_32;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_32;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_32;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_32;
} SG_SRR_FR_Detection_032_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_033_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_33;
  float32 SRR_FR_CAN_DET_AZIMUTH_33;
  Rte_DT_SG_SRR_FR_Detection_033_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_33;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_33;
  float32 SRR_FR_CAN_DET_ELEVATION_33;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_33;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_33;
  boolean SRR_FR_CAN_DET_Near_TARGET_33;
  float32 SRR_FR_CAN_DET_RANGE_33;
  float32 SRR_FR_CAN_DET_RANGE_RATE_33;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_33;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_33;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_33;
} SG_SRR_FR_Detection_033_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_034_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_34;
  float32 SRR_FR_CAN_DET_AZIMUTH_34;
  Rte_DT_SG_SRR_FR_Detection_034_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_34;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_34;
  float32 SRR_FR_CAN_DET_ELEVATION_34;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_34;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_34;
  boolean SRR_FR_CAN_DET_Near_TARGET_34;
  float32 SRR_FR_CAN_DET_RANGE_34;
  float32 SRR_FR_CAN_DET_RANGE_RATE_34;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_34;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_34;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_34;
} SG_SRR_FR_Detection_034_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_035_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_35;
  float32 SRR_FR_CAN_DET_AZIMUTH_35;
  Rte_DT_SG_SRR_FR_Detection_035_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_35;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_35;
  float32 SRR_FR_CAN_DET_ELEVATION_35;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_35;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_35;
  boolean SRR_FR_CAN_DET_Near_TARGET_35;
  float32 SRR_FR_CAN_DET_RANGE_35;
  float32 SRR_FR_CAN_DET_RANGE_RATE_35;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_35;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_35;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_35;
} SG_SRR_FR_Detection_035_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_036_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_36;
  float32 SRR_FR_CAN_DET_AZIMUTH_36;
  Rte_DT_SG_SRR_FR_Detection_036_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_36;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_36;
  float32 SRR_FR_CAN_DET_ELEVATION_36;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_36;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_36;
  boolean SRR_FR_CAN_DET_Near_TARGET_36;
  float32 SRR_FR_CAN_DET_RANGE_36;
  float32 SRR_FR_CAN_DET_RANGE_RATE_36;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_36;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_36;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_36;
} SG_SRR_FR_Detection_036_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_037_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_37;
  float32 SRR_FR_CAN_DET_AZIMUTH_37;
  Rte_DT_SG_SRR_FR_Detection_037_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_37;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_37;
  float32 SRR_FR_CAN_DET_ELEVATION_37;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_37;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_37;
  boolean SRR_FR_CAN_DET_Near_TARGET_37;
  float32 SRR_FR_CAN_DET_RANGE_37;
  float32 SRR_FR_CAN_DET_RANGE_RATE_37;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_37;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_37;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_37;
} SG_SRR_FR_Detection_037_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_038_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_38;
  float32 SRR_FR_CAN_DET_AZIMUTH_38;
  Rte_DT_SG_SRR_FR_Detection_038_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_38;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_38;
  float32 SRR_FR_CAN_DET_ELEVATION_38;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_38;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_38;
  boolean SRR_FR_CAN_DET_Near_TARGET_38;
  float32 SRR_FR_CAN_DET_RANGE_38;
  float32 SRR_FR_CAN_DET_RANGE_RATE_38;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_38;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_38;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_38;
} SG_SRR_FR_Detection_038_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_039_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_39;
  float32 SRR_FR_CAN_DET_AZIMUTH_39;
  Rte_DT_SG_SRR_FR_Detection_039_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_39;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_39;
  float32 SRR_FR_CAN_DET_ELEVATION_39;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_39;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_39;
  boolean SRR_FR_CAN_DET_Near_TARGET_39;
  float32 SRR_FR_CAN_DET_RANGE_39;
  float32 SRR_FR_CAN_DET_RANGE_RATE_39;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_39;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_39;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_39;
} SG_SRR_FR_Detection_039_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_040_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_40;
  float32 SRR_FR_CAN_DET_AZIMUTH_40;
  Rte_DT_SG_SRR_FR_Detection_040_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_40;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_40;
  float32 SRR_FR_CAN_DET_ELEVATION_40;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_40;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_40;
  boolean SRR_FR_CAN_DET_Near_TARGET_40;
  float32 SRR_FR_CAN_DET_RANGE_40;
  float32 SRR_FR_CAN_DET_RANGE_RATE_40;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_40;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_40;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_40;
} SG_SRR_FR_Detection_040_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_041_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_41;
  float32 SRR_FR_CAN_DET_AZIMUTH_41;
  Rte_DT_SG_SRR_FR_Detection_041_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_41;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_41;
  float32 SRR_FR_CAN_DET_ELEVATION_41;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_41;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_41;
  boolean SRR_FR_CAN_DET_Near_TARGET_41;
  float32 SRR_FR_CAN_DET_RANGE_41;
  float32 SRR_FR_CAN_DET_RANGE_RATE_41;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_41;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_41;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_41;
} SG_SRR_FR_Detection_041_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_042_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_42;
  float32 SRR_FR_CAN_DET_AZIMUTH_42;
  Rte_DT_SG_SRR_FR_Detection_042_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_42;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_42;
  float32 SRR_FR_CAN_DET_ELEVATION_42;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_42;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_42;
  boolean SRR_FR_CAN_DET_Near_TARGET_42;
  float32 SRR_FR_CAN_DET_RANGE_42;
  float32 SRR_FR_CAN_DET_RANGE_RATE_42;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_42;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_42;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_42;
} SG_SRR_FR_Detection_042_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_043_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_43;
  float32 SRR_FR_CAN_DET_AZIMUTH_43;
  Rte_DT_SG_SRR_FR_Detection_043_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_43;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_43;
  float32 SRR_FR_CAN_DET_ELEVATION_43;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_43;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_43;
  boolean SRR_FR_CAN_DET_Near_TARGET_43;
  float32 SRR_FR_CAN_DET_RANGE_43;
  float32 SRR_FR_CAN_DET_RANGE_RATE_43;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_43;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_43;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_43;
} SG_SRR_FR_Detection_043_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_044_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_44;
  float32 SRR_FR_CAN_DET_AZIMUTH_44;
  Rte_DT_SG_SRR_FR_Detection_044_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_44;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_44;
  float32 SRR_FR_CAN_DET_ELEVATION_44;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_44;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_44;
  boolean SRR_FR_CAN_DET_Near_TARGET_44;
  float32 SRR_FR_CAN_DET_RANGE_44;
  float32 SRR_FR_CAN_DET_RANGE_RATE_44;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_44;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_44;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_44;
} SG_SRR_FR_Detection_044_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_045_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_45;
  float32 SRR_FR_CAN_DET_AZIMUTH_45;
  Rte_DT_SG_SRR_FR_Detection_045_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_45;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_45;
  float32 SRR_FR_CAN_DET_ELEVATION_45;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_45;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_45;
  boolean SRR_FR_CAN_DET_Near_TARGET_45;
  float32 SRR_FR_CAN_DET_RANGE_45;
  float32 SRR_FR_CAN_DET_RANGE_RATE_45;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_45;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_45;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_45;
} SG_SRR_FR_Detection_045_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_046_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_46;
  float32 SRR_FR_CAN_DET_AZIMUTH_46;
  Rte_DT_SG_SRR_FR_Detection_046_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_46;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_46;
  float32 SRR_FR_CAN_DET_ELEVATION_46;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_46;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_46;
  boolean SRR_FR_CAN_DET_Near_TARGET_46;
  float32 SRR_FR_CAN_DET_RANGE_46;
  float32 SRR_FR_CAN_DET_RANGE_RATE_46;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_46;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_46;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_46;
} SG_SRR_FR_Detection_046_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_047_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_47;
  float32 SRR_FR_CAN_DET_AZIMUTH_47;
  Rte_DT_SG_SRR_FR_Detection_047_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_47;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_47;
  float32 SRR_FR_CAN_DET_ELEVATION_47;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_47;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_47;
  boolean SRR_FR_CAN_DET_Near_TARGET_47;
  float32 SRR_FR_CAN_DET_RANGE_47;
  float32 SRR_FR_CAN_DET_RANGE_RATE_47;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_47;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_47;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_47;
} SG_SRR_FR_Detection_047_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_048_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_48;
  float32 SRR_FR_CAN_DET_AZIMUTH_48;
  Rte_DT_SG_SRR_FR_Detection_048_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_48;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_48;
  float32 SRR_FR_CAN_DET_ELEVATION_48;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_48;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_48;
  boolean SRR_FR_CAN_DET_Near_TARGET_48;
  float32 SRR_FR_CAN_DET_RANGE_48;
  float32 SRR_FR_CAN_DET_RANGE_RATE_48;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_48;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_48;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_48;
} SG_SRR_FR_Detection_048_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_049_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_49;
  float32 SRR_FR_CAN_DET_AZIMUTH_49;
  Rte_DT_SG_SRR_FR_Detection_049_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_49;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_49;
  float32 SRR_FR_CAN_DET_ELEVATION_49;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_49;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_49;
  boolean SRR_FR_CAN_DET_Near_TARGET_49;
  float32 SRR_FR_CAN_DET_RANGE_49;
  float32 SRR_FR_CAN_DET_RANGE_RATE_49;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_49;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_49;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_49;
} SG_SRR_FR_Detection_049_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_050_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_50;
  float32 SRR_FR_CAN_DET_AZIMUTH_50;
  Rte_DT_SG_SRR_FR_Detection_050_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_50;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_50;
  float32 SRR_FR_CAN_DET_ELEVATION_50;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_50;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_50;
  boolean SRR_FR_CAN_DET_Near_TARGET_50;
  float32 SRR_FR_CAN_DET_RANGE_50;
  float32 SRR_FR_CAN_DET_RANGE_RATE_50;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_50;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_50;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_50;
} SG_SRR_FR_Detection_050_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_051_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_51;
  float32 SRR_FR_CAN_DET_AZIMUTH_51;
  Rte_DT_SG_SRR_FR_Detection_051_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_51;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_51;
  float32 SRR_FR_CAN_DET_ELEVATION_51;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_51;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_51;
  boolean SRR_FR_CAN_DET_Near_TARGET_51;
  float32 SRR_FR_CAN_DET_RANGE_51;
  float32 SRR_FR_CAN_DET_RANGE_RATE_51;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_51;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_51;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_51;
} SG_SRR_FR_Detection_051_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_052_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_52;
  float32 SRR_FR_CAN_DET_AZIMUTH_52;
  Rte_DT_SG_SRR_FR_Detection_052_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_52;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_52;
  float32 SRR_FR_CAN_DET_ELEVATION_52;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_52;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_52;
  boolean SRR_FR_CAN_DET_Near_TARGET_52;
  float32 SRR_FR_CAN_DET_RANGE_52;
  float32 SRR_FR_CAN_DET_RANGE_RATE_52;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_52;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_52;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_52;
} SG_SRR_FR_Detection_052_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_053_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_53;
  float32 SRR_FR_CAN_DET_AZIMUTH_53;
  Rte_DT_SG_SRR_FR_Detection_053_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_53;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_53;
  float32 SRR_FR_CAN_DET_ELEVATION_53;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_53;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_53;
  boolean SRR_FR_CAN_DET_Near_TARGET_53;
  float32 SRR_FR_CAN_DET_RANGE_53;
  float32 SRR_FR_CAN_DET_RANGE_RATE_53;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_53;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_53;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_53;
} SG_SRR_FR_Detection_053_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_054_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_54;
  float32 SRR_FR_CAN_DET_AZIMUTH_54;
  Rte_DT_SG_SRR_FR_Detection_054_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_54;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_54;
  float32 SRR_FR_CAN_DET_ELEVATION_54;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_54;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_54;
  boolean SRR_FR_CAN_DET_Near_TARGET_54;
  float32 SRR_FR_CAN_DET_RANGE_54;
  float32 SRR_FR_CAN_DET_RANGE_RATE_54;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_54;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_54;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_54;
} SG_SRR_FR_Detection_054_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_055_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_55;
  float32 SRR_FR_CAN_DET_AZIMUTH_55;
  Rte_DT_SG_SRR_FR_Detection_055_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_55;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_55;
  float32 SRR_FR_CAN_DET_ELEVATION_55;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_55;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_55;
  boolean SRR_FR_CAN_DET_Near_TARGET_55;
  float32 SRR_FR_CAN_DET_RANGE_55;
  float32 SRR_FR_CAN_DET_RANGE_RATE_55;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_55;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_55;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_55;
} SG_SRR_FR_Detection_055_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_056_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_56;
  float32 SRR_FR_CAN_DET_AZIMUTH_56;
  Rte_DT_SG_SRR_FR_Detection_056_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_56;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_56;
  float32 SRR_FR_CAN_DET_ELEVATION_56;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_56;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_56;
  boolean SRR_FR_CAN_DET_Near_TARGET_56;
  float32 SRR_FR_CAN_DET_RANGE_56;
  float32 SRR_FR_CAN_DET_RANGE_RATE_56;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_56;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_56;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_56;
} SG_SRR_FR_Detection_056_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_057_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_57;
  float32 SRR_FR_CAN_DET_AZIMUTH_57;
  Rte_DT_SG_SRR_FR_Detection_057_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_57;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_57;
  float32 SRR_FR_CAN_DET_ELEVATION_57;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_57;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_57;
  boolean SRR_FR_CAN_DET_Near_TARGET_57;
  float32 SRR_FR_CAN_DET_RANGE_57;
  float32 SRR_FR_CAN_DET_RANGE_RATE_57;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_57;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_57;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_57;
} SG_SRR_FR_Detection_057_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_058_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_58;
  float32 SRR_FR_CAN_DET_AZIMUTH_58;
  Rte_DT_SG_SRR_FR_Detection_058_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_58;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_58;
  float32 SRR_FR_CAN_DET_ELEVATION_58;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_58;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_58;
  boolean SRR_FR_CAN_DET_Near_TARGET_58;
  float32 SRR_FR_CAN_DET_RANGE_58;
  float32 SRR_FR_CAN_DET_RANGE_RATE_58;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_58;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_58;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_58;
} SG_SRR_FR_Detection_058_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_059_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_59;
  float32 SRR_FR_CAN_DET_AZIMUTH_59;
  Rte_DT_SG_SRR_FR_Detection_059_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_59;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_59;
  float32 SRR_FR_CAN_DET_ELEVATION_59;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_59;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_59;
  boolean SRR_FR_CAN_DET_Near_TARGET_59;
  float32 SRR_FR_CAN_DET_RANGE_59;
  float32 SRR_FR_CAN_DET_RANGE_RATE_59;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_59;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_59;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_59;
} SG_SRR_FR_Detection_059_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_060_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_60;
  float32 SRR_FR_CAN_DET_AZIMUTH_60;
  Rte_DT_SG_SRR_FR_Detection_060_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_60;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_60;
  float32 SRR_FR_CAN_DET_ELEVATION_60;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_60;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_60;
  boolean SRR_FR_CAN_DET_Near_TARGET_60;
  float32 SRR_FR_CAN_DET_RANGE_60;
  float32 SRR_FR_CAN_DET_RANGE_RATE_60;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_60;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_60;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_60;
} SG_SRR_FR_Detection_060_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_061_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_61;
  float32 SRR_FR_CAN_DET_AZIMUTH_61;
  Rte_DT_SG_SRR_FR_Detection_061_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_61;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_61;
  float32 SRR_FR_CAN_DET_ELEVATION_61;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_61;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_61;
  boolean SRR_FR_CAN_DET_Near_TARGET_61;
  float32 SRR_FR_CAN_DET_RANGE_61;
  float32 SRR_FR_CAN_DET_RANGE_RATE_61;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_61;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_61;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_61;
} SG_SRR_FR_Detection_061_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_062_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_62;
  float32 SRR_FR_CAN_DET_AZIMUTH_62;
  Rte_DT_SG_SRR_FR_Detection_062_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_62;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_62;
  float32 SRR_FR_CAN_DET_ELEVATION_62;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_62;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_62;
  boolean SRR_FR_CAN_DET_Near_TARGET_62;
  float32 SRR_FR_CAN_DET_RANGE_62;
  float32 SRR_FR_CAN_DET_RANGE_RATE_62;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_62;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_62;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_62;
} SG_SRR_FR_Detection_062_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_063_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_63;
  float32 SRR_FR_CAN_DET_AZIMUTH_63;
  Rte_DT_SG_SRR_FR_Detection_063_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_63;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_63;
  float32 SRR_FR_CAN_DET_ELEVATION_63;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_63;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_63;
  boolean SRR_FR_CAN_DET_Near_TARGET_63;
  float32 SRR_FR_CAN_DET_RANGE_63;
  float32 SRR_FR_CAN_DET_RANGE_RATE_63;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_63;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_63;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_63;
} SG_SRR_FR_Detection_063_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_064_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_64;
  float32 SRR_FR_CAN_DET_AZIMUTH_64;
  Rte_DT_SG_SRR_FR_Detection_064_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_64;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_64;
  float32 SRR_FR_CAN_DET_ELEVATION_64;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_64;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_64;
  boolean SRR_FR_CAN_DET_Near_TARGET_64;
  float32 SRR_FR_CAN_DET_RANGE_64;
  float32 SRR_FR_CAN_DET_RANGE_RATE_64;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_64;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_64;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_64;
} SG_SRR_FR_Detection_064_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_065_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_65;
  float32 SRR_FR_CAN_DET_AZIMUTH_65;
  Rte_DT_SG_SRR_FR_Detection_065_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_65;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_65;
  float32 SRR_FR_CAN_DET_ELEVATION_65;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_65;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_65;
  boolean SRR_FR_CAN_DET_Near_TARGET_65;
  float32 SRR_FR_CAN_DET_RANGE_65;
  float32 SRR_FR_CAN_DET_RANGE_RATE_65;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_65;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_65;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_65;
} SG_SRR_FR_Detection_065_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_066_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_66;
  float32 SRR_FR_CAN_DET_AZIMUTH_66;
  Rte_DT_SG_SRR_FR_Detection_066_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_66;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_66;
  float32 SRR_FR_CAN_DET_ELEVATION_66;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_66;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_66;
  boolean SRR_FR_CAN_DET_Near_TARGET_66;
  float32 SRR_FR_CAN_DET_RANGE_66;
  float32 SRR_FR_CAN_DET_RANGE_RATE_66;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_66;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_66;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_66;
} SG_SRR_FR_Detection_066_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_067_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_67;
  float32 SRR_FR_CAN_DET_AZIMUTH_67;
  Rte_DT_SG_SRR_FR_Detection_067_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_67;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_67;
  float32 SRR_FR_CAN_DET_ELEVATION_67;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_67;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_67;
  boolean SRR_FR_CAN_DET_Near_TARGET_67;
  float32 SRR_FR_CAN_DET_RANGE_67;
  float32 SRR_FR_CAN_DET_RANGE_RATE_67;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_67;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_67;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_67;
} SG_SRR_FR_Detection_067_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_068_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_68;
  float32 SRR_FR_CAN_DET_AZIMUTH_68;
  Rte_DT_SG_SRR_FR_Detection_068_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_68;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_68;
  float32 SRR_FR_CAN_DET_ELEVATION_68;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_68;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_68;
  boolean SRR_FR_CAN_DET_Near_TARGET_68;
  float32 SRR_FR_CAN_DET_RANGE_68;
  float32 SRR_FR_CAN_DET_RANGE_RATE_68;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_68;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_68;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_68;
} SG_SRR_FR_Detection_068_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_069_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_69;
  float32 SRR_FR_CAN_DET_AZIMUTH_69;
  Rte_DT_SG_SRR_FR_Detection_069_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_69;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_69;
  float32 SRR_FR_CAN_DET_ELEVATION_69;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_69;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_69;
  boolean SRR_FR_CAN_DET_Near_TARGET_69;
  float32 SRR_FR_CAN_DET_RANGE_69;
  float32 SRR_FR_CAN_DET_RANGE_RATE_69;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_69;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_69;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_69;
} SG_SRR_FR_Detection_069_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_070_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_70;
  float32 SRR_FR_CAN_DET_AZIMUTH_70;
  Rte_DT_SG_SRR_FR_Detection_070_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_70;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_70;
  float32 SRR_FR_CAN_DET_ELEVATION_70;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_70;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_70;
  boolean SRR_FR_CAN_DET_Near_TARGET_70;
  float32 SRR_FR_CAN_DET_RANGE_70;
  float32 SRR_FR_CAN_DET_RANGE_RATE_70;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_70;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_70;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_70;
} SG_SRR_FR_Detection_070_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_071_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_71;
  float32 SRR_FR_CAN_DET_AZIMUTH_71;
  Rte_DT_SG_SRR_FR_Detection_071_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_71;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_71;
  float32 SRR_FR_CAN_DET_ELEVATION_71;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_71;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_71;
  boolean SRR_FR_CAN_DET_Near_TARGET_71;
  float32 SRR_FR_CAN_DET_RANGE_71;
  float32 SRR_FR_CAN_DET_RANGE_RATE_71;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_71;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_71;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_71;
} SG_SRR_FR_Detection_071_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_072_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_72;
  float32 SRR_FR_CAN_DET_AZIMUTH_72;
  Rte_DT_SG_SRR_FR_Detection_072_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_72;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_72;
  float32 SRR_FR_CAN_DET_ELEVATION_72;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_72;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_72;
  boolean SRR_FR_CAN_DET_Near_TARGET_72;
  float32 SRR_FR_CAN_DET_RANGE_72;
  float32 SRR_FR_CAN_DET_RANGE_RATE_72;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_72;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_72;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_72;
} SG_SRR_FR_Detection_072_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_073_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_73;
  float32 SRR_FR_CAN_DET_AZIMUTH_73;
  Rte_DT_SG_SRR_FR_Detection_073_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_73;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_73;
  float32 SRR_FR_CAN_DET_ELEVATION_73;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_73;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_73;
  boolean SRR_FR_CAN_DET_Near_TARGET_73;
  float32 SRR_FR_CAN_DET_RANGE_73;
  float32 SRR_FR_CAN_DET_RANGE_RATE_73;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_73;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_73;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_73;
} SG_SRR_FR_Detection_073_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_074_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_74;
  float32 SRR_FR_CAN_DET_AZIMUTH_74;
  Rte_DT_SG_SRR_FR_Detection_074_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_74;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_74;
  float32 SRR_FR_CAN_DET_ELEVATION_74;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_74;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_74;
  boolean SRR_FR_CAN_DET_Near_TARGET_74;
  float32 SRR_FR_CAN_DET_RANGE_74;
  float32 SRR_FR_CAN_DET_RANGE_RATE_74;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_74;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_74;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_74;
} SG_SRR_FR_Detection_074_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_075_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_75;
  float32 SRR_FR_CAN_DET_AZIMUTH_75;
  Rte_DT_SG_SRR_FR_Detection_075_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_75;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_75;
  float32 SRR_FR_CAN_DET_ELEVATION_75;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_75;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_75;
  boolean SRR_FR_CAN_DET_Near_TARGET_75;
  float32 SRR_FR_CAN_DET_RANGE_75;
  float32 SRR_FR_CAN_DET_RANGE_RATE_75;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_75;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_75;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_75;
} SG_SRR_FR_Detection_075_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_076_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_76;
  float32 SRR_FR_CAN_DET_AZIMUTH_76;
  Rte_DT_SG_SRR_FR_Detection_076_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_76;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_76;
  float32 SRR_FR_CAN_DET_ELEVATION_76;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_76;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_76;
  boolean SRR_FR_CAN_DET_Near_TARGET_76;
  float32 SRR_FR_CAN_DET_RANGE_76;
  float32 SRR_FR_CAN_DET_RANGE_RATE_76;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_76;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_76;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_76;
} SG_SRR_FR_Detection_076_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_077_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_77;
  float32 SRR_FR_CAN_DET_AZIMUTH_77;
  Rte_DT_SG_SRR_FR_Detection_077_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_77;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_77;
  float32 SRR_FR_CAN_DET_ELEVATION_77;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_77;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_77;
  boolean SRR_FR_CAN_DET_Near_TARGET_77;
  float32 SRR_FR_CAN_DET_RANGE_77;
  float32 SRR_FR_CAN_DET_RANGE_RATE_77;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_77;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_77;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_77;
} SG_SRR_FR_Detection_077_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_078_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_78;
  float32 SRR_FR_CAN_DET_AZIMUTH_78;
  Rte_DT_SG_SRR_FR_Detection_078_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_78;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_78;
  float32 SRR_FR_CAN_DET_ELEVATION_78;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_78;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_78;
  boolean SRR_FR_CAN_DET_Near_TARGET_78;
  float32 SRR_FR_CAN_DET_RANGE_78;
  float32 SRR_FR_CAN_DET_RANGE_RATE_78;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_78;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_78;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_78;
} SG_SRR_FR_Detection_078_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_079_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_79;
  float32 SRR_FR_CAN_DET_AZIMUTH_79;
  Rte_DT_SG_SRR_FR_Detection_079_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_79;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_79;
  float32 SRR_FR_CAN_DET_ELEVATION_79;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_79;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_79;
  boolean SRR_FR_CAN_DET_Near_TARGET_79;
  float32 SRR_FR_CAN_DET_RANGE_79;
  float32 SRR_FR_CAN_DET_RANGE_RATE_79;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_79;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_79;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_79;
} SG_SRR_FR_Detection_079_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_080_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_80;
  float32 SRR_FR_CAN_DET_AZIMUTH_80;
  Rte_DT_SG_SRR_FR_Detection_080_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_80;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_80;
  float32 SRR_FR_CAN_DET_ELEVATION_80;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_80;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_80;
  boolean SRR_FR_CAN_DET_Near_TARGET_80;
  float32 SRR_FR_CAN_DET_RANGE_80;
  float32 SRR_FR_CAN_DET_RANGE_RATE_80;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_80;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_80;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_80;
} SG_SRR_FR_Detection_080_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_081_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_81;
  float32 SRR_FR_CAN_DET_AZIMUTH_81;
  Rte_DT_SG_SRR_FR_Detection_081_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_81;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_81;
  float32 SRR_FR_CAN_DET_ELEVATION_81;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_81;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_81;
  boolean SRR_FR_CAN_DET_Near_TARGET_81;
  float32 SRR_FR_CAN_DET_RANGE_81;
  float32 SRR_FR_CAN_DET_RANGE_RATE_81;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_81;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_81;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_81;
} SG_SRR_FR_Detection_081_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_082_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_82;
  float32 SRR_FR_CAN_DET_AZIMUTH_82;
  Rte_DT_SG_SRR_FR_Detection_082_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_82;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_82;
  float32 SRR_FR_CAN_DET_ELEVATION_82;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_82;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_82;
  boolean SRR_FR_CAN_DET_Near_TARGET_82;
  float32 SRR_FR_CAN_DET_RANGE_82;
  float32 SRR_FR_CAN_DET_RANGE_RATE_82;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_82;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_82;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_82;
} SG_SRR_FR_Detection_082_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_083_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_83;
  float32 SRR_FR_CAN_DET_AZIMUTH_83;
  Rte_DT_SG_SRR_FR_Detection_083_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_83;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_83;
  float32 SRR_FR_CAN_DET_ELEVATION_83;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_83;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_83;
  boolean SRR_FR_CAN_DET_Near_TARGET_83;
  float32 SRR_FR_CAN_DET_RANGE_83;
  float32 SRR_FR_CAN_DET_RANGE_RATE_83;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_83;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_83;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_83;
} SG_SRR_FR_Detection_083_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_084_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_84;
  float32 SRR_FR_CAN_DET_AZIMUTH_84;
  Rte_DT_SG_SRR_FR_Detection_084_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_84;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_84;
  float32 SRR_FR_CAN_DET_ELEVATION_84;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_84;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_84;
  boolean SRR_FR_CAN_DET_Near_TARGET_84;
  float32 SRR_FR_CAN_DET_RANGE_84;
  float32 SRR_FR_CAN_DET_RANGE_RATE_84;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_84;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_84;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_84;
} SG_SRR_FR_Detection_084_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_085_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_85;
  float32 SRR_FR_CAN_DET_AZIMUTH_85;
  Rte_DT_SG_SRR_FR_Detection_085_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_85;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_85;
  float32 SRR_FR_CAN_DET_ELEVATION_85;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_85;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_85;
  boolean SRR_FR_CAN_DET_Near_TARGET_85;
  float32 SRR_FR_CAN_DET_RANGE_85;
  float32 SRR_FR_CAN_DET_RANGE_RATE_85;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_85;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_85;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_85;
} SG_SRR_FR_Detection_085_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_086_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_86;
  float32 SRR_FR_CAN_DET_AZIMUTH_86;
  Rte_DT_SG_SRR_FR_Detection_086_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_86;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_86;
  float32 SRR_FR_CAN_DET_ELEVATION_86;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_86;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_86;
  boolean SRR_FR_CAN_DET_Near_TARGET_86;
  float32 SRR_FR_CAN_DET_RANGE_86;
  float32 SRR_FR_CAN_DET_RANGE_RATE_86;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_86;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_86;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_86;
} SG_SRR_FR_Detection_086_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_087_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_87;
  float32 SRR_FR_CAN_DET_AZIMUTH_87;
  Rte_DT_SG_SRR_FR_Detection_087_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_87;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_87;
  float32 SRR_FR_CAN_DET_ELEVATION_87;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_87;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_87;
  boolean SRR_FR_CAN_DET_Near_TARGET_87;
  float32 SRR_FR_CAN_DET_RANGE_87;
  float32 SRR_FR_CAN_DET_RANGE_RATE_87;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_87;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_87;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_87;
} SG_SRR_FR_Detection_087_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_088_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_88;
  float32 SRR_FR_CAN_DET_AZIMUTH_88;
  Rte_DT_SG_SRR_FR_Detection_088_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_88;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_88;
  float32 SRR_FR_CAN_DET_ELEVATION_88;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_88;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_88;
  boolean SRR_FR_CAN_DET_Near_TARGET_88;
  float32 SRR_FR_CAN_DET_RANGE_88;
  float32 SRR_FR_CAN_DET_RANGE_RATE_88;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_88;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_88;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_88;
} SG_SRR_FR_Detection_088_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_089_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_89;
  float32 SRR_FR_CAN_DET_AZIMUTH_89;
  Rte_DT_SG_SRR_FR_Detection_089_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_89;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_89;
  float32 SRR_FR_CAN_DET_ELEVATION_89;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_89;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_89;
  boolean SRR_FR_CAN_DET_Near_TARGET_89;
  float32 SRR_FR_CAN_DET_RANGE_89;
  float32 SRR_FR_CAN_DET_RANGE_RATE_89;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_89;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_89;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_89;
} SG_SRR_FR_Detection_089_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_090_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_90;
  float32 SRR_FR_CAN_DET_AZIMUTH_90;
  Rte_DT_SG_SRR_FR_Detection_090_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_90;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_90;
  float32 SRR_FR_CAN_DET_ELEVATION_90;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_90;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_90;
  boolean SRR_FR_CAN_DET_Near_TARGET_90;
  float32 SRR_FR_CAN_DET_RANGE_90;
  float32 SRR_FR_CAN_DET_RANGE_RATE_90;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_90;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_90;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_90;
} SG_SRR_FR_Detection_090_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_091_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_91;
  float32 SRR_FR_CAN_DET_AZIMUTH_91;
  Rte_DT_SG_SRR_FR_Detection_091_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_91;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_91;
  float32 SRR_FR_CAN_DET_ELEVATION_91;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_91;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_91;
  boolean SRR_FR_CAN_DET_Near_TARGET_91;
  float32 SRR_FR_CAN_DET_RANGE_91;
  float32 SRR_FR_CAN_DET_RANGE_RATE_91;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_91;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_91;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_91;
} SG_SRR_FR_Detection_091_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_092_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_92;
  float32 SRR_FR_CAN_DET_AZIMUTH_92;
  Rte_DT_SG_SRR_FR_Detection_092_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_92;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_92;
  float32 SRR_FR_CAN_DET_ELEVATION_92;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_92;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_92;
  boolean SRR_FR_CAN_DET_Near_TARGET_92;
  float32 SRR_FR_CAN_DET_RANGE_92;
  float32 SRR_FR_CAN_DET_RANGE_RATE_92;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_92;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_92;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_92;
} SG_SRR_FR_Detection_092_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_093_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_93;
  float32 SRR_FR_CAN_DET_AZIMUTH_93;
  Rte_DT_SG_SRR_FR_Detection_093_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_93;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_93;
  float32 SRR_FR_CAN_DET_ELEVATION_93;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_93;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_93;
  boolean SRR_FR_CAN_DET_Near_TARGET_93;
  float32 SRR_FR_CAN_DET_RANGE_93;
  float32 SRR_FR_CAN_DET_RANGE_RATE_93;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_93;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_93;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_93;
} SG_SRR_FR_Detection_093_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_094_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_94;
  float32 SRR_FR_CAN_DET_AZIMUTH_94;
  Rte_DT_SG_SRR_FR_Detection_094_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_94;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_94;
  float32 SRR_FR_CAN_DET_ELEVATION_94;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_94;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_94;
  boolean SRR_FR_CAN_DET_Near_TARGET_94;
  float32 SRR_FR_CAN_DET_RANGE_94;
  float32 SRR_FR_CAN_DET_RANGE_RATE_94;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_94;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_94;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_94;
} SG_SRR_FR_Detection_094_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_095_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_95;
  float32 SRR_FR_CAN_DET_AZIMUTH_95;
  Rte_DT_SG_SRR_FR_Detection_095_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_95;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_95;
  float32 SRR_FR_CAN_DET_ELEVATION_95;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_95;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_95;
  boolean SRR_FR_CAN_DET_Near_TARGET_95;
  float32 SRR_FR_CAN_DET_RANGE_95;
  float32 SRR_FR_CAN_DET_RANGE_RATE_95;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_95;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_95;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_95;
} SG_SRR_FR_Detection_095_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_096_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_96;
  float32 SRR_FR_CAN_DET_AZIMUTH_96;
  Rte_DT_SG_SRR_FR_Detection_096_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_96;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_96;
  float32 SRR_FR_CAN_DET_ELEVATION_96;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_96;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_96;
  boolean SRR_FR_CAN_DET_Near_TARGET_96;
  float32 SRR_FR_CAN_DET_RANGE_96;
  float32 SRR_FR_CAN_DET_RANGE_RATE_96;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_96;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_96;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_96;
} SG_SRR_FR_Detection_096_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_097_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_97;
  float32 SRR_FR_CAN_DET_AZIMUTH_97;
  Rte_DT_SG_SRR_FR_Detection_097_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_97;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_97;
  float32 SRR_FR_CAN_DET_ELEVATION_97;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_97;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_97;
  boolean SRR_FR_CAN_DET_Near_TARGET_97;
  float32 SRR_FR_CAN_DET_RANGE_97;
  float32 SRR_FR_CAN_DET_RANGE_RATE_97;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_97;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_97;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_97;
} SG_SRR_FR_Detection_097_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_098_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_98;
  float32 SRR_FR_CAN_DET_AZIMUTH_98;
  Rte_DT_SG_SRR_FR_Detection_098_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_98;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_98;
  float32 SRR_FR_CAN_DET_ELEVATION_98;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_98;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_98;
  boolean SRR_FR_CAN_DET_Near_TARGET_98;
  float32 SRR_FR_CAN_DET_RANGE_98;
  float32 SRR_FR_CAN_DET_RANGE_RATE_98;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_98;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_98;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_98;
} SG_SRR_FR_Detection_098_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_099_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_99;
  float32 SRR_FR_CAN_DET_AZIMUTH_99;
  Rte_DT_SG_SRR_FR_Detection_099_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_99;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_99;
  float32 SRR_FR_CAN_DET_ELEVATION_99;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_99;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_99;
  boolean SRR_FR_CAN_DET_Near_TARGET_99;
  float32 SRR_FR_CAN_DET_RANGE_99;
  float32 SRR_FR_CAN_DET_RANGE_RATE_99;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_99;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_99;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_99;
} SG_SRR_FR_Detection_099_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_100_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_100;
  float32 SRR_FR_CAN_DET_AZIMUTH_100;
  Rte_DT_SG_SRR_FR_Detection_100_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_100;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_100;
  float32 SRR_FR_CAN_DET_ELEVATION_100;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_100;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_100;
  boolean SRR_FR_CAN_DET_Near_TARGET_100;
  float32 SRR_FR_CAN_DET_RANGE_100;
  float32 SRR_FR_CAN_DET_RANGE_RATE_100;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_100;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_100;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_100;
} SG_SRR_FR_Detection_100_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_101_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_101;
  float32 SRR_FR_CAN_DET_AZIMUTH_101;
  Rte_DT_SG_SRR_FR_Detection_101_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_101;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_101;
  float32 SRR_FR_CAN_DET_ELEVATION_101;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_101;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_101;
  boolean SRR_FR_CAN_DET_Near_TARGET_101;
  float32 SRR_FR_CAN_DET_RANGE_101;
  float32 SRR_FR_CAN_DET_RANGE_RATE_101;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_101;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_101;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_101;
} SG_SRR_FR_Detection_101_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_102_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_102;
  float32 SRR_FR_CAN_DET_AZIMUTH_102;
  Rte_DT_SG_SRR_FR_Detection_102_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_102;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_102;
  float32 SRR_FR_CAN_DET_ELEVATION_102;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_102;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_102;
  boolean SRR_FR_CAN_DET_Near_TARGET_102;
  float32 SRR_FR_CAN_DET_RANGE_102;
  float32 SRR_FR_CAN_DET_RANGE_RATE_102;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_102;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_102;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_102;
} SG_SRR_FR_Detection_102_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_103_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_103;
  float32 SRR_FR_CAN_DET_AZIMUTH_103;
  Rte_DT_SG_SRR_FR_Detection_103_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_103;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_103;
  float32 SRR_FR_CAN_DET_ELEVATION_103;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_103;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_103;
  boolean SRR_FR_CAN_DET_Near_TARGET_103;
  float32 SRR_FR_CAN_DET_RANGE_103;
  float32 SRR_FR_CAN_DET_RANGE_RATE_103;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_103;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_103;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_103;
} SG_SRR_FR_Detection_103_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_104_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_104;
  float32 SRR_FR_CAN_DET_AZIMUTH_104;
  Rte_DT_SG_SRR_FR_Detection_104_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_104;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_104;
  float32 SRR_FR_CAN_DET_ELEVATION_104;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_104;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_104;
  boolean SRR_FR_CAN_DET_Near_TARGET_104;
  float32 SRR_FR_CAN_DET_RANGE_104;
  float32 SRR_FR_CAN_DET_RANGE_RATE_104;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_104;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_104;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_104;
} SG_SRR_FR_Detection_104_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_105_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_105;
  float32 SRR_FR_CAN_DET_AZIMUTH_105;
  Rte_DT_SG_SRR_FR_Detection_105_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_105;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_105;
  float32 SRR_FR_CAN_DET_ELEVATION_105;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_105;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_105;
  boolean SRR_FR_CAN_DET_Near_TARGET_105;
  float32 SRR_FR_CAN_DET_RANGE_105;
  float32 SRR_FR_CAN_DET_RANGE_RATE_105;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_105;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_105;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_105;
} SG_SRR_FR_Detection_105_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_106_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_106;
  float32 SRR_FR_CAN_DET_AZIMUTH_106;
  Rte_DT_SG_SRR_FR_Detection_106_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_106;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_106;
  float32 SRR_FR_CAN_DET_ELEVATION_106;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_106;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_106;
  boolean SRR_FR_CAN_DET_Near_TARGET_106;
  float32 SRR_FR_CAN_DET_RANGE_106;
  float32 SRR_FR_CAN_DET_RANGE_RATE_106;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_106;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_106;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_106;
} SG_SRR_FR_Detection_106_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_107_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_107;
  float32 SRR_FR_CAN_DET_AZIMUTH_107;
  Rte_DT_SG_SRR_FR_Detection_107_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_107;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_107;
  float32 SRR_FR_CAN_DET_ELEVATION_107;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_107;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_107;
  boolean SRR_FR_CAN_DET_Near_TARGET_107;
  float32 SRR_FR_CAN_DET_RANGE_107;
  float32 SRR_FR_CAN_DET_RANGE_RATE_107;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_107;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_107;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_107;
} SG_SRR_FR_Detection_107_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_108_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_108;
  float32 SRR_FR_CAN_DET_AZIMUTH_108;
  Rte_DT_SG_SRR_FR_Detection_108_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_108;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_108;
  float32 SRR_FR_CAN_DET_ELEVATION_108;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_108;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_108;
  boolean SRR_FR_CAN_DET_Near_TARGET_108;
  float32 SRR_FR_CAN_DET_RANGE_108;
  float32 SRR_FR_CAN_DET_RANGE_RATE_108;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_108;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_108;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_108;
} SG_SRR_FR_Detection_108_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_109_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_109;
  float32 SRR_FR_CAN_DET_AZIMUTH_109;
  Rte_DT_SG_SRR_FR_Detection_109_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_109;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_109;
  float32 SRR_FR_CAN_DET_ELEVATION_109;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_109;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_109;
  boolean SRR_FR_CAN_DET_Near_TARGET_109;
  float32 SRR_FR_CAN_DET_RANGE_109;
  float32 SRR_FR_CAN_DET_RANGE_RATE_109;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_109;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_109;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_109;
} SG_SRR_FR_Detection_109_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_110_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_110;
  float32 SRR_FR_CAN_DET_AZIMUTH_110;
  Rte_DT_SG_SRR_FR_Detection_110_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_110;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_110;
  float32 SRR_FR_CAN_DET_ELEVATION_110;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_110;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_110;
  boolean SRR_FR_CAN_DET_Near_TARGET_110;
  float32 SRR_FR_CAN_DET_RANGE_110;
  float32 SRR_FR_CAN_DET_RANGE_RATE_110;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_110;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_110;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_110;
} SG_SRR_FR_Detection_110_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_111_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_111;
  float32 SRR_FR_CAN_DET_AZIMUTH_111;
  Rte_DT_SG_SRR_FR_Detection_111_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_111;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_111;
  float32 SRR_FR_CAN_DET_ELEVATION_111;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_111;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_111;
  boolean SRR_FR_CAN_DET_Near_TARGET_111;
  float32 SRR_FR_CAN_DET_RANGE_111;
  float32 SRR_FR_CAN_DET_RANGE_RATE_111;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_111;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_111;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_111;
} SG_SRR_FR_Detection_111_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_112_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_112;
  float32 SRR_FR_CAN_DET_AZIMUTH_112;
  Rte_DT_SG_SRR_FR_Detection_112_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_112;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_112;
  float32 SRR_FR_CAN_DET_ELEVATION_112;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_112;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_112;
  boolean SRR_FR_CAN_DET_Near_TARGET_112;
  float32 SRR_FR_CAN_DET_RANGE_112;
  float32 SRR_FR_CAN_DET_RANGE_RATE_112;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_112;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_112;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_112;
} SG_SRR_FR_Detection_112_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_113_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_113;
  float32 SRR_FR_CAN_DET_AZIMUTH_113;
  Rte_DT_SG_SRR_FR_Detection_113_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_113;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_113;
  float32 SRR_FR_CAN_DET_ELEVATION_113;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_113;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_113;
  boolean SRR_FR_CAN_DET_Near_TARGET_113;
  float32 SRR_FR_CAN_DET_RANGE_113;
  float32 SRR_FR_CAN_DET_RANGE_RATE_113;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_113;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_113;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_113;
} SG_SRR_FR_Detection_113_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_114_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_114;
  float32 SRR_FR_CAN_DET_AZIMUTH_114;
  Rte_DT_SG_SRR_FR_Detection_114_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_114;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_114;
  float32 SRR_FR_CAN_DET_ELEVATION_114;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_114;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_114;
  boolean SRR_FR_CAN_DET_Near_TARGET_114;
  float32 SRR_FR_CAN_DET_RANGE_114;
  float32 SRR_FR_CAN_DET_RANGE_RATE_114;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_114;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_114;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_114;
} SG_SRR_FR_Detection_114_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_115_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_115;
  float32 SRR_FR_CAN_DET_AZIMUTH_115;
  Rte_DT_SG_SRR_FR_Detection_115_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_115;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_115;
  float32 SRR_FR_CAN_DET_ELEVATION_115;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_115;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_115;
  boolean SRR_FR_CAN_DET_Near_TARGET_115;
  float32 SRR_FR_CAN_DET_RANGE_115;
  float32 SRR_FR_CAN_DET_RANGE_RATE_115;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_115;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_115;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_115;
} SG_SRR_FR_Detection_115_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_116_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_116;
  float32 SRR_FR_CAN_DET_AZIMUTH_116;
  Rte_DT_SG_SRR_FR_Detection_116_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_116;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_116;
  float32 SRR_FR_CAN_DET_ELEVATION_116;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_116;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_116;
  boolean SRR_FR_CAN_DET_Near_TARGET_116;
  float32 SRR_FR_CAN_DET_RANGE_116;
  float32 SRR_FR_CAN_DET_RANGE_RATE_116;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_116;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_116;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_116;
} SG_SRR_FR_Detection_116_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_117_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_117;
  float32 SRR_FR_CAN_DET_AZIMUTH_117;
  Rte_DT_SG_SRR_FR_Detection_117_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_117;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_117;
  float32 SRR_FR_CAN_DET_ELEVATION_117;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_117;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_117;
  boolean SRR_FR_CAN_DET_Near_TARGET_117;
  float32 SRR_FR_CAN_DET_RANGE_117;
  float32 SRR_FR_CAN_DET_RANGE_RATE_117;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_117;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_117;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_117;
} SG_SRR_FR_Detection_117_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_118_t
typedef struct
{
  float32 SRR_FR_CAN_DET_AMPLITUDE_118;
  float32 SRR_FR_CAN_DET_AZIMUTH_118;
  Rte_DT_SG_SRR_FR_Detection_118_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_118;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_118;
  float32 SRR_FR_CAN_DET_ELEVATION_118;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_118;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_118;
  boolean SRR_FR_CAN_DET_Near_TARGET_118;
  float32 SRR_FR_CAN_DET_RANGE_118;
  float32 SRR_FR_CAN_DET_RANGE_RATE_118;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_118;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_118;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_118;
} SG_SRR_FR_Detection_118_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_119_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_119;
  float32 SRR_FR_CAN_DET_AZIMUTH_119;
  Rte_DT_SG_SRR_FR_Detection_119_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_119;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_119;
  float32 SRR_FR_CAN_DET_ELEVATION_119;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_119;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_119;
  boolean SRR_FR_CAN_DET_Near_TARGET_119;
  float32 SRR_FR_CAN_DET_RANGE_119;
  float32 SRR_FR_CAN_DET_RANGE_RATE_119;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_119;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_119;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_119;
} SG_SRR_FR_Detection_119_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_120_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_120;
  float32 SRR_FR_CAN_DET_AZIMUTH_120;
  Rte_DT_SG_SRR_FR_Detection_120_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_120;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_120;
  float32 SRR_FR_CAN_DET_ELEVATION_120;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_120;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_120;
  boolean SRR_FR_CAN_DET_Near_TARGET_120;
  float32 SRR_FR_CAN_DET_RANGE_120;
  float32 SRR_FR_CAN_DET_RANGE_RATE_120;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_120;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_120;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_120;
} SG_SRR_FR_Detection_120_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_121_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_121;
  float32 SRR_FR_CAN_DET_AZIMUTH_121;
  Rte_DT_SG_SRR_FR_Detection_121_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_121;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_121;
  float32 SRR_FR_CAN_DET_ELEVATION_121;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_121;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_121;
  boolean SRR_FR_CAN_DET_Near_TARGET_121;
  float32 SRR_FR_CAN_DET_RANGE_121;
  float32 SRR_FR_CAN_DET_RANGE_RATE_121;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_121;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_121;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_121;
} SG_SRR_FR_Detection_121_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_122_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_122;
  float32 SRR_FR_CAN_DET_AZIMUTH_122;
  Rte_DT_SG_SRR_FR_Detection_122_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_122;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_122;
  float32 SRR_FR_CAN_DET_ELEVATION_122;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_122;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_122;
  boolean SRR_FR_CAN_DET_Near_TARGET_122;
  float32 SRR_FR_CAN_DET_RANGE_122;
  float32 SRR_FR_CAN_DET_RANGE_RATE_122;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_122;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_122;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_122;
} SG_SRR_FR_Detection_122_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_123_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_123;
  float32 SRR_FR_CAN_DET_AZIMUTH_123;
  Rte_DT_SG_SRR_FR_Detection_123_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_123;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_123;
  float32 SRR_FR_CAN_DET_ELEVATION_123;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_123;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_123;
  boolean SRR_FR_CAN_DET_Near_TARGET_123;
  float32 SRR_FR_CAN_DET_RANGE_123;
  float32 SRR_FR_CAN_DET_RANGE_RATE_123;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_123;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_123;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_123;
} SG_SRR_FR_Detection_123_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_124_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_124;
  float32 SRR_FR_CAN_DET_AZIMUTH_124;
  Rte_DT_SG_SRR_FR_Detection_124_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_124;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_124;
  float32 SRR_FR_CAN_DET_ELEVATION_124;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_124;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_124;
  boolean SRR_FR_CAN_DET_Near_TARGET_124;
  float32 SRR_FR_CAN_DET_RANGE_124;
  float32 SRR_FR_CAN_DET_RANGE_RATE_124;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_124;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_124;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_124;
} SG_SRR_FR_Detection_124_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_125_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_125;
  float32 SRR_FR_CAN_DET_AZIMUTH_125;
  Rte_DT_SG_SRR_FR_Detection_125_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_125;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_125;
  float32 SRR_FR_CAN_DET_ELEVATION_125;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_125;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_125;
  boolean SRR_FR_CAN_DET_Near_TARGET_125;
  float32 SRR_FR_CAN_DET_RANGE_125;
  float32 SRR_FR_CAN_DET_RANGE_RATE_125;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_125;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_125;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_125;
} SG_SRR_FR_Detection_125_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_126_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_126;
  float32 SRR_FR_CAN_DET_AZIMUTH_126;
  Rte_DT_SG_SRR_FR_Detection_126_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_126;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_126;
  float32 SRR_FR_CAN_DET_ELEVATION_126;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_126;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_126;
  boolean SRR_FR_CAN_DET_Near_TARGET_126;
  float32 SRR_FR_CAN_DET_RANGE_126;
  float32 SRR_FR_CAN_DET_RANGE_RATE_126;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_126;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_126;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_126;
} SG_SRR_FR_Detection_126_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_127_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_127;
  float32 SRR_FR_CAN_DET_AZIMUTH_127;
  Rte_DT_SG_SRR_FR_Detection_127_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_127;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_127;
  float32 SRR_FR_CAN_DET_ELEVATION_127;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_127;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_127;
  boolean SRR_FR_CAN_DET_Near_TARGET_127;
  float32 SRR_FR_CAN_DET_RANGE_127;
  float32 SRR_FR_CAN_DET_RANGE_RATE_127;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_127;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_127;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_127;
} SG_SRR_FR_Detection_127_t;

#  define Rte_TypeDef_SG_SRR_FR_Detection_128_t
typedef struct
{
  sint8 SRR_FR_CAN_DET_AMPLITUDE_128;
  float32 SRR_FR_CAN_DET_AZIMUTH_128;
  Rte_DT_SG_SRR_FR_Detection_128_t_2 SRR_FR_CAN_DET_CONFID_AZIMUTH_128;
  boolean SRR_FR_CAN_DET_CONFID_ELEVATION_128;
  float32 SRR_FR_CAN_DET_ELEVATION_128;
  boolean SRR_FR_CAN_DET_GUARD_RAIL_128;
  boolean SRR_FR_CAN_DET_HOST_VEH_CLUTTER_128;
  boolean SRR_FR_CAN_DET_Near_TARGET_128;
  float32 SRR_FR_CAN_DET_RANGE_128;
  float32 SRR_FR_CAN_DET_RANGE_RATE_128;
  boolean SRR_FR_CAN_DET_SUPER_RES_TARGET_128;
  boolean SRR_FR_CAN_DET_VALID_LEVEL_128;
  uint8 SRR_FR_CAN_SCAN_INDEX_2LSB_128;
} SG_SRR_FR_Detection_128_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_001_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_01;
  float32 SRR_RL_CAN_DET_AZIMUTH_01;
  Rte_DT_SG_SRR_RL_Detection_001_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_01;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_01;
  float32 SRR_RL_CAN_DET_ELEVATION_01;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_01;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_01;
  boolean SRR_RL_CAN_DET_Near_TARGET_01;
  float32 SRR_RL_CAN_DET_RANGE_01;
  float32 SRR_RL_CAN_DET_RANGE_RATE_01;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_01;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_01;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_01;
} SG_SRR_RL_Detection_001_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_002_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_02;
  float32 SRR_RL_CAN_DET_AZIMUTH_02;
  Rte_DT_SG_SRR_RL_Detection_002_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_02;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_02;
  float32 SRR_RL_CAN_DET_ELEVATION_02;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_02;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_02;
  boolean SRR_RL_CAN_DET_Near_TARGET_02;
  float32 SRR_RL_CAN_DET_RANGE_02;
  float32 SRR_RL_CAN_DET_RANGE_RATE_02;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_02;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_02;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_02;
} SG_SRR_RL_Detection_002_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_003_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_03;
  float32 SRR_RL_CAN_DET_AZIMUTH_03;
  Rte_DT_SG_SRR_RL_Detection_003_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_03;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_03;
  float32 SRR_RL_CAN_DET_ELEVATION_03;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_03;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_03;
  boolean SRR_RL_CAN_DET_Near_TARGET_03;
  float32 SRR_RL_CAN_DET_RANGE_03;
  float32 SRR_RL_CAN_DET_RANGE_RATE_03;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_03;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_03;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_03;
} SG_SRR_RL_Detection_003_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_004_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_04;
  float32 SRR_RL_CAN_DET_AZIMUTH_04;
  Rte_DT_SG_SRR_RL_Detection_004_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_04;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_04;
  float32 SRR_RL_CAN_DET_ELEVATION_04;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_04;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_04;
  boolean SRR_RL_CAN_DET_Near_TARGET_04;
  float32 SRR_RL_CAN_DET_RANGE_04;
  float32 SRR_RL_CAN_DET_RANGE_RATE_04;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_04;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_04;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_04;
} SG_SRR_RL_Detection_004_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_005_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_05;
  float32 SRR_RL_CAN_DET_AZIMUTH_05;
  Rte_DT_SG_SRR_RL_Detection_005_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_05;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_05;
  float32 SRR_RL_CAN_DET_ELEVATION_05;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_05;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_05;
  boolean SRR_RL_CAN_DET_Near_TARGET_05;
  float32 SRR_RL_CAN_DET_RANGE_05;
  float32 SRR_RL_CAN_DET_RANGE_RATE_05;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_05;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_05;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_05;
} SG_SRR_RL_Detection_005_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_006_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_06;
  uint16 SRR_RL_CAN_DET_AZIMUTH_06;
  Rte_DT_SG_SRR_RL_Detection_006_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_06;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_06;
  float32 SRR_RL_CAN_DET_ELEVATION_06;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_06;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_06;
  boolean SRR_RL_CAN_DET_Near_TARGET_06;
  float32 SRR_RL_CAN_DET_RANGE_06;
  float32 SRR_RL_CAN_DET_RANGE_RATE_06;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_06;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_06;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_06;
} SG_SRR_RL_Detection_006_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_007_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_07;
  float32 SRR_RL_CAN_DET_AZIMUTH_07;
  Rte_DT_SG_SRR_RL_Detection_007_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_07;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_07;
  float32 SRR_RL_CAN_DET_ELEVATION_07;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_07;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_07;
  boolean SRR_RL_CAN_DET_Near_TARGET_07;
  float32 SRR_RL_CAN_DET_RANGE_07;
  float32 SRR_RL_CAN_DET_RANGE_RATE_07;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_07;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_07;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_07;
} SG_SRR_RL_Detection_007_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_008_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_08;
  float32 SRR_RL_CAN_DET_AZIMUTH_08;
  Rte_DT_SG_SRR_RL_Detection_008_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_08;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_08;
  float32 SRR_RL_CAN_DET_ELEVATION_08;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_08;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_08;
  boolean SRR_RL_CAN_DET_Near_TARGET_08;
  float32 SRR_RL_CAN_DET_RANGE_08;
  float32 SRR_RL_CAN_DET_RANGE_RATE_08;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_08;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_08;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_08;
} SG_SRR_RL_Detection_008_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_009_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_09;
  float32 SRR_RL_CAN_DET_AZIMUTH_09;
  Rte_DT_SG_SRR_RL_Detection_009_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_09;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_09;
  float32 SRR_RL_CAN_DET_ELEVATION_09;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_09;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_09;
  boolean SRR_RL_CAN_DET_Near_TARGET_09;
  float32 SRR_RL_CAN_DET_RANGE_09;
  float32 SRR_RL_CAN_DET_RANGE_RATE_09;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_09;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_09;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_09;
} SG_SRR_RL_Detection_009_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_010_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_10;
  float32 SRR_RL_CAN_DET_AZIMUTH_10;
  Rte_DT_SG_SRR_RL_Detection_010_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_10;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_10;
  float32 SRR_RL_CAN_DET_ELEVATION_10;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_10;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_10;
  boolean SRR_RL_CAN_DET_Near_TARGET_10;
  float32 SRR_RL_CAN_DET_RANGE_10;
  float32 SRR_RL_CAN_DET_RANGE_RATE_10;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_10;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_10;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_10;
} SG_SRR_RL_Detection_010_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_011_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_11;
  float32 SRR_RL_CAN_DET_AZIMUTH_11;
  Rte_DT_SG_SRR_RL_Detection_011_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_11;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_11;
  float32 SRR_RL_CAN_DET_ELEVATION_11;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_11;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_11;
  boolean SRR_RL_CAN_DET_Near_TARGET_11;
  float32 SRR_RL_CAN_DET_RANGE_11;
  float32 SRR_RL_CAN_DET_RANGE_RATE_11;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_11;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_11;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_11;
} SG_SRR_RL_Detection_011_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_012_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_12;
  float32 SRR_RL_CAN_DET_AZIMUTH_12;
  Rte_DT_SG_SRR_RL_Detection_012_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_12;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_12;
  float32 SRR_RL_CAN_DET_ELEVATION_12;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_12;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_12;
  boolean SRR_RL_CAN_DET_Near_TARGET_12;
  float32 SRR_RL_CAN_DET_RANGE_12;
  float32 SRR_RL_CAN_DET_RANGE_RATE_12;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_12;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_12;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_12;
} SG_SRR_RL_Detection_012_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_013_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_13;
  float32 SRR_RL_CAN_DET_AZIMUTH_13;
  Rte_DT_SG_SRR_RL_Detection_013_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_13;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_13;
  float32 SRR_RL_CAN_DET_ELEVATION_13;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_13;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_13;
  boolean SRR_RL_CAN_DET_Near_TARGET_13;
  float32 SRR_RL_CAN_DET_RANGE_13;
  float32 SRR_RL_CAN_DET_RANGE_RATE_13;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_13;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_13;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_13;
} SG_SRR_RL_Detection_013_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_014_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_14;
  float32 SRR_RL_CAN_DET_AZIMUTH_14;
  Rte_DT_SG_SRR_RL_Detection_014_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_14;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_14;
  float32 SRR_RL_CAN_DET_ELEVATION_14;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_14;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_14;
  boolean SRR_RL_CAN_DET_Near_TARGET_14;
  float32 SRR_RL_CAN_DET_RANGE_14;
  float32 SRR_RL_CAN_DET_RANGE_RATE_14;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_14;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_14;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_14;
} SG_SRR_RL_Detection_014_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_015_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_15;
  float32 SRR_RL_CAN_DET_AZIMUTH_15;
  Rte_DT_SG_SRR_RL_Detection_015_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_15;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_15;
  float32 SRR_RL_CAN_DET_ELEVATION_15;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_15;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_15;
  boolean SRR_RL_CAN_DET_Near_TARGET_15;
  float32 SRR_RL_CAN_DET_RANGE_15;
  float32 SRR_RL_CAN_DET_RANGE_RATE_15;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_15;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_15;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_15;
} SG_SRR_RL_Detection_015_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_016_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_16;
  float32 SRR_RL_CAN_DET_AZIMUTH_16;
  Rte_DT_SG_SRR_RL_Detection_016_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_16;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_16;
  float32 SRR_RL_CAN_DET_ELEVATION_16;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_16;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_16;
  boolean SRR_RL_CAN_DET_Near_TARGET_16;
  float32 SRR_RL_CAN_DET_RANGE_16;
  float32 SRR_RL_CAN_DET_RANGE_RATE_16;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_16;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_16;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_16;
} SG_SRR_RL_Detection_016_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_017_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_17;
  float32 SRR_RL_CAN_DET_AZIMUTH_17;
  Rte_DT_SG_SRR_RL_Detection_017_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_17;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_17;
  float32 SRR_RL_CAN_DET_ELEVATION_17;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_17;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_17;
  boolean SRR_RL_CAN_DET_Near_TARGET_17;
  float32 SRR_RL_CAN_DET_RANGE_17;
  float32 SRR_RL_CAN_DET_RANGE_RATE_17;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_17;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_17;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_17;
} SG_SRR_RL_Detection_017_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_018_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_18;
  float32 SRR_RL_CAN_DET_AZIMUTH_18;
  Rte_DT_SG_SRR_RL_Detection_018_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_18;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_18;
  float32 SRR_RL_CAN_DET_ELEVATION_18;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_18;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_18;
  boolean SRR_RL_CAN_DET_Near_TARGET_18;
  float32 SRR_RL_CAN_DET_RANGE_18;
  float32 SRR_RL_CAN_DET_RANGE_RATE_18;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_18;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_18;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_18;
} SG_SRR_RL_Detection_018_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_019_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_19;
  float32 SRR_RL_CAN_DET_AZIMUTH_19;
  Rte_DT_SG_SRR_RL_Detection_019_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_19;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_19;
  float32 SRR_RL_CAN_DET_ELEVATION_19;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_19;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_19;
  boolean SRR_RL_CAN_DET_Near_TARGET_19;
  float32 SRR_RL_CAN_DET_RANGE_19;
  float32 SRR_RL_CAN_DET_RANGE_RATE_19;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_19;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_19;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_19;
} SG_SRR_RL_Detection_019_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_020_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_20;
  float32 SRR_RL_CAN_DET_AZIMUTH_20;
  Rte_DT_SG_SRR_RL_Detection_020_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_20;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_20;
  float32 SRR_RL_CAN_DET_ELEVATION_20;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_20;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_20;
  boolean SRR_RL_CAN_DET_Near_TARGET_20;
  float32 SRR_RL_CAN_DET_RANGE_20;
  float32 SRR_RL_CAN_DET_RANGE_RATE_20;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_20;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_20;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_20;
} SG_SRR_RL_Detection_020_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_021_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_21;
  float32 SRR_RL_CAN_DET_AZIMUTH_21;
  Rte_DT_SG_SRR_RL_Detection_021_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_21;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_21;
  float32 SRR_RL_CAN_DET_ELEVATION_21;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_21;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_21;
  boolean SRR_RL_CAN_DET_Near_TARGET_21;
  float32 SRR_RL_CAN_DET_RANGE_21;
  float32 SRR_RL_CAN_DET_RANGE_RATE_21;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_21;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_21;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_21;
} SG_SRR_RL_Detection_021_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_022_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_22;
  float32 SRR_RL_CAN_DET_AZIMUTH_22;
  Rte_DT_SG_SRR_RL_Detection_022_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_22;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_22;
  float32 SRR_RL_CAN_DET_ELEVATION_22;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_22;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_22;
  boolean SRR_RL_CAN_DET_Near_TARGET_22;
  float32 SRR_RL_CAN_DET_RANGE_22;
  float32 SRR_RL_CAN_DET_RANGE_RATE_22;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_22;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_22;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_22;
} SG_SRR_RL_Detection_022_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_023_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_23;
  float32 SRR_RL_CAN_DET_AZIMUTH_23;
  Rte_DT_SG_SRR_RL_Detection_023_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_23;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_23;
  float32 SRR_RL_CAN_DET_ELEVATION_23;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_23;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_23;
  boolean SRR_RL_CAN_DET_Near_TARGET_23;
  float32 SRR_RL_CAN_DET_RANGE_23;
  float32 SRR_RL_CAN_DET_RANGE_RATE_23;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_23;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_23;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_23;
} SG_SRR_RL_Detection_023_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_024_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_24;
  float32 SRR_RL_CAN_DET_AZIMUTH_24;
  Rte_DT_SG_SRR_RL_Detection_024_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_24;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_24;
  float32 SRR_RL_CAN_DET_ELEVATION_24;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_24;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_24;
  boolean SRR_RL_CAN_DET_Near_TARGET_24;
  float32 SRR_RL_CAN_DET_RANGE_24;
  float32 SRR_RL_CAN_DET_RANGE_RATE_24;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_24;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_24;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_24;
} SG_SRR_RL_Detection_024_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_025_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_25;
  float32 SRR_RL_CAN_DET_AZIMUTH_25;
  Rte_DT_SG_SRR_RL_Detection_025_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_25;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_25;
  float32 SRR_RL_CAN_DET_ELEVATION_25;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_25;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_25;
  boolean SRR_RL_CAN_DET_Near_TARGET_25;
  float32 SRR_RL_CAN_DET_RANGE_25;
  float32 SRR_RL_CAN_DET_RANGE_RATE_25;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_25;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_25;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_25;
} SG_SRR_RL_Detection_025_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_026_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_26;
  float32 SRR_RL_CAN_DET_AZIMUTH_26;
  Rte_DT_SG_SRR_RL_Detection_026_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_26;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_26;
  float32 SRR_RL_CAN_DET_ELEVATION_26;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_26;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_26;
  boolean SRR_RL_CAN_DET_Near_TARGET_26;
  float32 SRR_RL_CAN_DET_RANGE_26;
  float32 SRR_RL_CAN_DET_RANGE_RATE_26;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_26;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_26;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_26;
} SG_SRR_RL_Detection_026_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_027_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_27;
  float32 SRR_RL_CAN_DET_AZIMUTH_27;
  Rte_DT_SG_SRR_RL_Detection_027_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_27;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_27;
  float32 SRR_RL_CAN_DET_ELEVATION_27;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_27;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_27;
  boolean SRR_RL_CAN_DET_Near_TARGET_27;
  float32 SRR_RL_CAN_DET_RANGE_27;
  float32 SRR_RL_CAN_DET_RANGE_RATE_27;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_27;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_27;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_27;
} SG_SRR_RL_Detection_027_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_028_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_28;
  float32 SRR_RL_CAN_DET_AZIMUTH_28;
  Rte_DT_SG_SRR_RL_Detection_028_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_28;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_28;
  float32 SRR_RL_CAN_DET_ELEVATION_28;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_28;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_28;
  boolean SRR_RL_CAN_DET_Near_TARGET_28;
  float32 SRR_RL_CAN_DET_RANGE_28;
  float32 SRR_RL_CAN_DET_RANGE_RATE_28;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_28;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_28;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_28;
} SG_SRR_RL_Detection_028_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_029_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_29;
  float32 SRR_RL_CAN_DET_AZIMUTH_29;
  Rte_DT_SG_SRR_RL_Detection_029_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_29;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_29;
  float32 SRR_RL_CAN_DET_ELEVATION_29;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_29;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_29;
  boolean SRR_RL_CAN_DET_Near_TARGET_29;
  float32 SRR_RL_CAN_DET_RANGE_29;
  float32 SRR_RL_CAN_DET_RANGE_RATE_29;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_29;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_29;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_29;
} SG_SRR_RL_Detection_029_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_030_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_30;
  float32 SRR_RL_CAN_DET_AZIMUTH_30;
  Rte_DT_SG_SRR_RL_Detection_030_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_30;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_30;
  float32 SRR_RL_CAN_DET_ELEVATION_30;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_30;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_30;
  boolean SRR_RL_CAN_DET_Near_TARGET_30;
  float32 SRR_RL_CAN_DET_RANGE_30;
  float32 SRR_RL_CAN_DET_RANGE_RATE_30;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_30;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_30;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_30;
} SG_SRR_RL_Detection_030_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_031_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_31;
  float32 SRR_RL_CAN_DET_AZIMUTH_31;
  Rte_DT_SG_SRR_RL_Detection_031_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_31;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_31;
  float32 SRR_RL_CAN_DET_ELEVATION_31;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_31;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_31;
  boolean SRR_RL_CAN_DET_Near_TARGET_31;
  float32 SRR_RL_CAN_DET_RANGE_31;
  float32 SRR_RL_CAN_DET_RANGE_RATE_31;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_31;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_31;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_31;
} SG_SRR_RL_Detection_031_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_032_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_32;
  float32 SRR_RL_CAN_DET_AZIMUTH_32;
  Rte_DT_SG_SRR_RL_Detection_032_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_32;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_32;
  float32 SRR_RL_CAN_DET_ELEVATION_32;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_32;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_32;
  boolean SRR_RL_CAN_DET_Near_TARGET_32;
  float32 SRR_RL_CAN_DET_RANGE_32;
  float32 SRR_RL_CAN_DET_RANGE_RATE_32;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_32;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_32;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_32;
} SG_SRR_RL_Detection_032_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_033_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_33;
  float32 SRR_RL_CAN_DET_AZIMUTH_33;
  Rte_DT_SG_SRR_RL_Detection_033_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_33;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_33;
  float32 SRR_RL_CAN_DET_ELEVATION_33;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_33;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_33;
  boolean SRR_RL_CAN_DET_Near_TARGET_33;
  float32 SRR_RL_CAN_DET_RANGE_33;
  float32 SRR_RL_CAN_DET_RANGE_RATE_33;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_33;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_33;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_33;
} SG_SRR_RL_Detection_033_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_034_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_34;
  float32 SRR_RL_CAN_DET_AZIMUTH_34;
  Rte_DT_SG_SRR_RL_Detection_034_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_34;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_34;
  float32 SRR_RL_CAN_DET_ELEVATION_34;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_34;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_34;
  boolean SRR_RL_CAN_DET_Near_TARGET_34;
  float32 SRR_RL_CAN_DET_RANGE_34;
  float32 SRR_RL_CAN_DET_RANGE_RATE_34;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_34;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_34;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_34;
} SG_SRR_RL_Detection_034_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_035_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_35;
  float32 SRR_RL_CAN_DET_AZIMUTH_35;
  Rte_DT_SG_SRR_RL_Detection_035_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_35;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_35;
  float32 SRR_RL_CAN_DET_ELEVATION_35;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_35;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_35;
  boolean SRR_RL_CAN_DET_Near_TARGET_35;
  float32 SRR_RL_CAN_DET_RANGE_35;
  float32 SRR_RL_CAN_DET_RANGE_RATE_35;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_35;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_35;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_35;
} SG_SRR_RL_Detection_035_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_036_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_36;
  float32 SRR_RL_CAN_DET_AZIMUTH_36;
  Rte_DT_SG_SRR_RL_Detection_036_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_36;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_36;
  float32 SRR_RL_CAN_DET_ELEVATION_36;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_36;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_36;
  boolean SRR_RL_CAN_DET_Near_TARGET_36;
  float32 SRR_RL_CAN_DET_RANGE_36;
  float32 SRR_RL_CAN_DET_RANGE_RATE_36;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_36;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_36;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_36;
} SG_SRR_RL_Detection_036_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_037_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_37;
  float32 SRR_RL_CAN_DET_AZIMUTH_37;
  Rte_DT_SG_SRR_RL_Detection_037_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_37;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_37;
  float32 SRR_RL_CAN_DET_ELEVATION_37;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_37;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_37;
  boolean SRR_RL_CAN_DET_Near_TARGET_37;
  float32 SRR_RL_CAN_DET_RANGE_37;
  float32 SRR_RL_CAN_DET_RANGE_RATE_37;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_37;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_37;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_37;
} SG_SRR_RL_Detection_037_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_038_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_38;
  float32 SRR_RL_CAN_DET_AZIMUTH_38;
  Rte_DT_SG_SRR_RL_Detection_038_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_38;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_38;
  float32 SRR_RL_CAN_DET_ELEVATION_38;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_38;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_38;
  boolean SRR_RL_CAN_DET_Near_TARGET_38;
  float32 SRR_RL_CAN_DET_RANGE_38;
  float32 SRR_RL_CAN_DET_RANGE_RATE_38;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_38;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_38;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_38;
} SG_SRR_RL_Detection_038_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_039_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_39;
  float32 SRR_RL_CAN_DET_AZIMUTH_39;
  Rte_DT_SG_SRR_RL_Detection_039_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_39;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_39;
  float32 SRR_RL_CAN_DET_ELEVATION_39;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_39;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_39;
  boolean SRR_RL_CAN_DET_Near_TARGET_39;
  float32 SRR_RL_CAN_DET_RANGE_39;
  float32 SRR_RL_CAN_DET_RANGE_RATE_39;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_39;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_39;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_39;
} SG_SRR_RL_Detection_039_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_040_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_40;
  float32 SRR_RL_CAN_DET_AZIMUTH_40;
  Rte_DT_SG_SRR_RL_Detection_040_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_40;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_40;
  float32 SRR_RL_CAN_DET_ELEVATION_40;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_40;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_40;
  boolean SRR_RL_CAN_DET_Near_TARGET_40;
  float32 SRR_RL_CAN_DET_RANGE_40;
  float32 SRR_RL_CAN_DET_RANGE_RATE_40;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_40;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_40;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_40;
} SG_SRR_RL_Detection_040_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_041_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_41;
  float32 SRR_RL_CAN_DET_AZIMUTH_41;
  Rte_DT_SG_SRR_RL_Detection_041_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_41;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_41;
  float32 SRR_RL_CAN_DET_ELEVATION_41;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_41;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_41;
  boolean SRR_RL_CAN_DET_Near_TARGET_41;
  float32 SRR_RL_CAN_DET_RANGE_41;
  float32 SRR_RL_CAN_DET_RANGE_RATE_41;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_41;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_41;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_41;
} SG_SRR_RL_Detection_041_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_042_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_42;
  float32 SRR_RL_CAN_DET_AZIMUTH_42;
  Rte_DT_SG_SRR_RL_Detection_042_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_42;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_42;
  float32 SRR_RL_CAN_DET_ELEVATION_42;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_42;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_42;
  boolean SRR_RL_CAN_DET_Near_TARGET_42;
  float32 SRR_RL_CAN_DET_RANGE_42;
  float32 SRR_RL_CAN_DET_RANGE_RATE_42;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_42;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_42;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_42;
} SG_SRR_RL_Detection_042_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_043_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_43;
  float32 SRR_RL_CAN_DET_AZIMUTH_43;
  Rte_DT_SG_SRR_RL_Detection_043_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_43;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_43;
  float32 SRR_RL_CAN_DET_ELEVATION_43;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_43;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_43;
  boolean SRR_RL_CAN_DET_Near_TARGET_43;
  float32 SRR_RL_CAN_DET_RANGE_43;
  float32 SRR_RL_CAN_DET_RANGE_RATE_43;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_43;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_43;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_43;
} SG_SRR_RL_Detection_043_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_044_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_44;
  float32 SRR_RL_CAN_DET_AZIMUTH_44;
  Rte_DT_SG_SRR_RL_Detection_044_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_44;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_44;
  float32 SRR_RL_CAN_DET_ELEVATION_44;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_44;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_44;
  boolean SRR_RL_CAN_DET_Near_TARGET_44;
  float32 SRR_RL_CAN_DET_RANGE_44;
  float32 SRR_RL_CAN_DET_RANGE_RATE_44;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_44;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_44;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_44;
} SG_SRR_RL_Detection_044_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_045_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_45;
  float32 SRR_RL_CAN_DET_AZIMUTH_45;
  Rte_DT_SG_SRR_RL_Detection_045_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_45;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_45;
  float32 SRR_RL_CAN_DET_ELEVATION_45;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_45;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_45;
  boolean SRR_RL_CAN_DET_Near_TARGET_45;
  float32 SRR_RL_CAN_DET_RANGE_45;
  float32 SRR_RL_CAN_DET_RANGE_RATE_45;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_45;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_45;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_45;
} SG_SRR_RL_Detection_045_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_046_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_46;
  float32 SRR_RL_CAN_DET_AZIMUTH_46;
  Rte_DT_SG_SRR_RL_Detection_046_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_46;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_46;
  float32 SRR_RL_CAN_DET_ELEVATION_46;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_46;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_46;
  boolean SRR_RL_CAN_DET_Near_TARGET_46;
  float32 SRR_RL_CAN_DET_RANGE_46;
  float32 SRR_RL_CAN_DET_RANGE_RATE_46;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_46;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_46;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_46;
} SG_SRR_RL_Detection_046_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_047_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_47;
  float32 SRR_RL_CAN_DET_AZIMUTH_47;
  Rte_DT_SG_SRR_RL_Detection_047_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_47;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_47;
  float32 SRR_RL_CAN_DET_ELEVATION_47;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_47;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_47;
  boolean SRR_RL_CAN_DET_Near_TARGET_47;
  float32 SRR_RL_CAN_DET_RANGE_47;
  float32 SRR_RL_CAN_DET_RANGE_RATE_47;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_47;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_47;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_47;
} SG_SRR_RL_Detection_047_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_048_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_48;
  float32 SRR_RL_CAN_DET_AZIMUTH_48;
  Rte_DT_SG_SRR_RL_Detection_048_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_48;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_48;
  float32 SRR_RL_CAN_DET_ELEVATION_48;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_48;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_48;
  boolean SRR_RL_CAN_DET_Near_TARGET_48;
  float32 SRR_RL_CAN_DET_RANGE_48;
  float32 SRR_RL_CAN_DET_RANGE_RATE_48;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_48;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_48;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_48;
} SG_SRR_RL_Detection_048_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_049_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_49;
  float32 SRR_RL_CAN_DET_AZIMUTH_49;
  Rte_DT_SG_SRR_RL_Detection_049_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_49;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_49;
  float32 SRR_RL_CAN_DET_ELEVATION_49;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_49;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_49;
  boolean SRR_RL_CAN_DET_Near_TARGET_49;
  float32 SRR_RL_CAN_DET_RANGE_49;
  float32 SRR_RL_CAN_DET_RANGE_RATE_49;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_49;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_49;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_49;
} SG_SRR_RL_Detection_049_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_050_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_50;
  float32 SRR_RL_CAN_DET_AZIMUTH_50;
  Rte_DT_SG_SRR_RL_Detection_050_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_50;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_50;
  float32 SRR_RL_CAN_DET_ELEVATION_50;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_50;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_50;
  boolean SRR_RL_CAN_DET_Near_TARGET_50;
  float32 SRR_RL_CAN_DET_RANGE_50;
  float32 SRR_RL_CAN_DET_RANGE_RATE_50;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_50;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_50;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_50;
} SG_SRR_RL_Detection_050_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_051_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_51;
  float32 SRR_RL_CAN_DET_AZIMUTH_51;
  Rte_DT_SG_SRR_RL_Detection_051_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_51;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_51;
  float32 SRR_RL_CAN_DET_ELEVATION_51;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_51;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_51;
  boolean SRR_RL_CAN_DET_Near_TARGET_51;
  float32 SRR_RL_CAN_DET_RANGE_51;
  float32 SRR_RL_CAN_DET_RANGE_RATE_51;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_51;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_51;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_51;
} SG_SRR_RL_Detection_051_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_052_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_52;
  float32 SRR_RL_CAN_DET_AZIMUTH_52;
  Rte_DT_SG_SRR_RL_Detection_052_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_52;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_52;
  float32 SRR_RL_CAN_DET_ELEVATION_52;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_52;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_52;
  boolean SRR_RL_CAN_DET_Near_TARGET_52;
  float32 SRR_RL_CAN_DET_RANGE_52;
  float32 SRR_RL_CAN_DET_RANGE_RATE_52;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_52;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_52;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_52;
} SG_SRR_RL_Detection_052_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_053_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_53;
  float32 SRR_RL_CAN_DET_AZIMUTH_53;
  Rte_DT_SG_SRR_RL_Detection_053_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_53;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_53;
  float32 SRR_RL_CAN_DET_ELEVATION_53;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_53;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_53;
  boolean SRR_RL_CAN_DET_Near_TARGET_53;
  float32 SRR_RL_CAN_DET_RANGE_53;
  float32 SRR_RL_CAN_DET_RANGE_RATE_53;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_53;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_53;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_53;
} SG_SRR_RL_Detection_053_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_054_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_54;
  float32 SRR_RL_CAN_DET_AZIMUTH_54;
  Rte_DT_SG_SRR_RL_Detection_054_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_54;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_54;
  float32 SRR_RL_CAN_DET_ELEVATION_54;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_54;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_54;
  boolean SRR_RL_CAN_DET_Near_TARGET_54;
  float32 SRR_RL_CAN_DET_RANGE_54;
  float32 SRR_RL_CAN_DET_RANGE_RATE_54;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_54;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_54;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_54;
} SG_SRR_RL_Detection_054_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_055_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_55;
  float32 SRR_RL_CAN_DET_AZIMUTH_55;
  Rte_DT_SG_SRR_RL_Detection_055_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_55;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_55;
  float32 SRR_RL_CAN_DET_ELEVATION_55;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_55;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_55;
  boolean SRR_RL_CAN_DET_Near_TARGET_55;
  float32 SRR_RL_CAN_DET_RANGE_55;
  float32 SRR_RL_CAN_DET_RANGE_RATE_55;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_55;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_55;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_55;
} SG_SRR_RL_Detection_055_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_056_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_56;
  float32 SRR_RL_CAN_DET_AZIMUTH_56;
  Rte_DT_SG_SRR_RL_Detection_056_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_56;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_56;
  float32 SRR_RL_CAN_DET_ELEVATION_56;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_56;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_56;
  boolean SRR_RL_CAN_DET_Near_TARGET_56;
  float32 SRR_RL_CAN_DET_RANGE_56;
  float32 SRR_RL_CAN_DET_RANGE_RATE_56;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_56;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_56;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_56;
} SG_SRR_RL_Detection_056_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_057_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_57;
  float32 SRR_RL_CAN_DET_AZIMUTH_57;
  Rte_DT_SG_SRR_RL_Detection_057_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_57;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_57;
  float32 SRR_RL_CAN_DET_ELEVATION_57;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_57;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_57;
  boolean SRR_RL_CAN_DET_Near_TARGET_57;
  float32 SRR_RL_CAN_DET_RANGE_57;
  float32 SRR_RL_CAN_DET_RANGE_RATE_57;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_57;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_57;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_57;
} SG_SRR_RL_Detection_057_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_058_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_58;
  float32 SRR_RL_CAN_DET_AZIMUTH_58;
  Rte_DT_SG_SRR_RL_Detection_058_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_58;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_58;
  float32 SRR_RL_CAN_DET_ELEVATION_58;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_58;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_58;
  boolean SRR_RL_CAN_DET_Near_TARGET_58;
  float32 SRR_RL_CAN_DET_RANGE_58;
  float32 SRR_RL_CAN_DET_RANGE_RATE_58;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_58;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_58;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_58;
} SG_SRR_RL_Detection_058_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_059_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_59;
  float32 SRR_RL_CAN_DET_AZIMUTH_59;
  Rte_DT_SG_SRR_RL_Detection_059_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_59;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_59;
  float32 SRR_RL_CAN_DET_ELEVATION_59;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_59;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_59;
  boolean SRR_RL_CAN_DET_Near_TARGET_59;
  float32 SRR_RL_CAN_DET_RANGE_59;
  float32 SRR_RL_CAN_DET_RANGE_RATE_59;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_59;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_59;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_59;
} SG_SRR_RL_Detection_059_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_060_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_60;
  float32 SRR_RL_CAN_DET_AZIMUTH_60;
  Rte_DT_SG_SRR_RL_Detection_060_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_60;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_60;
  float32 SRR_RL_CAN_DET_ELEVATION_60;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_60;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_60;
  boolean SRR_RL_CAN_DET_Near_TARGET_60;
  float32 SRR_RL_CAN_DET_RANGE_60;
  float32 SRR_RL_CAN_DET_RANGE_RATE_60;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_60;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_60;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_60;
} SG_SRR_RL_Detection_060_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_061_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_61;
  float32 SRR_RL_CAN_DET_AZIMUTH_61;
  Rte_DT_SG_SRR_RL_Detection_061_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_61;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_61;
  float32 SRR_RL_CAN_DET_ELEVATION_61;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_61;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_61;
  boolean SRR_RL_CAN_DET_Near_TARGET_61;
  float32 SRR_RL_CAN_DET_RANGE_61;
  float32 SRR_RL_CAN_DET_RANGE_RATE_61;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_61;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_61;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_61;
} SG_SRR_RL_Detection_061_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_062_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_62;
  float32 SRR_RL_CAN_DET_AZIMUTH_62;
  Rte_DT_SG_SRR_RL_Detection_062_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_62;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_62;
  float32 SRR_RL_CAN_DET_ELEVATION_62;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_62;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_62;
  boolean SRR_RL_CAN_DET_Near_TARGET_62;
  float32 SRR_RL_CAN_DET_RANGE_62;
  float32 SRR_RL_CAN_DET_RANGE_RATE_62;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_62;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_62;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_62;
} SG_SRR_RL_Detection_062_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_063_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_63;
  float32 SRR_RL_CAN_DET_AZIMUTH_63;
  Rte_DT_SG_SRR_RL_Detection_063_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_63;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_63;
  float32 SRR_RL_CAN_DET_ELEVATION_63;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_63;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_63;
  boolean SRR_RL_CAN_DET_Near_TARGET_63;
  float32 SRR_RL_CAN_DET_RANGE_63;
  float32 SRR_RL_CAN_DET_RANGE_RATE_63;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_63;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_63;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_63;
} SG_SRR_RL_Detection_063_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_064_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_64;
  float32 SRR_RL_CAN_DET_AZIMUTH_64;
  Rte_DT_SG_SRR_RL_Detection_064_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_64;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_64;
  float32 SRR_RL_CAN_DET_ELEVATION_64;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_64;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_64;
  boolean SRR_RL_CAN_DET_Near_TARGET_64;
  float32 SRR_RL_CAN_DET_RANGE_64;
  float32 SRR_RL_CAN_DET_RANGE_RATE_64;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_64;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_64;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_64;
} SG_SRR_RL_Detection_064_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_065_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_65;
  float32 SRR_RL_CAN_DET_AZIMUTH_65;
  Rte_DT_SG_SRR_RL_Detection_065_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_65;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_65;
  float32 SRR_RL_CAN_DET_ELEVATION_65;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_65;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_65;
  boolean SRR_RL_CAN_DET_Near_TARGET_65;
  float32 SRR_RL_CAN_DET_RANGE_65;
  float32 SRR_RL_CAN_DET_RANGE_RATE_65;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_65;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_65;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_65;
} SG_SRR_RL_Detection_065_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_066_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_66;
  float32 SRR_RL_CAN_DET_AZIMUTH_66;
  Rte_DT_SG_SRR_RL_Detection_066_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_66;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_66;
  float32 SRR_RL_CAN_DET_ELEVATION_66;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_66;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_66;
  boolean SRR_RL_CAN_DET_Near_TARGET_66;
  float32 SRR_RL_CAN_DET_RANGE_66;
  float32 SRR_RL_CAN_DET_RANGE_RATE_66;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_66;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_66;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_66;
} SG_SRR_RL_Detection_066_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_067_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_67;
  float32 SRR_RL_CAN_DET_AZIMUTH_67;
  Rte_DT_SG_SRR_RL_Detection_067_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_67;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_67;
  float32 SRR_RL_CAN_DET_ELEVATION_67;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_67;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_67;
  boolean SRR_RL_CAN_DET_Near_TARGET_67;
  float32 SRR_RL_CAN_DET_RANGE_67;
  float32 SRR_RL_CAN_DET_RANGE_RATE_67;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_67;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_67;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_67;
} SG_SRR_RL_Detection_067_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_068_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_68;
  float32 SRR_RL_CAN_DET_AZIMUTH_68;
  Rte_DT_SG_SRR_RL_Detection_068_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_68;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_68;
  float32 SRR_RL_CAN_DET_ELEVATION_68;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_68;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_68;
  boolean SRR_RL_CAN_DET_Near_TARGET_68;
  float32 SRR_RL_CAN_DET_RANGE_68;
  float32 SRR_RL_CAN_DET_RANGE_RATE_68;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_68;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_68;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_68;
} SG_SRR_RL_Detection_068_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_069_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_69;
  float32 SRR_RL_CAN_DET_AZIMUTH_69;
  Rte_DT_SG_SRR_RL_Detection_069_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_69;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_69;
  float32 SRR_RL_CAN_DET_ELEVATION_69;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_69;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_69;
  boolean SRR_RL_CAN_DET_Near_TARGET_69;
  float32 SRR_RL_CAN_DET_RANGE_69;
  float32 SRR_RL_CAN_DET_RANGE_RATE_69;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_69;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_69;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_69;
} SG_SRR_RL_Detection_069_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_070_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_70;
  float32 SRR_RL_CAN_DET_AZIMUTH_70;
  Rte_DT_SG_SRR_RL_Detection_070_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_70;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_70;
  float32 SRR_RL_CAN_DET_ELEVATION_70;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_70;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_70;
  boolean SRR_RL_CAN_DET_Near_TARGET_70;
  float32 SRR_RL_CAN_DET_RANGE_70;
  float32 SRR_RL_CAN_DET_RANGE_RATE_70;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_70;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_70;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_70;
} SG_SRR_RL_Detection_070_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_071_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_71;
  float32 SRR_RL_CAN_DET_AZIMUTH_71;
  Rte_DT_SG_SRR_RL_Detection_071_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_71;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_71;
  float32 SRR_RL_CAN_DET_ELEVATION_71;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_71;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_71;
  boolean SRR_RL_CAN_DET_Near_TARGET_71;
  float32 SRR_RL_CAN_DET_RANGE_71;
  float32 SRR_RL_CAN_DET_RANGE_RATE_71;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_71;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_71;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_71;
} SG_SRR_RL_Detection_071_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_072_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_72;
  float32 SRR_RL_CAN_DET_AZIMUTH_72;
  Rte_DT_SG_SRR_RL_Detection_072_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_72;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_72;
  float32 SRR_RL_CAN_DET_ELEVATION_72;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_72;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_72;
  boolean SRR_RL_CAN_DET_Near_TARGET_72;
  float32 SRR_RL_CAN_DET_RANGE_72;
  float32 SRR_RL_CAN_DET_RANGE_RATE_72;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_72;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_72;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_72;
} SG_SRR_RL_Detection_072_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_073_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_73;
  float32 SRR_RL_CAN_DET_AZIMUTH_73;
  Rte_DT_SG_SRR_RL_Detection_073_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_73;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_73;
  float32 SRR_RL_CAN_DET_ELEVATION_73;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_73;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_73;
  boolean SRR_RL_CAN_DET_Near_TARGET_73;
  float32 SRR_RL_CAN_DET_RANGE_73;
  float32 SRR_RL_CAN_DET_RANGE_RATE_73;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_73;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_73;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_73;
} SG_SRR_RL_Detection_073_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_074_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_74;
  float32 SRR_RL_CAN_DET_AZIMUTH_74;
  Rte_DT_SG_SRR_RL_Detection_074_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_74;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_74;
  float32 SRR_RL_CAN_DET_ELEVATION_74;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_74;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_74;
  boolean SRR_RL_CAN_DET_Near_TARGET_74;
  float32 SRR_RL_CAN_DET_RANGE_74;
  float32 SRR_RL_CAN_DET_RANGE_RATE_74;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_74;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_74;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_74;
} SG_SRR_RL_Detection_074_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_075_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_75;
  float32 SRR_RL_CAN_DET_AZIMUTH_75;
  Rte_DT_SG_SRR_RL_Detection_075_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_75;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_75;
  float32 SRR_RL_CAN_DET_ELEVATION_75;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_75;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_75;
  boolean SRR_RL_CAN_DET_Near_TARGET_75;
  float32 SRR_RL_CAN_DET_RANGE_75;
  float32 SRR_RL_CAN_DET_RANGE_RATE_75;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_75;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_75;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_75;
} SG_SRR_RL_Detection_075_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_076_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_76;
  float32 SRR_RL_CAN_DET_AZIMUTH_76;
  Rte_DT_SG_SRR_RL_Detection_076_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_76;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_76;
  float32 SRR_RL_CAN_DET_ELEVATION_76;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_76;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_76;
  boolean SRR_RL_CAN_DET_Near_TARGET_76;
  float32 SRR_RL_CAN_DET_RANGE_76;
  float32 SRR_RL_CAN_DET_RANGE_RATE_76;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_76;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_76;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_76;
} SG_SRR_RL_Detection_076_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_077_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_77;
  float32 SRR_RL_CAN_DET_AZIMUTH_77;
  Rte_DT_SG_SRR_RL_Detection_077_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_77;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_77;
  float32 SRR_RL_CAN_DET_ELEVATION_77;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_77;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_77;
  boolean SRR_RL_CAN_DET_Near_TARGET_77;
  float32 SRR_RL_CAN_DET_RANGE_77;
  float32 SRR_RL_CAN_DET_RANGE_RATE_77;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_77;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_77;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_77;
} SG_SRR_RL_Detection_077_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_078_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_78;
  float32 SRR_RL_CAN_DET_AZIMUTH_78;
  Rte_DT_SG_SRR_RL_Detection_078_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_78;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_78;
  float32 SRR_RL_CAN_DET_ELEVATION_78;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_78;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_78;
  boolean SRR_RL_CAN_DET_Near_TARGET_78;
  float32 SRR_RL_CAN_DET_RANGE_78;
  float32 SRR_RL_CAN_DET_RANGE_RATE_78;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_78;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_78;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_78;
} SG_SRR_RL_Detection_078_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_079_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_79;
  float32 SRR_RL_CAN_DET_AZIMUTH_79;
  Rte_DT_SG_SRR_RL_Detection_079_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_79;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_79;
  float32 SRR_RL_CAN_DET_ELEVATION_79;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_79;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_79;
  boolean SRR_RL_CAN_DET_Near_TARGET_79;
  float32 SRR_RL_CAN_DET_RANGE_79;
  float32 SRR_RL_CAN_DET_RANGE_RATE_79;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_79;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_79;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_79;
} SG_SRR_RL_Detection_079_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_080_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_80;
  float32 SRR_RL_CAN_DET_AZIMUTH_80;
  Rte_DT_SG_SRR_RL_Detection_080_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_80;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_80;
  float32 SRR_RL_CAN_DET_ELEVATION_80;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_80;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_80;
  boolean SRR_RL_CAN_DET_Near_TARGET_80;
  float32 SRR_RL_CAN_DET_RANGE_80;
  float32 SRR_RL_CAN_DET_RANGE_RATE_80;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_80;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_80;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_80;
} SG_SRR_RL_Detection_080_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_081_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_81;
  float32 SRR_RL_CAN_DET_AZIMUTH_81;
  Rte_DT_SG_SRR_RL_Detection_081_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_81;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_81;
  float32 SRR_RL_CAN_DET_ELEVATION_81;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_81;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_81;
  boolean SRR_RL_CAN_DET_Near_TARGET_81;
  float32 SRR_RL_CAN_DET_RANGE_81;
  float32 SRR_RL_CAN_DET_RANGE_RATE_81;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_81;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_81;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_81;
} SG_SRR_RL_Detection_081_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_082_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_82;
  float32 SRR_RL_CAN_DET_AZIMUTH_82;
  Rte_DT_SG_SRR_RL_Detection_082_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_82;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_82;
  float32 SRR_RL_CAN_DET_ELEVATION_82;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_82;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_82;
  boolean SRR_RL_CAN_DET_Near_TARGET_82;
  float32 SRR_RL_CAN_DET_RANGE_82;
  float32 SRR_RL_CAN_DET_RANGE_RATE_82;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_82;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_82;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_82;
} SG_SRR_RL_Detection_082_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_083_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_83;
  float32 SRR_RL_CAN_DET_AZIMUTH_83;
  Rte_DT_SG_SRR_RL_Detection_083_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_83;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_83;
  float32 SRR_RL_CAN_DET_ELEVATION_83;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_83;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_83;
  boolean SRR_RL_CAN_DET_Near_TARGET_83;
  float32 SRR_RL_CAN_DET_RANGE_83;
  float32 SRR_RL_CAN_DET_RANGE_RATE_83;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_83;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_83;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_83;
} SG_SRR_RL_Detection_083_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_084_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_84;
  float32 SRR_RL_CAN_DET_AZIMUTH_84;
  Rte_DT_SG_SRR_RL_Detection_084_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_84;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_84;
  float32 SRR_RL_CAN_DET_ELEVATION_84;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_84;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_84;
  boolean SRR_RL_CAN_DET_Near_TARGET_84;
  float32 SRR_RL_CAN_DET_RANGE_84;
  float32 SRR_RL_CAN_DET_RANGE_RATE_84;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_84;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_84;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_84;
} SG_SRR_RL_Detection_084_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_085_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_85;
  float32 SRR_RL_CAN_DET_AZIMUTH_85;
  Rte_DT_SG_SRR_RL_Detection_085_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_85;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_85;
  float32 SRR_RL_CAN_DET_ELEVATION_85;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_85;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_85;
  boolean SRR_RL_CAN_DET_Near_TARGET_85;
  float32 SRR_RL_CAN_DET_RANGE_85;
  float32 SRR_RL_CAN_DET_RANGE_RATE_85;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_85;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_85;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_85;
} SG_SRR_RL_Detection_085_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_086_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_86;
  float32 SRR_RL_CAN_DET_AZIMUTH_86;
  Rte_DT_SG_SRR_RL_Detection_086_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_86;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_86;
  float32 SRR_RL_CAN_DET_ELEVATION_86;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_86;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_86;
  boolean SRR_RL_CAN_DET_Near_TARGET_86;
  float32 SRR_RL_CAN_DET_RANGE_86;
  float32 SRR_RL_CAN_DET_RANGE_RATE_86;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_86;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_86;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_86;
} SG_SRR_RL_Detection_086_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_087_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_87;
  float32 SRR_RL_CAN_DET_AZIMUTH_87;
  Rte_DT_SG_SRR_RL_Detection_087_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_87;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_87;
  float32 SRR_RL_CAN_DET_ELEVATION_87;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_87;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_87;
  boolean SRR_RL_CAN_DET_Near_TARGET_87;
  float32 SRR_RL_CAN_DET_RANGE_87;
  float32 SRR_RL_CAN_DET_RANGE_RATE_87;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_87;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_87;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_87;
} SG_SRR_RL_Detection_087_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_088_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_88;
  float32 SRR_RL_CAN_DET_AZIMUTH_88;
  Rte_DT_SG_SRR_RL_Detection_088_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_88;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_88;
  float32 SRR_RL_CAN_DET_ELEVATION_88;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_88;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_88;
  boolean SRR_RL_CAN_DET_Near_TARGET_88;
  float32 SRR_RL_CAN_DET_RANGE_88;
  float32 SRR_RL_CAN_DET_RANGE_RATE_88;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_88;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_88;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_88;
} SG_SRR_RL_Detection_088_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_089_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_89;
  float32 SRR_RL_CAN_DET_AZIMUTH_89;
  Rte_DT_SG_SRR_RL_Detection_089_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_89;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_89;
  float32 SRR_RL_CAN_DET_ELEVATION_89;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_89;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_89;
  boolean SRR_RL_CAN_DET_Near_TARGET_89;
  float32 SRR_RL_CAN_DET_RANGE_89;
  float32 SRR_RL_CAN_DET_RANGE_RATE_89;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_89;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_89;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_89;
} SG_SRR_RL_Detection_089_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_090_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_90;
  float32 SRR_RL_CAN_DET_AZIMUTH_90;
  Rte_DT_SG_SRR_RL_Detection_090_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_90;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_90;
  float32 SRR_RL_CAN_DET_ELEVATION_90;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_90;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_90;
  boolean SRR_RL_CAN_DET_Near_TARGET_90;
  float32 SRR_RL_CAN_DET_RANGE_90;
  float32 SRR_RL_CAN_DET_RANGE_RATE_90;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_90;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_90;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_90;
} SG_SRR_RL_Detection_090_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_091_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_91;
  float32 SRR_RL_CAN_DET_AZIMUTH_91;
  Rte_DT_SG_SRR_RL_Detection_091_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_91;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_91;
  float32 SRR_RL_CAN_DET_ELEVATION_91;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_91;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_91;
  boolean SRR_RL_CAN_DET_Near_TARGET_91;
  float32 SRR_RL_CAN_DET_RANGE_91;
  float32 SRR_RL_CAN_DET_RANGE_RATE_91;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_91;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_91;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_91;
} SG_SRR_RL_Detection_091_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_092_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_92;
  float32 SRR_RL_CAN_DET_AZIMUTH_92;
  Rte_DT_SG_SRR_RL_Detection_092_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_92;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_92;
  float32 SRR_RL_CAN_DET_ELEVATION_92;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_92;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_92;
  boolean SRR_RL_CAN_DET_Near_TARGET_92;
  float32 SRR_RL_CAN_DET_RANGE_92;
  float32 SRR_RL_CAN_DET_RANGE_RATE_92;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_92;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_92;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_92;
} SG_SRR_RL_Detection_092_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_093_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_93;
  float32 SRR_RL_CAN_DET_AZIMUTH_93;
  Rte_DT_SG_SRR_RL_Detection_093_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_93;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_93;
  float32 SRR_RL_CAN_DET_ELEVATION_93;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_93;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_93;
  boolean SRR_RL_CAN_DET_Near_TARGET_93;
  float32 SRR_RL_CAN_DET_RANGE_93;
  float32 SRR_RL_CAN_DET_RANGE_RATE_93;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_93;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_93;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_93;
} SG_SRR_RL_Detection_093_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_094_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_94;
  float32 SRR_RL_CAN_DET_AZIMUTH_94;
  Rte_DT_SG_SRR_RL_Detection_094_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_94;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_94;
  float32 SRR_RL_CAN_DET_ELEVATION_94;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_94;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_94;
  boolean SRR_RL_CAN_DET_Near_TARGET_94;
  float32 SRR_RL_CAN_DET_RANGE_94;
  float32 SRR_RL_CAN_DET_RANGE_RATE_94;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_94;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_94;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_94;
} SG_SRR_RL_Detection_094_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_095_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_95;
  float32 SRR_RL_CAN_DET_AZIMUTH_95;
  Rte_DT_SG_SRR_RL_Detection_095_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_95;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_95;
  float32 SRR_RL_CAN_DET_ELEVATION_95;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_95;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_95;
  boolean SRR_RL_CAN_DET_Near_TARGET_95;
  float32 SRR_RL_CAN_DET_RANGE_95;
  float32 SRR_RL_CAN_DET_RANGE_RATE_95;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_95;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_95;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_95;
} SG_SRR_RL_Detection_095_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_096_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_96;
  float32 SRR_RL_CAN_DET_AZIMUTH_96;
  Rte_DT_SG_SRR_RL_Detection_096_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_96;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_96;
  float32 SRR_RL_CAN_DET_ELEVATION_96;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_96;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_96;
  boolean SRR_RL_CAN_DET_Near_TARGET_96;
  float32 SRR_RL_CAN_DET_RANGE_96;
  float32 SRR_RL_CAN_DET_RANGE_RATE_96;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_96;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_96;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_96;
} SG_SRR_RL_Detection_096_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_097_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_97;
  float32 SRR_RL_CAN_DET_AZIMUTH_97;
  Rte_DT_SG_SRR_RL_Detection_097_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_97;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_97;
  float32 SRR_RL_CAN_DET_ELEVATION_97;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_97;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_97;
  boolean SRR_RL_CAN_DET_Near_TARGET_97;
  float32 SRR_RL_CAN_DET_RANGE_97;
  float32 SRR_RL_CAN_DET_RANGE_RATE_97;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_97;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_97;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_97;
} SG_SRR_RL_Detection_097_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_098_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_98;
  float32 SRR_RL_CAN_DET_AZIMUTH_98;
  Rte_DT_SG_SRR_RL_Detection_098_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_98;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_98;
  float32 SRR_RL_CAN_DET_ELEVATION_98;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_98;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_98;
  boolean SRR_RL_CAN_DET_Near_TARGET_98;
  float32 SRR_RL_CAN_DET_RANGE_98;
  float32 SRR_RL_CAN_DET_RANGE_RATE_98;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_98;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_98;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_98;
} SG_SRR_RL_Detection_098_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_099_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_99;
  float32 SRR_RL_CAN_DET_AZIMUTH_99;
  Rte_DT_SG_SRR_RL_Detection_099_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_99;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_99;
  float32 SRR_RL_CAN_DET_ELEVATION_99;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_99;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_99;
  boolean SRR_RL_CAN_DET_Near_TARGET_99;
  float32 SRR_RL_CAN_DET_RANGE_99;
  float32 SRR_RL_CAN_DET_RANGE_RATE_99;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_99;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_99;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_99;
} SG_SRR_RL_Detection_099_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_100_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_100;
  float32 SRR_RL_CAN_DET_AZIMUTH_100;
  Rte_DT_SG_SRR_RL_Detection_100_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_100;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_100;
  float32 SRR_RL_CAN_DET_ELEVATION_100;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_100;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_100;
  boolean SRR_RL_CAN_DET_Near_TARGET_100;
  float32 SRR_RL_CAN_DET_RANGE_100;
  float32 SRR_RL_CAN_DET_RANGE_RATE_100;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_100;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_100;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_100;
} SG_SRR_RL_Detection_100_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_101_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_101;
  float32 SRR_RL_CAN_DET_AZIMUTH_101;
  Rte_DT_SG_SRR_RL_Detection_101_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_101;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_101;
  float32 SRR_RL_CAN_DET_ELEVATION_101;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_101;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_101;
  boolean SRR_RL_CAN_DET_Near_TARGET_101;
  float32 SRR_RL_CAN_DET_RANGE_101;
  float32 SRR_RL_CAN_DET_RANGE_RATE_101;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_101;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_101;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_101;
} SG_SRR_RL_Detection_101_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_102_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_102;
  float32 SRR_RL_CAN_DET_AZIMUTH_102;
  Rte_DT_SG_SRR_RL_Detection_102_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_102;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_102;
  float32 SRR_RL_CAN_DET_ELEVATION_102;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_102;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_102;
  boolean SRR_RL_CAN_DET_Near_TARGET_102;
  float32 SRR_RL_CAN_DET_RANGE_102;
  float32 SRR_RL_CAN_DET_RANGE_RATE_102;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_102;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_102;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_102;
} SG_SRR_RL_Detection_102_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_103_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_103;
  float32 SRR_RL_CAN_DET_AZIMUTH_103;
  Rte_DT_SG_SRR_RL_Detection_103_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_103;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_103;
  float32 SRR_RL_CAN_DET_ELEVATION_103;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_103;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_103;
  boolean SRR_RL_CAN_DET_Near_TARGET_103;
  float32 SRR_RL_CAN_DET_RANGE_103;
  float32 SRR_RL_CAN_DET_RANGE_RATE_103;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_103;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_103;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_103;
} SG_SRR_RL_Detection_103_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_104_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_104;
  float32 SRR_RL_CAN_DET_AZIMUTH_104;
  Rte_DT_SG_SRR_RL_Detection_104_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_104;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_104;
  float32 SRR_RL_CAN_DET_ELEVATION_104;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_104;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_104;
  boolean SRR_RL_CAN_DET_Near_TARGET_104;
  float32 SRR_RL_CAN_DET_RANGE_104;
  float32 SRR_RL_CAN_DET_RANGE_RATE_104;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_104;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_104;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_104;
} SG_SRR_RL_Detection_104_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_105_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_105;
  float32 SRR_RL_CAN_DET_AZIMUTH_105;
  Rte_DT_SG_SRR_RL_Detection_105_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_105;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_105;
  float32 SRR_RL_CAN_DET_ELEVATION_105;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_105;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_105;
  boolean SRR_RL_CAN_DET_Near_TARGET_105;
  float32 SRR_RL_CAN_DET_RANGE_105;
  float32 SRR_RL_CAN_DET_RANGE_RATE_105;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_105;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_105;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_105;
} SG_SRR_RL_Detection_105_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_106_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_106;
  float32 SRR_RL_CAN_DET_AZIMUTH_106;
  Rte_DT_SG_SRR_RL_Detection_106_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_106;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_106;
  float32 SRR_RL_CAN_DET_ELEVATION_106;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_106;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_106;
  boolean SRR_RL_CAN_DET_Near_TARGET_106;
  float32 SRR_RL_CAN_DET_RANGE_106;
  float32 SRR_RL_CAN_DET_RANGE_RATE_106;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_106;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_106;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_106;
} SG_SRR_RL_Detection_106_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_107_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_107;
  float32 SRR_RL_CAN_DET_AZIMUTH_107;
  Rte_DT_SG_SRR_RL_Detection_107_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_107;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_107;
  float32 SRR_RL_CAN_DET_ELEVATION_107;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_107;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_107;
  boolean SRR_RL_CAN_DET_Near_TARGET_107;
  float32 SRR_RL_CAN_DET_RANGE_107;
  float32 SRR_RL_CAN_DET_RANGE_RATE_107;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_107;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_107;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_107;
} SG_SRR_RL_Detection_107_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_108_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_108;
  float32 SRR_RL_CAN_DET_AZIMUTH_108;
  Rte_DT_SG_SRR_RL_Detection_108_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_108;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_108;
  float32 SRR_RL_CAN_DET_ELEVATION_108;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_108;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_108;
  boolean SRR_RL_CAN_DET_Near_TARGET_108;
  float32 SRR_RL_CAN_DET_RANGE_108;
  float32 SRR_RL_CAN_DET_RANGE_RATE_108;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_108;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_108;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_108;
} SG_SRR_RL_Detection_108_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_109_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_109;
  float32 SRR_RL_CAN_DET_AZIMUTH_109;
  Rte_DT_SG_SRR_RL_Detection_109_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_109;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_109;
  float32 SRR_RL_CAN_DET_ELEVATION_109;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_109;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_109;
  boolean SRR_RL_CAN_DET_Near_TARGET_109;
  float32 SRR_RL_CAN_DET_RANGE_109;
  float32 SRR_RL_CAN_DET_RANGE_RATE_109;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_109;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_109;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_109;
} SG_SRR_RL_Detection_109_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_110_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_110;
  float32 SRR_RL_CAN_DET_AZIMUTH_110;
  Rte_DT_SG_SRR_RL_Detection_110_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_110;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_110;
  float32 SRR_RL_CAN_DET_ELEVATION_110;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_110;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_110;
  boolean SRR_RL_CAN_DET_Near_TARGET_110;
  float32 SRR_RL_CAN_DET_RANGE_110;
  float32 SRR_RL_CAN_DET_RANGE_RATE_110;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_110;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_110;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_110;
} SG_SRR_RL_Detection_110_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_111_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_111;
  float32 SRR_RL_CAN_DET_AZIMUTH_111;
  Rte_DT_SG_SRR_RL_Detection_111_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_111;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_111;
  float32 SRR_RL_CAN_DET_ELEVATION_111;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_111;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_111;
  boolean SRR_RL_CAN_DET_Near_TARGET_111;
  float32 SRR_RL_CAN_DET_RANGE_111;
  float32 SRR_RL_CAN_DET_RANGE_RATE_111;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_111;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_111;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_111;
} SG_SRR_RL_Detection_111_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_112_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_112;
  float32 SRR_RL_CAN_DET_AZIMUTH_112;
  Rte_DT_SG_SRR_RL_Detection_112_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_112;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_112;
  float32 SRR_RL_CAN_DET_ELEVATION_112;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_112;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_112;
  boolean SRR_RL_CAN_DET_Near_TARGET_112;
  float32 SRR_RL_CAN_DET_RANGE_112;
  float32 SRR_RL_CAN_DET_RANGE_RATE_112;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_112;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_112;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_112;
} SG_SRR_RL_Detection_112_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_113_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_113;
  float32 SRR_RL_CAN_DET_AZIMUTH_113;
  Rte_DT_SG_SRR_RL_Detection_113_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_113;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_113;
  float32 SRR_RL_CAN_DET_ELEVATION_113;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_113;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_113;
  boolean SRR_RL_CAN_DET_Near_TARGET_113;
  float32 SRR_RL_CAN_DET_RANGE_113;
  float32 SRR_RL_CAN_DET_RANGE_RATE_113;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_113;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_113;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_113;
} SG_SRR_RL_Detection_113_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_114_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_114;
  float32 SRR_RL_CAN_DET_AZIMUTH_114;
  Rte_DT_SG_SRR_RL_Detection_114_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_114;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_114;
  float32 SRR_RL_CAN_DET_ELEVATION_114;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_114;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_114;
  boolean SRR_RL_CAN_DET_Near_TARGET_114;
  float32 SRR_RL_CAN_DET_RANGE_114;
  float32 SRR_RL_CAN_DET_RANGE_RATE_114;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_114;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_114;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_114;
} SG_SRR_RL_Detection_114_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_115_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_115;
  float32 SRR_RL_CAN_DET_AZIMUTH_115;
  Rte_DT_SG_SRR_RL_Detection_115_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_115;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_115;
  float32 SRR_RL_CAN_DET_ELEVATION_115;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_115;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_115;
  boolean SRR_RL_CAN_DET_Near_TARGET_115;
  float32 SRR_RL_CAN_DET_RANGE_115;
  float32 SRR_RL_CAN_DET_RANGE_RATE_115;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_115;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_115;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_115;
} SG_SRR_RL_Detection_115_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_116_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_116;
  float32 SRR_RL_CAN_DET_AZIMUTH_116;
  Rte_DT_SG_SRR_RL_Detection_116_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_116;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_116;
  float32 SRR_RL_CAN_DET_ELEVATION_116;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_116;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_116;
  boolean SRR_RL_CAN_DET_Near_TARGET_116;
  float32 SRR_RL_CAN_DET_RANGE_116;
  float32 SRR_RL_CAN_DET_RANGE_RATE_116;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_116;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_116;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_116;
} SG_SRR_RL_Detection_116_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_117_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_117;
  float32 SRR_RL_CAN_DET_AZIMUTH_117;
  Rte_DT_SG_SRR_RL_Detection_117_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_117;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_117;
  float32 SRR_RL_CAN_DET_ELEVATION_117;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_117;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_117;
  boolean SRR_RL_CAN_DET_Near_TARGET_117;
  float32 SRR_RL_CAN_DET_RANGE_117;
  float32 SRR_RL_CAN_DET_RANGE_RATE_117;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_117;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_117;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_117;
} SG_SRR_RL_Detection_117_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_118_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_118;
  float32 SRR_RL_CAN_DET_AZIMUTH_118;
  Rte_DT_SG_SRR_RL_Detection_118_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_118;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_118;
  float32 SRR_RL_CAN_DET_ELEVATION_118;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_118;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_118;
  boolean SRR_RL_CAN_DET_Near_TARGET_118;
  float32 SRR_RL_CAN_DET_RANGE_118;
  float32 SRR_RL_CAN_DET_RANGE_RATE_118;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_118;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_118;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_118;
} SG_SRR_RL_Detection_118_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_119_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_119;
  float32 SRR_RL_CAN_DET_AZIMUTH_119;
  Rte_DT_SG_SRR_RL_Detection_119_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_119;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_119;
  float32 SRR_RL_CAN_DET_ELEVATION_119;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_119;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_119;
  boolean SRR_RL_CAN_DET_Near_TARGET_119;
  float32 SRR_RL_CAN_DET_RANGE_119;
  float32 SRR_RL_CAN_DET_RANGE_RATE_119;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_119;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_119;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_119;
} SG_SRR_RL_Detection_119_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_120_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_120;
  float32 SRR_RL_CAN_DET_AZIMUTH_120;
  Rte_DT_SG_SRR_RL_Detection_120_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_120;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_120;
  float32 SRR_RL_CAN_DET_ELEVATION_120;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_120;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_120;
  boolean SRR_RL_CAN_DET_Near_TARGET_120;
  float32 SRR_RL_CAN_DET_RANGE_120;
  float32 SRR_RL_CAN_DET_RANGE_RATE_120;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_120;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_120;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_120;
} SG_SRR_RL_Detection_120_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_121_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_121;
  float32 SRR_RL_CAN_DET_AZIMUTH_121;
  Rte_DT_SG_SRR_RL_Detection_121_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_121;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_121;
  float32 SRR_RL_CAN_DET_ELEVATION_121;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_121;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_121;
  boolean SRR_RL_CAN_DET_Near_TARGET_121;
  float32 SRR_RL_CAN_DET_RANGE_121;
  float32 SRR_RL_CAN_DET_RANGE_RATE_121;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_121;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_121;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_121;
} SG_SRR_RL_Detection_121_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_122_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_122;
  float32 SRR_RL_CAN_DET_AZIMUTH_122;
  Rte_DT_SG_SRR_RL_Detection_122_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_122;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_122;
  float32 SRR_RL_CAN_DET_ELEVATION_122;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_122;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_122;
  boolean SRR_RL_CAN_DET_Near_TARGET_122;
  float32 SRR_RL_CAN_DET_RANGE_122;
  float32 SRR_RL_CAN_DET_RANGE_RATE_122;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_122;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_122;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_122;
} SG_SRR_RL_Detection_122_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_123_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_123;
  float32 SRR_RL_CAN_DET_AZIMUTH_123;
  Rte_DT_SG_SRR_RL_Detection_123_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_123;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_123;
  float32 SRR_RL_CAN_DET_ELEVATION_123;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_123;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_123;
  boolean SRR_RL_CAN_DET_Near_TARGET_123;
  float32 SRR_RL_CAN_DET_RANGE_123;
  float32 SRR_RL_CAN_DET_RANGE_RATE_123;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_123;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_123;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_123;
} SG_SRR_RL_Detection_123_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_124_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_124;
  float32 SRR_RL_CAN_DET_AZIMUTH_124;
  Rte_DT_SG_SRR_RL_Detection_124_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_124;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_124;
  float32 SRR_RL_CAN_DET_ELEVATION_124;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_124;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_124;
  boolean SRR_RL_CAN_DET_Near_TARGET_124;
  float32 SRR_RL_CAN_DET_RANGE_124;
  float32 SRR_RL_CAN_DET_RANGE_RATE_124;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_124;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_124;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_124;
} SG_SRR_RL_Detection_124_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_125_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_125;
  float32 SRR_RL_CAN_DET_AZIMUTH_125;
  Rte_DT_SG_SRR_RL_Detection_125_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_125;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_125;
  float32 SRR_RL_CAN_DET_ELEVATION_125;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_125;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_125;
  boolean SRR_RL_CAN_DET_Near_TARGET_125;
  float32 SRR_RL_CAN_DET_RANGE_125;
  float32 SRR_RL_CAN_DET_RANGE_RATE_125;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_125;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_125;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_125;
} SG_SRR_RL_Detection_125_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_126_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_126;
  float32 SRR_RL_CAN_DET_AZIMUTH_126;
  Rte_DT_SG_SRR_RL_Detection_126_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_126;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_126;
  float32 SRR_RL_CAN_DET_ELEVATION_126;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_126;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_126;
  boolean SRR_RL_CAN_DET_Near_TARGET_126;
  float32 SRR_RL_CAN_DET_RANGE_126;
  float32 SRR_RL_CAN_DET_RANGE_RATE_126;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_126;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_126;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_126;
} SG_SRR_RL_Detection_126_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_127_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_127;
  float32 SRR_RL_CAN_DET_AZIMUTH_127;
  Rte_DT_SG_SRR_RL_Detection_127_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_127;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_127;
  float32 SRR_RL_CAN_DET_ELEVATION_127;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_127;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_127;
  boolean SRR_RL_CAN_DET_Near_TARGET_127;
  float32 SRR_RL_CAN_DET_RANGE_127;
  float32 SRR_RL_CAN_DET_RANGE_RATE_127;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_127;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_127;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_127;
} SG_SRR_RL_Detection_127_t;

#  define Rte_TypeDef_SG_SRR_RL_Detection_128_t
typedef struct
{
  sint8 SRR_RL_CAN_DET_AMPLITUDE_128;
  float32 SRR_RL_CAN_DET_AZIMUTH_128;
  Rte_DT_SG_SRR_RL_Detection_128_t_2 SRR_RL_CAN_DET_CONFID_AZIMUTH_128;
  boolean SRR_RL_CAN_DET_CONFID_ELEVATION_128;
  float32 SRR_RL_CAN_DET_ELEVATION_128;
  boolean SRR_RL_CAN_DET_GUARD_RAIL_128;
  boolean SRR_RL_CAN_DET_HOST_VEH_CLUTTER_128;
  boolean SRR_RL_CAN_DET_Near_TARGET_128;
  float32 SRR_RL_CAN_DET_RANGE_128;
  float32 SRR_RL_CAN_DET_RANGE_RATE_128;
  boolean SRR_RL_CAN_DET_SUPER_RES_TARGET_128;
  boolean SRR_RL_CAN_DET_VALID_LEVEL_128;
  uint8 SRR_RL_CAN_SCAN_INDEX_2LSB_128;
} SG_SRR_RL_Detection_128_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_001_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_01;
  float32 SRR_RR_CAN_DET_AZIMUTH_01;
  Rte_DT_SG_SRR_RR_Detection_001_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_01;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_01;
  float32 SRR_RR_CAN_DET_ELEVATION_01;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_01;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_01;
  boolean SRR_RR_CAN_DET_Near_TARGET_01;
  float32 SRR_RR_CAN_DET_RANGE_01;
  float32 SRR_RR_CAN_DET_RANGE_RATE_01;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_01;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_01;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_01;
} SG_SRR_RR_Detection_001_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_002_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_02;
  float32 SRR_RR_CAN_DET_AZIMUTH_02;
  Rte_DT_SG_SRR_RR_Detection_002_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_02;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_02;
  float32 SRR_RR_CAN_DET_ELEVATION_02;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_02;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_02;
  boolean SRR_RR_CAN_DET_Near_TARGET_02;
  float32 SRR_RR_CAN_DET_RANGE_02;
  float32 SRR_RR_CAN_DET_RANGE_RATE_02;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_02;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_02;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_02;
} SG_SRR_RR_Detection_002_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_003_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_03;
  float32 SRR_RR_CAN_DET_AZIMUTH_03;
  Rte_DT_SG_SRR_RR_Detection_003_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_03;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_03;
  float32 SRR_RR_CAN_DET_ELEVATION_03;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_03;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_03;
  boolean SRR_RR_CAN_DET_Near_TARGET_03;
  float32 SRR_RR_CAN_DET_RANGE_03;
  float32 SRR_RR_CAN_DET_RANGE_RATE_03;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_03;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_03;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_03;
} SG_SRR_RR_Detection_003_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_004_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_04;
  float32 SRR_RR_CAN_DET_AZIMUTH_04;
  Rte_DT_SG_SRR_RR_Detection_004_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_04;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_04;
  float32 SRR_RR_CAN_DET_ELEVATION_04;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_04;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_04;
  boolean SRR_RR_CAN_DET_Near_TARGET_04;
  float32 SRR_RR_CAN_DET_RANGE_04;
  float32 SRR_RR_CAN_DET_RANGE_RATE_04;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_04;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_04;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_04;
} SG_SRR_RR_Detection_004_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_005_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_05;
  float32 SRR_RR_CAN_DET_AZIMUTH_05;
  Rte_DT_SG_SRR_RR_Detection_005_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_05;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_05;
  float32 SRR_RR_CAN_DET_ELEVATION_05;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_05;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_05;
  boolean SRR_RR_CAN_DET_Near_TARGET_05;
  float32 SRR_RR_CAN_DET_RANGE_05;
  float32 SRR_RR_CAN_DET_RANGE_RATE_05;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_05;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_05;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_05;
} SG_SRR_RR_Detection_005_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_006_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_06;
  float32 SRR_RR_CAN_DET_AZIMUTH_06;
  Rte_DT_SG_SRR_RR_Detection_006_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_06;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_06;
  float32 SRR_RR_CAN_DET_ELEVATION_06;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_06;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_06;
  boolean SRR_RR_CAN_DET_Near_TARGET_06;
  float32 SRR_RR_CAN_DET_RANGE_06;
  float32 SRR_RR_CAN_DET_RANGE_RATE_06;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_06;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_06;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_06;
} SG_SRR_RR_Detection_006_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_007_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_07;
  float32 SRR_RR_CAN_DET_AZIMUTH_07;
  Rte_DT_SG_SRR_RR_Detection_007_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_07;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_07;
  float32 SRR_RR_CAN_DET_ELEVATION_07;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_07;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_07;
  boolean SRR_RR_CAN_DET_Near_TARGET_07;
  float32 SRR_RR_CAN_DET_RANGE_07;
  float32 SRR_RR_CAN_DET_RANGE_RATE_07;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_07;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_07;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_07;
} SG_SRR_RR_Detection_007_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_008_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_08;
  float32 SRR_RR_CAN_DET_AZIMUTH_08;
  Rte_DT_SG_SRR_RR_Detection_008_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_08;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_08;
  float32 SRR_RR_CAN_DET_ELEVATION_08;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_08;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_08;
  boolean SRR_RR_CAN_DET_Near_TARGET_08;
  float32 SRR_RR_CAN_DET_RANGE_08;
  float32 SRR_RR_CAN_DET_RANGE_RATE_08;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_08;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_08;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_08;
} SG_SRR_RR_Detection_008_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_009_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_09;
  float32 SRR_RR_CAN_DET_AZIMUTH_09;
  Rte_DT_SG_SRR_RR_Detection_009_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_09;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_09;
  float32 SRR_RR_CAN_DET_ELEVATION_09;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_09;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_09;
  boolean SRR_RR_CAN_DET_Near_TARGET_09;
  float32 SRR_RR_CAN_DET_RANGE_09;
  float32 SRR_RR_CAN_DET_RANGE_RATE_09;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_09;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_09;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_09;
} SG_SRR_RR_Detection_009_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_010_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_10;
  float32 SRR_RR_CAN_DET_AZIMUTH_10;
  Rte_DT_SG_SRR_RR_Detection_010_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_10;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_10;
  float32 SRR_RR_CAN_DET_ELEVATION_10;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_10;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_10;
  boolean SRR_RR_CAN_DET_Near_TARGET_10;
  float32 SRR_RR_CAN_DET_RANGE_10;
  float32 SRR_RR_CAN_DET_RANGE_RATE_10;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_10;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_10;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_10;
} SG_SRR_RR_Detection_010_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_011_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_11;
  float32 SRR_RR_CAN_DET_AZIMUTH_11;
  Rte_DT_SG_SRR_RR_Detection_011_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_11;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_11;
  float32 SRR_RR_CAN_DET_ELEVATION_11;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_11;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_11;
  boolean SRR_RR_CAN_DET_Near_TARGET_11;
  float32 SRR_RR_CAN_DET_RANGE_11;
  float32 SRR_RR_CAN_DET_RANGE_RATE_11;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_11;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_11;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_11;
} SG_SRR_RR_Detection_011_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_012_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_12;
  float32 SRR_RR_CAN_DET_AZIMUTH_12;
  Rte_DT_SG_SRR_RR_Detection_012_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_12;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_12;
  float32 SRR_RR_CAN_DET_ELEVATION_12;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_12;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_12;
  boolean SRR_RR_CAN_DET_Near_TARGET_12;
  float32 SRR_RR_CAN_DET_RANGE_12;
  float32 SRR_RR_CAN_DET_RANGE_RATE_12;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_12;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_12;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_12;
} SG_SRR_RR_Detection_012_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_013_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_13;
  float32 SRR_RR_CAN_DET_AZIMUTH_13;
  Rte_DT_SG_SRR_RR_Detection_013_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_13;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_13;
  float32 SRR_RR_CAN_DET_ELEVATION_13;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_13;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_13;
  boolean SRR_RR_CAN_DET_Near_TARGET_13;
  float32 SRR_RR_CAN_DET_RANGE_13;
  float32 SRR_RR_CAN_DET_RANGE_RATE_13;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_13;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_13;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_13;
} SG_SRR_RR_Detection_013_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_014_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_14;
  float32 SRR_RR_CAN_DET_AZIMUTH_14;
  Rte_DT_SG_SRR_RR_Detection_014_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_14;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_14;
  float32 SRR_RR_CAN_DET_ELEVATION_14;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_14;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_14;
  boolean SRR_RR_CAN_DET_Near_TARGET_14;
  float32 SRR_RR_CAN_DET_RANGE_14;
  float32 SRR_RR_CAN_DET_RANGE_RATE_14;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_14;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_14;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_14;
} SG_SRR_RR_Detection_014_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_015_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_15;
  float32 SRR_RR_CAN_DET_AZIMUTH_15;
  Rte_DT_SG_SRR_RR_Detection_015_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_15;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_15;
  float32 SRR_RR_CAN_DET_ELEVATION_15;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_15;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_15;
  boolean SRR_RR_CAN_DET_Near_TARGET_15;
  float32 SRR_RR_CAN_DET_RANGE_15;
  float32 SRR_RR_CAN_DET_RANGE_RATE_15;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_15;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_15;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_15;
} SG_SRR_RR_Detection_015_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_016_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_16;
  float32 SRR_RR_CAN_DET_AZIMUTH_16;
  Rte_DT_SG_SRR_RR_Detection_016_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_16;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_16;
  float32 SRR_RR_CAN_DET_ELEVATION_16;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_16;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_16;
  boolean SRR_RR_CAN_DET_Near_TARGET_16;
  float32 SRR_RR_CAN_DET_RANGE_16;
  float32 SRR_RR_CAN_DET_RANGE_RATE_16;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_16;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_16;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_16;
} SG_SRR_RR_Detection_016_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_017_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_17;
  float32 SRR_RR_CAN_DET_AZIMUTH_17;
  Rte_DT_SG_SRR_RR_Detection_017_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_17;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_17;
  float32 SRR_RR_CAN_DET_ELEVATION_17;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_17;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_17;
  boolean SRR_RR_CAN_DET_Near_TARGET_17;
  float32 SRR_RR_CAN_DET_RANGE_17;
  float32 SRR_RR_CAN_DET_RANGE_RATE_17;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_17;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_17;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_17;
} SG_SRR_RR_Detection_017_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_018_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_18;
  float32 SRR_RR_CAN_DET_AZIMUTH_18;
  Rte_DT_SG_SRR_RR_Detection_018_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_18;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_18;
  float32 SRR_RR_CAN_DET_ELEVATION_18;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_18;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_18;
  boolean SRR_RR_CAN_DET_Near_TARGET_18;
  float32 SRR_RR_CAN_DET_RANGE_18;
  float32 SRR_RR_CAN_DET_RANGE_RATE_18;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_18;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_18;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_18;
} SG_SRR_RR_Detection_018_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_019_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_19;
  float32 SRR_RR_CAN_DET_AZIMUTH_19;
  Rte_DT_SG_SRR_RR_Detection_019_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_19;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_19;
  float32 SRR_RR_CAN_DET_ELEVATION_19;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_19;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_19;
  boolean SRR_RR_CAN_DET_Near_TARGET_19;
  float32 SRR_RR_CAN_DET_RANGE_19;
  float32 SRR_RR_CAN_DET_RANGE_RATE_19;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_19;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_19;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_19;
} SG_SRR_RR_Detection_019_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_020_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_20;
  float32 SRR_RR_CAN_DET_AZIMUTH_20;
  Rte_DT_SG_SRR_RR_Detection_020_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_20;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_20;
  float32 SRR_RR_CAN_DET_ELEVATION_20;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_20;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_20;
  boolean SRR_RR_CAN_DET_Near_TARGET_20;
  float32 SRR_RR_CAN_DET_RANGE_20;
  float32 SRR_RR_CAN_DET_RANGE_RATE_20;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_20;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_20;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_20;
} SG_SRR_RR_Detection_020_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_021_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_21;
  float32 SRR_RR_CAN_DET_AZIMUTH_21;
  Rte_DT_SG_SRR_RR_Detection_021_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_21;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_21;
  float32 SRR_RR_CAN_DET_ELEVATION_21;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_21;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_21;
  boolean SRR_RR_CAN_DET_Near_TARGET_21;
  float32 SRR_RR_CAN_DET_RANGE_21;
  float32 SRR_RR_CAN_DET_RANGE_RATE_21;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_21;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_21;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_21;
} SG_SRR_RR_Detection_021_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_022_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_22;
  float32 SRR_RR_CAN_DET_AZIMUTH_22;
  Rte_DT_SG_SRR_RR_Detection_022_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_22;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_22;
  float32 SRR_RR_CAN_DET_ELEVATION_22;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_22;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_22;
  boolean SRR_RR_CAN_DET_Near_TARGET_22;
  float32 SRR_RR_CAN_DET_RANGE_22;
  float32 SRR_RR_CAN_DET_RANGE_RATE_22;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_22;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_22;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_22;
} SG_SRR_RR_Detection_022_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_023_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_23;
  float32 SRR_RR_CAN_DET_AZIMUTH_23;
  Rte_DT_SG_SRR_RR_Detection_023_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_23;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_23;
  float32 SRR_RR_CAN_DET_ELEVATION_23;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_23;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_23;
  boolean SRR_RR_CAN_DET_Near_TARGET_23;
  float32 SRR_RR_CAN_DET_RANGE_23;
  float32 SRR_RR_CAN_DET_RANGE_RATE_23;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_23;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_23;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_23;
} SG_SRR_RR_Detection_023_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_024_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_24;
  float32 SRR_RR_CAN_DET_AZIMUTH_24;
  Rte_DT_SG_SRR_RR_Detection_024_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_24;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_24;
  float32 SRR_RR_CAN_DET_ELEVATION_24;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_24;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_24;
  boolean SRR_RR_CAN_DET_Near_TARGET_24;
  float32 SRR_RR_CAN_DET_RANGE_24;
  float32 SRR_RR_CAN_DET_RANGE_RATE_24;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_24;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_24;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_24;
} SG_SRR_RR_Detection_024_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_025_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_25;
  float32 SRR_RR_CAN_DET_AZIMUTH_25;
  Rte_DT_SG_SRR_RR_Detection_025_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_25;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_25;
  float32 SRR_RR_CAN_DET_ELEVATION_25;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_25;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_25;
  boolean SRR_RR_CAN_DET_Near_TARGET_25;
  float32 SRR_RR_CAN_DET_RANGE_25;
  float32 SRR_RR_CAN_DET_RANGE_RATE_25;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_25;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_25;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_25;
} SG_SRR_RR_Detection_025_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_026_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_26;
  float32 SRR_RR_CAN_DET_AZIMUTH_26;
  Rte_DT_SG_SRR_RR_Detection_026_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_26;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_26;
  float32 SRR_RR_CAN_DET_ELEVATION_26;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_26;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_26;
  boolean SRR_RR_CAN_DET_Near_TARGET_26;
  float32 SRR_RR_CAN_DET_RANGE_26;
  float32 SRR_RR_CAN_DET_RANGE_RATE_26;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_26;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_26;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_26;
} SG_SRR_RR_Detection_026_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_027_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_27;
  float32 SRR_RR_CAN_DET_AZIMUTH_27;
  Rte_DT_SG_SRR_RR_Detection_027_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_27;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_27;
  float32 SRR_RR_CAN_DET_ELEVATION_27;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_27;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_27;
  boolean SRR_RR_CAN_DET_Near_TARGET_27;
  float32 SRR_RR_CAN_DET_RANGE_27;
  float32 SRR_RR_CAN_DET_RANGE_RATE_27;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_27;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_27;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_27;
} SG_SRR_RR_Detection_027_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_028_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_28;
  float32 SRR_RR_CAN_DET_AZIMUTH_28;
  Rte_DT_SG_SRR_RR_Detection_028_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_28;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_28;
  float32 SRR_RR_CAN_DET_ELEVATION_28;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_28;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_28;
  boolean SRR_RR_CAN_DET_Near_TARGET_28;
  float32 SRR_RR_CAN_DET_RANGE_28;
  float32 SRR_RR_CAN_DET_RANGE_RATE_28;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_28;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_28;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_28;
} SG_SRR_RR_Detection_028_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_029_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_29;
  float32 SRR_RR_CAN_DET_AZIMUTH_29;
  Rte_DT_SG_SRR_RR_Detection_029_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_29;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_29;
  float32 SRR_RR_CAN_DET_ELEVATION_29;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_29;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_29;
  boolean SRR_RR_CAN_DET_Near_TARGET_29;
  float32 SRR_RR_CAN_DET_RANGE_29;
  float32 SRR_RR_CAN_DET_RANGE_RATE_29;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_29;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_29;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_29;
} SG_SRR_RR_Detection_029_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_030_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_30;
  float32 SRR_RR_CAN_DET_AZIMUTH_30;
  Rte_DT_SG_SRR_RR_Detection_030_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_30;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_30;
  float32 SRR_RR_CAN_DET_ELEVATION_30;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_30;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_30;
  boolean SRR_RR_CAN_DET_Near_TARGET_30;
  float32 SRR_RR_CAN_DET_RANGE_30;
  float32 SRR_RR_CAN_DET_RANGE_RATE_30;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_30;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_30;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_30;
} SG_SRR_RR_Detection_030_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_031_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_31;
  float32 SRR_RR_CAN_DET_AZIMUTH_31;
  Rte_DT_SG_SRR_RR_Detection_031_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_31;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_31;
  float32 SRR_RR_CAN_DET_ELEVATION_31;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_31;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_31;
  boolean SRR_RR_CAN_DET_Near_TARGET_31;
  float32 SRR_RR_CAN_DET_RANGE_31;
  float32 SRR_RR_CAN_DET_RANGE_RATE_31;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_31;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_31;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_31;
} SG_SRR_RR_Detection_031_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_032_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_32;
  float32 SRR_RR_CAN_DET_AZIMUTH_32;
  Rte_DT_SG_SRR_RR_Detection_032_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_32;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_32;
  float32 SRR_RR_CAN_DET_ELEVATION_32;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_32;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_32;
  boolean SRR_RR_CAN_DET_Near_TARGET_32;
  float32 SRR_RR_CAN_DET_RANGE_32;
  float32 SRR_RR_CAN_DET_RANGE_RATE_32;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_32;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_32;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_32;
} SG_SRR_RR_Detection_032_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_033_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_33;
  float32 SRR_RR_CAN_DET_AZIMUTH_33;
  Rte_DT_SG_SRR_RR_Detection_033_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_33;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_33;
  float32 SRR_RR_CAN_DET_ELEVATION_33;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_33;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_33;
  boolean SRR_RR_CAN_DET_Near_TARGET_33;
  float32 SRR_RR_CAN_DET_RANGE_33;
  float32 SRR_RR_CAN_DET_RANGE_RATE_33;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_33;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_33;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_33;
} SG_SRR_RR_Detection_033_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_034_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_34;
  float32 SRR_RR_CAN_DET_AZIMUTH_34;
  Rte_DT_SG_SRR_RR_Detection_034_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_34;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_34;
  float32 SRR_RR_CAN_DET_ELEVATION_34;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_34;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_34;
  boolean SRR_RR_CAN_DET_Near_TARGET_34;
  float32 SRR_RR_CAN_DET_RANGE_34;
  float32 SRR_RR_CAN_DET_RANGE_RATE_34;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_34;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_34;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_34;
} SG_SRR_RR_Detection_034_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_035_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_35;
  float32 SRR_RR_CAN_DET_AZIMUTH_35;
  Rte_DT_SG_SRR_RR_Detection_035_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_35;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_35;
  float32 SRR_RR_CAN_DET_ELEVATION_35;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_35;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_35;
  boolean SRR_RR_CAN_DET_Near_TARGET_35;
  float32 SRR_RR_CAN_DET_RANGE_35;
  float32 SRR_RR_CAN_DET_RANGE_RATE_35;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_35;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_35;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_35;
} SG_SRR_RR_Detection_035_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_036_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_36;
  float32 SRR_RR_CAN_DET_AZIMUTH_36;
  Rte_DT_SG_SRR_RR_Detection_036_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_36;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_36;
  float32 SRR_RR_CAN_DET_ELEVATION_36;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_36;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_36;
  boolean SRR_RR_CAN_DET_Near_TARGET_36;
  float32 SRR_RR_CAN_DET_RANGE_36;
  float32 SRR_RR_CAN_DET_RANGE_RATE_36;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_36;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_36;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_36;
} SG_SRR_RR_Detection_036_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_037_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_37;
  float32 SRR_RR_CAN_DET_AZIMUTH_37;
  Rte_DT_SG_SRR_RR_Detection_037_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_37;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_37;
  float32 SRR_RR_CAN_DET_ELEVATION_37;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_37;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_37;
  boolean SRR_RR_CAN_DET_Near_TARGET_37;
  float32 SRR_RR_CAN_DET_RANGE_37;
  float32 SRR_RR_CAN_DET_RANGE_RATE_37;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_37;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_37;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_37;
} SG_SRR_RR_Detection_037_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_038_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_38;
  float32 SRR_RR_CAN_DET_AZIMUTH_38;
  Rte_DT_SG_SRR_RR_Detection_038_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_38;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_38;
  float32 SRR_RR_CAN_DET_ELEVATION_38;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_38;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_38;
  boolean SRR_RR_CAN_DET_Near_TARGET_38;
  float32 SRR_RR_CAN_DET_RANGE_38;
  float32 SRR_RR_CAN_DET_RANGE_RATE_38;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_38;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_38;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_38;
} SG_SRR_RR_Detection_038_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_039_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_39;
  float32 SRR_RR_CAN_DET_AZIMUTH_39;
  Rte_DT_SG_SRR_RR_Detection_039_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_39;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_39;
  float32 SRR_RR_CAN_DET_ELEVATION_39;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_39;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_39;
  boolean SRR_RR_CAN_DET_Near_TARGET_39;
  float32 SRR_RR_CAN_DET_RANGE_39;
  float32 SRR_RR_CAN_DET_RANGE_RATE_39;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_39;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_39;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_39;
} SG_SRR_RR_Detection_039_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_040_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_40;
  float32 SRR_RR_CAN_DET_AZIMUTH_40;
  Rte_DT_SG_SRR_RR_Detection_040_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_40;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_40;
  float32 SRR_RR_CAN_DET_ELEVATION_40;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_40;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_40;
  boolean SRR_RR_CAN_DET_Near_TARGET_40;
  float32 SRR_RR_CAN_DET_RANGE_40;
  float32 SRR_RR_CAN_DET_RANGE_RATE_40;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_40;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_40;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_40;
} SG_SRR_RR_Detection_040_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_041_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_41;
  float32 SRR_RR_CAN_DET_AZIMUTH_41;
  Rte_DT_SG_SRR_RR_Detection_041_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_41;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_41;
  float32 SRR_RR_CAN_DET_ELEVATION_41;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_41;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_41;
  boolean SRR_RR_CAN_DET_Near_TARGET_41;
  float32 SRR_RR_CAN_DET_RANGE_41;
  float32 SRR_RR_CAN_DET_RANGE_RATE_41;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_41;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_41;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_41;
} SG_SRR_RR_Detection_041_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_042_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_42;
  float32 SRR_RR_CAN_DET_AZIMUTH_42;
  Rte_DT_SG_SRR_RR_Detection_042_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_42;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_42;
  float32 SRR_RR_CAN_DET_ELEVATION_42;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_42;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_42;
  boolean SRR_RR_CAN_DET_Near_TARGET_42;
  float32 SRR_RR_CAN_DET_RANGE_42;
  float32 SRR_RR_CAN_DET_RANGE_RATE_42;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_42;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_42;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_42;
} SG_SRR_RR_Detection_042_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_043_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_43;
  float32 SRR_RR_CAN_DET_AZIMUTH_43;
  Rte_DT_SG_SRR_RR_Detection_043_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_43;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_43;
  float32 SRR_RR_CAN_DET_ELEVATION_43;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_43;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_43;
  boolean SRR_RR_CAN_DET_Near_TARGET_43;
  float32 SRR_RR_CAN_DET_RANGE_43;
  float32 SRR_RR_CAN_DET_RANGE_RATE_43;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_43;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_43;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_43;
} SG_SRR_RR_Detection_043_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_044_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_44;
  float32 SRR_RR_CAN_DET_AZIMUTH_44;
  Rte_DT_SG_SRR_RR_Detection_044_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_44;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_44;
  float32 SRR_RR_CAN_DET_ELEVATION_44;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_44;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_44;
  boolean SRR_RR_CAN_DET_Near_TARGET_44;
  float32 SRR_RR_CAN_DET_RANGE_44;
  float32 SRR_RR_CAN_DET_RANGE_RATE_44;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_44;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_44;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_44;
} SG_SRR_RR_Detection_044_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_045_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_45;
  float32 SRR_RR_CAN_DET_AZIMUTH_45;
  Rte_DT_SG_SRR_RR_Detection_045_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_45;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_45;
  float32 SRR_RR_CAN_DET_ELEVATION_45;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_45;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_45;
  boolean SRR_RR_CAN_DET_Near_TARGET_45;
  float32 SRR_RR_CAN_DET_RANGE_45;
  float32 SRR_RR_CAN_DET_RANGE_RATE_45;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_45;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_45;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_45;
} SG_SRR_RR_Detection_045_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_046_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_46;
  float32 SRR_RR_CAN_DET_AZIMUTH_46;
  Rte_DT_SG_SRR_RR_Detection_046_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_46;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_46;
  float32 SRR_RR_CAN_DET_ELEVATION_46;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_46;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_46;
  boolean SRR_RR_CAN_DET_Near_TARGET_46;
  float32 SRR_RR_CAN_DET_RANGE_46;
  float32 SRR_RR_CAN_DET_RANGE_RATE_46;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_46;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_46;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_46;
} SG_SRR_RR_Detection_046_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_047_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_47;
  float32 SRR_RR_CAN_DET_AZIMUTH_47;
  Rte_DT_SG_SRR_RR_Detection_047_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_47;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_47;
  float32 SRR_RR_CAN_DET_ELEVATION_47;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_47;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_47;
  boolean SRR_RR_CAN_DET_Near_TARGET_47;
  float32 SRR_RR_CAN_DET_RANGE_47;
  float32 SRR_RR_CAN_DET_RANGE_RATE_47;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_47;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_47;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_47;
} SG_SRR_RR_Detection_047_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_048_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_48;
  float32 SRR_RR_CAN_DET_AZIMUTH_48;
  Rte_DT_SG_SRR_RR_Detection_048_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_48;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_48;
  float32 SRR_RR_CAN_DET_ELEVATION_48;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_48;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_48;
  boolean SRR_RR_CAN_DET_Near_TARGET_48;
  float32 SRR_RR_CAN_DET_RANGE_48;
  float32 SRR_RR_CAN_DET_RANGE_RATE_48;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_48;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_48;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_48;
} SG_SRR_RR_Detection_048_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_049_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_49;
  float32 SRR_RR_CAN_DET_AZIMUTH_49;
  Rte_DT_SG_SRR_RR_Detection_049_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_49;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_49;
  float32 SRR_RR_CAN_DET_ELEVATION_49;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_49;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_49;
  boolean SRR_RR_CAN_DET_Near_TARGET_49;
  float32 SRR_RR_CAN_DET_RANGE_49;
  float32 SRR_RR_CAN_DET_RANGE_RATE_49;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_49;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_49;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_49;
} SG_SRR_RR_Detection_049_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_050_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_50;
  float32 SRR_RR_CAN_DET_AZIMUTH_50;
  Rte_DT_SG_SRR_RR_Detection_050_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_50;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_50;
  float32 SRR_RR_CAN_DET_ELEVATION_50;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_50;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_50;
  boolean SRR_RR_CAN_DET_Near_TARGET_50;
  float32 SRR_RR_CAN_DET_RANGE_50;
  float32 SRR_RR_CAN_DET_RANGE_RATE_50;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_50;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_50;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_50;
} SG_SRR_RR_Detection_050_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_051_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_51;
  float32 SRR_RR_CAN_DET_AZIMUTH_51;
  Rte_DT_SG_SRR_RR_Detection_051_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_51;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_51;
  float32 SRR_RR_CAN_DET_ELEVATION_51;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_51;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_51;
  boolean SRR_RR_CAN_DET_Near_TARGET_51;
  float32 SRR_RR_CAN_DET_RANGE_51;
  float32 SRR_RR_CAN_DET_RANGE_RATE_51;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_51;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_51;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_51;
} SG_SRR_RR_Detection_051_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_052_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_52;
  float32 SRR_RR_CAN_DET_AZIMUTH_52;
  Rte_DT_SG_SRR_RR_Detection_052_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_52;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_52;
  float32 SRR_RR_CAN_DET_ELEVATION_52;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_52;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_52;
  boolean SRR_RR_CAN_DET_Near_TARGET_52;
  float32 SRR_RR_CAN_DET_RANGE_52;
  float32 SRR_RR_CAN_DET_RANGE_RATE_52;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_52;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_52;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_52;
} SG_SRR_RR_Detection_052_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_053_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_53;
  float32 SRR_RR_CAN_DET_AZIMUTH_53;
  Rte_DT_SG_SRR_RR_Detection_053_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_53;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_53;
  float32 SRR_RR_CAN_DET_ELEVATION_53;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_53;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_53;
  boolean SRR_RR_CAN_DET_Near_TARGET_53;
  float32 SRR_RR_CAN_DET_RANGE_53;
  float32 SRR_RR_CAN_DET_RANGE_RATE_53;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_53;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_53;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_53;
} SG_SRR_RR_Detection_053_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_054_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_54;
  float32 SRR_RR_CAN_DET_AZIMUTH_54;
  Rte_DT_SG_SRR_RR_Detection_054_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_54;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_54;
  float32 SRR_RR_CAN_DET_ELEVATION_54;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_54;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_54;
  boolean SRR_RR_CAN_DET_Near_TARGET_54;
  float32 SRR_RR_CAN_DET_RANGE_54;
  float32 SRR_RR_CAN_DET_RANGE_RATE_54;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_54;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_54;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_54;
} SG_SRR_RR_Detection_054_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_055_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_55;
  float32 SRR_RR_CAN_DET_AZIMUTH_55;
  Rte_DT_SG_SRR_RR_Detection_055_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_55;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_55;
  float32 SRR_RR_CAN_DET_ELEVATION_55;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_55;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_55;
  boolean SRR_RR_CAN_DET_Near_TARGET_55;
  float32 SRR_RR_CAN_DET_RANGE_55;
  float32 SRR_RR_CAN_DET_RANGE_RATE_55;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_55;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_55;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_55;
} SG_SRR_RR_Detection_055_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_056_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_56;
  float32 SRR_RR_CAN_DET_AZIMUTH_56;
  Rte_DT_SG_SRR_RR_Detection_056_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_56;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_56;
  float32 SRR_RR_CAN_DET_ELEVATION_56;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_56;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_56;
  boolean SRR_RR_CAN_DET_Near_TARGET_56;
  float32 SRR_RR_CAN_DET_RANGE_56;
  float32 SRR_RR_CAN_DET_RANGE_RATE_56;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_56;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_56;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_56;
} SG_SRR_RR_Detection_056_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_057_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_57;
  float32 SRR_RR_CAN_DET_AZIMUTH_57;
  Rte_DT_SG_SRR_RR_Detection_057_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_57;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_57;
  float32 SRR_RR_CAN_DET_ELEVATION_57;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_57;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_57;
  boolean SRR_RR_CAN_DET_Near_TARGET_57;
  float32 SRR_RR_CAN_DET_RANGE_57;
  float32 SRR_RR_CAN_DET_RANGE_RATE_57;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_57;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_57;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_57;
} SG_SRR_RR_Detection_057_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_058_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_58;
  float32 SRR_RR_CAN_DET_AZIMUTH_58;
  Rte_DT_SG_SRR_RR_Detection_058_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_58;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_58;
  float32 SRR_RR_CAN_DET_ELEVATION_58;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_58;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_58;
  boolean SRR_RR_CAN_DET_Near_TARGET_58;
  float32 SRR_RR_CAN_DET_RANGE_58;
  float32 SRR_RR_CAN_DET_RANGE_RATE_58;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_58;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_58;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_58;
} SG_SRR_RR_Detection_058_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_059_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_59;
  float32 SRR_RR_CAN_DET_AZIMUTH_59;
  Rte_DT_SG_SRR_RR_Detection_059_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_59;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_59;
  float32 SRR_RR_CAN_DET_ELEVATION_59;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_59;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_59;
  boolean SRR_RR_CAN_DET_Near_TARGET_59;
  float32 SRR_RR_CAN_DET_RANGE_59;
  float32 SRR_RR_CAN_DET_RANGE_RATE_59;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_59;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_59;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_59;
} SG_SRR_RR_Detection_059_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_060_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_60;
  float32 SRR_RR_CAN_DET_AZIMUTH_60;
  Rte_DT_SG_SRR_RR_Detection_060_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_60;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_60;
  float32 SRR_RR_CAN_DET_ELEVATION_60;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_60;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_60;
  boolean SRR_RR_CAN_DET_Near_TARGET_60;
  float32 SRR_RR_CAN_DET_RANGE_60;
  float32 SRR_RR_CAN_DET_RANGE_RATE_60;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_60;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_60;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_60;
} SG_SRR_RR_Detection_060_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_061_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_61;
  float32 SRR_RR_CAN_DET_AZIMUTH_61;
  Rte_DT_SG_SRR_RR_Detection_061_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_61;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_61;
  float32 SRR_RR_CAN_DET_ELEVATION_61;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_61;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_61;
  boolean SRR_RR_CAN_DET_Near_TARGET_61;
  float32 SRR_RR_CAN_DET_RANGE_61;
  float32 SRR_RR_CAN_DET_RANGE_RATE_61;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_61;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_61;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_61;
} SG_SRR_RR_Detection_061_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_062_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_62;
  float32 SRR_RR_CAN_DET_AZIMUTH_62;
  Rte_DT_SG_SRR_RR_Detection_062_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_62;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_62;
  float32 SRR_RR_CAN_DET_ELEVATION_62;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_62;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_62;
  boolean SRR_RR_CAN_DET_Near_TARGET_62;
  float32 SRR_RR_CAN_DET_RANGE_62;
  float32 SRR_RR_CAN_DET_RANGE_RATE_62;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_62;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_62;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_62;
} SG_SRR_RR_Detection_062_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_063_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_63;
  float32 SRR_RR_CAN_DET_AZIMUTH_63;
  Rte_DT_SG_SRR_RR_Detection_063_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_63;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_63;
  float32 SRR_RR_CAN_DET_ELEVATION_63;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_63;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_63;
  boolean SRR_RR_CAN_DET_Near_TARGET_63;
  float32 SRR_RR_CAN_DET_RANGE_63;
  float32 SRR_RR_CAN_DET_RANGE_RATE_63;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_63;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_63;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_63;
} SG_SRR_RR_Detection_063_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_064_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_64;
  float32 SRR_RR_CAN_DET_AZIMUTH_64;
  Rte_DT_SG_SRR_RR_Detection_064_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_64;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_64;
  float32 SRR_RR_CAN_DET_ELEVATION_64;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_64;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_64;
  boolean SRR_RR_CAN_DET_Near_TARGET_64;
  float32 SRR_RR_CAN_DET_RANGE_64;
  float32 SRR_RR_CAN_DET_RANGE_RATE_64;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_64;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_64;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_64;
} SG_SRR_RR_Detection_064_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_065_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_65;
  float32 SRR_RR_CAN_DET_AZIMUTH_65;
  Rte_DT_SG_SRR_RR_Detection_065_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_65;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_65;
  float32 SRR_RR_CAN_DET_ELEVATION_65;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_65;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_65;
  boolean SRR_RR_CAN_DET_Near_TARGET_65;
  float32 SRR_RR_CAN_DET_RANGE_65;
  float32 SRR_RR_CAN_DET_RANGE_RATE_65;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_65;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_65;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_65;
} SG_SRR_RR_Detection_065_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_066_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_66;
  float32 SRR_RR_CAN_DET_AZIMUTH_66;
  Rte_DT_SG_SRR_RR_Detection_066_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_66;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_66;
  float32 SRR_RR_CAN_DET_ELEVATION_66;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_66;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_66;
  boolean SRR_RR_CAN_DET_Near_TARGET_66;
  float32 SRR_RR_CAN_DET_RANGE_66;
  float32 SRR_RR_CAN_DET_RANGE_RATE_66;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_66;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_66;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_66;
} SG_SRR_RR_Detection_066_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_067_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_67;
  float32 SRR_RR_CAN_DET_AZIMUTH_67;
  Rte_DT_SG_SRR_RR_Detection_067_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_67;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_67;
  float32 SRR_RR_CAN_DET_ELEVATION_67;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_67;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_67;
  boolean SRR_RR_CAN_DET_Near_TARGET_67;
  float32 SRR_RR_CAN_DET_RANGE_67;
  float32 SRR_RR_CAN_DET_RANGE_RATE_67;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_67;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_67;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_67;
} SG_SRR_RR_Detection_067_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_068_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_68;
  float32 SRR_RR_CAN_DET_AZIMUTH_68;
  Rte_DT_SG_SRR_RR_Detection_068_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_68;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_68;
  float32 SRR_RR_CAN_DET_ELEVATION_68;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_68;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_68;
  boolean SRR_RR_CAN_DET_Near_TARGET_68;
  float32 SRR_RR_CAN_DET_RANGE_68;
  float32 SRR_RR_CAN_DET_RANGE_RATE_68;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_68;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_68;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_68;
} SG_SRR_RR_Detection_068_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_069_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_69;
  float32 SRR_RR_CAN_DET_AZIMUTH_69;
  Rte_DT_SG_SRR_RR_Detection_069_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_69;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_69;
  float32 SRR_RR_CAN_DET_ELEVATION_69;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_69;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_69;
  boolean SRR_RR_CAN_DET_Near_TARGET_69;
  float32 SRR_RR_CAN_DET_RANGE_69;
  float32 SRR_RR_CAN_DET_RANGE_RATE_69;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_69;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_69;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_69;
} SG_SRR_RR_Detection_069_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_070_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_70;
  float32 SRR_RR_CAN_DET_AZIMUTH_70;
  Rte_DT_SG_SRR_RR_Detection_070_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_70;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_70;
  float32 SRR_RR_CAN_DET_ELEVATION_70;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_70;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_70;
  boolean SRR_RR_CAN_DET_Near_TARGET_70;
  float32 SRR_RR_CAN_DET_RANGE_70;
  float32 SRR_RR_CAN_DET_RANGE_RATE_70;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_70;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_70;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_70;
} SG_SRR_RR_Detection_070_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_071_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_71;
  float32 SRR_RR_CAN_DET_AZIMUTH_71;
  Rte_DT_SG_SRR_RR_Detection_071_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_71;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_71;
  float32 SRR_RR_CAN_DET_ELEVATION_71;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_71;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_71;
  boolean SRR_RR_CAN_DET_Near_TARGET_71;
  float32 SRR_RR_CAN_DET_RANGE_71;
  float32 SRR_RR_CAN_DET_RANGE_RATE_71;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_71;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_71;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_71;
} SG_SRR_RR_Detection_071_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_072_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_72;
  float32 SRR_RR_CAN_DET_AZIMUTH_72;
  Rte_DT_SG_SRR_RR_Detection_072_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_72;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_72;
  float32 SRR_RR_CAN_DET_ELEVATION_72;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_72;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_72;
  boolean SRR_RR_CAN_DET_Near_TARGET_72;
  float32 SRR_RR_CAN_DET_RANGE_72;
  float32 SRR_RR_CAN_DET_RANGE_RATE_72;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_72;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_72;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_72;
} SG_SRR_RR_Detection_072_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_073_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_73;
  float32 SRR_RR_CAN_DET_AZIMUTH_73;
  Rte_DT_SG_SRR_RR_Detection_073_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_73;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_73;
  float32 SRR_RR_CAN_DET_ELEVATION_73;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_73;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_73;
  boolean SRR_RR_CAN_DET_Near_TARGET_73;
  float32 SRR_RR_CAN_DET_RANGE_73;
  float32 SRR_RR_CAN_DET_RANGE_RATE_73;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_73;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_73;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_73;
} SG_SRR_RR_Detection_073_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_074_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_74;
  float32 SRR_RR_CAN_DET_AZIMUTH_74;
  Rte_DT_SG_SRR_RR_Detection_074_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_74;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_74;
  float32 SRR_RR_CAN_DET_ELEVATION_74;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_74;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_74;
  boolean SRR_RR_CAN_DET_Near_TARGET_74;
  float32 SRR_RR_CAN_DET_RANGE_74;
  float32 SRR_RR_CAN_DET_RANGE_RATE_74;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_74;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_74;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_74;
} SG_SRR_RR_Detection_074_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_075_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_75;
  float32 SRR_RR_CAN_DET_AZIMUTH_75;
  Rte_DT_SG_SRR_RR_Detection_075_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_75;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_75;
  float32 SRR_RR_CAN_DET_ELEVATION_75;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_75;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_75;
  boolean SRR_RR_CAN_DET_Near_TARGET_75;
  float32 SRR_RR_CAN_DET_RANGE_75;
  float32 SRR_RR_CAN_DET_RANGE_RATE_75;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_75;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_75;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_75;
} SG_SRR_RR_Detection_075_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_076_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_76;
  float32 SRR_RR_CAN_DET_AZIMUTH_76;
  Rte_DT_SG_SRR_RR_Detection_076_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_76;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_76;
  float32 SRR_RR_CAN_DET_ELEVATION_76;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_76;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_76;
  boolean SRR_RR_CAN_DET_Near_TARGET_76;
  float32 SRR_RR_CAN_DET_RANGE_76;
  float32 SRR_RR_CAN_DET_RANGE_RATE_76;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_76;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_76;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_76;
} SG_SRR_RR_Detection_076_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_077_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_77;
  float32 SRR_RR_CAN_DET_AZIMUTH_77;
  Rte_DT_SG_SRR_RR_Detection_077_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_77;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_77;
  float32 SRR_RR_CAN_DET_ELEVATION_77;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_77;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_77;
  boolean SRR_RR_CAN_DET_Near_TARGET_77;
  float32 SRR_RR_CAN_DET_RANGE_77;
  float32 SRR_RR_CAN_DET_RANGE_RATE_77;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_77;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_77;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_77;
} SG_SRR_RR_Detection_077_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_078_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_78;
  float32 SRR_RR_CAN_DET_AZIMUTH_78;
  Rte_DT_SG_SRR_RR_Detection_078_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_78;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_78;
  float32 SRR_RR_CAN_DET_ELEVATION_78;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_78;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_78;
  boolean SRR_RR_CAN_DET_Near_TARGET_78;
  float32 SRR_RR_CAN_DET_RANGE_78;
  float32 SRR_RR_CAN_DET_RANGE_RATE_78;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_78;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_78;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_78;
} SG_SRR_RR_Detection_078_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_079_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_79;
  float32 SRR_RR_CAN_DET_AZIMUTH_79;
  Rte_DT_SG_SRR_RR_Detection_079_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_79;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_79;
  float32 SRR_RR_CAN_DET_ELEVATION_79;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_79;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_79;
  boolean SRR_RR_CAN_DET_Near_TARGET_79;
  float32 SRR_RR_CAN_DET_RANGE_79;
  float32 SRR_RR_CAN_DET_RANGE_RATE_79;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_79;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_79;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_79;
} SG_SRR_RR_Detection_079_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_080_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_80;
  float32 SRR_RR_CAN_DET_AZIMUTH_80;
  Rte_DT_SG_SRR_RR_Detection_080_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_80;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_80;
  float32 SRR_RR_CAN_DET_ELEVATION_80;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_80;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_80;
  boolean SRR_RR_CAN_DET_Near_TARGET_80;
  float32 SRR_RR_CAN_DET_RANGE_80;
  float32 SRR_RR_CAN_DET_RANGE_RATE_80;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_80;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_80;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_80;
} SG_SRR_RR_Detection_080_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_081_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_81;
  float32 SRR_RR_CAN_DET_AZIMUTH_81;
  Rte_DT_SG_SRR_RR_Detection_081_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_81;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_81;
  float32 SRR_RR_CAN_DET_ELEVATION_81;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_81;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_81;
  boolean SRR_RR_CAN_DET_Near_TARGET_81;
  float32 SRR_RR_CAN_DET_RANGE_81;
  float32 SRR_RR_CAN_DET_RANGE_RATE_81;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_81;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_81;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_81;
} SG_SRR_RR_Detection_081_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_082_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_82;
  float32 SRR_RR_CAN_DET_AZIMUTH_82;
  Rte_DT_SG_SRR_RR_Detection_082_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_82;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_82;
  float32 SRR_RR_CAN_DET_ELEVATION_82;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_82;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_82;
  boolean SRR_RR_CAN_DET_Near_TARGET_82;
  float32 SRR_RR_CAN_DET_RANGE_82;
  float32 SRR_RR_CAN_DET_RANGE_RATE_82;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_82;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_82;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_82;
} SG_SRR_RR_Detection_082_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_083_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_83;
  float32 SRR_RR_CAN_DET_AZIMUTH_83;
  Rte_DT_SG_SRR_RR_Detection_083_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_83;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_83;
  float32 SRR_RR_CAN_DET_ELEVATION_83;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_83;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_83;
  boolean SRR_RR_CAN_DET_Near_TARGET_83;
  float32 SRR_RR_CAN_DET_RANGE_83;
  float32 SRR_RR_CAN_DET_RANGE_RATE_83;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_83;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_83;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_83;
} SG_SRR_RR_Detection_083_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_084_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_84;
  float32 SRR_RR_CAN_DET_AZIMUTH_84;
  Rte_DT_SG_SRR_RR_Detection_084_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_84;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_84;
  float32 SRR_RR_CAN_DET_ELEVATION_84;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_84;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_84;
  boolean SRR_RR_CAN_DET_Near_TARGET_84;
  float32 SRR_RR_CAN_DET_RANGE_84;
  float32 SRR_RR_CAN_DET_RANGE_RATE_84;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_84;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_84;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_84;
} SG_SRR_RR_Detection_084_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_085_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_85;
  float32 SRR_RR_CAN_DET_AZIMUTH_85;
  Rte_DT_SG_SRR_RR_Detection_085_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_85;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_85;
  float32 SRR_RR_CAN_DET_ELEVATION_85;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_85;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_85;
  boolean SRR_RR_CAN_DET_Near_TARGET_85;
  float32 SRR_RR_CAN_DET_RANGE_85;
  float32 SRR_RR_CAN_DET_RANGE_RATE_85;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_85;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_85;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_85;
} SG_SRR_RR_Detection_085_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_086_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_86;
  float32 SRR_RR_CAN_DET_AZIMUTH_86;
  Rte_DT_SG_SRR_RR_Detection_086_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_86;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_86;
  float32 SRR_RR_CAN_DET_ELEVATION_86;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_86;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_86;
  boolean SRR_RR_CAN_DET_Near_TARGET_86;
  float32 SRR_RR_CAN_DET_RANGE_86;
  float32 SRR_RR_CAN_DET_RANGE_RATE_86;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_86;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_86;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_86;
} SG_SRR_RR_Detection_086_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_087_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_87;
  float32 SRR_RR_CAN_DET_AZIMUTH_87;
  Rte_DT_SG_SRR_RR_Detection_087_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_87;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_87;
  float32 SRR_RR_CAN_DET_ELEVATION_87;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_87;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_87;
  boolean SRR_RR_CAN_DET_Near_TARGET_87;
  float32 SRR_RR_CAN_DET_RANGE_87;
  float32 SRR_RR_CAN_DET_RANGE_RATE_87;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_87;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_87;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_87;
} SG_SRR_RR_Detection_087_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_088_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_88;
  float32 SRR_RR_CAN_DET_AZIMUTH_88;
  Rte_DT_SG_SRR_RR_Detection_088_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_88;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_88;
  float32 SRR_RR_CAN_DET_ELEVATION_88;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_88;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_88;
  boolean SRR_RR_CAN_DET_Near_TARGET_88;
  float32 SRR_RR_CAN_DET_RANGE_88;
  float32 SRR_RR_CAN_DET_RANGE_RATE_88;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_88;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_88;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_88;
} SG_SRR_RR_Detection_088_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_089_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_89;
  float32 SRR_RR_CAN_DET_AZIMUTH_89;
  Rte_DT_SG_SRR_RR_Detection_089_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_89;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_89;
  float32 SRR_RR_CAN_DET_ELEVATION_89;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_89;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_89;
  boolean SRR_RR_CAN_DET_Near_TARGET_89;
  float32 SRR_RR_CAN_DET_RANGE_89;
  float32 SRR_RR_CAN_DET_RANGE_RATE_89;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_89;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_89;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_89;
} SG_SRR_RR_Detection_089_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_090_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_90;
  float32 SRR_RR_CAN_DET_AZIMUTH_90;
  Rte_DT_SG_SRR_RR_Detection_090_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_90;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_90;
  float32 SRR_RR_CAN_DET_ELEVATION_90;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_90;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_90;
  boolean SRR_RR_CAN_DET_Near_TARGET_90;
  float32 SRR_RR_CAN_DET_RANGE_90;
  float32 SRR_RR_CAN_DET_RANGE_RATE_90;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_90;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_90;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_90;
} SG_SRR_RR_Detection_090_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_091_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_91;
  float32 SRR_RR_CAN_DET_AZIMUTH_91;
  Rte_DT_SG_SRR_RR_Detection_091_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_91;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_91;
  float32 SRR_RR_CAN_DET_ELEVATION_91;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_91;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_91;
  boolean SRR_RR_CAN_DET_Near_TARGET_91;
  float32 SRR_RR_CAN_DET_RANGE_91;
  float32 SRR_RR_CAN_DET_RANGE_RATE_91;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_91;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_91;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_91;
} SG_SRR_RR_Detection_091_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_092_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_92;
  float32 SRR_RR_CAN_DET_AZIMUTH_92;
  Rte_DT_SG_SRR_RR_Detection_092_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_92;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_92;
  float32 SRR_RR_CAN_DET_ELEVATION_92;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_92;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_92;
  boolean SRR_RR_CAN_DET_Near_TARGET_92;
  float32 SRR_RR_CAN_DET_RANGE_92;
  float32 SRR_RR_CAN_DET_RANGE_RATE_92;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_92;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_92;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_92;
} SG_SRR_RR_Detection_092_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_093_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_93;
  float32 SRR_RR_CAN_DET_AZIMUTH_93;
  Rte_DT_SG_SRR_RR_Detection_093_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_93;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_93;
  float32 SRR_RR_CAN_DET_ELEVATION_93;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_93;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_93;
  boolean SRR_RR_CAN_DET_Near_TARGET_93;
  float32 SRR_RR_CAN_DET_RANGE_93;
  float32 SRR_RR_CAN_DET_RANGE_RATE_93;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_93;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_93;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_93;
} SG_SRR_RR_Detection_093_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_094_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_94;
  float32 SRR_RR_CAN_DET_AZIMUTH_94;
  Rte_DT_SG_SRR_RR_Detection_094_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_94;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_94;
  float32 SRR_RR_CAN_DET_ELEVATION_94;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_94;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_94;
  boolean SRR_RR_CAN_DET_Near_TARGET_94;
  float32 SRR_RR_CAN_DET_RANGE_94;
  float32 SRR_RR_CAN_DET_RANGE_RATE_94;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_94;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_94;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_94;
} SG_SRR_RR_Detection_094_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_095_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_95;
  float32 SRR_RR_CAN_DET_AZIMUTH_95;
  Rte_DT_SG_SRR_RR_Detection_095_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_95;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_95;
  float32 SRR_RR_CAN_DET_ELEVATION_95;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_95;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_95;
  boolean SRR_RR_CAN_DET_Near_TARGET_95;
  float32 SRR_RR_CAN_DET_RANGE_95;
  float32 SRR_RR_CAN_DET_RANGE_RATE_95;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_95;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_95;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_95;
} SG_SRR_RR_Detection_095_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_096_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_96;
  float32 SRR_RR_CAN_DET_AZIMUTH_96;
  Rte_DT_SG_SRR_RR_Detection_096_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_96;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_96;
  float32 SRR_RR_CAN_DET_ELEVATION_96;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_96;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_96;
  boolean SRR_RR_CAN_DET_Near_TARGET_96;
  float32 SRR_RR_CAN_DET_RANGE_96;
  float32 SRR_RR_CAN_DET_RANGE_RATE_96;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_96;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_96;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_96;
} SG_SRR_RR_Detection_096_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_097_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_97;
  float32 SRR_RR_CAN_DET_AZIMUTH_97;
  Rte_DT_SG_SRR_RR_Detection_097_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_97;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_97;
  float32 SRR_RR_CAN_DET_ELEVATION_97;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_97;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_97;
  boolean SRR_RR_CAN_DET_Near_TARGET_97;
  float32 SRR_RR_CAN_DET_RANGE_97;
  float32 SRR_RR_CAN_DET_RANGE_RATE_97;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_97;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_97;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_97;
} SG_SRR_RR_Detection_097_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_098_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_98;
  float32 SRR_RR_CAN_DET_AZIMUTH_98;
  Rte_DT_SG_SRR_RR_Detection_098_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_98;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_98;
  float32 SRR_RR_CAN_DET_ELEVATION_98;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_98;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_98;
  boolean SRR_RR_CAN_DET_Near_TARGET_98;
  float32 SRR_RR_CAN_DET_RANGE_98;
  float32 SRR_RR_CAN_DET_RANGE_RATE_98;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_98;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_98;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_98;
} SG_SRR_RR_Detection_098_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_099_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_99;
  float32 SRR_RR_CAN_DET_AZIMUTH_99;
  Rte_DT_SG_SRR_RR_Detection_099_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_99;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_99;
  float32 SRR_RR_CAN_DET_ELEVATION_99;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_99;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_99;
  boolean SRR_RR_CAN_DET_Near_TARGET_99;
  float32 SRR_RR_CAN_DET_RANGE_99;
  float32 SRR_RR_CAN_DET_RANGE_RATE_99;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_99;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_99;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_99;
} SG_SRR_RR_Detection_099_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_100_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_100;
  float32 SRR_RR_CAN_DET_AZIMUTH_100;
  Rte_DT_SG_SRR_RR_Detection_100_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_100;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_100;
  float32 SRR_RR_CAN_DET_ELEVATION_100;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_100;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_100;
  boolean SRR_RR_CAN_DET_Near_TARGET_100;
  float32 SRR_RR_CAN_DET_RANGE_100;
  float32 SRR_RR_CAN_DET_RANGE_RATE_100;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_100;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_100;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_100;
} SG_SRR_RR_Detection_100_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_101_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_101;
  float32 SRR_RR_CAN_DET_AZIMUTH_101;
  Rte_DT_SG_SRR_RR_Detection_101_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_101;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_101;
  float32 SRR_RR_CAN_DET_ELEVATION_101;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_101;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_101;
  boolean SRR_RR_CAN_DET_Near_TARGET_101;
  float32 SRR_RR_CAN_DET_RANGE_101;
  float32 SRR_RR_CAN_DET_RANGE_RATE_101;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_101;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_101;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_101;
} SG_SRR_RR_Detection_101_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_102_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_102;
  float32 SRR_RR_CAN_DET_AZIMUTH_102;
  Rte_DT_SG_SRR_RR_Detection_102_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_102;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_102;
  float32 SRR_RR_CAN_DET_ELEVATION_102;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_102;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_102;
  boolean SRR_RR_CAN_DET_Near_TARGET_102;
  float32 SRR_RR_CAN_DET_RANGE_102;
  float32 SRR_RR_CAN_DET_RANGE_RATE_102;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_102;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_102;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_102;
} SG_SRR_RR_Detection_102_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_103_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_103;
  float32 SRR_RR_CAN_DET_AZIMUTH_103;
  Rte_DT_SG_SRR_RR_Detection_103_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_103;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_103;
  float32 SRR_RR_CAN_DET_ELEVATION_103;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_103;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_103;
  boolean SRR_RR_CAN_DET_Near_TARGET_103;
  float32 SRR_RR_CAN_DET_RANGE_103;
  float32 SRR_RR_CAN_DET_RANGE_RATE_103;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_103;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_103;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_103;
} SG_SRR_RR_Detection_103_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_104_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_104;
  float32 SRR_RR_CAN_DET_AZIMUTH_104;
  Rte_DT_SG_SRR_RR_Detection_104_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_104;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_104;
  float32 SRR_RR_CAN_DET_ELEVATION_104;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_104;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_104;
  boolean SRR_RR_CAN_DET_Near_TARGET_104;
  float32 SRR_RR_CAN_DET_RANGE_104;
  float32 SRR_RR_CAN_DET_RANGE_RATE_104;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_104;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_104;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_104;
} SG_SRR_RR_Detection_104_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_105_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_105;
  float32 SRR_RR_CAN_DET_AZIMUTH_105;
  Rte_DT_SG_SRR_RR_Detection_105_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_105;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_105;
  float32 SRR_RR_CAN_DET_ELEVATION_105;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_105;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_105;
  boolean SRR_RR_CAN_DET_Near_TARGET_105;
  float32 SRR_RR_CAN_DET_RANGE_105;
  float32 SRR_RR_CAN_DET_RANGE_RATE_105;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_105;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_105;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_105;
} SG_SRR_RR_Detection_105_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_106_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_106;
  float32 SRR_RR_CAN_DET_AZIMUTH_106;
  Rte_DT_SG_SRR_RR_Detection_106_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_106;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_106;
  float32 SRR_RR_CAN_DET_ELEVATION_106;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_106;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_106;
  boolean SRR_RR_CAN_DET_Near_TARGET_106;
  float32 SRR_RR_CAN_DET_RANGE_106;
  float32 SRR_RR_CAN_DET_RANGE_RATE_106;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_106;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_106;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_106;
} SG_SRR_RR_Detection_106_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_107_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_107;
  float32 SRR_RR_CAN_DET_AZIMUTH_107;
  Rte_DT_SG_SRR_RR_Detection_107_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_107;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_107;
  float32 SRR_RR_CAN_DET_ELEVATION_107;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_107;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_107;
  boolean SRR_RR_CAN_DET_Near_TARGET_107;
  float32 SRR_RR_CAN_DET_RANGE_107;
  float32 SRR_RR_CAN_DET_RANGE_RATE_107;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_107;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_107;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_107;
} SG_SRR_RR_Detection_107_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_108_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_108;
  float32 SRR_RR_CAN_DET_AZIMUTH_108;
  Rte_DT_SG_SRR_RR_Detection_108_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_108;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_108;
  float32 SRR_RR_CAN_DET_ELEVATION_108;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_108;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_108;
  boolean SRR_RR_CAN_DET_Near_TARGET_108;
  float32 SRR_RR_CAN_DET_RANGE_108;
  float32 SRR_RR_CAN_DET_RANGE_RATE_108;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_108;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_108;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_108;
} SG_SRR_RR_Detection_108_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_109_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_109;
  float32 SRR_RR_CAN_DET_AZIMUTH_109;
  Rte_DT_SG_SRR_RR_Detection_109_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_109;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_109;
  float32 SRR_RR_CAN_DET_ELEVATION_109;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_109;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_109;
  boolean SRR_RR_CAN_DET_Near_TARGET_109;
  float32 SRR_RR_CAN_DET_RANGE_109;
  float32 SRR_RR_CAN_DET_RANGE_RATE_109;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_109;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_109;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_109;
} SG_SRR_RR_Detection_109_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_110_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_110;
  float32 SRR_RR_CAN_DET_AZIMUTH_110;
  Rte_DT_SG_SRR_RR_Detection_110_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_110;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_110;
  float32 SRR_RR_CAN_DET_ELEVATION_110;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_110;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_110;
  boolean SRR_RR_CAN_DET_Near_TARGET_110;
  float32 SRR_RR_CAN_DET_RANGE_110;
  float32 SRR_RR_CAN_DET_RANGE_RATE_110;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_110;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_110;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_110;
} SG_SRR_RR_Detection_110_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_111_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_111;
  float32 SRR_RR_CAN_DET_AZIMUTH_111;
  Rte_DT_SG_SRR_RR_Detection_111_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_111;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_111;
  float32 SRR_RR_CAN_DET_ELEVATION_111;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_111;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_111;
  boolean SRR_RR_CAN_DET_Near_TARGET_111;
  float32 SRR_RR_CAN_DET_RANGE_111;
  float32 SRR_RR_CAN_DET_RANGE_RATE_111;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_111;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_111;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_111;
} SG_SRR_RR_Detection_111_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_112_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_112;
  float32 SRR_RR_CAN_DET_AZIMUTH_112;
  Rte_DT_SG_SRR_RR_Detection_112_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_112;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_112;
  float32 SRR_RR_CAN_DET_ELEVATION_112;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_112;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_112;
  boolean SRR_RR_CAN_DET_Near_TARGET_112;
  float32 SRR_RR_CAN_DET_RANGE_112;
  float32 SRR_RR_CAN_DET_RANGE_RATE_112;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_112;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_112;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_112;
} SG_SRR_RR_Detection_112_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_113_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_113;
  float32 SRR_RR_CAN_DET_AZIMUTH_113;
  Rte_DT_SG_SRR_RR_Detection_113_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_113;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_113;
  float32 SRR_RR_CAN_DET_ELEVATION_113;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_113;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_113;
  boolean SRR_RR_CAN_DET_Near_TARGET_113;
  float32 SRR_RR_CAN_DET_RANGE_113;
  float32 SRR_RR_CAN_DET_RANGE_RATE_113;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_113;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_113;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_113;
} SG_SRR_RR_Detection_113_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_114_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_114;
  float32 SRR_RR_CAN_DET_AZIMUTH_114;
  Rte_DT_SG_SRR_RR_Detection_114_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_114;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_114;
  float32 SRR_RR_CAN_DET_ELEVATION_114;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_114;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_114;
  boolean SRR_RR_CAN_DET_Near_TARGET_114;
  float32 SRR_RR_CAN_DET_RANGE_114;
  float32 SRR_RR_CAN_DET_RANGE_RATE_114;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_114;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_114;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_114;
} SG_SRR_RR_Detection_114_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_115_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_115;
  float32 SRR_RR_CAN_DET_AZIMUTH_115;
  Rte_DT_SG_SRR_RR_Detection_115_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_115;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_115;
  float32 SRR_RR_CAN_DET_ELEVATION_115;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_115;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_115;
  boolean SRR_RR_CAN_DET_Near_TARGET_115;
  float32 SRR_RR_CAN_DET_RANGE_115;
  float32 SRR_RR_CAN_DET_RANGE_RATE_115;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_115;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_115;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_115;
} SG_SRR_RR_Detection_115_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_116_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_116;
  float32 SRR_RR_CAN_DET_AZIMUTH_116;
  Rte_DT_SG_SRR_RR_Detection_116_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_116;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_116;
  float32 SRR_RR_CAN_DET_ELEVATION_116;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_116;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_116;
  boolean SRR_RR_CAN_DET_Near_TARGET_116;
  float32 SRR_RR_CAN_DET_RANGE_116;
  float32 SRR_RR_CAN_DET_RANGE_RATE_116;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_116;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_116;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_116;
} SG_SRR_RR_Detection_116_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_117_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_117;
  float32 SRR_RR_CAN_DET_AZIMUTH_117;
  Rte_DT_SG_SRR_RR_Detection_117_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_117;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_117;
  float32 SRR_RR_CAN_DET_ELEVATION_117;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_117;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_117;
  boolean SRR_RR_CAN_DET_Near_TARGET_117;
  float32 SRR_RR_CAN_DET_RANGE_117;
  float32 SRR_RR_CAN_DET_RANGE_RATE_117;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_117;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_117;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_117;
} SG_SRR_RR_Detection_117_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_118_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_118;
  float32 SRR_RR_CAN_DET_AZIMUTH_118;
  Rte_DT_SG_SRR_RR_Detection_118_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_118;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_118;
  float32 SRR_RR_CAN_DET_ELEVATION_118;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_118;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_118;
  boolean SRR_RR_CAN_DET_Near_TARGET_118;
  float32 SRR_RR_CAN_DET_RANGE_118;
  float32 SRR_RR_CAN_DET_RANGE_RATE_118;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_118;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_118;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_118;
} SG_SRR_RR_Detection_118_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_119_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_119;
  float32 SRR_RR_CAN_DET_AZIMUTH_119;
  Rte_DT_SG_SRR_RR_Detection_119_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_119;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_119;
  float32 SRR_RR_CAN_DET_ELEVATION_119;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_119;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_119;
  boolean SRR_RR_CAN_DET_Near_TARGET_119;
  float32 SRR_RR_CAN_DET_RANGE_119;
  float32 SRR_RR_CAN_DET_RANGE_RATE_119;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_119;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_119;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_119;
} SG_SRR_RR_Detection_119_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_120_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_120;
  float32 SRR_RR_CAN_DET_AZIMUTH_120;
  Rte_DT_SG_SRR_RR_Detection_120_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_120;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_120;
  float32 SRR_RR_CAN_DET_ELEVATION_120;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_120;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_120;
  boolean SRR_RR_CAN_DET_Near_TARGET_120;
  float32 SRR_RR_CAN_DET_RANGE_120;
  float32 SRR_RR_CAN_DET_RANGE_RATE_120;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_120;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_120;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_120;
} SG_SRR_RR_Detection_120_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_121_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_121;
  float32 SRR_RR_CAN_DET_AZIMUTH_121;
  Rte_DT_SG_SRR_RR_Detection_121_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_121;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_121;
  float32 SRR_RR_CAN_DET_ELEVATION_121;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_121;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_121;
  boolean SRR_RR_CAN_DET_Near_TARGET_121;
  float32 SRR_RR_CAN_DET_RANGE_121;
  float32 SRR_RR_CAN_DET_RANGE_RATE_121;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_121;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_121;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_121;
} SG_SRR_RR_Detection_121_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_122_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_122;
  float32 SRR_RR_CAN_DET_AZIMUTH_122;
  Rte_DT_SG_SRR_RR_Detection_122_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_122;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_122;
  float32 SRR_RR_CAN_DET_ELEVATION_122;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_122;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_122;
  boolean SRR_RR_CAN_DET_Near_TARGET_122;
  float32 SRR_RR_CAN_DET_RANGE_122;
  float32 SRR_RR_CAN_DET_RANGE_RATE_122;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_122;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_122;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_122;
} SG_SRR_RR_Detection_122_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_123_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_123;
  float32 SRR_RR_CAN_DET_AZIMUTH_123;
  Rte_DT_SG_SRR_RR_Detection_123_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_123;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_123;
  float32 SRR_RR_CAN_DET_ELEVATION_123;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_123;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_123;
  boolean SRR_RR_CAN_DET_Near_TARGET_123;
  float32 SRR_RR_CAN_DET_RANGE_123;
  float32 SRR_RR_CAN_DET_RANGE_RATE_123;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_123;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_123;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_123;
} SG_SRR_RR_Detection_123_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_124_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_124;
  float32 SRR_RR_CAN_DET_AZIMUTH_124;
  Rte_DT_SG_SRR_RR_Detection_124_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_124;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_124;
  float32 SRR_RR_CAN_DET_ELEVATION_124;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_124;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_124;
  boolean SRR_RR_CAN_DET_Near_TARGET_124;
  float32 SRR_RR_CAN_DET_RANGE_124;
  float32 SRR_RR_CAN_DET_RANGE_RATE_124;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_124;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_124;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_124;
} SG_SRR_RR_Detection_124_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_125_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_125;
  float32 SRR_RR_CAN_DET_AZIMUTH_125;
  Rte_DT_SG_SRR_RR_Detection_125_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_125;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_125;
  float32 SRR_RR_CAN_DET_ELEVATION_125;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_125;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_125;
  boolean SRR_RR_CAN_DET_Near_TARGET_125;
  float32 SRR_RR_CAN_DET_RANGE_125;
  float32 SRR_RR_CAN_DET_RANGE_RATE_125;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_125;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_125;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_125;
} SG_SRR_RR_Detection_125_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_126_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_126;
  float32 SRR_RR_CAN_DET_AZIMUTH_126;
  Rte_DT_SG_SRR_RR_Detection_126_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_126;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_126;
  float32 SRR_RR_CAN_DET_ELEVATION_126;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_126;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_126;
  boolean SRR_RR_CAN_DET_Near_TARGET_126;
  float32 SRR_RR_CAN_DET_RANGE_126;
  float32 SRR_RR_CAN_DET_RANGE_RATE_126;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_126;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_126;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_126;
} SG_SRR_RR_Detection_126_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_127_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_127;
  float32 SRR_RR_CAN_DET_AZIMUTH_127;
  Rte_DT_SG_SRR_RR_Detection_127_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_127;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_127;
  float32 SRR_RR_CAN_DET_ELEVATION_127;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_127;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_127;
  boolean SRR_RR_CAN_DET_Near_TARGET_127;
  float32 SRR_RR_CAN_DET_RANGE_127;
  float32 SRR_RR_CAN_DET_RANGE_RATE_127;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_127;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_127;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_127;
} SG_SRR_RR_Detection_127_t;

#  define Rte_TypeDef_SG_SRR_RR_Detection_128_t
typedef struct
{
  sint8 SRR_RR_CAN_DET_AMPLITUDE_128;
  float32 SRR_RR_CAN_DET_AZIMUTH_128;
  Rte_DT_SG_SRR_RR_Detection_128_t_2 SRR_RR_CAN_DET_CONFID_AZIMUTH_128;
  boolean SRR_RR_CAN_DET_CONFID_ELEVATION_128;
  float32 SRR_RR_CAN_DET_ELEVATION_128;
  boolean SRR_RR_CAN_DET_GUARD_RAIL_128;
  boolean SRR_RR_CAN_DET_HOST_VEH_CLUTTER_128;
  boolean SRR_RR_CAN_DET_Near_TARGET_128;
  float32 SRR_RR_CAN_DET_RANGE_128;
  float32 SRR_RR_CAN_DET_RANGE_RATE_128;
  boolean SRR_RR_CAN_DET_SUPER_RES_TARGET_128;
  boolean SRR_RR_CAN_DET_VALID_LEVEL_128;
  uint8 SRR_RR_CAN_SCAN_INDEX_2LSB_128;
} SG_SRR_RR_Detection_128_t;

#  define Rte_TypeDef_SG_SigGroup_260_1_t
typedef struct
{
  uint8 FL_1_Checksum1;
  uint8 FL_1_RollingCounter1;
  Rte_DT_SG_SigGroup_260_1_t_2 FL_DetSourceOfObj_1;
  float32 FL_ObjDistX_1;
  float32 FL_ObjDistXStd_1;
  float32 FL_ObjDistY_1;
  float32 FL_ObjExistProb_1;
  uint8 FL_ObjID_1;
  float32 FL_ObjObstacleProb_1;
  Rte_DT_SG_SigGroup_260_1_t_9 FL_ObjType_1;
} SG_SigGroup_260_1_t;

#  define Rte_TypeDef_SG_SigGroup_260_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_260_2_t_0 FL_ObjMeasured_1;
  Rte_DT_SG_SigGroup_260_2_t_1 FL_ObjMotionType_1;
  float32 FL_ObjRelAccelX_1;
  float32 FL_ObjRelAccelY_1;
  float32 FL_ObjRelVelX_1;
  float32 FL_ObjRelVelY_1;
} SG_SigGroup_260_2_t;

#  define Rte_TypeDef_SG_SigGroup_260_3_t
typedef struct
{
  uint8 FL_ObjAge_1;
  float32 FL_ObjDistYStd_1;
  Rte_DT_SG_SigGroup_260_3_t_2 FL_ObjMotionDirection_1;
  float32 FL_ObjRAccelXStd_1;
  float32 FL_ObjRAccelYStd_1;
  float32 FL_ObjRelVelXStd_1;
  float32 FL_ObjRelVelYStd_1;
  float32 FL_ObjWidth_1;
} SG_SigGroup_260_3_t;

#  define Rte_TypeDef_SG_SigGroup_260_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_260_4_t_0 FL_HWATargetValidity_1;
  float32 FL_ObjHeading_1;
  float32 FL_ObjLength_1;
  float32 FL_ObjRCS_1;
  Rte_DT_SG_SigGroup_260_4_t_4 FL_ObjRefPoint_1;
  float32 FL_ObjYawrate_1;
} SG_SigGroup_260_4_t;

#  define Rte_TypeDef_SG_SigGroup_260_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_260_5_t_0 FL_DetSourceOfObj_2;
  float32 FL_ObjDistX_2;
  float32 FL_ObjDistXStd_2;
  float32 FL_ObjDistY_2;
  float32 FL_ObjExistProb_2;
  uint8 FL_ObjID_2;
  float32 FL_ObjObstacleProb_2;
  Rte_DT_SG_SigGroup_260_5_t_7 FL_ObjType_2;
} SG_SigGroup_260_5_t;

#  define Rte_TypeDef_SG_SigGroup_260_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_260_6_t_0 FL_ObjMeasured_2;
  Rte_DT_SG_SigGroup_260_6_t_1 FL_ObjMotionType_2;
  float32 FL_ObjRelAccelX_2;
  float32 FL_ObjRelAccelY_2;
  float32 FL_ObjRelVelX_2;
  float32 FL_ObjRelVelY_2;
} SG_SigGroup_260_6_t;

#  define Rte_TypeDef_SG_SigGroup_260_7_t
typedef struct
{
  uint8 FL_ObjAge_2;
  float32 FL_ObjDistYStd_2;
  Rte_DT_SG_SigGroup_260_7_t_2 FL_ObjMotionDirection_2;
  float32 FL_ObjRAccelXStd_2;
  float32 FL_ObjRAccelYStd_2;
  float32 FL_ObjRelVelXStd_2;
  float32 FL_ObjRelVelYStd_2;
  float32 FL_ObjWidth_2;
} SG_SigGroup_260_7_t;

#  define Rte_TypeDef_SG_SigGroup_260_8_t
typedef struct
{
  uint8 FL_1_BlockCounter;
  Rte_DT_SG_SigGroup_260_8_t_1 FL_HWATargetValidity_2;
  float32 FL_ObjHeading_2;
  float32 FL_ObjLength_2;
  float32 FL_ObjRCS_2;
  Rte_DT_SG_SigGroup_260_8_t_5 FL_ObjRefPoint_2;
  float32 FL_ObjYawrate_2;
} SG_SigGroup_260_8_t;

#  define Rte_TypeDef_SG_SigGroup_261_1_t
typedef struct
{
  uint8 FL_2_Checksum1;
  uint8 FL_2_RollingCounter1;
  Rte_DT_SG_SigGroup_261_1_t_2 FL_DetSourceOfObj_3;
  float32 FL_ObjDistX_3;
  float32 FL_ObjDistXStd_3;
  float32 FL_ObjDistY_3;
  float32 FL_ObjExistProb_3;
  uint8 FL_ObjID_3;
  float32 FL_ObjObstacleProb_3;
  Rte_DT_SG_SigGroup_261_1_t_9 FL_ObjType_3;
} SG_SigGroup_261_1_t;

#  define Rte_TypeDef_SG_SigGroup_261_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_261_2_t_0 FL_ObjMeasured_3;
  Rte_DT_SG_SigGroup_261_2_t_1 FL_ObjMotionType_3;
  float32 FL_ObjRelAccelX_3;
  float32 FL_ObjRelAccelY_3;
  float32 FL_ObjRelVelX_3;
  float32 FL_ObjRelVelY_3;
} SG_SigGroup_261_2_t;

#  define Rte_TypeDef_SG_SigGroup_261_3_t
typedef struct
{
  uint8 FL_ObjAge_3;
  float32 FL_ObjDistYStd_3;
  Rte_DT_SG_SigGroup_261_3_t_2 FL_ObjMotionDirection_3;
  float32 FL_ObjRAccelXStd_3;
  float32 FL_ObjRAccelYStd_3;
  float32 FL_ObjRelVelXStd_3;
  float32 FL_ObjRelVelYStd_3;
  float32 FL_ObjWidth_3;
} SG_SigGroup_261_3_t;

#  define Rte_TypeDef_SG_SigGroup_261_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_261_4_t_0 FL_HWATargetValidity_3;
  float32 FL_ObjHeading_3;
  float32 FL_ObjLength_3;
  float32 FL_ObjRCS_3;
  Rte_DT_SG_SigGroup_261_4_t_4 FL_ObjRefPoint_3;
  float32 FL_ObjYawrate_3;
} SG_SigGroup_261_4_t;

#  define Rte_TypeDef_SG_SigGroup_261_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_261_5_t_0 FL_DetSourceOfObj_4;
  float32 FL_ObjDistX_4;
  float32 FL_ObjDistXStd_4;
  float32 FL_ObjDistY_4;
  float32 FL_ObjExistProb_4;
  uint8 FL_ObjID_4;
  float32 FL_ObjObstacleProb_4;
  Rte_DT_SG_SigGroup_261_5_t_7 FL_ObjType_4;
} SG_SigGroup_261_5_t;

#  define Rte_TypeDef_SG_SigGroup_261_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_261_6_t_0 FL_ObjMeasured_4;
  Rte_DT_SG_SigGroup_261_6_t_1 FL_ObjMotionType_4;
  float32 FL_ObjRelAccelX_4;
  float32 FL_ObjRelAccelY_4;
  float32 FL_ObjRelVelX_4;
  float32 FL_ObjRelVelY_4;
} SG_SigGroup_261_6_t;

#  define Rte_TypeDef_SG_SigGroup_261_7_t
typedef struct
{
  uint8 FL_ObjAge_4;
  float32 FL_ObjDistYStd_4;
  Rte_DT_SG_SigGroup_261_7_t_2 FL_ObjMotionDirection_4;
  float32 FL_ObjRAccelXStd_4;
  float32 FL_ObjRAccelYStd_4;
  float32 FL_ObjRelVelXStd_4;
  float32 FL_ObjRelVelYStd_4;
  float32 FL_ObjWidth_4;
} SG_SigGroup_261_7_t;

#  define Rte_TypeDef_SG_SigGroup_261_8_t
typedef struct
{
  uint8 FL_2_BlockCounter;
  Rte_DT_SG_SigGroup_261_8_t_1 FL_HWATargetValidity_4;
  float32 FL_ObjHeading_4;
  float32 FL_ObjLength_4;
  float32 FL_ObjRCS_4;
  Rte_DT_SG_SigGroup_261_8_t_5 FL_ObjRefPoint_4;
  float32 FL_ObjYawrate_4;
} SG_SigGroup_261_8_t;

#  define Rte_TypeDef_SG_SigGroup_262_1_t
typedef struct
{
  uint8 FL_3_Checksum1;
  uint8 FL_3_RollingCounter1;
  Rte_DT_SG_SigGroup_262_1_t_2 FL_DetSourceOfObj_5;
  float32 FL_ObjDistX_5;
  float32 FL_ObjDistXStd_5;
  float32 FL_ObjDistY_5;
  float32 FL_ObjExistProb_5;
  uint8 FL_ObjID_5;
  float32 FL_ObjObstacleProb_5;
  Rte_DT_SG_SigGroup_262_1_t_9 FL_ObjType_5;
} SG_SigGroup_262_1_t;

#  define Rte_TypeDef_SG_SigGroup_262_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_262_2_t_0 FL_ObjMeasured_5;
  Rte_DT_SG_SigGroup_262_2_t_1 FL_ObjMotionType_5;
  float32 FL_ObjRelAccelX_5;
  float32 FL_ObjRelAccelY_5;
  float32 FL_ObjRelVelX_5;
  float32 FL_ObjRelVelY_5;
} SG_SigGroup_262_2_t;

#  define Rte_TypeDef_SG_SigGroup_262_3_t
typedef struct
{
  uint8 FL_ObjAge_5;
  float32 FL_ObjDistYStd_5;
  Rte_DT_SG_SigGroup_262_3_t_2 FL_ObjMotionDirection_5;
  float32 FL_ObjRAccelXStd_5;
  float32 FL_ObjRAccelYStd_5;
  float32 FL_ObjRelVelXStd_5;
  float32 FL_ObjRelVelYStd_5;
  float32 FL_ObjWidth_5;
} SG_SigGroup_262_3_t;

#  define Rte_TypeDef_SG_SigGroup_262_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_262_4_t_0 FL_HWATargetValidity_5;
  float32 FL_ObjHeading_5;
  float32 FL_ObjLength_5;
  float32 FL_ObjRCS_5;
  Rte_DT_SG_SigGroup_262_4_t_4 FL_ObjRefPoint_5;
  float32 FL_ObjYawrate_5;
} SG_SigGroup_262_4_t;

#  define Rte_TypeDef_SG_SigGroup_262_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_262_5_t_0 FL_DetSourceOfObj_6;
  float32 FL_ObjDistX_6;
  float32 FL_ObjDistXStd_6;
  float32 FL_ObjDistY_6;
  float32 FL_ObjExistProb_6;
  uint8 FL_ObjID_6;
  float32 FL_ObjObstacleProb_6;
  Rte_DT_SG_SigGroup_262_5_t_7 FL_ObjType_6;
} SG_SigGroup_262_5_t;

#  define Rte_TypeDef_SG_SigGroup_262_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_262_6_t_0 FL_ObjMeasured_6;
  Rte_DT_SG_SigGroup_262_6_t_1 FL_ObjMotionType_6;
  float32 FL_ObjRelAccelX_6;
  float32 FL_ObjRelAccelY_6;
  float32 FL_ObjRelVelX_6;
  float32 FL_ObjRelVelY_6;
} SG_SigGroup_262_6_t;

#  define Rte_TypeDef_SG_SigGroup_262_7_t
typedef struct
{
  uint8 FL_ObjAge_6;
  float32 FL_ObjDistYStd_6;
  Rte_DT_SG_SigGroup_262_7_t_2 FL_ObjMotionDirection_6;
  float32 FL_ObjRAccelXStd_6;
  float32 FL_ObjRAccelYStd_6;
  float32 FL_ObjRelVelXStd_6;
  float32 FL_ObjRelVelYStd_6;
  float32 FL_ObjWidth_6;
} SG_SigGroup_262_7_t;

#  define Rte_TypeDef_SG_SigGroup_262_8_t
typedef struct
{
  uint8 FL_3_BlockCounter;
  Rte_DT_SG_SigGroup_262_8_t_1 FL_HWATargetValidity_6;
  float32 FL_ObjHeading_6;
  float32 FL_ObjLength_6;
  float32 FL_ObjRCS_6;
  Rte_DT_SG_SigGroup_262_8_t_5 FL_ObjRefPoint_6;
  float32 FL_ObjYawrate_6;
} SG_SigGroup_262_8_t;

#  define Rte_TypeDef_SG_SigGroup_263_1_t
typedef struct
{
  uint8 FL_4_Checksum1;
  uint8 FL_4_RollingCounter1;
  Rte_DT_SG_SigGroup_263_1_t_2 FL_DetSourceOfObj_7;
  float32 FL_ObjDistX_7;
  float32 FL_ObjDistXStd_7;
  float32 FL_ObjDistY_7;
  float32 FL_ObjExistProb_7;
  uint8 FL_ObjID_7;
  float32 FL_ObjObstacleProb_7;
  Rte_DT_SG_SigGroup_263_1_t_9 FL_ObjType_7;
} SG_SigGroup_263_1_t;

#  define Rte_TypeDef_SG_SigGroup_263_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_263_2_t_0 FL_ObjMeasured_7;
  Rte_DT_SG_SigGroup_263_2_t_1 FL_ObjMotionType_7;
  float32 FL_ObjRelAccelX_7;
  float32 FL_ObjRelAccelY_7;
  float32 FL_ObjRelVelX_7;
  float32 FL_ObjRelVelY_7;
} SG_SigGroup_263_2_t;

#  define Rte_TypeDef_SG_SigGroup_263_3_t
typedef struct
{
  uint8 FL_ObjAge_7;
  float32 FL_ObjDistYStd_7;
  Rte_DT_SG_SigGroup_263_3_t_2 FL_ObjMotionDirection_7;
  float32 FL_ObjRAccelXStd_7;
  float32 FL_ObjRAccelYStd_7;
  float32 FL_ObjRelVelXStd_7;
  float32 FL_ObjRelVelYStd_7;
  float32 FL_ObjWidth_7;
} SG_SigGroup_263_3_t;

#  define Rte_TypeDef_SG_SigGroup_263_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_263_4_t_0 FL_HWATargetValidity_7;
  float32 FL_ObjHeading_7;
  float32 FL_ObjLength_7;
  float32 FL_ObjRCS_7;
  Rte_DT_SG_SigGroup_263_4_t_4 FL_ObjRefPoint_7;
  float32 FL_ObjYawrate_7;
} SG_SigGroup_263_4_t;

#  define Rte_TypeDef_SG_SigGroup_263_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_263_5_t_0 FL_DetSourceOfObj_8;
  float32 FL_ObjDistX_8;
  float32 FL_ObjDistXStd_8;
  float32 FL_ObjDistY_8;
  float32 FL_ObjExistProb_8;
  uint8 FL_ObjID_8;
  float32 FL_ObjObstacleProb_8;
  Rte_DT_SG_SigGroup_263_5_t_7 FL_ObjType_8;
} SG_SigGroup_263_5_t;

#  define Rte_TypeDef_SG_SigGroup_263_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_263_6_t_0 FL_ObjMeasured_8;
  Rte_DT_SG_SigGroup_263_6_t_1 FL_ObjMotionType_8;
  float32 FL_ObjRelAccelX_8;
  float32 FL_ObjRelAccelY_8;
  float32 FL_ObjRelVelX_8;
  float32 FL_ObjRelVelY_8;
} SG_SigGroup_263_6_t;

#  define Rte_TypeDef_SG_SigGroup_263_7_t
typedef struct
{
  uint8 FL_ObjAge_8;
  float32 FL_ObjDistYStd_8;
  Rte_DT_SG_SigGroup_263_7_t_2 FL_ObjMotionDirection_8;
  float32 FL_ObjRAccelXStd_8;
  float32 FL_ObjRAccelYStd_8;
  float32 FL_ObjRelVelXStd_8;
  float32 FL_ObjRelVelYStd_8;
  float32 FL_ObjWidth_8;
} SG_SigGroup_263_7_t;

#  define Rte_TypeDef_SG_SigGroup_263_8_t
typedef struct
{
  uint8 FL_4_BlockCounter;
  Rte_DT_SG_SigGroup_263_8_t_1 FL_HWATargetValidity_8;
  float32 FL_ObjHeading_8;
  float32 FL_ObjLength_8;
  float32 FL_ObjRCS_8;
  Rte_DT_SG_SigGroup_263_8_t_5 FL_ObjRefPoint_8;
  float32 FL_ObjYawrate_8;
} SG_SigGroup_263_8_t;

#  define Rte_TypeDef_SG_SigGroup_264_1_t
typedef struct
{
  uint8 FL_5_Checksum1;
  uint8 FL_5_RollingCounter1;
  Rte_DT_SG_SigGroup_264_1_t_2 FL_DetSourceOfObj_9;
  float32 FL_ObjDistX_9;
  float32 FL_ObjDistXStd_9;
  float32 FL_ObjDistY_9;
  float32 FL_ObjExistProb_9;
  uint8 FL_ObjID_9;
  float32 FL_ObjObstacleProb_9;
  Rte_DT_SG_SigGroup_264_1_t_9 FL_ObjType_9;
} SG_SigGroup_264_1_t;

#  define Rte_TypeDef_SG_SigGroup_264_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_264_2_t_0 FL_ObjMeasured_9;
  Rte_DT_SG_SigGroup_264_2_t_1 FL_ObjMotionType_9;
  float32 FL_ObjRelAccelX_9;
  float32 FL_ObjRelAccelY_9;
  float32 FL_ObjRelVelX_9;
  float32 FL_ObjRelVelY_9;
} SG_SigGroup_264_2_t;

#  define Rte_TypeDef_SG_SigGroup_264_3_t
typedef struct
{
  uint8 FL_ObjAge_9;
  float32 FL_ObjDistYStd_9;
  Rte_DT_SG_SigGroup_264_3_t_2 FL_ObjMotionDirection_9;
  float32 FL_ObjRAccelXStd_9;
  float32 FL_ObjRAccelYStd_9;
  float32 FL_ObjRelVelXStd_9;
  float32 FL_ObjRelVelYStd_9;
  float32 FL_ObjWidth_9;
} SG_SigGroup_264_3_t;

#  define Rte_TypeDef_SG_SigGroup_264_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_264_4_t_0 FL_HWATargetValidity_9;
  float32 FL_ObjHeading_9;
  float32 FL_ObjLength_9;
  float32 FL_ObjRCS_9;
  Rte_DT_SG_SigGroup_264_4_t_4 FL_ObjRefPoint_9;
  float32 FL_ObjYawrate_9;
} SG_SigGroup_264_4_t;

#  define Rte_TypeDef_SG_SigGroup_264_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_264_5_t_0 FL_DetSourceOfObj_10;
  float32 FL_ObjDistX_10;
  float32 FL_ObjDistXStd_10;
  float32 FL_ObjDistY_10;
  float32 FL_ObjExistProb_10;
  uint8 FL_ObjID_10;
  float32 FL_ObjObstacleProb_10;
  Rte_DT_SG_SigGroup_264_5_t_7 FL_ObjType_10;
} SG_SigGroup_264_5_t;

#  define Rte_TypeDef_SG_SigGroup_264_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_264_6_t_0 FL_ObjMeasured_10;
  Rte_DT_SG_SigGroup_264_6_t_1 FL_ObjMotionType_10;
  float32 FL_ObjRelAccelX_10;
  float32 FL_ObjRelAccelY_10;
  float32 FL_ObjRelVelX_10;
  float32 FL_ObjRelVelY_10;
} SG_SigGroup_264_6_t;

#  define Rte_TypeDef_SG_SigGroup_264_7_t
typedef struct
{
  uint8 FL_ObjAge_10;
  float32 FL_ObjDistYStd_10;
  Rte_DT_SG_SigGroup_264_7_t_2 FL_ObjMotionDirection_10;
  float32 FL_ObjRAccelXStd_10;
  float32 FL_ObjRAccelYStd_10;
  float32 FL_ObjRelVelXStd_10;
  float32 FL_ObjRelVelYStd_10;
  float32 FL_ObjWidth_10;
} SG_SigGroup_264_7_t;

#  define Rte_TypeDef_SG_SigGroup_264_8_t
typedef struct
{
  uint8 FL_5_BlockCounter;
  Rte_DT_SG_SigGroup_264_8_t_1 FL_HWATargetValidity_10;
  float32 FL_ObjHeading_10;
  float32 FL_ObjLength_10;
  float32 FL_ObjRCS_10;
  Rte_DT_SG_SigGroup_264_8_t_5 FL_ObjRefPoint_10;
  float32 FL_ObjYawrate_10;
} SG_SigGroup_264_8_t;

#  define Rte_TypeDef_SG_SigGroup_265_1_t
typedef struct
{
  uint8 FL_6_Checksum1;
  uint8 FL_6_RollingCounter1;
  Rte_DT_SG_SigGroup_265_1_t_2 FL_DetSourceOfObj_11;
  float32 FL_ObjDistX_11;
  float32 FL_ObjDistXStd_11;
  float32 FL_ObjDistY_11;
  float32 FL_ObjExistProb_11;
  uint8 FL_ObjID_11;
  float32 FL_ObjObstacleProb_11;
  Rte_DT_SG_SigGroup_265_1_t_9 FL_ObjType_11;
} SG_SigGroup_265_1_t;

#  define Rte_TypeDef_SG_SigGroup_265_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_265_2_t_0 FL_ObjMeasured_11;
  Rte_DT_SG_SigGroup_265_2_t_1 FL_ObjMotionType_11;
  float32 FL_ObjRelAccelX_11;
  float32 FL_ObjRelAccelY_11;
  float32 FL_ObjRelVelX_11;
  float32 FL_ObjRelVelY_11;
} SG_SigGroup_265_2_t;

#  define Rte_TypeDef_SG_SigGroup_265_3_t
typedef struct
{
  uint8 FL_ObjAge_11;
  float32 FL_ObjDistYStd_11;
  Rte_DT_SG_SigGroup_265_3_t_2 FL_ObjMotionDirection_11;
  float32 FL_ObjRAccelXStd_11;
  float32 FL_ObjRAccelYStd_11;
  float32 FL_ObjRelVelXStd_11;
  float32 FL_ObjRelVelYStd_11;
  float32 FL_ObjWidth_11;
} SG_SigGroup_265_3_t;

#  define Rte_TypeDef_SG_SigGroup_265_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_265_4_t_0 FL_HWATargetValidity_11;
  float32 FL_ObjHeading_11;
  float32 FL_ObjLength_11;
  float32 FL_ObjRCS_11;
  Rte_DT_SG_SigGroup_265_4_t_4 FL_ObjRefPoint_11;
  float32 FL_ObjYawrate_11;
} SG_SigGroup_265_4_t;

#  define Rte_TypeDef_SG_SigGroup_265_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_265_5_t_0 FL_DetSourceOfObj_12;
  float32 FL_ObjDistX_12;
  float32 FL_ObjDistXStd_12;
  float32 FL_ObjDistY_12;
  float32 FL_ObjExistProb_12;
  uint8 FL_ObjID_12;
  float32 FL_ObjObstacleProb_12;
  Rte_DT_SG_SigGroup_265_5_t_7 FL_ObjType_12;
} SG_SigGroup_265_5_t;

#  define Rte_TypeDef_SG_SigGroup_265_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_265_6_t_0 FL_ObjMeasured_12;
  Rte_DT_SG_SigGroup_265_6_t_1 FL_ObjMotionType_12;
  float32 FL_ObjRelAccelX_12;
  float32 FL_ObjRelAccelY_12;
  float32 FL_ObjRelVelX_12;
  float32 FL_ObjRelVelY_12;
} SG_SigGroup_265_6_t;

#  define Rte_TypeDef_SG_SigGroup_265_7_t
typedef struct
{
  uint8 FL_ObjAge_12;
  float32 FL_ObjDistYStd_12;
  Rte_DT_SG_SigGroup_265_7_t_2 FL_ObjMotionDirection_12;
  float32 FL_ObjRAccelXStd_12;
  float32 FL_ObjRAccelYStd_12;
  float32 FL_ObjRelVelXStd_12;
  float32 FL_ObjRelVelYStd_12;
  float32 FL_ObjWidth_12;
} SG_SigGroup_265_7_t;

#  define Rte_TypeDef_SG_SigGroup_265_8_t
typedef struct
{
  uint8 FL_6_BlockCounter;
  Rte_DT_SG_SigGroup_265_8_t_1 FL_HWATargetValidity_12;
  float32 FL_ObjHeading_12;
  float32 FL_ObjLength_12;
  float32 FL_ObjRCS_12;
  Rte_DT_SG_SigGroup_265_8_t_5 FL_ObjRefPoint_12;
  float32 FL_ObjYawrate_12;
} SG_SigGroup_265_8_t;

#  define Rte_TypeDef_SG_SigGroup_360_1_Copy_1_t
typedef struct
{
  Rte_DT_SG_SigGroup_360_1_Copy_1_t_0 FR_BLIND;
  float32 FR_Guardrail_dxEnd;
  float32 FR_GuardrailConfidence;
  Rte_DT_SG_SigGroup_360_1_Copy_1_t_3 FR_hdr_ErrorStatus;
  uint8 FR_hdr_TimerStempStatus;
  uint8 FR_hdr_TimeStamp;
  uint8 FR_HEAD_Checksum1;
  uint8 FR_HEAD_RollingCounter1;
  uint8 FR_ObjDetected;
} SG_SigGroup_360_1_Copy_1_t;

#  define Rte_TypeDef_SG_SigGroup_360_1_t
typedef struct
{
  uint8 FR_1_Checksum1;
  uint8 FR_1_RollingCounter1;
  Rte_DT_SG_SigGroup_360_1_t_2 FR_DetSourceOfObj_1;
  float32 FR_ObjDistX_1;
  float32 FR_ObjDistXStd_1;
  float32 FR_ObjDistY_1;
  float32 FR_ObjExistProb_1;
  uint8 FR_ObjID_1;
  float32 FR_ObjObstacleProb_1;
  Rte_DT_SG_SigGroup_360_1_t_9 FR_ObjType_1;
} SG_SigGroup_360_1_t;

#  define Rte_TypeDef_SG_SigGroup_360_2_Copy_1_t
typedef struct
{
  uint64 FR_hdr_AutoSarTimeStamp;
} SG_SigGroup_360_2_Copy_1_t;

#  define Rte_TypeDef_SG_SigGroup_360_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_360_2_t_0 FR_ObjMeasured_1;
  Rte_DT_SG_SigGroup_360_2_t_1 FR_ObjMotionType_1;
  float32 FR_ObjRelAccelX_1;
  float32 FR_ObjRelAccelY_1;
  float32 FR_ObjRelVelX_1;
  float32 FR_ObjRelVelY_1;
} SG_SigGroup_360_2_t;

#  define Rte_TypeDef_SG_SigGroup_360_3_Copy_1_t
typedef struct
{
  float32 FR_GuardrailC0;
  float32 FR_GuardrailC1;
  float32 FR_GuardrailC2;
} SG_SigGroup_360_3_Copy_1_t;

#  define Rte_TypeDef_SG_SigGroup_360_3_t
typedef struct
{
  uint8 FR_ObjAge_1;
  float32 FR_ObjDistYStd_1;
  Rte_DT_SG_SigGroup_360_3_t_2 FR_ObjMotionDirection_1;
  float32 FR_ObjRAccelXStd_1;
  float32 FR_ObjRAccelYStd_1;
  float32 FR_ObjRelVelXStd_1;
  float32 FR_ObjRelVelYStd_1;
  float32 FR_ObjWidth_1;
} SG_SigGroup_360_3_t;

#  define Rte_TypeDef_SG_SigGroup_360_4_Copy_1_t
typedef struct
{
  float32 FR_Guardrail_dxStart;
  float32 FR_GuardrailC3;
  uint8 FR_HEAD_BlockCounter;
  float32 FR_ObjAziAngleCalib;
} SG_SigGroup_360_4_Copy_1_t;

#  define Rte_TypeDef_SG_SigGroup_360_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_360_4_t_0 FR_HWATargetValidity_1;
  float32 FR_ObjHeading_1;
  float32 FR_ObjLength_1;
  float32 FR_ObjRCS_1;
  Rte_DT_SG_SigGroup_360_4_t_4 FR_ObjRefPoint_1;
  float32 FR_ObjYawrate_1;
} SG_SigGroup_360_4_t;

#  define Rte_TypeDef_SG_SigGroup_360_5_Copy_1_t
typedef struct
{
  uint8 FL_BLIND;
  float32 FL_Guardrail_dxEnd;
  float32 FL_GuardrailConfidence;
  uint8 FL_hdr_ErrorStatus;
  uint8 FL_hdr_TimerStempStatus;
  uint8 FL_hdr_TimeStamp;
  uint8 FL_HEAD_Checksum1;
  uint8 FL_HEAD_RollingCounter1;
  uint8 FL_ObjDetected;
} SG_SigGroup_360_5_Copy_1_t;

#  define Rte_TypeDef_SG_SigGroup_360_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_360_5_t_0 FR_DetSourceOfObj_2;
  float32 FR_ObjDistX_2;
  float32 FR_ObjDistXStd_2;
  float32 FR_ObjDistY_2;
  float32 FR_ObjExistProb_2;
  uint8 FR_ObjID_2;
  float32 FR_ObjObstacleProb_2;
  Rte_DT_SG_SigGroup_360_5_t_7 FR_ObjType_2;
} SG_SigGroup_360_5_t;

#  define Rte_TypeDef_SG_SigGroup_360_6_Copy_1_t
typedef struct
{
  uint64 FL_hdr_AutoSarTimeStamp;
} SG_SigGroup_360_6_Copy_1_t;

#  define Rte_TypeDef_SG_SigGroup_360_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_360_6_t_0 FR_ObjMeasured_2;
  Rte_DT_SG_SigGroup_360_6_t_1 FR_ObjMotionType_2;
  float32 FR_ObjRelAccelX_2;
  float32 FR_ObjRelAccelY_2;
  float32 FR_ObjRelVelX_2;
  float32 FR_ObjRelVelY_2;
} SG_SigGroup_360_6_t;

#  define Rte_TypeDef_SG_SigGroup_360_7_Copy_1_t
typedef struct
{
  float32 FL_GuardrailC0;
  float32 FL_GuardrailC1;
  float32 FL_GuardrailC2;
} SG_SigGroup_360_7_Copy_1_t;

#  define Rte_TypeDef_SG_SigGroup_360_7_t
typedef struct
{
  uint8 FR_ObjAge_2;
  float32 FR_ObjDistYStd_2;
  Rte_DT_SG_SigGroup_360_7_t_2 FR_ObjMotionDirection_2;
  float32 FR_ObjRAccelXStd_2;
  float32 FR_ObjRAccelYStd_2;
  float32 FR_ObjRelVelXStd_2;
  float32 FR_ObjRelVelYStd_2;
  float32 FR_ObjWidth_2;
} SG_SigGroup_360_7_t;

#  define Rte_TypeDef_SG_SigGroup_360_8_Copy_1_t
typedef struct
{
  float32 FL_Guardrail_dxStart;
  float32 FL_GuardrailC3;
  uint8 FL_HEAD_BlockCounter;
  float32 FL_ObjAziAngleCalib;
} SG_SigGroup_360_8_Copy_1_t;

#  define Rte_TypeDef_SG_SigGroup_360_8_t
typedef struct
{
  uint8 FR_1_BlockCounter;
  Rte_DT_SG_SigGroup_360_8_t_1 FR_HWATargetValidity_2;
  float32 FR_ObjHeading_2;
  float32 FR_ObjLength_2;
  float32 FR_ObjRCS_2;
  Rte_DT_SG_SigGroup_360_8_t_5 FR_ObjRefPoint_2;
  float32 FR_ObjYawrate_2;
} SG_SigGroup_360_8_t;

#  define Rte_TypeDef_SG_SigGroup_361_1_t
typedef struct
{
  uint8 FR_2_Checksum1;
  uint8 FR_2_RollingCounter1;
  Rte_DT_SG_SigGroup_361_1_t_2 FR_DetSourceOfObj_3;
  float32 FR_ObjDistX_3;
  float32 FR_ObjDistXStd_3;
  float32 FR_ObjDistY_3;
  float32 FR_ObjExistProb_3;
  uint8 FR_ObjID_3;
  float32 FR_ObjObstacleProb_3;
  Rte_DT_SG_SigGroup_361_1_t_9 FR_ObjType_3;
} SG_SigGroup_361_1_t;

#  define Rte_TypeDef_SG_SigGroup_361_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_361_2_t_0 FR_ObjMeasured_3;
  Rte_DT_SG_SigGroup_361_2_t_1 FR_ObjMotionType_3;
  float32 FR_ObjRelAccelX_3;
  float32 FR_ObjRelAccelY_3;
  float32 FR_ObjRelVelX_3;
  float32 FR_ObjRelVelY_3;
} SG_SigGroup_361_2_t;

#  define Rte_TypeDef_SG_SigGroup_361_3_t
typedef struct
{
  uint8 FR_ObjAge_3;
  float32 FR_ObjDistYStd_3;
  Rte_DT_SG_SigGroup_361_3_t_2 FR_ObjMotionDirection_3;
  float32 FR_ObjRAccelXStd_3;
  float32 FR_ObjRAccelYStd_3;
  float32 FR_ObjRelVelXStd_3;
  float32 FR_ObjRelVelYStd_3;
  float32 FR_ObjWidth_3;
} SG_SigGroup_361_3_t;

#  define Rte_TypeDef_SG_SigGroup_361_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_361_4_t_0 FR_HWATargetValidity_3;
  float32 FR_ObjHeading_3;
  float32 FR_ObjLength_3;
  float32 FR_ObjRCS_3;
  Rte_DT_SG_SigGroup_361_4_t_4 FR_ObjRefPoint_3;
  float32 FR_ObjYawrate_3;
} SG_SigGroup_361_4_t;

#  define Rte_TypeDef_SG_SigGroup_361_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_361_5_t_0 FR_DetSourceOfObj_4;
  float32 FR_ObjDistX_4;
  float32 FR_ObjDistXStd_4;
  float32 FR_ObjDistY_4;
  float32 FR_ObjExistProb_4;
  uint8 FR_ObjID_4;
  float32 FR_ObjObstacleProb_4;
  Rte_DT_SG_SigGroup_361_5_t_7 FR_ObjType_4;
} SG_SigGroup_361_5_t;

#  define Rte_TypeDef_SG_SigGroup_361_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_361_6_t_0 FR_ObjMeasured_4;
  Rte_DT_SG_SigGroup_361_6_t_1 FR_ObjMotionType_4;
  float32 FR_ObjRelAccelX_4;
  float32 FR_ObjRelAccelY_4;
  float32 FR_ObjRelVelX_4;
  float32 FR_ObjRelVelY_4;
} SG_SigGroup_361_6_t;

#  define Rte_TypeDef_SG_SigGroup_361_7_t
typedef struct
{
  uint8 FR_ObjAge_4;
  float32 FR_ObjDistYStd_4;
  Rte_DT_SG_SigGroup_361_7_t_2 FR_ObjMotionDirection_4;
  float32 FR_ObjRAccelXStd_4;
  float32 FR_ObjRAccelYStd_4;
  float32 FR_ObjRelVelXStd_4;
  float32 FR_ObjRelVelYStd_4;
  float32 FR_ObjWidth_4;
} SG_SigGroup_361_7_t;

#  define Rte_TypeDef_SG_SigGroup_361_8_t
typedef struct
{
  uint8 FR_2_BlockCounter;
  Rte_DT_SG_SigGroup_361_8_t_1 FR_HWATargetValidity_4;
  float32 FR_ObjHeading_4;
  float32 FR_ObjLength_4;
  float32 FR_ObjRCS_4;
  Rte_DT_SG_SigGroup_361_8_t_5 FR_ObjRefPoint_4;
  float32 FR_ObjYawrate_4;
} SG_SigGroup_361_8_t;

#  define Rte_TypeDef_SG_SigGroup_362_1_t
typedef struct
{
  uint8 FR_3_Checksum1;
  uint8 FR_3_RollingCounter1;
  Rte_DT_SG_SigGroup_362_1_t_2 FR_DetSourceOfObj_5;
  float32 FR_ObjDistX_5;
  float32 FR_ObjDistXStd_5;
  float32 FR_ObjDistY_5;
  float32 FR_ObjExistProb_5;
  uint8 FR_ObjID_5;
  float32 FR_ObjObstacleProb_5;
  Rte_DT_SG_SigGroup_362_1_t_9 FR_ObjType_5;
} SG_SigGroup_362_1_t;

#  define Rte_TypeDef_SG_SigGroup_362_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_362_2_t_0 FR_ObjMeasured_5;
  Rte_DT_SG_SigGroup_362_2_t_1 FR_ObjMotionType_5;
  float32 FR_ObjRelAccelX_5;
  float32 FR_ObjRelAccelY_5;
  float32 FR_ObjRelVelX_5;
  float32 FR_ObjRelVelY_5;
} SG_SigGroup_362_2_t;

#  define Rte_TypeDef_SG_SigGroup_362_3_t
typedef struct
{
  uint8 FR_ObjAge_5;
  float32 FR_ObjDistYStd_5;
  Rte_DT_SG_SigGroup_362_3_t_2 FR_ObjMotionDirection_5;
  float32 FR_ObjRAccelXStd_5;
  float32 FR_ObjRAccelYStd_5;
  float32 FR_ObjRelVelXStd_5;
  float32 FR_ObjRelVelYStd_5;
  float32 FR_ObjWidth_5;
} SG_SigGroup_362_3_t;

#  define Rte_TypeDef_SG_SigGroup_362_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_362_4_t_0 FR_HWATargetValidity_5;
  float32 FR_ObjHeading_5;
  float32 FR_ObjLength_5;
  float32 FR_ObjRCS_5;
  Rte_DT_SG_SigGroup_362_4_t_4 FR_ObjRefPoint_5;
  float32 FR_ObjYawrate_5;
} SG_SigGroup_362_4_t;

#  define Rte_TypeDef_SG_SigGroup_362_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_362_5_t_0 FR_DetSourceOfObj_6;
  float32 FR_ObjDistX_6;
  float32 FR_ObjDistXStd_6;
  float32 FR_ObjDistY_6;
  float32 FR_ObjExistProb_6;
  uint8 FR_ObjID_6;
  float32 FR_ObjObstacleProb_6;
  Rte_DT_SG_SigGroup_362_5_t_7 FR_ObjType_6;
} SG_SigGroup_362_5_t;

#  define Rte_TypeDef_SG_SigGroup_362_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_362_6_t_0 FR_ObjMeasured_6;
  Rte_DT_SG_SigGroup_362_6_t_1 FR_ObjMotionType_6;
  float32 FR_ObjRelAccelX_6;
  float32 FR_ObjRelAccelY_6;
  float32 FR_ObjRelVelX_6;
  float32 FR_ObjRelVelY_6;
} SG_SigGroup_362_6_t;

#  define Rte_TypeDef_SG_SigGroup_362_7_t
typedef struct
{
  uint8 FR_ObjAge_6;
  float32 FR_ObjDistYStd_6;
  Rte_DT_SG_SigGroup_362_7_t_2 FR_ObjMotionDirection_6;
  float32 FR_ObjRAccelXStd_6;
  float32 FR_ObjRAccelYStd_6;
  float32 FR_ObjRelVelXStd_6;
  float32 FR_ObjRelVelYStd_6;
  float32 FR_ObjWidth_6;
} SG_SigGroup_362_7_t;

#  define Rte_TypeDef_SG_SigGroup_362_8_t
typedef struct
{
  uint8 FR_3_BlockCounter;
  Rte_DT_SG_SigGroup_362_8_t_1 FR_HWATargetValidity_6;
  float32 FR_ObjHeading_6;
  float32 FR_ObjLength_6;
  float32 FR_ObjRCS_6;
  Rte_DT_SG_SigGroup_362_8_t_5 FR_ObjRefPoint_6;
  float32 FR_ObjYawrate_6;
} SG_SigGroup_362_8_t;

#  define Rte_TypeDef_SG_SigGroup_363_1_t
typedef struct
{
  uint8 FR_4_Checksum1;
  uint8 FR_4_RollingCounter1;
  Rte_DT_SG_SigGroup_363_1_t_2 FR_DetSourceOfObj_7;
  float32 FR_ObjDistX_7;
  float32 FR_ObjDistXStd_7;
  float32 FR_ObjDistY_7;
  float32 FR_ObjExistProb_7;
  uint8 FR_ObjID_7;
  float32 FR_ObjObstacleProb_7;
  Rte_DT_SG_SigGroup_363_1_t_9 FR_ObjType_7;
} SG_SigGroup_363_1_t;

#  define Rte_TypeDef_SG_SigGroup_363_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_363_2_t_0 FR_ObjMeasured_7;
  Rte_DT_SG_SigGroup_363_2_t_1 FR_ObjMotionType_7;
  float32 FR_ObjRelAccelX_7;
  float32 FR_ObjRelAccelY_7;
  float32 FR_ObjRelVelX_7;
  float32 FR_ObjRelVelY_7;
} SG_SigGroup_363_2_t;

#  define Rte_TypeDef_SG_SigGroup_363_3_t
typedef struct
{
  uint8 FR_ObjAge_7;
  float32 FR_ObjDistYStd_7;
  Rte_DT_SG_SigGroup_363_3_t_2 FR_ObjMotionDirection_7;
  float32 FR_ObjRAccelXStd_7;
  float32 FR_ObjRAccelYStd_7;
  float32 FR_ObjRelVelXStd_7;
  float32 FR_ObjRelVelYStd_7;
  float32 FR_ObjWidth_7;
} SG_SigGroup_363_3_t;

#  define Rte_TypeDef_SG_SigGroup_363_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_363_4_t_0 FR_HWATargetValidity_7;
  float32 FR_ObjHeading_7;
  float32 FR_ObjLength_7;
  float32 FR_ObjRCS_7;
  Rte_DT_SG_SigGroup_363_4_t_4 FR_ObjRefPoint_7;
  float32 FR_ObjYawrate_7;
} SG_SigGroup_363_4_t;

#  define Rte_TypeDef_SG_SigGroup_363_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_363_5_t_0 FR_DetSourceOfObj_8;
  float32 FR_ObjDistX_8;
  float32 FR_ObjDistXStd_8;
  float32 FR_ObjDistY_8;
  float32 FR_ObjExistProb_8;
  uint8 FR_ObjID_8;
  float32 FR_ObjObstacleProb_8;
  Rte_DT_SG_SigGroup_363_5_t_7 FR_ObjType_8;
} SG_SigGroup_363_5_t;

#  define Rte_TypeDef_SG_SigGroup_363_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_363_6_t_0 FR_ObjMeasured_8;
  Rte_DT_SG_SigGroup_363_6_t_1 FR_ObjMotionType_8;
  float32 FR_ObjRelAccelX_8;
  float32 FR_ObjRelAccelY_8;
  float32 FR_ObjRelVelX_8;
  float32 FR_ObjRelVelY_8;
} SG_SigGroup_363_6_t;

#  define Rte_TypeDef_SG_SigGroup_363_7_t
typedef struct
{
  uint8 FR_ObjAge_8;
  float32 FR_ObjDistYStd_8;
  Rte_DT_SG_SigGroup_363_7_t_2 FR_ObjMotionDirection_8;
  float32 FR_ObjRAccelXStd_8;
  float32 FR_ObjRAccelYStd_8;
  float32 FR_ObjRelVelXStd_8;
  float32 FR_ObjRelVelYStd_8;
  float32 FR_ObjWidth_8;
} SG_SigGroup_363_7_t;

#  define Rte_TypeDef_SG_SigGroup_363_8_t
typedef struct
{
  uint8 FR_4_BlockCounter;
  Rte_DT_SG_SigGroup_363_8_t_1 FR_HWATargetValidity_8;
  float32 FR_ObjHeading_8;
  float32 FR_ObjLength_8;
  float32 FR_ObjRCS_8;
  Rte_DT_SG_SigGroup_363_8_t_5 FR_ObjRefPoint_8;
  float32 FR_ObjYawrate_8;
} SG_SigGroup_363_8_t;

#  define Rte_TypeDef_SG_SigGroup_364_1_t
typedef struct
{
  uint8 FR_5_Checksum1;
  uint8 FR_5_RollingCounter1;
  Rte_DT_SG_SigGroup_364_1_t_2 FR_DetSourceOfObj_9;
  float32 FR_ObjDistX_9;
  float32 FR_ObjDistXStd_9;
  float32 FR_ObjDistY_9;
  float32 FR_ObjExistProb_9;
  uint8 FR_ObjID_9;
  float32 FR_ObjObstacleProb_9;
  Rte_DT_SG_SigGroup_364_1_t_9 FR_ObjType_9;
} SG_SigGroup_364_1_t;

#  define Rte_TypeDef_SG_SigGroup_364_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_364_2_t_0 FR_ObjMeasured_9;
  Rte_DT_SG_SigGroup_364_2_t_1 FR_ObjMotionType_9;
  float32 FR_ObjRelAccelX_9;
  float32 FR_ObjRelAccelY_9;
  float32 FR_ObjRelVelX_9;
  float32 FR_ObjRelVelY_9;
} SG_SigGroup_364_2_t;

#  define Rte_TypeDef_SG_SigGroup_364_3_t
typedef struct
{
  uint8 FR_ObjAge_9;
  float32 FR_ObjDistYStd_9;
  Rte_DT_SG_SigGroup_364_3_t_2 FR_ObjMotionDirection_9;
  float32 FR_ObjRAccelXStd_9;
  float32 FR_ObjRAccelYStd_9;
  float32 FR_ObjRelVelXStd_9;
  float32 FR_ObjRelVelYStd_9;
  float32 FR_ObjWidth_9;
} SG_SigGroup_364_3_t;

#  define Rte_TypeDef_SG_SigGroup_364_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_364_4_t_0 FR_HWATargetValidity_9;
  float32 FR_ObjHeading_9;
  float32 FR_ObjLength_9;
  float32 FR_ObjRCS_9;
  Rte_DT_SG_SigGroup_364_4_t_4 FR_ObjRefPoint_9;
  float32 FR_ObjYawrate_9;
} SG_SigGroup_364_4_t;

#  define Rte_TypeDef_SG_SigGroup_364_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_364_5_t_0 FR_DetSourceOfObj_10;
  float32 FR_ObjDistX_10;
  float32 FR_ObjDistXStd_10;
  float32 FR_ObjDistY_10;
  float32 FR_ObjExistProb_10;
  uint8 FR_ObjID_10;
  float32 FR_ObjObstacleProb_10;
  Rte_DT_SG_SigGroup_364_5_t_7 FR_ObjType_10;
} SG_SigGroup_364_5_t;

#  define Rte_TypeDef_SG_SigGroup_364_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_364_6_t_0 FR_ObjMeasured_10;
  Rte_DT_SG_SigGroup_364_6_t_1 FR_ObjMotionType_10;
  float32 FR_ObjRelAccelX_10;
  float32 FR_ObjRelAccelY_10;
  float32 FR_ObjRelVelX_10;
  float32 FR_ObjRelVelY_10;
} SG_SigGroup_364_6_t;

#  define Rte_TypeDef_SG_SigGroup_364_7_t
typedef struct
{
  uint8 FR_ObjAge_10;
  float32 FR_ObjDistYStd_10;
  Rte_DT_SG_SigGroup_364_7_t_2 FR_ObjMotionDirection_10;
  float32 FR_ObjRAccelXStd_10;
  float32 FR_ObjRAccelYStd_10;
  float32 FR_ObjRelVelXStd_10;
  float32 FR_ObjRelVelYStd_10;
  float32 FR_ObjWidth_10;
} SG_SigGroup_364_7_t;

#  define Rte_TypeDef_SG_SigGroup_364_8_t
typedef struct
{
  uint8 FR_5_BlockCounter;
  Rte_DT_SG_SigGroup_364_8_t_1 FR_HWATargetValidity_10;
  float32 FR_ObjHeading_10;
  float32 FR_ObjLength_10;
  float32 FR_ObjRCS_10;
  Rte_DT_SG_SigGroup_364_8_t_5 FR_ObjRefPoint_10;
  float32 FR_ObjYawrate_10;
} SG_SigGroup_364_8_t;

#  define Rte_TypeDef_SG_SigGroup_365_1_t
typedef struct
{
  uint8 FR_6_Checksum1;
  uint8 FR_6_RollingCounter1;
  Rte_DT_SG_SigGroup_365_1_t_2 FR_DetSourceOfObj_11;
  float32 FR_ObjDistX_11;
  float32 FR_ObjDistXStd_11;
  float32 FR_ObjDistY_11;
  float32 FR_ObjExistProb_11;
  uint8 FR_ObjID_11;
  float32 FR_ObjObstacleProb_11;
  Rte_DT_SG_SigGroup_365_1_t_9 FR_ObjType_11;
} SG_SigGroup_365_1_t;

#  define Rte_TypeDef_SG_SigGroup_365_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_365_2_t_0 FR_ObjMeasured_11;
  Rte_DT_SG_SigGroup_365_2_t_1 FR_ObjMotionType_11;
  float32 FR_ObjRelAccelX_11;
  float32 FR_ObjRelAccelY_11;
  float32 FR_ObjRelVelX_11;
  float32 FR_ObjRelVelY_11;
} SG_SigGroup_365_2_t;

#  define Rte_TypeDef_SG_SigGroup_365_3_t
typedef struct
{
  uint8 FR_ObjAge_11;
  float32 FR_ObjDistYStd_11;
  Rte_DT_SG_SigGroup_365_3_t_2 FR_ObjMotionDirection_11;
  float32 FR_ObjRAccelXStd_11;
  float32 FR_ObjRAccelYStd_11;
  float32 FR_ObjRelVelXStd_11;
  float32 FR_ObjRelVelYStd_11;
  float32 FR_ObjWidth_11;
} SG_SigGroup_365_3_t;

#  define Rte_TypeDef_SG_SigGroup_365_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_365_4_t_0 FR_HWATargetValidity_11;
  float32 FR_ObjHeading_11;
  float32 FR_ObjLength_11;
  float32 FR_ObjRCS_11;
  Rte_DT_SG_SigGroup_365_4_t_4 FR_ObjRefPoint_11;
  float32 FR_ObjYawrate_11;
} SG_SigGroup_365_4_t;

#  define Rte_TypeDef_SG_SigGroup_365_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_365_5_t_0 FR_DetSourceOfObj_12;
  float32 FR_ObjDistX_12;
  float32 FR_ObjDistXStd_12;
  float32 FR_ObjDistY_12;
  float32 FR_ObjExistProb_12;
  uint8 FR_ObjID_12;
  float32 FR_ObjObstacleProb_12;
  Rte_DT_SG_SigGroup_365_5_t_7 FR_ObjType_12;
} SG_SigGroup_365_5_t;

#  define Rte_TypeDef_SG_SigGroup_365_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_365_6_t_0 FR_ObjMeasured_12;
  Rte_DT_SG_SigGroup_365_6_t_1 FR_ObjMotionType_12;
  float32 FR_ObjRelAccelX_12;
  float32 FR_ObjRelAccelY_12;
  float32 FR_ObjRelVelX_12;
  float32 FR_ObjRelVelY_12;
} SG_SigGroup_365_6_t;

#  define Rte_TypeDef_SG_SigGroup_365_7_t
typedef struct
{
  uint8 FR_ObjAge_12;
  float32 FR_ObjDistYStd_12;
  Rte_DT_SG_SigGroup_365_7_t_2 FR_ObjMotionDirection_12;
  float32 FR_ObjRAccelXStd_12;
  float32 FR_ObjRAccelYStd_12;
  float32 FR_ObjRelVelXStd_12;
  float32 FR_ObjRelVelYStd_12;
  float32 FR_ObjWidth_12;
} SG_SigGroup_365_7_t;

#  define Rte_TypeDef_SG_SigGroup_365_8_t
typedef struct
{
  uint8 FR_6_BlockCounter;
  Rte_DT_SG_SigGroup_365_8_t_1 FR_HWATargetValidity_12;
  float32 FR_ObjHeading_12;
  float32 FR_ObjLength_12;
  float32 FR_ObjRCS_12;
  Rte_DT_SG_SigGroup_365_8_t_5 FR_ObjRefPoint_12;
  float32 FR_ObjYawrate_12;
} SG_SigGroup_365_8_t;

#  define Rte_TypeDef_SG_SigGroup_460_1_t
typedef struct
{
  uint8 RL_1_Checksum1;
  uint8 RL_1_RollingCounter1;
  Rte_DT_SG_SigGroup_460_1_t_2 RL_DetSourceOfObj_1;
  float32 RL_ObjDistX_1;
  float32 RL_ObjDistXStd_1;
  float32 RL_ObjDistY_1;
  float32 RL_ObjExistProb_1;
  uint8 RL_ObjID_1;
  float32 RL_ObjObstacleProb_1;
  Rte_DT_SG_SigGroup_460_1_t_9 RL_ObjType_1;
} SG_SigGroup_460_1_t;

#  define Rte_TypeDef_SG_SigGroup_460_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_460_2_t_0 RL_ObjMeasured_1;
  Rte_DT_SG_SigGroup_460_2_t_1 RL_ObjMotionType_1;
  float32 RL_ObjRelAccelX_1;
  float32 RL_ObjRelAccelY_1;
  float32 RL_ObjRelVelX_1;
  float32 RL_ObjRelVelY_1;
} SG_SigGroup_460_2_t;

#  define Rte_TypeDef_SG_SigGroup_460_3_t
typedef struct
{
  uint8 RL_ObjAge_1;
  float32 RL_ObjDistYStd_1;
  Rte_DT_SG_SigGroup_460_3_t_2 RL_ObjMotionDirection_1;
  float32 RL_ObjRAccelXStd_1;
  float32 RL_ObjRAccelYStd_1;
  float32 RL_ObjRelVelXStd_1;
  float32 RL_ObjRelVelYStd_1;
  float32 RL_ObjWidth_1;
} SG_SigGroup_460_3_t;

#  define Rte_TypeDef_SG_SigGroup_460_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_460_4_t_0 RL_HWATargetValidity_1;
  float32 RL_ObjHeading_1;
  float32 RL_ObjLength_1;
  float32 RL_ObjRCS_1;
  Rte_DT_SG_SigGroup_460_4_t_4 RL_ObjRefPoint_1;
  float32 RL_ObjYawrate_1;
} SG_SigGroup_460_4_t;

#  define Rte_TypeDef_SG_SigGroup_460_5_Copy_1_t
typedef struct
{
  Rte_DT_SG_SigGroup_460_5_Copy_1_t_0 RL_BLIND;
  float32 RL_Guardrail_dxEnd;
  float32 RL_GuardrailConfidence;
  Rte_DT_SG_SigGroup_460_5_Copy_1_t_3 RL_hdr_ErrorStatus;
  uint8 RL_hdr_TimerStempStatus;
  uint8 RL_hdr_TimeStamp;
  uint8 RL_HEAD_Checksum1;
  uint8 RL_HEAD_RollingCounter1;
  uint8 RL_ObjDetected;
} SG_SigGroup_460_5_Copy_1_t;

#  define Rte_TypeDef_SG_SigGroup_460_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_460_5_t_0 RL_DetSourceOfObj_2;
  float32 RL_ObjDistX_2;
  float32 RL_ObjDistXStd_2;
  float32 RL_ObjDistY_2;
  float32 RL_ObjExistProb_2;
  uint8 RL_ObjID_2;
  float32 RL_ObjObstacleProb_2;
  Rte_DT_SG_SigGroup_460_5_t_7 RL_ObjType_2;
} SG_SigGroup_460_5_t;

#  define Rte_TypeDef_SG_SigGroup_460_6_Copy_1_t
typedef struct
{
  uint64 RL_hdr_AutoSarTimeStamp;
} SG_SigGroup_460_6_Copy_1_t;

#  define Rte_TypeDef_SG_SigGroup_460_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_460_6_t_0 RL_ObjMeasured_2;
  Rte_DT_SG_SigGroup_460_6_t_1 RL_ObjMotionType_2;
  float32 RL_ObjRelAccelX_2;
  float32 RL_ObjRelAccelY_2;
  float32 RL_ObjRelVelX_2;
  float32 RL_ObjRelVelY_2;
} SG_SigGroup_460_6_t;

#  define Rte_TypeDef_SG_SigGroup_460_7_Copy_1_t
typedef struct
{
  float32 RL_GuardrailC0;
  float32 RL_GuardrailC1;
  float32 RL_GuardrailC2;
} SG_SigGroup_460_7_Copy_1_t;

#  define Rte_TypeDef_SG_SigGroup_460_7_t
typedef struct
{
  uint8 RL_ObjAge_2;
  float32 RL_ObjDistYStd_2;
  Rte_DT_SG_SigGroup_460_7_t_2 RL_ObjMotionDirection_2;
  float32 RL_ObjRAccelXStd_2;
  float32 RL_ObjRAccelYStd_2;
  float32 RL_ObjRelVelXStd_2;
  float32 RL_ObjRelVelYStd_2;
  float32 RL_ObjWidth_2;
} SG_SigGroup_460_7_t;

#  define Rte_TypeDef_SG_SigGroup_460_8_Copy_1_t
typedef struct
{
  float32 RL_Guardrail_dxStart;
  float32 RL_GuardrailC3;
  uint8 RL_HEAD_BlockCounter;
  float32 RL_ObjAziAngleCalib;
} SG_SigGroup_460_8_Copy_1_t;

#  define Rte_TypeDef_SG_SigGroup_460_8_t
typedef struct
{
  uint8 RL_1_BlockCounter;
  Rte_DT_SG_SigGroup_460_8_t_1 RL_HWATargetValidity_2;
  float32 RL_ObjHeading_2;
  float32 RL_ObjLength_2;
  float32 RL_ObjRCS_2;
  Rte_DT_SG_SigGroup_460_8_t_5 RL_ObjRefPoint_2;
  float32 RL_ObjYawrate_2;
} SG_SigGroup_460_8_t;

#  define Rte_TypeDef_SG_SigGroup_461_1_t
typedef struct
{
  uint8 RL_2_Checksum1;
  uint8 RL_2_RollingCounter1;
  Rte_DT_SG_SigGroup_461_1_t_2 RL_DetSourceOfObj_3;
  float32 RL_ObjDistX_3;
  float32 RL_ObjDistXStd_3;
  float32 RL_ObjDistY_3;
  float32 RL_ObjExistProb_3;
  uint8 RL_ObjID_3;
  float32 RL_ObjObstacleProb_3;
  Rte_DT_SG_SigGroup_461_1_t_9 RL_ObjType_3;
} SG_SigGroup_461_1_t;

#  define Rte_TypeDef_SG_SigGroup_461_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_461_2_t_0 RL_ObjMeasured_3;
  Rte_DT_SG_SigGroup_461_2_t_1 RL_ObjMotionType_3;
  float32 RL_ObjRelAccelX_3;
  float32 RL_ObjRelAccelY_3;
  float32 RL_ObjRelVelX_3;
  float32 RL_ObjRelVelY_3;
} SG_SigGroup_461_2_t;

#  define Rte_TypeDef_SG_SigGroup_461_3_t
typedef struct
{
  uint8 RL_ObjAge_3;
  float32 RL_ObjDistYStd_3;
  Rte_DT_SG_SigGroup_461_3_t_2 RL_ObjMotionDirection_3;
  float32 RL_ObjRAccelXStd_3;
  float32 RL_ObjRAccelYStd_3;
  float32 RL_ObjRelVelXStd_3;
  float32 RL_ObjRelVelYStd_3;
  float32 RL_ObjWidth_3;
} SG_SigGroup_461_3_t;

#  define Rte_TypeDef_SG_SigGroup_461_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_461_4_t_0 RL_HWATargetValidity_3;
  float32 RL_ObjHeading_3;
  float32 RL_ObjLength_3;
  float32 RL_ObjRCS_3;
  Rte_DT_SG_SigGroup_461_4_t_4 RL_ObjRefPoint_3;
  float32 RL_ObjYawrate_3;
} SG_SigGroup_461_4_t;

#  define Rte_TypeDef_SG_SigGroup_461_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_461_5_t_0 RL_DetSourceOfObj_4;
  uint16 RL_ObjDistX_4;
  uint8 RL_ObjDistXStd_4;
  uint16 RL_ObjDistY_4;
  uint8 RL_ObjExistProb_4;
  uint8 RL_ObjID_4;
  uint8 RL_ObjObstacleProb_4;
  Rte_DT_SG_SigGroup_461_5_t_7 RL_ObjType_4;
} SG_SigGroup_461_5_t;

#  define Rte_TypeDef_SG_SigGroup_461_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_461_6_t_0 RL_ObjMeasured_4;
  Rte_DT_SG_SigGroup_461_6_t_1 RL_ObjMotionType_4;
  float32 RL_ObjRelAccelX_4;
  float32 RL_ObjRelAccelY_4;
  float32 RL_ObjRelVelX_4;
  float32 RL_ObjRelVelY_4;
} SG_SigGroup_461_6_t;

#  define Rte_TypeDef_SG_SigGroup_461_7_t
typedef struct
{
  uint8 RL_ObjAge_4;
  float32 RL_ObjDistYStd_4;
  Rte_DT_SG_SigGroup_461_7_t_2 RL_ObjMotionDirection_4;
  float32 RL_ObjRAccelXStd_4;
  float32 RL_ObjRAccelYStd_4;
  float32 RL_ObjRelVelXStd_4;
  float32 RL_ObjRelVelYStd_4;
  float32 RL_ObjWidth_4;
} SG_SigGroup_461_7_t;

#  define Rte_TypeDef_SG_SigGroup_461_8_t
typedef struct
{
  uint8 RL_2_BlockCounter;
  Rte_DT_SG_SigGroup_461_8_t_1 RL_HWATargetValidity_4;
  float32 RL_ObjHeading_4;
  float32 RL_ObjLength_4;
  float32 RL_ObjRCS_4;
  Rte_DT_SG_SigGroup_461_8_t_5 RL_ObjRefPoint_4;
  float32 RL_ObjYawrate_4;
} SG_SigGroup_461_8_t;

#  define Rte_TypeDef_SG_SigGroup_462_1_t
typedef struct
{
  uint8 RL_3_Checksum1;
  uint8 RL_3_RollingCounter1;
  Rte_DT_SG_SigGroup_462_1_t_2 RL_DetSourceOfObj_5;
  float32 RL_ObjDistX_5;
  float32 RL_ObjDistXStd_5;
  float32 RL_ObjDistY_5;
  float32 RL_ObjExistProb_5;
  uint8 RL_ObjID_5;
  float32 RL_ObjObstacleProb_5;
  Rte_DT_SG_SigGroup_462_1_t_9 RL_ObjType_5;
} SG_SigGroup_462_1_t;

#  define Rte_TypeDef_SG_SigGroup_462_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_462_2_t_0 RL_ObjMeasured_5;
  Rte_DT_SG_SigGroup_462_2_t_1 RL_ObjMotionType_5;
  float32 RL_ObjRelAccelX_5;
  float32 RL_ObjRelAccelY_5;
  float32 RL_ObjRelVelX_5;
  float32 RL_ObjRelVelY_5;
} SG_SigGroup_462_2_t;

#  define Rte_TypeDef_SG_SigGroup_462_3_t
typedef struct
{
  uint8 RL_ObjAge_5;
  float32 RL_ObjDistYStd_5;
  Rte_DT_SG_SigGroup_462_3_t_2 RL_ObjMotionDirection_5;
  float32 RL_ObjRAccelXStd_5;
  float32 RL_ObjRAccelYStd_5;
  float32 RL_ObjRelVelXStd_5;
  float32 RL_ObjRelVelYStd_5;
  float32 RL_ObjWidth_5;
} SG_SigGroup_462_3_t;

#  define Rte_TypeDef_SG_SigGroup_462_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_462_4_t_0 RL_HWATargetValidity_5;
  float32 RL_ObjHeading_5;
  float32 RL_ObjLength_5;
  float32 RL_ObjRCS_5;
  Rte_DT_SG_SigGroup_462_4_t_4 RL_ObjRefPoint_5;
  float32 RL_ObjYawrate_5;
} SG_SigGroup_462_4_t;

#  define Rte_TypeDef_SG_SigGroup_462_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_462_5_t_0 RL_DetSourceOfObj_6;
  float32 RL_ObjDistX_6;
  float32 RL_ObjDistXStd_6;
  float32 RL_ObjDistY_6;
  float32 RL_ObjExistProb_6;
  uint8 RL_ObjID_6;
  float32 RL_ObjObstacleProb_6;
  Rte_DT_SG_SigGroup_462_5_t_7 RL_ObjType_6;
} SG_SigGroup_462_5_t;

#  define Rte_TypeDef_SG_SigGroup_462_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_462_6_t_0 RL_ObjMeasured_6;
  Rte_DT_SG_SigGroup_462_6_t_1 RL_ObjMotionType_6;
  float32 RL_ObjRelAccelX_6;
  float32 RL_ObjRelAccelY_6;
  float32 RL_ObjRelVelX_6;
  float32 RL_ObjRelVelY_6;
} SG_SigGroup_462_6_t;

#  define Rte_TypeDef_SG_SigGroup_462_7_t
typedef struct
{
  uint8 RL_ObjAge_6;
  float32 RL_ObjDistYStd_6;
  Rte_DT_SG_SigGroup_462_7_t_2 RL_ObjMotionDirection_6;
  float32 RL_ObjRAccelXStd_6;
  float32 RL_ObjRAccelYStd_6;
  float32 RL_ObjRelVelXStd_6;
  float32 RL_ObjRelVelYStd_6;
  float32 RL_ObjWidth_6;
} SG_SigGroup_462_7_t;

#  define Rte_TypeDef_SG_SigGroup_462_8_t
typedef struct
{
  uint8 RL_3_BlockCounter;
  Rte_DT_SG_SigGroup_462_8_t_1 RL_HWATargetValidity_6;
  float32 RL_ObjHeading_6;
  float32 RL_ObjLength_6;
  float32 RL_ObjRCS_6;
  Rte_DT_SG_SigGroup_462_8_t_5 RL_ObjRefPoint_6;
  float32 RL_ObjYawrate_6;
} SG_SigGroup_462_8_t;

#  define Rte_TypeDef_SG_SigGroup_463_1_t
typedef struct
{
  uint8 RL_4_Checksum1;
  uint8 RL_4_RollingCounter1;
  Rte_DT_SG_SigGroup_463_1_t_2 RL_DetSourceOfObj_7;
  float32 RL_ObjDistX_7;
  float32 RL_ObjDistXStd_7;
  float32 RL_ObjDistY_7;
  float32 RL_ObjExistProb_7;
  uint8 RL_ObjID_7;
  float32 RL_ObjObstacleProb_7;
  Rte_DT_SG_SigGroup_463_1_t_9 RL_ObjType_7;
} SG_SigGroup_463_1_t;

#  define Rte_TypeDef_SG_SigGroup_463_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_463_2_t_0 RL_ObjMeasured_7;
  Rte_DT_SG_SigGroup_463_2_t_1 RL_ObjMotionType_7;
  float32 RL_ObjRelAccelX_7;
  float32 RL_ObjRelAccelY_7;
  float32 RL_ObjRelVelX_7;
  float32 RL_ObjRelVelY_7;
} SG_SigGroup_463_2_t;

#  define Rte_TypeDef_SG_SigGroup_463_3_t
typedef struct
{
  uint8 RL_ObjAge_7;
  float32 RL_ObjDistYStd_7;
  Rte_DT_SG_SigGroup_463_3_t_2 RL_ObjMotionDirection_7;
  float32 RL_ObjRAccelXStd_7;
  float32 RL_ObjRAccelYStd_7;
  float32 RL_ObjRelVelXStd_7;
  float32 RL_ObjRelVelYStd_7;
  float32 RL_ObjWidth_7;
} SG_SigGroup_463_3_t;

#  define Rte_TypeDef_SG_SigGroup_463_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_463_4_t_0 RL_HWATargetValidity_7;
  float32 RL_ObjHeading_7;
  float32 RL_ObjLength_7;
  float32 RL_ObjRCS_7;
  Rte_DT_SG_SigGroup_463_4_t_4 RL_ObjRefPoint_7;
  float32 RL_ObjYawrate_7;
} SG_SigGroup_463_4_t;

#  define Rte_TypeDef_SG_SigGroup_463_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_463_5_t_0 RL_DetSourceOfObj_8;
  float32 RL_ObjDistX_8;
  float32 RL_ObjDistXStd_8;
  float32 RL_ObjDistY_8;
  float32 RL_ObjExistProb_8;
  uint8 RL_ObjID_8;
  float32 RL_ObjObstacleProb_8;
  Rte_DT_SG_SigGroup_463_5_t_7 RL_ObjType_8;
} SG_SigGroup_463_5_t;

#  define Rte_TypeDef_SG_SigGroup_463_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_463_6_t_0 RL_ObjMeasured_8;
  Rte_DT_SG_SigGroup_463_6_t_1 RL_ObjMotionType_8;
  float32 RL_ObjRelAccelX_8;
  float32 RL_ObjRelAccelY_8;
  float32 RL_ObjRelVelX_8;
  float32 RL_ObjRelVelY_8;
} SG_SigGroup_463_6_t;

#  define Rte_TypeDef_SG_SigGroup_463_7_t
typedef struct
{
  uint8 RL_ObjAge_8;
  float32 RL_ObjDistYStd_8;
  Rte_DT_SG_SigGroup_463_7_t_2 RL_ObjMotionDirection_8;
  float32 RL_ObjRAccelXStd_8;
  float32 RL_ObjRAccelYStd_8;
  float32 RL_ObjRelVelXStd_8;
  float32 RL_ObjRelVelYStd_8;
  float32 RL_ObjWidth_8;
} SG_SigGroup_463_7_t;

#  define Rte_TypeDef_SG_SigGroup_463_8_t
typedef struct
{
  uint8 RL_4_BlockCounter;
  Rte_DT_SG_SigGroup_463_8_t_1 RL_HWATargetValidity_8;
  float32 RL_ObjHeading_8;
  float32 RL_ObjLength_8;
  float32 RL_ObjRCS_8;
  Rte_DT_SG_SigGroup_463_8_t_5 RL_ObjRefPoint_8;
  float32 RL_ObjYawrate_8;
} SG_SigGroup_463_8_t;

#  define Rte_TypeDef_SG_SigGroup_464_1_t
typedef struct
{
  uint8 RL_5_Checksum1;
  uint8 RL_5_RollingCounter1;
  Rte_DT_SG_SigGroup_464_1_t_2 RL_DetSourceOfObj_9;
  float32 RL_ObjDistX_9;
  float32 RL_ObjDistXStd_9;
  float32 RL_ObjDistY_9;
  float32 RL_ObjExistProb_9;
  uint8 RL_ObjID_9;
  float32 RL_ObjObstacleProb_9;
  Rte_DT_SG_SigGroup_464_1_t_9 RL_ObjType_9;
} SG_SigGroup_464_1_t;

#  define Rte_TypeDef_SG_SigGroup_464_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_464_2_t_0 RL_ObjMeasured_9;
  Rte_DT_SG_SigGroup_464_2_t_1 RL_ObjMotionType_9;
  float32 RL_ObjRelAccelX_9;
  float32 RL_ObjRelAccelY_9;
  float32 RL_ObjRelVelX_9;
  float32 RL_ObjRelVelY_9;
} SG_SigGroup_464_2_t;

#  define Rte_TypeDef_SG_SigGroup_464_3_t
typedef struct
{
  uint8 RL_ObjAge_9;
  float32 RL_ObjDistYStd_9;
  Rte_DT_SG_SigGroup_464_3_t_2 RL_ObjMotionDirection_9;
  float32 RL_ObjRAccelXStd_9;
  float32 RL_ObjRAccelYStd_9;
  float32 RL_ObjRelVelXStd_9;
  float32 RL_ObjRelVelYStd_9;
  float32 RL_ObjWidth_9;
} SG_SigGroup_464_3_t;

#  define Rte_TypeDef_SG_SigGroup_464_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_464_4_t_0 RL_HWATargetValidity_9;
  float32 RL_ObjHeading_9;
  float32 RL_ObjLength_9;
  float32 RL_ObjRCS_9;
  Rte_DT_SG_SigGroup_464_4_t_4 RL_ObjRefPoint_9;
  float32 RL_ObjYawrate_9;
} SG_SigGroup_464_4_t;

#  define Rte_TypeDef_SG_SigGroup_464_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_464_5_t_0 RL_DetSourceOfObj_10;
  float32 RL_ObjDistX_10;
  float32 RL_ObjDistXStd_10;
  float32 RL_ObjDistY_10;
  float32 RL_ObjExistProb_10;
  uint8 RL_ObjID_10;
  float32 RL_ObjObstacleProb_10;
  Rte_DT_SG_SigGroup_464_5_t_7 RL_ObjType_10;
} SG_SigGroup_464_5_t;

#  define Rte_TypeDef_SG_SigGroup_464_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_464_6_t_0 RL_ObjMeasured_10;
  Rte_DT_SG_SigGroup_464_6_t_1 RL_ObjMotionType_10;
  float32 RL_ObjRelAccelX_10;
  float32 RL_ObjRelAccelY_10;
  float32 RL_ObjRelVelX_10;
  float32 RL_ObjRelVelY_10;
} SG_SigGroup_464_6_t;

#  define Rte_TypeDef_SG_SigGroup_464_7_t
typedef struct
{
  uint8 RL_ObjAge_10;
  float32 RL_ObjDistYStd_10;
  Rte_DT_SG_SigGroup_464_7_t_2 RL_ObjMotionDirection_10;
  float32 RL_ObjRAccelXStd_10;
  float32 RL_ObjRAccelYStd_10;
  float32 RL_ObjRelVelXStd_10;
  float32 RL_ObjRelVelYStd_10;
  float32 RL_ObjWidth_10;
} SG_SigGroup_464_7_t;

#  define Rte_TypeDef_SG_SigGroup_464_8_t
typedef struct
{
  uint8 RL_5_BlockCounter;
  Rte_DT_SG_SigGroup_464_8_t_1 RL_HWATargetValidity_10;
  float32 RL_ObjHeading_10;
  float32 RL_ObjLength_10;
  float32 RL_ObjRCS_10;
  Rte_DT_SG_SigGroup_464_8_t_5 RL_ObjRefPoint_10;
  float32 RL_ObjYawrate_10;
} SG_SigGroup_464_8_t;

#  define Rte_TypeDef_SG_SigGroup_465_1_t
typedef struct
{
  uint8 RL_6_Checksum1;
  uint8 RL_6_RollingCounter1;
  Rte_DT_SG_SigGroup_465_1_t_2 RL_DetSourceOfObj_11;
  float32 RL_ObjDistX_11;
  float32 RL_ObjDistXStd_11;
  float32 RL_ObjDistY_11;
  float32 RL_ObjExistProb_11;
  uint8 RL_ObjID_11;
  float32 RL_ObjObstacleProb_11;
  Rte_DT_SG_SigGroup_465_1_t_9 RL_ObjType_11;
} SG_SigGroup_465_1_t;

#  define Rte_TypeDef_SG_SigGroup_465_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_465_2_t_0 RL_ObjMeasured_11;
  Rte_DT_SG_SigGroup_465_2_t_1 RL_ObjMotionType_11;
  float32 RL_ObjRelAccelX_11;
  float32 RL_ObjRelAccelY_11;
  float32 RL_ObjRelVelX_11;
  float32 RL_ObjRelVelY_11;
} SG_SigGroup_465_2_t;

#  define Rte_TypeDef_SG_SigGroup_465_3_t
typedef struct
{
  uint8 RL_ObjAge_11;
  float32 RL_ObjDistYStd_11;
  Rte_DT_SG_SigGroup_465_3_t_2 RL_ObjMotionDirection_11;
  float32 RL_ObjRAccelXStd_11;
  float32 RL_ObjRAccelYStd_11;
  float32 RL_ObjRelVelXStd_11;
  float32 RL_ObjRelVelYStd_11;
  float32 RL_ObjWidth_11;
} SG_SigGroup_465_3_t;

#  define Rte_TypeDef_SG_SigGroup_465_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_465_4_t_0 RL_HWATargetValidity_11;
  float32 RL_ObjHeading_11;
  float32 RL_ObjLength_11;
  float32 RL_ObjRCS_11;
  Rte_DT_SG_SigGroup_465_4_t_4 RL_ObjRefPoint_11;
  float32 RL_ObjYawrate_11;
} SG_SigGroup_465_4_t;

#  define Rte_TypeDef_SG_SigGroup_465_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_465_5_t_0 RL_DetSourceOfObj_12;
  float32 RL_ObjDistX_12;
  float32 RL_ObjDistXStd_12;
  float32 RL_ObjDistY_12;
  float32 RL_ObjExistProb_12;
  uint8 RL_ObjID_12;
  float32 RL_ObjObstacleProb_12;
  Rte_DT_SG_SigGroup_465_5_t_7 RL_ObjType_12;
} SG_SigGroup_465_5_t;

#  define Rte_TypeDef_SG_SigGroup_465_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_465_6_t_0 RL_ObjMeasured_12;
  Rte_DT_SG_SigGroup_465_6_t_1 RL_ObjMotionType_12;
  float32 RL_ObjRelAccelX_12;
  float32 RL_ObjRelAccelY_12;
  float32 RL_ObjRelVelX_12;
  float32 RL_ObjRelVelY_12;
} SG_SigGroup_465_6_t;

#  define Rte_TypeDef_SG_SigGroup_465_7_t
typedef struct
{
  uint8 RL_ObjAge_12;
  float32 RL_ObjDistYStd_12;
  Rte_DT_SG_SigGroup_465_7_t_2 RL_ObjMotionDirection_12;
  float32 RL_ObjRAccelXStd_12;
  float32 RL_ObjRAccelYStd_12;
  float32 RL_ObjRelVelXStd_12;
  float32 RL_ObjRelVelYStd_12;
  float32 RL_ObjWidth_12;
} SG_SigGroup_465_7_t;

#  define Rte_TypeDef_SG_SigGroup_465_8_t
typedef struct
{
  uint8 RL_6_BlockCounter;
  Rte_DT_SG_SigGroup_465_8_t_1 RL_HWATargetValidity_12;
  float32 RL_ObjHeading_12;
  float32 RL_ObjLength_12;
  float32 RL_ObjRCS_12;
  Rte_DT_SG_SigGroup_465_8_t_5 RL_ObjRefPoint_12;
  float32 RL_ObjYawrate_12;
} SG_SigGroup_465_8_t;

#  define Rte_TypeDef_SG_SigGroup_466_1_t
typedef struct
{
  uint8 RL_7_Checksum1;
  uint8 RL_7_RollingCounter1;
  Rte_DT_SG_SigGroup_466_1_t_2 RL_DetSourceOfObj_13;
  float32 RL_ObjDistX_13;
  float32 RL_ObjDistXStd_13;
  float32 RL_ObjDistY_13;
  float32 RL_ObjExistProb_13;
  uint8 RL_ObjID_13;
  float32 RL_ObjObstacleProb_13;
  Rte_DT_SG_SigGroup_466_1_t_9 RL_ObjType_13;
} SG_SigGroup_466_1_t;

#  define Rte_TypeDef_SG_SigGroup_466_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_466_2_t_0 RL_ObjMeasured_13;
  Rte_DT_SG_SigGroup_466_2_t_1 RL_ObjMotionType_13;
  float32 RL_ObjRelAccelX_13;
  float32 RL_ObjRelAccelY_13;
  float32 RL_ObjRelVelX_13;
  float32 RL_ObjRelVelY_13;
} SG_SigGroup_466_2_t;

#  define Rte_TypeDef_SG_SigGroup_466_3_t
typedef struct
{
  uint8 RL_ObjAge_13;
  float32 RL_ObjDistYStd_13;
  Rte_DT_SG_SigGroup_466_3_t_2 RL_ObjMotionDirection_13;
  float32 RL_ObjRAccelXStd_13;
  float32 RL_ObjRAccelYStd_13;
  float32 RL_ObjRelVelXStd_13;
  float32 RL_ObjRelVelYStd_13;
  float32 RL_ObjWidth_13;
} SG_SigGroup_466_3_t;

#  define Rte_TypeDef_SG_SigGroup_466_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_466_4_t_0 RL_HWATargetValidity_13;
  float32 RL_ObjHeading_13;
  float32 RL_ObjLength_13;
  float32 RL_ObjRCS_13;
  Rte_DT_SG_SigGroup_466_4_t_4 RL_ObjRefPoint_13;
  float32 RL_ObjYawrate_13;
} SG_SigGroup_466_4_t;

#  define Rte_TypeDef_SG_SigGroup_466_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_466_5_t_0 RL_DetSourceOfObj_14;
  float32 RL_ObjDistX_14;
  float32 RL_ObjDistXStd_14;
  float32 RL_ObjDistY_14;
  float32 RL_ObjExistProb_14;
  uint8 RL_ObjID_14;
  float32 RL_ObjObstacleProb_14;
  Rte_DT_SG_SigGroup_466_5_t_7 RL_ObjType_14;
} SG_SigGroup_466_5_t;

#  define Rte_TypeDef_SG_SigGroup_466_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_466_6_t_0 RL_ObjMeasured_14;
  Rte_DT_SG_SigGroup_466_6_t_1 RL_ObjMotionType_14;
  float32 RL_ObjRelAccelX_14;
  float32 RL_ObjRelAccelY_14;
  float32 RL_ObjRelVelX_14;
  float32 RL_ObjRelVelY_14;
} SG_SigGroup_466_6_t;

#  define Rte_TypeDef_SG_SigGroup_466_7_t
typedef struct
{
  uint8 RL_ObjAge_14;
  float32 RL_ObjDistYStd_14;
  Rte_DT_SG_SigGroup_466_7_t_2 RL_ObjMotionDirection_14;
  float32 RL_ObjRAccelXStd_14;
  float32 RL_ObjRAccelYStd_14;
  float32 RL_ObjRelVelXStd_14;
  float32 RL_ObjRelVelYStd_14;
  float32 RL_ObjWidth_14;
} SG_SigGroup_466_7_t;

#  define Rte_TypeDef_SG_SigGroup_466_8_t
typedef struct
{
  uint8 RL_7_BlockCounter;
  Rte_DT_SG_SigGroup_466_8_t_1 RL_HWATargetValidity_14;
  float32 RL_ObjHeading_14;
  float32 RL_ObjLength_14;
  float32 RL_ObjRCS_14;
  Rte_DT_SG_SigGroup_466_8_t_5 RL_ObjRefPoint_14;
  float32 RL_ObjYawrate_14;
} SG_SigGroup_466_8_t;

#  define Rte_TypeDef_SG_SigGroup_467_1_t
typedef struct
{
  uint8 RL_8_Checksum1;
  uint8 RL_8_RollingCounter1;
  Rte_DT_SG_SigGroup_467_1_t_2 RL_DetSourceOfObj_15;
  float32 RL_ObjDistX_15;
  float32 RL_ObjDistXStd_15;
  float32 RL_ObjDistY_15;
  float32 RL_ObjExistProb_15;
  uint8 RL_ObjID_15;
  float32 RL_ObjObstacleProb_15;
  Rte_DT_SG_SigGroup_467_1_t_9 RL_ObjType_15;
} SG_SigGroup_467_1_t;

#  define Rte_TypeDef_SG_SigGroup_467_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_467_2_t_0 RL_ObjMeasured_15;
  Rte_DT_SG_SigGroup_467_2_t_1 RL_ObjMotionType_15;
  float32 RL_ObjRelAccelX_15;
  float32 RL_ObjRelAccelY_15;
  float32 RL_ObjRelVelX_15;
  float32 RL_ObjRelVelY_15;
} SG_SigGroup_467_2_t;

#  define Rte_TypeDef_SG_SigGroup_467_3_t
typedef struct
{
  uint8 RL_ObjAge_15;
  float32 RL_ObjDistYStd_15;
  Rte_DT_SG_SigGroup_467_3_t_2 RL_ObjMotionDirection_15;
  float32 RL_ObjRAccelXStd_15;
  float32 RL_ObjRAccelYStd_15;
  float32 RL_ObjRelVelXStd_15;
  float32 RL_ObjRelVelYStd_15;
  float32 RL_ObjWidth_15;
} SG_SigGroup_467_3_t;

#  define Rte_TypeDef_SG_SigGroup_467_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_467_4_t_0 RL_HWATargetValidity_15;
  float32 RL_ObjHeading_15;
  float32 RL_ObjLength_15;
  float32 RL_ObjRCS_15;
  Rte_DT_SG_SigGroup_467_4_t_4 RL_ObjRefPoint_15;
  float32 RL_ObjYawrate_15;
} SG_SigGroup_467_4_t;

#  define Rte_TypeDef_SG_SigGroup_467_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_467_5_t_0 RL_DetSourceOfObj_16;
  float32 RL_ObjDistX_16;
  float32 RL_ObjDistXStd_16;
  float32 RL_ObjDistY_16;
  float32 RL_ObjExistProb_16;
  uint8 RL_ObjID_16;
  float32 RL_ObjObstacleProb_16;
  Rte_DT_SG_SigGroup_467_5_t_7 RL_ObjType_16;
} SG_SigGroup_467_5_t;

#  define Rte_TypeDef_SG_SigGroup_467_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_467_6_t_0 RL_ObjMeasured_16;
  Rte_DT_SG_SigGroup_467_6_t_1 RL_ObjMotionType_16;
  float32 RL_ObjRelAccelX_16;
  float32 RL_ObjRelAccelY_16;
  float32 RL_ObjRelVelX_16;
  float32 RL_ObjRelVelY_16;
} SG_SigGroup_467_6_t;

#  define Rte_TypeDef_SG_SigGroup_467_7_t
typedef struct
{
  uint8 RL_ObjAge_16;
  float32 RL_ObjDistYStd_16;
  Rte_DT_SG_SigGroup_467_7_t_2 RL_ObjMotionDirection_16;
  float32 RL_ObjRAccelXStd_16;
  float32 RL_ObjRAccelYStd_16;
  float32 RL_ObjRelVelXStd_16;
  float32 RL_ObjRelVelYStd_16;
  float32 RL_ObjWidth_16;
} SG_SigGroup_467_7_t;

#  define Rte_TypeDef_SG_SigGroup_467_8_t
typedef struct
{
  uint8 RL_8_BlockCounter;
  Rte_DT_SG_SigGroup_467_8_t_1 RL_HWATargetValidity_16;
  float32 RL_ObjHeading_16;
  float32 RL_ObjLength_16;
  float32 RL_ObjRCS_16;
  Rte_DT_SG_SigGroup_467_8_t_5 RL_ObjRefPoint_16;
  float32 RL_ObjYawrate_16;
} SG_SigGroup_467_8_t;

#  define Rte_TypeDef_SG_SigGroup_560_1_Copy_1_t
typedef struct
{
  uint8 RR_BLIND;
  float32 RR_Guardrail_dxEnd;
  float32 RR_GuardrailConfidence;
  uint8 RR_hdr_ErrorStatus;
  uint8 RR_hdr_TimerStempStatus;
  uint8 RR_hdr_TimeStamp;
  uint8 RR_HEAD_Checksum1;
  uint8 RR_HEAD_RollingCounter1;
  uint8 RR_ObjDetected;
} SG_SigGroup_560_1_Copy_1_t;

#  define Rte_TypeDef_SG_SigGroup_560_1_t
typedef struct
{
  uint8 RR_1_Checksum1;
  uint8 RR_1_RollingCounter1;
  Rte_DT_SG_SigGroup_560_1_t_2 RR_DetSourceOfObj_1;
  float32 RR_ObjDistX_1;
  float32 RR_ObjDistXStd_1;
  float32 RR_ObjDistY_1;
  float32 RR_ObjExistProb_1;
  uint8 RR_ObjID_1;
  float32 RR_ObjObstacleProb_1;
  Rte_DT_SG_SigGroup_560_1_t_9 RR_ObjType_1;
} SG_SigGroup_560_1_t;

#  define Rte_TypeDef_SG_SigGroup_560_2_Copy_1_t
typedef struct
{
  uint64 RR_hdr_AutoSarTimeStamp;
} SG_SigGroup_560_2_Copy_1_t;

#  define Rte_TypeDef_SG_SigGroup_560_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_560_2_t_0 RR_ObjMeasured_1;
  Rte_DT_SG_SigGroup_560_2_t_1 RR_ObjMotionType_1;
  float32 RR_ObjRelAccelX_1;
  float32 RR_ObjRelAccelY_1;
  float32 RR_ObjRelVelX_1;
  float32 RR_ObjRelVelY_1;
} SG_SigGroup_560_2_t;

#  define Rte_TypeDef_SG_SigGroup_560_3_Copy_1_t
typedef struct
{
  float32 RR_GuardrailC0;
  float32 RR_GuardrailC1;
  float32 RR_GuardrailC2;
} SG_SigGroup_560_3_Copy_1_t;

#  define Rte_TypeDef_SG_SigGroup_560_3_t
typedef struct
{
  uint8 RR_ObjAge_1;
  float32 RR_ObjDistYStd_1;
  Rte_DT_SG_SigGroup_560_3_t_2 RR_ObjMotionDirection_1;
  float32 RR_ObjRAccelXStd_1;
  float32 RR_ObjRAccelYStd_1;
  float32 RR_ObjRelVelXStd_1;
  float32 RR_ObjRelVelYStd_1;
  float32 RR_ObjWidth_1;
} SG_SigGroup_560_3_t;

#  define Rte_TypeDef_SG_SigGroup_560_4_Copy_1_t
typedef struct
{
  float32 RR_Guardrail_dxStart;
  float32 RR_GuardrailC3;
  uint8 RR_HEAD_BlockCounter;
  float32 RR_ObjAziAngleCalib;
} SG_SigGroup_560_4_Copy_1_t;

#  define Rte_TypeDef_SG_SigGroup_560_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_560_4_t_0 RR_HWATargetValidity_1;
  float32 RR_ObjHeading_1;
  float32 RR_ObjLength_1;
  float32 RR_ObjRCS_1;
  Rte_DT_SG_SigGroup_560_4_t_4 RR_ObjRefPoint_1;
  float32 RR_ObjYawrate_1;
} SG_SigGroup_560_4_t;

#  define Rte_TypeDef_SG_SigGroup_560_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_560_5_t_0 RR_DetSourceOfObj_2;
  float32 RR_ObjDistX_2;
  float32 RR_ObjDistXStd_2;
  float32 RR_ObjDistY_2;
  float32 RR_ObjExistProb_2;
  uint8 RR_ObjID_2;
  float32 RR_ObjObstacleProb_2;
  Rte_DT_SG_SigGroup_560_5_t_7 RR_ObjType_2;
} SG_SigGroup_560_5_t;

#  define Rte_TypeDef_SG_SigGroup_560_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_560_6_t_0 RR_ObjMeasured_2;
  Rte_DT_SG_SigGroup_560_6_t_1 RR_ObjMotionType_2;
  float32 RR_ObjRelAccelX_2;
  float32 RR_ObjRelAccelY_2;
  float32 RR_ObjRelVelX_2;
  float32 RR_ObjRelVelY_2;
} SG_SigGroup_560_6_t;

#  define Rte_TypeDef_SG_SigGroup_560_7_t
typedef struct
{
  uint8 RR_ObjAge_2;
  float32 RR_ObjDistYStd_2;
  Rte_DT_SG_SigGroup_560_7_t_2 RR_ObjMotionDirection_2;
  float32 RR_ObjRAccelXStd_2;
  float32 RR_ObjRAccelYStd_2;
  float32 RR_ObjRelVelXStd_2;
  float32 RR_ObjRelVelYStd_2;
  float32 RR_ObjWidth_2;
} SG_SigGroup_560_7_t;

#  define Rte_TypeDef_SG_SigGroup_560_8_t
typedef struct
{
  uint8 RR_1_BlockCounter;
  Rte_DT_SG_SigGroup_560_8_t_1 RR_HWATargetValidity_2;
  float32 RR_ObjHeading_2;
  float32 RR_ObjLength_2;
  float32 RR_ObjRCS_2;
  Rte_DT_SG_SigGroup_560_8_t_5 RR_ObjRefPoint_2;
  float32 RR_ObjYawrate_2;
} SG_SigGroup_560_8_t;

#  define Rte_TypeDef_SG_SigGroup_561_1_t
typedef struct
{
  uint8 RR_2_Checksum1;
  uint8 RR_2_RollingCounter1;
  Rte_DT_SG_SigGroup_561_1_t_2 RR_DetSourceOfObj_3;
  float32 RR_ObjDistX_3;
  float32 RR_ObjDistXStd_3;
  float32 RR_ObjDistY_3;
  float32 RR_ObjExistProb_3;
  uint8 RR_ObjID_3;
  float32 RR_ObjObstacleProb_3;
  Rte_DT_SG_SigGroup_561_1_t_9 RR_ObjType_3;
} SG_SigGroup_561_1_t;

#  define Rte_TypeDef_SG_SigGroup_561_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_561_2_t_0 RR_ObjMeasured_3;
  Rte_DT_SG_SigGroup_561_2_t_1 RR_ObjMotionType_3;
  float32 RR_ObjRelAccelX_3;
  float32 RR_ObjRelAccelY_3;
  float32 RR_ObjRelVelX_3;
  float32 RR_ObjRelVelY_3;
} SG_SigGroup_561_2_t;

#  define Rte_TypeDef_SG_SigGroup_561_3_t
typedef struct
{
  uint8 RR_ObjAge_3;
  float32 RR_ObjDistYStd_3;
  Rte_DT_SG_SigGroup_561_3_t_2 RR_ObjMotionDirection_3;
  float32 RR_ObjRAccelXStd_3;
  float32 RR_ObjRAccelYStd_3;
  float32 RR_ObjRelVelXStd_3;
  float32 RR_ObjRelVelYStd_3;
  float32 RR_ObjWidth_3;
} SG_SigGroup_561_3_t;

#  define Rte_TypeDef_SG_SigGroup_561_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_561_4_t_0 RR_HWATargetValidity_3;
  float32 RR_ObjHeading_3;
  float32 RR_ObjLength_3;
  float32 RR_ObjRCS_3;
  Rte_DT_SG_SigGroup_561_4_t_4 RR_ObjRefPoint_3;
  float32 RR_ObjYawrate_3;
} SG_SigGroup_561_4_t;

#  define Rte_TypeDef_SG_SigGroup_561_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_561_5_t_0 RR_DetSourceOfObj_4;
  float32 RR_ObjDistX_4;
  float32 RR_ObjDistXStd_4;
  float32 RR_ObjDistY_4;
  float32 RR_ObjExistProb_4;
  uint8 RR_ObjID_4;
  float32 RR_ObjObstacleProb_4;
  Rte_DT_SG_SigGroup_561_5_t_7 RR_ObjType_4;
} SG_SigGroup_561_5_t;

#  define Rte_TypeDef_SG_SigGroup_561_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_561_6_t_0 RR_ObjMeasured_4;
  Rte_DT_SG_SigGroup_561_6_t_1 RR_ObjMotionType_4;
  float32 RR_ObjRelAccelX_4;
  float32 RR_ObjRelAccelY_4;
  float32 RR_ObjRelVelX_4;
  float32 RR_ObjRelVelY_4;
} SG_SigGroup_561_6_t;

#  define Rte_TypeDef_SG_SigGroup_561_7_t
typedef struct
{
  uint8 RR_ObjAge_4;
  float32 RR_ObjDistYStd_4;
  Rte_DT_SG_SigGroup_561_7_t_2 RR_ObjMotionDirection_4;
  float32 RR_ObjRAccelXStd_4;
  float32 RR_ObjRAccelYStd_4;
  float32 RR_ObjRelVelXStd_4;
  float32 RR_ObjRelVelYStd_4;
  float32 RR_ObjWidth_4;
} SG_SigGroup_561_7_t;

#  define Rte_TypeDef_SG_SigGroup_561_8_t
typedef struct
{
  uint8 RR_2_BlockCounter;
  Rte_DT_SG_SigGroup_561_8_t_1 RR_HWATargetValidity_4;
  float32 RR_ObjHeading_4;
  float32 RR_ObjLength_4;
  float32 RR_ObjRCS_4;
  Rte_DT_SG_SigGroup_561_8_t_5 RR_ObjRefPoint_4;
  float32 RR_ObjYawrate_4;
} SG_SigGroup_561_8_t;

#  define Rte_TypeDef_SG_SigGroup_562_1_t
typedef struct
{
  uint8 RR_3_Checksum1;
  uint8 RR_3_RollingCounter1;
  Rte_DT_SG_SigGroup_562_1_t_2 RR_DetSourceOfObj_5;
  float32 RR_ObjDistX_5;
  float32 RR_ObjDistXStd_5;
  float32 RR_ObjDistY_5;
  float32 RR_ObjExistProb_5;
  uint8 RR_ObjID_5;
  float32 RR_ObjObstacleProb_5;
  Rte_DT_SG_SigGroup_562_1_t_9 RR_ObjType_5;
} SG_SigGroup_562_1_t;

#  define Rte_TypeDef_SG_SigGroup_562_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_562_2_t_0 RR_ObjMeasured_5;
  Rte_DT_SG_SigGroup_562_2_t_1 RR_ObjMotionType_5;
  float32 RR_ObjRelAccelX_5;
  float32 RR_ObjRelAccelY_5;
  float32 RR_ObjRelVelX_5;
  float32 RR_ObjRelVelY_5;
} SG_SigGroup_562_2_t;

#  define Rte_TypeDef_SG_SigGroup_562_3_t
typedef struct
{
  uint8 RR_ObjAge_5;
  float32 RR_ObjDistYStd_5;
  Rte_DT_SG_SigGroup_562_3_t_2 RR_ObjMotionDirection_5;
  float32 RR_ObjRAccelXStd_5;
  float32 RR_ObjRAccelYStd_5;
  float32 RR_ObjRelVelXStd_5;
  float32 RR_ObjRelVelYStd_5;
  float32 RR_ObjWidth_5;
} SG_SigGroup_562_3_t;

#  define Rte_TypeDef_SG_SigGroup_562_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_562_4_t_0 RR_HWATargetValidity_5;
  float32 RR_ObjHeading_5;
  float32 RR_ObjLength_5;
  float32 RR_ObjRCS_5;
  Rte_DT_SG_SigGroup_562_4_t_4 RR_ObjRefPoint_5;
  float32 RR_ObjYawrate_5;
} SG_SigGroup_562_4_t;

#  define Rte_TypeDef_SG_SigGroup_562_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_562_5_t_0 RR_DetSourceOfObj_6;
  float32 RR_ObjDistX_6;
  float32 RR_ObjDistXStd_6;
  float32 RR_ObjDistY_6;
  float32 RR_ObjExistProb_6;
  uint8 RR_ObjID_6;
  float32 RR_ObjObstacleProb_6;
  Rte_DT_SG_SigGroup_562_5_t_7 RR_ObjType_6;
} SG_SigGroup_562_5_t;

#  define Rte_TypeDef_SG_SigGroup_562_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_562_6_t_0 RR_ObjMeasured_6;
  Rte_DT_SG_SigGroup_562_6_t_1 RR_ObjMotionType_6;
  float32 RR_ObjRelAccelX_6;
  float32 RR_ObjRelAccelY_6;
  float32 RR_ObjRelVelX_6;
  float32 RR_ObjRelVelY_6;
} SG_SigGroup_562_6_t;

#  define Rte_TypeDef_SG_SigGroup_562_7_t
typedef struct
{
  uint8 RR_ObjAge_6;
  float32 RR_ObjDistYStd_6;
  Rte_DT_SG_SigGroup_562_7_t_2 RR_ObjMotionDirection_6;
  float32 RR_ObjRAccelXStd_6;
  float32 RR_ObjRAccelYStd_6;
  float32 RR_ObjRelVelXStd_6;
  float32 RR_ObjRelVelYStd_6;
  float32 RR_ObjWidth_6;
} SG_SigGroup_562_7_t;

#  define Rte_TypeDef_SG_SigGroup_562_8_t
typedef struct
{
  uint8 RR_3_BlockCounter;
  Rte_DT_SG_SigGroup_562_8_t_1 RR_HWATargetValidity_6;
  float32 RR_ObjHeading_6;
  float32 RR_ObjLength_6;
  float32 RR_ObjRCS_6;
  Rte_DT_SG_SigGroup_562_8_t_5 RR_ObjRefPoint_6;
  float32 RR_ObjYawrate_6;
} SG_SigGroup_562_8_t;

#  define Rte_TypeDef_SG_SigGroup_563_1_t
typedef struct
{
  uint8 RR_4_Checksum1;
  uint8 RR_4_RollingCounter1;
  Rte_DT_SG_SigGroup_563_1_t_2 RR_DetSourceOfObj_7;
  float32 RR_ObjDistX_7;
  float32 RR_ObjDistXStd_7;
  float32 RR_ObjDistY_7;
  float32 RR_ObjExistProb_7;
  uint8 RR_ObjID_7;
  float32 RR_ObjObstacleProb_7;
  Rte_DT_SG_SigGroup_563_1_t_9 RR_ObjType_7;
} SG_SigGroup_563_1_t;

#  define Rte_TypeDef_SG_SigGroup_563_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_563_2_t_0 RR_ObjMeasured_7;
  Rte_DT_SG_SigGroup_563_2_t_1 RR_ObjMotionType_7;
  float32 RR_ObjRelAccelX_7;
  float32 RR_ObjRelAccelY_7;
  float32 RR_ObjRelVelX_7;
  float32 RR_ObjRelVelY_7;
} SG_SigGroup_563_2_t;

#  define Rte_TypeDef_SG_SigGroup_563_3_t
typedef struct
{
  uint8 RR_ObjAge_7;
  float32 RR_ObjDistYStd_7;
  Rte_DT_SG_SigGroup_563_3_t_2 RR_ObjMotionDirection_7;
  float32 RR_ObjRAccelXStd_7;
  float32 RR_ObjRAccelYStd_7;
  float32 RR_ObjRelVelXStd_7;
  float32 RR_ObjRelVelYStd_7;
  float32 RR_ObjWidth_7;
} SG_SigGroup_563_3_t;

#  define Rte_TypeDef_SG_SigGroup_563_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_563_4_t_0 RR_HWATargetValidity_7;
  float32 RR_ObjHeading_7;
  float32 RR_ObjLength_7;
  float32 RR_ObjRCS_7;
  Rte_DT_SG_SigGroup_563_4_t_4 RR_ObjRefPoint_7;
  float32 RR_ObjYawrate_7;
} SG_SigGroup_563_4_t;

#  define Rte_TypeDef_SG_SigGroup_563_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_563_5_t_0 RR_DetSourceOfObj_8;
  float32 RR_ObjDistX_8;
  float32 RR_ObjDistXStd_8;
  float32 RR_ObjDistY_8;
  float32 RR_ObjExistProb_8;
  uint8 RR_ObjID_8;
  float32 RR_ObjObstacleProb_8;
  Rte_DT_SG_SigGroup_563_5_t_7 RR_ObjType_8;
} SG_SigGroup_563_5_t;

#  define Rte_TypeDef_SG_SigGroup_563_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_563_6_t_0 RR_ObjMeasured_8;
  Rte_DT_SG_SigGroup_563_6_t_1 RR_ObjMotionType_8;
  float32 RR_ObjRelAccelX_8;
  float32 RR_ObjRelAccelY_8;
  float32 RR_ObjRelVelX_8;
  float32 RR_ObjRelVelY_8;
} SG_SigGroup_563_6_t;

#  define Rte_TypeDef_SG_SigGroup_563_7_t
typedef struct
{
  uint8 RR_ObjAge_8;
  float32 RR_ObjDistYStd_8;
  Rte_DT_SG_SigGroup_563_7_t_2 RR_ObjMotionDirection_8;
  float32 RR_ObjRAccelXStd_8;
  float32 RR_ObjRAccelYStd_8;
  float32 RR_ObjRelVelXStd_8;
  float32 RR_ObjRelVelYStd_8;
  float32 RR_ObjWidth_8;
} SG_SigGroup_563_7_t;

#  define Rte_TypeDef_SG_SigGroup_563_8_t
typedef struct
{
  uint8 RR_4_BlockCounter;
  Rte_DT_SG_SigGroup_563_8_t_1 RR_HWATargetValidity_8;
  float32 RR_ObjHeading_8;
  float32 RR_ObjLength_8;
  float32 RR_ObjRCS_8;
  Rte_DT_SG_SigGroup_563_8_t_5 RR_ObjRefPoint_8;
  float32 RR_ObjYawrate_8;
} SG_SigGroup_563_8_t;

#  define Rte_TypeDef_SG_SigGroup_564_1_t
typedef struct
{
  uint8 RR_5_Checksum1;
  uint8 RR_5_RollingCounter1;
  Rte_DT_SG_SigGroup_564_1_t_2 RR_DetSourceOfObj_9;
  float32 RR_ObjDistX_9;
  float32 RR_ObjDistXStd_9;
  float32 RR_ObjDistY_9;
  float32 RR_ObjExistProb_9;
  uint8 RR_ObjID_9;
  float32 RR_ObjObstacleProb_9;
  Rte_DT_SG_SigGroup_564_1_t_9 RR_ObjType_9;
} SG_SigGroup_564_1_t;

#  define Rte_TypeDef_SG_SigGroup_564_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_564_2_t_0 RR_ObjMeasured_9;
  Rte_DT_SG_SigGroup_564_2_t_1 RR_ObjMotionType_9;
  float32 RR_ObjRelAccelX_9;
  float32 RR_ObjRelAccelY_9;
  float32 RR_ObjRelVelX_9;
  float32 RR_ObjRelVelY_9;
} SG_SigGroup_564_2_t;

#  define Rte_TypeDef_SG_SigGroup_564_3_t
typedef struct
{
  uint8 RR_ObjAge_9;
  float32 RR_ObjDistYStd_9;
  Rte_DT_SG_SigGroup_564_3_t_2 RR_ObjMotionDirection_9;
  float32 RR_ObjRAccelXStd_9;
  float32 RR_ObjRAccelYStd_9;
  float32 RR_ObjRelVelXStd_9;
  float32 RR_ObjRelVelYStd_9;
  float32 RR_ObjWidth_9;
} SG_SigGroup_564_3_t;

#  define Rte_TypeDef_SG_SigGroup_564_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_564_4_t_0 RR_HWATargetValidity_9;
  float32 RR_ObjHeading_9;
  float32 RR_ObjLength_9;
  float32 RR_ObjRCS_9;
  Rte_DT_SG_SigGroup_564_4_t_4 RR_ObjRefPoint_9;
  float32 RR_ObjYawrate_9;
} SG_SigGroup_564_4_t;

#  define Rte_TypeDef_SG_SigGroup_564_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_564_5_t_0 RR_DetSourceOfObj_10;
  float32 RR_ObjDistX_10;
  float32 RR_ObjDistXStd_10;
  float32 RR_ObjDistY_10;
  float32 RR_ObjExistProb_10;
  uint8 RR_ObjID_10;
  float32 RR_ObjObstacleProb_10;
  Rte_DT_SG_SigGroup_564_5_t_7 RR_ObjType_10;
} SG_SigGroup_564_5_t;

#  define Rte_TypeDef_SG_SigGroup_564_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_564_6_t_0 RR_ObjMeasured_10;
  Rte_DT_SG_SigGroup_564_6_t_1 RR_ObjMotionType_10;
  float32 RR_ObjRelAccelX_10;
  float32 RR_ObjRelAccelY_10;
  float32 RR_ObjRelVelX_10;
  float32 RR_ObjRelVelY_10;
} SG_SigGroup_564_6_t;

#  define Rte_TypeDef_SG_SigGroup_564_7_t
typedef struct
{
  uint8 RR_ObjAge_10;
  float32 RR_ObjDistYStd_10;
  Rte_DT_SG_SigGroup_564_7_t_2 RR_ObjMotionDirection_10;
  float32 RR_ObjRAccelXStd_10;
  float32 RR_ObjRAccelYStd_10;
  float32 RR_ObjRelVelXStd_10;
  float32 RR_ObjRelVelYStd_10;
  float32 RR_ObjWidth_10;
} SG_SigGroup_564_7_t;

#  define Rte_TypeDef_SG_SigGroup_564_8_t
typedef struct
{
  uint8 RR_5_BlockCounter;
  Rte_DT_SG_SigGroup_564_8_t_1 RR_HWATargetValidity_10;
  float32 RR_ObjHeading_10;
  float32 RR_ObjLength_10;
  float32 RR_ObjRCS_10;
  Rte_DT_SG_SigGroup_564_8_t_5 RR_ObjRefPoint_10;
  float32 RR_ObjYawrate_10;
} SG_SigGroup_564_8_t;

#  define Rte_TypeDef_SG_SigGroup_565_1_t
typedef struct
{
  uint8 RR_6_Checksum1;
  uint8 RR_6_RollingCounter1;
  Rte_DT_SG_SigGroup_565_1_t_2 RR_DetSourceOfObj_11;
  float32 RR_ObjDistX_11;
  float32 RR_ObjDistXStd_11;
  float32 RR_ObjDistY_11;
  float32 RR_ObjExistProb_11;
  uint8 RR_ObjID_11;
  float32 RR_ObjObstacleProb_11;
  Rte_DT_SG_SigGroup_565_1_t_9 RR_ObjType_11;
} SG_SigGroup_565_1_t;

#  define Rte_TypeDef_SG_SigGroup_565_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_565_2_t_0 RR_ObjMeasured_11;
  Rte_DT_SG_SigGroup_565_2_t_1 RR_ObjMotionType_11;
  float32 RR_ObjRelAccelX_11;
  float32 RR_ObjRelAccelY_11;
  float32 RR_ObjRelVelX_11;
  float32 RR_ObjRelVelY_11;
} SG_SigGroup_565_2_t;

#  define Rte_TypeDef_SG_SigGroup_565_3_t
typedef struct
{
  uint8 RR_ObjAge_11;
  float32 RR_ObjDistYStd_11;
  Rte_DT_SG_SigGroup_565_3_t_2 RR_ObjMotionDirection_11;
  float32 RR_ObjRAccelXStd_11;
  float32 RR_ObjRAccelYStd_11;
  float32 RR_ObjRelVelXStd_11;
  float32 RR_ObjRelVelYStd_11;
  float32 RR_ObjWidth_11;
} SG_SigGroup_565_3_t;

#  define Rte_TypeDef_SG_SigGroup_565_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_565_4_t_0 RR_HWATargetValidity_11;
  float32 RR_ObjHeading_11;
  float32 RR_ObjLength_11;
  float32 RR_ObjRCS_11;
  Rte_DT_SG_SigGroup_565_4_t_4 RR_ObjRefPoint_11;
  float32 RR_ObjYawrate_11;
} SG_SigGroup_565_4_t;

#  define Rte_TypeDef_SG_SigGroup_565_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_565_5_t_0 RR_DetSourceOfObj_12;
  float32 RR_ObjDistX_12;
  float32 RR_ObjDistXStd_12;
  float32 RR_ObjDistY_12;
  float32 RR_ObjExistProb_12;
  uint8 RR_ObjID_12;
  float32 RR_ObjObstacleProb_12;
  Rte_DT_SG_SigGroup_565_5_t_7 RR_ObjType_12;
} SG_SigGroup_565_5_t;

#  define Rte_TypeDef_SG_SigGroup_565_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_565_6_t_0 RR_ObjMeasured_12;
  Rte_DT_SG_SigGroup_565_6_t_1 RR_ObjMotionType_12;
  float32 RR_ObjRelAccelX_12;
  float32 RR_ObjRelAccelY_12;
  float32 RR_ObjRelVelX_12;
  float32 RR_ObjRelVelY_12;
} SG_SigGroup_565_6_t;

#  define Rte_TypeDef_SG_SigGroup_565_7_t
typedef struct
{
  uint8 RR_ObjAge_12;
  float32 RR_ObjDistYStd_12;
  Rte_DT_SG_SigGroup_565_7_t_2 RR_ObjMotionDirection_12;
  float32 RR_ObjRAccelXStd_12;
  float32 RR_ObjRAccelYStd_12;
  float32 RR_ObjRelVelXStd_12;
  float32 RR_ObjRelVelYStd_12;
  float32 RR_ObjWidth_12;
} SG_SigGroup_565_7_t;

#  define Rte_TypeDef_SG_SigGroup_565_8_t
typedef struct
{
  uint8 RR_6_BlockCounter;
  Rte_DT_SG_SigGroup_565_8_t_1 RR_HWATargetValidity_12;
  float32 RR_ObjHeading_12;
  float32 RR_ObjLength_12;
  float32 RR_ObjRCS_12;
  Rte_DT_SG_SigGroup_565_8_t_5 RR_ObjRefPoint_12;
  float32 RR_ObjYawrate_12;
} SG_SigGroup_565_8_t;

#  define Rte_TypeDef_SG_SigGroup_566_1_t
typedef struct
{
  uint8 RR_7_Checksum1;
  uint8 RR_7_RollingCounter1;
  Rte_DT_SG_SigGroup_566_1_t_2 RR_DetSourceOfObj_13;
  float32 RR_ObjDistX_13;
  float32 RR_ObjDistXStd_13;
  float32 RR_ObjDistY_13;
  float32 RR_ObjExistProb_13;
  uint8 RR_ObjID_13;
  float32 RR_ObjObstacleProb_13;
  Rte_DT_SG_SigGroup_566_1_t_9 RR_ObjType_13;
} SG_SigGroup_566_1_t;

#  define Rte_TypeDef_SG_SigGroup_566_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_566_2_t_0 RR_ObjMeasured_13;
  Rte_DT_SG_SigGroup_566_2_t_1 RR_ObjMotionType_13;
  float32 RR_ObjRelAccelX_13;
  float32 RR_ObjRelAccelY_13;
  float32 RR_ObjRelVelX_13;
  float32 RR_ObjRelVelY_13;
} SG_SigGroup_566_2_t;

#  define Rte_TypeDef_SG_SigGroup_566_3_t
typedef struct
{
  uint8 RR_ObjAge_13;
  float32 RR_ObjDistYStd_13;
  Rte_DT_SG_SigGroup_566_3_t_2 RR_ObjMotionDirection_13;
  float32 RR_ObjRAccelXStd_13;
  float32 RR_ObjRAccelYStd_13;
  float32 RR_ObjRelVelXStd_13;
  float32 RR_ObjRelVelYStd_13;
  float32 RR_ObjWidth_13;
} SG_SigGroup_566_3_t;

#  define Rte_TypeDef_SG_SigGroup_566_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_566_4_t_0 RR_HWATargetValidity_13;
  float32 RR_ObjHeading_13;
  float32 RR_ObjLength_13;
  float32 RR_ObjRCS_13;
  Rte_DT_SG_SigGroup_566_4_t_4 RR_ObjRefPoint_13;
  float32 RR_ObjYawrate_13;
} SG_SigGroup_566_4_t;

#  define Rte_TypeDef_SG_SigGroup_566_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_566_5_t_0 RR_DetSourceOfObj_14;
  float32 RR_ObjDistX_14;
  float32 RR_ObjDistXStd_14;
  float32 RR_ObjDistY_14;
  float32 RR_ObjExistProb_14;
  uint8 RR_ObjID_14;
  float32 RR_ObjObstacleProb_14;
  Rte_DT_SG_SigGroup_566_5_t_7 RR_ObjType_14;
} SG_SigGroup_566_5_t;

#  define Rte_TypeDef_SG_SigGroup_566_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_566_6_t_0 RR_ObjMeasured_14;
  Rte_DT_SG_SigGroup_566_6_t_1 RR_ObjMotionType_14;
  float32 RR_ObjRelAccelX_14;
  float32 RR_ObjRelAccelY_14;
  float32 RR_ObjRelVelX_14;
  float32 RR_ObjRelVelY_14;
} SG_SigGroup_566_6_t;

#  define Rte_TypeDef_SG_SigGroup_566_7_t
typedef struct
{
  uint8 RR_ObjAge_14;
  float32 RR_ObjDistYStd_14;
  Rte_DT_SG_SigGroup_566_7_t_2 RR_ObjMotionDirection_14;
  float32 RR_ObjRAccelXStd_14;
  float32 RR_ObjRAccelYStd_14;
  float32 RR_ObjRelVelXStd_14;
  float32 RR_ObjRelVelYStd_14;
  float32 RR_ObjWidth_14;
} SG_SigGroup_566_7_t;

#  define Rte_TypeDef_SG_SigGroup_566_8_t
typedef struct
{
  uint8 RR_7_BlockCounter;
  Rte_DT_SG_SigGroup_566_8_t_1 RR_HWATargetValidity_14;
  float32 RR_ObjHeading_14;
  float32 RR_ObjLength_14;
  float32 RR_ObjRCS_14;
  Rte_DT_SG_SigGroup_566_8_t_5 RR_ObjRefPoint_14;
  float32 RR_ObjYawrate_14;
} SG_SigGroup_566_8_t;

#  define Rte_TypeDef_SG_SigGroup_567_1_t
typedef struct
{
  uint8 RR_8_Checksum1;
  uint8 RR_8_RollingCounter1;
  Rte_DT_SG_SigGroup_567_1_t_2 RR_DetSourceOfObj_15;
  float32 RR_ObjDistX_15;
  float32 RR_ObjDistXStd_15;
  float32 RR_ObjDistY_15;
  float32 RR_ObjExistProb_15;
  uint8 RR_ObjID_15;
  float32 RR_ObjObstacleProb_15;
  Rte_DT_SG_SigGroup_567_1_t_9 RR_ObjType_15;
} SG_SigGroup_567_1_t;

#  define Rte_TypeDef_SG_SigGroup_567_2_t
typedef struct
{
  Rte_DT_SG_SigGroup_567_2_t_0 RR_ObjMeasured_15;
  Rte_DT_SG_SigGroup_567_2_t_1 RR_ObjMotionType_15;
  float32 RR_ObjRelAccelX_15;
  float32 RR_ObjRelAccelY_15;
  float32 RR_ObjRelVelX_15;
  float32 RR_ObjRelVelY_15;
} SG_SigGroup_567_2_t;

#  define Rte_TypeDef_SG_SigGroup_567_3_t
typedef struct
{
  uint8 RR_ObjAge_15;
  float32 RR_ObjDistYStd_15;
  Rte_DT_SG_SigGroup_567_3_t_2 RR_ObjMotionDirection_15;
  float32 RR_ObjRAccelXStd_15;
  float32 RR_ObjRAccelYStd_15;
  float32 RR_ObjRelVelXStd_15;
  float32 RR_ObjRelVelYStd_15;
  float32 RR_ObjWidth_15;
} SG_SigGroup_567_3_t;

#  define Rte_TypeDef_SG_SigGroup_567_4_t
typedef struct
{
  Rte_DT_SG_SigGroup_567_4_t_0 RR_HWATargetValidity_15;
  float32 RR_ObjHeading_15;
  float32 RR_ObjLength_15;
  float32 RR_ObjRCS_15;
  Rte_DT_SG_SigGroup_567_4_t_4 RR_ObjRefPoint_15;
  float32 RR_ObjYawrate_15;
} SG_SigGroup_567_4_t;

#  define Rte_TypeDef_SG_SigGroup_567_5_t
typedef struct
{
  Rte_DT_SG_SigGroup_567_5_t_0 RR_DetSourceOfObj_16;
  float32 RR_ObjDistX_16;
  float32 RR_ObjDistXStd_16;
  float32 RR_ObjDistY_16;
  float32 RR_ObjExistProb_16;
  uint8 RR_ObjID_16;
  float32 RR_ObjObstacleProb_16;
  Rte_DT_SG_SigGroup_567_5_t_7 RR_ObjType_16;
} SG_SigGroup_567_5_t;

#  define Rte_TypeDef_SG_SigGroup_567_6_t
typedef struct
{
  Rte_DT_SG_SigGroup_567_6_t_0 RR_ObjMeasured_16;
  Rte_DT_SG_SigGroup_567_6_t_1 RR_ObjMotionType_16;
  float32 RR_ObjRelAccelX_16;
  float32 RR_ObjRelAccelY_16;
  float32 RR_ObjRelVelX_16;
  float32 RR_ObjRelVelY_16;
} SG_SigGroup_567_6_t;

#  define Rte_TypeDef_SG_SigGroup_567_7_t
typedef struct
{
  uint8 RR_ObjAge_16;
  float32 RR_ObjDistYStd_16;
  Rte_DT_SG_SigGroup_567_7_t_2 RR_ObjMotionDirection_16;
  float32 RR_ObjRAccelXStd_16;
  float32 RR_ObjRAccelYStd_16;
  float32 RR_ObjRelVelXStd_16;
  float32 RR_ObjRelVelYStd_16;
  float32 RR_ObjWidth_16;
} SG_SigGroup_567_7_t;

#  define Rte_TypeDef_SG_SigGroup_567_8_t
typedef struct
{
  uint8 RR_8_BlockCounter;
  Rte_DT_SG_SigGroup_567_8_t_1 RR_HWATargetValidity_16;
  float32 RR_ObjHeading_16;
  float32 RR_ObjLength_16;
  float32 RR_ObjRCS_16;
  Rte_DT_SG_SigGroup_567_8_t_5 RR_ObjRefPoint_16;
  float32 RR_ObjYawrate_16;
} SG_SigGroup_567_8_t;

#  define Rte_TypeDef_ST_CTANVRAM_t
typedef struct
{
  boolean CTA_Nb_FCTAPowerOffSwitchState_nu;
  boolean CTA_Nb_RCTAPowerOffSwitchState_nu;
  boolean CTA_Nb_BoolReserved1_nu;
  boolean CTA_Nb_BoolReserved2_nu;
  boolean CTA_Nb_BoolReserved3_nu;
  boolean CTA_Nb_BoolReserved4_nu;
  boolean CTA_Nb_BoolReserved5_nu;
  uint8 CTA_Nu_UintReserved1_nu;
  uint8 CTA_Nu_UintReserved2_nu;
  uint8 CTA_Nu_UintReserved3_nu;
  uint8 CTA_Nu_UintReserved4_nu;
  uint8 CTA_Nu_UintReserved5_nu;
  float32 CTA_Nf_FloatReserved1_nu;
  float32 CTA_Nf_FloatReserved2_nu;
  float32 CTA_Nf_FloatReserved3_nu;
  float32 CTA_Nf_FloatReserved4_nu;
  float32 CTA_Nf_FloatReserved5_nu;
} ST_CTANVRAM_t;

#  define Rte_TypeDef_ST_CTASEN_CANOut
typedef struct
{
  uint8 ADCS8_FCTA_State;
  uint8 ADCS8_FCTALeftActiveSt;
  uint8 ADCS8_FCTARightActiveSt;
  uint8 ADCS8_FCTAWarnObjType;
  uint8 ADCS8_FCTA_SystemFaultStatus;
  uint8 ADCS12_FCTAWarnAudioplay;
  uint8 ADCS8_RCTA_State;
  uint8 ADCS8_RCTALeftWarnSt;
  uint8 ADCS8_RCTARightWarnSt;
  uint8 ADCS8_RCTAWarnObjType;
  uint8 ADCS8_RCTA_SystemFaultStatus;
  uint8 ADCS12_RCTAWarnAudioplay;
} ST_CTASEN_CANOut;

#  define Rte_TypeDef_ST_LBSNVRAM_t
typedef struct
{
  boolean LBS_Nb_BSDPowerOffSwitchState_nu;
  boolean LBS_Nb_LCAPowerOffSwitchState_nu;
  boolean LBS_Nb_DOWPowerOffSwitchState_nu;
  boolean LBS_Nb_RCWPowerOffSwitchState_nu;
  float32 LBS_Nf_Reserved1;
  float32 LBS_Nf_Reserved2;
  float32 LBS_Nf_Reserved3;
  float32 LBS_Nf_Reserved4;
  float32 LBS_Nf_Reserved5;
  uint8 LBS_Nu_Reserved1;
  uint8 LBS_Nu_Reserved2;
  uint8 LBS_Nu_Reserved3;
  uint8 LBS_Nu_Reserved4;
  uint8 LBS_Nu_Reserved5;
  boolean LBS_Nb_Reserved1;
  boolean LBS_Nb_Reserved2;
  boolean LBS_Nb_Reserved3;
  boolean LBS_Nb_Reserved4;
  boolean LBS_Nb_Reserved5;
} ST_LBSNVRAM_t;

#  define Rte_TypeDef_ST_LBSSEN_CANOut
typedef struct
{
  uint8 ADCS_AVM_RCW_warningReq;
  uint8 ADCS8_RCW_WarnState;
  uint8 ADCS8_RCW_SystemFaultStatus;
  boolean ADCS8_RCW_State;
  boolean ADCS12_RCWWarnAudioplay;
  uint8 ADCS8_DOWState;
  uint8 ADCS8_DOW_SystemFaultStatus;
  uint8 ADCS8_DOWRightWarnState;
  uint8 ADCS8_DOWLeftWarnState;
  boolean ADCS12_DOWWarnAudioplay;
  uint8 ADCS8_LCAState;
  uint8 ADCS8_LCASystemFaultStatus;
  uint8 ADCS8_LCALeftWarnSt;
  uint8 ADCS8_LCARightWarnSt;
} ST_LBSSEN_CANOut;

#  define Rte_TypeDef_ST_LCFVEH_CANOut
typedef struct
{
  uint8 ADCS8_lateralCtrHandsEyesOffWarning;
  uint8 ADAS8_LateralCtrHandOffReleasewarning;
  uint8 ADCS12_HandOffAudioplay;
} ST_LCFVEH_CANOut;

#  define Rte_TypeDef_ST_LCF_DmcNVRAMData_t
typedef struct
{
  boolean LCFVeh_Nb_SwitchReserved1_nu;
  boolean LCFVeh_Nb_SwitchReserved2_nu;
  boolean LCFVeh_Nb_SwitchReserved3_nu;
  boolean LCFVeh_Nb_SwitchReserved4_nu;
  boolean LCFVeh_Nb_SwitchReserved5_nu;
  boolean LCFVeh_Nb_SwitchReserved6_nu;
  boolean LCFVeh_Nb_SwitchReserved7_nu;
  boolean LCFVeh_Nb_SwitchReserved8_nu;
  boolean LCFVeh_Nb_SwitchReserved9_nu;
  boolean LCFVeh_Nb_SwitchReserved10_nu;
  uint8 LCFVeh_Nu_SensitivityReserved1_nu;
  uint8 LCFVeh_Nu_SensitivityReserved2_nu;
  uint8 LCFVeh_Nu_SensitivityReserved3_nu;
  uint8 LCFVeh_Nu_SensitivityReserved4_nu;
  uint8 LCFVeh_Nu_SensitivityReserved5_nu;
  float32 LCFVeh_Nf_SensitivityReserved1_nu;
  float32 LCFVeh_Nf_SensitivityReserved2_nu;
  float32 LCFVeh_Nf_SensitivityReserved3_nu;
  float32 LCFVeh_Nf_SensitivityReserved4_nu;
  float32 LCFVeh_Nf_SensitivityReserved5_nu;
  float32 LCFVeh_Nf_SensitivityReserved6_nu;
  float32 LCFVeh_Nf_SensitivityReserved7_nu;
  float32 LCFVeh_Nf_SensitivityReserved8_nu;
  float32 LCFVeh_Nf_SensitivityReserved9_nu;
  float32 LCFVeh_Nf_SensitivityReserved10_nu;
} ST_LCF_DmcNVRAMData_t;

#  define Rte_TypeDef_ST_REGSEN_CANIn
typedef struct
{
  uint8 CDCS11_TSR_OnOffSet;
  uint8 CDCS11_TSR_OverspeedOnoffSet;
  uint8 CDCS11_TSR_SLFOnOffSet;
  uint8 CDCS11_IHBC_SysSwState;
} ST_REGSEN_CANIn;

#  define Rte_TypeDef_ST_REGSEN_CANOut
typedef struct
{
  uint8 ADCS8_TSRState;
  uint8 ADCS8_TSR_SpeedSign;
  uint8 ADCS8_TSR_ForbiddenSign;
  uint8 ADCS8_TSR_SpeedWarnState;
  uint8 ADCS8_TSR_SystemFaultStatus;
  uint8 ADCS8_TSR_StrLightColor;
  uint8 ADCS8_TSR_RightLightColor;
  uint8 ADCS8_TSR_LeftLightColor;
  uint8 ADCS8_TSR_SLFStatefeedback;
  uint8 ADCS2_ADAS_IHBCSysState;
  uint8 ADCS8_ADAS_IHBCStat;
} ST_REGSEN_CANOut;

#  define Rte_TypeDef_ST_VLCSen_NVRAMData_t
typedef struct
{
  float32 VLCSEN_Nf_Reserved1;
  float32 VLCSEN_Nf_Reserved2;
  float32 VLCSEN_Nf_Reserved3;
  float32 VLCSEN_Nf_Reserved4;
  float32 VLCSEN_Nf_Reserved5;
  uint8 VLCSEN_Nu_Reserved1;
  uint8 VLCSEN_Nu_Reserved2;
  uint8 VLCSEN_Nu_Reserved3;
  uint8 VLCSEN_Nu_Reserved4;
  uint8 VLCSEN_Nu_Reserved5;
  boolean VLCSEN_Nb_Reserved1;
  boolean VLCSEN_Nb_Reserved2;
  boolean VLCSEN_Nb_Reserved3;
  boolean VLCSEN_Nb_Reserved4;
  boolean VLCSEN_Nb_Reserved5;
} ST_VLCSen_NVRAMData_t;

#  define Rte_TypeDef_ST_bDOWPowerModeDone
typedef struct
{
  boolean bDOWPowerModeDone;
} ST_bDOWPowerModeDone;

#  define Rte_TypeDef_ST_sTSROutput_t
typedef struct
{
  uint32 TSR_ForbiddenSign_btf;
  uint8 TSR_SpeedUpperLimit_btf;
  uint32 TSR_SpeedLowerLimit_btf;
  uint16 TSR_StrLightColor_st;
  uint16 TSR_LeftLightColor_st;
  uint16 TSR_RightLightColor_st;
  uint16 TSR_VehicleSpdWarningValid_btf;
  uint8 TSR_VehicleSpdMachineEn_btf;
  boolean TSR_SpeedWarning_bool;
  boolean TSR_SwitchEnNVRAM_bool;
  uint8 TSR_Sys_St;
  uint8 TSR_RelSpeedUpperLimit_btf;
  uint8 TSR_SpeedWarnAudioplay_nu;
} ST_sTSROutput_t;

#  define Rte_TypeDef_SensorHistInfo
typedef struct
{
  sint16 camera_hist_info;
  sint16 radar_hist_info;
} SensorHistInfo;

#  define Rte_TypeDef_SignalHeader_t
typedef struct
{
  AlgoDataTimeStamp_t uiTimeStamp;
  AlgoCycleCounter_t uiMeasurementCounter;
  AlgoCycleCounter_t uiCycleCounter;
  AlgoSignalState_t eSigStatus;
} SignalHeader_t;

#  define Rte_TypeDef_Sync_Output_1_Type
typedef struct
{
  uint64 ImageTimeStamp;
} Sync_Output_1_Type;

#  define Rte_TypeDef_Sync_Output_2_Type
typedef struct
{
  uint64 SPITimeStamp;
} Sync_Output_2_Type;

#  define Rte_TypeDef_Sync_Output_3_Type
typedef struct
{
  uint32 FrameIndex;
  uint32 CameraID;
  uint32 ProtocolMajorVersion;
  uint32 ProtocolMinorVersion;
  uint32 SWMajorVersion;
  uint32 SWMiddleVersion;
  uint32 SWMinorVersion;
  uint32 Unused;
} Sync_Output_3_Type;

#  define Rte_TypeDef_Vector2f
typedef struct
{
  float32 x;
  float32 y;
} Vector2f;

#  define Rte_TypeDef_Idt_FBL_or_APP_EE
typedef struct
{
  Rte_DT_Idt_FBL_or_APP_EE_0 De_F199_ProgrammingDate;
  Rte_DT_Idt_FBL_or_APP_EE_1 De_F198_TesterSerialNum;
  Rte_DT_Idt_FBL_or_APP_EE_2 reservedpadding;
  Rte_DT_Idt_FBL_or_APP_EE_3 reserved;
} Idt_FBL_or_APP_EE;

#  define Rte_TypeDef_Idt_FET_And_SMU_Faults_T
typedef struct
{
  Idt_FETMode_T FETMode;
  Idt_FETShort_Cnt_T FETShort_Cnt;
  Idt_SMU_Faults_T SMU_Faults;
} Idt_FET_And_SMU_Faults_T;

#  define Rte_TypeDef_Idt_Os_ErrorType
typedef struct
{
  Idt_Os_ErrorInformationType ErrorDetails;
  uint32 ExceptionInstructionAddr;
} Idt_Os_ErrorType;

#  define Rte_TypeDef_Idt_Os_Error_T
typedef struct
{
  uint8 Error;
  Idt_Os_ErrorType Last_Error;
  Idt_ExtendInformType ExtendInfo;
} Idt_Os_Error_T;

#  define Rte_TypeDef_Idt_Os_ExceptionContextType_Tag
typedef struct
{
  Rte_DT_Idt_Os_ExceptionContextType_Tag_0 De_AddressRegisters;
  Rte_DT_Idt_Os_ExceptionContextType_Tag_1 De_DataRegisters;
  uint32 De_Ra;
  uint32 De_Psw;
  uint32 De_ExceptionSource;
  uint32 De_Pcpn;
  uint32 De_Pie;
  uint32 De_MpuRegionForStackLow;
  uint32 De_MpuRegionForStackUpper;
} Idt_Os_ExceptionContextType_Tag;

#  define Rte_TypeDef_Idt_SystemResetReasonType
typedef struct
{
  uint16 ErrorType;
  uint8 TaskId;
  Idt_WdtErrorType Wdt;
  Idt_HardwareFaultType Hw;
  uint8 EcumId;
  Idt_BswErrorType Bsw;
  Idt_DetErrorInformationType Det;
} Idt_SystemResetReasonType;

#  define Rte_TypeDef_Idt_UserTrap_ExceptionAddress
typedef struct
{
  Rte_DT_Idt_UserTrap_ExceptionAddress_0 De_UserTrap_ExceptionAddress;
} Idt_UserTrap_ExceptionAddress;

#  define Rte_TypeDef_NvM_RequestResultType
typedef uint8 NvM_RequestResultType;

#  define Rte_TypeDef_NvM_ServiceIdType
typedef uint8 NvM_ServiceIdType;

#  define Rte_TypeDef_Pept_HB_LANE_Type
typedef struct
{
  uint32 SubFuncID;
  Rte_array_Pept_HB_LANE_Type_Unsed_t Unsed;
  Lane_Road_Information_Type Road_Information;
  LKA_Lane_A_Type LKA_Left_Lane_A;
  LKA_Lane_B_Type LKA_Left_Lane_B;
  LKA_Lane_C_Type LKA_Left_Lane_C;
  LKA_Lane_D_Type LKA_Left_Lane_D;
  LKA_Lane_E_Type LKA_Left_Lane_E;
  LKA_Lane_A_Type LKA_Right_Lane_A;
  LKA_Lane_B_Type LKA_Right_Lane_B;
  LKA_Lane_C_Type LKA_Right_Lane_C;
  LKA_Lane_D_Type LKA_Right_Lane_D;
  LKA_Lane_E_Type LKA_Right_Lane_E;
  LKA_Lane_A_Type Next_Left_Lane_A;
  LKA_Lane_B_Type Next_Left_Lane_B;
  LKA_Lane_C_Type Next_Left_Lane_C;
  LKA_Lane_D_Type Next_Left_Lane_D;
  LKA_Lane_E_Type Next_Left_Lane_E;
  LKA_Lane_A_Type Next_Right_Lane_A;
  LKA_Lane_B_Type Next_Right_Lane_B;
  LKA_Lane_C_Type Next_Right_Lane_C;
  LKA_Lane_D_Type Next_Right_Lane_D;
  LKA_Lane_E_Type Next_Right_Lane_E;
  LKA_Cone_Road_Edge_A_Type Left_Cone_Road_Edge_A;
  LKA_Cone_Road_Edge_B_Type Left_Cone_Road_Edge_B;
  LKA_Cone_Road_Edge_C_Type Left_Cone_Road_Edge_C;
  LKA_Cone_Road_Edge_A_Type Right_Cone_Road_Edge_A;
  LKA_Cone_Road_Edge_B_Type Right_Cone_Road_Edge_B;
  LKA_Cone_Road_Edge_C_Type Right_Cone_Road_Edge_C;
  LKA_Road_Edge_A_Type Left_Road_Edge_A;
  LKA_Road_Edge_B_Type Left_Road_Edge_B;
  LKA_Road_Edge_C_Type Left_Road_Edge_C;
  LKA_Road_Edge_A_Type Right_Road_Edge_A;
  LKA_Road_Edge_B_Type Right_Road_Edge_B;
  LKA_Road_Edge_C_Type Right_Road_Edge_C;
  LaneCRC_Type LaneCRC;
} Pept_HB_LANE_Type;

#  define Rte_TypeDef_Pept_Hb_ObstacleData_Type
typedef struct
{
  ObstacleDataA_Type ObstacleDataA;
  ObstacleDataB_Type ObstacleDataB;
  ObstacleDataC_Type ObstacleDataC;
  ObstacleDataD_Type ObstacleDataD;
  ObstacleDataE_Type ObstacleDataE;
  ObstacleDataF_Type ObstacleDataF;
  ObstacleDataG_Type ObstacleDataG;
  ObstacleDataH_Type ObstacleDataH;
  ObstacleDataI_Type ObstacleDataI;
  ObstacleDataJ_Type ObstacleDataJ;
  ObstacleDataK_Type ObstacleDataK;
  ObstacleDataL_Type ObstacleDataL;
  ObstacleDataM_Type ObstacleDataM;
  ObstacleDataN_Type ObstacleDataN;
  ObstacleDataO_Type ObstacleDataO;
  ObstacleDataP_Type ObstacleDataP;
} Pept_Hb_ObstacleData_Type;

#  define Rte_TypeDef_Pept_Hb_Sync_Type
typedef struct
{
  uint32 SubFunc;
  Rte_array_Pept_Hb_Sync_Type_Unsed_t Unsed;
  Sync_Output_1_Type Sync_Message_Output_1;
  Sync_Output_2_Type Sync_Message_Output_2;
  Sync_Output_3_Type Sync_Message_Output_3;
} Pept_Hb_Sync_Type;

#  define Rte_TypeDef_REG_SEN_NVRAMData_t
typedef struct
{
  REG_SenSignalHeader_t sSigHeader;
  boolean NVRAM_TSRSwitchEn_bool;
  boolean REGSEN_TSROverSpdWarningEnNVRAM_nu;
  boolean REGSEN_IHBCSwitchEnNVRAM_nu;
  boolean REGSEN_Nb_NVRAMReserved1_nu;
  boolean REGSEN_Nb_NVRAMReserved2_nu;
  boolean REGSEN_Nb_NVRAMReserved3_nu;
  boolean REGSEN_Nb_NVRAMReserved4_nu;
  boolean REGSEN_Nb_NVRAMReserved5_nu;
  boolean REGSEN_Nb_NVRAMReserved6_nu;
  float32 REGSEN_Nf_NVRAMReserved1_nu;
  float32 REGSEN_Nf_NVRAMReserved2_nu;
  float32 REGSEN_Nf_NVRAMReserved3_nu;
  float32 REGSEN_Nf_NVRAMReserved4_nu;
  float32 REGSEN_Nf_NVRAMReserved5_nu;
  float32 REGSEN_Nf_NVRAMReserved6_nu;
  uint8 REGSEN_Nu_NVRAMReserved1_nu;
  uint8 REGSEN_Nu_NVRAMReserved2_nu;
  uint8 REGSEN_Nu_NVRAMReserved3_nu;
  uint8 REGSEN_Nu_NVRAMReserved4_nu;
  uint8 REGSEN_Nu_NVRAMReserved5_nu;
  uint8 REGSEN_Nu_NVRAMReserved6_nu;
} REG_SEN_NVRAMData_t;

#  define Rte_TypeDef_Rte_DT_Idt_OS_TrapInfo_T_0
typedef Idt_Os_ExceptionContextType_Tag Rte_DT_Idt_OS_TrapInfo_T_0[3];

#  define Rte_TypeDef_Rte_DT_Idt_OS_TrapInfo_T_1
typedef Idt_UserTrap_ExceptionAddress Rte_DT_Idt_OS_TrapInfo_T_1[3];

#  define Rte_TypeDef_Rte_DT_PolygonBox_1
typedef Point2f Rte_DT_PolygonBox_1[8];

#  define Rte_TypeDef_Rte_array_Pept_Hb_Obstacle_Type_ObstacleData_t
typedef Pept_Hb_ObstacleData_Type Rte_array_Pept_Hb_Obstacle_Type_ObstacleData_t[20];

#  define Rte_TypeDef_Rte_array_Pept_Hb_Obstacle_Type_ObstacleInternalID_t
typedef ObstacleInternalID_Type Rte_array_Pept_Hb_Obstacle_Type_ObstacleInternalID_t[20];

#  define Rte_TypeDef_ST_CTASEN_CANIn
typedef struct
{
  Timestamp CAN_Msg_Time;
  uint8 CDCS11_FCTA_OnOffSet;
  uint8 CDCS11_RCTA_OnOffSet;
} ST_CTASEN_CANIn;

#  define Rte_TypeDef_ST_DMC_CANOut
typedef struct
{
  Timestamp timestamp;
  uint8 ADCS2_ADAS_EPSAngleReqSt;
  float32 ADCS2_ADAS_EPSAngleReq;
  uint8 ADCS2_ADAS_EPSLateralCtrlType;
  uint8 ADCS2_EPS_LDPState;
  uint8 ADCS_Pilot_SystemFaultStatus;
  uint8 ADCS2_NNP_SystemFaultStatus;
} ST_DMC_CANOut;

#  define Rte_TypeDef_ST_LBSSEN_CANIn
typedef struct
{
  Timestamp CAN_Msg_Time;
  uint8 CDCS11_RCW_OnOffSet;
  uint8 CDCS11_DOW_OnOffSet;
  uint8 CDCS11_LCA_OnOffSet;
} ST_LBSSEN_CANIn;

#  define Rte_TypeDef_ST_LCFSEN_CANIn
typedef struct
{
  Timestamp CAN_Msg_Time;
  uint8 CDCS11_LDP_OnOffSet;
  uint8 CDCS11_LKSSetspeed;
  uint8 CDCS11_LDW_OnOnffSet;
  uint8 CDCS11_DCLCSysState;
} ST_LCFSEN_CANIn;

#  define Rte_TypeDef_ST_LCFSEN_CANOut
typedef struct
{
  Timestamp timestamp;
  uint8 ADCS12_LKSOnOffAudioplay;
  uint8 ADCS8_VoiceMode;
  uint8 ADCS8_LDWState;
  uint8 ADCS8_LDWWarnState;
  uint8 ADCS8_LDWMode;
  uint8 ADCS8_LKSSetspeed;
  uint8 ADCS2_EPS_LDPState;
  uint8 ADCS8_LDPMode;
  uint8 ADCS8_DCLCSysState;
  uint8 ADCS8_LaneChangeWarning;
  uint8 ADCS8_Lanechangeinfor;
  uint8 ADCS8_Lanechangedirection;
  uint8 ADCS12_DCLCAudioplay;
  uint8 ADCS8_LaneChangeSystemFaultStatus;
  uint8 ADCS8_Npilot_SysState;
  uint8 ADCS12_NpilotSysInfo;
  uint8 ADCS12_PilotAudioPlay;
  uint8 ADCS8_NPilot_SystemFaultStatus;
  uint8 ADCS8_lateralCtrHandsEyesOffWarning;
  uint8 ADAS8_LateralCtrHandOffReleasewarning;
  uint8 ADCS8_lateralCtrtakeover;
  uint8 ADCS8_laneChangetate;
  uint8 ADCS8_NpilotsndState;
} ST_LCFSEN_CANOut;

#  define Rte_TypeDef_ST_NOPOutputModuleOutput_t
typedef struct
{
  MsgHeader header;
  uint32 uiVersionNum_nu;
  NOP_OutControlResult_t sControlOut;
  NOP_OutFuncDegradation_t sFuncDeg;
  NOP_OutSystemState_t sSystemSt;
  NOP_OutVehicleState_t sVehState;
  NOP_OutNeedNvRamWrite_t sNvRamWrite;
} ST_NOPOutputModuleOutput_t;

#  define Rte_TypeDef_ST_REG_SEN_NVRAMData_t
typedef struct
{
  REG_SenSignalHeader_t sSigHeader;
  boolean NVRAM_TSRSwitchEn_bool;
  boolean REGSEN_TSROverSpdWarningEnNVRAM_nu;
  boolean REGSEN_IHBCSwitchEnNVRAM_nu;
  boolean REGSEN_Nb_NVRAMReserved1_nu;
  boolean REGSEN_Nb_NVRAMReserved2_nu;
  boolean REGSEN_Nb_NVRAMReserved3_nu;
  boolean REGSEN_Nb_NVRAMReserved4_nu;
  boolean REGSEN_Nb_NVRAMReserved5_nu;
  boolean REGSEN_Nb_NVRAMReserved6_nu;
  float32 REGSEN_Nf_NVRAMReserved1_nu;
  float32 REGSEN_Nf_NVRAMReserved2_nu;
  float32 REGSEN_Nf_NVRAMReserved3_nu;
  float32 REGSEN_Nf_NVRAMReserved4_nu;
  float32 REGSEN_Nf_NVRAMReserved5_nu;
  float32 REGSEN_Nf_NVRAMReserved6_nu;
  uint8 REGSEN_Nu_NVRAMReserved1_nu;
  uint8 REGSEN_Nu_NVRAMReserved2_nu;
  uint8 REGSEN_Nu_NVRAMReserved3_nu;
  uint8 REGSEN_Nu_NVRAMReserved4_nu;
  uint8 REGSEN_Nu_NVRAMReserved5_nu;
  uint8 REGSEN_Nu_NVRAMReserved6_nu;
} ST_REG_SEN_NVRAMData_t;

#  define Rte_TypeDef_ST_VED_CANIn
typedef struct
{
  Timestamp CAN_Msg_Time;
  uint32 uiVersionNumber;
  VEDSignalHeader_t sSigHeader;
  VEDVehSigMain_t VehSigMain;
  VEDVehSigAdd_t VehSigAdd;
  VEDPowerTrain_t PowerTrain;
  VEDBrake_t Brake;
} ST_VED_CANIn;

#  define Rte_TypeDef_ST_VLCVEH_CANIn
typedef struct
{
  Timestamp CAN_Msg_Time;
  uint8 ACU1_Driver_Buckle;
  boolean ACU2_VehicleDynYawRateV;
  boolean ACU2_LongAccSensorValueV;
  boolean ACU2_LatAccSensorValueV;
  boolean ADCS2_AEBPartialBrake;
  boolean ADCS2_AEBFullBrake;
  boolean ADCS2_AEBPrefillReq;
  boolean ADCS2_AEB_JerkReq;
  uint8 ADCS8_FVC_120_Fail;
  uint8 ADCS8_FRS_Fail;
  uint8 ADCS8_TSR_SpeedSign;
  uint8 ADCS8_SystemFault;
  uint8 ADCS11_Parking_WorkSts;
  uint8 BDCS1_HazardLampSt;
  uint8 BDCS1_LeftTurnLightSt;
  uint8 BDCS1_RightTurnLightSt;
  uint8 BDCS1_HoodAjarSts;
  uint8 BDCS1_TrunkLockSts;
  uint8 CDCS3_ESCOffSw;
  uint8 CDCS11_ACCOnOffSet;
  uint8 CDCS11_AEB_OnOffSet;
  uint8 CDCS11_FCW_OnOffSet;
  uint8 CDCS11_VoiceMode;
  uint8 CDCS11_TSR_SLFOnOffSet;
  uint8 CDCS13_SwSmMode;
  uint8 EPS1_HSTWCalibrated;
  uint8 IDB1_FailedState;
  uint8 IDB1_BrakePedalApplied;
  boolean IDB1_BrakePedalAppliedV;
  uint8 IDB5_ACC_ReqLim;
  boolean IDB5_JerkActive;
  boolean IDB5_Jerkfail;
  boolean IDB5_ACC_Enable;
  boolean IDB5_AEB_Enable;
  uint8 IDB5_DriverOverride;
  uint8 IDB5_VehicleStanstill;
  uint8 IDB6_EPBAvailable;
  uint8 IDB6_EPBStatus;
  boolean IDB7_ABSActive;
  boolean IDB7_ESCActive;
  boolean IDB7_HDCAtive;
  boolean IDB7_TCSActive;
  uint8 VCU5_DriveMode;
  boolean IDB7_TCSDisable;
  boolean IDB7_ARPACTIVE;
  boolean IDB7_DynParkBrkByIDBActive;
  boolean IDB7_ABSFail;
  boolean IDB7_EBD_Fail;
  boolean IDB7_TCSFail;
  boolean IDB7_ESCFail;
  boolean IDB7_ARPFailure;
  uint8 Region_A_SwError;
  uint8 SWSM_A_CD_Add_Overtime;
  uint8 SWSM_A_CD_Minus_Overtime;
  uint8 SWSM_A_CruiseDistance_Add;
  uint8 SWSM_A_CruiseDistance_Minus;
  uint8 SWSM_A_CruiseSpeed_Add;
  uint8 SWSM_A_CruiseSpeed_Minus;
  uint8 VCU5_AccelPosition;
  boolean VCU5_AccelPositionValid;
} ST_VLCVEH_CANIn;

#  define Rte_TypeDef_ST_VLCVeh_DFV2SenInfo_t
typedef struct
{
  uint32 uiVersionNumber;
  VLCVeh_SignalHeader_t sSigHeader;
  boolean StandStill;
  boolean OverrideAccel;
  sint16 CurLongCtrlVelocity;
  sint16 CurLongCtrlAccel;
  sint16 MaxAccelLimit;
  sint16 MinAccelLimit;
  uint8 HeadwaySetting;
  uint8 ProbLaneChgLeft;
  uint8 ProbLaneChgRight;
  boolean AccOn;
  boolean AccNotOff;
  boolean DecelLimOverride;
  boolean CtrlToRelevObj;
  boolean ObjectEffective;
  sint8 EBAActivationObjID;
  uint16 MovingTime;
} ST_VLCVeh_DFV2SenInfo_t;

#  define Rte_TypeDef_VLC_AccLeverInput_t
typedef struct
{
  AlgoInterfaceVersionNumber_t uiVersionNumber;
  SignalHeader_t sSigHeader;
  boolean SetSwitch;
  uint8 DecelSwitch;
  uint8 ResumeAccelSwitch;
  boolean Cancel;
  uint8 ACCMode;
  boolean MainSwitch;
  boolean HeadwayInc;
  boolean HeadwayDec;
  boolean HeadwaySwitch;
  uint8 Headway;
  boolean PilotSwitch;
  boolean FCA_Setting;
} VLC_AccLeverInput_t;

#  define Rte_TypeDef_objectInfoSt
typedef struct
{
  MsgHeader MsgHeader;
  uint8 objectID;
  uint8 objectZone;
  uint8 objectDirection;
  uint8 warningLevel;
  float32 distance_x;
  float32 distance_y;
  uint8 class_id;
  uint8 angle_view;
  uint8 confidence;
  float32 width;
  float32 height;
  float32 length;
  float32 yaw;
  float32 relative_velocity_x;
  float32 relative_velocity_y;
  float32 relative_acceleration_x;
  float32 relative_acceleration_y;
  uint8 motion_status;
  uint16 valid_status;
  uint8 target_source;
} objectInfoSt;

#  define Rte_TypeDef_Idt_OS_TrapInfo_T
typedef struct
{
  Rte_DT_Idt_OS_TrapInfo_T_0 De_Context;
  Rte_DT_Idt_OS_TrapInfo_T_1 De_OS_UserTrap_ExceptionAddress;
  Rte_DT_Idt_OS_TrapInfo_T_2 De_Mcu_ResetStatusValue;
  Rte_DT_Idt_OS_TrapInfo_T_3 De_TaskId;
  Rte_DT_Idt_OS_TrapInfo_T_4 De_CoreId;
  Rte_DT_Idt_OS_TrapInfo_T_5 De_FatalError;
} Idt_OS_TrapInfo_T;

#  define Rte_TypeDef_Pept_Hb_Obstacle_Type
typedef struct
{
  uint32 SubFuncID;
  Rte_array_Pept_Hb_Obstacle_Type_Unsed_t Unsed;
  ObstacleHeader1_Type ObstacleHeader1;
  ObstacleHeader2_Type ObstacleHeader2;
  Rte_array_Pept_Hb_Obstacle_Type_ObstacleData_t ObstacleData;
  Rte_array_Pept_Hb_Obstacle_Type_ObstacleInternalID_t ObstacleInternalID;
  Pept_Hb_ObstacleCRC_Type ObstacleCRC;
} Pept_Hb_Obstacle_Type;

#  define Rte_TypeDef_PolygonBox
typedef struct
{
  boolean is_valid;
  Rte_DT_PolygonBox_1 polygon_contour;
  float32 height_lower_surface;
  float32 height_upper_surface;
} PolygonBox;

#  define Rte_TypeDef_Rte_DT_ST_LowSpeedBSD2CC_1
typedef objectInfoSt Rte_DT_ST_LowSpeedBSD2CC_1[2];

#  define Rte_TypeDef_ST_LowSpeedBSD2CC
typedef struct
{
  MsgHeader MsgHeader;
  Rte_DT_ST_LowSpeedBSD2CC_1 object;
  uint8 ViewSide;
  uint8 WorkStatus;
} ST_LowSpeedBSD2CC;

#  define Rte_TypeDef_GeneralObstacle
typedef struct
{
  SensorId sensor_id;
  uint32 obstacle_id;
  Timestamp current_prediction_timestamp_ns;
  ObstacleTypeInfo obstacle_type_info;
  SensorHistInfo sensor_hist_info;
  float32 existence_confidence;
  float32 class_confidence;
  Vector3f center_position;
  Vector3f absolute_velocity;
  Vector3f absolute_accelaration;
  float32 heading_angle;
  float32 heading_angular_velocity;
  uint8 moving_status;
  float32 bbox3d_width;
  float32 bbox3d_height;
  float32 bbox3d_length;
  PolygonBox polygon_box;
  Vector2f center_position_variance;
  Vector2f velocity_variance;
  Vector2f accelaration_variance;
  Vector3f size_variance;
  float32 heading_angle_std;
  float32 tracking_period;
  uint8 lamp_status;
  uint8 tracking_status;
  uint8 cut_in_status;
} GeneralObstacle;

#  define Rte_TypeDef_Rte_DT_ST_FusionObstacle_t_4
typedef GeneralObstacle Rte_DT_ST_FusionObstacle_t_4[100];

#  define Rte_TypeDef_ST_FusionObstacle_t
typedef struct
{
  Timestamp timestamp_t;
  CoordinateSystem coordinate;
  SensorId sensor_id;
  uint32 obstacle_num;
  Rte_DT_ST_FusionObstacle_t_4 general_obstacle_vector;
} ST_FusionObstacle_t;

# endif


/**********************************************************************************************************************
 * Constant value definitions
 *********************************************************************************************************************/

# define RTE_START_SEC_CONST_UNSPECIFIED
# include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

extern CONST(LCF_DmcNVRAMData_t, RTE_CONST) Rte_C_LCF_DmcNVRAMData_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(LCF_VehNVRAMData_t, RTE_CONST) Rte_C_LCF_VehNVRAMData_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(Lane_type, RTE_CONST) Rte_C_Lane_type_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(Objects_Type, RTE_CONST) Rte_C_Objects_Type_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_ADASHighlightID_t, RTE_CONST) Rte_C_ST_ADASHighlightID_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_ECAMtCyclEnvmode_t, RTE_CONST) Rte_C_ST_ECAMtCyclEnvmode_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_EMFusionGenObjList_t, RTE_CONST) Rte_C_ST_EMFusionGenObjList_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_EMVEDVehPar_t, RTE_CONST) Rte_C_ST_EMVEDVehPar_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_ENVODD2MCU_t, RTE_CONST) Rte_C_ST_ENVODD2MCU_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_EnvmNvm_t, RTE_CONST) Rte_C_ST_EnvmNvm_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_Envm_TrafficLight_t, RTE_CONST) Rte_C_ST_Envm_TrafficLight_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_Envm_TrafficSign_t, RTE_CONST) Rte_C_ST_Envm_TrafficSign_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_Envm_t_CRObjectList, RTE_CONST) Rte_C_ST_Envm_t_CRObjectList_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_Envm_t_GenObjectList, RTE_CONST) Rte_C_ST_Envm_t_GenObjectList_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_FusionLine_t, RTE_CONST) Rte_C_ST_FusionLine_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_LBSFunState_t, RTE_CONST) Rte_C_ST_LBSFunState_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_LCFSEN_NVRAMData_t, RTE_CONST) Rte_C_ST_LCFSEN_NVRAMData_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_LCF_DmcGenericOutputs_t, RTE_CONST) Rte_C_ST_LCF_DmcGenericOutputs_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_LCF_SenGenericOutputs_t, RTE_CONST) Rte_C_ST_LCF_SenGenericOutputs_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_LCF_SenToVehs_t, RTE_CONST) Rte_C_ST_LCF_SenToVehs_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_LCF_VehGenericOutputs_t, RTE_CONST) Rte_C_ST_LCF_VehGenericOutputs_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_RoadSemantics2MCU_t, RTE_CONST) Rte_C_ST_RoadSemantics2MCU_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_VEDNvIoDatas_t, RTE_CONST) Rte_C_ST_VEDNvIoDatas_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_VEDVehDyn_t, RTE_CONST) Rte_C_ST_VEDVehDyn_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_VEDVehDyn_t_SyncEgo, RTE_CONST) Rte_C_ST_VEDVehDyn_t_SyncEgo_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_VEDVehSig_t, RTE_CONST) Rte_C_ST_VEDVehSig_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_VLCSen_AccOOI_List_t, RTE_CONST) Rte_C_ST_VLCSen_AccOOI_List_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_VLCSen_AssessedObjList_t, RTE_CONST) Rte_C_ST_VLCSen_AssessedObjList_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_VLCSen_HypothesisIntf_t, RTE_CONST) Rte_C_ST_VLCSen_HypothesisIntf_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_VLCSen_acc_object_t, RTE_CONST) Rte_C_ST_VLCSen_acc_object_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_VLCSen_acc_output_data_t, RTE_CONST) Rte_C_ST_VLCSen_acc_output_data_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_VLCVEH_CANOut, RTE_CONST) Rte_C_ST_VLCVEH_CANOut_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_VLCVeh_LongCtrlInput_t, RTE_CONST) Rte_C_ST_VLCVeh_LongCtrlInput_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_VLCVeh_NVRAMData_t, RTE_CONST) Rte_C_ST_VLCVeh_NVRAMData_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_VehicleDynamicSignals_t, RTE_CONST) Rte_C_ST_VehicleDynamicSignals_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_reqCTASEN_SOA_HMI_t, RTE_CONST) Rte_C_ST_reqCTASEN_SOA_HMI_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_reqLBSSEN_SOA_HMI_t, RTE_CONST) Rte_C_ST_reqLBSSEN_SOA_HMI_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_reqLCFSEN_SOA_HMI_t, RTE_CONST) Rte_C_ST_reqLCFSEN_SOA_HMI_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(ST_reqVLCVEH_SOA_HMI_t, RTE_CONST) Rte_C_ST_reqVLCVEH_SOA_HMI_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

extern CONST(VLCSen_NVRAMData_t, RTE_CONST) Rte_C_VLCSen_NVRAMData_t_0; /* PRQA S 0850 */ /* MD_MSR_19.8 */

# define RTE_STOP_SEC_CONST_UNSPECIFIED
# include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */
# include "Rte_DataHandleType.h"

/**********************************************************************************************************************
 *  LOCAL DATA TYPES AND STRUCTURES
 *********************************************************************************************************************/

typedef unsigned int Rte_BitType;
/**********************************************************************************************************************
 * type and extern declarations of RTE internal variables
 *********************************************************************************************************************/

/**********************************************************************************************************************
 * Rte Init State Variable
 *********************************************************************************************************************/

# define RTE_STATE_UNINIT    (0U)
# define RTE_STATE_SCHM_INIT (1U)
# define RTE_STATE_INIT      (2U)

# define RTE_START_SEC_VAR_ZERO_INIT_8BIT
# include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

extern volatile VAR(uint8, RTE_VAR_ZERO_INIT) Rte_InitState; /* PRQA S 0850, 3408 */ /* MD_MSR_19.8, MD_Rte_3408 */

# define RTE_STOP_SEC_VAR_ZERO_INIT_8BIT
# include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

# define RTE_START_SEC_VAR_GLOBALSHARED_NOCACHE_ZERO_INIT_8BIT
# include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

extern volatile VAR(uint8, RTE_VAR_ZERO_INIT_NOCACHE) Rte_InitState_1; /* PRQA S 0850, 3408 */ /* MD_MSR_19.8, MD_Rte_3408 */

# define RTE_STOP_SEC_VAR_GLOBALSHARED_NOCACHE_ZERO_INIT_8BIT
# include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

# define RTE_START_SEC_VAR_GLOBALSHARED_NOCACHE_ZERO_INIT_8BIT
# include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

extern volatile VAR(uint8, RTE_VAR_ZERO_INIT_NOCACHE) Rte_InitState_2; /* PRQA S 0850, 3408 */ /* MD_MSR_19.8, MD_Rte_3408 */

# define RTE_STOP_SEC_VAR_GLOBALSHARED_NOCACHE_ZERO_INIT_8BIT
# include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

# define RTE_START_SEC_VAR_GLOBALSHARED_NOCACHE_ZERO_INIT_8BIT
# include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

extern volatile VAR(uint8, RTE_VAR_ZERO_INIT_NOCACHE) Rte_InitState_3; /* PRQA S 0850, 3408 */ /* MD_MSR_19.8, MD_Rte_3408 */

# define RTE_STOP_SEC_VAR_GLOBALSHARED_NOCACHE_ZERO_INIT_8BIT
# include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

# define RTE_START_SEC_VAR_GLOBALSHARED_NOCACHE_ZERO_INIT_8BIT
# include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

extern volatile VAR(uint8, RTE_VAR_ZERO_INIT_NOCACHE) Rte_InitState_4; /* PRQA S 0850, 3408 */ /* MD_MSR_19.8, MD_Rte_3408 */

# define RTE_STOP_SEC_VAR_GLOBALSHARED_NOCACHE_ZERO_INIT_8BIT
# include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

# define RTE_START_SEC_VAR_GLOBALSHARED_NOCACHE_ZERO_INIT_8BIT
# include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

extern volatile VAR(uint8, RTE_VAR_ZERO_INIT_NOCACHE) Rte_InitState_5; /* PRQA S 0850, 3408 */ /* MD_MSR_19.8, MD_Rte_3408 */

# define RTE_STOP_SEC_VAR_GLOBALSHARED_NOCACHE_ZERO_INIT_8BIT
# include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

# ifdef RTE_CORE

/**********************************************************************************************************************
 * Buffers for unqueued S/R
 *********************************************************************************************************************/

#  define RTE_START_SEC_VAR_NOCACHE_INIT_UNSPECIFIED
#  include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_ACU_FCWWarnDistanceCfg_ACU_FCWWarnDistanceCfg; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_ACU_LDW_LKACfg_ACU_LDW_LKACfg; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_ACU_iACC_SwitchReq_ACU_iACC_SwitchReq; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCM_DriverDoorAjarSt_BCM_DriverDoorAjarSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCM_FrontFogLampSt_BCM_FrontFogLampSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCM_FrontWasherSt_BCM_FrontWasherSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCM_FrontWiperSt_BCM_FrontWiperSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCM_HazardLampSt_BCM_HazardLampSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCM_HighBeamSt_BCM_HighBeamSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCM_KeySt_BCM_KeySt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCM_LeftTurnLampSt_BCM_LeftTurnLampSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCM_LowBeamSt_BCM_LowBeamSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCM_PsngrDoorAjarSt_BCM_PsngrDoorAjarSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCM_RLDoorAjarSt_BCM_RLDoorAjarSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCM_RRDoorAjarSt_BCM_RRDoorAjarSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCM_RearFogLampSt_BCM_RearFogLampSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCM_RightTurnLampSt_BCM_RightTurnLampSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCM_TurnLightSwitchSt_BCM_TurnLightSwitchSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_ABSActiveSt_BCS_ABSActiveSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_ABSFaultSt_BCS_ABSFaultSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_AEBAvailable_BCS_AEBAvailable; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_AWBActive_BCS_AWBActive; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_ActVehLaltrlAccel_BCS_ActVehLaltrlAccel; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_ActVehLaltrlAccelVD_BCS_ActVehLaltrlAccelVD; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_ActVehLongAccel_BCS_ActVehLongAccel; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_ActVehLongAccelVD_BCS_ActVehLongAccelVD; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_BrakeOverHeat_BCS_BrakeOverHeat; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_EBDFaultSt_BCS_EBDFaultSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_FLWheelRotatedDirection_BCS_FLWheelRotatedDirection; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_FLWheelSpd_BCS_FLWheelSpd; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_FLWheelSpdEdgesSum_BCS_FLWheelSpdEdgesSum; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_FLWheelSpdEdgesSumVD_BCS_FLWheelSpdEdgesSumVD; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_FLWheelSpdVD_BCS_FLWheelSpdVD; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_FRWheelRotatedDirection_BCS_FRWheelRotatedDirection; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_FRWheelSpd_BCS_FRWheelSpd; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_FRWheelSpdEdgesSum_BCS_FRWheelSpdEdgesSum; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_FRWheelSpdEdgesSumVD_BCS_FRWheelSpdEdgesSumVD; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_FRWheelSpdVD_BCS_FRWheelSpdVD; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_HDCCtrlSt_BCS_HDCCtrlSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_NoBrakeForce_BCS_NoBrakeForce; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_RLWheelRotatedDirection_BCS_RLWheelRotatedDirection; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_RLWheelSpd_BCS_RLWheelSpd; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_RLWheelSpdEdgesSum_BCS_RLWheelSpdEdgesSum; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_RLWheelSpdEdgesSumVD_BCS_RLWheelSpdEdgesSumVD; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_RLWheelSpdVD_BCS_RLWheelSpdVD; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_RRWheelRotatedDirection_BCS_RRWheelRotatedDirection; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_RRWheelSpd_BCS_RRWheelSpd; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_RRWheelSpdEdgesSum_BCS_RRWheelSpdEdgesSum; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_RRWheelSpdEdgesSumVD_BCS_RRWheelSpdEdgesSumVD; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_RRWheelSpdVD_BCS_RRWheelSpdVD; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_TCSActiveSt_BCS_TCSActiveSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_TCSFaultSt_BCS_TCSFaultSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_TCSOff_BCS_TCSOff; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_VehSpd_BCS_VehSpd; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_VehSpdVD_BCS_VehSpdVD; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_VehicleStandStillSt_BCS_VehicleStandStillSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_YawRate_BCS_YawRate; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BCS_YawRateSt_BCS_YawRateSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_BSDM_RCTBPrefillReq_BSDM_RCTBPrefillReq; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_DMS_FatigWarnSt_DMS_FatigWarnSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_EMS_ACCButtInfo_EMS_ACCButtInfo; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_EPB_FailSt_EPB_SysSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_EPB_SysSt_EPB_SysSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_EPSCtrlSt_EPSCtrlSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_EPS_LKACtrlAbortFeedback_EPS_LKACtrlAbortFeedback; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_EPS_SteeringAngle_EPS_SteeringAngle; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_EPS_SteeringAngleSpd_EPS_SteeringAngleSpd; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_EPS_SteeringAngleSpdVD_EPS_SteeringAngleSpdVD; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_EPS_SteeringAngleVD_EPS_SteeringAngleVD; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_EPS_StrngWhlTorq_EPS_StrngWhlTorq; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_EPS_StrngWhlTorqVD_EPS_StrngWhlTorqVD; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_HVAC_CorrectedExterTemp_HVAC_CorrectedExterTemp; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_HVAC_CorrectedExterTempVD_HVAC_CorrectedExterTempVD; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_ICM_DisFail_ICM_DisFail; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_ICM_TotalOdometer_ICM_TotalOdometer; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_ICM_VehInsSpd_ICM_VehInsSpd; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_SAS_CalibratedSt_SAS_CalibratedSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_SRS_DriverSeatBeltSt_SRS_DriverSeatBeltSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_SWSM_A_CD_Add_Overtime_SWSM_A_CD_Add_Overtime; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_SWSM_A_CD_Minus_Overtime_SWSM_A_CD_Minus_Overtime; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_SWSM_A_CruiseDistance_Add_SWSM_A_CruiseDistance_Add; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_SWSM_A_CruiseDistance_Minus_SWSM_A_CruiseDistance_Minus; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_SWSM_A_CruiseSpeed_Add_SWSM_A_CruiseSpeed_Add; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_SWSM_A_CruiseSpeed_Minus_SWSM_A_CruiseSpeed_Minus; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_VCU_AccDriverOrvd_VCU_AccDriverOrvd; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_VCU_ActVehWheelTorq_VCU_ActVehWheelTorq; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_VCU_CrntGearLvl_VCU_CrntGearLvl; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_VCU_CrntGearLvlVD_VCU_CrntGearLvlVD; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_VCU_EMS_AccPedalActPst_VCU_EMS_AccPedalActPst; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_VCU_EMS_AccPedalActPstVD_VCU_EMS_AccPedalActPstVD; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_VCU_EMS_BrkPedalSt_VCU_EMS_BrkPedalSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_VCU_EMS_BrkPedalStVD_VCU_EMS_BrkPedalStVD; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint16, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_VCU_LateralAssistBtnInfo_VCU_LateralAssistBtnInfo; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_FCU_rSWCRX_VCU_LateralAssistBtnInfoVD_VCU_LateralAssistBtnInfoVD; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(Lane_type, RTE_VAR_INIT_NOCACHE) Rte_SDC_Axera_Signal_Lane_Axera_Lane; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(Objects_Type, RTE_VAR_INIT_NOCACHE) Rte_SDC_Axera_Signal_Obstacle_Axera_Obstacle; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(Lane_type, RTE_VAR_INIT_NOCACHE) Rte_UDC_ME_Signal_Lane_ME_Lane; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(Objects_Type, RTE_VAR_INIT_NOCACHE) Rte_UDC_ME_Signal_Obstacle_ME_Obstacle; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */

#  define RTE_STOP_SEC_VAR_NOCACHE_INIT_UNSPECIFIED
#  include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

#  define RTE_START_SEC_VAR_SystemApplication_OsCore2_INIT_UNSPECIFIED
#  include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

extern VAR(ST_VEDNvIoDatas_t, RTE_VAR_INIT) Rte_VED_pVED_ST_VEDNvIoDatas_t_ST_VEDNvIoDatas_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(ST_VLCSen_HypothesisIntf_t, RTE_VAR_INIT) Rte_VLCSEN_pVLCSEN_ST_VLCSen_HypothesisIntf_t_ST_VLCSen_HypothesisIntf_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(VLCSen_NVRAMData_t, RTE_VAR_INIT) Rte_VLCSEN_pVLCSEN_ST_VLCSen_NVRAMData_t_ST_VLCSen_NVRAMData_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(ST_VLCSen_acc_object_t, RTE_VAR_INIT) Rte_VLCSEN_pVLCSEN_ST_VLCSen_acc_object_t_ST_VLCSen_acc_object_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(ST_VLCSen_acc_output_data_t, RTE_VAR_INIT) Rte_VLCSEN_pVLCSEN_ST_VLCSen_acc_output_data_t_ST_VLCSen_acc_output_data_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(ST_VLCVeh_NVRAMData_t, RTE_VAR_INIT) Rte_VLVEH_pVLCVEH_ST_VLCVeh_NVRAMData_t_ST_VLCVeh_NVRAMData_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */

#  define RTE_STOP_SEC_VAR_SystemApplication_OsCore2_INIT_UNSPECIFIED
#  include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

#  define RTE_START_SEC_VAR_SystemApplication_OsCore2_NOCACHE_INIT_UNSPECIFIED
#  include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

extern VAR(ST_EMVEDVehPar_t, RTE_VAR_INIT_NOCACHE) Rte_VED_pVED_ST_EMVEDVehPar_t_ST_EMVEDVehPar_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(ST_VEDVehDyn_t, RTE_VAR_INIT_NOCACHE) Rte_VED_pVED_ST_VEDVehDyn_t_ST_VEDVehDyn_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(ST_VEDVehSig_t, RTE_VAR_INIT_NOCACHE) Rte_VED_pVED_ST_VEDVehSig_t_ST_VEDVehSig_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_VLCSEN_pSWCTX_ADAS_HWAHF_PedestrainDet_ADAS_HWAHF_PedestrainDet; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLCSEN_pSWCTX_ADAS_TrkTargt2ObjClass_ADAS_TrkTargt2ObjClass; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_VLCSEN_pSWCTX_ADAS_TrkTargt2St_ADAS_TrkTargt2St; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_VLCSEN_pSWCTX_ADAS_TrkTargt2latPos_ADAS_TrkTargt2latPos; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLCSEN_pSWCTX_ADAS_TrkTargt3ObjClass_ADAS_TrkTargt3ObjClass; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_VLCSEN_pSWCTX_ADAS_TrkTargt3St_ADAS_TrkTargt3St; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_VLCSEN_pSWCTX_ADAS_TrkTargt3latPos_ADAS_TrkTargt3latPos; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLCSEN_pSWCTX_ADAS_TrkTargt3longPos_ADAS_TrkTargt3longPos; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_VLCSEN_pSWCTX_MRR_ObjectCapturedSt_MRR_ObjectCapturedSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(ST_VLCSen_AccOOI_List_t, RTE_VAR_INIT_NOCACHE) Rte_VLCSEN_pVLCSEN_ST_VLCSen_AccOOI_List_t_ST_VLCSen_AccOOI_List_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(ST_VLCSen_AssessedObjList_t, RTE_VAR_INIT_NOCACHE) Rte_VLCSEN_pVLCSEN_ST_VLCSen_AssessedObjList_t_ST_VLCSen_AssessedObjList_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_ADAS_HWAHF_SpdDecRea_ADAS_HWAHF_SpdDecRea; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_ADAS_IntlCrusMode_ADAS_IntlCrusMode; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_ADAS_LongCtrTargetAccelJerkMaxnValue_ADAS_LongCtrTargetAccelJerkMaxnValue; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_ADAS_LongCtrlAccelCtrlReq_ADAS_LongCtrlAccelCtrlReq; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_ADAS_LongCtrlDecToStopReq_ADAS_LongCtrlDecToStopReq; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_ADAS_LongCtrlDriveOff_ADAS_LongCtrlDriveOff; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_ADAS_LongCtrlModeForBrkSys_ADAS_LongCtrlModeForBrkSys; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_ADAS_LongCtrlShutdownReq_ADAS_LongCtrlShutdownReq; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_ADAS_LongCtrlTargetAccel_ADAS_LongCtrlTargetAccel; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_ADAS_LongCtrlTargetAccelJerkMinValue_ADAS_LongCtrlTargetAccelJerkMinValue; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_ADAS_LongCtrlTypReqLong_ADAS_LongCtrlTypReqLong; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_ADAS_LongCtrlTypReqMode_ADAS_LongCtrlTypReqMode; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_ADAS_SensorBlockedSts_ADAS_SensorBlockedSts; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_ADAS_SensorCalibrationSts_ADAS_SensorCalibrationSts; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_ADAS_SensorFailure_ADAS_SensorFailure; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_IFC_AEBBrkPedalOverRide_IFC_AEBBrkPedalOverRide; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_ACCActiveSt_MRR_ACCActiveSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_ACCFaultSt_MRR_ACCFaultSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_ACCFuncCancel_MRR_ACCFuncCancel; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_ACCGoNotifier_MRR_ACCGoNotifier; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_ACCMode_MRR_ACCMode; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_ACCQuitSound_MRR_ACCQuitSound; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_ACCRecpDecel_MRR_ACCRecpDecel; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_ACCRecpDecelReq_MRR_ACCRecpDecelReq; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_ACCReqQua_MRR_ACCReqQua; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_ACCTakeOverReq_MRR_ACCTakeOverReq; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_ACCTextInfo_MRR_ACCTextInfo; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_ACCUnableActivated_MRR_ACCUnableActivated; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_AEBFaultSt_MRR_AEBFaultSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_AEBLVehHoldReq_MRR_AEBLVehHoldReq; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_AEBOffSt_MRR_AEBOffSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_AEBTargetDecel_MRR_AEBTargetDecel; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_AWBLevel_MRR_AWBLevel; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_AWBReq_MRR_AWBReq; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_ActTrqReq_MRR_ActTrqReq; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_ActTrqReqVD_MRR_ActTrqReqVD; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_FCWFaultSt_MRR_FCWFaultSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_FCWOffSt_MRR_FCWOffSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_IFC_PriCANAvailableSt_MRR_IFC_PriCANAvailableSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_IFC_PriCANErrorSt_MRR_IFC_PriCANErrorSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_PEBSObjType_MRR_PEBSObjType; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_TargetDistanceSt_MRR_TargetDistanceSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_TargetSpd_MRR_TargetSpd; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_MRR_TauGapSet_MRR_TauGapSet; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pSWCTX_VCU_VehDrvMod_VCU_VehDrvMod; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(ST_reqVLCVEH_SOA_HMI_t, RTE_VAR_INIT_NOCACHE) Rte_VLVEH_pVLCVEH_ST_reqVLCVEH_SOA_HMI_t_ST_reqVLCVEH_SOA_HMI_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */

#  define RTE_STOP_SEC_VAR_SystemApplication_OsCore2_NOCACHE_INIT_UNSPECIFIED
#  include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

#  define RTE_START_SEC_VAR_SystemApplication_OsCore3_INIT_UNSPECIFIED
#  include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

extern VAR(ST_LCF_DmcGenericOutputs_t, RTE_VAR_INIT) Rte_DMC_pDMC_ST_LCF_DmcGenericOutputs_t_ST_LCF_DmcGenericOutputs_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(LCF_DmcNVRAMData_t, RTE_VAR_INIT) Rte_DMC_pDMC_ST_LCF_DmcNVRAMData_t_ST_LCF_DmcNVRAMData_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(ST_LCFSEN_NVRAMData_t, RTE_VAR_INIT) Rte_LCFSEN_pLCFSEN_ST_LCFSEN_NVRAMData_t_ST_LCFSEN_NVRAMData_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(ST_LCF_SenGenericOutputs_t, RTE_VAR_INIT) Rte_LCFSEN_pLCFSEN_ST_LCF_SenGenericOutputs_t_ST_LCF_SenGenericOutputs_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(ST_LCF_SenToVehs_t, RTE_VAR_INIT) Rte_LCFSEN_pLCFSEN_ST_LCF_SenToVehs_t_ST_LCF_SenToVehs_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(LCF_VehNVRAMData_t, RTE_VAR_INIT) Rte_LCFVEH_pLCFVEH_LCF_VehNVRAMData_t_LCF_VehNVRAMData_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(ST_LCF_VehGenericOutputs_t, RTE_VAR_INIT) Rte_LCFVEH_pLCFVEH_ST_LCF_VehGenericOutputs_t_ST_LCF_VehGenericOutputs_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */

#  define RTE_STOP_SEC_VAR_SystemApplication_OsCore3_INIT_UNSPECIFIED
#  include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

#  define RTE_START_SEC_VAR_SystemApplication_OsCore3_NOCACHE_INIT_UNSPECIFIED
#  include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_ADAS_HWAHF_CrrtCycLock_ADAS_HWAHF_CrrtCycLock; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_ADAS_HWAHF_FailureSt_ADAS_HWAHF_FailureSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_ADAS_HWA_EnableSt_ADAS_HWA_EnableSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_ADAS_HWA_FailureSt_ADAS_HWA_FailureSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_ADAS_HWA_ILCAbortReason_ADAS_HWA_ILCAbortReason; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_ADAS_HWA_ILCAbortSoundWarn_ADAS_HWA_ILCAbortSoundWarn; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_ADAS_HWA_ILCLeftIndicator_ADAS_HWA_ILCLeftIndicator; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_ADAS_HWA_ILCLeftSt_ADAS_HWA_ILCLeftSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_ADAS_HWA_ILCRightIndicator_ADAS_HWA_ILCRightIndicator; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_ADAS_HWA_ILCRighttSt_ADAS_HWA_ILCRighttSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_ADAS_HWA_ILCTextInfo_ADAS_HWA_ILCTextInfo; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_ADAS_L2FunReqSt_ADAS_L2FunReqSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_ADAS_L3FunReqSt_ADAS_L3FunReqSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_ADAS_LateralCtrlSt_ADAS_LateralCtrlSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_ADAS_LateralCtrlTyp_ADAS_LateralCtrlTyp; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_ADAS_StrAngleReq_ADAS_StrAngleReq; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_pSWCTX_EPS_LKACtrlSt_EPS_LKACtrlSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_IFC_CameraBlockageSt_IFC_CameraBlockageSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_IFC_ELKSt_IFC_ELKSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_IFC_ELKWarnL_IFC_ELKWarnL; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_IFC_ELKWarnR_IFC_ELKWarnR; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_IFC_LKS_LaneAssistType_IFC_LKS_LaneAssistType; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_IFC_LateralCtrlQuitWarn_IFC_LateralCtrlQuitWarn; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_IFC_LeftTrackingSt_IFC_LeftTrackingSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_IFC_RightTrackingSt_IFC_RightTrackingSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_IFC_SysCalibrationSt_IFC_SysCalibrationSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_IFC_TorqueReq_IFC_TorqueReq; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_IFC_TorqueReqSt_IFC_TorqueReqSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_FCU_pSWCTX_LKS_Status_LKS_Status; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_DMC_pSWCTX_PCS_LDWStatus_PCS_LDWStatus; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(ST_reqLCFSEN_SOA_HMI_t, RTE_VAR_INIT_NOCACHE) Rte_LCFSEN_pLCFSEN_ST_reqLCFSEN_SOA_HMI_t_ST_reqLCFSEN_SOA_HMI_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_LCFSEN_pSWCTX_ADAS_AdjLLnMrkingDispSt_ADAS_AdjLLnMrkingDispSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_LCFSEN_pSWCTX_ADAS_AdjRLnMrkingDispSt_ADAS_AdjRLnMrkingDispSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_LCFSEN_pSWCTX_ADAS_HWAHF_HandsOnReqSoundWarn_ADAS_HWAHF_HandsOnReqSoundWarn; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_LCFSEN_pSWCTX_ADAS_LLnMarkingDisPropToLnWidth_ADAS_LLnMarkingDisPropToLnWidth; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_LCFSEN_pSWCTX_ADAS_LnMarkingCurvature_ADAS_LnMarkingCurvature; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(float32, RTE_VAR_INIT_NOCACHE) Rte_LCFSEN_pSWCTX_ADAS_LnMarkingHeadAngToVeh_ADAS_LnMarkingHeadAngToVeh; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_LCFSEN_pSWCTX_EPS_HandsOffDetSt_EPS_HandsOffDetSt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_LCFSEN_pSWCTX_IFC_CruiseMode_IFC_CruiseMode; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_LCFSEN_pSWCTX_IFC_LKS_TakeoverReq_IFC_LKS_TakeoverReq; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_LCFVEH_pSWCTX_ADAS_HWAHF_EyesOnRoadReq_ADAS_HWAHF_EyesOnRoadReq; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_LCFVEH_pSWCTX_ADAS_HWAHF_EyesOnRoadSoundWarn_ADAS_HWAHF_EyesOnRoadSoundWarn; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_LCFVEH_pSWCTX_ADAS_HWAHF_HandsOnPrompt_ADAS_HWAHF_HandsOnPrompt; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_LCFVEH_pSWCTX_ADAS_HWAHF_LegalDisclaimer_ADAS_HWAHF_LegalDisclaimer; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_LCFVEH_pSWCTX_ADAS_HWAHF_Lightbar_ADAS_HWAHF_Lightbar; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_LCFVEH_pSWCTX_ADAS_HWAHF_SafeStop_ADAS_HWAHF_SafeStop; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_LCFVEH_pSWCTX_ADAS_HWAHF_SafeStopSoundWarn_ADAS_HWAHF_SafeStopSoundWarn; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_LCFVEH_pSWCTX_ADAS_HWAHF_TakeOverReq_ADAS_HWAHF_TakeOverReq; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_LCFVEH_pSWCTX_ADAS_HWAHF_TakeOverReqSoundWarn_ADAS_HWAHF_TakeOverReqSoundWarn; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(boolean, RTE_VAR_INIT_NOCACHE) Rte_LCFVEH_pSWCTX_ADAS_LateralCtrlOvrrdFlg_ADAS_LateralCtrlOvrrdFlg; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(uint8, RTE_VAR_INIT_NOCACHE) Rte_LCFVEH_pSWCTX_IFC_TJA_ICA_St_IFC_TJA_ICA_St; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */

#  define RTE_STOP_SEC_VAR_SystemApplication_OsCore3_NOCACHE_INIT_UNSPECIFIED
#  include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

#  define RTE_START_SEC_VAR_SystemApplication_OsCore4_INIT_UNSPECIFIED
#  include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

extern VAR(ST_ENVODD2MCU_t, RTE_VAR_INIT) Rte_EM_pEM_ST_ENVODD2MCU_t_ST_ENVODD2MCU_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(ST_EnvmNvm_t, RTE_VAR_INIT) Rte_EM_pEM_ST_EnvmNvm_t_ST_EnvmNvm_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(ST_FusionLine_t, RTE_VAR_INIT) Rte_EM_pEM_ST_FusionLine_t_ST_FusionLine_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(ST_RoadSemantics2MCU_t, RTE_VAR_INIT) Rte_EM_pEM_ST_RoadSemantics2MCU_t_ST_RoadSemantics2MCU_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */

#  define RTE_STOP_SEC_VAR_SystemApplication_OsCore4_INIT_UNSPECIFIED
#  include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

#  define RTE_START_SEC_VAR_SystemApplication_OsCore4_NOCACHE_INIT_UNSPECIFIED
#  include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

extern VAR(ST_ECAMtCyclEnvmode_t, RTE_VAR_INIT_NOCACHE) Rte_EM_pEM_ST_ECAMtCyclEnvmode_t_ST_ECAMtCyclEnvmode_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(ST_EMFusionGenObjList_t, RTE_VAR_INIT_NOCACHE) Rte_EM_pEM_ST_EMFusionGenObjList_t_ST_EMFusionGenObjList_t; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(ST_Envm_t_CRObjectList, RTE_VAR_INIT_NOCACHE) Rte_EM_pEM_ST_Envm_t_CRObjectList_ST_Envm_t_CRObjectList; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */
extern VAR(ST_Envm_t_GenObjectList, RTE_VAR_INIT_NOCACHE) Rte_EM_pEM_ST_Envm_t_GenObjectList_ST_Envm_t_GenObjectList; /* PRQA S 0850, 3408, 1504 */ /* MD_MSR_19.8, MD_Rte_3408, MD_MSR_8.10 */

#  define RTE_STOP_SEC_VAR_SystemApplication_OsCore4_NOCACHE_INIT_UNSPECIFIED
#  include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

typedef struct
{
  Rte_BitType Rte_ModeSwitchAck_BswM_Switch_ESH_ModeSwitch_BswM_MDGP_ESH_Mode_Ack : 1;
} Rte_SystemApplication_OsCore0_AckFlagsType;

#  define RTE_START_SEC_VAR_INIT_UNSPECIFIED
#  include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

extern VAR(Rte_SystemApplication_OsCore0_AckFlagsType, RTE_VAR_INIT) Rte_SystemApplication_OsCore0_AckFlags; /* PRQA S 0850 */ /* MD_MSR_19.8 */

#  define RTE_STOP_SEC_VAR_INIT_UNSPECIFIED
#  include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */


/**********************************************************************************************************************
 * Data structures for mode management
 *********************************************************************************************************************/


#  define RTE_START_SEC_VAR_INIT_UNSPECIFIED
#  include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

extern VAR(BswM_ESH_Mode, RTE_VAR_INIT) Rte_ModeMachine_BswM_Switch_ESH_ModeSwitch_BswM_MDGP_ESH_Mode; /* PRQA S 3408 */ /* MD_Rte_3408 */

#  define RTE_STOP_SEC_VAR_INIT_UNSPECIFIED
#  include "MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */


# endif /* defined(RTE_CORE) */

#endif /* _RTE_TYPE_H */

/**********************************************************************************************************************
 MISRA 2004 violations and justifications
 *********************************************************************************************************************/

/* module specific MISRA deviations:
   MD_Rte_3408:  MISRA rule: 8.8
     Reason:     For the purpose of monitoring during calibration or debugging it is necessary to use non-static declarations.
                 This is covered in the MISRA C compliance section of the Rte specification.
     Risk:       No functional risk.
     Prevention: Not required.

*/
