/**
 * @file
 * @brief  add 20211110
 *        instruction manual: include the head file in prediction.h;
 */
#include "PD_SVEstmd.h"
using namespace ADC::PD_SVEstmd;

#if FLAG_PDFP_SAVECSV != 0
extern std::string timeStampBag;
#endif

#if FLAG_PREDICTION_TNT_BA
std::unique_ptr<pd_forwardSpread::ObstaclePrediction> obstaclePrediction = std::make_unique<pd_forwardSpread::ObstaclePrediction>();
#endif

/**
 * @brief
 * @param
 */
SVEstmd::SVEstmd(const PD::PD_Input &m_pd_input){
    if(init(m_pd_input)==false)
    return;
}



/**
 * @brief 
 * @param
 * @return
 */
bool SVEstmd::init(const PD::PD_Input &m_pd_input){
    bool Flag=true;
    Flag = Flag && (static_cast<decltype(m_pd_input.rm_roadmodel.size())>(rm_Num)<m_pd_input.rm_roadmodel.size());                                 //chech rm_roadmodel
    if(Flag){
        Flag = Flag && (static_cast<decltype(m_pd_input.rm_roadmodel.at(rm_Num).passage_list.size())>(psg_Num)<m_pd_input.rm_roadmodel.at(rm_Num).passage_list.size());    //chech passage_list
    }
    /*Flag = Flag && !(m_pd_input.rm_roadmodel.empty());                  //chech rm_roadmodel
    for(auto& element : m_pd_input.rm_roadmodel){
        // Flag = Flag && !(element.lane_list.empty());                 //check lane_list
        Flag = Flag && !(element.passage_list.empty());                 //check passage_list
        // for(auto& element2 : element.lane_list){
            // Flag = Flag && !(element2.corridor_list.empty());               //check corridor_list
            // for(auto& element3 : element2.corridor_list){
            //     Flag = Flag && !(element3.object_in_corridor_list.empty()); //check object_in_corridor_list
            // }
        // }
    }*/

    if(Flag==false){
        initFlag=false;
    }
    else{
        SV_Trajectory_list.clear();
        _pd_SVEstmd_EV_LgtTraj.clear();
        initFlag=true;

        _BA_duration_time_input = m_pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).duration_time;
        _passage_corridor_ID    = m_pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).corridor_id;
        PD_SVEstmd_SV_msg pd_SVEstmd_SV_msg;
        _pd_SVEstmd_SV_msg_list.clear();
        _pd_SVEstmd_SV_msg_list.reserve(128);
        // get the offset between ilc corridor with base corridor
        float deltaL_ilc2baseCorridor = 0.0f;
        bool flagFindPassageCorridorID = false;
        const Corridor* corridor_withObject = nullptr;
        if(static_cast<uint8_t>(m_pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).feature_label) == static_cast<uint8_t>(3)){     // ilc
            float c0_baseCorridor = 0.0f;
            float c0_ilcCorridor = 0.0f;
            for(const auto& element:m_pd_input.rm_roadmodel.at(rm_Num).lane_list){
                for(const auto& element2:element.corridor_list){
                    if(element2.corridor_id == _passage_corridor_ID){
                        c0_ilcCorridor = element2.reference_line.c0;
                        _BA_corridor_line = element2.reference_line;
                        flagFindPassageCorridorID = true;
                        break;
                    }
                }
                if(flagFindPassageCorridorID){
                    for(const auto& element2:element.corridor_list){
                        if(static_cast<uint8_t>(element2.feature_tag) == static_cast<uint8_t>(1)){      // line follow
                            c0_baseCorridor = element2.reference_line.c0;
                            corridor_withObject = &element2;
                            break;
                        }
                    }
                    break;
                }
            }
            deltaL_ilc2baseCorridor = c0_ilcCorridor - c0_baseCorridor;
        }
        else{
            for(const auto& element:m_pd_input.rm_roadmodel.at(rm_Num).lane_list){
                for(const auto& element2:element.corridor_list){
                    if(element2.corridor_id == _passage_corridor_ID){
                        corridor_withObject = &element2;
                        _BA_corridor_line = element2.reference_line;
                        flagFindPassageCorridorID = true;
                        break;
                    }
                }
                if(flagFindPassageCorridorID) break;
            }
        }

        if(corridor_withObject != nullptr)
        for(const auto& ele_obj : corridor_withObject->object_in_corridor_list){
            pd_SVEstmd_SV_msg.obj_ID = ele_obj.object_id;
            pd_SVEstmd_SV_msg.s_SV = ele_obj.reference_point2corridor_frenet.s;
            pd_SVEstmd_SV_msg.ds_SV = ele_obj.reference_point2corridor_frenet.ds;
            pd_SVEstmd_SV_msg.dds_SV = ele_obj.reference_point2corridor_frenet.dds;
            pd_SVEstmd_SV_msg.dds_validtime_SV = ele_obj.reference_point2corridor_frenet.dds_valid_time;
            pd_SVEstmd_SV_msg.l_SV = ele_obj.reference_point2corridor_frenet.l - deltaL_ilc2baseCorridor;
            pd_SVEstmd_SV_msg.dl_SV = ele_obj.reference_point2corridor_frenet.dl;
            pd_SVEstmd_SV_msg.dl_validtime_SV = ele_obj.reference_point2corridor_frenet.dl_valid_time;
            pd_SVEstmd_SV_msg.ddl_SV = ele_obj.reference_point2corridor_frenet.ddl;
            pd_SVEstmd_SV_msg.ddl_validtime_SV = ele_obj.reference_point2corridor_frenet.ddl_valid_time;
            _pd_SVEstmd_SV_msg_list.emplace_back(pd_SVEstmd_SV_msg);
        }
        if(corridor_withObject != nullptr)
        for(const auto& ele_obj : corridor_withObject->relevant_object_corridor_list){
            pd_SVEstmd_SV_msg.obj_ID = ele_obj.object_id;
            pd_SVEstmd_SV_msg.s_SV = ele_obj.reference_point2corridor_frenet.s;
            pd_SVEstmd_SV_msg.ds_SV = ele_obj.reference_point2corridor_frenet.ds;
            pd_SVEstmd_SV_msg.dds_SV = ele_obj.reference_point2corridor_frenet.dds;
            pd_SVEstmd_SV_msg.dds_validtime_SV = ele_obj.reference_point2corridor_frenet.dds_valid_time;
            pd_SVEstmd_SV_msg.l_SV = ele_obj.reference_point2corridor_frenet.l - deltaL_ilc2baseCorridor;
            pd_SVEstmd_SV_msg.dl_SV = ele_obj.reference_point2corridor_frenet.dl;
            pd_SVEstmd_SV_msg.dl_validtime_SV = ele_obj.reference_point2corridor_frenet.dl_valid_time;
            pd_SVEstmd_SV_msg.ddl_SV = ele_obj.reference_point2corridor_frenet.ddl;
            pd_SVEstmd_SV_msg.ddl_validtime_SV = ele_obj.reference_point2corridor_frenet.ddl_valid_time;
            _pd_SVEstmd_SV_msg_list.emplace_back(pd_SVEstmd_SV_msg);
        }
        std::vector<PD_SVEstmd_SV_msg>(_pd_SVEstmd_SV_msg_list).swap(_pd_SVEstmd_SV_msg_list);
    }
    if(fabs(_BA_corridor_line.c0)>2000.0f) initFlag=initFlag&&false;
    return initFlag;
}


/**
 * @brief 
 * @param
 */
void SVEstmd::getLgtTrajectoryPoint(const std::vector<ADC::PD_EgoVehTrj::EgoVeh_TrjPnt> &m_get_LgtTraj){

    _pd_SVEstmd_EV_LgtTraj = m_get_LgtTraj;


    if(!_pd_SVEstmd_EV_LgtTraj.empty()){
        // _BA_duration_time_input = _pd_SVEstmd_EV_LgtTraj.back().t;
        // if((fabs(_BA_duration_time_input - _pd_SVEstmd_EV_LgtTraj.back().t) < 0.05f) && 
        //     (_pd_SVEstmd_EV_LgtTraj.size() == static_cast<decltype(_pd_SVEstmd_EV_LgtTraj.size())>(1.0f+(_BA_duration_time_input+0.001f)/0.1f))){    // time is very aligned

            _is_lgtTraj_directCallIndex = true;
        // }
    }
}


/**
 * @brief
 * @param
 */
void SVEstmd::process(){
    if(initFlag != true){
        // std::cout<< "ATTENTION: Data reading of PD_SVEstmd error" <<std::endl;
        return;
    }
    #if FLAG_PREDICTION_TNT_BA
        auto saverObstaclesTNTtoEgo = obstaclePrediction->get_obstacles_predictionTraj_toEgo();
    #endif
    SV_Trajectory_list.reserve(128);

    #if FLAG_PDFP_SAVECSV != 0
    std::ofstream outfile_PDsv;
    outfile_PDsv.open("./pd_svestmd_file.txt", std::ios::app);
    #endif
    #if FLAG_PDFP_SAVECSV != 0
    outfile_PDsv<< "timestamp," << timeStampBag<<",ba_time,"<<_BA_duration_time_input;
    #endif

    // output temporary
    for(auto& element : _pd_SVEstmd_SV_msg_list){                   // for one object
        PD_obj_SV pd_obj_SV;                                        // the object

        // 1.ID
        pd_obj_SV.m_obj_ID = element.obj_ID;
        #if FLAG_PREDICTION_TNT_BA
            bool isObjectPredictedTNT = saverObstaclesTNTtoEgo->count(element.obj_ID) != 0;
        #endif

        #if FLAG_PDFP_SAVECSV != 0
        outfile_PDsv<<",input_id,"<<element.obj_ID   \
                    <<",input_s,"<<element.s_SV<<",input_ds,"<<element.ds_SV     \
                    <<",input_dds,"<<element.dds_SV<<",input_dds_t,"<<element.dds_validtime_SV     \
                    <<",input_l,"<<element.l_SV     \
                    <<",input_dl,"<<element.dl_SV<<",input_dl_t,"<<element.dl_validtime_SV     \
                    <<",input_ddl,"<<element.ddl_SV<<",input_ddl_t,"<<element.ddl_validtime_SV;
        #endif

        // restriction of PD 20220409 20220713
        {   
            element.dl_SV = std::max(element.dl_SV, minLateralSpeed);
            element.dl_SV = std::min(element.dl_SV, maxLateralSpeed);
            // float dlMaxValidTime_temporary =    maxValidtimeCoeff[0] + 
            //                                     maxValidtimeCoeff[1] * fabs(element.dl_SV) +
            //                                     maxValidtimeCoeff[2] * fabs(element.dl_SV) * fabs(element.dl_SV);
            float dlMaxValidTime_temporary = 3500.0f;
            if(fabs(element.dl_SV)>0.001f)  dlMaxValidTime_temporary = 3.5f / fabs(element.dl_SV);
            element.dl_validtime_SV = std::min(element.dl_validtime_SV, dlMaxValidTime_temporary);
        }


        // 2.trajectory
        pd_obj_SV.pd_ls_point_list.reserve(256);
        decltype(_pd_SVEstmd_EV_LgtTraj.size()) n_lgtPoint = 0;
        for(float t=0.0; t<=_BA_duration_time_input+0.001; t=t+0.1){ 

            //EgoVehicle longitudinal position
            float EgoLgtPosition = 0.0f;                            // ego vehicle lgt position at t point   unit-m
            // n_lgtPoint = static_cast<decltype(_pd_SVEstmd_EV_LgtTraj.size())>(t*10.0f);      // not accurate
            /*if(t<=_pd_LgtTrj_plnTime){
                for(decltype(_pd_SVEstmd_EV_LgtCoff.size()) i=0;i<_pd_SVEstmd_EV_LgtCoff.size();i++){
                    float dis = _pd_SVEstmd_EV_LgtCoff.at(i) * pow(t,i);
                    EgoLgtPosition = EgoLgtPosition + dis;
                }
            }
            else{
                for(decltype(_pd_SVEstmd_EV_LgtCoff.size()) i=0;i<_pd_SVEstmd_EV_LgtCoff.size();i++){
                    float dis = _pd_SVEstmd_EV_LgtCoff.at(i) * pow(_pd_LgtTrj_plnTime,i);
                    EgoLgtPosition = EgoLgtPosition + dis;
                }
                float EgoLgtEndSpeed = 0.0;
                for(decltype(_pd_SVEstmd_EV_LgtCoff.size()) i=1;i<_pd_SVEstmd_EV_LgtCoff.size();i++){
                    float v = _pd_SVEstmd_EV_LgtCoff.at(i) * static_cast<float>(i) * pow(_pd_LgtTrj_plnTime,i-1);
                    EgoLgtEndSpeed = EgoLgtEndSpeed + v;
                }
                EgoLgtPosition = EgoLgtPosition + EgoLgtEndSpeed * (t-_pd_LgtTrj_plnTime);
            }*/
            if(!_pd_SVEstmd_EV_LgtTraj.empty())
            {

                if(!_is_lgtTraj_directCallIndex){
                    if(fabs(_BA_duration_time_input - _pd_SVEstmd_EV_LgtTraj.back().t) < 0.25f){    // time is aligned
                        decltype(_pd_SVEstmd_EV_LgtTraj.size()) n_leftPoint = std::max(n_lgtPoint-3, static_cast<decltype(_pd_SVEstmd_EV_LgtTraj.size())>(0));
                        decltype(_pd_SVEstmd_EV_LgtTraj.size()) n_rightPoint = std::min(n_lgtPoint+3, _pd_SVEstmd_EV_LgtTraj.size()-1);
                        float min_time = 999.9f;
                        for(decltype(_pd_SVEstmd_EV_LgtTraj.size()) i=n_leftPoint; i<=n_rightPoint; i++){
                            float time_diff = fabs(t - _pd_SVEstmd_EV_LgtTraj.at(i).t);
                            if(time_diff<min_time){
                                min_time = time_diff;
                                n_lgtPoint = i;
                            }
                        }
                    }
                    else{       // find the nearest time
                        float min_time = 999.9f;
                        for(decltype(_pd_SVEstmd_EV_LgtTraj.size()) i=0; i<_pd_SVEstmd_EV_LgtTraj.size(); i++){
                            float time_diff = fabs(t - _pd_SVEstmd_EV_LgtTraj.at(i).t);
                            if(time_diff<min_time){
                                min_time = time_diff;
                                n_lgtPoint = i;
                            }
                        }
                    }
                }

                n_lgtPoint = std::max(n_lgtPoint, static_cast<decltype(_pd_SVEstmd_EV_LgtTraj.size())>(0));
                n_lgtPoint = std::min(n_lgtPoint, _pd_SVEstmd_EV_LgtTraj.size()-1);
                EgoLgtPosition = _pd_SVEstmd_EV_LgtTraj.at(n_lgtPoint).s;
                n_lgtPoint=n_lgtPoint+1;
            }


            //SV
            LS_point pd_SVEstmd_ls_point;
            pd_SVEstmd_ls_point.t = t;
            float dds_SV_temporary = 0.0f;
            if(t<element.dds_validtime_SV)  {dds_SV_temporary = element.dds_SV;}
            float dl_SV_temporary  = 0.0f;
            if(t<element.dl_validtime_SV)   {dl_SV_temporary = element.dl_SV;}
            // float ddl_SV_temporary = 0.0f;
            // if(t<element.ddl_validtime_SV)  {ddl_SV_temporary = element.ddl_SV;}

            if(pd_obj_SV.pd_ls_point_list.empty()){         // t is 0.0
                pd_SVEstmd_ls_point.vs = element.ds_SV;
                pd_SVEstmd_ls_point.s_absolute = element.s_SV;
                pd_SVEstmd_ls_point.s_relative = pd_SVEstmd_ls_point.s_absolute - EgoLgtPosition;
                pd_SVEstmd_ls_point.vl = element.dl_SV;
                pd_SVEstmd_ls_point.l  = element.l_SV;
            }
            else{
                pd_SVEstmd_ls_point.vs = pd_obj_SV.pd_ls_point_list.back().vs + dds_SV_temporary * (t-pd_obj_SV.pd_ls_point_list.back().t);
                pd_SVEstmd_ls_point.s_absolute = pd_obj_SV.pd_ls_point_list.back().s_absolute
                        + 0.5f * (pd_obj_SV.pd_ls_point_list.back().vs + pd_SVEstmd_ls_point.vs) * (t-pd_obj_SV.pd_ls_point_list.back().t);
                #if FLAG_PREDICTION_TNT_BA
                    isObjectPredictedTNT = isObjectPredictedTNT && (!(*saverObstaclesTNTtoEgo)[element.obj_ID].empty());
                    isObjectPredictedTNT = isObjectPredictedTNT && ((*saverObstaclesTNTtoEgo)[element.obj_ID].front().size()==12);
                    float pointLeft_x = t - 0.1f;
                    float pointRight_x = t;
                    int n_s_inVector = 0;
                    int n_l_inVector = 1;
                    if(t<0.55f){pointRight_x=0.5f;n_s_inVector=0;n_l_inVector=1;}
                    else if(t<1.05f){pointRight_x=1.0f;n_s_inVector=2;n_l_inVector=3;}
                    else if(t<1.55f){pointRight_x=1.5f;n_s_inVector=4;n_l_inVector=5;}
                    else if(t<2.05f){pointRight_x=2.0f;n_s_inVector=6;n_l_inVector=7;}
                    else if(t<2.55f){pointRight_x=2.5f;n_s_inVector=8;n_l_inVector=9;}
                    else if(t<3.05f){pointRight_x=3.0f;n_s_inVector=10;n_l_inVector=11;}
                    float pointSelect_x = t;
                #endif
                #if FLAG_PREDICTION_TNT_BA
                    if(isObjectPredictedTNT)
                    if((t>0.05f)&&(t<3.05f)){
                        pd_SVEstmd_ls_point.s_absolute = linearInterpolation(pointSelect_x,
                                        {pointLeft_x, pd_obj_SV.pd_ls_point_list.back().s_absolute},
                                        {pointRight_x, (*saverObstaclesTNTtoEgo)[element.obj_ID].front().at(n_s_inVector)});
                    }
                #endif
                pd_SVEstmd_ls_point.s_relative = pd_SVEstmd_ls_point.s_absolute - EgoLgtPosition;
                pd_SVEstmd_ls_point.vl = dl_SV_temporary;
                pd_SVEstmd_ls_point.l  = pd_obj_SV.pd_ls_point_list.back().l 
                        + 0.5f * (pd_obj_SV.pd_ls_point_list.back().vl + pd_SVEstmd_ls_point.vl) * (t-pd_obj_SV.pd_ls_point_list.back().t);
                #if FLAG_PREDICTION_TNT_BA
                    if(isObjectPredictedTNT)
                    if((t>0.05f)&&(t<3.05f)){
                        // pd_SVEstmd_ls_point.l  = linearInterpolation(pointSelect_x,
                        //                 {pointLeft_x, pd_obj_SV.pd_ls_point_list.back().l},
                        //                 {pointRight_x, (*saverObstaclesTNTtoEgo)[element.obj_ID].front().at(n_l_inVector)
                        //                     -(_BA_corridor_line.c0+
                        //                         _BA_corridor_line.c1*
                        //                         (*saverObstaclesTNTtoEgo)[element.obj_ID].front().at(n_s_inVector)/*+
                        //                         _BA_corridor_line.c2*
                        //                         0.0f+
                        //                         _BA_corridor_line.c3*
                        //                         0.0f*/)});
                        float l_relative_BAcorridor_to_ego = 0.0f;
                        {
                            LineGeometry line_object_parallel = _BA_corridor_line;
                            float object_s_inVector = (*saverObstaclesTNTtoEgo)[element.obj_ID].front().at(n_s_inVector);
                            if( object_s_inVector > _BA_corridor_line.end_range ){
                                line_object_parallel.c1 = _BA_corridor_line.c1 + 
                                        2.0f * _BA_corridor_line.c2 * _BA_corridor_line.end_range + 
                                        3.0f * _BA_corridor_line.c3 * _BA_corridor_line.end_range * _BA_corridor_line.end_range;
                                line_object_parallel.c0 = _BA_corridor_line.c0 + 
                                        _BA_corridor_line.c1 * _BA_corridor_line.end_range + 
                                        _BA_corridor_line.c2 * _BA_corridor_line.end_range * _BA_corridor_line.end_range + 
                                        _BA_corridor_line.c3 * _BA_corridor_line.end_range * _BA_corridor_line.end_range * _BA_corridor_line.end_range - 
                                        line_object_parallel.c1 * _BA_corridor_line.end_range;
                                line_object_parallel.c2 = 0.0f;
                                line_object_parallel.c3 = 0.0f;
                            }
                            if( object_s_inVector < _BA_corridor_line.start_range ){
                                line_object_parallel.c1 = _BA_corridor_line.c1 + 
                                        2.0f * _BA_corridor_line.c2 * _BA_corridor_line.start_range + 
                                        3.0f * _BA_corridor_line.c3 * _BA_corridor_line.start_range * _BA_corridor_line.start_range;
                                line_object_parallel.c0 = _BA_corridor_line.c0 + 
                                        _BA_corridor_line.c1 * _BA_corridor_line.start_range + 
                                        _BA_corridor_line.c2 * _BA_corridor_line.start_range * _BA_corridor_line.start_range + 
                                        _BA_corridor_line.c3 * _BA_corridor_line.start_range * _BA_corridor_line.start_range * _BA_corridor_line.start_range - 
                                        line_object_parallel.c1 * _BA_corridor_line.start_range;
                                line_object_parallel.c2 = 0.0f;
                                line_object_parallel.c3 = 0.0f;
                            }

                            l_relative_BAcorridor_to_ego = line_object_parallel.c0 + 
                                        line_object_parallel.c1 * object_s_inVector + 
                                        line_object_parallel.c2 * object_s_inVector * object_s_inVector + 
                                        line_object_parallel.c3 * object_s_inVector * object_s_inVector * object_s_inVector; 
                        }
                        pd_SVEstmd_ls_point.l  = linearInterpolation(pointSelect_x,
                                        {pointLeft_x, pd_obj_SV.pd_ls_point_list.back().l},
                                        {pointRight_x, (*saverObstaclesTNTtoEgo)[element.obj_ID].front().at(n_l_inVector)
                                            - l_relative_BAcorridor_to_ego});
                    }
                #endif
            }

            pd_obj_SV.pd_ls_point_list.emplace_back(pd_SVEstmd_ls_point);
        }

        while(pd_obj_SV.pd_ls_point_list.size() > _pd_SVEstmd_EV_LgtTraj.size()){   // keep size equal
            pd_obj_SV.pd_ls_point_list.pop_back();
        }

        std::vector<LS_point>(pd_obj_SV.pd_ls_point_list).swap(pd_obj_SV.pd_ls_point_list);


        #if FLAG_PDFP_SAVECSV != 0
        /*for(float t=0.0; t<=_BA_duration_time_input+0.001; t=t+0.1){
            float EgoLgtPosition = 0.0f;                            // ego vehicle lgt position at t point   unit-m
            if(t<=_pd_LgtTrj_plnTime){
                for(decltype(_pd_SVEstmd_EV_LgtCoff.size()) i=0;i<_pd_SVEstmd_EV_LgtCoff.size();i++){
                    float dis = _pd_SVEstmd_EV_LgtCoff.at(i) * pow(t,i);
                    EgoLgtPosition = EgoLgtPosition + dis;
                }
            }
            else{
                for(decltype(_pd_SVEstmd_EV_LgtCoff.size()) i=0;i<_pd_SVEstmd_EV_LgtCoff.size();i++){
                    float dis = _pd_SVEstmd_EV_LgtCoff.at(i) * pow(_pd_LgtTrj_plnTime,i);
                    EgoLgtPosition = EgoLgtPosition + dis;
                }
                float EgoLgtEndSpeed = 0.0;
                for(decltype(_pd_SVEstmd_EV_LgtCoff.size()) i=1;i<_pd_SVEstmd_EV_LgtCoff.size();i++){
                    float v = _pd_SVEstmd_EV_LgtCoff.at(i) * static_cast<float>(i) * pow(_pd_LgtTrj_plnTime,i-1);
                    EgoLgtEndSpeed = EgoLgtEndSpeed + v;
                }
                EgoLgtPosition = EgoLgtPosition + EgoLgtEndSpeed * (t-_pd_LgtTrj_plnTime);
            }
            outfile_PDsv<<",EVLgtPos,"<<EgoLgtPosition;
        }*/
        for(const auto& egoTraj:_pd_SVEstmd_EV_LgtTraj){
            outfile_PDsv<<",EVLgtPos,"<<egoTraj.s;
        }
        for(const auto& posPoint: pd_obj_SV.pd_ls_point_list){
            outfile_PDsv<<",output_point_t,"<<posPoint.t \
                        <<",output_point_abs,"<<posPoint.s_absolute \
                        <<",output_point_rel,"<<posPoint.s_relative \
                        <<",output_point_l,"<<posPoint.l \
                        <<",output_point_vs,"<<posPoint.vs \
                        <<",output_point_vl,"<<posPoint.vl;
        }
        #endif


        // 3.valid time
        pd_obj_SV.pd_SV_ValidTime_Next.dds_SV = 0.0f;
        pd_obj_SV.pd_SV_ValidTime_Next.dds_validtime_SV = 0.0f;
        if(_BA_duration_time_input<element.dds_validtime_SV)  
        {
            pd_obj_SV.pd_SV_ValidTime_Next.dds_SV = element.dds_SV;
            pd_obj_SV.pd_SV_ValidTime_Next.dds_validtime_SV = element.dds_validtime_SV - _BA_duration_time_input;
        }
        pd_obj_SV.pd_SV_ValidTime_Next.dl_SV = 0.0f;
        pd_obj_SV.pd_SV_ValidTime_Next.dl_validtime_SV = 0.0f;
        if(_BA_duration_time_input<element.dl_validtime_SV)  
        {
            pd_obj_SV.pd_SV_ValidTime_Next.dl_SV = element.dl_SV;
            pd_obj_SV.pd_SV_ValidTime_Next.dl_validtime_SV = element.dl_validtime_SV - _BA_duration_time_input;
        }
        pd_obj_SV.pd_SV_ValidTime_Next.ddl_SV = 0.0f;
        pd_obj_SV.pd_SV_ValidTime_Next.ddl_validtime_SV = 0.0f;
        if(_BA_duration_time_input<element.ddl_validtime_SV)  
        {
            pd_obj_SV.pd_SV_ValidTime_Next.ddl_SV = element.ddl_SV;
            pd_obj_SV.pd_SV_ValidTime_Next.ddl_validtime_SV = element.ddl_validtime_SV - _BA_duration_time_input;
        }

        #if FLAG_PDFP_SAVECSV != 0
        outfile_PDsv<<",output_dds,"<< pd_obj_SV.pd_SV_ValidTime_Next.dds_SV \
                    <<",output_dds_t,"<<pd_obj_SV.pd_SV_ValidTime_Next.dds_validtime_SV \
                    <<",output_dl,"<<pd_obj_SV.pd_SV_ValidTime_Next.dl_SV \
                    <<",output_dl_t,"<<pd_obj_SV.pd_SV_ValidTime_Next.dl_validtime_SV \
                    <<",output_ddl,"<<pd_obj_SV.pd_SV_ValidTime_Next.ddl_SV \
                    <<",output_ddl_t,"<<pd_obj_SV.pd_SV_ValidTime_Next.ddl_validtime_SV;
        #endif

        // final.push
        SV_Trajectory_list.emplace_back(pd_obj_SV);
    }
    std::vector<PD_obj_SV>(SV_Trajectory_list).swap(SV_Trajectory_list);
    
    #if FLAG_PDFP_SAVECSV != 0
    // outfile_PDsv<<"-------------------------"<<std::endl;
    outfile_PDsv<<std::endl;
    outfile_PDsv.close();
    #endif
}














#if FLAG_PREDICTION_TNT_BA
using namespace std;

using namespace pd_forwardSpread;




void ObjectPredictionTNT::coeffInit(){

    /**********************************************
                    classification
    **********************************************/
    // std::shared_ptr< std::vector<std::vector<float> > > inputClass(new std::vector<std::vector<float>>(n_row_input_class,std::vector<float> (n_col_input_class)));
    std::shared_ptr< std::vector<std::vector<float> > > WaClass(new std::vector<std::vector<float>>(n_row_Wa_class,std::vector<float> (n_col_Wa_class)));
    std::shared_ptr< std::vector<std::vector<float> > > BaClass(new std::vector<std::vector<float>>(n_row_Ba_class,std::vector<float> (n_col_Ba_class)));
    std::shared_ptr< std::vector<std::vector<float> > > WbClass(new std::vector<std::vector<float>>(n_row_Wb_class,std::vector<float> (n_col_Wb_class)));
    std::shared_ptr< std::vector<std::vector<float> > > BbClass(new std::vector<std::vector<float>>(n_row_Bb_class,std::vector<float> (n_col_Bb_class)));
    std::shared_ptr< std::vector<std::vector<float> > > WcClass(new std::vector<std::vector<float>>(n_row_Wc_class,std::vector<float> (n_col_Wc_class)));
    std::shared_ptr< std::vector<std::vector<float> > > BcClass(new std::vector<std::vector<float>>(n_row_Bc_class,std::vector<float> (n_col_Bc_class)));

    /**********************************************
                    regression
    **********************************************/
    // std::shared_ptr< std::vector<std::vector<float> > > inputRegr(new std::vector<std::vector<float>>(n_row_input_regr,std::vector<float> (n_col_input_regr)));
    std::shared_ptr< std::vector<std::vector<float> > > WaRegr(new std::vector<std::vector<float>>(n_row_Wa_regr,std::vector<float> (n_col_Wa_regr)));
    std::shared_ptr< std::vector<std::vector<float> > > BaRegr(new std::vector<std::vector<float>>(n_row_Ba_regr,std::vector<float> (n_col_Ba_regr)));
    std::shared_ptr< std::vector<std::vector<float> > > WbRegr(new std::vector<std::vector<float>>(n_row_Wb_regr,std::vector<float> (n_col_Wb_regr)));
    std::shared_ptr< std::vector<std::vector<float> > > BbRegr(new std::vector<std::vector<float>>(n_row_Bb_regr,std::vector<float> (n_col_Bb_regr)));
    std::shared_ptr< std::vector<std::vector<float> > > WcRegr(new std::vector<std::vector<float>>(n_row_Wc_regr,std::vector<float> (n_col_Wc_regr)));
    std::shared_ptr< std::vector<std::vector<float> > > BcRegr(new std::vector<std::vector<float>>(n_row_Bc_regr,std::vector<float> (n_col_Bc_regr)));


    switch(_mode){
        case mode_type::HIGHWAY:

*WaClass = {{ 1.3625480e+00,  6.0834175e-01, -4.7048193e-01,  1.5392183e-01,
        -1.9021446e+00,  1.7964296e+00, -6.6122152e-02, -8.3151251e-01,
        -7.3914692e-02, -4.5458657e-01, -7.4373299e-01, -1.6791133e+00},
       { 1.8955630e+00, -1.2470184e-01, -6.1285228e-01,  1.3058417e+00,
        -1.5388303e+00,  1.9356239e+00, -6.7390829e-01, -4.3006983e-01,
        -5.6467736e-01,  1.2428566e+00,  1.3787454e+00, -4.2716902e-01},
       { 5.1740903e-01,  2.2414660e+00,  4.7654781e-01,  1.4096415e+00,
        -1.8538961e+00, -1.4214119e+00,  2.1925824e+00, -1.0833447e+00,
         3.8605651e-01,  8.5338724e-01, -2.0262730e+00,  2.8726828e+00},
       { 1.2811135e-01, -2.7336663e-01, -6.7749625e-01, -1.1915714e-01,
        -3.2211423e-01, -1.8435017e+00,  6.0528362e-01, -4.6271864e-01,
         3.6552360e+00,  6.3595258e-02, -1.7543622e+00,  5.7520908e-01},
       {-1.0568388e+00, -5.4799056e-01, -5.2875996e-01, -1.0413347e+00,
         1.4736421e+00,  9.1994852e-01, -7.1736389e-01, -6.9622922e-01,
         6.3348204e-01,  1.4519328e+00,  1.0601927e+00, -1.1287005e+00},
       { 1.9243424e+00, -4.0166417e-01,  1.4129385e+00,  1.1675425e+00,
        -8.6734253e-01,  8.0210567e-01, -3.3623087e-01,  8.5947150e-01,
        -4.5459846e-01,  9.2389297e-01,  3.7869295e-01, -6.2933266e-01},
       { 2.5970617e-01,  4.8154426e-01, -2.7971761e+00, -1.8455740e+00,
         8.3775765e-01, -8.2628363e-01, -6.1152893e-01, -8.2819521e-01,
         2.4698727e+00,  2.0786484e-01,  9.9400513e-02,  7.2541994e-01},
       {-2.0257545e+00,  4.6234614e-01, -1.3767423e-01, -2.0648996e-04,
         2.0750286e-01, -3.6211282e-01,  1.3818268e+00, -3.4137538e-01,
        -1.7726775e+00,  6.5009004e-01,  7.2885349e-02, -1.6719638e-01},
       { 1.5533468e+00,  6.1505187e-01,  6.8256885e-02,  9.5589632e-01,
        -4.2598206e-03,  1.8824893e-01, -2.7472302e-01,  1.5815322e+00,
        -1.5972594e+00,  8.0379790e-01, -6.2264466e-01,  2.1969335e+00},
       { 5.4091603e-01, -1.4602271e-01, -1.5845622e-01, -4.5452863e-01,
        -9.3133479e-01, -9.0646964e-01, -6.6799498e-01, -2.7119992e+00,
         1.2057170e+00,  7.1498674e-01, -4.8876938e-01, -2.3137875e-01}};
*WbClass = {{-2.4426667e-01,  4.4990745e-01, -6.3993627e-01,  2.3898499e-02,
         1.6288596e-01,  3.1465426e-01, -6.7123306e-01, -1.2351122e+00,
         1.2923318e+00},
       { 3.8327068e-01,  2.7369842e-01,  3.0765900e-01,  5.7109314e-01,
         1.0662414e+00, -8.2403827e-01,  3.2417098e-01, -6.3704711e-01,
        -8.8760829e-01},
       {-4.8689073e-01,  1.8036357e+00, -2.4297800e+00, -4.8855436e-01,
        -1.8743660e-01,  3.0145928e-01,  1.3276489e+00,  9.4768453e-01,
        -5.6195176e-01},
       {-3.6749661e-01,  1.0384548e+00, -9.9033302e-01,  1.7728764e+00,
         2.4602631e-01,  2.1706185e+00, -5.9662378e-01, -3.9495853e-01,
         6.0975206e-01},
       {-1.2570416e+00,  1.8468681e-01,  1.6308431e-01,  3.2551628e-01,
         2.7551055e-01, -8.7074500e-01, -1.1323153e+00,  4.6868241e-01,
         1.4537709e+00},
       {-2.1677171e-01,  1.6609044e-01, -2.7835235e-01, -1.7240245e+00,
         7.1038836e-01, -1.7388639e+00,  5.2756536e-01,  1.0753384e+00,
         1.4840500e-01},
       { 9.4101638e-01,  1.0851445e+00,  1.3854077e-01, -8.9407188e-01,
        -7.8115743e-01, -1.4309438e+00,  1.4171261e-01,  7.3321539e-01,
        -2.0773149e-01},
       { 2.3978941e-01, -2.8281876e-01, -1.0015979e+00, -1.3421484e+00,
         3.5508347e-01, -1.1988742e+00, -8.1649072e-02,  5.3258907e-02,
        -2.1813099e+00},
       {-2.6839104e-01,  9.8781878e-01, -5.8211327e-01, -8.0753487e-01,
        -1.3751718e-01, -2.9570132e-01,  9.8244625e-04, -5.0562680e-01,
         2.7168050e-01},
       {-3.2115451e-01,  8.9121407e-01,  8.7280148e-01,  1.3190243e+00,
        -5.7302542e-02,  1.2053283e+00,  1.4337252e+00,  8.7559730e-01,
        -5.2589482e-01},
       { 1.2930773e+00, -1.2613395e+00,  1.9015990e+00,  9.2978597e-01,
        -9.8342139e-01,  2.0393932e+00,  6.2532395e-01, -1.6370581e+00,
        -3.5748515e-01},
       { 8.6447053e-02,  1.8943652e+00,  5.4230082e-01, -9.0660203e-01,
        -1.0153295e+00,  2.6009509e-01,  2.0483532e+00,  6.1175752e-01,
         1.0414878e+00}};
*WcClass = {{ 6.41898215e-02, -1.84309170e-01,  5.18283725e-01,
         3.52854165e-03,  1.57673907e+00,  1.64526629e+00,
         5.75199462e-02,  2.85100996e-01,  1.31638253e+00,
        -1.39278138e+00, -1.70628560e+00, -1.52136850e+00,
         1.00335228e+00,  8.12677085e-01,  1.06259668e+00,
        -3.56818140e-01, -1.95180446e-01, -5.42930663e-01,
         1.65550756e+00, -5.73570617e-02,  1.26786602e+00,
         5.19093335e-01,  6.08091056e-01,  6.91845775e-01,
        -2.61275098e-02,  3.66252184e-01,  7.22256362e-01,
        -5.45030951e-01, -4.56958376e-02,  1.24370158e+00,
        -5.40843941e-02, -3.75452429e-01,  7.98114002e-01,
         1.17466319e+00,  1.33690417e-01,  1.33521605e+00,
        -1.05672203e-01, -3.13432097e-01, -4.77466762e-01,
        -1.30995524e+00, -3.50790799e-01, -1.57265902e+00,
         4.74555224e-01,  4.35820848e-01, -9.60384965e-01,
        -1.39829028e+00,  4.87466365e-01,  3.62004429e-01,
         1.29111719e+00,  3.58076155e-01, -7.94012904e-01,
         6.32398725e-01,  5.69137573e-01, -8.88268352e-01,
         1.71647632e+00,  1.95106402e-01, -2.97021955e-01,
        -1.57339841e-01, -2.46262416e-01,  9.45348799e-01,
        -5.46309650e-01, -1.06222951e+00, -1.05531144e+00,
         2.05842853e-01, -4.66677882e-02, -2.77786732e-01,
         8.79120052e-01,  1.05182683e+00,  2.81887680e-01,
         7.11196899e-01, -1.36170030e+00, -2.27782264e-01,
        -5.06572783e-01,  2.58709407e+00, -1.48907578e+00,
        -8.54678333e-01,  1.58208108e+00, -3.57626051e-01,
        -2.97105461e-02,  2.06333041e-01, -5.63768856e-03,
         6.57110691e-01, -9.15629447e-01, -9.56342399e-01,
        -1.18752189e-01,  7.44777098e-02,  1.19965732e+00,
         7.83480585e-01,  3.50306749e-01, -3.93404096e-01,
        -1.50628969e-01,  2.87586331e-01, -1.18084967e-01,
        -4.64124501e-01,  1.03189397e+00, -2.82838196e-01,
         1.36790246e-01,  1.54538071e+00, -9.10754442e-01,
         5.84855378e-01,  7.14692652e-01, -5.42943239e-01,
         2.56872386e-01, -1.92269313e+00,  2.04729155e-01,
         9.74404037e-01, -2.95802858e-02, -5.49380362e-01,
        -1.37973642e+00,  1.55302867e-01, -4.54831451e-01,
        -6.76410377e-01, -1.36247814e-01,  2.53354669e-01,
         1.62333980e-01, -7.79858291e-01,  2.61686981e-01,
        -1.11483049e+00, -2.65261233e-01, -1.85289288e+00},
       { 7.93884814e-01,  6.25843406e-01,  5.98120391e-01,
         7.40439892e-01,  1.26051700e+00,  4.76672143e-01,
        -3.77766341e-01, -5.97622395e-01,  1.64417398e+00,
         3.46924335e-01, -5.40342212e-01, -5.77642143e-01,
        -9.19914246e-01, -7.98995078e-01, -1.74259770e+00,
        -1.48099554e+00, -2.21131897e+00,  2.14394116e+00,
         5.85856438e-01,  5.90706468e-01,  1.49742007e+00,
         1.13096201e+00, -9.98463333e-01,  8.72593641e-01,
         1.17143011e+00, -1.00074530e+00,  9.98130068e-03,
         8.87774900e-02,  1.19816351e+00, -1.41424790e-01,
         3.11708033e-01,  1.06457937e+00, -3.30255218e-02,
         5.54250598e-01, -3.45079690e-01, -1.09976447e+00,
         2.55526811e-01, -1.97388530e+00,  2.83568144e-01,
        -1.51232588e+00,  1.22515416e+00, -1.44553661e+00,
        -2.90976763e-01,  2.17345327e-01,  8.92469764e-01,
        -2.20695287e-01, -1.03266752e+00, -1.88145733e+00,
        -1.64061666e+00,  6.14299953e-01,  2.93208838e-01,
        -6.55089736e-01, -2.24328950e-01, -9.92452353e-02,
        -1.73121107e+00,  1.57507837e+00,  6.31824195e-01,
         1.14832127e+00, -9.21635032e-01,  2.76260465e-01,
        -1.20358479e+00,  7.05965877e-01,  1.22527845e-01,
         9.30735469e-01,  2.71201044e-01,  2.71198213e-01,
         4.01595116e-01,  6.09230816e-01, -2.46143162e-01,
        -9.06711996e-01, -1.79903209e+00,  1.36054349e+00,
         1.33173788e+00, -1.06874071e-01, -6.83432519e-01,
        -7.46798217e-01, -8.65789294e-01,  1.62070692e-01,
         1.85074770e+00,  1.18775177e+00,  8.76476347e-01,
        -1.08598351e+00,  2.06336573e-01, -7.26072490e-02,
         2.81476974e-01, -1.27928138e+00,  2.86301941e-01,
         5.65653563e-01, -3.84791017e-01, -1.02104044e+00,
         3.08440998e-02,  2.03248397e-01,  3.39579821e-01,
        -2.18375635e+00,  9.45060790e-01,  5.45835961e-03,
         1.54617023e+00,  1.44512880e+00,  1.54693770e+00,
         1.27740040e-01,  1.46783531e+00, -3.78931999e-01,
        -1.22615683e+00, -5.15857756e-01, -9.47904348e-01,
        -4.96303618e-01,  4.16608751e-01, -1.60951746e+00,
        -4.08925593e-01,  4.03013498e-01,  4.34654206e-01,
        -1.84615910e+00, -2.33866572e-01,  1.48997581e+00,
         1.79325545e+00, -1.81541693e+00,  2.32819870e-01,
        -6.77301586e-01,  1.07578211e-01,  1.33461058e+00},
       {-2.10735917e-01,  7.36264959e-02,  1.46716535e+00,
         1.40082526e+00, -1.89330363e+00, -1.60737634e-01,
         1.24751210e-01,  5.39241545e-02, -1.38463306e+00,
        -7.91377723e-01, -1.76703525e+00,  1.58094716e+00,
         7.35110044e-01, -4.95066762e-01,  8.66208553e-01,
        -7.60207951e-01, -6.39705539e-01,  3.54329109e-01,
         8.38736653e-01, -4.47541237e-01, -4.76422161e-01,
        -1.29133654e+00, -5.11400819e-01, -5.96447945e-01,
         2.15673987e-02,  1.99779108e-01, -1.11397140e-01,
         1.25251615e+00, -1.19360626e+00, -1.69268107e+00,
        -1.48301530e+00,  8.36586058e-02, -7.34050155e-01,
         1.10317278e+00,  8.80394816e-01, -8.84385705e-01,
         1.19428480e+00,  2.21006894e+00, -5.12106478e-01,
         5.79829812e-01, -4.23289716e-01, -1.07596971e-01,
         2.10308712e-02,  6.30436599e-01, -7.72265673e-01,
         1.26732957e+00, -1.09234524e+00,  5.91372430e-01,
        -1.51707518e+00,  1.37203010e-02,  5.10636091e-01,
         2.34369850e+00, -1.65709305e+00, -1.71662509e+00,
        -2.62477666e-01,  1.81346846e+00, -7.97024608e-01,
         4.54943508e-01, -1.34781611e+00,  5.51093400e-01,
         1.78180563e+00,  5.46857357e-01,  6.71232820e-01,
        -7.99176395e-01, -2.37730682e-01,  2.08466911e+00,
        -9.83930051e-01, -1.46597564e-01, -5.43465734e-01,
         1.48890364e+00,  1.01042616e+00,  1.88276505e+00,
        -5.21792233e-01,  1.81119156e+00,  1.12433779e+00,
         3.18835437e-01, -1.64193779e-01,  1.05621004e+00,
        -8.89215410e-01, -9.18930531e-01,  1.05804396e+00,
         1.06552446e+00,  1.19021320e+00,  1.07850641e-01,
        -4.90950406e-01, -2.27566695e+00,  1.31845117e-01,
        -1.66235244e+00,  4.28549677e-01, -1.63814172e-01,
        -2.75007081e+00, -1.87502578e-01, -2.07733408e-01,
         4.17513937e-01, -1.93900302e-01,  5.22073507e-01,
         4.24702376e-01,  2.79603630e-01, -8.89797091e-01,
        -6.58873677e-01,  2.14302349e+00, -2.74513274e-01,
         1.00809407e+00, -9.56650019e-01, -1.40509620e-01,
         1.01892316e+00, -2.70730168e-01, -2.56386518e-01,
         1.83428693e+00,  4.80758369e-01,  2.34023356e+00,
        -7.08476484e-01,  5.31086385e-01,  6.91635370e-01,
        -1.08114161e-01, -1.06178141e+00, -1.90380144e+00,
        -1.40423164e-01, -7.62692451e-01, -9.06029165e-01},
       {-6.65484786e-01, -6.44426942e-01,  8.47716808e-01,
        -9.10670877e-01, -1.42793342e-01,  3.25771898e-01,
         1.24215722e+00,  6.19527221e-01,  1.71262736e-03,
         2.41377056e-01, -6.96218371e-01,  1.12027323e+00,
        -1.01323700e+00,  8.98455918e-01,  1.12691200e+00,
         1.13434231e+00, -1.21757112e-01, -3.54055941e-01,
        -5.89079082e-01,  1.52401400e+00, -1.09635806e+00,
         7.45140612e-01,  2.51923418e+00, -1.29799962e+00,
         4.85584527e-01, -4.99097884e-01, -1.35220766e-01,
        -2.01712918e+00, -8.83595705e-01,  1.05994904e+00,
        -1.43124306e+00, -4.35700715e-01,  1.02596939e+00,
        -3.71389315e-02, -1.34989762e+00, -1.64538324e-01,
        -9.87662673e-01,  3.04991245e-01,  2.00631690e+00,
        -1.59160838e-01, -9.81922567e-01,  3.70898128e-01,
         5.45037210e-01,  5.59487343e-01, -3.16865057e-01,
         1.97355127e+00, -1.82519257e+00, -2.58148491e-01,
        -8.54680359e-01,  3.48747939e-01, -3.82038623e-01,
         1.71322286e-01,  1.63618505e+00,  2.14461422e+00,
         1.02240038e+00,  7.87130415e-01, -7.81774759e-01,
         1.03259361e+00,  1.92520058e+00,  8.72186065e-01,
        -4.12760347e-01,  1.02418411e+00, -2.25974298e+00,
        -5.63151419e-01,  1.00667059e+00, -2.53518641e-01,
         1.25269079e+00,  7.75866270e-01, -5.04927896e-02,
        -7.15956986e-01,  6.58831060e-01, -4.31242436e-02,
         1.24931645e+00, -2.97785133e-01,  2.02135897e+00,
         1.46473980e+00, -5.89957833e-01, -2.84967095e-01,
        -9.06856418e-01, -1.20887887e+00, -1.56712842e+00,
         4.75684166e-01,  3.93007368e-01, -9.24703717e-01,
         1.32595563e+00, -6.95756197e-01, -2.02383369e-01,
        -1.72053647e+00,  1.49893200e+00, -5.79617262e-01,
         9.58997369e-01, -3.96390170e-01,  5.19204319e-01,
         2.42216825e+00, -3.04153085e-01,  2.46187419e-01,
         1.37939548e+00, -5.23997486e-01, -3.81424785e-01,
        -4.89099950e-01,  1.20195246e+00,  1.40834415e+00,
         2.06653881e+00, -5.94025433e-01, -3.47422153e-01,
         1.48941910e+00,  7.45806396e-01, -1.72390014e-01,
         1.19920123e+00,  1.98912844e-01,  1.47549963e+00,
        -8.24116945e-01, -3.86259824e-01, -1.45238614e+00,
         6.53280020e-01, -4.95845139e-01, -5.32174587e-01,
        -1.04339767e+00,  9.01699483e-01, -2.25446200e+00},
       {-1.12163341e+00,  1.27579224e+00,  1.15220940e+00,
        -9.60114956e-01,  9.57348228e-01,  5.45769334e-01,
         1.15130198e+00,  5.42840920e-02, -1.54361105e+00,
        -4.85490859e-01, -8.03200662e-01,  5.41677058e-01,
        -2.45000744e+00,  1.17506170e+00, -1.75985646e+00,
         7.33605921e-01, -2.23056173e+00,  1.57381546e+00,
        -1.27136558e-01,  5.03796399e-01,  2.12586485e-02,
         2.30367708e+00, -1.48595357e+00, -3.71429116e-01,
         4.13741469e-01,  1.55833215e-01,  1.15603626e+00,
         4.49548393e-01, -1.77445626e+00,  5.19807875e-01,
        -2.05092758e-01, -2.32441068e-01,  1.42640308e-01,
        -1.01444173e+00, -3.00640434e-01, -4.11549777e-01,
         1.68378830e+00, -6.79262877e-02, -1.18078399e+00,
        -9.85951364e-01, -4.04894918e-01,  7.49618858e-02,
        -1.07841432e+00, -1.46128774e+00, -6.11599386e-01,
         3.37567687e-01, -1.91304624e+00, -4.50770438e-01,
         1.13555694e+00,  5.06352447e-02, -1.15621054e+00,
         4.38647985e-01,  1.05187392e+00, -2.08383107e+00,
         2.52500504e-01, -7.99615204e-01, -9.32348594e-02,
         2.49563169e+00,  1.90017438e+00,  7.61487842e-01,
         1.42089844e-01,  9.51608837e-01,  2.15424991e+00,
         1.81705132e-01,  6.24637902e-01, -5.45794740e-02,
         2.89541960e+00, -4.00521696e-01, -5.53648323e-02,
        -1.66435707e+00,  4.91153538e-01, -3.85160863e-01,
         4.74643886e-01, -8.88239264e-01,  2.40809411e-01,
        -9.65991914e-01,  4.06871915e-01, -6.42049074e-01,
        -7.61631846e-01, -1.77635574e+00, -8.35250974e-01,
         1.28180861e-01,  2.08987927e+00,  6.94090307e-01,
         9.32107195e-02, -6.01875067e-01, -1.86533737e+00,
         1.28266287e+00, -9.01117861e-01,  1.59840286e-01,
         6.57610774e-01,  2.91324794e-01,  4.10005301e-01,
         1.59911764e+00, -6.55964136e-01, -1.83713961e+00,
        -1.33689511e+00, -9.33028936e-01,  1.60887465e-01,
         3.65209162e-01, -1.76511467e+00,  2.08861127e-01,
        -6.22441232e-01,  2.99582779e-01,  4.09284651e-01,
         1.93036824e-01,  4.01867509e-01,  6.78565562e-01,
         9.18783724e-01,  9.51790810e-01, -8.34316492e-01,
         2.94724870e+00, -7.84594059e-01,  5.63940167e-01,
         7.29527056e-01,  8.16347003e-01,  5.52240789e-01,
         5.41949332e-01,  1.13927054e+00,  3.68197143e-01},
       { 8.26263726e-01,  7.02333927e-01, -6.62439287e-01,
        -4.49212313e-01, -9.10695314e-01,  1.44210589e+00,
         1.20629537e+00,  1.74945855e+00,  3.42927426e-01,
        -1.36943614e+00,  1.66968048e-01, -1.82673860e+00,
         6.71071589e-01, -1.03015840e+00,  6.97922051e-01,
         4.71658289e-01,  9.51220021e-02,  7.70068467e-01,
        -1.98462200e+00,  6.99770510e-01,  9.68070179e-02,
         1.30985439e+00, -8.98333371e-01, -7.27348089e-01,
         1.10200632e+00, -1.15162790e+00,  7.82128870e-01,
         1.06862938e+00, -3.23835284e-01,  9.38703656e-01,
        -1.83644557e+00, -1.08543229e+00,  2.33378506e+00,
        -1.31768513e+00, -5.63968539e-01,  3.98239106e-01,
        -2.99681008e-01,  8.42418849e-01, -1.61261618e+00,
         1.45757294e+00, -9.20458212e-02,  7.42509604e-01,
         1.93715647e-01, -4.62978572e-01,  6.52315676e-01,
         4.36802059e-01, -1.82262331e-01, -1.65134990e+00,
        -6.36069298e-01, -4.98277813e-01,  3.18499297e-01,
        -8.26788247e-01, -2.64951974e-01,  3.97178918e-01,
         2.53029734e-01, -7.97436178e-01,  1.50985277e+00,
         6.49027407e-01,  4.71055895e-01,  1.92706120e+00,
         4.59318042e-01,  1.89152670e+00,  1.33197629e+00,
         5.14779210e-01,  6.12965822e-01,  6.01110995e-01,
        -3.80338460e-01, -1.68743980e+00,  1.54496133e+00,
        -3.38288099e-01, -2.10099325e-01, -5.36574483e-01,
         5.03609538e-01,  4.26014960e-01,  1.94856644e+00,
        -1.56612009e-01, -2.24534929e-01,  7.13406205e-01,
        -5.24136305e-01, -4.66676235e-01,  6.33201301e-01,
         4.60510254e-01,  1.56346703e+00, -7.93705344e-01,
         6.87860668e-01, -1.82258284e+00,  5.18599331e-01,
         4.81330246e-01,  1.44990587e+00, -8.53401482e-01,
         2.59144325e-02,  9.52249825e-01, -1.14490938e+00,
         3.32231253e-01, -1.51358533e+00,  7.91624367e-01,
         5.91975570e-01, -8.55809629e-01,  2.41661167e+00,
         4.35450286e-01, -1.66930652e+00, -2.73097813e-01,
         6.09688997e-01,  6.71798587e-01,  6.04859814e-02,
        -1.14169550e+00, -9.36791956e-01, -2.89028645e-01,
         1.18034983e+00,  2.06428438e-01, -2.43926311e+00,
         1.47693968e+00, -9.08093899e-02,  1.63851452e+00,
        -2.91950524e-01,  8.93263102e-01,  8.63029480e-01,
         1.56877693e-02,  4.31937158e-01, -1.24730015e+00},
       { 3.67184818e-01, -1.20572758e+00, -6.04512319e-02,
         7.02794790e-01, -5.16615093e-01, -5.37069619e-01,
         5.70335031e-01,  5.83551288e-01,  3.62990081e-01,
         4.56897169e-01,  5.34726202e-01, -8.07975709e-01,
         1.33894730e+00, -5.55004835e-01,  4.38687086e-01,
         9.45688069e-01, -7.88932920e-01, -8.72076035e-01,
         8.32553327e-01,  8.13690245e-01,  5.27031302e-01,
        -1.12080622e+00, -9.95476097e-02, -8.97190750e-01,
         7.04087317e-02,  5.08665800e-01,  7.14416027e-01,
        -4.96893376e-01,  6.29462749e-02, -2.44152570e+00,
        -6.57585084e-01, -4.28048581e-01, -5.91760993e-01,
         2.51759708e-01,  9.99661088e-01, -1.68263304e+00,
         1.03139627e+00, -1.07001686e+00, -1.14946641e-01,
        -1.11115921e+00,  2.23061278e-01, -1.07814622e+00,
        -1.05631900e+00, -7.52510801e-02,  8.71252835e-01,
         3.63600403e-01, -1.07059968e+00, -1.00400889e+00,
         3.74513090e-01, -1.55704463e+00, -1.21345544e+00,
        -9.55063641e-01, -1.52540910e+00, -1.30177701e+00,
         1.13063562e+00,  1.90569270e+00, -7.54247963e-01,
        -1.06025946e+00, -2.76915282e-01, -1.85392118e+00,
         7.19395280e-01,  2.40249056e-02, -1.06219244e+00,
         1.67101085e-01, -2.74872375e+00,  5.35608828e-01,
         1.63542062e-01, -2.32535958e+00, -2.53240615e-01,
         1.05651009e+00,  3.59541506e-01, -1.01975894e+00,
        -6.85703516e-01,  1.28030157e+00, -5.22482455e-01,
        -6.71167066e-03,  2.90836501e+00, -9.63193715e-01,
         1.40358877e+00,  5.29759407e-01, -2.41152383e-02,
        -2.78525233e-01,  2.88137287e-01, -1.14786458e+00,
         4.53705072e-01,  8.63589466e-01, -6.38214529e-01,
         1.31667423e+00, -1.11570442e+00, -9.48362201e-02,
         4.38108176e-01, -5.40915549e-01,  8.37630868e-01,
         1.00502229e+00, -2.63152570e-01, -5.84448218e-01,
         1.61704302e+00, -2.62437439e+00, -1.36517942e-01,
        -1.56900966e+00, -1.22331142e+00, -2.29714847e+00,
        -2.02300334e+00, -1.05927408e+00, -3.69878680e-01,
         3.49575251e-01, -2.12083387e+00, -8.98884058e-01,
         1.80210993e-01,  4.99987036e-01, -4.61351097e-01,
        -3.51497263e-01,  7.77793452e-02, -7.07584294e-03,
        -1.92759454e+00,  1.10578072e+00,  6.28082395e-01,
        -1.38712931e+00, -1.14440751e+00, -5.49751759e-01},
       { 5.68505287e-01,  3.42146575e-01,  7.54128277e-01,
        -1.26049209e+00, -7.91467667e-01, -1.05200970e+00,
        -4.73226428e-01, -2.13929772e-01, -8.85000408e-01,
        -2.03811482e-01, -4.34216142e-01,  3.98103058e-01,
        -4.66395289e-01, -1.43522847e+00, -5.75691998e-01,
         9.48859274e-01,  1.34241569e+00, -2.12454032e-02,
        -1.34614515e+00, -5.79987109e-01,  3.92806709e-01,
         6.88347891e-02,  1.78718674e+00,  2.14201376e-01,
         3.33937913e-01,  3.02775353e-02, -1.14117491e+00,
        -2.61152923e-01, -8.90660509e-02,  1.45576251e+00,
         1.76940754e-01,  5.91693461e-01,  8.04817617e-01,
         7.26139367e-01, -1.83314002e+00, -1.69786274e+00,
        -5.91231361e-02, -4.98599440e-01,  1.62452742e-01,
         7.20568836e-01, -3.18614334e-01, -7.99543262e-01,
        -7.25935221e-01,  8.00158978e-01,  8.84327173e-01,
         7.51828626e-02, -1.55417085e+00,  9.80198264e-01,
        -1.11498606e+00,  1.73034024e+00,  3.77783716e-01,
         7.64751256e-01, -2.05304816e-01,  2.88511723e-01,
        -7.30856597e-01,  1.54350781e+00, -2.60593027e-01,
         3.86254415e-02,  8.67726743e-01,  1.47881484e+00,
        -5.56544721e-01, -4.47609037e-01, -1.92916051e-01,
         1.78438103e+00, -3.89152318e-01,  6.44305408e-01,
         1.33437788e+00, -1.06832397e+00, -4.67568904e-01,
        -8.18914592e-01, -6.70846820e-01, -4.71087962e-01,
        -7.55715221e-02,  1.80616621e-02,  3.60013723e-01,
        -6.35499775e-01,  9.70641971e-01,  5.43891847e-01,
        -2.83133537e-01,  1.24544609e+00,  8.56079757e-01,
        -8.22028816e-01,  6.61351204e-01,  2.67407686e-01,
        -3.68939936e-02,  1.11658287e+00,  5.15734732e-01,
         2.63124228e-01, -5.51585034e-02, -7.67662525e-01,
         1.92594004e+00,  5.40191382e-02,  1.15621531e+00,
        -8.87766063e-01,  1.53874362e+00,  1.75707018e+00,
        -1.80765927e-01, -8.00892934e-02, -1.68133795e-01,
        -6.23845994e-01,  8.79211903e-01,  1.88128874e-01,
         1.24151015e+00, -5.89354098e-01,  1.22339320e+00,
         2.21944466e-01,  7.43418872e-01, -1.90869614e-01,
         1.04273260e+00, -9.46815908e-01,  5.00104368e-01,
         1.41458750e-01,  5.14694214e-01, -5.34755826e-01,
         2.62780213e+00,  3.14030051e-01, -2.84762931e+00,
         9.47784543e-01,  3.28255558e+00, -2.06586409e+00},
       { 6.06897712e-01, -3.24169159e-01,  1.04982603e+00,
         7.42741525e-01, -3.04044783e-01,  2.48010397e-01,
         4.58609670e-01, -2.83214045e+00,  5.28528869e-01,
         1.99029946e+00, -9.23046097e-02,  1.09811701e-01,
         8.76756161e-02,  8.45909476e-01,  2.12436721e-01,
         7.52599895e-01,  8.51994693e-01,  7.35045850e-01,
         6.53972447e-01, -1.26024342e+00, -5.78635991e-01,
        -1.17131650e+00, -1.91447103e+00, -7.31311083e-01,
         9.03445840e-01,  6.30105793e-01,  1.63018060e+00,
         1.23886108e+00, -1.48528917e-02, -4.38120216e-01,
        -1.83871120e-01, -6.91272691e-02, -3.66709352e-01,
         8.13929737e-01,  5.99105179e-01, -1.76310050e+00,
        -1.32859898e+00, -1.23814714e+00,  5.06123543e-01,
        -6.59778044e-02,  2.59826183e-02, -7.20994115e-01,
        -5.36174178e-02,  3.11260875e-02, -8.50707412e-01,
        -7.59124532e-02,  1.50368416e+00, -9.30405498e-01,
         2.30209514e-01, -1.55791020e+00, -6.61446750e-01,
        -1.11734259e+00,  3.62554014e-01, -1.87439740e-01,
        -5.36710262e-01, -4.62671459e-01, -1.70738533e-01,
         8.15593481e-01,  5.57489693e-01,  8.43243003e-01,
        -2.25759912e+00, -3.94122958e-01, -4.66220945e-01,
        -1.17831194e+00, -4.53710467e-01,  8.30117524e-01,
         1.18812084e+00, -1.89742899e+00,  1.91924584e+00,
         1.45205283e+00,  1.04654932e+00,  1.49928832e+00,
        -4.04861599e-01, -1.01446664e+00, -5.66657364e-01,
        -5.56806624e-01,  6.58423543e-01,  1.37452710e+00,
        -7.60199130e-01,  6.70229971e-01,  1.03796279e+00,
         2.14397097e+00,  1.34366453e+00,  1.19442523e-01,
         1.12192762e+00, -1.39271927e+00, -1.28736094e-01,
         2.31047943e-01,  8.98538604e-02,  3.58937979e-01,
        -1.21802557e+00, -3.80961567e-01,  2.33860016e+00,
        -5.69391251e-01,  6.15235083e-02, -4.83201444e-01,
        -3.44538726e-02, -2.12163165e-01, -1.00069359e-01,
        -7.61326373e-01,  2.13526353e-01,  5.92989743e-01,
         1.40093040e+00, -6.31586969e-01,  1.02464449e+00,
         8.43577743e-01, -2.32557803e-01,  8.97432268e-01,
         1.84381843e-01, -1.30977798e+00, -3.58422160e-01,
         6.49867237e-01, -1.09743714e+00,  1.11865640e+00,
         3.71035695e-01, -9.31152582e-01,  1.85998753e-01,
        -4.56166267e-01, -6.42723858e-01,  1.86757550e-01}};
*BaClass = {{ 0.11079982, -0.92926943,  1.2004038 ,  1.1503718 , -0.3532743 ,
       -0.82168806, -0.645     ,  0.2355023 , -1.4134946 ,  0.02683545,
       -0.22849318, -0.6957178 }};
*BbClass = {{-0.5663346 , -1.3093269 ,  0.5423732 ,  0.6223979 ,  0.04879043,
       -0.4012081 , -0.23341328, -1.3503604 ,  1.6106377 }};
*BcClass = {{-15.885624 , -15.808786 , -15.471447 , -15.968907 , -15.632613 ,
       -15.56691  , -15.886154 , -15.960619 , -15.341101 , -15.940795 ,
       -15.740162 , -15.860927 , -15.965317 , -15.88704  , -15.783717 ,
       -15.989228 , -15.878153 ,   4.8692565,   4.297892 ,   4.295633 ,
         3.714961 ,   4.308348 ,   4.300459 ,   4.6679606,   4.2955813,
         4.3062563,   4.2997756,   4.293464 ,   4.302254 ,   3.7146606,
         4.3063607,   4.6692777,   4.2958536,   4.3062763,   3.592144 ,
       -15.926195 , -15.862578 , -15.989968 , -15.759492 , -15.960978 ,
       -15.900021 , -15.925581 , -15.888557 , -15.7249   , -15.936801 ,
       -15.917547 , -15.824642 , -15.765785 , -15.869238 , -15.983661 ,
       -15.909978 , -15.838761 , -15.878891 , -15.930183 , -15.872438 ,
       -15.25623  , -15.883068 ,   2.911139 ,   1.5254017,   2.9116187,
         1.5247831,   2.2185006,   1.5252978,   3.3169084,   2.2183473,
         2.623629 ,   2.218491 ,   2.2182767,   2.2185426, -15.77155  ,
         2.2174914,   2.624022 ,   1.5251149,   2.2189429,   1.5250658,
       -15.840045 , -15.868468 , -15.899697 , -15.927566 , -15.850143 ,
       -15.936182 , -15.64208  , -15.642019 , -15.784325 , -15.887113 ,
       -15.826287 , -15.6865635, -15.974031 , -15.960083 , -15.701826 ,
       -15.858666 , -15.826656 , -15.793357 , -15.93215  , -15.849711 ,
       -15.821756 , -15.954263 ,   2.2179184,   2.6244555, -15.712077 ,
         1.5251703,   2.218313 ,   2.623761 , -15.775636 ,   2.218263 ,
         1.5252475,   2.218433 ,   2.2181456,   2.2186887,   2.2189014,
         2.2182105,   2.6235328,   2.6237571,   2.2183464,   1.5250777,
       -15.86806  , -15.989519 , -15.905904 , -16.099924 , -15.905103 }};

*WaRegr = {{-7.33798802e-01,  9.62755755e-02, -5.52326441e-01,
         2.61981189e-01, -4.47385728e-01,  2.88293660e-01,
        -5.99871457e-01, -9.81137156e-02,  2.81760073e+00,
         1.39834440e+00,  1.28225052e+00, -3.26536000e-01,
        -3.31382379e-02, -1.33513585e-01},
       { 4.51639056e-01,  3.52648087e-02,  4.89598274e-01,
        -2.31580719e-01,  1.07237756e+00, -8.16659391e-01,
         1.34914660e+00,  1.05773114e-01, -2.22031498e+00,
         3.43483090e-01,  1.17509854e+00,  3.35715151e+00,
        -6.99415493e+00,  9.89902878e+00},
       { 2.81695485e-01, -5.08828342e-01,  2.06943345e+00,
         5.24508297e-01, -2.43208691e-01,  3.25181723e-01,
         5.51964760e-01,  4.55409646e-01, -1.05658424e+00,
         4.79276851e-03,  1.74640048e+00,  5.53114653e-01,
        -4.29840565e-01, -3.43082368e-01},
       { 1.66028768e-01, -7.57989705e-01, -3.36330742e-01,
         9.99578059e-01, -7.14729801e-02,  1.34941685e+00,
        -1.05710876e+00, -3.14285845e-01,  2.21738845e-01,
         1.75599635e+00, -1.24902725e+00,  9.25360489e+00,
         1.56627092e+01, -1.56363354e+01},
       {-1.92451142e-02,  2.47076964e+00,  7.41488993e-01,
         4.17490304e-01,  1.62579882e+00,  8.11344832e-02,
         2.07810903e+00, -2.55173117e-01, -4.11726862e-01,
        -1.62865013e-01, -6.35142028e-01, -2.84912407e-01,
         6.42056644e-01,  4.79523569e-01},
       {-1.28351301e-01,  2.10138574e-01, -1.45751643e+00,
         7.38930523e-01,  8.58611465e-01, -2.69003630e+00,
        -4.28747028e-01,  7.35415697e-01, -4.93906736e-01,
        -8.21166039e-01,  1.33757496e+00, -3.84499054e+01,
        -2.00281792e+01,  2.41689262e+01},
       { 4.25401211e-01,  4.22833174e-01, -4.01239514e-01,
        -1.52319837e+00, -1.91653356e-01,  1.21337879e+00,
         4.46261734e-01, -4.60073757e+00,  1.28431702e-02,
         7.74705291e-01,  7.41625249e-01,  2.47079626e-01,
         1.25575848e-02,  2.07833743e+00},
       { 9.63873208e-01, -3.65202844e-01,  6.15033470e-02,
         2.62339562e-01,  4.79478896e-01,  4.42634726e+00,
        -1.72296893e-02, -1.08665884e+00,  4.33723748e-01,
        -1.43551692e-01,  1.12976916e-01,  5.26796341e+01,
         1.39918289e+01, -4.14508743e+01},
       {-9.40932214e-01,  2.75723636e-01, -8.92695785e-01,
        -9.76326242e-02, -5.76530576e-01,  1.04121995e+00,
         1.86538547e-01, -8.12944472e-01,  1.26135036e-01,
        -8.20022166e-01,  4.44963157e-01,  3.63937616e-02,
        -4.58159745e-01, -6.59755528e-01},
       {-1.49251491e-01,  7.24842325e-02, -2.69896567e-01,
        -1.59669185e+00,  1.96976411e+00, -2.04316092e+00,
        -2.03676775e-01,  6.25289381e-01, -5.14431596e-02,
        -2.18227670e-01,  3.16279262e-01, -2.82638454e+01,
         2.91708976e-01,  2.73649330e+01},
       {-8.16914976e-01, -7.24349201e-01, -1.77407712e-01,
        -4.62581605e-01, -3.30034196e-01,  4.63485152e-01,
         5.51292598e-01,  4.50930465e-03,  1.00861835e+00,
        -3.07781100e+00, -9.46296036e-01,  9.14835781e-02,
         7.02713877e-02,  4.44556773e-01},
       {-1.43414930e-01,  3.98932219e-01, -1.14355445e+00,
        -1.04318857e+00,  3.45289528e-01, -1.69839823e+00,
         4.28131312e-01,  1.48013353e+00, -1.01677883e+00,
         2.43484676e-01,  9.99834359e-01,  8.27849269e-01,
        -4.35569137e-02,  4.52979594e-01}};
*WbRegr = {{-2.4579661e-01,  1.3092270e+00,  1.2735419e+00, -4.7731331e-01,
         3.3173355e-01,  1.7549447e+00,  2.6360521e-01, -9.0011638e-01,
         7.7502584e-01,  1.0314606e+00},
       { 2.1741319e+00, -5.3028405e-01, -4.4197893e-01, -3.7506208e-01,
         1.4260590e+00,  1.4609354e-02,  1.5734823e+00, -1.4056734e+00,
         1.9592130e+00,  1.0323179e+00},
       { 1.8991382e-01, -2.4958242e-01,  2.9638693e-01, -1.7464737e+00,
        -1.5208983e-01,  1.4418106e+00, -5.0386834e-01, -4.8500901e-01,
         5.7635039e-01, -8.0390763e-01},
       { 4.7080719e-01, -1.5235298e+00, -3.3827859e-01,  4.4395823e-02,
         5.7944989e-01,  8.8284302e-01, -1.4898610e+00, -1.8318492e+00,
        -3.9646676e-01,  7.0113987e-01},
       { 3.2616101e-02,  2.2467656e+00,  6.9752805e-02,  1.0818814e+00,
        -3.7153608e-01, -1.1406827e+00,  9.1824430e-01, -5.2410078e-01,
         2.5678930e+00,  6.9894797e-01},
       { 3.4871626e-01, -4.6883580e-01,  1.0433998e+00, -1.6563101e+00,
         1.3646956e-01,  8.7076671e-02, -1.5891880e+00, -6.1810887e-01,
         6.8841159e-01, -1.5329303e+00},
       { 4.6807179e-01,  6.0209125e-01,  3.8376278e-01,  7.4130076e-01,
        -9.6378118e-01,  4.0368956e-02,  2.6744100e-01,  2.8171259e-01,
        -1.6359020e+00, -7.5089025e-01},
       { 1.1855035e+00, -3.1601033e-01, -2.4267203e-01, -2.1483125e-01,
        -6.9544274e-01, -9.2677164e-01,  2.8760341e-01,  7.6118179e-02,
        -1.0975538e+00, -1.0203462e+00},
       { 7.5021887e-01,  1.7544595e+00, -9.2401224e-01, -8.9637995e-01,
        -1.1300202e-01, -5.1067895e-01,  7.3039033e-02,  1.1855134e+00,
        -2.3827739e-01,  1.9283571e+00},
       {-7.1766478e-01,  1.5149009e-01, -6.7157233e-01,  1.2823799e+00,
        -2.1308190e-01,  1.7259504e-01,  2.5561625e-01, -1.5205051e+00,
         4.4138494e-01, -1.0952435e+00},
       { 8.0127138e-01, -9.7983688e-02, -1.2710240e+00, -7.8608340e-01,
        -1.6736779e+00, -1.4124877e+00, -3.9555356e-01,  1.2897532e+00,
        -1.1440724e+00, -4.7874051e-01},
       { 1.9100312e-03, -2.9723951e-01, -2.0213459e+00, -1.3527905e+00,
        -1.1446196e+00, -3.0472976e-01, -1.7207477e+00, -1.7179035e-01,
        -1.0912381e+00,  4.1815063e-01},
       { 1.6589491e-03, -5.0849289e-01, -7.7328366e-01,  2.6082149e-01,
         1.1058525e+00,  1.2143445e-01, -3.1452435e-01,  3.3898553e-01,
         1.3249648e+00, -8.8582736e-01},
       {-1.1221235e-02, -1.8814543e-01, -1.1115891e+00, -2.7795002e+00,
        -1.9039613e+00, -9.9313989e-02,  8.1893969e-01,  2.6840633e-01,
        -1.6004972e+00, -1.3555051e+00}};
*WcRegr = {{ 2.57949680e-01, -2.69581145e-03,  5.16718149e-01,
        -2.89172539e-03,  7.75398195e-01, -3.18154227e-03,
         1.03399301e+00, -3.64533765e-03,  1.29250050e+00,
        -4.28632554e-03,  1.55092037e+00, -5.16394153e-03},
       {-4.89724390e-02,  1.26072764e-01, -5.54456152e-02,
        -1.61984548e-01, -1.04590327e-01, -2.46550158e-01,
         7.70643004e-04, -1.52012914e-01,  1.92767695e-01,
         9.16265771e-02, -2.26140916e-01,  2.41010770e-01},
       {-3.05874556e-01,  6.30589008e-01,  1.61091149e-01,
         5.56052148e-01, -3.42856407e-01,  6.84641838e-01,
        -2.53016806e+00, -1.12113464e+00, -1.20523000e+00,
         1.19433749e+00,  3.65941912e-01,  1.53450954e+00},
       { 8.46847117e-01,  4.80107099e-01, -8.43718648e-02,
        -1.05330408e+00, -3.10775638e-01, -4.55943465e-01,
        -1.83696866e+00, -6.17871821e-01,  9.62443575e-02,
         1.02133834e+00, -2.62278533e+00,  1.12318933e+00},
       { 1.51342237e+00,  1.07323849e+00,  7.56892979e-01,
        -2.88315713e-01, -6.71742320e-01,  9.19607520e-01,
         1.53490484e+00,  3.75006020e-01, -6.38374448e-01,
        -5.96211135e-01, -9.04821932e-01,  1.89506245e+00},
       { 9.99133945e-01,  7.75426328e-01, -7.82521665e-01,
         2.64379889e-01, -8.98891926e-01, -5.26556551e-01,
        -4.78514224e-01, -7.94277012e-01,  9.40684304e-02,
        -1.73791237e-02,  9.99797106e-01,  1.04316509e+00},
       {-1.91773614e-03, -5.47492281e-02, -2.85279565e-03,
         4.49010320e-02, -3.79781006e-03,  1.36583939e-01,
        -4.76612430e-03,  2.15084240e-01, -5.75316232e-03,
         2.80047387e-01, -6.76441286e-03,  3.27793717e-01},
       {-3.98325780e-03,  5.15307724e-01, -7.05520902e-03,
         4.03033465e-01, -1.01220002e-02,  3.05943787e-01,
        -1.31861260e-02,  2.21678063e-01, -1.62355751e-02,
         1.39498651e-01, -1.92563087e-02,  6.79992959e-02},
       {-2.42685795e+00, -1.08517182e+00,  3.09003592e-01,
         1.59889770e+00, -1.37322590e-01, -1.25842023e+00,
         5.87596595e-01,  1.49383128e+00,  8.97123754e-01,
         8.40188682e-01, -1.46763790e+00, -1.70294628e-01},
       { 1.11660695e+00, -9.75992382e-01,  1.51187706e+00,
         1.15666366e+00, -1.10975468e+00, -1.48694313e+00,
        -7.61930704e-01,  1.01395644e-01, -5.73533297e-01,
        -1.08990133e+00, -1.52763152e+00,  6.04678214e-01}};
*BaRegr = {{-1.4122796 ,  0.9662882 , -0.53780365,  0.08518162,  0.01300964,
        0.41776994, -0.8810534 , -0.7450899 , -2.4265451 ,  0.984457  ,
        0.79218435, -1.5649589 ,  0.95774174, -0.17094496}};
*BbRegr = {{ 0.2977098 , -1.6699085 , -0.71388716,  0.15386267, -2.185258  ,
        1.0776737 , -1.6163855 , -1.61528   ,  1.4152954 ,  0.68529266}};
*BcRegr = {{ 0.14895037, -2.2291949 ,  0.30321342, -2.5805352 ,  0.46197206,
       -2.9317892 ,  0.6251913 , -3.213825  ,  0.792864  , -3.3626387 ,
        0.96496606, -3.3871193 }};


            break;
        case mode_type::URBAN:
       
*WaClass = {{ 1.61468983e-01, -2.06211448e+00,  6.19844079e-01,
        -5.04933894e-01,  8.25762570e-01, -2.82661974e-01,
         4.04959880e-02,  4.34273630e-01,  9.92648363e-01,
        -6.25791669e-01, -1.24958575e+00, -2.26451680e-02},
       {-2.96274006e-01,  1.00155191e+01,  7.08789945e-01,
         1.28893065e+00,  8.32407475e-01,  3.25266927e-01,
         6.45168734e+00, -2.02275944e+00, -3.35974765e+00,
         2.60279965e+00, -1.46621771e+01,  9.75176275e-01},
       { 1.50496915e-01,  8.52724910e-01, -2.40016222e-01,
         1.14699590e+00, -3.69796939e-02,  2.20757604e-01,
        -8.31289068e-02,  5.47356606e+00, -3.14149833e+00,
         1.29106247e+00,  1.25414491e+00,  6.47290766e-01},
       { 1.03946900e+00, -5.34276867e+00, -5.85663617e-01,
        -2.22047281e+00, -6.09810948e-01, -1.92846119e-01,
         1.46738005e+00,  3.72043777e+00,  3.08407843e-01,
        -1.00019503e+00,  3.68816304e+00, -2.05561137e+00},
       { 5.27540982e-01,  1.47021461e+00,  7.28137434e-01,
         2.73015499e-01, -4.39898446e-02,  4.64243740e-01,
         1.10314941e+00,  5.21716404e+00, -6.90991804e-02,
        -8.04181457e-01,  7.85021782e-01, -9.94631827e-01},
       {-1.29164982e+00,  2.50649929e+00,  2.86775410e-01,
        -3.08011341e+00, -6.10920370e-01, -1.69758224e+00,
        -3.96518397e+00,  1.77924109e+00, -3.93509912e+00,
        -4.45584774e+00, -5.52724421e-01,  7.88869524e+00},
       { 3.10283124e-01,  2.82350206e+00, -1.16425526e+00,
        -1.26819360e+00,  1.26723921e+00,  8.14772725e-01,
        -4.40250427e-01, -8.02472115e+00,  2.19746437e+01,
        -3.24368525e+00, -1.24323010e+00, -6.48232341e-01},
       { 1.12061405e+00, -3.24004316e+00,  4.38344866e-01,
         9.60182285e+00, -6.59096688e-02,  3.45253325e+00,
        -2.99631739e+00, -1.02939986e-01,  8.37012672e+00,
         8.13328457e+00, -5.08036995e+00, -1.29530535e+01},
       {-1.79574743e-01,  1.36899054e-02,  1.89680029e-02,
         4.12084341e-01, -8.58306944e-01,  2.55380213e-01,
        -5.12004018e-01,  1.90937165e-02,  3.07990044e-01,
         5.21880090e-01,  1.10425055e+00, -6.45815551e-01},
       {-8.31601918e-01,  1.64035523e+00, -8.16824496e-01,
        -5.80122042e+00, -6.41359389e-01, -1.96950150e+00,
         2.61647296e+00, -8.82292557e+00, -4.76741171e+00,
        -4.35391188e+00,  1.64438343e+00,  6.98239946e+00}};
*WbClass = {{-1.04479635e+00, -6.66641772e-01,  2.94195026e-01,
         3.50261509e-01, -5.82951844e-01, -2.20550799e+00,
        -1.50739327e-01, -1.04608238e+00,  1.24361241e+00},
       { 3.29307747e+00, -6.80335426e+00,  6.62531435e-01,
         1.43150604e+00,  4.35510874e+00,  1.37797081e+00,
         4.01051566e-02,  1.29049569e-01,  1.58998296e-01},
       { 8.09585929e-01, -1.38087845e+00,  1.24445891e+00,
         9.47194636e-01,  5.11424541e-01, -1.28252602e+00,
         1.60751808e+00, -1.15830374e+00,  4.00218934e-01},
       {-7.93419123e-01, -8.99782181e-01, -1.28960228e+00,
        -3.46461415e+00, -3.54732782e-01, -2.60634542e+00,
         1.36156523e+00, -1.79370880e+00, -1.98607743e+00},
       {-5.36034763e-01,  2.09647834e-01, -1.55530155e+00,
         2.96755940e-01,  7.59389997e-01,  7.26355314e-01,
         1.23494565e-01,  1.23505235e-01,  4.73300934e-01},
       { 1.85228080e-01,  1.58367455e-01,  9.61927509e+00,
         6.76960135e+00, -1.57675195e+00,  1.43463933e+00,
         6.62899351e+00, -8.67775738e-01, -1.21999168e+00},
       {-3.61657333e+00, -2.49445438e+00,  5.16589403e-01,
        -1.12450801e-01, -6.01240206e+00, -6.76675677e-01,
         6.78756475e-01,  2.35517956e-02, -8.89631450e-01},
       { 1.54659724e+00, -1.14399834e+01, -1.68048992e+01,
         4.13068533e+00, -6.72687292e+00,  1.31128063e+01,
         1.48204765e+01, -5.95105827e-01, -1.13362896e+00},
       { 1.78016329e+00, -1.79199785e-01, -2.55626202e+00,
         6.74483395e+00,  4.52604151e+00, -8.24820027e-02,
        -2.95949149e+00, -7.93046117e-01, -3.20521355e-01},
       {-3.86433333e-01, -4.06827033e-01, -2.85624957e+00,
        -4.53102732e+00, -4.85591030e+00, -3.79506636e+00,
        -1.88205540e-01,  1.59136427e-03,  2.84128189e-01},
       {-1.47158217e+00,  8.70866895e-01, -4.92754281e-02,
        -2.29528099e-01,  7.50736952e-01, -5.74449152e-02,
        -2.10270360e-02,  7.11832382e-03, -7.55201340e-01},
       {-6.03930116e-01, -2.75828898e-01,  1.98921990e+00,
        -2.90522432e+00, -1.35931432e+00, -1.38519609e+00,
        -3.86006951e-01, -2.51529813e+00, -2.59488463e+00}};
*WcClass = {{-6.39728248e-01, -1.66971028e-01,  1.19275086e-01,
         5.31098098e-02,  4.14579362e-02,  6.29142001e-02,
         2.46245503e-01,  3.50321263e-01,  7.33437777e-01,
         9.45846081e-01,  1.22074306e+00,  1.48753536e+00,
         1.73938704e+00,  1.97640610e+00,  2.37066460e+00,
         2.36480069e+00,  1.69460714e+00,  2.30387664e+00,
         2.25340319e+00,  2.22591424e+00,  2.21116710e+00,
         2.23592734e+00,  2.23535562e+00, -3.13009429e+00,
         8.97969961e-01, -3.17469865e-01,  9.19609010e-01,
         1.01038945e+00, -1.68452430e+00, -1.14931452e+00,
         1.81849051e+00,  7.51557112e-01, -6.38036847e-01,
        -1.86512220e+00,  6.15398467e-01, -1.12900996e+00,
        -2.44264221e+00, -1.17476337e-01, -3.93558830e-01,
         7.29149342e-01, -5.45557976e-01, -2.45102043e+01,
        -3.53629646e+01, -3.57221341e+00, -1.73232043e+00,
        -1.83194828e+00, -8.92221570e-01, -2.84528542e+00,
        -3.20767593e+00,  3.03218979e-02, -3.79800200e-01,
         7.43811131e-01,  4.04146343e-01,  7.84522235e-01,
         8.55222523e-01,  8.47286582e-01,  1.06950605e+00,
        -6.01524305e+00,  1.05528402e+00, -2.70945883e+00,
         1.27100718e+00, -4.39167309e+00, -2.30153084e+00,
        -1.30330098e+00, -3.15217912e-01, -6.73807487e-02,
         2.19260380e-01, -1.94096708e+00, -1.38613391e+00,
        -1.31769168e+00, -6.95343316e-01,  1.62996829e+00,
         4.59797382e-01, -4.66241747e-01, -1.39670312e+00,
        -2.39530951e-01,  2.68540710e-01,  2.08798975e-01,
        -1.12417257e+00, -9.16261196e-01,  8.23496103e-01,
        -2.35564804e+01, -2.06066914e+01, -8.14902973e+00,
        -5.86033201e+00, -5.03732986e+01, -3.10798335e+00,
        -2.46900635e+01, -1.37515104e+00, -1.99548702e+01,
        -1.37432039e+00, -1.02131042e+01, -7.64075994e-01,
        -1.35883560e+01, -8.70159912e+00, -3.88085222e+00,
        -1.64257690e-01, -7.91155529e+00, -6.38944101e+00,
        -6.93854570e+00, -5.68011475e+00, -4.47761583e+00,
        -4.89307308e+00,  4.40181524e-01,  1.56076002e+00,
        -6.55227482e-01, -9.22667980e-01, -2.39707541e+00,
        -1.85702443e+00, -6.30325496e-01, -9.35104966e-01,
         2.39846095e-01,  3.01647455e-01, -5.24115980e-01,
        -3.77723098e-01, -4.95351523e-01,  1.44640183e+00,
        -1.19716871e+00,  8.62549305e-01,  1.04657590e+00},
       {-1.82292442e+01, -8.21868706e+00, -6.66784954e+00,
         5.31704724e-01,  1.00055993e+00,  1.41646636e+00,
         1.63094866e+00,  2.00831842e+00,  2.22676802e+00,
         1.84859633e+00,  2.39200187e+00,  2.50977302e+00,
         2.63339186e+00,  2.72077656e+00,  2.64954042e+00,
         2.65924287e+00,  2.68169522e+00,  2.67624664e+00,
         2.74831009e+00,  2.73554897e+00,  2.74416685e+00,
         2.70215154e+00,  2.70067215e+00,  1.47247469e+00,
        -6.77846193e-01, -1.52960372e+00, -2.00550508e+00,
        -7.34220803e-01, -8.20731461e-01,  3.08426261e-01,
        -1.30576336e+00, -1.07076967e+00, -7.75589705e-01,
        -4.22779858e-01, -1.97237790e+00, -1.71744180e+00,
        -2.08623362e+00, -6.94925427e-01,  4.59263802e-01,
        -6.12086356e-01, -1.67912617e+01, -2.15058403e+01,
        -9.67666340e+00, -9.09149110e-01,  5.35541922e-02,
         5.11688255e-02, -4.50966477e-01, -1.12722933e+00,
         1.32403970e+00, -7.85844386e-01,  1.89273858e+00,
         1.81455541e+00,  2.04065251e+00, -4.43413734e+00,
        -4.75604248e+00, -5.02175045e+00, -3.68829560e+00,
        -2.63668466e+00, -4.44343179e-01, -3.76506138e+00,
        -4.81659889e+00, -4.43826485e+00, -4.86134815e+00,
         2.84962535e-01, -1.05965447e+00,  9.42363679e-01,
         9.67542410e-01,  1.35132775e-01, -1.13309860e+00,
         5.10488451e-01, -1.18921828e+00, -1.12804842e+00,
         9.07633781e-01, -1.39900780e+00, -1.45865649e-01,
        -5.93236804e-01, -1.16242453e-01,  1.43771338e+00,
        -1.11611950e+00,  9.37448680e-01,  1.56603682e+00,
        -1.07990532e+01, -7.77244806e+00, -1.83223176e+00,
        -1.11982219e-01,  4.55217451e-01,  9.98277247e-01,
         1.47152305e+00,  1.83758318e+00,  1.90651608e+00,
         1.76360691e+00,  1.85605204e+00, -1.09690940e+00,
         1.96617317e+00,  2.07166243e+00, -4.18675661e-01,
        -1.27888751e+00,  2.08261585e+00, -9.78743076e-01,
         2.08779335e+00, -1.84934652e+00,  1.96049929e+00,
         1.74259770e+00, -1.05938745e+00, -1.04038000e+00,
        -1.18076682e+00, -2.83722758e-01, -1.22019148e+00,
         2.60366201e-01, -1.09870769e-01,  1.79285064e-01,
         1.82829189e+00,  7.41405189e-01, -2.35186911e+00,
        -1.44351709e+00, -8.19280982e-01,  8.28252435e-01,
        -2.69999355e-01, -2.91716099e-01,  4.27587628e-01},
       { 3.08342308e-01, -4.69914556e-01,  7.60043383e-01,
         1.41258383e+00,  2.12641144e+00,  2.82954645e+00,
         3.57461476e+00,  4.01229191e+00,  2.84386420e+00,
         1.22932816e+00, -8.54857564e-01, -2.94925451e+00,
        -4.74754524e+00, -6.43196154e+00, -8.84642124e+00,
        -2.36313019e+01, -1.57040529e+01, -1.49051323e+01,
        -1.24087172e+01, -1.01915522e+01, -7.05740023e+00,
        -9.07359600e+00, -1.04126043e+01, -3.99069571e+00,
        -3.15332675e+00, -2.70965505e+00, -3.97259903e+00,
        -2.35418916e+00, -4.92838573e+00, -2.46586442e+00,
        -3.36116576e+00, -3.61188722e+00, -2.92346549e+00,
        -3.64080811e+00, -2.39640617e+00, -4.30174303e+00,
        -2.90675592e+00, -2.86518979e+00, -2.93709683e+00,
        -4.88177538e+00,  2.26811504e+00,  1.14090729e+00,
         3.55267978e+00,  4.68339443e+00,  5.60446262e+00,
         6.31642532e+00,  7.17673540e+00,  7.96190786e+00,
         3.58378029e+00, -4.40066242e+00,  8.77335548e-01,
        -1.07048595e+00, -3.36745763e+00, -5.43002367e+00,
        -1.05085020e+01, -1.86965027e+01, -1.17913561e+01,
        -1.04645777e+01, -6.10200071e+00, -7.18291235e+00,
        -7.32060480e+00, -6.21297216e+00, -5.12620258e+00,
        -2.45724893e+00, -4.11320448e+00, -2.73980308e+00,
        -2.54766870e+00, -4.20602989e+00, -4.21689987e+00,
        -3.15041423e+00, -3.16090512e+00, -7.03839874e+00,
        -4.02803707e+00, -4.10606337e+00, -3.72269988e+00,
        -3.42254138e+00, -4.99963903e+00, -3.68138695e+00,
        -3.82324791e+00, -2.78668761e+00, -4.20077085e+00,
        -3.18527198e+00, -2.00446939e+00, -1.01966143e+00,
         1.23466447e-01,  8.36149514e-01,  1.82629788e+00,
         2.76618910e+00,  1.64883316e+00, -7.36575186e-01,
        -2.34034657e+00, -4.23534679e+00, -5.77193069e+00,
        -7.37825346e+00, -1.04348688e+01, -3.60293541e+01,
        -5.40386152e+00, -1.10972147e+01, -9.30437851e+00,
        -8.84935093e+00, -8.89479065e+00, -5.70373726e+00,
        -7.03652716e+00, -5.38342953e+00, -5.06029177e+00,
        -2.27116227e+00, -4.15977240e+00, -3.12282920e+00,
        -2.82017350e+00, -2.37416434e+00, -1.49149346e+00,
        -4.19847059e+00, -4.01049709e+00, -1.92759717e+00,
        -3.65617824e+00, -3.73165584e+00, -4.03113365e+00,
        -4.82944012e+00, -6.27823400e+00, -5.96779108e+00},
       { 4.13063478e+00,  4.33162689e+00,  4.17139816e+00,
         2.28729272e+00,  4.77786988e-01, -1.13161647e+00,
        -2.62291455e+00, -4.29992676e+00, -7.15588713e+00,
        -7.70230722e+00, -6.45579624e+00, -4.24651670e+00,
        -1.36862481e+00, -2.77170229e+00, -3.25574303e+00,
        -2.01491642e+00,  1.04362415e-02, -5.93392432e-01,
         8.23080361e-01,  1.35873091e+00,  8.77896845e-01,
        -1.49299550e+00, -8.77317429e-01,  5.00753164e-01,
         3.41320395e-01,  7.11120784e-01,  3.12978536e-01,
        -2.23978972e+00, -3.17612171e+00, -9.23131883e-01,
         6.97594047e-01, -2.00479075e-01, -4.58389163e-01,
        -4.62306410e-01, -1.27922690e+00, -5.95669337e-02,
         5.58425440e-03,  1.43040085e+00, -1.49222240e-01,
        -1.08730830e-01,  7.35604525e+00,  3.26071048e+00,
         4.64312410e+00,  1.45764029e+00, -6.04080498e-01,
        -2.33801913e+00, -4.39478064e+00, -7.42996120e+00,
        -2.37608280e+01, -1.98486829e+00, -6.13096666e+00,
        -3.95697594e+00, -2.98930383e+00, -7.84993410e-01,
        -2.45892811e+00, -4.11414444e-01,  1.73703730e-01,
        -4.91054468e-02,  1.17444491e+00, -1.35621989e+00,
        -6.27210960e-02,  7.00366735e-01,  1.21285117e+00,
        -8.71504486e-01, -1.14761353e+00, -2.05937290e+00,
         3.05286329e-02, -1.15241110e+00,  1.18358397e+00,
        -1.87298548e+00, -1.94007492e+00, -1.84455144e+00,
        -1.14351952e+00, -1.99810433e+00, -1.98278081e+00,
        -8.91422331e-01, -6.51168823e-01, -7.86826909e-01,
        -1.71403736e-01, -7.04820335e-01, -8.58599186e-01,
         6.32046556e+00,  5.12699842e+00,  3.06421399e+00,
         9.77794051e-01, -3.02503169e-01, -2.01245880e+00,
        -4.08101177e+00, -1.61784248e+01, -6.01450968e+00,
        -4.21070051e+00, -4.27820206e+00, -2.69329071e+00,
        -2.70130491e+00, -3.27000117e+00, -1.83243322e+00,
        -1.46047163e+00,  1.23177266e+00,  1.07009232e+00,
        -9.46845263e-02, -2.15364671e+00, -3.99603665e-01,
         8.23461771e-01, -2.01622891e+00, -9.74766016e-01,
        -2.33757806e+00, -6.25083268e-01, -2.87333584e+00,
        -5.87998629e-01, -5.12834311e-01,  3.63846958e-01,
         1.95476055e-01,  6.66670501e-01,  8.64402890e-01,
        -9.79355395e-01,  4.17883098e-01, -7.38495469e-01,
        -8.61243665e-01,  3.31218392e-02,  3.91212672e-01},
       { 2.71774483e+00, -1.20768118e+00, -2.06282568e+00,
        -4.20616484e+00, -3.97225738e+00, -4.34145069e+00,
        -4.17264986e+00, -4.40334368e+00, -3.82194448e+00,
        -7.86662960e+00, -4.08623648e+00, -4.35357904e+00,
        -1.36976776e+01, -4.36609411e+00, -1.23954475e+00,
        -1.54144418e+00, -1.98460948e+00, -1.73430669e+00,
        -3.99164104e+00, -8.72515514e-02, -1.10229659e+00,
         1.30162346e+00,  2.19644117e+00, -1.10834269e-02,
        -3.88646752e-01,  2.00175905e+00, -1.23299170e+00,
         5.49909711e-01,  1.90495420e-03, -6.95478737e-01,
        -6.11922681e-01, -1.85179639e+00, -1.53876781e+00,
         1.99562812e+00, -1.08164966e+00, -2.19022489e+00,
        -6.20333552e-02, -1.76356483e+00, -9.42444623e-01,
         6.84686840e-01, -3.65955400e+00, -2.03982468e+01,
        -2.96437311e+00, -3.60331607e+00, -4.54758596e+00,
        -9.08707523e+00, -4.54706049e+00, -2.52401924e+00,
        -2.51548648e+00, -7.55098820e-01, -3.74870396e+00,
        -3.92459273e+00, -3.38467836e+00, -2.07657754e-01,
         3.47701430e-01,  1.24408197e+00,  2.70880270e+00,
         6.43882930e-01, -4.08774614e-02,  5.31200588e-01,
         9.83759224e-01,  1.13347113e+00, -3.40687670e-02,
         4.26507026e-01, -1.37772894e+00, -2.58310843e+00,
         7.10711181e-01, -8.04920495e-01,  6.80750251e-01,
        -2.64999568e-01,  7.60528445e-02, -6.10767975e-02,
        -2.56705999e-01, -6.56561494e-01, -4.92345512e-01,
        -1.78829324e+00, -1.05983531e+00, -1.52474940e+00,
         6.82239234e-01,  8.98466945e-01, -1.73789430e+00,
        -2.01234188e+01, -4.85061073e+00, -2.58785105e+00,
        -6.22979021e+00, -4.91306782e+00, -6.32099533e+00,
        -8.59383869e+00, -4.23073816e+00, -4.50641489e+00,
        -4.05864620e+00, -2.86967564e+00,  1.71833789e+00,
        -1.39505649e+00,  7.00252414e-01,  4.75325286e-01,
        -4.61223096e-01,  7.41324127e-01,  2.37880554e-02,
         1.53559953e-01, -1.76338628e-01,  2.63491213e-01,
         3.34844351e-01, -9.09443676e-01, -8.60479593e-01,
        -2.70431185e+00,  1.17391944e-01, -1.34836996e+00,
         1.14154248e-02, -1.43348444e+00, -2.62463140e+00,
        -1.00156736e+00,  6.33078694e-01, -1.39284089e-01,
        -1.89591730e+00, -2.23858193e-01, -9.18536708e-02,
        -1.76593614e+00, -1.25197697e+00, -2.09194374e+00},
       { 2.78561234e+00,  2.54081130e+00, -3.78876805e-01,
        -2.20771809e+01, -2.75999107e+01, -3.87539101e+01,
        -2.54930382e+01, -1.84613590e+01, -9.73619270e+00,
        -1.34108424e+00, -2.22977757e+00, -1.18038678e+00,
        -8.36230040e-01, -1.59377432e+00, -2.94868279e+00,
        -1.53002262e+00, -1.25382459e+00,  6.77169383e-01,
         1.03533721e+00,  4.23879743e-01, -9.14815843e-01,
         2.02771497e+00, -7.01521099e-01, -1.03086960e+00,
         2.00373426e-01, -1.53694236e+00, -4.87521827e-01,
         6.25332773e-01, -2.00558925e+00, -1.97112703e+00,
        -2.00110033e-01, -1.32862842e+00,  2.14813337e-01,
        -4.25463498e-01,  7.40762651e-01,  1.81071079e+00,
         5.82470655e-01, -1.31702030e+00, -1.26247942e+00,
        -2.62469560e-01,  2.22855616e+00,  9.66704369e+00,
        -3.73416495e+00, -2.61761551e+01, -2.25838261e+01,
        -1.26098766e+01, -5.48304272e+00, -1.59991586e+00,
        -9.64776814e-01, -4.12416160e-02, -2.79334378e+00,
        -3.29104161e+00, -3.18036032e+00, -1.31567752e+00,
        -3.00449824e+00, -1.92068851e+00, -1.67756423e-01,
         3.80898535e-01, -1.16702151e+00, -6.63121045e-01,
        -1.22349180e-01, -7.99404442e-01, -1.43266931e-01,
         9.31303263e-01, -3.57463866e-01, -5.99662006e-01,
         1.31111479e+00, -2.79925466e-01, -6.12085521e-01,
         8.83487582e-01, -9.58495796e-01,  1.06511748e+00,
         1.19106364e+00, -2.93513417e-01, -4.70616460e-01,
        -8.39976013e-01, -1.21932697e+00, -2.95041174e-01,
        -5.12545943e-01, -4.76027310e-01,  6.73096776e-02,
        -1.07020330e+00, -1.94368534e+01, -2.84094372e+01,
        -1.63660507e+01, -2.30555973e+01, -1.92964630e+01,
        -9.21807384e+00,  1.10674894e+00, -4.66668129e+00,
        -2.56888223e+00, -1.24065101e+00, -2.25171781e+00,
        -3.99897456e+00, -4.34232521e+00, -2.22932625e+00,
        -7.22372234e-01, -8.31705093e-01,  9.09702331e-02,
        -9.12019134e-01, -1.83364555e-01, -3.40458453e-01,
         8.44745398e-01,  1.02988040e+00,  1.03189254e+00,
         1.62399616e-02, -2.89375752e-01,  2.61241943e-01,
        -2.48771999e-02,  1.76683441e-01, -1.03655565e+00,
         2.14272857e+00, -2.44342670e-01, -1.21129346e+00,
        -1.05632818e+00,  4.40702438e-01, -1.17904365e+00,
        -5.89849114e-01,  7.09715247e-01, -1.51790082e+00},
       {-2.01952195e+00, -1.08155048e+00, -2.56519198e+00,
        -2.27925897e+00, -2.38503718e+00, -2.63009810e+00,
        -3.32890058e+00, -3.60142088e+00, -2.42016888e+00,
        -8.90514672e-01,  1.07969034e+00,  3.01381516e+00,
         4.43985748e+00,  5.67805052e+00,  6.69861460e+00,
         5.09630871e+00,  3.78904343e+00,  2.24552345e+00,
         4.32610750e-01, -1.91828644e+00, -6.01827860e+00,
        -1.63192959e+01, -2.90384045e+01, -6.23763323e+00,
        -5.82604790e+00, -7.94316244e+00, -2.72007227e-01,
        -3.77352762e+00, -6.58762360e+00, -6.15599918e+00,
        -2.87609291e+00, -3.33808875e+00, -8.04268074e+00,
        -6.13605881e+00, -5.48747826e+00, -4.29238796e+00,
        -5.98754120e+00, -7.91636109e-01, -5.38755655e+00,
        -7.40457392e+00, -9.39116287e+00, -2.80548310e+00,
        -6.73883104e+00, -6.30480433e+00, -6.51982927e+00,
        -6.76839924e+00, -7.55241156e+00, -8.33890343e+00,
        -4.18148470e+00, -7.38346624e+00, -1.48345518e+00,
         3.99824560e-01,  2.61025095e+00,  4.37967443e+00,
         6.31126928e+00,  4.49222708e+00,  3.19185352e+00,
         1.88225210e+00,  2.52593935e-01, -3.82697034e+00,
        -1.24289684e+01, -2.08303375e+01, -4.56608086e+01,
        -5.15263557e+00, -3.51491070e+00, -6.13258266e+00,
        -5.05388165e+00, -7.15887833e+00, -6.54166269e+00,
        -6.10958624e+00, -5.93352747e+00, -6.53201532e+00,
        -5.28142738e+00, -7.94379807e+00, -4.76877546e+00,
        -5.50052929e+00, -6.27170086e+00, -3.34023023e+00,
        -4.62093449e+00, -4.61367226e+00, -5.82478307e-02,
         1.25094461e+00,  6.74718797e-01,  5.83855689e-01,
         6.32246956e-02, -3.04220766e-01, -8.85716558e-01,
        -1.55785275e+00,  1.09474342e-02,  2.04212976e+00,
         3.52716708e+00,  5.13111019e+00,  6.20845747e+00,
         7.51779890e+00,  7.95077705e+00,  5.66830635e+00,
        -6.97285318e+00,  2.64233446e+00,  5.62870264e-01,
        -1.00144005e+00, -4.55405378e+00, -1.40475035e+01,
        -2.35504532e+01, -6.88987255e+00, -5.44667768e+00,
        -5.96648598e+00, -6.32807875e+00, -5.25074577e+00,
        -4.40652704e+00, -6.27623653e+00, -7.25997114e+00,
        -6.48752594e+00, -4.52254725e+00, -7.75784159e+00,
        -6.02807379e+00, -6.89031172e+00, -1.72405231e+00,
        -6.02524281e+00, -8.35706139e+00, -6.44173431e+00},
       {-7.10763574e-01, -1.57648730e+00,  4.68864799e-01,
        -8.65496635e-01,  4.70149487e-01,  2.06147146e+00,
         6.93127751e-01, -1.16192865e+00, -9.39511716e-01,
        -7.01694608e-01,  6.44109428e-01,  1.73926127e+00,
        -2.27664426e-01,  1.10663378e+00, -1.84648149e-02,
         3.25807892e-02, -1.64887290e-02,  1.36289752e+00,
        -1.74612794e-02, -3.07219386e-01,  8.72743428e-01,
        -2.07848012e-01, -1.02944148e+00, -1.27458572e+00,
        -2.08446592e-01,  2.87793070e-01, -8.44015777e-01,
         7.69656241e-01,  3.82744730e-01, -2.55931759e+00,
         5.97561300e-01,  9.86843646e-01,  1.60660386e+00,
         3.81762892e-01, -1.12597573e+00,  4.09435958e-01,
         2.80065298e-01, -2.15204716e+00, -2.20301962e+00,
        -6.78125441e-01, -1.32386160e+00,  9.71793652e-01,
         6.94207966e-01, -4.35303092e-01,  2.16939998e+00,
        -7.38082707e-01,  3.00539947e+00, -1.56072751e-01,
        -1.32044625e+00, -1.33258891e+00, -1.16658092e+00,
        -9.37679708e-01, -8.47618699e-01,  2.54131746e+00,
         7.32990801e-01, -3.43383342e-01,  6.03059053e-01,
         1.06666207e-01,  9.81728077e-01, -1.12563384e+00,
        -6.85272813e-01,  3.81957018e-03, -9.74084258e-01,
        -9.57360208e-01,  4.95585948e-01,  2.81934232e-01,
        -1.98065992e-02, -1.18051040e+00,  5.62756956e-01,
         1.05028784e+00,  1.06249511e+00,  2.09227705e+00,
        -5.50349593e-01, -1.55844092e+00,  2.84192920e-01,
        -4.03069347e-01, -8.53493586e-02, -1.21030271e+00,
         9.82003883e-02, -6.33178473e-01,  1.33838427e+00,
        -3.14870477e-01, -7.82791853e-01, -1.55872917e+00,
         1.09004498e+00, -1.78069696e-01,  4.68057811e-01,
        -8.98958266e-01,  4.77411628e-01,  3.84613693e-01,
         2.45076016e-01, -3.95615309e-01, -1.09074116e+00,
         4.48253304e-01,  8.80364537e-01,  3.23999107e-01,
        -4.47859317e-01, -4.29849327e-02,  1.89731145e+00,
         1.19202495e+00,  1.58828124e-01,  1.58279181e-01,
         3.23729157e-01, -1.78318250e+00,  1.35585710e-01,
         1.09710741e+00,  5.12127340e-01,  1.80965334e-01,
         7.13613927e-01, -9.09442425e-01, -1.93227839e+00,
         6.25879109e-01, -1.23723245e+00, -5.44735432e-01,
        -2.46071950e-01, -1.17230821e+00, -3.20942223e-01,
        -9.03776288e-02,  8.75173867e-01,  1.72611505e-01},
       { 2.29269713e-01, -8.23242813e-02, -1.36649740e+00,
         1.13088131e+00, -6.59523234e-02, -3.56703043e-01,
         1.65986395e+00, -2.15583537e-02,  1.44382405e+00,
         1.79917765e+00,  1.34927905e+00,  1.83408761e+00,
         2.25835204e+00, -3.23688954e-01,  1.44128370e+00,
         3.13722640e-01, -6.69222534e-01, -6.46847248e-01,
         9.22739089e-01, -7.04166815e-02,  1.06875455e+00,
        -5.97688556e-01, -2.48528317e-01, -2.53223610e+00,
        -1.56189001e+00, -6.70510948e-01,  1.91638613e+00,
        -7.04925895e-01, -5.22189140e-02,  8.66555393e-01,
         1.19792330e+00,  2.30262160e+00, -2.34240413e+00,
        -4.63021815e-01, -2.31263787e-01, -1.88127160e+00,
        -1.06563732e-01,  2.08688402e+00, -2.49510026e+00,
        -6.11298501e-01,  1.45884418e+00, -1.46516001e+00,
        -1.29617512e+00, -7.18529165e-01,  7.75360942e-01,
         3.79456937e-01, -6.03960633e-01, -6.23263828e-02,
         3.72098505e-01, -1.42306423e+00, -3.14093471e-01,
         8.77330601e-01, -2.78143942e-01,  9.44100738e-01,
        -2.18481749e-01, -3.46342921e-01, -6.25876367e-01,
        -3.42200808e-02, -1.37001705e+00,  2.69191551e+00,
         6.75342858e-01,  1.50084126e+00,  9.37408328e-01,
         8.06551695e-01, -1.74222612e+00, -1.87507963e+00,
        -1.35683990e+00, -9.50807095e-01, -1.05052948e+00,
        -1.84549481e-01, -8.56181502e-01,  9.69167173e-01,
         2.50453293e-01, -1.06511056e+00, -1.14369310e-01,
        -1.26686573e+00, -2.51611209e+00, -2.68424124e-01,
         1.16342854e+00,  4.10967261e-01,  1.79476929e+00,
        -1.63421810e-01,  4.78361189e-01,  1.95422328e+00,
        -1.48773780e-02,  1.76015711e+00,  6.16435528e-01,
        -1.69273603e+00,  6.66850805e-01,  2.65888786e+00,
         6.90958798e-01, -7.07534313e-01,  7.17434049e-01,
        -6.79773748e-01,  1.68161845e+00,  3.79901618e-01,
        -1.45300245e+00, -5.95303237e-01, -1.84565946e-01,
         4.19526637e-01,  1.25375301e-01, -2.51036920e-02,
         3.08715463e-01, -1.46267727e-01, -1.44715679e+00,
         4.74864662e-01,  6.96456134e-01, -1.06132042e+00,
         1.06419981e+00, -1.64375615e+00, -1.39116466e+00,
        -1.65840256e+00, -6.14878535e-01, -5.38072407e-01,
        -2.38846159e+00,  1.01124370e+00, -7.72608817e-01,
        -9.40244317e-01,  6.55064106e-01, -1.74574518e+00}};
*BaClass = {{-0.5248529 ,  0.05493584, -1.0303925 ,  2.4621074 , -2.8724988 ,
       10.770075  , -2.3867087 ,  0.40959504,  5.9630575 , -0.46027175,
        0.31263435,  1.3013262 }};
*BbClass = {{-2.4040701 , -0.10990631,  5.85299   ,  0.46304202,  0.85823363,
       -0.6806423 ,  3.3997023 , -0.65699625,  0.25976604}};
*BcClass = {{ -2.59363   ,   0.9503861 ,  -2.2016826 ,  -3.4546347 ,
        -1.1993454 ,  -5.093368  ,   0.7299552 ,  -5.505417  ,
         2.9156446 ,   6.626866  ,   5.3636107 ,  -3.9276397 ,
       -13.312054  , -27.55401   , -42.33897   , -12.379772  ,
         7.5585294 ,  25.379877  ,  39.949677  ,  47.907314  ,
        50.905224  ,  50.944588  ,  50.953873  ,  -2.8690314 ,
        -5.0905466 ,  -1.4689919 ,  -2.7770927 ,  -3.3809102 ,
        -1.6850917 ,  -1.5498506 ,  -4.0859632 ,  -2.1338527 ,
        -1.6861484 ,  -2.6127715 ,  -4.2554603 ,  -3.0518405 ,
        -2.122234  ,  -3.7776167 ,  -4.9746933 ,  -3.1041782 ,
        -1.1125236 ,  -4.2552786 ,  -5.265083  ,  -0.22504432,
        -1.9813331 ,  -4.294192  ,  -0.64910626,  -2.5667198 ,
        41.55511   ,  -2.738158  ,  40.893475  ,  33.954     ,
        15.64056   ,  -4.2481384 , -36.984325  ,  -5.017546  ,
        14.084596  ,  26.327589  ,  39.223     ,  47.772125  ,
        49.58486   ,  48.489304  ,  48.48949   ,  -4.9712977 ,
        -5.4833174 ,  -4.465464  ,  -3.051165  ,  -2.5715837 ,
        -4.140074  ,  -2.3907301 ,  -5.2606483 ,  -2.625863  ,
        -2.053282  ,  -2.8851597 ,  -2.2818434 ,  -3.9257743 ,
        -3.9550416 ,  -1.2652084 ,  -2.2084153 ,  -4.192234  ,
        -0.91531056,  -8.022572  ,  -8.657668  ,  -8.023372  ,
        -6.781233  , -10.889478  , -22.494438  , -36.730576  ,
       -49.210842  , -37.566315  , -40.21117   , -45.982807  ,
       -51.476654  , -70.49807   , -69.55027   , -23.73115   ,
        -2.3570898 ,  20.029596  ,  37.44551   ,  44.462456  ,
        48.14692   ,  49.58595   ,  49.587482  ,  -3.7555447 ,
        -4.115567  ,  -2.852198  ,  -3.7236464 ,  -2.5633132 ,
        -5.6976395 ,  -3.8875494 ,  -2.8076892 ,  -3.7719116 ,
        -2.620712  ,  -3.0692635 ,  -2.437306  ,  -1.6759757 ,
        -3.4370115 ,  -1.755899  ,  -2.5111327 ,  -2.511911  }};

*WaRegr = {{-1.68673909e+00,  9.90369856e-01, -4.38754463e+00,
         2.77244902e+00,  1.36323726e+00,  4.16791439e-02,
        -8.17852855e-01, -6.81973755e-01,  1.72895825e+00,
         1.82940030e+00,  7.92253971e-01,  1.42437011e-01,
         1.72038496e+00,  7.99354374e-01},
       {-1.87060666e+00,  6.30253971e-01,  1.05405369e+01,
        -7.60816514e-01,  5.40667295e+00, -6.93754017e-01,
        -8.32665622e-01, -2.13351679e+00, -5.69101477e+00,
        -1.43006885e+00, -2.92702109e-01, -3.54166627e+00,
         1.18635678e+00, -6.21879101e+00},
       { 4.01998401e-01, -8.56898546e-01,  1.08824902e+01,
         1.07990706e+00, -1.73410022e+00, -1.82491601e+00,
         1.55221117e+00,  1.07741094e+00, -1.66884315e+00,
         1.94207847e+00,  3.26395273e-01, -2.57610512e+00,
        -3.47239971e-02, -4.52222049e-01},
       { 2.65974998e+00,  3.88199902e+00,  4.61338329e+00,
         2.09812745e-01, -7.91433096e+00,  2.19112730e+00,
         1.29313552e+00, -4.98850155e+00, -2.26543665e+00,
        -3.31349993e+00, -6.08989835e-01,  6.20586634e-01,
        -7.94587016e-01, -3.52893925e+00},
       { 3.01759529e+00, -1.80086946e+00, -1.49056835e+01,
         6.05817497e-01,  4.56694573e-01, -1.93658400e+00,
        -6.34122670e-01, -5.03429234e-01,  3.03804427e-01,
         1.68859959e+00,  1.36001155e-01,  3.42107320e+00,
        -1.89077413e+00, -1.30020902e-01},
       {-9.07277882e-01, -1.83468437e+01, -7.51554060e+00,
         2.24879384e+00,  1.17252531e+01, -6.07776070e+00,
        -4.04044539e-01,  2.79812717e+01, -3.25029206e+00,
         1.01882725e+01, -5.15354347e+00,  1.21173258e+01,
        -9.95424390e-01,  1.84364855e+00},
       {-9.26125497e-02,  3.18362641e+00,  3.24012136e+00,
         1.79667816e-01, -1.41609597e+00,  1.10326920e+01,
        -4.22217798e+00,  7.36891702e-02, -1.37471244e-01,
         2.47334981e+00, -1.09730199e-01,  8.96439925e-02,
        -3.68704844e+00,  1.32169068e+00},
       {-1.36164856e+00,  3.31585197e+01, -8.11400488e-02,
        -9.69318211e-01, -3.61054420e+01,  7.53438663e+00,
         1.17822945e-01, -5.36459465e+01,  1.43356276e+01,
        -1.44561024e+01,  1.23174095e+01, -9.37917614e+00,
         1.86799920e+00, -7.03369856e-01},
       { 1.26651978e+00, -8.12815011e-01,  8.09958637e-01,
         1.03716588e+00, -8.06284547e-01,  1.59712112e+00,
         1.18081713e+00,  1.49595961e-01, -9.57060605e-02,
        -3.66838574e-01,  7.09960818e-01,  4.72813100e-01,
         2.15333030e-01,  1.27130682e-02},
       { 1.14183178e+01, -2.12381382e+01,  1.24212837e+01,
        -4.61618379e-02,  2.97968826e+01, -3.15441132e+00,
        -5.04475772e-01,  3.65916519e+01, -1.01483107e+01,
         1.15656586e+01, -7.15733671e+00, -7.64660406e+00,
        -1.54069185e+00,  2.30217481e+00},
       {-1.28907943e-03,  9.56175327e-02, -1.06729994e+01,
        -1.29761789e-02,  3.84241762e-03, -2.50319064e-01,
         1.13660609e-03,  1.29762348e-02, -2.84948736e-01,
        -1.78921413e+00, -9.47600827e-02, -6.24995753e-02,
         1.30778328e-02, -3.13148081e-01},
       {-8.24596174e-03, -1.08291768e-01, -4.95761871e+00,
         7.05090240e-02,  4.37158570e-02,  1.29658091e+00,
         2.66753207e-03, -7.57640461e-03, -2.84485985e-03,
         5.06450951e-01,  1.13456833e+00,  1.18160456e-01,
        -8.77552573e-03, -3.79173428e-01}};
*WbRegr = {{ 2.33392984e-01,  6.12829328e-02, -6.31189167e-01,
        -1.44969717e-01,  5.22101343e-01, -4.07676578e-01,
        -2.23160124e+00, -1.05750358e+00, -1.51524961e-01,
        -6.18304789e-01},
       { 6.26355529e-01,  1.47256243e+00, -2.25250316e+00,
        -5.18947840e-01,  1.57197610e-01,  3.12518507e-01,
        -1.19520295e+00, -1.39545465e+00,  2.62266970e+00,
        -4.89555985e-01},
       {-9.16490778e-02, -1.52656864e-02, -3.65238686e+01,
        -9.69835091e+00, -1.27137095e-01,  2.68001229e-01,
        -3.49474883e+00, -1.03503358e+00,  5.26024736e-02,
        -1.41262627e+01},
       { 6.35254264e-01,  1.62701535e+00,  4.75904512e+00,
         1.44079387e+00, -7.35177621e-02, -1.53448629e+00,
        -5.56763291e-01, -9.12156403e-02, -1.65702701e+00,
         3.48964310e+00},
       { 1.47098154e-01, -1.80838425e-02, -2.16025352e+00,
         2.94337273e-02,  2.93312609e-01, -6.58550262e-01,
         3.17922562e-01,  3.40036154e-01, -1.23417699e+00,
         9.99266684e-01},
       {-2.26510096e+00,  6.78612530e-01,  3.80002379e+00,
        -9.13914299e+00, -1.30443680e+00, -4.93681002e+00,
        -9.93676901e-01, -1.78210115e+00,  1.05102181e+00,
        -6.29044628e+00},
       { 6.26749992e-01,  2.26206347e-01, -3.91055971e-01,
         1.18271363e+00,  8.30202252e-02, -7.29132533e-01,
        -1.83313236e-01, -2.36001635e+00,  3.38187516e-01,
         4.15941142e-03},
       {-4.35696602e-01, -1.43860686e+00,  2.38802242e+00,
         2.80140698e-01, -3.47950280e-01,  7.45999068e-02,
        -2.40466728e+01, -1.90467250e+00, -2.14385390e+00,
        -1.07753426e-01},
       {-8.56688261e-01, -4.99915981e+00,  6.23927641e+00,
         6.03201091e-01, -6.60174727e-01,  1.50998688e+00,
         1.13364518e+00,  3.95861536e-01, -6.62497663e+00,
        -1.11841285e+00},
       {-2.47355556e+00,  2.52418828e+00, -2.48726482e+01,
         2.46458456e-01, -3.07815343e-01,  6.24255538e-01,
         4.22578335e+00,  1.18354070e+00, -8.39752655e+01,
        -2.68249969e+01},
       { 2.32585311e+00, -3.57784996e+01, -7.15262517e-02,
         2.96211671e-02, -1.65463034e-02, -3.51097894e+00,
         2.44209146e+00,  1.10510457e+00,  1.36031651e+00,
        -2.77567410e+00},
       { 1.94089077e-02, -2.03504577e-01,  4.33116943e-01,
        -7.94357583e-02, -2.17158034e-01, -9.64899826e+00,
        -1.65816784e+01, -1.27192485e+00, -4.84836668e-01,
         7.94965252e-02},
       { 4.21998531e-01,  2.62052512e+00, -1.78872049e+00,
         3.19043189e-01,  6.72542810e-01, -1.54802608e+00,
        -4.46478653e+00, -4.63483930e-01,  1.31200165e-01,
         4.06906700e+00},
       { 7.80224919e-01,  3.68841505e+00, -5.70536900e+00,
        -5.55953801e-01,  6.22600257e-01, -4.32457304e+00,
        -9.09500217e+00, -1.37559938e+00,  6.00708532e+00,
         3.78588229e-01}};
*WcRegr = {{ 1.50770232e-01, -2.34915450e-01,  3.01077634e-01,
        -3.78373623e-01,  4.50994790e-01, -4.68059838e-01,
         6.00365281e-01, -5.02781212e-01,  7.49263823e-01,
        -4.96237546e-01,  8.97678852e-01, -4.70786273e-01},
       {-1.75129194e-02,  1.61674395e-02, -3.68325971e-02,
         2.20252812e-01, -5.66914976e-02,  4.75679666e-01,
        -7.66500384e-02,  7.48803318e-01, -9.73496363e-02,
         1.00889778e+00, -1.18914977e-01,  1.22700417e+00},
       { 8.79372749e-03, -1.98610127e-02,  1.64188538e-02,
        -1.23174734e-01,  2.65129842e-02, -2.46390030e-01,
         3.72818746e-02, -3.71470004e-01,  4.81006056e-02,
        -4.84199494e-01,  5.91683909e-02, -5.74118853e-01},
       { 1.79613650e-01,  1.02082305e-01,  3.59140813e-01,
         1.67033419e-01,  5.39001584e-01,  2.08198518e-01,
         7.18983948e-01,  2.24713206e-01,  8.99179161e-01,
         2.22814590e-01,  1.07959449e+00,  2.12232500e-01},
       {-1.82031980e-03,  2.70864099e-01, -2.36118585e-03,
         2.64417768e-01, -2.35474505e-03,  2.41304070e-01,
        -1.99861499e-03,  2.02130094e-01, -1.19497569e-03,
         1.50116980e-01,  8.27163021e-05,  9.62592214e-02},
       { 3.51795465e-01,  4.86920774e-01,  4.56387818e-01,
        -2.69866467e-01, -9.17942598e-02, -2.17168957e-01,
        -1.85272634e-01,  7.29802102e-02, -3.92837971e-01,
         4.60834801e-01, -2.20651284e-01, -1.49528131e-01},
       {-1.83705557e-02,  4.67547476e-01,  1.68403268e-01,
         1.47201562e+00,  7.62102664e-01,  2.61550665e+00,
         1.03770721e+00,  3.72688055e+00,  1.28880656e+00,
         4.70018864e+00,  1.66270316e+00,  5.32056999e+00},
       {-5.68919659e-01,  8.94095004e-01, -9.68181551e-01,
        -1.31326115e+00, -5.48929155e-01,  1.07786584e+00,
        -1.29230690e+00,  1.64702523e+00, -1.91935182e-01,
        -6.25553280e-02, -8.62871647e-01,  1.26664782e+00},
       { 3.75210936e-03, -2.12885439e-03,  9.02870856e-03,
        -1.05638668e-01,  1.44494167e-02, -2.50915796e-01,
         2.04036981e-02, -4.16984409e-01,  2.68658195e-02,
        -5.81229329e-01,  3.39092836e-02, -7.20945060e-01},
       {-2.12543830e-02, -4.92707901e-02, -4.04087342e-02,
        -1.32953987e-01, -5.59105091e-02, -2.60968745e-01,
        -7.01920018e-02, -4.10164714e-01, -8.46610218e-02,
        -5.57418525e-01, -9.95889828e-02, -6.82459772e-01}};
*BaRegr = {{ 5.4257383 , -0.01548798, -4.2335024 , -1.818707  ,  0.68159604,
       -4.8783193 ,  1.48842   , -0.15756609,  0.09498966, -4.403825  ,
       -5.2688904 , -3.4684339 ,  0.5233529 ,  0.14912952}};
*BbRegr = {{-1.4803481 , -3.59545   ,  4.5427246 , -1.0099406 , -0.5205395 ,
       -2.62462   , -0.7885956 ,  0.17553554,  4.0146866 , -2.0407386 }};
*BcRegr = {{-0.19183697, -0.57047427, -0.38707352, -0.0679062 , -0.5853916 ,
        0.5554754 , -0.78677005,  1.2314767 , -0.9909125 ,  1.8963193 ,
       -1.1976476 ,  2.4703512 }};


            break;
        default:
            break;
    }



    // _classInput = inputClass;
    _classWa = WaClass;
    _classBa = BaClass;
    _classWb = WbClass;
    _classBb = BbClass;
    _classWc = WcClass;
    _classBc = BcClass;
    // _regrInput = inputRegr;
    _regrWa = WaRegr;
    _regrBa = BaRegr;
    _regrWb = WbRegr;
    _regrBb = BbRegr;
    _regrWc = WcRegr;
    _regrBc = BcRegr;


}


ObjectPredictionTNT::ObjectPredictionTNT(const mode_type mode){
    _mode = mode;
    // _input.clear();
    // std::cout<<_input.size()<<std::endl;

    if(_classInput==nullptr)
    _classInput = std::make_unique<std::vector< std::vector<float> >>();
    if(_regrInput==nullptr)
    _regrInput = std::make_unique<std::vector< std::vector<float> >>();
    if(_classOutput==nullptr)
    _classOutput = std::make_shared<std::vector< std::vector<float> >>();
    if(_regrOutput==nullptr)
    _regrOutput = std::make_unique<std::vector< std::vector<float> >>();
    if(objectOutput==nullptr)
    objectOutput = std::make_shared<std::vector< std::vector<float> >>();
}


Matrix ObjectPredictionTNT::relu(const Matrix &m){

    Matrix _copy = m;
    for (int i = 0; i < m.getRowNum(); i++)
    {
        for (int j = 0; j < m.getColNum(); j++)
        {
            _copy.set(i, j, std::max(m.get(i, j),0.0f));
        }
    }
    return _copy;

}

Matrix ObjectPredictionTNT::softmax(const Matrix &m){

    Matrix _res = m, _copy = m;
    int mat_colNum = _copy.getColNum();
    for (int i = 0; i < _copy.getRowNum(); i++)
    {
        float max_value = -999.9f;
        for (int j = 0; j < mat_colNum; j++){
            if( _copy.get(i, j) > max_value){
                max_value = _copy.get(i, j);
            }
        }
        for (int j = 0; j < mat_colNum; j++){
            _copy.set(i, j, _copy.get(i,j)-max_value);
        }

        // e
        float sum_row = 0.0f;
        for (int j = 0; j < mat_colNum; j++){
            _copy.set(i, j, exp(_copy.get(i,j)) );
            sum_row = sum_row + _copy.get(i,j);
        }
        sum_row = std::max(sum_row, 0.001f);

        // %
        if(isinf(sum_row)){     // incalculable probability
            float max_value_e = 0.0f;
            int max_j = 0;
            for (int j = 0; j < mat_colNum; j++){
                if( _copy.get(i, j) > max_value_e){
                    max_value_e = _copy.get(i, j);
                    max_j = j;
                }
            }
            for (int j = 0; j < mat_colNum; j++){
                if(j==max_j){
                    _res.set(i, j, 1.0f);
                }
                else{
                    _res.set(i, j, 0.0f);
                }
            }
        }
        else{
            for (int j = 0; j < mat_colNum; j++)
            {
                _res.set(i, j, static_cast<float>  ( _copy.get(i, j) / sum_row) );
            }
        }
    }

    return _res;

}



std::vector<std::vector<float> > ObjectPredictionTNT::label_decode_firstlayer(const std::vector<std::vector<float> > &m){
	// straight lane   0-119m   space 3m
	// 3.5   -------------------  No 40-79
	// 0     -#current lane#----  No 0-39   for object vehicle
	// -3.5  -------------------  No 80-119
    std::vector<std::vector<float> > _res;
    if(m.size()!=1) return _res;
    std::vector<float> res_firstlayer = m.at(0);
    float delta_s_firstlayer = 3.0f;

    while(*max_element(res_firstlayer.begin(), res_firstlayer.end()) > thresholdValue_intention){
        auto maxPosition = max_element(res_firstlayer.begin(), res_firstlayer.end());
        int n_pos = maxPosition - res_firstlayer.begin();

        // translate n_pos to xy_pos
        float x_pos = 0.0;
        float y_pos = 0.0;
        if(n_pos<40){
            x_pos = static_cast<float>(n_pos) * delta_s_firstlayer;
            y_pos = y_laneCenter[3];
        }
        else if(n_pos<80){
            x_pos = static_cast<float>(n_pos-40) * delta_s_firstlayer;
            y_pos = y_laneCenter[2];
        }
        else if(n_pos<120){
            x_pos = static_cast<float>(n_pos-80) * delta_s_firstlayer;
            y_pos = y_laneCenter[4];
        }

        std::vector<float> cur_res(2);
        cur_res.at(0) = x_pos;
        cur_res.at(1) = y_pos;

        _res.emplace_back(cur_res);

        *maxPosition = 0.0f;
    }

    if(_res.empty()){
        auto maxPosition = max_element(res_firstlayer.begin(), res_firstlayer.end());
        int n_pos = maxPosition - res_firstlayer.begin();

        // translate n_pos to xy_pos
        float x_pos = 0.0;
        float y_pos = 0.0;
        if(n_pos<40){
            x_pos = static_cast<float>(n_pos) * delta_s_firstlayer;
            y_pos = y_laneCenter[3];
        }
        else if(n_pos<80){
            x_pos = static_cast<float>(n_pos-40) * delta_s_firstlayer;
            y_pos = y_laneCenter[2];
        }
        else if(n_pos<120){
            x_pos = static_cast<float>(n_pos-80) * delta_s_firstlayer;
            y_pos = y_laneCenter[4];
        }

        std::vector<float> cur_res(2,0.0f);
        cur_res.at(0) = x_pos;
        cur_res.at(1) = y_pos;

        _res.emplace_back(cur_res);
    }

    return _res;

}


void ObjectPredictionTNT::classification(){

    std::unique_ptr<pd_forwardSpread::Matrix> input_mat(new pd_forwardSpread::Matrix(_classInput->size(),_classInput->front().size()));
    input_mat->vector2matrix(*_classInput);
    std::unique_ptr<pd_forwardSpread::Matrix> Wa_mat(new pd_forwardSpread::Matrix(_classWa->size(),_classWa->front().size()));
    Wa_mat->vector2matrix(*_classWa);
    std::unique_ptr<pd_forwardSpread::Matrix> Ba_mat(new pd_forwardSpread::Matrix(_classBa->size(),_classBa->front().size()));
    Ba_mat->vector2matrix(*_classBa);
    std::unique_ptr<pd_forwardSpread::Matrix> Wb_mat(new pd_forwardSpread::Matrix(_classWb->size(),_classWb->front().size()));
    Wb_mat->vector2matrix(*_classWb);
    std::unique_ptr<pd_forwardSpread::Matrix> Bb_mat(new pd_forwardSpread::Matrix(_classBb->size(),_classBb->front().size()));
    Bb_mat->vector2matrix(*_classBb);
    std::unique_ptr<pd_forwardSpread::Matrix> Wc_mat(new pd_forwardSpread::Matrix(_classWc->size(),_classWc->front().size()));
    Wc_mat->vector2matrix(*_classWc);
    std::unique_ptr<pd_forwardSpread::Matrix> Bc_mat(new pd_forwardSpread::Matrix(_classBc->size(),_classBc->front().size()));
    Bc_mat->vector2matrix(*_classBc);

    // forwward
    std::unique_ptr<pd_forwardSpread::Matrix> output1(new pd_forwardSpread::Matrix(n_row_input_class,n_col_Ba_class));
    *output1 = (*input_mat) * (*Wa_mat) + (*Ba_mat);
    *output1 = relu(*output1);
    std::unique_ptr<pd_forwardSpread::Matrix> output2(new pd_forwardSpread::Matrix(n_row_input_class,n_col_Bb_class));
    *output2 = (*output1) * (*Wb_mat) + (*Bb_mat);
    *output2 = relu(*output2);
    std::shared_ptr<pd_forwardSpread::Matrix> output3(new pd_forwardSpread::Matrix(n_row_input_class,n_col_Bc_class));
    *output3 = (*output2) * (*Wc_mat) + (*Bc_mat);
    // output3 = relu(output3); // this is wrong
    *output3 = softmax(*output3);

    std::shared_ptr<pd_forwardSpread::Matrix> output(new pd_forwardSpread::Matrix(n_row_input_class,n_col_Bc_class));
    output = (output3);
    // output->showMat();

    *_classOutput = output->matrix2vector();



}


void ObjectPredictionTNT::regression(){

    std::unique_ptr<pd_forwardSpread::Matrix> input_mat(new pd_forwardSpread::Matrix(_regrInput->size(),_regrInput->front().size()));
    input_mat->vector2matrix(*_regrInput);
    std::unique_ptr<pd_forwardSpread::Matrix> Wa_mat(new pd_forwardSpread::Matrix(_regrWa->size(),_regrWa->front().size()));
    Wa_mat->vector2matrix(*_regrWa);
    std::unique_ptr<pd_forwardSpread::Matrix> Ba_mat(new pd_forwardSpread::Matrix(_regrBa->size(),_regrBa->front().size()));
    Ba_mat->vector2matrix(*_regrBa);
    std::unique_ptr<pd_forwardSpread::Matrix> Wb_mat(new pd_forwardSpread::Matrix(_regrWb->size(),_regrWb->front().size()));
    Wb_mat->vector2matrix(*_regrWb);
    std::unique_ptr<pd_forwardSpread::Matrix> Bb_mat(new pd_forwardSpread::Matrix(_regrBb->size(),_regrBb->front().size()));
    Bb_mat->vector2matrix(*_regrBb);
    std::unique_ptr<pd_forwardSpread::Matrix> Wc_mat(new pd_forwardSpread::Matrix(_regrWc->size(),_regrWc->front().size()));
    Wc_mat->vector2matrix(*_regrWc);
    std::unique_ptr<pd_forwardSpread::Matrix> Bc_mat(new pd_forwardSpread::Matrix(_regrBc->size(),_regrBc->front().size()));
    Bc_mat->vector2matrix(*_regrBc);

    // forwward
    std::unique_ptr<pd_forwardSpread::Matrix> output1(new pd_forwardSpread::Matrix(n_row_input_regr,n_col_Ba_regr));
    *output1 = (*input_mat) * (*Wa_mat) + (*Ba_mat);
    *output1 = relu(*output1);
    std::unique_ptr<pd_forwardSpread::Matrix> output2(new pd_forwardSpread::Matrix(n_row_input_regr,n_col_Bb_regr));
    *output2 = (*output1) * (*Wb_mat) + (*Bb_mat);
    *output2 = relu(*output2);
    std::shared_ptr<pd_forwardSpread::Matrix> output3(new pd_forwardSpread::Matrix(n_row_input_regr,n_col_Bc_regr));
    *output3 = (*output2) * (*Wc_mat) + (*Bc_mat);
    // output3 = relu(output3); // this is wrong

    std::shared_ptr<pd_forwardSpread::Matrix> output = output3;
    // output->showMat();

    *_regrOutput = output->matrix2vector();

}


void ObjectPredictionTNT::getHistoryTraj(std::vector<std::vector<float> > historyTraj){
    isValid = true;
    if(historyTraj.size()!=n_trajPoints_Frenet){
        isValid = false;
        if(historyTraj.empty())
            return;
    }
    for(const auto& ele1:historyTraj){
        if(ele1.size()!=2){
            isValid = false;
            return;
        }
    }

    _s_cur = historyTraj.back().front();
    _l_cur = historyTraj.back().back();
    std::vector<float> r;
    for(const auto& ele1:historyTraj){
        r.emplace_back(ele1.at(0)-_s_cur);
        r.emplace_back(ele1.at(1));
    }

    _classInput->clear();
    _classInput->emplace_back(r);
}


void ObjectPredictionTNT::intentionPrediction(){
    classification();
}


void ObjectPredictionTNT::trajectoryprediction(){
    regression();
}


void ObjectPredictionTNT::postProcess(){
    if(_classInput->empty()) return;
    if(_classInput->at(0).size()<4) return;
    bool isValidReOut = true;
    if(_regrOutput->empty()) 
        isValidReOut = isValidReOut && false;
    else
        if(_regrOutput->front().size()!=12) 
            isValidReOut = isValidReOut && false;

    float l_last    = _classInput->at(0).at(_classInput->at(0).size()-1);
    float l_sublast = _classInput->at(0).at(_classInput->at(0).size()-3);
    float s_last    = _classInput->at(0).at(_classInput->at(0).size()-2);
    float s_sublast = _classInput->at(0).at(_classInput->at(0).size()-4);
    float vs_last = (s_last-s_sublast)/(delta_t_input*(19.0f-15.0f)); // 20220729 only input five points 
    float vl_last = (l_last-l_sublast)/(delta_t_input*(19.0f-15.0f)); // 20220729 only input five points 
    if(!isValid || !isValidReOut){
        std::vector<float> tempObject(12);
        tempObject.at(0) = s_last+vs_last*1.0f*delta_t_output;   tempObject.at(1) = l_last;
        tempObject.at(2) = s_last+vs_last*2.0f*delta_t_output;   tempObject.at(3) = l_last;
        tempObject.at(4) = s_last+vs_last*3.0f*delta_t_output;   tempObject.at(5) = l_last;
        tempObject.at(6) = s_last+vs_last*4.0f*delta_t_output;   tempObject.at(7) = l_last;
        tempObject.at(8) = s_last+vs_last*5.0f*delta_t_output;   tempObject.at(9) = l_last;
        tempObject.at(10) = s_last+vs_last*6.0f*delta_t_output;  tempObject.at(11) = l_last;
        objectOutput->emplace_back(tempObject);
    }
    else{
        objectOutput->emplace_back(_regrOutput->front());
    }

    // smooth based on vehicle kinematics
    constexpr float c_max_vs = 130.0f/3.6f;    constexpr float c_min_vs = 0.0f;     // m/s
    constexpr float c_max_vl = 1.0f;    constexpr float c_min_vl = -1.0f;           // m/s
    constexpr float c_max_as = 3.0f;    constexpr float c_min_as = -6.0f;           // m/s/s
    constexpr float c_max_al = 0.6f;    constexpr float c_min_al = -0.6f;           // m/s/s
    float max_vs_thisPoint = vs_last + c_max_as * delta_t_output;   max_vs_thisPoint = std::min(max_vs_thisPoint, c_max_vs);
    float min_vs_thisPoint = vs_last + c_min_as * delta_t_output;   min_vs_thisPoint = std::max(min_vs_thisPoint, c_min_vs);
    float max_vl_thisPoint = vl_last + c_max_al * delta_t_output;   max_vl_thisPoint = std::min(max_vl_thisPoint, c_max_vl);
    float min_vl_thisPoint = vl_last + c_min_al * delta_t_output;   min_vl_thisPoint = std::max(min_vl_thisPoint, c_min_vl);
    if(objectOutput->empty())  return;
    if(objectOutput->back().size() == 12){
        objectOutput->back().at(0) = std::max( std::min( objectOutput->back().at(0), 0.0f+max_vs_thisPoint*delta_t_output), 0.0f+min_vs_thisPoint*delta_t_output);
        objectOutput->back().at(1) = std::max( std::min( objectOutput->back().at(1), _l_cur+max_vl_thisPoint*delta_t_output), _l_cur+min_vl_thisPoint*delta_t_output);
        {
            vs_last = (objectOutput->back().at(0) - 0.0f) / delta_t_output;
            vl_last = (objectOutput->back().at(1) - _l_cur) / delta_t_output;
        }
        for(decltype(objectOutput->back().size()) i=2;i<objectOutput->back().size()-1;i=i+2){
            {
                max_vs_thisPoint = vs_last + c_max_as * delta_t_output;   max_vs_thisPoint = std::min(max_vs_thisPoint, c_max_vs);
                min_vs_thisPoint = vs_last + c_min_as * delta_t_output;   min_vs_thisPoint = std::max(min_vs_thisPoint, c_min_vs);
                max_vl_thisPoint = vl_last + c_max_al * delta_t_output;   max_vl_thisPoint = std::min(max_vl_thisPoint, c_max_vl);
                min_vl_thisPoint = vl_last + c_min_al * delta_t_output;   min_vl_thisPoint = std::max(min_vl_thisPoint, c_min_vl);
            }
            objectOutput->back().at(i) = std::max( std::min( objectOutput->back().at(i), objectOutput->back().at(i-2)+max_vs_thisPoint*delta_t_output), objectOutput->back().at(i-2)+min_vs_thisPoint*delta_t_output);
            objectOutput->back().at(i+1) = std::max( std::min( objectOutput->back().at(i+1), objectOutput->back().at(i-1)+max_vl_thisPoint*delta_t_output), objectOutput->back().at(i-1)+min_vl_thisPoint*delta_t_output);
            {
                vs_last = (objectOutput->back().at(i) - objectOutput->back().at(i-2)) / delta_t_output;
                vl_last = (objectOutput->back().at(i+1) - objectOutput->back().at(i-1)) / delta_t_output;
            }
        }
    }
    // translate from relative coordinates to absolute coordinates
    for(decltype(objectOutput->back().size()) i=0;i<objectOutput->back().size()-1;i=i+2){
        objectOutput->back().at(i) = objectOutput->back().at(i) + _s_cur;
        objectOutput->back().at(i+1) = objectOutput->back().at(i+1) + 0.0f;
    }
}


void ObjectPredictionTNT::prediction(){
    objectOutput->clear();
    if(isValid){
        coeffInit();
        intentionPrediction();

        std::vector<std::vector<float> > res1 = label_decode_firstlayer(*_classOutput);

        for(const auto& ele1:res1){    // every possible intention
            if(ele1.size()!=2) return;
            *_regrInput = *_classInput;
            for(auto& ele:*_regrInput){
                ele.emplace_back(ele1.at(0));
                ele.emplace_back(ele1.at(1));
            }

            trajectoryprediction();
            postProcess();
            if(static_cast<int>(objectOutput->size()) >= n_intentionNumber)
            break;  /************** only use one or some intention at present ****************/
        }
    }
    else{
        postProcess();
    }

}








Matrix::Matrix(int m, int n)
{
    if (m < 0 || n < 0)
    {
        return;
    }
    rowNum = m;
    colNum = n;
    item = new float[m*n];
    for (int i = 0; i < m*n; i++)
    {
        item[i] = 0;
    }
}

Matrix::Matrix(float* items, int m, int n)
{
    rowNum = m;
    colNum = n;
    item = new float[m*n];
    for (int i = 0; i < colNum*rowNum; i++)
    {
        item[i] = items[i];
    }
}
Matrix::Matrix(int n)
{
    rowNum = colNum = n;
    item = new float[n*n];
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < n; j++)
        {
            if (i == j)
                set(i, j, 1.0);
            else
                set(i, j, 0);
        }
    }
}
Matrix::Matrix(const Matrix &M)
{
    colNum = M.colNum;
    rowNum = M.rowNum;
    item = new float[colNum*rowNum];
    for (int i = 0; i < colNum*rowNum; i++)
    {
        item[i] = M.item[i];
    }
}
Matrix& Matrix::operator=(const Matrix & M)
{
    colNum = M.colNum;
    rowNum = M.rowNum;
    if (item != nullptr) delete[] item;
    item = new float[colNum*rowNum];
    for (int i = 0; i < colNum*rowNum; i++)
    {
        item[i] = M.item[i];
    }
    return *this;
}

Matrix Matrix::FromFile(std::string file)
{
    ifstream read(file);
    if (!read.is_open())
    {
        // cout << "Matrix::未能打开文件\n";
    }
    int rows = 0;
    string line;
    vector<float> nums;
    while (getline(read, line))
    {
        istringstream record(line);
        float num = 0.0;
        while (record >> num)  nums.push_back(num);
        rows++;
    }
    return Matrix(&(*nums.begin()), rows, nums.size() / rows);
}

Matrix::~Matrix()
{
    delete[] item;
}
float Matrix::get(int i, int j) const
{
    return item[i*colNum + j];
}
void Matrix::set(int i, int j, float value)
{
    item[i*colNum + j] = value;
}
void Matrix::RowSwap(int i, int j, float multiply)
{
    if (j == -1)
    {
        for (int k = 0; k < colNum; k++)
        {
            set(i, k, multiply*get(i, k));
        }
    }
    else
    {
        for (int k = 0; k < colNum; k++)
        {
            set(j, k, multiply*get(i, k) + get(j, k));
        }
    }
}
void Matrix::RowSwap(int i, int j)
{
    Matrix _copy = *this;
    for (int k = 0; k < colNum; k++)
    {
        float swap = _copy.get(j, k);
        set(j, k, _copy.get(i, k));
        set(i, k, swap);
    }
}
Matrix Matrix::Trans() const
{
    Matrix _copy = *this;
    _copy.rowNum = this->colNum;
    _copy.colNum = this->rowNum;
    for (int i = 0; i < _copy.rowNum; i++)
    {
        for (int j = 0; j < _copy.colNum; j++)
        {
            _copy.set(i, j, get(j, i));
        }
    }
    return _copy;
}
int Matrix::getRowNum() const
{
    return rowNum;
}
int Matrix::getColNum() const
{
    return colNum;
}
/*ostream& operator <<(ostream &os, const Matrix &m)
{
    for (int i = 0; i < m.rowNum; i++)
    {
        for (int j = 0; j < m.colNum; j++)
            os << std::setw(10) << std::fixed << std::setprecision(12) << m.get(i, j) << " ";
        os << "\n";
    }
    os.flush();
    return os;
}*/
Matrix Matrix::operator +(const Matrix &m)
{
    if (m.colNum != colNum || m.rowNum != rowNum) return *this;
    Matrix _copy = *this;
    for (int i = 0; i < rowNum; i++)
    {
        for (int j = 0; j < colNum; j++)
        {
            _copy.set(i, j, get(i, j) + m.get(i, j));
        }
    }
    return _copy;
}
Matrix Matrix::operator -(const Matrix &m)
{
    if (m.colNum != colNum || m.rowNum != rowNum) return *this;
    Matrix _copy = *this;
    for (int i = 0; i < rowNum; i++)
    {
        for (int j = 0; j < colNum; j++)
        {
            _copy.set(i, j, get(i, j) - m.get(i, j));
        }
    }
    return _copy;
}
Matrix Matrix::operator *(const float f)
{
    Matrix _copy = *this;
    for (int i = 0; i < rowNum; i++)
    {
        for (int j = 0; j < colNum; j++)
        {
            _copy.set(i, j, get(i, j)*f);
        }
    }
    return _copy;
}
Matrix Matrix::operator *(const Matrix &m)
{
    if (colNum != m.rowNum)
    {
        // cout << "无法相乘！";
        return *this;
    }
    Matrix _copy(rowNum, m.getColNum());
    for (int i = 0; i < rowNum; i++)
    {
        for (int j = 0; j < m.colNum; j++)
        {
            float sum = 0;
            for (int k = 0; k < m.rowNum; k++)
            {
                sum += get(i, k)*m.get(k, j);
            }
            _copy.set(i, j, sum);
        }
    }
    return _copy;
}
Matrix Matrix::Inverse()
{
    Matrix _copy = *this;
    Matrix result(colNum);
    if (colNum != rowNum)
    {
        // cout << "矩阵不可逆！" << endl;
        return *this;
    }
    for (int i = 0; i < rowNum; i++)
    {
        int MaxRow = i;
        float max = abs(_copy.get(i, i));
        for (int j = i; j < colNum; j++)
        {
            if (abs(_copy.get(j, i))>max)
            {
                max = abs(_copy.get(j, i));
                MaxRow = j;
            }
        }
        if (MaxRow != i)
        {
            result.RowSwap(i, MaxRow);
            _copy.RowSwap(i, MaxRow);
        }
        float r = 1.0 / _copy.get(i, i);
        _copy.RowSwap(i, -1, r);
        result.RowSwap(i, -1, r);
        for (int j = 0; j < rowNum; j++)
        {
            if (j == i) continue;
            r = -_copy.get(j, i);
            _copy.RowSwap(i, j, r);
            result.RowSwap(i, j, r);
        }
    }
    //result.FlowOver();
    return result;
}
void Matrix::FlowOver()
{
    for (int i = 0; i < rowNum;i++)
    {
        for (int j = 0; j < colNum;j++)
        {
            if (abs(get(i, j)) <= OVERFLOWED) set(i, j, 0);
        }
    }
}
Matrix Matrix::operator <<(const std::vector<std::vector<float> > &m){
    if(m.size()<1){
        Matrix _nullMat(0,0);
        return _nullMat;
    }
    Matrix _copy(m.size(),m.front().size());
    for (decltype(m.size()) i = 0; i < m.size(); i++)
    {
        for (decltype(m.front().size()) j = 0; j < m.front().size(); j++)
        {
            _copy.set(i, j, m.at(i).at(j));
        }
    }
    // _copy.showMat();
    return _copy;
}
void Matrix::vector2matrix(const std::vector<std::vector<float> > &m){
    if(m.size()<1){
        Matrix _nullMat(0,0);
        *this = _nullMat;
    }
    Matrix _copy(m.size(),m.front().size());
    for (decltype(m.size()) i = 0; i < m.size(); i++)
    {
        for (decltype(m.front().size()) j = 0; j < m.front().size(); j++)
        {
            _copy.set(i, j, m.at(i).at(j));
        }
    }
    *this = _copy;
}
std::vector<std::vector<float> > Matrix::matrix2vector(){
    std::vector<std::vector<float> > resVector(this->getRowNum(),std::vector<float> (this->getColNum()));
    for (int i = 0; i < this->getRowNum(); i++)
    {
        for (int j = 0; j < this->getColNum(); j++)
        {
            resVector.at(i).at(j) = this->get(i,j);
        }
    }
    return resVector;
}
void Matrix::showMat() const{
    for (int i = 0; i < this->getRowNum(); i++)
    {
        for (int j = 0; j < this->getColNum(); j++)
        {
            std::cout<<this->get(i,j)<<" ";
        }
        std::cout<<std::endl;
    }

}


















void ObstaclePrediction::saveSurround(const RoadInfo &m_rm_msg){
    std::chrono::time_point<std::chrono::system_clock, std::chrono::nanoseconds> tp = 
        std::chrono::time_point_cast<std::chrono::nanoseconds>(std::chrono::system_clock::now());
    long double cur_t_ms=tp.time_since_epoch().count()/1E6;
    static long double last_t_ms=cur_t_ms;

    // obstacle
    float delta_t_rm = static_cast<float>((cur_t_ms-last_t_ms)/1E3);
    for(auto& obstacle_state:(*_obstacles_updated_inThisCycle))    {obstacle_state.second = false;}
    for(const auto &oneObject : m_rm_msg.object_list){
        saveObstacleHist(oneObject, delta_t_rm, _rate_angle*delta_t_rm, _velo_x*delta_t_rm, _velo_y*delta_t_rm);
        (*_obstacles_updated_inThisCycle)[oneObject.object_id] = true;
    }
    last_t_ms=cur_t_ms;
    clearLossedObstacle();

    // corridor
    saveCorridor(m_rm_msg);
}
void ObstaclePrediction::saveEgoVehicle(const dpc::VED4DPC &m_vse_msg){
    _rate_angle = m_vse_msg.Yawrate * 3.1415926 / 180.0f;
    _velo_x     = m_vse_msg.LongitudinalVelocity;
    _velo_y     = 0.0f;
    bool ips_velocity_existed = has_member_inStruct_vse_velocity_ips<dpc::VED4DPC>::value;
    #if ips_velocity_existed == true
    if(m_vse_msg.vse_velocity_ips.size() == 3){
        _velo_y = m_vse_msg.vse_velocity_ips.at(1);
    }
    #endif
    if(ips_velocity_existed){}
}
void ObstaclePrediction::saveObstacleHist(const Object &m_object, const float m_delta_t_rm, const float m_d_angle, const float m_d_x, const float m_d_y){
    if((*_obstacles_histCartesianTraj_timelist).count(m_object.object_id) != 0){
        // isValid = true;
        updateObstaclePos(m_object, m_d_angle, m_d_x, m_d_y);
        recordExistedObstaclePos(m_object, m_delta_t_rm);
        eraseFirstObstaclePos(m_object);
    }
    else{
        // isValid = false;
        recordNonexistedObstaclePos(m_object);
    }
    recordLastObstaclePos(m_object, m_delta_t_rm);
}
void ObstaclePrediction::recordNonexistedObstaclePos(const Object &m_object){
    S_obstacle_tral temp_obstacle;
    temp_obstacle.t_s = ObjectPredictionTNT::delta_t_input;
    temp_obstacle.x_m = m_object.relative_center_x;
    temp_obstacle.y_m = m_object.relative_center_y;
    temp_obstacle.vx_m = m_object.absolute_velocity_x;
    temp_obstacle.vy_m = m_object.absolute_velocity_y;
    (*_obstacles_histCartesianTraj_timelist)[m_object.object_id].clear();
    (*_obstacles_histCartesianTraj_timelist)[m_object.object_id].emplace_back(temp_obstacle);
}
void ObstaclePrediction::recordExistedObstaclePos(const Object &m_object, const float m_delta_t_rm){
    float cur_time = (*_obstacles_lastCartesianPos)[m_object.object_id].t_s + m_delta_t_rm;
    if(!(*_obstacles_histCartesianTraj_timelist)[m_object.object_id].empty()){
        if((cur_time-(*_obstacles_histCartesianTraj_timelist)[m_object.object_id].back().t_s)>(ObjectPredictionTNT::delta_t_input-0.001f)){  // push to _obstacles_histCartesianTraj_timelist
            S_obstacle_tral temp_obstacle;
            if((*_obstacles_lastCartesianPos)[m_object.object_id].t_s > (*_obstacles_histCartesianTraj_timelist)[m_object.object_id].back().t_s){
                temp_obstacle.t_s = (*_obstacles_histCartesianTraj_timelist)[m_object.object_id].back().t_s + ObjectPredictionTNT::delta_t_input;
                temp_obstacle.x_m = linearInterpolation(temp_obstacle.t_s, 
                                    {(*_obstacles_lastCartesianPos)[m_object.object_id].t_s, (*_obstacles_lastCartesianPos)[m_object.object_id].x_m}, 
                                    {cur_time, static_cast<float>(m_object.relative_center_x)});
                temp_obstacle.y_m = linearInterpolation(temp_obstacle.t_s, 
                                    {(*_obstacles_lastCartesianPos)[m_object.object_id].t_s, (*_obstacles_lastCartesianPos)[m_object.object_id].y_m}, 
                                    {cur_time, static_cast<float>(m_object.relative_center_y)});
            }
            else{
                temp_obstacle.t_s = (*_obstacles_histCartesianTraj_timelist)[m_object.object_id].back().t_s + ObjectPredictionTNT::delta_t_input;
                temp_obstacle.x_m = linearInterpolation(temp_obstacle.t_s, 
                                    {(*_obstacles_histCartesianTraj_timelist)[m_object.object_id].back().t_s, (*_obstacles_histCartesianTraj_timelist)[m_object.object_id].back().x_m}, 
                                    {cur_time, static_cast<float>(m_object.relative_center_x)});
                temp_obstacle.y_m = linearInterpolation(temp_obstacle.t_s, 
                                    {(*_obstacles_histCartesianTraj_timelist)[m_object.object_id].back().t_s, (*_obstacles_histCartesianTraj_timelist)[m_object.object_id].back().y_m}, 
                                    {cur_time, static_cast<float>(m_object.relative_center_y)});
            }
            temp_obstacle.vx_m = m_object.absolute_velocity_x;
            temp_obstacle.vy_m = m_object.absolute_velocity_y;
            (*_obstacles_histCartesianTraj_timelist)[m_object.object_id].emplace_back(temp_obstacle);
        }
        else{       // do not push to _obstacles_histCartesianTraj_timelist
        }
    }
    else{   // no trajectory in this obstacle
        recordNonexistedObstaclePos(m_object);
    }
}
void ObstaclePrediction::updateObstaclePos(const Object &m_object, const float m_d_angle, const float m_d_x, const float m_d_y){
    if((*_obstacles_histCartesianTraj_timelist).count(m_object.object_id) == 0) return;
    for(auto& pos:(*_obstacles_histCartesianTraj_timelist)[m_object.object_id]){// for one position
        float x_last = pos.x_m;
        float y_last = pos.y_m;
        pos.x_m = x_last * cos(-m_d_angle) - y_last * sin(-m_d_angle);
        pos.y_m = x_last * sin(-m_d_angle) + y_last * cos(-m_d_angle);
        pos.x_m = pos.x_m - m_d_x;
        pos.y_m = pos.y_m - m_d_y;
    }
}
void ObstaclePrediction::eraseFirstObstaclePos(const Object &m_object){
    if((*_obstacles_histCartesianTraj_timelist).count(m_object.object_id) == 0) return;
    decltype((*_obstacles_histCartesianTraj_timelist)[m_object.object_id].size()) n_len_traj = static_cast<decltype((*_obstacles_histCartesianTraj_timelist)[m_object.object_id].size())>(n_trajPoints_Cartesian);
    if((*_obstacles_histCartesianTraj_timelist)[m_object.object_id].size() > n_len_traj){          // need erase
        // pop_front
        while((*_obstacles_histCartesianTraj_timelist)[m_object.object_id].size() > n_len_traj){
            (*_obstacles_histCartesianTraj_timelist)[m_object.object_id].pop_front();
        }

        // decrease time
        float minuend_time = (*_obstacles_histCartesianTraj_timelist)[m_object.object_id].front().t_s - ObjectPredictionTNT::delta_t_input;
        for(auto& pos:(*_obstacles_histCartesianTraj_timelist)[m_object.object_id]){                   // for one position
            pos.t_s = pos.t_s - minuend_time;
        }
        (*_obstacles_lastCartesianPos)[m_object.object_id].t_s = (*_obstacles_lastCartesianPos)[m_object.object_id].t_s - minuend_time;
    }
}
void ObstaclePrediction::recordLastObstaclePos(const Object &m_object, const float m_delta_t_rm){
    if((*_obstacles_lastCartesianPos).count(m_object.object_id)==0){
        (*_obstacles_lastCartesianPos)[m_object.object_id].t_s = ObjectPredictionTNT::delta_t_input;
    }
    else{
        (*_obstacles_lastCartesianPos)[m_object.object_id].t_s = (*_obstacles_lastCartesianPos)[m_object.object_id].t_s + m_delta_t_rm;
    }
    (*_obstacles_lastCartesianPos)[m_object.object_id].x_m = static_cast<float>(m_object.relative_center_x);
    (*_obstacles_lastCartesianPos)[m_object.object_id].y_m = static_cast<float>(m_object.relative_center_y);
}
void ObstaclePrediction::clearLossedObstacle(){
    std::list<uint32_t> eraseObstacleID;
    for(const auto& obstacle_state:(*_obstacles_updated_inThisCycle)){
        if(obstacle_state.second == false){     // the obstacle is lossed in this cycle
            if(_obstacles_histCartesianTraj_timelist->count(obstacle_state.first) != 0)
            (*_obstacles_histCartesianTraj_timelist).erase(obstacle_state.first);
            if(_obstacles_lastCartesianPos->count(obstacle_state.first) != 0)
            (*_obstacles_lastCartesianPos).erase(obstacle_state.first);
            // if(_obstacles_updated_inThisCycle->count(obstacle_state.first) != 0)     // core dumped!
            // (*_obstacles_updated_inThisCycle).erase(obstacle_state.first);
            eraseObstacleID.emplace_back(obstacle_state.first);
        }
    }
    for(const auto& id:eraseObstacleID){
        if(_obstacles_updated_inThisCycle->count(id) != 0)
        (*_obstacles_updated_inThisCycle).erase(id);
    }
}
float ObstaclePrediction::linearInterpolation(const float x, const std::pair<float,float>& point1, const std::pair<float,float>& point2){
    if(fabs(point2.first-point1.first)<0.000001f) return 0.0f;
    return (point2.second-point1.second)*(x-point1.first)/(point2.first-point1.first)+point1.second;
}
float SVEstmd::linearInterpolation(const float x, const std::pair<float,float>& point1, const std::pair<float,float>& point2){
    if(fabs(point2.first-point1.first)<0.000001f) return 0.0f;
    return (point2.second-point1.second)*(x-point1.first)/(point2.first-point1.first)+point1.second;
}
void ObstaclePrediction::saveCorridor(const RoadInfo &m_rm_msg){
    (*_corridors_inLanes).clear();
    _c0_leftAndRight = std::make_pair(-9999.9f, 9999.9f);
    for(const auto& oneLane:m_rm_msg.lane_list){
        bool isFindFrontCorridor=false;
        bool isFindBackCorridor=false;
        Corridor front_corridor,back_corridor;
        for(const auto& oneCorridor:oneLane.corridor_list){
            if(oneCorridor.feature_tag == static_cast<decltype(oneCorridor.feature_tag)>(1)){       // lane follow
                front_corridor = oneCorridor;
                isFindFrontCorridor = true;
                break;
            }
        }
        if(!isFindFrontCorridor){
            for(const auto& oneCorridor:oneLane.corridor_list){
                if(oneCorridor.feature_tag == static_cast<decltype(oneCorridor.feature_tag)>(2)){   // car follow
                    front_corridor = oneCorridor;
                    isFindFrontCorridor = true;
                    break;
                }
            }
        }
        if(isFindFrontCorridor){
            front_corridor.reference_line.start_range = 0.0f;
            _c0_leftAndRight.first = std::max(_c0_leftAndRight.first, front_corridor.reference_line.c0);
            _c0_leftAndRight.second = std::min(_c0_leftAndRight.second, front_corridor.reference_line.c0);
        }

        for(const auto& oneCorridor:oneLane.back_corridor_list){
            if(oneCorridor.feature_tag == static_cast<decltype(oneCorridor.feature_tag)>(1)){       // lane follow
                back_corridor = oneCorridor;
                isFindBackCorridor = true;
                break;
            }
        }
        if(!isFindBackCorridor){
            for(const auto& oneCorridor:oneLane.back_corridor_list){
                if(oneCorridor.feature_tag == static_cast<decltype(oneCorridor.feature_tag)>(2)){   // car follow
                    back_corridor = oneCorridor;
                    isFindBackCorridor = true;
                    break;
                }
            }
        }
        if(isFindBackCorridor){back_corridor.reference_line.end_range = 0.0f;}

        std::list<Corridor> corridors_inOneLane;
        if(isFindFrontCorridor){
            if(isFindBackCorridor){
                corridors_inOneLane.emplace_back(back_corridor);
                corridors_inOneLane.emplace_back(front_corridor);
            }
            else{
                corridors_inOneLane.emplace_back(front_corridor);
            }
        }
        else{
            if(isFindBackCorridor){
                corridors_inOneLane.emplace_back(back_corridor);
            }
        }

        if(isFindFrontCorridor||isFindBackCorridor){    // insert to _corridors_inLanes from left to right
            std::list< std::list<Corridor> >::iterator it1 = _corridors_inLanes->begin();
            if(_corridors_inLanes->empty()){
                _corridors_inLanes->insert(it1, corridors_inOneLane);
            }
            else if(_corridors_inLanes->size() == 1){
                float c0_it1 = calculateYPolynomial(*it1, 0.0f);
                float c0_this = calculateYPolynomial(corridors_inOneLane, 0.0f);
                if(c0_this>c0_it1){
                    _corridors_inLanes->emplace_front(corridors_inOneLane);
                }
                else{
                    _corridors_inLanes->emplace_back(corridors_inOneLane);
                }
            }
            else{
                std::list< std::list<Corridor> >::iterator it2 = it1;
                while(_corridors_inLanes->size() > 1){
                    it2++;
                    if(it2 == _corridors_inLanes->end()) break;
                    float c0_it1 = calculateYPolynomial(*it1, 0.0f);
                    float c0_it2 = calculateYPolynomial(*it2, 0.0f);
                    float c0_this = calculateYPolynomial(corridors_inOneLane, 0.0f);
                    if((c0_this<=c0_it1) && (c0_this>c0_it2)){
                        _corridors_inLanes->insert(it2, corridors_inOneLane);   // left to right
                        break;
                    }
                    it1++;
                }
                if(it2 == _corridors_inLanes->end()){
                    _corridors_inLanes->insert(it2, corridors_inOneLane);
                }
            }
        }
    }

    // extend   from left to right
    float k_front_leftGradient = 9999.9f, k_back_leftGradient = -9999.9f;
    float multipe_extend = 5.0f;
    for(auto& corridors_inOneLane:(*_corridors_inLanes)){
        if(corridors_inOneLane.empty()) continue;
        Corridor ext_back_cor = linearExtendCorridor(corridors_inOneLane.front(), -x_max_objectNeedPredict*multipe_extend, corridors_inOneLane.front().reference_line.start_range, k_back_leftGradient);
        corridors_inOneLane.push_front(ext_back_cor);   // back corridor
        Corridor ext_front_cor = linearExtendCorridor(corridors_inOneLane.back(), corridors_inOneLane.back().reference_line.end_range, x_max_objectNeedPredict*multipe_extend, k_front_leftGradient);
        corridors_inOneLane.push_back(ext_front_cor);   // front corridor
        k_front_leftGradient = ext_front_cor.reference_line.c1;
        k_back_leftGradient = ext_back_cor.reference_line.c1;
    }
}
Corridor ObstaclePrediction::linearExtendCorridor(const Corridor &m_corridor, const float m_startRange, float m_endRange, float m_leftGradient){

    Corridor ext_corridor_ptr;
    if(m_startRange>m_endRange) m_endRange=m_startRange+1.0f;

    Corridor ext_corridor;
    ext_corridor.corridor_id = m_corridor.corridor_id;
    if(m_endRange<(m_corridor.reference_line.start_range+1.0f)){     // extend to back
        if(std::isnan(m_leftGradient)) m_leftGradient=-9999.9f;
        float x1 = m_corridor.reference_line.start_range;
        float y1 = calculateYPolynomial(m_corridor, x1);
        // float x2 = m_corridor.reference_line.start_range + std::max(
        //                 std::min(m_corridor.reference_line.end_range-m_corridor.reference_line.start_range,1.0f),0.001f);
        // float y2 = calculateYPolynomial(m_corridor, x2);
        ext_corridor.reference_line.start_range = m_startRange;
        ext_corridor.reference_line.end_range = m_endRange;
        // ext_corridor.reference_line.c1 = (y2-y1)/(x2-x1);
        ext_corridor.reference_line.c1 = m_corridor.reference_line.c1
                                + 2.0f * m_corridor.reference_line.c2 * x1
                                + 3.0f * m_corridor.reference_line.c3 * x1 * x1;
        ext_corridor.reference_line.c1 = std::max(ext_corridor.reference_line.c1, m_leftGradient);
        ext_corridor.reference_line.c0 = y1 - ext_corridor.reference_line.c1 * x1;
        ext_corridor.reference_line.c2 = 0.0f;
        ext_corridor.reference_line.c3 = 0.0f;
        ext_corridor_ptr = ext_corridor;
    }
    if(m_startRange>(m_corridor.reference_line.end_range-1.0f)){    // extend to front
        if(std::isnan(m_leftGradient)) m_leftGradient=9999.9f;
        float x1 = m_corridor.reference_line.end_range;
        float y1 = calculateYPolynomial(m_corridor, x1);
        // float x2 = m_corridor.reference_line.end_range - std::max(
        //                 std::min(m_corridor.reference_line.end_range-m_corridor.reference_line.start_range,1.0f),0.001f);
        // float y2 = calculateYPolynomial(m_corridor, x2);
        ext_corridor.reference_line.start_range = m_startRange;
        ext_corridor.reference_line.end_range = m_endRange;
        // ext_corridor.reference_line.c1 = (y2-y1)/(x2-x1);
        ext_corridor.reference_line.c1 = m_corridor.reference_line.c1
                                + 2.0f * m_corridor.reference_line.c2 * x1
                                + 3.0f * m_corridor.reference_line.c3 * x1 * x1;
        ext_corridor.reference_line.c1 = std::min(ext_corridor.reference_line.c1, m_leftGradient);
        ext_corridor.reference_line.c0 = y1 - ext_corridor.reference_line.c1 * x1;
        ext_corridor.reference_line.c2 = 0.0f;
        ext_corridor.reference_line.c3 = 0.0f;
        ext_corridor_ptr = ext_corridor;
    }

    return ext_corridor_ptr;
}
void ObstaclePrediction::calculateFrenetTraj(){
    _obstacles_histFrenetTraj_forward->clear();
    for(const auto& obs:(*_obstacles_histCartesianTraj_timelist)){
        if(obs.second.size() != static_cast<decltype(obs.second.size())>(n_trajPoints_Cartesian)) continue; // not 20 history points
        if(fabs(obs.second.back().x_m)>x_max_objectNeedPredict) continue; // x is far
        if(fabs(obs.second.back().y_m)>y_min_objectNeedPredict) continue; // y is far
        if(_corridors_inLanes->empty()) return; // no corridor, do not translate any obstacle

        std::list<Corridor> referenceCorridors = findNearestCorridors(obs.second.back());
        std::vector<std::vector<float> > trajVector;
        std::vector<float> trajPos;
        int n_calculateFrenet_orNot = 0;// only use five points 0 5 10 15 19
        for(const auto& pos:obs.second){
            if(n_calculateFrenet_orNot==0 || n_calculateFrenet_orNot==5 || n_calculateFrenet_orNot==10 || n_calculateFrenet_orNot==15 || n_calculateFrenet_orNot==19){// only use five points 0 5 10 15 19
                trajPos = CartesianToFrenet(referenceCorridors, pos.x_m, pos.y_m);
                trajVector.emplace_back(trajPos);
            }
            n_calculateFrenet_orNot +=1;// only use five points 0 5 10 15 19
        }
        fitterFrenetHistTraj(trajVector);
        _obstacles_histFrenetTraj_forward->insert(std::make_pair(obs.first,std::make_pair(referenceCorridors,trajVector)));
    }


}
std::list<Corridor> ObstaclePrediction::findNearestCorridors(const S_obstacle_tral& m_obstacle_point){
    std::list<Corridor> nearest_corridors;
    float nearestDis = 9999.9f;
    for(const auto& corridors_inOneLane:(*_corridors_inLanes)){
        float delta_y_dis = fabs(calculateYPolynomial(corridors_inOneLane, m_obstacle_point.x_m) - m_obstacle_point.y_m);
        if(delta_y_dis<nearestDis){
            nearest_corridors = corridors_inOneLane;
            nearestDis = delta_y_dis;
        }
    }
    return nearest_corridors;
}
std::vector<float> ObstaclePrediction::CartesianToFrenet(const std::list<Corridor>& m_corridor_list, const float m_x, const float m_y){
    std::vector<float> trajPos(2);
    float k_s = 1.0f;
    float k_l = 1.0f;

    float refer_x0 = m_x;
    float refer_x1 = refer_x0 + 0.1f;
    findReferPointNewtonMethod(refer_x0, refer_x1, m_x, m_y, m_corridor_list);

    if(refer_x0<0.0f) k_s = -1.0f;
    if(m_y<calculateYPolynomial(m_corridor_list, refer_x0)) k_l = -1.0f;

    trajPos.at(0) = k_s * calculateArcLengthAbs(m_corridor_list, refer_x0);       // s
    trajPos.at(1) = k_l * calculateDisBetweenPoints({m_x,m_y},{refer_x0,calculateYPolynomial(m_corridor_list, refer_x0)});    // l

    return trajPos;
}
float ObstaclePrediction::calculateYPolynomial(const Corridor& m_corridor, const float x){
    float y = m_corridor.reference_line.c0 + 
                m_corridor.reference_line.c1 * x + 
                m_corridor.reference_line.c2 * x * x + 
                m_corridor.reference_line.c3 * x * x * x;
    return y;
}
float ObstaclePrediction::calculateYPolynomial(const std::list<Corridor>& m_corridors, const float x){
    if(m_corridors.empty()) return 9999.9f;
    Corridor cor;
    if(x<m_corridors.front().reference_line.start_range){
        cor =m_corridors.front();
    } 
    else{
        if(x>m_corridors.back().reference_line.end_range){
            cor=m_corridors.back();
        }
        else{
            for(const auto& oneCorridor:(m_corridors)){
                if((x>oneCorridor.reference_line.start_range-(1E-3))&&(x<oneCorridor.reference_line.end_range+(1E-3))){
                    cor = oneCorridor;
                    break;
                }
            }        
        }
    }
    return calculateYPolynomial(cor, x);
}
float ObstaclePrediction::calculateDisBetweenPoints(const std::pair<float,float>& point1, const std::pair<float,float>& point2){
    return pow((point1.first-point2.first)*(point1.first-point2.first) + 
                (point1.second-point2.second)*(point1.second-point2.second),0.5);
}
void ObstaclePrediction::findReferPointNewtonMethod(float& refer_x0, float& refer_x1, const float m_x, const float m_y, 
                        const std::list<Corridor>& m_corridors,
                        const float step_x, const float accuracy_diff, const int cycleNum){
    int count = 0;

    // float dis_x_left = calculateDisBetweenPoints({m_x,m_y},{refer_x0-step_x,calculateYPolynomial(m_corridors, refer_x0-step_x)});
    float dis_x_midd = calculateDisBetweenPoints({m_x,m_y},{refer_x0,calculateYPolynomial(m_corridors, refer_x0)});
    float dis_x_right = calculateDisBetweenPoints({m_x,m_y},{refer_x0+step_x,calculateYPolynomial(m_corridors, refer_x0+step_x)});
    float diff_x = (dis_x_right - dis_x_midd)/step_x;

    while(fabs(diff_x)>accuracy_diff){
        if(count>cycleNum) break;

        // dis_x_left = calculateDisBetweenPoints({m_x,m_y},{refer_x0-step_x,calculateYPolynomial(m_corridors, refer_x0-step_x)});
        dis_x_midd = calculateDisBetweenPoints({m_x,m_y},{refer_x0,calculateYPolynomial(m_corridors, refer_x0)});
        dis_x_right = calculateDisBetweenPoints({m_x,m_y},{refer_x0+step_x,calculateYPolynomial(m_corridors, refer_x0+step_x)});
        diff_x = (dis_x_right - dis_x_midd)/step_x;
        // float diff2_x = (dis_x_left + dis_x_right - 2.0f * dis_x_midd) / step_x / step_x;
        // if(fabs(diff2_x)<1E-6) break;//diff2_x=1E-3;
        // if(fabs(diff_x)<1E-2) {
        //     refer_x1 = 0.5f*(refer_x0+refer_x1);
        //     refer_x0 = refer_x1*2.0f-refer_x0;
        // }
        // else{
            refer_x0 = refer_x1;
            // refer_x1 = refer_x1 - diff_x/diff2_x;   //Newton's Method
            refer_x1 = refer_x1 - 0.07f*diff_x;   //modified Newton's Method
        // }
        count++;
    }
}
float ObstaclePrediction::calculateArcLengthAbs(const std::list<Corridor>& m_corridors, const float refer_x){
    float s_referPoint = 0.0f;
    if(refer_x>0.0f){   // front
        for(auto it = m_corridors.begin(); it != m_corridors.end(); ++it){
            if(it->reference_line.start_range>-0.1f){       //front
                if(refer_x < it->reference_line.end_range){ // in this corridor
                    s_referPoint = s_referPoint + calculateArcIntegralSimpsonMethod(*it,refer_x);
                    break;
                }
                else{
                    s_referPoint = s_referPoint + calculateArcIntegralSimpsonMethod(*it,it->reference_line.end_range);
                }
            }
        }
    }
    else{               // back
        for(auto it = m_corridors.rbegin(); it != m_corridors.rend(); ++it){
            if(it->reference_line.end_range<0.1f){              // back
                if(refer_x > it->reference_line.start_range){   // in this corridor
                    s_referPoint = s_referPoint + calculateArcIntegralSimpsonMethod(*it,refer_x);
                    break;
                }
                else{
                    s_referPoint = s_referPoint + calculateArcIntegralSimpsonMethod(*it,it->reference_line.start_range);
                }
            }
        }
    }
    return s_referPoint;
}
float ObstaclePrediction::calculateArcIntegralSimpsonMethod(const Corridor& m_corridor, const float refer_x){
    
    float arcStart = 0.0f;
    float arcEnd = 0.0f;
    if(m_corridor.reference_line.start_range<-0.1f){  // back
        arcStart = refer_x;
        arcEnd = m_corridor.reference_line.end_range;
    }
    else{   // front
        arcStart = m_corridor.reference_line.start_range;
        arcEnd = refer_x;
    }

    if(arcEnd<=arcStart) return 0.0f;
    // Simpson Method
    return (arcEnd-arcStart)/6.0f*(calculateDeltaArc(m_corridor,arcStart) + 
                4.0f*calculateDeltaArc(m_corridor,0.5*(arcStart+arcEnd)) + calculateDeltaArc(m_corridor,arcEnd));
}
float ObstaclePrediction::calculateDeltaArc(const Corridor& m_corridor, const float point_x){
    float gradient = m_corridor.reference_line.c1 + 
                    2.0f * m_corridor.reference_line.c2 * point_x + 
                    3.0f * m_corridor.reference_line.c3 * point_x * point_x;
    return pow(1+pow(gradient,2),0.5);    
}
void ObstaclePrediction::fitterFrenetHistTraj(std::vector<std::vector<float> > &m_trajVector){

    if(m_trajVector.size() != static_cast<decltype(m_trajVector.size())>(n_trajPoints_Frenet)) return;
    if(m_trajVector.front().size() != static_cast<decltype(m_trajVector.front().size())>(2)) return;

    // 20220715 only keep the l of 0 5 10 15 19, others are linear interpolated
    // 20220729 only calculate five points the l of 0 5 10 15 19, others do not join forward spread
    #if 0
    for(decltype(m_trajVector.size()) i=0; i<m_trajVector.size(); i++){
        if(i == 0) continue;
        if(i == 5) continue;
        if(i == 10) continue;
        if(i == 15) continue;
        if(i == 19) break;

        std::array<float, 5> keepPoints{0.0f, 5.0f, 10.0f, 15.0f, 19.0f};
        decltype(m_trajVector.size()) left_keep_key,right_keep_key;
        float left_keep_key_float,right_keep_key_float;
        float i_float = static_cast<float>(i);
        for(decltype(keepPoints.size()) j=0; j< keepPoints.size()-1; j++){
            if((i_float>keepPoints.at(j)) && (i_float<keepPoints.at(j+1))){
                left_keep_key_float = keepPoints.at(j);
                right_keep_key_float = keepPoints.at(j+1);
                left_keep_key = static_cast<decltype(m_trajVector.size())>(left_keep_key_float);
                right_keep_key = static_cast<decltype(m_trajVector.size())>(right_keep_key_float);
                break;
            }
        }
        if((right_keep_key_float - left_keep_key_float) > 0.5f)
        m_trajVector.at(i).back() = linearInterpolation(i_float,
                                    {left_keep_key_float,m_trajVector.at(left_keep_key).back()},
                                    {right_keep_key_float,m_trajVector.at(right_keep_key).back()});
    }
    /*{   // 20220720   set l as same value if the difference of l is small
        // 20220721   close because it causes predict to be late
        float l_hist_max = -9999.9f, l_hist_min = 9999.9f;
        std::list<int> keepList = {0, 5, 10, 15, 19};
        float totalKeep = 0.0f;
        for(auto it = keepList.begin(); it!=keepList.end(); it++){
            l_hist_max = std::max(l_hist_max, m_trajVector.at(*it).back());
            l_hist_min = std::min(l_hist_min, m_trajVector.at(*it).back());
            totalKeep = totalKeep + m_trajVector.at(*it).back();
        }
        if(fabs(l_hist_max-l_hist_min) < 0.65f){
            for(auto it = keepList.begin(); it!=keepList.end(); it++){
                m_trajVector.at(*it).back() = totalKeep/static_cast<float>(keepList.size());
            }
        }
    }*/
    // #endif   // 20220729 only calculate five points the l of 0 5 10 15 19, others do not join forward spread
    m_trajVector.at(1).back() = linearInterpolation(1.0f, {0.0f,m_trajVector.at(0).back()}, {5.0f,m_trajVector.at(5).back()});
    m_trajVector.at(2).back() = linearInterpolation(2.0f, {0.0f,m_trajVector.at(0).back()}, {5.0f,m_trajVector.at(5).back()});
    m_trajVector.at(3).back() = linearInterpolation(3.0f, {0.0f,m_trajVector.at(0).back()}, {5.0f,m_trajVector.at(5).back()});
    m_trajVector.at(4).back() = linearInterpolation(4.0f, {0.0f,m_trajVector.at(0).back()}, {5.0f,m_trajVector.at(5).back()});
    m_trajVector.at(6).back() = linearInterpolation(6.0f, {5.0f,m_trajVector.at(5).back()}, {10.0f,m_trajVector.at(10).back()});
    m_trajVector.at(7).back() = linearInterpolation(7.0f, {5.0f,m_trajVector.at(5).back()}, {10.0f,m_trajVector.at(10).back()});
    m_trajVector.at(8).back() = linearInterpolation(8.0f, {5.0f,m_trajVector.at(5).back()}, {10.0f,m_trajVector.at(10).back()});
    m_trajVector.at(9).back() = linearInterpolation(9.0f, {5.0f,m_trajVector.at(5).back()}, {10.0f,m_trajVector.at(10).back()});
    m_trajVector.at(11).back() = linearInterpolation(11.0f, {10.0f,m_trajVector.at(10).back()}, {15.0f,m_trajVector.at(15).back()});
    m_trajVector.at(12).back() = linearInterpolation(12.0f, {10.0f,m_trajVector.at(10).back()}, {15.0f,m_trajVector.at(15).back()});
    m_trajVector.at(13).back() = linearInterpolation(13.0f, {10.0f,m_trajVector.at(10).back()}, {15.0f,m_trajVector.at(15).back()});
    m_trajVector.at(14).back() = linearInterpolation(14.0f, {10.0f,m_trajVector.at(10).back()}, {15.0f,m_trajVector.at(15).back()});
    m_trajVector.at(16).back() = linearInterpolation(16.0f, {15.0f,m_trajVector.at(15).back()}, {19.0f,m_trajVector.at(19).back()});
    m_trajVector.at(17).back() = linearInterpolation(17.0f, {15.0f,m_trajVector.at(15).back()}, {19.0f,m_trajVector.at(19).back()});
    m_trajVector.at(18).back() = linearInterpolation(18.0f, {15.0f,m_trajVector.at(15).back()}, {19.0f,m_trajVector.at(19).back()});
    #endif
    return;

    // find the most outrageous points
    std::map<decltype(m_trajVector.size()), float> pointMap_outrag;
    float l_average = 0.0f;
    for(decltype(m_trajVector.size()) i = 0; i<m_trajVector.size(); i++){
        l_average = l_average + m_trajVector.at(i).back();
    }
    l_average = l_average / static_cast<float>(m_trajVector.size());
    float dis_limit = 2.5f;   // calibration
    for(decltype(m_trajVector.size()) i = 0; i<m_trajVector.size(); i++){
        float delta_l = fabs(m_trajVector.at(i).back()-l_average);
        if(delta_l > dis_limit){
            pointMap_outrag[i] = delta_l;
        }
    }

    // linear interpolation
    if(pointMap_outrag.size() <= 3){
        for(const auto& point_outrag:pointMap_outrag){
            decltype(m_trajVector.size()) point1_nearestReasonable=9999, point2_nearestReasonable=9999;
            {
                for(decltype(m_trajVector.size()) i=point_outrag.first-1; i>=0; i--){
                    if(i>point_outrag.first-1)break;
                    if(pointMap_outrag.count(i) == 0){
                        point1_nearestReasonable = i;
                        break;
                    }
                    if(i==0)break;
                }
                if(point1_nearestReasonable>m_trajVector.size()-1){
                    for(decltype(m_trajVector.size()) i=point_outrag.first+1; i<m_trajVector.size(); i++){
                        if(pointMap_outrag.count(i) == 0){
                            point1_nearestReasonable = i;
                            break;
                        }
                    }
                }
                for(decltype(m_trajVector.size()) i=point_outrag.first+1; i<m_trajVector.size(); i++){
                    if((pointMap_outrag.count(i) == 0) && (i!=point1_nearestReasonable)){
                        point2_nearestReasonable = i;
                        break;
                    }
                }
                if(point2_nearestReasonable>m_trajVector.size()-1){
                    for(decltype(m_trajVector.size()) i=point_outrag.first-1; i>=0; i--){
                        if(i>point_outrag.first-1)break;
                        if((pointMap_outrag.count(i) == 0) && (i!=point1_nearestReasonable)){
                            point2_nearestReasonable = i;
                            break;
                        }
                        if(i==0)break;
                    }
                }
                point1_nearestReasonable = std::min(point1_nearestReasonable, m_trajVector.size()-1);
                point1_nearestReasonable = std::max(point1_nearestReasonable, static_cast<decltype(m_trajVector.size())>(0));
                point2_nearestReasonable = std::min(point1_nearestReasonable, m_trajVector.size()-1);
                point2_nearestReasonable = std::max(point1_nearestReasonable, static_cast<decltype(m_trajVector.size())>(0));
            }
            if(point1_nearestReasonable != point2_nearestReasonable){
                m_trajVector.at(point_outrag.first).front() = linearInterpolation(
                        static_cast<float>(point_outrag.first),
                        {static_cast<float>(point1_nearestReasonable), m_trajVector.at(point1_nearestReasonable).front()},
                        {static_cast<float>(point2_nearestReasonable), m_trajVector.at(point2_nearestReasonable).front()});
                m_trajVector.at(point_outrag.first).back() = linearInterpolation(
                        static_cast<float>(point_outrag.first),
                        {static_cast<float>(point1_nearestReasonable), m_trajVector.at(point1_nearestReasonable).back()},
                        {static_cast<float>(point2_nearestReasonable), m_trajVector.at(point2_nearestReasonable).back()});
            }
        }
    }
    // low pass filter
    else{   
        float velo_s = (m_trajVector.back().front() - m_trajVector.front().front())/static_cast<float>(m_trajVector.size()-1);
        float velo_l_limit = 1.5f;
        for(decltype(m_trajVector.size()) i = m_trajVector.size()-2; i>=0; i--){
            if(i>m_trajVector.size()-2)break;
            m_trajVector.at(i).front() = m_trajVector.at(i+1).front() - velo_s * 0.1f;
            m_trajVector.at(i).back() = std::min(m_trajVector.at(i).back(),m_trajVector.at(i+1).back() + velo_l_limit * 0.1f);
            m_trajVector.at(i).back() = std::max(m_trajVector.at(i).back(),m_trajVector.at(i+1).back() - velo_l_limit * 0.1f);
            if(i==0)break;
        }
    }
}
void ObstaclePrediction::restrictPredictL(){

    std::set< uint32_t > obstacles_prediction_inThisCycle;
    for(auto& obj:(*_obstacles_predictionTraj)){
        if(_obstacles_histFrenetTraj_forward->count(obj.first)==0) continue;
        // 20220715 avoid out of road
        if(_c0_leftAndRight.first > _c0_leftAndRight.second){
            float delta_l = calculateYPolynomial((*_obstacles_histFrenetTraj_forward)[obj.first].first,0.0f);
            for(auto&posFrenet:obj.second){
                for(decltype(posFrenet.size()) i=1; i<posFrenet.size(); i=i+2){
                    posFrenet.at(i) = std::min(posFrenet.at(i), _c0_leftAndRight.first - delta_l + 1.5f);
                    posFrenet.at(i) = std::max(posFrenet.at(i), _c0_leftAndRight.second - delta_l - 1.5f);
                }
            }
        }

        // 20220718 limit L combined with history intention    // 0:lane_follow   1:left_lane_change   2:right_lane_change
        // const float l_laneChange = 2.0f;   // 20220718 too large so too late for lane_change
        constexpr float l_laneChange = 1.2f;    // 20220720
        constexpr std::array<float, 20> l_limit_to_numIntention{0.5f, 1.0f, 1.5f, 2.0f, 2.5f, 3.0f, 3.5f, 4.0f, 4.5f, 5.0f, 
                                                            5.5f, 6.0f, 6.5f, 7.0f, 7.5f, 8.0f, 8.5f, 9.0f, 9.5f, 10.0f};
        if(obj.second.empty() || static_cast<int>(obj.second.size()) > n_intentionNumber) continue;    // only available for one or some intention
        if(obj.second.front().size() != 12) continue;   // only use the first/max intention as current intention
        int obj_intention = 0;
        if(obj.second.front().at(11) > l_laneChange) obj_intention = 1;  // left lane change
        else if(obj.second.front().at(11) < -1.0f*l_laneChange) obj_intention = 2;   // right lane change
        for(auto& objTraj_oneIntention : obj.second){
            if(obj_intention==0){
                for(decltype(objTraj_oneIntention.size()) i=1; i<objTraj_oneIntention.size(); i=i+2){
                    objTraj_oneIntention.at(i) = std::min(objTraj_oneIntention.at(i), 1.0f);
                    objTraj_oneIntention.at(i) = std::max(objTraj_oneIntention.at(i), -1.0f);
                }
            }
            if(_obstacles_predictionHistoryIntention->count(obj.first) == 0){
                for(decltype(objTraj_oneIntention.size()) i=1; i<objTraj_oneIntention.size(); i=i+2){
                    objTraj_oneIntention.at(i) = std::min(objTraj_oneIntention.at(i), l_limit_to_numIntention.at(0));
                    objTraj_oneIntention.at(i) = std::max(objTraj_oneIntention.at(i), -1.0f*l_limit_to_numIntention.at(0));
                }
            }
            else{
                int num_sameIntention = 0;
                for(auto it = (*_obstacles_predictionHistoryIntention)[obj.first].rbegin(); it != (*_obstacles_predictionHistoryIntention)[obj.first].rend(); ++it){
                    if((*it) == obj_intention)
                        num_sameIntention = num_sameIntention + 1;
                    else
                        break;
                }
                num_sameIntention = std::max(num_sameIntention, 0);
                num_sameIntention = std::min(num_sameIntention, static_cast<int>(l_limit_to_numIntention.size()-1));
                if(obj_intention == 1){
                    for(decltype(objTraj_oneIntention.size()) i=1; i<objTraj_oneIntention.size(); i=i+2){
                        objTraj_oneIntention.at(i) = std::min(objTraj_oneIntention.at(i), l_limit_to_numIntention.at(num_sameIntention));
                    }
                }
                else if(obj_intention==2){
                    for(decltype(objTraj_oneIntention.size()) i=1; i<objTraj_oneIntention.size(); i=i+2){
                        objTraj_oneIntention.at(i) = std::max(objTraj_oneIntention.at(i), -1.0f*l_limit_to_numIntention.at(num_sameIntention));
                    }
                }
            }
        }
        if(_obstacles_predictionHistoryIntention->count(obj.first) == 0){
            (*_obstacles_predictionHistoryIntention)[obj.first].push_back(obj_intention);
        }
        else{
            (*_obstacles_predictionHistoryIntention)[obj.first].push_back(obj_intention);
            while((*_obstacles_predictionHistoryIntention)[obj.first].size()>l_limit_to_numIntention.size()){
                (*_obstacles_predictionHistoryIntention)[obj.first].pop_front();
            }
        }
        obstacles_prediction_inThisCycle.insert(obj.first);

        // 20220719 limit L combined with current position
        const std::list<float> l_current_lLimitToCurrentPos  {-1.0f, -0.5f, -0.25f, -0.2f, -0.1f, 0.0f, 0.2f};
        const std::list<float> l_limit_lLimitToCurrentPos    {0.1f, 0.25f, 0.5f, 0.7f, 1.4f, 2.5f, 7.0f};
        if((*_obstacles_histFrenetTraj_forward)[obj.first].second.empty()) continue;
        if((*_obstacles_histFrenetTraj_forward)[obj.first].second.back().empty()) continue;
        float l_current = (*_obstacles_histFrenetTraj_forward)[obj.first].second.back().back();
        for(auto& objTraj_oneIntention : obj.second){
            if(obj_intention==1){
                float l_leftLimit = linearLookupTable(l_current, l_current_lLimitToCurrentPos, l_limit_lLimitToCurrentPos);
                for(decltype(objTraj_oneIntention.size()) i=1; i<objTraj_oneIntention.size(); i=i+2){
                    objTraj_oneIntention.at(i) = std::min(objTraj_oneIntention.at(i), l_leftLimit);
                }
            }
            else if(obj_intention==2){
                float l_rightLimit = -1.0f * linearLookupTable(-1.0f*l_current, l_current_lLimitToCurrentPos, l_limit_lLimitToCurrentPos);
                for(decltype(objTraj_oneIntention.size()) i=1; i<objTraj_oneIntention.size(); i=i+2){
                    objTraj_oneIntention.at(i) = std::max(objTraj_oneIntention.at(i), l_rightLimit);
                }
            }
        }

        // 20220720 smooth based on vehicle kinematics
        constexpr float c_max_vl = 1.0f;    constexpr float c_min_vl = -1.0f;
        for(auto& objTraj_oneIntention : obj.second){
            objTraj_oneIntention.at(1) = std::min(objTraj_oneIntention.at(1), l_current + c_max_vl*ObjectPredictionTNT::delta_t_output);
            objTraj_oneIntention.at(1) = std::max(objTraj_oneIntention.at(1), l_current + c_min_vl*ObjectPredictionTNT::delta_t_output);
            for(decltype(objTraj_oneIntention.size()) i=3; i<objTraj_oneIntention.size(); i=i+2){
                objTraj_oneIntention.at(i) = std::min(objTraj_oneIntention.at(i), objTraj_oneIntention.at(i-2) + c_max_vl*ObjectPredictionTNT::delta_t_output);
                objTraj_oneIntention.at(i) = std::max(objTraj_oneIntention.at(i), objTraj_oneIntention.at(i-2) + c_min_vl*ObjectPredictionTNT::delta_t_output);
            }
        }
    }
    std::list<uint32_t> eraseObstacleID;     // erase object not predicted in this cycle
    for(const auto& ob:(*_obstacles_predictionHistoryIntention)){
        if(obstacles_prediction_inThisCycle.count(ob.first)==0){
            eraseObstacleID.push_back(ob.first);
        }
    }
    for(const auto& id:eraseObstacleID){
        if(_obstacles_predictionHistoryIntention->count(id) != 0)
        _obstacles_predictionHistoryIntention->erase(id);
    }
}
float ObstaclePrediction::linearLookupTable(const float x, const std::list<float>& table_x, const std::list<float>& table_y){
    float x_temp = x;
    float y = 0.0f;
    if(table_x.size()<2) return y;
    if(table_y.size() != table_x.size()) return y;
    x_temp = std::max(x_temp, table_x.front()+0.001f);
    x_temp = std::min(x_temp, table_x.back()-0.001f);
    auto it_x = table_x.begin();
    auto it_y = table_y.begin();
    auto it_xTemp = it_x;
    auto it_yTemp = it_y;
    for(;it_x!=table_x.end();){
        it_xTemp = it_x;
        it_yTemp = it_y;
        it_x++;it_y++;
        if(x_temp<*it_x){
            y = linearInterpolation(x_temp, {*it_xTemp, *it_yTemp},{*it_x, *it_y});
            return y;
        }
    }
    it_xTemp--;it_yTemp--;it_x--;it_y--;
    y = linearInterpolation(x_temp, {*it_xTemp, *it_yTemp},{*it_x, *it_y});
    return y;
}


void ObstaclePrediction::translateLToEgo(){
    _obstacles_predictionTraj_toEgo->clear();
    for(const auto& obj:(*_obstacles_predictionTraj)){
        if(_obstacles_histFrenetTraj_forward->count(obj.first)==0) continue;
        std::vector<std::vector<float>> predictionTraj_thisObject_toEgo = obj.second;
        if(predictionTraj_thisObject_toEgo.empty()) continue;
        for(auto it = predictionTraj_thisObject_toEgo.begin(); it != predictionTraj_thisObject_toEgo.end(); ){
            if(it->size() != 12){
                predictionTraj_thisObject_toEgo.erase(it);
            }
            else{
                it++;
            }
        }
        for(auto& traj_oneIntention:predictionTraj_thisObject_toEgo){
            for(int i=1; i<traj_oneIntention.size(); i=i+2){
                traj_oneIntention.at(i) = traj_oneIntention.at(i) + calculateYPolynomial(
                            (*_obstacles_histFrenetTraj_forward)[obj.first].first,traj_oneIntention.at(i-1));
            }
        }
        _obstacles_predictionTraj_toEgo->insert(std::make_pair( obj.first, predictionTraj_thisObject_toEgo));
    }
}




void ObstaclePrediction::predictTrajectory(){
    _obstacles_predictionTraj->clear();
    _obstacles_predictionTraj_toEgo->clear();
    for(const auto& obj:(*_obstacles_histFrenetTraj_forward)){
        if( _obstacles_histCartesianTraj_timelist->count(obj.first) == 0 ) continue;
        if( (*_obstacles_histCartesianTraj_timelist)[obj.first].size() != 
                static_cast<decltype((*_obstacles_histCartesianTraj_timelist)[obj.first].size())>(n_trajPoints_Cartesian) ) continue;
        float vx = (*_obstacles_histCartesianTraj_timelist)[obj.first].back().vx_m;
        float vy = (*_obstacles_histCartesianTraj_timelist)[obj.first].back().vy_m;
        float v_xy = pow(vx*vx+vy*vy,0.5f);
        if(v_xy > vx_highway_objectNeedPredict*1.1f){       // use highway model
            _tntHighway->getHistoryTraj(obj.second.second);
            _tntHighway->prediction();
            _obstacles_predictionTraj->insert(std::make_pair(obj.first, *(_tntHighway->getObjectOutput()) ));
        }
        else if(v_xy > vx_urban_objectNeedPredict)/*if(   __classification__   )*/{      // use urban model
            _tntUrban->getHistoryTraj(obj.second.second);
            _tntUrban->prediction();
            _obstacles_predictionTraj->insert(std::make_pair(obj.first, *(_tntUrban->getObjectOutput()) ));
        }
    }

    restrictPredictL();
    translateLToEgo();
}


void ObstaclePrediction::savefile(){
    #if FLAG_PDFP_SAVECSV != 0
    std::ofstream outfile_PDobstacle;
    outfile_PDobstacle.open("./pd_obstacleTNT_file.txt", std::ios::app);

    outfile_PDobstacle<< "timestamp," << timeStampBag;

    // save history trajectory
    for(const auto& obs:(*_obstacles_histCartesianTraj_timelist)){
        outfile_PDobstacle<<",obs_id,"<<obs.first;
        for(const auto& pos:obs.second){
            outfile_PDobstacle<<",obsHist_t,"<<pos.t_s
                                <<",obsHist_x,"<<pos.x_m
                                <<",obsHist_y,"<<pos.y_m;
        }
    }

    // save corridor
    for(const auto& corridors_inOneLane:(*_corridors_inLanes)){
        for(const auto& oneCorridor:corridors_inOneLane){
            outfile_PDobstacle<<",cor_id,"<<oneCorridor.corridor_id
                                <<",cor_c0,"<<oneCorridor.reference_line.c0
                                <<",cor_c1,"<<oneCorridor.reference_line.c1
                                <<",cor_c2,"<<oneCorridor.reference_line.c2
                                <<",cor_c3,"<<oneCorridor.reference_line.c3
                                <<",cor_start,"<<oneCorridor.reference_line.start_range
                                <<",cor_end,"<<oneCorridor.reference_line.end_range; 
        }
    }

    // save Frenet history trajectory
    for(const auto& obj:*_obstacles_histFrenetTraj_forward){
        outfile_PDobstacle<<",obj_id,"<<(obj).first;
        float delta_l = calculateYPolynomial(obj.second.first,0.0f);
        for(const auto&posFrenet:obj.second.second){
            outfile_PDobstacle<<",obj_s,"<<posFrenet.at(0)
                                <<",obj_l,"<<posFrenet.at(1)+delta_l;
        }
    }


    // save prediction trajectory
    /*for(const auto& obj:*_obstacles_predictionTraj){
        float delta_l = calculateYPolynomial((*_obstacles_histFrenetTraj_forward)[obj.first].first,0.0f);
        for(const auto&posFrenet:obj.second){
            outfile_PDobstacle<<",obj_id,"<<obj.first;
            outfile_PDobstacle<<",obj_s,"<<posFrenet.at(0)<<",obj_l,"<<posFrenet.at(1)+delta_l;
            outfile_PDobstacle<<",obj_s,"<<posFrenet.at(2)<<",obj_l,"<<posFrenet.at(3)+delta_l;
            outfile_PDobstacle<<",obj_s,"<<posFrenet.at(4)<<",obj_l,"<<posFrenet.at(5)+delta_l;
            outfile_PDobstacle<<",obj_s,"<<posFrenet.at(6)<<",obj_l,"<<posFrenet.at(7)+delta_l;
            outfile_PDobstacle<<",obj_s,"<<posFrenet.at(8)<<",obj_l,"<<posFrenet.at(9)+delta_l;
            outfile_PDobstacle<<",obj_s,"<<posFrenet.at(10)<<",obj_l,"<<posFrenet.at(11)+delta_l;
        }
    }*/
    for(const auto& obj:*_obstacles_predictionTraj_toEgo){
        for(const auto&posFrenet:obj.second){
            outfile_PDobstacle<<",obj_id,"<<obj.first;
            outfile_PDobstacle<<",obj_s,"<<posFrenet.at(0)<<",obj_l,"<<posFrenet.at(1);
            outfile_PDobstacle<<",obj_s,"<<posFrenet.at(2)<<",obj_l,"<<posFrenet.at(3);
            outfile_PDobstacle<<",obj_s,"<<posFrenet.at(4)<<",obj_l,"<<posFrenet.at(5);
            outfile_PDobstacle<<",obj_s,"<<posFrenet.at(6)<<",obj_l,"<<posFrenet.at(7);
            outfile_PDobstacle<<",obj_s,"<<posFrenet.at(8)<<",obj_l,"<<posFrenet.at(9);
            outfile_PDobstacle<<",obj_s,"<<posFrenet.at(10)<<",obj_l,"<<posFrenet.at(11);
        }
    }

    outfile_PDobstacle<<std::endl;
    outfile_PDobstacle.close();
    #endif
}


void ObstaclePrediction::process(){

    // history
    calculateFrenetTraj();

    // prediction
    predictTrajectory();

    #if FLAG_PDFP_SAVECSV != 0
    savefile();
    #endif

}







#endif  // FLAG_PREDICTION_TNT_BA